# UNICODE CHARACTER DATABASE
# This file was generated with the command:
#     generate_unicodedb.py --unidata_version=4.1.0 --output=unicodedb_4_1_0


base_mod = None
version = '4.1.0'


def trie_lookup(name):
    charnode = 0
    while 0 <= charnode < 0xffff: # 16bit number, 0xffff = None
        charnode *= 3
        leftright, parentstr, codepoint = _charnodes[charnode:charnode+3]

        if leftright < 0:
            # XXX assumes msb is sign
            left = 0x8000 | ((leftright & 0x7fffffff) >> 16)
        else:
            left = (leftright & 0x7fffffff) >> 16
        right = leftright & 0xffff

        if parentstr < 0:
            # XXX assumes msb is sign
            parent = 0x8000 | ((parentstr & 0x7fffffff) >> 16)
        else:
            parent = (parentstr & 0x7fffffff) >> 16
        stridx = parentstr & ((1 << 16) - 1)
        
        strlen = ord(_stringtable[stridx])
        substring = _stringtable[stridx+1:stridx+1+strlen]

        if codepoint != -1 and name == substring:
            return int(codepoint)
        if name.startswith(substring):
            name = name[strlen:]
            charnode = left
        else:
            charnode = right
    raise KeyError, name

def name_of_node(charnode):
    res = []
    prevnode = -1
    while 0 <= charnode < 0xffff: # 16bit number, 0xffff = None
        charnode *= 3
        leftright, parentstr, codepoint = _charnodes[charnode:charnode+3]

        if leftright < 0:
            # XXX assumes msg is sign
            left = 0x8000 | ((leftright & 0x7fffffff) >> 16)
        else:
            left = (leftright & 0x7fffffff) >> 16
        right = leftright & 0xffff

        if parentstr < 0:
            # XXX assumes msb is sign
            parent = 0x8000 | ((parentstr & 0x7fffffff) >> 16)
        else:
            parent = (parentstr & 0x7fffffff) >> 16

        if prevnode < 0 or prevnode == left:
            stridx = parentstr & ((1<<16)-1)
            strlen = ord(_stringtable[stridx])
            substring = _stringtable[stridx+1:stridx+1+strlen]
            res.insert(0, substring)

        prevnode = charnode // 3
        charnode = parent

    return ''.join(res)
    

_stringtable = (
'\x05UBUTS'
'\x0eTWO DOT LEADER'
'\x03AGL'
'\x12ON-SPOKED ASTERISK'
'\x11TEN THOUSAND SIGN'
'\x06HYPHEN'
'\x04MEN '
'\x04LIFI'
'\x03RTH'
'\x07NYI ZLA'
'\x040 MA'
'\x03NYO'
'\x08ENT SIGN'
'\x02CR'
'\x04OOTH'
'\x0fWHITE DOT RIGHT'
'\tLOWER DOT'
'\rTROKE OVERLAY'
'\x05AMOND'
'\x07IRCLED '
'\x04MEGA'
'\x07IMILAR '
'\nUP HARPOON'
'\x03HEH'
'\x07D WITH '
'\x06MACRON'
'\x06JOINED'
'\x08CHATTAWA'
'\x045 TO'
'\x03BWA'
'\rLVEOLAR CLICK'
'\rNTY FULL STOP'
'\x07ACTION '
'\x049 PI'
'\x02G '
'\x04LASH'
'\x0fUPERSCRIPT ALEF'
'\x06JOINER'
'\x07A NAME '
'\x16BINING GEMINATION MARK'
'\rOMAN NUMERAL '
'\x02GS'
'\tUPTSTIMME'
'\nELT BUCKLE'
'\x0cOHAZARD SIGN'
'\x02GG'
'\x07RD SIGN'
'\x07 HYPHEN'
'\x02GA'
'\x04TIN '
'\x02GO'
'\x02GN'
'\x05PASEQ'
'\x02GI'
'\x03MAP'
'\x03AG-'
'\rYPOGEGRAMMENI'
'\x1dUP HEAVY AND RIGHT DOWN LIGHT'
'\x04ERET'
'\tZERO SIGN'
'\nAEDA-PILLA'
'\x0cGHT OPEN BOX'
'\rOON NOTEHEAD '
'\x06SPONSE'
'\x08LOW STOP'
'\x10MULTIPLICATION X'
'\x04HILD'
'\x0fBINDING BRACKET'
'\x0fLEFT DOWN BARB '
'\x045 JU'
'\nMONOFONIAS'
'\x06SHORT '
'\x04NGUE'
'\x1fRIANGLE-HEADED RIGHTWARDS ARROW'
'\x0cMADDA ABOVE '
'\x0eCORNER BRACKET'
'\x03MAN'
'\x04LAAN'
'\x03BEH'
'\x04A-HA'
'\x12MATHEMATICAL SPACE'
"'RIANGLE CONTAINING SMALL WHITE TRIANGLE"
'\x043 A3'
'\x05REVIA'
'\x15DIGRAMMOS EX DODEKATA'
'\x03EVE'
'\x05AVROS'
'\x0fST QUARTER MOON'
'\tCENT SIGN'
'\x08MEDIUM S'
'\n NOTATION '
'\x08P HALF O'
'\x03BET'
'\x07EN SIGN'
'\x0cKAPPA SYMBOL'
'\x07LL SIGN'
'\x06F MARE'
'\x0fORIZONTAL COLON'
'\x0fMEEM FINAL FORM'
'\x04MBOO'
'\x05LASMA'
'\x06E WAVE'
'\x18UPRIGHT RECTANGULAR ZERO'
'\nETTA-PILLA'
'$TURNED COMMA QUOTATION MARK ORNAMENT'
'\x08ONE MARK'
'\x04BIRD'
'\x06P TACK'
'\x10IMENSIONAL ANGLE'
'\x16CURLY BRACKET ORNAMENT'
'\x02ZH'
'\x07OSITION'
'+LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW'
'\x1eMODIFIER LETTER LEFT HALF RING'
'\x0bMED RGYINGS'
'\x05SHIMA'
'\x04EIRT'
'\x057 TWE'
'\x02LF'
'\rUPSILON WITH '
'\nMINUS SIGN'
'\x0eYOUTHFUL FOLLY'
'\tHALSHELET'
'\x1aLLALLAHOU ALAYHE WASSALLAM'
'\x08MPERSAND'
'\nAVE ACCENT'
'\x03NOO'
'\x03TJE'
'\x04IGER'
'\x16DOMAIN ANTIRESTRICTION'
'\x05HIEUH'
'\x04RITU'
'\x11TERSYLLABIC TSHEG'
'\x0eBAG MEMBERSHIP'
'\x05LAMED'
'\nMIDDLE DOT'
'\x0f PARESTIGMENON '
'\nACE SYMBOL'
'\x18DIAGONAL CROSSHATCH FILL'
'\nRVICE MARK'
'\x03NOW'
'\x10 OR THE IMAGE OF'
'\tLAMATION '
'\x04TOP '
'\x15ACUTE AND HOOK SYMBOL'
'\x04IVE '
'\x07CAYANNA'
'\x041 DU'
'\x05CHED '
'\x12 WITH PALATAL HOOK'
'\x05AXIMA'
'\x11QUAT REVERSED ESH'
'\x08UNDERBAR'
'\x046 RU'
'\x041 DA'
'\x06TATED '
'\x05DKAR '
'\nOLON EQUAL'
'\x0bLATIN CROSS'
'\rOBLIQUE LINE '
'\tLEFT HALF'
'\x10STERISK OPERATOR'
'\x03OR '
'\x12LENTICULAR BRACKET'
'\x0eWITH FATHATAN '
'\x08NAM BCAD'
'\x07AM ALEF'
'\x17ALGAMATION OR COPRODUCT'
'\x05FIFTH'
'\x05IYEOK'
'\x07 OVER S'
'\x16TRIPLE RIGHT TURNSTILE'
'\x04MESO'
'\x0fLONG VOWEL SIGN'
'\x06MEMBER'
'\nFTOGGOS OU'
'\tIALECT-P '
'\x07 OVER M'
'\n WITH BASE'
'\x11BOTTOM HALF BLACK'
'\x04ARTH'
'\x0cUPPER CORNER'
'\x06ANCHOR'
'\x07PRICORN'
'\x0bCREDIT SIGN'
'\x07TIFIED '
'\x08F SYMBOL'
'\x0bWAVY HAMZA '
'\x05IVATE'
'\x05ICRON'
'\x05NGLE '
'\x0fDIGA AELA-PILLA'
'\x0bTHEMATICAL '
'\x07MAGE OF'
'\x06INSHIP'
'\x05UNITY'
'\x08EK ONKAR'
'\x12FORKED PARAGRAPHOS'
'\x04ATER'
'\x01V'
' SEMICIRCULAR ANTICLOCKWISE ARROW'
'\x06HIEUTH'
'\x04EVEN'
'\nHORT-TWIG-'
'\x0fESSARON CHRONON'
'\x14SCRIPTION CHARACTER '
'\x03LOS'
'\x15HORIZONTAL TABULATION'
'\tINISHMENT'
'\x11MEEM INITIAL FORM'
'\rENG WITH HOOK'
'\x06 AND S'
'\x04WTIE'
'\x03ORN'
'\x14HORIZONTAL BAR WITH '
'\x03ORI'
'\tVANAGARI '
'\x06KHAH I'
'\x0bMADDA ABOVE'
'\x1b DIVIDED BY HORIZONTAL RULE'
'\x06TICAL '
'\x05PRIME'
'\x04YEH '
'\x0eUNION OPERATOR'
'\x06ENIKI '
'\x047 RE'
'\x03UKY'
'\x0bED EQUAL TO'
'\x03UKU'
'\r DIMINUTION-1'
'\x07URATION'
'\x0eLOWER DIAGONAL'
'\x04OWER'
'\x08VOCALIC '
'\x04PEEP'
'\x0bCONTAIN AS '
'\x06IYANNA'
'\tEART SUIT'
'\x02GR'
'\x08ARCHAION'
'\x02LD'
'\x02LE'
'\x0cUN WITH RAYS'
'\x04IRIT'
'\x02LA'
'\tUPPER DOT'
'\x10 SOLIDUS OVERLAY'
'\x05PEECH'
'\x0bREE HUNDRED'
'\x16LONG HORIZONTAL STROKE'
'\x03ONG'
'\x02LH'
'\x03ONE'
'\x05HIDET'
'\x02LT'
'\x02LU'
'\tKU RU KHA'
'\x1dCONTAINING BLACK SMALL SQUARE'
'\x05NCORA'
'\x08TICK IN '
'\x04ORTY'
'\x04KAKO'
'\x02LY'
'\x01A'
'\x04HEAD'
'\x05BOVE '
'\x11LAPPING LESS-THAN'
'\x02L '
'\x1cBESIDE AND JOINED WITH UNION'
'\x16RECTILINEAR BLACK STAR'
'\x03ON '
'\x0cREVERSE MARK'
'\x04FORE'
'\x07DIARGON'
'\x04NION'
'\x04HEAT'
'\x11WO VERTICAL DOTS '
'\x0b SHOE STILE'
'\x038 A'
'\x038 E'
'\x0fOUTH EAST ARROW'
'\x06HEAVY '
'\x02LO'
'\x11BERBER ACADEMY YA'
'\x05 LINE'
'\x15GRUENT WITH DOT ABOVE'
'\x16IGEL LONG-BRANCH-SOL S'
'\x0fWO HEADED ARROW'
'\x04KWAA'
'\x10STRING FRETBOARD'
'\x07DLE DOT'
'\x08SKLIRON '
'\x07ASES AS'
'\x0cSHORT RIKRIK'
'\x0f OPERATOR WITH '
'\x03TA '
'\nTRETCHED C'
'\x11CTION APPLICATION'
'\x07 GROUND'
'\x02LL'
'\x07HALANTA'
'\x0bPARAKALESMA'
'\x0c-DZUD RTAGS '
'\x06LASTON'
'\x11OURTEEN FULL STOP'
'\x1c BETWEEN TWO HORIZONTAL BARS'
'\x0b PROPORTION'
'\x06EATHER'
'\x13VERTICAL TABULATION'
'\rFINAL SEMKATH'
'\x02BS'
'\x12CANTILLATION SIGN '
'\x11ATHERING TOGETHER'
'\x15DOWN HORIZONTAL HEAVY'
'\rSMALL V BELOW'
'\x14TERNATIVE KEY SYMBOL'
'\x03CH '
'\x0eINVERTED DAMMA'
'\nROEZENIAN '
'\x03JOT'
'\x07ROGRESS'
'\x10 WITH DOT INSIDE'
'\x0eVERTICAL LIGHT'
'\x03JOY'
'\x0fRIGHT HALF RING'
'\x0bFIXED-FORM '
'\x03 HU'
'\x05BEITH'
'\x04SCES'
'\rFINAL LETTER '
'\x05MEIZI'
'\x04DGER'
'\x06ENTIMA'
'\x14YRENAIC TWO DRACHMAS'
'\rH-TYPE SYMBOL'
'\x03CHA'
'\x04SA-I'
'\x05TIGMA'
'\x04NPEA'
'\x03CHE'
'\x04OXIA'
'\rANGLE BRACKET'
'\x06M BOAR'
'\x08REVERSED'
'\x0fST SYRIAC CROSS'
'\x14RIGHT-POINTING ANGLE'
'\x04EGOL'
'\nEICH STARK'
'\x05IKEUT'
'\x0fHEAVY AND LEFT '
'\x03ATH'
'\x15AKIA TELOUS ICHIMATOS'
'\x05PEITH'
'\x07RMUKHI '
'\tHARACTER '
'\nBLACK STAR'
'\x1a OR APPROXIMATELY EQUAL TO'
'\x0fZAIN FINAL FORM'
'\x05RUHUA'
'\x04LOW '
'\tNGTH MARK'
'\x0fRISING DIAGONAL'
'\x05AL TO'
'\rCHROMA SYNAFI'
'\x04HAM '
'\x10HEAVY AND RIGHT '
'\x04LIWN'
'\x03APA'
'\x05RIEUL'
'\x07 SLOWLY'
'\x05ARERU'
'\x05HORSE'
'\x06XO NEO'
'\x0cYOUTHFULNESS'
'\x08SUCCEEDS'
'\x065 MERI'
'\x06W LINE'
'\x0f AND LOWER LEFT'
'\x11 AND MIDDLE TILDE'
'\rIMAGE BRACKET'
'\tTELEPHONE'
'\rEWDATA SQUARE'
'\x07OCTOBER'
'\x05MROCK'
'\x05HANGE'
'\x06SYOUWA'
'\x14BSET OF NOR EQUAL TO'
'\x0bMALL SQUARE'
'\x0fUGMENTATION DOT'
'\x04EAT '
'\x1aRIPLE DOT PUNCTUATION MARK'
'\x07UP MARK'
'\x0bESTION MARK'
'\x03QOT'
'\x12NITE PART INTEGRAL'
'\x05ESIS '
'\x06RIISAP'
'\tILE TILDE'
'\x17VERTICAL BISECTING LINE'
'\x0eIWAZ TIR TYR T'
'\rEIGHTHS BLOCK'
'\x03QOF'
'\x04OBAT'
'\x19 WITH DOUBLE GRAVE ACCENT'
'\x04ODO '
'\x05SHARP'
'\x08 OVER KG'
'\x03DO '
'\nANGULAR TO'
'\x04HWAA'
'\x07ARRED B'
'\x06GEADAL'
'\x16ABOVE RIGHTWARDS ARROW'
'\x0bBUMPY ABOVE'
'\x0bPUNCTUATION'
"'USED AS KORANIC STOP SIGN ISOLATED FORM"
'\x07ARRED O'
'\x18ORIZONTAL BAR WITH NOTCH'
'\x01W'
'\x040 NI'
'\x07CELSIUS'
'\x07DAYANNA'
'\x17DOWNWARDS THEN CURVING '
'\x043 RI'
'\x07SUKUUDO'
'\x15OREAN STANDARD SYMBOL'
'\x0cDIGRAPH KOTO'
'\x03HE '
'\x04CRET'
'\x05EGIN '
'\x05PEN O'
'\x04LOOP'
'\x04EATH'
'\x05HEAD '
'\x05PEN E'
'\x0eALLAJALALOUHOU'
'\x0ePLITTING APART'
'\x03SSA'
'\x08TTENTION'
'\x040 RA'
'\tEMBEDDING'
'\x0bORT BARLINE'
'\x07R TSHES'
'#OUNDED HIGH STOP WITH FILLED CENTRE'
'\x07SECTION'
'\tANEROSIS '
'\x07D MOUTH'
'\x0cGRAVE ACCENT'
'\x15OHAMMAD ISOLATED FORM'
'\tIGH HAMZA'
'\x0fNOT TILDE ABOVE'
'\x15GHT OPEN BOX OPERATOR'
'\x03BEN'
'\x06EYANNA'
'\x05ISED '
'\x17SOLIDUS BINARY RELATION'
'\nFAHRENHEIT'
'\x1ePOINTED RECTILINEAR BLACK STAR'
'\x02OT'
'\x12KBAR ISOLATED FORM'
'\x07KYLISMA'
'\nERO WIDTH '
'\x03ECH'
'\x03RMA'
'\x05ECEDE'
'\x03EVA'
'\x0cGXI RADICAL '
'\x08JAVIYANI'
'\x04AR A'
'\x05CLICK'
'\x08WO DOTS '
'\x0bLOGICAL AND'
'\x0bESH DIGRAPH'
'\x01B'
'\x18-POINTING TRIANGLE WITH '
'\x08OUR DOTS'
'\x08LOW LINE'
'\x06VIYANI'
'\x04BETA'
'\rROSGEGRAMMENI'
'\x0bUNJO WYNN W'
'\x04WAIR'
'\x15MAKSURA ISOLATED FORM'
'\x04BETH'
'\x03YAA'
'\x0bPARALLEL TO'
'\x0eSMALL LETTER J'
'\tITRA SIGN'
'\x10DITORIAL CORONIS'
'\x07MBOL B0'
'\x05 REST'
'\x07PEGERMA'
'\x06AYANNA'
'\x0bGHAIN WITH '
'\x1a LESS THAN THE DENOMINATOR'
'\tY-FOURTH '
'\x1dSIBE SYLLABLE BOUNDARY MARKER'
'\x10YATHOS BASE SIGN'
'\x17 WITH CIRCUMFLEX ACCENT'
'\x06PENCIL'
'\x0eAU LENGTH MARK'
'\x04WYNN'
'\x05NGMAN'
'\x05PTUNE'
'\x06EENTH '
'\x050 DWO'
'\x11KHAH INITIAL FORM'
'\x11YEH ISOLATED FORM'
'\x0cRCHAIC KOPPA'
'\x04UBED'
'\tSYLLABLE '
'\x08IN WITH '
'\x04NIC '
'\x05ATIN '
'\x04ELVE'
'\x06EMASTI'
'\x05EO-EU'
'\x08FEBRUARY'
'\x0fEFT REPEAT SIGN'
'\tMMER AND '
'\x08IN SPACE'
'\x06ORPIUS'
'\x06GORGON'
'\x04DLE '
'\x01-'
'\x05TYPE-'
'\x04OLAM'
'\x06GO NGU'
'\x04MIL '
'\x11VOICED SOUND MARK'
'\x04CHWA'
'\nPRALINEAR '
'\n-SHAPED HA'
'\tRUM CLEF-'
'\x05YISI '
'\x0f DEYTEROU ICHOU'
'\x0cRNAM BCAD MA'
'\tEAVY DOWN'
'\x05TWEEL'
'\x13ANS-SERIF CAPITAL L'
'\x0eRK NOON GHUNNA'
'\x08EFT HOOK'
'\x05HIGH '
'\x17 HUNDRED TWENTY-EIGHTH '
'\x061 GOLD'
'\nFLATTENED '
'\n ENCLOSURE'
'\x0eVRON SNOWFLAKE'
'\x06ARTER '
'\nRAGGISMATA'
'\x06RSIAN '
'\x02QU'
'\x08MALL YUS'
'\x0eLEFT TURNSTILE'
'\x1dSEMICIRCULAR PATH AROUND POLE'
'\tURAMAZDAA'
'\x05CAUDA'
'\rLEGETOS ICHOS'
'\x0bYRIGHT SIGN'
'\x02QA'
'\x064 DART'
'\x01R'
'\x0cLTA EQUAL TO'
'\nTIMES SIGN'
'\rSEVEN EIGHTHS'
'\x0bUNCTUATION '
'\x047 ZA'
'\x08NAVIYANI'
'\x15ELATIONAL COMPOSITION'
'\x05EGION'
'\x05GONEK'
'\x1bDOUBLE ANGLE QUOTATION MARK'
'\x0cIVE CIRCLED '
'\x17VERSAL RECYCLING SYMBOL'
'\x14WITH FOUR DOTS ABOVE'
'\x08SANYAKA '
'\x08IRA SIGN'
'\nOSSED SHEI'
'\x0cULL NOTEHEAD'
'\x042 NO'
'\x0bIN EQUAL TO'
'\t EQUAL TO'
'\tPENTASEME'
'\x0eAFOREMENTIONED'
'\x04KATO'
'\x04ENTY'
'\x05L TAG'
'\x0fLETTER CAPITAL '
'\x07HEADING'
'\x04CHEH'
'\tNVERTED R'
'\x0bACKNOWLEDGE'
'\tUNGSEONG '
'\x0eAILLE PATTERN '
'\x06MILAR '
'\x05ONG S'
'\x0fINUS SIGN BELOW'
'\x0856 TURO2'
'\x08HAN-AKAT'
'\x10BBREVIATION SIGN'
'\x04PERS'
'\x07AMAKKAN'
'\tXHAUSTION'
'-ED DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE'
'\x07OTATED '
'\x08S INSIDE'
'\x08HARPOON '
'\x07AXIMATA'
'\x06CREASE'
'\x0cNATURAL SIGN'
'\x07CLOSURE'
'\x04PER '
'\x0fFTER COMPLETION'
'\x04SHAD'
'!LESS-THAN ABOVE DOUBLE-LINE EQUAL'
'\x04LACK'
'\x0eTHOUSANDS SIGN'
'\x07YAYANNA'
'\x04SIGN'
'\x03WER'
'\x06DERBAR'
'\x07I RTAGS'
'\x08BLINEAR '
'\x01X'
'\x05QUEEN'
'\rGHT HALF RING'
'\x06IRINGU'
'\x03AW '
'\x03OIN'
'\x07HAYANNA'
'\x15ABOVE SHORT DOWN TACK'
'\x12HORIZONTALLY BELOW'
'\x06GICAL '
'\x04NYIS'
'\x13GAPPED CIRCLE ARROW'
'\nALENT SIGN'
'\x05WITH '
'\x0fEH INITIAL FORM'
'\x03IHI'
'\x06TAKANA'
'\x03OIX'
'\x04IFTY'
'\x14RIGHT ANGLE WITH DOT'
'\nSPACE MARK'
'\tTHOUSAND '
'\x14GHTWARDS ARROW BELOW'
'\x03DMA'
'\x03ITE'
'\x15SHORT LEFTWARDS ARROW'
'#OR LOWER LEFT CURLY BRACKET SECTION'
'\x05PPAGE'
'\x05UBURU'
'\rOGOTYPE SIGN '
'\x05MI RO'
'\x02ZO'
'\x10 WITH RAIN DROPS'
'\x08TTO MARK'
'"NTICLOCKWISE-ROTATED DIVISION SIGN'
'\t1 CHARIOT'
'\x07HUNDRED'
'\x04RGON'
'\x07VAGRAHA'
'\x04MEEM'
'\x04IRTY'
'\x10KA- SHOG YIG MGO'
'\x17GREEK SMALL LETTER IOTA'
'\x0fNOT APPROXIMATE'
'\nLE-DELAYED'
'\x0bMOVED BELOW'
'\x07BE ROOT'
'\x03BUT'
'\nUNKIA SIGN'
'\x06 BELOW'
'\x02ZE'
'\tRTER NOTE'
'\x06N DASH'
'\x0bRIPLE ARROW'
'"TEARDROP-SPOKED PROPELLER ASTERISK'
'\x08IALYTIKA'
'\nMONOGRAM B'
'\x01C'
'\x12NINETEEN FULL STOP'
'\x05HIFT '
'\x1bEAVY WHITE RIGHTWARDS ARROW'
'\x03PII'
'\x03ITY'
'\x03BEE'
'\x04LOVO'
'\x02ZA'
'\x0fLEVEL TONE MARK'
'\x04MER '
'\tDELIMITER'
'\x08LOCATIVE'
'\x05THEMA'
'\x04HALF'
'\x03BU '
'&RIGHTWARDS ARROW ABOVE LEFTWARDS ARROW'
'\x13SEVEN EIGHTHS BLOCK'
'\x04RAEA'
'&EH WITH SUPERSCRIPT ALEF ISOLATED FORM'
'\x0cNUITY SYMBOL'
'\tRAL HEART'
'\nNUMERATOR '
'\x08APITAL L'
'\x05BIRGA'
'\x072 WOMAN'
'\x08ANUSVARA'
'\nWITH MEEM '
'\rLVE FULL STOP'
'\rQUESTION MARK'
'\x0cAND CRESCENT'
'\x03MOO'
'\x18GLOTTAL STOP WITH STROKE'
'\x03 IN'
'\x04RUKU'
'\x07WAZ EOH'
'\x05YANNA'
'\x11HORIZONTAL SINGLE'
'\x05RAIDA'
'\x0f CORNER BRACKET'
'\x18SINGLE-LINE NOT EQUAL TO'
'\tCANG TE-U'
'\x08EGORIAN '
'\x05TERIS'
'\x03BLE'
'\x03ETA'
'\nICAL TAPER'
'\x11AMBDA WITH STROKE'
'\x03ETH'
'\x06OTTED-'
'\nHOOK ABOVE'
'\x046 NA'
'\x07HM SIGN'
'\x07PALLAWA'
'\tCRESCENDO'
'\nLIMITATION'
'\x07IBIFILI'
'\x0fXCLAMATION MARK'
'\x04LLET'
'\x03BLA'
'\x05-TAIL'
'\rHALF INTEGRAL'
'\x1eHIGH-REVERSED-9 QUOTATION MARK'
'\x08CANDICUS'
'\x0cATNAH HAFUKH'
'\nLINE STAFF'
'\n7 PLASTICS'
'\x1dARROW POINTING DIRECTLY RIGHT'
'\x03DES'
'\x06URNED '
'\x0bRIPLE PRIME'
'\x10VE EIGHTHS BLOCK'
'\x10AM ISOLATED FORM'
'\x02CK'
'\tGREATER Y'
'\x02CH'
'\x02CO'
'\x08ULL STOP'
'\x0bCAN RGYINGS'
'\x02CA'
'\rRRIAGE SYMBOL'
'\x05AINS '
'\x02CE'
'\x06LIGON '
'\x0eDEYTEROS ICHOS'
'\x04ZERO'
'\x05 MARK'
'\x06YELLOW'
'\x05RUSH '
'\x03IME'
'\x04GIT '
'\x11ABBREVIATION MARK'
'\x10EPSILON UNDERBAR'
'\x02CW'
'\x07TTHACAN'
'\x065 WOOL'
'\x02CT'
'\x05MIEUM'
'\x04RPSE'
'\x08LUS SIGN'
'#BOTTOM-LIGHTED RIGHTWARDS ARROWHEAD'
'\x0eXO EKFONITIKON'
'\rQUARTER BLOCK'
'\x0bMEDIAL FORM'
'\x03ET '
'\x1bDOTTED INTERPOLATION MARKER'
'\x08IDEWAYS '
'\x03NMA'
'\x06OFOUND'
'\x0fIDING ENCLOSURE'
'\x06LEMENT'
'\x08TAL MARK'
'\x13WITH YEH FINAL FORM'
'\x0cFIVE HUNDRED'
'\x0bEQUALS SIGN'
'\x04LAM '
'\x0cBLACK CIRCLE'
'\x05PONSE'
'\rLEFT QUADRANT'
'\nIMPERFECTA'
'\x03LOO'
'\x03LOR'
'\x05WINJA'
'\x05KO LA'
'\x18UPWARD POINTING TRIANGLE'
'\x03LOW'
'\x0bUZEIRO SIGN'
'\x05ADDAK'
'\x07ANGULAR'
'\x05OKEN '
'\x08OK ABOVE'
'\x07RAYANNA'
'\nUPPER HALF'
'\rEFTWARDS TICK'
'\t247 DIPTE'
'\x044 NE'
'\x15BUT NOT EQUIVALENT TO'
'\x08SPERSION'
'\x18EQUAL TO OR GREATER-THAN'
'\x0fVERTICAL STROKE'
'\x05UNOO '
'\x1eAND JOINED BY DASH WITH SUBSET'
'"APANESE INDUSTRIAL STANDARD SYMBOL'
'\x16SEMI-VOICED SOUND MARK'
'\x06POKED '
'\x02VA'
'\x02VE'
'\x07HOUSAND'
'\x02VI'
'\rPARALLELOGRAM'
'\x17REE VARIATION SELECTOR '
'\x02VO'
'\x11WARDS ARROW BELOW'
'\x0bGRAMMA SIGN'
'\x05BELOW'
'\x04TACK'
'\x02VU'
'\tHI SYMBOL'
'\tCROSSING '
'\x01Y'
'\x13LEFT TO LOWER RIGHT'
'\x1cMONOGRAMMOS TESSERA DODEKATA'
'\x13RROW NO-BREAK SPACE'
'\x08EAR SIGN'
'\x0fND OF PARAGRAPH'
'\x04IPT '
'\x0cEATH PRODUCT'
'\x0cWORD DIVIDER'
'\x06INAGMA'
'\x05POLI '
'\x11URNED COMMA ABOVE'
'\tAS MEMBER'
'\x11CAL SYMBOL BOTTOM'
'\tCAPITAL Q'
'\x08SS-THAN '
'\x08ESCENDER'
'\x0bTURN SYMBOL'
'\x15MORPHOLOGICAL DIVIDER'
'\nFEATHERED '
'\x0bOR EQUAL TO'
'\x08EBEEFILI'
'\rHINESE TONE Y'
'\x03INI'
'\nUT NOT EQU'
'\x03BIB'
'\tDOWNWARDS'
'\x0bAPPROXIMATE'
'\nLET SYMBOL'
'\x0cRAH BEN YOMO'
'\x19TERNION INTEGRAL OPERATOR'
'\x04COND'
'\x16C GREATER-THAN BRACKET'
'\x08NITIAL Z'
'\x07UT TIME'
'\x05MINUS'
'!DOWNWARDS HARPOON WITH BARB RIGHT'
'\x0fRIGHT TURNSTILE'
'\x0bRPOON ABOVE'
'\x14JUDEO-SPANISH VARIKA'
'\x12HARPOON WITH BARB '
'\x07THESEOS'
'\x03ION'
'\x06CHEMA '
'\x07SH TAIL'
'\x04NUUN'
'\x03FWA'
'\x08TIMORION'
'\x0eLACE OF SAJDAH'
'\x0cYPTOGRAMMIC '
'\x08ARISTERA'
'\x01D'
'\nTOP CORNER'
'\x14RC LESS-THAN BRACKET'
'\x05WIDE '
'\x17ESS OUTLINED WHITE STAR'
'\x08HESPIAN '
'\x17RAISED OMISSION BRACKET'
'\x07TAYANNA'
'\nARANI SIGN'
'\rROW POINTING '
'\x1eGREATER-THAN ABOVE EQUALS SIGN'
'\x05RRECT'
'\x06GEDOLA'
'\x0bAESCULAPIUS'
'\x14YIG MGO PHUR SHAD MA'
'\x0bURNED COMMA'
'\tYANUKITTA'
'\nIKRON ISON'
'\x04O MA'
'\tRPORATION'
'\x08OVERLAID'
'\rVERTICAL BAR '
'\x0256'
'\x0250'
'\tCAPITAL D'
'\x10OETIC VERSE SIGN'
'\nPERCUSSIVE'
'\x07KOMBUVA'
'\x07T ABOVE'
'\x15DELIMITER TSHEG BSTAR'
'\tOP HALF O'
'\x10RST QUARTER MOON'
'\x10NORTH WEST ARROW'
'\x08LFWIDTH '
'\tIRST MARK'
'\x1cOUND-TIPPED RIGHTWARDS ARROW'
'\x17OVERLAPPING LOGICAL AND'
'\x04AGON'
'\x04SEYE'
'\x07TH MARK'
'\x0cROWNING FACE'
'\x08QAIRTHRA'
'\x05VARIA'
'\x02HW'
'\x0cBZHI MIG CAN'
'\x02HK'
'\x07KAYANNA'
'\x02HI'
'\x02HO'
'\x0eIGHTWARDS TICK'
'\x19HREE DOTS ABOVE DOWNWARDS'
'\x07S ICHOS'
'\x02HA'
'\x08LI GALI '
'\x02HE'
'&ABOVE LEFTWARDS HARPOON WITH BARB DOWN'
'\r B BAR SYMBOL'
'\x06HEAVEN'
'\x19FECTIVENESS OR DISTORTION'
'\x12DOUBLE PUNCTUATION'
'\x06NISTER'
'\x04HOKE'
'\tBRUL SHAD'
'\x08ISH TAIL'
'\x16MNYAM YIG GI MGO RGYAN'
'\x04DAGS'
'\tB DIGRAPH'
'\x06STOLI '
'\x0bFINAL SIGMA'
'\x0bEPIDAUREAN '
'\x07AY SIGN'
'\x0b WITH CARON'
'\x16I YFESIS TETARTIMORION'
'\x0cTHODOX CROSS'
'\x06NDA TA'
'\nINVERTED V'
'\x0cSAZ IS ISS I'
'\x0bME LONG CAN'
'\n WITH TICK'
'\x08ESH LOOP'
'\x08QUARTERS'
'\x0bENG DIGRAPH'
'\tDIAERESIS'
'\x05PI RO'
'\x0bPHNAEK MUAN'
'\x06GHAMAL'
'\rVERTICAL LINE'
'\x08OPERATOR'
'\x05DHADH'
'\x05OMIKO'
'\x05TIMES'
'\x07AULDRON'
'\x04ALEF'
'\x06OOMUUT'
'\x10ECIMAL SEPARATOR'
'\x04AMPI'
'\x0bILCROW SIGN'
'\rNAP PIZZICATO'
'\x03MPL'
'\x0cFEATHER MARK'
'\x0bCTRIC ARROW'
' NORMAL FACTOR SEMIDIRECT PRODUCT'
'\x03MPI'
'\x17QUOTATION MARK ORNAMENT'
'\x05HREAD'
'\x05ESO E'
'\x05INITY'
'\tRIZONTAL '
'\x06RENGTH'
'\x03AVE'
'\x02H '
'\x12AYHE ISOLATED FORM'
'\tFLAT SIGN'
'\x046 QA'
'\x02HZ'
'\tORINHIEUH'
'\x08SANGSIOS'
'\x08OHM SIGN'
'\x04ADHU'
'\x0eOUR OBOLS SIGN'
'\x03SUM'
'\x07JARATI '
'\x05INTHU'
'\x04RAM '
'\x05FEARN'
'\x0cNGLE BRACKET'
'\x04ADHE'
'\x049 SE'
'\x07PPROACH'
'\nHORIZONTAL'
'\r HEADED ARROW'
'\x0cVIAN LETTER '
'\x0fSPOKED ASTERISK'
'\x03TEH'
'\x0fUBLE RING BELOW'
'\tGITTARIUS'
'\x04BOVE'
'\x06CHIRET'
'\tIDEWAYS U'
'\x06MEEM I'
'\tBJARKAN B'
'\x10MIDDLE AND BELOW'
'\nND OF AYAH'
'\x08NOT SIGN'
'\x13VARIANT WITH SQUARE'
'\x16AISED OMISSION BRACKET'
'\x04ATTO'
'\x03TER'
'\x08NSULAR G'
'\x15ND UP ARROWHEAD BELOW'
'\x05HOLE '
'\rSMALL LETTER '
'\x08NUS SIGN'
'\x04NAL '
'\x0eITERATION MARK'
'\x15INVERTED GLOTTAL STOP'
'\x0bDIATONON DI'
'\x06ENTION'
'\x0eSURROUND FROM '
'\x05WARDS'
'\x08REATNESS'
'\tPADE SUIT'
'\x11LAH ISOLATED FORM'
'\x08AR TSHES'
'\nCTORY HAND'
'\x16INDIRECT QUESTION MARK'
'\x06 HANDS'
'\x06KLITON'
'\rI WITH STROKE'
'\x01Z'
'\x0eRIPLE UNDERDOT'
'\x1cLIQUID MEASURE FIRST SUBUNIT'
'\x08SHKIR KA'
'\x0cMETA STAVROU'
'\x06RRIER '
'\x07DRACHMA'
'\x04EST '
'\x04WEET'
'\x0cS SUBPUNCTIS'
'\x03XEH'
'\x03MWA'
'\x05EISMA'
'\x06N SIGN'
'\x0eMENSION ORIGIN'
'\x04TIKI'
'\x0cDE MARK SIGN'
'\x043 PA'
'\x14INGLE QUOTATION MARK'
'\x14 ABOVE LEFT TRIANGLE'
'\x066 TREE'
'\x03OUT'
'\x0b UPPER HALF'
'\x03BRA'
'\x06TERON '
'\x03TWA'
'\x03155'
'\x06GHUNNA'
'\tWITH DOT '
'\x14OTLESS J WITH STROKE'
'\x11GENERIC MATERIALS'
'\tIALYTIKA '
'\rOTHIC LETTER '
'\x03TWO'
'\x06 WITH '
'\x06ILLAGE'
'\x07NANCIAL'
'\x03VER'
'\x0bIBLE-CREE Y'
'\x03ORU'
'\x12LEFT-STEM TONE BAR'
'\x12HOUSANDS SEPARATOR'
'\x03HO '
'\x03EAN'
'\n2 PLASTICS'
'\x02AM'
'\t GARSHUNI'
'\x03EAF'
'\x038 I'
'\x1dINSTRUMENTAL NOTATION SYMBOL-'
'*OWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW'
'\x07HYAAUSH'
'\nRIGHT HALF'
'\x03EAT'
'\x07LABIAL '
'\x1d WITH REVERSED NEGATION SLASH'
'\x04OMMA'
'\tVERTICAL '
'\x01E'
'\nLHAG RTAGS'
'\x16WITH VOICED SOUND MARK'
'\nKFONITIKON'
'\x08MAKSURA '
'\x08ASTERISK'
'\x06BOFILI'
'\x08N-JOINER'
'\x08YLLABLE '
'!DIRECT PRODUCT WITH BOTTOM CLOSED'
'\x03ESC'
'\x05O ANG'
'\x10OUR POINTED STAR'
'\rOTEHEAD BLACK'
'\x0c-BREAK SPACE'
'\x07QUARTER'
'\x0bNYIS -KHYIL'
'\x05DALET'
'\x0f-CARRIER LETTER'
'\x03ESH'
'\x04ZETA'
'"PPROXIMATELY NOR ACTUALLY EQUAL TO'
'\x0fREVERSED OPEN E'
'(VERTICAL BAR AT END OF HORIZONTAL STROKE'
'\x05AR AE'
'\x05FLICT'
'\x04ROUT'
'\x14REVERSED ONE HUNDRED'
'\x18GREATER-THAN OR EQUAL TO'
'\x16RROW WITH ROUNDED HEAD'
'\x07EPHONE '
'\x04RUIS'
'%ONCAVE-POINTED BLACK RIGHTWARDS ARROW'
'\tSYNTHETON'
'\x1aDOTTED SUBSTITUTION MARKER'
'\x06TAIKHU'
'\x16POINTING UPWARDS BELOW'
'\x10RISING TONE MARK'
'\x04EFT '
'\x19RANCH BANK IDENTIFICATION'
'\x05IRCLE'
'\x15RISING DIAGONAL SLASH'
'\x11GREATER-THAN NOR '
'\x06ORTION'
'\x1bEMICIRCULAR CLOCKWISE ARROW'
'\rI LENGTH MARK'
'\rROKEE LETTER '
'\x0cMPHASIS MARK'
'\x03LTI'
'\x11OWER NUMERAL SIGN'
'\x12 WITH CROSSED-TAIL'
'\x0c-SIMPLIFIED '
'\x08GARITIC '
'\x07OP MARK'
'\x041 KU'
'\nHILIPPINE '
'\tNUSVARAYA'
'\x04ONE-'
'\x0fCAPITAL LETTER '
'\x06ORETTE'
'\x010'
'\x08RK SHADE'
'\x02WN'
'\x08MEASURE '
'\x05ITUAL'
'\x04RAMA'
'\x07CK MARK'
'\x05SARGA'
'\nRENCY SIGN'
'\x05ERSON'
'\x07CHU CAN'
'\x06SKAPI '
'\x04WEEN'
'\n1 PLASTICS'
'\x07HASANTA'
'\tLLAR SIGN'
'\x14ENARMONIOS ANTIFONIA'
'\x04PLE '
'\x10TODO SOFT HYPHEN'
'\t TROMIKON'
'\x10FFERENCE BETWEEN'
'\x05LONG '
'\x10LEFT PARENTHESIS'
'\x06DICINE'
'\x0fALAYHE ASSALLAM'
'\x03VAV'
'&WO DOTS VERTICALLY BELOW AND SMALL TAH'
'\x05LEASE'
'\x08MANGALAM'
'\n AND ACUTE'
'\x06ACCENT'
'\tFOUR DOTS'
'\x08IMANSIS '
'\x07HI SIGN'
'\x11RYBLION BASE SIGN'
'\nOMMA BELOW'
'\x0bTRUNCATED A'
'\x16HUNDRED THOUSANDS SIGN'
'\nUNDERSTORM'
'\x06HIEUCH'
'\x07OVERBAR'
'\x11 WITH MIDDLE HOOK'
'\x10UNCTUATION SPACE'
'\x07LLIANCE'
'\x06TTAVA '
"'WITH OPEN ARM ENDING IN ARROW POINTING "
'\x0fMIDDLE DIAGONAL'
'\x05TONOS'
'\x04TEN '
'\x04NESS'
'\x06HAMZA '
'\x06-IEUNG'
'\x06IAMOND'
'\x16FALLING DIAGONAL SLASH'
'\x05DOWN '
'\x03EK '
'\x03IN '
'\x05KOPPA'
'\tLEFT TACK'
'\x07AL SIGN'
'\x02GE'
'\x11EMICOLON UNDERBAR'
'\x11VEE WITH UNDERBAR'
'\x06INGLE '
'\x04OUND'
'\x16WITH JEEM INITIAL FORM'
'\x06EN BOX'
'\x04JEEM'
'\x07TCHFORK'
'\x02SO'
'\rEVERSED DAMMA'
'\x12ASTROLOGICAL SIGN '
'\rDOUBLE HYPHEN'
'\x04FLAT'
'\x04-ONE'
'\x05UCEUS'
'\x05ENUTO'
'\x04HETA'
'\x08THOUSAND'
'\x07 WITH S'
'\x0cMPTY CENTRE '
'\x08RYNGEAL '
'\x17ELVE POINTED BLACK STAR'
'\x01O'
'\x0cFEMININE DOT'
'\rRRIAGE RETURN'
'\x07 WITH D'
'\x07 WITH C'
'\x02ME'
'\x05 DOTS'
'\rPINWHEEL STAR'
'\x02MA'
'\x07STATERS'
'\x02MM'
'\x03INU'
'\x02MO'
'\x13 IN A RECTANGLE BOX'
'\x02MI'
'\x05ALATH'
'\x0eGERED TREMOLO-'
'\x06CRIPT '
'\x0bHEAVEN MARK'
'\nPENDICULAR'
'\x06EMOLO-'
'\x0bRYVNIA SIGN'
'\x03IND'
'\x03INE'
'\x03ING'
'\x02MY'
'\x05RING '
'\x04ILDE'
'\x05IEUNG'
'\x03DON'
'\rALEF MAKSURA '
'\tPERSET OF'
'\tNDRABINDU'
'\x07DOFONON'
'\x0fHORIZONTAL DASH'
'\x13 AND PROSGEGRAMMENI'
'\x03FIN'
'\x04ORII'
'\x11 TO BLACK DIAMOND'
'\tSEPARATOR'
'\x06YFESIS'
'\x04REAT'
'\x08OLLOWING'
'\x05HALF '
'\x03AKE'
'\tTO-RIGHT '
'\x07 STRIDE'
'\x06-HIDET'
'\x05UNTER'
'\x04DAIR'
'\x07OWILO S'
'\x13UP HORIZONTAL LIGHT'
'\x14AND NORTH WEST ARROW'
'\x0eRFACE INTEGRAL'
'\x06WIDTH '
'\x12OTLESS DALATH RISH'
'\x06IGHTH '
'\nLITTLE YUS'
'\x05ERTIE'
'\x08ER TRUTH'
'\x11ABOVE EQUALS SIGN'
'\x01F'
'\x07ARDNESS'
'\tLISSANDO '
'\x1cEDGE-TAILED RIGHTWARDS ARROW'
'\x10HORIZONTAL LIGHT'
'\x07VAYANNA'
'\x05DESTY'
'\x07DIAMOND'
'\x05SPACE'
'\nENTHUSIASM'
'\x0eALF TREE TRUNK'
'\nTEMPLATION'
'\x03LON'
'\n WITH DOT '
'\x03RGO'
'\x04INUS'
'\x07DIPLOUN'
'\t FROM BAR'
'\x05UGUST'
'\tEBIT SIGN'
'\rSTERISK BELOW'
'\x0e ISOLATED FORM'
'\x03TH '
'\x03MMA'
'\x03ERU'
'\tE TSA CAN'
'\x04EKAA'
'\x03BAR'
'\x03KOO'
'\x10POSTPOSITION MEN'
'\x0bIDDLE TILDE'
'\x03CAL'
'\nLOWER HALF'
'\r-PER-EM SPACE'
'\x0fHREE DOTS BELOW'
'\tEEN WITH '
'\x16GREATER-THAN DIAERESIS'
'\x07IRPLANE'
'\x03BAA'
'\x03BAN'
'\x05FTEEN'
'\x04NEO '
'\x07PAYANNA'
'\tBASE UNIT'
'\x07MENT OF'
'\rYOD YOD PATAH'
'\x0cMAN NUMERAL '
'\tLL SYMBOL'
'\x05CHULA'
'\x06GURAMU'
'\x011'
'\x0eWITH DOT ABOVE'
'\nTERNATIVE '
'\tEVERSED E'
'\x04MWAA'
'\x01H'
'\nNAASIKYAYA'
'\x05FORCE'
'\x056 RA2'
'\x11EAR SCREEN SYMBOL'
'\x06SHAYIM'
'\x05ETORU'
'\x03HAD'
'\x1bENTATION FORM FOR VERTICAL '
'\x04REST'
'\x03STU'
'\nHREE DOTS '
'\x04IRIQ'
')ULTIPLICATION SIGN WITH CIRCUMFLEX ACCENT'
'\x04MUOY'
'\x05EYYAL'
'\x048 QE'
'\x02LC'
'\tARISTERA '
'\x05TTORU'
'\x0f ALTERNATE FORM'
'\x05HAALU'
'\x08BATBEIT '
'\x05BHADH'
'\nATER-THAN '
'\x04IEUC'
'\x13CIRCLED SANS-SERIF '
'\x03AVA'
'\x07SUCCEED'
'\x03ER '
'\x0f POINTING INDEX'
'\x05I RHO'
'\x10OREAN CHARACTER '
'\x04IEUP'
'\x1cRECTANGULAR PATH AROUND POLE'
'\x0fITION INDICATOR'
'\tHIMA SIMA'
'\x0fLEFT HALF BLACK'
'\x1aORTHOGONAL CROSSHATCH FILL'
'\x03NEO'
'\x07ALESMA '
'\x05 AND '
'\t WITH DOT'
'\x08HARMONIC'
'\x02LK'
'\x08ANUDATTA'
'\nLEFT LIGHT'
'\x08ARSI YEH'
'\x02LI'
'\x05DAMMA'
'\x0cOND OPERATOR'
'\x08RAM FOR '
'\x02RT'
'\x02RU'
'\x10EXCLAMATION MARK'
'\x04UNAV'
'\x03O Y'
'\x02RR'
'\x0bLOTTAL STOP'
'\x0c OVER TWO PI'
'\rVERTICAL FILL'
'\x02RY'
'\x08ETRASEME'
'\tQUSHSHAYA'
'\x02RE'
'\x05FLAKE'
'\x06 ABOVE'
'\x02RN'
'\x02RO'
'\x02RI'
'\x02RK'
'\x0cVAKRAHASANYA'
'\x05F COW'
'\x1aTENDED ARABIC-INDIC DIGIT '
'\x05OSS O'
'\x0bTHIRDS SIGN'
'\rVICE CONTROL '
'\x06UBLE X'
'\nSWASH TAIL'
'\x05HI RO'
'\nNASPIRATED'
'\x0fEATER-THAN SIGN'
'\x06HIEUPH'
'\x12WHITE VERTICAL BAR'
'\x02R '
'\x03ACT'
'\x05NIGHT'
'\x06ITABLE'
'\x08LONG LEG'
'\x05CAUSE'
'\x14INVERSE WHITE CIRCLE'
'\x06BANWA '
'\x13SUBSTITUTION MARKER'
'\x03KAF'
'\x08UMMATION'
'\x03KUN'
'\x05IPEHA'
'\x0cEIGHTH NOTES'
'\x04LAKE'
'\x04ANT '
'\x05ALAPH'
'\x04VEDE'
'\nTESE CROSS'
'\x03RHO'
'\x1eQAF WITH LAM WITH ALEF MAKSURA'
'\x0fHEH MEDIAL FORM'
'\x06PARKLE'
'\tINVERTED '
'\nTER SYMBOL'
'\x04KICK'
'\x07UPWARDS'
'\x04FORK'
'\x03ANA'
'\rSIGN PAMUDPOD'
'\x15-SHAPED BAG DELIMITER'
'\x11INTEGRAL OPERATOR'
'\x04PEAT'
'\x044 ZE'
'\x07VAV YOD'
'\x08LOW TONE'
'\x073 SWORD'
'\x0cHASIS SYMBOL'
'\x07OGDIAN '
'\x0cTE SEPARATOR'
'\x05 AMPS'
'\x0bCCUMULATION'
'\x07RISIMOU'
'\x03RTE'
'\x08MOUNTAIN'
'\rOURTH SUBUNIT'
'\x04EZZO'
'\x10BRACKET ORNAMENT'
'\tVOCALIC R'
'\x16TORTOISE SHELL BRACKET'
'\tWORDSPACE'
'\x1cFTING POINT RIGHTWARDS ARROW'
'\x04TAIL'
'\x0f2 CHARIOT FRAME'
'\n OF DHARMA'
"'ABOVE RIGHTWARDS HARPOON WITH BARB DOWN"
'\x05EIGHT'
'\x1bDOUBLE PRIME QUOTATION MARK'
'\nRHO SYMBOL'
'\x05MPARE'
'\x03RTY'
'\nTELEGRAPH '
'\x03KIN'
'\x06 RIGHT'
'\x08IAGONAL '
'\x03RT '
'\x01G'
'\x05 ALLO'
'\x0bARPEGGIATO '
'\x02-U'
'\x07ATURAL '
'\x13VERSE FINAL BARLINE'
'\x1dEVERSED LUNATE EPSILON SYMBOL'
'\x07VISARGA'
'\x03ENT'
'\x05GAMAL'
'\x0bROR-BARRED '
'\x04EEK '
'\x07T BELOW'
'\nRING ABOVE'
'\x05DASIA'
'\tMBROIDERY'
'\x03TEN'
'\x07DIGRAPH'
'\x03C A'
'\x07NG SIGN'
'\x05F SOW'
'\x0eTWO WHITE DOTS'
'\x1dEFTWARDS HARPOON WITH BARB UP'
'\x12TROFLEX HOOK BELOW'
'\x05HITE '
'\n SEPARATOR'
'\x05MUSIC'
'\x07XT PAGE'
'\x03II '
'\x0eIVE OBOLS SIGN'
'\x14WARE-FUNCTION SYMBOL'
'\x03ATE'
'\x05ASEIA'
'\x04DASH'
'\x07THUNDER'
'\x08PAIRTHRA'
'\x0bORCE SYMBOL'
'\x12ABOVE GREATER-THAN'
'\x05URAMU'
'\x03ATI'
'\x0bYEORINHIEUH'
'\x03ISH'
'\x06ISSIMO'
'\nWO SHORTS '
'\x07RARIETY'
'\x0fVOWEL SEPARATOR'
'\x0f THROUGH CIRCLE'
'\x0eOSITION SYMBOL'
'\x03SET'
'\x045 AU'
'\x16WITH HORIZONTAL STROKE'
'\x07 BULLET'
'\x1bLESS-THAN ABOVE EQUALS SIGN'
'\nEVERSED PE'
'\nTACK BELOW'
'\x04AULA'
'\x04AAMU'
'\x17ORIGINAL OF OR EQUAL TO'
'\x14CURVED ANGLE BRACKET'
'\x012'
'\x0b-FEATHERED '
'\x04QAPH'
'\tKEMPHRENG'
'\nEDIAL FORM'
'\x07PRESENT'
'\x03IMA'
'\x045 A2'
'\tYEAR SIGN'
'\tFULL STOP'
'\x15WITH THREE DOTS ABOVE'
'\x10IRCUMFLEX ACCENT'
'\x04CART'
'\x08IAERESIS'
'3LANTED EQUAL ABOVE GREATER-THAN ABOVE SLANTED EQUAL'
'\x07UKKAKHA'
'\x0fMARRYING MAIDEN'
'\x08LOGICAL '
'\x1aIDEOGRAPHIC ITERATION MARK'
'\x06SQUARE'
'\x03SE '
'\x05HALA '
'\x03JK '
'\x0eOUSING THUNDER'
'\x07GINESE '
'\x044 TE'
'\tMODYNAMIC'
'\x04RUTU'
'\x03AT '
'\tLLABLE OM'
'\x05MANNA'
'\x11JEEM INITIAL FORM'
'\x04ILUY'
'\x0cLOWER CORNER'
'\x03ZER'
'\x06EAHMUK'
'\x08BEVERAGE'
'\x05NDRA '
'\x07ITALIC '
'\x08NG RTAGS'
'\x0e-STEM TONE BAR'
'\x0bSANS-SERIF '
'\x06TY SET'
'\x06UYANNA'
'\x02DO'
'\x07BESIDE '
'\nOBOLS SIGN'
'\x02DI'
'\x06OYANNA'
'\x0cDIGRAPH YORI'
'\x02DE'
'\tLOCKWISE '
'\x02DA'
'\x04HREE'
'\x07LOTTAL '
'\x02DY'
'\x04EIWS'
'\x04FWAA'
'\x02DR'
'\x07EIGHTHS'
'\x073 SPICE'
'\x06CHO CH'
'\x07VERSED '
'\x05NUKTA'
'\x1cRECT CURRENT SYMBOL FORM TWO'
'\x04NANA'
'\x04LO L'
'\x08QUESTION'
'&ASHED TRIANGLE-HEADED RIGHTWARDS ARROW'
'\x07SMALL L'
'\x11 WITH TILDE ABOVE'
'\x07SMALL V'
'\tCAPITAL L'
'\x1aALEF MAKSURA ISOLATED FORM'
'\x04LPHA'
'\x05IAUDA'
'\x04IK H'
'\x0fPRIOT SYLLABLE '
'\x14CENTRE VERTICAL LINE'
'\tCAPITAL F'
'\x04INTE'
'\x0bOLDING BACK'
'\x1dDOWN HEAVY AND RIGHT UP LIGHT'
'\x0bLENGTH MARK'
'\x03S O'
'\x0cCIRCLED PLUS'
'\x04INTO'
'\nUPPER HOOK'
'\x03DHA'
'\x04AMDA'
'\x06ARADDO'
'\x05BREW '
'\x15 AND THREE DOTS ABOVE'
'\nETA SYMBOL'
'\x07E FACE-'
'\x03JEE'
'\x04SUNG'
'\nOUR FIFTHS'
'\x08ERAL URN'
'\x0bXAGRAM FOR '
'\x1cSCONTINUOUS UNDERLINE SYMBOL'
'\x03RCH'
'\x06OR EQU'
'\x06JUDIJE'
'\x02D '
'\x08CRO SIGN'
'\x1eMAKSURA WITH SUPERSCRIPT ALEF '
'\x03ADE'
'\nAPOSTROPHE'
'\x18BLACK LENTICULAR BRACKET'
'\x07 MUQDAM'
'\x06 BLOCK'
'\x02WG'
'\x02WE'
'\nOLLAR SIGN'
')NT-TILTED SHADOWED WHITE RIGHTWARDS ARROW'
'\x06IGAMMA'
'\x02WA'
'\x03QAR'
'\x02WO'
'\x0fSHORT OVER LONG'
'\x06VELOPE'
'\x12DOWN-OUTPUT SYMBOL'
'\nDASH ARROW'
'6UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA '
'\x03POT'
'\x05D OF '
'\x02WU'
'\x03QAF'
'\x03MIM'
'\x0eRIGHT TRIANGLE'
'\x0fCLOSED BY CURVE'
'\x06OUBLE '
'\x03HSA'
'\x08TAALUJA '
'\x05JUEUI'
'\x0bRACHMA SIGN'
'\x04ARIA'
'\tETRASIMOU'
'\x04MALL'
'\x03RIP'
'\x08YPORROON'
'\x02PA'
'\tCHAVIYANI'
'\x14ONCAVE-SIDED DIAMOND'
'\x06MADR M'
'\x04OUBT'
'\nI ARCHAION'
'\nOSTAL MARK'
'\rORNER BRACKET'
'\x04IOTA'
'\x03HAH'
'\x03XIA'
'\x05PATAH'
'\x03HAL'
'\x05LEVEN'
'\x03HAN'
'\x08COUNT OF'
'\x03HAA'
'\x03EQU'
'\x0cINITIAL FORM'
'\tEMPTY SET'
'\x07IKHAHIT'
'\x03HAR'
'\x16TWO HORIZONTAL STROKES'
'\x05TSHEG'
'\nSBUB -CHAL'
'\x03ELL'
'\x03YEH'
'\x02PI'
'\tLESS-THAN'
'\x02W '
'\tURNED GAN'
'\x07JERAN J'
'\x03YEE'
'\x02MU'
'\x05 SIGN'
'\x04BAR '
'\x04ADDA'
'\x14LMOST EQUAL TO ABOVE'
'\x04PPER'
'\nTHMIKON N '
'\tJERUSALEM'
'\x06IRCLE '
'\x06M BULL'
'\x080 BRONZE'
'\rDOUBLE STROKE'
'\x07SOLIDUS'
'\x1fRIGHTWARDS HARPOON WITH BARB UP'
'\x08PEE SIGN'
'\t FORM TWO'
'\x04IANO'
'\nINAL SIGMA'
'\x04LING'
'\x04HELF'
'\x03RGE'
'\x06ORONIS'
'\x1a NEGATED WITH VERTICAL BAR'
'\x04HELL'
'\x0bCOMPOSITION'
'\x0eLITTLE SECTION'
'\tZ DIGRAPH'
'\x083 ARMOUR'
'\x04ROOK'
'\x02S '
'\x03LDE'
'\x14A- SHOG GI MGO RGYAN'
'\x0bMIDDLE STEM'
'\x02EO'
'\x04ONG '
'\nGAS BZUNG '
'\x19PERFECTUM CUM PROLATIONE '
'\x08OO TYPE '
'\x013'
'\x15VOICED ITERATION MARK'
'\x03FO '
'\x10RECORD SEPARATOR'
'\x061 WINE'
'\x1aLINE FEED SEPARATOR SYMBOL'
'\x11HORIZONTAL STROKE'
'\x07SYNAGMA'
'\x06EMKATH'
'\x13LUNATE SIGMA SYMBOL'
'\rMINUS SIMILAR'
'\x04REIA'
'\tFEH WITH '
'\x05HEAVY'
'\x0cI LE LETTER '
'\x03LD '
'\x06OLIDUS'
'\x0eLUS SIGN BELOW'
'\tFINAL MEM'
'\x05LTIRE'
'\x03LJE'
'\x07CHIEUCH'
'\x04ONGA'
'\x16LOW PARAPHRASE BRACKET'
'\x0cIRST SUBUNIT'
'\x08ONG DASH'
'\x07FAYANNA'
'\x05LIDUS'
'\x03NDO'
'\x08OURGLASS'
'\x0eAPITAL LETTER '
'\x05A UNA'
'\x01S'
'\nTYPE COLON'
'\x10SMALL CAPITAL EL'
'\x05 TACK'
'\x05M RAM'
'\x03PRO'
'\x04WIND'
'\x1aCLOCKWISE ARROW WITH MINUS'
'\x03ILE'
'\x07NTAINS '
'\x08DANTAJA '
'\tPPOSITION'
'\x03YNN'
'\x0bBLACK ARROW'
'\tPOINTING '
'\x03PEH'
'\x05-BEAM'
'\x1eDOWNWARDS AND RIGHTWARDS ARROW'
'\x06PHRASE'
'\x042 RO'
'\x06OW TIE'
'\x03COO'
'\x10HORIZONTAL HEAVY'
'\x08YBEYFILI'
'\x05WEST '
'\x08SAME DOT'
'\x07ERCIAL '
'\x05BOLD '
'\rWO-LINE STAFF'
'\nDS-CREE TH'
'\tM HE-GOAT'
'\x06PIRIT '
'\x05PSILI'
'\x07LAGIOS '
'\x0eLMOST EQUAL TO'
'\x07KUTAARU'
'\nX NOTEHEAD'
'\x04INES'
'\x06DAGESH'
'\x06 QATAN'
'\nRAINIAN IE'
'\tZENE RING'
'\x05NCHU '
'\tHWAZ EH E'
'\x03WAI'
'\x07OVERLAY'
'\x11WHITE PARENTHESIS'
'\x0cIDEOGRAPHIC '
'\x03CR '
'\nIDEOGRAPH '
'\x03WAA'
'\x06UPTURN'
'\rCRIPTION TAKE'
'\x10DOUBLE TURNSTILE'
'\x03WAZ'
'\x04PEN '
'\x03WAW'
'\x06CKNESS'
'\x03WAU'
'\rPERFECTA REST'
'\n3 PLASTICS'
'\tAOS ICHOS'
'\x0cNOT EQUAL TO'
'\x059 PU2'
'\x03EEL'
'\x05GURE '
'\x047 DI'
'\x19DIAERESIS AND HOOK SYMBOL'
'\x05CHECK'
'\x08SLANTED '
'\x03OEH'
'\nHAAPRAANA '
'\x03 HE'
'\x11CROSS PUNCTUATION'
'\x16KEEPING STILL MOUNTAIN'
'\x06C CLEF'
'\tNOT EQUAL'
'\x13OW-9 QUOTATION MARK'
'\x03JHA'
'\x14TRANSPOSITION MARKER'
'\x0bNUN HAFUKHA'
'\x03MKA'
'\x0bOT OPERATOR'
'\x06QUARE '
'\x05SEGOL'
'\rL-TYPE SYMBOL'
'\x04XEIA'
'\x13ND SOUTH EAST ARROW'
'\x03AIL'
'\x03SHE'
'\x03AIN'
'\x04OBRO'
'\x07ACCENT '
'\x0cKANA REPEAT '
'\x06PERSET'
'\x0fE OVER INFINITY'
'\x07COPTIC '
'\x05IPING'
'\x1aDOTTED LUNATE SIGMA SYMBOL'
'\x11DENTAL PERCUSSIVE'
'\x04MEAR'
'\x06EMPUS '
'\nEARTH MARK'
'\x0eORD SEPARATOR '
'\x08OR EQUAL'
'\x1bIMPERFECTUM CUM PROLATIONE '
'\x07MYSLITE'
'\x04LOLL'
'\x05SASA '
'\x0eTIMES OPERATOR'
'\x03CHI'
'\x02I '
'\x08RECORDER'
'\x05GADOL'
'\x03NSU'
'\x04ITSA'
'\x02IX'
'\x04 OHM'
'\x05HOUR '
'\nNUMBER TEN'
'\x07OURTEEN'
'\x06EXISTS'
'\x03UTE'
'\x01I'
'\x02IP'
'\x02IS'
'\x02IR'
'\x03IRT'
'\x02IT'
'\x0e AND DIAERESIS'
'\tNTERPRISE'
'\x02II'
'\x02IH'
'\x02IJ'
'\x02IM'
'\x02IL'
'\x08BOL SIGN'
'\x02IN'
'\x02IA'
'\x07STIMATE'
'\x03IRC'
'\x02IE'
'\x03IRE'
'\x02IG'
'\rYUUKALEAPINTU'
'\x0fGH VOLTAGE SIGN'
'\x03OPO'
'\x13ARTIAL DIFFERENTIAL'
'\x08UND SIGN'
'\x03URU'
'\rWO DOTS BELOW'
'\x04AME '
'\x10ADIAN SYLLABICS '
'\x0eRIGHT QUADRANT'
'\x07N WITH '
'\x04ZATA'
'\tIGHT DOWN'
'\rWITH UNDERBAR'
'\x05RACHY'
'\x08-CREE RE'
'\x0bBUT NOT EQU'
'\x03PWA'
'\t OPERATOR'
'\tLLABLE B0'
'\x03BOX'
'\x0eUSPENSION MARK'
'\x047 KI'
'\x11VERTICAL BOX LINE'
'\x03NAH'
'\x05NATE '
'\x06EIGHTY'
'\x0bVOWEL SIGN '
'\x13RIGHT TO LOWER LEFT'
'\nCIRCUMFLEX'
'\x08V OVER M'
'\x12 AND YPOGEGRAMMENI'
'\x08AH WITH '
'\x0cSS-THAN SIGN'
'\x06VIRIAM'
'\x12NORMAL SUBGROUP OF'
'\rU LENGTH MARK'
'\x06EIGHTH'
'\x0bATION POINT'
'\x17OVER RIGHTWARDS HARPOON'
'\x07JAYANNA'
'\x05 HAA '
'\x06NTIIMU'
'\x046 JE'
'\x04KAPH'
'\x0bPERISPOMENI'
'\x15VERTICAL LINE OVERLAY'
'\x0eED PARAGRAPHOS'
'\x046 JO'
'\x0cURLY BRACKET'
'\x0fSTERESIS SYMBOL'
'\nADDA WITH '
'\x014'
'\x1b-FEATHERED RIGHTWARDS ARROW'
'\x047 KA'
'\x18 OVER TOP SQUARE BRACKET'
'\nLCROW SIGN'
'\tSEMICOLON'
'\x06BETAN '
'\x08RSECTION'
'\x02TH'
'\x0cBYSMAL WATER'
'\x14RIGHT QUADRANT BLACK'
'\t5 CYPERUS'
'\x06 EQUID'
'\x03ILK'
'\x05SUKUN'
'\x05AR B '
'\x0eSERTION SYMBOL'
'\x05FAIHU'
'\x04GRU '
'\x049 TA'
'\x06AGRANT'
'\x08IRD MARK'
'\x07THIEUTH'
'\x18VOICED LARYNGEAL SPIRANT'
'\x11HAH ISOLATED FORM'
'\x11 ALTERNATION MARK'
'\x05ORGON'
'\rGHT ARROWHEAD'
'\x07TERNITY'
'\rTROFLEX CLICK'
'\x10-BREAKING HYPHEN'
'\x14WHITE SQUARE BRACKET'
'\nAKKHANGYAO'
'\n WITH TAIL'
'\x06EIGHT '
'\x05BREVE'
'\x05UBLE '
'\x14 WITH RETROFLEX HOOK'
'\x07MBRELLA'
'\x03IRI'
'\x06CCEEDS'
'\x11EMIDIRECT PRODUCT'
'\x07ZQAPHA '
'\tONGSEONG '
'\x16DRESSED TO THE SUBJECT'
'\rUSICAL LEIMMA'
'\x04IPOD'
'\nNANGMONTHO'
'\x06U MARK'
'\x06UNATE '
'\x15CTOR OR CROSS PRODUCT'
'\x08HAVIYANI'
'\x03PEE'
'\x03ESS'
'\x10MIDDLE AND RIGHT'
'\nGGRAVATION'
'\x0c ON PEDESTAL'
'\x03OE '
'\x06ERESIS'
'\x06FILLER'
'\r WITH OVERBAR'
'\x05ZILDE'
'\x07ILLEANN'
'\x02AI'
'\x05COLON'
'\x02AH'
'\x06ISSHAR'
'\x07DRIL BU'
'\x02AK'
'\x08YIDDISH '
'\x17SING DIAGONAL CROSSING '
'\x03TRI'
'\nSH PRODUCT'
'\x06APISMA'
'\x04 OF '
'\rSAMYOK SANNYA'
'\x07SQUARED'
'\tMHANCHOLL'
'\x05OPBAR'
'\x0fLATION FUNCTION'
'\x0eTHALAN ETHEL O'
'\x11APLI DYO DODEKATA'
'\x056 TA2'
'\x08 SOLIDUS'
'\nASTERISCUS'
'\x040 WI'
'\x05MARK '
'\x07READING'
'\n WITH CURL'
'\x13DIAGONAL HALF BLACK'
'\x0e WITH UNDERBAR'
'\x16TRIPLE VERTICAL STROKE'
'\x05QUARE'
'\nANGKHANKHU'
'\x1aJECT REPLACEMENT CHARACTER'
'\x07HANGUL '
'\x05ITING'
'\rISOLATED FORM'
'\x05SCHWA'
'\x02AS'
'\x03LK '
'\x06DERMA '
'\tVELOPMENT'
'\x07JECTIVE'
'\x11CANCELLATION MARK'
'\x0c DIMINUTION-'
'\x0cEIGHTH BLOCK'
'\x05NAG G'
'\x1cASTERISKS ALIGNED VERTICALLY'
'\x08TURNED M'
'\x03ZUP'
'\x08ALLIANCE'
'\x05OTERI'
'\x03OLL'
'\x0cLER CONSTANT'
'\n5 PLASTICS'
'\x06RUPEE '
'\x0eSQUIGGLE ARROW'
'\x06DVANCE'
'\rMILLIONS SIGN'
'\x08DVISVARA'
'\tOKOUFISMA'
'\x04SILI'
'\x044 DO'
'\x0fNE EIGHTH BLOCK'
'\rONGRATULATION'
'\x02NI'
'\x0bDOUBLE AND '
'\x03UEH'
'\x02NN'
'\x02NO'
'\x06PSILON'
'\x07ASUTORU'
'\tNO TELEIA'
'\x02NE'
'\x02NG'
'\x02NY'
'\x06HE MGO'
'\x03ESI'
'\rHAKASSIAN CHE'
'\rLEFT TRIANGLE'
'\tIRCUMFLEX'
'\x02NT'
'\x15DOWN HORIZONTAL LIGHT'
'\x19CROSSING NORTH EAST ARROW'
'\x02NW'
'\x0fFOUR DOTS ABOVE'
'\x07NUMBER '
'\x02N '
'\x01J'
'\nOPEN SHELF'
'\x08YER YAGH'
'\x04RTAR'
'\x04IGMA'
'\x0fBAR ABOVE UNION'
'\x0cRIGHT ARROW '
'\x03ELS'
'\x06 DIPLI'
'\x06BALUDA'
'\x03ELT'
'\x0fGROUP SEPARATOR'
'\nDOWN HEAVY'
'\x14AND SOUTH WEST ARROW'
'\x03OZE'
'\x05DOTS-'
'\x03LEF'
'\tUTER JOIN'
'\x11RIGHT PARENTHESIS'
'\x03RUE'
'\x06YMBOL '
'\x05HAH I'
'\x05VAAVU'
'\x10UPERSCRIPT ALAPH'
'\x0bUTH CORNERS'
'\x1cISMILLAH AR-RAHMAN AR-RAHEEM'
'\x0bLON SKEWED '
'\x05RIAC '
'\x04TEEN'
'\x03USE'
'\x08TION KEY'
'\x05MALL '
'\r DIFFERENTIAL'
'\x07VILIK B'
'\tLEFT AND '
'\x05GIMEL'
'\x06YLISMA'
'\x18-HEADED RIGHTWARDS ARROW'
'\x08EMICOLON'
'\x07NAYANNA'
'\tHALF RING'
'\x05HREE '
'\x07VERLINE'
'\n AND BREVE'
'\x03AZU'
'\x051 DWE'
'\rWAVY OVERLINE'
'\nADAK BINDI'
'\x15HAND INTERIOR PRODUCT'
'\x10UP-OUTPUT SYMBOL'
'\tPAA-PILLA'
'\tCOMPLETED'
'\x11DOUBLE ARCH BELOW'
'\x11IGHTEEN FULL STOP'
'\nPEDAL MARK'
'\x0cRANCHING OUT'
'\x0fNORMAL SUBGROUP'
'\x04RUNA'
'\x05HAINU'
'\x07F DAVID'
'\x015'
'\nSCAN LINE-'
'\x13ICTLY EQUIVALENT TO'
'\x08OVERRIDE'
'\x10SLANTED EQUAL TO'
'\x0bGREEK CROSS'
'\x12KOREAN CHARACTER O'
'\x0fDOWNWARDS ARROW'
'\x07BAIRKAN'
'\x06PALUTA'
'\x04FIRE'
'\x0cIDENTICAL TO'
'\tLVIN SIGN'
'\x0cPHEME JOINER'
'\x03ICE'
'\x06SICKLE'
'\x04IMES'
'\x05LAGUS'
'\x05ENANO'
'\x05GOGI '
'\x0bENTHESIZED '
'\x042 SO'
'\rVERSE DIVIDER'
'\nLEFT HEAVY'
'\x06BISHOP'
'\x08EH WITH '
'\x1cLEFTWARDS OF DOWNWARDS ARROW'
'\x0fYNCHRONOUS IDLE'
'\x07HROUGH '
'\x12UTLINED BLACK STAR'
'\x05KASRA'
'\x0cMBELLISHMENT'
'\tNCLOSING '
'\x07MAKSURA'
'\x0cPER-EM SPACE'
'\x0eREE-LINE STAFF'
'\x05DIUM '
'\x04ZAIN'
'\x04THOR'
'\rILE SEPARATOR'
'\x05DATUS'
'\x0eAMNUC PII KUUH'
'\x05ALPHA'
'\x0cEMISOFT SIGN'
'\x05O PLA'
'\x05FISTO'
'\x05DIPLI'
'\x03AH '
'\x06LAZY S'
'\x02-A'
'\x04PRIL'
'\x08WASH KAF'
'\x03SIX'
'\x05TROKE'
'\x0bBZHI -KHYIL'
'\x03SIC'
'\rWAVY LOW LINE'
'\x02-W'
'\x04GAIN'
'\x15ARKENING OF THE LIGHT'
'\x06N YANG'
'\x05EGL H'
'\x045 MO'
'\x07BREVIS '
'\x0bEZH DIGRAPH'
'\x04NGLE'
'\x01 '
'\x16IN DEPARTING TONE MARK'
'\x0bRONTHISMATA'
'\x06ARRIER'
'\x03TAR'
'\x03TAS'
'\x06TIKEUT'
'\x07KORONIS'
'\x07OT SIGN'
'\x07TALENTS'
'\x08EQUAL TO'
'\rAWELLEMET YAZ'
'\x04TEXT'
'\x03TAL'
'\x03TAM'
'\x03TAN'
'\x03TAO'
'\x03TAH'
'\x1fUPWARDS HARPOON WITH BARB RIGHT'
'\x07BINING '
'\x1f-HEADED ARROW FROM SMALL CIRCLE'
'\x14THROUGH SMALL CIRCLE'
'\nIVALENT TO'
'\x06OICING'
'\x04QEF '
'\x07RCHAION'
'\x06RIPLE '
'\x05BLANK'
'\x07MARCATO'
'\x03DJA'
'\x11UP AND HORIZONTAL'
'\nSE-CREE SK'
'\x08ABAAFILI'
'\rFIXED-FORM RA'
'\x08EVERANCE'
'\x07RILLIC '
'\rINVERTED FORK'
'\x04ORT '
'\x02TE'
'\tRNEY PARA'
'\rBY DEFINITION'
'\x06ROBANG'
'\x04MENT'
'\x0eVERTICAL HEAVY'
'\x05SHANG'
'\x0bASHED ARROW'
'\x11TRIPLE DASH ARROW'
'\x16SHORT VERTICAL STROKES'
'\x08TINGUISH'
'\x0cF TREE TRUNK'
'\x04PACE'
'\x06LOWER '
'\x070 WHEAT'
'\x02-2'
'\x04LOOR'
'\x08NG BELOW'
'\x07GAYANNA'
'\x08MULTIMAP'
'\x0bDYO CHRONON'
'\tLM SYMBOL'
'\x05UTIES'
'\x04LY H'
'\x10IRCLE X NOTEHEAD'
'\tPLUS SIGN'
'\x10NORTH EAST ARROW'
'\x06F CLEF'
'\x13HORIZONTAL ELLIPSIS'
'\x04GORT'
'\x08NOVEMBER'
'\tUURDHAJA '
'\x18BERKANAN BEORC BJARKAN B'
'\x04 ALL'
'\x11BRACKET EXTENSION'
'\x08VERTICAL'
'\x08ARKENING'
'\x04APON'
'\x05CIEUC'
'"IGHUR KAZAKH KIRGHIZ ALEF MAKSURA '
'\nHOTIC HOOK'
'\x0b0 FOOTSTOOL'
'\x05RCURY'
'\x08POSITION'
'\x04ARON'
'\x05HADDA'
'\x06FONIAS'
'\x04ONE '
'\tMPLIFIED '
'\x06EN GHE'
'\x07TIVATE '
'\x10IVE POINTED STAR'
'\x0fVOWEL SHORTENER'
'\x14AND SOUTH EAST ARROW'
'\x01K'
'\x18CONSECUTIVE EQUALS SIGNS'
'\x06OBELOS'
'\x0eQUARTERS BLOCK'
'\tDOT BELOW'
'\x04RIME'
'\x11AEUM ONE PLETHRON'
'\tAMPERSAND'
'\x04FFIN'
'\x13PLACEMENT CHARACTER'
'\x0bHOOK SYMBOL'
'\rWITH ASTERISK'
'\x05ALLI '
'\x08ATHERING'
' TRIANGLE-HEADED RIGHTWARDS ARROW'
'\x13STRATIAN FIFTY MNAS'
'\nWITH CARON'
'\x07ARDROP-'
'\x10 AND HEAVY RIGHT'
'\x16NOT INCLUDING THE POLE'
'#RIGHT-POINTING ANGLE QUOTATION MARK'
'\x04AAFU'
'\tPOSTROPHE'
'\x06H NOTE'
'\tYEH WITH '
'\tACE NOTE '
'\x0bCUTE ACCENT'
'\n4 PLASTICS'
'\nUR YIG MGO'
'\x0b-LINE STAFF'
'\x11DELPHIC FIVE MNAS'
'\x0bUG RTAGS GY'
'\x03PLI'
'\x14UBLE VERTICAL STROKE'
'\x07TLINED '
'\x02EY'
'\x05YURII'
'\x11GREATER-THAN SIGN'
'\x08I SHAKTI'
'#TWO HORIZONTAL STROKES TO THE RIGHT'
'\x06SUBSET'
'\rPAIRED ARROWS'
'\x07FORKING'
'\x05SHADE'
'\rBACKSLASH BAR'
'\x05YAMOK'
'\x05LOURE'
'\tBO BAIMAI'
'\x03UAT'
'\x08WN ARROW'
'\x03REH'
'\tCHOSEONG '
'\x04BEND'
'\x10RIGHT DOWN BARB '
'\x0bDONG TSHUGS'
'\x08TONE BAR'
'\x047 TI'
'\x05JEEM '
'\x11RIGHTWARDS ARROWS'
'\x03REE'
'\x04LIFU'
'\x03LFA'
'\x07HIRTEEN'
'\x05OTHAL'
'\x12ORK ON THE DECAYED'
'\x04IITO'
'\x10PRECHGESANG STEM'
'\x05TTOM '
'\tITTLE YUS'
'\x0fN-ARY SUMMATION'
'\x08WON SIGN'
'\x0e WITH LONG LEG'
'\x06WN BOW'
'\x03VE '
'\x016'
'\x03OUR'
'\x06KIYEOK'
'\x03VOU'
'\x07ANDERER'
'\x04LEFT'
'\x0bLEFT DOUBLE'
'\x07ESCENDO'
'\rNE DOT LEADER'
'\x05KAPPA'
'\x03LF '
'\x05BASSA'
'\x04LEF '
'\x04 NOT'
'\x15NTISTRY SYMBOL LIGHT '
'\x03VEE'
'\x07AVIYANI'
'\x14TOP SEMICIRCLE ARROW'
'\x07UP AND '
'\x03VEN'
'\x0cCHAIR SYMBOL'
'\x0c OR EQUAL TO'
'\x06ULDRON'
'\tAGOLITIC '
'\nRNING SIGN'
'\x02SY'
'\x08ACKSPACE'
'\x08VESSEL B'
'\x04 NEO'
'\x05FENCE'
'\x0fCORNER WITH DOT'
'\x02SS'
'\x0fBINARY RELATION'
'\x0bLT OF CLOTH'
'!ALL BUT UPPER LEFT QUADRANT BLACK'
'\x02SU'
'\x02ST'
'\x03QUA'
'\x11MALL CIRCLE ABOVE'
'\x02SI'
'\x02SH'
'\tAVE ARROW'
'\x0cUP ARROWHEAD'
'\x0fALMOST EQUAL TO'
'\x03VOW'
'\x02SA'
'\x0bGAYANUKITTA'
'\x044 KE'
'\x02SE'
'\x04AILM'
'\x0bCARET TILDE'
'\x04SELF'
'\tTTED STEM'
'\x06M DASH'
'\x050 MAN'
'\x0eAROUND-PROFILE'
'\x05ERKHA'
'\x10HAH INITIAL FORM'
'\x041 QI'
'\x042 PE'
'\x1eDOT BELOW AND THREE DOTS ABOVE'
'\x06CALATE'
'\x0bIMEL SYMBOL'
'\x08PE DRIVE'
'\x05TSERE'
'\x0cAND OPERATOR'
'\x05TYR T'
'\x04OENG'
'\x05KURON'
'\x0eENDED MULTIMAP'
'\x15ARYSTIAN FIVE HUNDRED'
'\tTUTEYASAT'
'\x05SIXTH'
'\x0bLOTI NAGRI '
'\x044 WA'
'\x0bVARYS ICHOS'
'\x03GNO'
'\tSSANGSIOS'
'\x04CHOR'
'\x08PAVIYANI'
'\x06ARSEOS'
'\x0eSQUARE BRACKET'
'\x0fOWER HALF BLACK'
'\x04YWAA'
'\x1aCIMAL SEPARATOR KEY SYMBOL'
'\x08IS-PILLA'
'\x05F EWE'
'\rCIRCLE INSIDE'
'\x0fTVIMADUR SYMBOL'
'\x0bMALL CIRCLE'
'\x07ARALLEL'
'\x04ONEK'
'\x0cMFLEX ACCENT'
'\x06METRIC'
'\x16DOUBLE VERTICAL STROKE'
'\x10OMPLETE INFINITY'
'\rPLUS OPERATOR'
'\x0bJECT SYMBOL'
'\x05OTHES'
'\nQUISH QUAD'
'\nERISPOMENI'
'\x08OSTROPHE'
'\x07BARLINE'
'\nW OR MODEL'
'\x06NGBAT '
'\tADMA GDAN'
'\x04UGU '
'\x07PRODUCT'
'\x10THREE DOTS BELOW'
'\x12GATIVE ACKNOWLEDGE'
'\x14CURRENCY SYMBOL RIEL'
'\x06SIXTHS'
'\x0fONTOUR INTEGRAL'
'\x15EQUAL TO OR LESS-THAN'
'\x03UDY'
'\nUBLE GRAVE'
'\x02EF'
'\x0fCIRCUIT-OUTPUT '
'\x03OGH'
'\t5 BATHTUB'
'\x05LEFT '
'\x045 WE'
'\x07BARREKH'
'\x03GHT'
'\x03IP '
'\x03GAT'
'\x08-CREE TH'
'\x15INTERSECTING LOGICAL '
'\tODIASTOLE'
'\x0cZIGZAG ARROW'
'\x03 OF'
'\x05VER S'
'\x04IXTY'
'\rALATALIZATION'
'\x04AH I'
'\x08HAGALL H'
'\tWASH TAIL'
'\x06TRAPLI'
'\x03GHA'
'%RIGHT TORTOISE SHELL BRACKET ORNAMENT'
'\x07LEK TOO'
'\x0cWITH STROKE '
'\x0cTRAGRAM FOR '
'\x04LINE'
'\x04NET '
'\x0bEKFONITIKON'
'\x08RIYOOSAN'
'\x07FLUENCE'
'\x0cVER EQUAL TO'
'\x04SECT'
'\x0222'
'\x18LY-RECYCLED PAPER SYMBOL'
'\x03UR-'
'\x04VIDA'
'\x08RDEL NAG'
'\x0cGLOTTAL STOP'
'\x04VIDE'
'\x07IP SIGN'
'\x1bRIGHT ARC LESS-THAN BRACKET'
'\x04PLUS'
'\x04SUIT'
'\x0fSIXTEENTH NOTES'
'\x0cEAGULL BELOW'
'\x0fATA LINK ESCAPE'
'\x03EHI'
'\x03FTY'
'\x0eEFT HALF BLACK'
'\x073 AREPA'
'\x03URE'
'\x08BOL FOR '
'\x03URA'
'\x14ANGE ANTIRESTRICTION'
'\x03URL'
'\x03URN'
'\x0cETARTIMORION'
'\x01L'
'\x06DIVIDE'
'\x03AYB'
'\x03URT'
'\x06UP BOW'
'\x022F'
'\x06IFTEEN'
'\x07UPSILON'
'\x04EETA'
'\x07URNED M'
'\x05TONE '
'\x06THORA '
'\x11PARTING TONE MARK'
'\x0eUNDER RELATION'
'\x03MI '
'\x0bANNOTATION '
'\x0eDOES NOT EXIST'
'\x04REE '
'\x07CKWISE '
'\nHEAD BELOW'
'\x05HIRTY'
'\x11WIDE BRIDGE ABOVE'
'\x07URNED R'
'\x11NAUDIZ NYD NAUD N'
'\nHEAVY BEAT'
'\x12LOSED CIRCLE ARROW'
'\n WITH PLUS'
'\x03NGA'
'\x0bNUMBER SIGN'
'\x04BASA'
'\x02AY'
'\x19OUTLINED RIGHTWARDS ARROW'
'\n BACKSLASH'
'\tSOF PASUQ'
'\x07PHUTHAO'
'\x07VALENT '
'\x18MALL CIRCLE TO THE RIGHT'
'\x10DOWN RIGHT BARB '
'\x13ITED LIABILITY SIGN'
'\x0cREPONDERANCE'
'\x04OONU'
'\x0fUSTER NOTEHEAD '
'\x16INVERTED SMALL V BELOW'
'\x06DOTTED'
'\x1bIDE-HEADED RIGHTWARDS ARROW'
'\x07STERISK'
'\t OPENING '
'\nTOM SYMBOL'
'\x02E '
'\x08ARKLEAN '
'\nD WITH DOT'
'\x0fPERTHO PEORTH P'
'\x017'
'\x07SPRINGS'
'\x03OVE'
'\x08HROUGH X'
'\x02EM'
'\x02EL'
'\x0bCANDRABINDU'
'\x02EN'
'\x02EI'
'\x02EH'
'\x02EK'
'\x04GIBA'
'\x02EE'
'\x02ED'
'\x0bUSTRAL SIGN'
'\x02EA'
'\x0cDOWED WHITE '
'\x03IRU'
'\x18RIGHTWARDS THEN CURVING '
'\x03SHA'
'\x0cBLACK SQUARE'
'\x0cWARDS BULLET'
'\x0bHREE BALUDA'
'\x0cRING OVERLAY'
'\x04GORG'
'\x02EU'
'\x02ET'
'\x02EW'
'\x02EP'
'\x02ER'
'\x04AMIL'
'\tCHMA SIGN'
'\x03NG '
'\x1e-HIRAGANA PROLONGED SOUND MARK'
'\x07DISIMOU'
'\tERCIAL AT'
'\x1aMARRIED PARTNERSHIP SYMBOL'
'\x06NTOGEN'
'\x0fRECEPTIVE EARTH'
'\x03CES'
'\x07ONE BAR'
'\x0cXIRON KLASMA'
'\x05ZHAIN'
'\tIDEOGRAM '
'\x07ONG LEG'
'\x06OGONEK'
'\n NOTEHEAD '
'\nUTION SIGN'
'\x17BALLOON-SPOKED ASTERISK'
'\x07ECEMBER'
'\x03LUS'
'\tETER SIGN'
'\x04UON '
'\x07RESSION'
'\x06SYMBOL'
'\rMESSENIAN TEN'
'\x10ULDERED OPEN BOX'
'\x0cETRETES SIGN'
'\x03LUE'
'\x07CISSORS'
'\x03YA '
'\x04YIS '
'\x08 TALENTS'
'\x0cRIGHT DOUBLE'
'\x07PTHAHA '
'\x14DIRECT QUESTION MARK'
'\x07 APLOUN'
'\x05-SIOS'
'\x13VARIATION INDICATOR'
'\x02X '
'\x16UBSCRIPT SMALL LETTER '
'\x0fITH FINGERNAILS'
'\nD OF PROOF'
'\x0bIL FRAGMENT'
'!RIGHTWARDS HARPOON WITH BARB DOWN'
'\x0eUNIT SEPARATOR'
'\x13 WITH STRIKETHROUGH'
'\x03UAN'
'\tOGRAPHIC '
'\x04APPA'
'\x08YIG MGO '
'\x02XI'
'\x02XO'
'\tNOTEHEAD '
'\x05OWER '
'\x0c WITH DAGESH'
'\rARGOSYNTHETON'
'\x02XA'
'\x02XG'
'\x14L FUNCTIONAL SYMBOL '
'\x05HISTI'
'\x17ARC ANTICLOCKWISE ARROW'
'\x1d OVER RIGHTWARDS ARROW TO BAR'
'\x07PANSIOS'
'\x06HEISEI'
'\x06MALL V'
'\x0bPARENTHESIS'
'\x07PERSAND'
'\x08ERO SIGN'
'\x03ARU'
'\x13VASTNESS OR WASTING'
'\nCISIVENESS'
'\x06CHADIN'
'\tLEMENT OF'
'\x0eREH FINAL FORM'
'\nUBLE DASH '
'\x16PRECEDED BY APOSTROPHE'
'\x04UT H'
'\x0cLINKING MARK'
'\x0c IN TRIANGLE'
'\x05GORGI'
'\rMALL LETTER Z'
'\x04ETAL'
'\x04EACE'
'\x03KET'
'\tURUZ UR U'
'\x0eWITH DOT BELOW'
'\x08EVENTEEN'
'\t DRACHMAS'
'\x08LEFT TO '
'\x03OT '
'\x15YMPTOTICALLY EQUAL TO'
' -POINTING ANGLE BRACKET ORNAMENT'
'\tTO CORNER'
'\x08OFT SIGN'
'\x06RGIAN '
'\x10EFORE COMPLETION'
'\x05 DEKA'
'\x04SINK'
'\x04YUDH'
'\rFTWARDS ARROW'
'\x04ABIC'
'\x10-POINTING ANGLE '
'\x08VERGENCE'
'\x14GRA GCAN -CHAR RTAGS'
'\x18COMPATIBILITY IDEOGRAPH-'
'\rOWN-POINTING '
'\x07OTLESS '
'\x18TEARDROP-SPOKED ASTERISK'
'\x05HANNA'
'\x1cDOWN HEAVY AND LEFT UP LIGHT'
'\x05-ARY '
'\x07ALLOT X'
'\x07TAISYOU'
'\x15QUADRANT CIRCULAR ARC'
'\x0eLINE EXTENSION'
'\x08PERSIAN '
'\x06 ARROW'
'\x05KHAPH'
'\x061 HORN'
'\x08OWN TACK'
'\x0bTONAL MARK '
'\x0bGSUM -KHYIL'
'\x17SHORT HORIZONTAL STROKE'
'\x0bLEFT SINGLE'
'\nHITE ARROW'
'\x13ASOUL ISOLATED FORM'
'\x03ARG'
'\x01M'
'\x0bJOYOUS LAKE'
'\x04BEAM'
'\x0fAND PARALLEL TO'
'\x04NTOC'
'\x05MAPIQ'
'\x06KTIKO '
'\x08DIFONIAS'
'\x0279'
'\x0bBOTTOM MARK'
'\x03OTH'
'\x14DOUBLE ANGLE BRACKET'
'\tREVERSED '
'\x05RONIS'
'\tHIGH TONE'
'\x06APLOUN'
'\x0fIMISEOS CHRONOU'
'\x03OTA'
'\x05CUTE '
'\x13QUESTION MARK ABOVE'
'\x0eOUR DOTS ABOVE'
'\x0fWITH DOWN ARROW'
'\x07RIGHT C'
'\x18XCLAMATION MARK ORNAMENT'
'\x0eLEFTWARDS TICK'
'\x04QOPA'
'\nWARDS VANE'
'\x06 SMALL'
'\rSMALL V ABOVE'
'\x08UNDERTIE'
'\x16ND RECORDING COPYRIGHT'
'\rRIGHT HARPOON'
'\x03DZE'
'\x03TLE'
'\x17BARBED RIGHTWARDS ARROW'
'\x05EPEAT'
'\x0cLACK DIAMOND'
'\x0fREVERSE SOLIDUS'
'\x12SMALL CIRCLE ABOVE'
'\x04IBE '
'\x06OCIETY'
'\x12KATAKANA-HIRAGANA '
'\x05EAST '
'\nDOWN ARROW'
'\rPREPONDERANCE'
'\x1bDGE-TAILED RIGHTWARDS ARROW'
'\x02JE'
'\x0bROUND OMEGA'
'\x110 WHEELED CHARIOT'
'\x02JA'
'\x0bHAGGAR YAZH'
'\nFFICULTIES'
'\x0fLEVEN FULL STOP'
'\x15MALE WITH STROKE SIGN'
'\x03TAV'
'\tLAM WITH '
'\x03IWN'
'\x06ERMATA'
'\x0cDOWN HARPOON'
'\x03IWR'
'\x05NASHI'
'\x04UMAN'
'\x018'
'\x12VE DOT PUNCTUATION'
'\x03TIV'
'\x06THREE '
'\x12LENTICULAR BRAKCET'
'\tATHAMASAT'
'\x14ARXIS KAI FTHORA VOU'
'\x12ANTED EQUAL TO OR '
'\x04EESU'
'\x04FITA'
'\x03IRO'
'\tTOS ICHOS'
'\x18INTERSECTION WITH SERIFS'
'\x041 PO'
'!DOUBLE-LINE EQUAL ABOVE LESS-THAN'
'\nNAKE BELOW'
'\x07CIRCLE '
'\x05LLEL '
'\x04DEAD'
'\x04INGU'
'\x05EGALI'
'\x05O RUA'
'\x04GGER'
'\x0cREFACE COLON'
'\x08ION SIGN'
'\x06RRED O'
'\x0eAI LENGTH MARK'
'\x03NAR'
'\x03PHI'
'\x06BULLET'
'\x05JERVI'
'\x0eSTROKE OVERLAY'
'\x18YZANTINE MUSICAL SYMBOL '
'\x16WASALLAM ISOLATED FORM'
'\x13SANS-SERIF CAPITAL '
'\x03 SU'
'\x0bUBLE TONGUE'
'\x03MZA'
'\x06EDILLA'
'\x06CIRCLE'
'\x0b WITH MAPIQ'
'\x05TTED '
'\x11OINTED BLACK STAR'
'\x05AGGER'
'\x16PUNCTUATION KUNDDALIYA'
'\x05SHORT'
'\x02BR'
'\x13EFT-POINTING ANGLE '
'\x04HID '
'\x05PIEUP'
'\x05PAATO'
'\x05TTER '
'\x0cHYPHEN-MINUS'
'\x0eIAGONAL STROKE'
'\x05MISRA'
'\x14OVER LEFTWARDS ARROW'
'\x0cTHETA SYMBOL'
'\x04OTE '
'\x04ENAT'
'\x058 RO2'
'\x14LIQUE ANGLE OPENING '
'\x05UPLE '
'\rZHOU NUMERAL '
'\x16PERSET OF NOR EQUAL TO'
'\x03GER'
'\x08PALOCHKA'
'\x0bX DRAWINGS '
'\x06NOR BU'
'\x04ROTO'
'\x0fDIALYTIKA TONOS'
'\x17RIGHT DIAGONAL ELLIPSIS'
'\t UNDERBAR'
'\x05AMBOO'
'\x05UNION'
'\x07 CIRCLE'
'\x03TCH'
'\nMONOSPACE '
'\x0eOLIDUS OVERLAY'
'\x12 WITH CIRCLE BELOW'
'\tHIGH STOP'
'\nRIGINAL OF'
'\x07BAYANNA'
'\x0bRANSMISSION'
'\x0cROUNDED ZERO'
'\x05ALOG '
'\x05ACCAT'
'\x11VEN EIGHTHS BLOCK'
'\x04ATHA'
'\x0fAMOUNT OF CHECK'
'\x05ZYGOS'
'\x1cEFT ARC GREATER-THAN BRACKET'
'\x06STROKE'
'\x07STRUCK '
'\x08VINATION'
'\x0cIRTY-SECOND '
'\rS KAI APOTHES'
'\x07ES NOT '
'\x0bARROW ABOVE'
'\x14INTERPOLATION MARKER'
'\rITING THROUGH'
'\x03AND'
'\x03ANG'
'\rU WITH STROKE'
'\t AND HOOK'
'\x18GHT TRIFOLIATE SNOWFLAKE'
'\x05HIRIQ'
'\x0eVERTICAL ABOVE'
'\x02HM'
'\x10UBJOINED LETTER '
'\tSEPTEMBER'
'\x10 INSERTION POINT'
'\x15YIG MGO TSHEG SHAD MA'
'\x05OMMA '
'\x042 WO'
'\nLIGHT BEAT'
'\nGREE SLASH'
'\x11MALL WHITE CIRCLE'
'\x06BLACK '
'\x05GALGA'
'\x06TOPBAR'
'\x0cLINGING FIRE'
'\x07GLAGOLI'
'\x07MENIAN '
'\x0cOACTIVE SIGN'
'\x07ASURED '
'\n FULL STOP'
'\nPLICATION '
'\x040 ZO'
'\tROJECTION'
'\x07AN MARK'
'\x05BAARU'
'\x10QUALS SIGN BELOW'
'\x05ENTRE'
'\x16LOSING YIG MGO SGAB MA'
'\x03NJE'
'\x0bRESCENT BAR'
'\x03ND '
'\x04IGN '
'\x07NUBIAN '
'\x0bSINGLE AND '
'\x03HWA'
'\x03UON'
'\n6 PLASTICS'
'\x06NIRUGU'
'\n-HIRAGANA '
'\x13ND SLANTED PARALLEL'
'\x05AADHU'
'\x04NOUT'
'\x04MBIC'
'\x06ASSING'
'\x07WO MARK'
'\x04PAWN'
'\x0bROSSED-TAIL'
'\x04ITH '
'\nAL BARLINE'
'\x0bINTEGRATION'
'\x01N'
'\x03HEE'
'\x05THIRD'
'\tLACKFOOT '
'\x03HEN'
'\x05SHED '
'\x07OCALIC '
'\x05TACK '
'\x06BELOW '
'\x04GOAL'
'\x11OPEN CIRCLE ARROW'
'\x0f WITH DOT ABOVE'
'\x07AHAPAKH'
'\x04TAIN'
'\x06-CREE '
'\x05SOL S'
'\x08LORRAINE'
'\nDIATONIKI '
'\x03SON'
'\x0bOR OPERATOR'
'\x07NTICAL '
'\x058 NWA'
'\t OR EQUAL'
'\x05NSYON'
'\x03EIS'
'\rQUARTERS SIGN'
'\x05SIGN '
'\tGRAM FOR '
'\x0bNITIAL FORM'
'\x0eTILDE OPERATOR'
'\nHALF BLACK'
'\x08OMMA BAR'
'\x1bCIRCLE WITH NORTHWEST ARROW'
'\tORIZONTAL'
'\x03EIE'
'\x05DIGA '
'\tP DIGRAPH'
'\x04LUIS'
'\x05FAAFU'
'\x0cRRESPONDS TO'
'\x08MON TIME'
'\x08SHOE JOT'
'\x06ARROW '
'\x06O SIGN'
'\x0cVERTICAL BAR'
'\x03OWN'
'\nRIGHT AND '
'\x04ASLA'
'\x0cSOLATED FORM'
'\nDDAH ABOVE'
'\x10HMATULLAH ALAYHE'
'\x10ONE EIGHTH BLOCK'
'\x03AY '
'\tING ABOVE'
'\x1fETALLED OUTLINED BLACK FLORETTE'
'\x0cOTATION MARK'
'\x019'
'\x04ANA '
'\x19TTED SUBSTITUTION BRACKET'
'\x02MP'
'\x03YOO'
'\x05CHADA'
'\x08OBOOFILI'
'\x06ECEDES'
'\x0fHOUSAND STATERS'
'\x05LACK '
'&AL WITH SUPERSCRIPT ALEF ISOLATED FORM'
'\x03YOD'
'\x03OW '
'\x04TER '
'\x03LVE'
'\x05XTRA-'
'\x07SAMPHAO'
'\x05MUOY '
'\x049 TU'
'\x13DOWN AND HORIZONTAL'
'\x07LETTER '
'\x08ESS-THAN'
'\x05WHITE'
'\x03YOT'
'\x08FISHHOOK'
'\x07MICOLON'
'\x04UND '
'\x02XE'
'\x04 BAR'
'\tINE BELOW'
'\x0fGHT REPEAT SIGN'
'\x04PING'
'\x06FINAL '
'\x05ARET '
'\x03EI '
'\x07KHIEUKH'
'\x04ARC '
'\x06KRISIS'
'\x0cMING TO MEET'
'\x03LY '
'\x04TENT'
'\x07POINTER'
'\x06OCENCE'
'\x05QUILL'
'\nNOON WITH '
'\t AND TAIL'
'\x04IKRI'
'\x02KS'
'\x03XAN'
'\nTONE MARK-'
'\x05INIMA'
'\x1eSUPERSCRIPT ALEF ISOLATED FORM'
'\x02O '
'\nLONG OVER '
'\x041 SI'
'\x08AIYANNOI'
'\x05COND '
'\x04HAVE'
'\nM STALLION'
'\x15LESS-THAN OR EQUAL TO'
'\x041 SA'
'\x0cSMALL CIRCLE'
'\x07L SEGNO'
'\x0cINTERSECTION'
'\nSHARP SIGN'
'\x06 SIGN '
'\x05GMENT'
'\x03PIC'
'\x08LONG S T'
'\x08NO SLASH'
'\x06BEFILI'
'\x06TILDE '
'\x04TURN'
'\x13ND SOUTH WEST ARROW'
'\tYEH ABOVE'
'\nOUTER JOIN'
'\x1bIDE ARC ANTICLOCKWISE ARROW'
'\x0eEVERSE SOLIDUS'
'\x08ELLIPSIS'
'\x05LABOR'
'\x04GGWS'
'\x11RIGHT HALF CIRCLE'
'\x10MIDIRECT PRODUCT'
'\x06STROFO'
'\tBAR ABOVE'
'\x15ALATALIZED HOOK BELOW'
'\rVE-LINE STAFF'
'\x04SIOS'
'\x07MIDDLE '
'\x08FRICAN D'
'\nUBLE DANDA'
'\x070 SPEAR'
'\x11-9 QUOTATION MARK'
'\x07BRACKET'
'\x05AMEKH'
'\x02OO'
'\x02ON'
'\x02OM'
'\x02OL'
'\x02OK'
'\x05URITY'
'\x13NAXIAN FIVE HUNDRED'
'\x02OH'
'\x02OG'
'\x02OF'
'\x02OE'
'\t2 GARMENT'
'\x06CATAWA'
'\n RGYA GRAM'
'\x0bONG-BRANCH-'
'\x05IANCE'
'\x06NSUZ A'
'\x03RQA'
'\x02OW'
'\x07TRICAL '
'\x02OU'
'\x12FIVE EIGHTHS BLOCK'
'\x02OS'
'\x02OR'
'\x1aLEFTWARDS OF UPWARDS ARROW'
'\x02OP'
'\x05UBITO'
'\nOANDAKHIAT'
'\tNIGGAHITA'
'\x04ANG '
'\x05YIZET'
'\x04INOR'
'\x0bWHITE ARROW'
'\rGTER TSHEG MA'
'\x04CAYN'
'\nUMBER SIGN'
'\x13ANSPOSITION BRACKET'
'\rEAVENLY EARTH'
'\x08REE MARK'
'\x0cNCK CONSTANT'
'\x05RASHA'
'\x08VOLUTION'
'\x03DEK'
'\x05RUDAA'
'\x02FI'
'\x05PRINT'
'\x11HIRTEEN FULL STOP'
'\x03DEE'
'\x05BLOCK'
'\x19LEFTWARDS ARROW WITH HOOK'
'\x048 SU'
'\x08 SQUARED'
'\nYRILLIC EN'
'\x08UP HEAVY'
'\x0eDASIA PNEUMATA'
'\x1aDROP-SHADOWED WHITE SQUARE'
'\x03AME'
'\x06APLI M'
'\x03UP '
'\x06LISHA '
'\rWITH TWO DOTS'
'\x03DOT'
'\x10RAIDO RAD REID R'
'\x08ALLY EQU'
'\tTONE MAI '
'\x08ECH YIWN'
'\tIVINATION'
'\tMALE SIGN'
'\x11IDEOGRAPHIC COMMA'
'\x06LEADER'
'\nLEK ATTAK '
'\x0fRMAN PENNY SIGN'
'\x15GRAMMOS OKTO DODEKATA'
'\x04UPLE'
'\x05HETHE'
'\x04TWAA'
'\x0fABOVE LESS-THAN'
'\x03ASH'
'\x19LEFT PARENTHESIS ORNAMENT'
'\x03305'
'\x0cOID NOTEHEAD'
'\x05IRAMA'
'\x0cMIDDLE PIECE'
'\x0eQUOTATION MARK'
'\x19DRY MEASURE FIRST SUBUNIT'
'\x0fBELGTHOR SYMBOL'
'\x06IG YUS'
'\x04AYIN'
'\x03IVE'
'\tLEFTWARDS'
'\x12UNATE SIGMA SYMBOL'
'\x08MUSICAL '
'\rINVERTED TURN'
'\t THOUSAND'
'\x04HADE'
'\x04SIS '
'\x18WO DOTS VERTICALLY ABOVE'
'\x13URRENCY SYMBOL BAHT'
'\x0cUBSCRIPT TWO'
'\x1cUPWARDS AND RIGHTWARDS ARROW'
'\x07ETNAHTA'
'\x10THREE DOTS ABOVE'
'\x0bOUBLE ACUTE'
'\x04MNAS'
'\x05OKOJI'
'\tRISPOMENI'
'\x19FFICULTY AT THE BEGINNING'
'\x071 ARROW'
'\tEARDROP-S'
'\x11WITH NOT EQUAL TO'
'\x1cUP HEAVY AND LEFT DOWN LIGHT'
'\n RESUPINUS'
'\x0eOLD RESOLUTION'
'\x053 RA3'
'\x03ACH'
'\x0fQUADRUPLE DASH '
'\nLGIZ EOLHX'
'\x03CWA'
'\x06INKING'
'\x14DOUBLE DOT TONE MARK'
'\rBOTTOM CORNER'
'\x0cRIANGLE DOWN'
'\x04RING'
'\x03NER'
'\x0cPOGEGRAMMENI'
'\x0bFEMALE SIGN'
'\x0cWN ARROWHEAD'
'\x05EMLJA'
'\x0bREAKTHROUGH'
'\nAL SYMBOL '
'\rLOCATION SIGN'
'\tEEM WITH '
'\rUPERIMPOSED X'
'\x04OTUS'
' ETALLED BLACK AND WHITE FLORETTE'
'\x0cMANNAZ MAN M'
'\x0cEQUAL TO OR '
'\x05TILDE'
'\x05EARTH'
'\x11INEAR ANNOTATION '
'\x07NESTED '
'\x0fTILDE DIAERESIS'
'\x18HEAVY BLACK HEART BULLET'
'\nTHAPASCAN '
'\x045 NU'
'\x06-MINUS'
'\x07LAYANNA'
'\x0bIOR PRODUCT'
'\x02NA'
'\tOURA SIGN'
'\x07OINTED '
'\x07PHIEUPH'
'\rWN TACK BELOW'
'\x05HORT '
'\x04MUIN'
'\x13LATIN SMALL LETTER '
'\x04QUAD'
'\x10PEN CENTRE CROSS'
'\x03SJE'
'\tOVER LONG'
'\x17HANKED RIGHTWARDS ARROW'
'\x0bMIDDLE HOOK'
'\x06NOKHUK'
'\x04ARGI'
'\x03MEM'
'\x06WITH T'
'\x03MEN'
'\x05MAI K'
'\x03NE '
'\x04NGIA'
'\x03ACE'
'\x04HIRT'
'\x05MALON'
'\x064 DEER'
'\x06WHITE '
'\rCURLY BRACKET'
'\x0eMOTHETIC ABOVE'
'\x11RIGHT ARROW ABOVE'
'\x05ANGLE'
'\tESAME DOT'
'\nNGUAGE TAG'
'\x07SMANYA '
'\x05EQUAL'
'\x1aTHREE DOTS ABOVE DOWNWARDS'
'\rD COMMA ABOVE'
'\x04NOT '
'\tAROSHTHI '
'\x06ANUARY'
'\x0e AND SMALL TAH'
'\tMETOBELUS'
'\x04DEL '
'\x07PERATOR'
'\x06FIFTHS'
'\x06TIKENO'
'\x02TY'
'\x15SHADOWED WHITE SQUARE'
'\x08GINAL OF'
'\x02TU'
'\x02TS'
'\x03ACK'
'\x02TO'
'\x1bWO DOTS BELOW AND DOT ABOVE'
'\x05RASS '
'\x02TI'
'\x06QAMATS'
'\x0bXESTES SIGN'
'\x08RINHIEUH'
'\x02TA'
'\x02AA'
'\x02AC'
'\x02AE'
'\x02AD'
'\x02AG'
'\x02AF'
'\x06IANGLE'
'\x073 WHEEL'
'\x08OT ABOVE'
'\x05EMALE'
'\x04ZELO'
'\x02AL'
'\x15ORTOISE SHELL BRACKET'
'\x02AN'
'\x02AP'
'\nILING FACE'
'\x02AR'
'\x02AU'
'\x02AT'
'\x02AW'
'\x02AV'
'\x10RIGHT HALF BLACK'
'\x0fULGAR FRACTION '
' VED STEM PARAGRAPH SIGN ORNAMENT'
'\x02T '
'\nTWO SHORTS'
'\x043 MU'
'\x05ICHON'
'\tKSTREPTON'
'\x04HSDA'
'\x05CKING'
'\x15OCAL NOTATION SYMBOL-'
'\x1bROTATED FLORAL HEART BULLET'
'\nUMAN EARTH'
'\x04NOTE'
'\nREVERSED I'
'\x06QETANA'
'\x043 ME'
'\x03EZH'
'\x03EZI'
'\x04ASIA'
'\x0bSHEQEL SIGN'
'\x14LEFT AND LOWER RIGHT'
'\x043 MI'
'\n-POINTING '
'\nENETRATION'
'\x0fMALAKON CHROMA '
'\x05ORNER'
'\x04REH '
'\x05MBOL '
'\x03UJA'
'\x0bZIGZAG LINE'
'\x15INTERSECTION OPERATOR'
'\x0bAGAZ DAEG D'
'\x04CWAA'
'\x0cLUS NOTEHEAD'
'\tTABE SIGN'
'\x06CORNER'
'\tLEFT HOOK'
'\tABOVE TO '
'\x05BARB '
'\x04HEEP'
'\x02 A'
'\x07PARTURE'
'\x0bBETA SYMBOL'
'\x02 K'
'\x04IFAT'
'\x067 KAPO'
'\x05SSERA'
'\x02ND'
'\x04ABOR'
'\x0bROKUTASTI A'
'\x03EH '
'\x04ARB '
'\x13UBSTITUTION BRACKET'
'\x11 PUNCTUATION MARK'
'\x04HEEN'
'\x15EFT OPEN BOX OPERATOR'
'\x04ALDA'
'\x04BER '
'\x06RGLASS'
'\x03NTY'
'\tDESCENDER'
'\x08VISION S'
'\x0fING SYMBOL FOR '
'\nCHECK MARK'
'\x04QAAF'
'\x13IN CHEN SPUNGS SHAD'
'\tED SWORDS'
'\x04ARP '
'\x0bFGHANI SIGN'
'\x04SHTA'
'\x01P'
'\tNFORZANDO'
'\x06TE TSE'
'\x06BAFILI'
'\nHEAVY AND '
'\x0b TACK BELOW'
'\nING LARGE '
'\x03IOS'
'\x03LAM'
'\x04EENU'
'#BESIDE AND JOINED WITH INTERSECTION'
'\x0eTROKE NOT SIGN'
'\x08MMATION '
'\tOUND SIGN'
'\x0bHAMZA ABOVE'
'\x0fQUADRUPLE ARROW'
'\x0cPUNCTUATION '
'\x10SERIFS AT BOTTOM'
'\x05GALI '
'\x04UBLE'
'\x088 KANAKO'
'\x18P DIRECTIONAL FORMATTING'
'\x04CHEE'
'\x08 HUNDRED'
'\x0cNUMERAL SIGN'
'\nWITH BARB '
'\x05CARON'
'\x07RA SIGN'
'\x06TO BAR'
'\x0bARACTER TIE'
'\x11TAN ISOLATED FORM'
'\x03LAS'
'\tLINE FEED'
'\x10WITH CENTRED DOT'
'\x03UOP'
'\x07BOTTOM '
'\x07ORCULUS'
'\nAELA-PILLA'
'\x05VRIDO'
'\x12NYOOGA NAAKSIKYAYA'
'\x08SIGN LAE'
'\x16ROUND A POINT OPERATOR'
'\x04PII '
'\x03ALC'
'\x0e WITH FISHHOOK'
'\x05VERSE'
'\x06MEDIUM'
'\x06LAFRON'
'\x07APYEOUN'
'\x08GENITIVE'
'\rDOUBLE CIRCLE'
'\x07POMOFO '
'\x03ALA'
'\x06HERMES'
'\x051 TWO'
'\x05GAMMA'
'\x19BUT NOT ACTUALLY EQUAL TO'
'\nIDGE BELOW'
'\x06URTEEN'
'\x0eLEFT HALF RING'
'\x0cZIGZAG ABOVE'
'\x04HAIR'
'\nALEF LAMED'
'\x10WITH HAMZA ABOVE'
'\x0bBREVE BELOW'
'\x07ISIBLE '
')CK-TILTED SHADOWED WHITE RIGHTWARDS ARROW'
'\x03FT '
'\x0bMBA BAYANNA'
'\x05VOWEL'
'\x0cUTH-SLAVEY K'
'\tDUS RTAGS'
'\x05MAQAF'
'\x03TAA'
'\x06EQUAL '
'\x07IRGHIZ '
'\x05ERET '
'\x16SHORT RIGHTWARDS ARROW'
'\x08D RIGHT '
'\x05OURCE'
'\x14 ABOVE SLANTED EQUAL'
'\x1eOPEN CENTRE EIGHT POINTED STAR'
'!TWO DOTS ABOVE AND TWO DOTS BELOW'
'\x06EQUALS'
'\rIFIER LETTER '
'\x1dCOMMA QUOTATION MARK ORNAMENT'
'\x04IRGA'
'\x14DOTLESS HEAD OF KHAH'
'\x04FIVE'
'$LEFT TORTOISE SHELL BRACKET ORNAMENT'
'\x08ZWARAKAY'
'\x12EVENTEEN FULL STOP'
'\x03IGN'
'\x0fED PAPER SYMBOL'
'\x07UBADAMA'
'\x07LLOWING'
'\x03IGH'
'\x05SICLE'
'\x0bCOMMA ABOVE'
'\nHOGI PIECE'
'\tYRANISMA '
'\x12ENTERING TONE MARK'
'\x08ATAKANA '
'\x0cSIGMA SYMBOL'
'\x0234'
'\x0cDOUBLE ARROW'
'\x0cMIDDLE TILDE'
'\nLOWER HOOK'
'\x05WENTY'
'\x11VERAGE WITH SLASH'
'\x07DEAVOUR'
'\x02FT'
'\x05RITSI'
'\x04HAIN'
'\x0cGREATER-THAN'
'\x04CRON'
'\x02FA'
'\nDOWN LIGHT'
'\x04EUNG'
'\x06RIGHT '
'\x02FE'
'\rGISTERED SIGN'
'\rDOTTED ZLAMA '
'\x17CIRCUMFLEX ACCENT ABOVE'
'\x19NIVERSAL RECYCLING SYMBOL'
'\x08O SYMBOL'
'\x04 C D'
'\x02FL'
'\x03SMA'
'\x02FO'
'\x08THIOPIC '
'\x05HEART'
'\x08RADICAL '
'\x04UNAH'
'\x0bMUUSIKATOAN'
'\x02YN'
'\x0cERTICAL LINE'
'\x03HHA'
'\x02YA'
'\x04NCEL'
'\x06UPITER'
'\x0bNWHEEL STAR'
'\x07RRECTUS'
'\tSMALL YUS'
'\x05OMEGA'
'\rUPWARDS ARROW'
'\tMUKPHRENG'
'\x08TO-LEFT '
'\x03JER'
'\nRSI SYMBOL'
'\x06ETTER '
'\x13UP HORIZONTAL HEAVY'
'\nCROPHONIC '
'\x06ANSIOS'
'\x052 PTE'
'\x05IMMA '
'\x08ALE SIGN'
'\rGYA GRAM SHAD'
'\x10FALLING DIAGONAL'
'\x04HOST'
'\x12 AND SMASH PRODUCT'
'\rQUARE BRACKET'
'\x05ABOVE'
'\n WITH HOOK'
'\x0fOLIDUS OPERATOR'
'\x08PERFECTA'
'\x05CREEN'
'\x03ALL'
'\x10RIGHTWARDS ARROW'
'\x03ALK'
'\x0eFEHU FEOH FE F'
'\x03ALF'
'\x08-HEADED '
'\x03ALE'
'\x05IGIT '
'\x08THAMASAT'
'\x04MARK'
'\x04TIC '
'\x04MARU'
'\x14SINGLE DOT TONE MARK'
'\x08RAMMA GG'
'\x08 STATERS'
'\x03ALT'
'\tOWER LEFT'
'(DASH FROM LEFT MEMBER OF DOUBLE VERTICAL'
'\x02YI'
'\x13TIONAL DIGIT SHAPES'
'\x0cSHED BARLINE'
'\x08LUB SUIT'
'\x06SPATHI'
'\x02YO'
'\tDOT ABOVE'
'\x04SLUR'
'\x06VILIAN'
'\x03TOP'
'\x04RIPT'
'\x02YE'
'\x08NCE SIGN'
'\x02UP'
'\nIDDLE MARK'
'\x03TON'
'\x03TOO'
'\x16UPPER RIGHT AND LOWER '
'\x02YR'
'\x02YU'
'\x02YT'
'\x0bIGGLY FENCE'
'\x0fIRCUMFLEX BELOW'
'\x03HIP'
'\x0bSSIVE-PULL-'
'\x0bOUBLE ARROW'
'$OR LOWER RIGHT CURLY BRACKET SECTION'
'\x02NU'
'\x13ANTICLOCKWISE ARROW'
'\x0fNOON FINAL FORM'
'\x05BASA '
'\x08HEG SHAD'
'\tVISARGAYA'
'\x0b WITH DASIA'
'\x06OBELUS'
'\x06LAMADH'
'\x04IGH '
'\x06BARREE'
'\x06DIESIS'
'\x04JEON'
'\x05 CLEF'
'\x03HIN'
'\tNTRACTION'
'\x1aOCKED FEMALE AND MALE SIGN'
'\tTONE MARK'
'\x04IGHT'
'\tAND ACUTE'
'\x04OMBU'
'\x01Q'
'\x02UE'
'\x0bIN TRIANGLE'
'\x13FLORAL HEART BULLET'
'\x0fR WITH FISHHOOK'
'\x15OVER RIGHTWARDS ARROW'
'\x05EAVEN'
'\x11NEGATIVE CIRCLED '
'\x13 AND TWO DOTS ABOVE'
'\x0bINDICESIMA '
'\tRECTANGLE'
'\x04A IE'
'\x1cTRIPLE VERTICAL BAR OPERATOR'
'\n FROM WALL'
'\x06UUMISH'
'\x03BHA'
'\x02Y '
'\x04USA '
'\x042 QO'
'\r SKEWED RIGHT'
'\x12ARAGRAPH SEPARATOR'
'\x0cDENTAL CLICK'
'\x10TELOUS ICHIMATOS'
'\x07NUSVARA'
'\x08SPECTIVE'
'\x04OTTO'
'\rUSHING UPWARD'
'\x07GOLIAN '
'\x03TO '
'\x06IRTEEN'
'\x06ESTION'
'\x15-ROUND NOTEHEAD DOWN '
'\x05LINE '
'\x05UTE A'
'\x07 KEFULA'
'\x08UP LIGHT'
'\x06HIEUKH'
'\x0bRIGHT LIGHT'
'\x12MINAL DIGIT SHAPES'
'\x0bSYMBOL FOR '
'\t ARCHAION'
'\nLOGICAL OR'
'\x07RAGANA '
'\x11PINWHEEL ASTERISK'
'\x04KAUN'
'\x0fMZA ABOVE WITH '
'\x12 WITH CIRCLE ABOVE'
'\x03EGA'
'\nLINDRICITY'
'\nSSANGARAEA'
'\rARLAUG SYMBOL'
'\x0bULO TWO SUM'
'\tTRAIGHT U'
'\x06TAMING'
'\x0bEORGIAN NAR'
'\x0fEFT PARENTHESIS'
'\x04ONOS'
'\x03RAA'
'\x03RAN'
'\x0eSMALL TRIANGLE'
'\x08TISMOS E'
'\x08LASH BAR'
'\x08KOUFISMA'
'\x0bVISARGA ONE'
'\x04ONON'
'\x0bULAR BULLET'
'\tDAD WITH '
'\x06WARDS '
'\x13TART OF RUB EL HIZB'
'\x03RAY'
'\x07BIG YUS'
'!EFT-POINTING ANGLE QUOTATION MARK'
'\x17ININE ORDINAL INDICATOR'
'\rTOP HALF RING'
'\x0fHREE DOTS ABOVE'
'\x06GANGIA'
'\x030 U'
'\x08SSESSION'
'\x04STOP'
'\x05TINNE'
'\x15 AND SLANTED PARALLEL'
'\x08ABOAFILI'
'\x0cWIGGLY FENCE'
'\x07QUARIUS'
'\x05SLASH'
'\x05SCAPE'
'\x04ROA '
'\x03LPA'
'\x05QATAN'
'\x05ACRON'
'\x07USSYERU'
'\x0bTRESS SIGN '
'\x04LETE'
'\x0cMALL LETTER '
'\x0bTETRAFONIAS'
'\tS DIGRAPH'
'\x05RANUS'
'\x03VIN'
'\x0bRAVE ACCENT'
'\x0eIGHTWARDS VANE'
'\x03VIR'
'\x03VIS'
'\x04ARA '
'\x16LLAHOU ALAYHE WASALLAM'
'\x0eBLADE SCISSORS'
'\tLARGEMENT'
'\x05CEDES'
'\x07ER THAN'
'\x18LLING DIAGONAL CROSSING '
'\x07SAYANNA'
'\x04ROSS'
'\x03IFT'
'\x03OCK'
'\x04STAR'
'\x05TUEUM'
'\x06HARP S'
'$GREATER-THAN ABOVE DOUBLE-LINE EQUAL'
'\x0fHALF FILL SPACE'
'\x16DOUBLE SOLIDUS OVERLAY'
'\x04GLE '
'\x06APITAL'
'\x04OUT '
'\x03IFF'
'\x0fPLUS SIGN BELOW'
'\tFISH TAIL'
'\x03FHA'
'\x08TWO DOTS'
'\x08EVERSED '
'\tHREE DOTS'
'\x0eRONIAN SIGN ET'
'\x0b AND MACRON'
'\x07ENTRED '
'\x06SMALL '
'\x06LIGION'
'\x05QUIRY'
'\x04SADI'
'\tMES WITH '
'\x10CORNER LEFTWARDS'
'\x0cKHMIMIC KHEI'
'\x03WO '
'\nANS-SERIF '
'\x0fRNAMENT STROKE-'
'\x0fLIGHT AND LEFT '
'\x07NIKAHIT'
'\x10IFTEEN FULL STOP'
'\x0b-MINUS SIGN'
'\x04URUS'
'\x06TAU RO'
'\x06AESURA'
'\x04OLON'
'\x07Y MUCH '
'\x07RAKHANG'
'\nARAKALESMA'
'\x1eOWER RIGHT DIAGONAL HALF BLACK'
'\x0cEN FULL STOP'
'\x08TAI LUE '
'\x1cHADED WHITE RIGHTWARDS ARROW'
'\x06FF OF '
'\rMASORA CIRCLE'
'\x04NOON'
'\x03THA'
'\x04RESH'
'0LANTED EQUAL ABOVE LESS-THAN ABOVE SLANTED EQUAL'
'\x08LESSER Y'
'\x05SAUIL'
'\x11MANENT PAPER SIGN'
'\x050 OIL'
'\x0cRIGHT SINGLE'
'\x06KNIFE '
'\x14PROLONGED SOUND MARK'
'\x0cACUTE ACCENT'
'\x03MUT'
'\x07FINAGH '
'\x07RDO RJE'
'\x05EEM I'
'\x04HORI'
'\x13PARAGRAPH SEPARATOR'
'\x03ZJE'
'\x07OREVMA '
'\x0eLESS-THAN NOR '
'\x03IT '
'\x04HORN'
'\x0bN THE VERGE'
'\x04KAPA'
'\nSTROM SIGN'
'\x10ENTRE WHITE STAR'
'\x04CURL'
'\x08NINETEEN'
'\x08SIFISTON'
'\x05ZENGE'
'\x06HIBIT '
'\x06GLAZ H'
'\tRD JOINER'
'\x0fRIANGULAR COLON'
'\x03ASU'
'\tBACKSLASH'
'\x08I SYMBOL'
'\x03NUN'
'\x06UFISMA'
'\x05STILE'
'\nEUR-DE-LIS'
'\x03ASE'
'\x06CHAMKO'
'\x0bOLD NUBIAN '
'\x08 OTTAVA '
'\x1aRIGHT PARENTHESIS ORNAMENT'
'\x0bOUBLE DANDA'
'\x03IAL'
'\x05BINDI'
'\tWUNG DASH'
'\x0bSSANGKIYEOK'
'\x03AS '
' TOP-LIGHTED RIGHTWARDS ARROWHEAD'
'\x03UNG'
'\x03DUR'
'\x07STROKE '
'\x04HERU'
'\r-OR-PLUS SIGN'
'\x0eJOINED SQUARES'
'\x02KA'
'\x02KE'
'\x0fAND FEMALE SIGN'
'\nMILLE SIGN'
'\x02KH'
'\nRUPEE SIGN'
'\x05OINT '
'\x03ITA'
'\x0bAISED COLON'
'\x05 CAPO'
'\x07DHALATH'
'\x02KW'
'\x0cBSCRIPT ALEF'
'\x03OMU'
'\nCHAD RTAGS'
'\tXIMATELY '
'\x0cLEFT HARPOON'
'\x03ITU'
'\nF SHE-GOAT'
'\x0c LINE SYMBOL'
'\x16USTOMER ACCOUNT NUMBER'
'\x03AAF'
'\x08TRIANGLE'
'\x08IGATURE '
'\tEXTENSION'
'\nDIGIT ZERO'
'\x08ARTYRIA '
'\tROW WITH '
'\nBSTRUCTION'
'\x11HORIZONTAL DOUBLE'
'\x05SHEYE'
'\x14 WITH FATHATAN ABOVE'
'\x13C DIGRAPH WITH CURL'
'\x05BLACK'
'\x05IDGE '
'\x040 KO'
'\x07DIGAMMA'
'\x0cOTTOM HALF O'
'\x0eOLUME INTEGRAL'
'\x06NTEVMA'
'\x05KUSMA'
'\rONG RIGHT LEG'
'\nATRICHISMA'
'\x03BIE'
'\x05RNED '
'\x04HAH '
'\x05FIFTY'
'\x04RKLE'
'\x04SANG'
'\x0cOUR INTEGRAL'
'\rARCHAIC KOPPA'
'\x05COMMA'
'\x15BESIDE RIGHT TRIANGLE'
'\x05ETTI '
'\x10 AND LIGHT RIGHT'
'\x08XCELLENT'
'\x0f WITH DIAERESIS'
'\x0bIPLE TONGUE'
'\x05GRAVE'
'\x05HIUTH'
'\tUBSTITUTE'
'\x06IASMA '
'\x0cTICLOCKWISE '
'\x08ELEPHONE'
'\x0cPROTOS ICHOS'
'\x0cCENDING NODE'
'\nPLUS BELOW'
'\x0eTOP HALF BLACK'
'\x0c WITH STROKE'
'\x08D SYMBOL'
'\x10 WITH CIRCUMFLEX'
'\x06ZHITSA'
'\x03ELD'
'\x1dSUPERSCRIPT ALEF INITIAL FORM'
'\x0bNITIAL IZHE'
'\x0cFERENCE MARK'
'\x079 CLOTH'
'\x05GREE '
'\x0fRIGHTWARDS TICK'
'\x07WN TACK'
'\x05RIGHT'
'\x07F WITH '
'\x0bSHAAYATHIYA'
'\x0cNNED LEATHER'
'\nCTION MARK'
'\x04AMMA'
'\x0bERCENT SIGN'
'\x05LAMDA'
'\x07HIN DOT'
'\x0cOING TO MEET'
'\x08COUNTERS'
'\x08TART OF '
'\nQUALS SIGN'
'\nMONTH SIGN'
'\rFULL SURROUND'
'\nBROKEN BAR'
'\x04EVMA'
'\x07T RIGHT'
'\x0fSTROKE NOT SIGN'
'\x03EXT'
'\rMALL CAPITAL '
'\x06YGISMA'
'\x0e-CURRENCY SIGN'
'\x13DENOMINATOR SIXTEEN'
'\x12ARIATION SELECTOR-'
'\x15NSVERSAL INTERSECTION'
'\x06ITHER '
'\x15DOUBLE LEFT TURNSTILE'
'\x0fHORIZONTAL FILL'
'\x0bSIGN VIRAMA'
'\x0bLOSING MARK'
'\rJES SU NGA RO'
'\x06THIRDS'
'\x06NAUD N'
'\x08FRAKTUR '
'\tDOWN AND '
'\x05ALLEY'
'\r BZHI MIG CAN'
'\x0eZAH WITH MEEM '
'\x0cNE HALF SIGN'
'\x04PICK'
'\x05REEK '
'\x04 OR '
'\x05TIPPI'
'\x0cDOT OPERATOR'
'\x0c SKEWED LEFT'
'\x07OW LINE'
'\x08LONG BAR'
'\x0eBLACK TRIANGLE'
'\x03THY'
'\x0bROSS ACCENT'
'\x07 EQUALS'
'\x06DIGIT '
'\x08YEN SIGN'
'\x06JEEM I'
'\x0fORMATION SOURCE'
'\x07CANDRA '
'\x08KATAKANA'
'\x05IHVUS'
'\x03NII'
'\x04RROI'
'\x0eCOLON OPERATOR'
'\x04POSE'
'\x03NIB'
'\x03NIA'
'\x04ATIM'
'\x08OVERLINE'
'\x04ITEM'
'\rSTABLE SYMBOL'
'\x07SERTION'
'\x0cSINGLE-LINE '
'\x0cRION CHRONON'
'\x04RROW'
'\x06OPEN E'
'\x06HUR PA'
'\x0fDI ALLAHOU ANHU'
'\x04MIIN'
'\x05MACUS'
'\x04AVY '
'\x05ATAF '
'\x05LIGHT'
'\x05NABLA'
'\tPIDERY HA'
'\x0bTHREE DOTS '
'\t APODEXIA'
'\x04TTER'
'\x0cEEPING SMALL'
'\x10LEFT ARROW ABOVE'
'\x02PR'
'\x02PP'
'\x02 P'
'\x0bSECOND MARK'
'\nSSANGPIEUP'
'\x02PU'
'\x04CYCL'
'\x05AMATS'
'\x13TO LOWER RIGHT FILL'
'\x02PY'
'\x0cFALLING DOTS'
'\x0fLEFTWARDS ARROW'
'\x16INVERTED SMALL V ABOVE'
'\x06AILURE'
'\x04DOT '
'\x04NINE'
'\x06WEORTH'
'\x04NING'
'\x02PE'
'\x03EF '
'\x05DENCE'
'\x02PH'
'\x05WLINE'
'\x04EHEH'
'\x0cANG KHANG GY'
'\rSYNDESMOS NEO'
'\x02PM'
'\x0bQUARE BELOW'
'\x03WN '
'\x0fIMPERFECTA REST'
'\tTAKHALLUS'
'\x0bWARDS ARROW'
'\x06BOWTIE'
'\x0cAPYEOUNPIEUP'
'\x10RACTION ONE HALF'
'\x03EFT'
'\tCURRENCY '
'\x05METRY'
'\x02P '
'\x03RAE'
'\x17ALEF MAKSURA FINAL FORM'
'\x07IGHTEEN'
'\x07CENTRE '
'\x04OONE'
'\x03ZOO'
'\x07-KIYEOK'
'\x05 LEFT'
'\x15REVERSED FEATHER MARK'
'\x13CE OF INTEREST SIGN'
'\x06RISEME'
'\x08ORM FEED'
'\x12WITH STROKE SYMBOL'
'\x06BOTTOM'
'\x06TAUROS'
'\x04GHT '
'\x04ALTA'
'\x06DRAGON'
'\x1fHEART EXCLAMATION MARK ORNAMENT'
'\x073 MONTH'
'\x14ALF TRIANGULAR COLON'
'\x04LEIA'
'\x05AMED '
'\x06VOWEL '
'\x05ACUTE'
'\x03RAM'
'\x08JUNCTION'
'\nPPA SYMBOL'
'\x04TRIA'
'\x08AMS HORN'
'\x06UPPER '
'\x05TITLO'
'\x05 FACE'
'\x08FROM BAR'
'\x0cNERSHIP SIGN'
'\x07MANCHU '
'\x0cPOETRY MARK-'
'\x0ePARESTIGMENON '
'\x0fXTEEN FULL STOP'
'\x06CHURCH'
'\x04WAHA'
'\x06-HIEUH'
'\x04THER'
'\x06AITING'
'\x02RD'
'\x13KULL AND CROSSBONES'
'\x17YELORUSSIAN-UKRAINIAN I'
'\x03OLD'
'\x03OLE'
'"MODIFIER LETTER LABIALIZATION MARK'
'\x07 SYMBOL'
'\x04ANDA'
'\x08MIONIAN '
'\tWITH HOOK'
'\x12KANTAJA NAASIKYAYA'
'\x05KNIFE'
'\rMINUS WHITE X'
'\x05CLIFF'
'\rDIAERESIZED U'
'\x0eNYI ZLA NAA DA'
'\x02RA'
'\x08LF RING '
'\x04AMLA'
'\nALL SQUARE'
'\x12JEEM ISOLATED FORM'
'\x04KURO'
'\x06PECIAL'
'\x08INTEGRAL'
'\x03IES'
'\x18T BLACK RIGHTWARDS ARROW'
'\x14IMAGE OF OR EQUAL TO'
'\x04AND '
'\x08MOTHETIC'
'\tLIVERANCE'
'\x0eOUNDED CORNERS'
'\x06 CARET'
'\x16BAR ABOVE INTERSECTION'
'\nITING HAND'
'\x08CAPITAL '
'\x05TTERN'
'\x04IRED'
'\x03USH'
'\rANNED LEATHER'
'\x14HADOWED WHITE SQUARE'
'\x05URTLE'
'\nED FIGURE-'
'\x05IGHT '
'\x04RAFE'
'\x06ODHADH'
'\x07BSET OF'
'\x12ATIN SMALL LETTER '
'\x04SEEN'
'\x10HOLDING TOGETHER'
'\x06NINETY'
'\x14AND NORTH EAST ARROW'
'\x07YANMAR '
'\nLPAPRAANA '
'\x0fIAMOND UNDERBAR'
'\x0fMAL SUBGROUP OF'
'\x14PARENTHESIS ORNAMENT'
'\x045 DE'
'\x0cINTEGRATION '
'\x05CCENT'
'\x06INDHI '
'\x04RT T'
'\x03ANO'
'\tNK SYMBOL'
'\x07LYGISMA'
'\x0eOBLIQUE HYPHEN'
'\x18RIGHT TO LOWER LEFT FILL'
'\x04HOOK'
'\x08PRECEDES'
'\x0eINVERTED BREVE'
'\x0cN ELEMENT OF'
'\x05KHAH '
'\x08SNA LDAN'
'\x05GRAPH'
'\x05SION '
'\x0eOOTNOTE MARKER'
'\x03BXG'
'\x08ETARTOS '
'\x03PPA'
'\x0b WITH TITLO'
'\x06FAMILY'
'\x03GAY'
'\x07UNDRED '
'\x05 MEGA'
'\x03MOI'
'\x03SOO'
'\x0e AND DOT ABOVE'
'\x03 FA'
'\x08OPENING '
'\x06-PIEUP'
'\x06LITIKI'
'\x0cS ABOVE SIGN'
'\x03GAG'
'\x07ESTIVAL'
'\x04ALES'
'\nRIGHTWARDS'
'\x04WAW '
'\x03SO '
'\x05O KAI'
'\x07UBUFILI'
'\x06RIKRIK'
'\x07BOURING'
'\nEBENSTIMME'
'\rNUMERATOR ONE'
'\x15TEEN POINTED ASTERISK'
'\x08UAREG YA'
'\x08ETA SIGN'
'$DOUBLE-LINE EQUAL ABOVE GREATER-THAN'
'\x13HURISAZ THURS THORN'
'\x05SENTO'
'\x0fOUBLE BACKSLASH'
'\x06ABOVE '
'\x17ANG DEPARTING TONE MARK'
'\x12INDEPENDENT VOWEL '
'\x0cNGLE BARLINE'
'\x04NWAA'
'\x06KEYCAP'
'\x08NUMERAL '
'\x03ARC'
'\nSHOE STILE'
'\x05DELTA'
'\x17IDE ARC CLOCKWISE ARROW'
'\rMALL LETTER J'
'\x08BUNDANCE'
'\x06YBOARD'
'\rHERICAL ANGLE'
'\x03YIN'
'\tANTHAKHAT'
'\x02BE'
'\rTHIRD SUBUNIT'
'\x18RMITIAN CONJUGATE MATRIX'
'\x02BA'
'\x1aHTORA SKLIRON CHROMA VASIS'
'\r-INDIC DIGIT '
'\x0eREATIVE HEAVEN'
'\x06RIPT G'
'\x02BO'
'\x02BI'
'\x05ORUTO'
'\x13ARENTHESIS NOTEHEAD'
'\x14MULTIPLE PUNCTUATION'
'\x04JOT '
'\x03TIO'
'\x04LAT '
'\x0fNVERTED UBADAMA'
'\x13ARABIC FORM SHAPING'
'\x0eMULTIPLICATION'
'\x03TIE'
'\x04BORE'
'\x0cPALATAL HOOK'
'\x02BY'
'\x04NCIL'
'\x06FATHA '
'\x08OPRODUCT'
'\x07APITAL '
'\tERTY LINE'
'\x17INUOUS UNDERLINE SYMBOL'
'\x06AKABAT'
'\x12VERTICAL RECTANGLE'
'\x04OPPA'
'\x08IR SPACE'
'\x05WATTO'
'\x0bDOLLAR SIGN'
'\x06EVENTY'
'\x05NIEUN'
'\nTERMINATOR'
'\x05METEG'
'\x07MEETORU'
'\x04KOET'
'\x0bDOACHASHMEE'
'\nTAL RUNOUT'
'\nACK CIRCLE'
'\x05DEXIA'
'\x05HOLAM'
'\x16DOWNWARDS ZIGZAG ARROW'
'\x10SOUTH EAST ARROW'
'\x0eOT PUNCTUATION'
'\x05HESS '
'\nINHERENT A'
'\x01T'
'\x05ARROW'
'\x05HOLAR'
'\x0eYEH FINAL FORM'
'\x0cNGRATULATION'
'\x0cAR DIAERESIS'
'\x06CHRIVI'
'\x17DOT BELOW AND DOT ABOVE'
'\tBKHASIAN '
'\x05IKURU'
'\x18POINTING DOWNWARDS ABOVE'
'\x07STERING'
'\r WITH TEE TOP'
'\x05PEN-P'
'\x06WN BOX'
'\x05JUDGE'
'\x06EASURE'
'\x0bON PEDESTAL'
'\x06HIVETE'
'\x04BSET'
'\nTSHEG SHAD'
'\x07A -PHRU'
'\x13WARDS ARROW OVERLAY'
'\x04ROAR'
'\x072 OLIVE'
'\x0cWHITE CIRCLE'
'\x05NADA '
'\x04DOWN'
'\x040 PU'
'\x10CORNER DOWNWARDS'
'\x03EEN'
'\x05DIAL '
'\x04ARGA'
'\x1cFOUR BALLOON-SPOKED ASTERISK'
'\tTWO DOTS '
'\x1eSAD WITH LAM WITH ALEF MAKSURA'
'\x02U '
'\x05ETION'
'\x16OVER LEFTWARDS HARPOON'
'\x0cTRIPLE DASH '
'\x06ATTIC '
'\x10LIGHT AND RIGHT '
'\x03RON'
'*LA USED AS KORANIC STOP SIGN ISOLATED FORM'
'\x03OSS'
'\x03ROC'
'\x0bNUMBER ZERO'
'\x04EUCH'
'\x0fESIDE LESS-THAN'
'\x03ROG'
'\x0f QUOTATION MARK'
'\x07T MINUS'
'\x03LLO'
'\x0eCRIFICIAL WINE'
'\x03ROP'
'\x03LLA'
'\x05ICHOS'
'\x05MEEMU'
'\x10 AND LOWER RIGHT'
'\tGRIK SIGN'
'\x0bNUSVARA ONE'
'\x06EGEAN '
'\x05WAAVU'
'\x16SYMPTOTICALLY EQUAL TO'
'\x0bGLE BRACKET'
'\tBO GYFU G'
'\x05MEEM '
'\t-STACCATO'
'\x1eCONTAINING BLACK SMALL DIAMOND'
'\x10BBREVIATION MARK'
'\x05OWEL '
'\x04BERD'
'\x0eTETARTOS ICHOS'
'\rETROFLEX HOOK'
'\nLIGHT AND '
'\x08ATH MARK'
'\x06UDATTA'
'\x03KAY'
'\x04WAVE'
'\x05ALEF '
'\x081 BARLEY'
'\x15ITIAL YIG MGO MDUN MA'
'\x05TRAIF'
'\nEONGCHIEUM'
'\x06IXTEEN'
'\x02UT'
'\x05TSADI'
'\tULTI REST'
'\x02US'
'\x02UR'
'\x02UM'
'\x02UL'
'\x02UO'
'\x02UN'
'\x04RUSI'
'\x0fTWO WITH STROKE'
'\x0eRETROFLEX HOOK'
'\x02UD'
'\nLINE BELOW'
'\x02UA'
'\x07DOUBLE '
'\x10LEFT HALF CIRCLE'
'\x06ARBUTA'
'\tDOWN TACK'
'\x0bGENTLE WIND'
'\x04ALAI'
'>DIVIDED BY HORIZONTAL BAR AND TOP HALF DIVIDED BY VERTICAL BAR'
'\x0eEPSILON SYMBOL'
'\x05CROSS'
'\x16LEFT TRIANGLE OPERATOR'
'\x04ELTA'
'\x1bPHARYNGEAL VOICED FRICATIVE'
'\t-KHYUD PA'
'\tALI GALI '
'\x05QAAFU'
'\x08ECTANGLE'
'\nSGOR RTAGS'
'\x12SINGLE PUNCTUATION'
'\x0fDAGESH OR MAPIQ'
'\nUARDEDNESS'
'\x03O B'
'\x03O N'
'\x18LINE HORIZONTAL ELLIPSIS'
'\tOF STIMME'
'\x04GRAL'
'\x06IN DOT'
'\x11CONTOURED OUTLINE'
'\rLATERAL CLICK'
'\x05ZAYIN'
'\x05SCENT'
'\x10VERTICALLY ABOVE'
'\x04MINI'
'\x03FEE'
'\tARROWHEAD'
'\x0cENOS CHRONOU'
'\x07TA MARK'
'\x08AF WITH '
'\x07WO WAEN'
'\x07UP TACK'
'\x03FEH'
'\x04MING'
'\x06SIEUNG'
'\x19MULTIPLICATION SIGN BELOW'
'\x05CUBED'
'\x06R THAN'
'\x10BOTTOM HALF RING'
'\x04HIIN'
'\tHAH WITH '
'\x03ZWG'
'\tELLOWSHIP'
'\x0eEND OF SECTION'
'\x0bCELANDIC-YR'
'\x04FOUR'
'\x0bASE TO THE '
'\x07AYALAM '
'\x04TED '
'\x04ABLE'
'\x08YRILLIC '
'\x06LOSED '
'\x0bRIGHT HEAVY'
'\x06LEFT C'
'\x0cOPENING LEFT'
'\x05ISTLE'
'\x0eDOUBLE-STRUCK '
'\x0bMOST EQUAL '
'\tTANDSTILL'
'\x11UNION WITH SERIFS'
'\x0cCSIMILE SIGN'
'\x04TIP '
'\x14CLUB-SPOKED ASTERISK'
'\x03CIG'
'\x05BHETH'
'\x05AUTHS'
'\x03 UP'
'\x1aIANGLE BESIDE VERTICAL BAR'
'\x03ZHA'
'\x0eUP RIGHT BARB '
'\x06BEGIN '
'\x0cING OPERATOR'
'\x04-UM '
'\x08ST-CREE '
'\x18CULINE ORDINAL INDICATOR'
'\x04ZIET'
'\x0fACHES THE LIMIT'
'+UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW'
'\x0eSECOND SUBUNIT'
'\x06ANGUL '
'\x0fENCH FRANC SIGN'
'\x07VEW NOW'
'\x0fBELOW LONG DASH'
'\x06EILING'
'\x03HER'
'\x11OPEN-HEADED ARROW'
'\rSILI PNEUMATA'
'\x081 HELMET'
'\x07MINIMA '
'\x1fEFTWARDS HARPOON WITH BARB DOWN'
'\x0eTWO DOTS ABOVE'
'\x03DAP'
'\x03UL '
'\x07TH ROOT'
'\x0f WITH DESCENDER'
'\x10NT SCREEN SYMBOL'
'\nFINAL FORM'
'\x08L-LAKUNA'
'\x06STANCE'
'\x07DOTTED '
'\x047 JA'
'\x07SS-THAN'
'\x14FORMS LIGHT VERTICAL'
'\x07HALF BL'
'\x0bRISING DOTS'
'\r-ESASA DOTTED'
'\x05AGMA '
'\x01U'
'\x07PERVISE'
'\x03ULL'
'\x06UZEIRO'
'\x0eHORIZONTAL BAR'
'\x06STANCY'
'\x0cERPENDICULAR'
'\x07CURVED '
'\x18AND MALE AND FEMALE SIGN'
'\x04ANCH'
'\x03OOD'
'\x11AUKAZ LAGU LOGR L'
'\x03OOF'
'\rUFFLE PRODUCT'
'\x04DAL '
'\rWITH INTEGRAL'
'\nAILED BIRD'
'\x06INSIDE'
'\x03OON'
'\x12SYMMETRIC SWAPPING'
'\x04WER '
'\x03OOU'
'\x03OOT'
'\x05PATAK'
'\nVIOUS PAGE'
'\x06I MAIM'
'\x06ALENTS'
'\x0fATINATE MYSLITE'
'\x07 FLEXUS'
'\x0fSEMIVOWEL SIGN '
'\x031 O'
)
_charnodes =[68903,
 -58315,
 -1,
 132351,
 17079,
 -1,
 197691,
 94681,
 -1,
 262727,
 158325,
 -1,
 327957,
 228883,
 -1,
 393238,
 276351,
 -1,
 -65529,
 341887,
 195071,
 -65528,
 405201,
 195070,
 -65527,
 468288,
 195069,
 -65526,
 531509,
 195068,
 -65525,
 594801,
 195067,
 -65524,
 658044,
 195066,
 -65523,
 753171,
 195065,
 -65522,
 816545,
 195064,
 -65521,
 879753,
 195063,
 -65520,
 943026,
 195062,
 -65519,
 1006171,
 195061,
 -65518,
 1069600,
 195060,
 -65517,
 1133003,
 195059,
 -65516,
 1196468,
 195058,
 -65515,
 1259854,
 195057,
 -1,
 1323525,
 195056,
 1507367,
 339665,
 -1,
 -65512,
 1455999,
 195055,
 -65511,
 1519313,
 195054,
 -65510,
 1582400,
 195053,
 -65509,
 1645621,
 195052,
 -65508,
 1708913,
 195051,
 -65507,
 1772156,
 195050,
 -65506,
 1867283,
 195049,
 -65505,
 1930657,
 195048,
 -65504,
 1993865,
 195047,
 -65503,
 2057138,
 195046,
 -65502,
 2120283,
 195045,
 -65501,
 2183712,
 195044,
 -65500,
 2247115,
 195043,
 -65499,
 2310580,
 195042,
 -65498,
 2373966,
 195041,
 -1,
 2437637,
 195040,
 2621496,
 1451328,
 -1,
 -65495,
 2570111,
 195039,
 -65494,
 2633425,
 195038,
 -65493,
 2696512,
 195037,
 -65492,
 2759733,
 195036,
 -65491,
 2823025,
 195035,
 -65490,
 2886268,
 195034,
 -65489,
 2981395,
 195033,
 -65488,
 3044769,
 195032,
 -65487,
 3107977,
 195031,
 -65486,
 3171250,
 195030,
 -65485,
 3234395,
 195029,
 -65484,
 3297824,
 195028,
 -65483,
 3361227,
 195027,
 -65482,
 3424692,
 195026,
 -65481,
 3488078,
 195025,
 -1,
 3551749,
 195024,
 3735625,
 2563125,
 -1,
 -65478,
 3684223,
 195023,
 -65477,
 3747537,
 195022,
 -65476,
 3810624,
 195021,
 -65475,
 3873845,
 195020,
 -65474,
 3937137,
 195019,
 -65473,
 4000380,
 195018,
 -65472,
 4095507,
 195017,
 -65471,
 4158881,
 195016,
 -65470,
 4222089,
 195015,
 -65469,
 4285362,
 195014,
 -65468,
 4348507,
 195013,
 -65467,
 4411936,
 195012,
 -65466,
 4475339,
 195011,
 -65465,
 4538804,
 195010,
 -65464,
 4602190,
 195009,
 -1,
 4665861,
 195008,
 4849754,
 3674993,
 -1,
 -65461,
 4798335,
 195007,
 -65460,
 4861649,
 195006,
 -65459,
 4924736,
 195005,
 -65458,
 4987957,
 195004,
 -65457,
 5051249,
 195003,
 -65456,
 5114492,
 195002,
 -65455,
 5209619,
 195001,
 -65454,
 5272993,
 195000,
 -65453,
 5336201,
 194999,
 -65452,
 5399474,
 194998,
 -65451,
 5462619,
 194997,
 -65450,
 5526048,
 194996,
 -65449,
 5589451,
 194995,
 -65448,
 5652916,
 194994,
 -65447,
 5716302,
 194993,
 -1,
 5779973,
 194992,
 5963883,
 4786812,
 -1,
 -65444,
 5912447,
 194991,
 -65443,
 5975761,
 194990,
 -65442,
 6038848,
 194989,
 -65441,
 6102069,
 194988,
 -65440,
 6165361,
 194987,
 -65439,
 6228604,
 194986,
 -65438,
 6323731,
 194985,
 -65437,
 6387105,
 194984,
 -65436,
 6450313,
 194983,
 -65435,
 6513586,
 194982,
 -65434,
 6576731,
 194981,
 -65433,
 6640160,
 194980,
 -65432,
 6703563,
 194979,
 -65431,
 6767028,
 194978,
 -65430,
 6830414,
 194977,
 -1,
 6894085,
 194976,
 7078012,
 5930515,
 -1,
 -65427,
 7026559,
 194975,
 -65426,
 7089873,
 194974,
 -65425,
 7152960,
 194973,
 -65424,
 7216181,
 194972,
 -65423,
 7279473,
 194971,
 -65422,
 7342716,
 194970,
 -65421,
 7437843,
 194969,
 -65420,
 7501217,
 194968,
 -65419,
 7564425,
 194967,
 -65418,
 7627698,
 194966,
 -65417,
 7690843,
 194965,
 -65416,
 7754272,
 194964,
 -65415,
 7817675,
 194963,
 -65414,
 7881140,
 194962,
 -65413,
 7944526,
 194961,
 -1,
 8008197,
 194960,
 8192141,
 7042465,
 -1,
 -65410,
 8140671,
 194959,
 -65409,
 8203985,
 194958,
 -65408,
 8267072,
 194957,
 -65407,
 8330293,
 194956,
 -65406,
 8393585,
 194955,
 -65405,
 8456828,
 194954,
 -65404,
 8551955,
 194953,
 -65403,
 8615329,
 194952,
 -65402,
 8678537,
 194951,
 -65401,
 8741810,
 194950,
 -65400,
 8804955,
 194949,
 -65399,
 8868384,
 194948,
 -65398,
 8931787,
 194947,
 -65397,
 8995252,
 194946,
 -65396,
 9058638,
 194945,
 -1,
 9122309,
 194944,
 9306270,
 8154249,
 -1,
 -65393,
 9254783,
 194943,
 -65392,
 9318097,
 194942,
 -65391,
 9381184,
 194941,
 -65390,
 9444405,
 194940,
 -65389,
 9507697,
 194939,
 -65388,
 9570940,
 194938,
 -65387,
 9666067,
 194937,
 -65386,
 9729441,
 194936,
 -65385,
 9792649,
 194935,
 -65384,
 9855922,
 194934,
 -65383,
 9919067,
 194933,
 -65382,
 9982496,
 194932,
 -65381,
 10045899,
 194931,
 -65380,
 10109364,
 194930,
 -65379,
 10172750,
 194929,
 -1,
 10236421,
 194928,
 10420399,
 9266098,
 -1,
 -65376,
 10368895,
 194927,
 -65375,
 10432209,
 194926,
 -65374,
 10495296,
 194925,
 -65373,
 10558517,
 194924,
 -65372,
 10621809,
 194923,
 -65371,
 10685052,
 194922,
 -65370,
 10780179,
 194921,
 -65369,
 10843553,
 194920,
 -65368,
 10906761,
 194919,
 -65367,
 10970034,
 194918,
 -65366,
 11033179,
 194917,
 -65365,
 11096608,
 194916,
 -65364,
 11160011,
 194915,
 -65363,
 11223476,
 194914,
 -65362,
 11286862,
 194913,
 -1,
 11350533,
 194912,
 11534528,
 10377819,
 -1,
 -65359,
 11483007,
 194911,
 -65358,
 11546321,
 194910,
 -65357,
 11609408,
 194909,
 -65356,
 11672629,
 194908,
 -65355,
 11735921,
 194907,
 -65354,
 11799164,
 194906,
 -65353,
 11894291,
 194905,
 -65352,
 11957665,
 194904,
 -65351,
 12020873,
 194903,
 -65350,
 12084146,
 194902,
 -65349,
 12147291,
 194901,
 -65348,
 12210720,
 194900,
 -65347,
 12274123,
 194899,
 -65346,
 12337588,
 194898,
 -65345,
 12400974,
 194897,
 -1,
 12464645,
 194896,
 12648657,
 11489824,
 -1,
 -65342,
 12597119,
 194895,
 -65341,
 12660433,
 194894,
 -65340,
 12723520,
 194893,
 -65339,
 12786741,
 194892,
 -65338,
 12850033,
 194891,
 -65337,
 12913276,
 194890,
 -65336,
 13008403,
 194889,
 -65335,
 13071777,
 194888,
 -65334,
 13134985,
 194887,
 -65333,
 13198258,
 194886,
 -65332,
 13261403,
 194885,
 -65331,
 13324832,
 194884,
 -65330,
 13388235,
 194883,
 -65329,
 13451700,
 194882,
 -65328,
 13515086,
 194881,
 -1,
 13578757,
 194880,
 13762786,
 12601803,
 -1,
 -65325,
 13711231,
 194879,
 -65324,
 13774545,
 194878,
 -65323,
 13837632,
 194877,
 -65322,
 13900853,
 194876,
 -65321,
 13964145,
 194875,
 -65320,
 14027388,
 194874,
 -65319,
 14122515,
 194873,
 -65318,
 14185889,
 194872,
 -65317,
 14249097,
 194871,
 -65316,
 14312370,
 194870,
 -65315,
 14375515,
 194869,
 -65314,
 14438944,
 194868,
 -65313,
 14502347,
 194867,
 -65312,
 14565812,
 194866,
 -65311,
 14629198,
 194865,
 -1,
 14692869,
 194864,
 14876915,
 13713844,
 -1,
 -65308,
 14825343,
 194863,
 -65307,
 14888657,
 194862,
 -65306,
 14951744,
 194861,
 -65305,
 15014965,
 194860,
 -65304,
 15078257,
 194859,
 -65303,
 15141500,
 194858,
 -65302,
 15236627,
 194857,
 -65301,
 15300001,
 194856,
 -65300,
 15363209,
 194855,
 -65299,
 15426482,
 194854,
 -65298,
 15489627,
 194853,
 -65297,
 15553056,
 194852,
 -65296,
 15616459,
 194851,
 -65295,
 15679924,
 194850,
 -65294,
 15743310,
 194849,
 -1,
 15806981,
 194848,
 15991044,
 14825806,
 -1,
 -65291,
 15939455,
 194847,
 -65290,
 16002769,
 194846,
 -65289,
 16065856,
 194845,
 -65288,
 16129077,
 194844,
 -65287,
 16192369,
 194843,
 -65286,
 16255612,
 194842,
 -65285,
 16350739,
 194841,
 -65284,
 16414113,
 194840,
 -65283,
 16477321,
 194839,
 -65282,
 16540594,
 194838,
 -65281,
 16603739,
 194837,
 -65280,
 16667168,
 194836,
 -65279,
 16730571,
 194835,
 -65278,
 16794036,
 194834,
 -65277,
 16857422,
 194833,
 -1,
 16921093,
 194832,
 17170431,
 15938053,
 -1,
 -65274,
 17053567,
 194831,
 -65273,
 17116881,
 194830,
 -65272,
 17179968,
 194829,
 -65271,
 17243189,
 194828,
 -65270,
 17306481,
 194827,
 -65269,
 17369724,
 194826,
 -65268,
 17464851,
 194825,
 -65267,
 17528225,
 194824,
 -65266,
 17591433,
 194823,
 -65265,
 17654706,
 194822,
 -65264,
 17717851,
 194821,
 -65263,
 17781280,
 194820,
 -65262,
 17844683,
 194819,
 -65261,
 17908148,
 194818,
 -65260,
 17971534,
 194817,
 -1,
 18035205,
 194816,
 18219558,
 292257,
 -1,
 18284839,
 18167679,
 -1,
 -65256,
 18233215,
 194815,
 -65255,
 18296529,
 194814,
 -65254,
 18359616,
 194813,
 -65253,
 18422837,
 194812,
 -65252,
 18486129,
 194811,
 -65251,
 18549372,
 194810,
 -65250,
 18644499,
 194809,
 -65249,
 18707873,
 194808,
 -65248,
 18771081,
 194807,
 -65247,
 18834354,
 194806,
 -65246,
 18897499,
 194805,
 -65245,
 18960928,
 194804,
 -65244,
 19024331,
 194803,
 -65243,
 19087796,
 194802,
 -65242,
 19151182,
 194801,
 -1,
 19214853,
 194800,
 19398968,
 18230993,
 -1,
 -65239,
 19347327,
 194799,
 -65238,
 19410641,
 194798,
 -65237,
 19473728,
 194797,
 -65236,
 19536949,
 194796,
 -65235,
 19600241,
 194795,
 -65234,
 19663484,
 194794,
 -65233,
 19758611,
 194793,
 -65232,
 19821985,
 194792,
 -65231,
 19885193,
 194791,
 -65230,
 19948466,
 194790,
 -65229,
 20011611,
 194789,
 -65228,
 20075040,
 194788,
 -65227,
 20138443,
 194787,
 -65226,
 20201908,
 194786,
 -65225,
 20265294,
 194785,
 -1,
 20328965,
 194784,
 20513097,
 19342656,
 -1,
 -65222,
 20461439,
 194783,
 -65221,
 20524753,
 194782,
 -65220,
 20587840,
 194781,
 -65219,
 20651061,
 194780,
 -65218,
 20714353,
 194779,
 -65217,
 20777596,
 194778,
 -65216,
 20872723,
 194777,
 -65215,
 20936097,
 194776,
 -65214,
 20999305,
 194775,
 -65213,
 21062578,
 194774,
 -65212,
 21125723,
 194773,
 -65211,
 21189152,
 194772,
 -65210,
 21252555,
 194771,
 -65209,
 21316020,
 194770,
 -65208,
 21379406,
 194769,
 -1,
 21443077,
 194768,
 21627226,
 20454453,
 -1,
 -65205,
 21575551,
 194767,
 -65204,
 21638865,
 194766,
 -65203,
 21701952,
 194765,
 -65202,
 21765173,
 194764,
 -65201,
 21828465,
 194763,
 -65200,
 21891708,
 194762,
 -65199,
 21986835,
 194761,
 -65198,
 22050209,
 194760,
 -65197,
 22113417,
 194759,
 -65196,
 22176690,
 194758,
 -65195,
 22239835,
 194757,
 -65194,
 22303264,
 194756,
 -65193,
 22366667,
 194755,
 -65192,
 22430132,
 194754,
 -65191,
 22493518,
 194753,
 -1,
 22557189,
 194752,
 22741355,
 21566321,
 -1,
 -65188,
 22689663,
 194751,
 -65187,
 22752977,
 194750,
 -65186,
 22816064,
 194749,
 -65185,
 22879285,
 194748,
 -65184,
 22942577,
 194747,
 -65183,
 23005820,
 194746,
 -65182,
 23100947,
 194745,
 -65181,
 23164321,
 194744,
 -65180,
 23227529,
 194743,
 -65179,
 23290802,
 194742,
 -65178,
 23353947,
 194741,
 -65177,
 23417376,
 194740,
 -65176,
 23480779,
 194739,
 -65175,
 23544244,
 194738,
 -65174,
 23607630,
 194737,
 -1,
 23671301,
 194736,
 23855484,
 22678140,
 -1,
 -65171,
 23803775,
 194735,
 -65170,
 23867089,
 194734,
 -65169,
 23930176,
 194733,
 -65168,
 23993397,
 194732,
 -65167,
 24056689,
 194731,
 -65166,
 24119932,
 194730,
 -65165,
 24215059,
 194729,
 -65164,
 24278433,
 194728,
 -65163,
 24341641,
 194727,
 -65162,
 24404914,
 194726,
 -65161,
 24468059,
 194725,
 -65160,
 24531488,
 194724,
 -65159,
 24594891,
 194723,
 -65158,
 24658356,
 194722,
 -65157,
 24721742,
 194721,
 -1,
 24785413,
 194720,
 24969613,
 23821843,
 -1,
 -65154,
 24917887,
 194719,
 -65153,
 24981201,
 194718,
 -65152,
 25044288,
 194717,
 -65151,
 25107509,
 194716,
 -65150,
 25170801,
 194715,
 -65149,
 25234044,
 194714,
 -65148,
 25329171,
 194713,
 -65147,
 25392545,
 194712,
 -65146,
 25455753,
 194711,
 -65145,
 25519026,
 194710,
 -65144,
 25582171,
 194709,
 -65143,
 25645600,
 194708,
 -65142,
 25709003,
 194707,
 -65141,
 25772468,
 194706,
 -65140,
 25835854,
 194705,
 -1,
 25899525,
 194704,
 26083742,
 24933793,
 -1,
 -65137,
 26031999,
 194703,
 -65136,
 26095313,
 194702,
 -65135,
 26158400,
 194701,
 -65134,
 26221621,
 194700,
 -65133,
 26284913,
 194699,
 -65132,
 26348156,
 194698,
 -65131,
 26443283,
 194697,
 -65130,
 26506657,
 194696,
 -65129,
 26569865,
 194695,
 -65128,
 26633138,
 194694,
 -65127,
 26696283,
 194693,
 -65126,
 26759712,
 194692,
 -65125,
 26823115,
 194691,
 -65124,
 26886580,
 194690,
 -65123,
 26949966,
 194689,
 -1,
 27013637,
 194688,
 27197871,
 26045577,
 -1,
 -65120,
 27146111,
 194687,
 -65119,
 27209425,
 194686,
 -65118,
 27272512,
 194685,
 -65117,
 27335733,
 194684,
 -65116,
 27399025,
 194683,
 -65115,
 27462268,
 194682,
 -65114,
 27557395,
 194681,
 -65113,
 27620769,
 194680,
 -65112,
 27683977,
 194679,
 -65111,
 27747250,
 194678,
 -65110,
 27810395,
 194677,
 -65109,
 27873824,
 194676,
 -65108,
 27937227,
 194675,
 -65107,
 28000692,
 194674,
 -65106,
 28064078,
 194673,
 -1,
 28127749,
 194672,
 28312000,
 27157426,
 -1,
 -65103,
 28260223,
 194671,
 -65102,
 28323537,
 194670,
 -65101,
 28386624,
 194669,
 -65100,
 28449845,
 194668,
 -65099,
 28513137,
 194667,
 -65098,
 28576380,
 194666,
 -65097,
 28671507,
 194665,
 -65096,
 28734881,
 194664,
 -65095,
 28798089,
 194663,
 -65094,
 28861362,
 194662,
 -65093,
 28924507,
 194661,
 -65092,
 28987936,
 194660,
 -65091,
 29051339,
 194659,
 -65090,
 29114804,
 194658,
 -65089,
 29178190,
 194657,
 -1,
 29241861,
 194656,
 29426129,
 28269147,
 -1,
 -65086,
 29374335,
 194655,
 -65085,
 29437649,
 194654,
 -65084,
 29500736,
 194653,
 -65083,
 29563957,
 194652,
 -65082,
 29627249,
 194651,
 -65081,
 29690492,
 194650,
 -65080,
 29785619,
 194649,
 -65079,
 29848993,
 194648,
 -65078,
 29912201,
 194647,
 -65077,
 29975474,
 194646,
 -65076,
 30038619,
 194645,
 -65075,
 30102048,
 194644,
 -65074,
 30165451,
 194643,
 -65073,
 30228916,
 194642,
 -65072,
 30292302,
 194641,
 -1,
 30355973,
 194640,
 30540258,
 29381152,
 -1,
 -65069,
 30488447,
 194639,
 -65068,
 30551761,
 194638,
 -65067,
 30614848,
 194637,
 -65066,
 30678069,
 194636,
 -65065,
 30741361,
 194635,
 -65064,
 30804604,
 194634,
 -65063,
 30899731,
 194633,
 -65062,
 30963105,
 194632,
 -65061,
 31026313,
 194631,
 -65060,
 31089586,
 194630,
 -65059,
 31152731,
 194629,
 -65058,
 31216160,
 194628,
 -65057,
 31279563,
 194627,
 -65056,
 31343028,
 194626,
 -65055,
 31406414,
 194625,
 -1,
 31470085,
 194624,
 31654387,
 30493131,
 -1,
 -65052,
 31602559,
 194623,
 -65051,
 31665873,
 194622,
 -65050,
 31728960,
 194621,
 -65049,
 31792181,
 194620,
 -65048,
 31855473,
 194619,
 -65047,
 31918716,
 194618,
 -65046,
 32013843,
 194617,
 -65045,
 32077217,
 194616,
 -65044,
 32140425,
 194615,
 -65043,
 32203698,
 194614,
 -65042,
 32266843,
 194613,
 -65041,
 32330272,
 194612,
 -65040,
 32393675,
 194611,
 -65039,
 32457140,
 194610,
 -65038,
 32520526,
 194609,
 -1,
 32584197,
 194608,
 32768516,
 31605172,
 -1,
 -65035,
 32716671,
 194607,
 -65034,
 32779985,
 194606,
 -65033,
 32843072,
 194605,
 -65032,
 32906293,
 194604,
 -65031,
 32969585,
 194603,
 -65030,
 33032828,
 194602,
 -65029,
 33127955,
 194601,
 -65028,
 33191329,
 194600,
 -65027,
 33254537,
 194599,
 -65026,
 33317810,
 194598,
 -65025,
 33380955,
 194597,
 -65024,
 33444384,
 194596,
 -65023,
 33507787,
 194595,
 -65022,
 33571252,
 194594,
 -65021,
 33634638,
 194593,
 -1,
 33698309,
 194592,
 33882645,
 32717134,
 -1,
 -65018,
 33830783,
 194591,
 -65017,
 33894097,
 194590,
 -65016,
 33957184,
 194589,
 -65015,
 34020405,
 194588,
 -65014,
 34083697,
 194587,
 -65013,
 34146940,
 194586,
 -65012,
 34242067,
 194585,
 -65011,
 34305441,
 194584,
 -65010,
 34368649,
 194583,
 -65009,
 34431922,
 194582,
 -65008,
 34495067,
 194581,
 -65007,
 34558496,
 194580,
 -65006,
 34621899,
 194579,
 -65005,
 34685364,
 194578,
 -65004,
 34748750,
 194577,
 -1,
 34812421,
 194576,
 35061759,
 33829381,
 -1,
 -65001,
 34944895,
 194575,
 -65000,
 35008209,
 194574,
 -64999,
 35071296,
 194573,
 -64998,
 35134517,
 194572,
 -64997,
 35197809,
 194571,
 -64996,
 35261052,
 194570,
 -64995,
 35356179,
 194569,
 -64994,
 35419553,
 194568,
 -64993,
 35482761,
 194567,
 -64992,
 35546034,
 194566,
 -64991,
 35609179,
 194565,
 -64990,
 35672608,
 194564,
 -64989,
 35736011,
 194563,
 -64988,
 35799476,
 194562,
 -64987,
 35862862,
 194561,
 -1,
 35926533,
 194560,
 36175871,
 18156156,
 -1,
 36176440,
 36057605,
 -1,
 -64983,
 36124543,
 195087,
 -64982,
 36187857,
 195086,
 -64981,
 36250944,
 195085,
 -64980,
 36314165,
 195084,
 -64979,
 36377457,
 195083,
 -64978,
 36440700,
 195082,
 -64977,
 36535827,
 195081,
 -64976,
 36599201,
 195080,
 -64975,
 36662409,
 195079,
 -64974,
 36725682,
 195078,
 -64973,
 36788827,
 195077,
 -64972,
 36852256,
 195076,
 -64971,
 36915659,
 195075,
 -64970,
 36979124,
 195074,
 -64969,
 37042510,
 195073,
 -1,
 37106181,
 195072,
 37355519,
 36125006,
 -1,
 -64966,
 37233984,
 195101,
 -64965,
 37297205,
 195100,
 -64964,
 37360497,
 195099,
 -64963,
 37423740,
 195098,
 -64962,
 37518867,
 195097,
 -64961,
 37582241,
 195096,
 -64960,
 37645449,
 195095,
 -64959,
 37708722,
 195094,
 -64958,
 37771867,
 195093,
 -64957,
 37835296,
 195092,
 -64956,
 37898699,
 195091,
 -64955,
 37962164,
 195090,
 -64954,
 38025550,
 195089,
 -1,
 38089221,
 195088,
 38338559,
 210815,
 -1,
 38339417,
 38239763,
 -1,
 38404698,
 38287231,
 -1,
 -64949,
 38352767,
 63999,
 -64948,
 38416081,
 63998,
 -64947,
 38479168,
 63997,
 -64946,
 38542389,
 63996,
 -64945,
 38605681,
 63995,
 -64944,
 38668924,
 63994,
 -64943,
 38764051,
 63993,
 -64942,
 38827425,
 63992,
 -64941,
 38890633,
 63991,
 -64940,
 38953906,
 63990,
 -64939,
 39017051,
 63989,
 -64938,
 39080480,
 63988,
 -64937,
 39143883,
 63987,
 -64936,
 39207348,
 63986,
 -64935,
 39270734,
 63985,
 -1,
 39334405,
 63984,
 39518827,
 38350545,
 -1,
 -64932,
 39466879,
 63983,
 -64931,
 39530193,
 63982,
 -64930,
 39593280,
 63981,
 -64929,
 39656501,
 63980,
 -64928,
 39719793,
 63979,
 -64927,
 39783036,
 63978,
 -64926,
 39878163,
 63977,
 -64925,
 39941537,
 63976,
 -64924,
 40004745,
 63975,
 -64923,
 40068018,
 63974,
 -64922,
 40131163,
 63973,
 -64921,
 40194592,
 63972,
 -64920,
 40257995,
 63971,
 -64919,
 40321460,
 63970,
 -64918,
 40384846,
 63969,
 -1,
 40448517,
 63968,
 40632956,
 39462208,
 -1,
 -64915,
 40580991,
 63967,
 -64914,
 40644305,
 63966,
 -64913,
 40707392,
 63965,
 -64912,
 40770613,
 63964,
 -64911,
 40833905,
 63963,
 -64910,
 40897148,
 63962,
 -64909,
 40992275,
 63961,
 -64908,
 41055649,
 63960,
 -64907,
 41118857,
 63959,
 -64906,
 41182130,
 63958,
 -64905,
 41245275,
 63957,
 -64904,
 41308704,
 63956,
 -64903,
 41372107,
 63955,
 -64902,
 41435572,
 63954,
 -64901,
 41498958,
 63953,
 -1,
 41562629,
 63952,
 41747085,
 40574005,
 -1,
 -64898,
 41695103,
 63951,
 -64897,
 41758417,
 63950,
 -64896,
 41821504,
 63949,
 -64895,
 41884725,
 63948,
 -64894,
 41948017,
 63947,
 -64893,
 42011260,
 63946,
 -64892,
 42106387,
 63945,
 -64891,
 42169761,
 63944,
 -64890,
 42232969,
 63943,
 -64889,
 42296242,
 63942,
 -64888,
 42359387,
 63941,
 -64887,
 42422816,
 63940,
 -64886,
 42486219,
 63939,
 -64885,
 42549684,
 63938,
 -64884,
 42613070,
 63937,
 -1,
 42676741,
 63936,
 42861214,
 41685873,
 -1,
 -64881,
 42809215,
 63935,
 -64880,
 42872529,
 63934,
 -64879,
 42935616,
 63933,
 -64878,
 42998837,
 63932,
 -64877,
 43062129,
 63931,
 -64876,
 43125372,
 63930,
 -64875,
 43220499,
 63929,
 -64874,
 43283873,
 63928,
 -64873,
 43347081,
 63927,
 -64872,
 43410354,
 63926,
 -64871,
 43473499,
 63925,
 -64870,
 43536928,
 63924,
 -64869,
 43600331,
 63923,
 -64868,
 43663796,
 63922,
 -64867,
 43727182,
 63921,
 -1,
 43790853,
 63920,
 43975343,
 42797692,
 -1,
 -64864,
 43923327,
 63919,
 -64863,
 43986641,
 63918,
 -64862,
 44049728,
 63917,
 -64861,
 44112949,
 63916,
 -64860,
 44176241,
 63915,
 -64859,
 44239484,
 63914,
 -64858,
 44334611,
 63913,
 -64857,
 44397985,
 63912,
 -64856,
 44461193,
 63911,
 -64855,
 44524466,
 63910,
 -64854,
 44587611,
 63909,
 -64853,
 44651040,
 63908,
 -64852,
 44714443,
 63907,
 -64851,
 44777908,
 63906,
 -64850,
 44841294,
 63905,
 -1,
 44904965,
 63904,
 45089472,
 43941395,
 -1,
 -64847,
 45037439,
 63903,
 -64846,
 45100753,
 63902,
 -64845,
 45163840,
 63901,
 -64844,
 45227061,
 63900,
 -64843,
 45290353,
 63899,
 -64842,
 45353596,
 63898,
 -64841,
 45448723,
 63897,
 -64840,
 45512097,
 63896,
 -64839,
 45575305,
 63895,
 -64838,
 45638578,
 63894,
 -64837,
 45701723,
 63893,
 -64836,
 45765152,
 63892,
 -64835,
 45828555,
 63891,
 -64834,
 45892020,
 63890,
 -64833,
 45955406,
 63889,
 -1,
 46019077,
 63888,
 46203601,
 45053345,
 -1,
 -64830,
 46151551,
 63887,
 -64829,
 46214865,
 63886,
 -64828,
 46277952,
 63885,
 -64827,
 46341173,
 63884,
 -64826,
 46404465,
 63883,
 -64825,
 46467708,
 63882,
 -64824,
 46562835,
 63881,
 -64823,
 46626209,
 63880,
 -64822,
 46689417,
 63879,
 -64821,
 46752690,
 63878,
 -64820,
 46815835,
 63877,
 -64819,
 46879264,
 63876,
 -64818,
 46942667,
 63875,
 -64817,
 47006132,
 63874,
 -64816,
 47069518,
 63873,
 -1,
 47133189,
 63872,
 47317730,
 46165129,
 -1,
 -64813,
 47265663,
 63871,
 -64812,
 47328977,
 63870,
 -64811,
 47392064,
 63869,
 -64810,
 47455285,
 63868,
 -64809,
 47518577,
 63867,
 -64808,
 47581820,
 63866,
 -64807,
 47676947,
 63865,
 -64806,
 47740321,
 63864,
 -64805,
 47803529,
 63863,
 -64804,
 47866802,
 63862,
 -64803,
 47929947,
 63861,
 -64802,
 47993376,
 63860,
 -64801,
 48056779,
 63859,
 -64800,
 48120244,
 63858,
 -64799,
 48183630,
 63857,
 -1,
 48247301,
 63856,
 48431859,
 47276978,
 -1,
 -64796,
 48379775,
 63855,
 -64795,
 48443089,
 63854,
 -64794,
 48506176,
 63853,
 -64793,
 48569397,
 63852,
 -64792,
 48632689,
 63851,
 -64791,
 48695932,
 63850,
 -64790,
 48791059,
 63849,
 -64789,
 48854433,
 63848,
 -64788,
 48917641,
 63847,
 -64787,
 48980914,
 63846,
 -64786,
 49044059,
 63845,
 -64785,
 49107488,
 63844,
 -64784,
 49170891,
 63843,
 -64783,
 49234356,
 63842,
 -64782,
 49297742,
 63841,
 -1,
 49361413,
 63840,
 49545988,
 48388699,
 -1,
 -64779,
 49493887,
 63839,
 -64778,
 49557201,
 63838,
 -64777,
 49620288,
 63837,
 -64776,
 49683509,
 63836,
 -64775,
 49746801,
 63835,
 -64774,
 49810044,
 63834,
 -64773,
 49905171,
 63833,
 -64772,
 49968545,
 63832,
 -64771,
 50031753,
 63831,
 -64770,
 50095026,
 63830,
 -64769,
 50158171,
 63829,
 -64768,
 50221600,
 63828,
 -64767,
 50285003,
 63827,
 -64766,
 50348468,
 63826,
 -64765,
 50411854,
 63825,
 -1,
 50475525,
 63824,
 50660117,
 49500704,
 -1,
 -64762,
 50607999,
 63823,
 -64761,
 50671313,
 63822,
 -64760,
 50734400,
 63821,
 -64759,
 50797621,
 63820,
 -64758,
 50860913,
 63819,
 -64757,
 50924156,
 63818,
 -64756,
 51019283,
 63817,
 -64755,
 51082657,
 63816,
 -64754,
 51145865,
 63815,
 -64753,
 51209138,
 63814,
 -64752,
 51272283,
 63813,
 -64751,
 51335712,
 63812,
 -64750,
 51399115,
 63811,
 -64749,
 51462580,
 63810,
 -64748,
 51525966,
 63809,
 -1,
 51589637,
 63808,
 51774246,
 50612683,
 -1,
 -64745,
 51722111,
 63807,
 -64744,
 51785425,
 63806,
 -64743,
 51848512,
 63805,
 -64742,
 51911733,
 63804,
 -64741,
 51975025,
 63803,
 -64740,
 52038268,
 63802,
 -64739,
 52133395,
 63801,
 -64738,
 52196769,
 63800,
 -64737,
 52259977,
 63799,
 -64736,
 52323250,
 63798,
 -64735,
 52386395,
 63797,
 -64734,
 52449824,
 63796,
 -64733,
 52513227,
 63795,
 -64732,
 52576692,
 63794,
 -64731,
 52640078,
 63793,
 -1,
 52703749,
 63792,
 52888375,
 51724724,
 -1,
 -64728,
 52836223,
 63791,
 -64727,
 52899537,
 63790,
 -64726,
 52962624,
 63789,
 -64725,
 53025845,
 63788,
 -64724,
 53089137,
 63787,
 -64723,
 53152380,
 63786,
 -64722,
 53247507,
 63785,
 -64721,
 53310881,
 63784,
 -64720,
 53374089,
 63783,
 -64719,
 53437362,
 63782,
 -64718,
 53500507,
 63781,
 -64717,
 53563936,
 63780,
 -64716,
 53627339,
 63779,
 -64715,
 53690804,
 63778,
 -64714,
 53754190,
 63777,
 -1,
 53817861,
 63776,
 54002504,
 52836686,
 -1,
 -64711,
 53950335,
 63775,
 -64710,
 54013649,
 63774,
 -64709,
 54076736,
 63773,
 -64708,
 54139957,
 63772,
 -64707,
 54203249,
 63771,
 -64706,
 54266492,
 63770,
 -64705,
 54361619,
 63769,
 -64704,
 54424993,
 63768,
 -64703,
 54488201,
 63767,
 -64702,
 54551474,
 63766,
 -64701,
 54614619,
 63765,
 -64700,
 54678048,
 63764,
 -64699,
 54741451,
 63763,
 -64698,
 54804916,
 63762,
 -64697,
 54868302,
 63761,
 -1,
 54931973,
 63760,
 55181311,
 53948933,
 -1,
 -64694,
 55064447,
 63759,
 -64693,
 55127761,
 63758,
 -64692,
 55190848,
 63757,
 -64691,
 55254069,
 63756,
 -64690,
 55317361,
 63755,
 -64689,
 55380604,
 63754,
 -64688,
 55475731,
 63753,
 -64687,
 55539105,
 63752,
 -64686,
 55602313,
 63751,
 -64685,
 55665586,
 63750,
 -64684,
 55728731,
 63749,
 -64683,
 55792160,
 63748,
 -64682,
 55855563,
 63747,
 -64681,
 55919028,
 63746,
 -64680,
 55982414,
 63745,
 -1,
 56046085,
 63744,
 56295423,
 38275708,
 -1,
 56296299,
 56171573,
 -1,
 -64676,
 56244095,
 64207,
 -64675,
 56307409,
 64206,
 -64674,
 56370496,
 64205,
 -64673,
 56433717,
 64204,
 -64672,
 56497009,
 64203,
 -64671,
 56560252,
 64202,
 -64670,
 56655379,
 64201,
 -64669,
 56718753,
 64200,
 -64668,
 56781961,
 64199,
 -64667,
 56845234,
 64198,
 -64666,
 56908379,
 64197,
 -64665,
 56971808,
 64196,
 -64664,
 57035211,
 64195,
 -64663,
 57098676,
 64194,
 -64662,
 57162062,
 64193,
 -1,
 57225733,
 64192,
 57410428,
 56234865,
 -1,
 -64659,
 57358207,
 64191,
 -64658,
 57421521,
 64190,
 -64657,
 57484608,
 64189,
 -64656,
 57547829,
 64188,
 -64655,
 57611121,
 64187,
 -64654,
 57674364,
 64186,
 -64653,
 57769491,
 64185,
 -64652,
 57832865,
 64184,
 -64651,
 57896073,
 64183,
 -64650,
 57959346,
 64182,
 -64649,
 58022491,
 64181,
 -64648,
 58085920,
 64180,
 -64647,
 58149323,
 64179,
 -64646,
 58212788,
 64178,
 -64645,
 58276174,
 64177,
 -1,
 58339845,
 64176,
 58524557,
 57346684,
 -1,
 -64642,
 58472319,
 64175,
 -64641,
 58535633,
 64174,
 -64640,
 58598720,
 64173,
 -64639,
 58661941,
 64172,
 -64638,
 58725233,
 64171,
 -64637,
 58788476,
 64170,
 -64636,
 58883603,
 64169,
 -64635,
 58946977,
 64168,
 -64634,
 59010185,
 64167,
 -64633,
 59073458,
 64166,
 -64632,
 59136603,
 64165,
 -64631,
 59200032,
 64164,
 -64630,
 59263435,
 64163,
 -64629,
 59326900,
 64162,
 -64628,
 59390286,
 64161,
 -1,
 59453957,
 64160,
 59638686,
 58490387,
 -1,
 -64625,
 59586431,
 64159,
 -64624,
 59649745,
 64158,
 -64623,
 59712832,
 64157,
 -64622,
 59776053,
 64156,
 -64621,
 59839345,
 64155,
 -64620,
 59902588,
 64154,
 -64619,
 59997715,
 64153,
 -64618,
 60061089,
 64152,
 -64617,
 60124297,
 64151,
 -64616,
 60187570,
 64150,
 -64615,
 60250715,
 64149,
 -64614,
 60314144,
 64148,
 -64613,
 60377547,
 64147,
 -64612,
 60441012,
 64146,
 -64611,
 60504398,
 64145,
 -1,
 60568069,
 64144,
 60752815,
 59602337,
 -1,
 -64608,
 60700543,
 64143,
 -64607,
 60763857,
 64142,
 -64606,
 60826944,
 64141,
 -64605,
 60890165,
 64140,
 -64604,
 60953457,
 64139,
 -64603,
 61016700,
 64138,
 -64602,
 61111827,
 64137,
 -64601,
 61175201,
 64136,
 -64600,
 61238409,
 64135,
 -64599,
 61301682,
 64134,
 -64598,
 61364827,
 64133,
 -64597,
 61428256,
 64132,
 -64596,
 61491659,
 64131,
 -64595,
 61555124,
 64130,
 -64594,
 61618510,
 64129,
 -1,
 61682181,
 64128,
 61866944,
 60714121,
 -1,
 -64591,
 61814655,
 64127,
 -64590,
 61877969,
 64126,
 -64589,
 61941056,
 64125,
 -64588,
 62004277,
 64124,
 -64587,
 62067569,
 64123,
 -64586,
 62130812,
 64122,
 -64585,
 62225939,
 64121,
 -64584,
 62289313,
 64120,
 -64583,
 62352521,
 64119,
 -64582,
 62415794,
 64118,
 -64581,
 62478939,
 64117,
 -64580,
 62542368,
 64116,
 -64579,
 62605771,
 64115,
 -64578,
 62669236,
 64114,
 -64577,
 62732622,
 64113,
 -1,
 62796293,
 64112,
 62981073,
 61823579,
 -1,
 -64574,
 62928767,
 64095,
 -64573,
 62992081,
 64094,
 -64572,
 63055168,
 64093,
 -64571,
 63118389,
 64092,
 -64570,
 63181681,
 64091,
 -64569,
 63244924,
 64090,
 -64568,
 63340051,
 64089,
 -64567,
 63403425,
 64088,
 -64566,
 63466633,
 64087,
 -64565,
 63529906,
 64086,
 -64564,
 63593051,
 64085,
 -64563,
 63656480,
 64084,
 -64562,
 63719883,
 64083,
 -64561,
 63783348,
 64082,
 -64560,
 63846734,
 64081,
 -1,
 63910405,
 64080,
 64095202,
 62935584,
 -1,
 -64557,
 64042879,
 64079,
 -64556,
 64106193,
 64078,
 -64555,
 64169280,
 64077,
 -64554,
 64232501,
 64076,
 -64553,
 64295793,
 64075,
 -64552,
 64359036,
 64074,
 -64551,
 64454163,
 64073,
 -64550,
 64517537,
 64072,
 -64549,
 64580745,
 64071,
 -64548,
 64644018,
 64070,
 -64547,
 64707163,
 64069,
 -64546,
 64770592,
 64068,
 -64545,
 64833995,
 64067,
 -64544,
 64897460,
 64066,
 -64543,
 64960846,
 64065,
 -1,
 65024517,
 64064,
 65209331,
 64047563,
 -1,
 -64540,
 65156991,
 64063,
 -64539,
 65220305,
 64062,
 -64538,
 65283392,
 64061,
 -64537,
 65346613,
 64060,
 -64536,
 65409905,
 64059,
 -64535,
 65473148,
 64058,
 -64534,
 65568275,
 64057,
 -64533,
 65631649,
 64056,
 -64532,
 65694857,
 64055,
 -64531,
 65758130,
 64054,
 -64530,
 65821275,
 64053,
 -64529,
 65884704,
 64052,
 -64528,
 65948107,
 64051,
 -64527,
 66011572,
 64050,
 -64526,
 66074958,
 64049,
 -1,
 66138629,
 64048,
 66323460,
 65157454,
 -1,
 -64523,
 66271103,
 64031,
 -64522,
 66334417,
 64030,
 -64521,
 66397504,
 64029,
 -64520,
 66460725,
 64028,
 -64519,
 66524017,
 64027,
 -64518,
 66587260,
 64026,
 -64517,
 66682387,
 64025,
 -64516,
 66745761,
 64024,
 -64515,
 66808969,
 64023,
 -64514,
 66872242,
 64022,
 -64513,
 66935387,
 64021,
 -64512,
 66998816,
 64020,
 -64511,
 67062219,
 64019,
 -64510,
 67125684,
 64018,
 -64509,
 67189070,
 64017,
 -1,
 67252741,
 64016,
 67437589,
 66269701,
 -1,
 -64506,
 67385215,
 64015,
 -64505,
 67448529,
 64014,
 -64504,
 67511616,
 64013,
 -64503,
 67574837,
 64012,
 -64502,
 67638129,
 64011,
 -64501,
 67701372,
 64010,
 -64500,
 67796499,
 64009,
 -64499,
 67859873,
 64008,
 -64498,
 67923081,
 64007,
 -64497,
 67986354,
 64006,
 -64496,
 68049499,
 64005,
 -64495,
 68112928,
 64004,
 -64494,
 68176331,
 64003,
 -64493,
 68239796,
 64002,
 -64492,
 68303182,
 64001,
 -1,
 68366853,
 64000,
 68551716,
 67387828,
 -1,
 -64489,
 68494656,
 64045,
 -64488,
 68557877,
 64044,
 -64487,
 68621169,
 64043,
 -64486,
 68684412,
 64042,
 -64485,
 68779539,
 64041,
 -64484,
 68842913,
 64040,
 -64483,
 68906121,
 64039,
 -64482,
 68969394,
 64038,
 -64481,
 69032539,
 64037,
 -64480,
 69095968,
 64036,
 -64479,
 69159371,
 64035,
 -64478,
 69222836,
 64034,
 -64477,
 69286222,
 64033,
 -1,
 69349893,
 64032,
 69534768,
 68510642,
 -1,
 -64474,
 69470844,
 64106,
 -64473,
 69565971,
 64105,
 -64472,
 69629345,
 64104,
 -64471,
 69692553,
 64103,
 -64470,
 69755826,
 64102,
 -64469,
 69818971,
 64101,
 -64468,
 69882400,
 64100,
 -64467,
 69945803,
 64099,
 -64466,
 70009268,
 64098,
 -64465,
 70072654,
 64097,
 -1,
 70136325,
 64096,
 70385663,
 69477696,
 -1,
 -64462,
 70286867,
 64217,
 -64461,
 70350241,
 64216,
 -64460,
 70413449,
 64215,
 -64459,
 70476722,
 64214,
 -64458,
 70539867,
 64213,
 -64457,
 70603296,
 64212,
 -64456,
 70666699,
 64211,
 -64455,
 70730164,
 64210,
 -64454,
 70793550,
 64209,
 -1,
 70857221,
 64208,
 71042283,
 168560,
 -1,
 71107682,
 70982709,
 -1,
 71173210,
 71053745,
 -1,
 71238724,
 71125783,
 -1,
 -64448,
 71174648,
 11976,
 -64447,
 71258807,
 11952,
 -64446,
 71321909,
 11977,
 -64445,
 71396547,
 11973,
 -1,
 71472182,
 12007,
 71631944,
 71217090,
 -1,
 -64442,
 71608893,
 12019,
 -64441,
 71630960,
 12014,
 -1,
 71739930,
 11993,
 71894092,
 71579519,
 -1,
 -64438,
 71872989,
 12010,
 -64437,
 71895673,
 11996,
 -1,
 71975126,
 12005,
 72156239,
 71854685,
 -1,
 -64434,
 72092193,
 11987,
 -1,
 72166964,
 11994,
 72352850,
 72105797,
 -1,
 -64431,
 72329383,
 11984,
 -1,
 72368257,
 11988,
 72549461,
 72298193,
 -1,
 -64428,
 72508491,
 12012,
 -1,
 72583702,
 12000,
 -64426,
 72502085,
 11995,
 -64425,
 72683274,
 12002,
 -64424,
 72787834,
 12016,
 -64423,
 72827432,
 11979,
 -1,
 72877077,
 12006,
 73073757,
 71133789,
 -1,
 -64420,
 73033574,
 11970,
 -1,
 73112359,
 11905,
 73270368,
 73027467,
 -1,
 -64417,
 73241779,
 11936,
 -1,
 73304382,
 11983,
 -64415,
 73236972,
 11943,
 -1,
 73410587,
 11931,
 73598081,
 71060247,
 -1,
 73663597,
 73551755,
 -1,
 73729132,
 73621537,
 -1,
 73794664,
 73666872,
 -1,
 -64409,
 73730805,
 12008,
 -1,
 73831373,
 11980,
 73991275,
 73742713,
 -1,
 -64406,
 73926858,
 11974,
 -1,
 74004456,
 11942,
 -1,
 73932737,
 12009,
 -1,
 73677635,
 11951,
 74318964,
 73608913,
 -1,
 74384499,
 74285025,
 -1,
 74450034,
 74362818,
 -1,
 -64399,
 74401388,
 11907,
 -1,
 74466223,
 11908,
 -1,
 74385960,
 11906,
 -1,
 74353126,
 11915,
 74777721,
 74284034,
 -1,
 74843256,
 74750754,
 -1,
 -64393,
 74788288,
 11925,
 -1,
 74844712,
 11924,
 -1,
 74790602,
 11922,
 75105404,
 74730552,
 -1,
 -64389,
 75050432,
 11949,
 -1,
 75106856,
 11948,
 75302015,
 75061534,
 -1,
 -64386,
 75247040,
 11917,
 -1,
 75303464,
 11916,
 -64384,
 75281260,
 11932,
 -1,
 75467713,
 11958,
 75629708,
 73560836,
 -1,
 75695241,
 75576674,
 -1,
 75760774,
 75661048,
 -1,
 -64379,
 75705792,
 11990,
 -1,
 75762216,
 11989,
 -64377,
 75737196,
 11935,
 -64376,
 75913234,
 11965,
 -1,
 75989377,
 11933,
 76218367,
 75640529,
 -1,
 -64373,
 76113173,
 11957,
 -1,
 76188182,
 11964,
 76350614,
 75567985,
 -1,
 76416145,
 76297570,
 -1,
 -64369,
 76356027,
 11910,
 -64368,
 76437361,
 12003,
 -1,
 76506312,
 11946,
 76678292,
 76357576,
 -1,
 -64365,
 76623296,
 11963,
 -1,
 76679720,
 11962,
 -64363,
 76639871,
 11992,
 -1,
 76839080,
 11950,
 77005985,
 76288312,
 -1,
 77071518,
 76941948,
 -1,
 77137051,
 77037206,
 -1,
 -64358,
 77082048,
 11938,
 -1,
 77138472,
 11937,
 77398015,
 77092405,
 -1,
 -64355,
 77278656,
 11982,
 -1,
 77335080,
 11981,
 77594623,
 77016266,
 -1,
 -64352,
 77475264,
 11972,
 -1,
 77531688,
 11971,
 77726891,
 76966493,
 -1,
 77792424,
 77680699,
 -1,
 77857958,
 77770690,
 -1,
 -64347,
 77809260,
 11919,
 -1,
 77874095,
 11920,
 -64345,
 77793832,
 11918,
 -1,
 78034428,
 11921,
 78249983,
 77744536,
 -1,
 -64342,
 78130624,
 11986,
 -1,
 78187048,
 11985,
 78382259,
 77682684,
 -1,
 78447794,
 78328241,
 -1,
 78513328,
 78426050,
 -1,
 -64337,
 78490173,
 12018,
 -1,
 78512240,
 12013,
 -64335,
 78448709,
 12011,
 -1,
 78686074,
 12015,
 -1,
 78398956,
 11945,
 78906555,
 78330233,
 -1,
 78972089,
 78867669,
 -1,
 79037624,
 78921537,
 -1,
 -64329,
 78982592,
 11927,
 -1,
 79039016,
 11926,
 -1,
 78980416,
 12001,
 -64326,
 78907594,
 11975,
 -1,
 79264227,
 11928,
 79430851,
 78851793,
 -1,
 79496385,
 79381222,
 -1,
 79561920,
 79474626,
 -1,
 -64321,
 79513196,
 11998,
 -1,
 79578031,
 11999,
 -1,
 79497768,
 11997,
 -64318,
 79467715,
 11947,
 -1,
 79775270,
 11960,
 79955144,
 79409090,
 -1,
 -64315,
 79931965,
 12017,
 -64314,
 79955240,
 11969,
 -64313,
 80030190,
 11923,
 -1,
 80131610,
 11911,
 80282830,
 79894283,
 -1,
 80348365,
 80218748,
 -1,
 -64309,
 80317644,
 11929,
 -64308,
 80376580,
 11959,
 -1,
 80433102,
 11991,
 -1,
 80311419,
 11904,
 80676052,
 80242996,
 -1,
 80741586,
 80654274,
 -1,
 -64303,
 80692844,
 11954,
 -1,
 80757679,
 11955,
 -64301,
 80677416,
 11953,
 -1,
 80918012,
 11956,
 81069275,
 80625477,
 -1,
 81134810,
 81037705,
 -1,
 81200345,
 81113026,
 -1,
 -64296,
 81151596,
 11967,
 -1,
 81216431,
 11968,
 -1,
 81136168,
 11966,
 -1,
 81105762,
 12004,
 81528032,
 81038540,
 -1,
 81593567,
 81467864,
 -1,
 -64290,
 81538496,
 11941,
 -1,
 81594920,
 11940,
 -1,
 81539648,
 11909,
 81855716,
 81470784,
 -1,
 -64286,
 81822122,
 11944,
 -64285,
 81888183,
 11914,
 -1,
 81924529,
 11934,
 82117863,
 81829162,
 -1,
 -64282,
 82062784,
 11913,
 -1,
 82119208,
 11912,
 82314474,
 82065279,
 -1,
 -64279,
 82295171,
 11978,
 -1,
 82333667,
 11939,
 -1,
 82290855,
 11961,
 82640895,
 71016163,
 -1,
 82642167,
 82524537,
 -1,
 82707701,
 82586743,
 -1,
 82773233,
 82652279,
 12741,
 -64272,
 82717815,
 12750,
 -1,
 82808012,
 12747,
 82969843,
 82710840,
 12749,
 -1,
 82919237,
 12744,
 -64268,
 82948034,
 12746,
 -1,
 83050309,
 12742,
 83296255,
 82676940,
 12743,
 -1,
 83183139,
 12748,
 83363066,
 82594583,
 -1,
 -64263,
 83342803,
 12745,
 -1,
 83366200,
 12740,
 -64261,
 83324863,
 12738,
 -64260,
 83510819,
 12737,
 -64259,
 83603394,
 12736,
 -64258,
 83655682,
 12751,
 -1,
 83733419,
 12739,
 83888082,
 68220,
 -1,
 83953607,
 83852290,
 -1,
 84019140,
 83906624,
 -1,
 84084190,
 83958837,
 5281,
 84149712,
 84019836,
 5264,
 84215246,
 84094139,
 -1,
 84280624,
 84193218,
 -1,
 84346132,
 84258754,
 -1,
 84411662,
 84298519,
 -1,
 84477194,
 84356817,
 5737,
 -1,
 84422353,
 5738,
 -64245,
 84457656,
 5735,
 -64244,
 84555106,
 5736,
 -64243,
 84627339,
 5739,
 -1,
 84675196,
 5740,
 84870416,
 84356817,
 5604,
 -1,
 84815569,
 5605,
 -64239,
 84850872,
 5602,
 -64238,
 84948322,
 5603,
 -64237,
 85020555,
 5606,
 -1,
 85068412,
 5607,
 85263650,
 84306525,
 -1,
 85329180,
 85211513,
 -1,
 85394712,
 85274321,
 5686,
 -1,
 85339857,
 5687,
 -64231,
 85375160,
 5684,
 -64230,
 85472610,
 5685,
 -64229,
 85544843,
 5688,
 -1,
 85592700,
 5689,
 85787934,
 85274321,
 5692,
 -1,
 85733073,
 5693,
 -64225,
 85768376,
 5690,
 -64224,
 85865826,
 5691,
 -64223,
 85938059,
 5694,
 -1,
 85985916,
 5695,
 86181161,
 85216023,
 -1,
 86246693,
 86126289,
 5725,
 -1,
 86191825,
 5726,
 -64218,
 86227128,
 5723,
 -64217,
 86324578,
 5724,
 -64216,
 86396811,
 5727,
 -1,
 86444668,
 5728,
 86704127,
 86129017,
 -1,
 86705452,
 86585041,
 5598,
 -1,
 86650577,
 5599,
 -64211,
 86685880,
 5596,
 -64210,
 86783330,
 5597,
 -64209,
 86855563,
 5600,
 -1,
 86903420,
 5601,
 87098689,
 84223296,
 -1,
 87164216,
 87043191,
 -1,
 87229748,
 87109329,
 5706,
 -1,
 87174865,
 5707,
 -64203,
 87210168,
 5704,
 -64202,
 87307618,
 5705,
 -64201,
 87379851,
 5708,
 -1,
 87427708,
 5709,
 87622975,
 87124573,
 -1,
 87688507,
 87568081,
 5674,
 -1,
 87633617,
 5675,
 -64196,
 87668920,
 5672,
 -64195,
 87766370,
 5673,
 -64194,
 87838603,
 5676,
 -1,
 87886460,
 5677,
 -64192,
 87576459,
 5204,
 -1,
 88042691,
 5203,
 88212815,
 87051031,
 -1,
 88278345,
 88160633,
 5722,
 88343877,
 88223441,
 5718,
 -1,
 88288977,
 5719,
 -64186,
 88324280,
 5716,
 -64185,
 88421730,
 5717,
 -64184,
 88493963,
 5720,
 -1,
 88541820,
 5721,
 88737099,
 88223441,
 5712,
 -1,
 88682193,
 5713,
 -64180,
 88717496,
 5710,
 -64179,
 88814946,
 5711,
 -64178,
 88887179,
 5714,
 -1,
 88935036,
 5715,
 89130334,
 88170608,
 -1,
 89195863,
 89088112,
 5633,
 89261395,
 89140945,
 5629,
 -1,
 89206481,
 5630,
 -64172,
 89241784,
 5627,
 -64171,
 89339234,
 5628,
 -64170,
 89411467,
 5631,
 -1,
 89459324,
 5632,
 89718783,
 89143673,
 -1,
 89720154,
 89599697,
 5623,
 -1,
 89665233,
 5624,
 -64165,
 89700536,
 5621,
 -64164,
 89797986,
 5622,
 -64163,
 89870219,
 5625,
 -1,
 89918076,
 5626,
 90113388,
 89090653,
 -1,
 90178918,
 90061177,
 -1,
 90244450,
 90123985,
 5680,
 -1,
 90189521,
 5681,
 -64157,
 90224824,
 5678,
 -64156,
 90322274,
 5679,
 -64155,
 90394507,
 5682,
 -1,
 90442364,
 5683,
 90637672,
 90123985,
 5668,
 -1,
 90582737,
 5669,
 -64151,
 90618040,
 5666,
 -64150,
 90715490,
 5667,
 -64149,
 90787723,
 5670,
 -1,
 90835580,
 5671,
 91030906,
 90068988,
 -1,
 91096436,
 90986492,
 -1,
 91161968,
 91041489,
 5662,
 -1,
 91107025,
 5663,
 -64143,
 91142328,
 5660,
 -64142,
 91239778,
 5661,
 -64141,
 91312011,
 5664,
 -1,
 91359868,
 5665,
 91555190,
 91041489,
 5655,
 -1,
 91500241,
 5656,
 -64137,
 91535544,
 5652,
 -64136,
 91632994,
 5654,
 -64135,
 91705227,
 5657,
 -1,
 91753084,
 5659,
 91948424,
 90980165,
 -1,
 92013954,
 91896185,
 -1,
 92079486,
 91958993,
 5574,
 -1,
 92024529,
 5575,
 -64129,
 92059832,
 5572,
 -64128,
 92157282,
 5573,
 -64127,
 92229515,
 5576,
 -1,
 92277372,
 5577,
 92472708,
 91958993,
 5617,
 -1,
 92417745,
 5618,
 -64123,
 92453048,
 5615,
 -64122,
 92550498,
 5616,
 -64121,
 92622731,
 5619,
 -1,
 92670588,
 5620,
 92865938,
 91896185,
 5195,
 92931472,
 92803384,
 -1,
 92997004,
 92876497,
 5592,
 -1,
 92942033,
 5593,
 -64115,
 92977336,
 5590,
 -64114,
 93074786,
 5591,
 -64113,
 93147019,
 5594,
 -1,
 93194876,
 5595,
 -64111,
 92884875,
 5175,
 -1,
 93351107,
 5174,
 93521305,
 92810359,
 5702,
 93586837,
 93466321,
 5698,
 -1,
 93531857,
 5699,
 -64106,
 93567160,
 5696,
 -64105,
 93664610,
 5697,
 -64104,
 93736843,
 5700,
 -1,
 93784700,
 5701,
 93980064,
 93490380,
 5614,
 94045596,
 93925073,
 5610,
 -1,
 93990609,
 5611,
 -64099,
 94025912,
 5608,
 -64098,
 94123362,
 5609,
 -64097,
 94195595,
 5612,
 -1,
 94243452,
 5613,
 94438824,
 93944834,
 -1,
 94504355,
 94383825,
 5636,
 -1,
 94449361,
 5637,
 -64092,
 94484664,
 5634,
 -64091,
 94582114,
 5635,
 -64090,
 94654347,
 5638,
 -64089,
 94715717,
 5329,
 -1,
 94767740,
 5639,
 94963119,
 94380756,
 -1,
 95028651,
 94908113,
 5648,
 -1,
 94973649,
 5649,
 -64084,
 95008952,
 5646,
 -64083,
 95106402,
 5647,
 -64082,
 95178635,
 5650,
 -1,
 95226492,
 5651,
 95421878,
 94900536,
 -1,
 95487410,
 95366865,
 5586,
 -1,
 95432401,
 5587,
 -64077,
 95467704,
 5584,
 -64076,
 95565154,
 5585,
 -64075,
 95637387,
 5588,
 -1,
 95685244,
 5589,
 95880637,
 95360779,
 -1,
 95946169,
 95825617,
 5580,
 -1,
 95891153,
 5581,
 -64070,
 95926456,
 5578,
 -64069,
 96023906,
 5579,
 -64068,
 96096139,
 5582,
 -1,
 96143996,
 5583,
 96339396,
 95843076,
 -1,
 96404928,
 96284369,
 5642,
 -1,
 96349905,
 5643,
 -64063,
 96385208,
 5640,
 -64062,
 96482658,
 5641,
 -64061,
 96554891,
 5644,
 -1,
 96602748,
 5645,
 96798155,
 96280427,
 -1,
 96863687,
 96743121,
 5731,
 -1,
 96808657,
 5732,
 -64056,
 96843960,
 5729,
 -64055,
 96941410,
 5730,
 -64054,
 97013643,
 5733,
 -1,
 97061500,
 5734,
 97256909,
 96751499,
 5129,
 -1,
 97199217,
 5703,
 -1,
 97217731,
 5128,
 97517567,
 84150908,
 5265,
 -1,
 97406859,
 5258,
 97584600,
 84087096,
 -1,
 97650131,
 97531234,
 5272,
 -1,
 97596770,
 5274,
 97781205,
 97603467,
 5268,
 -1,
 97734539,
 5270,
 97912279,
 97716860,
 5276,
 -1,
 97847932,
 5278,
 -1,
 97857233,
 5266,
 98108890,
 97531234,
 5261,
 -1,
 98055522,
 5262,
 98239964,
 98062219,
 5259,
 -1,
 98193291,
 5260,
 -64035,
 98186058,
 5741,
 -1,
 98315985,
 5257,
 98502225,
 84021560,
 -1,
 98567750,
 98447057,
 5132,
 98697215,
 98547470,
 -1,
 98698738,
 98585367,
 -1,
 98764266,
 98636088,
 -1,
 98829797,
 98710882,
 5373,
 -1,
 98776418,
 5375,
 98960871,
 98783115,
 5369,
 -1,
 98914187,
 5371,
 99091945,
 98896508,
 5377,
 -1,
 99027580,
 5379,
 -1,
 99036881,
 5367,
 99352575,
 98707274,
 -1,
 99354093,
 99235170,
 5406,
 -1,
 99300706,
 5408,
 99485167,
 99307403,
 5402,
 -1,
 99438475,
 5404,
 99616241,
 99420796,
 5410,
 -1,
 99551868,
 5412,
 -1,
 99561169,
 5400,
 99812862,
 98658909,
 5355,
 99878395,
 99750200,
 -1,
 99943926,
 99824994,
 5347,
 -1,
 99890530,
 5349,
 100075000,
 99897227,
 5343,
 -1,
 100028299,
 5345,
 100206074,
 100010620,
 5351,
 -1,
 100141692,
 5353,
 -1,
 100150993,
 5341,
 -64004,
 99824994,
 5450,
 -64003,
 100347601,
 5444,
 -1,
 100403836,
 5453,
 100599303,
 99754708,
 5440,
 100728831,
 100536632,
 -1,
 100730370,
 100611426,
 5430,
 -1,
 100676962,
 5432,
 100861444,
 100683659,
 5426,
 -1,
 100814731,
 5428,
 100992518,
 100797052,
 5434,
 -1,
 100928124,
 5436,
 -1,
 100937425,
 5424,
 101189137,
 100577218,
 -1,
 101254672,
 101126456,
 -1,
 101320203,
 101201250,
 5214,
 -1,
 101266786,
 5216,
 101451277,
 101273483,
 5210,
 -1,
 101404555,
 5212,
 101582351,
 101386876,
 5218,
 -1,
 101517948,
 5220,
 -1,
 101527249,
 5208,
 -1,
 101191852,
 5481,
 101844506,
 101158092,
 5194,
 101974015,
 101781816,
 -1,
 101975573,
 101856610,
 5185,
 -1,
 101922146,
 5187,
 102106647,
 101928843,
 5181,
 -1,
 102059915,
 5183,
 102237721,
 102042236,
 5189,
 -1,
 102173308,
 5191,
 -1,
 102182609,
 5179,
 102434339,
 101806852,
 5308,
 102563839,
 102371640,
 -1,
 102565406,
 102446434,
 5299,
 -1,
 102511970,
 5301,
 102696480,
 102518667,
 5295,
 -1,
 102649739,
 5297,
 102827554,
 102632060,
 5303,
 -1,
 102763132,
 5305,
 -1,
 102772433,
 5293,
 103024171,
 102371640,
 -1,
 103089702,
 102970722,
 5139,
 -1,
 103036258,
 5141,
 103220776,
 103042955,
 5135,
 -1,
 103174027,
 5137,
 103351850,
 103156348,
 5144,
 -1,
 103287420,
 5146,
 -1,
 103296721,
 5133,
 103548467,
 102997856,
 -1,
 103613998,
 103495010,
 5243,
 -1,
 103560546,
 5245,
 103745072,
 103567243,
 5239,
 -1,
 103698315,
 5241,
 103876146,
 103680636,
 5247,
 -1,
 103811708,
 5249,
 -1,
 103821009,
 5237,
 104072763,
 103489530,
 -1,
 104138294,
 104019298,
 5273,
 -1,
 104084834,
 5275,
 104269368,
 104091531,
 5269,
 -1,
 104222603,
 5271,
 104400442,
 104204924,
 5277,
 -1,
 104335996,
 5279,
 -1,
 104345297,
 5267,
 104597057,
 104011531,
 5457,
 -63939,
 104549601,
 5455,
 -63938,
 104609122,
 5516,
 -63937,
 104681355,
 5515,
 -63936,
 104738513,
 5514,
 -1,
 104794748,
 5517,
 104990277,
 104552414,
 -1,
 105055812,
 104925820,
 5324,
 -1,
 104991356,
 5326,
 -1,
 105000657,
 5322,
 -1,
 104940484,
 5468,
 105317965,
 98514274,
 5138,
 105447423,
 105264482,
 5140,
 105512959,
 105335843,
 5535,
 -63926,
 105395554,
 5533,
 -63925,
 105467787,
 5532,
 -63924,
 105524945,
 5531,
 -1,
 105581180,
 5534,
 105776719,
 105271179,
 5134,
 -1,
 105729931,
 5136,
 105971711,
 105712252,
 5143,
 -1,
 105843324,
 5145,
 106038927,
 98466818,
 5328,
 106104423,
 105974396,
 5319,
 106169957,
 106050126,
 -1,
 106235484,
 106122007,
 -1,
 106301015,
 106209120,
 5386,
 -1,
 106236540,
 5390,
 -63912,
 106253537,
 5380,
 -63911,
 106376552,
 5389,
 -63910,
 106451104,
 5388,
 -63909,
 106530355,
 5391,
 -1,
 106585214,
 5387,
 106759775,
 106172728,
 -1,
 -63906,
 106725758,
 5142,
 -1,
 106793393,
 5147,
 -63904,
 106718890,
 5437,
 -63903,
 106923040,
 5221,
 -63902,
 106999089,
 5327,
 -63901,
 107034996,
 5306,
 -63900,
 107088783,
 5250,
 -1,
 107187076,
 5280,
 107413503,
 106105468,
 5320,
 -1,
 107302795,
 5313,
 107480689,
 106052505,
 -1,
 107546224,
 107431066,
 5499,
 107611755,
 107492706,
 5495,
 -1,
 107558242,
 5496,
 107742829,
 107564939,
 5493,
 -1,
 107696011,
 5494,
 107873903,
 107678332,
 5497,
 -1,
 107809404,
 5498,
 -1,
 107818705,
 5492,
 -1,
 107507883,
 5500,
 108136058,
 107429701,
 5525,
 108201590,
 108071548,
 5523,
 108267125,
 108137084,
 5524,
 -1,
 108220299,
 5518,
 -1,
 108220299,
 5744,
 108463736,
 108148066,
 5521,
 -1,
 108410210,
 5522,
 108658687,
 108416907,
 5519,
 -1,
 108547979,
 5520,
 108725889,
 108091252,
 5526,
 108791421,
 108672354,
 5747,
 -1,
 108737890,
 5748,
 108922495,
 108744587,
 5745,
 -1,
 108875659,
 5746,
 109117439,
 108857980,
 5749,
 -1,
 108989052,
 5750,
 109184645,
 108663096,
 -1,
 109250180,
 109120124,
 5323,
 -1,
 109185660,
 5325,
 -1,
 109194961,
 5321,
 109446793,
 109144177,
 -1,
 109512328,
 109399947,
 5473,
 -1,
 109465483,
 5475,
 -1,
 109457105,
 5471,
 109708939,
 109393250,
 5316,
 -1,
 109655394,
 5317,
 109840013,
 109662091,
 5314,
 -1,
 109793163,
 5315,
 -63858,
 109787513,
 5330,
 -1,
 109915857,
 5312,
 110102213,
 106016706,
 5222,
 110167713,
 110049657,
 5482,
 110233241,
 110127217,
 5550,
 110298772,
 110179682,
 5546,
 -1,
 110245218,
 5547,
 110429846,
 110251915,
 5544,
 -1,
 110382987,
 5545,
 110560920,
 110365308,
 5548,
 -1,
 110496380,
 5549,
 -1,
 110505681,
 5543,
 110757531,
 110179682,
 5476,
 -1,
 110703970,
 5477,
 110888605,
 110710667,
 5472,
 -1,
 110841739,
 5474,
 111019679,
 110824060,
 5478,
 -1,
 110955132,
 5479,
 -63840,
 110972129,
 5480,
 -1,
 111095505,
 5470,
 111281835,
 110145474,
 -1,
 111347367,
 111229305,
 5487,
 -63836,
 111293794,
 5485,
 -63835,
 111366027,
 5484,
 -63834,
 111423185,
 5483,
 -1,
 111479420,
 5486,
 -63832,
 111293794,
 5225,
 -63831,
 111628171,
 5224,
 -63830,
 111685329,
 5223,
 -1,
 111741564,
 5226,
 111937203,
 111219000,
 -1,
 112002734,
 111883618,
 5213,
 -1,
 111949154,
 5215,
 112133808,
 111955851,
 5209,
 -1,
 112086923,
 5211,
 112264882,
 112069244,
 5217,
 -1,
 112200316,
 5219,
 -1,
 112209617,
 5207,
 112461496,
 111878868,
 -1,
 -63819,
 112407906,
 5490,
 -63818,
 112480139,
 5489,
 -63817,
 112537297,
 5488,
 -1,
 112593532,
 5491,
 112789181,
 112396837,
 -1,
 -63814,
 112735586,
 5512,
 -63813,
 112807819,
 5511,
 -63812,
 112864977,
 5510,
 -1,
 112921212,
 5513,
 113116864,
 112724604,
 5205,
 113246207,
 113052284,
 5206,
 -1,
 113135499,
 5197,
 113313474,
 113063266,
 5200,
 -1,
 113259874,
 5201,
 113444548,
 113266571,
 5198,
 -1,
 113397643,
 5199,
 -1,
 113389265,
 5196,
 113641212,
 110054167,
 5381,
 113706714,
 113576572,
 5364,
 113772248,
 113645020,
 -1,
 113837773,
 113730837,
 -1,
 -63798,
 113784162,
 5529,
 -63797,
 113856395,
 5528,
 -63796,
 113913553,
 5527,
 -1,
 113969788,
 5530,
 114165458,
 113785209,
 -1,
 -63793,
 114111842,
 5570,
 -63792,
 114184075,
 5569,
 -63791,
 114241233,
 5568,
 -1,
 114297468,
 5571,
 114493141,
 114120700,
 -1,
 -63788,
 114473144,
 5653,
 -1,
 114511755,
 5658,
 -63786,
 114463853,
 5441,
 -63785,
 114643585,
 5282,
 -1,
 114717444,
 5311,
 114950143,
 113707644,
 5365,
 -1,
 114839435,
 5358,
 115017450,
 113654137,
 5413,
 115082979,
 114954552,
 -1,
 115148510,
 115029346,
 5405,
 -1,
 115094882,
 5407,
 115279584,
 115101579,
 5401,
 -1,
 115232651,
 5403,
 115410658,
 115214972,
 5409,
 -1,
 115346044,
 5411,
 -1,
 115355345,
 5399,
 115607269,
 115029346,
 5395,
 -1,
 115553634,
 5396,
 115738343,
 115560331,
 5393,
 -1,
 115691403,
 5394,
 115869417,
 115673724,
 5397,
 -1,
 115804796,
 5398,
 -1,
 115814097,
 5392,
 116066034,
 114954552,
 5383,
 116131565,
 116012386,
 5372,
 -1,
 116077922,
 5374,
 116262639,
 116084619,
 5368,
 -1,
 116215691,
 5370,
 116393713,
 116198012,
 5376,
 -1,
 116329084,
 5378,
 -1,
 116338385,
 5366,
 116590329,
 116012386,
 5361,
 116655864,
 116559801,
 -1,
 -63755,
 116621735,
 5255,
 -63754,
 116674489,
 5254,
 -63753,
 116747448,
 5253,
 -1,
 116806858,
 5256,
 -1,
 116602210,
 5362,
 117049083,
 116543371,
 5359,
 -1,
 117002123,
 5360,
 -1,
 116993745,
 5357,
 117245723,
 113582804,
 5438,
 117311243,
 117210219,
 -1,
 117376769,
 117279948,
 -1,
 -63744,
 117329121,
 5192,
 -1,
 117408126,
 5173,
 -63742,
 117341751,
 5420,
 -63741,
 117510456,
 5149,
 -63740,
 117609697,
 5202,
 -63739,
 117681125,
 5363,
 -63738,
 117735806,
 5127,
 -63737,
 117769504,
 5318,
 -63736,
 117841300,
 5289,
 -63735,
 117907746,
 5337,
 -63734,
 117979256,
 5233,
 -1,
 118049754,
 5263,
 118228755,
 117248312,
 -1,
 118294286,
 118175074,
 5429,
 -1,
 118240610,
 5431,
 118425360,
 118247307,
 5425,
 -1,
 118378379,
 5427,
 118556434,
 118360700,
 5433,
 -1,
 118491772,
 5435,
 -1,
 118501073,
 5423,
 118753046,
 118164092,
 5421,
 118882303,
 118688380,
 5422,
 -1,
 118771595,
 5415,
 118949656,
 118699362,
 5418,
 -1,
 118895970,
 5419,
 119080730,
 118902667,
 5416,
 -1,
 119033739,
 5417,
 -1,
 119025361,
 5414,
 119277363,
 117205597,
 5354,
 119342884,
 119214392,
 -1,
 119408415,
 119289186,
 5346,
 -1,
 119354722,
 5348,
 119539489,
 119361419,
 5342,
 -1,
 119492491,
 5344,
 119670563,
 119474812,
 5350,
 -1,
 119605884,
 5352,
 -1,
 119615185,
 5340,
 119867179,
 119290233,
 5542,
 119932711,
 119813474,
 5538,
 -1,
 119879010,
 5539,
 120063785,
 119885707,
 5536,
 -1,
 120016779,
 5537,
 120258559,
 119999100,
 5540,
 -1,
 120130172,
 5541,
 120325934,
 119802492,
 5338,
 120455167,
 120261244,
 5339,
 -1,
 120344459,
 5332,
 120522544,
 120272226,
 5335,
 -1,
 120468834,
 5336,
 120653618,
 120475531,
 5333,
 -1,
 120606603,
 5334,
 -1,
 120598225,
 5331,
 120850254,
 119224191,
 5469,
 120915782,
 120803211,
 5461,
 120981317,
 120859577,
 -1,
 121046843,
 120931186,
 -1,
 121112378,
 121000878,
 -1,
 -63687,
 121069201,
 5158,
 -1,
 121153488,
 5157,
 -1,
 121086510,
 5162,
 121374526,
 120994808,
 -1,
 -63683,
 121329524,
 5156,
 -1,
 121379267,
 5155,
 -63681,
 121346380,
 5154,
 -63680,
 121533117,
 5160,
 -63679,
 121596364,
 5161,
 -63678,
 121636214,
 5159,
 -63677,
 121741632,
 5152,
 -63676,
 121812403,
 5153,
 -1,
 121874384,
 5151,
 -1,
 120934283,
 5462,
 122095433,
 120851068,
 5465,
 122224639,
 122030716,
 5466,
 -1,
 122113931,
 5460,
 122292043,
 122041698,
 5463,
 -1,
 122238306,
 5464,
 -63668,
 122244321,
 5467,
 -63667,
 122363761,
 5742,
 -1,
 122433233,
 5459,
 122619748,
 120812292,
 5307,
 122685271,
 122556728,
 -1,
 122750802,
 122631522,
 5298,
 -1,
 122697058,
 5300,
 122881876,
 122703755,
 5294,
 -1,
 122834827,
 5296,
 123012950,
 122817148,
 5302,
 -1,
 122948220,
 5304,
 -1,
 122957521,
 5292,
 123209562,
 122631522,
 5287,
 123338751,
 123155810,
 5288,
 -1,
 123231729,
 5385,
 123406174,
 123154129,
 5283,
 123535359,
 123384047,
 -1,
 -63651,
 123410187,
 5458,
 -1,
 123497053,
 5356,
 123668321,
 123341436,
 5290,
 123797503,
 123603580,
 5291,
 -1,
 123686795,
 5284,
 123864931,
 123621259,
 5285,
 -1,
 123817867,
 5286,
 -1,
 123812217,
 5309,
 124061563,
 122557297,
 -1,
 124127098,
 124025870,
 -1,
 124192619,
 124064056,
 -1,
 -63640,
 124138850,
 5558,
 -63639,
 124211083,
 5557,
 -63638,
 124268241,
 5556,
 -1,
 124324476,
 5559,
 124520304,
 124156930,
 -1,
 -63635,
 124466530,
 5562,
 -63634,
 124538763,
 5561,
 -63633,
 124595921,
 5560,
 -1,
 124652156,
 5563,
 124847989,
 124477552,
 -1,
 -63630,
 124794210,
 5566,
 -63629,
 124866443,
 5565,
 -63628,
 124923601,
 5564,
 -1,
 124979836,
 5567,
 -63626,
 124799767,
 5384,
 -63625,
 125121890,
 5554,
 -63624,
 125194123,
 5553,
 -63623,
 125251281,
 5552,
 -1,
 125307516,
 5555,
 -1,
 124071390,
 5439,
 125568908,
 124018800,
 5251,
 125634436,
 125505848,
 5252,
 125699967,
 125580642,
 5242,
 -1,
 125646178,
 5244,
 125831041,
 125652875,
 5238,
 -1,
 125783947,
 5240,
 125962115,
 125766268,
 5246,
 -1,
 125897340,
 5248,
 -1,
 125906641,
 5236,
 126158727,
 125569660,
 5234,
 126287871,
 126093948,
 5235,
 -1,
 126177163,
 5228,
 126355337,
 126104930,
 5231,
 -1,
 126301538,
 5232,
 126486411,
 126308235,
 5229,
 -1,
 126439307,
 5230,
 -1,
 126430929,
 5227,
 126683037,
 125537484,
 5193,
 126748565,
 126619960,
 -1,
 126814096,
 126694754,
 5184,
 -1,
 126760290,
 5186,
 126945170,
 126766987,
 5180,
 -1,
 126898059,
 5182,
 127076244,
 126880380,
 5188,
 -1,
 127011452,
 5190,
 -1,
 127020753,
 5178,
 127272856,
 126683772,
 5176,
 127401983,
 127208060,
 5177,
 -1,
 127291275,
 5168,
 127469466,
 127219042,
 5171,
 -1,
 127415650,
 5172,
 127600540,
 127422347,
 5169,
 -1,
 127553419,
 5170,
 -1,
 127545041,
 5167,
 127797160,
 126621451,
 5456,
 127862689,
 127732348,
 5451,
 127991807,
 127797884,
 5452,
 -1,
 127881099,
 5445,
 128059299,
 127808866,
 5448,
 -1,
 128005474,
 5449,
 128190373,
 128012171,
 5446,
 -1,
 128143243,
 5447,
 -63578,
 128142561,
 5454,
 -63577,
 128265937,
 5442,
 -1,
 128340107,
 5443,
 128518065,
 127768097,
 5509,
 128583597,
 128453244,
 5507,
 128649132,
 128518780,
 5508,
 -1,
 128601995,
 5502,
 -1,
 128601995,
 5743,
 128845743,
 128529762,
 5505,
 -1,
 128791906,
 5506,
 129040383,
 128798603,
 5503,
 -1,
 128929675,
 5504,
 129107898,
 128453244,
 5130,
 129173429,
 129075055,
 -1,
 -63564,
 129125143,
 5382,
 -1,
 129200900,
 5310,
 129370039,
 129126283,
 5148,
 -1,
 129325362,
 5551,
 129501113,
 129305212,
 5131,
 -1,
 129453963,
 5122,
 -1,
 129465346,
 5166,
 129697725,
 129054050,
 5125,
 -63556,
 129643874,
 5126,
 -1,
 129727490,
 5165,
 129894336,
 129650571,
 5123,
 -63553,
 129858562,
 5164,
 -1,
 129912715,
 5124,
 130090946,
 129838801,
 5121,
 -1,
 130055170,
 5163,
 -63549,
 130033498,
 5501,
 -1,
 130181526,
 5150,
 130416639,
 83959709,
 -1,
 -63546,
 130291467,
 9803,
 -1,
 130357293,
 917631,
 130549709,
 83891979,
 -1,
 130615244,
 130494161,
 -1,
 130680779,
 130592706,
 8248,
 -1,
 130644559,
 8257,
 -1,
 130640039,
 8453,
 -1,
 130580865,
 711,
 130942928,
 130491712,
 -1,
 -63537,
 130888978,
 9764,
 -1,
 130960145,
 8454,
 -63535,
 130903558,
 9761,
 -1,
 131073926,
 9809,
 131271013,
 83829460,
 -1,
 131336480,
 131227164,
 -1,
 131401848,
 131286088,
 -1,
 131467380,
 131371777,
 -1,
 131532780,
 131424368,
 -1,
 131598307,
 131478882,
 -1,
 131663842,
 131558082,
 -1,
 131729373,
 131605824,
 -1,
 -63525,
 131702150,
 1287,
 -63524,
 131757323,
 1283,
 -1,
 131804881,
 1281,
 -63522,
 131702150,
 1285,
 -63521,
 131925284,
 1295,
 -63520,
 132024314,
 1293,
 -63519,
 132086608,
 1291,
 -1,
 132139689,
 1289,
 -1,
 131640248,
 1153,
 132384745,
 131533436,
 1082,
 132513791,
 132328900,
 -1,
 -63514,
 132391396,
 1181,
 -63513,
 132479353,
 1183,
 -63512,
 132557655,
 1220,
 -1,
 132615269,
 1179,
 -63510,
 132343058,
 1135,
 -63509,
 132740363,
 1116,
 -1,
 132798341,
 1228,
 132974588,
 131477201,
 1101,
 133040114,
 132938754,
 1085,
 133169151,
 132984260,
 -1,
 -63504,
 133054115,
 1226,
 -63503,
 133147479,
 1224,
 -1,
 133205093,
 1187,
 133367796,
 132991767,
 1089,
 -1,
 133347370,
 1195,
 133498870,
 133306123,
 1088,
 -1,
 133441755,
 1167,
 133629944,
 133460740,
 1084,
 -1,
 133583766,
 1230,
 133761018,
 133589597,
 1083,
 -1,
 133714838,
 1222,
 -63493,
 133707647,
 1092,
 -1,
 133865764,
 1261,
 134023180,
 132927371,
 1080,
 134088706,
 133969250,
 1105,
 134217727,
 134023066,
 -1,
 -63488,
 134100819,
 1129,
 -63487,
 134164177,
 1125,
 -1,
 134256906,
 1133,
 134416390,
 134033105,
 1077,
 134545407,
 134360516,
 -1,
 -63483,
 134455616,
 1104,
 -1,
 134501288,
 1239,
 134678538,
 134360516,
 -1,
 -63480,
 134611151,
 1251,
 -63479,
 134717760,
 1117,
 -1,
 134752516,
 1253,
 135004159,
 134652366,
 1141,
 -1,
 134877295,
 1143,
 135071771,
 133974807,
 -1,
 135137301,
 135018873,
 -1,
 135202834,
 135093810,
 -1,
 135268369,
 135155595,
 1081,
 -1,
 135222166,
 1163,
 -1,
 135248056,
 1118,
 -63469,
 135145372,
 1211,
 -63468,
 135400880,
 1097,
 -1,
 135465596,
 1096,
 135661591,
 135108704,
 1199,
 -1,
 135635367,
 1201,
 135792665,
 135599543,
 1241,
 -1,
 135766308,
 1243,
 -63462,
 135754086,
 1100,
 -1,
 135879707,
 1165,
 136054822,
 135015543,
 -1,
 136120354,
 135997352,
 1078,
 136249343,
 136064452,
 -1,
 136251425,
 136127808,
 -1,
 -63456,
 136200749,
 1245,
 -1,
 136258465,
 1175,
 -1,
 136205224,
 1218,
 136577023,
 136064721,
 1079,
 136642559,
 136459647,
 -1,
 -63451,
 136528429,
 1247,
 -1,
 136586145,
 1177,
 136775727,
 135989884,
 1072,
 136841260,
 136753176,
 -1,
 136906794,
 136777156,
 1213,
 -1,
 136886314,
 1215,
 -63445,
 136849308,
 1193,
 -1,
 137000027,
 1249,
 137232383,
 136785348,
 -1,
 -63442,
 137111812,
 1235,
 -1,
 137188264,
 1233,
 137365558,
 136717012,
 -1,
 137431090,
 137312353,
 1099,
 -1,
 137404708,
 1273,
 137562164,
 137366140,
 1103,
 -1,
 137539522,
 1123,
 -63435,
 137541816,
 1102,
 -1,
 137645963,
 1111,
 137824318,
 137345208,
 1091,
 137889852,
 137768388,
 -1,
 137955387,
 137831744,
 -1,
 -63430,
 137921912,
 1267,
 -1,
 137970221,
 1265,
 -1,
 137887951,
 1263,
 138280959,
 137846896,
 1145,
 -1,
 138169474,
 1108,
 138348614,
 137772869,
 -1,
 138414149,
 138291112,
 1075,
 138543103,
 138358212,
 -1,
 -63422,
 138431717,
 1169,
 -63421,
 138508665,
 1171,
 -63420,
 138577952,
 1173,
 -1,
 138644581,
 1271,
 -1,
 138376459,
 1107,
 138872910,
 138285937,
 -1,
 138938443,
 138807932,
 -1,
 139003978,
 138901160,
 1257,
 -1,
 138977572,
 1259,
 -1,
 138947749,
 1185,
 -63412,
 138913935,
 1110,
 -63411,
 139166896,
 1131,
 -1,
 139210449,
 1073,
 139397203,
 138818914,
 1086,
 139462737,
 139329707,
 1121,
 -1,
 139439036,
 1149,
 -63406,
 139440066,
 1151,
 -1,
 139567396,
 1255,
 139724889,
 139374530,
 -1,
 139790423,
 139676439,
 -1,
 -63402,
 139732904,
 1115,
 -1,
 139800273,
 1094,
 140050431,
 139734737,
 1090,
 -1,
 139966506,
 1197,
 140118111,
 139666752,
 -1,
 140183645,
 140061815,
 -1,
 -63396,
 140126120,
 1119,
 -1,
 140193489,
 1109,
 -63394,
 140145931,
 1106,
 -1,
 140324561,
 1076,
 140511333,
 140053956,
 1095,
 140640255,
 140455364,
 -1,
 140642404,
 140518720,
 -1,
 -63389,
 140591661,
 1269,
 -1,
 140649377,
 1207,
 -1,
 140583396,
 1209,
 140904553,
 140479692,
 -1,
 140970088,
 140848849,
 1087,
 -1,
 140915628,
 1191,
 -1,
 140928274,
 1137,
 141166700,
 140847004,
 1093,
 -63381,
 141099404,
 1098,
 -1,
 141211690,
 1203,
 141363311,
 141126237,
 -1,
 -63378,
 141325579,
 1113,
 -1,
 141386613,
 1127,
 -63376,
 141304413,
 1074,
 -63375,
 141522190,
 1147,
 -63374,
 141589328,
 1114,
 -63373,
 141653259,
 1112,
 -1,
 141719051,
 1139,
 141950975,
 131440598,
 -1,
 -63370,
 141855960,
 1205,
 -63369,
 141910059,
 1189,
 -1,
 141989550,
 1237,
 142149916,
 131351658,
 -1,
 142215448,
 142119681,
 -1,
 142280848,
 142172272,
 -1,
 142346375,
 142226786,
 -1,
 142411910,
 142305986,
 -1,
 142477441,
 142353728,
 -1,
 -63361,
 142450054,
 1286,
 -63360,
 142505227,
 1282,
 -1,
 142552785,
 1280,
 -63358,
 142450054,
 1284,
 -63357,
 142673188,
 1294,
 -63356,
 142772218,
 1292,
 -63355,
 142834512,
 1290,
 -1,
 142887593,
 1288,
 -1,
 142388152,
 1152,
 143132813,
 142281340,
 1050,
 143261695,
 143076804,
 -1,
 -63350,
 143139300,
 1180,
 -63349,
 143227257,
 1182,
 -63348,
 143305559,
 1219,
 -1,
 143363173,
 1178,
 -63346,
 143090962,
 1134,
 -63345,
 143488267,
 1036,
 -1,
 143546245,
 1227,
 143722656,
 142225105,
 1069,
 143788182,
 143686658,
 1053,
 143917055,
 143732164,
 -1,
 -63340,
 143802019,
 1225,
 -63339,
 143895383,
 1223,
 -1,
 143952997,
 1186,
 144115864,
 143739671,
 1057,
 -1,
 144095274,
 1194,
 144246938,
 144054027,
 1056,
 -1,
 144189659,
 1166,
 144378012,
 144208644,
 1052,
 -1,
 144331670,
 1229,
 144509086,
 144337501,
 1051,
 -1,
 144462742,
 1221,
 -63329,
 144455551,
 1060,
 -1,
 144613668,
 1260,
 144771248,
 143675275,
 1048,
 144836774,
 144717154,
 1025,
 144965631,
 144770970,
 -1,
 -63324,
 144848723,
 1128,
 -63323,
 144912081,
 1124,
 -1,
 145004810,
 1132,
 145164458,
 144781009,
 1045,
 145293311,
 145108420,
 -1,
 -63319,
 145203520,
 1024,
 -1,
 145249192,
 1238,
 145426606,
 145108420,
 -1,
 -63316,
 145359055,
 1250,
 -63315,
 145465664,
 1037,
 -1,
 145500420,
 1252,
 145752063,
 145400270,
 1140,
 -1,
 145625199,
 1142,
 145819839,
 144722711,
 -1,
 145885369,
 145766777,
 -1,
 145950902,
 145841714,
 -1,
 146016437,
 145903499,
 1049,
 -1,
 145970070,
 1162,
 -1,
 145995960,
 1038,
 -63305,
 145893276,
 1210,
 -63304,
 146148784,
 1065,
 -1,
 146213500,
 1064,
 146409659,
 145856608,
 1198,
 -1,
 146383271,
 1200,
 146540733,
 146347447,
 1240,
 -1,
 146514212,
 1242,
 -63298,
 146501990,
 1068,
 -1,
 146627611,
 1164,
 146802890,
 145763447,
 -1,
 146868422,
 146745256,
 1046,
 146997247,
 146812356,
 -1,
 146999493,
 146875712,
 -1,
 -63292,
 146948653,
 1244,
 -1,
 147006369,
 1174,
 -1,
 146953128,
 1217,
 147324927,
 146812625,
 1047,
 147390463,
 147207551,
 -1,
 -63287,
 147276333,
 1246,
 -1,
 147334049,
 1176,
 147523795,
 146737788,
 1040,
 147589328,
 147501080,
 -1,
 147654862,
 147525060,
 1212,
 -1,
 147634218,
 1214,
 -63281,
 147597212,
 1192,
 -1,
 147747931,
 1248,
 147980287,
 147533252,
 -1,
 -63278,
 147859716,
 1234,
 -1,
 147936168,
 1232,
 148113626,
 147464916,
 -1,
 148179158,
 148060257,
 1067,
 -1,
 148152612,
 1272,
 148310232,
 148114044,
 1071,
 -1,
 148287426,
 1122,
 -63271,
 148289720,
 1070,
 -1,
 148393867,
 1031,
 148572386,
 148093112,
 1059,
 148637920,
 148516292,
 -1,
 148703455,
 148579648,
 -1,
 -63266,
 148669816,
 1266,
 -1,
 148718125,
 1264,
 -1,
 148635855,
 1262,
 149028863,
 148594800,
 1144,
 -1,
 148917378,
 1028,
 149096682,
 148520773,
 -1,
 149162217,
 149039016,
 1043,
 149291007,
 149106116,
 -1,
 -63258,
 149179621,
 1168,
 -63257,
 149256569,
 1170,
 -63256,
 149325856,
 1172,
 -1,
 149392485,
 1270,
 -1,
 149124363,
 1027,
 149620978,
 149033841,
 -1,
 149686511,
 149555836,
 -1,
 149752046,
 149649064,
 1256,
 -1,
 149725476,
 1258,
 -1,
 149695653,
 1184,
 -63248,
 149661839,
 1030,
 -63247,
 149914800,
 1130,
 -1,
 149958353,
 1041,
 150145271,
 149566818,
 1054,
 150210805,
 150077611,
 1120,
 -1,
 150186940,
 1148,
 -63242,
 150187970,
 1150,
 -1,
 150315300,
 1254,
 150472957,
 150122434,
 -1,
 150538491,
 150424343,
 -1,
 -63238,
 150480808,
 1035,
 -1,
 150548177,
 1062,
 150798335,
 150482641,
 1058,
 -1,
 150714410,
 1196,
 150866179,
 150414656,
 -1,
 150931713,
 150809719,
 -1,
 -63232,
 150874024,
 1039,
 -1,
 150941393,
 1029,
 -63230,
 150893835,
 1026,
 -1,
 151072465,
 1044,
 151259401,
 150801860,
 1063,
 151388159,
 151203268,
 -1,
 151390472,
 151266624,
 -1,
 -63225,
 151339565,
 1268,
 -1,
 151397281,
 1206,
 -1,
 151331300,
 1208,
 151652621,
 151227596,
 -1,
 151718156,
 151596753,
 1055,
 -1,
 151663532,
 1190,
 -1,
 151676178,
 1136,
 151914768,
 151594908,
 1061,
 -63217,
 151847308,
 1066,
 -1,
 151959594,
 1202,
 152111379,
 151874141,
 -1,
 -63214,
 152073483,
 1033,
 -1,
 152134517,
 1126,
 -63212,
 152052317,
 1042,
 -63211,
 152270094,
 1146,
 -63210,
 152337232,
 1034,
 -63209,
 152401163,
 1032,
 -1,
 152466955,
 1138,
 152698879,
 142188502,
 -1,
 -63206,
 152603864,
 1204,
 -63205,
 152657963,
 1188,
 -1,
 152737454,
 1236,
 152897823,
 142114508,
 -1,
 -63202,
 152849188,
 7467,
 -1,
 152926293,
 1216,
 -1,
 152836483,
 1154,
 153160036,
 131286175,
 -1,
 153225511,
 153137090,
 -1,
 -63197,
 153204920,
 67633,
 -63196,
 153236834,
 67632,
 -63195,
 153309067,
 67631,
 -63194,
 153366225,
 67630,
 -1,
 153422460,
 67629,
 153618733,
 153176855,
 -1,
 -63191,
 153598136,
 67628,
 -63190,
 153630050,
 67627,
 -63189,
 153702283,
 67626,
 -63188,
 153759441,
 67625,
 -1,
 153815676,
 67624,
 154011955,
 153556747,
 -1,
 -63185,
 153991352,
 67623,
 -63184,
 154023266,
 67622,
 -63183,
 154095499,
 67621,
 -63182,
 154152657,
 67620,
 -1,
 154208892,
 67619,
 154405177,
 153980108,
 -1,
 -63179,
 154384568,
 67618,
 -63178,
 154416482,
 67617,
 -63177,
 154488715,
 67616,
 -63176,
 154545873,
 67615,
 -1,
 154602108,
 67614,
 154798399,
 154369026,
 -1,
 -63173,
 154777784,
 67613,
 -63172,
 154809698,
 67612,
 -63171,
 154881931,
 67611,
 -63170,
 154939089,
 67610,
 -1,
 154995324,
 67609,
 155191621,
 154759940,
 -1,
 -63167,
 155171000,
 67608,
 -63166,
 155202914,
 67607,
 -63165,
 155275147,
 67606,
 -63164,
 155332305,
 67605,
 -1,
 155388540,
 67604,
 155584843,
 155150941,
 -1,
 -63161,
 155564216,
 67603,
 -63160,
 155596130,
 67602,
 -63159,
 155668363,
 67601,
 -63158,
 155725521,
 67600,
 -1,
 155781756,
 67599,
 155978065,
 155541616,
 -1,
 -63155,
 155957432,
 67598,
 -63154,
 155989346,
 67597,
 -63153,
 156061579,
 67596,
 -63152,
 156118737,
 67595,
 -1,
 156174972,
 67594,
 156371286,
 155914552,
 -1,
 -63149,
 156317026,
 67637,
 -63148,
 156389259,
 67636,
 -63147,
 156446417,
 67635,
 -1,
 156502652,
 67634,
 156698969,
 156314743,
 -1,
 -63144,
 156644706,
 67647,
 -1,
 156699260,
 67644,
 156895580,
 156637627,
 -1,
 -63141,
 156839633,
 67640,
 -1,
 156895868,
 67639,
 157092191,
 156850172,
 -1,
 -63138,
 157037922,
 67592,
 -1,
 157092476,
 67589,
 -63136,
 157071544,
 67588,
 -63135,
 157234530,
 67587,
 -63134,
 157306763,
 67586,
 -63133,
 157363921,
 67585,
 -1,
 157420156,
 67584,
 -1,
 153131056,
 9005,
 157682471,
 131216738,
 -1,
 157747801,
 157643524,
 -1,
 157813328,
 157703530,
 -1,
 157878677,
 157772381,
 -1,
 157944183,
 157854312,
 -1,
 -63125,
 157882811,
 879,
 -63124,
 157943835,
 878,
 -63123,
 158054584,
 871,
 -63122,
 158117826,
 877,
 -63121,
 158144267,
 876,
 -63120,
 158217570,
 870,
 -63119,
 158298884,
 875,
 -63118,
 158355339,
 869,
 -63117,
 158415225,
 874,
 -63116,
 158478033,
 868,
 -63115,
 158541120,
 873,
 -63114,
 158604341,
 872,
 -1,
 158665340,
 867,
 158861706,
 157918907,
 -1,
 158927241,
 158817479,
 -1,
 158992768,
 158861948,
 -1,
 159058301,
 158967049,
 -1,
 -63108,
 159017710,
 852,
 -1,
 159071211,
 8406,
 159318015,
 158992323,
 -1,
 -63105,
 159195826,
 841,
 -1,
 159290248,
 794,
 159451525,
 158934940,
 -1,
 159517060,
 159426879,
 -1,
 -63101,
 159457970,
 796,
 -1,
 159552392,
 849,
 -1,
 159458490,
 8400,
 159779208,
 159406124,
 -1,
 -63097,
 159720114,
 845,
 -1,
 159814536,
 8417,
 -1,
 159727986,
 792,
 -1,
 158904476,
 8426,
 160106898,
 158807394,
 -1,
 160172433,
 160066908,
 -1,
 160237967,
 160123671,
 -1,
 -63090,
 160170127,
 822,
 -1,
 160266443,
 824,
 -63088,
 160190926,
 8402,
 -1,
 160406271,
 8427,
 -1,
 160108340,
 818,
 160694271,
 160079830,
 -1,
 -63084,
 160575117,
 65057,
 -1,
 160630402,
 65056,
 160827832,
 157820224,
 -1,
 160893366,
 160773474,
 -1,
 160958893,
 160846766,
 -1,
 161024413,
 160902855,
 -1,
 161089948,
 160995206,
 -1,
 -63077,
 161030834,
 840,
 -1,
 161125256,
 782,
 -1,
 161052371,
 8422,
 161352097,
 160991008,
 864,
 161480703,
 161307847,
 -1,
 -63072,
 161361549,
 65059,
 -1,
 161416834,
 65058,
 161614244,
 161299448,
 -1,
 -63069,
 161570522,
 858,
 -1,
 161618576,
 866,
 161810854,
 161546447,
 862,
 -1,
 161749975,
 863,
 161941928,
 161764264,
 861,
 -1,
 161881047,
 860,
 -63063,
 161916107,
 831,
 -63062,
 162010005,
 819,
 -63061,
 162114405,
 865,
 -63060,
 162140750,
 783,
 -1,
 162241862,
 779,
 162400693,
 160935874,
 -1,
 162466226,
 162356423,
 -1,
 162531761,
 162435976,
 775,
 -1,
 162479921,
 856,
 -1,
 162472626,
 803,
 162791423,
 162444821,
 -1,
 -63052,
 162665038,
 7616,
 -1,
 162766150,
 7617,
 -1,
 162367415,
 798,
 163053567,
 160842285,
 776,
 -1,
 162929623,
 804,
 163121615,
 160767029,
 -1,
 163187137,
 163100191,
 -1,
 163252669,
 163155148,
 -1,
 -63044,
 163231692,
 1158,
 -1,
 163276982,
 1156,
 -63042,
 163227651,
 1155,
 -63041,
 163403510,
 1161,
 -63040,
 163459963,
 1160,
 -1,
 163545912,
 1157,
 163711429,
 163150454,
 -1,
 163776964,
 163681160,
 787,
 -1,
 163725105,
 789,
 -1,
 163717810,
 806,
 163973577,
 163646076,
 -1,
 164039112,
 163950981,
 780,
 -1,
 163978199,
 812,
 -1,
 163984980,
 784,
 164235724,
 163922850,
 -1,
 -63029,
 164195628,
 8409,
 -1,
 164264372,
 8405,
 164432334,
 164184599,
 770,
 -1,
 164371415,
 813,
 -1,
 164394810,
 807,
 164628968,
 163059467,
 -1,
 164694499,
 164581259,
 -1,
 164760031,
 164669296,
 -1,
 164825561,
 164736964,
 -1,
 164891096,
 164762038,
 -1,
 164956631,
 164825724,
 -1,
 -63018,
 164899718,
 854,
 -1,
 164965117,
 848,
 -1,
 164897458,
 853,
 -1,
 164838379,
 8407,
 165284318,
 164767644,
 -1,
 165349853,
 165259583,
 -1,
 -63012,
 165290674,
 825,
 -1,
 165385096,
 855,
 -1,
 165291194,
 8401,
 -1,
 165233010,
 793,
 165740543,
 164719964,
 -1,
 -63007,
 165629099,
 8408,
 -63006,
 165683890,
 805,
 -1,
 165778312,
 778,
 166002687,
 164638417,
 -1,
 166005223,
 165908138,
 -1,
 -63002,
 165972198,
 788,
 -1,
 166005223,
 8421,
 -1,
 165953575,
 802,
 166267385,
 164563382,
 -1,
 166332915,
 166215604,
 -1,
 166398447,
 166298845,
 -1,
 166463982,
 166375362,
 -1,
 -62995,
 166438719,
 119362,
 -1,
 166476751,
 119363,
 -1,
 166402058,
 119364,
 -62992,
 166330811,
 837,
 -62991,
 166678978,
 834,
 -62990,
 166747394,
 835,
 -1,
 166819958,
 836,
 167051263,
 166267516,
 -1,
 167053816,
 166945710,
 -1,
 167119351,
 166998832,
 768,
 -1,
 167058391,
 790,
 -1,
 167089667,
 832,
 -1,
 167009008,
 847,
 167381508,
 166211281,
 -1,
 167447043,
 167336884,
 -1,
 167512574,
 167398167,
 -1,
 -62979,
 167466468,
 8414,
 -1,
 167547826,
 8418,
 167709184,
 167475009,
 8413,
 -1,
 167668614,
 8416,
 -62975,
 167649590,
 8420,
 -62974,
 167816502,
 8419,
 -1,
 167851983,
 8415,
 -1,
 167410466,
 839,
 168102416,
 167316092,
 -1,
 168167946,
 168066050,
 -1,
 168233481,
 168141149,
 -1,
 -62968,
 168193324,
 8410,
 -1,
 168262068,
 8404,
 -1,
 168172830,
 8423,
 168495630,
 168129439,
 -1,
 168561165,
 168440624,
 769,
 -1,
 168500183,
 791,
 -1,
 168531459,
 833,
 -62961,
 168441916,
 857,
 -1,
 168708198,
 844,
 168888858,
 168053527,
 -1,
 168954390,
 168855493,
 -1,
 169019925,
 168905495,
 -1,
 -62956,
 168951951,
 821,
 -1,
 169048267,
 823,
 -1,
 168972750,
 8403,
 -62953,
 168906940,
 7619,
 -62952,
 169256544,
 827,
 -62951,
 169309790,
 7618,
 -1,
 169372134,
 828,
 169544226,
 168865730,
 -1,
 169609759,
 169489965,
 771,
 169738239,
 169565383,
 -1,
 -62946,
 169626795,
 820,
 -1,
 169681586,
 816,
 -62944,
 169550688,
 786,
 -62943,
 169815161,
 8424,
 -1,
 169908570,
 8411,
 170068520,
 169491818,
 -1,
 170134055,
 170030991,
 -1,
 170199590,
 170066728,
 785,
 -1,
 170138583,
 815,
 -1,
 170168086,
 826,
 -1,
 170088956,
 811,
 170461742,
 170030991,
 -1,
 170527276,
 170434649,
 -1,
 -62933,
 170468018,
 810,
 -1,
 170562440,
 838,
 170786815,
 170459944,
 774,
 -1,
 170662871,
 814,
 170854963,
 170405575,
 -1,
 170920498,
 170825606,
 -1,
 -62927,
 170861234,
 809,
 -1,
 170955656,
 781,
 -1,
 170886944,
 830,
 171182647,
 170816260,
 -1,
 171248182,
 171153880,
 772,
 -1,
 171187159,
 817,
 -1,
 171186316,
 800,
 171444795,
 171124584,
 -1,
 -62919,
 171391986,
 795,
 -62918,
 171450739,
 777,
 -1,
 171542657,
 843,
 171706942,
 171405033,
 -1,
 -62915,
 171647666,
 851,
 -1,
 171742088,
 829,
 171903553,
 171676879,
 -1,
 -62912,
 171844244,
 846,
 -1,
 171937009,
 797,
 172100164,
 171871436,
 -1,
 -62909,
 172051082,
 799,
 -1,
 172130577,
 801,
 172296775,
 172045666,
 -1,
 -62906,
 172251531,
 773,
 -1,
 172300137,
 808,
 172493386,
 172258493,
 -1,
 -62903,
 172430757,
 12441,
 -1,
 172499516,
 12442,
 172689997,
 172439423,
 -1,
 -62900,
 172651449,
 8412,
 -1,
 172717438,
 850,
 -62898,
 172658487,
 859,
 -62897,
 172845823,
 8425,
 -1,
 172888699,
 842,
 173083221,
 157774596,
 -1,
 173148756,
 173034503,
 -1,
 -62893,
 173081805,
 8274,
 -1,
 173181462,
 64,
 -1,
 173083260,
 44,
 173410904,
 173051084,
 -1,
 -62889,
 173359380,
 9092,
 -1,
 173416628,
 8705,
 -1,
 173370689,
 9732,
 173673230,
 157715660,
 -1,
 173738765,
 173642757,
 -1,
 173804213,
 173689623,
 -1,
 173869739,
 173775351,
 -1,
 173935220,
 173815138,
 11423,
 174000755,
 173886079,
 -1,
 174066285,
 173952664,
 -1,
 174131813,
 174012793,
 -1,
 174197347,
 174066300,
 11471,
 -1,
 174174146,
 11477,
 -62876,
 174131427,
 11469,
 -1,
 174288053,
 11475,
 174459496,
 174089493,
 -1,
 -62873,
 174408164,
 11483,
 -1,
 174484661,
 11461,
 -62871,
 174438783,
 11455,
 -62870,
 174627178,
 11479,
 -62869,
 174665645,
 11463,
 -62868,
 174743003,
 11481,
 -1,
 174804579,
 11445,
 175046655,
 174029673,
 -1,
 175049329,
 174947330,
 -1,
 -62864,
 175019117,
 11489,
 -1,
 175047088,
 11487,
 -62862,
 175000863,
 11491,
 -1,
 175178923,
 11485,
 -1,
 173965815,
 11441,
 175442556,
 173876544,
 -1,
 175508090,
 175376190,
 -1,
 -62857,
 175462207,
 11451,
 -62856,
 175545782,
 11449,
 -62855,
 175611245,
 11467,
 -1,
 175647064,
 11443,
 -62853,
 175467701,
 1007,
 -1,
 175803472,
 11399,
 175966851,
 175393559,
 -1,
 176032384,
 175913337,
 -1,
 -62849,
 175981028,
 1005,
 -1,
 176057525,
 995,
 -62847,
 175997431,
 11403,
 -62846,
 176177636,
 11429,
 -1,
 176236917,
 11457,
 176425609,
 175923312,
 -1,
 176491143,
 176372089,
 -1,
 -62842,
 176443275,
 11437,
 -1,
 176516277,
 999,
 -62840,
 176448786,
 11421,
 -1,
 176623346,
 11413,
 176818830,
 176357485,
 -1,
 176884365,
 176760106,
 -1,
 -62836,
 176838463,
 11453,
 -1,
 176913713,
 11447,
 -1,
 176822231,
 11459,
 177146513,
 176795586,
 -1,
 -62832,
 177112090,
 11409,
 -1,
 177179155,
 11431,
 177343124,
 177114316,
 -1,
 -62829,
 177300754,
 11439,
 -1,
 177360779,
 11425,
 177539735,
 177302109,
 -1,
 -62826,
 177488253,
 11415,
 -1,
 177542599,
 11473,
 177736346,
 177486201,
 -1,
 -62823,
 177670371,
 1001,
 -1,
 177750145,
 11407,
 177932957,
 177668508,
 -1,
 -62820,
 177899601,
 1003,
 -1,
 177944669,
 11397,
 178129568,
 177878911,
 -1,
 -62817,
 178081675,
 11435,
 -1,
 178154677,
 997,
 178326179,
 178063996,
 -1,
 -62814,
 178283316,
 11393,
 -1,
 178363324,
 11465,
 -62812,
 178278504,
 11405,
 -62811,
 178481544,
 11395,
 -62810,
 178566049,
 11433,
 -62809,
 178600949,
 11427,
 -62808,
 178673471,
 11419,
 -62807,
 178730447,
 11417,
 -62806,
 178799764,
 11411,
 -1,
 178879793,
 11401,
 179109887,
 173824173,
 -1,
 179112623,
 178998039,
 -1,
 -62802,
 179087209,
 11495,
 -1,
 179124969,
 11498,
 179309234,
 179069040,
 -1,
 -62799,
 179256414,
 11497,
 -1,
 179328193,
 11492,
 -62797,
 179280930,
 11496,
 -62796,
 179448078,
 11494,
 -1,
 179510017,
 11493,
 179702532,
 173748718,
 -1,
 179768013,
 179647842,
 11422,
 179833548,
 179718783,
 -1,
 179899078,
 179785368,
 -1,
 179964606,
 179845497,
 -1,
 180030140,
 179899004,
 11470,
 -1,
 180006850,
 11476,
 -62787,
 179964131,
 11468,
 -1,
 180120757,
 11474,
 180292289,
 179922197,
 -1,
 -62784,
 180240868,
 11482,
 -1,
 180317365,
 11460,
 -62782,
 180271487,
 11454,
 -62781,
 180459882,
 11478,
 -62780,
 180498349,
 11462,
 -62779,
 180575707,
 11480,
 -1,
 180637283,
 11444,
 180879359,
 179862377,
 -1,
 180882122,
 180780034,
 -1,
 -62775,
 180851821,
 11488,
 -1,
 180879792,
 11486,
 -62773,
 180833567,
 11490,
 -1,
 181011627,
 11484,
 -1,
 179798519,
 11440,
 181275349,
 179709248,
 -1,
 181340883,
 181208894,
 -1,
 -62768,
 181294911,
 11450,
 -62767,
 181378486,
 11448,
 -62766,
 181443949,
 11466,
 -1,
 181479768,
 11442,
 -62764,
 181300405,
 1006,
 -1,
 181636176,
 11398,
 181799644,
 181226263,
 -1,
 181865177,
 181746041,
 -1,
 -62760,
 181813732,
 1004,
 -1,
 181890229,
 994,
 -62758,
 181830135,
 11402,
 -62757,
 182010340,
 11428,
 -1,
 182069621,
 11456,
 182258402,
 181756016,
 -1,
 182323936,
 182204793,
 -1,
 -62753,
 182275979,
 11436,
 -1,
 182348981,
 998,
 -62751,
 182281490,
 11420,
 -1,
 182456050,
 11412,
 182651623,
 182190189,
 -1,
 182717158,
 182592810,
 -1,
 -62747,
 182671167,
 11452,
 -1,
 182746417,
 11446,
 -1,
 182654935,
 11458,
 182979306,
 182628290,
 -1,
 -62743,
 182944794,
 11408,
 -1,
 183011859,
 11430,
 183175917,
 182947020,
 -1,
 -62740,
 183133458,
 11438,
 -1,
 183193483,
 11424,
 183372528,
 183134813,
 -1,
 -62737,
 183320957,
 11414,
 -1,
 183375303,
 11472,
 183569139,
 183318905,
 -1,
 -62734,
 183503075,
 1000,
 -1,
 183582849,
 11406,
 183765750,
 183501212,
 -1,
 -62731,
 183732305,
 1002,
 -1,
 183777373,
 11396,
 183962361,
 183711615,
 -1,
 -62728,
 183914379,
 11434,
 -1,
 183987381,
 996,
 184158972,
 183896700,
 -1,
 -62725,
 184116020,
 11392,
 -1,
 184196028,
 11464,
 -62723,
 184111208,
 11404,
 -62722,
 184314248,
 11394,
 -62721,
 184398753,
 11432,
 -62720,
 184433653,
 11426,
 -62719,
 184506175,
 11418,
 -62718,
 184563151,
 11416,
 -62717,
 184632468,
 11410,
 -1,
 184712497,
 11400,
 184879881,
 179674714,
 -1,
 -62714,
 184834864,
 11516,
 -62713,
 184888388,
 11515,
 -62712,
 184959479,
 11513,
 -1,
 185036466,
 11514,
 185207564,
 184825727,
 -1,
 -62709,
 185147249,
 11518,
 -1,
 185247402,
 11517,
 -1,
 185148342,
 11519,
 -1,
 173676277,
 169,
 185535262,
 173636610,
 -1,
 185600795,
 185511874,
 -1,
 185666329,
 185540503,
 -1,
 185731861,
 185604668,
 -1,
 -62701,
 185675753,
 8955,
 -62700,
 185742244,
 8957,
 -1,
 185797130,
 8954,
 186056703,
 185704118,
 -1,
 186059544,
 185948728,
 8883,
 -1,
 186016860,
 8885,
 -1,
 185993004,
 8715,
 -62694,
 185639117,
 8750,
 -1,
 186232527,
 9089,
 -62692,
 185575386,
 9740,
 -62691,
 186326570,
 9010,
 -1,
 186387282,
 10861,
 186583842,
 185481218,
 58,
 186712063,
 186539207,
 -1,
 -62687,
 186587546,
 8353,
 -1,
 186683499,
 8788,
 186845989,
 186529511,
 -1,
 -62684,
 186806669,
 9013,
 -1,
 186887827,
 9012,
 -62682,
 186809680,
 8792,
 -1,
 186998988,
 9904,
 187174029,
 157634524,
 -1,
 187239562,
 187107781,
 -1,
 187305081,
 187188673,
 -1,
 187370339,
 187263581,
 -1,
 187435874,
 187307317,
 -1,
 187501383,
 187378594,
 -1,
 -62674,
 187444343,
 9449,
 -62673,
 187507412,
 9448,
 -62672,
 187570619,
 9447,
 -62671,
 187633976,
 9446,
 -62670,
 187697179,
 9445,
 -62669,
 187807928,
 9444,
 -62668,
 187871170,
 9443,
 -62667,
 187910935,
 9442,
 -62666,
 187963147,
 9441,
 -62665,
 188061217,
 9440,
 -62664,
 188124364,
 9439,
 -62663,
 188167522,
 9438,
 -62662,
 188251138,
 9437,
 -62661,
 188314372,
 9436,
 -62660,
 188377693,
 9435,
 -62659,
 188440688,
 9434,
 -62658,
 188504060,
 9433,
 -62657,
 188567435,
 9432,
 -62656,
 188627321,
 9431,
 -62655,
 188694341,
 9430,
 -62654,
 188757887,
 9429,
 -62653,
 188821201,
 9428,
 -62652,
 188884288,
 9427,
 -62651,
 188947509,
 9426,
 -62650,
 189010801,
 9425,
 -1,
 189074044,
 9424,
 189333503,
 187445742,
 -1,
 -62647,
 189213815,
 9423,
 -62646,
 189276884,
 9422,
 -62645,
 189340091,
 9421,
 -62644,
 189403448,
 9420,
 -62643,
 189466651,
 9419,
 -62642,
 189577400,
 9418,
 -62641,
 189640642,
 9417,
 -62640,
 189680407,
 9416,
 -62639,
 189732619,
 9415,
 -62638,
 189830689,
 9414,
 -62637,
 189893836,
 9413,
 -62636,
 189936994,
 9412,
 -62635,
 190020610,
 9411,
 -62634,
 190083844,
 9410,
 -62633,
 190147165,
 9409,
 -62632,
 190210160,
 9408,
 -62631,
 190273532,
 9407,
 -62630,
 190336907,
 9406,
 -62629,
 190396793,
 9405,
 -62628,
 190463813,
 9404,
 -62627,
 190527359,
 9403,
 -62626,
 190590673,
 9402,
 -62625,
 190653760,
 9401,
 -62624,
 190716981,
 9400,
 -62623,
 190780273,
 9399,
 -1,
 190843516,
 9398,
 -1,
 187399892,
 10688,
 191105952,
 187326576,
 -1,
 191171485,
 191074656,
 -1,
 191236971,
 191147970,
 -1,
 -62617,
 191215800,
 13025,
 -62616,
 191247714,
 13027,
 -62615,
 191319947,
 13024,
 -62614,
 191377105,
 13026,
 -1,
 191433340,
 13023,
 191630193,
 191187735,
 -1,
 -62611,
 191609016,
 13020,
 -62610,
 191640930,
 13022,
 -62609,
 191713163,
 13019,
 -62608,
 191770321,
 13021,
 -1,
 191826556,
 13018,
 192023415,
 191567627,
 -1,
 -62605,
 192002232,
 13048,
 -62604,
 192034146,
 13050,
 -62603,
 192106379,
 13047,
 -62602,
 192163537,
 13049,
 -1,
 192219772,
 13046,
 192416637,
 191986690,
 -1,
 -62599,
 192395448,
 13030,
 -62598,
 192427362,
 13032,
 -62597,
 192499595,
 13029,
 -62596,
 192556753,
 13031,
 -1,
 192612988,
 13028,
 192809859,
 192377604,
 -1,
 -62593,
 192788664,
 13040,
 -62592,
 192820578,
 13042,
 -62591,
 192892811,
 13039,
 -62590,
 192949969,
 13041,
 -1,
 193006204,
 13038,
 193203081,
 192766064,
 -1,
 -62587,
 193181880,
 13015,
 -62586,
 193213794,
 13017,
 -62585,
 193286027,
 13014,
 -62584,
 193343185,
 13016,
 -1,
 193399420,
 13013,
 193596303,
 193149305,
 -1,
 -62581,
 193575096,
 13035,
 -62580,
 193607010,
 13037,
 -62579,
 193679243,
 13034,
 -62578,
 193736401,
 13036,
 -1,
 193792636,
 13033,
 193989524,
 193532216,
 -1,
 -62575,
 193934690,
 13054,
 -62574,
 194006923,
 13052,
 -62573,
 194064081,
 13053,
 -1,
 194120316,
 13051,
 194317208,
 193929940,
 -1,
 -62570,
 194295992,
 13044,
 -62569,
 194327906,
 13045,
 -1,
 194382460,
 13043,
 -62567,
 194295992,
 13010,
 -62566,
 194524514,
 13012,
 -62565,
 194596747,
 13009,
 -62564,
 194653905,
 13011,
 -1,
 194710140,
 13008,
 194969599,
 191117990,
 -1,
 -62561,
 194856739,
 12925,
 -1,
 194944595,
 12924,
 195103719,
 191057110,
 -1,
 195169199,
 195054359,
 -1,
 195234726,
 195147960,
 -1,
 -62556,
 195213498,
 12972,
 -62555,
 195263490,
 12944,
 -1,
 195312806,
 12956,
 195496873,
 195211202,
 -1,
 -62552,
 195455010,
 12971,
 -1,
 195533492,
 12945,
 195693484,
 195440337,
 -1,
 -62549,
 195650635,
 12934,
 -1,
 195695003,
 12953,
 -62547,
 195668336,
 12949,
 -62546,
 195851446,
 12947,
 -1,
 195907423,
 12933,
 196086710,
 195114879,
 -1,
 196152244,
 196038539,
 -1,
 -62542,
 196092509,
 12932,
 -62541,
 196164578,
 12939,
 -1,
 196226514,
 12950,
 -62539,
 196109236,
 12931,
 -1,
 196381147,
 12955,
 196545469,
 196024075,
 -1,
 196611004,
 196488913,
 -1,
 196676539,
 196561687,
 -1,
 -62534,
 196652994,
 12961,
 -1,
 196710415,
 12974,
 -1,
 196647823,
 12970,
 -1,
 196580877,
 12968,
 197004227,
 196506372,
 -1,
 197069761,
 196947665,
 -1,
 -62528,
 197025078,
 12942,
 -1,
 197079764,
 12969,
 -62526,
 197048675,
 12938,
 -1,
 197235693,
 12954,
 197397448,
 196947665,
 -1,
 -62523,
 197370139,
 12957,
 -62522,
 197414828,
 12973,
 -62521,
 197498381,
 12935,
 -1,
 197527405,
 12943,
 197725134,
 197336117,
 -1,
 197790669,
 197670242,
 -1,
 -62517,
 197731809,
 12963,
 -62516,
 197830099,
 12962,
 -1,
 197898207,
 12951,
 -1,
 197753651,
 12965,
 198118354,
 197701570,
 -1,
 -62512,
 198067820,
 12929,
 -62511,
 198132655,
 12930,
 -1,
 198208690,
 12937,
 198380503,
 198081538,
 -1,
 198446038,
 198332299,
 -1,
 -62507,
 198399857,
 12936,
 -1,
 198469733,
 12976,
 -1,
 198411106,
 12948,
 198708187,
 198339165,
 -1,
 -62503,
 198672876,
 12966,
 -62502,
 198747835,
 12967,
 -1,
 198806517,
 12952,
 198970334,
 198644024,
 -1,
 -62499,
 198949142,
 12941,
 -1,
 198969366,
 12940,
 199166945,
 198916473,
 -1,
 -62496,
 199135522,
 12964,
 -1,
 199174673,
 12946,
 199363556,
 199101052,
 -1,
 -62493,
 199299556,
 12959,
 -1,
 199373775,
 12975,
 -62491,
 199328474,
 12958,
 -62490,
 199494184,
 12928,
 -1,
 199599316,
 12960,
 199756837,
 195057649,
 -1,
 199822346,
 199733186,
 -1,
 199887865,
 199771686,
 -1,
 199953400,
 199855201,
 9331,
 200081407,
 199908551,
 -1,
 200084463,
 199995330,
 -1,
 -62482,
 200033900,
 12882,
 -1,
 200098735,
 12883,
 200281074,
 200035095,
 -1,
 -62479,
 200232799,
 12886,
 -1,
 200280133,
 12887,
 200477685,
 200226687,
 -1,
 -62476,
 200434612,
 12884,
 -1,
 200508604,
 12885,
 -62474,
 200411688,
 12881,
 -62473,
 200648214,
 12889,
 -1,
 200687339,
 12888,
 -1,
 199917211,
 9323,
 200936457,
 199854170,
 -1,
 201001992,
 200876756,
 12890,
 201129983,
 200957127,
 -1,
 201133055,
 201043906,
 -1,
 -62466,
 201082476,
 12892,
 -1,
 201147311,
 12893,
 201329666,
 201083671,
 -1,
 -62463,
 201281375,
 12977,
 -1,
 201328709,
 12978,
 201526277,
 201275263,
 -1,
 -62460,
 201483188,
 12894,
 -1,
 201557180,
 12895,
 -62458,
 201460264,
 12891,
 -62457,
 201696790,
 12980,
 -1,
 201735915,
 12979,
 -1,
 200978667,
 9324,
 -1,
 200895666,
 9321,
 202050590,
 199767935,
 -1,
 202116123,
 201995618,
 -1,
 202181658,
 202063646,
 12981,
 202309631,
 202136775,
 -1,
 202312721,
 202223554,
 -1,
 -62448,
 202262124,
 12983,
 -1,
 202326959,
 12984,
 202509332,
 202263319,
 -1,
 -62445,
 202461023,
 12987,
 -1,
 202508357,
 12988,
 202705943,
 202454911,
 -1,
 -62442,
 202662836,
 12985,
 -1,
 202736828,
 12986,
 -62440,
 202639912,
 12982,
 -62439,
 202876438,
 12990,
 -1,
 202915563,
 12989,
 -1,
 202149665,
 9325,
 203227135,
 202087088,
 -1,
 -62435,
 203104980,
 12991,
 -1,
 203206891,
 9326,
 203361313,
 202001175,
 -1,
 -62432,
 203338563,
 9327,
 -1,
 203387141,
 9328,
 203557924,
 203304657,
 -1,
 -62429,
 203507647,
 9322,
 -1,
 203597550,
 9329,
 -1,
 203529692,
 9330,
 203820107,
 199702905,
 -1,
 203885641,
 203798400,
 -1,
 203951148,
 203861954,
 -1,
 204016682,
 203886112,
 12898,
 -1,
 203983814,
 12912,
 204210175,
 203950142,
 12907,
 -1,
 204114886,
 12921,
 204278833,
 203918540,
 -1,
 204344367,
 204225207,
 12901,
 -1,
 204311494,
 12915,
 204537855,
 204291199,
 12908,
 -1,
 204442566,
 12922,
 204606518,
 204234864,
 -1,
 204672052,
 204539634,
 12896,
 -1,
 204639174,
 12910,
 204865535,
 204642211,
 12906,
 -1,
 204770246,
 12920,
 204934203,
 204545077,
 -1,
 204999737,
 204880487,
 12904,
 -1,
 204966854,
 12918,
 205193215,
 204944285,
 12905,
 -1,
 205097926,
 12919,
 205261887,
 204879410,
 12903,
 205389823,
 205216967,
 -1,
 -62402,
 205306040,
 12926,
 -1,
 205326972,
 12917,
 205524033,
 205226293,
 12902,
 -1,
 205491142,
 12916,
 205655107,
 205459190,
 12899,
 -1,
 205622214,
 12913,
 205786181,
 205631272,
 12897,
 -1,
 205753286,
 12911,
 205917255,
 205725711,
 12900,
 -1,
 205884358,
 12914,
 206110719,
 205849924,
 12909,
 -1,
 206015430,
 12923,
 -62390,
 203821343,
 9097,
 -1,
 206117968,
 10162,
 206310496,
 203760960,
 -1,
 206376030,
 206262155,
 -1,
 206441563,
 206315474,
 -1,
 206507089,
 206417858,
 -1,
 -62384,
 206456428,
 9313,
 -1,
 206521263,
 9314,
 206703700,
 206457623,
 -1,
 -62381,
 206655327,
 9317,
 -1,
 206702661,
 9318,
 206900311,
 206649215,
 -1,
 -62378,
 206857140,
 9315,
 -1,
 206931132,
 9316,
 -62376,
 206839734,
 9450,
 -62375,
 207030824,
 9312,
 -62374,
 207136278,
 9320,
 -1,
 207175403,
 9319,
 207421439,
 206408815,
 -1,
 -62371,
 207290651,
 8856,
 -1,
 207393022,
 10808,
 -62369,
 206327323,
 8857,
 -1,
 207520821,
 8861,
 207686757,
 206277836,
 -1,
 -62366,
 207636367,
 12342,
 -62365,
 207711793,
 8853,
 -62364,
 207796451,
 10681,
 -1,
 207841027,
 10679,
 208014440,
 207652972,
 -1,
 -62361,
 207985336,
 10026,
 -1,
 208041670,
 10686,
 208211051,
 207990722,
 -1,
 -62358,
 208176737,
 9098,
 -1,
 208231176,
 8855,
 208407662,
 208148235,
 -1,
 -62355,
 208385788,
 8858,
 -1,
 208437434,
 10680,
 208604273,
 208368388,
 -1,
 -62352,
 208550378,
 10806,
 -1,
 208615445,
 8854,
 208800884,
 208538236,
 -1,
 -62349,
 208733836,
 8859,
 -1,
 208804644,
 10684,
 -62347,
 208764285,
 10678,
 -62346,
 208965674,
 10050,
 -62345,
 209031628,
 10689,
 -62344,
 209096811,
 8860,
 -1,
 209155782,
 10687,
 209387519,
 187260103,
 -1,
 209390729,
 209263164,
 -1,
 209456254,
 209364988,
 -1,
 -62339,
 209408657,
 9684,
 -1,
 209485047,
 9683,
 209652865,
 209406743,
 -1,
 -62336,
 209618642,
 10683,
 -1,
 209677227,
 10690,
 209849476,
 209611357,
 -1,
 -62333,
 209807002,
 9682,
 -1,
 209873419,
 9680,
 -62331,
 209796030,
 9677,
 -62330,
 210002525,
 10691,
 -62329,
 210078239,
 9681,
 -62328,
 210155725,
 10677,
 -1,
 210199764,
 9685,
 -1,
 209368031,
 10682,
 210501631,
 187218104,
 -1,
 -62324,
 210396944,
 94,
 -1,
 210457921,
 10768,
 210636020,
 187119993,
 -1,
 210701554,
 210579153,
 -1,
 210767089,
 210645357,
 -1,
 210832546,
 210743234,
 -1,
 210898072,
 210782999,
 -1,
 -62317,
 210831387,
 5096,
 -62316,
 210942136,
 5095,
 -62315,
 210974050,
 5094,
 -62314,
 211046283,
 5093,
 -62313,
 211103441,
 5092,
 -1,
 211159676,
 5091,
 211356831,
 210856541,
 -1,
 -62310,
 211290139,
 5090,
 -62309,
 211400888,
 5089,
 -62308,
 211432802,
 5088,
 -62307,
 211505035,
 5087,
 -62306,
 211562193,
 5086,
 -1,
 211618428,
 5085,
 -62304,
 211308427,
 5080,
 -62303,
 211758801,
 5078,
 -1,
 211815036,
 5076,
 212012201,
 210782999,
 5069,
 -62300,
 211945499,
 5074,
 -62299,
 212056248,
 5073,
 -62298,
 212088162,
 5072,
 -62297,
 212160395,
 5071,
 -62296,
 212217553,
 5070,
 -1,
 212273788,
 5068,
 212470961,
 211975170,
 -1,
 212536492,
 212404860,
 5054,
 -1,
 212482425,
 5056,
 -62291,
 212469787,
 5061,
 -62290,
 212646072,
 5060,
 -62289,
 212677986,
 5059,
 -62288,
 212750219,
 5058,
 -1,
 212807377,
 5057,
 212995257,
 212416889,
 -1,
 -62285,
 212928539,
 5042,
 -62284,
 213039288,
 5041,
 -62283,
 213071202,
 5040,
 -62282,
 213157786,
 5055,
 -62281,
 213208971,
 5039,
 -62280,
 213266129,
 5038,
 -1,
 213322364,
 5037,
 213519553,
 212936000,
 -1,
 -62277,
 213452827,
 5083,
 -62276,
 213563576,
 5082,
 -62275,
 213595490,
 5081,
 -62274,
 213649882,
 5084,
 -62273,
 213733259,
 5079,
 -62272,
 213790417,
 5077,
 -1,
 213846652,
 5075,
 214043848,
 213459668,
 -1,
 -62269,
 213977115,
 5108,
 -62268,
 214087864,
 5107,
 -62267,
 214119778,
 5106,
 -62266,
 214192011,
 5105,
 -62265,
 214249169,
 5104,
 -1,
 214305404,
 5103,
 214502607,
 213979448,
 -1,
 -62262,
 214435867,
 5102,
 -62261,
 214546616,
 5101,
 -62260,
 214578530,
 5100,
 -62259,
 214650763,
 5099,
 -62258,
 214707921,
 5098,
 -1,
 214764156,
 5097,
 214961366,
 214439582,
 -1,
 -62255,
 214894619,
 5067,
 -62254,
 215005368,
 5066,
 -62253,
 215037282,
 5065,
 -62252,
 215109515,
 5064,
 -62251,
 215166673,
 5063,
 -1,
 215222908,
 5062,
 215420125,
 214919773,
 -1,
 -62248,
 215353371,
 5048,
 -62247,
 215464120,
 5047,
 -62246,
 215496034,
 5046,
 -62245,
 215568267,
 5045,
 -62244,
 215625425,
 5044,
 -1,
 215681660,
 5043,
 215878884,
 215367493,
 -1,
 -62241,
 215812123,
 5036,
 -62240,
 215922872,
 5035,
 -62239,
 215954786,
 5034,
 -62238,
 216027019,
 5033,
 -62237,
 216084177,
 5032,
 -1,
 216140412,
 5030,
 216337642,
 215839492,
 -1,
 -62234,
 216316088,
 5053,
 -62233,
 216348002,
 5052,
 -62232,
 216420235,
 5051,
 -62231,
 216477393,
 5050,
 -1,
 216533628,
 5049,
 -62229,
 216270875,
 5029,
 -62228,
 216709304,
 5028,
 -62227,
 216741218,
 5027,
 -62226,
 216833805,
 5031,
 -62225,
 216878987,
 5026,
 -62224,
 216936145,
 5025,
 -1,
 216992380,
 5024,
 -1,
 210711079,
 10003,
 -62221,
 210647712,
 9767,
 -1,
 217222653,
 8256,
 217386251,
 210594397,
 -1,
 217451786,
 217331042,
 -1,
 217517313,
 217408855,
 -1,
 217582848,
 217466305,
 -1,
 217648381,
 217539830,
 -1,
 217713915,
 217599617,
 10960,
 -1,
 217670748,
 10962,
 217907199,
 217690244,
 10959,
 -1,
 217801820,
 10961,
 217976063,
 217626234,
 10828,
 -1,
 217944935,
 10832,
 -1,
 217937438,
 10829,
 -1,
 217560771,
 8272,
 218238217,
 217475814,
 -1,
 218303749,
 218176565,
 -1,
 -62204,
 218261500,
 8754,
 -1,
 218327862,
 10561,
 -62202,
 218260526,
 8631,
 -62201,
 218463292,
 8635,
 -62200,
 218540407,
 8753,
 -1,
 218569245,
 10227,
 -1,
 218215315,
 9729,
 -1,
 217397650,
 9114,
 218893589,
 217364664,
 -1,
 218959124,
 218830603,
 -1,
 219024658,
 218922838,
 -1,
 219090193,
 218972802,
 -1,
 -62192,
 219054608,
 8910,
 -1,
 219118051,
 8911,
 -1,
 219045778,
 9130,
 -62189,
 218991168,
 10081,
 -1,
 219296309,
 164,
 -1,
 218897344,
 8731,
 219548960,
 218836689,
 -1,
 219614493,
 219502507,
 -1,
 219680028,
 219560930,
 -1,
 219745563,
 219649926,
 -1,
 -62182,
 219718859,
 65098,
 -1,
 219747221,
 65102,
 -1,
 219717541,
 8452,
 -1,
 219629654,
 162,
 220135423,
 219562888,
 -1,
 -62177,
 220049936,
 184,
 -1,
 220088406,
 8373,
 220332031,
 219485963,
 -1,
 220335398,
 220246452,
 -1,
 220400933,
 220288278,
 -1,
 -62172,
 220363896,
 9768,
 -1,
 220416139,
 9769,
 -1,
 220368044,
 9876,
 -1,
 220275027,
 8354,
 220730808,
 29444,
 -1,
 220795351,
 220662396,
 -1,
 220860769,
 220727257,
 -1,
 220925641,
 220810007,
 -1,
 220991133,
 220896205,
 -1,
 221056546,
 220941327,
 -1,
 221121953,
 221004600,
 -1,
 221187427,
 221092744,
 -1,
 221252915,
 221154508,
 120421,
 -62159,
 221209874,
 120769,
 -62158,
 221269899,
 120761,
 -1,
 221325157,
 120767,
 221515062,
 221228994,
 120425,
 -62155,
 221459742,
 120753,
 -1,
 221547027,
 120765,
 221711674,
 221459810,
 120420,
 221839359,
 221672196,
 -1,
 -62151,
 221710269,
 120760,
 -1,
 221812780,
 120770,
 221973821,
 221654737,
 120410,
 -62148,
 221940142,
 120752,
 -1,
 221992792,
 120750,
 222170431,
 221916279,
 120431,
 -1,
 222109222,
 120751,
 222301505,
 222108091,
 120429,
 -1,
 222252939,
 120759,
 222432579,
 222279864,
 120426,
 -1,
 222386008,
 120766,
 222563653,
 222382871,
 120424,
 -1,
 222517271,
 120764,
 222694727,
 222500619,
 120423,
 -1,
 222635880,
 120762,
 222825801,
 222657538,
 120419,
 -1,
 222804152,
 120758,
 222956875,
 222786308,
 120418,
 -1,
 222935224,
 120757,
 223087949,
 222915165,
 120417,
 -1,
 223036718,
 120756,
 223219023,
 223043696,
 120416,
 -1,
 223178621,
 120755,
 223350097,
 223170443,
 120414,
 -1,
 223310747,
 120754,
 223481171,
 223297349,
 120412,
 -1,
 223453800,
 120748,
 223612245,
 223426431,
 120411,
 -1,
 223561978,
 120763,
 223743319,
 223552832,
 120409,
 -1,
 223720522,
 120749,
 223874393,
 223681589,
 120408,
 -1,
 223815525,
 120768,
 224005467,
 223810417,
 120407,
 -1,
 223944230,
 120747,
 224136541,
 223939196,
 120406,
 -1,
 224085135,
 120746,
 -62114,
 224076500,
 120430,
 -62113,
 224203064,
 120428,
 -62112,
 224266267,
 120427,
 -62111,
 224368161,
 120422,
 -62110,
 224417788,
 120415,
 -1,
 224475513,
 120413,
 224660888,
 221161986,
 -1,
 224726376,
 224636866,
 120399,
 224791911,
 224671006,
 120727,
 -1,
 224766162,
 120737,
 -1,
 224758291,
 120739,
 224988524,
 224693452,
 120395,
 -62102,
 224945426,
 120743,
 -62101,
 225005451,
 120735,
 -1,
 225060709,
 120741,
 225250672,
 224933218,
 120394,
 225378303,
 225211140,
 -1,
 -62097,
 225249213,
 120734,
 -1,
 225351724,
 120744,
 225512819,
 225193681,
 120384,
 -62094,
 225479086,
 120726,
 -1,
 225531736,
 120724,
 225709429,
 225455223,
 120405,
 -1,
 225648166,
 120725,
 225840503,
 225647035,
 120403,
 -1,
 225791883,
 120733,
 225971577,
 225818808,
 120400,
 -1,
 225924952,
 120740,
 226102651,
 225921815,
 120398,
 -1,
 226056215,
 120738,
 226233725,
 226039563,
 120397,
 -1,
 226174824,
 120736,
 226364799,
 226196482,
 120393,
 -1,
 226343096,
 120732,
 226495873,
 226325252,
 120392,
 -1,
 226474168,
 120731,
 226626947,
 226454109,
 120391,
 -1,
 226575662,
 120730,
 226758021,
 226582640,
 120390,
 -1,
 226717565,
 120729,
 226889095,
 226709387,
 120388,
 -1,
 226849691,
 120728,
 227020169,
 226836293,
 120386,
 -1,
 226992744,
 120722,
 227151243,
 226960704,
 120383,
 -1,
 227128394,
 120723,
 227282317,
 227089461,
 120382,
 -1,
 227223397,
 120742,
 227413391,
 227218289,
 120381,
 -1,
 227352102,
 120721,
 227544465,
 227347068,
 120380,
 -1,
 227493007,
 120720,
 -62062,
 227484372,
 120404,
 -62061,
 227610936,
 120402,
 -62060,
 227674139,
 120401,
 -62059,
 227776033,
 120396,
 -62058,
 227825660,
 120389,
 -62057,
 227883385,
 120387,
 -1,
 227948415,
 120385,
 228134300,
 224627916,
 -1,
 -62054,
 228105770,
 120777,
 -62053,
 228139712,
 120775,
 -1,
 228216844,
 120771,
 -62051,
 228095988,
 120773,
 -62050,
 228343565,
 120776,
 -62049,
 228435272,
 120745,
 -62048,
 228459381,
 120774,
 -1,
 228570142,
 120772,
 228724182,
 221092744,
 -1,
 228789670,
 228691148,
 120317,
 -62044,
 228746514,
 120711,
 -62043,
 228806539,
 120703,
 -1,
 228861797,
 120709,
 229051817,
 228765634,
 120321,
 -62040,
 228996382,
 120695,
 -1,
 229083667,
 120707,
 229248429,
 228996450,
 120316,
 229375999,
 229208836,
 -1,
 -62036,
 229246909,
 120702,
 -1,
 229349420,
 120712,
 229510576,
 229191377,
 120306,
 -62033,
 229476782,
 120694,
 -1,
 229529432,
 120692,
 229707186,
 229452919,
 120327,
 -1,
 229645862,
 120693,
 229838260,
 229644731,
 120325,
 -1,
 229789579,
 120701,
 229969334,
 229816504,
 120322,
 -1,
 229922648,
 120708,
 230100408,
 229919511,
 120320,
 -1,
 230053911,
 120706,
 230231482,
 230037259,
 120319,
 -1,
 230172520,
 120704,
 230362556,
 230194178,
 120315,
 -1,
 230340792,
 120700,
 230493630,
 230322948,
 120314,
 -1,
 230471864,
 120699,
 230624704,
 230451805,
 120313,
 -1,
 230573358,
 120698,
 230755778,
 230580336,
 120312,
 -1,
 230715261,
 120697,
 230886852,
 230707083,
 120310,
 -1,
 230847387,
 120696,
 231017926,
 230833989,
 120308,
 -1,
 230990440,
 120690,
 231149000,
 230963071,
 120307,
 -1,
 231098618,
 120705,
 231280074,
 231089472,
 120305,
 -1,
 231257162,
 120691,
 231411148,
 231218229,
 120304,
 -1,
 231352165,
 120710,
 231542222,
 231347057,
 120303,
 -1,
 231480870,
 120689,
 231673296,
 231475836,
 120302,
 -1,
 231621775,
 120688,
 -61999,
 231613140,
 120326,
 -61998,
 231739704,
 120324,
 -61997,
 231802907,
 120323,
 -61996,
 231904801,
 120318,
 -61995,
 231954428,
 120311,
 -1,
 232012153,
 120309,
 232197643,
 228698626,
 -1,
 232263131,
 232173506,
 120295,
 232328666,
 232207646,
 120669,
 -1,
 232302802,
 120679,
 -1,
 232294931,
 120681,
 232525279,
 232230092,
 120291,
 -61987,
 232482066,
 120685,
 -61986,
 232542091,
 120677,
 -1,
 232597349,
 120683,
 232787427,
 232469858,
 120290,
 232914943,
 232747780,
 -1,
 -61982,
 232785853,
 120676,
 -1,
 232888364,
 120686,
 233049574,
 232730321,
 120280,
 -61979,
 233015726,
 120668,
 -1,
 233068376,
 120666,
 233246184,
 232991863,
 120301,
 -1,
 233184806,
 120667,
 233377258,
 233183675,
 120299,
 -1,
 233328523,
 120675,
 233508332,
 233355448,
 120296,
 -1,
 233461592,
 120682,
 233639406,
 233458455,
 120294,
 -1,
 233592855,
 120680,
 233770480,
 233576203,
 120293,
 -1,
 233711464,
 120678,
 233901554,
 233733122,
 120289,
 -1,
 233879736,
 120674,
 234032628,
 233861892,
 120288,
 -1,
 234010808,
 120673,
 234163702,
 233990749,
 120287,
 -1,
 234112302,
 120672,
 234294776,
 234119280,
 120286,
 -1,
 234254205,
 120671,
 234425850,
 234246027,
 120284,
 -1,
 234386331,
 120670,
 234556924,
 234372933,
 120282,
 -1,
 234529384,
 120664,
 234687998,
 234497344,
 120279,
 -1,
 234665034,
 120665,
 234819072,
 234626101,
 120278,
 -1,
 234760037,
 120684,
 234950146,
 234754929,
 120277,
 -1,
 234888742,
 120663,
 235081220,
 234883708,
 120276,
 -1,
 235029647,
 120662,
 -61947,
 235021012,
 120300,
 -61946,
 235147576,
 120298,
 -61945,
 235210779,
 120297,
 -61944,
 235312673,
 120292,
 -61943,
 235362300,
 120285,
 -61942,
 235420025,
 120283,
 -1,
 235485055,
 120281,
 235671065,
 232170595,
 -1,
 235736591,
 235646914,
 -1,
 -61938,
 235685484,
 120814,
 -1,
 235750319,
 120815,
 235933202,
 235686679,
 -1,
 -61935,
 235884383,
 120818,
 -1,
 235931717,
 120819,
 236129813,
 235878271,
 -1,
 -61932,
 236086196,
 120816,
 -1,
 236160188,
 120817,
 -61930,
 236068790,
 120812,
 -61929,
 236259880,
 120813,
 -61928,
 236365334,
 120821,
 -1,
 236404459,
 120820,
 236588573,
 235637964,
 -1,
 -61925,
 236559914,
 120719,
 -61924,
 236593856,
 120717,
 -1,
 236670988,
 120713,
 -61922,
 236550132,
 120715,
 -61921,
 236797709,
 120718,
 -61920,
 236889416,
 120687,
 -61919,
 236913525,
 120716,
 -1,
 237024286,
 120714,
 237178457,
 221004600,
 -1,
 237243966,
 237149064,
 -1,
 -61915,
 237186167,
 120379,
 -61914,
 237249236,
 120378,
 -61913,
 237312443,
 120377,
 -61912,
 237375800,
 120376,
 -61911,
 237439003,
 120375,
 -61910,
 237549752,
 120374,
 -61909,
 237612994,
 120373,
 -61908,
 237652759,
 120372,
 -61907,
 237704971,
 120371,
 -61906,
 237803041,
 120370,
 -61905,
 237866188,
 120369,
 -61904,
 237909346,
 120368,
 -61903,
 237992962,
 120367,
 -61902,
 238056196,
 120366,
 -61901,
 238119517,
 120365,
 -61900,
 238182512,
 120364,
 -61899,
 238245884,
 120363,
 -61898,
 238309259,
 120362,
 -61897,
 238369145,
 120361,
 -61896,
 238436165,
 120360,
 -61895,
 238499711,
 120359,
 -61894,
 238563025,
 120358,
 -61893,
 238626112,
 120357,
 -61892,
 238689333,
 120356,
 -61891,
 238752625,
 120355,
 -1,
 238815868,
 120354,
 239075327,
 237218306,
 -1,
 -61888,
 238955639,
 120353,
 -61887,
 239018708,
 120352,
 -61886,
 239081915,
 120351,
 -61885,
 239145272,
 120350,
 -61884,
 239208475,
 120349,
 -61883,
 239319224,
 120348,
 -61882,
 239382466,
 120347,
 -61881,
 239422231,
 120346,
 -61880,
 239474443,
 120345,
 -61879,
 239572513,
 120344,
 -61878,
 239635660,
 120343,
 -61877,
 239678818,
 120342,
 -61876,
 239762434,
 120341,
 -61875,
 239825668,
 120340,
 -61874,
 239888989,
 120339,
 -61873,
 239951984,
 120338,
 -61872,
 240015356,
 120337,
 -61871,
 240078731,
 120336,
 -61870,
 240138617,
 120335,
 -61869,
 240205637,
 120334,
 -61868,
 240269183,
 120333,
 -61867,
 240332497,
 120332,
 -61866,
 240395584,
 120331,
 -61865,
 240458805,
 120330,
 -61864,
 240522097,
 120329,
 -1,
 240585340,
 120328,
 240782964,
 237149064,
 -1,
 -61861,
 240725111,
 120275,
 -61860,
 240788180,
 120274,
 -61859,
 240851387,
 120273,
 -61858,
 240914744,
 120272,
 -61857,
 240977947,
 120271,
 -61856,
 241088696,
 120270,
 -61855,
 241151938,
 120269,
 -61854,
 241191703,
 120268,
 -61853,
 241243915,
 120267,
 -61852,
 241341985,
 120266,
 -61851,
 241405132,
 120265,
 -61850,
 241448290,
 120264,
 -61849,
 241531906,
 120263,
 -61848,
 241595140,
 120262,
 -61847,
 241658461,
 120261,
 -61846,
 241721456,
 120260,
 -61845,
 241784828,
 120259,
 -61844,
 241848203,
 120258,
 -61843,
 241908089,
 120257,
 -61842,
 241975109,
 120256,
 -61841,
 242038655,
 120255,
 -61840,
 242101969,
 120254,
 -61839,
 242165056,
 120253,
 -61838,
 242228277,
 120252,
 -61837,
 242291569,
 120251,
 -1,
 242354812,
 120250,
 242552463,
 240757250,
 -1,
 -61834,
 242494583,
 120249,
 -61833,
 242557652,
 120248,
 -61832,
 242620859,
 120247,
 -61831,
 242684216,
 120246,
 -61830,
 242747419,
 120245,
 -61829,
 242858168,
 120244,
 -61828,
 242921410,
 120243,
 -61827,
 242961175,
 120242,
 -61826,
 243013387,
 120241,
 -61825,
 243111457,
 120240,
 -61824,
 243174604,
 120239,
 -61823,
 243217762,
 120238,
 -61822,
 243301378,
 120237,
 -61821,
 243364612,
 120236,
 -61820,
 243427933,
 120235,
 -61819,
 243490928,
 120234,
 -61818,
 243554300,
 120233,
 -61817,
 243617675,
 120232,
 -61816,
 243677561,
 120231,
 -61815,
 243744581,
 120230,
 -61814,
 243808127,
 120229,
 -61813,
 243871441,
 120228,
 -61812,
 243934528,
 120227,
 -61811,
 243997749,
 120226,
 -61810,
 244061041,
 120225,
 -1,
 244124284,
 120224,
 244383743,
 242525283,
 -1,
 244387475,
 244297666,
 -1,
 -61806,
 244336236,
 120804,
 -1,
 244401071,
 120805,
 244584086,
 244337431,
 -1,
 -61803,
 244535135,
 120808,
 -1,
 244582469,
 120809,
 244780697,
 244529023,
 -1,
 -61800,
 244736948,
 120806,
 -1,
 244810940,
 120807,
 -61798,
 244719542,
 120802,
 -61797,
 244910632,
 120803,
 -61796,
 245016086,
 120811,
 -1,
 245055211,
 120810,
 245301247,
 220935655,
 -1,
 245305014,
 245209992,
 -1,
 -61792,
 245247095,
 120015,
 -61791,
 245310164,
 120014,
 -61790,
 245373371,
 120013,
 -61789,
 245436728,
 120012,
 -61788,
 245499931,
 120011,
 -61787,
 245610680,
 120010,
 -61786,
 245673922,
 120009,
 -61785,
 245713687,
 120008,
 -61784,
 245765899,
 120007,
 -61783,
 245863969,
 120006,
 -61782,
 245927116,
 120005,
 -61781,
 245988354,
 120003,
 -61780,
 246051588,
 120002,
 -61779,
 246114909,
 120001,
 -61778,
 246177904,
 120000,
 -61777,
 246241276,
 119999,
 -61776,
 246304651,
 119998,
 -61775,
 246364537,
 119997,
 -61774,
 246429567,
 119995,
 -61773,
 246490432,
 119993,
 -61772,
 246553653,
 119992,
 -61771,
 246616945,
 119991,
 -1,
 246680188,
 119990,
 246939647,
 245279234,
 -1,
 -61768,
 246819959,
 119989,
 -61767,
 246883028,
 119988,
 -61766,
 246946235,
 119987,
 -61765,
 247009592,
 119986,
 -61764,
 247072795,
 119985,
 -61763,
 247183544,
 119984,
 -61762,
 247246786,
 119983,
 -61761,
 247286551,
 119982,
 -61760,
 247371297,
 119980,
 -61759,
 247434444,
 119979,
 -61758,
 247477602,
 119978,
 -61757,
 247561218,
 119977,
 -61756,
 247619696,
 119974,
 -61755,
 247683068,
 119973,
 -61754,
 247742277,
 119970,
 -61753,
 247801152,
 119967,
 -61752,
 247864373,
 119966,
 -1,
 247925372,
 119964,
 248123438,
 220875791,
 -1,
 248188734,
 248070968,
 -1,
 248254208,
 248159112,
 -1,
 248319696,
 248220876,
 119953,
 -61746,
 248276242,
 120653,
 -61745,
 248336267,
 120645,
 -1,
 248391525,
 120651,
 248581843,
 248295362,
 119957,
 -61742,
 248526110,
 120637,
 -1,
 248613395,
 120649,
 248778455,
 248526178,
 119952,
 248905727,
 248738564,
 -1,
 -61738,
 248776637,
 120644,
 -1,
 248879148,
 120654,
 249040602,
 248721105,
 119942,
 -61735,
 249006510,
 120636,
 -1,
 249059160,
 120634,
 249237212,
 248982647,
 119963,
 -1,
 249175590,
 120635,
 249368286,
 249174459,
 119961,
 -1,
 249319307,
 120643,
 249499360,
 249346232,
 119958,
 -1,
 249452376,
 120650,
 249630434,
 249449239,
 119956,
 -1,
 249583639,
 120648,
 249761508,
 249566987,
 119955,
 -1,
 249702248,
 120646,
 249892582,
 249723906,
 119951,
 -1,
 249870520,
 120642,
 250023656,
 249852676,
 119950,
 -1,
 250001592,
 120641,
 250154730,
 249981533,
 119949,
 -1,
 250103086,
 120640,
 250285804,
 250110064,
 119948,
 -1,
 250244989,
 120639,
 250416878,
 250236811,
 119946,
 -1,
 250377115,
 120638,
 250547952,
 250363717,
 119944,
 -1,
 250520168,
 120632,
 250679026,
 250492799,
 119943,
 -1,
 250628346,
 120647,
 250810100,
 250619200,
 119941,
 -1,
 250786890,
 120633,
 250941174,
 250747957,
 119940,
 -1,
 250881893,
 120652,
 251072248,
 250876785,
 119939,
 -1,
 251010598,
 120631,
 251203322,
 251005564,
 119938,
 -1,
 251151503,
 120630,
 -61701,
 251142868,
 119962,
 -61700,
 251269432,
 119960,
 -61699,
 251332635,
 119959,
 -61698,
 251434529,
 119954,
 -61697,
 251484156,
 119947,
 -1,
 251541881,
 119945,
 251727669,
 248228354,
 -1,
 251793157,
 251703234,
 119931,
 251858692,
 251737374,
 120611,
 -1,
 251832530,
 120621,
 -1,
 251824659,
 120623,
 252055305,
 251759820,
 119927,
 -61689,
 252011794,
 120627,
 -61688,
 252071819,
 120619,
 -1,
 252127077,
 120625,
 252317453,
 251999586,
 119926,
 252444671,
 252277508,
 -1,
 -61684,
 252315581,
 120618,
 -1,
 252418092,
 120628,
 252579600,
 252260049,
 119916,
 -61681,
 252545454,
 120610,
 -1,
 252598104,
 120608,
 252776210,
 252521591,
 119937,
 -1,
 252714534,
 120609,
 252907284,
 252713403,
 119935,
 -1,
 252858251,
 120617,
 253038358,
 252885176,
 119932,
 -1,
 252991320,
 120624,
 253169432,
 252988183,
 119930,
 -1,
 253122583,
 120622,
 253300506,
 253105931,
 119929,
 -1,
 253241192,
 120620,
 253431580,
 253262850,
 119925,
 -1,
 253409464,
 120616,
 253562654,
 253391620,
 119924,
 -1,
 253540536,
 120615,
 253693728,
 253520477,
 119923,
 -1,
 253642030,
 120614,
 253824802,
 253649008,
 119922,
 -1,
 253783933,
 120613,
 253955876,
 253775755,
 119920,
 -1,
 253916059,
 120612,
 254086950,
 253902661,
 119918,
 -1,
 254059112,
 120606,
 254218024,
 254027072,
 119915,
 -1,
 254194762,
 120607,
 254349098,
 254155829,
 119914,
 -1,
 254289765,
 120626,
 254480172,
 254284657,
 119913,
 -1,
 254418470,
 120605,
 254611246,
 254413436,
 119912,
 -1,
 254559375,
 120604,
 -61649,
 254550740,
 119936,
 -61648,
 254677304,
 119934,
 -61647,
 254740507,
 119933,
 -61646,
 254842401,
 119928,
 -61645,
 254892028,
 119921,
 -61644,
 254949753,
 119919,
 -1,
 255014783,
 119917,
 255201081,
 251694284,
 -1,
 -61641,
 255172138,
 120661,
 -61640,
 255206080,
 120659,
 -1,
 255283212,
 120655,
 -61638,
 255162356,
 120657,
 -61637,
 255409933,
 120660,
 -61636,
 255501640,
 120629,
 -61635,
 255525749,
 120658,
 -1,
 255636510,
 120656,
 255791019,
 248138519,
 -1,
 255856502,
 255735271,
 -1,
 255922011,
 255826824,
 -1,
 -61630,
 255863927,
 120067,
 -61629,
 255926996,
 120066,
 -61628,
 255990203,
 120065,
 -61627,
 256053560,
 120064,
 -61626,
 256116763,
 120063,
 -61625,
 256227512,
 120062,
 -61624,
 256290754,
 120061,
 -61623,
 256330519,
 120060,
 -61622,
 256382731,
 120059,
 -61621,
 256480801,
 120058,
 -61620,
 256543948,
 120057,
 -61619,
 256587106,
 120056,
 -61618,
 256670722,
 120055,
 -61617,
 256733956,
 120054,
 -61616,
 256797277,
 120053,
 -61615,
 256860272,
 120052,
 -61614,
 256923644,
 120051,
 -61613,
 256987019,
 120050,
 -61612,
 257046905,
 120049,
 -61611,
 257113925,
 120048,
 -61610,
 257177471,
 120047,
 -61609,
 257240785,
 120046,
 -61608,
 257303872,
 120045,
 -61607,
 257367093,
 120044,
 -61606,
 257430385,
 120043,
 -1,
 257493628,
 120042,
 257753087,
 255896066,
 -1,
 -61603,
 257633399,
 120041,
 -61602,
 257696468,
 120040,
 -61601,
 257759675,
 120039,
 -61600,
 257823032,
 120038,
 -61599,
 257886235,
 120037,
 -61598,
 257996984,
 120036,
 -61597,
 258060226,
 120035,
 -61596,
 258099991,
 120034,
 -61595,
 258152203,
 120033,
 -61594,
 258250273,
 120032,
 -61593,
 258313420,
 120031,
 -61592,
 258356578,
 120030,
 -61591,
 258440194,
 120029,
 -61590,
 258503428,
 120028,
 -61589,
 258566749,
 120027,
 -61588,
 258629744,
 120026,
 -61587,
 258693116,
 120025,
 -61586,
 258756491,
 120024,
 -61585,
 258816377,
 120023,
 -61584,
 258883397,
 120022,
 -61583,
 258946943,
 120021,
 -61582,
 259010257,
 120020,
 -61581,
 259073344,
 120019,
 -61580,
 259136565,
 120018,
 -61579,
 259199857,
 120017,
 -1,
 259263100,
 120016,
 259522559,
 255809822,
 -1,
 259526523,
 259427532,
 119849,
 -61575,
 259482898,
 120537,
 -61574,
 259542923,
 120529,
 -1,
 259598181,
 120535,
 259788670,
 259502018,
 119853,
 -61571,
 259732766,
 120521,
 -1,
 259820051,
 120533,
 259985282,
 259732834,
 119848,
 260112383,
 259945220,
 -1,
 -61567,
 259983293,
 120528,
 -1,
 260085804,
 120538,
 260247429,
 259927761,
 119838,
 -61564,
 260213166,
 120520,
 -1,
 260265816,
 120518,
 260444039,
 260189303,
 119859,
 -1,
 260382246,
 120519,
 260575113,
 260381115,
 119857,
 -1,
 260525963,
 120527,
 260706187,
 260552888,
 119854,
 -1,
 260659032,
 120534,
 260837261,
 260655895,
 119852,
 -1,
 260790295,
 120532,
 260968335,
 260773643,
 119851,
 -1,
 260908904,
 120530,
 261099409,
 260930562,
 119847,
 -1,
 261077176,
 120526,
 261230483,
 261059332,
 119846,
 -1,
 261208248,
 120525,
 261361557,
 261188189,
 119845,
 -1,
 261309742,
 120524,
 261492631,
 261316720,
 119844,
 -1,
 261451645,
 120523,
 261623705,
 261443467,
 119842,
 -1,
 261583771,
 120522,
 261754779,
 261570373,
 119840,
 -1,
 261726824,
 120516,
 261885853,
 261699455,
 119839,
 -1,
 261835002,
 120531,
 262016927,
 261825856,
 119837,
 -1,
 261993546,
 120517,
 262148001,
 261954613,
 119836,
 -1,
 262088549,
 120536,
 262279075,
 262083441,
 119835,
 -1,
 262217254,
 120515,
 262410149,
 262212220,
 119834,
 -1,
 262358159,
 120514,
 -61530,
 262349524,
 119858,
 -61529,
 262476088,
 119856,
 -61528,
 262539291,
 119855,
 -61527,
 262641185,
 119850,
 -61526,
 262690812,
 119843,
 -1,
 262748537,
 119841,
 262934498,
 255763384,
 -1,
 263000007,
 262904712,
 -1,
 -61522,
 262941815,
 120223,
 -61521,
 263004884,
 120222,
 -61520,
 263068091,
 120221,
 -61519,
 263131448,
 120220,
 -61518,
 263194651,
 120219,
 -61517,
 263305400,
 120218,
 -61516,
 263368642,
 120217,
 -61515,
 263408407,
 120216,
 -61514,
 263460619,
 120215,
 -61513,
 263558689,
 120214,
 -61512,
 263621836,
 120213,
 -61511,
 263664994,
 120212,
 -61510,
 263748610,
 120211,
 -61509,
 263811844,
 120210,
 -61508,
 263875165,
 120209,
 -61507,
 263938160,
 120208,
 -61506,
 264001532,
 120207,
 -61505,
 264064907,
 120206,
 -61504,
 264124793,
 120205,
 -61503,
 264191813,
 120204,
 -61502,
 264255359,
 120203,
 -61501,
 264318673,
 120202,
 -61500,
 264381760,
 120201,
 -61499,
 264444981,
 120200,
 -61498,
 264508273,
 120199,
 -1,
 264571516,
 120198,
 264830975,
 262973954,
 -1,
 -61495,
 264711287,
 120197,
 -61494,
 264774356,
 120196,
 -61493,
 264837563,
 120195,
 -61492,
 264900920,
 120194,
 -61491,
 264964123,
 120193,
 -61490,
 265074872,
 120192,
 -61489,
 265138114,
 120191,
 -61488,
 265177879,
 120190,
 -61487,
 265230091,
 120189,
 -61486,
 265328161,
 120188,
 -61485,
 265391308,
 120187,
 -61484,
 265434466,
 120186,
 -61483,
 265518082,
 120185,
 -61482,
 265581316,
 120184,
 -61481,
 265644637,
 120183,
 -61480,
 265707632,
 120182,
 -61479,
 265771004,
 120181,
 -61478,
 265834379,
 120180,
 -61477,
 265894265,
 120179,
 -61476,
 265961285,
 120178,
 -61475,
 266024831,
 120177,
 -61474,
 266088145,
 120176,
 -61473,
 266151232,
 120175,
 -61472,
 266214453,
 120174,
 -61471,
 266277745,
 120173,
 -1,
 266340988,
 120172,
 266539031,
 262908418,
 -1,
 266604519,
 266514370,
 119827,
 266670054,
 266548510,
 120495,
 -1,
 266643666,
 120505,
 -1,
 266635795,
 120507,
 266866667,
 266570956,
 119823,
 -61463,
 266822930,
 120511,
 -61462,
 266882955,
 120503,
 -1,
 266938213,
 120509,
 267128815,
 266810722,
 119822,
 267255807,
 267088644,
 -1,
 -61458,
 267126717,
 120502,
 -1,
 267229228,
 120512,
 267390962,
 267071185,
 119812,
 -61455,
 267356590,
 120494,
 -1,
 267409240,
 120492,
 267587572,
 267332727,
 119833,
 -1,
 267525670,
 120493,
 267718646,
 267524539,
 119831,
 -1,
 267669387,
 120501,
 267849720,
 267696312,
 119828,
 -1,
 267802456,
 120508,
 267980794,
 267799319,
 119826,
 -1,
 267933719,
 120506,
 268111868,
 267917067,
 119825,
 -1,
 268052328,
 120504,
 268242942,
 268073986,
 119821,
 -1,
 268220600,
 120500,
 268374016,
 268202756,
 119820,
 -1,
 268351672,
 120499,
 268505090,
 268331613,
 119819,
 -1,
 268453166,
 120498,
 268636164,
 268460144,
 119818,
 -1,
 268595069,
 120497,
 268767238,
 268586891,
 119816,
 -1,
 268727195,
 120496,
 268898312,
 268713797,
 119814,
 -1,
 268870248,
 120490,
 269029386,
 268838208,
 119811,
 -1,
 269005898,
 120491,
 269160460,
 268966965,
 119810,
 -1,
 269100901,
 120510,
 269291534,
 269095793,
 119809,
 -1,
 269229606,
 120489,
 269422608,
 269224572,
 119808,
 -1,
 269370511,
 120488,
 -61423,
 269361876,
 119832,
 -61422,
 269488440,
 119830,
 -61421,
 269551643,
 119829,
 -61420,
 269653537,
 119824,
 -61419,
 269703164,
 119817,
 -61418,
 269760889,
 119815,
 -1,
 269825919,
 119813,
 270012453,
 266511459,
 -1,
 270077979,
 269987778,
 -1,
 -61414,
 270026348,
 120784,
 -1,
 270091183,
 120785,
 270274590,
 270027543,
 -1,
 -61411,
 270225247,
 120788,
 -1,
 270272581,
 120789,
 270471201,
 270219135,
 -1,
 -61408,
 270427060,
 120786,
 -1,
 270501052,
 120787,
 -61406,
 270409654,
 120782,
 -61405,
 270600744,
 120783,
 -61404,
 270706198,
 120791,
 -1,
 270745323,
 120790,
 270929961,
 269978828,
 -1,
 -61401,
 270900778,
 120545,
 -61400,
 270934720,
 120543,
 -1,
 271011852,
 120539,
 -61398,
 270890996,
 120541,
 -61397,
 271138573,
 120544,
 -61396,
 271230280,
 120513,
 -61395,
 271254389,
 120542,
 -1,
 271365150,
 120540,
 271519908,
 248070968,
 -1,
 271585382,
 271489928,
 -1,
 271650868,
 271551692,
 119901,
 -61390,
 271607058,
 120595,
 -61389,
 271667083,
 120587,
 -1,
 271722341,
 120593,
 271913017,
 271590720,
 119889,
 271978552,
 271872512,
 -1,
 -61385,
 271931388,
 120485,
 -1,
 271994763,
 120484,
 -1,
 271955018,
 120575,
 272240700,
 271888322,
 119905,
 -61381,
 272184606,
 120579,
 -1,
 272271891,
 120591,
 272437312,
 272184674,
 119900,
 272564223,
 272397060,
 -1,
 -61377,
 272435133,
 120586,
 -1,
 272537644,
 120596,
 272699459,
 272379601,
 119890,
 -61374,
 272665006,
 120578,
 -1,
 272717656,
 120576,
 272896069,
 272641143,
 119911,
 -1,
 272834086,
 120577,
 273027143,
 272832955,
 119909,
 -1,
 272977803,
 120585,
 273158217,
 273004728,
 119906,
 -1,
 273110872,
 120592,
 273289291,
 273107735,
 119904,
 -1,
 273242135,
 120590,
 273420365,
 273225483,
 119903,
 -1,
 273360744,
 120588,
 273551439,
 273382402,
 119899,
 -1,
 273529016,
 120584,
 273682513,
 273511172,
 119898,
 -1,
 273660088,
 120583,
 273813587,
 273640029,
 119897,
 -1,
 273761582,
 120582,
 273944661,
 273768560,
 119896,
 -1,
 273903485,
 120581,
 274075735,
 273895307,
 119894,
 -1,
 274035611,
 120580,
 274206809,
 274022213,
 119892,
 -1,
 274178664,
 120574,
 274337883,
 274151295,
 119891,
 -1,
 274286842,
 120589,
 274468957,
 274275381,
 119888,
 -1,
 274409317,
 120594,
 274600031,
 274404209,
 119887,
 -1,
 274538022,
 120573,
 274731105,
 274532988,
 119886,
 -1,
 274678927,
 120572,
 -61342,
 274670292,
 119910,
 -61341,
 274796856,
 119908,
 -61340,
 274860059,
 119907,
 -61339,
 274961953,
 119902,
 -1,
 275011580,
 119895,
 275189915,
 271559170,
 -1,
 275255403,
 275165122,
 119879,
 275320938,
 275199262,
 120553,
 -1,
 275294418,
 120563,
 -1,
 275286547,
 120565,
 275517551,
 275221708,
 119875,
 -61331,
 275473682,
 120569,
 -61330,
 275533707,
 120561,
 -1,
 275588965,
 120567,
 275779699,
 275461474,
 119874,
 275906559,
 275739396,
 -1,
 -61326,
 275777469,
 120560,
 -1,
 275879980,
 120570,
 276041846,
 275721937,
 119864,
 -61323,
 276007342,
 120552,
 -1,
 276059992,
 120550,
 276238456,
 275983479,
 119885,
 -1,
 276176422,
 120551,
 276369530,
 276175291,
 119883,
 -1,
 276320139,
 120559,
 276500604,
 276347064,
 119880,
 -1,
 276453208,
 120566,
 276631678,
 276450071,
 119878,
 -1,
 276584471,
 120564,
 276762752,
 276567819,
 119877,
 -1,
 276703080,
 120562,
 276893826,
 276724738,
 119873,
 -1,
 276871352,
 120558,
 277024900,
 276853508,
 119872,
 -1,
 277002424,
 120557,
 277155974,
 276982365,
 119871,
 -1,
 277103918,
 120556,
 277287048,
 277110896,
 119870,
 -1,
 277245821,
 120555,
 277418122,
 277237643,
 119868,
 -1,
 277377947,
 120554,
 277549196,
 277364549,
 119866,
 -1,
 277521000,
 120548,
 277680270,
 277488960,
 119863,
 -1,
 277656650,
 120549,
 277811344,
 277617717,
 119862,
 -1,
 277751653,
 120568,
 277942418,
 277746545,
 119861,
 -1,
 277880358,
 120547,
 278073492,
 277875324,
 119860,
 -1,
 278021263,
 120546,
 -61291,
 278012628,
 119884,
 -61290,
 278139192,
 119882,
 -61289,
 278202395,
 119881,
 -61288,
 278304289,
 119876,
 -61287,
 278353916,
 119869,
 -61286,
 278411641,
 119867,
 -1,
 278476671,
 119865,
 278663327,
 275156172,
 -1,
 -61283,
 278634026,
 120603,
 -61282,
 278667968,
 120601,
 -1,
 278745100,
 120597,
 -61280,
 278624244,
 120599,
 -61279,
 278871821,
 120602,
 -61278,
 278963528,
 120571,
 -61277,
 278987637,
 120600,
 -1,
 279098398,
 120598,
 279253225,
 271481024,
 -1,
 279318720,
 279223176,
 -1,
 -61273,
 279260279,
 120483,
 -61272,
 279323348,
 120482,
 -61271,
 279386555,
 120481,
 -61270,
 279449912,
 120480,
 -61269,
 279513115,
 120479,
 -61268,
 279623864,
 120478,
 -61267,
 279687106,
 120477,
 -61266,
 279726871,
 120476,
 -61265,
 279779083,
 120475,
 -61264,
 279877153,
 120474,
 -61263,
 279940300,
 120473,
 -61262,
 279983458,
 120472,
 -61261,
 280067074,
 120471,
 -61260,
 280130308,
 120470,
 -61259,
 280193629,
 120469,
 -61258,
 280256624,
 120468,
 -61257,
 280319996,
 120467,
 -61256,
 280383371,
 120466,
 -61255,
 280443257,
 120465,
 -61254,
 280510277,
 120464,
 -61253,
 280573823,
 120463,
 -61252,
 280637137,
 120462,
 -61251,
 280700224,
 120461,
 -61250,
 280763445,
 120460,
 -61249,
 280826737,
 120459,
 -1,
 280889980,
 120458,
 281088219,
 279292418,
 -1,
 -61246,
 281029751,
 120457,
 -61245,
 281092820,
 120456,
 -61244,
 281156027,
 120455,
 -61243,
 281219384,
 120454,
 -61242,
 281282587,
 120453,
 -61241,
 281393336,
 120452,
 -61240,
 281456578,
 120451,
 -61239,
 281496343,
 120450,
 -61238,
 281548555,
 120449,
 -61237,
 281646625,
 120448,
 -61236,
 281709772,
 120447,
 -61235,
 281752930,
 120446,
 -61234,
 281836546,
 120445,
 -61233,
 281899780,
 120444,
 -61232,
 281963101,
 120443,
 -61231,
 282026096,
 120442,
 -61230,
 282089468,
 120441,
 -61229,
 282152843,
 120440,
 -61228,
 282212729,
 120439,
 -61227,
 282279749,
 120438,
 -61226,
 282343295,
 120437,
 -61225,
 282406609,
 120436,
 -61224,
 282469696,
 120435,
 -61223,
 282532917,
 120434,
 -61222,
 282596209,
 120433,
 -1,
 282659452,
 120432,
 282918911,
 281060451,
 -1,
 282923231,
 282832834,
 -1,
 -61218,
 282871404,
 120824,
 -1,
 282936239,
 120825,
 283119842,
 282872599,
 -1,
 -61215,
 283070303,
 120828,
 -1,
 283117637,
 120829,
 283316453,
 283064191,
 -1,
 -61212,
 283272116,
 120826,
 -1,
 283346108,
 120827,
 -61210,
 283254710,
 120822,
 -61209,
 283445800,
 120823,
 -61208,
 283551254,
 120831,
 -1,
 283590379,
 120830,
 283775271,
 279230037,
 -1,
 283840773,
 283745160,
 -1,
 -61204,
 283782263,
 120171,
 -61203,
 283845332,
 120170,
 -61202,
 283908539,
 120169,
 -61201,
 283971896,
 120168,
 -61200,
 284035099,
 120167,
 -61199,
 284145848,
 120166,
 -61198,
 284209090,
 120165,
 -61197,
 284248855,
 120164,
 -61196,
 284301067,
 120163,
 -61195,
 284399137,
 120162,
 -61194,
 284462284,
 120161,
 -61193,
 284505442,
 120160,
 -61192,
 284589058,
 120159,
 -61191,
 284652292,
 120158,
 -61190,
 284715613,
 120157,
 -61189,
 284778608,
 120156,
 -61188,
 284841980,
 120155,
 -61187,
 284905355,
 120154,
 -61186,
 284965241,
 120153,
 -61185,
 285032261,
 120152,
 -61184,
 285095807,
 120151,
 -61183,
 285159121,
 120150,
 -61182,
 285222208,
 120149,
 -61181,
 285285429,
 120148,
 -61180,
 285348721,
 120147,
 -1,
 285411964,
 120146,
 285610265,
 283814402,
 -1,
 -61177,
 285549268,
 120144,
 -61176,
 285612475,
 120143,
 -61175,
 285675832,
 120142,
 -61174,
 285739035,
 120141,
 -61173,
 285849784,
 120140,
 -61172,
 285913026,
 120139,
 -61171,
 285952791,
 120138,
 -61170,
 286012770,
 120134,
 -61169,
 286094084,
 120132,
 -61168,
 286157405,
 120131,
 -61167,
 286220400,
 120130,
 -61166,
 286283772,
 120129,
 -61165,
 286347147,
 120128,
 -61164,
 286408517,
 120126,
 -61163,
 286472063,
 120125,
 -61162,
 286535377,
 120124,
 -61161,
 286598464,
 120123,
 -61160,
 286659441,
 120121,
 -1,
 286722684,
 120120,
 286982143,
 285582435,
 -1,
 286986525,
 286896066,
 -1,
 -61156,
 286934636,
 120794,
 -1,
 286999471,
 120795,
 287183136,
 286935831,
 -1,
 -61153,
 287133535,
 120798,
 -1,
 287180869,
 120799,
 287379747,
 287127423,
 -1,
 -61150,
 287335348,
 120796,
 -1,
 287409340,
 120797,
 -61148,
 287317942,
 120792,
 -61147,
 287509032,
 120793,
 -61146,
 287614486,
 120801,
 -1,
 287653611,
 120800,
 287838553,
 283747256,
 -1,
 287904067,
 287808392,
 -1,
 -61142,
 287845495,
 120119,
 -61141,
 287908564,
 120118,
 -61140,
 287971771,
 120117,
 -61139,
 288035128,
 120116,
 -61138,
 288098331,
 120115,
 -61137,
 288209080,
 120114,
 -61136,
 288272322,
 120113,
 -61135,
 288312087,
 120112,
 -61134,
 288364299,
 120111,
 -61133,
 288462369,
 120110,
 -61132,
 288525516,
 120109,
 -61131,
 288568674,
 120108,
 -61130,
 288652290,
 120107,
 -61129,
 288715524,
 120106,
 -61128,
 288778845,
 120105,
 -61127,
 288841840,
 120104,
 -61126,
 288905212,
 120103,
 -61125,
 288968587,
 120102,
 -61124,
 289028473,
 120101,
 -61123,
 289095493,
 120100,
 -61122,
 289159039,
 120099,
 -61121,
 289222353,
 120098,
 -61120,
 289285440,
 120097,
 -61119,
 289348661,
 120096,
 -61118,
 289411953,
 120095,
 -1,
 289475196,
 120094,
 289734655,
 287877634,
 -1,
 -61115,
 289612500,
 120092,
 -61114,
 289675707,
 120091,
 -61113,
 289739064,
 120090,
 -61112,
 289802267,
 120089,
 -61111,
 289913016,
 120088,
 -61110,
 289976258,
 120087,
 -61109,
 290016023,
 120086,
 -61108,
 290100769,
 120084,
 -61107,
 290163916,
 120083,
 -61106,
 290207074,
 120082,
 -61105,
 290290690,
 120081,
 -61104,
 290353924,
 120080,
 -61103,
 290417245,
 120079,
 -61102,
 290480240,
 120078,
 -61101,
 290543612,
 120077,
 -61100,
 290602821,
 120074,
 -61099,
 290666367,
 120073,
 -61098,
 290729681,
 120072,
 -61097,
 290792768,
 120071,
 -61096,
 290853745,
 120069,
 -1,
 290916988,
 120068,
 291115357,
 287805937,
 -1,
 -61093,
 291066742,
 10215,
 -61092,
 291140437,
 10219,
 -1,
 291179981,
 10217,
 291438591,
 291072082,
 -1,
 -61089,
 291328886,
 10214,
 -61088,
 291402581,
 10218,
 -1,
 291442125,
 10216,
 291639762,
 220818013,
 -1,
 291705291,
 291616269,
 -1,
 291770793,
 291667660,
 -1,
 291836267,
 291702811,
 -1,
 291901802,
 291798050,
 -1,
 291967336,
 291837707,
 3339,
 -1,
 291903243,
 3424,
 292159487,
 291924573,
 3340,
 -1,
 292055645,
 3425,
 -1,
 291834492,
 3381,
 292295025,
 291811266,
 -1,
 292360559,
 292270018,
 -1,
 -61074,
 292300700,
 3360,
 -1,
 292358780,
 3359,
 -61072,
 292300700,
 3365,
 -1,
 292489852,
 3364,
 292688246,
 292256770,
 -1,
 -61069,
 292655774,
 3358,
 -61068,
 292718490,
 3363,
 -61067,
 292749724,
 3353,
 -1,
 292817532,
 3368,
 293015932,
 292627776,
 -1,
 293081466,
 292955456,
 -1,
 -61063,
 293021596,
 3362,
 -1,
 293079676,
 3361,
 -61061,
 293021596,
 3367,
 -1,
 293210748,
 3366,
 293409152,
 292948604,
 3333,
 -61058,
 293386424,
 3348,
 -61057,
 293425035,
 3344,
 -1,
 293472892,
 3334,
 293671300,
 293358359,
 -1,
 -61054,
 293627203,
 3383,
 -61053,
 293676956,
 3382,
 -1,
 293735036,
 3384,
 293933449,
 293628509,
 -1,
 293998984,
 293890653,
 -1,
 -61049,
 293931482,
 3380,
 -1,
 293997180,
 3379,
 -1,
 293931644,
 3378,
 294261131,
 293910712,
 3337,
 -1,
 294238392,
 3338,
 294392206,
 294197003,
 -1,
 -61043,
 294365500,
 3377,
 -1,
 294390396,
 3376,
 294588817,
 294358220,
 -1,
 -61040,
 294528924,
 3371,
 -1,
 294587004,
 3370,
 294785427,
 294532450,
 3346,
 -1,
 294729058,
 3347,
 294916502,
 294740080,
 -1,
 -61035,
 294856604,
 3350,
 -1,
 294914684,
 3349,
 295113113,
 294868988,
 -1,
 -61032,
 295053212,
 3357,
 -1,
 295111292,
 3356,
 295309723,
 295063435,
 3335,
 -1,
 295260043,
 3336,
 295440798,
 295255877,
 -1,
 -61027,
 295380892,
 3352,
 -1,
 295438972,
 3351,
 295637408,
 295382737,
 3342,
 -1,
 295579345,
 3343,
 295768483,
 295574581,
 -1,
 -61022,
 295708572,
 3355,
 -1,
 295766652,
 3354,
 295965094,
 295703409,
 -1,
 -61019,
 295905180,
 3373,
 -1,
 295963260,
 3372,
 -61017,
 295932574,
 3375,
 -61016,
 296105382,
 3374,
 -1,
 296167324,
 3385,
 296358327,
 291721459,
 -1,
 296423854,
 296290940,
 -1,
 -61012,
 296401080,
 3404,
 -61011,
 296439691,
 3400,
 -1,
 296487548,
 3390,
 296686000,
 296401080,
 3393,
 -1,
 296663224,
 3394,
 296817074,
 296629602,
 3402,
 -1,
 296760674,
 3403,
 296948148,
 296767371,
 3391,
 -1,
 296898443,
 3392,
 297079222,
 296890065,
 3398,
 -1,
 297021137,
 3399,
 -1,
 297025115,
 3395,
 297275845,
 296330339,
 -1,
 297341371,
 297250754,
 -1,
 -60998,
 297289324,
 3432,
 -1,
 297354159,
 3433,
 297537982,
 297290519,
 -1,
 -60995,
 297488223,
 3436,
 -1,
 297535557,
 3437,
 297734593,
 297482111,
 -1,
 -60992,
 297690036,
 3434,
 -1,
 297764028,
 3435,
 -60990,
 297672630,
 3430,
 -60989,
 297863720,
 3431,
 -60988,
 297969174,
 3439,
 -1,
 298008299,
 3438,
 298193354,
 297237708,
 -1,
 298258889,
 298132072,
 -1,
 -60984,
 298201647,
 3331,
 -1,
 298267170,
 3405,
 -1,
 298196311,
 3330,
 -1,
 298128570,
 3415,
 298586577,
 291662946,
 -1,
 298652111,
 298543381,
 -1,
 -60978,
 298588570,
 9894,
 -1,
 298694904,
 9895,
 -60976,
 298588570,
 9794,
 -1,
 298819347,
 9893,
 -1,
 298532133,
 10016,
 299045333,
 291588887,
 -1,
 -60972,
 298996789,
 12348,
 -1,
 299087639,
 186,
 -60970,
 298983305,
 9901,
 -1,
 299209177,
 175,
 299373471,
 220738914,
 -1,
 299438804,
 299312448,
 -1,
 299504338,
 299405426,
 -1,
 299569721,
 299453207,
 -1,
 299635256,
 299522334,
 -1,
 299700716,
 299610050,
 7511,
 299766249,
 299638569,
 -1,
 299831777,
 299698812,
 7492,
 -60960,
 299779215,
 7579,
 -1,
 299839185,
 7494,
 300028387,
 299767563,
 692,
 -1,
 299996046,
 693,
 300159461,
 299987716,
 7514,
 -1,
 300114840,
 7597,
 -60954,
 300091419,
 7610,
 -60953,
 300262670,
 7500,
 -60952,
 300306315,
 7502,
 -1,
 300366201,
 7587,
 -60950,
 299706024,
 7508,
 -60949,
 300496158,
 7615,
 -1,
 300549650,
 7605,
 300749302,
 299637813,
 7580,
 300814836,
 300723901,
 -1,
 300880369,
 300765067,
 7590,
 -60944,
 300816464,
 694,
 -1,
 300917159,
 7591,
 -60942,
 300857528,
 7608,
 -60941,
 301038594,
 7600,
 -1,
 301099613,
 7595,
 -60939,
 300754789,
 7521,
 -1,
 301225375,
 7581,
 301404668,
 300698391,
 738,
 301470202,
 301341749,
 -1,
 -60935,
 301444626,
 7586,
 -1,
 301497213,
 7498,
 -60933,
 301411081,
 7513,
 -1,
 301634446,
 7603,
 301797889,
 301346513,
 7497,
 -60930,
 301728841,
 7614,
 -60929,
 301814401,
 7582,
 -60928,
 301884693,
 7604,
 -1,
 301946740,
 7505,
 302125574,
 301743941,
 7501,
 302191109,
 302097408,
 -1,
 -60924,
 302151362,
 7520,
 -1,
 302223094,
 7518,
 -1,
 302162536,
 736,
 302453258,
 302060401,
 7495,
 -60920,
 302424172,
 7509,
 -60919,
 302456358,
 7517,
 -1,
 302518551,
 7601,
 302715406,
 302394487,
 7611,
 302841855,
 302656964,
 -1,
 -60915,
 302756740,
 7612,
 -1,
 302816727,
 7613,
 302977553,
 302692536,
 7512,
 -60912,
 302929752,
 7607,
 -1,
 303005440,
 7606,
 303174165,
 302913291,
 691,
 303300607,
 303143762,
 -1,
 -60908,
 303211790,
 7583,
 -1,
 303262102,
 740,
 303436313,
 303117666,
 7506,
 303562751,
 303385871,
 -1,
 -60904,
 303445346,
 7507,
 -1,
 303509201,
 7499,
 303698461,
 303393373,
 737,
 303824895,
 303640004,
 -1,
 -60900,
 303739780,
 7593,
 -1,
 303804056,
 7594,
 303960608,
 303637824,
 7496,
 -60897,
 303902081,
 7585,
 -1,
 304002122,
 7519,
 304157219,
 303893116,
 7491,
 -60894,
 304104591,
 7493,
 -1,
 304173006,
 7516,
 304353829,
 304089115,
 7515,
 -1,
 304321422,
 7609,
 304484903,
 304319692,
 7510,
 -1,
 304424805,
 7602,
 304615978,
 304435296,
 -1,
 -60887,
 304591748,
 7599,
 -1,
 304647079,
 7598,
 304812588,
 304575236,
 7504,
 -1,
 304780174,
 7596,
 304943662,
 304764924,
 690,
 -1,
 304886174,
 7592,
 305074737,
 304893835,
 -1,
 -60880,
 305034139,
 7589,
 -1,
 305111463,
 7588,
 305271347,
 305019257,
 688,
 -1,
 305238926,
 689,
 -60876,
 305210068,
 696,
 -60875,
 305338811,
 739,
 -60874,
 305402168,
 695,
 -60873,
 305487984,
 7503,
 -1,
 305543039,
 7584,
 -1,
 299583754,
 765,
 305795684,
 299506741,
 -1,
 305861203,
 305770173,
 -1,
 305926719,
 305796875,
 7487,
 306053119,
 305896274,
 -1,
 -60866,
 305953794,
 7483,
 -1,
 305999569,
 7474,
 306188865,
 305870178,
 7484,
 -1,
 306165944,
 7485,
 306319939,
 306123633,
 7470,
 -1,
 306254001,
 7471,
 306451013,
 306252412,
 7468,
 -1,
 306392785,
 7469,
 -60858,
 306385208,
 7490,
 -60857,
 306559160,
 7489,
 -60856,
 306622402,
 7488,
 -60855,
 306678988,
 7486,
 -60854,
 306740226,
 7482,
 -60853,
 306803460,
 7481,
 -60852,
 306866781,
 7480,
 -60851,
 306929776,
 7479,
 -60850,
 306993148,
 7478,
 -60849,
 307056523,
 7477,
 -60848,
 307116409,
 7476,
 -60847,
 307183429,
 7475,
 -60846,
 307244753,
 7473,
 -1,
 307307840,
 7472,
 307499614,
 305800172,
 -1,
 307565145,
 307442780,
 -1,
 -60842,
 307519085,
 42754,
 -60841,
 307575685,
 42758,
 -60840,
 307631774,
 42756,
 -1,
 307724063,
 42752,
 307953663,
 307528268,
 -1,
 -60837,
 307846765,
 42755,
 -60836,
 307903365,
 42759,
 -60835,
 307959454,
 42757,
 -1,
 308051743,
 42753,
 308220513,
 307469184,
 -1,
 -60832,
 308153666,
 722,
 -1,
 308252456,
 723,
 -60830,
 308183844,
 7544,
 -60829,
 308388943,
 735,
 -1,
 308429335,
 710,
 308613757,
 305752669,
 -1,
 308679290,
 308575890,
 -1,
 308744810,
 308634571,
 -1,
 308810345,
 308703880,
 767,
 -1,
 308742782,
 753,
 -1,
 308757321,
 42773,
 309006959,
 308691826,
 -1,
 309072494,
 308967252,
 -1,
 -60819,
 309027589,
 42763,
 -1,
 309079534,
 42768,
 -1,
 309036688,
 751,
 309334642,
 308981698,
 -1,
 -60815,
 309292487,
 744,
 -1,
 309343789,
 759,
 309531253,
 309279736,
 -1,
 -60812,
 309483380,
 755,
 -1,
 309547841,
 754,
 -60810,
 309471527,
 716,
 -60809,
 309683490,
 752,
 -60808,
 309723343,
 717,
 -60807,
 309793358,
 718,
 -1,
 309894470,
 719,
 310116351,
 308621551,
 -1,
 -60804,
 310008187,
 703,
 -1,
 310097220,
 706,
 310252174,
 308555473,
 -1,
 310317707,
 310214303,
 -1,
 310383237,
 310251172,
 -1,
 310448771,
 310360166,
 -1,
 -60798,
 310403845,
 42764,
 -1,
 310455790,
 42769,
 -60796,
 310403845,
 745,
 -1,
 310586862,
 42774,
 310837247,
 310318651,
 -1,
 310841993,
 310753382,
 -1,
 -60792,
 310797061,
 42760,
 -1,
 310849006,
 42765,
 -60790,
 310797061,
 741,
 -1,
 310980078,
 42770,
 311230463,
 310279008,
 -1,
 -60787,
 311115229,
 764,
 -1,
 311194490,
 762,
 311366302,
 310211332,
 -1,
 311431837,
 311316363,
 -1,
 311497372,
 311371072,
 -1,
 311562903,
 311450823,
 -1,
 311628437,
 311539814,
 -1,
 -60780,
 311583493,
 42762,
 -1,
 311635438,
 42767,
 -60778,
 311583493,
 743,
 -1,
 311766510,
 42772,
 312016895,
 311498119,
 -1,
 312021659,
 311931812,
 -1,
 -60774,
 311956046,
 757,
 -1,
 312057158,
 758,
 -1,
 311956046,
 756,
 -1,
 311438256,
 727,
 -1,
 311400920,
 713,
 312414887,
 311301899,
 -1,
 312480418,
 312388174,
 -1,
 -60767,
 312433019,
 702,
 -1,
 312522052,
 707,
 312677029,
 312449874,
 -1,
 -60764,
 312633750,
 705,
 -1,
 312713448,
 701,
 -60762,
 312631268,
 734,
 -1,
 312844102,
 760,
 313004719,
 312359289,
 -1,
 313070254,
 312972732,
 -1,
 313135788,
 313047142,
 -1,
 -60757,
 313090821,
 42761,
 -1,
 313142766,
 42766,
 -60755,
 313090821,
 742,
 -1,
 313273838,
 42771,
 -1,
 313042857,
 721,
 313529014,
 312951666,
 -1,
 313594547,
 313501292,
 -1,
 -60750,
 313533112,
 725,
 -1,
 313636164,
 709,
 313851903,
 313545646,
 -1,
 -60747,
 313723175,
 698,
 -1,
 313804272,
 750,
 313987771,
 313505976,
 -1,
 314053306,
 313960143,
 -1,
 -60743,
 313991864,
 724,
 -1,
 314094916,
 708,
 -1,
 313998436,
 749,
 314315455,
 313933637,
 -1,
 -60739,
 314284580,
 715,
 -60738,
 314325925,
 704,
 -1,
 314415217,
 4348,
 314577602,
 314254036,
 -1,
 -60735,
 314531017,
 746,
 -1,
 314617081,
 747,
 314774213,
 314509339,
 -1,
 -60732,
 314727858,
 748,
 -1,
 314806925,
 712,
 314970824,
 314748866,
 -1,
 -60729,
 314910223,
 699,
 -1,
 315006476,
 720,
 315167435,
 314936524,
 -1,
 -60726,
 315121835,
 697,
 -1,
 315170842,
 726,
 315364046,
 315143925,
 -1,
 -60723,
 315309533,
 763,
 -1,
 315388794,
 761,
 315560657,
 315296380,
 -1,
 -60720,
 315515303,
 700,
 -1,
 315580876,
 714,
 -1,
 315512830,
 766,
 -60717,
 299472980,
 10762,
 -1,
 315775033,
 8871,
 316014591,
 299400194,
 -1,
 316019608,
 315922262,
 -1,
 316085110,
 315981516,
 -1,
 316150524,
 316059586,
 -1,
 316216058,
 316084361,
 -1,
 316281566,
 316148348,
 -1,
 316347101,
 316221343,
 -1,
 -60708,
 316323554,
 6297,
 -1,
 316377518,
 6296,
 -1,
 316299124,
 6218,
 316609248,
 316258488,
 6215,
 -1,
 316550865,
 6217,
 316740323,
 316583874,
 -1,
 -60702,
 316695875,
 6228,
 -1,
 316738172,
 6224,
 316936933,
 316683618,
 6214,
 -1,
 316878545,
 6216,
 317068008,
 316889084,
 -1,
 -60697,
 317018065,
 6234,
 -1,
 317065852,
 6227,
 317264618,
 316998044,
 6222,
 -1,
 317196924,
 6232,
 317395693,
 317203776,
 -1,
 -60692,
 317332605,
 6236,
 -1,
 317393532,
 6225,
 -60690,
 317362846,
 6229,
 -60689,
 317539941,
 6230,
 -60688,
 317593345,
 6221,
 -60687,
 317671254,
 6220,
 -60686,
 317760706,
 6235,
 -60685,
 317797798,
 6223,
 -60684,
 317851420,
 6211,
 -60683,
 317955853,
 6231,
 -60682,
 318001035,
 6213,
 -60681,
 318064594,
 6233,
 -60680,
 318123729,
 6212,
 -60679,
 318180784,
 6226,
 -1,
 318287319,
 6219,
 -60677,
 316171587,
 6204,
 -1,
 318376572,
 6194,
 318575393,
 316082812,
 6176,
 318640928,
 318515103,
 -1,
 318706436,
 318615490,
 -1,
 318771970,
 318681026,
 -1,
 -60671,
 318711708,
 6285,
 -1,
 318769788,
 6284,
 -60669,
 318729504,
 6278,
 -1,
 318900860,
 6288,
 319099657,
 318645568,
 -1,
 319165192,
 319031932,
 6289,
 -60665,
 319132682,
 6274,
 -1,
 319191728,
 6313,
 -1,
 319112108,
 6286,
 319427340,
 319031932,
 6279,
 -60661,
 319402555,
 6272,
 -1,
 319437177,
 6295,
 319623951,
 319368311,
 -1,
 -60658,
 319563676,
 6293,
 -1,
 319621756,
 6294,
 319820562,
 319589580,
 -1,
 -60655,
 319760284,
 6291,
 -1,
 319818364,
 6290,
 320017173,
 319781890,
 -1,
 -60652,
 319981466,
 6287,
 -1,
 320012700,
 6282,
 320213783,
 319967115,
 6280,
 -1,
 320187996,
 6276,
 320344858,
 320157380,
 -1,
 -60647,
 320311966,
 6311,
 -1,
 320387256,
 6310,
 -60645,
 320313540,
 6273,
 -60644,
 320508178,
 6275,
 -60643,
 320541152,
 6292,
 -60642,
 320642829,
 6281,
 -60641,
 320675718,
 6283,
 -1,
 320755780,
 6277,
 -1,
 318592884,
 6185,
 321000253,
 318524183,
 -1,
 321065787,
 320959665,
 -1,
 321131302,
 321006711,
 -1,
 -60635,
 321071004,
 6258,
 -1,
 321129084,
 6255,
 321327912,
 321108152,
 6241,
 -1,
 321269457,
 6240,
 321458987,
 321302466,
 -1,
 -60630,
 321414467,
 6254,
 -1,
 321456764,
 6248,
 321655597,
 321408907,
 6238,
 -1,
 321594068,
 6239,
 321786671,
 321595292,
 6245,
 -1,
 321718908,
 6253,
 321917745,
 321716636,
 6244,
 -1,
 321849980,
 6252,
 -60622,
 321875202,
 6247,
 -60621,
 322017426,
 6256,
 -60620,
 322062166,
 6246,
 -60619,
 322150157,
 6243,
 -60618,
 322204972,
 6250,
 -60617,
 322277854,
 6251,
 -60616,
 322318033,
 6237,
 -60615,
 322388908,
 6249,
 -60614,
 322440624,
 6257,
 -1,
 322533863,
 6242,
 -60612,
 321005468,
 6193,
 -1,
 322636412,
 6192,
 322835286,
 320943526,
 6190,
 322961407,
 322784407,
 -1,
 322966353,
 322876533,
 -1,
 323031875,
 322907255,
 -1,
 -60606,
 322971548,
 6308,
 -1,
 323029628,
 6309,
 323228486,
 323006402,
 -1,
 -60603,
 323193262,
 6302,
 -1,
 323226236,
 6304,
 323425097,
 323167552,
 -1,
 -60600,
 323364764,
 6305,
 -1,
 323437866,
 6303,
 323621708,
 323361845,
 -1,
 -60597,
 323588766,
 6307,
 -1,
 323619452,
 6300,
 -60595,
 323555808,
 6306,
 -60594,
 323775316,
 6299,
 -60593,
 323833330,
 6301,
 -60592,
 323905763,
 6298,
 -1,
 323983074,
 6312,
 -60590,
 322942690,
 6263,
 -60589,
 324118844,
 6261,
 -60588,
 324181773,
 6260,
 -60587,
 324226955,
 6259,
 -1,
 324309470,
 6262,
 324473690,
 322776183,
 -1,
 -60584,
 324446524,
 6207,
 -60583,
 324478821,
 6209,
 -1,
 324536956,
 6205,
 324735836,
 324450488,
 6180,
 -1,
 324677329,
 6182,
 324866910,
 324679010,
 6179,
 -1,
 324808401,
 6181,
 324997985,
 324823645,
 -1,
 -60576,
 324937628,
 6208,
 -1,
 324995708,
 6191,
 325194596,
 324952176,
 -1,
 -60573,
 325134236,
 6203,
 -1,
 325192316,
 6202,
 325391206,
 325136081,
 6177,
 -1,
 325332689,
 6183,
 325522281,
 325328747,
 -1,
 -60568,
 325472139,
 6210,
 -1,
 325519996,
 6196,
 -60566,
 325489310,
 6198,
 -60565,
 325666405,
 6200,
 -60564,
 325757244,
 6199,
 -60563,
 325785345,
 6188,
 -60562,
 325863254,
 6187,
 -60561,
 325945242,
 6184,
 -60560,
 326006060,
 6197,
 -60559,
 326061963,
 6178,
 -60558,
 326125522,
 6206,
 -60557,
 326173084,
 6189,
 -60556,
 326275550,
 6201,
 -60555,
 326321068,
 6195,
 -1,
 326413783,
 6186,
 326570884,
 316056675,
 -1,
 326636410,
 326545346,
 -1,
 -60551,
 326583916,
 6162,
 -1,
 326648751,
 6163,
 326833021,
 326585111,
 -1,
 -60548,
 326782815,
 6166,
 -1,
 326830149,
 6167,
 327029632,
 326776703,
 -1,
 -60545,
 326984628,
 6164,
 -1,
 327058620,
 6165,
 -60543,
 326967222,
 6160,
 -60542,
 327158312,
 6161,
 -60541,
 327263766,
 6169,
 -1,
 327302891,
 6168,
 327488396,
 326514559,
 -1,
 327553930,
 327426681,
 -1,
 327619465,
 327528386,
 -1,
 -60536,
 327566956,
 6156,
 -1,
 327631791,
 6157,
 -1,
 327551528,
 6155,
 -60533,
 327491441,
 6147,
 -1,
 327816076,
 6149,
 328012687,
 327460901,
 -1,
 -60530,
 327959031,
 6153,
 -1,
 328048872,
 6152,
 328209298,
 327950190,
 -1,
 -60527,
 328153181,
 6146,
 -1,
 328218626,
 6148,
 -60525,
 328155380,
 6158,
 -60524,
 328348305,
 6150,
 -60523,
 328406124,
 6151,
 -60522,
 328498064,
 6154,
 -60521,
 328564937,
 6145,
 -1,
 328605001,
 6144,
 328859647,
 315962722,
 -1,
 328864670,
 328760530,
 -1,
 328930205,
 328803028,
 -1,
 -60516,
 328880078,
 9867,
 -1,
 328956391,
 9866,
 -1,
 328894246,
 119552,
 -1,
 328836313,
 9101,
 329258243,
 299350200,
 -1,
 329323758,
 329210988,
 -1,
 329389290,
 329287343,
 -1,
 329454558,
 329325621,
 -1,
 329520080,
 329397602,
 -1,
 329585615,
 329478916,
 -1,
 329651150,
 329538922,
 -1,
 329716655,
 329599767,
 -1,
 329782188,
 329691074,
 -1,
 329847723,
 329742633,
 -1,
 -60502,
 329790818,
 119164,
 -1,
 329859290,
 119166,
 -1,
 329804960,
 119141,
 -60499,
 329737054,
 119142,
 -60498,
 330049926,
 119213,
 -1,
 330125011,
 119176,
 330306487,
 329683543,
 -1,
 330372022,
 330236343,
 -1,
 -60494,
 330324571,
 119154,
 -60493,
 330388000,
 119153,
 -60492,
 330451403,
 119152,
 -60491,
 330514868,
 119151,
 -1,
 330578254,
 119150,
 -1,
 330321805,
 119175,
 330830783,
 330280898,
 -1,
 330896318,
 330766091,
 -1,
 330961853,
 330839557,
 -1,
 -60485,
 330910155,
 119145,
 -60484,
 330973620,
 119144,
 -1,
 331037006,
 119143,
 -1,
 330932532,
 119179,
 -1,
 330839320,
 119165,
 331355075,
 330777458,
 -1,
 -60479,
 331309991,
 119210,
 -60478,
 331380522,
 119178,
 -1,
 331435930,
 119173,
 331617223,
 331287164,
 -1,
 331682758,
 331590407,
 119163,
 -1,
 331657863,
 119169,
 -1,
 331616191,
 119149,
 331879369,
 331570643,
 119167,
 -1,
 331854471,
 119168,
 -60470,
 331836014,
 119211,
 -60469,
 331958089,
 119174,
 -60468,
 332030648,
 119170,
 -60467,
 332086074,
 119212,
 -1,
 332161763,
 119177,
 -1,
 329612637,
 119092,
 -1,
 329532332,
 119052,
 332469207,
 329476701,
 -1,
 332534740,
 332426235,
 -1,
 -60461,
 332496605,
 119130,
 -1,
 332570707,
 119131,
 332791807,
 332484491,
 -1,
 -60458,
 332700227,
 119253,
 -1,
 332768561,
 119255,
 332927962,
 332404491,
 -1,
 -60455,
 332864093,
 119247,
 -1,
 332948444,
 119186,
 -60453,
 332866682,
 119093,
 -60452,
 333078293,
 119109,
 -60451,
 333159465,
 119059,
 -1,
 333223380,
 119073,
 333386764,
 329428930,
 -1,
 333452276,
 333321995,
 119190,
 333578239,
 333416899,
 -1,
 333583345,
 333475323,
 -1,
 333648872,
 333546349,
 -1,
 333714406,
 333615601,
 -1,
 -60443,
 333676253,
 119120,
 -1,
 333750355,
 119121,
 -60441,
 333676253,
 119112,
 -1,
 333881427,
 119113,
 334042091,
 333615601,
 -1,
 -60438,
 334003933,
 119116,
 -1,
 334078035,
 119117,
 334238702,
 333998162,
 -1,
 -60435,
 334200541,
 119114,
 -1,
 334274643,
 119115,
 334495743,
 334181458,
 -1,
 -60432,
 334397149,
 119118,
 -1,
 334471251,
 119119,
 334692351,
 333551472,
 -1,
 -60429,
 334593757,
 119124,
 -1,
 334667859,
 119125,
 334828544,
 333401816,
 -1,
 334894076,
 334778114,
 -1,
 334959611,
 334831895,
 119243,
 335085567,
 334911076,
 -1,
 -60423,
 334973387,
 119246,
 -60422,
 335036852,
 119245,
 -1,
 335100238,
 119244,
 -1,
 334926761,
 119242,
 335413247,
 334842280,
 -1,
 335418367,
 335319977,
 119239,
 -1,
 335350113,
 119241,
 -1,
 335356183,
 119240,
 335614980,
 334785100,
 119191,
 335740927,
 335568071,
 -1,
 -60413,
 335647951,
 119194,
 -1,
 335714749,
 119193,
 335877129,
 335559033,
 -1,
 335942664,
 335837585,
 -1,
 -60409,
 335886801,
 119104,
 -1,
 335973068,
 119138,
 -1,
 335895507,
 119064,
 336204811,
 335842886,
 119256,
 -1,
 336168436,
 119260,
 -1,
 336153621,
 119063,
 336401458,
 333335319,
 -1,
 336466970,
 336351115,
 -1,
 336532505,
 336402875,
 -1,
 336598038,
 336506818,
 -1,
 336663571,
 336532578,
 -1,
 -60398,
 336607697,
 119105,
 -1,
 336693964,
 119139,
 336920575,
 336598234,
 -1,
 -60395,
 336804305,
 119103,
 -1,
 336890572,
 119137,
 337117183,
 336532876,
 -1,
 -60392,
 336989076,
 119068,
 -1,
 337059569,
 119067,
 -1,
 336506148,
 119040,
 337318949,
 336408273,
 -1,
 337384484,
 337262031,
 -1,
 337450016,
 337360867,
 -1,
 -60386,
 337411805,
 119229,
 -60385,
 337459665,
 119238,
 -1,
 337551443,
 119230,
 337772543,
 337403054,
 -1,
 -60382,
 337673949,
 119225,
 -60381,
 337721809,
 119236,
 -1,
 337813587,
 119226,
 -1,
 337340008,
 119051,
 338039850,
 337268263,
 -1,
 338105385,
 337997713,
 -1,
 -60376,
 338067165,
 119110,
 -1,
 338141267,
 119111,
 -1,
 338039665,
 119250,
 338367535,
 337983865,
 -1,
 338433070,
 338332854,
 -1,
 -60371,
 338400463,
 119088,
 -1,
 338473168,
 119089,
 -1,
 338366972,
 119045,
 338695217,
 338304731,
 119254,
 -1,
 338672054,
 119259,
 -1,
 338657841,
 119181,
 338891852,
 336344959,
 -1,
 338957371,
 338841483,
 -1,
 339022906,
 338918402,
 -1,
 339088441,
 338965976,
 -1,
 -60361,
 339036619,
 119148,
 -60360,
 339100084,
 119147,
 -1,
 339163470,
 119146,
 -1,
 339049451,
 119042,
 -1,
 338985255,
 119066,
 339481664,
 338900322,
 -1,
 339547199,
 339437956,
 -1,
 -60354,
 339479444,
 119069,
 -1,
 339549937,
 119065,
 -1,
 339492394,
 119185,
 339809348,
 339449300,
 119074,
 339935231,
 339779174,
 -1,
 -60349,
 339829756,
 119076,
 -1,
 339912565,
 119075,
 340071495,
 339777257,
 -1,
 -60346,
 340033245,
 119231,
 -1,
 340107347,
 119232,
 340268106,
 340045399,
 -1,
 -60343,
 340235471,
 119084,
 -1,
 340308176,
 119085,
 340525055,
 340227454,
 119056,
 -1,
 340401111,
 119057,
 340595809,
 338834786,
 -1,
 340661337,
 340564952,
 -1,
 340726865,
 340605262,
 119195,
 -60336,
 340670798,
 119205,
 -1,
 340734469,
 119204,
 -60334,
 340688403,
 119203,
 -60333,
 340882849,
 119202,
 -60332,
 340946057,
 119201,
 -60331,
 341009330,
 119200,
 -60330,
 341072475,
 119199,
 -60329,
 341135904,
 119198,
 -60328,
 341199307,
 119197,
 -1,
 341262772,
 119196,
 341447774,
 340612977,
 -1,
 341513309,
 341382721,
 -1,
 -60324,
 341457361,
 119106,
 -1,
 341543628,
 119140,
 -1,
 341467630,
 119062,
 341835775,
 341390295,
 -1,
 -60320,
 341730300,
 119095,
 -1,
 341813109,
 119094,
 341972082,
 340534592,
 -1,
 342037608,
 341903996,
 -1,
 342103141,
 341999156,
 119220,
 -1,
 342056845,
 119221,
 -60314,
 342070404,
 119044,
 -60313,
 342196255,
 119049,
 -1,
 342269778,
 119050,
 342430828,
 341985039,
 -1,
 -60310,
 342364302,
 119082,
 -60309,
 342439176,
 119083,
 -1,
 342517643,
 119041,
 342692975,
 342365650,
 -1,
 -60306,
 342639028,
 119078,
 -1,
 342702414,
 119077,
 342949887,
 342634193,
 -1,
 -60303,
 342850188,
 119209,
 -1,
 342892146,
 119187,
 343086210,
 341906289,
 -1,
 343151741,
 343021323,
 -1,
 343217274,
 343092945,
 -1,
 343282809,
 343148571,
 -1,
 343348344,
 343232400,
 119224,
 -1,
 343282726,
 119235,
 -1,
 343289553,
 119132,
 -1,
 343257844,
 119058,
 343670783,
 343181748,
 -1,
 -60292,
 343568616,
 119061,
 -1,
 343617233,
 119060,
 343867391,
 343085472,
 -1,
 -60289,
 343781007,
 119157,
 -60288,
 343839918,
 119159,
 -60287,
 343886791,
 119161,
 -1,
 343962386,
 119155,
 344134799,
 343051468,
 -1,
 344200327,
 344077666,
 -1,
 344265862,
 344167097,
 119257,
 -1,
 344242614,
 119258,
 -1,
 344218624,
 119252,
 344462476,
 344141521,
 -1,
 344528011,
 344439102,
 -1,
 -60278,
 344461295,
 119215,
 -1,
 344560640,
 119214,
 -1,
 344468692,
 119261,
 -60275,
 344427401,
 119108,
 -60274,
 344738037,
 119183,
 -1,
 344829477,
 119126,
 344986782,
 344080197,
 -1,
 345052311,
 344921867,
 -1,
 345117844,
 344989203,
 -1,
 -60269,
 345071425,
 119249,
 -1,
 345132493,
 119248,
 345374719,
 345072066,
 -1,
 -60266,
 345283005,
 119188,
 -1,
 345342041,
 119189,
 345511067,
 345019860,
 119070,
 345636863,
 345480806,
 -1,
 -60262,
 345531388,
 119072,
 -1,
 345614197,
 119071,
 345833471,
 345454473,
 -1,
 -60259,
 345740495,
 119217,
 -1,
 345813200,
 119218,
 345969833,
 344945412,
 -1,
 346035363,
 345931680,
 119227,
 346161151,
 345988295,
 -1,
 -60254,
 346044881,
 119237,
 -1,
 346136659,
 119228,
 346297510,
 345965070,
 -1,
 -60251,
 346259165,
 119122,
 -1,
 346333267,
 119123,
 -60249,
 346272595,
 119098,
 -60248,
 346439237,
 119184,
 -1,
 346490405,
 119222,
 346690741,
 345904907,
 -1,
 346756274,
 346631889,
 -1,
 346821809,
 346701259,
 -1,
 346887344,
 346794563,
 -1,
 -60242,
 346835403,
 119055,
 -60241,
 346898868,
 119054,
 -1,
 346962254,
 119053,
 -1,
 346830226,
 119048,
 -1,
 346767204,
 119043,
 347340799,
 346705803,
 -1,
 -60236,
 347245774,
 119180,
 -1,
 347307791,
 119047,
 347477183,
 346631889,
 -1,
 347542716,
 347437920,
 -1,
 -60232,
 347516559,
 119158,
 -60231,
 347575470,
 119160,
 -60230,
 347622343,
 119162,
 -60229,
 347714792,
 119208,
 -1,
 347763474,
 119156,
 347996159,
 347486028,
 -1,
 -60226,
 347879889,
 119102,
 -1,
 347966156,
 119136,
 348132553,
 347412126,
 -1,
 348198086,
 348067461,
 -1,
 348263620,
 348154516,
 -1,
 -60221,
 348197006,
 119090,
 -1,
 348271880,
 119091,
 -60219,
 348207569,
 119101,
 -1,
 348424908,
 119135,
 348651519,
 348165784,
 -1,
 -60216,
 348546044,
 119097,
 -1,
 348628853,
 119096,
 348787920,
 348093442,
 -1,
 348853453,
 348733276,
 -1,
 -60212,
 348820687,
 119086,
 -1,
 348893392,
 119087,
 -60210,
 348788706,
 119129,
 -60209,
 348991336,
 119128,
 -1,
 349088866,
 119207,
 349246678,
 348744285,
 -1,
 349312213,
 349194933,
 119223,
 349437951,
 349265095,
 -1,
 -60204,
 349326627,
 119233,
 -1,
 349415024,
 119234,
 -1,
 349246806,
 119046,
 349639900,
 349185948,
 -1,
 349705435,
 349594616,
 -1,
 -60199,
 349649361,
 119100,
 -60198,
 349723168,
 119216,
 -1,
 349801164,
 119134,
 -1,
 349634919,
 119206,
 350033121,
 349573432,
 -1,
 350098656,
 349973404,
 -1,
 -60193,
 350042577,
 119099,
 -1,
 350128844,
 119133,
 -1,
 350056195,
 119219,
 350360804,
 349964315,
 -1,
 -60189,
 350323799,
 119127,
 -1,
 350392478,
 119251,
 350557415,
 350306125,
 -1,
 -60186,
 350524623,
 119171,
 -1,
 350597328,
 119172,
 -60184,
 350497911,
 119182,
 -60183,
 350702692,
 119107,
 -1,
 350782694,
 119192,
 351010815,
 329342151,
 -1,
 -60180,
 350912564,
 9839,
 -60179,
 350951725,
 9838,
 -1,
 351021611,
 9837,
 351212800,
 329265544,
 -1,
 351278331,
 351173370,
 -1,
 351343866,
 351213978,
 215,
 351469567,
 351296711,
 -1,
 351474935,
 351351900,
 -1,
 -60172,
 351444941,
 10811,
 -60171,
 351502557,
 10805,
 -60170,
 351581100,
 10804,
 -1,
 351637199,
 10807,
 351862783,
 351410748,
 -1,
 -60167,
 351733309,
 10801,
 -1,
 351835300,
 10800,
 -1,
 351279547,
 10005,
 352064767,
 351224099,
 8844,
 352190463,
 352017607,
 -1,
 -60162,
 352090286,
 8846,
 -1,
 352169600,
 8845,
 -1,
 351994291,
 8888,
 352452607,
 351145204,
 -1,
 -60158,
 352340016,
 8810,
 -1,
 352424396,
 8811,
 352589165,
 329231021,
 -1,
 352654659,
 352550604,
 -1,
 352720140,
 352615426,
 -1,
 352785673,
 352680962,
 -1,
 -60152,
 352752286,
 4106,
 -1,
 352782972,
 4111,
 -60150,
 352752286,
 4105,
 -60149,
 352911772,
 4100,
 -1,
 352979580,
 4116,
 353178897,
 352651659,
 -1,
 353244431,
 353113867,
 4178,
 -1,
 353179403,
 4179,
 353435647,
 353200733,
 4180,
 -1,
 353331805,
 4181,
 353506583,
 353152962,
 -1,
 353572117,
 353480642,
 -1,
 -60140,
 353511324,
 4108,
 -1,
 353569404,
 4107,
 -60138,
 353511324,
 4113,
 -1,
 353700476,
 4112,
 353899805,
 353445184,
 -1,
 353965339,
 353838400,
 -1,
 -60134,
 353904540,
 4110,
 -1,
 353962620,
 4109,
 -60132,
 353904540,
 4115,
 -1,
 354093692,
 4114,
 354293025,
 353848087,
 -1,
 -60129,
 354248003,
 4177,
 -60128,
 354297756,
 4176,
 -1,
 354355836,
 4126,
 354555171,
 354269368,
 4133,
 -1,
 354531512,
 4134,
 354686246,
 354520268,
 -1,
 -60123,
 354625436,
 4118,
 -1,
 354683516,
 4117,
 354882857,
 354642525,
 -1,
 -60120,
 354814426,
 4128,
 -1,
 354880124,
 4124,
 355079468,
 354836592,
 -1,
 -60117,
 355018652,
 4097,
 -1,
 355076732,
 4096,
 355276079,
 355031036,
 -1,
 -60114,
 355215260,
 4104,
 -1,
 355273340,
 4103,
 355472689,
 355225483,
 4131,
 -1,
 355422091,
 4132,
 355603764,
 355417925,
 -1,
 -60109,
 355542940,
 4099,
 -1,
 355601020,
 4098,
 355800375,
 355540021,
 -1,
 -60106,
 355739548,
 4102,
 -1,
 355797628,
 4101,
 355996986,
 355734385,
 -1,
 -60103,
 355936156,
 4120,
 -1,
 355994236,
 4119,
 356193596,
 355928700,
 4129,
 -1,
 356169912,
 4138,
 -60099,
 356160158,
 4122,
 -60098,
 356271717,
 4125,
 -60097,
 356362556,
 4123,
 -60096,
 356398434,
 4137,
 -60095,
 356464038,
 4121,
 -60094,
 356525980,
 4127,
 -1,
 356593361,
 4135,
 356783441,
 352604403,
 -1,
 356848969,
 356714891,
 -1,
 356914503,
 356783883,
 4182,
 -1,
 356849419,
 4183,
 357105663,
 356870749,
 4184,
 -1,
 357001821,
 4185,
 357176651,
 356825272,
 4143,
 -1,
 357152952,
 4144,
 357307725,
 357126027,
 4141,
 -1,
 357257099,
 4142,
 357438800,
 357239420,
 -1,
 -60081,
 357388171,
 4146,
 -1,
 357436028,
 4140,
 -1,
 357379793,
 4145,
 357700959,
 356731671,
 -1,
 357766490,
 357661540,
 -1,
 357832022,
 357704296,
 -1,
 -60075,
 357773871,
 4152,
 -1,
 357839394,
 4153,
 -60073,
 357765684,
 4171,
 -60072,
 357976390,
 4170,
 -60071,
 358047905,
 4151,
 -1,
 358096215,
 4150,
 358350847,
 357718189,
 -1,
 -60068,
 358227103,
 4172,
 -60067,
 358321862,
 4175,
 -60066,
 358373874,
 4173,
 -1,
 358422548,
 4174,
 358678527,
 357672035,
 -1,
 358684003,
 358592450,
 -1,
 -60062,
 358631020,
 4162,
 -1,
 358695855,
 4163,
 358880614,
 358632215,
 -1,
 -60059,
 358829919,
 4166,
 -1,
 358877253,
 4167,
 359077225,
 358823807,
 -1,
 -60056,
 359031732,
 4164,
 -1,
 359105724,
 4165,
 -60054,
 359014326,
 4160,
 -60053,
 359205416,
 4161,
 -60052,
 359310870,
 4169,
 -1,
 359349995,
 4168,
 359536036,
 352530129,
 -1,
 359601539,
 359488482,
 -1,
 359667060,
 359572022,
 -1,
 359732595,
 359619783,
 -1,
 -60046,
 359705312,
 10089,
 -1,
 359728178,
 10101,
 -1,
 359690555,
 10093,
 359994745,
 359621579,
 -1,
 360060280,
 359947463,
 -1,
 -60041,
 360032992,
 10088,
 -1,
 360055858,
 10100,
 -1,
 360018235,
 10092,
 360322428,
 359942935,
 -1,
 -60037,
 360282775,
 9900,
 -1,
 360350974,
 9618,
 360519039,
 360257120,
 -1,
 -60034,
 360488559,
 10091,
 -1,
 360547385,
 10090,
 -60032,
 360493245,
 9898,
 -60031,
 360676733,
 10073,
 -60030,
 360710860,
 8287,
 -1,
 360784118,
 9899,
 360977814,
 359561959,
 -1,
 361043348,
 360941730,
 8737,
 361168895,
 360996039,
 -1,
 361174419,
 361051102,
 -1,
 361239946,
 361129027,
 -1,
 -60023,
 361210422,
 10664,
 -1,
 361259979,
 10665,
 361436557,
 361201038,
 -1,
 -60020,
 361403599,
 10668,
 -1,
 361476304,
 10670,
 361633168,
 361388346,
 -1,
 -60017,
 361600207,
 10669,
 -1,
 361672912,
 10671,
 361889791,
 361604033,
 -1,
 -60014,
 361800246,
 10666,
 -1,
 361849803,
 10667,
 -1,
 361150018,
 10651,
 -60011,
 360979046,
 10653,
 -1,
 362065573,
 8798,
 362223011,
 360940015,
 -1,
 362288541,
 362196930,
 -1,
 362354075,
 362234081,
 -1,
 -60006,
 362317822,
 9173,
 -1,
 362348758,
 9174,
 -60004,
 362325823,
 9175,
 -1,
 362494927,
 9176,
 362681760,
 362250184,
 -1,
 -60001,
 362646116,
 9172,
 -1,
 362706825,
 9170,
 -59999,
 362628719,
 9171,
 -59998,
 362813450,
 9177,
 -1,
 362894248,
 9169,
 -1,
 362176507,
 9791,
 363200511,
 359485323,
 -1,
 363206067,
 363101186,
 -1,
 363271602,
 363180893,
 -1,
 363337137,
 363224263,
 -1,
 363402672,
 363272602,
 8722,
 363528191,
 363355335,
 -1,
 363533743,
 363403836,
 -1,
 -59988,
 363509912,
 10796,
 -59987,
 363570646,
 10795,
 -59986,
 363618465,
 10794,
 -1,
 363696428,
 10793,
 -1,
 363501094,
 10810,
 -1,
 363366176,
 8770,
 -1,
 363306736,
 8723,
 -1,
 363209428,
 10751,
 364123574,
 363144512,
 -1,
 -59979,
 364098767,
 8943,
 -1,
 364120997,
 183,
 -59977,
 364053378,
 8357,
 -1,
 364266948,
 181,
 364453162,
 220686941,
 -1,
 364518012,
 364382844,
 -1,
 364583449,
 364446111,
 -1,
 364648483,
 364530455,
 -1,
 364714009,
 364599582,
 -1,
 364779542,
 364669533,
 -1,
 364845067,
 364745473,
 -1,
 364910071,
 364818370,
 116,
 364975577,
 364846889,
 -1,
 365041093,
 364910347,
 633,
 365166591,
 364981700,
 -1,
 -59964,
 365051053,
 634,
 -1,
 365144919,
 635,
 365303240,
 364984697,
 613,
 365428735,
 365268635,
 686,
 -1,
 365330303,
 687,
 365499851,
 365234812,
 592,
 -59958,
 365446287,
 594,
 -1,
 365506257,
 7426,
 365696462,
 365442402,
 -1,
 -59955,
 365629884,
 7432,
 -1,
 365702865,
 7444,
 365893072,
 365654788,
 623,
 -1,
 365847448,
 624,
 -59951,
 365830868,
 654,
 -59950,
 365957432,
 653,
 -59949,
 366020635,
 652,
 -59948,
 366129090,
 647,
 -59947,
 366174320,
 670,
 -59946,
 366235531,
 7433,
 -59945,
 366296901,
 7543,
 -59944,
 366358225,
 477,
 -1,
 366456149,
 397,
 366613995,
 364916164,
 -1,
 366679520,
 366550069,
 -1,
 -59940,
 366635592,
 566,
 -59939,
 366687076,
 539,
 -59938,
 366777617,
 7793,
 -59937,
 366835514,
 355,
 -1,
 366895114,
 357,
 367072741,
 366617920,
 -1,
 367138276,
 367030561,
 -1,
 -59933,
 367076018,
 7789,
 -1,
 367170440,
 7787,
 -1,
 367084077,
 7831,
 -59930,
 367032697,
 359,
 -59929,
 367375236,
 648,
 -59928,
 367439512,
 427,
 -59927,
 367497606,
 7541,
 -59926,
 367571862,
 7791,
 -1,
 367635287,
 429,
 367793649,
 366556514,
 -1,
 367859184,
 367757389,
 -1,
 -59922,
 367799744,
 424,
 -59921,
 367877206,
 389,
 -1,
 367956152,
 445,
 -1,
 367788896,
 7446,
 368186868,
 367737209,
 -1,
 -59917,
 368117962,
 254,
 -1,
 368209755,
 7546,
 -59915,
 368155152,
 678,
 -59914,
 368317285,
 679,
 -1,
 368418879,
 680,
 368580142,
 364852578,
 111,
 368645671,
 368520644,
 -1,
 368711170,
 368584552,
 -1,
 368776705,
 368655346,
 417,
 368902143,
 368720682,
 -1,
 -59907,
 368805664,
 7905,
 -59906,
 368844370,
 7903,
 -59905,
 368943424,
 7901,
 -59904,
 368992417,
 7907,
 -1,
 369076176,
 7899,
 -1,
 368714099,
 7887,
 369301005,
 368649536,
 -1,
 369366539,
 369243490,
 -1,
 369432072,
 369330785,
 -1,
 369497607,
 369398664,
 559,
 -1,
 369466228,
 561,
 -1,
 369435314,
 7885,
 369754111,
 369382318,
 -1,
 -59894,
 369664320,
 525,
 -1,
 369731536,
 337,
 369950719,
 369312301,
 246,
 -1,
 369859444,
 555,
 370021910,
 369237045,
 -1,
 370087445,
 369973153,
 244,
 370212863,
 370031402,
 -1,
 -59887,
 370116384,
 7895,
 -59886,
 370155090,
 7893,
 -59885,
 370254144,
 7891,
 -59884,
 370303137,
 7897,
 -1,
 370386896,
 7889,
 -1,
 370040842,
 466,
 370611739,
 369985312,
 245,
 370737151,
 370555690,
 -1,
 -59879,
 370606287,
 557,
 -59878,
 370682116,
 7759,
 -1,
 370780112,
 7757,
 370939423,
 370540751,
 333,
 371064831,
 370883370,
 -1,
 -59874,
 370975040,
 7761,
 -1,
 371042256,
 7763,
 371201569,
 370899321,
 248,
 -1,
 371143461,
 511,
 371332643,
 371158516,
 491,
 -1,
 371301236,
 493,
 -59868,
 371305317,
 527,
 -59867,
 371433792,
 242,
 -59866,
 371479464,
 335,
 -1,
 371566544,
 243,
 371725868,
 368594191,
 -1,
 371791402,
 371668322,
 596,
 -1,
 371741620,
 7575,
 371982335,
 371732177,
 603,
 -1,
 371872692,
 7571,
 -59859,
 371701944,
 547,
 -1,
 372002699,
 419,
 372184673,
 368520913,
 101,
 372250193,
 372125124,
 -1,
 372315709,
 372186165,
 -1,
 372381242,
 372266913,
 234,
 372506623,
 372333767,
 -1,
 372512313,
 372418994,
 -1,
 -59851,
 372475680,
 7877,
 -59850,
 372514386,
 7875,
 -59849,
 372613440,
 7873,
 -59848,
 372662433,
 7879,
 -1,
 372746192,
 7871,
 -1,
 372449970,
 7705,
 372971068,
 372340538,
 553,
 -1,
 372922771,
 7709,
 -1,
 372924426,
 283,
 373167684,
 372254016,
 -1,
 373233219,
 373110114,
 -1,
 373298754,
 373197409,
 -1,
 -59839,
 373236402,
 7865,
 -1,
 373330824,
 279,
 -1,
 373254182,
 517,
 -1,
 373178925,
 235,
 373626440,
 373096655,
 275,
 373751807,
 373570346,
 -1,
 -59833,
 373662016,
 7701,
 -1,
 373729232,
 7703,
 373888586,
 373589792,
 7869,
 -1,
 373824471,
 7707,
 -59829,
 373863300,
 7570,
 -59828,
 373976564,
 281,
 -59827,
 374057829,
 519,
 -59826,
 374087250,
 7867,
 -59825,
 374186304,
 232,
 -59824,
 374231976,
 277,
 -1,
 374319056,
 233,
 374478426,
 372180041,
 658,
 374603775,
 374430919,
 -1,
 374609497,
 374479420,
 -1,
 374675031,
 374545461,
 -1,
 -59818,
 374630984,
 659,
 -1,
 374693898,
 495,
 -59816,
 374619811,
 442,
 -1,
 374846340,
 7578,
 -1,
 374541794,
 441,
 375068255,
 374433045,
 643,
 375193599,
 375008708,
 -1,
 -59811,
 375108484,
 7576,
 -59810,
 375172760,
 7563,
 -1,
 375234007,
 646,
 -59808,
 375018113,
 240,
 -1,
 375347060,
 331,
 375527057,
 372116092,
 97,
 375592587,
 375467460,
 -1,
 375658092,
 375528501,
 -1,
 375723627,
 375609249,
 226,
 375848959,
 375667498,
 -1,
 -59801,
 375752480,
 7851,
 -59800,
 375791186,
 7849,
 -59799,
 375890240,
 7847,
 -59798,
 375939233,
 7853,
 -1,
 376022992,
 7845,
 -1,
 375676938,
 462,
 376247925,
 375596352,
 -1,
 376313459,
 376190306,
 -1,
 376378994,
 376277601,
 -1,
 376444529,
 376345480,
 551,
 -1,
 376413044,
 481,
 -1,
 376382130,
 7841,
 -1,
 376334374,
 513,
 376766463,
 376259117,
 228,
 -1,
 376675188,
 479,
 376837756,
 376198056,
 259,
 376963071,
 376781610,
 -1,
 -59784,
 376866592,
 7861,
 -59783,
 376905298,
 7859,
 -59782,
 377004352,
 7857,
 -59781,
 377053345,
 7863,
 -1,
 377137104,
 7855,
 377296516,
 376772363,
 -1,
 377362051,
 377245579,
 -1,
 377427586,
 377318748,
 -1,
 377493121,
 377394056,
 229,
 -1,
 377434917,
 507,
 -1,
 377430706,
 7681,
 -1,
 377362883,
 7834,
 -1,
 377336539,
 7567,
 -59771,
 377259808,
 227,
 -59770,
 377777652,
 261,
 -59769,
 377815247,
 257,
 -59768,
 377924453,
 515,
 -59767,
 377953874,
 7843,
 -59766,
 378052928,
 224,
 -1,
 378120144,
 225,
 378279567,
 375533265,
 230,
 378404863,
 378219972,
 -1,
 -59762,
 378273999,
 483,
 -1,
 378382288,
 509,
 378601471,
 378225807,
 593,
 -1,
 378491828,
 7568,
 378672833,
 375503032,
 117,
 378738366,
 378625223,
 -1,
 378803901,
 378673724,
 -1,
 378869410,
 378742080,
 -1,
 378934941,
 378815021,
 252,
 379060223,
 378887367,
 -1,
 379066012,
 378972594,
 -1,
 -59751,
 378994895,
 470,
 -59750,
 379101504,
 476,
 -59749,
 379162088,
 474,
 -1,
 379234256,
 472,
 -1,
 379003570,
 7795,
 379518975,
 378877282,
 -1,
 379524769,
 379409326,
 -1,
 -59744,
 379494720,
 533,
 -1,
 379561936,
 369,
 -1,
 379469753,
 7909,
 379786923,
 378808168,
 -1,
 379852458,
 379730930,
 432,
 379977727,
 379796266,
 -1,
 -59738,
 379881248,
 7919,
 -59737,
 379919954,
 7917,
 -59736,
 380019008,
 7915,
 -59735,
 380068001,
 7921,
 -1,
 380151760,
 7913,
 -1,
 379789683,
 7911,
 380376751,
 379750176,
 361,
 380502015,
 380329159,
 -1,
 -59730,
 380379826,
 7797,
 -1,
 380474898,
 7801,
 380638899,
 380312629,
 -1,
 380704434,
 380589985,
 251,
 -1,
 380640215,
 7799,
 -1,
 380657674,
 468,
 380901046,
 380573451,
 -1,
 -59723,
 380861916,
 367,
 -1,
 380941019,
 7577,
 381097656,
 380829903,
 363,
 -1,
 381046685,
 7803,
 -59719,
 381054452,
 371,
 -59718,
 381201253,
 535,
 -59717,
 381264192,
 249,
 -59716,
 381309864,
 365,
 -1,
 381396944,
 250,
 -1,
 378746996,
 649,
 381621952,
 378689368,
 650,
 -1,
 381591975,
 7551,
 -1,
 381562577,
 7531,
 381818594,
 378620695,
 115,
 381884115,
 381758916,
 -1,
 381949641,
 381819957,
 -1,
 382015174,
 381902858,
 353,
 -1,
 381987817,
 7783,
 -59705,
 381956964,
 537,
 -59704,
 382097313,
 349,
 -1,
 382170938,
 351,
 382342861,
 381920785,
 -1,
 382408396,
 382280370,
 7779,
 -1,
 382381033,
 7785,
 -1,
 382374792,
 7777,
 382605007,
 382314448,
 347,
 -1,
 382577641,
 7781,
 -59696,
 382549075,
 575,
 -59695,
 382709400,
 7562,
 -59694,
 382767494,
 7540,
 -1,
 382839639,
 642,
 382998234,
 381821072,
 -1,
 383063767,
 382940514,
 7441,
 -59690,
 382996902,
 7442,
 -1,
 383099303,
 7443,
 -59688,
 383039672,
 7453,
 -59687,
 383211169,
 7455,
 -1,
 383297823,
 7454,
 383456992,
 382934069,
 -1,
 383522527,
 383417213,
 601,
 383647743,
 383462852,
 -1,
 -59682,
 383562628,
 7573,
 -1,
 383626071,
 602,
 -1,
 383495698,
 609,
 -59679,
 383387179,
 645,
 -1,
 383818435,
 223,
 383981313,
 381756736,
 100,
 384046837,
 383921604,
 -1,
 384112361,
 383982645,
 -1,
 -59674,
 384068168,
 545,
 -59673,
 384144657,
 7699,
 -59672,
 384202554,
 7697,
 -1,
 384262154,
 271,
 384440044,
 384085954,
 -1,
 -59669,
 384390459,
 396,
 -1,
 384454235,
 598,
 384636654,
 384412503,
 599,
 -1,
 384597887,
 7569,
 384767729,
 384607761,
 -1,
 -59664,
 384705202,
 7693,
 -1,
 384799624,
 7691,
 -59662,
 384727417,
 273,
 -59661,
 384937624,
 7553,
 -59660,
 384995718,
 7533,
 -1,
 385069974,
 7695,
 385226490,
 383986807,
 499,
 385351679,
 385178823,
 -1,
 385357561,
 385236960,
 675,
 -1,
 385308063,
 677,
 -1,
 385311043,
 454,
 385554175,
 385184256,
 -1,
 385619710,
 385505276,
 567,
 385744895,
 385589671,
 607,
 -1,
 385645049,
 644,
 -1,
 385568651,
 305,
 -59648,
 385506486,
 676,
 -1,
 385820751,
 568,
 386012956,
 383937117,
 108,
 386078485,
 385953220,
 -1,
 386144008,
 386014261,
 -1,
 -59643,
 386099784,
 564,
 -59642,
 386176273,
 7741,
 -59641,
 386234170,
 316,
 -1,
 386293770,
 318,
 386471691,
 386105658,
 -1,
 -59638,
 386434848,
 619,
 -1,
 386499462,
 320,
 386668301,
 386424993,
 7735,
 -1,
 386636660,
 7737,
 386799376,
 386601841,
 -1,
 -59633,
 386750539,
 620,
 -1,
 386828816,
 410,
 -59631,
 386759033,
 322,
 -59630,
 386970500,
 621,
 -59629,
 387034776,
 7557,
 -59628,
 387101590,
 7739,
 -1,
 387164112,
 314,
 387323671,
 386013318,
 383,
 -1,
 387284046,
 7835,
 -59624,
 387270997,
 683,
 -59623,
 387422736,
 682,
 -59622,
 387471356,
 457,
 -59621,
 387549928,
 622,
 -1,
 387587637,
 411,
 387782457,
 385947403,
 114,
 387847985,
 387722692,
 -1,
 387913508,
 387793778,
 -1,
 387979043,
 387877473,
 -1,
 388044578,
 387916466,
 7771,
 -1,
 388012916,
 7773,
 -1,
 388010888,
 7769,
 -1,
 387934246,
 529,
 388306727,
 387869277,
 -1,
 -59610,
 388263404,
 636,
 -1,
 388333317,
 7775,
 388503337,
 388267751,
 638,
 -1,
 388435787,
 7539,
 388634412,
 388439093,
 -1,
 -59605,
 388593466,
 343,
 -1,
 388653066,
 345,
 -59603,
 388578979,
 637,
 -59602,
 388804248,
 7561,
 -59601,
 388862342,
 7538,
 -59600,
 388934501,
 531,
 -1,
 388999120,
 341,
 389158712,
 387816274,
 -1,
 389224246,
 389129486,
 604,
 389349375,
 389164484,
 -1,
 -59595,
 389264260,
 7572,
 -1,
 389327703,
 605,
 -59593,
 389191238,
 639,
 -1,
 389426897,
 600,
 -1,
 389130227,
 612,
 389683026,
 387731339,
 105,
 389748559,
 389623236,
 -1,
 389814081,
 389686592,
 -1,
 389879615,
 389756258,
 -1,
 -59586,
 389834790,
 521,
 -1,
 389889977,
 7883,
 390135807,
 389825069,
 239,
 -1,
 390017829,
 7727,
 390207299,
 389777184,
 297,
 -1,
 390142935,
 7725,
 390338374,
 390143029,
 -1,
 -59579,
 390289313,
 238,
 -1,
 390357002,
 464,
 -59577,
 390297977,
 616,
 -59576,
 390509444,
 7574,
 -59575,
 390557172,
 303,
 -59574,
 390594767,
 299,
 -59573,
 390703973,
 523,
 -59572,
 390733394,
 7881,
 -59571,
 390832448,
 236,
 -59570,
 390878120,
 301,
 -1,
 390965200,
 237,
 391124817,
 389706651,
 617,
 -1,
 391094695,
 7548,
 -1,
 391064445,
 7545,
 391321449,
 389643266,
 110,
 391386984,
 391273671,
 -1,
 391452519,
 391322172,
 -1,
 391518042,
 391388213,
 -1,
 -59561,
 391473736,
 565,
 -59560,
 391550225,
 7755,
 -59559,
 391608122,
 326,
 -1,
 391667722,
 328,
 391845726,
 391473757,
 -1,
 -59556,
 391815317,
 414,
 -59555,
 391872261,
 7753,
 -1,
 391910962,
 626,
 392107873,
 391816721,
 -1,
 -59552,
 392045234,
 7751,
 -1,
 392139656,
 7749,
 -59550,
 392070944,
 241,
 -59549,
 392278916,
 627,
 -59548,
 392343192,
 7559,
 -59547,
 392401286,
 7536,
 -59546,
 392470848,
 505,
 -1,
 392538064,
 324,
 -1,
 391409812,
 329,
 -1,
 391337980,
 460,
 392828795,
 391261303,
 122,
 392953855,
 392768964,
 -1,
 392959855,
 392830005,
 -1,
 -59539,
 392915528,
 657,
 -59538,
 392976289,
 7825,
 -1,
 393043978,
 382,
 393222002,
 392907543,
 -1,
 -59535,
 393177298,
 576,
 -1,
 393239642,
 438,
 393418613,
 393192977,
 -1,
 -59532,
 393355954,
 7827,
 -1,
 393450376,
 380,
 -59530,
 393393028,
 656,
 -59529,
 393588376,
 7566,
 -59528,
 393646470,
 7542,
 -59527,
 393720726,
 7829,
 -59526,
 393784151,
 549,
 -1,
 393848784,
 378,
 394008459,
 392766164,
 121,
 394073994,
 393948612,
 -1,
 394139522,
 394011968,
 -1,
 394205057,
 394096929,
 -1,
 -59520,
 394142386,
 7925,
 -1,
 394236808,
 7823,
 -1,
 394150445,
 255,
 394467204,
 394111831,
 436,
 -1,
 394410987,
 7927,
 -59515,
 394430240,
 7929,
 -59514,
 394543041,
 7833,
 -59513,
 394592463,
 563,
 -59512,
 394699072,
 7923,
 -59511,
 394744083,
 375,
 -1,
 394831824,
 253,
 -1,
 394029124,
 541,
 395057052,
 393951609,
 104,
 395122586,
 394997188,
 -1,
 395188114,
 395060544,
 -1,
 395253649,
 395145505,
 -1,
 -59504,
 395190962,
 7717,
 -1,
 395285384,
 7715,
 -1,
 395199021,
 7719,
 395515798,
 395123765,
 -1,
 -59500,
 395466657,
 293,
 -59499,
 395540282,
 7721,
 -1,
 395599882,
 543,
 -59497,
 395475321,
 295,
 -59496,
 395752342,
 7830,
 -59495,
 395815767,
 614,
 -1,
 395874149,
 7723,
 -59493,
 395053083,
 405,
 -1,
 395970736,
 615,
 396171181,
 394992693,
 99,
 396236712,
 396111300,
 -1,
 396302244,
 396172341,
 -1,
 396367777,
 396261178,
 231,
 -1,
 396309285,
 7689,
 -59486,
 396323400,
 597,
 -59485,
 396449697,
 265,
 -1,
 396517386,
 269,
 -59483,
 396261753,
 572,
 -59482,
 396667735,
 392,
 -59481,
 396727460,
 267,
 -1,
 396797904,
 263,
 397017087,
 396211752,
 -1,
 397023148,
 396899682,
 -1,
 -59477,
 396956092,
 666,
 -1,
 397017259,
 631,
 -1,
 396963801,
 606,
 397285307,
 396115781,
 103,
 397350842,
 397225412,
 -1,
 397416371,
 397286453,
 -1,
 -59471,
 397367201,
 285,
 -59470,
 397440826,
 291,
 -1,
 397500426,
 487,
 -59468,
 397375865,
 485,
 -59467,
 397651608,
 7555,
 -59466,
 397672655,
 7713,
 -59465,
 397781847,
 608,
 -59464,
 397841572,
 289,
 -59463,
 397890472,
 287,
 -1,
 397977552,
 501,
 -1,
 397320808,
 611,
 398202824,
 397218673,
 98,
 398268358,
 398142916,
 -1,
 398333888,
 398239249,
 -1,
 -59457,
 398271154,
 7685,
 -1,
 398365576,
 7683,
 -59455,
 398293686,
 387,
 -59454,
 398489977,
 384,
 -59453,
 398569112,
 7552,
 -59452,
 398627206,
 7532,
 -59451,
 398701462,
 7687,
 -1,
 398764887,
 595,
 -59449,
 398237804,
 7447,
 -1,
 398856471,
 629,
 399054803,
 398155888,
 107,
 399120338,
 398994884,
 -1,
 399185869,
 399055925,
 -1,
 -59444,
 399144762,
 311,
 -1,
 399204362,
 489,
 -59442,
 399158936,
 7556,
 -59441,
 399356822,
 7733,
 -59440,
 399420247,
 409,
 -59439,
 399466657,
 7731,
 -1,
 399550416,
 7729,
 -1,
 399092028,
 312,
 399775710,
 398987576,
 119,
 399900671,
 399715780,
 -1,
 399906778,
 399779136,
 -1,
 399972313,
 399864097,
 -1,
 -59432,
 399909554,
 7817,
 -1,
 400003976,
 7815,
 -1,
 399917613,
 7813,
 -59429,
 399851457,
 7832,
 -59428,
 400204096,
 7809,
 -59427,
 400249107,
 373,
 -1,
 400336848,
 7811,
 400496615,
 399740108,
 112,
 400562150,
 400436676,
 -1,
 -59423,
 400521593,
 7549,
 -59422,
 400600728,
 7560,
 -59421,
 400658822,
 7537,
 -59420,
 400730967,
 421,
 -59419,
 400790692,
 7767,
 -1,
 400861136,
 7765,
 -1,
 400500581,
 632,
 401086448,
 400454404,
 109,
 401211391,
 401026500,
 -1,
 401217516,
 401122833,
 -1,
 -59413,
 401154738,
 7747,
 -1,
 401249160,
 7745,
 -59411,
 401190552,
 7558,
 -59410,
 401379718,
 7535,
 -59409,
 401451863,
 625,
 -1,
 401516496,
 7743,
 401676279,
 401028991,
 102,
 401741814,
 401616324,
 -1,
 -59405,
 401714840,
 7554,
 -59404,
 401772934,
 7534,
 -59403,
 401845079,
 402,
 -1,
 401904804,
 7711,
 -1,
 401680632,
 681,
 402135037,
 401606683,
 118,
 402259967,
 402075076,
 -1,
 -59398,
 402163488,
 7805,
 -59397,
 402239128,
 7564,
 -59396,
 402303831,
 651,
 -1,
 402350241,
 7807,
 402528259,
 402069947,
 120,
 402653183,
 402468292,
 -1,
 402659330,
 402531648,
 -1,
 -59391,
 402622930,
 7819,
 -1,
 402670125,
 7821,
 -1,
 402632344,
 7565,
 402921480,
 402479100,
 106,
 403046399,
 402863495,
 -1,
 -59386,
 402947034,
 669,
 -59385,
 403003297,
 309,
 -1,
 403070986,
 496,
 403308543,
 402888225,
 113,
 -59382,
 403209531,
 569,
 -1,
 403280782,
 672,
 403505151,
 364814294,
 -1,
 403511314,
 403388287,
 -1,
 403576848,
 403453823,
 64256,
 -59377,
 403532381,
 64260,
 -1,
 403591051,
 64259,
 -59375,
 403532381,
 64258,
 -1,
 403722123,
 64257,
 -59373,
 403465465,
 64262,
 -59372,
 403866032,
 339,
 -59371,
 403931216,
 64261,
 -1,
 403984316,
 307,
 404226047,
 364720622,
 -1,
 -59368,
 404126187,
 7550,
 -1,
 404171881,
 7547,
 404422655,
 364670700,
 -1,
 -59365,
 404298171,
 8339,
 -59364,
 404359195,
 7525,
 -59363,
 404469944,
 7524,
 -59362,
 404510252,
 8340,
 -59361,
 404559627,
 7523,
 -59360,
 404632930,
 8338,
 -59359,
 404705163,
 7522,
 -59358,
 404762321,
 8337,
 -1,
 404818556,
 8336,
 405019097,
 364583989,
 -1,
 405084632,
 404954432,
 -1,
 405150165,
 405050113,
 -1,
 405215325,
 405091682,
 79,
 405280856,
 405155268,
 -1,
 405346353,
 405219176,
 -1,
 405411888,
 405289970,
 416,
 405536767,
 405355306,
 -1,
 -59348,
 405440288,
 7904,
 -59347,
 405478994,
 7902,
 -59346,
 405578048,
 7900,
 -59345,
 405627041,
 7906,
 -1,
 405710800,
 7898,
 -1,
 405348723,
 7886,
 405936188,
 405284160,
 -1,
 406001722,
 405878114,
 -1,
 406067255,
 405965409,
 -1,
 406132790,
 406033288,
 558,
 -1,
 406100852,
 560,
 -1,
 406069938,
 7884,
 406388735,
 406016942,
 -1,
 -59335,
 406298944,
 524,
 -1,
 406366160,
 336,
 406585343,
 405946925,
 214,
 -1,
 406494068,
 554,
 406657093,
 405871669,
 -1,
 406722628,
 406607777,
 212,
 406847487,
 406666026,
 -1,
 -59328,
 406751008,
 7894,
 -59327,
 406789714,
 7892,
 -59326,
 406888768,
 7890,
 -59325,
 406937761,
 7896,
 -1,
 407021520,
 7888,
 -1,
 406675466,
 465,
 407246922,
 406619936,
 213,
 407371775,
 407190314,
 -1,
 -59320,
 407240911,
 556,
 -59319,
 407316740,
 7758,
 -1,
 407414736,
 7756,
 407574608,
 407204612,
 -1,
 407640143,
 407542232,
 332,
 407764991,
 407583530,
 -1,
 -59314,
 407675200,
 7760,
 -1,
 407742416,
 7762,
 -1,
 407582861,
 415,
 407967826,
 407533945,
 216,
 -1,
 407909157,
 510,
 408098900,
 407924212,
 490,
 -1,
 408066932,
 492,
 -59307,
 408071013,
 526,
 -59306,
 408199488,
 210,
 -59305,
 408245160,
 334,
 -1,
 408332240,
 211,
 408492123,
 405228815,
 -1,
 -59302,
 408434018,
 390,
 -1,
 408497873,
 400,
 -59300,
 408467640,
 546,
 -1,
 408637323,
 418,
 408819849,
 405146236,
 65,
 408885380,
 408759748,
 -1,
 408950888,
 408820789,
 -1,
 409016423,
 408901537,
 194,
 409141247,
 408959786,
 -1,
 -59293,
 409044768,
 7850,
 -59292,
 409083474,
 7848,
 -59291,
 409182528,
 7846,
 -59290,
 409231521,
 7852,
 -1,
 409315280,
 7844,
 -1,
 408969226,
 461,
 409540721,
 408888640,
 -1,
 409606255,
 409482594,
 -1,
 409671790,
 409569889,
 -1,
 409737325,
 409637768,
 550,
 -1,
 409705332,
 480,
 -1,
 409674418,
 7840,
 -1,
 409626662,
 512,
 410058751,
 409551405,
 196,
 -1,
 409967476,
 478,
 410130552,
 409490344,
 258,
 410255359,
 410073898,
 -1,
 -59276,
 410158880,
 7860,
 -59275,
 410197586,
 7858,
 -59274,
 410296640,
 7856,
 -59273,
 410345633,
 7862,
 -1,
 410429392,
 7854,
 410589308,
 410072615,
 -1,
 410654843,
 410555272,
 197,
 -1,
 410596133,
 506,
 -1,
 410591922,
 7680,
 -59267,
 410552096,
 195,
 -59266,
 410810745,
 570,
 -59265,
 410873332,
 260,
 -59264,
 410910927,
 256,
 -59263,
 411020133,
 514,
 -59262,
 411049554,
 7842,
 -59261,
 411148608,
 192,
 -1,
 411215824,
 193,
 411375752,
 408825553,
 198,
 411500543,
 411315652,
 -1,
 -59257,
 411369679,
 482,
 -1,
 411477968,
 508,
 -1,
 411337026,
 393,
 411703475,
 408795320,
 85,
 411769010,
 411643332,
 -1,
 411834521,
 411706688,
 -1,
 411900052,
 411779629,
 220,
 412024831,
 411851975,
 -1,
 412031123,
 411937202,
 -1,
 -59248,
 411959503,
 469,
 -59247,
 412066112,
 475,
 -59246,
 412126696,
 473,
 -1,
 412198864,
 471,
 -1,
 411968178,
 7794,
 412483583,
 411841890,
 -1,
 412489880,
 412373934,
 -1,
 -59241,
 412459328,
 532,
 -1,
 412526544,
 368,
 -1,
 412434361,
 7908,
 412752034,
 411772776,
 -1,
 412817569,
 412695538,
 431,
 412942335,
 412760874,
 -1,
 -59235,
 412845856,
 7918,
 -59234,
 412884562,
 7916,
 -59233,
 412983616,
 7914,
 -59232,
 413032609,
 7920,
 -1,
 413116368,
 7912,
 -1,
 412754291,
 7910,
 413341862,
 412714784,
 360,
 413466623,
 413293767,
 -1,
 -59227,
 413344434,
 7796,
 -1,
 413439506,
 7800,
 413604010,
 413277237,
 -1,
 413669545,
 413554593,
 219,
 -1,
 413604823,
 7798,
 -1,
 413622282,
 467,
 413866156,
 413532367,
 362,
 -1,
 413814685,
 7802,
 -59219,
 413810625,
 366,
 -59218,
 413953524,
 370,
 -59217,
 414034789,
 534,
 -59216,
 414097728,
 217,
 -59215,
 414143400,
 364,
 -1,
 414230480,
 218,
 -1,
 411719512,
 433,
 414456028,
 411643601,
 69,
 414521557,
 414395844,
 -1,
 414587074,
 414456885,
 -1,
 414652607,
 414537633,
 202,
 414777343,
 414604487,
 -1,
 414783678,
 414689714,
 -1,
 -59206,
 414746400,
 7876,
 -59205,
 414785106,
 7874,
 -59204,
 414884160,
 7872,
 -59203,
 414933153,
 7878,
 -1,
 415016912,
 7870,
 -1,
 414720690,
 7704,
 415242433,
 414611258,
 552,
 -1,
 415193491,
 7708,
 -1,
 415195146,
 282,
 415439049,
 414524736,
 -1,
 415504584,
 415380834,
 -1,
 415570119,
 415468129,
 -1,
 -59194,
 415507122,
 7864,
 -1,
 415601544,
 278,
 -1,
 415524902,
 516,
 -1,
 415449645,
 203,
 415897805,
 415367375,
 274,
 416022527,
 415841066,
 -1,
 -59188,
 415932736,
 7700,
 -1,
 415999952,
 7702,
 416159951,
 415860512,
 7868,
 -1,
 416095191,
 7706,
 -59184,
 416116212,
 280,
 -59183,
 416263013,
 518,
 -59182,
 416292434,
 7866,
 -59181,
 416391488,
 200,
 -59180,
 416437160,
 276,
 -1,
 416524240,
 201,
 416684249,
 414450761,
 439,
 416808959,
 416636103,
 -1,
 -59176,
 416702787,
 494,
 -1,
 416746978,
 440,
 -59174,
 416633473,
 208,
 -59173,
 416900373,
 425,
 -1,
 416962420,
 330,
 417143028,
 414404491,
 73,
 417208563,
 417082820,
 -1,
 417274086,
 417146176,
 -1,
 417339620,
 417215842,
 -1,
 417405155,
 417303137,
 -1,
 -59166,
 417342130,
 7882,
 -1,
 417436552,
 304,
 -1,
 417359910,
 520,
 417726463,
 417284653,
 207,
 -1,
 417608485,
 7726,
 417798376,
 417236768,
 296,
 -1,
 417733591,
 7724,
 417929451,
 417733685,
 -1,
 -59158,
 417879969,
 206,
 -1,
 417947658,
 463,
 -59156,
 417888633,
 407,
 -59155,
 418082292,
 302,
 -59154,
 418119887,
 298,
 -59153,
 418229093,
 522,
 -59152,
 418258514,
 7880,
 -59151,
 418357568,
 204,
 -59150,
 418403240,
 300,
 -1,
 418490320,
 205,
 -1,
 417166235,
 406,
 418715914,
 417116098,
 84,
 418781444,
 418655684,
 -1,
 418846971,
 418716725,
 -1,
 -59144,
 418788196,
 538,
 -59143,
 418878737,
 7792,
 -59142,
 418936634,
 354,
 -1,
 418996234,
 356,
 419174656,
 418784576,
 -1,
 419240191,
 419131681,
 -1,
 -59138,
 419177138,
 7788,
 -1,
 419271560,
 7786,
 -1,
 419198922,
 574,
 -59135,
 419133817,
 358,
 -59134,
 419476356,
 430,
 -59133,
 419541910,
 7790,
 -1,
 419605335,
 428,
 419764488,
 418734108,
 -1,
 -59130,
 419704256,
 423,
 -59129,
 419781718,
 388,
 -1,
 419860664,
 444,
 -59127,
 419719820,
 412,
 -1,
 419995045,
 222,
 420157724,
 418675714,
 78,
 420223259,
 420097476,
 -1,
 420288784,
 420178525,
 -1,
 -59122,
 420257941,
 544,
 -59121,
 420314885,
 7752,
 -1,
 420353586,
 413,
 420550932,
 420224053,
 -1,
 -59118,
 420517137,
 7754,
 -59117,
 420575034,
 325,
 -1,
 420634634,
 327,
 420813079,
 420521489,
 -1,
 -59114,
 420750002,
 7750,
 -1,
 420844424,
 7748,
 -59112,
 420775712,
 209,
 -59111,
 420942836,
 459,
 -59110,
 421044544,
 504,
 -1,
 421111760,
 323,
 -1,
 420173820,
 458,
 421337390,
 420095296,
 68,
 421402924,
 421277124,
 -1,
 421468450,
 421350167,
 -1,
 421533985,
 421425360,
 498,
 -1,
 421472384,
 453,
 -1,
 421485658,
 272,
 421730598,
 421403701,
 -1,
 -59100,
 421696785,
 7698,
 -59099,
 421754682,
 7696,
 -1,
 421814282,
 270,
 421992745,
 421701137,
 -1,
 -59096,
 421929650,
 7692,
 -1,
 422024072,
 7690,
 -59094,
 421952182,
 395,
 -59093,
 422163350,
 7694,
 -1,
 422226775,
 394,
 422445055,
 421342327,
 497,
 -1,
 422324352,
 452,
 422517054,
 421292637,
 76,
 422582589,
 422456772,
 -1,
 422648116,
 422517813,
 -1,
 -59086,
 422614289,
 7740,
 -59085,
 422672186,
 315,
 -1,
 422731786,
 317,
 422910263,
 422595351,
 -1,
 -59082,
 422861914,
 321,
 -1,
 422948211,
 456,
 423106873,
 422863009,
 7734,
 -1,
 423074676,
 7736,
 -59078,
 423036278,
 319,
 -59077,
 423211926,
 7738,
 -59076,
 423245940,
 573,
 -1,
 423339984,
 313,
 -1,
 422533116,
 455,
 423565645,
 422453972,
 89,
 423631180,
 423505348,
 -1,
 423696709,
 423568704,
 -1,
 423762244,
 423653665,
 -1,
 -59069,
 423699122,
 7924,
 -1,
 423793544,
 7822,
 -1,
 423707181,
 376,
 424024391,
 423668567,
 435,
 -1,
 423967723,
 7926,
 -59064,
 423986976,
 7928,
 -59063,
 424083663,
 562,
 -59062,
 424190272,
 7922,
 -59061,
 424235283,
 374,
 -1,
 424323024,
 221,
 -1,
 423585860,
 540,
 424548700,
 423512855,
 83,
 424614235,
 424488388,
 -1,
 424679765,
 424549429,
 -1,
 424745298,
 424632330,
 352,
 -1,
 424717289,
 7782,
 -59053,
 424686436,
 536,
 -59052,
 424826785,
 348,
 -1,
 424900410,
 350,
 425072985,
 424650257,
 -1,
 425138520,
 425009842,
 7778,
 -1,
 425110505,
 7784,
 -1,
 425104264,
 7776,
 425394175,
 425043920,
 346,
 -1,
 425307113,
 7780,
 -1,
 424547767,
 399,
 425531754,
 424492869,
 71,
 425597288,
 425471428,
 -1,
 425662818,
 425532469,
 -1,
 -59040,
 425613217,
 284,
 -59039,
 425686842,
 290,
 -1,
 425746442,
 486,
 -59037,
 425621881,
 484,
 -59036,
 425853135,
 7712,
 -59035,
 425962327,
 403,
 -59034,
 426022052,
 288,
 -59033,
 426070952,
 286,
 -1,
 426158032,
 500,
 -59031,
 425540517,
 577,
 -1,
 426287720,
 404,
 426449273,
 425465611,
 82,
 426514808,
 426388932,
 -1,
 426580338,
 426460018,
 -1,
 426645873,
 426543713,
 -1,
 426711408,
 426582706,
 7770,
 -1,
 426679156,
 7772,
 -1,
 426677128,
 7768,
 -1,
 426600486,
 528,
 426973557,
 426515509,
 -1,
 -59020,
 426932026,
 342,
 -1,
 426991626,
 344,
 -59018,
 426947478,
 7774,
 -59017,
 427141989,
 530,
 -1,
 427206608,
 340,
 -1,
 426457450,
 398,
 427432327,
 426391929,
 72,
 427497862,
 427371972,
 -1,
 427563392,
 427435328,
 -1,
 427628927,
 427520289,
 -1,
 -59010,
 427565746,
 7716,
 -1,
 427660168,
 7714,
 -1,
 427573805,
 7718,
 427891076,
 427498549,
 -1,
 -59006,
 427841441,
 292,
 -59005,
 427915066,
 7720,
 -1,
 427974666,
 542,
 -59003,
 427850105,
 294,
 -1,
 428117861,
 7722,
 -1,
 427430852,
 502,
 428349843,
 427371639,
 90,
 428474367,
 428289476,
 -1,
 428480908,
 428385809,
 -1,
 -58997,
 428417714,
 7826,
 -1,
 428512136,
 379,
 428677519,
 428416053,
 -1,
 -58994,
 428627873,
 7824,
 -1,
 428695562,
 381,
 -58992,
 428636537,
 437,
 -58991,
 428848022,
 7828,
 -58990,
 428911447,
 548,
 -1,
 428976080,
 377,
 429136286,
 428284981,
 67,
 429260799,
 429075908,
 -1,
 429267354,
 429136949,
 -1,
 429332888,
 429225786,
 199,
 -1,
 429273893,
 7688,
 -58983,
 429283233,
 264,
 -1,
 429416458,
 268,
 -58981,
 429226361,
 571,
 -58980,
 429566807,
 391,
 -58979,
 429626532,
 266,
 -1,
 429696976,
 262,
 429857193,
 429068600,
 87,
 429922728,
 429796804,
 -1,
 429988261,
 429860160,
 -1,
 430053796,
 429945121,
 -1,
 -58973,
 429990578,
 7816,
 -1,
 430085000,
 7814,
 -1,
 429998637,
 7812,
 -58970,
 429957440,
 7808,
 -58969,
 430264595,
 372,
 -1,
 430352336,
 7810,
 -1,
 429869956,
 503,
 430578098,
 429809776,
 75,
 430702591,
 430517700,
 -1,
 430709166,
 430578741,
 -1,
 -58963,
 430667578,
 310,
 -1,
 430727178,
 488,
 -58961,
 430683030,
 7732,
 -58960,
 430877527,
 408,
 -58959,
 430923937,
 7730,
 -1,
 431007696,
 7728,
 431167930,
 430510961,
 66,
 431292415,
 431107524,
 -1,
 431298999,
 431203857,
 -1,
 -58954,
 431235762,
 7684,
 -1,
 431330184,
 7682,
 -58952,
 431258294,
 386,
 -58951,
 431469462,
 7686,
 -1,
 431532887,
 385,
 431692223,
 431097883,
 86,
 431816703,
 431631812,
 -1,
 -58947,
 431720224,
 7804,
 -58946,
 431795031,
 434,
 -1,
 431841441,
 7806,
 432019908,
 431656140,
 80,
 432144383,
 431959492,
 -1,
 -58942,
 432057175,
 420,
 -58941,
 432116900,
 7766,
 -1,
 432187344,
 7764,
 432347594,
 431977220,
 77,
 432472063,
 432287172,
 -1,
 432478665,
 432383505,
 -1,
 -58936,
 432415410,
 7746,
 -1,
 432509832,
 7744,
 -1,
 432449488,
 7742,
 432740814,
 432282043,
 88,
 432865279,
 432682367,
 -1,
 -58931,
 432769490,
 7818,
 -1,
 432816685,
 7820,
 433002962,
 432682879,
 70,
 433127423,
 432942532,
 -1,
 -58927,
 433040215,
 401,
 -1,
 433099940,
 7710,
 433265108,
 432953340,
 74,
 -1,
 433234365,
 308,
 -1,
 433231393,
 81,
 433520639,
 405118934,
 -1,
 -58921,
 433422768,
 338,
 -1,
 433475516,
 306,
 -1,
 405052075,
 10013,
 433782783,
 404979404,
 -1,
 433789441,
 433670935,
 -1,
 433854976,
 433758966,
 -1,
 433920480,
 433796450,
 7439,
 -58914,
 433895608,
 7445,
 -58913,
 433918374,
 7440,
 -1,
 433991377,
 630,
 434182628,
 433854219,
 640,
 434307071,
 434150226,
 -1,
 -58909,
 434181899,
 7449,
 -1,
 434273282,
 7438,
 434444775,
 434122449,
 7431,
 -58906,
 434373705,
 7459,
 -1,
 434459265,
 7430,
 434641385,
 434417602,
 7451,
 -1,
 434596625,
 7450,
 434772459,
 434596445,
 671,
 -1,
 434741671,
 7436,
 434903533,
 434720651,
 618,
 -1,
 434837584,
 641,
 435034607,
 434847557,
 610,
 -1,
 435000206,
 667,
 435165681,
 434967409,
 665,
 -1,
 435097777,
 7427,
 435296755,
 435096188,
 7424,
 -1,
 435236561,
 7425,
 -58892,
 435235959,
 7458,
 -58891,
 435364564,
 655,
 -58890,
 435425592,
 7457,
 -58889,
 435488795,
 7456,
 -58888,
 435599544,
 7452,
 -58887,
 435653836,
 7448,
 -58886,
 435715074,
 628,
 -58885,
 435778308,
 7437,
 -58884,
 435839088,
 7435,
 -58883,
 435902460,
 7434,
 -58882,
 435960185,
 668,
 -58881,
 436020544,
 7429,
 -1,
 436083765,
 7428,
 -1,
 433785823,
 663,
 436345350,
 433732578,
 -1,
 436410885,
 436290531,
 -1,
 -58876,
 436346264,
 674,
 -1,
 436414694,
 426,
 -1,
 436360023,
 451,
 436673035,
 436317724,
 -1,
 436738570,
 436612764,
 -1,
 -58871,
 436676215,
 684,
 -1,
 436736842,
 664,
 -1,
 436686529,
 685,
 437000717,
 436612045,
 662,
 -1,
 436969895,
 446,
 437131791,
 436955542,
 660,
 -1,
 437100967,
 673,
 437262866,
 437062268,
 -1,
 -58863,
 437190895,
 450,
 -1,
 437276622,
 7461,
 -58861,
 437228796,
 422,
 -58860,
 437392585,
 447,
 -58859,
 437474046,
 7460,
 -58858,
 437564276,
 443,
 -58857,
 437630031,
 661,
 -58856,
 437695760,
 449,
 -1,
 437753620,
 448,
 437918321,
 364543941,
 -1,
 437983809,
 437878476,
 -1,
 438049312,
 437956546,
 -1,
 438114847,
 437988884,
 -1,
 -58850,
 438066490,
 3735,
 -1,
 438125933,
 3734,
 -1,
 438056290,
 3733,
 438376997,
 438013132,
 -1,
 438442532,
 438316564,
 -1,
 -58845,
 438394170,
 3742,
 -1,
 438453613,
 3740,
 -1,
 438383970,
 3739,
 438704681,
 438336514,
 -1,
 -58841,
 438670497,
 3725,
 -58840,
 438711650,
 3737,
 -1,
 438763940,
 3719,
 438966830,
 438657136,
 -1,
 439032365,
 438906388,
 -1,
 -58836,
 438983994,
 3716,
 -1,
 439043437,
 3714,
 -1,
 438973794,
 3713,
 439294513,
 438938689,
 -1,
 -58832,
 439246138,
 3722,
 -1,
 439305581,
 3754,
 439491124,
 439239699,
 -1,
 -58829,
 439466371,
 3749,
 -1,
 439498272,
 3747,
 439687735,
 439430676,
 -1,
 -58826,
 439639354,
 3758,
 -1,
 439698797,
 3755,
 439884346,
 439634403,
 -1,
 -58823,
 439835962,
 3741,
 -1,
 439895405,
 3743,
 -58821,
 439850145,
 3746,
 -58820,
 440026732,
 3751,
 -58819,
 440087906,
 3757,
 -58818,
 440153528,
 3745,
 -58817,
 440222578,
 3732,
 -58816,
 440278894,
 3720,
 -1,
 440380953,
 3738,
 440539731,
 437932275,
 -1,
 440605255,
 440470140,
 3760,
 -58812,
 440541908,
 3779,
 -58811,
 440627972,
 3763,
 -58810,
 440684427,
 3780,
 -1,
 440732284,
 3762,
 440932937,
 440541908,
 3766,
 -1,
 440869588,
 3767,
 441064011,
 440907960,
 3768,
 -1,
 441039032,
 3769,
 441195086,
 441026631,
 -1,
 -58803,
 441155969,
 3771,
 -1,
 441223679,
 3761,
 441391696,
 441143179,
 3764,
 -1,
 441339787,
 3765,
 441522770,
 441331409,
 3776,
 -1,
 441470859,
 3777,
 -1,
 441464162,
 3778,
 441719393,
 440509539,
 -1,
 441784919,
 441692098,
 -1,
 -58794,
 441730668,
 3794,
 -1,
 441795503,
 3795,
 441981530,
 441731863,
 -1,
 -58791,
 441929567,
 3798,
 -1,
 441976901,
 3799,
 442178141,
 441923455,
 -1,
 -58788,
 442131380,
 3796,
 -1,
 442205372,
 3797,
 -58786,
 442113974,
 3792,
 -58785,
 442305064,
 3793,
 -58784,
 442410518,
 3801,
 -1,
 442449643,
 3800,
 442636903,
 441680804,
 -1,
 442702437,
 442609602,
 -1,
 -58780,
 442650507,
 3786,
 -1,
 442705768,
 3785,
 -58778,
 442657979,
 3784,
 -1,
 442859965,
 3787,
 443030122,
 442612158,
 -1,
 -58775,
 442957920,
 3773,
 -1,
 443026231,
 3772,
 443226733,
 442969620,
 -1,
 -58772,
 443176789,
 3804,
 -1,
 443233720,
 3805,
 -58770,
 443187778,
 3789,
 -58769,
 443359536,
 3782,
 -58768,
 443449545,
 3759,
 -1,
 443504210,
 3788,
 443685498,
 437864719,
 -1,
 443751032,
 443636935,
 -1,
 -58764,
 443725172,
 10200,
 -58763,
 443782835,
 11004,
 -58762,
 443855923,
 10782,
 -58761,
 443921348,
 10201,
 -1,
 443971393,
 9711,
 444203007,
 443725228,
 10923,
 -1,
 444097628,
 10925,
 -58757,
 443614002,
 9790,
 -1,
 444238002,
 917505,
 444406765,
 364466059,
 -1,
 444472201,
 444356465,
 -1,
 444537730,
 444420801,
 -1,
 444603151,
 444493282,
 -1,
 444668653,
 444535665,
 -1,
 444734159,
 444610894,
 -1,
 444799638,
 444674565,
 -1,
 444865159,
 444750427,
 -1,
 -58747,
 444825580,
 65669,
 -58746,
 444859274,
 65668,
 -1,
 444945072,
 65667,
 445127306,
 444825107,
 -1,
 -58743,
 445073564,
 65677,
 -1,
 445135883,
 65676,
 445323917,
 445085089,
 -1,
 -58740,
 445255131,
 65675,
 -1,
 445333492,
 65674,
 445520528,
 445279369,
 -1,
 -58737,
 445467694,
 65673,
 -1,
 445554586,
 65672,
 445717139,
 445473714,
 -1,
 -58734,
 445664059,
 65671,
 -1,
 445736659,
 65670,
 -58732,
 445679717,
 65666,
 -58731,
 445848911,
 65665,
 -1,
 445932929,
 65664,
 446110369,
 444752818,
 -1,
 -58728,
 446070291,
 65713,
 -58727,
 446133665,
 65712,
 -58726,
 446196873,
 65711,
 -58725,
 446260146,
 65710,
 -58724,
 446323291,
 65709,
 -58723,
 446386720,
 65708,
 -58722,
 446450015,
 65707,
 -58721,
 446529971,
 65706,
 -58720,
 446576974,
 65705,
 -1,
 446640645,
 65704,
 446831275,
 446065801,
 -1,
 -58717,
 446791187,
 65722,
 -58716,
 446854561,
 65721,
 -58715,
 446917769,
 65720,
 -58714,
 446967110,
 65719,
 -58713,
 447042080,
 65718,
 -58712,
 447129505,
 65717,
 -58711,
 447168948,
 65716,
 -58710,
 447232334,
 65715,
 -1,
 447296005,
 65714,
 447486644,
 446782043,
 -1,
 -58707,
 447455760,
 65703,
 -58706,
 447509921,
 65702,
 -58705,
 447573129,
 65701,
 -58704,
 447631904,
 65699,
 -58703,
 447695307,
 65698,
 -58702,
 447758772,
 65697,
 -58701,
 447836821,
 65696,
 -1,
 447885829,
 65695,
 448076476,
 447444385,
 -1,
 -58698,
 448036371,
 65729,
 -58697,
 448092763,
 65728,
 -58696,
 448156192,
 65727,
 -58695,
 448219595,
 65726,
 -58694,
 448283060,
 65725,
 -58693,
 448346446,
 65724,
 -1,
 448410117,
 65723,
 448600770,
 448025120,
 -1,
 -58690,
 448553906,
 65694,
 -58689,
 448602117,
 65693,
 -58688,
 448676276,
 65692,
 -58687,
 448730713,
 65691,
 -1,
 448809123,
 65690,
 448993992,
 448545204,
 -1,
 -58684,
 448942758,
 65682,
 -58683,
 449004500,
 65681,
 -58682,
 449097909,
 65680,
 -58681,
 449164051,
 65679,
 -1,
 449208010,
 65678,
 449387212,
 448940491,
 -1,
 -58678,
 449331636,
 65687,
 -58677,
 449399288,
 65686,
 -1,
 449486103,
 65685,
 449708031,
 449347091,
 -1,
 -58674,
 449624026,
 65731,
 -1,
 449655301,
 65730,
 449904639,
 444678580,
 -1,
 449911514,
 449796699,
 -1,
 -58670,
 449871379,
 65757,
 -58669,
 449934753,
 65756,
 -58668,
 449997961,
 65755,
 -58667,
 450061234,
 65754,
 -58666,
 450124379,
 65753,
 -58665,
 450172676,
 65752,
 -58664,
 450251211,
 65751,
 -58663,
 450314676,
 65750,
 -1,
 450378062,
 65749,
 450566883,
 449860128,
 -1,
 -58660,
 450526739,
 65748,
 -58659,
 450590113,
 65747,
 -58658,
 450651058,
 65745,
 -58657,
 450714203,
 65744,
 -58656,
 450791882,
 65743,
 -58655,
 450838184,
 65742,
 -58654,
 450894663,
 65741,
 -1,
 450983194,
 65740,
 451156714,
 450513355,
 -1,
 -58651,
 451109810,
 65739,
 -58650,
 451170848,
 65738,
 -58649,
 451231206,
 65737,
 -58648,
 451297716,
 65736,
 -58647,
 451380659,
 65735,
 -1,
 451445078,
 65734,
 451674111,
 451101108,
 -1,
 -58644,
 451569736,
 65733,
 -1,
 451633135,
 65732,
 451870719,
 444621969,
 -1,
 451877645,
 451756468,
 -1,
 451943162,
 451819854,
 -1,
 -58639,
 451902995,
 65778,
 -58638,
 451966369,
 65777,
 -58637,
 452029577,
 65776,
 -58636,
 452092850,
 65775,
 -58635,
 452155995,
 65774,
 -58634,
 452219424,
 65773,
 -58633,
 452282827,
 65772,
 -58632,
 452346292,
 65771,
 -58631,
 452409678,
 65770,
 -1,
 452473349,
 65769,
 452664069,
 451883525,
 -1,
 -58628,
 452623891,
 65768,
 -58627,
 452687265,
 65767,
 -58626,
 452750473,
 65766,
 -58625,
 452813746,
 65765,
 -58624,
 452876891,
 65764,
 -58623,
 452940320,
 65763,
 -58622,
 453003723,
 65762,
 -58621,
 453067188,
 65761,
 -58620,
 453130574,
 65760,
 -1,
 453194245,
 65759,
 453384972,
 452608436,
 -1,
 -58617,
 453344787,
 65784,
 -58616,
 453408161,
 65783,
 -58615,
 453471369,
 65782,
 -58614,
 453534642,
 65781,
 -58613,
 453591476,
 65780,
 -1,
 453654862,
 65779,
 -1,
 453322329,
 65785,
 -58610,
 451839059,
 65786,
 -1,
 453848428,
 65758,
 454040440,
 444556421,
 -1,
 454105957,
 453988526,
 -1,
 454171419,
 454061193,
 -1,
 -58605,
 454113823,
 65572,
 -58604,
 454185534,
 65551,
 -58603,
 454244748,
 65608,
 -58602,
 454322264,
 65592,
 -58601,
 454376912,
 65597,
 -58600,
 454462230,
 65558,
 -58599,
 454518194,
 65567,
 -58598,
 454580642,
 65603,
 -1,
 454664287,
 65554,
 454826789,
 454122075,
 -1,
 -58595,
 454775521,
 65586,
 -58594,
 454853398,
 65585,
 -58593,
 454932590,
 65546,
 -58592,
 454985594,
 65565,
 -58591,
 455042647,
 65591,
 -58590,
 455086439,
 65578,
 -58589,
 455153647,
 65564,
 -58588,
 455214599,
 65545,
 -1,
 455323861,
 65570,
 455482159,
 454771124,
 -1,
 -58585,
 455429459,
 65606,
 -58584,
 455487032,
 65538,
 -58583,
 455543112,
 65577,
 -58582,
 455607878,
 65580,
 -58581,
 455688680,
 65600,
 -58580,
 455745959,
 65562,
 -58579,
 455838319,
 65560,
 -58578,
 455894445,
 65573,
 -1,
 455965445,
 65599,
 456137529,
 455422469,
 -1,
 -58575,
 456075932,
 65582,
 -58574,
 456133400,
 65536,
 -58573,
 456215907,
 65543,
 -58572,
 456269405,
 65561,
 -58571,
 456327398,
 65589,
 -58570,
 456409810,
 65587,
 -58569,
 456469783,
 65566,
 -58568,
 456543182,
 65579,
 -1,
 456590923,
 65541,
 456792898,
 456090546,
 -1,
 -58565,
 456752819,
 65590,
 -58564,
 456816651,
 65610,
 -58563,
 456872139,
 65553,
 -58562,
 456938866,
 65611,
 -58561,
 456983138,
 65550,
 -58560,
 457085742,
 65607,
 -58559,
 457161166,
 65539,
 -1,
 457183725,
 65576,
 457382731,
 456741408,
 -1,
 -58556,
 457342116,
 65605,
 -58555,
 457396664,
 65547,
 -58554,
 457485045,
 65542,
 -58553,
 457532754,
 65552,
 -58552,
 457573127,
 65601,
 -58551,
 457669244,
 65594,
 -58550,
 457736147,
 65583,
 -1,
 457790860,
 65593,
 457972564,
 457329099,
 -1,
 -58547,
 457900307,
 65568,
 -58546,
 457968412,
 65537,
 -58545,
 458056462,
 65588,
 -58544,
 458117619,
 65549,
 -58543,
 458196494,
 65609,
 -58542,
 458266350,
 65574,
 -58541,
 458326029,
 65581,
 -1,
 458363194,
 65563,
 458562397,
 457914702,
 -1,
 -58538,
 458495807,
 65596,
 -58537,
 458566197,
 65571,
 -58536,
 458644649,
 65559,
 -58535,
 458708764,
 65544,
 -58534,
 458787555,
 65557,
 -58533,
 458840875,
 65584,
 -58532,
 458913335,
 65569,
 -1,
 458987889,
 65540,
 459152226,
 458519969,
 -1,
 -58529,
 459080886,
 65612,
 -58528,
 459161895,
 65602,
 -58527,
 459223503,
 65555,
 -1,
 459276379,
 65556,
 459538431,
 459111955,
 -1,
 -58524,
 459443952,
 65613,
 -1,
 459478241,
 65604,
 459735039,
 454038558,
 -1,
 459742059,
 459634081,
 -1,
 -58520,
 459701779,
 65629,
 -58519,
 459760562,
 65628,
 -58518,
 459819467,
 65627,
 -1,
 459882932,
 65626,
 460069742,
 459695026,
 -1,
 -58515,
 460018208,
 65624,
 -1,
 460081611,
 65623,
 460266353,
 460018208,
 -1,
 -58512,
 460226067,
 65621,
 -1,
 460287113,
 65620,
 460462964,
 460208462,
 -1,
 -58509,
 460422675,
 65617,
 -1,
 460486049,
 65616,
 -58507,
 460419906,
 65625,
 -58506,
 460596822,
 65622,
 -58505,
 460689782,
 65619,
 -1,
 460745064,
 65618,
 460980223,
 453975082,
 -1,
 460987265,
 460863822,
 -1,
 461052797,
 460933579,
 -1,
 -58500,
 460984109,
 65689,
 -1,
 461072922,
 65688,
 461249408,
 460997044,
 -1,
 -58497,
 461213088,
 65684,
 -1,
 461278181,
 65683,
 -1,
 461183132,
 65700,
 -1,
 460923293,
 65746,
 461635583,
 444488903,
 -1,
 461642632,
 461548282,
 -1,
 461708167,
 461576764,
 -1,
 -58490,
 461641401,
 10771,
 -1,
 461716156,
 10770,
 -1,
 461660519,
 10772,
 -1,
 461584037,
 8232,
 462035940,
 444429060,
 -1,
 462101475,
 461970611,
 -1,
 462166962,
 462061260,
 -1,
 462232464,
 462113559,
 -1,
 -58482,
 462185795,
 6426,
 -58481,
 462235548,
 6425,
 -1,
 462293628,
 6427,
 462494610,
 462197406,
 6421,
 -1,
 462453762,
 6410,
 462625685,
 462467010,
 -1,
 -58476,
 462563228,
 6412,
 -1,
 462621308,
 6411,
 462822296,
 462589132,
 -1,
 -58473,
 462759836,
 6417,
 -1,
 462817916,
 6416,
 463018907,
 462781442,
 -1,
 -58470,
 462946716,
 6405,
 -1,
 463014524,
 6415,
 463215518,
 462970992,
 -1,
 -58467,
 463153052,
 6402,
 -1,
 463211132,
 6401,
 463412129,
 463165436,
 -1,
 -58464,
 463349660,
 6409,
 -1,
 463407740,
 6408,
 463608740,
 463355717,
 -1,
 -58461,
 463546268,
 6404,
 -1,
 463604348,
 6403,
 463805351,
 463545664,
 -1,
 -58458,
 463742876,
 6414,
 -1,
 463800956,
 6413,
 464001962,
 463739957,
 -1,
 -58455,
 463939484,
 6407,
 -1,
 463997564,
 6406,
 464198573,
 463934321,
 -1,
 -58452,
 464136092,
 6419,
 -1,
 464194172,
 6418,
 -58450,
 464143973,
 6424,
 -58449,
 464365884,
 6422,
 -58448,
 464401830,
 6420,
 -58447,
 464456154,
 6423,
 -1,
 464529308,
 6428,
 464722887,
 462113559,
 -1,
 464788414,
 464689655,
 -1,
 464853943,
 464747522,
 -1,
 -58442,
 464781724,
 6449,
 -1,
 464849532,
 6452,
 -58440,
 464816558,
 6451,
 -58439,
 465021244,
 6455,
 -58438,
 465061718,
 6453,
 -58437,
 465122726,
 6454,
 -58436,
 465177050,
 6456,
 -58435,
 465280781,
 6448,
 -1,
 465313111,
 6450,
 465509315,
 464747364,
 -1,
 -58432,
 465440180,
 6459,
 -58431,
 465539807,
 6457,
 -58430,
 465576226,
 6464,
 -1,
 465650119,
 6458,
 465895423,
 465467956,
 -1,
 -58427,
 465801886,
 6441,
 -58426,
 465847909,
 6443,
 -1,
 465938748,
 6442,
 466099155,
 464687027,
 -1,
 466164690,
 466059327,
 -1,
 466230220,
 466094716,
 6432,
 -58421,
 466204856,
 6438,
 -1,
 466243467,
 6436,
 466426830,
 466171234,
 6440,
 -1,
 466367842,
 6437,
 466557904,
 466366161,
 6439,
 -1,
 466497233,
 6435,
 -58415,
 466532536,
 6434,
 -1,
 466636683,
 6433,
 -1,
 466104221,
 6400,
 466885601,
 466068579,
 -1,
 466951127,
 466857922,
 -1,
 -58410,
 466896492,
 6472,
 -1,
 466961327,
 6473,
 467147738,
 466897687,
 -1,
 -58407,
 467095391,
 6476,
 -1,
 467142725,
 6477,
 467344349,
 467089279,
 -1,
 -58404,
 467297204,
 6474,
 -1,
 467371196,
 6475,
 -58402,
 467279798,
 6470,
 -58401,
 467470888,
 6471,
 -58400,
 467576342,
 6479,
 -1,
 467615467,
 6478,
 -58398,
 466820473,
 6469,
 -1,
 467745672,
 6468,
 -1,
 462056405,
 13007,
 467999723,
 461989989,
 -1,
 468065258,
 467950791,
 -1,
 -58393,
 468024701,
 10072,
 -58392,
 468083358,
 9617,
 -58391,
 468150503,
 10099,
 -1,
 468226237,
 10098,
 -1,
 468035106,
 9735,
 -58388,
 467963374,
 8356,
 -1,
 468397405,
 9806,
 468589787,
 444346065,
 -1,
 468655284,
 468554174,
 -1,
 468720735,
 468606151,
 -1,
 468786178,
 468667159,
 -1,
 468851708,
 468751226,
 91,
 468975615,
 468802759,
 -1,
 468982777,
 468851260,
 -1,
 469048311,
 468912742,
 -1,
 -58378,
 468985154,
 10637,
 -1,
 469075539,
 10639,
 -58376,
 468977213,
 10635,
 -1,
 469204846,
 8261,
 -58374,
 468911986,
 9121,
 -58373,
 469320465,
 9123,
 -1,
 469409759,
 9122,
 469572607,
 468790993,
 -1,
 -58370,
 469530927,
 9609,
 -1,
 469598447,
 8907,
 -58368,
 469535759,
 11778,
 -58367,
 469708060,
 8216,
 -1,
 469777827,
 10181,
 469965845,
 468719371,
 -1,
 470031380,
 469936718,
 -1,
 470096907,
 470003652,
 8596,
 470220799,
 470047943,
 -1,
 470227978,
 470096444,
 -1,
 -58360,
 470163940,
 8697,
 -58359,
 470251897,
 8622,
 -1,
 470312740,
 8700,
 -1,
 470179218,
 10568,
 470555663,
 470061433,
 8660,
 470679551,
 470494660,
 -1,
 -58354,
 470557156,
 10500,
 -1,
 470645113,
 8654,
 470817810,
 470487352,
 -1,
 -58351,
 470774497,
 11012,
 -1,
 470836504,
 8621,
 -58349,
 470792122,
 8703,
 -1,
 470961032,
 11020,
 -1,
 469969757,
 11788,
 471211039,
 469897528,
 -1,
 471276574,
 471154746,
 -1,
 471342106,
 471211061,
 -1,
 -58343,
 471290360,
 10627,
 -1,
 471353242,
 12302,
 -58341,
 471285349,
 12312,
 -58340,
 471492235,
 12314,
 -58339,
 471560233,
 10629,
 -1,
 471598753,
 12310,
 -1,
 471241989,
 10712,
 471866408,
 471183298,
 -1,
 471931939,
 471799563,
 -1,
 -58334,
 471905991,
 10703,
 -1,
 471958150,
 11785,
 472128550,
 471882117,
 -1,
 -58331,
 472080530,
 9610,
 -1,
 472125528,
 9613,
 -58329,
 472091113,
 12308,
 -1,
 472287590,
 8867,
 472456240,
 471800885,
 -1,
 472521774,
 472404472,
 123,
 472645631,
 472472775,
 -1,
 -58324,
 472532255,
 9127,
 -58323,
 472613994,
 9128,
 -1,
 472682899,
 9129,
 -58321,
 472467354,
 12300,
 -1,
 472823727,
 8968,
 472980539,
 472388465,
 -1,
 473046072,
 472943626,
 -1,
 473111605,
 473020134,
 -1,
 -58316,
 473039032,
 10574,
 -1,
 473134469,
 10570,
 473366527,
 473066436,
 -1,
 -58313,
 473235640,
 10571,
 -1,
 473331077,
 10576,
 473563135,
 473005665,
 -1,
 -58310,
 473448037,
 10647,
 -1,
 473499297,
 12304,
 473701443,
 472910460,
 -1,
 473766978,
 473660418,
 -1,
 473832511,
 473739883,
 12296,
 -1,
 473774896,
 10641,
 474021887,
 473796614,
 -1,
 -58303,
 473899704,
 10203,
 -1,
 473976058,
 10202,
 -1,
 473703757,
 10643,
 474225736,
 473657385,
 40,
 474349567,
 474176711,
 -1,
 -58298,
 474236191,
 9115,
 -58297,
 474321299,
 9117,
 -1,
 474390495,
 9116,
 474553422,
 474170226,
 -1,
 474618957,
 474502062,
 -1,
 -58293,
 474585512,
 10714,
 -58292,
 474645623,
 8220,
 -1,
 474680781,
 12298,
 -1,
 474578458,
 11780,
 474946643,
 474494306,
 -1,
 475012178,
 474908749,
 -1,
 -58287,
 474947670,
 9614,
 -1,
 475027057,
 9615,
 -1,
 474962061,
 10197,
 475274328,
 474888063,
 -1,
 475339863,
 475221899,
 -1,
 -58282,
 475275068,
 9611,
 -1,
 475342081,
 10620,
 -1,
 475291349,
 8970,
 475602011,
 475248784,
 -1,
 -58278,
 475568820,
 9612,
 -1,
 475639651,
 9686,
 -58276,
 475549904,
 9144,
 -58275,
 475736497,
 8905,
 -58274,
 475815659,
 10204,
 -1,
 475876026,
 11804,
 476060840,
 468687083,
 -1,
 476126333,
 476032964,
 8592,
 476191868,
 476077255,
 -1,
 476257390,
 476125756,
 -1,
 476322920,
 476229570,
 -1,
 476388455,
 476276841,
 -1,
 -58266,
 476331396,
 11025,
 -1,
 476390413,
 11024,
 -1,
 476335707,
 8610,
 -58263,
 476258788,
 8695,
 -58262,
 476608889,
 8602,
 -58261,
 476684685,
 10566,
 -58260,
 476713388,
 8619,
 -58259,
 476818263,
 8617,
 -1,
 476866340,
 8698,
 477043830,
 476229570,
 -1,
 477109363,
 477017287,
 -1,
 477174898,
 477071888,
 8676,
 -1,
 477130741,
 8633,
 -1,
 477131905,
 10525,
 477429759,
 477059974,
 -1,
 -58251,
 477323905,
 10618,
 -1,
 477382704,
 10615,
 477568120,
 477014031,
 8612,
 -1,
 477509267,
 10527,
 477699195,
 477539570,
 -1,
 -58246,
 477658344,
 10611,
 -1,
 477728751,
 10563,
 -1,
 477664854,
 8646,
 -1,
 476126888,
 10521,
 478026897,
 476059925,
 -1,
 478092432,
 477990365,
 -1,
 478157961,
 478057679,
 -1,
 478223496,
 478108871,
 -1,
 478289030,
 478194930,
 -1,
 478354565,
 478243421,
 -1,
 -58236,
 478300894,
 10602,
 -1,
 478394347,
 10594,
 -1,
 478300354,
 10598,
 -58233,
 478252534,
 10578,
 -1,
 478586895,
 10586,
 -1,
 478161925,
 8636,
 478871551,
 478130384,
 -1,
 478878863,
 478764231,
 -1,
 -58228,
 478842358,
 10582,
 -58227,
 478914575,
 10590,
 -58226,
 478984095,
 10603,
 -1,
 479018691,
 10599,
 -1,
 478817285,
 8637,
 -1,
 478040459,
 8651,
 479337628,
 477963584,
 -1,
 479403163,
 479282959,
 -1,
 479468698,
 479375300,
 8656,
 479534233,
 479419591,
 -1,
 479599768,
 479468092,
 -1,
 -58217,
 479535588,
 10498,
 -1,
 479623545,
 8653,
 -1,
 479569935,
 10502,
 -1,
 479469224,
 10523,
 -1,
 479413913,
 10508,
 -1,
 479354483,
 8672,
 480058529,
 479309762,
 -1,
 480124064,
 480009670,
 -1,
 -58209,
 480069273,
 10510,
 -1,
 480161732,
 8666,
 -1,
 480054143,
 8606,
 480386212,
 479990072,
 -1,
 -58205,
 480342753,
 8678,
 -1,
 480404760,
 8604,
 -58203,
 480335584,
 8668,
 -58202,
 480535176,
 8647,
 -58201,
 480622522,
 8701,
 -1,
 480660360,
 11013,
 480903167,
 475993484,
 -1,
 480910509,
 480786126,
 -1,
 -58197,
 480860796,
 8237,
 -58196,
 480941056,
 8206,
 -1,
 480973298,
 8234,
 481172657,
 480856980,
 -1,
 -58193,
 481105775,
 171,
 -58192,
 481182111,
 10748,
 -1,
 481234381,
 9001,
 481492991,
 481118999,
 -1,
 -58189,
 481394846,
 10553,
 -1,
 481467525,
 10154,
 481631450,
 468591512,
 -1,
 481696962,
 481572194,
 -1,
 481762497,
 481639577,
 -1,
 481828028,
 481712773,
 10877,
 481951743,
 481769478,
 -1,
 481959099,
 481858440,
 10881,
 -1,
 481902385,
 10883,
 -1,
 481933660,
 10879,
 482155711,
 481773526,
 -1,
 -58178,
 482106791,
 8818,
 -1,
 482152131,
 8804,
 -58176,
 482120140,
 8822,
 -1,
 482288663,
 10885,
 -1,
 481716566,
 8806,
 482548943,
 481626748,
 -1,
 482614476,
 482478723,
 -1,
 482680009,
 482560791,
 -1,
 482745544,
 482607280,
 -1,
 -58169,
 482692857,
 10893,
 -1,
 482754733,
 10895,
 -1,
 482689590,
 10899,
 -58166,
 482649571,
 10614,
 -58165,
 482974410,
 10897,
 -1,
 483044515,
 10891,
 483262463,
 482573152,
 -1,
 -58162,
 483139056,
 10887,
 -1,
 483203993,
 10889,
 483400915,
 482482748,
 -1,
 -58159,
 483357605,
 10875,
 -58158,
 483427206,
 8918,
 -1,
 483485401,
 10873,
 483663061,
 483346175,
 10918,
 -1,
 483627029,
 10920,
 483794136,
 483610772,
 -1,
 -58153,
 483745191,
 8934,
 -1,
 483790531,
 8808,
 -58151,
 483727770,
 60,
 -1,
 483926475,
 8922,
 -1,
 481572194,
 9804,
 484187433,
 468530530,
 -1,
 484252924,
 484118840,
 -1,
 484318456,
 484194956,
 -1,
 484383975,
 484282865,
 -1,
 484449506,
 484330263,
 -1,
 -58143,
 484420136,
 10065,
 -1,
 484454723,
 10558,
 -58141,
 484417485,
 9727,
 -58140,
 484602458,
 9694,
 -58139,
 484644019,
 9998,
 -58138,
 484737863,
 10063,
 -1,
 484795557,
 10195,
 484973803,
 484337746,
 -1,
 -58135,
 484941773,
 9722,
 -58134,
 484968477,
 10559,
 -1,
 485061210,
 9695,
 485235951,
 484914884,
 -1,
 -58131,
 485178556,
 9691,
 -58130,
 485259073,
 9697,
 -1,
 485327606,
 9604,
 485498098,
 485193146,
 -1,
 -58127,
 485449874,
 9606,
 -1,
 485494872,
 9603,
 485694709,
 485449756,
 -1,
 -58124,
 485630038,
 9602,
 -1,
 485709425,
 9601,
 -58122,
 485629150,
 9607,
 -58121,
 485851642,
 9605,
 -1,
 485923427,
 9987,
 486146047,
 484269255,
 -1,
 -58118,
 486041903,
 95,
 -58117,
 486096625,
 12319,
 -1,
 486158089,
 8270,
 486350097,
 484207964,
 -1,
 486415624,
 486302667,
 -1,
 486481155,
 486381803,
 -1,
 486546689,
 486445433,
 10232,
 -1,
 486488098,
 10237,
 486735871,
 486518724,
 10229,
 -1,
 486619170,
 10235,
 486866943,
 486431943,
 -1,
 486874375,
 486773233,
 -1,
 -58106,
 486838649,
 10234,
 -1,
 486911940,
 10231,
 -1,
 486810296,
 10206,
 487136528,
 486384182,
 -1,
 487202063,
 487102699,
 -1,
 487267596,
 487166329,
 10233,
 -1,
 487208994,
 10238,
 487398670,
 487239620,
 10230,
 -1,
 487340066,
 10236,
 -1,
 487347936,
 10239,
 -1,
 487148341,
 10205,
 -1,
 487101508,
 10982,
 487726375,
 486283793,
 -1,
 487791901,
 487686672,
 8744,
 487915519,
 487742663,
 -1,
 487922972,
 487791164,
 -1,
 487988506,
 487867250,
 -1,
 488054041,
 487936942,
 -1,
 -58088,
 487982653,
 10851,
 -1,
 488059812,
 10850,
 -1,
 487990922,
 10834,
 -58085,
 487934345,
 10843,
 -1,
 488257126,
 10845,
 -1,
 487859972,
 10841,
 488570879,
 487750115,
 8743,
 488636415,
 488451524,
 -1,
 488643876,
 488522610,
 -1,
 488709411,
 488592302,
 -1,
 -58078,
 488638013,
 10848,
 -1,
 488715172,
 10846,
 -1,
 488646282,
 10833,
 -58075,
 488572477,
 10847,
 -58074,
 488917385,
 10842,
 -1,
 488978022,
 10844,
 489226239,
 487693806,
 9674,
 -1,
 489097476,
 10208,
 -1,
 484124626,
 8468,
 489366672,
 364382844,
 -1,
 489431962,
 489297675,
 -1,
 489497365,
 489386405,
 -1,
 489562887,
 489446599,
 -1,
 489628307,
 489515613,
 -1,
 489693239,
 489594838,
 -1,
 489758152,
 489638679,
 -1,
 489823604,
 489699705,
 -1,
 489889125,
 489765062,
 -1,
 489954626,
 489830777,
 -1,
 490020159,
 489905210,
 -1,
 490085690,
 489953852,
 -1,
 490151225,
 490058369,
 -1,
 -58056,
 490096602,
 64872,
 -1,
 490190923,
 64871,
 -1,
 490123216,
 64938,
 490413373,
 490033035,
 -1,
 -58052,
 490372510,
 64778,
 -1,
 490437852,
 64814,
 -58050,
 490348644,
 64824,
 -1,
 490584139,
 64806,
 490799103,
 489982982,
 -1,
 -58047,
 490676324,
 64746,
 -1,
 490751962,
 64818,
 490937679,
 489927297,
 -1,
 491003210,
 490871356,
 -1,
 491068743,
 490975873,
 -1,
 -58042,
 491014106,
 64877,
 -1,
 491108427,
 64876,
 491323391,
 491039617,
 -1,
 -58039,
 491210714,
 64875,
 -1,
 491305035,
 64874,
 491461965,
 490950539,
 -1,
 -58036,
 491421086,
 64780,
 -1,
 491486428,
 64816,
 -58034,
 491397220,
 64745,
 -1,
 491632715,
 64808,
 491789654,
 490890003,
 -1,
 491855187,
 491736971,
 -1,
 -58030,
 491814302,
 64777,
 -1,
 491879644,
 64813,
 -58028,
 491790532,
 64873,
 -58027,
 491987044,
 64823,
 -1,
 492091467,
 64805,
 492248412,
 491760513,
 -1,
 492313946,
 492195723,
 -1,
 -58023,
 492273054,
 64779,
 -1,
 492338396,
 64815,
 -58021,
 492249188,
 64825,
 -1,
 492484683,
 64807,
 492641631,
 492177709,
 -1,
 -58018,
 492590622,
 64766,
 -1,
 492681291,
 64794,
 492838242,
 492604231,
 -1,
 -58015,
 492787230,
 64781,
 -1,
 492877899,
 64809,
 493092863,
 492779068,
 -1,
 -58012,
 492983838,
 64765,
 -1,
 493074507,
 64793,
 493289471,
 489837077,
 -1,
 493297003,
 493181857,
 -1,
 493362538,
 493247687,
 -1,
 -58007,
 493297764,
 64756,
 -1,
 493377054,
 64610,
 -1,
 493325833,
 64607,
 493624688,
 493239142,
 -1,
 493690223,
 493575367,
 -1,
 -58002,
 493625444,
 64755,
 -1,
 493704734,
 64609,
 -1,
 493653513,
 64606,
 493952371,
 493596333,
 -1,
 -57998,
 493887588,
 64754,
 -1,
 493966878,
 64608,
 -1,
 493911974,
 64611,
 494214565,
 489765062,
 -1,
 494280066,
 494187137,
 -1,
 494345598,
 494213692,
 -1,
 494411130,
 494318209,
 -1,
 -57991,
 494356442,
 64867,
 -1,
 494450763,
 64866,
 494607741,
 494379192,
 -1,
 -57988,
 494553050,
 64864,
 -1,
 494647371,
 64863,
 -1,
 494551802,
 64865,
 494869889,
 494292875,
 -1,
 -57984,
 494828958,
 64543,
 -1,
 494894300,
 64688,
 -1,
 494805092,
 64743,
 495132044,
 494221689,
 -1,
 495197577,
 495082554,
 -1,
 495263111,
 495144843,
 -1,
 -57978,
 495222174,
 64541,
 -1,
 495287516,
 64686,
 -57976,
 495203499,
 64860,
 -1,
 495394916,
 64821,
 495648767,
 495160326,
 -1,
 -57973,
 495525988,
 64744,
 -1,
 495601626,
 64817,
 495787412,
 495102849,
 -1,
 495852944,
 495721020,
 -1,
 -57969,
 495824848,
 64966,
 -1,
 495888086,
 64936,
 496049555,
 495800203,
 -1,
 -57966,
 496008606,
 64542,
 -1,
 496073948,
 64687,
 -1,
 495984740,
 64822,
 496311708,
 495739667,
 -1,
 496377240,
 496245308,
 -1,
 -57961,
 496330140,
 64861,
 -1,
 496412374,
 64862,
 496573851,
 496324491,
 -1,
 -57958,
 496532894,
 64540,
 -1,
 496598236,
 64685,
 -1,
 496509028,
 64820,
 496835999,
 496240941,
 -1,
 -57954,
 496784926,
 64764,
 -1,
 496875595,
 64792,
 497032610,
 496798535,
 -1,
 -57951,
 496981534,
 64782,
 -1,
 497072203,
 64810,
 497287167,
 496973372,
 -1,
 -57948,
 497178142,
 64763,
 -1,
 497268811,
 64791,
 497483775,
 494144124,
 -1,
 497491393,
 497352903,
 -1,
 497556912,
 497459384,
 -1,
 497622445,
 497490492,
 -1,
 497687980,
 497590456,
 -1,
 -57941,
 497633242,
 64869,
 -1,
 497727563,
 64868,
 -1,
 497659856,
 64937,
 498008063,
 497569675,
 -1,
 -57937,
 497909150,
 64544,
 -1,
 497974492,
 64689,
 498146743,
 497529473,
 -1,
 498212276,
 498081120,
 -1,
 -57933,
 498157530,
 64965,
 -1,
 498251851,
 64870,
 498466815,
 498159499,
 -1,
 -57930,
 498367902,
 64545,
 -1,
 498433244,
 64691,
 498605498,
 498075949,
 -1,
 -57927,
 498554398,
 64774,
 -1,
 498645067,
 64802,
 498802109,
 498568007,
 -1,
 -57924,
 498751006,
 64783,
 -1,
 498841675,
 64811,
 498998720,
 498742844,
 -1,
 -57921,
 498947614,
 64773,
 -1,
 499038283,
 64801,
 -1,
 498930919,
 64690,
 499318783,
 497445469,
 -1,
 499326407,
 499190234,
 -1,
 499391942,
 499276999,
 -1,
 -57915,
 499323119,
 65008,
 -1,
 499406366,
 65017,
 -1,
 499358284,
 65018,
 -1,
 499261261,
 65013,
 499719717,
 489729986,
 -1,
 499785212,
 499669840,
 -1,
 499850710,
 499757697,
 -1,
 499916241,
 499784252,
 -1,
 -57907,
 499888080,
 64931,
 -57906,
 499913959,
 64855,
 -57905,
 499991290,
 64853,
 -57904,
 500065692,
 64854,
 -1,
 500147926,
 64932,
 500309460,
 499863435,
 -1,
 -57901,
 500268446,
 64526,
 -1,
 500333788,
 64676,
 -57899,
 500244580,
 64739,
 -1,
 500480075,
 64626,
 500637155,
 499792249,
 -1,
 500702688,
 500587578,
 -1,
 500768221,
 500636220,
 -1,
 500833756,
 500720403,
 -1,
 -57893,
 500778970,
 64850,
 -1,
 500873291,
 64849,
 -1,
 500762782,
 64851,
 501153791,
 500715403,
 -1,
 -57889,
 501054878,
 64524,
 -1,
 501120220,
 64674,
 501350399,
 500665350,
 -1,
 -57886,
 501227620,
 64740,
 -1,
 501303258,
 64677,
 501489131,
 500607873,
 -1,
 501554664,
 501422652,
 -1,
 -57882,
 501526480,
 64929,
 -57881,
 501549214,
 64852,
 -1,
 501655254,
 64930,
 501874687,
 501501835,
 -1,
 -57878,
 501775774,
 64525,
 -1,
 501841116,
 64675,
 502013427,
 501441299,
 -1,
 502078960,
 501946940,
 -1,
 -57874,
 502050768,
 64927,
 -57873,
 502073502,
 64848,
 -1,
 502179542,
 64928,
 502398975,
 502026123,
 -1,
 -57870,
 502300062,
 64523,
 -1,
 502365404,
 64673,
 502537718,
 501942573,
 -1,
 -57867,
 502486558,
 64528,
 -1,
 502577227,
 64629,
 502734329,
 502478396,
 -1,
 -57864,
 502683166,
 64527,
 -1,
 502773835,
 64628,
 -57862,
 502664846,
 64625,
 -57861,
 502886522,
 64624,
 -1,
 502961529,
 64627,
 503127568,
 499726713,
 -1,
 503193103,
 503077712,
 -1,
 503258628,
 503165569,
 -1,
 503324162,
 503205771,
 -1,
 -57855,
 503283102,
 64530,
 -1,
 503348444,
 64678,
 -57853,
 503259236,
 64741,
 -1,
 503494731,
 64632,
 503651847,
 503187757,
 -1,
 -57850,
 503600670,
 64532,
 -1,
 503691339,
 64635,
 503848458,
 503592508,
 -1,
 -57847,
 503797278,
 64531,
 -1,
 503887947,
 64634,
 -57845,
 503778958,
 64631,
 -57844,
 504000634,
 64630,
 -57843,
 504075641,
 64633,
 -57842,
 504146264,
 64529,
 -1,
 504184147,
 64742,
 -1,
 503152231,
 64603,
 504496127,
 503075130,
 -1,
 504503836,
 504410753,
 -1,
 504569368,
 504437308,
 -1,
 504634902,
 504537272,
 -1,
 -57835,
 504580058,
 64882,
 -1,
 504674379,
 64881,
 -57833,
 504606672,
 64884,
 -1,
 504760478,
 64883,
 504962587,
 504516491,
 -1,
 -57830,
 504921502,
 64551,
 -1,
 504986844,
 64819,
 -1,
 504897636,
 64826,
 505224735,
 504432941,
 -1,
 -57826,
 505173534,
 64758,
 -1,
 505264203,
 64786,
 505421346,
 505174196,
 -1,
 -57823,
 505380254,
 64550,
 -1,
 505445596,
 64696,
 505675775,
 505361980,
 -1,
 -57820,
 505566750,
 64757,
 -1,
 505657419,
 64785,
 505814656,
 499671480,
 -1,
 505880164,
 505756025,
 -1,
 505945697,
 505809532,
 -1,
 506011228,
 505911305,
 -1,
 506076723,
 505940604,
 -1,
 506142256,
 506029058,
 -1,
 506207790,
 506081024,
 -1,
 -57811,
 506156574,
 64515,
 -1,
 506247243,
 64616,
 -57809,
 506156574,
 64490,
 -1,
 506378315,
 64491,
 506593279,
 506096738,
 -1,
 -57806,
 506484254,
 64492,
 -1,
 506574923,
 64493,
 506732090,
 506012372,
 -1,
 506797623,
 506704192,
 -1,
 -57802,
 506746398,
 64500,
 -1,
 506837067,
 64501,
 507052031,
 506760198,
 -1,
 -57799,
 506943006,
 64516,
 -1,
 507033675,
 64617,
 507190848,
 506704513,
 -1,
 507256382,
 507137931,
 -1,
 -57795,
 507215262,
 64514,
 -1,
 507280604,
 64666,
 -57793,
 507191396,
 64735,
 -1,
 507426891,
 64614,
 507584071,
 507132281,
 -1,
 507649604,
 507546630,
 -1,
 -57789,
 507584612,
 64736,
 -1,
 507660250,
 64667,
 507903999,
 507603140,
 -1,
 -57786,
 507805086,
 64513,
 -1,
 507870428,
 64664,
 508042828,
 507538530,
 -1,
 508108363,
 507989899,
 -1,
 -57782,
 508067230,
 64502,
 -1,
 508132572,
 64504,
 -1,
 508082251,
 64503,
 508370511,
 508013628,
 -1,
 -57778,
 508319262,
 64494,
 -1,
 508409931,
 64495,
 508567122,
 508342592,
 -1,
 -57775,
 508515870,
 64496,
 -1,
 508606539,
 64497,
 508763733,
 508515475,
 -1,
 -57772,
 508712478,
 64498,
 -1,
 508803147,
 64499,
 508960344,
 508732531,
 -1,
 -57769,
 508919198,
 64512,
 -1,
 508984540,
 64663,
 -57767,
 508890766,
 64613,
 -57766,
 509112442,
 64612,
 -57765,
 509187449,
 64615,
 -1,
 509220071,
 64665,
 509476863,
 505948693,
 -1,
 509484640,
 509366155,
 -1,
 -57761,
 509443486,
 64598,
 -1,
 509508828,
 64731,
 -1,
 509419716,
 64942,
 509804543,
 505908230,
 -1,
 -57757,
 509681764,
 64753,
 -1,
 509757402,
 64734,
 509943407,
 505852545,
 -1,
 510008938,
 509876796,
 -1,
 510074473,
 509981313,
 -1,
 -57752,
 510019546,
 64925,
 -1,
 510113867,
 64924,
 -1,
 510046160,
 64944,
 510336621,
 509955979,
 -1,
 -57748,
 510295454,
 64600,
 -1,
 510360796,
 64733,
 -57746,
 510271588,
 64752,
 -1,
 510507083,
 64659,
 510664308,
 509895443,
 -1,
 510729843,
 510611339,
 -1,
 -57742,
 510688670,
 64597,
 -1,
 510754012,
 64730,
 -1,
 510664900,
 64943,
 510991991,
 510593325,
 -1,
 -57738,
 510940702,
 64602,
 -1,
 511031371,
 64662,
 511188602,
 510920945,
 -1,
 -57735,
 511147422,
 64599,
 -1,
 511212764,
 64732,
 511385213,
 511129148,
 -1,
 -57732,
 511333918,
 64601,
 -1,
 511424587,
 64661,
 -57730,
 511315598,
 64658,
 -57729,
 511537274,
 64657,
 -1,
 511612281,
 64660,
 511778495,
 505771376,
 -1,
 511843986,
 511750925,
 -1,
 511909517,
 511777340,
 -1,
 511975050,
 511849510,
 -1,
 512040583,
 511933488,
 -1,
 -57722,
 511989278,
 65273,
 -1,
 512079947,
 65274,
 512294911,
 512011506,
 -1,
 -57719,
 512185886,
 65271,
 -1,
 512276555,
 65272,
 512491519,
 511902366,
 -1,
 -57716,
 512382494,
 65269,
 -1,
 512473163,
 65270,
 512630416,
 511848192,
 -1,
 -57713,
 512579102,
 64579,
 -1,
 512669771,
 64646,
 -57711,
 512579102,
 65275,
 -1,
 512800843,
 65276,
 512958109,
 511816321,
 -1,
 513023640,
 512891452,
 -1,
 513089175,
 512991416,
 -1,
 -57706,
 513034202,
 64904,
 -1,
 513128523,
 64903,
 -1,
 513060816,
 64941,
 513351323,
 512970635,
 -1,
 -57702,
 513310110,
 64578,
 -1,
 513375452,
 64716,
 -57700,
 513286244,
 64749,
 -1,
 513521739,
 64645,
 513679017,
 512910099,
 -1,
 513744550,
 513612348,
 -1,
 513810082,
 513716865,
 -1,
 -57695,
 513755098,
 64954,
 -1,
 513849419,
 64956,
 514006693,
 513762067,
 -1,
 -57692,
 513951706,
 64899,
 -1,
 514046027,
 64900,
 -1,
 513978320,
 64940,
 514326527,
 513691531,
 -1,
 -57688,
 514227614,
 64575,
 -1,
 514292956,
 64713,
 514465461,
 513620345,
 -1,
 514530996,
 514415674,
 -1,
 514596529,
 514464316,
 -1,
 514662063,
 514568833,
 -1,
 -57682,
 514607066,
 64949,
 -1,
 514701387,
 64896,
 -57680,
 514633680,
 64897,
 -1,
 514827990,
 64898,
 515047423,
 514543499,
 -1,
 -57677,
 514948510,
 64576,
 -1,
 515013852,
 64714,
 -1,
 514464322,
 64717,
 515251900,
 514435969,
 -1,
 515317433,
 515186016,
 -1,
 -57672,
 515262426,
 64902,
 -1,
 515356747,
 64901,
 515571711,
 515264395,
 -1,
 -57669,
 515472798,
 64577,
 -1,
 515538140,
 64715,
 515768319,
 515180845,
 -1,
 -57666,
 515659294,
 64580,
 -1,
 515749963,
 64647,
 515907314,
 511729776,
 -1,
 515972836,
 515880291,
 -1,
 516038348,
 515945089,
 -1,
 516103879,
 515971644,
 -1,
 516169414,
 516076161,
 -1,
 -57659,
 516114394,
 64963,
 -1,
 516208715,
 64955,
 -1,
 516141008,
 64951,
 516431562,
 516050827,
 -1,
 -57655,
 516390302,
 64572,
 -1,
 516455644,
 64712,
 -57653,
 516366436,
 64748,
 -1,
 516601931,
 64642,
 516759250,
 515973361,
 -1,
 516824784,
 516706187,
 -1,
 -57649,
 516783518,
 64571,
 -1,
 516848860,
 64711,
 -57647,
 516759652,
 64747,
 -1,
 516995147,
 64641,
 517152472,
 516731661,
 -1,
 517218006,
 517091072,
 -1,
 -57643,
 517166622,
 64573,
 -1,
 517257291,
 64643,
 -57641,
 517166622,
 64567,
 -1,
 517388363,
 64640,
 517545691,
 517081389,
 -1,
 -57638,
 517494302,
 64574,
 -1,
 517584971,
 64644,
 517742302,
 517474545,
 -1,
 -57635,
 517701022,
 64570,
 -1,
 517766364,
 64710,
 517938913,
 517710963,
 -1,
 -57632,
 517897630,
 64568,
 -1,
 517962972,
 64708,
 518193151,
 517888180,
 -1,
 -57629,
 518094238,
 64569,
 -1,
 518159580,
 64709,
 518389759,
 515945929,
 -1,
 518397672,
 518261037,
 -1,
 -57625,
 518346270,
 64772,
 -1,
 518436939,
 64800,
 518594283,
 518335251,
 -1,
 -57622,
 518552990,
 64539,
 -1,
 518618332,
 64684,
 518790894,
 518562931,
 -1,
 -57619,
 518749598,
 64537,
 -1,
 518814940,
 64683,
 518987505,
 518731324,
 -1,
 -57616,
 518936094,
 64771,
 -1,
 519026763,
 64799,
 -1,
 518935319,
 64538,
 519249697,
 515866484,
 -1,
 519315200,
 519201555,
 -1,
 519380733,
 519248444,
 -1,
 519446264,
 519352961,
 -1,
 -57609,
 519391194,
 64920,
 -1,
 519485515,
 64919,
 519642875,
 519413944,
 -1,
 -57606,
 519587802,
 64952,
 -1,
 519682123,
 64957,
 -57604,
 519614416,
 64967,
 -1,
 519808726,
 64921,
 520028159,
 519327627,
 -1,
 -57601,
 519929246,
 64587,
 -1,
 519994588,
 64722,
 520167180,
 519256441,
 -1,
 520232713,
 520117306,
 -1,
 520298246,
 520165948,
 -1,
 -57596,
 520269776,
 64947,
 -57595,
 520292510,
 64917,
 -1,
 520398550,
 64918,
 520617983,
 520245131,
 -1,
 -57592,
 520519070,
 64588,
 -1,
 520584412,
 64723,
 520814591,
 520195078,
 -1,
 -57589,
 520691812,
 64751,
 -1,
 520767450,
 64726,
 520953621,
 520139393,
 -1,
 521019152,
 520886844,
 -1,
 -57585,
 520990672,
 64922,
 -1,
 521053910,
 64923,
 521215763,
 520966027,
 -1,
 -57582,
 521174430,
 64590,
 -1,
 521239772,
 64725,
 -57580,
 521150564,
 64750,
 -1,
 521386059,
 64652,
 521543448,
 520882477,
 -1,
 -57577,
 521491998,
 64592,
 -1,
 521582667,
 64655,
 521740059,
 521472241,
 -1,
 -57574,
 521698718,
 64589,
 -1,
 521764060,
 64724,
 521936670,
 521680444,
 -1,
 -57571,
 521885214,
 64591,
 -1,
 521975883,
 64654,
 -57569,
 521866894,
 64651,
 -57568,
 522088570,
 64650,
 -1,
 522163577,
 64653,
 522329927,
 519205636,
 -1,
 522395462,
 522290888,
 -1,
 522460972,
 522347283,
 -1,
 522526505,
 522394172,
 -1,
 -57562,
 522498000,
 64960,
 -57561,
 522520734,
 64909,
 -57560,
 522589415,
 64914,
 -1,
 522675612,
 64908,
 522911743,
 522473355,
 -1,
 -57557,
 522812830,
 64581,
 -1,
 522878172,
 64718,
 523050804,
 522431361,
 -1,
 523116337,
 522983996,
 -1,
 -57553,
 523087824,
 64953,
 -57552,
 523110558,
 64911,
 -1,
 523191034,
 64910,
 523436031,
 523063179,
 -1,
 -57549,
 523337118,
 64583,
 -1,
 523402460,
 64720,
 523575100,
 523018424,
 -1,
 523640633,
 523508284,
 -1,
 -57545,
 523612112,
 64907,
 -57544,
 523634846,
 64906,
 -1,
 523715322,
 64905,
 523960319,
 523587467,
 -1,
 -57541,
 523861406,
 64582,
 -1,
 523926748,
 64719,
 524099394,
 523547265,
 -1,
 524164928,
 524046219,
 -1,
 -57537,
 524123550,
 64584,
 -1,
 524188892,
 64721,
 -57535,
 524099780,
 64945,
 -1,
 524335179,
 64649,
 524492613,
 524071693,
 -1,
 -57532,
 524424137,
 64585,
 -1,
 524531787,
 64648,
 -1,
 524424441,
 64586,
 -1,
 522326619,
 65012,
 524820330,
 522261361,
 -1,
 524885865,
 524770128,
 -1,
 524951378,
 524827001,
 -1,
 525016911,
 524901434,
 -1,
 525082446,
 524963723,
 -1,
 -57523,
 525041054,
 64518,
 -1,
 525106396,
 64669,
 -1,
 525017284,
 64962,
 525402111,
 524979206,
 -1,
 -57519,
 525279332,
 64738,
 -1,
 525354970,
 64672,
 525541208,
 524923521,
 -1,
 525606742,
 525488011,
 -1,
 -57515,
 525565342,
 64520,
 -1,
 525630684,
 64671,
 -57513,
 525541476,
 64737,
 -1,
 525776971,
 64620,
 525934429,
 525511553,
 -1,
 525999964,
 525881227,
 -1,
 -57509,
 525958558,
 64519,
 -1,
 526023900,
 64670,
 -1,
 525934788,
 64926,
 526262112,
 525863213,
 -1,
 -57505,
 526210590,
 64522,
 -1,
 526301259,
 64623,
 526458723,
 526230643,
 -1,
 -57502,
 526417310,
 64517,
 -1,
 526482652,
 64668,
 526655334,
 526399036,
 -1,
 -57499,
 526603806,
 64521,
 -1,
 526694475,
 64622,
 -57497,
 526585486,
 64619,
 -57496,
 526807162,
 64618,
 -1,
 526882169,
 64621,
 -1,
 524835037,
 65021,
 527114126,
 524749436,
 -1,
 527179651,
 527045927,
 -1,
 527245174,
 527151745,
 -1,
 527310707,
 527178300,
 -1,
 527376241,
 527282817,
 -1,
 -57488,
 527321050,
 64887,
 -1,
 527415371,
 64886,
 -57486,
 527347664,
 64950,
 -1,
 527541974,
 64888,
 527761407,
 527257483,
 -1,
 -57483,
 527662494,
 64554,
 -1,
 527727836,
 64699,
 527900541,
 527196947,
 -1,
 527966074,
 527834464,
 -1,
 -57479,
 527910874,
 64964,
 -1,
 528005195,
 64885,
 528220159,
 527912843,
 -1,
 -57476,
 528121246,
 64553,
 -1,
 528186588,
 64698,
 528359296,
 527829293,
 -1,
 -57473,
 528307742,
 64760,
 -1,
 528398411,
 64788,
 528613375,
 528299580,
 -1,
 -57470,
 528504350,
 64759,
 -1,
 528595019,
 64787,
 528752525,
 527133277,
 -1,
 528818059,
 528721450,
 -1,
 528883592,
 528746164,
 -1,
 -57465,
 528832030,
 64829,
 -1,
 528922699,
 64828,
 529137663,
 528827853,
 -1,
 -57462,
 529028638,
 64605,
 -1,
 529119307,
 64656,
 -57460,
 528755742,
 65010,
 -1,
 529213976,
 65015,
 -1,
 528683767,
 65011,
 529473456,
 527055225,
 -1,
 529538978,
 529420602,
 -1,
 529604503,
 529511041,
 -1,
 529670036,
 529537596,
 -1,
 -57453,
 529641424,
 64858,
 -1,
 529704662,
 64859,
 529924095,
 529616779,
 -1,
 -57450,
 529825182,
 64536,
 -1,
 529890524,
 64682,
 530063260,
 529556243,
 -1,
 530128795,
 530009995,
 -1,
 -57446,
 530087326,
 64535,
 -1,
 530152668,
 64681,
 -1,
 530063556,
 64959,
 530390943,
 529991981,
 -1,
 -57442,
 530339358,
 64768,
 -1,
 530430027,
 64796,
 530644991,
 530331196,
 -1,
 -57439,
 530535966,
 64767,
 -1,
 530626635,
 64795,
 530841599,
 529488720,
 -1,
 530849706,
 530756225,
 -1,
 530915239,
 530782780,
 -1,
 -57434,
 530843806,
 64916,
 -1,
 530924282,
 64915,
 531169279,
 530861963,
 -1,
 -57431,
 531070366,
 64594,
 -1,
 531135708,
 64728,
 531308461,
 530818163,
 -1,
 -57428,
 531266974,
 64593,
 -1,
 531332316,
 64727,
 -57426,
 531240185,
 64596,
 -57425,
 531472857,
 64729,
 -1,
 531514484,
 64595,
 531701710,
 529438945,
 -1,
 531767224,
 531671937,
 -1,
 531832757,
 531701088,
 -1,
 -57420,
 531777498,
 64880,
 -1,
 531871819,
 64879,
 532086783,
 531779467,
 -1,
 -57417,
 531987870,
 64548,
 -1,
 532053212,
 64694,
 532225983,
 531734712,
 -1,
 532291516,
 532159036,
 -1,
 -57413,
 532262864,
 64939,
 -1,
 532326102,
 64878,
 532545535,
 532238219,
 -1,
 -57410,
 532446622,
 64547,
 -1,
 532511964,
 64693,
 532684738,
 532154669,
 -1,
 -57407,
 532633118,
 64776,
 -1,
 532723787,
 64804,
 532881349,
 532646727,
 -1,
 -57404,
 532829726,
 64784,
 -1,
 532920395,
 64812,
 533077960,
 532818707,
 -1,
 -57401,
 533036446,
 64549,
 -1,
 533101788,
 64695,
 533274571,
 533046387,
 -1,
 -57398,
 533233054,
 64546,
 -1,
 533298396,
 64692,
 533528575,
 533214780,
 -1,
 -57395,
 533419550,
 64775,
 -1,
 533510219,
 64803,
 533667816,
 531650556,
 -1,
 533733351,
 533628616,
 -1,
 533798874,
 533705345,
 -1,
 533864407,
 533731900,
 -1,
 533929941,
 533831864,
 -1,
 -57388,
 533874650,
 64857,
 -1,
 533968971,
 64856,
 -57386,
 533901264,
 64933,
 -1,
 534095574,
 64935,
 534315007,
 533811083,
 -1,
 -57383,
 534216094,
 64534,
 -1,
 534281436,
 64680,
 534454241,
 533766328,
 -1,
 534519774,
 534387260,
 -1,
 -57379,
 534491088,
 64958,
 -1,
 534554326,
 64934,
 534773759,
 534466443,
 -1,
 -57376,
 534674846,
 64533,
 -1,
 534740188,
 64679,
 534912996,
 534382893,
 -1,
 -57373,
 534861342,
 64770,
 -1,
 534952011,
 64798,
 535166975,
 534853180,
 -1,
 -57370,
 535057950,
 64769,
 -1,
 535148619,
 64797,
 -1,
 533664194,
 65019,
 535371777,
 533613154,
 -1,
 535437296,
 535341953,
 -1,
 535502829,
 535371104,
 -1,
 -57364,
 535447514,
 64893,
 -1,
 535541835,
 64892,
 535756799,
 535449483,
 -1,
 -57361,
 535657886,
 64559,
 -1,
 535723228,
 64704,
 535896053,
 535409281,
 -1,
 535961588,
 535842699,
 -1,
 -57357,
 535920030,
 64560,
 -1,
 535985372,
 64705,
 -1,
 535896260,
 64961,
 536223736,
 535824685,
 -1,
 -57353,
 536172062,
 64562,
 -1,
 536262731,
 64637,
 536420347,
 536192115,
 -1,
 -57350,
 536378782,
 64557,
 -1,
 536444124,
 64702,
 536616958,
 536369332,
 -1,
 -57347,
 536575390,
 64558,
 -1,
 536640732,
 64703,
 536870911,
 536557116,
 -1,
 -57344,
 536761886,
 64561,
 -1,
 536852555,
 64636,
 537010199,
 535303937,
 -1,
 537075734,
 536977980,
 -1,
 537141261,
 537047681,
 -1,
 537206794,
 537074236,
 -1,
 537272328,
 537174200,
 -1,
 -57337,
 537216986,
 64948,
 -1,
 537311307,
 64894,
 -57335,
 537243600,
 64946,
 -1,
 537396129,
 64895,
 537657343,
 537153419,
 -1,
 -57332,
 537558430,
 64564,
 -1,
 537623772,
 64707,
 537796624,
 537069869,
 -1,
 -57329,
 537744926,
 64566,
 -1,
 537835595,
 64639,
 537993235,
 537745588,
 -1,
 -57326,
 537951646,
 64563,
 -1,
 538016988,
 64706,
 538247167,
 537933372,
 -1,
 -57323,
 538138142,
 64565,
 -1,
 538228811,
 64638,
 -1,
 537047433,
 65009,
 538452009,
 536941627,
 -1,
 538517536,
 538423937,
 -1,
 538583069,
 538450492,
 -1,
 -57317,
 538554320,
 64890,
 -57316,
 538575777,
 64889,
 -1,
 538683094,
 64891,
 538902527,
 538529675,
 -1,
 -57313,
 538803614,
 64556,
 -1,
 538868956,
 64701,
 539041827,
 538446125,
 -1,
 -57310,
 538990110,
 64762,
 -1,
 539080779,
 64790,
 539238438,
 539010163,
 -1,
 -57307,
 539196830,
 64555,
 -1,
 539262172,
 64700,
 539492351,
 539178556,
 -1,
 -57304,
 539383326,
 64761,
 -1,
 539473995,
 64789,
 539631662,
 538420191,
 -1,
 539697197,
 539578251,
 -1,
 -57300,
 539655582,
 64552,
 -1,
 539720924,
 64697,
 -1,
 539631716,
 64827,
 539959347,
 539575972,
 -1,
 540024882,
 539905931,
 -1,
 -57295,
 539983262,
 64505,
 -1,
 540048604,
 64507,
 -1,
 539998283,
 64506,
 540287030,
 539891467,
 -1,
 -57291,
 540220663,
 64604,
 -1,
 540308204,
 65014,
 -1,
 540243707,
 65016,
 540606463,
 489657089,
 -1,
 540614785,
 540520386,
 -1,
 540680272,
 540568760,
 1578,
 540745801,
 540630215,
 -1,
 540811330,
 540701444,
 -1,
 540876865,
 540783549,
 1577,
 540999679,
 540826823,
 -1,
 -57281,
 540890654,
 65171,
 -57280,
 540965943,
 1731,
 -1,
 541046859,
 65172,
 -1,
 540819921,
 65176,
 541270085,
 540744252,
 -1,
 -57276,
 541231307,
 1661,
 -1,
 541296238,
 1660,
 541466696,
 541216651,
 -1,
 -57273,
 541425054,
 65173,
 -1,
 541490396,
 65175,
 -1,
 541440075,
 65174,
 541786111,
 540699832,
 1663,
 541851647,
 541678791,
 -1,
 541859918,
 541740939,
 -1,
 -57267,
 541818270,
 64354,
 -1,
 541883612,
 64356,
 -57265,
 541794404,
 64357,
 -1,
 542029899,
 64355,
 542187615,
 540612683,
 1670,
 542253144,
 542141624,
 1671,
 542375935,
 542203079,
 -1,
 542384214,
 542265227,
 -1,
 -57259,
 542342558,
 64382,
 -1,
 542407900,
 64384,
 -57257,
 542318692,
 64385,
 -1,
 542554187,
 64383,
 542769151,
 542203079,
 -1,
 542777436,
 542658443,
 -1,
 -57253,
 542735774,
 64378,
 -1,
 542801116,
 64380,
 -57251,
 542718288,
 1727,
 -57250,
 542908516,
 64381,
 -1,
 543012939,
 64379,
 543170669,
 542124767,
 1657,
 543236199,
 543124664,
 1658,
 543358975,
 543186119,
 -1,
 543367269,
 543248267,
 -1,
 -57244,
 543325598,
 64350,
 -1,
 543390940,
 64352,
 -57242,
 543301732,
 64353,
 -1,
 543537227,
 64351,
 543752191,
 543186119,
 -1,
 543760491,
 543641483,
 -1,
 -57238,
 543718814,
 64358,
 -1,
 543784156,
 64360,
 -57236,
 543694948,
 64361,
 -1,
 543930443,
 64359,
 544088185,
 543111545,
 -1,
 544153717,
 544042168,
 1579,
 544276479,
 544103623,
 -1,
 544284787,
 544165771,
 -1,
 -57230,
 544243102,
 65177,
 -1,
 544308444,
 65179,
 -57228,
 544219236,
 65180,
 -1,
 544454731,
 65178,
 544669695,
 544115174,
 1584,
 544735231,
 544562375,
 -1,
 -57224,
 544626206,
 65195,
 -1,
 544716875,
 65196,
 544931839,
 544036042,
 1591,
 544997375,
 544824519,
 -1,
 545005694,
 544886667,
 -1,
 -57219,
 544963998,
 65217,
 -1,
 545029340,
 65219,
 -57217,
 544948737,
 1695,
 -57216,
 545136740,
 65220,
 -1,
 545241163,
 65218,
 545398966,
 540550464,
 -1,
 545464478,
 545327740,
 -1,
 545530002,
 545417821,
 1583,
 545652735,
 545479879,
 -1,
 545661072,
 545528380,
 -1,
 545726601,
 545632194,
 -1,
 -57208,
 545665775,
 1881,
 -1,
 545728378,
 1679,
 545923212,
 545668458,
 -1,
 -57205,
 545851419,
 1774,
 -1,
 545918161,
 1882,
 546119822,
 545874081,
 1674,
 -1,
 546081034,
 1675,
 -57201,
 546080366,
 1673,
 -1,
 546199521,
 1680,
 -57199,
 545609246,
 65193,
 -1,
 546355275,
 65194,
 546513050,
 545465664,
 1590,
 546635775,
 546462919,
 -1,
 546644119,
 546525067,
 -1,
 -57194,
 546602398,
 65213,
 -1,
 546667740,
 65215,
 -57192,
 546599158,
 1787,
 -57191,
 546775140,
 65216,
 -1,
 546879563,
 65214,
 547094527,
 546457531,
 1676,
 547160063,
 546987207,
 -1,
 -57187,
 547051038,
 64388,
 -1,
 547141707,
 64389,
 547299495,
 545407916,
 -1,
 547365027,
 547252829,
 1672,
 547487743,
 547314887,
 -1,
 -57182,
 547378718,
 64392,
 -1,
 547469387,
 64393,
 547684351,
 547309499,
 1677,
 547749887,
 547577031,
 -1,
 -57178,
 547640862,
 64386,
 -1,
 547731531,
 64387,
 547889326,
 547244073,
 1668,
 548012031,
 547839175,
 -1,
 548020396,
 547901323,
 -1,
 -57173,
 547978654,
 64370,
 -1,
 548043996,
 64372,
 -57171,
 547954788,
 64373,
 -1,
 548190283,
 64371,
 548348082,
 547861350,
 1678,
 548470783,
 548297927,
 -1,
 -57167,
 548361758,
 64390,
 -1,
 548452427,
 64391,
 548667391,
 548303360,
 -1,
 -57164,
 548554472,
 1647,
 -57163,
 548648316,
 1697,
 -1,
 548668099,
 1646,
 548872427,
 545339769,
 -1,
 548937939,
 548826296,
 1607,
 549060607,
 548887751,
 -1,
 549068993,
 548961335,
 1729,
 549191679,
 549018823,
 -1,
 549200062,
 549080971,
 -1,
 -57155,
 549158302,
 64422,
 -1,
 549223644,
 64424,
 -57153,
 549162836,
 1730,
 -57152,
 549331044,
 64425,
 -1,
 549435467,
 64423,
 549593288,
 549039948,
 1726,
 549715967,
 549543111,
 -1,
 549724358,
 549605259,
 -1,
 -57147,
 549682590,
 64426,
 -1,
 549747932,
 64428,
 -57145,
 549658724,
 64429,
 -1,
 549894219,
 64427,
 550052046,
 549526076,
 -1,
 550117581,
 550011017,
 1728,
 550240255,
 550067399,
 -1,
 -57140,
 550131230,
 64420,
 -1,
 550221899,
 64421,
 -1,
 550054071,
 1791,
 550445265,
 549998475,
 -1,
 -57136,
 550403486,
 65257,
 -1,
 550468828,
 65259,
 -57134,
 550379620,
 65260,
 -1,
 550615115,
 65258,
 550772966,
 548866684,
 -1,
 550838500,
 550713721,
 1581,
 550961151,
 550788295,
 -1,
 550969567,
 550836796,
 -1,
 551035102,
 550940610,
 -1,
 551100635,
 550966096,
 -1,
 -57126,
 551057954,
 1666,
 -1,
 551129992,
 1879,
 551354367,
 551041498,
 -1,
 -57123,
 551235783,
 1880,
 -1,
 551326600,
 1669,
 -1,
 550997339,
 1665,
 551559394,
 550915979,
 -1,
 -57119,
 551517598,
 65185,
 -1,
 551582940,
 65187,
 -57117,
 551493732,
 65188,
 -1,
 551729227,
 65186,
 551944191,
 550795062,
 1569,
 -1,
 551827530,
 65152,
 552075263,
 550703729,
 1652,
 552140799,
 551967943,
 -1,
 -57111,
 552028201,
 1656,
 -57110,
 552094996,
 1654,
 -1,
 552151384,
 1653,
 552345881,
 548801148,
 -1,
 552411402,
 552294537,
 1575,
 552534015,
 552361159,
 -1,
 552542468,
 552407352,
 -1,
 552608000,
 552500198,
 -1,
 552673529,
 552547366,
 -1,
 552739061,
 552608434,
 1573,
 552861695,
 552688839,
 -1,
 -57100,
 552752670,
 65159,
 -1,
 552843339,
 65160,
 553058303,
 552702856,
 1571,
 553123839,
 552950983,
 -1,
 -57096,
 553014814,
 65155,
 -1,
 553105483,
 65156,
 553263357,
 552601848,
 1570,
 553385983,
 553213127,
 -1,
 -57092,
 553276958,
 65153,
 -1,
 553367627,
 65154,
 553582591,
 553191339,
 -1,
 -57089,
 553460402,
 1651,
 -1,
 553554824,
 1650,
 553779199,
 552566169,
 1649,
 553844735,
 553671879,
 -1,
 -57085,
 553735710,
 64336,
 -1,
 553826379,
 64337,
 553984264,
 552491966,
 1609,
 554106879,
 553934023,
 -1,
 -57081,
 553997854,
 65263,
 -1,
 554088523,
 65264,
 -57079,
 553932318,
 65165,
 -1,
 554219595,
 65166,
 554377496,
 552357838,
 1593,
 554500095,
 554327239,
 -1,
 554508563,
 554403900,
 -1,
 554574096,
 554439504,
 -1,
 -57073,
 554546474,
 1887,
 -1,
 554603400,
 1885,
 554827775,
 554514906,
 -1,
 -57070,
 554741800,
 1886,
 -1,
 554800008,
 1696,
 554967318,
 554454923,
 -1,
 -57067,
 554925470,
 65225,
 -1,
 554990812,
 65227,
 -57065,
 554901604,
 65228,
 -1,
 555137099,
 65226,
 -1,
 554315473,
 1749,
 555360579,
 552303618,
 -1,
 555426094,
 555333987,
 1606,
 555548671,
 555375815,
 -1,
 555557157,
 555424316,
 -1,
 555622688,
 555528130,
 -1,
 -57057,
 555569197,
 1895,
 -1,
 555653466,
 1725,
 555819299,
 555588488,
 -1,
 -57054,
 555747355,
 1897,
 -1,
 555834694,
 1896,
 -57052,
 555779694,
 1724,
 -1,
 555966625,
 1721,
 556146985,
 555494768,
 1722,
 556269567,
 556096711,
 -1,
 -57048,
 556160542,
 64414,
 -1,
 556251211,
 64415,
 556409132,
 556093323,
 -1,
 -57045,
 556367262,
 65253,
 -1,
 556432604,
 65255,
 -57043,
 556343396,
 65256,
 -1,
 556578891,
 65254,
 556736828,
 555368261,
 1709,
 556802358,
 556682641,
 1713,
 556924927,
 556752071,
 -1,
 556933428,
 556814219,
 -1,
 -57037,
 556891550,
 64410,
 -1,
 556956892,
 64412,
 -57035,
 556867684,
 64413,
 -1,
 557103179,
 64411,
 557318143,
 556752071,
 -1,
 557326650,
 557207435,
 -1,
 -57031,
 557284766,
 64467,
 -1,
 557350108,
 64469,
 -57029,
 557260900,
 64470,
 -1,
 557496395,
 64468,
 557711359,
 556681257,
 1667,
 557776895,
 557604039,
 -1,
 557785409,
 557666187,
 -1,
 -57024,
 557743518,
 64374,
 -1,
 557808860,
 64376,
 -57022,
 557719652,
 64377,
 -1,
 557955147,
 64375,
 558113131,
 555311216,
 -1,
 558178640,
 558081597,
 1705,
 558301183,
 558128327,
 -1,
 558309707,
 558176828,
 -1,
 558375242,
 558277976,
 -1,
 -57015,
 558313671,
 1892,
 -1,
 558404488,
 1891,
 -1,
 558339236,
 1890,
 558637390,
 558256011,
 -1,
 -57011,
 558595486,
 64398,
 -1,
 558660828,
 64400,
 -57009,
 558571620,
 64401,
 -1,
 558807115,
 64399,
 558965083,
 558139840,
 1603,
 559087615,
 558914759,
 -1,
 559096150,
 558963260,
 -1,
 -57004,
 559048636,
 1710,
 -57003,
 559122030,
 1707,
 -1,
 559191204,
 1708,
 559358297,
 559042443,
 -1,
 -57000,
 559316382,
 65241,
 -1,
 559381724,
 65243,
 -56998,
 559292516,
 65244,
 -1,
 559528011,
 65242,
 559685988,
 558927841,
 -1,
 559751520,
 559650047,
 1737,
 559874047,
 559701191,
 -1,
 -56993,
 559765022,
 64482,
 -1,
 559855691,
 64483,
 560070655,
 559710640,
 1733,
 560136191,
 559963335,
 -1,
 -56989,
 560027166,
 64480,
 -1,
 560117835,
 64481,
 560332799,
 559630253,
 1582,
 560398335,
 560225479,
 -1,
 560406889,
 560287627,
 -1,
 -56984,
 560364958,
 65189,
 -1,
 560430300,
 65191,
 -56982,
 560341092,
 65192,
 -1,
 560576587,
 65190,
 560734606,
 558058263,
 -1,
 560800122,
 560705771,
 1587,
 560922623,
 560749767,
 -1,
 560931189,
 560798268,
 -1,
 560996723,
 560902082,
 -1,
 561062258,
 560937142,
 1691,
 -1,
 561005888,
 1692,
 -1,
 561022216,
 1901,
 -56972,
 560945121,
 1884,
 -1,
 561229824,
 1690,
 561389944,
 560877451,
 -1,
 -56969,
 561347998,
 65201,
 -1,
 561413340,
 65203,
 -56967,
 561324132,
 65204,
 -1,
 561559627,
 65202,
 561717636,
 560761274,
 1589,
 561840127,
 561667271,
 -1,
 561848703,
 561743932,
 -1,
 -56962,
 561795117,
 1693,
 -1,
 561879386,
 1694,
 562045314,
 561794955,
 -1,
 -56959,
 562003358,
 65209,
 -1,
 562068700,
 65211,
 -56957,
 561979492,
 65212,
 -1,
 562214987,
 65210,
 562373004,
 561679413,
 1588,
 562495487,
 562322631,
 -1,
 562504073,
 562384779,
 -1,
 -56952,
 562462110,
 65205,
 -1,
 562527452,
 65207,
 -56950,
 562458870,
 1786,
 -56949,
 562634852,
 65208,
 -1,
 562739275,
 65206,
 -56947,
 562322509,
 1706,
 -1,
 562823456,
 1648,
 563028398,
 560669396,
 -1,
 563093930,
 562982072,
 1610,
 563216383,
 563043527,
 -1,
 563224989,
 563092028,
 -1,
 563290521,
 563187035,
 1574,
 563412991,
 563240135,
 -1,
 563421591,
 563302283,
 -1,
 -56938,
 563379614,
 65161,
 -1,
 563444956,
 65163,
 -56936,
 563355748,
 65164,
 -1,
 563591243,
 65162,
 563749276,
 563261378,
 -1,
 -56933,
 563689654,
 1745,
 -1,
 563760731,
 1741,
 -1,
 563692642,
 1742,
 564011429,
 563189185,
 1746,
 564133887,
 563961031,
 -1,
 564142499,
 564039508,
 1747,
 564264959,
 564092103,
 -1,
 -56926,
 564155934,
 64432,
 -1,
 564246603,
 64433,
 -56924,
 564090398,
 64430,
 -1,
 564377675,
 64431,
 564535720,
 563957643,
 -1,
 -56921,
 564493726,
 65265,
 -1,
 564559068,
 65267,
 -56919,
 564469860,
 65268,
 -1,
 564705355,
 65266,
 564920319,
 563067064,
 1736,
 564985855,
 564812999,
 -1,
 -56915,
 564876830,
 64475,
 -1,
 564967499,
 64476,
 565125580,
 562960139,
 -1,
 565191105,
 565079224,
 1585,
 565313535,
 565140679,
 -1,
 565322175,
 565189180,
 -1,
 565387702,
 565267223,
 -1,
 565453237,
 565342242,
 1682,
 -1,
 565386199,
 1685,
 -1,
 565402714,
 1883,
 565649849,
 565358871,
 -1,
 -56904,
 565622058,
 1899,
 -1,
 565678984,
 1687,
 565846459,
 565600417,
 1684,
 -1,
 565816297,
 1686,
 -56900,
 565806702,
 1683,
 -56899,
 565913783,
 1775,
 -56898,
 566005083,
 1900,
 -1,
 566056929,
 1689,
 -56896,
 565270046,
 65197,
 -1,
 566212683,
 65198,
 566370760,
 565157047,
 1723,
 566493183,
 566320327,
 -1,
 566501830,
 566382475,
 -1,
 -56891,
 566459806,
 64416,
 -1,
 566525148,
 64418,
 -56889,
 566435940,
 64419,
 -1,
 566671435,
 64417,
 566886399,
 566321877,
 1681,
 566951935,
 566779079,
 -1,
 -56885,
 566842910,
 64396,
 -1,
 566933579,
 64397,
 567091692,
 565095853,
 -1,
 567157221,
 567032185,
 1576,
 567222750,
 567106759,
 -1,
 567288281,
 567155260,
 -1,
 567353814,
 567259074,
 -1,
 567419349,
 567294426,
 -1,
 567484884,
 567357639,
 1874,
 -1,
 567449220,
 1875,
 -1,
 567417342,
 1872,
 -1,
 567380333,
 1876,
 -56873,
 567297122,
 1878,
 -56872,
 567700491,
 1877,
 -1,
 567764407,
 1873,
 567943644,
 567234443,
 -1,
 -56869,
 567901598,
 65167,
 -1,
 567966940,
 65169,
 -56867,
 567877732,
 65170,
 -1,
 568113227,
 65168,
 568328191,
 567176376,
 1664,
 568393727,
 568220871,
 -1,
 568402403,
 568283019,
 -1,
 -56862,
 568360350,
 64346,
 -1,
 568425692,
 64348,
 -56860,
 568336484,
 64349,
 -1,
 568571979,
 64347,
 568786943,
 567110840,
 1659,
 568852479,
 568679623,
 -1,
 568861162,
 568741771,
 -1,
 -56855,
 568819102,
 64338,
 -1,
 568884444,
 64340,
 -56853,
 568795236,
 64341,
 -1,
 569030731,
 64339,
 569188872,
 567033669,
 -1,
 569254393,
 569149888,
 1711,
 569376767,
 569203911,
 -1,
 569385460,
 569252412,
 -1,
 569450995,
 569356226,
 -1,
 -56846,
 569397293,
 1714,
 -1,
 569481562,
 1716,
 -1,
 569411182,
 1712,
 569713143,
 569331595,
 -1,
 -56842,
 569671070,
 64402,
 -1,
 569736412,
 64404,
 -56840,
 569647204,
 64405,
 -1,
 569882699,
 64403,
 570040833,
 569217479,
 1594,
 570163199,
 569990343,
 -1,
 570171902,
 570052491,
 -1,
 -56835,
 570129822,
 65229,
 -1,
 570195164,
 65231,
 -56833,
 570126582,
 1788,
 -56832,
 570302564,
 65232,
 -1,
 570406987,
 65230,
 570621951,
 569988942,
 1715,
 570687487,
 570514631,
 -1,
 570696198,
 570576779,
 -1,
 -56827,
 570654110,
 64406,
 -1,
 570719452,
 64408,
 -56825,
 570630244,
 64409,
 -1,
 570865739,
 64407,
 571023904,
 569128831,
 -1,
 571089433,
 570977464,
 1601,
 571211775,
 571038919,
 -1,
 571220500,
 571087420,
 -1,
 571286033,
 571191234,
 -1,
 571351568,
 571226586,
 -1,
 -56817,
 571289799,
 1889,
 -1,
 571351730,
 1701,
 -1,
 571297837,
 1888,
 571670527,
 571254289,
 -1,
 -56813,
 571546548,
 1698,
 -1,
 571613874,
 1699,
 571810327,
 571166603,
 -1,
 -56810,
 571768222,
 65233,
 -1,
 571833564,
 65235,
 -56808,
 571744356,
 65236,
 -1,
 571979851,
 65234,
 572194815,
 571030362,
 1740,
 572260351,
 572087495,
 -1,
 572269086,
 572149643,
 -1,
 -56803,
 572226974,
 64508,
 -1,
 572292316,
 64510,
 -56801,
 572203108,
 64511,
 -1,
 572438603,
 64509,
 572596782,
 570968990,
 1662,
 572662312,
 572550328,
 1702,
 572784639,
 572611783,
 -1,
 572793382,
 572673931,
 -1,
 -56795,
 572751262,
 64366,
 -1,
 572816604,
 64368,
 -56793,
 572727396,
 64369,
 -1,
 572962891,
 64367,
 573177855,
 572611783,
 -1,
 573186604,
 573067147,
 -1,
 -56789,
 573144478,
 64342,
 -1,
 573209820,
 64344,
 -56787,
 573120612,
 64345,
 -1,
 573356107,
 64343,
 573514300,
 572558604,
 1604,
 573636607,
 573463751,
 -1,
 573645367,
 573512252,
 -1,
 573710900,
 573613400,
 -1,
 -56781,
 573645490,
 1720,
 -1,
 573739912,
 1719,
 -56779,
 573654114,
 1717,
 -56778,
 573871268,
 1718,
 -1,
 573913204,
 1898,
 574104122,
 573591435,
 -1,
 -56775,
 574061982,
 65245,
 -1,
 574127324,
 65247,
 -56773,
 574038116,
 65248,
 -1,
 574273611,
 65246,
 574431816,
 573459732,
 1608,
 574554111,
 574381255,
 -1,
 574562886,
 574429756,
 -1,
 574628419,
 574524763,
 1572,
 574750719,
 574577863,
 -1,
 -56766,
 574641694,
 65157,
 -1,
 574732363,
 65158,
 -56764,
 574601227,
 1738,
 -56763,
 574850670,
 1732,
 -1,
 574919844,
 1743,
 -56761,
 574510622,
 65261,
 -1,
 575060043,
 65262,
 575218260,
 574364797,
 -1,
 575283792,
 575158649,
 1592,
 575406079,
 575233223,
 -1,
 575414862,
 575295371,
 -1,
 -56755,
 575372702,
 65221,
 -1,
 575438044,
 65223,
 -56753,
 575348836,
 65224,
 -1,
 575584331,
 65222,
 575799295,
 575229902,
 1586,
 575864831,
 575691975,
 -1,
 -56749,
 575755806,
 65199,
 -1,
 575846475,
 65200,
 576004703,
 575152733,
 1739,
 576070236,
 575945081,
 1700,
 576192511,
 576019655,
 -1,
 576201306,
 576081803,
 -1,
 -56743,
 576159134,
 64362,
 -1,
 576224476,
 64364,
 -56741,
 576135268,
 64365,
 -1,
 576370763,
 64363,
 576585727,
 576019655,
 -1,
 -56738,
 576476702,
 64478,
 -1,
 576567371,
 64479,
 576725611,
 575960331,
 -1,
 576791143,
 576679072,
 1580,
 576913407,
 576740551,
 -1,
 576922213,
 576802699,
 -1,
 -56732,
 576880030,
 65181,
 -1,
 576945372,
 65183,
 -56730,
 576856164,
 65184,
 -1,
 577091659,
 65182,
 577306623,
 576731513,
 1688,
 577372159,
 577199303,
 -1,
 -56726,
 577263134,
 64394,
 -1,
 577353803,
 64395,
 577512052,
 576698552,
 1735,
 577577585,
 577461447,
 -1,
 577643119,
 577539924,
 1655,
 -1,
 577583178,
 64477,
 -56720,
 577590814,
 64471,
 -1,
 577747019,
 64472,
 577961983,
 577527745,
 -1,
 -56717,
 577839204,
 64489,
 -1,
 577914842,
 64488,
 578101886,
 577455848,
 1602,
 578224127,
 578051271,
 -1,
 578232953,
 578099772,
 -1,
 -56712,
 578192743,
 1704,
 -1,
 578262180,
 1703,
 578429564,
 578178955,
 -1,
 -56709,
 578387358,
 65237,
 -1,
 578452700,
 65239,
 -56707,
 578363492,
 65240,
 -1,
 578598987,
 65238,
 578757256,
 578034534,
 1605,
 578879487,
 578706631,
 -1,
 578888323,
 578760055,
 -1,
 -56702,
 578822834,
 1894,
 -1,
 578917256,
 1893,
 579084934,
 578834315,
 -1,
 -56699,
 579042718,
 65249,
 -1,
 579108060,
 65251,
 -56697,
 579018852,
 65252,
 -1,
 579254347,
 65250,
 579412623,
 578694865,
 1744,
 579534847,
 579361991,
 -1,
 579543693,
 579424139,
 -1,
 -56692,
 579501470,
 64484,
 -1,
 579566812,
 64486,
 -56690,
 579477604,
 64487,
 -1,
 579713099,
 64485,
 579928063,
 579371440,
 1734,
 579993599,
 579820743,
 -1,
 -56686,
 579884574,
 64473,
 -1,
 579975243,
 64474,
 580133578,
 489573143,
 -1,
 580199087,
 580081950,
 -1,
 580264618,
 580130363,
 -1,
 580330139,
 580219652,
 -1,
 580395674,
 580296039,
 -1,
 -56679,
 580353438,
 1762,
 -1,
 580418780,
 1752,
 -1,
 580339809,
 1764,
 580657824,
 580282973,
 -1,
 580723359,
 580624342,
 -1,
 -56674,
 580694305,
 1750,
 -1,
 580730164,
 1751,
 -1,
 580650700,
 1753,
 580985507,
 580628418,
 -1,
 -56670,
 580950875,
 1755,
 -1,
 580998346,
 1557,
 -56668,
 580929577,
 1767,
 -56667,
 581108675,
 1760,
 -56666,
 581216891,
 1756,
 -56665,
 581269782,
 1759,
 -56664,
 581344439,
 1768,
 -56663,
 581383369,
 1754,
 -1,
 581472419,
 1761,
 581640877,
 580193956,
 -1,
 -56660,
 581610107,
 1763,
 -1,
 581639014,
 1773,
 -56658,
 581584937,
 1766,
 -1,
 581782804,
 1765,
 581968574,
 580156260,
 -1,
 582034104,
 581913367,
 -1,
 582099637,
 581962364,
 -1,
 -56653,
 582045922,
 1537,
 -56652,
 582092017,
 1552,
 -1,
 582196037,
 1539,
 582418431,
 582069005,
 -1,
 -56649,
 582301820,
 1790,
 -1,
 582377666,
 1789,
 582558395,
 582003004,
 -1,
 -56646,
 582516150,
 1554,
 -1,
 582591772,
 1555,
 -56644,
 582526592,
 1556,
 -56643,
 582711257,
 1551,
 -1,
 582759131,
 1553,
 582951620,
 581941432,
 -1,
 583017155,
 582892793,
 1618,
 583139327,
 582966471,
 -1,
 -56638,
 583016548,
 65151,
 -1,
 583095838,
 65150,
 -1,
 582983523,
 1622,
 583344840,
 582901775,
 1617,
 583467007,
 583294151,
 -1,
 -56633,
 583344228,
 65149,
 -1,
 583423518,
 65148,
 -56631,
 583309554,
 1758,
 -1,
 583555434,
 1563,
 583738069,
 580073343,
 -1,
 583803602,
 583694657,
 1614,
 583869136,
 583752903,
 -1,
 -56626,
 583828344,
 1630,
 -56625,
 583868516,
 65143,
 -1,
 583947806,
 65142,
 584187903,
 583818558,
 1611,
 -1,
 584071242,
 65136,
 -56621,
 583737201,
 1748,
 -56620,
 584231836,
 1538,
 -1,
 584278074,
 1645,
 584458975,
 583673152,
 -1,
 584524510,
 584387196,
 -1,
 584590045,
 584464477,
 1615,
 584655578,
 584539454,
 1612,
 -1,
 584595530,
 65138,
 584843263,
 584604871,
 -1,
 -56612,
 584720484,
 65145,
 -1,
 584799774,
 65144,
 -1,
 584531459,
 1549,
 -1,
 584460644,
 1643,
 585114342,
 584429506,
 -1,
 585179876,
 585042556,
 -1,
 585245411,
 585111049,
 1600,
 -1,
 585211946,
 65137,
 -1,
 585199390,
 65139,
 -56603,
 585109460,
 1566,
 -1,
 585379329,
 1644,
 585573100,
 585063329,
 1616,
 585638633,
 585522494,
 1613,
 -1,
 585578570,
 65140,
 585826303,
 585587911,
 -1,
 -56597,
 585703524,
 65147,
 -1,
 585782814,
 65146,
 585966320,
 585519347,
 -1,
 -56594,
 585921567,
 1626,
 -56593,
 585999859,
 1627,
 -1,
 586047649,
 1628,
 586228468,
 585927884,
 -1,
 -56590,
 586163814,
 1550,
 -56589,
 586229019,
 1769,
 -1,
 586326637,
 1642,
 586490617,
 586165969,
 -1,
 586556152,
 586429748,
 -1,
 -56585,
 586482211,
 1770,
 -1,
 586578157,
 1771,
 -1,
 586492725,
 1757,
 586818300,
 586422027,
 -1,
 -56581,
 586748432,
 1772,
 -1,
 586822873,
 1629,
 587014911,
 586757542,
 -1,
 -56578,
 586946083,
 1624,
 -1,
 587038123,
 1619,
 587211522,
 586953766,
 -1,
 -56575,
 587145906,
 1621,
 -1,
 587240328,
 1620,
 -56573,
 587174114,
 1625,
 -56572,
 587341177,
 1567,
 -56571,
 587426648,
 1536,
 -56570,
 587468024,
 1623,
 -1,
 587571432,
 1548,
 587792383,
 489532917,
 -1,
 587801355,
 587706306,
 -1,
 -56566,
 587744876,
 1634,
 -1,
 587809711,
 1635,
 587997966,
 587746071,
 -1,
 -56563,
 587943775,
 1638,
 -1,
 587991109,
 1639,
 588194577,
 587937663,
 -1,
 -56560,
 588145588,
 1636,
 -1,
 588219580,
 1637,
 -56558,
 588128182,
 1632,
 -56557,
 588319272,
 1633,
 -56556,
 588424726,
 1641,
 -1,
 588463851,
 1640,
 588653457,
 489454290,
 -1,
 588718930,
 588596296,
 -1,
 588784458,
 588681985,
 -1,
 588849950,
 588717109,
 -1,
 588915484,
 588790137,
 -1,
 -56549,
 588868792,
 1395,
 -1,
 588909180,
 1401,
 -56547,
 588854626,
 1409,
 -1,
 589040252,
 1390,
 589243170,
 588787409,
 -1,
 -56544,
 589213634,
 1384,
 -56543,
 589248889,
 1383,
 -1,
 589307755,
 1381,
 589505317,
 589180023,
 -1,
 -56540,
 589440936,
 1386,
 -1,
 589499004,
 1382,
 589701927,
 589468781,
 1397,
 -1,
 589640208,
 1410,
 589833002,
 589629467,
 -1,
 -56535,
 589772130,
 1400,
 -1,
 589851972,
 1406,
 590029613,
 589803458,
 -1,
 -56532,
 589968738,
 1385,
 -1,
 590050682,
 1407,
 590226224,
 589974295,
 -1,
 -56529,
 590161820,
 1399,
 -1,
 590245048,
 1405,
 590422835,
 590157579,
 -1,
 -56526,
 590376120,
 1408,
 -1,
 590416508,
 1404,
 590619446,
 590384332,
 -1,
 -56523,
 590574994,
 1411,
 -1,
 590638264,
 1402,
 590816057,
 590585616,
 -1,
 -56520,
 590773250,
 1391,
 -1,
 590821753,
 1412,
 591012668,
 590764028,
 -1,
 -56517,
 590938307,
 1403,
 -1,
 591006332,
 1393,
 591209279,
 590954309,
 -1,
 -56514,
 591155135,
 1379,
 -1,
 591215025,
 1394,
 -56512,
 591146209,
 1389,
 -56511,
 591364519,
 1413,
 -56510,
 591398336,
 1398,
 -56509,
 591497283,
 1396,
 -56508,
 591531757,
 1388,
 -56507,
 591602682,
 1387,
 -56506,
 591669096,
 1392,
 -56505,
 591771004,
 1414,
 -56504,
 591807404,
 1380,
 -56503,
 591860385,
 1378,
 -1,
 591948390,
 1377,
 592183295,
 588750806,
 -1,
 592192336,
 592052293,
 -1,
 -56499,
 592129249,
 64279,
 -56498,
 592184768,
 64275,
 -56497,
 592258042,
 64277,
 -1,
 592319261,
 64276,
 -56495,
 592164759,
 64278,
 -1,
 592479150,
 1415,
 592651143,
 588651573,
 -1,
 592716678,
 592595714,
 -1,
 592782170,
 592649269,
 -1,
 592847704,
 592722297,
 -1,
 -56489,
 592800952,
 1347,
 -1,
 592841340,
 1353,
 -56487,
 592786786,
 1361,
 -1,
 592972412,
 1342,
 593175390,
 592719569,
 -1,
 -56484,
 593145794,
 1336,
 -56483,
 593181049,
 1335,
 -1,
 593239915,
 1333,
 593437537,
 593112183,
 -1,
 -56480,
 593373096,
 1338,
 -1,
 593431164,
 1334,
 593634147,
 593400941,
 1349,
 -1,
 593572368,
 1362,
 593765222,
 593561627,
 -1,
 -56475,
 593704290,
 1352,
 -1,
 593784132,
 1358,
 593961833,
 593735618,
 -1,
 -56472,
 593900898,
 1337,
 -1,
 593982842,
 1359,
 594158444,
 593906455,
 -1,
 -56469,
 594093980,
 1351,
 -1,
 594177208,
 1357,
 594355055,
 594089739,
 -1,
 -56466,
 594308280,
 1360,
 -1,
 594348668,
 1356,
 594551666,
 594316492,
 -1,
 -56463,
 594507154,
 1363,
 -1,
 594570424,
 1354,
 594748277,
 594517776,
 -1,
 -56460,
 594705410,
 1343,
 -1,
 594753913,
 1364,
 594944888,
 594696188,
 -1,
 -56457,
 594870467,
 1355,
 -1,
 594938492,
 1345,
 595141499,
 594886469,
 -1,
 -56454,
 595087295,
 1331,
 -1,
 595147185,
 1346,
 -56452,
 595078369,
 1341,
 -56451,
 595296679,
 1365,
 -56450,
 595330496,
 1350,
 -56449,
 595429443,
 1348,
 -56448,
 595463917,
 1340,
 -56447,
 595534842,
 1339,
 -56446,
 595601256,
 1344,
 -56445,
 595703164,
 1366,
 -56444,
 595739564,
 1332,
 -56443,
 595792545,
 1330,
 -1,
 595880550,
 1329,
 -1,
 592654018,
 1373,
 596124554,
 592588497,
 -1,
 -56439,
 596057743,
 1372,
 -1,
 596128123,
 1371,
 596321165,
 596052604,
 -1,
 -56436,
 596271527,
 1370,
 -1,
 596357808,
 1375,
 -56434,
 596254073,
 1374,
 -56433,
 596444288,
 1369,
 -56432,
 596508734,
 1418,
 -1,
 596591095,
 1417,
 596779928,
 588588468,
 -1,
 596845461,
 596733161,
 -1,
 -56428,
 596786564,
 10548,
 -1,
 596845581,
 10549,
 597098495,
 596775247,
 -1,
 -56425,
 597011505,
 10551,
 -1,
 597066944,
 10550,
 -56423,
 596748672,
 9800,
 -1,
 597171253,
 8978,
 597369863,
 489393356,
 -1,
 597435390,
 597323714,
 -1,
 597500860,
 597366430,
 -1,
 597566393,
 597461434,
 9109,
 597688319,
 597515463,
 -1,
 597697448,
 597566784,
 -1,
 597762979,
 597654922,
 -1,
 -56414,
 597730954,
 9047,
 -1,
 597797337,
 9036,
 597959590,
 597708683,
 -1,
 -56411,
 597911971,
 9017,
 -1,
 597950621,
 9018,
 598212607,
 597912739,
 9044,
 -1,
 598116782,
 9037,
 598287275,
 597660879,
 -1,
 -56406,
 598255242,
 9040,
 -1,
 598321625,
 9043,
 598483886,
 598215109,
 -1,
 -56403,
 598456435,
 9027,
 -1,
 598503831,
 9031,
 598680497,
 598416437,
 -1,
 -56400,
 598645808,
 9056,
 -1,
 598683918,
 9020,
 -56398,
 598645181,
 9025,
 -56397,
 598840252,
 9032,
 -56396,
 598885400,
 9072,
 -56395,
 598953428,
 9071,
 -56394,
 599002386,
 9019,
 -56393,
 599101900,
 9028,
 -56392,
 599165125,
 9016,
 -1,
 599236128,
 9026,
 599457791,
 597522433,
 -1,
 -56389,
 599328317,
 9048,
 -1,
 599427044,
 9054,
 599598030,
 597435712,
 -1,
 599663557,
 599555466,
 -1,
 599729092,
 599612615,
 -1,
 599794626,
 599686186,
 -1,
 -56383,
 599721533,
 9034,
 -1,
 599788818,
 9038,
 -56381,
 599764298,
 9062,
 -1,
 599942495,
 9073,
 -1,
 599684109,
 9046,
 600187853,
 599616675,
 -1,
 600253386,
 600136903,
 -1,
 -56376,
 600213280,
 9067,
 -56375,
 600284734,
 9042,
 -1,
 600320260,
 9058,
 600571903,
 600181723,
 -1,
 -56372,
 600442429,
 9049,
 -1,
 600546878,
 9035,
 -1,
 600156864,
 9050,
 600777688,
 599530549,
 -1,
 600843223,
 600721557,
 -1,
 600908755,
 600794361,
 -1,
 -56366,
 600853349,
 9021,
 -1,
 600934928,
 9055,
 -56364,
 600835645,
 9052,
 -56363,
 601034002,
 9022,
 -56362,
 601106692,
 9061,
 -1,
 601202208,
 9033,
 -1,
 600800514,
 9066,
 601433057,
 600741071,
 -1,
 601498592,
 601382087,
 -1,
 601564126,
 601455658,
 -1,
 -56356,
 601502628,
 9041,
 -56355,
 601558290,
 9045,
 -1,
 601630980,
 9057,
 -56353,
 601521510,
 9053,
 -1,
 601777503,
 9074,
 -1,
 601453581,
 9039,
 602022888,
 601377559,
 -1,
 602088421,
 601993154,
 -1,
 -56348,
 602017831,
 9069,
 -1,
 602124268,
 9059,
 -56346,
 602040172,
 9015,
 -56345,
 602249394,
 9023,
 -1,
 602289275,
 9070,
 602481644,
 601968523,
 -1,
 602547179,
 602436507,
 9075,
 -1,
 602503326,
 9080,
 -1,
 602491810,
 9014,
 602743791,
 602412811,
 -1,
 -56338,
 602708528,
 9030,
 -1,
 602744680,
 9076,
 602940401,
 602706635,
 9077,
 -1,
 602896542,
 9081,
 603071476,
 602891211,
 -1,
 -56333,
 603026445,
 9029,
 -1,
 603065100,
 9063,
 603268087,
 603041358,
 -1,
 -56330,
 603194941,
 9051,
 -1,
 603269380,
 9060,
 603464697,
 603216917,
 9082,
 -1,
 603420830,
 9078,
 -56326,
 603411635,
 9068,
 -56325,
 603555654,
 9064,
 -56324,
 603601104,
 9065,
 -56323,
 603660265,
 9079,
 -1,
 603742884,
 9024,
 603923462,
 597379905,
 -1,
 603988997,
 603889535,
 -1,
 604054532,
 603951066,
 -1,
 604120067,
 604014954,
 8773,
 -1,
 604046788,
 8786,
 -1,
 604054487,
 10864,
 -1,
 604016380,
 8774,
 -1,
 603961141,
 8784,
 -1,
 603875202,
 39,
 604513367,
 597340743,
 -1,
 604578886,
 604461041,
 -1,
 604644378,
 604549058,
 -1,
 604709905,
 604574008,
 -1,
 604775439,
 604648802,
 65800,
 604897279,
 604724423,
 -1,
 -56306,
 604779811,
 65827,
 -1,
 604838737,
 65818,
 605093887,
 604706856,
 65809,
 -1,
 604996852,
 65836,
 605168664,
 604649849,
 -1,
 605234198,
 605119275,
 65801,
 605356031,
 605183175,
 -1,
 -56299,
 605238563,
 65828,
 -1,
 605297489,
 65819,
 605552639,
 605166443,
 65810,
 -1,
 605455604,
 65837,
 605683711,
 605121714,
 65808,
 -1,
 605586676,
 65835,
 605758503,
 604588823,
 -1,
 605824033,
 605704031,
 65804,
 605889566,
 605784382,
 65813,
 -1,
 605848820,
 65840,
 606076927,
 605838535,
 -1,
 -56288,
 605959459,
 65831,
 -1,
 606018385,
 65822,
 606273535,
 605751365,
 65805,
 606282788,
 606177598,
 65814,
 -1,
 606242036,
 65841,
 606470143,
 606231751,
 -1,
 -56282,
 606352675,
 65832,
 -1,
 606411601,
 65823,
 606610486,
 605697919,
 -1,
 606676015,
 606549346,
 -1,
 606741549,
 606647136,
 65802,
 606863359,
 606690503,
 -1,
 -56276,
 606745891,
 65829,
 -1,
 606804817,
 65820,
 607059967,
 606682910,
 65811,
 -1,
 606962932,
 65838,
 607191039,
 606621579,
 -1,
 607200308,
 607068765,
 65803,
 607322111,
 607149255,
 -1,
 -56269,
 607204643,
 65830,
 -1,
 607263569,
 65821,
 607518719,
 607152647,
 65812,
 -1,
 607421684,
 65839,
 607593532,
 606578198,
 65807,
 607659065,
 607553854,
 65816,
 -1,
 607618292,
 65843,
 607846399,
 607608007,
 -1,
 -56261,
 607728931,
 65834,
 -1,
 607787857,
 65825,
 607986754,
 607534827,
 65806,
 608052287,
 607920852,
 65815,
 -1,
 608011508,
 65842,
 608239615,
 608001223,
 -1,
 -56255,
 608122147,
 65833,
 -1,
 608181073,
 65824,
 608436223,
 607914536,
 65799,
 608501759,
 608328903,
 -1,
 -56251,
 608384291,
 65826,
 -1,
 608443217,
 65817,
 608642129,
 604508472,
 -1,
 608707662,
 608588705,
 -1,
 608773195,
 608647039,
 -1,
 -56246,
 608714295,
 65851,
 -1,
 608783057,
 65848,
 -56244,
 608742832,
 65850,
 -56243,
 608941937,
 65849,
 -1,
 608975114,
 65847,
 609222655,
 608653034,
 -1,
 -56240,
 609118511,
 65792,
 -1,
 609190790,
 65793,
 609363028,
 608580115,
 -1,
 -56237,
 609332656,
 65855,
 -1,
 609400689,
 65854,
 -56235,
 609299592,
 65853,
 -56234,
 609518726,
 65852,
 -1,
 609586312,
 65794,
 609756265,
 604470274,
 -1,
 609821792,
 609722717,
 -1,
 609887324,
 609754165,
 -1,
 -56229,
 609839100,
 8755,
 -1,
 609905462,
 10560,
 -56227,
 609838126,
 8630,
 -56226,
 610040892,
 8634,
 -56225,
 610106358,
 10769,
 -1,
 610146845,
 10226,
 610346086,
 609763141,
 -1,
 610411621,
 610273733,
 8736,
 610533375,
 610348484,
 -1,
 -56220,
 610403901,
 10660,
 -1,
 610474252,
 10654,
 -1,
 610377147,
 8491,
 -56217,
 610311982,
 9765,
 -56216,
 610692206,
 10193,
 -1,
 610756214,
 9875,
 610935925,
 609708637,
 -1,
 611001454,
 610907748,
 -1,
 611066989,
 610961770,
 8776,
 -1,
 610997403,
 10863,
 -1,
 611001303,
 8778,
 611263601,
 610929307,
 -1,
 -56208,
 611212570,
 8780,
 -1,
 611280263,
 9006,
 611460212,
 611200721,
 -1,
 -56205,
 611417025,
 9879,
 -1,
 611452834,
 8501,
 -1,
 611388639,
 9095,
 611722365,
 610880279,
 -1,
 611787898,
 611655196,
 -1,
 611853433,
 611737712,
 42,
 -1,
 611799204,
 8727,
 -1,
 611808004,
 8258,
 -56197,
 611741989,
 8771,
 -56196,
 612017383,
 8870,
 -1,
 612082048,
 9738,
 612246661,
 611654709,
 -1,
 612312193,
 612210572,
 -1,
 -56192,
 612261058,
 10655,
 -1,
 612346631,
 180,
 612508804,
 612261938,
 -1,
 -56189,
 612481383,
 8299,
 -1,
 612544108,
 8301,
 -1,
 612452297,
 8448,
 612770952,
 612201220,
 -1,
 -56185,
 612724789,
 38,
 -1,
 612763348,
 10815,
 612967563,
 612705600,
 -1,
 -56182,
 612917844,
 9772,
 -1,
 612979712,
 8449,
 -56180,
 612920521,
 8371,
 -56179,
 613117015,
 9883,
 -56178,
 613194165,
 9810,
 -56177,
 613234919,
 9992,
 -1,
 613321915,
 1547,
 613493153,
 489300692,
 -1,
 613558688,
 613437323,
 -1,
 613624223,
 613506247,
 -1,
 613689681,
 613553437,
 -1,
 613754201,
 613645314,
 -1,
 613819571,
 613690487,
 -1,
 613885085,
 613791928,
 41727,
 613950617,
 613816075,
 41730,
 -1,
 613882299,
 41729,
 614081691,
 613889378,
 41721,
 -1,
 614013371,
 41720,
 -56164,
 614013371,
 41726,
 -1,
 614173900,
 41728,
 614343844,
 613830539,
 41711,
 614409377,
 614280913,
 41714,
 -56160,
 614341051,
 41713,
 -1,
 614436044,
 41715,
 -56158,
 614341051,
 41710,
 -56157,
 614576066,
 41709,
 -1,
 614632652,
 41712,
 614802602,
 614277844,
 41733,
 614868135,
 614733579,
 41736,
 -1,
 614799803,
 41735,
 -56152,
 614799803,
 41732,
 -56151,
 614969282,
 41731,
 -1,
 615025868,
 41734,
 615195822,
 614730364,
 41718,
 -56148,
 615127483,
 41717,
 -56147,
 615231426,
 41716,
 -1,
 615288012,
 41719,
 615457969,
 615134562,
 -1,
 -56144,
 615389627,
 41722,
 -1,
 615484620,
 41723,
 615710719,
 615395025,
 41725,
 -1,
 615586235,
 41724,
 615785679,
 613749617,
 -1,
 615851195,
 615731083,
 41080,
 615916728,
 615788241,
 41083,
 -56137,
 615848379,
 41082,
 -1,
 615943372,
 41084,
 -56135,
 615848379,
 41079,
 -56134,
 616083394,
 41078,
 -1,
 616139980,
 41081,
 616309953,
 615785172,
 41101,
 616375486,
 616240907,
 41104,
 -1,
 616307131,
 41103,
 -56129,
 616307131,
 41100,
 -56128,
 616476610,
 41099,
 -1,
 616533196,
 41102,
 616703175,
 616282296,
 41095,
 616768708,
 616634123,
 41098,
 -1,
 616700347,
 41097,
 -56123,
 616700347,
 41094,
 -56122,
 616869826,
 41093,
 -1,
 616926412,
 41096,
 617096395,
 616641890,
 41091,
 -56119,
 617028027,
 41090,
 -56118,
 617131970,
 41089,
 -1,
 617188556,
 41092,
 617414655,
 617024124,
 41087,
 -56115,
 617290171,
 41086,
 -56114,
 617394114,
 41085,
 -1,
 617450700,
 41088,
 617620713,
 615733244,
 -1,
 617686232,
 617566091,
 42035,
 617751765,
 617623249,
 42039,
 -56109,
 617683387,
 42038,
 -56108,
 617787330,
 42037,
 -1,
 617843916,
 42040,
 -56106,
 617683387,
 42034,
 -56105,
 617983938,
 42033,
 -1,
 618040524,
 42036,
 618210527,
 617658552,
 42048,
 618276059,
 618141451,
 42051,
 -1,
 618207675,
 42050,
 618407133,
 618214754,
 42042,
 -1,
 618338747,
 42041,
 -56098,
 618338747,
 42047,
 -1,
 618499276,
 42049,
 618669285,
 618144468,
 42054,
 618734818,
 618600203,
 42057,
 -1,
 618666427,
 42056,
 -56093,
 618666427,
 42053,
 -56092,
 618835906,
 42052,
 -1,
 618892492,
 42055,
 619118591,
 618607970,
 42045,
 -56089,
 618994107,
 42044,
 -56088,
 619098050,
 42043,
 -1,
 619154636,
 42046,
 619324673,
 617551627,
 -1,
 619390192,
 619258580,
 41895,
 619455725,
 619321099,
 41898,
 -1,
 619387323,
 41897,
 -56082,
 619387323,
 41894,
 -56081,
 619556802,
 41893,
 -1,
 619613388,
 41896,
 619783414,
 619362488,
 41889,
 619848947,
 619714315,
 41892,
 -1,
 619780539,
 41891,
 -56076,
 619780539,
 41888,
 -56075,
 619950018,
 41887,
 -1,
 620006604,
 41890,
 620176634,
 619720401,
 41885,
 -56072,
 620108219,
 41884,
 -56071,
 620212162,
 41883,
 -1,
 620268748,
 41886,
 620438782,
 620104316,
 41878,
 -56068,
 620370363,
 41877,
 -56067,
 620474306,
 41876,
 -1,
 620530892,
 41879,
 620756991,
 620377442,
 41881,
 -56064,
 620632507,
 41880,
 -1,
 620727500,
 41882,
 620897561,
 619259200,
 -1,
 620963080,
 620869816,
 41316,
 621028613,
 620893963,
 41319,
 -1,
 620960187,
 41318,
 -56058,
 620960187,
 41315,
 -56057,
 621129666,
 41314,
 -1,
 621186252,
 41317,
 621356302,
 620908427,
 41299,
 621421835,
 621293265,
 41302,
 -1,
 621353403,
 41301,
 -56052,
 621353403,
 41298,
 -56051,
 621522882,
 41297,
 -1,
 621579468,
 41300,
 621749522,
 621294946,
 41309,
 -56048,
 621681083,
 41308,
 -56047,
 621785026,
 41307,
 -1,
 621841612,
 41310,
 622011670,
 621677180,
 41305,
 -56044,
 621943227,
 41304,
 -56043,
 622047170,
 41303,
 -1,
 622103756,
 41306,
 622329855,
 621948625,
 41312,
 -56040,
 622205371,
 41311,
 -1,
 622300364,
 41313,
 622470445,
 620831444,
 -1,
 622535970,
 622415755,
 42060,
 622601503,
 622472913,
 42064,
 -56035,
 622533051,
 42063,
 -56034,
 622636994,
 42062,
 -1,
 622693580,
 42065,
 -56032,
 622533051,
 42059,
 -56031,
 622833602,
 42058,
 -1,
 622890188,
 42061,
 623060265,
 622508216,
 42075,
 623125798,
 622998882,
 42067,
 -56027,
 623057339,
 42066,
 -1,
 623152332,
 42068,
 -56025,
 623057339,
 42074,
 -56024,
 623292354,
 42073,
 -1,
 623348940,
 42076,
 623575039,
 622998882,
 42071,
 -56021,
 623450555,
 42070,
 -56020,
 623554498,
 42069,
 -1,
 623611084,
 42072,
 623781183,
 622411589,
 -1,
 623846706,
 623719778,
 41577,
 -56016,
 623778235,
 41576,
 -56015,
 623882178,
 41575,
 -1,
 623938764,
 41578,
 624108854,
 623774332,
 41570,
 -56012,
 624040379,
 41569,
 -56011,
 624144322,
 41568,
 -1,
 624200908,
 41571,
 624371001,
 624079721,
 41574,
 -56008,
 624302523,
 41573,
 -1,
 624406466,
 41572,
 624567612,
 624316384,
 41566,
 -56005,
 624499131,
 41565,
 -1,
 624594124,
 41567,
 624820223,
 624504529,
 41580,
 -56002,
 624695739,
 41579,
 -1,
 624790732,
 41581,
 624960840,
 623753400,
 41363,
 625026371,
 624899426,
 41352,
 -55998,
 624957883,
 41351,
 -1,
 625052876,
 41353,
 625222981,
 624957195,
 41366,
 -1,
 625154491,
 41365,
 -55994,
 625154491,
 41362,
 -55993,
 625323970,
 41361,
 -1,
 625380556,
 41364,
 625550671,
 624906123,
 41343,
 625616204,
 625487569,
 41346,
 -55989,
 625547707,
 41345,
 -1,
 625642700,
 41347,
 -55987,
 625547707,
 41342,
 -55986,
 625782722,
 41341,
 -1,
 625839308,
 41344,
 626009427,
 625489250,
 41356,
 -55983,
 625940923,
 41355,
 -55982,
 626044866,
 41354,
 -1,
 626101452,
 41357,
 626271574,
 625946321,
 41359,
 -55979,
 626203067,
 41358,
 -1,
 626298060,
 41360,
 626524159,
 626199164,
 41349,
 -55976,
 626399675,
 41348,
 -1,
 626494668,
 41350,
 626664924,
 613693817,
 -1,
 626730363,
 626616925,
 -1,
 626795876,
 626702520,
 41389,
 626861407,
 626734434,
 41379,
 -55970,
 626792891,
 41378,
 -1,
 626887884,
 41380,
 627058017,
 626792203,
 41392,
 -1,
 626989499,
 41391,
 -55966,
 626989499,
 41388,
 -55965,
 627158978,
 41387,
 -1,
 627215564,
 41390,
 627385707,
 626741131,
 41369,
 627451240,
 627322577,
 41372,
 -55961,
 627382715,
 41371,
 -1,
 627477708,
 41373,
 -55959,
 627382715,
 41368,
 -55958,
 627617730,
 41367,
 -1,
 627674316,
 41370,
 627844465,
 627319508,
 41395,
 627909998,
 627775243,
 41398,
 -1,
 627841467,
 41397,
 -55953,
 627841467,
 41394,
 -55952,
 628010946,
 41393,
 -1,
 628067532,
 41396,
 628237685,
 627772028,
 41376,
 -55949,
 628169147,
 41375,
 -55948,
 628273090,
 41374,
 -1,
 628329676,
 41377,
 628499832,
 628176226,
 41382,
 -55945,
 628431291,
 41381,
 -1,
 628526284,
 41383,
 628752383,
 628436689,
 41385,
 -55942,
 628627899,
 41384,
 -1,
 628722892,
 41386,
 628893081,
 626684676,
 -1,
 628958597,
 628865208,
 41125,
 629024128,
 628897122,
 41117,
 -55937,
 628955579,
 41116,
 -1,
 629050572,
 41118,
 629220738,
 628954891,
 41128,
 -1,
 629152187,
 41127,
 -55933,
 629152187,
 41124,
 -55932,
 629321666,
 41123,
 -1,
 629378252,
 41126,
 629548428,
 628903819,
 41107,
 629613961,
 629485265,
 41110,
 -55928,
 629545403,
 41109,
 -1,
 629640396,
 41111,
 -55926,
 629545403,
 41106,
 -55925,
 629780418,
 41105,
 -1,
 629837004,
 41108,
 630007185,
 629482196,
 41130,
 630072719,
 629937931,
 41133,
 -1,
 630004155,
 41132,
 -55920,
 630004155,
 41129,
 -1,
 630164684,
 41131,
 630334869,
 629945698,
 41121,
 -55917,
 630266299,
 41120,
 -55916,
 630370242,
 41119,
 -1,
 630426828,
 41122,
 630652927,
 630262396,
 41114,
 -55913,
 630528443,
 41113,
 -55912,
 630632386,
 41112,
 -1,
 630688972,
 41115,
 630859185,
 628824507,
 -1,
 630924706,
 630804363,
 41544,
 630990239,
 630861521,
 41548,
 -55907,
 630921659,
 41547,
 -55906,
 631025602,
 41546,
 -1,
 631082188,
 41549,
 -55904,
 630921659,
 41543,
 -55903,
 631222210,
 41542,
 -1,
 631278796,
 41545,
 631448998,
 630895465,
 41556,
 -55900,
 631380411,
 41555,
 -55899,
 631484354,
 41554,
 -1,
 631540940,
 41557,
 631711146,
 631387490,
 41560,
 -55896,
 631642555,
 41559,
 -55895,
 631746498,
 41558,
 -1,
 631803084,
 41561,
 631973294,
 631638652,
 41552,
 -55892,
 631904699,
 41551,
 -55891,
 632008642,
 41550,
 -1,
 632065228,
 41553,
 632291327,
 631910097,
 41563,
 -55888,
 632166843,
 41562,
 -1,
 632261836,
 41564,
 632432073,
 630815746,
 -1,
 632497594,
 632377227,
 41322,
 632563127,
 632434385,
 41326,
 -55883,
 632494523,
 41325,
 -55882,
 632598466,
 41324,
 -1,
 632655052,
 41327,
 -55880,
 632494523,
 41321,
 -55879,
 632795074,
 41320,
 -1,
 632851660,
 41323,
 633021886,
 632425084,
 41330,
 -55876,
 632953275,
 41329,
 -55875,
 633057218,
 41328,
 -1,
 633113804,
 41331,
 633284034,
 632993976,
 -1,
 633349569,
 633222498,
 41333,
 -1,
 633280955,
 41332,
 -1,
 633319362,
 41340,
 633546182,
 633222498,
 -1,
 -55868,
 633477563,
 41335,
 -55867,
 633581506,
 41334,
 -1,
 633638092,
 41336,
 633864191,
 633482961,
 41338,
 -55864,
 633739707,
 41337,
 -1,
 633834700,
 41339,
 634004941,
 632402793,
 41591,
 -55861,
 633936315,
 41590,
 -55860,
 634040258,
 41589,
 -1,
 634096844,
 41592,
 634267089,
 633943394,
 41595,
 -55857,
 634198459,
 41594,
 -55856,
 634302402,
 41593,
 -1,
 634358988,
 41596,
 634529237,
 634194556,
 41587,
 -55853,
 634460603,
 41586,
 -55852,
 634564546,
 41585,
 -1,
 634621132,
 41588,
 634791385,
 634474379,
 -1,
 634856920,
 634728145,
 41584,
 -1,
 634788283,
 41583,
 -1,
 634826690,
 41582,
 635109375,
 634728145,
 41598,
 -55845,
 634984891,
 41597,
 -1,
 635079884,
 41599,
 635250232,
 626601079,
 -1,
 635315707,
 635186295,
 -1,
 635381222,
 635260811,
 41682,
 635446755,
 635317969,
 41686,
 -55839,
 635378107,
 41685,
 -55838,
 635482050,
 41684,
 -1,
 635538636,
 41687,
 -55836,
 635378107,
 41681,
 -55835,
 635678658,
 41680,
 -1,
 635735244,
 41683,
 635905516,
 635314900,
 41705,
 635971049,
 635836171,
 41708,
 -1,
 635902395,
 41707,
 -55830,
 635902395,
 41704,
 -55829,
 636071874,
 41703,
 -1,
 636128460,
 41706,
 636298737,
 635877560,
 41699,
 636364271,
 636229387,
 41702,
 -1,
 636295611,
 41701,
 -55824,
 636295611,
 41698,
 -1,
 636456140,
 41700,
 636626421,
 636226172,
 41690,
 -55821,
 636557755,
 41689,
 -55820,
 636661698,
 41688,
 -1,
 636718284,
 41691,
 636888568,
 636564834,
 41693,
 -55817,
 636819899,
 41692,
 -1,
 636914892,
 41694,
 637140991,
 636825297,
 41696,
 -55814,
 637016507,
 41695,
 -1,
 637111500,
 41697,
 637281815,
 635255161,
 -1,
 637347333,
 637253816,
 41815,
 637412864,
 637285730,
 41803,
 -55809,
 637344187,
 41802,
 -1,
 637439180,
 41804,
 637609474,
 637343499,
 41818,
 -1,
 637540795,
 41817,
 -55805,
 637540795,
 41814,
 -55804,
 637710274,
 41813,
 -1,
 637766860,
 41816,
 637937163,
 637280980,
 41821,
 638002696,
 637867787,
 41824,
 -1,
 637934011,
 41823,
 -55799,
 637934011,
 41820,
 -55798,
 638103490,
 41819,
 -1,
 638160076,
 41822,
 638330383,
 637875554,
 41807,
 -55795,
 638261691,
 41806,
 -55794,
 638365634,
 41805,
 -1,
 638422220,
 41808,
 638592531,
 638267089,
 41811,
 -55791,
 638523835,
 41810,
 -55790,
 638627778,
 41809,
 -1,
 638684364,
 41812,
 638910463,
 638519932,
 41800,
 -55787,
 638785979,
 41799,
 -55786,
 638889922,
 41798,
 -1,
 638946508,
 41801,
 639116832,
 637253816,
 41636,
 639182363,
 639055202,
 41625,
 -55782,
 639113659,
 41624,
 -1,
 639208652,
 41626,
 639378973,
 639112971,
 41639,
 -1,
 639310267,
 41638,
 -55778,
 639310267,
 41635,
 -55777,
 639479746,
 41634,
 -1,
 639536332,
 41637,
 639706663,
 639061899,
 41615,
 639772196,
 639643345,
 41618,
 -55773,
 639703483,
 41617,
 -1,
 639798476,
 41619,
 -55771,
 639703483,
 41614,
 -55770,
 639938498,
 41613,
 -1,
 639995084,
 41616,
 640165421,
 639640276,
 41642,
 640230954,
 640096011,
 41645,
 -1,
 640162235,
 41644,
 -55765,
 640162235,
 41641,
 -55764,
 640331714,
 41640,
 -1,
 640388300,
 41643,
 640558641,
 640103778,
 41629,
 -55761,
 640489915,
 41628,
 -55760,
 640593858,
 41627,
 -1,
 640650444,
 41630,
 640820789,
 640486012,
 41622,
 -55757,
 640752059,
 41621,
 -55756,
 640856002,
 41620,
 -1,
 640912588,
 41623,
 641138687,
 640757457,
 41632,
 -55753,
 641014203,
 41631,
 -1,
 641109196,
 41633,
 641279635,
 635194135,
 -1,
 641345110,
 641223447,
 -1,
 641410625,
 641290123,
 41772,
 641476158,
 641347281,
 41775,
 -55747,
 641407419,
 41774,
 -1,
 641502412,
 41776,
 -55745,
 641407419,
 41771,
 -55744,
 641642434,
 41770,
 -1,
 641699020,
 41773,
 641869383,
 641344212,
 41794,
 641934916,
 641799947,
 41797,
 -1,
 641866171,
 41796,
 -55739,
 641866171,
 41793,
 -55738,
 642035650,
 41792,
 -1,
 642092236,
 41795,
 642262603,
 641841336,
 41790,
 -55735,
 642193851,
 41789,
 -55734,
 642297794,
 41788,
 -1,
 642354380,
 41791,
 642524751,
 642200930,
 41783,
 -55731,
 642455995,
 41782,
 -55730,
 642559938,
 41781,
 -1,
 642616524,
 41784,
 642786899,
 642452092,
 41779,
 -55727,
 642718139,
 41778,
 -55726,
 642822082,
 41777,
 -1,
 642878668,
 41780,
 643104767,
 642723537,
 41786,
 -55723,
 642980283,
 41785,
 -1,
 643075276,
 41787,
 643245682,
 641284473,
 -1,
 643311200,
 643217592,
 41916,
 643376731,
 643249506,
 41904,
 -55718,
 643307963,
 41903,
 -1,
 643402956,
 41905,
 643573341,
 643307275,
 41919,
 -1,
 643504571,
 41918,
 -55714,
 643504571,
 41915,
 -55713,
 643674050,
 41914,
 -1,
 643730636,
 41917,
 643901030,
 643244756,
 41922,
 643966563,
 643831563,
 41925,
 -1,
 643897787,
 41924,
 -55708,
 643897787,
 41921,
 -55707,
 644067266,
 41920,
 -1,
 644123852,
 41923,
 644294250,
 643839330,
 41908,
 -55704,
 644225467,
 41907,
 -55703,
 644329410,
 41906,
 -1,
 644385996,
 41909,
 644556398,
 644230865,
 41912,
 -55700,
 644487611,
 41911,
 -55699,
 644591554,
 41910,
 -1,
 644648140,
 41913,
 644874239,
 644483708,
 41901,
 -55696,
 644749755,
 41900,
 -55695,
 644853698,
 41899,
 -1,
 644910284,
 41902,
 645080699,
 643217592,
 41760,
 645146230,
 645018978,
 41749,
 -55691,
 645077435,
 41748,
 -1,
 645172428,
 41750,
 645342840,
 645076747,
 41763,
 -1,
 645274043,
 41762,
 -55687,
 645274043,
 41759,
 -55686,
 645443522,
 41758,
 -1,
 645500108,
 41761,
 645670530,
 645025675,
 41739,
 645736063,
 645607121,
 41742,
 -55682,
 645667259,
 41741,
 -1,
 645762252,
 41743,
 -55680,
 645667259,
 41738,
 -55679,
 645902274,
 41737,
 -1,
 645958860,
 41740,
 646129288,
 645604052,
 41766,
 646194821,
 646059787,
 41769,
 -1,
 646126011,
 41768,
 -55674,
 646126011,
 41765,
 -55673,
 646295490,
 41764,
 -1,
 646352076,
 41767,
 646522508,
 646067554,
 41753,
 -55670,
 646453691,
 41752,
 -55669,
 646557634,
 41751,
 -1,
 646614220,
 41754,
 646784656,
 646449788,
 41746,
 -55666,
 646715835,
 41745,
 -55665,
 646819778,
 41744,
 -1,
 646876364,
 41747,
 647102463,
 646721233,
 41756,
 -55662,
 646977979,
 41755,
 -1,
 647072972,
 41757,
 647243479,
 641209201,
 -1,
 647308981,
 647172977,
 -1,
 647374494,
 647280824,
 41070,
 647440025,
 647312738,
 41059,
 -55656,
 647371195,
 41058,
 -1,
 647466188,
 41060,
 647636635,
 647370507,
 41073,
 -1,
 647567803,
 41072,
 -55652,
 647567803,
 41069,
 -55651,
 647737282,
 41068,
 -1,
 647793868,
 41071,
 647964326,
 647319435,
 41048,
 648029859,
 647900881,
 41052,
 -55647,
 647961019,
 41051,
 -55646,
 648064962,
 41050,
 -1,
 648121548,
 41053,
 -55644,
 647961019,
 41047,
 -55643,
 648261570,
 41046,
 -1,
 648318156,
 41049,
 648488618,
 647897812,
 41076,
 -55640,
 648419771,
 41075,
 -55639,
 648523714,
 41074,
 -1,
 648580300,
 41077,
 648750766,
 648426850,
 41063,
 -55636,
 648681915,
 41062,
 -55635,
 648785858,
 41061,
 -1,
 648842444,
 41064,
 649012914,
 648678012,
 41056,
 -55632,
 648944059,
 41055,
 -55631,
 649048002,
 41054,
 -1,
 649104588,
 41057,
 649330687,
 648949457,
 41066,
 -55628,
 649206203,
 41065,
 -1,
 649301196,
 41067,
 649471678,
 647280824,
 41006,
 649537209,
 649409890,
 40995,
 -55624,
 649468347,
 40994,
 -1,
 649563340,
 40996,
 649733819,
 649467659,
 41009,
 -1,
 649664955,
 41008,
 -55620,
 649664955,
 41005,
 -55619,
 649834434,
 41004,
 -1,
 649891020,
 41007,
 650061510,
 649416587,
 40984,
 650127043,
 649998033,
 40988,
 -55615,
 650058171,
 40987,
 -55614,
 650162114,
 40986,
 -1,
 650218700,
 40989,
 -55612,
 650058171,
 40983,
 -55611,
 650358722,
 40982,
 -1,
 650415308,
 40985,
 650585804,
 649994964,
 41012,
 650651337,
 650516235,
 41015,
 -1,
 650582459,
 41014,
 -55606,
 650582459,
 41011,
 -55605,
 650751938,
 41010,
 -1,
 650808524,
 41013,
 650979024,
 650524002,
 40999,
 -55602,
 650910139,
 40998,
 -55601,
 651014082,
 40997,
 -1,
 651070668,
 41000,
 651241172,
 650906236,
 40992,
 -55598,
 651172283,
 40991,
 -55597,
 651276226,
 40990,
 -1,
 651332812,
 40993,
 651558911,
 651177681,
 41002,
 -55594,
 651434427,
 41001,
 -1,
 651529420,
 41003,
 651699990,
 647175221,
 -1,
 651765492,
 651639161,
 -1,
 651831010,
 651737272,
 41842,
 651896542,
 651769186,
 41831,
 -55588,
 651827643,
 41830,
 -55587,
 651931586,
 41829,
 -1,
 651988172,
 41832,
 652158688,
 651826955,
 41845,
 -1,
 652089787,
 41844,
 -55583,
 652089787,
 41841,
 -1,
 652250316,
 41843,
 652420840,
 651764436,
 41848,
 652486373,
 652351243,
 41851,
 -1,
 652417467,
 41850,
 -55578,
 652417467,
 41847,
 -55577,
 652586946,
 41846,
 -1,
 652643532,
 41849,
 652814060,
 652359010,
 41835,
 -55574,
 652745147,
 41834,
 -55573,
 652849090,
 41833,
 -1,
 652905676,
 41836,
 653076208,
 652750545,
 41839,
 -55570,
 653007291,
 41838,
 -55569,
 653111234,
 41837,
 -1,
 653167820,
 41840,
 653393919,
 653003388,
 41827,
 -55566,
 653269435,
 41826,
 -55565,
 653373378,
 41825,
 -1,
 653429964,
 41828,
 653600509,
 651737272,
 41670,
 653666040,
 653538658,
 41659,
 -55561,
 653597115,
 41658,
 -1,
 653692108,
 41660,
 653862650,
 653596427,
 41673,
 -1,
 653793723,
 41672,
 -55557,
 653793723,
 41669,
 -55556,
 653963202,
 41668,
 -1,
 654019788,
 41671,
 654190341,
 653545355,
 41648,
 654255874,
 654126801,
 41652,
 -55552,
 654186939,
 41651,
 -55551,
 654290882,
 41650,
 -1,
 654347468,
 41653,
 -55549,
 654186939,
 41647,
 -55548,
 654487490,
 41646,
 -1,
 654544076,
 41649,
 654714635,
 654123732,
 41676,
 654780168,
 654645003,
 41679,
 -1,
 654711227,
 41678,
 -55543,
 654711227,
 41675,
 -55542,
 654880706,
 41674,
 -1,
 654937292,
 41677,
 655107855,
 654652770,
 41663,
 -55539,
 655038907,
 41662,
 -55538,
 655142850,
 41661,
 -1,
 655199436,
 41664,
 655370003,
 655035004,
 41656,
 -55535,
 655301051,
 41655,
 -55534,
 655404994,
 41654,
 -1,
 655461580,
 41657,
 655687679,
 655306449,
 41666,
 -55531,
 655563195,
 41665,
 -1,
 655658188,
 41667,
 655828818,
 651640645,
 -1,
 655894324,
 655769413,
 -1,
 655959842,
 655866040,
 41516,
 656025373,
 655897954,
 41504,
 -55525,
 655956411,
 41503,
 -55524,
 656060354,
 41502,
 -1,
 656116940,
 41505,
 656287519,
 655955723,
 41519,
 -1,
 656218555,
 41518,
 -55520,
 656218555,
 41515,
 -55519,
 656388034,
 41514,
 -1,
 656444620,
 41517,
 656615208,
 655904651,
 41494,
 656680742,
 656551633,
 41496,
 -55515,
 656611771,
 41495,
 -1,
 656706764,
 41497,
 -55513,
 656611771,
 41493,
 -1,
 656846786,
 41492,
 657008428,
 656553314,
 41508,
 -55510,
 656939451,
 41507,
 -55509,
 657043394,
 41506,
 -1,
 657099980,
 41509,
 657270576,
 656944849,
 41512,
 -55506,
 657201595,
 41511,
 -55505,
 657305538,
 41510,
 -1,
 657362124,
 41513,
 657588223,
 657197692,
 41500,
 -55502,
 657463739,
 41499,
 -55501,
 657567682,
 41498,
 -1,
 657624268,
 41501,
 657794878,
 655866040,
 41460,
 657860409,
 657732962,
 41448,
 -55497,
 657791419,
 41447,
 -55496,
 657895362,
 41446,
 -1,
 657951948,
 41449,
 658122555,
 657790731,
 41463,
 -1,
 658053563,
 41462,
 -55492,
 658053563,
 41459,
 -55491,
 658223042,
 41458,
 -1,
 658279628,
 41461,
 658450246,
 657739659,
 41436,
 658515779,
 658386641,
 41440,
 -55487,
 658446779,
 41439,
 -55486,
 658550722,
 41438,
 -1,
 658607308,
 41441,
 -55484,
 658446779,
 41435,
 -55483,
 658747330,
 41434,
 -1,
 658803916,
 41437,
 658974538,
 658388322,
 41452,
 -55480,
 658905531,
 41451,
 -55479,
 659009474,
 41450,
 -1,
 659066060,
 41453,
 659236686,
 658910929,
 41456,
 -55476,
 659167675,
 41455,
 -55475,
 659271618,
 41454,
 -1,
 659328204,
 41457,
 659554303,
 659163772,
 41444,
 -55472,
 659429819,
 41443,
 -55471,
 659533762,
 41442,
 -1,
 659590348,
 41445,
 659761033,
 655782660,
 -1,
 659826538,
 659701573,
 -1,
 659892061,
 659798200,
 41538,
 659957592,
 659830114,
 41527,
 -55465,
 659888571,
 41526,
 -1,
 659983564,
 41528,
 660154202,
 659887883,
 41541,
 -1,
 660085179,
 41540,
 -55461,
 660085179,
 41537,
 -55460,
 660254658,
 41536,
 -1,
 660311244,
 41539,
 660481889,
 659830114,
 41531,
 -55457,
 660412859,
 41530,
 -55456,
 660516802,
 41529,
 -1,
 660573388,
 41532,
 660744037,
 660408956,
 41524,
 -55453,
 660675003,
 41523,
 -55452,
 660778946,
 41522,
 -1,
 660835532,
 41525,
 661006184,
 660680401,
 41534,
 -55449,
 660937147,
 41533,
 -1,
 661032140,
 41535,
 661258239,
 660951008,
 41521,
 -1,
 661133755,
 41520,
 661333876,
 659798200,
 41157,
 661399407,
 661271906,
 41147,
 -55443,
 661330363,
 41146,
 -55442,
 661434306,
 41145,
 -1,
 661490892,
 41148,
 661661553,
 661329675,
 41160,
 -1,
 661592507,
 41159,
 -55438,
 661592507,
 41156,
 -55437,
 661761986,
 41155,
 -1,
 661818572,
 41158,
 661989243,
 661278603,
 41136,
 662054776,
 661925585,
 41139,
 -55433,
 661985723,
 41138,
 -1,
 662080716,
 41140,
 -55431,
 661985723,
 41135,
 -55430,
 662220738,
 41134,
 -1,
 662277324,
 41137,
 662447999,
 661922516,
 41163,
 -55427,
 662378939,
 41162,
 -55426,
 662482882,
 41161,
 -1,
 662539468,
 41164,
 662710147,
 662386018,
 41151,
 -55423,
 662641083,
 41150,
 -55422,
 662745026,
 41149,
 -1,
 662801612,
 41152,
 662972295,
 662637180,
 41143,
 -55419,
 662903227,
 41142,
 -55418,
 663007170,
 41141,
 -1,
 663063756,
 41144,
 663289855,
 662908625,
 41154,
 -1,
 663165371,
 41153,
 663365568,
 659707900,
 -1,
 663431076,
 663312380,
 -1,
 663496596,
 663402680,
 42025,
 663562127,
 663434594,
 42017,
 -55410,
 663493051,
 42016,
 -1,
 663588044,
 42018,
 663758737,
 663492363,
 42028,
 -1,
 663689659,
 42027,
 -55406,
 663689659,
 42024,
 -55405,
 663859138,
 42023,
 -1,
 663915724,
 42026,
 664086428,
 663441291,
 42010,
 664151961,
 664022737,
 42014,
 -55401,
 664082875,
 42013,
 -55400,
 664186818,
 42012,
 -1,
 664243404,
 42015,
 -55398,
 664082875,
 42009,
 -55397,
 664383426,
 42008,
 -1,
 664440012,
 42011,
 664610720,
 664019668,
 42031,
 -55394,
 664541627,
 42030,
 -55393,
 664645570,
 42029,
 -1,
 664702156,
 42032,
 664928255,
 664548706,
 42021,
 -55390,
 664803771,
 42020,
 -55389,
 664907714,
 42019,
 -1,
 664964300,
 42022,
 665135022,
 663402680,
 41970,
 665200553,
 665072994,
 41962,
 -55385,
 665131451,
 41961,
 -55384,
 665235394,
 41960,
 -1,
 665291980,
 41963,
 665462699,
 665130763,
 41973,
 -1,
 665393595,
 41972,
 -55380,
 665393595,
 41969,
 -55379,
 665563074,
 41968,
 -1,
 665619660,
 41971,
 665790390,
 665079691,
 41954,
 665855923,
 665726673,
 41958,
 -55375,
 665786811,
 41957,
 -55374,
 665890754,
 41956,
 -1,
 665947340,
 41959,
 -55372,
 665786811,
 41953,
 -55371,
 666087362,
 41952,
 -1,
 666143948,
 41955,
 666314684,
 665723604,
 41976,
 666380217,
 666244875,
 41979,
 -1,
 666311099,
 41978,
 -55366,
 666311099,
 41975,
 -55365,
 666480578,
 41974,
 -1,
 666537164,
 41977,
 666763263,
 666252642,
 41966,
 -55362,
 666638779,
 41965,
 -55361,
 666742722,
 41964,
 -1,
 666799308,
 41967,
 666970103,
 663299392,
 -1,
 667035613,
 666903872,
 -1,
 667101131,
 667007160,
 41293,
 667166662,
 667039074,
 41282,
 -55355,
 667097531,
 41281,
 -1,
 667192524,
 41283,
 667363272,
 667096843,
 41296,
 -1,
 667294139,
 41295,
 -55351,
 667294139,
 41292,
 -55350,
 667463618,
 41291,
 -1,
 667520204,
 41294,
 667690962,
 667045771,
 41272,
 667756495,
 667627217,
 41275,
 -55346,
 667687355,
 41274,
 -1,
 667782348,
 41276,
 -55344,
 667687355,
 41271,
 -55343,
 667922370,
 41270,
 -1,
 667978956,
 41273,
 668149718,
 667628898,
 41286,
 -55340,
 668080571,
 41285,
 -55339,
 668184514,
 41284,
 -1,
 668241100,
 41287,
 668411866,
 668076668,
 41279,
 -55336,
 668342715,
 41278,
 -55335,
 668446658,
 41277,
 -1,
 668503244,
 41280,
 668729343,
 668348113,
 41289,
 -55332,
 668604859,
 41288,
 -1,
 668699852,
 41290,
 668870629,
 667007160,
 41238,
 668936160,
 668800779,
 41241,
 -1,
 668867003,
 41240,
 669067234,
 668874082,
 41228,
 -1,
 668998075,
 41227,
 -55325,
 668998075,
 41237,
 -55324,
 669167554,
 41236,
 -1,
 669224140,
 41239,
 669394924,
 668815243,
 41218,
 669460457,
 669331153,
 41221,
 -55320,
 669391291,
 41220,
 -1,
 669486284,
 41222,
 -55318,
 669391291,
 41217,
 -55317,
 669626306,
 41216,
 -1,
 669682892,
 41219,
 669853680,
 669332834,
 41231,
 -55314,
 669784507,
 41230,
 -55313,
 669888450,
 41229,
 -1,
 669945036,
 41232,
 670115828,
 669780604,
 41225,
 -55310,
 670046651,
 41224,
 -55309,
 670150594,
 41223,
 -1,
 670207180,
 41226,
 670433279,
 670052049,
 41234,
 -55306,
 670308795,
 41233,
 -1,
 670403788,
 41235,
 670574635,
 666900235,
 -1,
 670640145,
 670504715,
 -1,
 670705665,
 670611640,
 41866,
 670771196,
 670635787,
 41869,
 -1,
 670702011,
 41868,
 670902270,
 670709090,
 41855,
 -1,
 670833083,
 41854,
 -55297,
 670833083,
 41865,
 -55296,
 671002562,
 41864,
 -1,
 671059148,
 41867,
 671229959,
 670638804,
 41872,
 671295492,
 671160075,
 41875,
 -1,
 671226299,
 41874,
 -55291,
 671226299,
 41871,
 -55290,
 671395778,
 41870,
 -1,
 671452364,
 41873,
 671623179,
 671167842,
 41858,
 -55287,
 671553979,
 41857,
 -55286,
 671657922,
 41856,
 -1,
 671714508,
 41859,
 671885327,
 671559377,
 41862,
 -55283,
 671816123,
 41861,
 -55282,
 671920066,
 41860,
 -1,
 671976652,
 41863,
 672202751,
 671812220,
 41853,
 -1,
 672078267,
 41852,
 672278554,
 670611640,
 41942,
 672344085,
 672216418,
 41931,
 -55276,
 672274875,
 41930,
 -1,
 672369868,
 41932,
 672540695,
 672274187,
 41945,
 -1,
 672471483,
 41944,
 -55272,
 672471483,
 41941,
 -55271,
 672640962,
 41940,
 -1,
 672697548,
 41943,
 672868384,
 672211668,
 41948,
 672933917,
 672798475,
 41951,
 -1,
 672864699,
 41950,
 -55266,
 672864699,
 41947,
 -55265,
 673034178,
 41946,
 -1,
 673090764,
 41949,
 673261604,
 672806242,
 41935,
 -55262,
 673192379,
 41934,
 -55261,
 673296322,
 41933,
 -1,
 673352908,
 41936,
 673523752,
 673188476,
 41928,
 -55258,
 673454523,
 41927,
 -55257,
 673558466,
 41926,
 -1,
 673615052,
 41929,
 673841151,
 673459921,
 41938,
 -55254,
 673716667,
 41937,
 -1,
 673811660,
 41939,
 673982543,
 670526045,
 -1,
 674048054,
 673953976,
 41424,
 674113585,
 673985890,
 41413,
 -55249,
 674044347,
 41412,
 -55248,
 674148290,
 41411,
 -1,
 674204876,
 41414,
 674375731,
 674043659,
 41427,
 -1,
 674306491,
 41426,
 -55244,
 674306491,
 41423,
 -55243,
 674475970,
 41422,
 -1,
 674532556,
 41425,
 674703422,
 673992587,
 41401,
 674768955,
 674639569,
 41405,
 -55239,
 674699707,
 41404,
 -55238,
 674803650,
 41403,
 -1,
 674860236,
 41406,
 -55236,
 674699707,
 41400,
 -55235,
 675000258,
 41399,
 -1,
 675056844,
 41402,
 675227716,
 674636500,
 41430,
 675293249,
 675157771,
 41433,
 -1,
 675223995,
 41432,
 -55230,
 675223995,
 41429,
 -55229,
 675393474,
 41428,
 -1,
 675450060,
 41431,
 675620936,
 675165538,
 41417,
 -55226,
 675551675,
 41416,
 -55225,
 675655618,
 41415,
 -1,
 675712204,
 41418,
 675883084,
 675547772,
 41409,
 -55222,
 675813819,
 41408,
 -55221,
 675917762,
 41407,
 -1,
 675974348,
 41410,
 676200447,
 675819217,
 41420,
 -55218,
 676075963,
 41419,
 -1,
 676170956,
 41421,
 676341871,
 673908763,
 -1,
 676407384,
 676286347,
 41188,
 676472917,
 676343505,
 41192,
 -55213,
 676403643,
 41191,
 -55212,
 676507586,
 41190,
 -1,
 676564172,
 41193,
 -55210,
 676403643,
 41187,
 -55209,
 676704194,
 41186,
 -1,
 676760780,
 41189,
 676931678,
 676340436,
 41212,
 676997211,
 676861707,
 41215,
 -1,
 676927931,
 41214,
 -55204,
 676927931,
 41211,
 -55203,
 677097410,
 41210,
 -1,
 677153996,
 41213,
 677324900,
 676903096,
 41206,
 677390433,
 677254923,
 41209,
 -1,
 677321147,
 41208,
 -55198,
 677321147,
 41205,
 -55197,
 677490626,
 41204,
 -1,
 677547212,
 41207,
 677718120,
 677262690,
 41200,
 -55194,
 677648827,
 41199,
 -55193,
 677752770,
 41198,
 -1,
 677809356,
 41201,
 677980268,
 677644924,
 41196,
 -55190,
 677910971,
 41195,
 -55189,
 678014914,
 41194,
 -1,
 678071500,
 41197,
 678297599,
 677916369,
 -1,
 -55186,
 678173115,
 41202,
 -1,
 678268108,
 41203,
 678439054,
 676302028,
 -1,
 678504569,
 678410424,
 41036,
 678570100,
 678442338,
 41028,
 -55181,
 678500795,
 41027,
 -1,
 678595788,
 41029,
 678766710,
 678500107,
 41039,
 -1,
 678697403,
 41038,
 -55177,
 678697403,
 41035,
 -55176,
 678866882,
 41034,
 -1,
 678923468,
 41037,
 679094400,
 678449035,
 41018,
 679159933,
 679030481,
 41021,
 -55172,
 679090619,
 41020,
 -1,
 679185612,
 41022,
 -55170,
 679090619,
 41017,
 -55169,
 679325634,
 41016,
 -1,
 679382220,
 41019,
 679553158,
 679027412,
 41042,
 679618691,
 679483147,
 41045,
 -1,
 679549371,
 41044,
 -55164,
 679549371,
 41041,
 -55163,
 679718850,
 41040,
 -1,
 679775436,
 41043,
 679946378,
 679490914,
 41032,
 -55160,
 679877051,
 41031,
 -55159,
 679980994,
 41030,
 -1,
 680037580,
 41033,
 680263679,
 679873148,
 41025,
 -55156,
 680139195,
 41024,
 -55155,
 680243138,
 41023,
 -1,
 680299724,
 41026,
 680470699,
 678372052,
 -1,
 680536217,
 680442040,
 42115,
 680601748,
 680473954,
 42107,
 -55150,
 680532411,
 42106,
 -55149,
 680636354,
 42105,
 -1,
 680692940,
 42108,
 680863894,
 680531723,
 42118,
 -1,
 680794555,
 42117,
 -55145,
 680794555,
 42114,
 -55144,
 680964034,
 42113,
 -1,
 681020620,
 42116,
 681191585,
 680480651,
 42099,
 681257118,
 681127633,
 42103,
 -55140,
 681187771,
 42102,
 -55139,
 681291714,
 42101,
 -1,
 681348300,
 42104,
 -55137,
 681187771,
 42098,
 -55136,
 681488322,
 42097,
 -1,
 681544908,
 42100,
 681715879,
 681124564,
 42121,
 681781412,
 681645835,
 42124,
 -1,
 681712059,
 42123,
 -55131,
 681712059,
 42120,
 -55130,
 681881538,
 42119,
 -1,
 681938124,
 42122,
 682164223,
 681653602,
 42111,
 -55127,
 682039739,
 42110,
 -55126,
 682143682,
 42109,
 -1,
 682200268,
 42112,
 682371272,
 680439746,
 -1,
 682436790,
 682342584,
 41266,
 682502321,
 682374498,
 41255,
 -55121,
 682432955,
 41254,
 -55120,
 682536898,
 41253,
 -1,
 682593484,
 41256,
 682764467,
 682432267,
 41269,
 -1,
 682695099,
 41268,
 -55116,
 682695099,
 41265,
 -55115,
 682864578,
 41264,
 -1,
 682921164,
 41267,
 683092157,
 682381195,
 41244,
 683157690,
 683028177,
 41247,
 -55111,
 683088315,
 41246,
 -1,
 683183308,
 41248,
 -55109,
 683088315,
 41243,
 -55108,
 683323330,
 41242,
 -1,
 683379916,
 41245,
 683550913,
 683029858,
 41259,
 -55105,
 683481531,
 41258,
 -55104,
 683585474,
 41257,
 -1,
 683642060,
 41260,
 683813061,
 683477628,
 41251,
 -55101,
 683743675,
 41250,
 -55100,
 683847618,
 41249,
 -1,
 683904204,
 41252,
 684130303,
 683749073,
 41262,
 -55097,
 684005819,
 41261,
 -1,
 684100812,
 41263,
 684271845,
 682333729,
 -1,
 684337363,
 684243128,
 41998,
 684402894,
 684275042,
 41990,
 -55092,
 684333499,
 41989,
 -55091,
 684437442,
 41988,
 -1,
 684494028,
 41991,
 684665040,
 684332811,
 42001,
 -1,
 684595643,
 42000,
 -55087,
 684595643,
 41997,
 -55086,
 684765122,
 41996,
 -1,
 684821708,
 41999,
 684992731,
 684281739,
 41982,
 685058264,
 684928721,
 41986,
 -55082,
 684988859,
 41985,
 -55081,
 685092802,
 41984,
 -1,
 685149388,
 41987,
 -55079,
 684988859,
 41981,
 -55078,
 685289410,
 41980,
 -1,
 685345996,
 41983,
 685517025,
 684925652,
 42004,
 685582558,
 685446923,
 42007,
 -1,
 685513147,
 42006,
 -55073,
 685513147,
 42003,
 -55072,
 685682626,
 42002,
 -1,
 685739212,
 42005,
 685965311,
 685454690,
 41994,
 -55069,
 685840827,
 41993,
 -55068,
 685944770,
 41992,
 -1,
 686001356,
 41995,
 686172418,
 684220528,
 -1,
 686237935,
 686143672,
 41488,
 686303466,
 686175586,
 41476,
 -55063,
 686234043,
 41475,
 -1,
 686329036,
 41477,
 686500076,
 686233355,
 41491,
 -1,
 686430651,
 41490,
 -55059,
 686430651,
 41487,
 -55058,
 686600130,
 41486,
 -1,
 686656716,
 41489,
 686827766,
 686182283,
 41466,
 686893299,
 686763729,
 41469,
 -55054,
 686823867,
 41468,
 -1,
 686918860,
 41470,
 -55052,
 686823867,
 41465,
 -55051,
 687058882,
 41464,
 -1,
 687115468,
 41467,
 687286522,
 686765410,
 41480,
 -55048,
 687217083,
 41479,
 -55047,
 687321026,
 41478,
 -1,
 687377612,
 41481,
 687548670,
 687222481,
 41484,
 -55044,
 687479227,
 41483,
 -55043,
 687583170,
 41482,
 -1,
 687639756,
 41485,
 687865855,
 687475324,
 41473,
 -55040,
 687741371,
 41472,
 -55039,
 687845314,
 41471,
 -1,
 687901900,
 41474,
 688072984,
 686110591,
 -1,
 688138505,
 688044216,
 41178,
 688204038,
 688068363,
 41181,
 -1,
 688134587,
 41180,
 -55033,
 688134587,
 41177,
 -55032,
 688304066,
 41176,
 -1,
 688360652,
 41179,
 688531725,
 688071380,
 41184,
 -55029,
 688462267,
 41183,
 -55028,
 688566210,
 41182,
 -1,
 688622796,
 41185,
 688793873,
 688476043,
 41167,
 -55025,
 688724411,
 41166,
 -55024,
 688828354,
 41165,
 -1,
 688884940,
 41168,
 689056021,
 688720508,
 41171,
 -55021,
 688986555,
 41170,
 -55020,
 689090498,
 41169,
 -1,
 689147084,
 41172,
 689373183,
 688993634,
 41174,
 -55017,
 689248699,
 41173,
 -1,
 689343692,
 41175,
 689514797,
 688003515,
 -1,
 689580321,
 689459083,
 42079,
 689645854,
 689516241,
 42083,
 -55012,
 689576379,
 42082,
 -55011,
 689680322,
 42081,
 -1,
 689736908,
 42084,
 -55009,
 689576379,
 42078,
 -55008,
 689876930,
 42077,
 -1,
 689933516,
 42080,
 690104615,
 689513172,
 42093,
 690170148,
 690034443,
 42096,
 -1,
 690100667,
 42095,
 -55003,
 690100667,
 42092,
 -55002,
 690270146,
 42091,
 -1,
 690326732,
 42094,
 690497835,
 690042210,
 42089,
 -54999,
 690428347,
 42088,
 -54998,
 690532290,
 42087,
 -1,
 690588876,
 42090,
 690814975,
 690467689,
 42086,
 -1,
 690690491,
 42085,
 690891068,
 689443128,
 -1,
 690956594,
 690862264,
 40981,
 691077119,
 690894178,
 41605,
 -54991,
 690952635,
 41604,
 -1,
 691047628,
 41606,
 691218742,
 690883196,
 41602,
 -54988,
 691149243,
 41601,
 -54987,
 691253186,
 41600,
 -1,
 691309772,
 41603,
 691480889,
 691156322,
 41608,
 -54984,
 691411387,
 41607,
 -1,
 691506380,
 41609,
 691732479,
 691416785,
 41611,
 -54981,
 691607995,
 41610,
 -1,
 691702988,
 41612,
 691874116,
 690835339,
 40962,
 691939649,
 691810001,
 40966,
 -54977,
 691870139,
 40965,
 -54976,
 691974082,
 40964,
 -1,
 692030668,
 40967,
 -54974,
 691870139,
 40961,
 -54973,
 692170690,
 40960,
 -1,
 692227276,
 40963,
 692398408,
 691811682,
 40977,
 -54970,
 692328891,
 40976,
 -54969,
 692432834,
 40975,
 -1,
 692489420,
 40978,
 692660556,
 692324988,
 40970,
 -54966,
 692591035,
 40969,
 -54965,
 692694978,
 40968,
 -1,
 692751564,
 40971,
 692922703,
 692630377,
 40973,
 -54962,
 692853179,
 40972,
 -1,
 692948172,
 40974,
 693174271,
 692858577,
 40980,
 -1,
 693049787,
 40979,
 693305343,
 613651056,
 -1,
 693315929,
 693181493,
 -1,
 693381462,
 693248724,
 42172,
 -54955,
 693350338,
 42147,
 -1,
 693406924,
 42132,
 -54953,
 693341754,
 42173,
 -54952,
 693522317,
 42174,
 -1,
 693577640,
 42179,
 693774688,
 693251191,
 -1,
 693840221,
 693745848,
 -1,
 -54948,
 693769995,
 42177,
 -1,
 693865676,
 42146,
 -54946,
 693810992,
 42180,
 -54945,
 693965556,
 42155,
 -1,
 694028924,
 42162,
 694233447,
 693717783,
 -1,
 694298982,
 694172025,
 -1,
 -54941,
 694231764,
 42160,
 -54940,
 694334304,
 42170,
 -54939,
 694387246,
 42178,
 -1,
 694454806,
 42176,
 -1,
 694248722,
 42133,
 694692206,
 694173509,
 -1,
 694757739,
 694632261,
 -1,
 -54934,
 694727529,
 42150,
 -1,
 694780462,
 42134,
 -54932,
 694686452,
 42166,
 -54931,
 694906183,
 42135,
 -1,
 694946428,
 42145,
 695150964,
 694647810,
 -1,
 695216498,
 695083732,
 -1,
 -54927,
 695173678,
 42151,
 -1,
 695226253,
 42131,
 -54925,
 695162538,
 42164,
 -1,
 695378094,
 42181,
 695544186,
 695097340,
 -1,
 695609721,
 695490556,
 -1,
 -54921,
 695542484,
 42165,
 -54920,
 695645002,
 42154,
 -1,
 695685088,
 42167,
 -1,
 695547234,
 42163,
 695937408,
 695482745,
 -1,
 696002943,
 695867835,
 -1,
 -54915,
 695972713,
 42143,
 -54914,
 696025646,
 42175,
 -1,
 696078234,
 42137,
 -1,
 695940536,
 42157,
 696330628,
 695888477,
 -1,
 696396163,
 696274827,
 42129,
 -1,
 696331985,
 42171,
 -1,
 696358140,
 42138,
 696592775,
 696263380,
 -1,
 -54906,
 696530274,
 42141,
 -1,
 696602522,
 42158,
 696789386,
 696518683,
 -1,
 -54903,
 696759136,
 42159,
 -1,
 696806727,
 42161,
 696985997,
 696758210,
 -1,
 -54900,
 696957112,
 42152,
 -1,
 697010710,
 42144,
 697182608,
 696945868,
 -1,
 -54897,
 697144578,
 42156,
 -1,
 697217866,
 42142,
 697379219,
 697135876,
 -1,
 -54894,
 697336366,
 42140,
 -1,
 697388939,
 42136,
 697575830,
 697327728,
 -1,
 -54891,
 697520026,
 42130,
 -1,
 697577169,
 42182,
 697772441,
 697509184,
 -1,
 -54888,
 697743544,
 42169,
 -1,
 697802463,
 42148,
 697969052,
 697701233,
 -1,
 -54885,
 697938784,
 42149,
 -1,
 697965512,
 42139,
 -54883,
 697910892,
 42168,
 -54882,
 698093571,
 42128,
 -1,
 698188334,
 42153,
 -1,
 613571740,
 9775,
 -1,
 613483373,
 165,
 698494580,
 613421937,
 -1,
 698559145,
 698423051,
 -1,
 698624677,
 698488944,
 -1,
 698690212,
 698570883,
 -1,
 698755621,
 698628430,
 10241,
 698821094,
 698696116,
 10243,
 698886599,
 698763723,
 10247,
 698952120,
 698831392,
 10255,
 699017649,
 698899035,
 10271,
 699083182,
 698966962,
 10303,
 699148717,
 699034761,
 10367,
 -1,
 699102625,
 10495,
 -1,
 699102625,
 10431,
 699345328,
 699034761,
 10335,
 -1,
 699299233,
 10463,
 -1,
 699299233,
 10399,
 699541941,
 698966962,
 10287,
 699607476,
 699493513,
 10351,
 -1,
 699561377,
 10479,
 -1,
 699561377,
 10415,
 699804087,
 699493513,
 10319,
 -1,
 699757985,
 10447,
 -1,
 699757985,
 10383,
 700000704,
 698899035,
 10263,
 700066237,
 699950002,
 10295,
 700131772,
 700017801,
 10359,
 -1,
 700085665,
 10487,
 -1,
 700085665,
 10423,
 700328383,
 700017801,
 10327,
 -1,
 700282273,
 10455,
 -1,
 700282273,
 10391,
 700524996,
 699950002,
 10279,
 700590531,
 700476553,
 10343,
 -1,
 700544417,
 10471,
 -1,
 700544417,
 10407,
 700787142,
 700476553,
 10311,
 -1,
 700741025,
 10439,
 -1,
 700741025,
 10375,
 700983767,
 698831392,
 10251,
 701049296,
 700930651,
 10267,
 701114829,
 700998578,
 10299,
 701180364,
 701066377,
 10363,
 -1,
 701134241,
 10491,
 -1,
 701134241,
 10427,
 701376975,
 701066377,
 10331,
 -1,
 701330849,
 10459,
 -1,
 701330849,
 10395,
 701573588,
 700998578,
 10283,
 701639123,
 701525129,
 10347,
 -1,
 701592993,
 10475,
 -1,
 701592993,
 10411,
 701835734,
 701525129,
 10315,
 -1,
 701789601,
 10443,
 -1,
 701789601,
 10379,
 702032351,
 700930651,
 10259,
 702097884,
 701981618,
 10291,
 702163419,
 702049417,
 10355,
 -1,
 702117281,
 10483,
 -1,
 702117281,
 10419,
 702360030,
 702049417,
 10323,
 -1,
 702313889,
 10451,
 -1,
 702313889,
 10387,
 702556643,
 701981618,
 10275,
 702622178,
 702508169,
 10339,
 -1,
 702576033,
 10467,
 -1,
 702576033,
 10403,
 702818789,
 702508169,
 10307,
 -1,
 702772641,
 10435,
 -1,
 702772641,
 10371,
 703015430,
 698763723,
 10245,
 703080951,
 702960160,
 10253,
 703146480,
 703027803,
 10269,
 703212013,
 703095730,
 10301,
 703277548,
 703163529,
 10365,
 -1,
 703231393,
 10493,
 -1,
 703231393,
 10429,
 703474159,
 703163529,
 10333,
 -1,
 703428001,
 10461,
 -1,
 703428001,
 10397,
 703670772,
 703095730,
 10285,
 703736307,
 703622281,
 10349,
 -1,
 703690145,
 10477,
 -1,
 703690145,
 10413,
 703932918,
 703622281,
 10317,
 -1,
 703886753,
 10445,
 -1,
 703886753,
 10381,
 704129535,
 703027803,
 10261,
 704195068,
 704078770,
 10293,
 704260603,
 704146569,
 10357,
 -1,
 704214433,
 10485,
 -1,
 704214433,
 10421,
 704457214,
 704146569,
 10325,
 -1,
 704411041,
 10453,
 -1,
 704411041,
 10389,
 704653827,
 704078770,
 10277,
 704719362,
 704605321,
 10341,
 -1,
 704673185,
 10469,
 -1,
 704673185,
 10405,
 704915973,
 704605321,
 10309,
 -1,
 704869793,
 10437,
 -1,
 704869793,
 10373,
 705112598,
 702960160,
 10249,
 705178127,
 705059419,
 10265,
 705243660,
 705127346,
 10297,
 705309195,
 705195145,
 10361,
 -1,
 705263009,
 10489,
 -1,
 705263009,
 10425,
 705505806,
 705195145,
 10329,
 -1,
 705459617,
 10457,
 -1,
 705459617,
 10393,
 705702419,
 705127346,
 10281,
 705767954,
 705653897,
 10345,
 -1,
 705721761,
 10473,
 -1,
 705721761,
 10409,
 705964565,
 705653897,
 10313,
 -1,
 705918369,
 10441,
 -1,
 705918369,
 10377,
 706161182,
 705059419,
 10257,
 706226715,
 706110386,
 10289,
 706292250,
 706178185,
 10353,
 -1,
 706246049,
 10481,
 -1,
 706246049,
 10417,
 706488861,
 706178185,
 10321,
 -1,
 706442657,
 10449,
 -1,
 706442657,
 10385,
 706685474,
 706110386,
 10273,
 706751009,
 706636937,
 10337,
 -1,
 706704801,
 10465,
 -1,
 706704801,
 10401,
 706947620,
 706636937,
 10305,
 -1,
 706901409,
 10433,
 -1,
 706901409,
 10369,
 707144293,
 698696116,
 10242,
 707209798,
 707086795,
 10246,
 707275319,
 707154464,
 10254,
 707340848,
 707222107,
 10270,
 707406381,
 707290034,
 10302,
 707471916,
 707357833,
 10366,
 -1,
 707425697,
 10494,
 -1,
 707425697,
 10430,
 707668527,
 707357833,
 10334,
 -1,
 707622305,
 10462,
 -1,
 707622305,
 10398,
 707865140,
 707290034,
 10286,
 707930675,
 707816585,
 10350,
 -1,
 707884449,
 10478,
 -1,
 707884449,
 10414,
 708127286,
 707816585,
 10318,
 -1,
 708081057,
 10446,
 -1,
 708081057,
 10382,
 708323903,
 707222107,
 10262,
 708389436,
 708273074,
 10294,
 708454971,
 708340873,
 10358,
 -1,
 708408737,
 10486,
 -1,
 708408737,
 10422,
 708651582,
 708340873,
 10326,
 -1,
 708605345,
 10454,
 -1,
 708605345,
 10390,
 708848195,
 708273074,
 10278,
 708913730,
 708799625,
 10342,
 -1,
 708867489,
 10470,
 -1,
 708867489,
 10406,
 709110341,
 708799625,
 10310,
 -1,
 709064097,
 10438,
 -1,
 709064097,
 10374,
 709306966,
 707154464,
 10250,
 709372495,
 709253723,
 10266,
 709438028,
 709321650,
 10298,
 709503563,
 709389449,
 10362,
 -1,
 709457313,
 10490,
 -1,
 709457313,
 10426,
 709700174,
 709389449,
 10330,
 -1,
 709653921,
 10458,
 -1,
 709653921,
 10394,
 709896787,
 709321650,
 10282,
 709962322,
 709848201,
 10346,
 -1,
 709916065,
 10474,
 -1,
 709916065,
 10410,
 710158933,
 709848201,
 10314,
 -1,
 710112673,
 10442,
 -1,
 710112673,
 10378,
 710355550,
 709253723,
 10258,
 710421083,
 710304690,
 10290,
 710486618,
 710372489,
 10354,
 -1,
 710440353,
 10482,
 -1,
 710440353,
 10418,
 710683229,
 710372489,
 10322,
 -1,
 710636961,
 10450,
 -1,
 710636961,
 10386,
 710879842,
 710304690,
 10274,
 710945377,
 710831241,
 10338,
 -1,
 710899105,
 10466,
 -1,
 710899105,
 10402,
 711141988,
 710831241,
 10306,
 -1,
 711095713,
 10434,
 -1,
 711095713,
 10370,
 711338629,
 707086795,
 10244,
 711404150,
 711283232,
 10252,
 711469679,
 711350875,
 10268,
 711535212,
 711418802,
 10300,
 711600747,
 711486601,
 10364,
 -1,
 711554465,
 10492,
 -1,
 711554465,
 10428,
 711797358,
 711486601,
 10332,
 -1,
 711751073,
 10460,
 -1,
 711751073,
 10396,
 711993971,
 711418802,
 10284,
 712059506,
 711945353,
 10348,
 -1,
 712013217,
 10476,
 -1,
 712013217,
 10412,
 712256117,
 711945353,
 10316,
 -1,
 712209825,
 10444,
 -1,
 712209825,
 10380,
 712452734,
 711350875,
 10260,
 712518267,
 712401842,
 10292,
 712583802,
 712469641,
 10356,
 -1,
 712537505,
 10484,
 -1,
 712537505,
 10420,
 712780413,
 712469641,
 10324,
 -1,
 712734113,
 10452,
 -1,
 712734113,
 10388,
 712977026,
 712401842,
 10276,
 713042561,
 712928393,
 10340,
 -1,
 712996257,
 10468,
 -1,
 712996257,
 10404,
 713239172,
 712928393,
 10308,
 -1,
 713192865,
 10436,
 -1,
 713192865,
 10372,
 713435797,
 711283232,
 10248,
 713501326,
 713382491,
 10264,
 713566859,
 713450418,
 10296,
 713632394,
 713518217,
 10360,
 -1,
 713586081,
 10488,
 -1,
 713586081,
 10424,
 713829005,
 713518217,
 10328,
 -1,
 713782689,
 10456,
 -1,
 713782689,
 10392,
 714025618,
 713450418,
 10280,
 714091153,
 713976969,
 10344,
 -1,
 714044833,
 10472,
 -1,
 714044833,
 10408,
 714287764,
 713976969,
 10312,
 -1,
 714241441,
 10440,
 -1,
 714241441,
 10376,
 714484381,
 713382491,
 10256,
 714549914,
 714433458,
 10288,
 714615449,
 714501257,
 10352,
 -1,
 714569121,
 10480,
 -1,
 714569121,
 10416,
 714812060,
 714501257,
 10320,
 -1,
 714765729,
 10448,
 -1,
 714765729,
 10384,
 715008673,
 714433458,
 10272,
 715074208,
 714960009,
 10336,
 -1,
 715027873,
 10464,
 -1,
 715027873,
 10400,
 715270819,
 714960009,
 10304,
 -1,
 715224481,
 10432,
 -1,
 715224481,
 10368,
 -1,
 698637773,
 10240,
 715532968,
 698556781,
 -1,
 -54617,
 715488523,
 9099,
 -1,
 715536500,
 166,
 -1,
 715457320,
 728,
 715795497,
 698513122,
 -1,
 715860699,
 715721340,
 -1,
 715926205,
 715820236,
 -1,
 715991737,
 715863394,
 -1,
 716057269,
 715948288,
 -1,
 716122802,
 716000023,
 118801,
 716242943,
 716070087,
 -1,
 -54607,
 716127006,
 118865,
 -1,
 716201012,
 118802,
 716439551,
 716066628,
 -1,
 -54604,
 716347169,
 118957,
 -1,
 716416591,
 118866,
 716581560,
 716002873,
 -1,
 -54601,
 716520222,
 118916,
 -1,
 716573113,
 118818,
 -1,
 716512424,
 118819,
 716843708,
 715926004,
 -1,
 -54597,
 716771088,
 118835,
 -1,
 716844789,
 118797,
 -1,
 716782435,
 118917,
 717105865,
 715855627,
 -1,
 717171398,
 717058866,
 -1,
 -54592,
 717101831,
 119022,
 -54591,
 717185983,
 119018,
 -54590,
 717244246,
 119017,
 -54589,
 717313855,
 119023,
 -54588,
 717397776,
 119021,
 -54587,
 717423004,
 119019,
 -1,
 717505416,
 119020,
 717750271,
 717095332,
 -1,
 -54584,
 717631643,
 118899,
 -1,
 717716482,
 118935,
 717892310,
 717052697,
 -1,
 717957837,
 717824858,
 -1,
 -54580,
 717910218,
 118945,
 -1,
 717981747,
 118938,
 718154448,
 717895055,
 -1,
 -54577,
 718120942,
 118941,
 -1,
 718169362,
 118942,
 718351059,
 718105913,
 -1,
 -54574,
 718296759,
 118944,
 -1,
 718360459,
 118943,
 718602239,
 718304000,
 -1,
 -54571,
 718493367,
 118939,
 -1,
 718557067,
 118940,
 718798847,
 717847554,
 -1,
 718809818,
 718702903,
 -1,
 -54567,
 718747046,
 118876,
 -1,
 718803722,
 118882,
 -1,
 718774435,
 118824,
 719072006,
 715808880,
 -1,
 719137514,
 718998918,
 -1,
 719203044,
 719096238,
 118800,
 719323135,
 719150279,
 -1,
 719334115,
 719206653,
 -1,
 -54559,
 719259415,
 119024,
 -54558,
 719329315,
 119026,
 -1,
 719432473,
 118862,
 -1,
 719260089,
 118812,
 719716351,
 719150279,
 -1,
 719727337,
 719599869,
 -1,
 -54553,
 719652631,
 119025,
 -54552,
 719722531,
 119027,
 -1,
 719825689,
 118863,
 -1,
 719653305,
 118811,
 720055031,
 719066891,
 -1,
 720120566,
 720020678,
 -1,
 720186099,
 720046716,
 -1,
 720251634,
 720133319,
 -1,
 720317169,
 720177788,
 -1,
 -54544,
 720264638,
 118913,
 -1,
 720351737,
 118914,
 -1,
 720255774,
 118915,
 -1,
 720210350,
 118834,
 720699391,
 720123234,
 -1,
 -54539,
 720586573,
 118868,
 -1,
 720672955,
 118860,
 -1,
 720049472,
 118796,
 720907004,
 719992162,
 -1,
 720972538,
 720871560,
 118842,
 -1,
 720912199,
 118850,
 -54533,
 720936503,
 118858,
 -1,
 721056628,
 118921,
 721234688,
 720831414,
 118820,
 721354751,
 721181895,
 -1,
 -54529,
 721229859,
 119028,
 -1,
 721333017,
 118911,
 721496837,
 721193494,
 -1,
 721562372,
 721435264,
 -1,
 -54525,
 721523290,
 118906,
 -1,
 721564322,
 118839,
 -1,
 721514455,
 118791,
 -1,
 721443146,
 118881,
 721890085,
 719014679,
 -1,
 721955604,
 721826625,
 -1,
 722021134,
 721888494,
 119006,
 722141183,
 721968327,
 -1,
 722152205,
 722055106,
 -1,
 -54516,
 722091554,
 119008,
 -1,
 722159418,
 119009,
 -1,
 722103679,
 119007,
 722468863,
 721970820,
 119010,
 722534399,
 722361543,
 -1,
 722545427,
 722448322,
 -1,
 -54510,
 722484770,
 119012,
 -1,
 722552634,
 119013,
 -1,
 722496895,
 119011,
 722807581,
 721887956,
 -1,
 722873115,
 722762754,
 -1,
 722938650,
 722843826,
 -1,
 -54504,
 722877214,
 118885,
 -54503,
 722939054,
 118827,
 -1,
 722995641,
 118826,
 -1,
 722903765,
 118803,
 723320831,
 722801441,
 118886,
 -1,
 723201285,
 118792,
 723397410,
 722776002,
 -1,
 723462944,
 723321644,
 118910,
 -1,
 723428708,
 118815,
 -54495,
 723392140,
 118852,
 -1,
 723539991,
 119016,
 723725092,
 723332329,
 118825,
 -1,
 723674266,
 118889,
 -1,
 723654942,
 118813,
 723921734,
 721849548,
 -1,
 723987248,
 723870994,
 -1,
 724052781,
 723934254,
 -1,
 724118314,
 724007938,
 118841,
 -1,
 724067482,
 118874,
 -54485,
 724060716,
 118897,
 -54484,
 724175887,
 118895,
 -1,
 724282151,
 118892,
 724500479,
 724003421,
 -1,
 -54481,
 724402561,
 118807,
 -1,
 724455307,
 118784,
 724642617,
 723922641,
 -1,
 724708150,
 724589815,
 -1,
 724773685,
 724676546,
 -1,
 -54476,
 724719373,
 118859,
 -1,
 724782987,
 118857,
 -1,
 724710822,
 118849,
 725035832,
 724634664,
 118840,
 -1,
 724984986,
 118861,
 -1,
 724993423,
 118786,
 725232451,
 724601360,
 -1,
 725297986,
 725177564,
 -1,
 725363519,
 725265420,
 118793,
 725483519,
 725310663,
 -1,
 -54466,
 725367582,
 118878,
 -1,
 725420473,
 118846,
 725680127,
 725302050,
 -1,
 -54463,
 725564190,
 118879,
 -1,
 725617081,
 118845,
 -1,
 725256820,
 118814,
 725942271,
 725197142,
 -1,
 -54459,
 725826334,
 118873,
 -1,
 725879225,
 118822,
 726084452,
 723859327,
 -1,
 726149983,
 726035098,
 -1,
 726215506,
 726105217,
 -1,
 726281038,
 726170626,
 -1,
 726346573,
 726224708,
 -1,
 -54452,
 726276131,
 118977,
 -1,
 726379289,
 118978,
 -1,
 726285713,
 118971,
 -54449,
 726211335,
 118976,
 -54448,
 726550358,
 118970,
 -54447,
 726638352,
 118975,
 -1,
 726680456,
 118973,
 726870869,
 726141869,
 -1,
 -54444,
 726805475,
 118974,
 -1,
 726863561,
 118982,
 727067480,
 726825986,
 -1,
 -54441,
 727014163,
 118983,
 -1,
 727076156,
 118972,
 727264091,
 727026481,
 -1,
 -54438,
 727188071,
 118980,
 -1,
 727282489,
 118979,
 727460701,
 727189945,
 118836,
 -1,
 727389666,
 118969,
 -54434,
 727394444,
 118987,
 -1,
 727528055,
 118988,
 727722851,
 726078012,
 -1,
 -54431,
 727685636,
 118958,
 -54430,
 727712359,
 118959,
 -1,
 727806777,
 118960,
 -1,
 727690714,
 118981,
 728050564,
 726017344,
 -1,
 728116098,
 727994251,
 -1,
 728181615,
 728043546,
 -1,
 728247148,
 728149954,
 -1,
 728312683,
 728185848,
 -1,
 -54422,
 728245522,
 118990,
 -1,
 728335359,
 118995,
 -1,
 728263248,
 118991,
 -54419,
 728179434,
 118993,
 -54418,
 728498962,
 118994,
 -1,
 728585568,
 118992,
 728771447,
 728121157,
 -1,
 728836982,
 728716091,
 118930,
 728956927,
 728761729,
 -1,
 728968053,
 728840743,
 -1,
 -54412,
 728897571,
 118931,
 -1,
 729000729,
 118932,
 -1,
 728936302,
 118933,
 -1,
 728798244,
 119014,
 729295743,
 728697468,
 -1,
 729361278,
 729229401,
 -1,
 729426812,
 729318246,
 -1,
 -54405,
 729382793,
 119002,
 -1,
 729446017,
 119003,
 -54403,
 729359598,
 119005,
 -1,
 729570356,
 119004,
 -1,
 729291609,
 118937,
 729820033,
 729244184,
 118918,
 -1,
 729782229,
 118912,
 -1,
 729745203,
 119015,
 -54397,
 728077473,
 118831,
 -1,
 729956485,
 118785,
 730147747,
 728018882,
 -1,
 730213269,
 730076939,
 -1,
 730278801,
 730147140,
 -1,
 730344332,
 730224633,
 -1,
 730409867,
 730270332,
 -1,
 -54390,
 730357182,
 118838,
 -1,
 730444281,
 118851,
 -1,
 730348318,
 118883,
 730672015,
 730303692,
 -1,
 -54386,
 730635749,
 118891,
 -1,
 730700869,
 118894,
 -54384,
 730614316,
 118896,
 -1,
 730835751,
 118893,
 731054079,
 730222475,
 -1,
 -54381,
 730948120,
 118919,
 -54380,
 730994048,
 118934,
 -1,
 731056764,
 118832,
 731261854,
 730151289,
 -1,
 731327389,
 731197137,
 -1,
 731392924,
 731264422,
 118829,
 731458459,
 731355305,
 -1,
 -54374,
 731410318,
 118903,
 -1,
 731460822,
 118902,
 -1,
 731410119,
 118904,
 -1,
 731347358,
 118905,
 -1,
 731291458,
 118804,
 731851682,
 731197137,
 -1,
 -54368,
 731801820,
 118920,
 -54367,
 731876332,
 118833,
 -1,
 731948990,
 118799,
 -1,
 731784019,
 118823,
 732179386,
 730100484,
 -1,
 732244921,
 732143604,
 -1,
 732310444,
 732213186,
 -1,
 732375977,
 732249080,
 -1,
 -54360,
 732329492,
 118950,
 -1,
 732389397,
 118951,
 732626943,
 732343215,
 -1,
 -54357,
 732501735,
 118953,
 -1,
 732606996,
 118952,
 732769203,
 732269772,
 -1,
 732834736,
 732723313,
 -1,
 -54353,
 732784220,
 118962,
 -1,
 732833684,
 118946,
 733085695,
 732777541,
 -1,
 -54350,
 733000396,
 118963,
 -1,
 733065748,
 118955,
 733227958,
 732717311,
 -1,
 -54347,
 733192563,
 118947,
 -1,
 733224871,
 118949,
 -54345,
 733177436,
 118961,
 -54344,
 733353703,
 118954,
 -1,
 733421479,
 118948,
 -1,
 732177957,
 118871,
 733686732,
 732111572,
 -1,
 733752262,
 733647352,
 -1,
 733817795,
 733709571,
 -1,
 733883328,
 733762816,
 -1,
 -54337,
 733816082,
 118989,
 -1,
 733905919,
 118999,
 -54335,
 733815530,
 118997,
 -54334,
 734003986,
 118998,
 -1,
 734090592,
 118996,
 734330879,
 733763577,
 -1,
 -54331,
 734205987,
 118908,
 -1,
 734309145,
 118909,
 734527487,
 733711564,
 -1,
 734538699,
 734410082,
 -1,
 734604234,
 734494530,
 118794,
 -1,
 734550077,
 118795,
 -1,
 734569637,
 118867,
 -1,
 734484247,
 118864,
 734866399,
 733626181,
 -1,
 734931931,
 734822928,
 -1,
 734997464,
 734855588,
 -1,
 735062999,
 734943225,
 -1,
 735128531,
 735029306,
 -1,
 -54318,
 735096686,
 118929,
 -1,
 735126839,
 118928,
 735325142,
 735066365,
 -1,
 -54315,
 735254563,
 119029,
 -1,
 735357721,
 118927,
 -1,
 735250873,
 118806,
 -1,
 734998683,
 118898,
 735707135,
 734939264,
 -1,
 -54310,
 735590426,
 118965,
 -1,
 735671172,
 118964,
 735849438,
 734857537,
 -1,
 -54307,
 735786671,
 119001,
 -1,
 735876552,
 119000,
 -1,
 735796448,
 118853,
 736111597,
 734803298,
 -1,
 736177126,
 736054850,
 -1,
 736242661,
 736124103,
 -1,
 -54301,
 736181022,
 118856,
 -54300,
 736258361,
 118787,
 -1,
 736320564,
 118788,
 -1,
 736184196,
 118816,
 736570345,
 736137539,
 -1,
 -54296,
 736508702,
 118901,
 -1,
 736561593,
 118828,
 736766956,
 736501664,
 -1,
 -54293,
 736705310,
 118855,
 -1,
 736758201,
 118805,
 -1,
 736725087,
 118875,
 737029115,
 736055179,
 -1,
 737094645,
 736966095,
 -1,
 737160180,
 737032063,
 -1,
 737225715,
 737106925,
 -1,
 -54286,
 737182081,
 118968,
 -1,
 737217148,
 118837,
 -1,
 737188048,
 118967,
 -1,
 737086184,
 118936,
 737553402,
 737037079,
 -1,
 737618937,
 737479378,
 -1,
 -54280,
 737557278,
 118854,
 -1,
 737610169,
 118810,
 -1,
 737545786,
 118956,
 -1,
 737505385,
 118847,
 737946630,
 736964305,
 -1,
 738012159,
 737881441,
 -1,
 -54274,
 737938447,
 118880,
 -1,
 738029486,
 118900,
 738208770,
 737967106,
 -1,
 -54271,
 738145886,
 118907,
 -1,
 738227678,
 118966,
 -54269,
 738140231,
 118798,
 -54268,
 738333740,
 118888,
 -54267,
 738430647,
 118869,
 -1,
 738495098,
 118884,
 738667537,
 737897053,
 -1,
 738733072,
 738602705,
 -1,
 738798607,
 738693940,
 -1,
 738864140,
 738766786,
 -1,
 -54261,
 738829564,
 118924,
 -1,
 738854997,
 118925,
 -54259,
 738816907,
 118926,
 -54258,
 739030350,
 118922,
 -1,
 739073780,
 118923,
 -1,
 738765793,
 118830,
 -1,
 738697988,
 118877,
 739388444,
 738598763,
 -1,
 739453974,
 739350985,
 -1,
 -54252,
 739408214,
 118984,
 -54251,
 739480730,
 118986,
 -1,
 739519586,
 118985,
 739716121,
 739417482,
 -1,
 -54248,
 739654430,
 118887,
 -1,
 739707321,
 118843,
 739966975,
 739667277,
 -1,
 -54245,
 739869057,
 118808,
 -1,
 739921803,
 118870,
 740109348,
 739320410,
 -1,
 740174883,
 740051549,
 -1,
 740240418,
 740121799,
 -1,
 -54240,
 740178718,
 118872,
 -54239,
 740256057,
 118789,
 -1,
 740318260,
 118790,
 -1,
 740181892,
 118817,
 -1,
 740140107,
 118809,
 740633639,
 740038411,
 -1,
 -54234,
 740598485,
 118821,
 -1,
 740644111,
 118844,
 -54232,
 740584911,
 118890,
 -1,
 740770830,
 118848,
 740961593,
 715732322,
 -1,
 741027046,
 740915294,
 -1,
 741092452,
 740977245,
 -1,
 741157977,
 741059150,
 -1,
 741223484,
 741090624,
 -1,
 741289015,
 741160290,
 -1,
 741354548,
 741224976,
 9591,
 741474303,
 741292842,
 -1,
 -54222,
 741384758,
 9484,
 -54221,
 741434315,
 9488,
 -1,
 741485225,
 9516,
 741736447,
 741306505,
 -1,
 -54218,
 741629860,
 9550,
 -1,
 741681833,
 9548,
 741933055,
 741228344,
 -1,
 741944379,
 741844988,
 -1,
 -54214,
 741888255,
 9585,
 -1,
 741941974,
 9586,
 -1,
 741913645,
 9587,
 742206531,
 741184719,
 9589,
 742326271,
 742144810,
 -1,
 742337601,
 742209913,
 -1,
 -54208,
 742292775,
 9524,
 -1,
 742331903,
 9597,
 -54206,
 742302262,
 9492,
 -1,
 742482891,
 9496,
 742665288,
 742154148,
 9474,
 742785023,
 742603562,
 -1,
 -54202,
 742695478,
 9500,
 -54201,
 742745035,
 9508,
 -1,
 742795945,
 9532,
 742992975,
 742620989,
 -1,
 743058508,
 742941763,
 -1,
 -54197,
 743023158,
 9584,
 -1,
 743072715,
 9583,
 743309311,
 743023553,
 -1,
 -54194,
 743219766,
 9581,
 -1,
 743269323,
 9582,
 743451730,
 742961504,
 -1,
 -54191,
 743399332,
 9478,
 -1,
 743451305,
 9476,
 743648341,
 743409176,
 -1,
 -54188,
 743595940,
 9482,
 -1,
 743647913,
 9480,
 743844951,
 743597003,
 9588,
 -1,
 743792982,
 9596,
 -54184,
 743809590,
 9590,
 -1,
 743910057,
 9472,
 744161279,
 741093615,
 -1,
 744172638,
 744075636,
 -1,
 -54180,
 744119902,
 9546,
 -54179,
 744194863,
 9530,
 -1,
 744249439,
 9522,
 744434786,
 744099548,
 -1,
 -54176,
 744361263,
 9533,
 -54175,
 744462234,
 9525,
 -1,
 744526305,
 9517,
 -54173,
 744358345,
 9539,
 -1,
 744637663,
 9541,
 744828047,
 741032818,
 -1,
 744893568,
 744793708,
 -1,
 744959087,
 744862441,
 -1,
 745024618,
 744919537,
 -1,
 -54167,
 744981295,
 9505,
 -1,
 745032300,
 9485,
 745221229,
 744974418,
 -1,
 -54164,
 745177903,
 9513,
 -1,
 745228908,
 9489,
 -54162,
 745181960,
 9543,
 -1,
 745360350,
 9519,
 745548920,
 744918246,
 -1,
 745614451,
 745509361,
 -1,
 -54158,
 745576346,
 9503,
 -1,
 745645378,
 9486,
 745811062,
 745564242,
 -1,
 -54155,
 745772954,
 9511,
 -1,
 745841986,
 9490,
 -54153,
 745748218,
 9537,
 -1,
 745945008,
 9520,
 746138748,
 745503601,
 -1,
 -54150,
 746090141,
 9554,
 -54149,
 746152912,
 9557,
 -1,
 746233874,
 9572,
 746455039,
 746084162,
 -1,
 -54146,
 746364189,
 9555,
 -54145,
 746418901,
 9558,
 -1,
 746462664,
 9573,
 746717183,
 744838062,
 -1,
 746728582,
 746610596,
 9553,
 746848255,
 746666794,
 -1,
 -54140,
 746758710,
 9568,
 -54139,
 746808267,
 9571,
 -1,
 746859177,
 9580,
 747056266,
 746677315,
 -1,
 -54136,
 747020854,
 9562,
 -54135,
 747070411,
 9565,
 -1,
 747121321,
 9577,
 747318414,
 747021249,
 -1,
 -54132,
 747282998,
 9556,
 -54131,
 747332555,
 9559,
 -1,
 747383465,
 9574,
 -1,
 747252393,
 9552,
 747646127,
 744753968,
 -1,
 747711641,
 747586418,
 -1,
 747777174,
 747647504,
 9595,
 747896831,
 747715370,
 -1,
 -54124,
 747807286,
 9487,
 -54123,
 747856843,
 9491,
 -1,
 747907753,
 9523,
 748158975,
 747729033,
 -1,
 -54120,
 748052388,
 9551,
 -1,
 748104361,
 9549,
 748301472,
 747672783,
 9593,
 748421119,
 748239658,
 -1,
 748432542,
 748317277,
 -1,
 -54115,
 748376173,
 9599,
 -1,
 748463803,
 9499,
 -54113,
 748397110,
 9495,
 -1,
 748563113,
 9531,
 748760229,
 748248996,
 9475,
 748879871,
 748698410,
 -1,
 -54109,
 748790326,
 9507,
 -54108,
 748839883,
 9515,
 -1,
 748890793,
 9547,
 749087912,
 748728672,
 -1,
 -54105,
 749035428,
 9479,
 -1,
 749087401,
 9477,
 749284523,
 749045272,
 -1,
 -54102,
 749232036,
 9483,
 -1,
 749284009,
 9481,
 749481133,
 749233099,
 9592,
 -1,
 749445386,
 9598,
 -54098,
 749445686,
 9594,
 -1,
 749546153,
 9473,
 749743306,
 747602797,
 -1,
 749808825,
 749712105,
 -1,
 749874356,
 749769201,
 -1,
 -54093,
 749816428,
 9493,
 -1,
 749885535,
 9506,
 750070967,
 749824082,
 -1,
 -54090,
 750013036,
 9497,
 -1,
 750082143,
 9514,
 -54088,
 750013406,
 9527,
 -1,
 750193851,
 9544,
 750398658,
 749767910,
 -1,
 750464189,
 750359025,
 -1,
 -54084,
 750429506,
 9494,
 -1,
 750490081,
 9502,
 750660800,
 750413906,
 -1,
 -54081,
 750626114,
 9498,
 -1,
 750686689,
 9510,
 -54079,
 750598064,
 9528,
 -1,
 750802862,
 9536,
 750988486,
 750353265,
 -1,
 -54076,
 750939805,
 9560,
 -54075,
 751002576,
 9563,
 -1,
 751083538,
 9575,
 751304703,
 750933826,
 -1,
 -54072,
 751213853,
 9561,
 -54071,
 751268565,
 9564,
 -1,
 751312328,
 9576,
 751512795,
 749678279,
 -1,
 751578319,
 751467377,
 -1,
 -54067,
 751529629,
 9566,
 -54066,
 751592400,
 9569,
 -1,
 751673362,
 9578,
 751840467,
 751547113,
 -1,
 -54063,
 751810095,
 9501,
 -54062,
 751852350,
 9509,
 -1,
 751913950,
 9535,
 752102615,
 751799526,
 -1,
 -54059,
 752064426,
 9504,
 -54058,
 752106319,
 9512,
 -1,
 752170928,
 9538,
 752418815,
 752047938,
 -1,
 -54055,
 752327965,
 9567,
 -54054,
 752382677,
 9570,
 -1,
 752426440,
 9579,
 752680959,
 751473137,
 -1,
 752692448,
 752589800,
 -1,
 -54050,
 752639582,
 9545,
 -54049,
 752714543,
 9529,
 -1,
 752769119,
 9521,
 752954596,
 752619046,
 -1,
 -54046,
 752880943,
 9534,
 -54045,
 752981914,
 9526,
 -1,
 753045985,
 9518,
 -54043,
 752911831,
 9540,
 -1,
 753168935,
 9542,
 753347882,
 740986589,
 -1,
 753413413,
 753303244,
 -1,
 753478897,
 753339004,
 12570,
 753544428,
 753433602,
 12578,
 -54037,
 753499138,
 12713,
 -1,
 753549125,
 12580,
 753741038,
 753514680,
 12576,
 -1,
 753686354,
 12719,
 753872112,
 753684363,
 12574,
 -1,
 753817426,
 12718,
 -1,
 753824516,
 12720,
 754068729,
 753413841,
 12572,
 754134261,
 754023426,
 12579,
 -54028,
 754088962,
 12709,
 -1,
 754138949,
 12581,
 -54026,
 754063115,
 12582,
 -54025,
 754274187,
 12575,
 -54024,
 754334073,
 12573,
 -1,
 754396881,
 12708,
 754593024,
 754005346,
 12571,
 754658557,
 754547714,
 -1,
 -54020,
 754613250,
 12711,
 -1,
 754663237,
 12722,
 -54018,
 754628792,
 12577,
 -54017,
 754791778,
 12710,
 -1,
 754873092,
 12721,
 755051782,
 754536331,
 12583,
 755117315,
 754997074,
 12714,
 -1,
 755072002,
 12723,
 -54012,
 755087544,
 12585,
 -54011,
 755177227,
 12712,
 -1,
 755266308,
 12716,
 755445001,
 754986103,
 12567,
 -54008,
 755388299,
 12705,
 -1,
 755448185,
 12563,
 755641612,
 755399682,
 12555,
 755761151,
 755580741,
 12587,
 -1,
 755646277,
 12717,
 755838223,
 755580741,
 12557,
 -54002,
 755808440,
 12707,
 -1,
 755858434,
 12588,
 756034833,
 755808440,
 12584,
 -1,
 755980114,
 12715,
 756165907,
 755976983,
 12569,
 -1,
 756103545,
 12565,
 756296981,
 756111356,
 12560,
 -1,
 756240267,
 12706,
 756428055,
 756227125,
 12568,
 -1,
 756365689,
 12564,
 756559129,
 756355953,
 12549,
 -1,
 756529336,
 12704,
 -53990,
 756488635,
 12562,
 -53989,
 756615195,
 12586,
 -53988,
 756723650,
 12554,
 -53987,
 756750091,
 12566,
 -53986,
 756848161,
 12561,
 -53985,
 756911308,
 12550,
 -53984,
 756970244,
 12551,
 -53983,
 757033565,
 12556,
 -53982,
 757096560,
 12558,
 -53981,
 757152121,
 12559,
 -53980,
 757217151,
 12552,
 -1,
 757278016,
 12553,
 757530623,
 753339757,
 -1,
 -53977,
 757444546,
 12725,
 -53976,
 757501132,
 12724,
 -53975,
 757555312,
 12726,
 -1,
 757610873,
 12727,
 757804341,
 753296239,
 -1,
 757869869,
 757753483,
 9141,
 -1,
 757813827,
 9142,
 758000944,
 757822424,
 -1,
 -53969,
 757969420,
 8972,
 -1,
 758025025,
 8991,
 758197555,
 757970491,
 -1,
 -53966,
 758166028,
 8973,
 -1,
 758221633,
 8990,
 -53964,
 758128302,
 8993,
 -1,
 758345693,
 10555,
 758579199,
 757729477,
 8904,
 758644735,
 758459844,
 -1,
 -53960,
 758549023,
 10706,
 -1,
 758594291,
 10705,
 758787519,
 740896465,
 -1,
 758853047,
 758742018,
 -1,
 758918582,
 758812053,
 -1,
 758984065,
 758873804,
 -1,
 759049540,
 758912779,
 -1,
 759115074,
 758975100,
 2480,
 759234559,
 759049668,
 -1,
 -53951,
 759116806,
 2544,
 -1,
 759171447,
 2545,
 -53949,
 759081276,
 2524,
 -1,
 759310236,
 2525,
 759508297,
 758974859,
 -1,
 759573831,
 759437067,
 2443,
 -1,
 759502603,
 2528,
 759758847,
 759523933,
 2444,
 -1,
 759655005,
 2529,
 759835983,
 759476162,
 -1,
 759901517,
 759803842,
 -1,
 -53940,
 759834524,
 2464,
 -1,
 759892604,
 2463,
 -53938,
 759834524,
 2469,
 -1,
 760023676,
 2468,
 760229204,
 759790594,
 -1,
 -53935,
 760189598,
 2462,
 -53934,
 760252314,
 2467,
 -53933,
 760283548,
 2457,
 -1,
 760351356,
 2472,
 760556890,
 760161600,
 -1,
 760622424,
 760489280,
 -1,
 -53929,
 760555420,
 2466,
 -1,
 760613500,
 2465,
 -53927,
 760555420,
 2471,
 -1,
 760744572,
 2470,
 760950110,
 760482428,
 2437,
 -53924,
 760920248,
 2452,
 -53923,
 760958859,
 2448,
 -1,
 761006716,
 2438,
 761212258,
 760892183,
 -1,
 -53920,
 761161027,
 2487,
 -53919,
 761210780,
 2486,
 -1,
 761268860,
 2488,
 761474406,
 761159792,
 -1,
 761539941,
 761407388,
 2454,
 -1,
 761473200,
 2510,
 -1,
 761465468,
 2453,
 761736553,
 761406164,
 -1,
 -53912,
 761696926,
 2527,
 -1,
 761727612,
 2479,
 761933163,
 761706680,
 2441,
 -1,
 761903288,
 2442,
 762064238,
 761892044,
 -1,
 -53907,
 761997212,
 2475,
 -1,
 762055292,
 2474,
 762260849,
 762009596,
 -1,
 -53904,
 762193820,
 2461,
 -1,
 762251900,
 2460,
 762457459,
 762204043,
 2439,
 -1,
 762400651,
 2440,
 762588534,
 762396485,
 -1,
 -53899,
 762521500,
 2456,
 -1,
 762579580,
 2455,
 762785145,
 762518581,
 -1,
 -53896,
 762718108,
 2459,
 -1,
 762776188,
 2458,
 762981756,
 762712945,
 -1,
 -53893,
 762914716,
 2477,
 -1,
 762972796,
 2476,
 -53891,
 762918242,
 2451,
 -53890,
 763114918,
 2478,
 -53889,
 763169242,
 2482,
 -53888,
 763242396,
 2489,
 -1,
 763309777,
 2447,
 763506065,
 758927603,
 -1,
 763571591,
 763431307,
 -1,
 763637125,
 763500299,
 2499,
 -1,
 763565835,
 2500,
 763822079,
 763587165,
 2530,
 -1,
 763718237,
 2531,
 763899275,
 763497084,
 -1,
 -53879,
 763869368,
 2508,
 -53878,
 763907979,
 2504,
 -1,
 763955836,
 2494,
 764161421,
 763869368,
 2497,
 -1,
 764131512,
 2498,
 764292495,
 764104587,
 2495,
 -1,
 764235659,
 2496,
 -53872,
 764228962,
 2507,
 -1,
 764358353,
 2503,
 764554655,
 763470947,
 -1,
 764620181,
 764522434,
 -1,
 -53868,
 764561004,
 2536,
 -1,
 764625839,
 2537,
 764816792,
 764562199,
 -1,
 -53865,
 764759903,
 2540,
 -1,
 764807237,
 2541,
 765013403,
 764753791,
 -1,
 -53862,
 764961716,
 2538,
 -1,
 765035708,
 2539,
 -53860,
 764944310,
 2534,
 -53859,
 765135400,
 2535,
 -53858,
 765240854,
 2543,
 -1,
 765279979,
 2542,
 765472168,
 764509388,
 -1,
 765537699,
 765403752,
 -1,
 -53854,
 765473327,
 2435,
 -1,
 765538850,
 2509,
 765734310,
 765463164,
 -1,
 -53851,
 765664094,
 2493,
 -1,
 765761330,
 2434,
 -53849,
 765674475,
 2492,
 -1,
 765881510,
 2433,
 766062001,
 765437631,
 -1,
 766127536,
 765992245,
 -1,
 766193069,
 766095298,
 -1,
 -53844,
 766133868,
 2549,
 -1,
 766198703,
 2550,
 766389679,
 766118440,
 2548,
 -1,
 766317639,
 2552,
 -1,
 766359036,
 2551,
 -1,
 766092058,
 2553,
 766651828,
 766007001,
 -1,
 -53837,
 766581146,
 2547,
 -1,
 766678016,
 2546,
 -53835,
 766596301,
 2554,
 -1,
 766776506,
 2519,
 -1,
 758860941,
 9004,
 767045050,
 758820802,
 -1,
 -53831,
 766980693,
 8812,
 -1,
 767076562,
 8502,
 767241661,
 767010755,
 -1,
 -53828,
 767191510,
 9836,
 -1,
 767245571,
 9835,
 -53826,
 767179063,
 9086,
 -1,
 767376566,
 8757,
 767569443,
 758712794,
 -1,
 767634978,
 767500126,
 -1,
 767700503,
 767581383,
 -1,
 767765970,
 767630389,
 -1,
 767831499,
 767733681,
 -1,
 767897031,
 767778928,
 -1,
 -53818,
 767835296,
 9822,
 -1,
 767899168,
 9818,
 -53816,
 767838568,
 9820,
 -53815,
 768022973,
 9819,
 -53814,
 768113621,
 9823,
 -1,
 768170825,
 9821,
 768355792,
 767766798,
 9679,
 768475135,
 768290244,
 -1,
 -53810,
 768344181,
 9864,
 -53809,
 768425978,
 9865,
 -1,
 768505046,
 10733,
 -53807,
 768316561,
 9827,
 -1,
 768646598,
 10028,
 768814556,
 767707927,
 -1,
 768880086,
 768766724,
 -1,
 -53803,
 768838149,
 9787,
 -1,
 768911693,
 9642,
 -53801,
 768805320,
 9728,
 -53800,
 769023219,
 9733,
 -53799,
 769086948,
 9632,
 -53798,
 769141780,
 9824,
 -53797,
 769233208,
 9751,
 -1,
 769289859,
 9986,
 769469928,
 768743179,
 -1,
 769535463,
 769431053,
 -1,
 769600994,
 769497323,
 -1,
 769666529,
 769568708,
 10145,
 -1,
 769591934,
 10148,
 -1,
 769619654,
 8269,
 769863142,
 769559323,
 -1,
 -53788,
 769826765,
 9654,
 -53787,
 769890458,
 9656,
 -1,
 769949535,
 9658,
 -1,
 769800848,
 9755,
 -1,
 769504389,
 9644,
 770256373,
 769419869,
 -1,
 770321904,
 770221755,
 -1,
 770387438,
 770280219,
 -1,
 -53780,
 770351053,
 9664,
 -53779,
 770414746,
 9666,
 -1,
 770473823,
 9668,
 -53777,
 770338067,
 8268,
 -1,
 770587280,
 9754,
 770834431,
 770258274,
 -1,
 770846196,
 770750842,
 -1,
 -53773,
 770787056,
 9698,
 -1,
 770856851,
 9699,
 -1,
 770809326,
 10731,
 771108350,
 770188608,
 -1,
 771173883,
 771044404,
 9670,
 771293183,
 771120327,
 -1,
 -53767,
 771191752,
 10730,
 -53766,
 771254737,
 9830,
 -1,
 771336459,
 10070,
 771555327,
 771125746,
 -1,
 -53763,
 771465165,
 9660,
 -1,
 771528858,
 9662,
 771698183,
 771078328,
 -1,
 771763718,
 771656908,
 -1,
 771829251,
 771692866,
 -1,
 -53758,
 771770096,
 9701,
 -1,
 771839891,
 9700,
 772079615,
 771787547,
 -1,
 -53755,
 771989453,
 9650,
 -1,
 772053146,
 9652,
 -1,
 771723823,
 9851,
 772288012,
 771635071,
 -1,
 772353547,
 772237917,
 -1,
 -53750,
 772289022,
 10047,
 -1,
 772377021,
 9873,
 -1,
 772288343,
 10022,
 772615695,
 772211532,
 -1,
 -53746,
 772560356,
 9724,
 -1,
 772607923,
 9726,
 772812306,
 772553081,
 -1,
 -53743,
 772754169,
 10711,
 -1,
 772802988,
 9829,
 -53741,
 772779758,
 9646,
 -53740,
 772935531,
 9742,
 -53739,
 773005931,
 9648,
 -53738,
 773104830,
 10002,
 -1,
 773170838,
 10707,
 773390335,
 767628684,
 -1,
 773402142,
 773265459,
 -1,
 -53734,
 773336183,
 8488,
 -53733,
 773396235,
 8476,
 -53732,
 773476235,
 8465,
 -53731,
 773536121,
 8460,
 -1,
 773594165,
 8493,
 773849087,
 773333964,
 -1,
 -53728,
 773762961,
 10164,
 -53727,
 773821372,
 10165,
 -1,
 773873456,
 10166,
 -1,
 767601437,
 9250,
 774123109,
 767539384,
 -1,
 774188617,
 774062794,
 -1,
 774254145,
 774143692,
 -1,
 774319663,
 774208514,
 -1,
 774385194,
 774251220,
 -1,
 -53719,
 774315910,
 6671,
 -1,
 774376060,
 6670,
 774581805,
 774324037,
 -1,
 -53716,
 774545165,
 6659,
 -1,
 774572668,
 6658,
 -53714,
 774547772,
 6667,
 -1,
 774703740,
 6666,
 774909490,
 774271748,
 -1,
 -53711,
 774850390,
 6663,
 -1,
 774900348,
 6662,
 -53709,
 774869662,
 6672,
 -53708,
 775037530,
 6675,
 -53707,
 775129518,
 6664,
 -53706,
 775185731,
 6676,
 -53705,
 775268668,
 6673,
 -53704,
 775309142,
 6660,
 -53703,
 775358938,
 6674,
 -53702,
 775462669,
 6656,
 -53701,
 775517484,
 6669,
 -53700,
 775563164,
 6678,
 -53699,
 775618972,
 6657,
 -53698,
 775701420,
 6665,
 -53697,
 775757702,
 6668,
 -53696,
 775859671,
 6661,
 -1,
 775883388,
 6677,
 776089159,
 774197491,
 -1,
 -53693,
 776059064,
 6680,
 -53692,
 776090978,
 6682,
 -53691,
 776163211,
 6679,
 -53690,
 776220369,
 6681,
 -1,
 776309175,
 6683,
 -53688,
 776019562,
 6686,
 -1,
 776451553,
 6687,
 776613473,
 774141862,
 -1,
 776679006,
 776568524,
 -1,
 776744526,
 776633346,
 -1,
 -53683,
 776667548,
 5957,
 -1,
 776735356,
 5960,
 -53681,
 776704670,
 5964,
 -53680,
 776881765,
 5967,
 -53679,
 776976568,
 5954,
 -53678,
 777030062,
 5958,
 -53677,
 777086275,
 5968,
 -53676,
 777169212,
 5965,
 -53675,
 777209686,
 5961,
 -53674,
 777270694,
 5963,
 -53673,
 777325018,
 5966,
 -53672,
 777428749,
 5955,
 -53671,
 777473931,
 5953,
 -53670,
 777529244,
 5969,
 -53669,
 777585052,
 5956,
 -53668,
 777667500,
 5959,
 -53667,
 777760215,
 5962,
 -1,
 777783932,
 5952,
 778043391,
 776622323,
 -1,
 -53664,
 777959608,
 5971,
 -1,
 777998219,
 5970,
 778239999,
 776539140,
 -1,
 778251876,
 778136897,
 8226,
 -1,
 778195108,
 8729,
 -1,
 778184481,
 9678,
 778448495,
 774048380,
 -1,
 778514030,
 778416633,
 -1,
 778579565,
 778472033,
 -1,
 778645100,
 778522808,
 9744,
 778764287,
 778579396,
 -1,
 -53653,
 778639803,
 9746,
 -1,
 778718594,
 9745,
 -1,
 778574267,
 10007,
 -1,
 778502169,
 10057,
 -1,
 778473337,
 10155,
 779157503,
 778391435,
 -1,
 779169395,
 779026712,
 -1,
 -53646,
 779110586,
 10744,
 -1,
 779187342,
 10745,
 -1,
 779092348,
 9763,
 779432782,
 698433349,
 -1,
 779497765,
 779360011,
 -1,
 779563300,
 779431633,
 -1,
 779628794,
 779498584,
 -1,
 779693903,
 779569943,
 -1,
 779759433,
 779655671,
 -1,
 779824805,
 779714948,
 -1,
 779890328,
 779786284,
 969,
 780009471,
 779824580,
 -1,
 780021385,
 779914444,
 -1,
 780086919,
 779966231,
 8032,
 780206079,
 780024618,
 -1,
 780217986,
 780085060,
 8034,
 -1,
 780161319,
 8098,
 780349060,
 780161474,
 8038,
 -1,
 780292391,
 8102,
 780480134,
 780275144,
 8036,
 -1,
 780423463,
 8100,
 -1,
 780403131,
 8096,
 780730367,
 780035959,
 8182,
 -1,
 780620071,
 8183,
 780807826,
 779960268,
 8033,
 780926975,
 780745514,
 -1,
 780938893,
 780805956,
 8035,
 -1,
 780882215,
 8099,
 781069967,
 780882370,
 8039,
 -1,
 781013287,
 8103,
 781201041,
 780996040,
 8037,
 -1,
 781144359,
 8101,
 -1,
 781124027,
 8097,
 781397652,
 780740420,
 8060,
 -1,
 781340967,
 8178,
 781528726,
 781323720,
 8061,
 -1,
 781472039,
 8180,
 -53609,
 781451707,
 8179,
 -1,
 781595670,
 974,
 781844479,
 779814845,
 959,
 781910015,
 781725124,
 -1,
 781921950,
 781798463,
 8000,
 782041087,
 781859626,
 -1,
 -53603,
 781920068,
 8002,
 -1,
 781979080,
 8004,
 782184098,
 781860812,
 8001,
 782303231,
 782121770,
 -1,
 -53599,
 782182212,
 8003,
 -1,
 782241224,
 8005,
 -53597,
 782116676,
 8056,
 -53596,
 782382102,
 972,
 -1,
 782437832,
 8057,
 782642896,
 779759313,
 -1,
 782708419,
 782600622,
 951,
 782827519,
 782642628,
 -1,
 782839476,
 782732492,
 -1,
 782905010,
 782784279,
 7968,
 783024127,
 782842666,
 -1,
 783036077,
 782903108,
 7970,
 -1,
 782979367,
 8082,
 783167151,
 782979522,
 7974,
 -1,
 783110439,
 8086,
 783298225,
 783093192,
 7972,
 -1,
 783241511,
 8084,
 -1,
 783221179,
 8080,
 783548415,
 782854007,
 8134,
 -1,
 783438119,
 8135,
 783625917,
 782778316,
 7969,
 783745023,
 783563562,
 -1,
 783756984,
 783624004,
 7971,
 -1,
 783700263,
 8083,
 783888058,
 783700418,
 7975,
 -1,
 783831335,
 8087,
 784019132,
 783814088,
 7973,
 -1,
 783962407,
 8085,
 -1,
 783942075,
 8081,
 784215743,
 783558468,
 8052,
 -1,
 784159015,
 8130,
 784346817,
 784141768,
 8053,
 -1,
 784290087,
 8132,
 -53566,
 784269755,
 8131,
 -1,
 784413718,
 942,
 784662527,
 782653272,
 949,
 784728063,
 784543172,
 -1,
 784740041,
 784616511,
 7952,
 784859135,
 784677674,
 -1,
 -53560,
 784738116,
 7954,
 -1,
 784797128,
 7956,
 785002189,
 784678860,
 7953,
 785121279,
 784939818,
 -1,
 -53556,
 785000260,
 7955,
 -1,
 785059272,
 7957,
 -53554,
 784934724,
 8050,
 -53553,
 785200150,
 941,
 -1,
 785255880,
 8051,
 785460978,
 782568060,
 -1,
 785526513,
 785400975,
 945,
 785645567,
 785460676,
 -1,
 785657567,
 785550540,
 -1,
 785723101,
 785602327,
 7936,
 785842175,
 785660714,
 -1,
 785854168,
 785721156,
 7938,
 -1,
 785797415,
 8066,
 785985242,
 785797570,
 7942,
 -1,
 785928487,
 8070,
 786116316,
 785911240,
 7940,
 -1,
 786059559,
 8068,
 -1,
 786039227,
 8064,
 786366463,
 785672055,
 8118,
 -1,
 786256167,
 8119,
 786444008,
 785596364,
 7937,
 786563071,
 786381610,
 -1,
 786575075,
 786442052,
 7939,
 -1,
 786518311,
 8067,
 786706149,
 786518466,
 7943,
 -1,
 786649383,
 8071,
 786837223,
 786632136,
 7941,
 -1,
 786780455,
 8069,
 -1,
 786760123,
 8065,
 787033836,
 786368539,
 -1,
 787099371,
 786974517,
 8048,
 -1,
 787042599,
 8114,
 -1,
 787042437,
 8112,
 787295982,
 786959816,
 8049,
 -1,
 787239207,
 8116,
 -53521,
 787218875,
 8115,
 -53520,
 787362838,
 940,
 -1,
 787415247,
 8113,
 -1,
 785454347,
 985,
 787689229,
 785410687,
 965,
 787808255,
 787623364,
 -1,
 787820288,
 787686720,
 -1,
 787885819,
 787749921,
 971,
 788004863,
 787823402,
 -1,
 -53512,
 787883844,
 8162,
 -53511,
 787952662,
 944,
 -53510,
 788025794,
 8167,
 -1,
 788073928,
 8163,
 788332543,
 787843824,
 8017,
 788398079,
 788216618,
 -1,
 -53506,
 788277060,
 8019,
 -53505,
 788353474,
 8023,
 -1,
 788401608,
 8021,
 788606727,
 787778764,
 -1,
 788672262,
 788551447,
 8016,
 788791295,
 788609834,
 -1,
 -53500,
 788670276,
 8018,
 -53499,
 788746690,
 8022,
 -1,
 788794824,
 8020,
 -1,
 788621175,
 8166,
 789065482,
 788531227,
 -1,
 -53495,
 789008517,
 8160,
 -1,
 789071669,
 8058,
 -53493,
 789001238,
 973,
 -53492,
 789188040,
 8059,
 -1,
 789250255,
 8161,
 789458728,
 787629992,
 953,
 789577727,
 789392836,
 -1,
 789589787,
 789456192,
 -1,
 789655318,
 789519393,
 970,
 789774335,
 789592874,
 -1,
 -53485,
 789653316,
 8146,
 -53484,
 789722134,
 912,
 -53483,
 789795266,
 8151,
 -1,
 789843400,
 8147,
 790102015,
 789613296,
 7985,
 790167551,
 789986090,
 -1,
 -53479,
 790046532,
 7987,
 -53478,
 790122946,
 7991,
 -1,
 790171080,
 7989,
 790376226,
 789548236,
 -1,
 790441761,
 790320919,
 7984,
 790560767,
 790379306,
 -1,
 -53473,
 790439748,
 7986,
 -53472,
 790516162,
 7990,
 -1,
 790564296,
 7988,
 -1,
 790390647,
 8150,
 790834981,
 790300699,
 -1,
 -53468,
 790777989,
 8144,
 -1,
 790841141,
 8054,
 -53466,
 790770710,
 943,
 -53465,
 790957512,
 8055,
 -1,
 791019727,
 8145,
 791228207,
 789400343,
 -1,
 791293740,
 791153276,
 -1,
 -53461,
 791247874,
 1019,
 -1,
 791292370,
 993,
 -53459,
 791219641,
 987,
 -53458,
 791435287,
 963,
 -1,
 791488360,
 1016,
 791686963,
 791166256,
 961,
 791805951,
 791621060,
 -1,
 -53454,
 791694399,
 8164,
 -1,
 791756748,
 8165,
 791949111,
 791645388,
 -1,
 -53451,
 791897362,
 968,
 -53450,
 791957387,
 960,
 -1,
 792012645,
 966,
 792211258,
 791916482,
 -1,
 -53447,
 792147230,
 952,
 -1,
 792234515,
 964,
 792407869,
 792158320,
 -1,
 -53444,
 792375041,
 991,
 -1,
 792424317,
 954,
 792604480,
 792339776,
 -1,
 -53441,
 792544862,
 989,
 -1,
 792638538,
 948,
 -53439,
 792539057,
 950,
 -53438,
 792752011,
 958,
 -53437,
 792827234,
 957,
 -53436,
 792873043,
 956,
 -53435,
 792961657,
 955,
 -53434,
 793022198,
 947,
 -53433,
 793061472,
 962,
 -53432,
 793136960,
 967,
 -1,
 793187237,
 946,
 793444351,
 779710188,
 -1,
 -53429,
 793328944,
 7528,
 -53428,
 793409218,
 7529,
 -53427,
 793480950,
 7527,
 -53426,
 793530176,
 7530,
 -1,
 793580453,
 7526,
 793784322,
 779659778,
 -1,
 793849853,
 793733725,
 -1,
 793915388,
 793809665,
 -1,
 793980795,
 793870724,
 -1,
 794046318,
 793942060,
 937,
 794165247,
 793980356,
 -1,
 794177377,
 794070220,
 -1,
 794242912,
 794122007,
 8040,
 794361855,
 794180394,
 -1,
 794373980,
 794266828,
 -1,
 794439515,
 794322807,
 8046,
 -1,
 794375798,
 8110,
 -1,
 794366890,
 8104,
 794636126,
 794306372,
 8042,
 -1,
 794572406,
 8106,
 794820607,
 794561992,
 8044,
 -1,
 794703478,
 8108,
 -1,
 794170282,
 8188,
 794963819,
 794116044,
 8041,
 795082751,
 794901290,
 -1,
 795094887,
 794987724,
 -1,
 795160422,
 795043703,
 8047,
 -1,
 795096694,
 8111,
 -1,
 795087786,
 8105,
 795357033,
 795027268,
 8043,
 -1,
 795293302,
 8107,
 795541503,
 795282888,
 8045,
 -1,
 795424374,
 8109,
 -53396,
 794896196,
 8186,
 -53395,
 795554838,
 911,
 -1,
 795610568,
 8187,
 795869183,
 793970621,
 927,
 795934719,
 795749828,
 -1,
 795946868,
 795823167,
 8008,
 796065791,
 795884330,
 -1,
 -53389,
 795944772,
 8010,
 -1,
 796003784,
 8012,
 796209016,
 795885516,
 8009,
 796327935,
 796146474,
 -1,
 -53385,
 796206916,
 8011,
 -1,
 796265928,
 8013,
 -53383,
 796141380,
 8184,
 -53382,
 796406806,
 908,
 -1,
 796462536,
 8185,
 796667812,
 793915089,
 -1,
 796733335,
 796625326,
 919,
 796852223,
 796667332,
 -1,
 796864394,
 796757196,
 -1,
 796929929,
 796808983,
 7976,
 797048831,
 796867370,
 -1,
 797060997,
 796953804,
 -1,
 797126532,
 797009783,
 7982,
 -1,
 797062774,
 8094,
 -1,
 797053866,
 8088,
 797323143,
 796993348,
 7978,
 -1,
 797259382,
 8090,
 797507583,
 797248968,
 7980,
 -1,
 797390454,
 8092,
 -1,
 796857258,
 8140,
 797650836,
 796803020,
 7977,
 797769727,
 797588266,
 -1,
 797781904,
 797674700,
 -1,
 797847439,
 797730679,
 7983,
 -1,
 797783670,
 8095,
 -1,
 797774762,
 8089,
 798044050,
 797714244,
 7979,
 -1,
 797980278,
 8091,
 798228479,
 797969864,
 7981,
 -1,
 798111350,
 8093,
 -53355,
 797583172,
 8138,
 -53354,
 798241814,
 905,
 -1,
 798297544,
 8139,
 798556159,
 796677976,
 917,
 798621695,
 798436804,
 -1,
 798633885,
 798510143,
 7960,
 798752767,
 798571306,
 -1,
 -53348,
 798631748,
 7962,
 -1,
 798690760,
 7964,
 798896033,
 798572492,
 7961,
 799014911,
 798833450,
 -1,
 -53344,
 798893892,
 7963,
 -1,
 798952904,
 7965,
 -53342,
 798828356,
 8136,
 -53341,
 799093782,
 904,
 -1,
 799149512,
 8137,
 799354818,
 796613653,
 913,
 799473663,
 799288772,
 -1,
 799485874,
 799378636,
 -1,
 799551409,
 799430423,
 7944,
 799670271,
 799488810,
 -1,
 799682477,
 799575244,
 -1,
 799748012,
 799631223,
 7950,
 -1,
 799684214,
 8078,
 -1,
 799675306,
 8072,
 799944623,
 799614788,
 7946,
 -1,
 799880822,
 8074,
 800129023,
 799870408,
 7948,
 -1,
 800011894,
 8076,
 -1,
 799478698,
 8124,
 800272316,
 799424460,
 7945,
 800391167,
 800209706,
 -1,
 800403384,
 800296140,
 -1,
 800468919,
 800352119,
 7951,
 -1,
 800405110,
 8079,
 -1,
 800396202,
 8073,
 800665530,
 800335684,
 7947,
 -1,
 800601718,
 8075,
 800849919,
 800591304,
 7949,
 -1,
 800732790,
 8077,
 800927679,
 800196635,
 -1,
 -53314,
 800870533,
 8120,
 -1,
 800933685,
 8122,
 -53312,
 800863254,
 902,
 -53311,
 801050056,
 8123,
 -1,
 801112271,
 8121,
 801320918,
 799295400,
 921,
 801439743,
 801254852,
 -1,
 801451979,
 801318208,
 -1,
 801517514,
 801409776,
 7993,
 801636351,
 801454890,
 -1,
 -53304,
 801515332,
 7995,
 -53303,
 801591746,
 7999,
 -1,
 801639880,
 7997,
 -1,
 801446945,
 938,
 801910736,
 801393727,
 7992,
 802029567,
 801848106,
 -1,
 -53298,
 801908548,
 7994,
 -53297,
 801984962,
 7998,
 -1,
 802033096,
 7996,
 802238419,
 801835035,
 -1,
 -53294,
 802181253,
 8152,
 -1,
 802244405,
 8154,
 -53292,
 802173974,
 906,
 -53291,
 802360776,
 8155,
 -1,
 802422991,
 8153,
 802631653,
 801270399,
 933,
 802750463,
 802565572,
 -1,
 802762719,
 802628928,
 -1,
 802828254,
 802720496,
 8025,
 802947071,
 802765610,
 -1,
 -53284,
 802826052,
 8027,
 -53283,
 802902466,
 8031,
 -1,
 802950600,
 8029,
 -1,
 802757665,
 939,
 803221474,
 802687003,
 -1,
 -53279,
 803164293,
 8168,
 -1,
 803227445,
 8170,
 -53277,
 803157014,
 910,
 -53276,
 803343816,
 8171,
 -1,
 803406031,
 8169,
 803614697,
 802573079,
 -1,
 -53273,
 803559447,
 931,
 -53272,
 803612520,
 1015,
 -1,
 803703295,
 1018,
 803876845,
 803572940,
 -1,
 -53269,
 803824914,
 936,
 -53268,
 803884939,
 928,
 -1,
 803940197,
 934,
 804138992,
 803844034,
 -1,
 -53265,
 804074782,
 920,
 -1,
 804162067,
 932,
 804335602,
 804076848,
 929,
 -1,
 804296098,
 8172,
 -53261,
 804270001,
 918,
 -53260,
 804417419,
 926,
 -53259,
 804492642,
 925,
 -53258,
 804538451,
 924,
 -53257,
 804627065,
 923,
 -53256,
 804676594,
 922,
 -53255,
 804753142,
 915,
 -53254,
 804826453,
 916,
 -53253,
 804867904,
 935,
 -1,
 804918181,
 914,
 -1,
 793871562,
 1017,
 805187584,
 793801578,
 -1,
 -53249,
 805128763,
 1021,
 -1,
 805195430,
 1023,
 -53247,
 805140468,
 1012,
 -1,
 805326502,
 1022,
 805515351,
 793709180,
 -1,
 805580883,
 805475100,
 -1,
 805646377,
 805548397,
 -1,
 805711896,
 805602007,
 -1,
 805777425,
 805642845,
 65859,
 805896191,
 805723335,
 -1,
 805908492,
 805810114,
 -1,
 805974027,
 805839456,
 65862,
 -1,
 805924500,
 65870,
 -1,
 805943711,
 65864,
 806170640,
 805837649,
 65861,
 806289407,
 806116551,
 -1,
 -53233,
 806182162,
 65868,
 -1,
 806237609,
 65875,
 -1,
 806106537,
 65871,
 806551551,
 805726727,
 65860,
 806617087,
 806444231,
 -1,
 806629399,
 806531010,
 -1,
 806694934,
 806560352,
 65863,
 -1,
 806655021,
 65878,
 -1,
 806664607,
 65866,
 -1,
 806565289,
 65873,
 806957091,
 805658652,
 -1,
 807022622,
 806893945,
 -1,
 807088157,
 806988755,
 -1,
 -53220,
 807034130,
 65867,
 -1,
 807089577,
 65874,
 -1,
 807048160,
 65857,
 807350305,
 806951558,
 -1,
 -53216,
 807296274,
 65869,
 -1,
 807351721,
 65876,
 -53214,
 807284611,
 65856,
 -1,
 807480514,
 65858,
 807731199,
 806892572,
 -1,
 807743527,
 807645122,
 -1,
 -53210,
 807698001,
 65877,
 -1,
 807778719,
 65865,
 -53208,
 807679401,
 65872,
 -1,
 807896452,
 65879,
 808071234,
 805613506,
 -1,
 808136762,
 808002944,
 -1,
 808202289,
 808103874,
 -1,
 808267823,
 808139129,
 -1,
 -53202,
 808192510,
 65899,
 -1,
 808262507,
 65893,
 -53200,
 808207980,
 65884,
 -1,
 808414386,
 65892,
 808595509,
 808127016,
 65881,
 808714239,
 808541383,
 -1,
 -53196,
 808596771,
 65905,
 -1,
 808655697,
 65898,
 808910847,
 808551127,
 -1,
 808923193,
 808805294,
 -1,
 -53192,
 808858915,
 65906,
 -1,
 808917841,
 65902,
 -1,
 808872455,
 65897,
 809238527,
 808062215,
 -1,
 809250880,
 809140951,
 -1,
 809316414,
 809181789,
 65887,
 -1,
 809274823,
 65901,
 809500671,
 809265671,
 65894,
 -1,
 809384503,
 65895,
 809631743,
 809189340,
 65888,
 -1,
 809515575,
 65889,
 809709640,
 808040374,
 -1,
 809775175,
 809674975,
 -1,
 -53179,
 809713628,
 65890,
 -53178,
 809765416,
 65882,
 -1,
 809869501,
 65896,
 -1,
 809722032,
 65880,
 810102860,
 809642092,
 -1,
 810168395,
 810036672,
 65883,
 -1,
 810119438,
 65886,
 -1,
 810098904,
 65900,
 810365007,
 810032181,
 -1,
 -53170,
 810290573,
 65885,
 -1,
 810378789,
 65903,
 -53168,
 810311983,
 65908,
 -53167,
 810516883,
 65904,
 -53166,
 810577491,
 65891,
 -1,
 810639866,
 65907,
 810823766,
 805508875,
 -1,
 -53163,
 810781590,
 65926,
 -1,
 810846109,
 65927,
 -1,
 810768231,
 903,
 811085950,
 805449276,
 -1,
 811151456,
 811029024,
 119327,
 -53158,
 811105811,
 119356,
 -53157,
 811169185,
 119355,
 -53156,
 811232393,
 119354,
 -53155,
 811293275,
 119353,
 -53154,
 811354571,
 119352,
 -53153,
 811418036,
 119351,
 -1,
 811479557,
 119350,
 811675752,
 811088206,
 119325,
 -53150,
 811630099,
 119337,
 -53149,
 811693473,
 119336,
 -53148,
 811756681,
 119335,
 -53147,
 811815456,
 119334,
 -53146,
 811878859,
 119333,
 -53145,
 811942324,
 119332,
 -1,
 812005710,
 119331,
 812200047,
 811614644,
 119326,
 -53142,
 812154387,
 119343,
 -53141,
 812215433,
 119342,
 -53140,
 812278706,
 119341,
 -53139,
 812341851,
 119340,
 -53138,
 812405280,
 119339,
 -1,
 812468683,
 119338,
 812658805,
 812145243,
 119328,
 -53135,
 812601888,
 119361,
 -53134,
 812665291,
 119360,
 -53133,
 812728756,
 119359,
 -53132,
 812792142,
 119358,
 -1,
 812855813,
 119357,
 813052028,
 812599755,
 -1,
 -53129,
 813006355,
 119349,
 -53128,
 813069729,
 119348,
 -53127,
 813132937,
 119347,
 -53126,
 813196210,
 119346,
 -53125,
 813253044,
 119345,
 -1,
 813314565,
 119344,
 -53123,
 813004193,
 119330,
 -1,
 813460617,
 119329,
 813641886,
 811010075,
 -1,
 813707421,
 813599375,
 -1,
 813772939,
 813644110,
 119296,
 -53118,
 813727251,
 119314,
 -53117,
 813790625,
 119313,
 -53116,
 813853833,
 119312,
 -53115,
 813917106,
 119311,
 -53114,
 813980251,
 119310,
 -53113,
 814043680,
 119309,
 -53112,
 814107083,
 119308,
 -53111,
 814170548,
 119307,
 -53110,
 814233934,
 119306,
 -1,
 814297605,
 119305,
 814493841,
 813718107,
 119300,
 -53107,
 814436896,
 119324,
 -53106,
 814500299,
 119323,
 -53105,
 814563764,
 119322,
 -53104,
 814627150,
 119321,
 -1,
 814690821,
 119320,
 814887063,
 814432692,
 119297,
 -53101,
 814830112,
 119319,
 -53100,
 814893515,
 119318,
 -53099,
 814956980,
 119317,
 -53098,
 815020366,
 119316,
 -1,
 815084037,
 119315,
 -53096,
 814841363,
 119304,
 -53095,
 815232417,
 119303,
 -53094,
 815295625,
 119302,
 -53093,
 815358898,
 119301,
 -53092,
 815419936,
 119299,
 -1,
 815483339,
 119298,
 -1,
 813647669,
 8175,
 815739059,
 813591133,
 -1,
 815804590,
 815698689,
 -1,
 815870122,
 815745815,
 -1,
 815935656,
 815833846,
 -1,
 816001189,
 815893708,
 -1,
 -53084,
 815949074,
 7466,
 -1,
 816009099,
 7464,
 -53082,
 815938864,
 7465,
 -53081,
 816161401,
 7463,
 -1,
 816221942,
 7462,
 -53079,
 815861177,
 986,
 -1,
 816327029,
 992,
 -53077,
 815824611,
 1011,
 -53076,
 816460896,
 990,
 -53075,
 816554084,
 988,
 -1,
 816619738,
 984,
 816787633,
 815748156,
 -1,
 -53072,
 816746857,
 1010,
 -1,
 816821278,
 1013,
 -53070,
 816722316,
 885,
 -1,
 816911363,
 65923,
 817115328,
 815670592,
 -1,
 817180858,
 817049000,
 -1,
 817246393,
 817146290,
 -1,
 -53065,
 817178436,
 8173,
 -53064,
 817254850,
 8129,
 -1,
 817302984,
 8174,
 -1,
 817181718,
 901,
 817574079,
 817138416,
 8190,
 817692671,
 817511210,
 -1,
 -53059,
 817571652,
 8157,
 -53058,
 817648066,
 8159,
 -1,
 817696200,
 8158,
 -1,
 817514281,
 65915,
 817967308,
 817082306,
 -1,
 818032838,
 817903993,
 -1,
 818098373,
 817982177,
 -1,
 -53052,
 818052286,
 65912,
 -1,
 818103165,
 65918,
 -1,
 818038102,
 977,
 818360521,
 817994697,
 -1,
 -53048,
 818297906,
 65911,
 -1,
 818365309,
 65917,
 -53046,
 818295634,
 65929,
 -53045,
 818518157,
 900,
 -1,
 818551345,
 65914,
 818753750,
 817925324,
 -1,
 818819282,
 818698007,
 8127,
 818937855,
 818756394,
 -1,
 -53040,
 818816836,
 8141,
 -53039,
 818893250,
 8143,
 -1,
 818941384,
 8142,
 -53037,
 818746282,
 8126,
 -53036,
 819109418,
 982,
 -53035,
 819143360,
 981,
 -1,
 819226487,
 8128,
 819409116,
 818689378,
 -1,
 819474649,
 819373038,
 65909,
 -1,
 819411511,
 65910,
 -53030,
 819414961,
 8189,
 -53029,
 819534796,
 65924,
 -1,
 819613637,
 65916,
 819802338,
 819355760,
 -1,
 819867872,
 819726972,
 -1,
 -53025,
 819832803,
 1008,
 -1,
 819895850,
 983,
 -53023,
 819795082,
 65922,
 -1,
 820005139,
 8125,
 820195558,
 819725503,
 -1,
 -53020,
 820142309,
 978,
 -53019,
 820202856,
 980,
 -1,
 820250084,
 979,
 820457707,
 820123403,
 -1,
 820523242,
 820391444,
 -1,
 -53015,
 820488015,
 1020,
 -1,
 820538956,
 1009,
 -1,
 820461432,
 1014,
 820785390,
 820388564,
 -1,
 -53011,
 820741751,
 890,
 -1,
 820781851,
 65913,
 820982001,
 820736772,
 -1,
 -53008,
 820925463,
 119365,
 -1,
 820997746,
 65921,
 821178612,
 820918143,
 -1,
 -53005,
 821111390,
 65919,
 -1,
 821182557,
 65920,
 -53003,
 821101036,
 65930,
 -53002,
 821332377,
 65925,
 -53001,
 821370233,
 894,
 -53000,
 821464528,
 884,
 -52999,
 821502630,
 65928,
 -1,
 821595089,
 976,
 821821439,
 779565660,
 -1,
 821833994,
 821704034,
 -1,
 821899527,
 821771417,
 -1,
 821965058,
 821844613,
 10878,
 822083583,
 821901318,
 -1,
 822096129,
 821990280,
 10882,
 -1,
 822060815,
 10884,
 -1,
 822065500,
 10880,
 822292741,
 821905366,
 -1,
 -52988,
 822238631,
 8819,
 -1,
 822283971,
 8805,
 -52986,
 822233136,
 8823,
 -1,
 822420503,
 10886,
 822673407,
 821833178,
 -1,
 -52983,
 822545033,
 10916,
 -1,
 822614016,
 8807,
 822817047,
 821758588,
 -1,
 822882580,
 822741635,
 -1,
 822948113,
 822823703,
 -1,
 823013648,
 822870192,
 -1,
 -52977,
 822955769,
 10894,
 -1,
 823034917,
 10896,
 -1,
 822975685,
 10900,
 -52974,
 822907836,
 10616,
 -52973,
 823204188,
 10898,
 -1,
 823293500,
 10892,
 823525375,
 822836064,
 -1,
 -52970,
 823401968,
 10888,
 -1,
 823466905,
 10890,
 823669019,
 822745660,
 -1,
 -52967,
 823620517,
 10876,
 -52966,
 823690118,
 8919,
 -1,
 823748313,
 10874,
 823931168,
 823595889,
 -1,
 823996703,
 823862270,
 -1,
 -52962,
 823942567,
 8935,
 -1,
 823987907,
 8809,
 -1,
 823964109,
 10917,
 824258850,
 823871231,
 10919,
 -1,
 824217621,
 10921,
 -52957,
 824187290,
 62,
 -1,
 824338444,
 8923,
 -1,
 779486485,
 96,
 824586751,
 779466936,
 -1,
 824652183,
 824519281,
 -1,
 824717671,
 824606412,
 -1,
 824783151,
 824641563,
 -1,
 824848686,
 824736802,
 -1,
 824914220,
 824776459,
 2699,
 -1,
 824841995,
 2784,
 825098239,
 824863325,
 2700,
 -1,
 824994397,
 2785,
 -1,
 824773244,
 2741,
 825241909,
 824750018,
 -1,
 825307443,
 825208770,
 -1,
 -52942,
 825239452,
 2720,
 -1,
 825297532,
 2719,
 -52940,
 825239452,
 2725,
 -1,
 825428604,
 2724,
 825635130,
 825195522,
 -1,
 -52937,
 825594526,
 2718,
 -52936,
 825657242,
 2723,
 -52935,
 825688476,
 2713,
 -1,
 825756284,
 2728,
 825962816,
 825566528,
 -1,
 826028350,
 825894208,
 -1,
 -52931,
 825960348,
 2722,
 -1,
 826018428,
 2721,
 -52929,
 825960348,
 2727,
 -1,
 826149500,
 2726,
 826356036,
 825887356,
 2693,
 -52926,
 826325176,
 2708,
 -52925,
 826363787,
 2704,
 -1,
 826411644,
 2694,
 826618184,
 826297111,
 -1,
 -52922,
 826565955,
 2743,
 -52921,
 826615708,
 2742,
 -1,
 826673788,
 2744,
 826880330,
 826587320,
 2697,
 -1,
 826849464,
 2698,
 827011405,
 826838220,
 -1,
 -52916,
 826943388,
 2731,
 -1,
 827001468,
 2730,
 827208016,
 826960477,
 -1,
 -52913,
 827132378,
 2739,
 -1,
 827198076,
 2738,
 827404627,
 827154544,
 -1,
 -52910,
 827336604,
 2710,
 -1,
 827394684,
 2709,
 827601238,
 827348988,
 -1,
 -52907,
 827533212,
 2717,
 -1,
 827591292,
 2716,
 827797848,
 827543435,
 2695,
 -1,
 827740043,
 2696,
 827928923,
 827735877,
 -1,
 -52902,
 827860892,
 2712,
 -1,
 827918972,
 2711,
 828125534,
 827857973,
 -1,
 -52899,
 828057500,
 2715,
 -1,
 828115580,
 2714,
 828322145,
 828052337,
 -1,
 -52896,
 828254108,
 2733,
 -1,
 828312188,
 2732,
 -52894,
 828281502,
 2735,
 -52893,
 828483900,
 2736,
 -52892,
 828519778,
 2707,
 -52891,
 828585382,
 2734,
 -52890,
 828647324,
 2745,
 -1,
 828714705,
 2703,
 828911998,
 824682441,
 -1,
 828977531,
 828865740,
 -1,
 829043054,
 828901771,
 -1,
 829108588,
 828970763,
 2755,
 -1,
 829036299,
 2756,
 829292543,
 829057629,
 2786,
 -1,
 829188701,
 2787,
 829370738,
 828967548,
 -1,
 -52880,
 829339832,
 2764,
 -52879,
 829378443,
 2760,
 -1,
 829426300,
 2750,
 829632884,
 829339832,
 2753,
 -1,
 829601976,
 2754,
 829763958,
 829575051,
 2751,
 -1,
 829706123,
 2752,
 829895033,
 829727882,
 -1,
 -52872,
 829830498,
 2761,
 -1,
 829894353,
 2757,
 -52870,
 829830498,
 2763,
 -1,
 830025425,
 2759,
 830275583,
 828941450,
 -1,
 -52867,
 830158178,
 2705,
 -1,
 830222033,
 2701,
 830419340,
 828875875,
 -1,
 830484866,
 830386114,
 -1,
 -52863,
 830424684,
 2792,
 -1,
 830489519,
 2793,
 830681477,
 830425879,
 -1,
 -52860,
 830623583,
 2796,
 -1,
 830670917,
 2797,
 830878088,
 830617471,
 -1,
 -52857,
 830825396,
 2794,
 -1,
 830899388,
 2795,
 -52855,
 830807990,
 2790,
 -52854,
 830999080,
 2791,
 -52853,
 831104534,
 2799,
 -1,
 831143659,
 2798,
 831336853,
 830373068,
 -1,
 831402384,
 831267432,
 -1,
 -52849,
 831337007,
 2691,
 -1,
 831402530,
 2765,
 831598995,
 831326844,
 -1,
 -52846,
 831527774,
 2749,
 -1,
 831625010,
 2690,
 -52844,
 831538155,
 2748,
 -1,
 831745190,
 2689,
 -52842,
 831299377,
 2801,
 -1,
 831881604,
 2768,
 832057854,
 824577622,
 -1,
 832123353,
 832011980,
 -1,
 832188831,
 832090050,
 -1,
 832254365,
 832155586,
 -1,
 -52836,
 832186268,
 2592,
 -1,
 832244348,
 2591,
 -52834,
 832186268,
 2597,
 -1,
 832375420,
 2596,
 832582052,
 832142338,
 -1,
 -52831,
 832541342,
 2590,
 -52830,
 832604058,
 2595,
 -52829,
 832635292,
 2585,
 -1,
 832703100,
 2600,
 832909738,
 832513344,
 -1,
 832975272,
 832841024,
 -1,
 -52825,
 832907164,
 2594,
 -1,
 832965244,
 2593,
 -52823,
 832907164,
 2599,
 -1,
 833096316,
 2598,
 833302958,
 832834172,
 2565,
 -52820,
 833271992,
 2580,
 -52819,
 833310603,
 2576,
 -1,
 833358460,
 2566,
 833565107,
 833249392,
 -1,
 833630642,
 833501561,
 -1,
 -52815,
 833562524,
 2649,
 -1,
 833620604,
 2582,
 -1,
 833555068,
 2581,
 833892792,
 833503045,
 -1,
 833958327,
 833829241,
 -1,
 -52810,
 833890204,
 2650,
 -1,
 833948284,
 2584,
 -1,
 833882748,
 2583,
 834220474,
 833861816,
 2569,
 -1,
 834189496,
 2570,
 834351549,
 834161431,
 -1,
 -52804,
 834283420,
 2614,
 -1,
 834341500,
 2616,
 834548160,
 834279179,
 -1,
 -52801,
 834513212,
 2652,
 -1,
 834538108,
 2608,
 834744771,
 834505932,
 -1,
 -52798,
 834676636,
 2603,
 -1,
 834734716,
 2602,
 834941382,
 834693725,
 -1,
 -52795,
 834865626,
 2611,
 -1,
 834931324,
 2610,
 835137993,
 834885628,
 -1,
 -52792,
 835069852,
 2589,
 -1,
 835127932,
 2588,
 835334603,
 835080075,
 2567,
 -1,
 835276683,
 2568,
 835465678,
 835263541,
 -1,
 -52787,
 835397532,
 2587,
 -1,
 835455612,
 2586,
 835662289,
 835392369,
 -1,
 -52784,
 835594140,
 2605,
 -1,
 835652220,
 2604,
 -52782,
 835591293,
 2651,
 -52781,
 835818142,
 2607,
 -52780,
 835854938,
 2613,
 -52779,
 835944830,
 2579,
 -52778,
 835990950,
 2606,
 -52777,
 836052892,
 2617,
 -52776,
 836145630,
 2654,
 -1,
 836201667,
 2575,
 836383207,
 832087139,
 -1,
 836448733,
 836349890,
 -1,
 -52772,
 836388460,
 2664,
 -1,
 836453295,
 2665,
 836645344,
 836389655,
 -1,
 -52769,
 836587359,
 2668,
 -1,
 836634693,
 2669,
 836841955,
 836581247,
 -1,
 -52766,
 836789172,
 2666,
 -1,
 836863164,
 2667,
 -52764,
 836771766,
 2662,
 -52763,
 836962856,
 2663,
 -52762,
 837068310,
 2671,
 -1,
 837107435,
 2670,
 837300722,
 836325619,
 -1,
 837366252,
 837225084,
 -1,
 -52758,
 837335224,
 2636,
 -52757,
 837373835,
 2632,
 -1,
 837421692,
 2622,
 837628398,
 837335224,
 2625,
 -1,
 837597368,
 2626,
 837759472,
 837570443,
 2623,
 -1,
 837701515,
 2624,
 -52751,
 837714302,
 2635,
 -1,
 837840067,
 2631,
 838021625,
 837254348,
 -1,
 838087158,
 837952104,
 -1,
 -52747,
 838021679,
 2563,
 -1,
 838087202,
 2637,
 -52745,
 838026219,
 2620,
 -52744,
 838246042,
 2562,
 -1,
 838293942,
 2561,
 -52742,
 837970479,
 2675,
 -52741,
 838444043,
 2672,
 -52740,
 838489041,
 2674,
 -52739,
 838535162,
 2676,
 -1,
 838607199,
 2673,
 -1,
 831989161,
 8370,
 838873770,
 824520401,
 -1,
 838939302,
 838808930,
 -1,
 839004833,
 838889839,
 -1,
 839070268,
 838958796,
 -1,
 839135754,
 839006585,
 -1,
 839201287,
 839060092,
 -1,
 -52730,
 839128843,
 4340,
 -1,
 839200465,
 4336,
 -52728,
 839156144,
 4341,
 -52727,
 839340000,
 4338,
 -1,
 839397073,
 4337,
 839594512,
 839064629,
 -1,
 839660046,
 839530873,
 -1,
 -52723,
 839602126,
 4329,
 -1,
 839682576,
 4333,
 -52721,
 839602114,
 4332,
 -1,
 839813631,
 4330,
 839987733,
 839561154,
 -1,
 840053268,
 839912060,
 -1,
 -52717,
 839980811,
 4322,
 -1,
 840072194,
 4311,
 -1,
 839993405,
 4345,
 840315416,
 839920759,
 -1,
 -52713,
 840255481,
 4319,
 -1,
 840330418,
 4310,
 840512027,
 840256279,
 -1,
 -52710,
 840472026,
 4328,
 -1,
 840534527,
 4321,
 840708638,
 840469708,
 -1,
 -52707,
 840648697,
 4324,
 -1,
 840731152,
 4318,
 840905249,
 840654960,
 -1,
 -52704,
 840845305,
 4325,
 -1,
 840927743,
 4313,
 841101860,
 840849404,
 -1,
 -52701,
 841043906,
 4331,
 -1,
 841107397,
 4335,
 841298471,
 841039685,
 -1,
 -52698,
 841238469,
 4326,
 -1,
 841320959,
 4306,
 841495082,
 841232081,
 -1,
 -52695,
 841448450,
 4308,
 -1,
 841482314,
 4344,
 841691693,
 841419388,
 -1,
 -52692,
 841645058,
 4304,
 -1,
 841699278,
 4346,
 -52690,
 841650826,
 4343,
 -52689,
 841842577,
 4334,
 -52688,
 841893414,
 4339,
 -52687,
 841980448,
 4309,
 -52686,
 842052460,
 4323,
 -52685,
 842114770,
 4320,
 -52684,
 842155624,
 4327,
 -52683,
 842236289,
 4317,
 -52682,
 842299070,
 4316,
 -52681,
 842334906,
 4315,
 -52680,
 842436123,
 4314,
 -52679,
 842485710,
 4312,
 -52678,
 842564311,
 4342,
 -52677,
 842610232,
 4307,
 -1,
 842676467,
 4305,
 842871406,
 839003042,
 -1,
 842936900,
 842807673,
 -1,
 843002433,
 842861180,
 -1,
 -52672,
 842929931,
 11556,
 -1,
 843001553,
 11552,
 -52670,
 842957232,
 11557,
 -52669,
 843141088,
 11554,
 -1,
 843198161,
 11553,
 843395658,
 842865717,
 -1,
 843461192,
 843331961,
 -1,
 -52665,
 843403214,
 11545,
 -1,
 843483664,
 11549,
 -52663,
 843403202,
 11548,
 -1,
 843614719,
 11546,
 843788877,
 843328631,
 -1,
 -52660,
 843728889,
 11535,
 -1,
 843803826,
 11526,
 843985488,
 843745710,
 -1,
 -52657,
 843912971,
 11538,
 -1,
 844004354,
 11527,
 844182099,
 843926295,
 -1,
 -52654,
 844142042,
 11544,
 -1,
 844204543,
 11537,
 844378710,
 844139724,
 -1,
 -52651,
 844318713,
 11540,
 -1,
 844401168,
 11534,
 844575321,
 844324976,
 -1,
 -52648,
 844515321,
 11541,
 -1,
 844597759,
 11529,
 844771932,
 844519420,
 -1,
 -52645,
 844713922,
 11547,
 -1,
 844777413,
 11551,
 844968543,
 844709701,
 -1,
 -52642,
 844908485,
 11542,
 -1,
 844990975,
 11522,
 -52640,
 844922769,
 11550,
 -52639,
 845104678,
 11555,
 -52638,
 845191712,
 11525,
 -52637,
 845263724,
 11539,
 -52636,
 845326034,
 11536,
 -52635,
 845366888,
 11543,
 -52634,
 845447553,
 11533,
 -52633,
 845510334,
 11532,
 -52632,
 845546170,
 11531,
 -52631,
 845647387,
 11530,
 -52630,
 845696974,
 11528,
 -52629,
 845769906,
 11524,
 -52628,
 845821496,
 11523,
 -52627,
 845887731,
 11521,
 -1,
 845974015,
 11520,
 846148256,
 842805742,
 -1,
 846213750,
 846084473,
 -1,
 846279283,
 846137980,
 -1,
 -52622,
 846206731,
 4292,
 -1,
 846278353,
 4288,
 -52620,
 846234032,
 4293,
 -52619,
 846417888,
 4290,
 -1,
 846474961,
 4289,
 846672508,
 846142517,
 -1,
 846738042,
 846608761,
 -1,
 -52615,
 846680014,
 4281,
 -1,
 846760464,
 4285,
 -52613,
 846680002,
 4284,
 -1,
 846891519,
 4282,
 847065727,
 846605431,
 -1,
 -52610,
 847005689,
 4271,
 -1,
 847080626,
 4262,
 847262338,
 847022510,
 -1,
 -52607,
 847189771,
 4274,
 -1,
 847281154,
 4263,
 847458949,
 847203095,
 -1,
 -52604,
 847418842,
 4280,
 -1,
 847481343,
 4273,
 847655560,
 847416524,
 -1,
 -52601,
 847595513,
 4276,
 -1,
 847677968,
 4270,
 847852171,
 847601776,
 -1,
 -52598,
 847792121,
 4277,
 -1,
 847874559,
 4265,
 848048782,
 847796220,
 -1,
 -52595,
 847990722,
 4283,
 -1,
 848054213,
 4287,
 848245393,
 847986501,
 -1,
 -52592,
 848185285,
 4278,
 -1,
 848267775,
 4258,
 -52590,
 848199569,
 4286,
 -52589,
 848381478,
 4291,
 -52588,
 848468512,
 4261,
 -52587,
 848540524,
 4275,
 -52586,
 848602834,
 4272,
 -52585,
 848643688,
 4279,
 -52584,
 848724353,
 4269,
 -52583,
 848787134,
 4268,
 -52582,
 848822970,
 4267,
 -52581,
 848924187,
 4266,
 -52580,
 848973774,
 4264,
 -52579,
 849046706,
 4260,
 -52578,
 849098296,
 4259,
 -52577,
 849164531,
 4257,
 -1,
 849250815,
 4256,
 -1,
 846110066,
 4347,
 849543167,
 838952733,
 -1,
 849556133,
 849445787,
 -1,
 -52572,
 849501607,
 8782,
 -1,
 849546947,
 8785,
 -1,
 849480798,
 8762,
 -52569,
 838907227,
 12307,
 -52568,
 849773551,
 8368,
 -52567,
 849851707,
 9802,
 -1,
 849906192,
 9881,
 850080555,
 838822493,
 -1,
 850146090,
 850027632,
 -1,
 850211563,
 850078626,
 -1,
 850277046,
 850152215,
 -1,
 850342578,
 850213241,
 -1,
 850408113,
 850299310,
 11339,
 -1,
 850362444,
 11356,
 -1,
 850332284,
 11342,
 850604724,
 850269857,
 11348,
 -1,
 850547606,
 11349,
 -52555,
 850568526,
 11346,
 -1,
 850664568,
 11332,
 850866879,
 850207444,
 -1,
 850932412,
 850800337,
 -1,
 850997947,
 850859787,
 -1,
 -52550,
 850966712,
 11343,
 -1,
 851005323,
 11344,
 -1,
 850934230,
 11317,
 -52547,
 850901176,
 11347,
 -52546,
 851195234,
 11350,
 -1,
 851263686,
 11345,
 851456711,
 850808715,
 11323,
 851522243,
 851379273,
 -1,
 -52542,
 851464026,
 11355,
 -1,
 851521233,
 11321,
 851718854,
 851450116,
 -1,
 -52539,
 851677889,
 11351,
 -1,
 851745034,
 11353,
 -1,
 851681783,
 11322,
 851981003,
 851423170,
 -1,
 -52535,
 851938905,
 11333,
 -52534,
 851993874,
 11340,
 -1,
 852069370,
 11357,
 852243151,
 851912000,
 -1,
 -52531,
 852199905,
 11319,
 -52530,
 852250215,
 11316,
 -1,
 852326093,
 11324,
 852505298,
 852175991,
 -1,
 -52527,
 852471933,
 11318,
 -1,
 852526749,
 11320,
 852701909,
 852462796,
 -1,
 -52524,
 852657545,
 11330,
 -1,
 852700881,
 11338,
 852898520,
 852637026,
 -1,
 -52521,
 852855136,
 11337,
 -1,
 852923746,
 11329,
 853095131,
 852847197,
 -1,
 -52518,
 853034426,
 11326,
 -1,
 853129638,
 11358,
 853291742,
 853030783,
 -1,
 -52515,
 853214538,
 11335,
 -1,
 853319490,
 11354,
 853488353,
 853218161,
 -1,
 -52512,
 853412173,
 11313,
 -1,
 853509296,
 11352,
 -52510,
 853425440,
 11314,
 -52509,
 853608797,
 11334,
 -52508,
 853709249,
 11331,
 -52507,
 853767574,
 11328,
 -52506,
 853823262,
 11327,
 -52505,
 853871220,
 11325,
 -52504,
 853974763,
 11336,
 -52503,
 854031050,
 11315,
 -52502,
 854110201,
 11341,
 -1,
 854153630,
 11312,
 854392831,
 850145774,
 -1,
 854405877,
 854280983,
 -1,
 854471409,
 854342009,
 -1,
 854536944,
 854428078,
 11291,
 -1,
 854491212,
 11308,
 -1,
 854461052,
 11294,
 854733555,
 854398625,
 11300,
 -1,
 854676374,
 11301,
 -52492,
 854697294,
 11298,
 -1,
 854793336,
 11284,
 854995710,
 854336212,
 -1,
 855061243,
 854929105,
 -1,
 855126778,
 854988555,
 -1,
 -52487,
 855095480,
 11295,
 -1,
 855134091,
 11296,
 -1,
 855062998,
 11269,
 -52484,
 855029944,
 11299,
 -52483,
 855324002,
 11302,
 -1,
 855392454,
 11297,
 855585542,
 854937483,
 11275,
 855651074,
 855508041,
 -1,
 -52479,
 855592794,
 11307,
 -1,
 855650001,
 11273,
 855847685,
 855578884,
 -1,
 -52476,
 855806657,
 11303,
 -1,
 855873802,
 11305,
 -1,
 855810551,
 11274,
 856109834,
 855551938,
 -1,
 -52472,
 856067673,
 11285,
 -52471,
 856122642,
 11292,
 -1,
 856198138,
 11309,
 856371982,
 856040768,
 -1,
 -52468,
 856328673,
 11271,
 -52467,
 856378983,
 11268,
 -1,
 856454861,
 11276,
 856634129,
 856304759,
 -1,
 -52464,
 856600701,
 11270,
 -1,
 856655517,
 11272,
 856830740,
 856591564,
 -1,
 -52461,
 856786313,
 11282,
 -1,
 856829649,
 11290,
 857027351,
 856765794,
 -1,
 -52458,
 856983904,
 11289,
 -1,
 857052514,
 11281,
 857223962,
 856975965,
 -1,
 -52455,
 857163194,
 11278,
 -1,
 857258406,
 11310,
 857420573,
 857159551,
 -1,
 -52452,
 857343306,
 11287,
 -1,
 857448258,
 11306,
 857617184,
 857346929,
 -1,
 -52449,
 857540941,
 11265,
 -1,
 857638064,
 11304,
 -52447,
 857554208,
 11266,
 -52446,
 857737565,
 11286,
 -52445,
 857838017,
 11283,
 -52444,
 857896342,
 11280,
 -52443,
 857952030,
 11279,
 -52442,
 857999988,
 11277,
 -52441,
 858103531,
 11288,
 -52440,
 858159818,
 11267,
 -52439,
 858238969,
 11293,
 -1,
 858282398,
 11264,
 -1,
 850071061,
 10726,
 858534733,
 850013618,
 -1,
 858600241,
 858487810,
 -1,
 858665776,
 858535452,
 -1,
 -52433,
 858622270,
 66369,
 -1,
 858688967,
 66378,
 -1,
 858633917,
 66365,
 858927924,
 858566594,
 -1,
 -52429,
 858890566,
 66360,
 -1,
 858932159,
 66372,
 859124535,
 858869643,
 -1,
 -52426,
 859081554,
 66358,
 -1,
 859144408,
 66375,
 859321146,
 859060601,
 -1,
 -52423,
 859247556,
 66376,
 -1,
 859308053,
 66359,
 859517757,
 859245180,
 -1,
 -52420,
 859481243,
 66356,
 -1,
 859522838,
 66352,
 -52418,
 859447594,
 66373,
 -52417,
 859675677,
 66367,
 -52416,
 859741439,
 66371,
 -52415,
 859774426,
 66370,
 -52414,
 859842363,
 66357,
 -52413,
 859914392,
 66368,
 -52412,
 859988800,
 66377,
 -52411,
 860046068,
 66364,
 -52410,
 860117773,
 66363,
 -52409,
 860201103,
 66362,
 -52408,
 860263154,
 66366,
 -52407,
 860318910,
 66354,
 -52406,
 860377814,
 66374,
 -52405,
 860454074,
 66361,
 -52404,
 860497994,
 66355,
 -1,
 860576453,
 66353,
 -1,
 858482141,
 8503,
 860829692,
 779399106,
 -1,
 860894386,
 860770187,
 -1,
 860959845,
 860836465,
 -1,
 861025209,
 860900119,
 -1,
 861090702,
 860977716,
 -1,
 861156188,
 861056962,
 -1,
 861221719,
 861122498,
 -1,
 -52394,
 861153180,
 3995,
 -1,
 861211260,
 3994,
 861418330,
 861162263,
 -1,
 -52391,
 861349788,
 4010,
 -1,
 861407868,
 4009,
 -52389,
 861349788,
 4000,
 -1,
 861538940,
 3999,
 861746021,
 861087040,
 -1,
 861811552,
 861678711,
 -1,
 -52385,
 861743004,
 4012,
 -1,
 861801084,
 4011,
 862008163,
 861742400,
 -1,
 -52382,
 861939612,
 3997,
 -1,
 861997692,
 3996,
 -52380,
 861939612,
 4002,
 -1,
 862128764,
 4001,
 862335850,
 861699074,
 -1,
 -52377,
 862294686,
 3993,
 -52376,
 862357402,
 3998,
 -52375,
 862388636,
 3988,
 -1,
 862456444,
 4003,
 862663534,
 862276375,
 -1,
 -52372,
 862610755,
 4021,
 -52371,
 862660508,
 4020,
 -1,
 862718588,
 4022,
 862925682,
 862609520,
 -1,
 -52368,
 862851552,
 4025,
 -52367,
 862922652,
 3985,
 -1,
 862980732,
 3984,
 863187830,
 862850386,
 -1,
 -52364,
 863146654,
 4027,
 -52363,
 863192677,
 4026,
 -1,
 863283516,
 4028,
 863449977,
 863120503,
 -1,
 -52360,
 863381404,
 4014,
 -1,
 863439484,
 4015,
 863646588,
 863407308,
 -1,
 -52357,
 863578012,
 4005,
 -1,
 863636092,
 4004,
 863843199,
 863584069,
 -1,
 -52354,
 863774620,
 3987,
 -1,
 863832700,
 3986,
 864039810,
 863771701,
 -1,
 -52351,
 863971228,
 3990,
 -1,
 864029308,
 3989,
 864236421,
 863966065,
 -1,
 -52348,
 864167836,
 4007,
 -1,
 864225916,
 4006,
 -52346,
 864195230,
 4017,
 -52345,
 864372325,
 4013,
 -52344,
 864463164,
 4018,
 -52343,
 864499110,
 4008,
 -52342,
 864553434,
 4019,
 -52341,
 864646444,
 3991,
 -52340,
 864692124,
 4023,
 -52339,
 864750204,
 4024,
 -1,
 864836677,
 4016,
 865022891,
 861043556,
 -1,
 865088413,
 864950027,
 -1,
 865153947,
 865044771,
 -1,
 865219479,
 865076823,
 -1,
 865285014,
 865156933,
 -1,
 -52332,
 865217133,
 3868,
 -52331,
 865278488,
 3867,
 -1,
 865384115,
 3866,
 -1,
 865233293,
 3871,
 865665023,
 865162878,
 -1,
 -52327,
 865544813,
 4047,
 -52326,
 865606168,
 3870,
 -1,
 865711795,
 3869,
 -52324,
 865076931,
 3967,
 -1,
 865837980,
 3966,
 866005920,
 865047198,
 -1,
 -52321,
 865931784,
 3902,
 -1,
 866009920,
 3975,
 866202531,
 865956612,
 -1,
 -52318,
 866136646,
 3977,
 -1,
 866200624,
 3903,
 866399142,
 866138660,
 -1,
 -52315,
 866326954,
 3974,
 -1,
 866400357,
 3976,
 866595753,
 866341596,
 -1,
 -52312,
 866518175,
 3979,
 -1,
 866590586,
 3978,
 -52310,
 866560903,
 3971,
 -1,
 866756909,
 3970,
 866975743,
 864953044,
 -1,
 866988984,
 866880332,
 -1,
 867054514,
 866941034,
 4041,
 867172351,
 866999495,
 -1,
 -52304,
 867053451,
 4042,
 -52303,
 867136177,
 4043,
 -1,
 867196000,
 4044,
 867382196,
 867016031,
 4037,
 -1,
 867336644,
 4039,
 867513271,
 867339468,
 -1,
 -52298,
 867476757,
 4040,
 -1,
 867526565,
 4038,
 -1,
 867456212,
 4036,
 -1,
 866927338,
 3840,
 867841014,
 860973661,
 -1,
 867906547,
 867799809,
 -1,
 867972036,
 867872706,
 -1,
 868037567,
 867938242,
 -1,
 -52290,
 867968924,
 3915,
 -1,
 868027004,
 3914,
 868234178,
 867978007,
 -1,
 -52287,
 868165532,
 3930,
 -1,
 868223612,
 3929,
 -52285,
 868165532,
 3920,
 -1,
 868354684,
 3919,
 868561869,
 867902784,
 -1,
 868627400,
 868494455,
 -1,
 -52281,
 868558748,
 3932,
 -1,
 868616828,
 3931,
 868824011,
 868558144,
 -1,
 -52278,
 868755356,
 3917,
 -1,
 868813436,
 3916,
 -52276,
 868755356,
 3922,
 -1,
 868944508,
 3921,
 869151698,
 868514818,
 -1,
 -52273,
 869110430,
 3913,
 -52272,
 869173146,
 3918,
 -52271,
 869204380,
 3908,
 -1,
 869272188,
 3923,
 869479382,
 869092119,
 -1,
 -52268,
 869426499,
 3941,
 -52267,
 869476252,
 3940,
 -1,
 869534332,
 3942,
 869741530,
 869425264,
 -1,
 -52264,
 869667296,
 3945,
 -52263,
 869738396,
 3905,
 -1,
 869796476,
 3904,
 870003677,
 869674103,
 -1,
 -52260,
 869935004,
 3934,
 -1,
 869993084,
 3935,
 870200288,
 869960908,
 -1,
 -52257,
 870131612,
 3925,
 -1,
 870189692,
 3924,
 870396899,
 870137669,
 -1,
 -52254,
 870328220,
 3907,
 -1,
 870386300,
 3906,
 870593510,
 870325301,
 -1,
 -52251,
 870524828,
 3910,
 -1,
 870582908,
 3909,
 870790121,
 870519665,
 -1,
 -52248,
 870721436,
 3927,
 -1,
 870779516,
 3926,
 -52246,
 870748830,
 3937,
 -52245,
 870925925,
 3933,
 -52244,
 871016764,
 3938,
 -52243,
 871052710,
 3928,
 -52242,
 871107034,
 3939,
 -52241,
 871200044,
 3911,
 -52240,
 871245724,
 3943,
 -52239,
 871325189,
 3946,
 -52238,
 871369340,
 3944,
 -1,
 871455813,
 3936,
 871694335,
 867834611,
 -1,
 -52235,
 871575251,
 3862,
 -1,
 871669620,
 3861,
 871838764,
 867784081,
 -1,
 871904258,
 871776069,
 -1,
 871969791,
 871857814,
 -1,
 872035326,
 871919490,
 -1,
 872100861,
 872003337,
 -1,
 -52228,
 872027634,
 3842,
 -1,
 872120936,
 3843,
 -1,
 872035183,
 3841,
 -1,
 871974932,
 3860,
 872480767,
 871916044,
 -1,
 -52223,
 872382849,
 3898,
 -1,
 872437298,
 3899,
 872625162,
 871832629,
 -1,
 872690696,
 872578859,
 -1,
 872756231,
 872614939,
 -1,
 -52218,
 872687823,
 3859,
 -1,
 872752973,
 3894,
 -1,
 872687098,
 3846,
 -52215,
 872643385,
 3845,
 -1,
 872961914,
 3896,
 873149457,
 872578050,
 -1,
 873214990,
 873098895,
 -1,
 -52211,
 873181321,
 3856,
 -1,
 873208151,
 3854,
 873463807,
 873154973,
 -1,
 -52208,
 873378958,
 3895,
 -1,
 873398355,
 3893,
 873608216,
 873075569,
 -1,
 873673751,
 873548567,
 -1,
 873739286,
 873619568,
 -1,
 -52203,
 873685475,
 3849,
 -1,
 873744756,
 4048,
 -1,
 873697222,
 3892,
 -1,
 873601904,
 3850,
 874066971,
 873564515,
 -1,
 -52198,
 874026383,
 3855,
 -1,
 874098836,
 3897,
 874263582,
 874007319,
 -1,
 -52195,
 874199473,
 3853,
 -1,
 874260512,
 3848,
 874460193,
 874190603,
 -1,
 -52192,
 874417304,
 3857,
 -1,
 874484547,
 3858,
 874656804,
 874401742,
 -1,
 -52189,
 874579279,
 3851,
 -1,
 874689308,
 3844,
 874853415,
 874620482,
 -1,
 -52186,
 874807681,
 3900,
 -1,
 874862130,
 3901,
 -52184,
 874805856,
 3847,
 -52183,
 874994381,
 3973,
 -52182,
 875046963,
 4049,
 -52181,
 875105287,
 3972,
 -1,
 875177618,
 3852,
 875377736,
 871801955,
 -1,
 875443259,
 875312836,
 -1,
 875508785,
 875409346,
 -1,
 -52176,
 875447916,
 3883,
 -1,
 875512751,
 3884,
 875705396,
 875449111,
 -1,
 -52173,
 875646815,
 3887,
 -1,
 875694149,
 3888,
 875902007,
 875640703,
 -1,
 -52170,
 875848628,
 3885,
 -1,
 875922620,
 3886,
 -52168,
 875831222,
 3891,
 -52167,
 876022312,
 3882,
 -52166,
 876127766,
 3890,
 -1,
 876166891,
 3889,
 876360766,
 875409346,
 -1,
 -52163,
 876299884,
 3874,
 -1,
 876364719,
 3875,
 876557377,
 876301079,
 -1,
 -52160,
 876498783,
 3878,
 -1,
 876546117,
 3879,
 876753988,
 876492671,
 -1,
 -52157,
 876700596,
 3876,
 -1,
 876774588,
 3877,
 -52155,
 876683190,
 3872,
 -52154,
 876874280,
 3873,
 -52153,
 876979734,
 3881,
 -1,
 877018859,
 3880,
 877212761,
 875319539,
 -1,
 877278286,
 877136267,
 -1,
 877343820,
 877205259,
 3958,
 -1,
 877270795,
 3959,
 877527039,
 877292125,
 3960,
 -1,
 877423197,
 3961,
 877605968,
 877246648,
 3956,
 -1,
 877574328,
 3957,
 877737042,
 877562577,
 3968,
 -1,
 877678475,
 3969,
 877868116,
 877671778,
 3964,
 -1,
 877802850,
 3965,
 877999190,
 877809547,
 3954,
 -1,
 877940619,
 3955,
 878130264,
 877932241,
 3962,
 -1,
 878063313,
 3963,
 -1,
 878086577,
 3953,
 878326878,
 877137046,
 -1,
 -52133,
 878266394,
 4035,
 -52132,
 878344833,
 4033,
 -52131,
 878406443,
 4032,
 -1,
 878452233,
 4034,
 878654563,
 878261479,
 -1,
 878720098,
 878594839,
 -1,
 -52127,
 878670276,
 3863,
 -1,
 878732025,
 3865,
 -1,
 878687339,
 3864,
 879034367,
 878578232,
 4030,
 -1,
 878945233,
 4031,
 879113380,
 860921175,
 -1,
 879178915,
 879066828,
 -1,
 879244433,
 879108820,
 -1,
 879309966,
 879168124,
 11568,
 879375469,
 879240512,
 11575,
 879441004,
 879306048,
 11577,
 -1,
 879376761,
 11578,
 -1,
 879376761,
 11576,
 879637616,
 879307895,
 11619,
 -52113,
 879570039,
 11621,
 -1,
 879638905,
 11594,
 879834227,
 879603650,
 11612,
 -52110,
 879800258,
 11615,
 -1,
 879835513,
 11613,
 880030838,
 879774487,
 11609,
 -52107,
 879971095,
 11610,
 -1,
 880032121,
 11611,
 880227449,
 879976560,
 11581,
 880345087,
 880163193,
 11589,
 -1,
 880228729,
 11583,
 880424060,
 880164677,
 11571,
 880541695,
 880359801,
 11606,
 -1,
 880425337,
 11572,
 880620670,
 880350987,
 11604,
 -1,
 880547595,
 11605,
 880751744,
 880556409,
 11584,
 -1,
 880687481,
 11587,
 880882818,
 880677745,
 11569,
 -1,
 880818553,
 11570,
 -52093,
 880812756,
 11618,
 -52092,
 880939320,
 11617,
 -52091,
 881002523,
 11616,
 -52090,
 881104417,
 11591,
 -52089,
 881167564,
 11602,
 -52088,
 881228802,
 11599,
 -52087,
 881292036,
 11598,
 -52086,
 881355357,
 11597,
 -52085,
 881416188,
 11574,
 -52084,
 881473407,
 11580,
 -52083,
 881532779,
 11614,
 -1,
 881592956,
 11588,
 -52081,
 879278264,
 11603,
 -52080,
 881741707,
 11593,
 -1,
 881812025,
 11579,
 881996957,
 879210434,
 -1,
 882062492,
 881962129,
 -1,
 882128021,
 882008176,
 11582,
 -1,
 882063737,
 11590,
 882259096,
 882065221,
 -1,
 -52073,
 882211842,
 11600,
 -1,
 882260345,
 11607,
 -52071,
 882181193,
 11596,
 -52070,
 882415137,
 11592,
 -52069,
 882464628,
 11601,
 -1,
 882522489,
 11586,
 -1,
 882007331,
 11620,
 882783392,
 881920826,
 -1,
 -52065,
 882726908,
 11573,
 -1,
 882784633,
 11585,
 883032063,
 882707068,
 -1,
 -52062,
 882923529,
 11608,
 -1,
 882996527,
 11595,
 -1,
 879143087,
 11631,
 883242155,
 879053168,
 126,
 883359743,
 883183780,
 8764,
 883425279,
 883252423,
 -1,
 883438762,
 883300924,
 -1,
 -52055,
 883407000,
 10859,
 -1,
 883463332,
 10858,
 -1,
 883364032,
 10610,
 883700910,
 883202977,
 -1,
 -52051,
 883657247,
 10709,
 -1,
 883702515,
 10708,
 -52049,
 883661669,
 8266,
 -52048,
 883840887,
 10750,
 -52047,
 883915267,
 10053,
 -1,
 883969672,
 10717,
 884159968,
 860818044,
 -1,
 884225368,
 884096837,
 -1,
 884290858,
 884169927,
 -1,
 884356340,
 884238941,
 -1,
 884421869,
 884282677,
 -1,
 884487378,
 884353954,
 -1,
 -52039,
 884419703,
 917626,
 -52038,
 884482772,
 917625,
 -52037,
 884545979,
 917624,
 -52036,
 884609336,
 917623,
 -52035,
 884672539,
 917622,
 -52034,
 884783288,
 917621,
 -52033,
 884846530,
 917620,
 -52032,
 884886295,
 917619,
 -52031,
 884938507,
 917618,
 -52030,
 885036577,
 917617,
 -52029,
 885099724,
 917616,
 -52028,
 885142882,
 917615,
 -52027,
 885226498,
 917614,
 -52026,
 885289732,
 917613,
 -52025,
 885353053,
 917612,
 -52024,
 885416048,
 917611,
 -52023,
 885479420,
 917610,
 -52022,
 885542795,
 917609,
 -52021,
 885602681,
 917608,
 -52020,
 885669701,
 917607,
 -52019,
 885733247,
 917606,
 -52018,
 885796561,
 917605,
 -52017,
 885859648,
 917604,
 -52016,
 885922869,
 917603,
 -52015,
 885986161,
 917602,
 -1,
 886049404,
 917601,
 886308863,
 884421102,
 -1,
 -52012,
 886189175,
 917594,
 -52011,
 886252244,
 917593,
 -52010,
 886315451,
 917592,
 -52009,
 886378808,
 917591,
 -52008,
 886442011,
 917590,
 -52007,
 886552760,
 917589,
 -52006,
 886616002,
 917588,
 -52005,
 886655767,
 917587,
 -52004,
 886707979,
 917586,
 -52003,
 886806049,
 917585,
 -52002,
 886869196,
 917584,
 -52001,
 886912354,
 917583,
 -52000,
 886995970,
 917582,
 -51999,
 887059204,
 917581,
 -51998,
 887122525,
 917580,
 -51997,
 887185520,
 917579,
 -51996,
 887248892,
 917578,
 -51995,
 887312267,
 917577,
 -51994,
 887372153,
 917576,
 -51993,
 887439173,
 917575,
 -51992,
 887502719,
 917574,
 -51991,
 887566033,
 917573,
 -51990,
 887629120,
 917572,
 -51989,
 887692341,
 917571,
 -51988,
 887755633,
 917570,
 -1,
 887818876,
 917569,
 888026355,
 884354769,
 -1,
 888091890,
 887984035,
 -1,
 -51984,
 888039051,
 917595,
 -51983,
 888107049,
 917544,
 -1,
 888178803,
 917627,
 -1,
 888033603,
 917564,
 -1,
 887989291,
 917599,
 888485124,
 884286784,
 -1,
 888550659,
 888443889,
 -1,
 888616185,
 888516546,
 -1,
 -51976,
 888555116,
 917554,
 -1,
 888619951,
 917555,
 888812796,
 888556311,
 -1,
 -51973,
 888754015,
 917558,
 -1,
 888801349,
 917559,
 889009407,
 888747903,
 -1,
 -51970,
 888955828,
 917556,
 -1,
 889029820,
 917557,
 -51968,
 888938422,
 917552,
 -51967,
 889129512,
 917553,
 -51966,
 889234966,
 917561,
 -1,
 889274091,
 917560,
 -1,
 888489513,
 917540,
 889533706,
 888411915,
 -1,
 889599241,
 889498190,
 -1,
 -51961,
 889546379,
 917597,
 -51960,
 889614377,
 917545,
 -1,
 889686131,
 917629,
 -1,
 889553082,
 917596,
 889926929,
 889461813,
 -1,
 889992464,
 889861474,
 -1,
 890057999,
 889927089,
 -1,
 -51954,
 890006919,
 917568,
 -1,
 890047100,
 917548,
 -1,
 889993218,
 917562,
 -1,
 889930263,
 917598,
 890385685,
 889867031,
 -1,
 -51949,
 890330814,
 917536,
 -51948,
 890391171,
 917551,
 -1,
 890460522,
 917563,
 890647833,
 890309244,
 -1,
 -51945,
 890596421,
 917546,
 -51944,
 890659239,
 917543,
 -1,
 890701068,
 917542,
 890909980,
 890574494,
 -1,
 -51941,
 890863110,
 917538,
 -1,
 890900471,
 917567,
 891106591,
 890866892,
 -1,
 -51938,
 891035674,
 917547,
 -1,
 891134573,
 917541,
 891303202,
 891029942,
 -1,
 -51935,
 891239535,
 917566,
 -1,
 891290901,
 917600,
 891499813,
 891236049,
 -1,
 -51932,
 891428495,
 917537,
 -1,
 891527846,
 917565,
 -51930,
 891431207,
 917628,
 -51929,
 891651872,
 917630,
 -51928,
 891710296,
 917539,
 -51927,
 891779005,
 917549,
 -1,
 891830775,
 917550,
 892024130,
 884242723,
 -1,
 892089662,
 891977420,
 -1,
 892155183,
 892042242,
 -1,
 -51922,
 892076444,
 5893,
 -1,
 892144252,
 5896,
 -51920,
 892113566,
 5900,
 -51919,
 892290661,
 5903,
 -51918,
 892385464,
 5890,
 -51917,
 892438958,
 5894,
 -51916,
 892495171,
 5904,
 -51915,
 892553046,
 5897,
 -51914,
 892614054,
 5899,
 -51913,
 892668378,
 5902,
 -51912,
 892772109,
 5891,
 -51911,
 892817291,
 5889,
 -51910,
 892872604,
 5905,
 -51909,
 892928412,
 5892,
 -51908,
 893010860,
 5895,
 -51907,
 893103575,
 5898,
 -1,
 893127292,
 5888,
 893334849,
 892031219,
 -1,
 -51904,
 893302968,
 5907,
 -1,
 893341579,
 5906,
 -1,
 893297540,
 5908,
 893648895,
 891960529,
 -1,
 893662549,
 893550284,
 -1,
 893728071,
 893615106,
 -1,
 -51898,
 893649308,
 5989,
 -1,
 893717116,
 5992,
 -51896,
 893686430,
 5996,
 -51895,
 893863525,
 5999,
 -51894,
 893958328,
 5986,
 -51893,
 894011822,
 5990,
 -51892,
 894068035,
 6000,
 -51891,
 894125910,
 5993,
 -51890,
 894186918,
 5995,
 -51889,
 894241242,
 5998,
 -51888,
 894344973,
 5987,
 -51887,
 894390155,
 5985,
 -51886,
 894435740,
 5988,
 -51885,
 894518188,
 5991,
 -51884,
 894610903,
 5994,
 -1,
 894634620,
 5984,
 894894079,
 893604083,
 -1,
 -51881,
 894810296,
 6003,
 -1,
 894848907,
 6002,
 895038900,
 884151712,
 -1,
 895104388,
 894992076,
 -1,
 895169889,
 895056898,
 -1,
 895235422,
 895122434,
 -1,
 -51875,
 895190938,
 2985,
 -1,
 895224444,
 2979,
 -51873,
 895193758,
 2974,
 -51872,
 895353244,
 2969,
 -1,
 895421052,
 2984,
 895628645,
 895093372,
 2949,
 -51869,
 895596728,
 2964,
 -51868,
 895635339,
 2960,
 -1,
 895683196,
 2950,
 895890793,
 895568663,
 -1,
 -51865,
 895837507,
 2999,
 -51864,
 895887260,
 2998,
 -1,
 895945340,
 3000,
 896152942,
 895838813,
 -1,
 896218477,
 896100957,
 -1,
 -51860,
 896141786,
 2996,
 -1,
 896207484,
 2995,
 -1,
 896141948,
 2994,
 896480624,
 896121016,
 2953,
 -1,
 896448696,
 2954,
 896611699,
 896446402,
 -1,
 -51854,
 896567726,
 2975,
 -1,
 896600700,
 2980,
 896808310,
 896538379,
 -1,
 -51851,
 896772412,
 2993,
 -1,
 896797308,
 2992,
 897004920,
 896742754,
 2962,
 -1,
 896939362,
 2963,
 897135994,
 896946059,
 2951,
 -1,
 897077131,
 2952,
 897267068,
 897068753,
 2958,
 -1,
 897199825,
 2959,
 -51843,
 897225374,
 2991,
 -51842,
 897327706,
 2997,
 -51841,
 897402710,
 2986,
 -51840,
 897463718,
 2990,
 -51839,
 897556237,
 2965,
 -51838,
 897611052,
 2972,
 -51837,
 897656732,
 3001,
 -1,
 897720198,
 2970,
 897922453,
 895034688,
 -1,
 897987987,
 897881073,
 -1,
 898053513,
 897953730,
 -1,
 -51832,
 897992300,
 3048,
 -1,
 898057135,
 3049,
 898250124,
 897993495,
 -1,
 -51829,
 898191199,
 3052,
 -1,
 898238533,
 3053,
 898446735,
 898185087,
 -1,
 -51826,
 898393012,
 3050,
 -1,
 898467004,
 3051,
 -51824,
 898375606,
 3046,
 -51823,
 898566696,
 3047,
 -51822,
 898672150,
 3055,
 -1,
 898711275,
 3054,
 -51820,
 897923122,
 3062,
 -1,
 898836600,
 3059,
 899036578,
 897863923,
 -1,
 899102106,
 898959996,
 -1,
 -51816,
 899070136,
 3020,
 -51815,
 899108747,
 3016,
 -1,
 899156604,
 3006,
 899364252,
 899070136,
 3009,
 -1,
 899332280,
 3010,
 899495326,
 899298658,
 3018,
 -1,
 899429730,
 3019,
 899626400,
 899436427,
 3007,
 -1,
 899567499,
 3008,
 899809279,
 899559121,
 3014,
 -1,
 899690193,
 3015,
 899888552,
 898979825,
 -1,
 899954086,
 899833884,
 -1,
 -51803,
 899888419,
 3058,
 -1,
 899947345,
 3057,
 -51801,
 899891164,
 3056,
 -1,
 900077978,
 3066,
 900281773,
 899841228,
 -1,
 900347308,
 900211304,
 -1,
 -51797,
 900280879,
 2947,
 -1,
 900346402,
 3021,
 -1,
 900275543,
 2946,
 900609456,
 900205180,
 -1,
 -51793,
 900551018,
 3031,
 -1,
 900639763,
 3064,
 -51791,
 900547053,
 3061,
 -51790,
 900767537,
 3065,
 -51789,
 900833969,
 3060,
 -1,
 900859790,
 3063,
 901068254,
 894978674,
 -1,
 901133761,
 901033922,
 -1,
 901199292,
 901067241,
 -1,
 -51784,
 901145522,
 6516,
 -51783,
 901208667,
 6515,
 -51782,
 901272096,
 6514,
 -51781,
 901335499,
 6513,
 -1,
 901398964,
 6512,
 901592511,
 901139223,
 -1,
 -51778,
 901523356,
 6497,
 -1,
 901581436,
 6483,
 -51776,
 901523356,
 6487,
 -1,
 901712508,
 6486,
 901920196,
 901066449,
 6507,
 -51773,
 901855609,
 6502,
 -1,
 901918417,
 6501,
 902116807,
 901843580,
 6499,
 -51770,
 902075939,
 6508,
 -1,
 902123403,
 6509,
 902313417,
 902084792,
 6503,
 -1,
 902246097,
 6506,
 902444492,
 902270156,
 -1,
 -51765,
 902375324,
 6490,
 -1,
 902433404,
 6489,
 902641102,
 902378850,
 6505,
 -1,
 902575458,
 6504,
 902772177,
 902593538,
 -1,
 -51760,
 902693276,
 6482,
 -1,
 902761084,
 6498,
 902968788,
 902717552,
 -1,
 -51757,
 902899612,
 6496,
 -1,
 902957692,
 6480,
 -51755,
 902927006,
 6485,
 -51754,
 903114684,
 6481,
 -51753,
 903160410,
 6493,
 -51752,
 903243075,
 6484,
 -51751,
 903288577,
 6495,
 -51750,
 903361958,
 6491,
 -51749,
 903416282,
 6488,
 -51748,
 903499659,
 6500,
 -51747,
 903554972,
 6494,
 -1,
 903647710,
 6492,
 -51745,
 901028893,
 9801,
 -1,
 903767529,
 9991,
 903952074,
 884092625,
 -1,
 904017489,
 903899741,
 -1,
 904083021,
 903964591,
 -1,
 904148521,
 904006085,
 -1,
 904214056,
 904099767,
 -1,
 904279532,
 904136731,
 -1,
 904345067,
 904231970,
 -1,
 904410601,
 904271627,
 3083,
 -1,
 904337163,
 3168,
 904593407,
 904358493,
 3084,
 -1,
 904489565,
 3169,
 -1,
 904268412,
 3125,
 904738290,
 904245186,
 -1,
 904803824,
 904703938,
 -1,
 -51729,
 904734620,
 3104,
 -1,
 904792700,
 3103,
 -51727,
 904734620,
 3109,
 -1,
 904923772,
 3108,
 905131511,
 904690690,
 -1,
 -51724,
 905089694,
 3102,
 -51723,
 905152410,
 3107,
 -51722,
 905183644,
 3097,
 -1,
 905251452,
 3112,
 905459197,
 905061696,
 -1,
 905524731,
 905389376,
 -1,
 -51718,
 905455516,
 3106,
 -1,
 905513596,
 3105,
 -51716,
 905455516,
 3111,
 -1,
 905644668,
 3110,
 905852417,
 905382524,
 3077,
 -51713,
 905820344,
 3092,
 -51712,
 905858955,
 3088,
 -1,
 905906812,
 3078,
 906114565,
 905792279,
 -1,
 -51709,
 906061123,
 3127,
 -51708,
 906110876,
 3126,
 -1,
 906168956,
 3128,
 906376711,
 906082488,
 3081,
 -1,
 906344632,
 3082,
 906507786,
 906303243,
 -1,
 -51703,
 906471740,
 3121,
 -1,
 906496636,
 3120,
 906704397,
 906464460,
 -1,
 -51700,
 906635164,
 3115,
 -1,
 906693244,
 3114,
 906901007,
 906638690,
 3090,
 -1,
 906835298,
 3091,
 907032082,
 906848861,
 -1,
 -51695,
 906955226,
 3123,
 -1,
 907020924,
 3122,
 907228693,
 906977392,
 -1,
 -51692,
 907159452,
 3094,
 -1,
 907217532,
 3093,
 907425304,
 907171836,
 -1,
 -51689,
 907356060,
 3101,
 -1,
 907414140,
 3100,
 907621914,
 907366283,
 3079,
 -1,
 907562891,
 3080,
 907752989,
 907558725,
 -1,
 -51684,
 907683740,
 3096,
 -1,
 907741820,
 3095,
 907949599,
 907685585,
 3086,
 -1,
 907882193,
 3087,
 908080674,
 907877429,
 -1,
 -51679,
 908011420,
 3099,
 -1,
 908069500,
 3098,
 908277285,
 908006257,
 -1,
 -51676,
 908208028,
 3117,
 -1,
 908266108,
 3116,
 -51674,
 908235422,
 3119,
 -51673,
 908408230,
 3118,
 -1,
 908470172,
 3129,
 -1,
 904138409,
 3157,
 908736056,
 904089843,
 -1,
 908801582,
 908659324,
 -1,
 -51668,
 908769464,
 3148,
 -51667,
 908808075,
 3144,
 -1,
 908855932,
 3134,
 909063728,
 908738139,
 3139,
 -1,
 908990219,
 3140,
 909194802,
 909031608,
 3137,
 -1,
 909162680,
 3138,
 909325876,
 909129058,
 3146,
 -1,
 909260130,
 3147,
 909456950,
 909266827,
 3135,
 -1,
 909397899,
 3136,
 909639679,
 909389521,
 3142,
 -1,
 909520593,
 3143,
 909719110,
 908698723,
 -1,
 909784636,
 909684674,
 -1,
 -51653,
 909723244,
 3176,
 -1,
 909788079,
 3177,
 909981247,
 909724439,
 -1,
 -51650,
 909922143,
 3180,
 -1,
 909969477,
 3181,
 910177858,
 909916031,
 -1,
 -51647,
 910123956,
 3178,
 -1,
 910197948,
 3179,
 -51645,
 910106550,
 3174,
 -51644,
 910297640,
 3175,
 -51643,
 910403094,
 3183,
 -1,
 910442219,
 3182,
 910636620,
 909671628,
 -1,
 910702154,
 910565992,
 -1,
 -51639,
 910635567,
 3075,
 -1,
 910701090,
 3149,
 -51637,
 910650534,
 3073,
 -1,
 910826839,
 3074,
 -1,
 910587567,
 3158,
 911147007,
 904015976,
 -1,
 -51633,
 911022490,
 8481,
 -51632,
 911101767,
 8981,
 -1,
 911181498,
 9990,
 911357639,
 903964962,
 -1,
 911423076,
 911285301,
 -1,
 911488605,
 911357282,
 -1,
 911554138,
 911440898,
 -1,
 911619673,
 911519682,
 -1,
 -51625,
 911556844,
 119563,
 -51624,
 911617007,
 119582,
 -1,
 911686812,
 119573,
 -1,
 911587548,
 119608,
 911998975,
 911485332,
 -1,
 -51620,
 911901147,
 119634,
 -1,
 911978819,
 119630,
 912143970,
 911411322,
 -1,
 912209505,
 912076497,
 -1,
 -51616,
 912143393,
 119590,
 -1,
 912200262,
 119613,
 -1,
 912157218,
 119631,
 -51613,
 912068497,
 119585,
 -1,
 912423731,
 119558,
 912602738,
 911353152,
 -1,
 912668267,
 912543627,
 -1,
 912733801,
 912618244,
 -1,
 -51608,
 912700800,
 119625,
 -1,
 912722068,
 119612,
 -51606,
 912683451,
 119568,
 -1,
 912880955,
 119636,
 913061487,
 912600785,
 -1,
 -51603,
 913017801,
 119623,
 -51602,
 913057767,
 119567,
 -1,
 913141854,
 119586,
 -51600,
 913006346,
 119584,
 -51599,
 913262463,
 119619,
 -1,
 913334189,
 119624,
 913520251,
 912535249,
 -1,
 913585783,
 913472514,
 -1,
 -51595,
 913545842,
 119603,
 -51594,
 913609142,
 119583,
 -1,
 913678996,
 119600,
 -51592,
 913512652,
 119626,
 -51591,
 913789775,
 119610,
 -51590,
 913857447,
 119618,
 -1,
 913940047,
 119580,
 914110085,
 913446667,
 -1,
 914175620,
 914042577,
 -1,
 914241154,
 914115351,
 -1,
 914306689,
 914182027,
 -1,
 -51584,
 914274399,
 119579,
 -1,
 914335278,
 119596,
 -1,
 914235651,
 119598,
 -51581,
 914174742,
 119578,
 -1,
 914523668,
 119572,
 -1,
 914108956,
 119605,
 914765454,
 914044799,
 -1,
 914830985,
 914733250,
 -1,
 -51576,
 914764833,
 119595,
 -1,
 914847924,
 119559,
 915027596,
 914765154,
 -1,
 -51573,
 914993217,
 119638,
 -1,
 915050778,
 119576,
 -51571,
 914990402,
 119606,
 -1,
 915187210,
 119632,
 915355286,
 914705175,
 -1,
 915420820,
 915320770,
 -1,
 915486355,
 915354978,
 -1,
 -51566,
 915415645,
 119601,
 -1,
 915479271,
 119628,
 -1,
 915417610,
 119593,
 -51563,
 915375671,
 119621,
 -1,
 915693075,
 119627,
 915879580,
 915291973,
 -1,
 915945113,
 915824901,
 119592,
 -1,
 915873201,
 119615,
 -51558,
 915911868,
 119614,
 -51557,
 916007947,
 119602,
 -1,
 916103815,
 119599,
 916272802,
 915836108,
 -1,
 916338336,
 916195964,
 -1,
 -51553,
 916302347,
 119604,
 -1,
 916359817,
 119588,
 -51551,
 916291981,
 119594,
 -1,
 916491046,
 119571,
 916666023,
 916195964,
 -1,
 -51548,
 916632868,
 119564,
 -51547,
 916673659,
 119633,
 -51546,
 916739823,
 119577,
 -1,
 916798998,
 119617,
 916993707,
 916615940,
 -1,
 -51543,
 916957713,
 119560,
 -51542,
 917024874,
 119609,
 -1,
 917076934,
 119616,
 917255856,
 916941405,
 -1,
 917321391,
 917179004,
 -1,
 -51538,
 917268371,
 119597,
 -1,
 917351514,
 119637,
 -1,
 917247843,
 119589,
 917583540,
 917181297,
 -1,
 -51534,
 917527083,
 119566,
 -51533,
 917603839,
 119587,
 -1,
 917658860,
 119561,
 917845687,
 917522021,
 -1,
 -51530,
 917797052,
 119620,
 -1,
 917853720,
 119575,
 918042298,
 917779810,
 -1,
 -51527,
 917982074,
 119565,
 -1,
 918068650,
 119635,
 918238909,
 917987440,
 -1,
 -51524,
 918161389,
 119591,
 -1,
 918267251,
 119562,
 918435520,
 918179790,
 -1,
 -51521,
 918390387,
 119622,
 -1,
 918427942,
 119570,
 918632131,
 918370681,
 -1,
 -51518,
 918570195,
 119574,
 -1,
 918632321,
 119629,
 -51516,
 918556439,
 119569,
 -51515,
 918777930,
 119607,
 -51514,
 918816756,
 119611,
 -1,
 918883646,
 119581,
 919142399,
 911302990,
 -1,
 -51511,
 919022287,
 10043,
 -1,
 919106659,
 10170,
 919287717,
 903887225,
 -1,
 919353232,
 919210620,
 -1,
 919418700,
 919293764,
 -1,
 919484222,
 919346229,
 -1,
 919549757,
 919408222,
 -1,
 919615206,
 919489303,
 -1,
 919680736,
 919575111,
 -1,
 919746264,
 919603836,
 3632,
 919811797,
 919714200,
 -1,
 -51500,
 919760751,
 3651,
 -1,
 919843802,
 3652,
 -51498,
 919761668,
 3635,
 -51497,
 919940817,
 3649,
 -1,
 919997052,
 3634,
 920205020,
 919713976,
 3640,
 920270555,
 920137425,
 3638,
 -1,
 920202961,
 3639,
 -1,
 920238264,
 3641,
 920467166,
 920145803,
 3636,
 -1,
 920407947,
 3637,
 -51489,
 920401250,
 3650,
 -1,
 920530641,
 3648,
 920780799,
 919633861,
 -1,
 920794853,
 920668951,
 -1,
 -51485,
 920761249,
 3626,
 -51484,
 920794466,
 3595,
 -1,
 920882917,
 3624,
 -1,
 920761199,
 3625,
 921122549,
 919580610,
 -1,
 921188082,
 921057657,
 -1,
 921253617,
 921141189,
 -1,
 921319151,
 921195137,
 -1,
 921384685,
 921242236,
 -1,
 -51476,
 921336834,
 3600,
 -1,
 921388997,
 3607,
 -51474,
 921345755,
 3606,
 -1,
 921504289,
 3608,
 -51472,
 921267099,
 3602,
 -1,
 921654314,
 3601,
 -1,
 921218467,
 3660,
 921960447,
 921141189,
 -1,
 -51468,
 921853250,
 3605,
 -1,
 921942407,
 3599,
 922105601,
 921072388,
 -1,
 922171136,
 922047681,
 -1,
 922236670,
 922115271,
 -1,
 922302203,
 922202050,
 -1,
 -51462,
 922237944,
 3658,
 -1,
 922298216,
 3657,
 -51460,
 922228901,
 3633,
 -51459,
 922447035,
 3656,
 -1,
 922484957,
 3659,
 -51457,
 922182322,
 3654,
 -1,
 922628288,
 3655,
 -1,
 922101296,
 3617,
 922892044,
 922050672,
 -1,
 922957579,
 922822504,
 -1,
 923023114,
 922901703,
 -1,
 923088649,
 922984238,
 -1,
 -51450,
 923028647,
 3588,
 -51449,
 923099848,
 3587,
 -51448,
 923173249,
 3589,
 -1,
 923227329,
 3586,
 -1,
 923049021,
 3590,
 -1,
 922983763,
 3675,
 -1,
 922922053,
 3585,
 923612950,
 922848460,
 -1,
 923678484,
 923548025,
 -1,
 923744019,
 923631557,
 -1,
 923809554,
 923706932,
 -1,
 -51439,
 923770587,
 3612,
 -1,
 923830783,
 3614,
 -1,
 923762341,
 3616,
 -1,
 923675257,
 3642,
 -51435,
 923622440,
 3611,
 -1,
 924090328,
 3631,
 924268316,
 923565058,
 -1,
 924333850,
 924234955,
 -1,
 -51431,
 924301496,
 3609,
 -1,
 924347570,
 3603,
 -51429,
 924272625,
 3661,
 -1,
 924456345,
 3591,
 924661538,
 924215901,
 -1,
 924727072,
 924614597,
 -1,
 -51425,
 924666117,
 3621,
 -1,
 924727617,
 3628,
 -51423,
 924694712,
 3622,
 -1,
 924865419,
 3653,
 925054759,
 924599260,
 -1,
 925120293,
 925010431,
 3592,
 -1,
 925056837,
 3594,
 -51418,
 925073840,
 3596,
 -1,
 925185568,
 3593,
 925382444,
 924984020,
 -1,
 925447979,
 925318046,
 -1,
 -51414,
 925382176,
 3597,
 -1,
 925455580,
 3618,
 -1,
 925374660,
 3662,
 925710128,
 925340254,
 -1,
 925775663,
 925674488,
 3613,
 -1,
 925727746,
 3615,
 -1,
 925701326,
 3663,
 925972275,
 925636363,
 -1,
 -51406,
 925939896,
 3620,
 -1,
 925988487,
 3619,
 926168886,
 925904404,
 -1,
 -51403,
 926124076,
 3630,
 -1,
 926192929,
 3627,
 926365497,
 926093469,
 -1,
 -51400,
 926319309,
 3604,
 -1,
 926383675,
 3598,
 -51398,
 926332268,
 3623,
 -51397,
 926494545,
 3629,
 -51396,
 926573246,
 3610,
 -1,
 926635498,
 3674,
 -1,
 919504161,
 3647,
 926941183,
 919446627,
 -1,
 926955330,
 926855106,
 -1,
 -51391,
 926893676,
 3666,
 -1,
 926958511,
 3667,
 927151941,
 926894871,
 -1,
 -51388,
 927092575,
 3670,
 -1,
 927139909,
 3671,
 927348552,
 927086463,
 -1,
 -51385,
 927294388,
 3668,
 -1,
 927368380,
 3669,
 -51383,
 927276982,
 3664,
 -51382,
 927468072,
 3665,
 -51381,
 927573526,
 3673,
 -1,
 927612651,
 3672,
 927858687,
 919371285,
 -1,
 927872898,
 927760076,
 -1,
 927938388,
 927838146,
 -1,
 928003921,
 927877074,
 1932,
 -1,
 927926837,
 1947,
 -51374,
 927961046,
 1944,
 -51373,
 928068962,
 1952,
 -1,
 928146470,
 1939,
 928331610,
 927877911,
 -1,
 928397144,
 928266617,
 -1,
 -51369,
 928353552,
 1949,
 -1,
 928408614,
 1921,
 -51367,
 928353552,
 1936,
 -1,
 928545718,
 1950,
 928724831,
 928263287,
 -1,
 928790366,
 928647804,
 -1,
 -51363,
 928715678,
 1938,
 -1,
 928778876,
 1948,
 -1,
 928724322,
 1953,
 929052515,
 928661317,
 -1,
 -51359,
 928978756,
 1935,
 -51358,
 929061453,
 1955,
 -1,
 929128866,
 1934,
 929314664,
 928982336,
 -1,
 929380199,
 929237628,
 -1,
 -51354,
 929305502,
 1937,
 -1,
 929376857,
 1951,
 -1,
 929315399,
 1931,
 929642347,
 929266690,
 -1,
 -51350,
 929590262,
 1922,
 -1,
 929663409,
 1969,
 929838958,
 929589853,
 -1,
 -51347,
 929780825,
 1925,
 -1,
 929841538,
 1933,
 930035569,
 929783920,
 -1,
 -51344,
 929974226,
 1946,
 -1,
 930046370,
 1926,
 930232180,
 929970553,
 -1,
 -51341,
 930170834,
 1945,
 -1,
 930253233,
 1920,
 930428791,
 930155132,
 -1,
 -51338,
 930374447,
 1927,
 -1,
 930428340,
 1954,
 -51336,
 930354148,
 1940,
 -51335,
 930591310,
 1957,
 -51334,
 930633914,
 1928,
 -51333,
 930715794,
 1923,
 -51332,
 930788479,
 1956,
 -51331,
 930834043,
 1941,
 -51330,
 930918938,
 1929,
 -51329,
 930943804,
 1942,
 -51328,
 931036490,
 1930,
 -51327,
 931088217,
 1943,
 -1,
 931150063,
 1924,
 931346310,
 927806818,
 -1,
 -51324,
 931298881,
 1963,
 -51323,
 931344146,
 1966,
 -1,
 931436959,
 1967,
 931608458,
 931278545,
 -1,
 -51320,
 931548143,
 1965,
 -51319,
 931603427,
 1961,
 -1,
 931692642,
 1964,
 931870605,
 931531388,
 -1,
 -51316,
 931826911,
 1958,
 -1,
 931880444,
 1959,
 -51314,
 931834955,
 1962,
 -51313,
 932008635,
 1968,
 -1,
 932060807,
 1960,
 932263836,
 919298859,
 -1,
 932329367,
 932207815,
 -1,
 932394901,
 932259136,
 -1,
 -51308,
 932360098,
 8278,
 -1,
 932381729,
 10176,
 -51306,
 932340505,
 8694,
 -1,
 932536434,
 10870,
 932773887,
 932255116,
 -1,
 932788123,
 932660673,
 -1,
 -51302,
 932748986,
 10146,
 -1,
 932782115,
 10147,
 -1,
 932731846,
 8196,
 933050275,
 932212042,
 -1,
 933115810,
 932982481,
 -1,
 933181345,
 933059783,
 -1,
 -51296,
 933121920,
 8707,
 -1,
 933194450,
 8708,
 -1,
 933104355,
 8756,
 -1,
 933053143,
 10727,
 -51292,
 932983698,
 9736,
 -1,
 933434736,
 8201,
 933640145,
 919213835,
 -1,
 933705677,
 933580683,
 -1,
 933771194,
 933638796,
 -1,
 933836717,
 933701192,
 -1,
 -51286,
 933773612,
 10997,
 -51285,
 933831850,
 8874,
 -51284,
 933895317,
 10624,
 -1,
 933979320,
 10996,
 934164400,
 933792972,
 -1,
 -51281,
 934109355,
 8244,
 -1,
 934178353,
 10747,
 934361011,
 934119230,
 -1,
 -51278,
 934299696,
 10999,
 -1,
 934384076,
 11000,
 934557622,
 934283470,
 -1,
 -51275,
 934499789,
 10857,
 -1,
 934569764,
 10856,
 -51273,
 934512416,
 8779,
 -51272,
 934679218,
 11003,
 -51271,
 934783351,
 8749,
 -1,
 934847658,
 10998,
 935016388,
 933723346,
 -1,
 935081918,
 934940984,
 -1,
 -51267,
 935015960,
 9780,
 -1,
 935069718,
 9781,
 -51265,
 935018640,
 9779,
 -51264,
 935214638,
 9782,
 -51263,
 935279888,
 9777,
 -51262,
 935340000,
 9776,
 -51261,
 935418580,
 9778,
 -1,
 935495462,
 9783,
 935671756,
 934967783,
 -1,
 935737291,
 935594437,
 -1,
 935802826,
 935669188,
 -1,
 -51256,
 935724605,
 10699,
 -51255,
 935824772,
 10701,
 -1,
 935892132,
 10698,
 -1,
 935745873,
 10141,
 -1,
 935696597,
 8227,
 -1,
 935613636,
 8285,
 936261584,
 933628540,
 -1,
 -51249,
 936223553,
 10971,
 -1,
 936258826,
 8482,
 -1,
 936220195,
 8872,
 936523744,
 933564728,
 -1,
 936589279,
 936476613,
 -1,
 936654806,
 936526466,
 -1,
 -51243,
 936606864,
 10760,
 -1,
 936666616,
 10759,
 936851417,
 936601722,
 -1,
 -51240,
 936804880,
 10838,
 -1,
 936868323,
 10837,
 937048028,
 936814097,
 -1,
 -51237,
 936972515,
 8282,
 -1,
 937067485,
 8229,
 -51235,
 937008894,
 10697,
 -51234,
 937189490,
 10869,
 -1,
 937252484,
 8273,
 -1,
 936523082,
 10041,
 937506799,
 936457570,
 -1,
 937572334,
 937469647,
 -1,
 937637862,
 937525053,
 -1,
 937703397,
 937596261,
 10554,
 -1,
 937651017,
 10557,
 -1,
 937642826,
 10556,
 937900009,
 937587672,
 -1,
 -51224,
 937865740,
 8974,
 -1,
 937921345,
 8989,
 938096620,
 937866811,
 -1,
 -51221,
 938062348,
 8975,
 -1,
 938117953,
 8988,
 -51219,
 938043019,
 9140,
 -1,
 938221230,
 8992,
 -1,
 937537368,
 9008,
 938541055,
 937474232,
 -1,
 938555387,
 938451122,
 -1,
 938620917,
 938506002,
 -1,
 -51213,
 938549972,
 8516,
 -51212,
 938633821,
 8514,
 -1,
 938688325,
 8513,
 938883064,
 938543740,
 -1,
 -51209,
 938826946,
 10658,
 -1,
 938870028,
 8523,
 -51207,
 938814272,
 8985,
 -51206,
 939006849,
 8489,
 -1,
 939082948,
 8498,
 -1,
 938521137,
 8366,
 939342945,
 860764537,
 -1,
 939408002,
 939264636,
 -1,
 939473382,
 939359234,
 -1,
 939538893,
 939409221,
 -1,
 939604411,
 939505694,
 -1,
 939669700,
 939546620,
 -1,
 939735154,
 939611126,
 -1,
 939800607,
 939658998,
 4527,
 939917311,
 939726220,
 -1,
 939931660,
 939822284,
 -1,
 939997194,
 939866807,
 4530,
 940113919,
 939922828,
 -1,
 -51191,
 940015925,
 4563,
 -1,
 940049732,
 4564,
 -51189,
 939932799,
 4533,
 -1,
 940217127,
 4567,
 940390417,
 939876464,
 -1,
 940455951,
 940312306,
 4528,
 -1,
 940404431,
 4556,
 -51184,
 940414883,
 4568,
 -1,
 940549789,
 4565,
 940718101,
 940355522,
 -1,
 940783636,
 940641824,
 4558,
 -1,
 940746853,
 4559,
 -1,
 940705854,
 4532,
 940980249,
 940646415,
 4529,
 941096959,
 940905868,
 -1,
 -51176,
 940998965,
 4562,
 -1,
 941056952,
 4561,
 941242396,
 940919575,
 -1,
 -51173,
 941173319,
 4566,
 -1,
 941264136,
 4531,
 -51171,
 941179082,
 4569,
 -51170,
 941403944,
 4557,
 -1,
 941425988,
 4534,
 941635627,
 939739927,
 -1,
 941701158,
 941591816,
 4538,
 941817855,
 941626764,
 -1,
 -51165,
 941710587,
 4584,
 -51164,
 941756150,
 4585,
 -51163,
 941848491,
 4586,
 -1,
 941908920,
 4583,
 942145535,
 941662408,
 -1,
 -51160,
 942047541,
 4539,
 -51159,
 942083830,
 4560,
 -51158,
 942171064,
 4521,
 -1,
 942224946,
 4590,
 942422071,
 941563919,
 4535,
 942538751,
 942347660,
 -1,
 942553136,
 942426903,
 -1,
 -51153,
 942484039,
 4574,
 -1,
 942574856,
 4573,
 942749747,
 942509260,
 -1,
 -51150,
 942684855,
 4572,
 -1,
 942773031,
 4575,
 -51148,
 942673654,
 4571,
 -51147,
 942891960,
 4570,
 -51146,
 942933316,
 4577,
 -1,
 943016621,
 4576,
 943208513,
 942378188,
 -1,
 943274046,
 943143607,
 4536,
 943390719,
 943199628,
 -1,
 -51141,
 943292725,
 4537,
 -51140,
 943329014,
 4579,
 -51139,
 943425455,
 4580,
 -1,
 943457604,
 4581,
 943667264,
 943209599,
 4545,
 -1,
 943631365,
 4595,
 -1,
 943624999,
 4587,
 943863883,
 943173416,
 4523,
 943980543,
 943789452,
 -1,
 943994950,
 943894466,
 -1,
 -51131,
 943918624,
 4550,
 -1,
 943982654,
 4553,
 -51129,
 943948085,
 4551,
 -51128,
 944140307,
 4552,
 -51127,
 944202680,
 4549,
 -51126,
 944244036,
 4525,
 -1,
 944332731,
 4524,
 944519255,
 943808624,
 -1,
 944584785,
 944441074,
 4520,
 944701439,
 944510348,
 -1,
 944715856,
 944603445,
 4522,
 -1,
 944678663,
 4548,
 -1,
 944639734,
 4547,
 944912470,
 944541374,
 -1,
 944978005,
 944868556,
 -1,
 -51116,
 944913079,
 4582,
 -1,
 944979071,
 4596,
 -1,
 944906255,
 4578,
 -1,
 944871331,
 4543,
 945305693,
 944440644,
 4546,
 945422335,
 945231244,
 -1,
 -51110,
 945295094,
 4598,
 -51109,
 945387435,
 4600,
 -51108,
 945467176,
 4597,
 -1,
 945496079,
 4599,
 945698915,
 945263811,
 -1,
 945764450,
 945665413,
 4592,
 945881087,
 945689996,
 -1,
 -51103,
 945783093,
 4593,
 -1,
 945844243,
 4594,
 -1,
 945695293,
 4601,
 946092137,
 945663938,
 -1,
 946157672,
 946015776,
 4526,
 946274303,
 946083212,
 -1,
 -51097,
 946147062,
 4555,
 -1,
 946234296,
 4554,
 -1,
 946079806,
 4544,
 946485359,
 946026034,
 4540,
 946601983,
 946410892,
 -1,
 946616430,
 946495600,
 -1,
 -51091,
 946538226,
 4588,
 -1,
 946640803,
 4591,
 -1,
 946577066,
 4589,
 946929663,
 946412597,
 -1,
 -51087,
 946813543,
 4541,
 -1,
 946877341,
 4542,
 947126271,
 939661414,
 -1,
 947140753,
 947004116,
 -1,
 947206269,
 947108024,
 4466,
 947322879,
 947131788,
 -1,
 947337336,
 947229891,
 4498,
 -1,
 947271010,
 4497,
 947468410,
 947269329,
 4496,
 -1,
 947402082,
 4495,
 -51077,
 947435704,
 4499,
 -51076,
 947539851,
 4500,
 -1,
 947587708,
 4494,
 947796101,
 947139938,
 4461,
 947912703,
 947721612,
 -1,
 947927171,
 947790548,
 -1,
 947992706,
 947849852,
 4484,
 -1,
 947924689,
 4485,
 -1,
 947931541,
 4486,
 -51068,
 947860834,
 4487,
 -1,
 948129675,
 4488,
 948320394,
 947728081,
 4456,
 948436991,
 948254050,
 4455,
 948502527,
 948311436,
 -1,
 -51063,
 948418744,
 4478,
 -1,
 948450658,
 4477,
 948648079,
 948243068,
 4451,
 948713614,
 948573580,
 -1,
 -51059,
 948671649,
 4473,
 -1,
 948712802,
 4472,
 -1,
 948645585,
 4452,
 949026815,
 948588427,
 4468,
 -1,
 948911961,
 4503,
 949106843,
 947072721,
 4454,
 949172375,
 949040482,
 4453,
 949288959,
 949097868,
 -1,
 -51051,
 949205176,
 4475,
 -51050,
 949237090,
 4474,
 -1,
 949316926,
 4476,
 949551103,
 949139640,
 4467,
 949616639,
 949425548,
 -1,
 -51046,
 949532856,
 4501,
 -1,
 949579070,
 4502,
 949762213,
 949029500,
 4449,
 949827745,
 949689586,
 4510,
 949944319,
 949753228,
 -1,
 -51041,
 949860536,
 4512,
 -51040,
 949899147,
 4513,
 -1,
 949963157,
 4511,
 950155428,
 949753228,
 -1,
 -51037,
 950122680,
 4471,
 -1,
 950154594,
 4470,
 -1,
 950087377,
 4450,
 950417581,
 949695842,
 4457,
 950483116,
 950343052,
 -1,
 950548649,
 950415057,
 4480,
 -1,
 950482274,
 4479,
 -51030,
 950506691,
 4481,
 -51029,
 950646968,
 4483,
 -1,
 950678882,
 4482,
 -1,
 950415057,
 4460,
 950941877,
 950357899,
 4469,
 951058431,
 950867340,
 -1,
 951072945,
 950930044,
 4504,
 -1,
 951000306,
 4509,
 -51022,
 951030430,
 4505,
 -51021,
 951171256,
 4507,
 -51020,
 951203170,
 4506,
 -1,
 951283006,
 4508,
 951466172,
 950909112,
 4462,
 951582719,
 951391628,
 -1,
 951597241,
 951454332,
 4489,
 -1,
 951529169,
 4490,
 -51014,
 951555267,
 4492,
 -51013,
 951695544,
 4493,
 -1,
 951719239,
 4491,
 951924930,
 951390520,
 -1,
 951990463,
 951856849,
 4464,
 -1,
 951924066,
 4463,
 952121537,
 951913084,
 4458,
 -1,
 952053457,
 4459,
 -1,
 952061835,
 4465,
 -51005,
 951883835,
 4514,
 -1,
 952259742,
 4448,
 952449337,
 939622092,
 -1,
 952514778,
 952378068,
 -1,
 952580301,
 952446673,
 12630,
 952645835,
 952546693,
 12673,
 952762367,
 952571276,
 -1,
 -50998,
 952664373,
 12674,
 -1,
 952725523,
 12675,
 952958975,
 952579426,
 12629,
 -1,
 952863141,
 12678,
 953039058,
 952547512,
 12640,
 953155583,
 952964492,
 -1,
 953170129,
 953062595,
 12683,
 -1,
 953103714,
 12682,
 -1,
 953110411,
 12684,
 953366743,
 952972642,
 12635,
 953483263,
 953292172,
 -1,
 953497814,
 953389726,
 12679,
 -1,
 953429713,
 12680,
 -1,
 953438091,
 12681,
 953694425,
 953289340,
 12625,
 -1,
 953626321,
 12626,
 -1,
 953634699,
 12642,
 953891051,
 952453911,
 -1,
 953956580,
 953852104,
 -1,
 -50979,
 953900283,
 12600,
 -50978,
 953975093,
 12614,
 -50977,
 954038187,
 12611,
 -50976,
 954117928,
 12645,
 -50975,
 954164152,
 12594,
 -50974,
 954218034,
 12672,
 -50973,
 954271044,
 12677,
 -1,
 954359739,
 12617,
 954597375,
 953912584,
 12613,
 954662911,
 954471820,
 -1,
 -50969,
 954555643,
 12668,
 -50968,
 954628011,
 12669,
 -50967,
 954707752,
 12667,
 -50966,
 954753976,
 12666,
 -1,
 954818491,
 12670,
 955005179,
 953814774,
 12601,
 955121663,
 954930572,
 -1,
 955136242,
 955026636,
 -1,
 955201776,
 955071159,
 12604,
 -1,
 955150031,
 12651,
 -50959,
 955137151,
 12607,
 -1,
 955290407,
 12652,
 955463925,
 955101122,
 -1,
 -50956,
 955387424,
 12650,
 -1,
 955451454,
 12606,
 955660535,
 955409336,
 12602,
 -1,
 955608783,
 12649,
 -50952,
 955597002,
 12653,
 -50951,
 955744565,
 12605,
 -50950,
 955785231,
 12603,
 -1,
 955843908,
 12608,
 956053769,
 954961100,
 -1,
 956119303,
 955988663,
 12610,
 956235775,
 956044684,
 -1,
 956250370,
 956137781,
 12612,
 956366847,
 956175756,
 -1,
 -50943,
 956259579,
 12661,
 -1,
 956326840,
 12660,
 956512517,
 956215234,
 -1,
 -50940,
 956436000,
 12659,
 -1,
 956500030,
 12663,
 -50938,
 956457912,
 12658,
 -1,
 956653499,
 12662,
 -50936,
 956054655,
 12621,
 -1,
 956797735,
 12671,
 956971283,
 955998320,
 -1,
 957036816,
 956927678,
 -1,
 957102350,
 956992716,
 -1,
 -50931,
 957037239,
 12664,
 -1,
 957103231,
 12676,
 -50929,
 957064614,
 12665,
 -1,
 957227023,
 12657,
 957430034,
 956958450,
 12593,
 -1,
 957378255,
 12595,
 -1,
 957388707,
 12619,
 957626650,
 956935976,
 12596,
 957743103,
 957552012,
 -1,
 -50922,
 957635835,
 12646,
 -50921,
 957710645,
 12647,
 -50920,
 957771795,
 12648,
 -50919,
 957809988,
 12598,
 -1,
 957898683,
 12597,
 958085408,
 957550904,
 -1,
 958150941,
 958017233,
 12638,
 -1,
 958084450,
 12637,
 958282015,
 958073468,
 12632,
 -1,
 958213841,
 12633,
 -1,
 958222219,
 12639,
 958478630,
 958013455,
 12609,
 958595071,
 958403980,
 -1,
 958609701,
 958500044,
 -1,
 -50908,
 958544567,
 12654,
 -1,
 958632743,
 12656,
 -1,
 958562613,
 12655,
 958871850,
 958401148,
 12623,
 958937385,
 958799090,
 12685,
 -1,
 958869201,
 12686,
 -1,
 958869201,
 12624,
 959133997,
 958803665,
 12628,
 -50900,
 959101112,
 12641,
 -1,
 959133026,
 12627,
 959330608,
 959098818,
 -1,
 -50897,
 959254048,
 12599,
 -1,
 959318078,
 12620,
 959527218,
 959264098,
 12631,
 -1,
 959459025,
 12634,
 959658292,
 959467403,
 12643,
 -1,
 959615468,
 12615,
 959789367,
 959585333,
 -1,
 -50890,
 959724135,
 12616,
 -1,
 959787933,
 12618,
 -50888,
 959756472,
 12636,
 -1,
 959907140,
 12622,
 960117176,
 952394457,
 -1,
 960182618,
 960056087,
 -1,
 960248144,
 960138504,
 4361,
 960364543,
 960173452,
 -1,
 960379201,
 960269516,
 -1,
 960444736,
 960314039,
 4402,
 -1,
 960407303,
 4403,
 -1,
 960380031,
 4410,
 960641348,
 960344002,
 -1,
 -50877,
 960564768,
 4399,
 -1,
 960628798,
 4409,
 960837959,
 960585840,
 -1,
 -50874,
 960759538,
 4397,
 -1,
 960862115,
 4408,
 961034570,
 960764981,
 -1,
 -50871,
 960969319,
 4406,
 -1,
 961033117,
 4407,
 -50869,
 960980588,
 4404,
 -50868,
 961154806,
 4400,
 -50867,
 961261352,
 4398,
 -50866,
 961290255,
 4401,
 -50865,
 961361458,
 4405,
 -1,
 961414468,
 4411,
 961675263,
 960209096,
 -1,
 -50862,
 961567995,
 4356,
 -50861,
 961642805,
 4362,
 -50860,
 961679094,
 4377,
 -50859,
 961771435,
 4360,
 -50858,
 961851176,
 4372,
 -50857,
 961897400,
 4353,
 -50856,
 961951282,
 4423,
 -50855,
 962004292,
 4440,
 -1,
 962092987,
 4365,
 962279793,
 960138444,
 -1,
 962345326,
 962214583,
 4359,
 962461695,
 962270604,
 -1,
 962476389,
 962349847,
 -1,
 962541924,
 962432264,
 4385,
 962658303,
 962467212,
 -1,
 -50847,
 962551035,
 4387,
 -50846,
 962623403,
 4388,
 -50845,
 962683832,
 4386,
 -1,
 962748347,
 4390,
 -1,
 962472519,
 4389,
 963000680,
 962441154,
 -1,
 -50841,
 962924064,
 4384,
 -1,
 962988094,
 4393,
 963197291,
 962927669,
 -1,
 -50838,
 963132007,
 4391,
 -1,
 963195805,
 4392,
 -50836,
 963151791,
 4394,
 -50835,
 963358504,
 4383,
 -1,
 963404728,
 4382,
 963590512,
 962280575,
 4369,
 -1,
 963554309,
 4438,
 -1,
 963547943,
 4416,
 963787147,
 962206773,
 -1,
 963852672,
 963716965,
 -1,
 963918204,
 963812029,
 -1,
 963983737,
 963857175,
 -1,
 964049272,
 963944648,
 -1,
 -50825,
 964002101,
 4413,
 -1,
 964059067,
 4431,
 -1,
 964005128,
 4412,
 964362239,
 963910709,
 -1,
 -50821,
 964246119,
 4430,
 -1,
 964309917,
 4436,
 964558847,
 963883464,
 4366,
 964624383,
 964433292,
 -1,
 -50817,
 964525877,
 4434,
 -1,
 964560196,
 4435,
 964770185,
 963818296,
 -1,
 964835718,
 964709143,
 -1,
 964901253,
 964796616,
 -1,
 -50812,
 964854069,
 4415,
 -1,
 964911035,
 4433,
 -1,
 964857096,
 4414,
 965214207,
 964762677,
 -1,
 -50808,
 965098087,
 4432,
 -1,
 965161885,
 4437,
 965410815,
 964704871,
 4364,
 -1,
 965293101,
 4429,
 965491098,
 963720754,
 4363,
 965607423,
 965416332,
 -1,
 965622161,
 965512396,
 -1,
 -50801,
 965556919,
 4420,
 -50800,
 965622911,
 4427,
 -1,
 965710631,
 4422,
 965884308,
 965586882,
 -1,
 -50797,
 965807648,
 4418,
 -1,
 965871678,
 4426,
 966080919,
 965811253,
 -1,
 -50794,
 966015591,
 4424,
 -1,
 966079389,
 4425,
 -50792,
 966033717,
 4421,
 -50791,
 966205455,
 4419,
 -1,
 966288312,
 4417,
 966474148,
 965435504,
 -1,
 966539682,
 966430398,
 -1,
 966605215,
 966495436,
 -1,
 -50786,
 966539959,
 4395,
 -1,
 966605951,
 4439,
 -50784,
 966567334,
 4396,
 -50783,
 966725366,
 4379,
 -1,
 966795279,
 4381,
 -50781,
 966461170,
 4352,
 -1,
 966956963,
 4367,
 967129513,
 966438696,
 4354,
 967245823,
 967054732,
 -1,
 -50777,
 967138555,
 4373,
 -50776,
 967210923,
 4374,
 -1,
 967271352,
 4371,
 967457197,
 967094210,
 -1,
 967522732,
 967380512,
 4355,
 -1,
 967485191,
 4375,
 -1,
 967444542,
 4368,
 967719345,
 967380726,
 4357,
 967835647,
 967644556,
 -1,
 -50768,
 967749416,
 4376,
 -1,
 967771460,
 4378,
 967981492,
 967677123,
 -1,
 -50765,
 967947653,
 4428,
 -1,
 967977533,
 4441,
 968178102,
 967909391,
 4358,
 -1,
 968141829,
 4380,
 -50761,
 968099140,
 4370,
 -1,
 968250526,
 4447,
 -50759,
 960074767,
 12334,
 -50758,
 968381598,
 12644,
 -1,
 968459838,
 12335,
 968687615,
 939554860,
 -1,
 968702404,
 968601538,
 -1,
 968767936,
 968626488,
 -1,
 -50753,
 968701282,
 12322,
 -1,
 968759336,
 12345,
 968964547,
 968702329,
 -1,
 -50750,
 968909611,
 12323,
 -1,
 968956779,
 12346,
 -1,
 968912050,
 12344,
 969226695,
 968641303,
 -1,
 -50746,
 969166687,
 12326,
 -1,
 969214021,
 12327,
 969423306,
 969160575,
 -1,
 -50743,
 969368500,
 12324,
 -1,
 969442492,
 12325,
 -50741,
 969345576,
 12321,
 -50740,
 969582102,
 12329,
 -1,
 969621227,
 12328,
 969867263,
 939467252,
 -1,
 969882082,
 969768652,
 -1,
 969947602,
 969833474,
 -1,
 -50735,
 969867676,
 5925,
 -1,
 969935484,
 5928,
 -50733,
 969904798,
 5932,
 -50732,
 970081893,
 5935,
 -50731,
 970176696,
 5922,
 -50730,
 970230190,
 5926,
 -50729,
 970286403,
 5936,
 -50728,
 970369340,
 5933,
 -50727,
 970409814,
 5929,
 -50726,
 970470822,
 5931,
 -50725,
 970525146,
 5934,
 -50724,
 970628877,
 5923,
 -50723,
 970674059,
 5921,
 -50722,
 970729372,
 5937,
 -50721,
 970785180,
 5924,
 -50720,
 970867628,
 5927,
 -50719,
 970960343,
 5930,
 -1,
 970984060,
 5920,
 971192805,
 969822451,
 -1,
 -50716,
 971159736,
 5939,
 -1,
 971198347,
 5938,
 -1,
 971128213,
 5940,
 971455102,
 939402964,
 -1,
 971520559,
 971416722,
 -1,
 971586094,
 971463879,
 -1,
 971651627,
 971538124,
 -1,
 971717115,
 971590423,
 -1,
 971782646,
 971659550,
 -1,
 971848176,
 971711188,
 -1,
 -50706,
 971815096,
 65389,
 -50705,
 971847010,
 65390,
 -1,
 971901564,
 65388,
 -50703,
 971815096,
 65385,
 -50702,
 972065120,
 65391,
 -50701,
 972109154,
 65387,
 -50700,
 972181387,
 65384,
 -50699,
 972238545,
 65386,
 -1,
 972294780,
 65383,
 -50697,
 971749560,
 65405,
 -50696,
 972436834,
 65407,
 -50695,
 972509067,
 65404,
 -50694,
 972566225,
 65406,
 -1,
 972622460,
 65403,
 972831233,
 971668482,
 65437,
 -50691,
 972798136,
 65415,
 -50690,
 972830050,
 65417,
 -50689,
 972902283,
 65414,
 -50688,
 972959441,
 65416,
 -1,
 973015676,
 65413,
 973224455,
 972795842,
 -1,
 -50685,
 973191352,
 65410,
 -50684,
 973223266,
 65412,
 -50683,
 973295499,
 65409,
 -50682,
 973352657,
 65411,
 -1,
 973408892,
 65408,
 973617677,
 973149963,
 -1,
 -50679,
 973584568,
 65433,
 -50678,
 973616482,
 65435,
 -50677,
 973688715,
 65432,
 -50676,
 973745873,
 65434,
 -1,
 973802108,
 65431,
 974010899,
 973566724,
 -1,
 -50673,
 973977784,
 65425,
 -50672,
 974009698,
 65427,
 -50671,
 974081931,
 65424,
 -50670,
 974139089,
 65426,
 -1,
 974195324,
 65423,
 974404121,
 973955184,
 -1,
 -50667,
 974371000,
 65400,
 -50666,
 974402914,
 65402,
 -50665,
 974475147,
 65399,
 -50664,
 974532305,
 65401,
 -1,
 974588540,
 65398,
 974797343,
 974338425,
 -1,
 -50661,
 974764216,
 65420,
 -50660,
 974796130,
 65422,
 -50659,
 974868363,
 65419,
 -50658,
 974925521,
 65421,
 -1,
 974981756,
 65418,
 975190563,
 974725844,
 -1,
 -50655,
 975157432,
 65429,
 -50654,
 975189346,
 65430,
 -1,
 975243900,
 65428,
 975452710,
 975114552,
 -1,
 -50651,
 975385954,
 65382,
 -1,
 975440508,
 65436,
 -50649,
 975419576,
 65395,
 -50648,
 975582562,
 65397,
 -50647,
 975654795,
 65394,
 -50646,
 975711953,
 65396,
 -1,
 975768188,
 65393,
 -50644,
 971576741,
 65438,
 -50643,
 975905340,
 65439,
 -1,
 975963510,
 65381,
 -1,
 971533664,
 65392,
 976239216,
 971462160,
 -1,
 976304751,
 976191180,
 -1,
 976370235,
 976228086,
 65449,
 976486399,
 976295308,
 -1,
 976501302,
 976391372,
 -1,
 -50635,
 976435895,
 65452,
 -1,
 976501887,
 65455,
 -50633,
 976442102,
 65454,
 -50632,
 976650549,
 65453,
 -50631,
 976691215,
 65451,
 -50630,
 976774072,
 65450,
 -1,
 976815428,
 65456,
 977025603,
 976298708,
 -1,
 977091134,
 976957137,
 65483,
 -1,
 977024354,
 65482,
 977222208,
 977013372,
 65476,
 -1,
 977153745,
 65477,
 -50623,
 977189048,
 65495,
 -50622,
 977286498,
 65490,
 -1,
 977358731,
 65499,
 977549899,
 976964375,
 -1,
 977615434,
 977510600,
 -1,
 -50618,
 977558779,
 65448,
 -50617,
 977633589,
 65462,
 -50616,
 977696683,
 65459,
 -50615,
 977757112,
 65442,
 -1,
 977821627,
 65465,
 -1,
 977571080,
 65461,
 978074193,
 977473848,
 -1,
 978139726,
 978005713,
 65493,
 -1,
 978072930,
 65492,
 978270800,
 978061948,
 65485,
 -1,
 978202321,
 65486,
 -1,
 978210699,
 65494,
 978467413,
 978029772,
 -1,
 978532948,
 978401975,
 65458,
 -1,
 978480847,
 65460,
 -1,
 978467967,
 65469,
 978729561,
 978431784,
 65444,
 978845695,
 978654604,
 -1,
 -50600,
 978715972,
 65446,
 -1,
 978804667,
 65445,
 978991709,
 978673776,
 -1,
 979057244,
 978913010,
 65441,
 -1,
 979005135,
 65443,
 -1,
 979015587,
 65467,
 979253856,
 978923217,
 65479,
 -50593,
 979220664,
 65498,
 -1,
 979252578,
 65478,
 979450467,
 979218370,
 -1,
 -50590,
 979373600,
 65447,
 -1,
 979437630,
 65468,
 979647077,
 979383650,
 65484,
 -1,
 979578577,
 65487,
 979778151,
 979586955,
 65500,
 -1,
 979735020,
 65463,
 979909226,
 979704885,
 -1,
 -50583,
 979843687,
 65464,
 -1,
 979907485,
 65466,
 980105836,
 979831420,
 65474,
 -1,
 980037329,
 65475,
 -50579,
 980072632,
 65491,
 -50578,
 980164623,
 65457,
 -1,
 980223300,
 65470,
 -1,
 976245918,
 65440,
 980499059,
 976200246,
 -1,
 -50574,
 980461194,
 65515,
 -1,
 980491744,
 65379,
 980695670,
 980444107,
 -1,
 -50571,
 980657802,
 65513,
 -1,
 980688352,
 65378,
 980892281,
 980634821,
 -1,
 -50568,
 980828663,
 65377,
 -1,
 980918504,
 65380,
 -50566,
 980857021,
 65518,
 -50565,
 981045969,
 65514,
 -50564,
 981121147,
 65512,
 -50563,
 981162677,
 65516,
 -1,
 981232902,
 65517,
 981416577,
 971380070,
 -1,
 -50560,
 981359361,
 9773,
 -1,
 981443579,
 9874,
 -1,
 981380870,
 8202,
 981679065,
 939339473,
 -1,
 981744437,
 981615930,
 -1,
 981809892,
 981690973,
 -1,
 981875420,
 981766913,
 -1,
 981940879,
 981804386,
 -1,
 -50552,
 981890412,
 64296,
 -50551,
 981966016,
 64295,
 -50550,
 981992816,
 64293,
 -50549,
 982072556,
 64292,
 -50548,
 982132648,
 64291,
 -50547,
 982207129,
 64294,
 -50546,
 982265751,
 64290,
 -1,
 982329688,
 64289,
 982530715,
 981879575,
 -1,
 982596249,
 982488538,
 1513,
 982712319,
 982527428,
 -1,
 982727318,
 982600820,
 64329,
 982843391,
 982649022,
 -1,
 -50539,
 982758647,
 64301,
 -1,
 982819455,
 64300,
 983039999,
 982666007,
 -1,
 -50536,
 982955255,
 64299,
 -1,
 983016063,
 64298,
 983236607,
 982548856,
 1505,
 -1,
 983134113,
 64321,
 983317155,
 982482724,
 -1,
 983382686,
 983279143,
 1507,
 -1,
 983330721,
 64323,
 983513760,
 983317740,
 1498,
 -1,
 983461793,
 64314,
 -50527,
 983479117,
 1509,
 -50526,
 983604787,
 1503,
 -1,
 983664696,
 1501,
 983841454,
 983239292,
 -1,
 983906989,
 983788125,
 -1,
 983972522,
 983853105,
 1488,
 984088575,
 983903684,
 -1,
 -50520,
 983992722,
 64303,
 -50519,
 984041397,
 64302,
 -1,
 984118060,
 64304,
 984350719,
 983906655,
 -1,
 -50516,
 984244006,
 64297,
 -1,
 984319159,
 64288,
 -1,
 983870879,
 1506,
 984562357,
 983805890,
 -1,
 984627889,
 984521628,
 1510,
 -1,
 984575905,
 64326,
 984758963,
 984575297,
 1496,
 -1,
 984706977,
 64312,
 984940543,
 984713756,
 1514,
 -1,
 984838049,
 64330,
 985021113,
 984514190,
 1497,
 985137151,
 984952260,
 -1,
 -50504,
 985037340,
 64285,
 -1,
 985091188,
 64313,
 985283261,
 984953579,
 1493,
 985399295,
 985214404,
 -1,
 -50500,
 985313140,
 64331,
 -1,
 985353332,
 64309,
 985545409,
 985245223,
 1508,
 985661439,
 985476548,
 -1,
 -50496,
 985573972,
 64334,
 -1,
 985615476,
 64324,
 985807557,
 985480428,
 1499,
 985923583,
 985738692,
 -1,
 -50492,
 985836116,
 64333,
 -1,
 985877620,
 64315,
 986069704,
 985737128,
 1492,
 -50489,
 986034114,
 1495,
 -1,
 986085192,
 64308,
 986266316,
 985989993,
 1489,
 986382335,
 986197444,
 -1,
 -50485,
 986294868,
 64332,
 -1,
 986336372,
 64305,
 986528462,
 986232094,
 1494,
 -1,
 986476449,
 64310,
 986659536,
 986488000,
 1512,
 -1,
 986607521,
 64328,
 986790610,
 986583142,
 1511,
 -1,
 986738593,
 64327,
 986921684,
 986750515,
 1504,
 -1,
 986869665,
 64320,
 987052758,
 986875960,
 1502,
 -1,
 987000737,
 64318,
 987183832,
 986973552,
 1500,
 -1,
 987131809,
 64316,
 987314906,
 987126084,
 1490,
 -1,
 987262881,
 64306,
 987496447,
 987246487,
 1491,
 -1,
 987393953,
 64307,
 987627519,
 981835734,
 -1,
 987642595,
 987518175,
 -1,
 987708129,
 987607972,
 -1,
 -50464,
 987659918,
 1522,
 -1,
 987706091,
 1520,
 -50462,
 987642140,
 64287,
 -1,
 987839957,
 1521,
 -1,
 987598665,
 64335,
 988101392,
 981749356,
 -1,
 988166892,
 988032119,
 -1,
 988232427,
 988088956,
 -1,
 988297962,
 988175801,
 -1,
 -50455,
 988256722,
 1428,
 -1,
 988303184,
 1429,
 -1,
 988250600,
 1432,
 -1,
 988185175,
 1454,
 988625651,
 988131266,
 -1,
 988691186,
 988557009,
 -1,
 988756721,
 988644209,
 -1,
 -50448,
 988711644,
 1449,
 -1,
 988751335,
 1440,
 -1,
 988715583,
 1435,
 -1,
 988626173,
 1430,
 989084408,
 988574468,
 -1,
 989149942,
 989029782,
 1445,
 -1,
 989108114,
 1446,
 -50441,
 989106809,
 1443,
 -1,
 989232222,
 1444,
 989412092,
 989034577,
 -1,
 989477627,
 989343661,
 1436,
 -1,
 989414932,
 1437,
 -1,
 989411748,
 1438,
 989674239,
 989369539,
 -1,
 -50434,
 989623734,
 1434,
 -1,
 989668398,
 1450,
 989870850,
 989612823,
 -1,
 -50431,
 989791463,
 1427,
 -1,
 989859344,
 1426,
 990067461,
 989796097,
 -1,
 -50428,
 990010938,
 1439,
 -1,
 990059173,
 1448,
 990264072,
 990005078,
 -1,
 -50425,
 990200606,
 1441,
 -1,
 990284999,
 1433,
 990460683,
 990192960,
 -1,
 -50422,
 990407171,
 1453,
 -1,
 990490869,
 1447,
 -50420,
 990380812,
 1431,
 -50419,
 990619819,
 1451,
 -50418,
 990659340,
 1452,
 -50417,
 990741855,
 1425,
 -1,
 990781156,
 1442,
 990985009,
 988056780,
 -1,
 991050537,
 990945084,
 -1,
 991116057,
 990984569,
 -1,
 991181591,
 991077692,
 -1,
 -50411,
 991120942,
 1457,
 -50410,
 991201682,
 1459,
 -1,
 991250357,
 1458,
 -50408,
 991106452,
 1465,
 -1,
 991377893,
 1460,
 991574815,
 991054615,
 -1,
 991640349,
 991508857,
 -1,
 -50404,
 991606007,
 1473,
 -1,
 991630123,
 1456,
 -50402,
 991606007,
 1474,
 -1,
 991759888,
 1462,
 991968035,
 991532577,
 -1,
 992033570,
 991929785,
 1464,
 -1,
 991972475,
 1479,
 -1,
 991952896,
 1467,
 -50396,
 991913458,
 1461,
 -50395,
 992193108,
 1471,
 -50394,
 992233397,
 1463,
 -50393,
 992325433,
 1469,
 -50392,
 992355526,
 64286,
 -1,
 992457900,
 1468,
 992673791,
 990975795,
 -1,
 992688941,
 992573521,
 -1,
 -50388,
 992623012,
 1524,
 -1,
 992685997,
 1523,
 -50386,
 992635793,
 1475,
 -50385,
 992805290,
 1472,
 -50384,
 992890379,
 1478,
 -1,
 992972752,
 1470,
 993198079,
 990926225,
 -1,
 -50381,
 993069533,
 1476,
 -50380,
 993172649,
 1455,
 -1,
 993198213,
 1477,
 993409940,
 981681542,
 -1,
 993475403,
 993374146,
 -1,
 993540938,
 993399191,
 -1,
 993606460,
 993467445,
 -1,
 -50374,
 993570307,
 19904,
 -50373,
 993622717,
 19933,
 -1,
 993667408,
 19953,
 993868609,
 993528444,
 -1,
 993934144,
 993793803,
 -1,
 -50369,
 993870523,
 19954,
 -1,
 993932836,
 19910,
 -1,
 993874564,
 19932,
 994196292,
 993792312,
 -1,
 -50365,
 994134053,
 19951,
 -1,
 994206659,
 19959,
 -50363,
 994143667,
 19905,
 -50362,
 994329202,
 19957,
 -50361,
 994397622,
 19955,
 -50360,
 994472710,
 19961,
 -50359,
 994554830,
 19960,
 -1,
 994618312,
 19940,
 -1,
 993482135,
 19913,
 994851669,
 993404224,
 -1,
 994917200,
 994782929,
 -1,
 -50354,
 994858560,
 19956,
 -50353,
 994945472,
 19943,
 -1,
 994973990,
 19944,
 995179347,
 994856843,
 -1,
 -50350,
 995107266,
 19962,
 -1,
 995198361,
 19906,
 -50348,
 995101039,
 19935,
 -1,
 995318918,
 19939,
 995507040,
 994787141,
 -1,
 995572575,
 995432203,
 -1,
 995638110,
 995495887,
 -1,
 995703645,
 995593420,
 -1,
 995769180,
 995636578,
 -1,
 -50341,
 995695007,
 19937,
 -1,
 995793269,
 19917,
 -1,
 995716073,
 19931,
 -1,
 995661930,
 19929,
 -1,
 995592278,
 19925,
 -1,
 995495081,
 19948,
 996227942,
 995445527,
 -1,
 996293476,
 996170014,
 -1,
 -50333,
 996251754,
 19912,
 -1,
 996308193,
 19965,
 -50331,
 996259440,
 19915,
 -1,
 996413905,
 19926,
 996621164,
 996167630,
 -1,
 996686698,
 996572162,
 -1,
 -50327,
 996638567,
 19928,
 -1,
 996685668,
 19964,
 -50325,
 996632910,
 19934,
 -1,
 996808998,
 19945,
 997014385,
 996555746,
 -1,
 997079920,
 996978626,
 -1,
 -50321,
 997026380,
 19927,
 -1,
 997078710,
 19936,
 -1,
 997032644,
 19952,
 997342069,
 996969676,
 -1,
 -50317,
 997300040,
 19949,
 -50316,
 997330198,
 19938,
 -1,
 997421283,
 19914,
 997604218,
 997274978,
 -1,
 997669753,
 997565844,
 -1,
 -50312,
 997617220,
 19950,
 -1,
 997655628,
 19941,
 -1,
 997629959,
 19942,
 997931903,
 997531502,
 -1,
 997997438,
 997882882,
 -1,
 -50307,
 997930999,
 19923,
 -1,
 997994520,
 19909,
 -1,
 997949257,
 19947,
 998259587,
 997856113,
 -1,
 -50303,
 998213283,
 19946,
 -50302,
 998275541,
 19924,
 -1,
 998338934,
 19967,
 998521735,
 998181500,
 -1,
 -50299,
 998451873,
 19922,
 -50298,
 998512967,
 19966,
 -1,
 998616449,
 19958,
 998783882,
 998445368,
 -1,
 -50295,
 998728518,
 19921,
 -1,
 998811761,
 19908,
 998980493,
 998716856,
 -1,
 -50292,
 998922449,
 19930,
 -1,
 998979529,
 19918,
 999177104,
 998913919,
 -1,
 -50289,
 999110331,
 19920,
 -1,
 999208407,
 19916,
 -50287,
 999097560,
 19907,
 -50286,
 999300732,
 19963,
 -50285,
 999402112,
 19911,
 -1,
 999438301,
 19919,
 999635927,
 993371447,
 -1,
 999701409,
 999560049,
 -1,
 999766944,
 999627134,
 -1,
 999832475,
 999702966,
 -1,
 -50279,
 999796625,
 10167,
 -50278,
 999855036,
 10168,
 -1,
 999907120,
 10169,
 1000144895,
 999775431,
 -1,
 1000160159,
 1000061168,
 -1,
 -50274,
 1000113474,
 10150,
 -1,
 1000164264,
 10149,
 -1,
 1000116842,
 10084,
 -1,
 999715402,
 10008,
 1000487848,
 999665602,
 -1,
 1000553383,
 1000441275,
 -1,
 1000618918,
 1000481363,
 -1,
 -50267,
 1000577010,
 10051,
 -1,
 1000615689,
 10045,
 -1,
 1000572936,
 10171,
 -1,
 1000473214,
 10142,
 1000946606,
 1000426263,
 -1,
 1001012140,
 1000879263,
 -1,
 -50261,
 1000932327,
 10075,
 -1,
 1001033856,
 10076,
 -50259,
 1000947043,
 10056,
 -1,
 1001130784,
 10136,
 1001339829,
 1000871691,
 -1,
 1001405364,
 1001297421,
 -1,
 1001470899,
 1001353642,
 -1,
 -50254,
 1001400790,
 10095,
 -1,
 1001471562,
 10097,
 -1,
 1001432714,
 10137,
 -1,
 1001334503,
 10140,
 1001798586,
 1001286237,
 -1,
 1001864121,
 1001748370,
 -1,
 -50248,
 1001794006,
 10094,
 -1,
 1001864778,
 10096,
 -1,
 1001795162,
 10157,
 1002126271,
 1001729745,
 -1,
 1002191806,
 1002089038,
 -1,
 -50243,
 1002118142,
 10059,
 -1,
 1002181333,
 10040,
 -1,
 1002140640,
 10082,
 1002453956,
 1002054976,
 -1,
 1002519491,
 1002391311,
 -1,
 -50238,
 1002439655,
 10077,
 -1,
 1002541184,
 10078,
 -1,
 1002456097,
 10144,
 1002781641,
 1002380341,
 -1,
 1002847176,
 1002710952,
 -1,
 -50233,
 1002772086,
 10054,
 -1,
 1002844711,
 10004,
 -1,
 1002778741,
 10152,
 1003109324,
 1002705208,
 -1,
 -50229,
 1003056169,
 10132,
 -1,
 1003108243,
 10173,
 1003305935,
 1003042146,
 -1,
 -50226,
 1003248526,
 10030,
 -1,
 1003325417,
 10012,
 -50224,
 1003257213,
 10074,
 -50223,
 1003468613,
 10158,
 -50222,
 1003511600,
 10138,
 -50221,
 1003553324,
 10006,
 -50220,
 1003661185,
 10083,
 -50219,
 1003707030,
 10010,
 -50218,
 1003794682,
 10020,
 -1,
 1003826953,
 10033,
 -50216,
 999599550,
 8889,
 -1,
 1003970304,
 9096,
 1004158022,
 981618571,
 -1,
 1004223557,
 1004115946,
 -1,
 1004289090,
 1004175052,
 -1,
 1004354545,
 1004227351,
 -1,
 1004420076,
 1004296478,
 -1,
 1004485602,
 1004348116,
 -1,
 -50208,
 1004452024,
 12421,
 -50207,
 1004483938,
 12423,
 -1,
 1004538492,
 12419,
 1004747749,
 1004429424,
 -1,
 -50204,
 1004678865,
 12438,
 -1,
 1004735100,
 12437,
 -50202,
 1004684901,
 12430,
 -50201,
 1004910776,
 12357,
 -50200,
 1004964192,
 12387,
 -50199,
 1005008226,
 12361,
 -50198,
 1005080459,
 12355,
 -50197,
 1005137617,
 12359,
 -1,
 1005193852,
 12353,
 -50195,
 1004386488,
 12377,
 -50194,
 1005335906,
 12381,
 -50193,
 1005408139,
 12375,
 -50192,
 1005465297,
 12379,
 -1,
 1005521532,
 12373,
 1005730807,
 1004305410,
 12435,
 -50189,
 1005697208,
 12396,
 -50188,
 1005729122,
 12398,
 -50187,
 1005801355,
 12395,
 -50186,
 1005858513,
 12397,
 -1,
 1005914748,
 12394,
 1006124029,
 1005661303,
 -1,
 -50183,
 1006090424,
 12378,
 -50182,
 1006122338,
 12382,
 -50181,
 1006194571,
 12376,
 -50180,
 1006251729,
 12380,
 -1,
 1006307964,
 12374,
 1006517251,
 1006088130,
 -1,
 -50177,
 1006483640,
 12388,
 -50176,
 1006515554,
 12392,
 -50175,
 1006587787,
 12385,
 -50174,
 1006644945,
 12390,
 -1,
 1006701180,
 12383,
 1006910473,
 1006442251,
 -1,
 -50171,
 1006876856,
 12427,
 -50170,
 1006908770,
 12429,
 -50169,
 1006981003,
 12426,
 -50168,
 1007038161,
 12428,
 -1,
 1007094396,
 12425,
 1007303695,
 1006865612,
 -1,
 -50165,
 1007270072,
 12407,
 -50164,
 1007301986,
 12413,
 -50163,
 1007374219,
 12404,
 -50162,
 1007431377,
 12410,
 -1,
 1007487612,
 12401,
 1007696917,
 1007252228,
 -1,
 -50159,
 1007663288,
 12416,
 -50158,
 1007695202,
 12418,
 -50157,
 1007767435,
 12415,
 -50156,
 1007824593,
 12417,
 -1,
 1007880828,
 12414,
 1008090139,
 1007640688,
 -1,
 -50153,
 1008056504,
 12367,
 -50152,
 1008088418,
 12371,
 -50151,
 1008160651,
 12365,
 -50150,
 1008217809,
 12369,
 -1,
 1008274044,
 12363,
 1008483361,
 1008023929,
 -1,
 -50147,
 1008449720,
 12405,
 -50146,
 1008481634,
 12411,
 -50145,
 1008553867,
 12402,
 -50144,
 1008611025,
 12408,
 -1,
 1008667260,
 12399,
 1008876583,
 1008418629,
 -1,
 -50141,
 1008842936,
 12368,
 -50140,
 1008874850,
 12372,
 -50139,
 1008947083,
 12366,
 -50138,
 1009004241,
 12370,
 -1,
 1009060476,
 12364,
 1009269805,
 1008805184,
 -1,
 -50135,
 1009236152,
 12389,
 -50134,
 1009268066,
 12393,
 -50133,
 1009340299,
 12386,
 -50132,
 1009397457,
 12391,
 -1,
 1009453692,
 12384,
 1009663027,
 1009193841,
 -1,
 -50129,
 1009629368,
 12406,
 -50128,
 1009661282,
 12412,
 -50127,
 1009733515,
 12403,
 -50126,
 1009790673,
 12409,
 -1,
 1009846908,
 12400,
 1010056248,
 1009586488,
 -1,
 -50123,
 1009988962,
 12434,
 -50122,
 1010061195,
 12432,
 -50121,
 1010118353,
 12433,
 -1,
 1010174588,
 12431,
 1010383932,
 1009984212,
 -1,
 -50118,
 1010350264,
 12422,
 -50117,
 1010382178,
 12424,
 -1,
 1010436732,
 12420,
 -50115,
 1010311869,
 12436,
 -50114,
 1010612408,
 12358,
 -50113,
 1010644322,
 12362,
 -50112,
 1010716555,
 12356,
 -50111,
 1010773713,
 12360,
 -1,
 1010829948,
 12354,
 -50109,
 1004227021,
 12446,
 -50108,
 1010969534,
 12445,
 -1,
 1011041170,
 12447,
 -1,
 1004163064,
 9889,
 1011301464,
 1004090722,
 -1,
 1011366993,
 1011231232,
 -1,
 1011432525,
 1011309149,
 -1,
 -50102,
 1011383827,
 9149,
 -50101,
 1011444873,
 9148,
 -50100,
 1011501515,
 9147,
 -1,
 1011562830,
 9146,
 -50098,
 1011381590,
 9897,
 -50097,
 1011708528,
 9135,
 -50096,
 1011777737,
 8230,
 -1,
 1011824756,
 8213,
 1012022356,
 1011333304,
 -1,
 -50093,
 1011967319,
 8962,
 -1,
 1012042842,
 8987,
 1012218967,
 1011976801,
 -1,
 -50090,
 1012165771,
 9832,
 -1,
 1012220713,
 9749,
 -1,
 1012181431,
 8763,
 1012481120,
 1011229396,
 -1,
 1012546655,
 1012436172,
 -1,
 1012612190,
 1012497432,
 8208,
 -50084,
 1012552063,
 8231,
 -50083,
 1012631423,
 45,
 -1,
 1012678979,
 8259,
 -1,
 1012557968,
 11794,
 -1,
 1012486661,
 9102,
 -1,
 1012413964,
 8372,
 1013071985,
 939281175,
 -1,
 1013136789,
 1013015804,
 -1,
 1013202324,
 1013070818,
 -1,
 1013267849,
 1013144775,
 -1,
 1013333142,
 1013216004,
 -1,
 1013398639,
 1013297472,
 -1,
 -50072,
 1013322040,
 13244,
 -50071,
 1013385243,
 13238,
 -50070,
 1013467927,
 13234,
 -50069,
 1013543684,
 13211,
 -50068,
 1013607005,
 13205,
 -50067,
 1013661509,
 13197,
 -50066,
 1013725055,
 13196,
 -1,
 1013779068,
 13186,
 1013988470,
 1013320316,
 13187,
 1014054003,
 1013927819,
 -1,
 -50062,
 1013988229,
 13124,
 -1,
 1014081899,
 13123,
 -50060,
 1013980597,
 13126,
 -50059,
 1014201524,
 13127,
 -1,
 1014272666,
 13125,
 1014447229,
 1013931207,
 -1,
 1014512763,
 1014379874,
 -1,
 1014578298,
 1014458539,
 13223,
 -1,
 1014530843,
 13224,
 -1,
 1014528561,
 13249,
 -50052,
 1014453545,
 13217,
 -1,
 1014740390,
 13221,
 1014905986,
 1014386571,
 -1,
 1014971520,
 1014840312,
 13129,
 -1,
 1014922012,
 13130,
 -50047,
 1014917725,
 13269,
 -1,
 1015047696,
 13128,
 1015233670,
 1014854404,
 13212,
 1015349247,
 1015176391,
 -1,
 -50043,
 1015239977,
 13215,
 -1,
 1015330214,
 13219,
 1015495818,
 1015164625,
 -1,
 1015561353,
 1015415196,
 13131,
 -1,
 1015518429,
 13132,
 -1,
 1015495083,
 13133,
 1015757964,
 1015419192,
 13245,
 -1,
 1015720923,
 13247,
 1015889038,
 1015679003,
 13239,
 -1,
 1015851995,
 13241,
 1016020112,
 1015812977,
 13190,
 -1,
 1015968792,
 13268,
 -50031,
 1015958295,
 13235,
 -50030,
 1016088406,
 13227,
 -50029,
 1016168839,
 13270,
 -50028,
 1016228445,
 13206,
 -50027,
 1016277562,
 13202,
 -1,
 1016348485,
 13198,
 1016544441,
 1013276784,
 -1,
 1016609949,
 1016492804,
 13214,
 1016725503,
 1016552647,
 -1,
 1016741020,
 1016601653,
 -1,
 -50021,
 1016665368,
 13222,
 -1,
 1016765211,
 13262,
 -1,
 1016681769,
 13218,
 1017003169,
 1016559120,
 13076,
 -50017,
 1016966927,
 13079,
 -50016,
 1017032511,
 13078,
 -1,
 1017067847,
 13077,
 1017265318,
 1016924796,
 13188,
 1017330853,
 1017190155,
 -1,
 -50012,
 1017263758,
 13069,
 -1,
 1017326452,
 13068,
 -1,
 1017271249,
 13067,
 1017593001,
 1017230176,
 -1,
 -50008,
 1017559238,
 13082,
 -1,
 1017620222,
 13083,
 1017789612,
 1017525602,
 -1,
 -50005,
 1017731656,
 13085,
 -1,
 1017794568,
 13086,
 -50003,
 1017733692,
 13074,
 -50002,
 1017909560,
 13246,
 -50001,
 1017972763,
 13240,
 -50000,
 1018081218,
 13263,
 -49999,
 1018120022,
 13226,
 -49998,
 1018194525,
 13208,
 -49997,
 1018257520,
 13261,
 -49996,
 1018309178,
 13201,
 -49995,
 1018380101,
 13199,
 -49994,
 1018459654,
 13084,
 -49993,
 1018509465,
 13193,
 -49992,
 1018565489,
 13189,
 -1,
 1018646370,
 13248,
 1018838230,
 1016499404,
 -1,
 1018903744,
 1018769105,
 -1,
 1018969278,
 1018854402,
 -1,
 -49987,
 1018914038,
 13114,
 -1,
 1018960466,
 13112,
 -49985,
 1018901718,
 13111,
 -1,
 1019120364,
 13115,
 1019296965,
 1018825340,
 13225,
 1019362500,
 1019218556,
 -1,
 -49981,
 1019316576,
 13100,
 -1,
 1019391196,
 13099,
 -1,
 1019297296,
 13184,
 1019624650,
 1019236235,
 -1,
 1019690185,
 1019568240,
 -1,
 -49976,
 1019629609,
 13103,
 -1,
 1019688290,
 13104,
 -1,
 1019631455,
 13102,
 1019952333,
 1019557218,
 -1,
 -49972,
 1019890421,
 13120,
 -1,
 1019954458,
 13117,
 -49970,
 1019875640,
 13242,
 -49969,
 1020069915,
 13236,
 -49968,
 1020152599,
 13232,
 -49967,
 1020204811,
 13274,
 -49966,
 1020307037,
 13273,
 -49965,
 1020359428,
 13272,
 -49964,
 1020410233,
 13271,
 -49963,
 1020475263,
 13194,
 -1,
 1020533813,
 13174,
 1020738794,
 1018761528,
 -1,
 1020804328,
 1020689382,
 -1,
 1020869853,
 1020766204,
 -1,
 1020935388,
 1020815442,
 -1,
 -49957,
 1020896703,
 9639,
 -1,
 1020941738,
 9705,
 -1,
 1020898110,
 9640,
 1021197536,
 1020815965,
 -1,
 -49953,
 1021156432,
 9706,
 -1,
 1021209099,
 9703,
 -49951,
 1021131710,
 9637,
 -49950,
 1021354392,
 11026,
 -49949,
 1021413919,
 9704,
 -49948,
 1021459203,
 9638,
 -49947,
 1021551476,
 9636,
 -49946,
 1021576604,
 9641,
 -49945,
 1021687038,
 10720,
 -1,
 1021708123,
 11027,
 -49943,
 1020728177,
 13277,
 -1,
 1021848436,
 13143,
 1022049533,
 1020672377,
 -1,
 1022115055,
 1022015672,
 -1,
 -49939,
 1022072982,
 13109,
 -49938,
 1022124889,
 13107,
 -1,
 1022182707,
 13106,
 1022377204,
 1022047586,
 -1,
 1022442739,
 1022309730,
 -1,
 -49934,
 1022376837,
 13121,
 -1,
 1022458882,
 13122,
 -1,
 1022393346,
 13119,
 1022704886,
 1022332108,
 13259,
 -1,
 1022626428,
 13169,
 1022835961,
 1022635729,
 -1,
 -49928,
 1022771937,
 13113,
 -1,
 1022839900,
 13110,
 1023032571,
 1022757500,
 13258,
 -1,
 1022992278,
 13098,
 -49924,
 1022962807,
 13200,
 -1,
 1023098693,
 13004,
 1023294732,
 1021984581,
 -1,
 1023360258,
 1023233931,
 -1,
 -49920,
 1023312593,
 13075,
 -49919,
 1023386785,
 13073,
 -1,
 1023410588,
 13072,
 1023622406,
 1023281788,
 -1,
 -49916,
 1023586693,
 13070,
 -49915,
 1023615129,
 13071,
 -1,
 1023699549,
 13311,
 1023884552,
 1023557824,
 13080,
 -1,
 1023841501,
 13081,
 -49911,
 1023812308,
 13257,
 -49910,
 1023952726,
 13228,
 -49909,
 1024010810,
 13203,
 -1,
 1024070513,
 13191,
 1024277787,
 1023219467,
 -1,
 1024343313,
 1024216971,
 -1,
 -49905,
 1024277041,
 13137,
 -49904,
 1024371004,
 13138,
 -1,
 1024397963,
 10958,
 1024605460,
 1024297402,
 13229,
 1024720895,
 1024526072,
 13230,
 -1,
 1024623387,
 13231,
 1024802071,
 1024571576,
 -1,
 -49898,
 1024727789,
 13140,
 -1,
 1024793708,
 13139,
 1024998682,
 1024732881,
 -1,
 -49895,
 1024945580,
 13142,
 -1,
 1025001555,
 13141,
 -1,
 1024964995,
 8730,
 1025260841,
 1024203829,
 -1,
 1025326368,
 1025209092,
 13213,
 1025441791,
 1025268935,
 -1,
 -49889,
 1025332521,
 13216,
 -1,
 1025422758,
 13220,
 1025588514,
 1025258850,
 13255,
 -1,
 1025517109,
 13183,
 1025719589,
 1025510012,
 -1,
 -49884,
 1025674444,
 8851,
 -1,
 1025731165,
 13192,
 -49882,
 1025676495,
 8852,
 -49881,
 1025844544,
 13253,
 -49880,
 1025907765,
 13252,
 -1,
 1025970324,
 13254,
 1026178356,
 1025189184,
 -1,
 1026243886,
 1026126596,
 13175,
 1026359295,
 1026186439,
 -1,
 -49875,
 1026250025,
 13176,
 -1,
 1026340262,
 13177,
 1026506032,
 1026165372,
 13170,
 -1,
 1026465308,
 13092,
 -49871,
 1026436586,
 13094,
 -49870,
 1026583133,
 13207,
 -49869,
 1026643841,
 13093,
 -1,
 1026691953,
 13256,
 1026899261,
 1026128898,
 -1,
 1026964791,
 1026820732,
 13185,
 -1,
 1026905941,
 13096,
 -49864,
 1026887992,
 13243,
 -49863,
 1027016731,
 13237,
 -49862,
 1027099415,
 13233,
 -49861,
 1027184451,
 13097,
 -49860,
 1027240708,
 13210,
 -1,
 1027291007,
 13195,
 1027489096,
 1026830033,
 -1,
 1027554629,
 1027413771,
 -1,
 1027620164,
 1027473719,
 -1,
 -49855,
 1027568210,
 13181,
 -49854,
 1027608471,
 13180,
 -49853,
 1027673467,
 13182,
 -1,
 1027764251,
 13179,
 -1,
 1027555141,
 13005,
 -49850,
 1027475483,
 13006,
 -49849,
 1027936620,
 13063,
 -1,
 1028012143,
 13064,
 1028210002,
 1027427095,
 -1,
 1028275532,
 1028145054,
 -1,
 -49845,
 1028207970,
 13091,
 -1,
 1028280203,
 13090,
 1028472143,
 1028196988,
 -1,
 -49842,
 1028411825,
 13088,
 -1,
 1028501538,
 13087,
 -49840,
 1028392987,
 13276,
 -49839,
 1028593419,
 13275,
 -1,
 1028659665,
 13089,
 1028865371,
 1028149131,
 -1,
 1028930902,
 1028815874,
 13260,
 -49835,
 1028884879,
 13061,
 -1,
 1028945532,
 13060,
 1029127514,
 1028851685,
 8847,
 1029242879,
 1029088262,
 -1,
 -49831,
 1029131590,
 8932,
 -1,
 1029201178,
 8849,
 -1,
 1029093560,
 13178,
 1029455204,
 1028789105,
 -1,
 1029520735,
 1029376636,
 -1,
 -49826,
 1029445387,
 13172,
 -1,
 1029508868,
 13101,
 -49824,
 1029478878,
 13108,
 -49823,
 1029674529,
 13251,
 -49822,
 1029746207,
 13118,
 -49821,
 1029795045,
 13105,
 -1,
 1029859975,
 13116,
 1030045036,
 1029376636,
 -1,
 -49818,
 1030011064,
 13171,
 -49817,
 1030033054,
 13057,
 -49816,
 1030125489,
 13056,
 -49815,
 1030163903,
 13058,
 -49814,
 1030255364,
 13250,
 -49813,
 1030320198,
 13059,
 -1,
 1030358856,
 13279,
 1030569332,
 1029977442,
 -1,
 1030634865,
 1030519031,
 8848,
 1030750207,
 1030595590,
 -1,
 -49808,
 1030638918,
 8933,
 -1,
 1030708506,
 8850,
 -49806,
 1030555675,
 13173,
 -49805,
 1030856560,
 13066,
 -1,
 1030901590,
 13065,
 1031093628,
 1030515293,
 -1,
 1031159160,
 1031026018,
 -1,
 -49801,
 1031118318,
 8977,
 -1,
 1031159621,
 13266,
 -49799,
 1031084475,
 13267,
 -49798,
 1031306242,
 13265,
 -49797,
 1031369476,
 13264,
 -1,
 1031441466,
 10957,
 1031617921,
 1031021268,
 -1,
 1031683456,
 1031571889,
 -1,
 -49793,
 1031617413,
 13135,
 -1,
 1031684978,
 13134,
 -1,
 1031630703,
 13136,
 1031945604,
 1031581634,
 -1,
 -49789,
 1031897473,
 13095,
 -1,
 1031940666,
 13204,
 1032142215,
 1031878527,
 -1,
 -49786,
 1032108419,
 9165,
 -1,
 1032155908,
 13209,
 -49784,
 1032081694,
 13278,
 -1,
 1032289153,
 13062,
 1032519679,
 1013204417,
 -1,
 1032535437,
 1032407831,
 -1,
 -49780,
 1032476132,
 10696,
 -1,
 1032546039,
 10695,
 -49778,
 1032464714,
 8864,
 -49777,
 1032663316,
 10692,
 -49776,
 1032743372,
 8862,
 -49775,
 1032791170,
 8863,
 -49774,
 1032860731,
 10693,
 -49773,
 1032954897,
 8865,
 -1,
 1032990473,
 10694,
 -1,
 1013164420,
 10151,
 1033256563,
 1013064404,
 -1,
 1033321983,
 1033197830,
 -1,
 1033387457,
 1033273036,
 -1,
 1033452961,
 1033325335,
 -1,
 1033518493,
 1033387515,
 -1,
 -49765,
 1033465308,
 1869,
 -49764,
 1033532047,
 1870,
 -1,
 1033605624,
 1871,
 -49762,
 1033459904,
 1809,
 -49761,
 1033737690,
 1835,
 -49760,
 1033783860,
 1827,
 -1,
 1033841303,
 1832,
 1034042790,
 1033414183,
 1830,
 1034158079,
 1033967255,
 -1,
 -49756,
 1034037536,
 1838,
 -49755,
 1034133336,
 1839,
 -1,
 1034204855,
 1837,
 1034370474,
 1034006466,
 -1,
 1034436009,
 1034296903,
 1819,
 -1,
 1034366506,
 1820,
 -1,
 1034390041,
 1836,
 1034632620,
 1034318226,
 1821,
 -1,
 1034571168,
 1822,
 1034763695,
 1034557195,
 -1,
 -49746,
 1034698966,
 1834,
 -1,
 1034764647,
 1831,
 1034960305,
 1034692520,
 1815,
 -1,
 1034900097,
 1818,
 1035091379,
 1034895266,
 1811,
 -1,
 1035021866,
 1812,
 1035222454,
 1035019584,
 -1,
 -49739,
 1035155257,
 1814,
 -1,
 1035220434,
 1813,
 -49737,
 1035164648,
 1817,
 -49736,
 1035357460,
 1816,
 -49735,
 1035420098,
 1833,
 -49734,
 1035509299,
 1826,
 -49733,
 1035552492,
 1825,
 -49732,
 1035638197,
 1824,
 -49731,
 1035686333,
 1823,
 -49730,
 1035734149,
 1828,
 -49729,
 1035808465,
 1829,
 -49728,
 1035867103,
 1810,
 -1,
 1035943194,
 1808,
 1036139980,
 1033320825,
 -1,
 1036205511,
 1036086116,
 -1,
 1036271046,
 1036147911,
 -1,
 -49723,
 1036198578,
 1851,
 -1,
 1036293000,
 1850,
 -1,
 1036236964,
 1852,
 1036533195,
 1036151909,
 -1,
 -49719,
 1036490158,
 1803,
 -49718,
 1036552473,
 1804,
 -1,
 1036604801,
 1805,
 -1,
 1036452753,
 1797,
 1036860885,
 1036084470,
 -1,
 1036926417,
 1036785084,
 -1,
 1036991952,
 1036866756,
 1795,
 -1,
 1036952606,
 1800,
 -1,
 1036927479,
 1793,
 1037238271,
 1036851634,
 -1,
 1037254100,
 1037128900,
 1796,
 -1,
 1037211379,
 1801,
 -1,
 1037189623,
 1794,
 1037450716,
 1036824514,
 -1,
 1037516249,
 1037372154,
 -1,
 -49704,
 1037443762,
 1860,
 -1,
 1037538184,
 1859,
 1037762559,
 1037449690,
 -1,
 -49701,
 1037640370,
 1862,
 -1,
 1037734792,
 1861,
 1037909474,
 1037375243,
 -1,
 1037975008,
 1037866377,
 -1,
 -49697,
 1037902514,
 1847,
 -1,
 1037996936,
 1846,
 -49695,
 1037936736,
 1855,
 -1,
 1038107242,
 1858,
 1038302694,
 1037849582,
 -1,
 -49692,
 1038248994,
 1845,
 -49691,
 1038295730,
 1844,
 -1,
 1038390152,
 1843,
 1038564842,
 1038249642,
 -1,
 -49688,
 1038511138,
 1842,
 -49687,
 1038557874,
 1841,
 -1,
 1038652296,
 1840,
 1038826991,
 1038495441,
 -1,
 1038892526,
 1038765867,
 -1,
 -49683,
 1038820018,
 1854,
 -1,
 1038914440,
 1853,
 -1,
 1038820132,
 1792,
 1039154676,
 1038753646,
 -1,
 1039220211,
 1039096058,
 -1,
 -49678,
 1039180342,
 1799,
 -1,
 1039229899,
 1798,
 -1,
 1039177182,
 1802,
 1039482359,
 1039074932,
 -1,
 -49674,
 1039409842,
 1864,
 -1,
 1039504264,
 1863,
 1039678970,
 1039438345,
 -1,
 -49671,
 1039608489,
 1848,
 -1,
 1039671653,
 1849,
 -49669,
 1039612888,
 1857,
 -49668,
 1039810635,
 1865,
 -49667,
 1039873380,
 1856,
 -49666,
 1039951965,
 1866,
 -1,
 1039998935,
 1807,
 1040203323,
 1033266763,
 -1,
 1040268844,
 1040154316,
 -1,
 1040334343,
 1040232386,
 -1,
 1040399877,
 1040297922,
 -1,
 -49660,
 1040332130,
 43024,
 -1,
 1040394088,
 43025,
 -49658,
 1040332130,
 43028,
 -1,
 1040525160,
 43029,
 1040727565,
 1040262464,
 -1,
 1040793099,
 1040655680,
 -1,
 -49654,
 1040725346,
 43026,
 -1,
 1040787304,
 43027,
 -49652,
 1040725346,
 43030,
 -1,
 1040918376,
 43031,
 1041120784,
 1040652043,
 -1,
 -49649,
 1041054709,
 43040,
 -1,
 1041118562,
 43038,
 1041317395,
 1041075404,
 -1,
 -49646,
 1041249634,
 43033,
 -1,
 1041311592,
 43034,
 1041514006,
 1041260656,
 -1,
 -49643,
 1041446242,
 43015,
 -1,
 1041508200,
 43016,
 1041710617,
 1041455100,
 -1,
 -49640,
 1041642850,
 43022,
 -1,
 1041704808,
 43023,
 1041907228,
 1041645381,
 -1,
 -49637,
 1041839458,
 43017,
 -1,
 1041901416,
 43018,
 1042103839,
 1041833013,
 -1,
 -49634,
 1042036066,
 43020,
 -1,
 1042098024,
 43021,
 1042300450,
 1042027377,
 -1,
 -49631,
 1042232674,
 43035,
 -1,
 1042294632,
 43036,
 -49629,
 1042266296,
 43011,
 -49628,
 1042429142,
 43041,
 -49627,
 1042494818,
 43013,
 -49626,
 1042569045,
 43032,
 -49625,
 1042625976,
 43037,
 -49624,
 1042680631,
 43039,
 -49623,
 1042763659,
 43009,
 -49622,
 1042818920,
 43042,
 -49621,
 1042886353,
 43012,
 -1,
 1042942588,
 43008,
 1043152434,
 1040208115,
 -1,
 -49618,
 1043118264,
 43045,
 -49617,
 1043169662,
 43047,
 -49616,
 1043222411,
 43044,
 -49615,
 1043279569,
 43046,
 -1,
 1043335804,
 43043,
 1043545655,
 1043114029,
 -1,
 -49612,
 1043485216,
 43051,
 -49611,
 1043548619,
 43050,
 -49610,
 1043612084,
 43049,
 -1,
 1043675470,
 43048,
 1043922943,
 1043496140,
 -1,
 -49607,
 1043804773,
 43014,
 -49606,
 1043879684,
 43010,
 -1,
 1043930455,
 43019,
 1044185087,
 1040151300,
 -1,
 1044201074,
 1044081190,
 -1,
 1044266568,
 1044138775,
 -1,
 1044332096,
 1044226380,
 9242,
 -1,
 1044269291,
 9254,
 1044463171,
 1044292253,
 -1,
 -49598,
 1044405553,
 9218,
 -1,
 1044453443,
 9217,
 1044659782,
 1044388938,
 -1,
 -49595,
 1044589901,
 9230,
 -1,
 1044664270,
 9231,
 -49593,
 1044601718,
 9238,
 -1,
 1044799166,
 9248,
 1044987475,
 1044194624,
 -1,
 1045053010,
 1044917969,
 -1,
 1045118544,
 1044986942,
 -1,
 1045184078,
 1045082050,
 -1,
 -49587,
 1045120620,
 9234,
 -1,
 1045185455,
 9235,
 -49585,
 1045105192,
 9233,
 -1,
 1045345788,
 9236,
 1045561343,
 1045076466,
 9249,
 -1,
 1045448939,
 9253,
 -1,
 1044998643,
 9232,
 1045708381,
 1044917969,
 -1,
 1045773916,
 1045658626,
 -1,
 1045839451,
 1045710559,
 -1,
 1045904986,
 1045802946,
 -1,
 1045970521,
 1045854474,
 9220,
 -1,
 1045906972,
 9239,
 -1,
 1045930738,
 9219,
 -1,
 1045860016,
 9241,
 -1,
 1045797782,
 9221,
 -1,
 1045731779,
 9243,
 1046363746,
 1045658626,
 -1,
 1046429281,
 1046294225,
 -1,
 -49568,
 1046390327,
 9252,
 -1,
 1046439885,
 9237,
 -1,
 1046395074,
 9216,
 1046691429,
 1046296447,
 -1,
 -49564,
 1046652742,
 9228,
 -1,
 1046698994,
 9244,
 1046888040,
 1046617990,
 -1,
 -49561,
 1046820209,
 9229,
 -1,
 1046909601,
 9240,
 1047084651,
 1046811505,
 -1,
 -49558,
 1047021605,
 9223,
 -1,
 1047094408,
 9224,
 -49556,
 1047006321,
 9227,
 -49555,
 1047228236,
 9247,
 -49554,
 1047284199,
 9246,
 -49553,
 1047367199,
 9226,
 -49552,
 1047398526,
 9225,
 -49551,
 1047484495,
 9245,
 -1,
 1047533658,
 9222,
 -1,
 1044162249,
 9007,
 1047805692,
 1033195403,
 -1,
 1047871214,
 1047755778,
 -1,
 1047936743,
 1047806641,
 -1,
 1048002248,
 1047887564,
 -1,
 1048067725,
 1047923324,
 -1,
 1048133253,
 1048029877,
 -1,
 1048198780,
 1048096706,
 -1,
 -49541,
 1048126881,
 3495,
 -1,
 1048187956,
 3501,
 1048395391,
 1048126784,
 -1,
 -49538,
 1048318279,
 3497,
 -1,
 1048384564,
 3503,
 -49536,
 1048328450,
 3508,
 -49535,
 1048520541,
 3482,
 -49534,
 1048596899,
 3490,
 -49533,
 1048665827,
 3484,
 -49532,
 1048708607,
 3488,
 -1,
 1048803586,
 3510,
 1048985224,
 1048063697,
 -1,
 -49529,
 1048911298,
 3463,
 -1,
 1048973989,
 3464,
 -49527,
 1048911298,
 3461,
 -49526,
 1049117547,
 3478,
 -49525,
 1049202599,
 3513,
 -49524,
 1049233829,
 3475,
 -1,
 1049302068,
 3462,
 1049509537,
 1048015620,
 -1,
 1049575069,
 1049430652,
 -1,
 1049640604,
 1049513365,
 -1,
 1049706131,
 1049604034,
 -1,
 -49518,
 1049634209,
 3496,
 -1,
 1049695284,
 3502,
 1049902742,
 1049634112,
 -1,
 -49515,
 1049825607,
 3498,
 -1,
 1049891892,
 3504,
 -49513,
 1049835778,
 3509,
 -49512,
 1050027869,
 3483,
 -49511,
 1050104227,
 3491,
 -49510,
 1050173155,
 3485,
 -49509,
 1050215935,
 3489,
 -1,
 1050310914,
 3511,
 -1,
 1049566658,
 3512,
 1050607615,
 1049517930,
 -1,
 -49505,
 1050516131,
 3522,
 -49504,
 1050564979,
 3499,
 -1,
 1050642310,
 3525,
 1050820266,
 1049448331,
 -1,
 1050885797,
 1050753925,
 -1,
 -49500,
 1050811842,
 3469,
 -1,
 1050887019,
 3470,
 1051082408,
 1050806837,
 -1,
 -49497,
 1051008450,
 3471,
 -1,
 1051083627,
 3472,
 -49495,
 1051008450,
 3465,
 -1,
 1051199909,
 3466,
 1051410096,
 1050744773,
 -1,
 1051475630,
 1051338048,
 -1,
 -49491,
 1051398471,
 3500,
 -1,
 1051464756,
 3507,
 -49489,
 1051414947,
 3494,
 -1,
 1051614947,
 3487,
 1051803317,
 1051346714,
 -1,
 1051868852,
 1051747651,
 -1,
 -49485,
 1051794882,
 3521,
 -1,
 1051889247,
 3493,
 -1,
 1051801979,
 3492,
 1052131001,
 1051741041,
 -1,
 -49481,
 1052088995,
 3523,
 -49480,
 1052137843,
 3505,
 -1,
 1052215174,
 3517,
 1052393148,
 1052096696,
 -1,
 -49477,
 1052319170,
 3467,
 -1,
 1052394347,
 3468,
 1052589759,
 1052325218,
 -1,
 -49474,
 1052515778,
 3476,
 -1,
 1052590987,
 3477,
 1052786370,
 1052520145,
 -1,
 -49471,
 1052712386,
 3473,
 -1,
 1052775077,
 3474,
 -49469,
 1052711314,
 3514,
 -49468,
 1052915649,
 3520,
 -49467,
 1052975484,
 3515,
 -49466,
 1053075698,
 3486,
 -49465,
 1053104608,
 3524,
 -1,
 1053182695,
 3526,
 1053376225,
 1047941363,
 -1,
 1053441749,
 1053319280,
 -1,
 1053507281,
 1053398556,
 -1,
 1053572816,
 1053434458,
 3545,
 1053687807,
 1053512107,
 -1,
 -49458,
 1053582662,
 3550,
 -49457,
 1053624265,
 3549,
 -1,
 1053724238,
 3548,
 -1,
 1053520263,
 3547,
 1054015487,
 1053466884,
 -1,
 -49453,
 1053907432,
 3540,
 -49452,
 1053976266,
 3538,
 -1,
 1054015990,
 3536,
 1054228189,
 1053392181,
 -1,
 1054293721,
 1054146972,
 -1,
 -49448,
 1054221851,
 3571,
 -1,
 1054278620,
 3570,
 -49446,
 1054235112,
 3542,
 -49445,
 1054418562,
 3546,
 -49444,
 1054500554,
 3539,
 -1,
 1054540278,
 3537,
 1054752480,
 1054146972,
 -1,
 -49441,
 1054680603,
 3551,
 -1,
 1054737372,
 3544,
 -1,
 1054707278,
 3535,
 1055014630,
 1053326540,
 -1,
 1055080165,
 1054935676,
 -1,
 -49436,
 1055011295,
 3458,
 -1,
 1055111254,
 3530,
 -1,
 1055036824,
 3459,
 -1,
 1054963570,
 3572,
 1055407853,
 1047894806,
 -1,
 1055473387,
 1055353437,
 -1,
 -49430,
 1055411678,
 8218,
 -1,
 1055496466,
 8249,
 -49428,
 1055416702,
 8250,
 -1,
 1055596220,
 8219,
 -1,
 1055327164,
 8767,
 1055866614,
 1047795839,
 -1,
 1055932146,
 1055786653,
 -1,
 -49423,
 1055868976,
 10909,
 -1,
 1055953356,
 10910,
 1056128757,
 1055894770,
 -1,
 -49420,
 1056063819,
 10911,
 -1,
 1056122306,
 10912,
 -1,
 1056066127,
 10860,
 1056440319,
 1055791547,
 -1,
 1056456442,
 1056351639,
 -1,
 -49415,
 1056405338,
 10038,
 -1,
 1056474853,
 10046,
 -49413,
 1056418939,
 10042,
 -1,
 1056585896,
 8198,
 1056784236,
 1047771320,
 -1,
 1056849709,
 1056708799,
 -1,
 1056915222,
 1056781799,
 -1,
 1056980740,
 1056860765,
 -1,
 1057046275,
 1056942696,
 -1,
 -49406,
 1056996354,
 8319,
 -1,
 1057050507,
 8305,
 -1,
 1057003645,
 8317,
 1057308423,
 1056944066,
 -1,
 -49402,
 1057244780,
 178,
 -1,
 1057309615,
 179,
 1057505034,
 1057245975,
 -1,
 -49399,
 1057443679,
 8310,
 -1,
 1057491013,
 8311,
 1057701645,
 1057437567,
 -1,
 -49396,
 1057645492,
 8308,
 -1,
 1057719484,
 8309,
 1057898256,
 1057631953,
 -1,
 -49393,
 1057858214,
 8316,
 -1,
 1057920525,
 8312,
 -49391,
 1057824694,
 8304,
 -49390,
 1058035863,
 8318,
 -49389,
 1058103078,
 8314,
 -49388,
 1058146856,
 185,
 -49387,
 1058252310,
 8313,
 -1,
 1058284674,
 8315,
 1058537471,
 1056841840,
 -1,
 1058553633,
 1058439597,
 8835,
 1058668543,
 1058495687,
 -1,
 1058684702,
 1058581746,
 -1,
 -49381,
 1058634984,
 10952,
 -49380,
 1058688326,
 10956,
 -49379,
 1058742501,
 10950,
 -1,
 1058825519,
 10954,
 1059012384,
 1058612183,
 8839,
 -1,
 1058962510,
 10948,
 -1,
 1058964933,
 8843,
 1059208997,
 1058478652,
 -1,
 -49373,
 1059167019,
 10944,
 -49372,
 1059239308,
 10946,
 -1,
 1059292038,
 10942,
 1059471146,
 1059171570,
 -1,
 1059536681,
 1059415286,
 -1,
 -49368,
 1059475073,
 10966,
 -1,
 1059565700,
 10964,
 -1,
 1059497443,
 10619,
 1059848191,
 1059406709,
 -1,
 -49364,
 1059742337,
 10967,
 -1,
 1059791354,
 10968,
 1059995478,
 1056771219,
 -1,
 1060060994,
 1059927527,
 -1,
 1060126514,
 1060024258,
 -1,
 -49359,
 1060062828,
 8322,
 -1,
 1060127663,
 8323,
 1060323125,
 1060064023,
 -1,
 -49356,
 1060261727,
 8326,
 -1,
 1060309061,
 8327,
 1060519736,
 1060255615,
 -1,
 -49353,
 1060463540,
 8324,
 -1,
 1060537532,
 8325,
 1060716347,
 1060450001,
 -1,
 -49350,
 1060676262,
 8332,
 -1,
 1060738573,
 8328,
 -49348,
 1060642742,
 8320,
 -49347,
 1060853911,
 8334,
 -49346,
 1060921126,
 8330,
 -49345,
 1060964904,
 8321,
 -49344,
 1061070358,
 8329,
 -49343,
 1061102722,
 8331,
 -1,
 1061171907,
 8333,
 1061421055,
 1059987568,
 -1,
 1061437261,
 1061323181,
 8834,
 1061552127,
 1061379271,
 -1,
 1061568330,
 1061465330,
 -1,
 -49337,
 1061518568,
 10951,
 -49336,
 1061571910,
 10955,
 -49335,
 1061626085,
 10949,
 -1,
 1061709103,
 10953,
 1061896012,
 1061495767,
 8838,
 -1,
 1061846094,
 10947,
 -1,
 1061848517,
 8842,
 1062092625,
 1061362236,
 -1,
 -49329,
 1062050603,
 10943,
 -49328,
 1062122892,
 10945,
 -1,
 1062175622,
 10941,
 1062404095,
 1062055154,
 -1,
 1062420309,
 1062298870,
 -1,
 -49324,
 1062358657,
 10963,
 -1,
 1062449284,
 10965,
 -1,
 1062376380,
 10617,
 1062682470,
 1059935189,
 8827,
 1062797311,
 1062624455,
 -1,
 1062813537,
 1062710514,
 -1,
 1062879068,
 1062773999,
 -1,
 -49317,
 1062817094,
 10930,
 -1,
 1062871269,
 10928,
 1063075679,
 1062832372,
 -1,
 -49314,
 1063017754,
 10934,
 -1,
 1063085359,
 10938,
 -49312,
 1063002341,
 10932,
 -1,
 1063216431,
 10936,
 1063403364,
 1062749619,
 -1,
 -49309,
 1063345575,
 8831,
 -1,
 1063390915,
 8829,
 -49307,
 1063348915,
 8881,
 -1,
 1063526828,
 8937,
 1063731050,
 1062636872,
 -1,
 -49304,
 1063696707,
 10763,
 -49303,
 1063752890,
 9138,
 -1,
 1063823202,
 9139,
 -49301,
 1063663395,
 8751,
 -1,
 1063943170,
 9737,
 1064124349,
 1056717177,
 -1,
 1064189873,
 1064045180,
 -1,
 1064255404,
 1064118978,
 -1,
 1064320889,
 1064176252,
 -1,
 1064386419,
 1064245003,
 -1,
 -49294,
 1064343814,
 66684,
 -1,
 1064382161,
 66680,
 -49292,
 1064322598,
 66679,
 -49291,
 1064527125,
 66664,
 -49290,
 1064587155,
 66682,
 -49289,
 1064647033,
 66669,
 -49288,
 1064711288,
 66673,
 -1,
 1064780658,
 66665,
 1064976256,
 1064252770,
 -1,
 -49285,
 1064940362,
 66668,
 -49284,
 1064965899,
 66681,
 -49283,
 1065048191,
 66677,
 -49282,
 1065122818,
 66666,
 -49281,
 1065177026,
 66678,
 -1,
 1065243868,
 66676,
 1065435014,
 1064906449,
 -1,
 1065500548,
 1065355900,
 -1,
 -49277,
 1065463746,
 66672,
 -1,
 1065490187,
 66685,
 -49275,
 1065434018,
 66683,
 -1,
 1065615753,
 66663,
 1065828235,
 1065398210,
 -1,
 1065893770,
 1065761145,
 -1,
 -49271,
 1065849122,
 66644,
 -1,
 1065902649,
 66654,
 -1,
 1065816820,
 66641,
 1066155919,
 1065766795,
 -1,
 -49267,
 1066088319,
 66662,
 -49266,
 1066147741,
 66674,
 -1,
 1066240511,
 66686,
 1066418066,
 1066112195,
 -1,
 -49263,
 1066340664,
 66687,
 -1,
 1066404476,
 66648,
 1066614677,
 1066354284,
 -1,
 -49260,
 1066566023,
 66667,
 -1,
 1066610385,
 66658,
 1066811288,
 1066552087,
 -1,
 -49257,
 1066756642,
 66646,
 -1,
 1066808674,
 66645,
 1067007899,
 1066758916,
 -1,
 -49254,
 1066934222,
 66661,
 -1,
 1067036778,
 66656,
 1067204510,
 1066940793,
 -1,
 -49251,
 1067163355,
 66649,
 -1,
 1067188935,
 66659,
 -49249,
 1067165443,
 66655,
 -49248,
 1067345215,
 66653,
 -49247,
 1067422927,
 66675,
 -49246,
 1067495600,
 66670,
 -49245,
 1067518356,
 66640,
 -49244,
 1067621939,
 66671,
 -49243,
 1067667238,
 66660,
 -49242,
 1067728255,
 66642,
 -49241,
 1067823204,
 66657,
 -49240,
 1067887648,
 66652,
 -49239,
 1067955520,
 66643,
 -49238,
 1068004983,
 66651,
 -49237,
 1068083289,
 66647,
 -1,
 1068114953,
 66650,
 1068318640,
 1064201432,
 -1,
 -49234,
 1068276408,
 10032,
 -49233,
 1068303976,
 10014,
 -1,
 1068398401,
 10061,
 -1,
 1068240779,
 9752,
 1068646332,
 1064121698,
 -1,
 1068711867,
 1068580673,
 -1,
 1068777399,
 1068676468,
 10976,
 1068892159,
 1068719303,
 -1,
 -49226,
 1068781687,
 10984,
 -1,
 1068833256,
 10985,
 1069039545,
 1068741572,
 10975,
 -1,
 1068979365,
 10983,
 -49222,
 1068965047,
 10564,
 -1,
 1069102182,
 10974,
 -1,
 1068658273,
 9085,
 -1,
 1068611888,
 10722,
 1069432843,
 1064071940,
 -1,
 1069498378,
 1069353596,
 -1,
 1069563913,
 1069419524,
 -1,
 1069629447,
 1069505735,
 -1,
 1069694943,
 1069553419,
 -1,
 1069760474,
 1069613398,
 -1,
 1069825993,
 1069723586,
 -1,
 1069891527,
 1069748536,
 -1,
 -49210,
 1069823330,
 8561,
 -1,
 1069880635,
 8571,
 -49208,
 1069826991,
 8562,
 -1,
 1070034098,
 8569,
 1070219215,
 1069758335,
 -1,
 1070284750,
 1070157707,
 -1,
 1070350285,
 1070211677,
 8564,
 -1,
 1070304711,
 8574,
 -1,
 1070295559,
 8572,
 -1,
 1070228404,
 8563,
 1070612435,
 1070139944,
 8560,
 1070727167,
 1070554311,
 -1,
 -49198,
 1070609699,
 8575,
 -1,
 1070668625,
 8573,
 1070874582,
 1070549783,
 -1,
 -49195,
 1070813023,
 8565,
 -1,
 1070860357,
 8566,
 1071071193,
 1070804689,
 -1,
 -49192,
 1071007679,
 8570,
 -1,
 1071093261,
 8567,
 -1,
 1071031830,
 8568,
 1071333342,
 1069722190,
 -1,
 -49188,
 1071267429,
 65118,
 -49187,
 1071345705,
 65114,
 -1,
 1071417459,
 65116,
 -1,
 1071284410,
 65128,
 1071661031,
 1069625041,
 -1,
 1071726564,
 1071607920,
 8714,
 1071841279,
 1071656388,
 -1,
 -49181,
 1071722473,
 8948,
 -1,
 1071788964,
 8951,
 -49179,
 1071652495,
 65111,
 -49178,
 1071948454,
 65126,
 -1,
 1071998330,
 65112,
 1072185329,
 1071587182,
 -1,
 1072250861,
 1072122729,
 -1,
 1072316396,
 1072175676,
 -1,
 -49173,
 1072246761,
 8956,
 -1,
 1072313252,
 8958,
 -1,
 1072243570,
 8717,
 1072578544,
 1072182705,
 -1,
 -49169,
 1072524679,
 65131,
 -1,
 1072564860,
 65104,
 -1,
 1072510978,
 65109,
 1072840695,
 1072105925,
 -1,
 1072906230,
 1072795555,
 -1,
 -49164,
 1072840293,
 65117,
 -49163,
 1072918569,
 65113,
 -1,
 1072990323,
 65115,
 -1,
 1072845123,
 65124,
 1073233914,
 1072794828,
 -1,
 -49159,
 1073160218,
 65122,
 -1,
 1073259117,
 65130,
 1073430525,
 1073154684,
 -1,
 -49156,
 1073376325,
 65121,
 -1,
 1073415436,
 65120,
 -49154,
 1073362061,
 10849,
 -49153,
 1073579808,
 732,
 -49152,
 1073631847,
 65108,
 -49151,
 1073683833,
 65110,
 -49150,
 1073769304,
 65119,
 -49149,
 1073841099,
 65105,
 -49148,
 1073903549,
 65123,
 -49147,
 1073963586,
 65125,
 -49146,
 1074020855,
 65106,
 -1,
 1074114325,
 65129,
 1074331647,
 1069587074,
 10922,
 -1,
 1074226268,
 10924,
 -1,
 1069503748,
 10803,
 -1,
 1069435749,
 8995,
 1074544678,
 1069364578,
 -1,
 1074610209,
 1074510008,
 -1,
 1074675744,
 1074542681,
 -1,
 1074741272,
 1074623696,
 -1,
 1074806805,
 1074704324,
 8600,
 1074921471,
 1074748615,
 -1,
 -49134,
 1074833640,
 10533,
 -49133,
 1074884956,
 8690,
 -49132,
 1074943940,
 10541,
 -1,
 1075009642,
 10537,
 -49130,
 1074758236,
 11010,
 -49129,
 1075155321,
 8664,
 -1,
 1075202952,
 11018,
 1075445759,
 1074678776,
 -1,
 1075462173,
 1075359684,
 8601,
 1075576831,
 1075403975,
 -1,
 -49124,
 1075489000,
 10534,
 -1,
 1075525390,
 10538,
 -49122,
 1075413596,
 11011,
 -49121,
 1075679609,
 8665,
 -1,
 1075727240,
 11019,
 -1,
 1074623542,
 8471,
 1075986467,
 1074547439,
 47,
 -1,
 1075926181,
 10742,
 1076166655,
 1075941822,
 -1,
 -49115,
 1076052076,
 9108,
 -1,
 1076101524,
 173,
 1076314171,
 1074469941,
 -1,
 1076379705,
 1076238091,
 -1,
 1076445240,
 1076306740,
 -1,
 1076510771,
 1076406786,
 -1,
 -49109,
 1076434699,
 8475,
 -49108,
 1076530380,
 8472,
 -49107,
 1076589316,
 8499,
 -49106,
 1076652637,
 8466,
 -49105,
 1076711307,
 8464,
 -49104,
 1076771193,
 8459,
 -49103,
 1076836223,
 8497,
 -49102,
 1076899537,
 8496,
 -1,
 1076958065,
 8492,
 1077215231,
 1076468616,
 -1,
 -49099,
 1077097826,
 8500,
 -49098,
 1077176925,
 8467,
 -49097,
 1077231429,
 8458,
 -1,
 1077292753,
 8495,
 -1,
 1076397077,
 8456,
 -49094,
 1076303225,
 9807,
 -1,
 1077521452,
 9878,
 1077690441,
 1076277186,
 -1,
 1077755974,
 1077611132,
 -1,
 1077821507,
 1077689497,
 -1,
 1077887041,
 1077753186,
 -1,
 -49088,
 1077840168,
 8902,
 -1,
 1077893715,
 10017,
 -49086,
 1077842027,
 8795,
 -1,
 1078009223,
 9770,
 1078263807,
 1077779618,
 -1,
 -49083,
 1078169321,
 9882,
 -1,
 1078207982,
 9877,
 1078460415,
 1077679883,
 -1,
 -49080,
 1078352488,
 8803,
 -1,
 1078404456,
 10025,
 1078607956,
 1077620433,
 -1,
 1078673485,
 1078539727,
 -1,
 -49076,
 1078603563,
 10802,
 -1,
 1078678724,
 59,
 1078870096,
 1078599692,
 -1,
 -49073,
 1078821392,
 8980,
 -1,
 1078883999,
 167,
 -49071,
 1078833649,
 8726,
 -49070,
 1079004158,
 65093,
 -49069,
 1079051701,
 8480,
 -1,
 1079148614,
 8979,
 1079328863,
 1078553181,
 -1,
 1079394394,
 1079277043,
 -1,
 1079459928,
 1079330864,
 10901,
 -1,
 1079381278,
 10903,
 1079640063,
 1079415244,
 10902,
 -1,
 1079512350,
 10904,
 1079771135,
 1079345710,
 -1,
 1079787614,
 1079676157,
 -1,
 -49059,
 1079738896,
 10839,
 -1,
 1079802339,
 10840,
 -1,
 1079717585,
 9011,
 1080049767,
 1079282892,
 -1,
 1080115300,
 1080012177,
 8738,
 1080229887,
 1080061005,
 -1,
 -49053,
 1080136911,
 10657,
 -1,
 1080189899,
 10656,
 1080426495,
 1080035964,
 -1,
 -49050,
 1080336579,
 10055,
 -1,
 1080369053,
 32,
 1080574059,
 1079970428,
 -1,
 -49047,
 1080524912,
 9796,
 -49046,
 1080576675,
 9747,
 -1,
 1080634099,
 9808,
 1080836206,
 1080493504,
 -1,
 -49043,
 1080754874,
 9731,
 -1,
 1080835045,
 10052,
 -49041,
 1080794784,
 8275,
 -49040,
 1080993915,
 9760,
 -1,
 1081045181,
 10700,
 1081230295,
 1013014640,
 -1,
 1081295519,
 1081150076,
 -1,
 1081360916,
 1081244674,
 -1,
 1081426342,
 1081283375,
 -1,
 1081491626,
 1081363223,
 -1,
 1081557119,
 1081454530,
 -1,
 1081622651,
 1081488738,
 -1,
 1081688186,
 1081576652,
 12108,
 -1,
 1081638687,
 12169,
 -1,
 1081628529,
 12143,
 1081884798,
 1081552593,
 -1,
 -49027,
 1081838796,
 12091,
 -1,
 1081880103,
 12115,
 -1,
 1081833955,
 12148,
 1082146950,
 1081511116,
 -1,
 1082212483,
 1082076881,
 -1,
 -49022,
 1082135325,
 12180,
 -1,
 1082231312,
 12141,
 -49020,
 1082142750,
 12076,
 -49019,
 1082374499,
 12052,
 -1,
 1082395093,
 12144,
 1082605711,
 1082079609,
 -1,
 1082671244,
 1082537314,
 -1,
 1082736779,
 1082632980,
 -1,
 -49014,
 1082665454,
 12083,
 -1,
 1082767697,
 12203,
 -1,
 1082659572,
 12087,
 1083047935,
 1082601169,
 -1,
 -49010,
 1082919940,
 12185,
 -1,
 1083010375,
 12154,
 1083195540,
 1082535633,
 -1,
 -49007,
 1083114684,
 12163,
 -49006,
 1083190993,
 12178,
 -49005,
 1083253845,
 12036,
 -1,
 1083345382,
 12057,
 1083523225,
 1083140701,
 -1,
 1083588760,
 1083443836,
 -1,
 -49001,
 1083515485,
 12202,
 -1,
 1083598101,
 12035,
 -1,
 1083529981,
 12122,
 1083850909,
 1083443836,
 -1,
 -48997,
 1083777748,
 12104,
 -48996,
 1083836978,
 12228,
 -1,
 1083945469,
 12223,
 1084113056,
 1083789195,
 -1,
 -48993,
 1084046147,
 12151,
 -1,
 1084116248,
 12135,
 1084309667,
 1084038197,
 -1,
 -48990,
 1084265662,
 12098,
 -1,
 1084338122,
 12064,
 -48988,
 1084239055,
 12130,
 -48987,
 1084470124,
 12103,
 -48986,
 1084511716,
 12101,
 -48985,
 1084568742,
 12211,
 -48984,
 1084652476,
 12089,
 -48983,
 1084704580,
 12073,
 -1,
 1084768045,
 12138,
 1084965058,
 1081419072,
 -1,
 1085030581,
 1084896610,
 -1,
 1085096112,
 1084993474,
 12034,
 1085210623,
 1085060629,
 -1,
 -48977,
 1085112154,
 12136,
 -1,
 1085188377,
 12084,
 -48975,
 1085059165,
 12044,
 -48974,
 1085291596,
 12120,
 -48973,
 1085374992,
 12094,
 -48972,
 1085423429,
 12125,
 -1,
 1085498375,
 12111,
 1085685947,
 1084968843,
 -1,
 1085751481,
 1085623063,
 -1,
 -48968,
 1085693608,
 12196,
 -1,
 1085749625,
 12139,
 -48966,
 1085700488,
 12056,
 -1,
 1085884539,
 12099,
 1086079167,
 1085609739,
 -1,
 -48963,
 1086005972,
 12082,
 -48962,
 1086108515,
 12238,
 -1,
 1086138140,
 12243,
 1086390271,
 1086009041,
 -1,
 -48959,
 1086287178,
 12229,
 -1,
 1086328374,
 12109,
 1086537945,
 1084887921,
 -1,
 1086603465,
 1086469474,
 -1,
 -48955,
 1086525752,
 12088,
 -48954,
 1086609265,
 12219,
 -48953,
 1086678216,
 12134,
 -48952,
 1086735292,
 12189,
 -1,
 1086818838,
 12168,
 1086996685,
 1086527243,
 -1,
 -48949,
 1086958102,
 12160,
 -48948,
 1087026767,
 12090,
 -1,
 1087093009,
 12096,
 1087258833,
 1086941789,
 -1,
 -48945,
 1087215139,
 12205,
 -48944,
 1087289622,
 12174,
 -1,
 1087342950,
 12234,
 1087520981,
 1087197067,
 -1,
 -48941,
 1087481198,
 12191,
 -48940,
 1087547512,
 12227,
 -1,
 1087586117,
 12068,
 1087783128,
 1087441532,
 -1,
 -48937,
 1087701937,
 12149,
 -1,
 1087769985,
 12184,
 -1,
 1087712792,
 12182,
 1088045294,
 1086500802,
 -1,
 1088110814,
 1087969035,
 -1,
 -48932,
 1088050213,
 12237,
 -48931,
 1088122051,
 12106,
 -1,
 1088194918,
 12145,
 1088372962,
 1088031356,
 -1,
 -48928,
 1088332368,
 12209,
 -48927,
 1088359428,
 12220,
 -1,
 1088429602,
 12047,
 1088635108,
 1088308844,
 12038,
 -1,
 1088564315,
 12086,
 1088766183,
 1088598880,
 -1,
 -48922,
 1088713823,
 12244,
 -1,
 1088764147,
 12081,
 1088962794,
 1088697698,
 -1,
 -48919,
 1088910161,
 12242,
 -1,
 1088946809,
 12166,
 1089159405,
 1088901003,
 -1,
 -48916,
 1089079749,
 12129,
 -1,
 1089173585,
 12172,
 -1,
 1089105074,
 12055,
 1089421569,
 1087977343,
 -1,
 1089487092,
 1089359755,
 -1,
 -48911,
 1089430805,
 12226,
 -48910,
 1089485794,
 12117,
 -48909,
 1089562725,
 12222,
 -1,
 1089642965,
 12133,
 1089814776,
 1089407612,
 -1,
 -48906,
 1089775724,
 12119,
 -48905,
 1089820532,
 12123,
 -1,
 1089871773,
 12207,
 1090076923,
 1089738507,
 -1,
 -48902,
 1090027946,
 12236,
 -1,
 1090081510,
 12217,
 1090273534,
 1090021981,
 -1,
 -48899,
 1090200276,
 12214,
 -1,
 1090277255,
 12245,
 -48897,
 1090237280,
 12113,
 -48896,
 1090435459,
 12188,
 -1,
 1090456682,
 12155,
 1090666772,
 1089346613,
 -1,
 1090732296,
 1090598242,
 -1,
 -48892,
 1090654520,
 12124,
 -48891,
 1090727386,
 12045,
 -48890,
 1090789397,
 12075,
 -48889,
 1090862872,
 12112,
 -1,
 1090920742,
 12170,
 1091125518,
 1090677341,
 -1,
 1091191052,
 1091046012,
 -1,
 -48885,
 1091113272,
 12118,
 -1,
 1091206146,
 12114,
 -48883,
 1091135334,
 12176,
 -1,
 1091345191,
 12058,
 1091518738,
 1091046012,
 -1,
 -48880,
 1091445341,
 12147,
 -48879,
 1091527785,
 12224,
 -1,
 1091582850,
 12190,
 -48877,
 1091443824,
 12194,
 -1,
 1091699261,
 12070,
 1091911976,
 1090588984,
 -1,
 1091977497,
 1091832444,
 -1,
 1092043032,
 1091910467,
 12193,
 -1,
 1091966571,
 12175,
 -1,
 1091971961,
 12116,
 1092239644,
 1091901195,
 -1,
 -48869,
 1092160033,
 12206,
 -1,
 1092258306,
 12051,
 1092436255,
 1092171106,
 -1,
 -48866,
 1092369403,
 12079,
 -1,
 1092420282,
 12069,
 1092632866,
 1092374478,
 -1,
 -48863,
 1092562641,
 12195,
 -1,
 1092625728,
 12213,
 1092829477,
 1092565369,
 -1,
 -48860,
 1092754089,
 12137,
 -1,
 1092824728,
 12230,
 1093074943,
 1092759249,
 -1,
 -48857,
 1092969721,
 12177,
 -1,
 1093033910,
 12110,
 1093222714,
 1091859204,
 -1,
 1093288243,
 1093154146,
 -1,
 1093353775,
 1093253304,
 -1,
 1093419310,
 1093303298,
 -1,
 -48851,
 1093368934,
 12077,
 -1,
 1093412160,
 12201,
 -1,
 1093358209,
 12061,
 1093681458,
 1093277451,
 -1,
 -48847,
 1093623027,
 12165,
 -1,
 1093707298,
 12192,
 -1,
 1093632385,
 12105,
 1093943606,
 1093226379,
 -1,
 -48843,
 1093871636,
 12162,
 -1,
 1093934751,
 12233,
 1094140217,
 1093873361,
 -1,
 -48840,
 1094072322,
 12128,
 -1,
 1094158870,
 12161,
 -1,
 1094093311,
 12040,
 1094402378,
 1093167709,
 -1,
 1094467905,
 1094332113,
 -1,
 1094533439,
 1094388348,
 -1,
 -48834,
 1094494316,
 12208,
 -1,
 1094530943,
 12212,
 -48832,
 1094451556,
 12041,
 -1,
 1094675643,
 12210,
 1094861125,
 1094406027,
 -1,
 -48829,
 1094801265,
 12033,
 -48828,
 1094881784,
 12131,
 -1,
 1094919488,
 12039,
 1095123271,
 1094781473,
 12199,
 -1,
 1095055064,
 12085,
 1095303167,
 1095043708,
 -1,
 -48823,
 1095185807,
 12074,
 -1,
 1095245662,
 12107,
 1095450972,
 1094334841,
 -1,
 1095516497,
 1095371388,
 -1,
 1095582031,
 1095461469,
 -1,
 -48818,
 1095524017,
 12121,
 -1,
 1095611079,
 12093,
 -48816,
 1095535602,
 12095,
 -1,
 1095716755,
 12221,
 1095909718,
 1095447906,
 -1,
 1095975253,
 1095833355,
 -1,
 -48812,
 1095918935,
 12218,
 -1,
 1095990274,
 12179,
 -1,
 1095926154,
 12037,
 1096237403,
 1095839441,
 -1,
 1096302938,
 1096157820,
 -1,
 -48807,
 1096235906,
 12092,
 -1,
 1096295744,
 12216,
 -1,
 1096252980,
 12231,
 -1,
 1096163492,
 12054,
 1096630633,
 1095380689,
 -1,
 1096696161,
 1096551036,
 -1,
 1096761696,
 1096619787,
 12159,
 -1,
 1096700545,
 12063,
 -1,
 1096724418,
 12215,
 1096958307,
 1096639563,
 12241,
 -1,
 1096889888,
 12067,
 1097089382,
 1096907778,
 -1,
 -48795,
 1097018233,
 12042,
 -1,
 1097079098,
 12062,
 -48793,
 1097045187,
 12140,
 -48792,
 1097220050,
 12235,
 -1,
 1097307661,
 12043,
 1097482613,
 1096554251,
 -1,
 1097548142,
 1097420683,
 -1,
 -48788,
 1097477594,
 12078,
 -48787,
 1097531905,
 12053,
 -1,
 1097605021,
 12150,
 1097810290,
 1097468540,
 -1,
 -48784,
 1097772994,
 12239,
 -48783,
 1097829580,
 12097,
 -1,
 1097879502,
 12204,
 -48781,
 1097773932,
 12187,
 -48780,
 1098037548,
 12071,
 -1,
 1098083526,
 12186,
 1098269054,
 1097416517,
 -1,
 1098334585,
 1098200418,
 12065,
 -48776,
 1098254786,
 12198,
 -1,
 1098321660,
 12066,
 1098531196,
 1098295612,
 -1,
 -48773,
 1098474677,
 12171,
 -1,
 1098534862,
 12146,
 -48771,
 1098486626,
 12225,
 -1,
 1098662017,
 12200,
 1098858885,
 1098222796,
 -1,
 1098924418,
 1098782475,
 -1,
 -48767,
 1098850461,
 12126,
 -1,
 1098909623,
 12059,
 -48765,
 1098844550,
 12050,
 -48764,
 1099047247,
 12158,
 -1,
 1099124711,
 12183,
 1099317644,
 1098790242,
 -1,
 1099383177,
 1099271372,
 -1,
 -48760,
 1099343033,
 12167,
 -1,
 1099379906,
 12048,
 1099579787,
 1099323249,
 12032,
 -1,
 1099523435,
 12080,
 -1,
 1099499970,
 12156,
 1099776403,
 1099238012,
 -1,
 1099841936,
 1099709346,
 -1,
 -48753,
 1099792876,
 12142,
 -1,
 1099859132,
 12164,
 -48751,
 1099792125,
 12100,
 -48750,
 1099992050,
 12157,
 -1,
 1100045441,
 12060,
 1100235160,
 1099725826,
 -1,
 1100300695,
 1100166498,
 -1,
 -48746,
 1100263362,
 12102,
 -1,
 1100309847,
 12240,
 -1,
 1100246337,
 12153,
 1100562845,
 1100173195,
 -1,
 1100628380,
 1100512258,
 -1,
 -48741,
 1100573027,
 12173,
 -1,
 1100619627,
 12072,
 -1,
 1100554141,
 12046,
 1100890528,
 1100482587,
 -1,
 -48737,
 1100819915,
 12197,
 -1,
 1100915659,
 12181,
 1101087139,
 1100838188,
 -1,
 -48734,
 1101010699,
 12152,
 -1,
 1101087647,
 12127,
 -48732,
 1101012929,
 12232,
 -48731,
 1101224209,
 12132,
 -1,
 1101310213,
 12049,
 1101529087,
 1081389258,
 -1,
 1101545966,
 1101400517,
 -1,
 1101611501,
 1101494199,
 -1,
 1101676976,
 1101531163,
 -1,
 1101742511,
 1101626402,
 -1,
 1101808045,
 1101666059,
 3211,
 -1,
 1101731595,
 3296,
 1101987839,
 1101752925,
 3212,
 -1,
 1101883997,
 3297,
 -1,
 1101662844,
 3253,
 1102135734,
 1101639618,
 -1,
 1102201268,
 1102098370,
 -1,
 -48717,
 1102129052,
 3232,
 -1,
 1102187132,
 3231,
 -48715,
 1102129052,
 3237,
 -1,
 1102318204,
 3236,
 1102528955,
 1102085122,
 -1,
 -48712,
 1102484126,
 3230,
 -48711,
 1102546842,
 3235,
 -48710,
 1102578076,
 3225,
 -1,
 1102645884,
 3240,
 1102856641,
 1102456128,
 -1,
 1102922175,
 1102783808,
 -1,
 -48706,
 1102849948,
 3234,
 -1,
 1102908028,
 3233,
 -48704,
 1102849948,
 3239,
 -1,
 1103039100,
 3238,
 1103249861,
 1102776956,
 3205,
 -48701,
 1103214776,
 3220,
 -48700,
 1103253387,
 3216,
 -1,
 1103301244,
 3206,
 1103512009,
 1103186711,
 -1,
 -48697,
 1103455555,
 3255,
 -48696,
 1103505308,
 3254,
 -1,
 1103563388,
 3256,
 1103774155,
 1103476920,
 3209,
 -1,
 1103739064,
 3210,
 1103905230,
 1103697675,
 -1,
 -48691,
 1103866172,
 3249,
 -1,
 1103891068,
 3248,
 1104101841,
 1103858892,
 -1,
 -48688,
 1104029596,
 3243,
 -1,
 1104087676,
 3242,
 1104298451,
 1104033122,
 3218,
 -1,
 1104229730,
 3219,
 1104429526,
 1104243293,
 -1,
 -48683,
 1104349658,
 3251,
 -1,
 1104415356,
 3250,
 1104626137,
 1104371824,
 -1,
 -48680,
 1104553884,
 3222,
 -1,
 1104611964,
 3221,
 1104822748,
 1104566268,
 -1,
 -48677,
 1104750492,
 3229,
 -1,
 1104808572,
 3228,
 1105019358,
 1104760715,
 3207,
 -1,
 1104957323,
 3208,
 1105150433,
 1104953157,
 -1,
 -48672,
 1105078172,
 3224,
 -1,
 1105136252,
 3223,
 1105347043,
 1105080017,
 3214,
 -1,
 1105276625,
 3215,
 1105478118,
 1105271861,
 -1,
 -48667,
 1105405852,
 3227,
 -1,
 1105463932,
 3226,
 1105674729,
 1105400689,
 -1,
 -48664,
 1105602460,
 3245,
 -1,
 1105660540,
 3244,
 -48662,
 1105629854,
 3247,
 -48661,
 1105802662,
 3246,
 -48660,
 1105864604,
 3257,
 -1,
 1105957342,
 3294,
 -1,
 1101532841,
 3285,
 1106199037,
 1101484275,
 -1,
 1106264563,
 1106119292,
 -1,
 -48655,
 1106229432,
 3276,
 -48654,
 1106268043,
 3272,
 -1,
 1106315900,
 3262,
 1106526709,
 1106198107,
 3267,
 -1,
 1106450187,
 3268,
 1106657783,
 1106491576,
 3265,
 -1,
 1106622648,
 3266,
 1106788857,
 1106589026,
 3274,
 -1,
 1106720098,
 3275,
 1106919931,
 1106726795,
 3263,
 -1,
 1106857867,
 3264,
 1107099647,
 1106849489,
 3270,
 -1,
 1106980561,
 3271,
 1107182091,
 1106158691,
 -1,
 1107247617,
 1107144642,
 -1,
 -48640,
 1107183212,
 3304,
 -1,
 1107248047,
 3305,
 1107444228,
 1107184407,
 -1,
 -48637,
 1107382111,
 3308,
 -1,
 1107429445,
 3309,
 1107640839,
 1107375999,
 -1,
 -48634,
 1107583924,
 3306,
 -1,
 1107657916,
 3307,
 -48632,
 1107566518,
 3302,
 -48631,
 1107757608,
 3303,
 -48630,
 1107863062,
 3311,
 -1,
 1107902187,
 3310,
 1108099603,
 1107131596,
 -1,
 1108165135,
 1108025960,
 -1,
 -48626,
 1108095535,
 3203,
 -1,
 1108161058,
 3277,
 1108361746,
 1108085372,
 -1,
 -48623,
 1108286302,
 3261,
 -1,
 1108383538,
 3202,
 -1,
 1108296683,
 3260,
 -1,
 1108047535,
 3286,
 1108738047,
 1081285206,
 -1,
 1108755098,
 1108630727,
 -1,
 1108820630,
 1108704972,
 -1,
 1108886080,
 1108757271,
 -1,
 1108951611,
 1108826398,
 -1,
 1109017119,
 1108875019,
 -1,
 -48613,
 1108981944,
 12797,
 -48612,
 1109013858,
 12799,
 -48611,
 1109086091,
 12796,
 -48610,
 1109143249,
 12798,
 -1,
 1109199484,
 12795,
 1109410341,
 1108949369,
 -1,
 -48607,
 1109375160,
 12791,
 -48606,
 1109407074,
 12793,
 -48605,
 1109479307,
 12790,
 -48604,
 1109536465,
 12792,
 -1,
 1109592700,
 12789,
 1109803561,
 1109336788,
 -1,
 -48601,
 1109768376,
 12517,
 -48600,
 1109800290,
 12519,
 -1,
 1109854844,
 12515,
 1110065709,
 1109745776,
 -1,
 -48597,
 1110030520,
 12784,
 -48596,
 1110060753,
 12534,
 -1,
 1110116988,
 12533,
 1110327856,
 1110028226,
 -1,
 -48593,
 1110292664,
 12483,
 -1,
 1110324578,
 12787,
 1110524467,
 1110264599,
 -1,
 -48590,
 1110489272,
 12786,
 -1,
 1110527883,
 12785,
 -48588,
 1110460005,
 12526,
 -48587,
 1110685880,
 12453,
 -48586,
 1110717794,
 12457,
 -48585,
 1110807906,
 12788,
 -48584,
 1110853715,
 12794,
 -48583,
 1110921099,
 12451,
 -48582,
 1110978257,
 12455,
 -1,
 1111034492,
 12449,
 -48580,
 1108916408,
 12473,
 -48579,
 1111176546,
 12477,
 -48578,
 1111248779,
 12471,
 -48577,
 1111305937,
 12475,
 -1,
 1111362172,
 12469,
 1111573062,
 1108835330,
 12531,
 -48574,
 1111537848,
 12492,
 -48573,
 1111569762,
 12494,
 -48572,
 1111641995,
 12491,
 -48571,
 1111699153,
 12493,
 -1,
 1111755388,
 12490,
 1111966284,
 1111501943,
 -1,
 -48568,
 1111931064,
 12474,
 -48567,
 1111962978,
 12478,
 -48566,
 1112035211,
 12472,
 -48565,
 1112092369,
 12476,
 -1,
 1112148604,
 12470,
 1112359506,
 1111885851,
 -1,
 -48562,
 1112324280,
 12532,
 -48561,
 1112356194,
 12538,
 -48560,
 1112428427,
 12536,
 -48559,
 1112485585,
 12537,
 -1,
 1112541820,
 12535,
 1112752728,
 1112321986,
 -1,
 -48556,
 1112717496,
 12484,
 -48555,
 1112749410,
 12488,
 -48554,
 1112821643,
 12481,
 -48553,
 1112878801,
 12486,
 -1,
 1112935036,
 12479,
 1113145950,
 1112676107,
 -1,
 -48550,
 1113110712,
 12523,
 -48549,
 1113142626,
 12525,
 -48548,
 1113214859,
 12522,
 -48547,
 1113272017,
 12524,
 -1,
 1113328252,
 12521,
 1113539172,
 1113099468,
 -1,
 -48544,
 1113503928,
 12503,
 -48543,
 1113535842,
 12509,
 -48542,
 1113608075,
 12500,
 -48541,
 1113665233,
 12506,
 -1,
 1113721468,
 12497,
 1113932394,
 1113486084,
 -1,
 -48538,
 1113897144,
 12512,
 -48537,
 1113929058,
 12514,
 -48536,
 1114001291,
 12511,
 -48535,
 1114058449,
 12513,
 -1,
 1114114684,
 12510,
 1114325616,
 1113874544,
 -1,
 -48532,
 1114290360,
 12463,
 -48531,
 1114322274,
 12467,
 -48530,
 1114394507,
 12461,
 -48529,
 1114451665,
 12465,
 -1,
 1114507900,
 12459,
 1114718838,
 1114257785,
 -1,
 -48526,
 1114683576,
 12501,
 -48525,
 1114715490,
 12507,
 -48524,
 1114787723,
 12498,
 -48523,
 1114844881,
 12504,
 -1,
 1114901116,
 12495,
 1115112060,
 1114652485,
 -1,
 -48520,
 1115076792,
 12464,
 -48519,
 1115108706,
 12468,
 -48518,
 1115180939,
 12462,
 -48517,
 1115238097,
 12466,
 -1,
 1115294332,
 12460,
 1115505282,
 1115039040,
 -1,
 -48514,
 1115470008,
 12485,
 -48513,
 1115501922,
 12489,
 -48512,
 1115574155,
 12482,
 -48511,
 1115631313,
 12487,
 -1,
 1115687548,
 12480,
 1115898504,
 1115427697,
 -1,
 -48508,
 1115863224,
 12502,
 -48507,
 1115895138,
 12508,
 -48506,
 1115967371,
 12499,
 -48505,
 1116024529,
 12505,
 -1,
 1116080764,
 12496,
 1116291725,
 1115820344,
 -1,
 -48502,
 1116222818,
 12530,
 -48501,
 1116295051,
 12528,
 -48500,
 1116352209,
 12529,
 -1,
 1116408444,
 12527,
 1116619409,
 1116218068,
 -1,
 -48497,
 1116584120,
 12518,
 -48496,
 1116616034,
 12520,
 -1,
 1116670588,
 12516,
 -48494,
 1116584120,
 12454,
 -48493,
 1116812642,
 12458,
 -48492,
 1116884875,
 12452,
 -48491,
 1116942033,
 12456,
 -1,
 1116998268,
 12450,
 -48489,
 1108756941,
 12542,
 -48488,
 1117128054,
 12539,
 -48487,
 1117203390,
 12541,
 -1,
 1117262218,
 12543,
 1117519871,
 1108704151,
 -1,
 -48484,
 1117394341,
 12443,
 -48483,
 1117463100,
 12444,
 -48482,
 1117560113,
 12540,
 -1,
 1117598970,
 12448,
 1117799378,
 1081227641,
 -1,
 1117864821,
 1117723792,
 -1,
 1117930249,
 1117801239,
 -1,
 1117995754,
 1117870253,
 -1,
 1118061242,
 1117949132,
 -1,
 1118126774,
 1118021590,
 -1,
 1118192307,
 1118049676,
 -1,
 1118257837,
 1118114673,
 -1,
 1118323370,
 1118203455,
 -1,
 -48471,
 1118286264,
 6649,
 -1,
 1118351175,
 6633,
 1118568447,
 1118273329,
 -1,
 -48468,
 1118482872,
 6648,
 -1,
 1118547783,
 6632,
 1118716592,
 1118211730,
 -1,
 -48465,
 1118679480,
 6647,
 -1,
 1118744391,
 6631,
 1118961663,
 1118666413,
 -1,
 -48462,
 1118876088,
 6646,
 -1,
 1118940999,
 6630,
 1119158271,
 1118133447,
 -1,
 -48459,
 1119072696,
 6645,
 -1,
 1119137607,
 6629,
 1119306425,
 1118060633,
 -1,
 -48456,
 1119269304,
 6642,
 -1,
 1119334215,
 6626,
 -1,
 1119253972,
 6624,
 1119568592,
 1118025754,
 -1,
 1119634125,
 1119491468,
 -1,
 1119699651,
 1119587532,
 -1,
 1119765184,
 1119627903,
 -1,
 -48449,
 1119728056,
 6655,
 -1,
 1119792967,
 6639,
 1120010239,
 1119699033,
 -1,
 -48446,
 1119924664,
 6652,
 -1,
 1119989575,
 6636,
 1120158410,
 1119622001,
 -1,
 1120223943,
 1120103999,
 -1,
 -48442,
 1120186808,
 6654,
 -1,
 1120251719,
 6638,
 1120468991,
 1120173873,
 -1,
 -48439,
 1120383416,
 6653,
 -1,
 1120448327,
 6637,
 1120665599,
 1120108205,
 -1,
 -48436,
 1120580024,
 6651,
 -1,
 1120644935,
 6635,
 1120862207,
 1119575239,
 -1,
 -48433,
 1120776632,
 6650,
 -1,
 1120841543,
 6634,
 1121010399,
 1119519716,
 -1,
 1121075930,
 1120963788,
 -1,
 1121141465,
 1121036246,
 6133,
 1121255423,
 1121064332,
 -1,
 1121272535,
 1121129329,
 -1,
 -48426,
 1121221505,
 6137,
 -1,
 1121283253,
 6136,
 -48424,
 1121197164,
 6135,
 -1,
 1121401364,
 6134,
 -1,
 1121079222,
 6130,
 1121665757,
 1120998257,
 -1,
 -48420,
 1121614721,
 6132,
 -1,
 1121676469,
 6131,
 -48418,
 1121614988,
 6128,
 -1,
 1121794580,
 6129,
 1121993446,
 1120932721,
 -1,
 1122058979,
 1121939007,
 -1,
 -48414,
 1122021816,
 6644,
 -1,
 1122086727,
 6628,
 1122303999,
 1122008881,
 -1,
 -48411,
 1122218424,
 6643,
 -1,
 1122283335,
 6627,
 1122452201,
 1121943213,
 -1,
 -48408,
 1122415032,
 6641,
 -1,
 1122479943,
 6625,
 -1,
 1122395707,
 6640,
 1122762751,
 1117944676,
 -1,
 1122779889,
 1122636657,
 -1,
 1122845424,
 1122699900,
 -1,
 -48402,
 1122800631,
 6099,
 -48401,
 1122855237,
 6101,
 -1,
 1122923303,
 6091,
 -1,
 1122777625,
 6104,
 1123173109,
 1122721904,
 -1,
 -48397,
 1123101021,
 6106,
 -48396,
 1123174341,
 6100,
 -1,
 1123266279,
 6094,
 1123435257,
 1123093116,
 -1,
 -48393,
 1123367934,
 6108,
 -48392,
 1123426301,
 6109,
 -1,
 1123519108,
 6095,
 1123697404,
 1123397570,
 -1,
 -48389,
 1123618848,
 6090,
 -1,
 1123713591,
 6093,
 1123894015,
 1123620619,
 -1,
 -48386,
 1123815530,
 6092,
 -1,
 1123894050,
 6087,
 1124090626,
 1123818549,
 -1,
 -48383,
 1124034059,
 6098,
 -1,
 1124097030,
 6102,
 -48381,
 1124028394,
 6088,
 -48380,
 1124225360,
 6097,
 -48379,
 1124291867,
 6096,
 -48378,
 1124346132,
 6105,
 -48377,
 1124441080,
 6086,
 -48376,
 1124504190,
 6089,
 -1,
 1124559117,
 6103,
 1124746042,
 1117880012,
 -1,
 1124811539,
 1124708290,
 -1,
 1124877070,
 1124749953,
 -1,
 -48371,
 1124808034,
 6029,
 -1,
 1124862588,
 6027,
 1125073681,
 1124809081,
 -1,
 -48368,
 1125004642,
 6034,
 -1,
 1125059196,
 6032,
 -48366,
 1125004642,
 6033,
 -1,
 1125190268,
 6031,
 1125401368,
 1124760578,
 -1,
 -48363,
 1125356705,
 6025,
 -48362,
 1125397858,
 6035,
 -48361,
 1125472085,
 6030,
 -1,
 1125515684,
 6020,
 1125729054,
 1125343344,
 -1,
 1125794588,
 1125661049,
 -1,
 -48357,
 1125725538,
 6019,
 -1,
 1125780092,
 6017,
 -48355,
 1125725538,
 6018,
 -1,
 1125911164,
 6016,
 1126122276,
 1125653557,
 -1,
 1126187810,
 1126054265,
 -1,
 -48351,
 1126118754,
 6024,
 -1,
 1126173308,
 6022,
 -48349,
 1126118754,
 6023,
 -1,
 1126304380,
 6021,
 1126515496,
 1126058775,
 -1,
 -48346,
 1126446294,
 6046,
 -48345,
 1126508444,
 6045,
 -1,
 1126566524,
 6047,
 1126777645,
 1126468812,
 -1,
 1126843180,
 1126709625,
 -1,
 -48341,
 1126774114,
 6039,
 -1,
 1126828668,
 6037,
 -1,
 1126774114,
 6038,
 1127105328,
 1126722141,
 -1,
 -48337,
 1127036258,
 6043,
 -1,
 1127090812,
 6049,
 1127301939,
 1127032128,
 -1,
 -48334,
 1127232866,
 6028,
 -1,
 1127287420,
 6026,
 -48332,
 1127257249,
 6041,
 -48331,
 1127424657,
 6044,
 -48330,
 1127496693,
 6042,
 -48329,
 1127552769,
 6050,
 -48328,
 1127626168,
 6040,
 -48327,
 1127688092,
 6048,
 -1,
 1127787991,
 6036,
 1127957329,
 1124706249,
 -1,
 1128022862,
 1127906508,
 -1,
 1128088385,
 1127942780,
 -1,
 -48322,
 1128052920,
 6085,
 -48321,
 1128091531,
 6083,
 -48320,
 1128148689,
 6082,
 -1,
 1128204924,
 6070,
 1128416068,
 1128014548,
 6073,
 -48317,
 1128342228,
 6074,
 -1,
 1128401532,
 6079,
 1128612679,
 1128380600,
 6075,
 -48314,
 1128577208,
 6076,
 -1,
 1128598140,
 6077,
 1128809290,
 1128550283,
 6071,
 -48311,
 1128746891,
 6072,
 -1,
 1128804049,
 6080,
 1129005901,
 1128740194,
 -1,
 -48308,
 1128936802,
 6084,
 -1,
 1129000657,
 6078,
 -1,
 1128935121,
 6081,
 1129316351,
 1127985079,
 -1,
 -48304,
 1129223713,
 6068,
 -1,
 1129253500,
 6069,
 1129464678,
 1127918865,
 -1,
 1129530210,
 1129420321,
 -1,
 1129595735,
 1129494712,
 6055,
 1129661270,
 1129560248,
 6057,
 -1,
 1129580571,
 6058,
 -1,
 1129603184,
 6056,
 1129857884,
 1129515644,
 -1,
 -48295,
 1129822392,
 6067,
 -48294,
 1129879073,
 6051,
 -48293,
 1129926539,
 6064,
 -1,
 1129974396,
 6052,
 1130185567,
 1129793986,
 -1,
 -48290,
 1130114496,
 6066,
 -1,
 1130170920,
 6065,
 1130382177,
 1130123147,
 6053,
 -1,
 1130319755,
 6054,
 -1,
 1130311377,
 6063,
 1130578788,
 1129462732,
 6059,
 -1,
 1130504916,
 6060,
 1130758143,
 1130498681,
 6061,
 -1,
 1130635988,
 6062,
 1130840948,
 1129423971,
 -1,
 1130906474,
 1130803138,
 -1,
 -48279,
 1130841708,
 6114,
 -1,
 1130906543,
 6115,
 1131103085,
 1130842903,
 -1,
 -48276,
 1131040607,
 6118,
 -1,
 1131087941,
 6119,
 1131299696,
 1131034495,
 -1,
 -48273,
 1131242420,
 6116,
 -1,
 1131316412,
 6117,
 -48271,
 1131225014,
 6112,
 -48270,
 1131416104,
 6113,
 -48269,
 1131521558,
 6121,
 -1,
 1131560683,
 6120,
 -1,
 1130784736,
 6107,
 1131872255,
 1117817081,
 -1,
 1131889573,
 1131773644,
 -1,
 1131955070,
 1131851714,
 -1,
 1132020604,
 1131917250,
 -1,
 -48262,
 1131977916,
 68147,
 -48261,
 1132013468,
 68123,
 -1,
 1132071548,
 68122,
 -48259,
 1131947932,
 68128,
 -1,
 1132202620,
 68127,
 1132413828,
 1131881792,
 -1,
 1132479362,
 1132340544,
 -1,
 -48255,
 1132406684,
 68125,
 -1,
 1132464764,
 68124,
 -48253,
 1132406684,
 68130,
 -1,
 1132595836,
 68129,
 1132807048,
 1132350231,
 -1,
 -48250,
 1132750147,
 68142,
 -48249,
 1132799900,
 68141,
 -1,
 1132857980,
 68143,
 1133069196,
 1132755970,
 -1,
 -48246,
 1133023902,
 68121,
 -48245,
 1133086618,
 68126,
 -1,
 1133120124,
 68131,
 1133331344,
 1133011056,
 -1,
 -48242,
 1133289229,
 68146,
 -48241,
 1133324188,
 68113,
 -1,
 1133382268,
 68112,
 1133593491,
 1133284556,
 -1,
 -48238,
 1133520796,
 68133,
 -1,
 1133578876,
 68132,
 1133790102,
 1133526853,
 -1,
 -48235,
 1133717404,
 68115,
 -1,
 1133775484,
 68114,
 1133986713,
 1133714485,
 -1,
 -48232,
 1133914012,
 68118,
 -1,
 1133972092,
 68117,
 1134183324,
 1133908849,
 -1,
 -48229,
 1134110620,
 68135,
 -1,
 1134168700,
 68134,
 -48227,
 1134107773,
 68144,
 -48226,
 1134334622,
 68137,
 -48225,
 1134371418,
 68140,
 -48224,
 1134471484,
 68138,
 -48223,
 1134507430,
 68136,
 -48222,
 1134561754,
 68139,
 -48221,
 1134654764,
 68119,
 -48220,
 1134700444,
 68145,
 -1,
 1134758524,
 68096,
 1134969779,
 1131842935,
 -1,
 1135035307,
 1134896448,
 -1,
 1135100842,
 1134966114,
 -1,
 -48215,
 1135051083,
 68183,
 -1,
 1135128514,
 68176,
 -1,
 1135061210,
 68182,
 1135362990,
 1134979677,
 -1,
 -48211,
 1135314656,
 68181,
 -1,
 1135365231,
 68184,
 1135559601,
 1135287349,
 -1,
 -48208,
 1135508308,
 68179,
 -1,
 1135554830,
 68178,
 -48206,
 1135509522,
 68177,
 -1,
 1135686428,
 68180,
 1135887293,
 1134888987,
 -1,
 1135952828,
 1135850177,
 -1,
 1136018363,
 1135901900,
 -1,
 -48201,
 1135951451,
 68099,
 -48200,
 1136048312,
 68098,
 -48199,
 1136080226,
 68102,
 -48198,
 1136152459,
 68097,
 -1,
 1136209617,
 68101,
 -1,
 1135953149,
 68108,
 -1,
 1135903844,
 68159,
 1136542661,
 1135836364,
 -1,
 1136608193,
 1136477042,
 -1,
 -48192,
 1136536291,
 68109,
 -1,
 1136607161,
 68154,
 -48190,
 1136541590,
 68111,
 -48189,
 1136727777,
 68153,
 -48188,
 1136820487,
 68152,
 -1,
 1136860503,
 68110,
 1137066956,
 1136482289,
 -1,
 1137132489,
 1137029058,
 -1,
 -48184,
 1137086878,
 68165,
 -1,
 1137142962,
 68164,
 1137377279,
 1137074204,
 -1,
 -48181,
 1137259811,
 68167,
 -1,
 1137318737,
 68166,
 1137573887,
 1137026147,
 -1,
 1137591248,
 1137487810,
 -1,
 -48177,
 1137526380,
 68161,
 -1,
 1137591215,
 68162,
 -48175,
 1137510952,
 68160,
 -1,
 1137751548,
 68163,
 1137918933,
 1117728465,
 -1,
 -48172,
 1137880458,
 9000,
 -1,
 1137924838,
 8490,
 -48170,
 1137840500,
 12927,
 -1,
 1138059688,
 8365,
 1138247277,
 1081159377,
 -1,
 1138312688,
 1138201185,
 -1,
 1138378172,
 1138248471,
 -1,
 1138443705,
 1138306850,
 -1,
 1138508810,
 1138376517,
 -1,
 1138574314,
 1138442053,
 -1,
 1138639843,
 1138495800,
 -1,
 1138705376,
 1138568913,
 11670,
 -1,
 1138634449,
 11669,
 1138836450,
 1138625148,
 11667,
 -1,
 1138756220,
 4895,
 -1,
 1138773899,
 11668,
 1139033061,
 1138568913,
 4893,
 -1,
 1138962129,
 4892,
 1139164135,
 1138952828,
 4888,
 -1,
 1139083900,
 4891,
 -48152,
 1139128504,
 4889,
 -48151,
 1139225954,
 4894,
 -1,
 1139298187,
 4890,
 1139491828,
 1138508724,
 -1,
 1139557357,
 1139422562,
 4774,
 -1,
 1139477116,
 11658,
 1139688431,
 1139486417,
 4773,
 -1,
 1139617489,
 4772,
 1139819505,
 1139608188,
 4768,
 -1,
 1139739260,
 4771,
 -48142,
 1139754597,
 4775,
 -48141,
 1139914936,
 4769,
 -1,
 1139953547,
 4770,
 1140147196,
 1139417812,
 -1,
 1140212727,
 1140076241,
 11741,
 -1,
 1140141777,
 11740,
 1140343801,
 1140132476,
 11736,
 -1,
 1140263548,
 11739,
 -48134,
 1140308152,
 11737,
 -48133,
 1140405602,
 11742,
 -1,
 1140477835,
 11738,
 1140671490,
 1140068664,
 -1,
 1140737023,
 1140600529,
 4885,
 -1,
 1140666065,
 4884,
 1140868097,
 1140656764,
 4880,
 -1,
 1140787836,
 4883,
 -1,
 1140805515,
 4882,
 1141064708,
 1140602210,
 4878,
 -1,
 1140984444,
 4879,
 1141195782,
 1140993745,
 4877,
 -1,
 1141124817,
 4876,
 1141326856,
 1141115516,
 4872,
 -1,
 1141246588,
 4875,
 -48119,
 1141291192,
 4873,
 -1,
 1141395339,
 4874,
 1141589044,
 1138445079,
 -1,
 1141654549,
 1141520761,
 -1,
 1141720078,
 1141585250,
 4670,
 -1,
 1141639804,
 11652,
 1141851152,
 1141649105,
 4669,
 -1,
 1141780177,
 4668,
 1141982226,
 1141770876,
 4664,
 -1,
 1141901948,
 4667,
 -48109,
 1141917285,
 4671,
 -48108,
 1142077624,
 4665,
 -1,
 1142116235,
 4666,
 1142309918,
 1141582967,
 -1,
 1142375448,
 1142238929,
 4645,
 -1,
 1142304465,
 4644,
 1142506522,
 1142295164,
 4640,
 -1,
 1142426236,
 4643,
 -48101,
 1142441573,
 4647,
 -48100,
 1142601912,
 4641,
 -48099,
 1142633826,
 4646,
 -1,
 1142706059,
 4642,
 1142899750,
 1142246167,
 -1,
 1142965281,
 1142828753,
 11685,
 -1,
 1142894289,
 11684,
 1143096355,
 1142884988,
 11680,
 -1,
 1143016060,
 11683,
 -48092,
 1143060664,
 11681,
 -48091,
 1143158114,
 11686,
 -1,
 1143230347,
 11682,
 1143424045,
 1142828753,
 4661,
 1143489580,
 1143355981,
 -1,
 -48087,
 1143427232,
 5004,
 -48086,
 1143483621,
 4992,
 -48085,
 1143547150,
 5000,
 -1,
 1143603435,
 4996,
 -1,
 1143418577,
 4660,
 1143882799,
 1143354722,
 4662,
 -1,
 1143802492,
 11651,
 1144013873,
 1143802492,
 4656,
 -1,
 1143933564,
 4659,
 -48078,
 1143948901,
 4663,
 -48077,
 1144109240,
 4657,
 -1,
 1144147851,
 4658,
 1144341594,
 1141551042,
 -1,
 1144407103,
 1144273273,
 -1,
 1144472632,
 1144337762,
 4902,
 -1,
 1144392316,
 11663,
 1144603706,
 1144401617,
 4901,
 -1,
 1144532689,
 4900,
 1144734780,
 1144523388,
 4896,
 -1,
 1144654460,
 4899,
 -48067,
 1144669797,
 4903,
 -48066,
 1144830136,
 4897,
 -1,
 1144868747,
 4898,
 1145062472,
 1144335479,
 -1,
 1145128002,
 1144993122,
 4934,
 -1,
 1145047676,
 4935,
 1145259076,
 1145056977,
 4933,
 -1,
 1145188049,
 4932,
 1145390150,
 1145178748,
 4928,
 -1,
 1145309820,
 4931,
 -48057,
 1145354424,
 4929,
 -1,
 1145458571,
 4930,
 1145652305,
 1144998679,
 -1,
 1145717835,
 1145581265,
 4925,
 -1,
 1145646801,
 4924,
 1145848909,
 1145637500,
 4920,
 -1,
 1145768572,
 4923,
 -48050,
 1145783909,
 4927,
 -48049,
 1145944248,
 4921,
 -48048,
 1145976162,
 4926,
 -1,
 1146048395,
 4922,
 1146242131,
 1145582946,
 4726,
 -1,
 1146161788,
 11654,
 1146373205,
 1146171089,
 4725,
 -1,
 1146302161,
 4724,
 1146504279,
 1146292860,
 4720,
 -1,
 1146423932,
 4723,
 -48040,
 1146439269,
 4727,
 -48039,
 1146599608,
 4721,
 -1,
 1146638219,
 4722,
 1146831999,
 1144296993,
 -1,
 1146897513,
 1146763641,
 -1,
 1146963042,
 1146818872,
 -1,
 1147028575,
 1146891985,
 4701,
 -1,
 1146957521,
 4700,
 1147159649,
 1146948220,
 4696,
 -1,
 1147079292,
 4699,
 -1,
 1147096971,
 4698,
 1147356260,
 1146891985,
 4693,
 -1,
 1147285201,
 4692,
 1147487334,
 1147275900,
 4688,
 -1,
 1147406972,
 4691,
 -48025,
 1147451576,
 4689,
 -48024,
 1147549026,
 4694,
 -1,
 1147621259,
 4690,
 1147815025,
 1146823380,
 -1,
 1147880556,
 1147743953,
 11717,
 -1,
 1147809489,
 11716,
 1148011630,
 1147800188,
 11712,
 -1,
 1147931260,
 11715,
 -48017,
 1147975864,
 11713,
 -48016,
 1148073314,
 11718,
 -1,
 1148145547,
 11714,
 1148339319,
 1147736376,
 -1,
 1148404852,
 1148268241,
 4685,
 -1,
 1148333777,
 4684,
 1148535926,
 1148324476,
 4680,
 -1,
 1148455548,
 4683,
 -1,
 1148473227,
 4682,
 1148732537,
 1148269922,
 4678,
 -1,
 1148652156,
 4679,
 1148863611,
 1148661457,
 4677,
 -1,
 1148792529,
 4676,
 1148994685,
 1148783228,
 4672,
 -1,
 1148914300,
 4675,
 -48002,
 1148958904,
 4673,
 -1,
 1149063051,
 4674,
 1149256868,
 1146773616,
 -1,
 1149322382,
 1149180347,
 -1,
 1149387911,
 1149243704,
 -1,
 1149453444,
 1149316817,
 4805,
 -1,
 1149382353,
 4804,
 1149584518,
 1149373052,
 4800,
 -1,
 1149504124,
 4803,
 -1,
 1149521803,
 4802,
 1149781129,
 1149316817,
 4797,
 -1,
 1149710033,
 4796,
 1149912203,
 1149700732,
 4792,
 -1,
 1149831804,
 4795,
 -47988,
 1149876408,
 4793,
 -47987,
 1149973858,
 4798,
 -1,
 1150046091,
 4794,
 1150239894,
 1149248212,
 -1,
 1150305425,
 1150168785,
 11725,
 -1,
 1150234321,
 11724,
 1150436499,
 1150225020,
 11720,
 -1,
 1150356092,
 11723,
 -47980,
 1150400696,
 11721,
 -47979,
 1150498146,
 11726,
 -1,
 1150570379,
 11722,
 1150764188,
 1150161208,
 -1,
 1150829721,
 1150693073,
 4789,
 -1,
 1150758609,
 4788,
 1150960795,
 1150749308,
 4784,
 -1,
 1150880380,
 4787,
 -1,
 1150898059,
 4786,
 1151157406,
 1150694754,
 4782,
 -1,
 1151076988,
 4783,
 1151288480,
 1151086289,
 4781,
 -1,
 1151217361,
 4780,
 1151419554,
 1151208060,
 4776,
 -1,
 1151339132,
 4779,
 -47965,
 1151383736,
 4777,
 -1,
 1151487883,
 4778,
 1151681736,
 1149180981,
 -1,
 1151747253,
 1151605813,
 -1,
 1151812782,
 1151678841,
 -1,
 1151878313,
 1151741649,
 11709,
 -1,
 1151807185,
 11708,
 1152009387,
 1151797884,
 11704,
 -1,
 1151928956,
 11707,
 -47956,
 1151973560,
 11705,
 -47955,
 1152071010,
 11710,
 -1,
 1152143243,
 11706,
 1152337072,
 1151741649,
 11693,
 -1,
 1152265937,
 11692,
 1152468146,
 1152256636,
 11688,
 -1,
 1152387708,
 11691,
 -47949,
 1152432312,
 11689,
 -47948,
 1152529762,
 11694,
 -1,
 1152601995,
 11690,
 1152795839,
 1151678841,
 -1,
 1152861368,
 1152726370,
 4910,
 -1,
 1152780924,
 11664,
 1152992442,
 1152790225,
 4909,
 -1,
 1152921297,
 4908,
 1153123516,
 1152911996,
 4904,
 -1,
 1153043068,
 4907,
 -47939,
 1153058405,
 4911,
 -47938,
 1153218744,
 4905,
 -1,
 1153257355,
 4906,
 1153451201,
 1152726370,
 4734,
 -1,
 1153370748,
 11655,
 1153582275,
 1153380049,
 4733,
 -1,
 1153511121,
 4732,
 1153713349,
 1153501820,
 4728,
 -1,
 1153632892,
 4731,
 -47930,
 1153648229,
 4735,
 -47929,
 1153808568,
 4729,
 -1,
 1153847179,
 4730,
 1154041064,
 1151634636,
 -1,
 1154106587,
 1153972601,
 -1,
 1154172116,
 1154026108,
 4912,
 1154237651,
 1154102593,
 -1,
 1154303182,
 1154166481,
 4821,
 -1,
 1154232017,
 4820,
 1154434256,
 1154222716,
 4816,
 -1,
 1154353788,
 4819,
 -47919,
 1154398392,
 4817,
 -47918,
 1154495842,
 4822,
 -1,
 1154568075,
 4818,
 -1,
 1154157180,
 4915,
 1154827478,
 1154102626,
 4918,
 -1,
 1154747004,
 11665,
 1154958552,
 1154756305,
 4917,
 -1,
 1154887377,
 4916,
 -47911,
 1154893413,
 4919,
 -47910,
 1155053752,
 4913,
 -1,
 1155092363,
 4914,
 1155286240,
 1154027832,
 -1,
 1155351774,
 1155215057,
 5007,
 -1,
 1155280593,
 5006,
 -47905,
 1155288971,
 5005,
 -1,
 1155402364,
 4951,
 1155613922,
 1155216738,
 4950,
 -1,
 1155533436,
 11666,
 1155744996,
 1155542737,
 4949,
 -1,
 1155673809,
 4948,
 1155876070,
 1155664508,
 4944,
 -1,
 1155795580,
 4947,
 -47897,
 1155840184,
 4945,
 -1,
 1155944331,
 4946,
 1156138243,
 1153969271,
 -1,
 1156203762,
 1156069753,
 -1,
 1156269292,
 1156132561,
 4837,
 -1,
 1156198097,
 4836,
 1156400366,
 1156188796,
 4832,
 -1,
 1156319868,
 4835,
 -47889,
 1156335205,
 4839,
 -47888,
 1156495544,
 4833,
 -47887,
 1156527458,
 4838,
 -1,
 1156599691,
 4834,
 1156793594,
 1156131959,
 -1,
 1156859125,
 1156722385,
 11701,
 -1,
 1156787921,
 11700,
 1156990199,
 1156778620,
 11696,
 -1,
 1156909692,
 11699,
 -47880,
 1156954296,
 11697,
 -47879,
 1157051746,
 11702,
 -1,
 1157123979,
 11698,
 1157317884,
 1156724066,
 4830,
 -1,
 1157237372,
 11659,
 1157448958,
 1157246673,
 4829,
 -1,
 1157377745,
 4828,
 1157580032,
 1157368444,
 4824,
 -1,
 1157499516,
 4827,
 -47871,
 1157514853,
 4831,
 -47870,
 1157675192,
 4825,
 -1,
 1157713803,
 4826,
 1157907738,
 1156061627,
 -1,
 1157973260,
 1157833428,
 -1,
 1158038791,
 1157902033,
 11733,
 -1,
 1157967569,
 11732,
 1158169865,
 1157958268,
 11728,
 -1,
 1158089340,
 11731,
 -47862,
 1158133944,
 11729,
 -47861,
 1158231394,
 11734,
 -1,
 1158303627,
 11730,
 1158497554,
 1157894456,
 -1,
 1158563087,
 1158426321,
 4749,
 -1,
 1158491857,
 4748,
 1158694161,
 1158482556,
 4744,
 -1,
 1158613628,
 4747,
 -1,
 1158631307,
 4746,
 1158890772,
 1158428002,
 4742,
 -1,
 1158810236,
 4743,
 1159021846,
 1158819537,
 4741,
 -1,
 1158950609,
 4740,
 1159152920,
 1158941308,
 4736,
 -1,
 1159072380,
 4739,
 -47847,
 1159116984,
 4737,
 -1,
 1159221131,
 4738,
 1159415086,
 1157856258,
 -1,
 1159480613,
 1159340756,
 -1,
 1159546142,
 1159411042,
 4766,
 -1,
 1159465596,
 11657,
 1159677216,
 1159474897,
 4765,
 -1,
 1159605969,
 4764,
 1159808290,
 1159596668,
 4760,
 -1,
 1159727740,
 4763,
 -47837,
 1159743077,
 4767,
 -47836,
 1159903416,
 4761,
 -1,
 1159942027,
 4762,
 1160135975,
 1159411042,
 4758,
 -1,
 1160055420,
 11656,
 1160267049,
 1160064721,
 4757,
 -1,
 1160195793,
 4756,
 1160398123,
 1160186492,
 4752,
 -1,
 1160317564,
 4755,
 -47828,
 1160332901,
 4759,
 -47827,
 1160493240,
 4753,
 -1,
 1160531851,
 4754,
 1160725826,
 1159341376,
 -1,
 1160791353,
 1160652096,
 -1,
 1160856882,
 1160721762,
 4862,
 -1,
 1160776316,
 11661,
 1160987956,
 1160785617,
 4861,
 -1,
 1160916689,
 4860,
 1161119030,
 1160907388,
 4856,
 -1,
 1161038460,
 4859,
 -47817,
 1161053797,
 4863,
 -47816,
 1161214136,
 4857,
 -1,
 1161252747,
 4858,
 1161446715,
 1160721762,
 4854,
 -1,
 1161366140,
 11660,
 1161577789,
 1161375441,
 4853,
 -1,
 1161506513,
 4852,
 1161708863,
 1161497212,
 4848,
 -1,
 1161628284,
 4851,
 -47808,
 1161643621,
 4855,
 -47807,
 1161803960,
 4849,
 -1,
 1161842571,
 4850,
 1162036564,
 1160657273,
 -1,
 1162102092,
 1161967993,
 -1,
 1162167622,
 1162030801,
 4629,
 -1,
 1162096337,
 4628,
 1162298696,
 1162087036,
 4624,
 -1,
 1162218108,
 4627,
 -47799,
 1162233445,
 4631,
 -47798,
 1162393784,
 4625,
 -47797,
 1162425698,
 4630,
 -1,
 1162497931,
 4626,
 1162691918,
 1162032482,
 4614,
 -1,
 1162611324,
 4615,
 1162822992,
 1162620625,
 4613,
 -1,
 1162751697,
 4612,
 1162954066,
 1162742396,
 4608,
 -1,
 1162873468,
 4611,
 -47789,
 1162918072,
 4609,
 -1,
 1163022219,
 4610,
 1163216227,
 1161982724,
 -1,
 1163281754,
 1163137336,
 -1,
 1163347288,
 1163210449,
 4995,
 -1,
 1163275985,
 4994,
 -47783,
 1163284363,
 4993,
 -1,
 1163397756,
 4639,
 1163609436,
 1163212130,
 4638,
 -1,
 1163528828,
 11649,
 1163740510,
 1163538129,
 4637,
 -1,
 1163669201,
 4636,
 1163871584,
 1163659900,
 4632,
 -1,
 1163790972,
 4635,
 -47775,
 1163825822,
 4953,
 -47774,
 1163966648,
 4633,
 -1,
 1164005259,
 4634,
 1164199281,
 1163147135,
 -1,
 1164264809,
 1164120376,
 -1,
 1164330343,
 1164193489,
 5003,
 -1,
 1164259025,
 5002,
 -47768,
 1164267403,
 5001,
 -1,
 1164380796,
 4943,
 1164592491,
 1164193489,
 4941,
 -1,
 1164521169,
 4940,
 1164723565,
 1164511868,
 4936,
 -1,
 1164642940,
 4939,
 -47762,
 1164677790,
 4954,
 -47761,
 1164818616,
 4937,
 -47760,
 1164850530,
 4942,
 -1,
 1164922763,
 4938,
 1165116799,
 1164120945,
 -1,
 1165182327,
 1165037880,
 -1,
 1165247861,
 1165110993,
 4999,
 -1,
 1165176529,
 4998,
 -47754,
 1165184907,
 4997,
 -1,
 1165298300,
 4711,
 1165510009,
 1165112674,
 4710,
 -1,
 1165429372,
 11653,
 1165641083,
 1165438673,
 4709,
 -1,
 1165569745,
 4708,
 1165772157,
 1165560444,
 4704,
 -1,
 1165691516,
 4707,
 -47746,
 1165736120,
 4705,
 -1,
 1165840267,
 4706,
 1166034314,
 1165039371,
 -1,
 1166099842,
 1165964642,
 4654,
 -1,
 1166019196,
 11650,
 1166230916,
 1166028497,
 4653,
 -1,
 1166159569,
 4652,
 1166361990,
 1166150268,
 4648,
 -1,
 1166281340,
 4651,
 -47737,
 1166316190,
 4952,
 -47736,
 1166427749,
 4655,
 -47735,
 1166522552,
 4649,
 -1,
 1166561163,
 4650,
 1166755220,
 1165978205,
 -1,
 1166820749,
 1166685538,
 4622,
 -1,
 1166740092,
 11648,
 1166951823,
 1166749393,
 4621,
 -1,
 1166880465,
 4620,
 1167082897,
 1166871164,
 4616,
 -1,
 1167002236,
 4619,
 -47726,
 1167017573,
 4623,
 -47725,
 1167177912,
 4617,
 -1,
 1167216523,
 4618,
 1167410590,
 1166694396,
 -1,
 1167476119,
 1167340898,
 4870,
 -1,
 1167395452,
 11662,
 1167607193,
 1167404753,
 4869,
 -1,
 1167535825,
 4868,
 1167738267,
 1167526524,
 4864,
 -1,
 1167657596,
 4867,
 -47716,
 1167672933,
 4871,
 -47715,
 1167833272,
 4865,
 -1,
 1167871883,
 4866,
 1168065959,
 1167336148,
 -1,
 1168131489,
 1167996258,
 4846,
 -1,
 1168050812,
 4847,
 1168262563,
 1168060113,
 4845,
 -1,
 1168191185,
 4844,
 1168393637,
 1168181884,
 4840,
 -1,
 1168312956,
 4843,
 -47706,
 1168357560,
 4841,
 -1,
 1168461707,
 4842,
 1168655792,
 1167987000,
 -1,
 1168721322,
 1168586082,
 4814,
 -1,
 1168640636,
 4815,
 1168852396,
 1168649937,
 4813,
 -1,
 1168781009,
 4812,
 1168983470,
 1168771708,
 4808,
 -1,
 1168902780,
 4811,
 -47697,
 1168947384,
 4809,
 -1,
 1169051531,
 4810,
 1169293311,
 1168574491,
 -1,
 1169311155,
 1169174225,
 4717,
 -1,
 1169239761,
 4716,
 1169442229,
 1169230460,
 4712,
 -1,
 1169361532,
 4715,
 -47690,
 1169376869,
 4719,
 -47689,
 1169537208,
 4713,
 -47688,
 1169569122,
 4718,
 -1,
 1169641355,
 4714,
 1169883135,
 1138372305,
 -1,
 -47685,
 1169784560,
 4964,
 -1,
 1169859165,
 4960,
 1170032075,
 1138317297,
 -1,
 1170097602,
 1169993666,
 -1,
 1170163136,
 1170042034,
 4978,
 -1,
 1170113780,
 4988,
 -47679,
 1170117022,
 4979,
 -1,
 1170238201,
 4980,
 1170425285,
 1170033431,
 -1,
 -47676,
 1170368689,
 4983,
 -1,
 1170452257,
 4984,
 1170621896,
 1170356095,
 -1,
 -47673,
 1170541167,
 4981,
 -1,
 1170610785,
 4982,
 -47671,
 1170582161,
 4986,
 -47670,
 1170742097,
 4987,
 -1,
 1170821356,
 4985,
 1171015128,
 1169978021,
 -1,
 1171080656,
 1170941248,
 -1,
 1171146191,
 1170997735,
 5009,
 -1,
 1171076832,
 5016,
 -1,
 1171098592,
 5012,
 1171342803,
 1171021936,
 -1,
 -47662,
 1171286634,
 5017,
 -1,
 1171355654,
 5013,
 -47660,
 1171292753,
 5008,
 -47659,
 1171459006,
 5011,
 -47658,
 1171565651,
 5010,
 -47657,
 1171589676,
 5015,
 -1,
 1171663618,
 5014,
 1171867109,
 1170973795,
 -1,
 1171932636,
 1171828674,
 -1,
 -47653,
 1171867244,
 4970,
 -1,
 1171932079,
 4971,
 1172129247,
 1171868439,
 -1,
 -47650,
 1172066143,
 4974,
 -1,
 1172113477,
 4975,
 1172325858,
 1172060031,
 -1,
 -47647,
 1172267956,
 4972,
 -1,
 1172341948,
 4973,
 -47645,
 1172245032,
 4969,
 -47644,
 1172481558,
 4977,
 -1,
 1172520683,
 4976,
 1172719082,
 1171791726,
 -1,
 1172784617,
 1172665092,
 -1,
 -47640,
 1172714918,
 4963,
 -1,
 1172767039,
 4959,
 -1,
 1172715522,
 4965,
 1173046765,
 1172671692,
 -1,
 -47636,
 1172993682,
 4966,
 -1,
 1173067521,
 4968,
 -47634,
 1172979324,
 4961,
 -47633,
 1173167481,
 4967,
 -1,
 1173242359,
 4962,
 1173440016,
 1138235038,
 -1,
 1173505547,
 1173391846,
 -1,
 1173571074,
 1173440877,
 -1,
 1173636608,
 1173494170,
 61,
 1173749759,
 1173576903,
 -1,
 1173767676,
 1173621372,
 -1,
 1173833210,
 1173686915,
 -1,
 -47624,
 1173781736,
 10867,
 -47623,
 1173853116,
 10609,
 -1,
 1173905190,
 10865,
 1174142975,
 1173781410,
 10723,
 -1,
 1174029392,
 10724,
 1174274047,
 1173690940,
 -1,
 -47618,
 1174179913,
 10871,
 -47617,
 1174233249,
 10854,
 -1,
 1174278359,
 10926,
 -47615,
 1173577969,
 10862,
 -1,
 1174426820,
 8789,
 1174667263,
 1173511367,
 -1,
 1174685194,
 1174574942,
 -1,
 1174750729,
 1174603421,
 -1,
 -47610,
 1174671140,
 8927,
 -47609,
 1174776668,
 8926,
 -47608,
 1174816816,
 8924,
 -1,
 1174901196,
 8925,
 -1,
 1174691396,
 8797,
 -1,
 1174631191,
 8917,
 1175257087,
 1173442443,
 -1,
 1175275023,
 1175153571,
 -1,
 -47602,
 1175197616,
 10872,
 -1,
 1175292266,
 8781,
 -1,
 1175195809,
 8794,
 1175537188,
 1173363131,
 -1,
 1175602719,
 1175469073,
 -1,
 1175668245,
 1175564226,
 -1,
 -47596,
 1175602796,
 1778,
 -1,
 1175667631,
 1779,
 1175864856,
 1175603991,
 -1,
 -47593,
 1175801695,
 1782,
 -1,
 1175849029,
 1783,
 1176061467,
 1175795583,
 -1,
 -47590,
 1176003508,
 1780,
 -1,
 1176077500,
 1781,
 -47588,
 1175986102,
 1776,
 -47587,
 1176177192,
 1777,
 -47586,
 1176282646,
 1785,
 -1,
 1176321771,
 1784,
 1176567807,
 1175526453,
 -1,
 1176585763,
 1176438229,
 -1,
 -47582,
 1176509817,
 8265,
 -1,
 1176605696,
 33,
 -1,
 1176523878,
 8761,
 1176847922,
 1175456197,
 -1,
 1176913457,
 1176779028,
 8712,
 1177026559,
 1176853703,
 -1,
 1177044526,
 1176902204,
 -1,
 -47575,
 1176973289,
 8947,
 -47574,
 1177028157,
 8952,
 -47573,
 1177110525,
 8953,
 -47572,
 1177170852,
 8950,
 -47571,
 1177225738,
 8946,
 -1,
 1177326756,
 8949,
 1177550847,
 1177005052,
 -1,
 -47568,
 1177435524,
 10194,
 -1,
 1177494541,
 10969,
 -1,
 1176840613,
 8961,
 1177765439,
 1176793860,
 -1,
 1177830971,
 1177717964,
 -1,
 1177896506,
 1177764708,
 8709,
 1178009599,
 1177824708,
 -1,
 -47561,
 1177908382,
 10674,
 -47560,
 1177979024,
 10675,
 -47559,
 1178022820,
 10673,
 -1,
 1178117504,
 10676,
 -1,
 1177828846,
 9091,
 1178402815,
 1177771207,
 -1,
 -47555,
 1178286039,
 8195,
 -47554,
 1178372068,
 8193,
 -1,
 1178419339,
 8212,
 1178617420,
 1177687819,
 -1,
 1178682953,
 1178550184,
 -1,
 1178748485,
 1178634348,
 -1,
 -47549,
 1178682022,
 10734,
 -47548,
 1178744783,
 10736,
 -1,
 1178826561,
 10738,
 1179058175,
 1178696361,
 -1,
 -47545,
 1178944166,
 10735,
 -47544,
 1179006927,
 10737,
 -1,
 1179088705,
 10739,
 1179320319,
 1178646017,
 -1,
 -47541,
 1179230774,
 8998,
 -1,
 1179280331,
 9003,
 1179469399,
 1178572301,
 -1,
 1179534934,
 1179409607,
 -1,
 1179600468,
 1179487436,
 -1,
 1179666003,
 1179551655,
 -1,
 -47535,
 1179585211,
 10039,
 -47534,
 1179661720,
 10037,
 -1,
 1179717224,
 10036,
 -1,
 1179614694,
 10049,
 -47531,
 1179524094,
 10058,
 -1,
 1179921103,
 10035,
 -1,
 1179476401,
 9834,
 1180190303,
 1179417602,
 -1,
 1180255836,
 1180130503,
 -1,
 -47526,
 1180186583,
 8194,
 -47525,
 1180272612,
 8192,
 -1,
 1180319883,
 8211,
 -47523,
 1180190335,
 9993,
 -47522,
 1180450164,
 9094,
 -1,
 1180528403,
 8718,
 1180714596,
 1180154040,
 -1,
 1180780131,
 1180646389,
 -1,
 -47518,
 1180738315,
 8352,
 -1,
 1180780630,
 8364,
 -1,
 1180718785,
 8455,
 1181042280,
 1180633724,
 -1,
 1181107815,
 1180958799,
 9793,
 -1,
 1181027324,
 9178,
 -1,
 1181027819,
 9841,
 1181304427,
 1180979156,
 -1,
 -47510,
 1181240087,
 8793,
 -1,
 1181327796,
 8494,
 -47508,
 1181247322,
 9167,
 -1,
 1181422605,
 11790,
 1181632696,
 1138173248,
 -1,
 1181697921,
 1181560529,
 -1,
 1181763331,
 1181616359,
 -1,
 1181828810,
 1181712076,
 -1,
 1181894266,
 1181764375,
 -1,
 1181959800,
 1181825401,
 -1,
 1182025335,
 1181900338,
 -1,
 -47499,
 1181955426,
 2322,
 -47498,
 1182019281,
 2318,
 -1,
 1182075516,
 2308,
 -1,
 1181944444,
 2358,
 -47495,
 1181902147,
 2359,
 -1,
 1182272124,
 2360,
 1182484097,
 1181812763,
 -1,
 1182549632,
 1182432290,
 -1,
 1182615166,
 1182471947,
 2315,
 -1,
 1182537483,
 2400,
 1182793727,
 1182558813,
 2316,
 -1,
 1182689885,
 2401,
 -1,
 1182468732,
 2357,
 1182942856,
 1182432258,
 -1,
 1183008389,
 1182891010,
 -1,
 -47484,
 1182959514,
 2345,
 -1,
 1182993020,
 2339,
 -47482,
 1182962334,
 2334,
 -47481,
 1183121820,
 2329,
 -1,
 1183189628,
 2344,
 1183401615,
 1182868800,
 -1,
 1183467149,
 1183327552,
 -1,
 -47477,
 1183393692,
 2338,
 -47476,
 1183466794,
 2396,
 -1,
 1183517308,
 2337,
 -47474,
 1183393692,
 2343,
 -1,
 1183648380,
 2342,
 1183860373,
 1183363010,
 -1,
 1183925907,
 1183821762,
 -1,
 -47470,
 1183852444,
 2336,
 -1,
 1183910524,
 2335,
 -47468,
 1183852444,
 2341,
 -1,
 1184041596,
 2340,
 1184253595,
 1183792965,
 -1,
 1184319129,
 1184184697,
 -1,
 -47464,
 1184245660,
 2394,
 -1,
 1184303740,
 2328,
 -47462,
 1184250789,
 2429,
 -1,
 1184434812,
 2327,
 1184646817,
 1184177205,
 -1,
 1184712352,
 1184565884,
 2330,
 1184825343,
 1184645938,
 -1,
 -47457,
 1184707938,
 2321,
 -1,
 1184771793,
 2317,
 -1,
 1184638876,
 2331,
 1185040037,
 1184565884,
 2309,
 -47453,
 1185003704,
 2324,
 -47452,
 1185042315,
 2320,
 -1,
 1185090172,
 2310,
 1185302185,
 1184962315,
 -1,
 -47449,
 1185261884,
 2353,
 -47448,
 1185294236,
 2397,
 -1,
 1185352316,
 2352,
 1185564334,
 1185245789,
 -1,
 1185629869,
 1185507933,
 -1,
 -47444,
 1185548762,
 2356,
 -1,
 1185614460,
 2355,
 -1,
 1185548924,
 2354,
 1185892019,
 1185505392,
 -1,
 1185957554,
 1185823097,
 -1,
 -47439,
 1185884060,
 2393,
 -1,
 1185942140,
 2326,
 -1,
 1185876604,
 2325,
 1186219702,
 1185817300,
 -1,
 -47435,
 1186173598,
 2399,
 -1,
 1186204284,
 2351,
 1186416312,
 1186183352,
 2313,
 -1,
 1186379960,
 2314,
 1186547387,
 1186368716,
 -1,
 -47430,
 1186473884,
 2347,
 -1,
 1186531964,
 2346,
 1186743998,
 1186486268,
 -1,
 -47427,
 1186670492,
 2333,
 -1,
 1186728572,
 2332,
 1186940608,
 1186680715,
 2311,
 -1,
 1186877323,
 2312,
 1187071683,
 1186861937,
 -1,
 -47422,
 1186998172,
 2349,
 -1,
 1187056252,
 2348,
 -47420,
 1186995325,
 2395,
 -47419,
 1187190529,
 2392,
 -47418,
 1187263842,
 2323,
 -47417,
 1187329446,
 2350,
 -47416,
 1187391388,
 2361,
 -47415,
 1187484126,
 2398,
 -1,
 1187524305,
 2319,
 1187727072,
 1181765875,
 -1,
 1187792592,
 1187645835,
 -1,
 1187858126,
 1187714827,
 2371,
 -1,
 1187780363,
 2372,
 1188036607,
 1187801693,
 2402,
 -1,
 1187932765,
 2403,
 1188120276,
 1187711612,
 -1,
 -47406,
 1188083896,
 2380,
 -47405,
 1188122507,
 2376,
 -1,
 1188170364,
 2366,
 1188382422,
 1188083896,
 2369,
 -1,
 1188346040,
 2370,
 1188513497,
 1188299378,
 -1,
 -47400,
 1188443490,
 2378,
 -1,
 1188507345,
 2374,
 1188710107,
 1188450187,
 2367,
 -1,
 1188646795,
 2368,
 1188841182,
 1188668554,
 -1,
 -47395,
 1188771170,
 2377,
 -1,
 1188835025,
 2373,
 -47393,
 1188771170,
 2379,
 -1,
 1188966097,
 2375,
 1189168881,
 1187652928,
 -1,
 1189234415,
 1189123057,
 -1,
 1189299941,
 1189195714,
 -1,
 -47388,
 1189234284,
 2408,
 -1,
 1189299119,
 2409,
 1189496552,
 1189235479,
 -1,
 -47385,
 1189433183,
 2412,
 -1,
 1189480517,
 2413,
 1189693163,
 1189427071,
 -1,
 -47382,
 1189634996,
 2410,
 -1,
 1189708988,
 2411,
 -47380,
 1189617590,
 2406,
 -47379,
 1189808680,
 2407,
 -47378,
 1189914134,
 2415,
 -1,
 1189953259,
 2414,
 -47376,
 1189191306,
 2405,
 -1,
 1190111450,
 2404,
 1190283006,
 1189104407,
 -1,
 1190348539,
 1190230884,
 -1,
 1190414070,
 1190273640,
 -1,
 -47371,
 1190343215,
 2307,
 -1,
 1190408738,
 2381,
 1190610681,
 1190333052,
 -1,
 -47368,
 1190533982,
 2365,
 -1,
 1190631218,
 2306,
 -47366,
 1190544363,
 2364,
 -1,
 1190751398,
 2305,
 1190985727,
 1190304230,
 -1,
 -47363,
 1190900477,
 2385,
 -1,
 1190935366,
 2386,
 1191134977,
 1190201980,
 -1,
 -47360,
 1191076300,
 2388,
 -1,
 1191123118,
 2416,
 -47358,
 1191084420,
 2384,
 -1,
 1191252558,
 2387,
 1191462756,
 1181698839,
 -1,
 1191528291,
 1191415785,
 -1,
 1191593780,
 1191455650,
 -1,
 1191659281,
 1191522001,
 -1,
 1191724809,
 1191594775,
 66629,
 -1,
 1191655801,
 66631,
 1191855883,
 1191672834,
 66636,
 -1,
 1191788357,
 66637,
 -47348,
 1191776568,
 66639,
 -47347,
 1191924353,
 66627,
 -47346,
 1191974667,
 66633,
 -47345,
 1192063748,
 66635,
 -47344,
 1192127069,
 66634,
 -1,
 1192179583,
 66625,
 1192380184,
 1191576178,
 -1,
 1192445716,
 1192310114,
 66610,
 -1,
 1192375650,
 66611,
 1192576790,
 1192364668,
 66608,
 -1,
 1192507769,
 66609,
 -47337,
 1192513419,
 66606,
 -1,
 1192636113,
 66607,
 1192838943,
 1192309437,
 -1,
 1192904475,
 1192768866,
 66604,
 -1,
 1192834402,
 66605,
 1193035549,
 1192823420,
 66602,
 -1,
 1192966521,
 66603,
 -47330,
 1192972171,
 66600,
 -1,
 1193094865,
 66601,
 1193297698,
 1192766583,
 -1,
 -47327,
 1193245700,
 66632,
 -1,
 1193307331,
 66630,
 1193494309,
 1193258946,
 -1,
 -47324,
 1193442308,
 66628,
 -1,
 1193503939,
 66619,
 1193690920,
 1193424226,
 -1,
 -47321,
 1193611576,
 66613,
 -1,
 1193693067,
 66638,
 -47319,
 1193625679,
 66615,
 -47318,
 1193821925,
 66614,
 -47317,
 1193894946,
 66626,
 -47316,
 1193956450,
 66617,
 -47315,
 1194046212,
 66623,
 -47314,
 1194083689,
 66622,
 -47313,
 1194146169,
 66616,
 -47312,
 1194240975,
 66624,
 -47311,
 1194296050,
 66620,
 -47310,
 1194364354,
 66621,
 -47309,
 1194400884,
 66618,
 -1,
 1194486633,
 66612,
 1194721279,
 1191522798,
 -1,
 1194739520,
 1194602193,
 -1,
 1194805048,
 1194674967,
 66589,
 -1,
 1194735993,
 66591,
 1194936122,
 1194753026,
 66596,
 -1,
 1194868549,
 66597,
 -47301,
 1194856760,
 66599,
 -47300,
 1195004545,
 66587,
 -47299,
 1195054859,
 66593,
 -47298,
 1195143940,
 66595,
 -47297,
 1195207261,
 66594,
 -1,
 1195259775,
 66585,
 1195460423,
 1194656370,
 -1,
 1195525955,
 1195390306,
 66570,
 -1,
 1195455842,
 66571,
 1195657029,
 1195444860,
 66568,
 -1,
 1195587961,
 66569,
 -47290,
 1195593611,
 66566,
 -1,
 1195716305,
 66567,
 1195919182,
 1195389629,
 -1,
 1195984714,
 1195849058,
 66564,
 -1,
 1195914594,
 66565,
 1196115788,
 1195903612,
 66562,
 -1,
 1196046713,
 66563,
 -47283,
 1196052363,
 66560,
 -1,
 1196175057,
 66561,
 1196377937,
 1195846775,
 -1,
 -47280,
 1196325892,
 66592,
 -1,
 1196387523,
 66590,
 1196574548,
 1196339138,
 -1,
 -47277,
 1196522500,
 66588,
 -1,
 1196584131,
 66579,
 1196771159,
 1196504418,
 -1,
 -47274,
 1196691768,
 66573,
 -1,
 1196773259,
 66598,
 -47272,
 1196705871,
 66575,
 -47271,
 1196902117,
 66574,
 -47270,
 1196975138,
 66586,
 -47269,
 1197036642,
 66577,
 -47268,
 1197126404,
 66583,
 -47267,
 1197163881,
 66582,
 -47266,
 1197226361,
 66576,
 -47265,
 1197321167,
 66584,
 -47264,
 1197376242,
 66580,
 -47263,
 1197444546,
 66581,
 -47262,
 1197481076,
 66578,
 -1,
 1197566825,
 66572,
 -1,
 1191485824,
 9739,
 1197819771,
 1191404556,
 -1,
 1197885297,
 1197747911,
 -1,
 1197950830,
 1197844914,
 -1,
 1198016362,
 1197868511,
 -1,
 -47255,
 1197974070,
 9150,
 -1,
 1198023627,
 9163,
 1198212973,
 1197968958,
 -1,
 -47252,
 1198170678,
 9151,
 -1,
 1198220235,
 9164,
 -1,
 1198174984,
 9158,
 1198522367,
 1197873724,
 -1,
 -47248,
 1198432205,
 9155,
 -1,
 1198487361,
 9152,
 1198671734,
 1197825503,
 9162,
 1198784511,
 1198599620,
 -1,
 -47244,
 1198699272,
 9160,
 -47243,
 1198759885,
 9157,
 -1,
 1198815041,
 9154,
 1199046655,
 1198620344,
 9161,
 1199112191,
 1198927300,
 -1,
 -47239,
 1199026952,
 9159,
 -47238,
 1199087565,
 9156,
 -1,
 1199142721,
 9153,
 1199327103,
 1197777432,
 -1,
 -47235,
 1199249818,
 176,
 -47234,
 1199313610,
 8457,
 -1,
 1199378751,
 8451,
 -47232,
 1199249165,
 8796,
 -1,
 1199531695,
 9110,
 1199720510,
 1181627746,
 -1,
 1199785966,
 1199672731,
 -1,
 1199851465,
 1199725767,
 -1,
 1199916949,
 1199774773,
 -1,
 1199982484,
 1199833251,
 -1,
 1200048019,
 1199940707,
 -1,
 1200113546,
 1200009154,
 -1,
 -47223,
 1200047724,
 9462,
 -1,
 1200112559,
 9463,
 1200310157,
 1200048919,
 -1,
 -47220,
 1200246623,
 9466,
 -1,
 1200293957,
 9467,
 1200506768,
 1200240511,
 -1,
 -47217,
 1200448436,
 9464,
 -1,
 1200522428,
 9465,
 -47215,
 1200425512,
 9461,
 -47214,
 1200662038,
 9469,
 -1,
 1200701163,
 9468,
 -1,
 1199984493,
 9470,
 -1,
 1199900253,
 10868,
 1201031071,
 1199852311,
 -1,
 1201096602,
 1200994488,
 -1,
 -47208,
 1201032833,
 8913,
 -47207,
 1201099733,
 10940,
 -1,
 1201188996,
 8912,
 1201358749,
 1201032743,
 -1,
 -47204,
 1201305774,
 10831,
 -1,
 1201373223,
 10830,
 -47202,
 1201311033,
 10988,
 -1,
 1201509273,
 11005,
 1201686440,
 1200974429,
 -1,
 1201751975,
 1201616226,
 -1,
 1201817508,
 1201672504,
 -1,
 -47197,
 1201766750,
 8222,
 -1,
 1201802060,
 8215,
 1202061311,
 1201740305,
 -1,
 -47194,
 1201963536,
 10836,
 -1,
 1202026979,
 10835,
 -1,
 1201699164,
 10645,
 1202276271,
 1201614535,
 -1,
 1202341806,
 1202210908,
 -1,
 1202407341,
 1202303908,
 -1,
 -47188,
 1202332842,
 8875,
 -1,
 1202394794,
 10981,
 -1,
 1202329258,
 10979,
 -1,
 1202284847,
 8214,
 1202735029,
 1202228428,
 -1,
 1202800564,
 1202657035,
 -1,
 1202866099,
 1202724814,
 8243,
 -1,
 1202827745,
 12318,
 -1,
 1202814538,
 10939,
 -1,
 1202744881,
 10746,
 1203128249,
 1202685758,
 -1,
 1203193784,
 1203062832,
 10913,
 -1,
 1203131838,
 10915,
 -1,
 1203147212,
 10914,
 1203390396,
 1203091640,
 -1,
 -47173,
 1203307546,
 10987,
 -1,
 1203374832,
 8915,
 1203587007,
 1203324110,
 -1,
 -47170,
 1203524216,
 8914,
 -1,
 1203614962,
 8748,
 1203783618,
 1203512640,
 -1,
 -47167,
 1203729052,
 10986,
 -1,
 1203795820,
 8225,
 -47165,
 1203722664,
 65100,
 -47164,
 1203923376,
 10646,
 -47163,
 1203969401,
 8263,
 -47162,
 1204071215,
 11799,
 -47161,
 1204100796,
 8223,
 -47160,
 1204173704,
 8252,
 -1,
 1204264262,
 733,
 1204439019,
 1199773068,
 -1,
 1204504544,
 1204386176,
 -1,
 1204570069,
 1204464130,
 -1,
 1204635598,
 1204522188,
 8473,
 -1,
 1204572043,
 8511,
 -47153,
 1204563063,
 8484,
 -47152,
 1204688651,
 8477,
 -47151,
 1204786721,
 8474,
 -47150,
 1204845570,
 8469,
 -47149,
 1204894073,
 8461,
 -47148,
 1204981494,
 8510,
 -1,
 1205017653,
 8450,
 1205225436,
 1204503352,
 -1,
 1205290971,
 1205181320,
 -1,
 -47144,
 1205229564,
 8521,
 -47143,
 1205292939,
 8520,
 -47142,
 1205350097,
 8519,
 -1,
 1205413184,
 8518,
 -1,
 1205216860,
 8517,
 1205684191,
 1205181320,
 -1,
 -47138,
 1205618733,
 8508,
 -1,
 1205702390,
 8509,
 -1,
 1205625727,
 8512,
 1205946346,
 1204459398,
 -1,
 1206011879,
 1205882248,
 -1,
 1206077413,
 1205962515,
 -1,
 -47132,
 1206011952,
 10907,
 -1,
 1206096332,
 10908,
 -47130,
 1206026231,
 11001,
 -1,
 1206202424,
 11002,
 1206452223,
 1205962515,
 -1,
 -47127,
 1206339632,
 10905,
 -1,
 1206424012,
 10906,
 -1,
 1205888534,
 10719,
 1206714367,
 1204372929,
 -1,
 -47123,
 1206617025,
 9891,
 -1,
 1206683268,
 9890,
 1206863904,
 1199714832,
 -1,
 1206929431,
 1206819051,
 -1,
 1206994942,
 1206848124,
 -1,
 1207060477,
 1206953225,
 8595,
 1207173119,
 1207000263,
 -1,
 1207191546,
 1207048764,
 -1,
 1207257079,
 1207154329,
 -1,
 -47114,
 1207217201,
 8627,
 -1,
 1207272640,
 8626,
 -47112,
 1207192090,
 10504,
 -47111,
 1207388332,
 8671,
 -1,
 1207475115,
 8629,
 -47109,
 1207143926,
 10515,
 -47108,
 1207599635,
 8693,
 -1,
 1207674895,
 8615,
 -1,
 1206979168,
 11796,
 1207912460,
 1206920411,
 -1,
 1207977991,
 1207854027,
 -1,
 1208043526,
 1207917767,
 -1,
 1208109060,
 1207976821,
 -1,
 -47101,
 1208048970,
 10607,
 -1,
 1208099976,
 10597,
 -47099,
 1208061430,
 10585,
 -1,
 1208264719,
 10593,
 -1,
 1207970821,
 8643,
 1208549375,
 1207935542,
 -1,
 1208567819,
 1208442055,
 -1,
 -47094,
 1208520182,
 10581,
 -1,
 1208592399,
 10589,
 -1,
 1208495109,
 8642,
 1208829967,
 1207873474,
 -1,
 -47090,
 1208748927,
 8609,
 -1,
 1208818674,
 10507,
 1209026578,
 1208755520,
 -1,
 -47087,
 1208980785,
 8659,
 -1,
 1209032307,
 8675,
 -47085,
 1208969370,
 8623,
 -47084,
 1209172572,
 8681,
 -47083,
 1209240935,
 10225,
 -47082,
 1209295496,
 8650,
 -1,
 1209355144,
 11015,
 1209550877,
 1206869191,
 -1,
 1209616410,
 1209475768,
 8868,
 -1,
 1209563354,
 10993,
 -47077,
 1209563270,
 8945,
 -47076,
 1209703227,
 10623,
 -1,
 1209775428,
 8964,
 1209991167,
 1209471859,
 -1,
 -47073,
 1209895455,
 10729,
 -1,
 1209940723,
 10728,
 1210140718,
 1206811052,
 -1,
 1210206245,
 1210099089,
 -1,
 1210271780,
 1210127141,
 8832,
 -1,
 1210219690,
 8928,
 -1,
 1210215571,
 8876,
 1210468393,
 1210124697,
 -1,
 1210533928,
 1210407480,
 8939,
 -1,
 1210481834,
 8941,
 -1,
 1210451756,
 8716,
 1210730539,
 1210399364,
 8833,
 -1,
 1210678442,
 8929,
 1210861613,
 1210673759,
 8740,
 -1,
 1210789540,
 10990,
 -1,
 1210792326,
 8878,
 1211058236,
 1210101698,
 -1,
 1211123767,
 1211020821,
 -1,
 1211189299,
 1211046965,
 -1,
 -47054,
 1211144875,
 8284,
 -1,
 1211183374,
 9676,
 -47052,
 1211125238,
 11784,
 -47051,
 1211305467,
 11798,
 -47050,
 1211392139,
 11795,
 -1,
 1211458719,
 10649,
 1211695103,
 1211063495,
 -1,
 -47047,
 1211591116,
 8724,
 -47046,
 1211640117,
 8901,
 -47045,
 1211704450,
 8760,
 -1,
 1211798408,
 729,
 -47043,
 1210990572,
 8363,
 -1,
 1211904621,
 36,
 1212106925,
 1199656843,
 -1,
 1212172397,
 1212049310,
 -1,
 1212237918,
 1212126834,
 -1,
 1212303440,
 1212171096,
 -1,
 1212368975,
 1212261475,
 -1,
 1212434502,
 1212329922,
 -1,
 -47035,
 1212368492,
 10123,
 -1,
 1212433327,
 10124,
 1212631113,
 1212369687,
 -1,
 -47032,
 1212567391,
 10127,
 -1,
 1212614725,
 10128,
 1212827724,
 1212561279,
 -1,
 -47029,
 1212769204,
 10125,
 -1,
 1212843196,
 10126,
 -47027,
 1212746280,
 10122,
 -47026,
 1212982806,
 10130,
 -1,
 1213021931,
 10129,
 -1,
 1212305261,
 10131,
 1213286493,
 1212261475,
 -1,
 1213352020,
 1213247426,
 -1,
 -47021,
 1213285996,
 10103,
 -1,
 1213350831,
 10104,
 1213548631,
 1213287191,
 -1,
 -47018,
 1213484895,
 10107,
 -1,
 1213532229,
 10108,
 1213745242,
 1213478783,
 -1,
 -47015,
 1213686708,
 10105,
 -1,
 1213760700,
 10106,
 -47013,
 1213663784,
 10102,
 -47012,
 1213900310,
 10110,
 -1,
 1213939435,
 10109,
 -1,
 1213222765,
 10111,
 1214251007,
 1212168812,
 -1,
 1214269548,
 1214162019,
 -1,
 1214335075,
 1214230466,
 -1,
 -47006,
 1214269036,
 10113,
 -1,
 1214333871,
 10114,
 1214531686,
 1214270231,
 -1,
 -47003,
 1214467935,
 10117,
 -1,
 1214515269,
 10118,
 1214728297,
 1214461823,
 -1,
 -47000,
 1214669748,
 10115,
 -1,
 1214743740,
 10116,
 -46998,
 1214646824,
 10112,
 -46997,
 1214883350,
 10120,
 -1,
 1214922475,
 10119,
 -1,
 1214205805,
 10121,
 1215187091,
 1212104517,
 -1,
 1215252613,
 1215143329,
 -1,
 1215318132,
 1215213506,
 -1,
 1215383666,
 1215252076,
 50,
 -1,
 1215331055,
 9353,
 1215561727,
 1215316911,
 51,
 -1,
 1215462127,
 9354,
 1215645817,
 1215253271,
 -1,
 1215711351,
 1215582047,
 54,
 -1,
 1215658735,
 9357,
 1215889407,
 1215629381,
 55,
 -1,
 1215789807,
 9358,
 1215973502,
 1215575935,
 -1,
 1216039036,
 1215914932,
 52,
 -1,
 1215986415,
 9355,
 1216217087,
 1215988924,
 53,
 -1,
 1216117487,
 9356,
 1216301184,
 1215892008,
 49,
 -1,
 1216248559,
 9352,
 1216432258,
 1216259606,
 57,
 -1,
 1216379631,
 9360,
 1216563332,
 1216364267,
 56,
 -1,
 1216510703,
 9359,
 -1,
 1216487350,
 48,
 1216806911,
 1215183737,
 -1,
 1216825482,
 1216710438,
 119557,
 1216937983,
 1216765712,
 -1,
 -46967,
 1216837020,
 119556,
 -1,
 1216910956,
 119555,
 1217087629,
 1216781558,
 -1,
 -46964,
 1217023950,
 9869,
 -1,
 1217100263,
 9870,
 1217284240,
 1217018233,
 -1,
 -46961,
 1217235649,
 119554,
 -1,
 1217299098,
 119553,
 1217527807,
 1217208161,
 -1,
 -46958,
 1217417166,
 9871,
 -1,
 1217493479,
 9868,
 1217677466,
 1215120737,
 -1,
 -46955,
 1217618866,
 9861,
 -46954,
 1217682011,
 9860,
 -46953,
 1217745440,
 9859,
 -46952,
 1217808843,
 9858,
 -46951,
 1217872308,
 9857,
 -1,
 1217935694,
 9856,
 1218136227,
 1217595419,
 -1,
 1218201762,
 1218072459,
 -1,
 1218267297,
 1218161558,
 -1,
 1218332832,
 1218202391,
 -1,
 -46945,
 1218248987,
 8725,
 -1,
 1218351358,
 247,
 -1,
 1218259274,
 8903,
 -1,
 1218191141,
 8739,
 -1,
 1218134177,
 9902,
 1218726056,
 1218054780,
 -1,
 1218791591,
 1218671364,
 -1,
 -46938,
 1218722668,
 8900,
 -1,
 1218801205,
 8960,
 -1,
 1218729111,
 168,
 -46935,
 1218648859,
 12291,
 -46934,
 1218987410,
 9090,
 -46933,
 1219052529,
 9107,
 -46932,
 1219112182,
 9009,
 -1,
 1219179180,
 8783,
 1219381429,
 1212025468,
 -1,
 1219446962,
 1219329052,
 -1,
 -46928,
 1219387662,
 10143,
 -46927,
 1219470539,
 65097,
 -1,
 1219498901,
 65101,
 -46925,
 1219375623,
 9619,
 -46924,
 1219634211,
 8504,
 -1,
 1219720845,
 8224,
 1219952639,
 1219340604,
 -1,
 -46921,
 1219837574,
 10139,
 -1,
 1219915090,
 8367,
 1220102645,
 1181550619,
 -1,
 1220168122,
 1220059950,
 -1,
 1220233513,
 1220098382,
 65024,
 1220298950,
 1220181523,
 917762,
 -46915,
 1220247059,
 917942,
 -46914,
 1220310433,
 917941,
 -46913,
 1220373641,
 917940,
 -46912,
 1220436914,
 917939,
 -46911,
 1220500059,
 917938,
 -46910,
 1220563488,
 917937,
 -46909,
 1220626891,
 917936,
 -46908,
 1220690356,
 917935,
 -46907,
 1220753742,
 917934,
 -1,
 1220817413,
 917933,
 1221019857,
 1220244897,
 917761,
 -46904,
 1220967955,
 917932,
 -46903,
 1221031329,
 917931,
 -46902,
 1221094537,
 917930,
 -46901,
 1221157810,
 917929,
 -46900,
 1221220955,
 917928,
 -46899,
 1221284384,
 917927,
 -46898,
 1221347787,
 917926,
 -46897,
 1221411252,
 917925,
 -46896,
 1221474638,
 917924,
 -1,
 1221538309,
 917923,
 1221740764,
 1220963465,
 917760,
 -46893,
 1221688851,
 917922,
 -46892,
 1221752225,
 917921,
 -46891,
 1221815433,
 917920,
 -46890,
 1221878706,
 917919,
 -46889,
 1221941851,
 917918,
 -46888,
 1222005280,
 917917,
 -46887,
 1222068683,
 917916,
 -46886,
 1222132148,
 917915,
 -46885,
 1222195534,
 917914,
 -1,
 1222259205,
 917913,
 1222461671,
 1221682098,
 65039,
 -46882,
 1222409747,
 917912,
 -46881,
 1222473121,
 917911,
 -46880,
 1222536329,
 917910,
 -46879,
 1222599602,
 917909,
 -46878,
 1222662747,
 917908,
 -46877,
 1222726176,
 917907,
 -46876,
 1222789579,
 917906,
 -46875,
 1222853044,
 917905,
 -46874,
 1222916430,
 917904,
 -1,
 1222980101,
 917903,
 1223182578,
 1222400603,
 65038,
 -46871,
 1223130643,
 917902,
 -46870,
 1223194017,
 917901,
 -46869,
 1223257225,
 917900,
 -46868,
 1223320498,
 917899,
 -46867,
 1223383643,
 917898,
 -46866,
 1223447072,
 917897,
 -46865,
 1223510475,
 917896,
 -46864,
 1223573940,
 917895,
 -46863,
 1223637326,
 917894,
 -1,
 1223700997,
 917893,
 1223903485,
 1223119392,
 65037,
 -46860,
 1223851539,
 917892,
 -46859,
 1223914913,
 917891,
 -46858,
 1223978121,
 917890,
 -46857,
 1224041394,
 917889,
 -46856,
 1224104539,
 917888,
 -46855,
 1224167968,
 917887,
 -46854,
 1224231371,
 917886,
 -46853,
 1224294836,
 917885,
 -46852,
 1224358222,
 917884,
 -1,
 1224421893,
 917883,
 1224624392,
 1223838155,
 65036,
 -46849,
 1224572435,
 917882,
 -46848,
 1224635809,
 917881,
 -46847,
 1224699017,
 917880,
 -46846,
 1224762290,
 917879,
 -46845,
 1224825435,
 917878,
 -46844,
 1224888864,
 917877,
 -46843,
 1224952267,
 917876,
 -46842,
 1225015732,
 917875,
 -46841,
 1225079118,
 917874,
 -1,
 1225142789,
 917873,
 1225345299,
 1224556980,
 65035,
 -46838,
 1225293331,
 917872,
 -46837,
 1225356705,
 917871,
 -46836,
 1225419913,
 917870,
 -46835,
 1225483186,
 917869,
 -46834,
 1225546331,
 917868,
 -46833,
 1225609760,
 917867,
 -46832,
 1225673163,
 917866,
 -46831,
 1225736628,
 917865,
 -46830,
 1225800014,
 917864,
 -1,
 1225863685,
 917863,
 1226066206,
 1225275726,
 65034,
 -46827,
 1226014227,
 917862,
 -46826,
 1226077601,
 917861,
 -46825,
 1226140809,
 917860,
 -46824,
 1226204082,
 917859,
 -46823,
 1226267227,
 917858,
 -46822,
 1226330656,
 917857,
 -46821,
 1226394059,
 917856,
 -46820,
 1226457524,
 917855,
 -46819,
 1226520910,
 917854,
 -1,
 1226584581,
 917853,
 1226833919,
 1225994757,
 65033,
 -46816,
 1226735123,
 917852,
 -46815,
 1226798497,
 917851,
 -46814,
 1226861705,
 917850,
 -46813,
 1226924978,
 917849,
 -46812,
 1226988123,
 917848,
 -46811,
 1227051552,
 917847,
 -46810,
 1227114955,
 917846,
 -46809,
 1227178420,
 917845,
 -46808,
 1227241806,
 917844,
 -1,
 1227305477,
 917843,
 1227508077,
 1220166068,
 65025,
 1227573557,
 1227444768,
 917767,
 -46804,
 1227521555,
 917992,
 -46803,
 1227584929,
 917991,
 -46802,
 1227648137,
 917990,
 -46801,
 1227711410,
 917989,
 -46800,
 1227774555,
 917988,
 -46799,
 1227837984,
 917987,
 -46798,
 1227901387,
 917986,
 -46797,
 1227964852,
 917985,
 -46796,
 1228028238,
 917984,
 -1,
 1228091909,
 917983,
 1228294464,
 1227508171,
 917766,
 -46793,
 1228242451,
 917982,
 -46792,
 1228305825,
 917981,
 -46791,
 1228369033,
 917980,
 -46790,
 1228432306,
 917979,
 -46789,
 1228495451,
 917978,
 -46788,
 1228558880,
 917977,
 -46787,
 1228622283,
 917976,
 -46786,
 1228685748,
 917975,
 -46785,
 1228749134,
 917974,
 -1,
 1228812805,
 917973,
 1229015371,
 1228226996,
 917765,
 -46782,
 1228963347,
 917972,
 -46781,
 1229026721,
 917971,
 -46780,
 1229089929,
 917970,
 -46779,
 1229153202,
 917969,
 -46778,
 1229216347,
 917968,
 -46777,
 1229279776,
 917967,
 -46776,
 1229343179,
 917966,
 -46775,
 1229406644,
 917965,
 -46774,
 1229470030,
 917964,
 -1,
 1229533701,
 917963,
 1229736278,
 1228945742,
 917764,
 -46771,
 1229684243,
 917962,
 -46770,
 1229747617,
 917961,
 -46769,
 1229810825,
 917960,
 -46768,
 1229874098,
 917959,
 -46767,
 1229937243,
 917958,
 -46766,
 1230000672,
 917957,
 -46765,
 1230064075,
 917956,
 -46764,
 1230127540,
 917955,
 -46763,
 1230190926,
 917954,
 -1,
 1230254597,
 917953,
 1230457185,
 1229664773,
 917763,
 -46760,
 1230405139,
 917952,
 -46759,
 1230468513,
 917951,
 -46758,
 1230531721,
 917950,
 -46757,
 1230594994,
 917949,
 -46756,
 1230658139,
 917948,
 -46755,
 1230721568,
 917947,
 -46754,
 1230784971,
 917946,
 -46753,
 1230848436,
 917945,
 -46752,
 1230911822,
 917944,
 -1,
 1230975493,
 917943,
 1231178089,
 1230395995,
 917768,
 -46749,
 1231119282,
 917999,
 -46748,
 1231182427,
 917998,
 -46747,
 1231245856,
 917997,
 -46746,
 1231309259,
 917996,
 -46745,
 1231372724,
 917995,
 -46744,
 1231436110,
 917994,
 -1,
 1231499781,
 917993,
 -46742,
 1231126035,
 917772,
 -46741,
 1231648161,
 917771,
 -46740,
 1231711369,
 917770,
 -1,
 1231774642,
 917769,
 1231964536,
 1227456019,
 65032,
 -46737,
 1231912467,
 917842,
 -46736,
 1231975841,
 917841,
 -46735,
 1232039049,
 917840,
 -46734,
 1232102322,
 917839,
 -46733,
 1232165467,
 917838,
 -46732,
 1232228896,
 917837,
 -46731,
 1232292299,
 917836,
 -46730,
 1232355764,
 917835,
 -46729,
 1232419150,
 917834,
 -1,
 1232482821,
 917833,
 1232685443,
 1231910305,
 65031,
 -46726,
 1232633363,
 917832,
 -46725,
 1232696737,
 917831,
 -46724,
 1232759945,
 917830,
 -46723,
 1232823218,
 917829,
 -46722,
 1232886363,
 917828,
 -46721,
 1232949792,
 917827,
 -46720,
 1233013195,
 917826,
 -46719,
 1233076660,
 917825,
 -46718,
 1233140046,
 917824,
 -1,
 1233203717,
 917823,
 1233406350,
 1232628873,
 65030,
 -46715,
 1233354259,
 917822,
 -46714,
 1233417633,
 917821,
 -46713,
 1233480841,
 917820,
 -46712,
 1233544114,
 917819,
 -46711,
 1233607259,
 917818,
 -46710,
 1233670688,
 917817,
 -46709,
 1233734091,
 917816,
 -46708,
 1233797556,
 917815,
 -46707,
 1233860942,
 917814,
 -1,
 1233924613,
 917813,
 1234127257,
 1233347506,
 65029,
 -46704,
 1234075155,
 917812,
 -46703,
 1234138529,
 917811,
 -46702,
 1234201737,
 917810,
 -46701,
 1234265010,
 917809,
 -46700,
 1234328155,
 917808,
 -46699,
 1234391584,
 917807,
 -46698,
 1234454987,
 917806,
 -46697,
 1234518452,
 917805,
 -46696,
 1234581838,
 917804,
 -1,
 1234645509,
 917803,
 1234848164,
 1234066011,
 65028,
 -46693,
 1234796051,
 917802,
 -46692,
 1234859425,
 917801,
 -46691,
 1234922633,
 917800,
 -46690,
 1234985906,
 917799,
 -46689,
 1235049051,
 917798,
 -46688,
 1235112480,
 917797,
 -46687,
 1235175883,
 917796,
 -46686,
 1235239348,
 917795,
 -46685,
 1235302734,
 917794,
 -1,
 1235366405,
 917793,
 1235569071,
 1234784800,
 65027,
 -46682,
 1235516947,
 917792,
 -46681,
 1235580321,
 917791,
 -46680,
 1235643529,
 917790,
 -46679,
 1235706802,
 917789,
 -46678,
 1235769947,
 917788,
 -46677,
 1235833376,
 917787,
 -46676,
 1235896779,
 917786,
 -46675,
 1235960244,
 917785,
 -46674,
 1236023630,
 917784,
 -1,
 1236087301,
 917783,
 1236336639,
 1235503563,
 65026,
 -46671,
 1236237843,
 917782,
 -46670,
 1236301217,
 917781,
 -46669,
 1236364425,
 917780,
 -46668,
 1236427698,
 917779,
 -46667,
 1236490843,
 917778,
 -46666,
 1236554272,
 917777,
 -46665,
 1236617675,
 917776,
 -46664,
 1236681140,
 917775,
 -46663,
 1236744526,
 917774,
 -1,
 1236808197,
 917773,
 1237010906,
 1220095697,
 -1,
 1237076441,
 1236932363,
 -1,
 1237141973,
 1236994336,
 -1,
 1237207493,
 1237084463,
 124,
 1237319679,
 1237146823,
 -1,
 1237338564,
 1237195324,
 -1,
 1237404099,
 1237284457,
 -1,
 -46654,
 1237328562,
 10992,
 -1,
 1237422984,
 10991,
 -1,
 1237321078,
 9087,
 -1,
 1237295071,
 9168,
 1237731788,
 1237143156,
 -1,
 1237797322,
 1237685248,
 12337,
 1237909503,
 1237736647,
 -1,
 -46647,
 1237787012,
 12339,
 -1,
 1237858461,
 12341,
 1238106111,
 1237724894,
 12338,
 -1,
 1237986641,
 12340,
 1238190544,
 1237665884,
 -1,
 -46642,
 1238107904,
 10978,
 -46641,
 1238213470,
 10980,
 -1,
 1238278382,
 10704,
 -46639,
 1238141782,
 10650,
 -46638,
 1238398294,
 9896,
 -46637,
 1238450827,
 12347,
 -46636,
 1238512439,
 8286,
 -1,
 1238597833,
 8942,
 1238780376,
 1237097525,
 -1,
 -46633,
 1238714416,
 8920,
 -1,
 1238798796,
 8921,
 -1,
 1238733094,
 8483,
 -1,
 1237013571,
 10799,
 1239108080,
 1236961840,
 -1,
 1239173602,
 1239048220,
 -1,
 -46627,
 1239120904,
 8531,
 -46626,
 1239180869,
 8537,
 -46625,
 1239232387,
 188,
 -46624,
 1239293102,
 189,
 -46623,
 1239353068,
 8533,
 -1,
 1239437688,
 8539,
 1239632362,
 1239134146,
 -1,
 1239697895,
 1239570821,
 -1,
 -46619,
 1239623919,
 190,
 -46618,
 1239714096,
 8535,
 -1,
 1239761868,
 8540,
 1240006655,
 1239653321,
 -1,
 -46615,
 1239917482,
 8532,
 -1,
 1239976240,
 8534,
 1240156655,
 1239562111,
 -1,
 1240222190,
 1240073722,
 -1,
 -46611,
 1240164341,
 8538,
 -1,
 1240220620,
 8541,
 -1,
 1240155506,
 8536,
 -1,
 1240078117,
 8542,
 1240549876,
 1239043979,
 -1,
 -46606,
 1240479761,
 9805,
 -46605,
 1240534901,
 8983,
 -1,
 1240607801,
 9996,
 -1,
 1240506489,
 8752,
 1240877943,
 1220024075,
 -1,
 1240943294,
 1240813451,
 -1,
 1241008821,
 1240885349,
 -1,
 1241074255,
 1240947911,
 -1,
 1241139721,
 1241008919,
 -1,
 1241205253,
 1241092986,
 93,
 1241317375,
 1241144519,
 -1,
 1241336322,
 1241193020,
 -1,
 1241401856,
 1241254502,
 -1,
 -46593,
 1241326914,
 10640,
 -1,
 1241417299,
 10638,
 -46591,
 1241318973,
 10636,
 -1,
 1241546606,
 8262,
 -46589,
 1241253746,
 9124,
 -46588,
 1241662225,
 9126,
 -1,
 1241751519,
 9125,
 -46586,
 1241156623,
 11779,
 -46585,
 1241853212,
 8217,
 -46584,
 1241928668,
 8908,
 -1,
 1241988515,
 10182,
 1242188313,
 1241057916,
 -1,
 1242253844,
 1242127554,
 8735,
 1242365951,
 1242193095,
 -1,
 1242384911,
 1242241596,
 -1,
 -46578,
 1242345338,
 9084,
 -1,
 1242410310,
 8894,
 1242581521,
 1242333552,
 12297,
 -1,
 1242512176,
 10642,
 -46574,
 1242508105,
 10652,
 -46573,
 1242643672,
 11776,
 -1,
 1242706085,
 11777,
 1242955775,
 1242175243,
 -1,
 1242974744,
 1242865661,
 -1,
 -46569,
 1242923026,
 8692,
 -1,
 1242973453,
 10228,
 -1,
 1242899546,
 10644,
 1243236899,
 1242108216,
 -1,
 1243302434,
 1243168826,
 -1,
 1243367966,
 1243225141,
 -1,
 -46563,
 1243304440,
 10628,
 -1,
 1243367322,
 12303,
 -46561,
 1243299429,
 12313,
 -46560,
 1243506315,
 12315,
 -46559,
 1243574313,
 10630,
 -1,
 1243612833,
 12311,
 -1,
 1243256069,
 10713,
 1243892267,
 1243159605,
 -1,
 1243957801,
 1243828728,
 125,
 1244069887,
 1243897031,
 -1,
 -46553,
 1243956511,
 9131,
 -46552,
 1244038250,
 9132,
 -1,
 1244107155,
 9133,
 -46550,
 1243891610,
 12301,
 -1,
 1244247983,
 8969,
 1244416562,
 1243852738,
 -1,
 1244482096,
 1244337931,
 -1,
 1244547631,
 1244432835,
 8895,
 -1,
 1244474673,
 10702,
 -1,
 1244496518,
 11786,
 -46543,
 1244432873,
 12309,
 -1,
 1244694886,
 8866,
 1244875322,
 1244349298,
 -1,
 1244940857,
 1244812206,
 -1,
 1245006391,
 1244859004,
 -1,
 -46538,
 1244934225,
 10608,
 -1,
 1244998282,
 12299,
 -46536,
 1244961192,
 10715,
 -1,
 1245152375,
 8221,
 -1,
 1244888602,
 11781,
 1245399615,
 1244819497,
 41,
 1245511679,
 1245338823,
 -1,
 -46531,
 1245398303,
 9118,
 -46530,
 1245483411,
 9120,
 -1,
 1245552607,
 9119,
 1245727298,
 1245328738,
 -1,
 -46527,
 1245665421,
 10198,
 -1,
 1245730593,
 9621,
 1245923909,
 1245690000,
 -1,
 -46524,
 1245878964,
 9616,
 -1,
 1245949795,
 9687,
 1246120520,
 1245853567,
 -1,
 -46521,
 1246060245,
 8971,
 -1,
 1246111786,
 10621,
 1246317131,
 1246067369,
 -1,
 -46518,
 1246248549,
 10648,
 -1,
 1246299809,
 12305,
 -46516,
 1246253264,
 9145,
 -46515,
 1246438793,
 11789,
 -46514,
 1246505393,
 8906,
 -1,
 1246579386,
 11805,
 1246775976,
 1241028843,
 -1,
 1246841457,
 1246736324,
 8594,
 1246906992,
 1246780615,
 -1,
 1246972516,
 1246829116,
 -1,
 1247038043,
 1246932930,
 -1,
 1247103576,
 1246973531,
 8611,
 1247215615,
 1247030724,
 -1,
 -46505,
 1247093220,
 10516,
 -1,
 1247176484,
 10517,
 1247412223,
 1247045737,
 -1,
 -46502,
 1247296900,
 11023,
 -1,
 1247355917,
 11022,
 1247562334,
 1246970738,
 -1,
 -46499,
 1247502876,
 8699,
 -1,
 1247569264,
 10513,
 -46497,
 1247486436,
 8696,
 -46496,
 1247705465,
 8603,
 -46495,
 1247781261,
 10565,
 -46494,
 1247809964,
 8620,
 -46493,
 1247914839,
 8618,
 -1,
 1247981786,
 8628,
 1248152169,
 1246932930,
 -1,
 1248217704,
 1248113863,
 -1,
 -46489,
 1248162945,
 10526,
 -1,
 1248234000,
 8677,
 -1,
 1248160919,
 10567,
 1248479853,
 1248111858,
 -1,
 -46485,
 1248427240,
 10612,
 -46484,
 1248467629,
 10562,
 -1,
 1248552239,
 10613,
 1248741999,
 1248438287,
 8614,
 -1,
 1248671379,
 10528,
 -1,
 1248688095,
 8644,
 -1,
 1246830248,
 10522,
 1249004165,
 1246763285,
 -1,
 1249069700,
 1248955869,
 -1,
 1249135229,
 1249023183,
 -1,
 1249200764,
 1249074375,
 -1,
 1249266298,
 1249160434,
 -1,
 1249331833,
 1249208925,
 -1,
 -46472,
 1249266398,
 10604,
 -1,
 1249329161,
 10600,
 -1,
 1249275690,
 10596,
 -46469,
 1249218038,
 10579,
 -1,
 1249552399,
 10587,
 -1,
 1249127429,
 8640,
 1249837055,
 1249095888,
 -1,
 1249856131,
 1249729735,
 -1,
 -46464,
 1249807862,
 10583,
 -46463,
 1249880079,
 10591,
 -46462,
 1249949599,
 10605,
 -1,
 1249978283,
 10601,
 -1,
 1249782789,
 8641,
 -1,
 1249030473,
 8652,
 1250314902,
 1248964546,
 -1,
 1250380435,
 1250248300,
 -1,
 1250445970,
 1250333668,
 -1,
 1250511505,
 1250393455,
 -1,
 1250577040,
 1250433596,
 -1,
 1250642574,
 1250508451,
 10518,
 1250754559,
 1250569668,
 -1,
 -46451,
 1250632164,
 10519,
 -1,
 1250715428,
 10520,
 -46449,
 1250566628,
 10496,
 -1,
 1250846500,
 10497,
 -1,
 1250535439,
 10501,
 -1,
 1250451071,
 10512,
 -1,
 1250372276,
 8608,
 1251278847,
 1250319814,
 -1,
 -46443,
 1251165849,
 10511,
 -1,
 1251258308,
 8667,
 1251429025,
 1250239808,
 -1,
 1251494560,
 1251362575,
 -1,
 1251560095,
 1251454916,
 8658,
 1251625630,
 1251499207,
 -1,
 1251691165,
 1251547708,
 -1,
 -46436,
 1251615204,
 10499,
 -1,
 1251703161,
 8655,
 -1,
 1251649551,
 10503,
 -1,
 1251548840,
 10524,
 -1,
 1251493529,
 10509,
 -1,
 1251434099,
 8674,
 1252149925,
 1251348792,
 -1,
 1252215460,
 1252094689,
 8680,
 -1,
 1252169424,
 8688,
 -1,
 1252156696,
 8605,
 -46426,
 1252087520,
 8669,
 -46425,
 1252352648,
 8649,
 -1,
 1252439994,
 8702,
 1252608692,
 1246696844,
 -1,
 1252674221,
 1252561641,
 -1,
 -46421,
 1252612732,
 8238,
 -46420,
 1252692992,
 8207,
 -1,
 1252725234,
 8235,
 1252936369,
 1252608916,
 -1,
 -46417,
 1252857711,
 187,
 -46416,
 1252934047,
 10749,
 -1,
 1252986317,
 9002,
 1253244927,
 1252870935,
 -1,
 -46413,
 1253158235,
 10552,
 -1,
 1253219461,
 10153,
 -1,
 1252547009,
 10813,
 1253460666,
 1240952156,
 -1,
 -46409,
 1253386549,
 8728,
 -46408,
 1253447668,
 8790,
 -46407,
 1253530906,
 8791,
 -1,
 1253610376,
 730,
 1253788349,
 1253397736,
 -1,
 -46404,
 1253748625,
 10544,
 -1,
 1253806929,
 10539,
 -1,
 1253717104,
 65020,
 1254050592,
 1240905912,
 -1,
 1254116126,
 1253971248,
 -1,
 1254181656,
 1254063820,
 -1,
 1254247119,
 1254116119,
 -1,
 1254312652,
 1254164554,
 -1,
 -46396,
 1254266108,
 5863,
 -46395,
 1254319621,
 5840,
 -46394,
 1254390898,
 5836,
 -46393,
 1254439980,
 5805,
 -46392,
 1254532017,
 5823,
 -46391,
 1254573944,
 5849,
 -46390,
 1254648009,
 5821,
 -46389,
 1254697754,
 5843,
 -1,
 1254757189,
 5830,
 -46387,
 1254251838,
 5861,
 -46386,
 1254897394,
 5834,
 -1,
 1254951784,
 5835,
 1255164629,
 1254176098,
 5806,
 -46383,
 1255101777,
 5855,
 -46382,
 1255163145,
 5801,
 -46381,
 1255256151,
 5845,
 -46380,
 1255308290,
 5808,
 -1,
 1255354065,
 5807,
 1255557853,
 1255107165,
 -1,
 1255623388,
 1255506383,
 -1,
 -46376,
 1255576828,
 5862,
 -46375,
 1255619628,
 5804,
 -46374,
 1255688056,
 5848,
 -46373,
 1255762121,
 5820,
 -1,
 1255813138,
 5829,
 -1,
 1255586074,
 5850,
 1256082148,
 1255493515,
 -1,
 1256147680,
 1256019828,
 5853,
 -1,
 1256082699,
 5852,
 -46367,
 1256070586,
 5831,
 -46366,
 1256204482,
 5825,
 -46365,
 1256292880,
 5857,
 -1,
 1256371696,
 5864,
 1256540905,
 1256009425,
 5826,
 -46362,
 1256477313,
 5799,
 -46361,
 1256544116,
 5814,
 -46360,
 1256606877,
 5846,
 -1,
 1256688144,
 5856,
 1256868591,
 1256465728,
 5841,
 1256934126,
 1256791627,
 -1,
 -46356,
 1256885452,
 5844,
 -46355,
 1256946690,
 5824,
 -1,
 1257007709,
 5851,
 -1,
 1256885112,
 5854,
 1257261813,
 1256791093,
 5837,
 1257327347,
 1257189073,
 -1,
 -46350,
 1257274370,
 5811,
 -1,
 1257344663,
 5860,
 -46348,
 1257285147,
 5858,
 -1,
 1257475735,
 5859,
 1257655034,
 1257193285,
 5813,
 1257720569,
 1257582289,
 -1,
 -46344,
 1257641739,
 5828,
 -1,
 1257747063,
 5815,
 -1,
 1257671184,
 5816,
 1257982719,
 1257572988,
 -1,
 -46340,
 1257931233,
 5800,
 -46339,
 1257997864,
 5833,
 -46338,
 1258041165,
 5803,
 -1,
 1258110952,
 5802,
 1258310401,
 1257906900,
 5796,
 -1,
 1258231563,
 5795,
 1258441475,
 1258230072,
 5797,
 -1,
 1258361784,
 5817,
 1258572550,
 1258401730,
 -1,
 -46331,
 1258491977,
 5839,
 -1,
 1258597576,
 5798,
 1258769161,
 1258526724,
 -1,
 -46328,
 1258687100,
 5810,
 -1,
 1258785757,
 5812,
 1258965772,
 1258694556,
 -1,
 -46325,
 1258921467,
 5818,
 -1,
 1258970275,
 5819,
 -46323,
 1258892407,
 5838,
 -46322,
 1259084219,
 5866,
 -46321,
 1259145243,
 5793,
 -46320,
 1259237612,
 5794,
 -46319,
 1259307914,
 5809,
 -46318,
 1259378209,
 5865,
 -46317,
 1259433081,
 5832,
 -46316,
 1259498265,
 5822,
 -46315,
 1259570950,
 5847,
 -46314,
 1259620423,
 5827,
 -46313,
 1259705297,
 5792,
 -1,
 1259757428,
 5842,
 -46311,
 1254123239,
 5871,
 -46310,
 1259910297,
 5867,
 -46309,
 1259974201,
 5868,
 -46308,
 1260015012,
 5869,
 -46307,
 1260094624,
 5872,
 -1,
 1260165190,
 5870,
 -46305,
 1254050018,
 8360,
 -1,
 1260264361,
 10740,
 1260473164,
 1253977809,
 -1,
 1260538683,
 1260424874,
 -1,
 1260604215,
 1260471745,
 -1,
 1260669735,
 1260564418,
 -1,
 1260735270,
 1260598829,
 8765,
 -1,
 1260692571,
 8909,
 -1,
 1260658480,
 8247,
 1260931883,
 1260630948,
 -1,
 1260997418,
 1260849447,
 8246,
 -1,
 1260958177,
 12317,
 -1,
 1260954338,
 10989,
 1261194030,
 1260866327,
 -1,
 -46291,
 1261132138,
 8271,
 -1,
 1261180431,
 8515,
 1261390641,
 1261145292,
 -1,
 -46288,
 1261330603,
 8245,
 -1,
 1261382010,
 8267,
 1261587251,
 1261340834,
 10659,
 -1,
 1261524414,
 10661,
 -46284,
 1261537957,
 9753,
 -46283,
 1261644608,
 8976,
 -46282,
 1261701123,
 11793,
 -1,
 1261783015,
 10672,
 1262026751,
 1260541304,
 92,
 1262092287,
 1261919431,
 -1,
 -46278,
 1261977900,
 10743,
 -1,
 1262037301,
 10741,
 1262242631,
 1260496308,
 -1,
 1262308166,
 1262193784,
 -1,
 1262373701,
 1262228878,
 -1,
 -46273,
 1262296828,
 9849,
 -46272,
 1262386053,
 9848,
 -46271,
 1262442190,
 9847,
 -46270,
 1262510552,
 9846,
 -46269,
 1262570801,
 9845,
 -46268,
 1262628380,
 9844,
 -1,
 1262695002,
 9843,
 -1,
 1262300566,
 9850,
 -1,
 1262260482,
 9852,
 -46264,
 1262166954,
 9166,
 -46263,
 1262944796,
 8479,
 -46262,
 1263034577,
 65533,
 -46261,
 1263112699,
 174,
 -1,
 1263182339,
 8251,
 1263356782,
 1260402018,
 -1,
 1263422314,
 1263286570,
 -1,
 1263487829,
 1263382466,
 -1,
 1263553362,
 1263407416,
 -1,
 -46255,
 1263482210,
 8545,
 -1,
 1263539515,
 8555,
 1263749972,
 1263496370,
 8553,
 -1,
 1263699188,
 8578,
 -1,
 1263682479,
 8546,
 1263946589,
 1263417215,
 -1,
 1264012124,
 1263882123,
 -1,
 1264077659,
 1263936093,
 8548,
 1264189439,
 1264016583,
 -1,
 -46246,
 1264071971,
 8577,
 -1,
 1264130897,
 8558,
 -1,
 1264019975,
 8556,
 -1,
 1263952820,
 8547,
 1264470882,
 1263864360,
 8544,
 1264582655,
 1264409799,
 -1,
 1264601953,
 1264465187,
 8559,
 -1,
 1264554578,
 8576,
 -1,
 1264524113,
 8557,
 1264798565,
 1264405271,
 -1,
 -46236,
 1264734047,
 8549,
 -1,
 1264781381,
 8550,
 1264995176,
 1264725713,
 -1,
 -46233,
 1264928703,
 8554,
 -1,
 1265014285,
 8551,
 -46231,
 1264922659,
 8579,
 -1,
 1265149462,
 8552,
 1265369087,
 1263339088,
 -1,
 -46228,
 1265272662,
 10085,
 -46227,
 1265342002,
 10087,
 -1,
 1265378190,
 8506,
 1265631231,
 1263274620,
 -1,
 1265650547,
 1265504940,
 -1,
 -46223,
 1265582758,
 11787,
 -46222,
 1265662400,
 11782,
 -1,
 1265705076,
 11783,
 1265912694,
 1265582984,
 -1,
 -46219,
 1265859290,
 9762,
 -1,
 1265902460,
 9143,
 -1,
 1265872467,
 8758,
 1266175204,
 1240806754,
 -1,
 1266240493,
 1266095883,
 -1,
 1266306025,
 1266175883,
 -1,
 1266371560,
 1266249355,
 -1,
 1266437057,
 1266319052,
 -1,
 1266502531,
 1266354203,
 -1,
 1266568066,
 1266449442,
 -1,
 1266633600,
 1266489099,
 2827,
 -1,
 1266554635,
 2912,
 1266810879,
 1266575965,
 2828,
 -1,
 1266707037,
 2913,
 -1,
 1266485884,
 2869,
 1266961289,
 1266462658,
 -1,
 1267026823,
 1266921410,
 -1,
 -46202,
 1266952092,
 2848,
 -1,
 1267010172,
 2847,
 -46200,
 1266952092,
 2853,
 -1,
 1267141244,
 2852,
 1267354510,
 1266908162,
 -1,
 -46197,
 1267307166,
 2846,
 -46196,
 1267369882,
 2851,
 -46195,
 1267401116,
 2841,
 -1,
 1267468924,
 2856,
 1267682196,
 1267279168,
 -1,
 1267747730,
 1267606848,
 -1,
 -46191,
 1267672988,
 2850,
 -1,
 1267731068,
 2849,
 -46189,
 1267672988,
 2855,
 -1,
 1267862140,
 2854,
 1268075416,
 1267599996,
 2821,
 -46186,
 1268037816,
 2836,
 -46185,
 1268076427,
 2832,
 -1,
 1268124284,
 2822,
 1268337564,
 1268009751,
 -1,
 -46182,
 1268278595,
 2871,
 -46181,
 1268328348,
 2870,
 -1,
 1268386428,
 2872,
 1268599712,
 1268258571,
 -1,
 -46178,
 1268558140,
 2908,
 -46177,
 1268590492,
 2909,
 -1,
 1268648572,
 2864,
 1268861859,
 1268523732,
 -1,
 -46174,
 1268814494,
 2911,
 -1,
 1268845180,
 2863,
 1269058469,
 1268824248,
 2825,
 -1,
 1269020856,
 2826,
 1269189544,
 1269009612,
 -1,
 -46169,
 1269114780,
 2859,
 -1,
 1269172860,
 2858,
 1269386155,
 1269131869,
 -1,
 -46166,
 1269303770,
 2867,
 -1,
 1269369468,
 2866,
 1269582766,
 1269325936,
 -1,
 -46163,
 1269507996,
 2838,
 -1,
 1269566076,
 2837,
 1269779377,
 1269520380,
 -1,
 -46160,
 1269704604,
 2845,
 -1,
 1269762684,
 2844,
 1269975987,
 1269714827,
 2823,
 -1,
 1269911435,
 2824,
 1270107062,
 1269907269,
 -1,
 -46155,
 1270032284,
 2840,
 -1,
 1270090364,
 2839,
 1270303673,
 1270029365,
 -1,
 -46152,
 1270228892,
 2843,
 -1,
 1270286972,
 2842,
 1270500284,
 1270223729,
 -1,
 -46149,
 1270425500,
 2861,
 -1,
 1270483580,
 2860,
 -46147,
 1270433381,
 2929,
 -46146,
 1270625634,
 2835,
 -46145,
 1270691238,
 2862,
 -46144,
 1270753180,
 2873,
 -1,
 1270820561,
 2831,
 1271024589,
 1266372851,
 -1,
 1271090118,
 1270942332,
 -1,
 -46140,
 1271052472,
 2892,
 -46139,
 1271091083,
 2888,
 -1,
 1271138940,
 2878,
 1271352264,
 1271052472,
 2881,
 -1,
 1271314616,
 2882,
 1271483338,
 1271287691,
 2879,
 -1,
 1271418763,
 2880,
 -46133,
 1271414363,
 2883,
 -46132,
 1271543138,
 2891,
 -1,
 1271606993,
 2887,
 1271811035,
 1270981731,
 -1,
 1271876561,
 1271771074,
 -1,
 -46128,
 1271809644,
 2920,
 -1,
 1271874479,
 2921,
 1272073172,
 1271810839,
 -1,
 -46125,
 1272008543,
 2924,
 -1,
 1272055877,
 2925,
 1272269783,
 1272002431,
 -1,
 -46122,
 1272210356,
 2922,
 -1,
 1272284348,
 2923,
 -46120,
 1272192950,
 2918,
 -46119,
 1272384040,
 2919,
 -46118,
 1272489494,
 2927,
 -1,
 1272528619,
 2926,
 1272728548,
 1271758028,
 -1,
 1272794079,
 1272652392,
 -1,
 -46114,
 1272721967,
 2819,
 -1,
 1272787490,
 2893,
 1272990690,
 1272711804,
 -1,
 -46111,
 1272912734,
 2877,
 -1,
 1273009970,
 2818,
 -46109,
 1272923115,
 2876,
 -1,
 1273130150,
 2817,
 1273318375,
 1272646268,
 -1,
 -46106,
 1273254250,
 2903,
 -1,
 1273311583,
 2902,
 -1,
 1273255117,
 2928,
 -1,
 1266321751,
 8886,
 1273646060,
 1266241766,
 -1,
 -46101,
 1273583767,
 64831,
 -1,
 1273639619,
 64830,
 -1,
 1273571491,
 9766,
 1273908315,
 1266174591,
 -1,
 1273973809,
 1273852543,
 -1,
 1274039336,
 1273920716,
 -1,
 1274104822,
 1273963840,
 -1,
 1274170356,
 1274022524,
 66477,
 1274281983,
 1274097285,
 66508,
 -1,
 1274175186,
 66509,
 -46091,
 1274132664,
 66479,
 -1,
 1274302347,
 66478,
 1274498042,
 1274022524,
 66464,
 1274609663,
 1274418903,
 66504,
 -46087,
 1274488732,
 66506,
 -1,
 1274568402,
 66505,
 1274760190,
 1274458050,
 -1,
 -46084,
 1274722488,
 66476,
 -46083,
 1274750876,
 66480,
 -1,
 1274808956,
 66475,
 1275022338,
 1274694423,
 -1,
 -46080,
 1274963267,
 66498,
 -46079,
 1275013020,
 66497,
 -1,
 1275071100,
 66495,
 1275284486,
 1274966788,
 -1,
 -46076,
 1275246776,
 66488,
 -46075,
 1275285387,
 66487,
 -1,
 1275333244,
 66486,
 1275546634,
 1275204465,
 -1,
 1275612169,
 1275464316,
 66482,
 -1,
 1275527580,
 66510,
 -1,
 1275565787,
 66511,
 1275808781,
 1275468219,
 -1,
 -46068,
 1275765316,
 66507,
 -1,
 1275791996,
 66471,
 1276005392,
 1275725851,
 -1,
 -46065,
 1275940747,
 66491,
 -1,
 1275988604,
 66490,
 1276202003,
 1275926283,
 -1,
 -46062,
 1276164280,
 66493,
 -1,
 1276185212,
 66492,
 1276398614,
 1276148738,
 -1,
 -46059,
 1276360888,
 66485,
 -1,
 1276381820,
 66484,
 1276595225,
 1276338288,
 -1,
 -46056,
 1276557496,
 66468,
 -1,
 1276578428,
 66467,
 1276791836,
 1276532732,
 -1,
 -46053,
 1276727179,
 66474,
 -1,
 1276775036,
 66473,
 1276988447,
 1276723013,
 -1,
 -46050,
 1276950712,
 66470,
 -1,
 1276971644,
 66469,
 -46048,
 1276910717,
 66496,
 -46047,
 1277137566,
 66489,
 -46046,
 1277212856,
 66466,
 -46045,
 1277249366,
 66481,
 -46044,
 1277299162,
 66494,
 -46043,
 1277382539,
 66465,
 -46042,
 1277437852,
 66499,
 -46041,
 1277530590,
 66483,
 -1,
 1277566854,
 66472,
 1277774896,
 1273976817,
 -1,
 1277840430,
 1277734850,
 -1,
 1277905965,
 1277759800,
 -1,
 -46036,
 1277834594,
 66514,
 -1,
 1277892648,
 66516,
 -1,
 1277848754,
 66515,
 -46033,
 1277757992,
 66513,
 -1,
 1278090065,
 66517,
 -1,
 1277698886,
 66512,
 1278410751,
 1273905976,
 -1,
 1278430293,
 1278312140,
 -1,
 1278495805,
 1278357201,
 66308,
 1278561334,
 1278429975,
 66324,
 -1,
 1278491001,
 66318,
 1278692408,
 1278482187,
 66323,
 -1,
 1278626583,
 66331,
 -46023,
 1278639106,
 66317,
 -46022,
 1278767876,
 66316,
 -46021,
 1278831197,
 66315,
 -46020,
 1278902158,
 66327,
 -1,
 1278949247,
 66330,
 1279151170,
 1278435440,
 -1,
 -46017,
 1279113400,
 66322,
 -46016,
 1279141800,
 66329,
 -46015,
 1279209169,
 66306,
 -1,
 1279265404,
 66314,
 1279478852,
 1279113400,
 66326,
 -1,
 1279441080,
 66334,
 1279609927,
 1279438786,
 -1,
 -46010,
 1279535016,
 66312,
 -1,
 1279602385,
 66325,
 1279806538,
 1279560908,
 -1,
 -46007,
 1279731624,
 66328,
 -1,
 1279798993,
 66320,
 1280003148,
 1279741835,
 66313,
 -1,
 1279938443,
 66333,
 -46003,
 1279925214,
 66310,
 -46002,
 1280057949,
 66309,
 -46001,
 1280134751,
 66321,
 -46000,
 1280193890,
 66319,
 -45999,
 1280255912,
 66311,
 -45998,
 1280328607,
 66307,
 -45997,
 1280380356,
 66332,
 -45996,
 1280486829,
 66305,
 -1,
 1280510588,
 66304,
 1280770047,
 1278389565,
 -1,
 1280789593,
 1280672471,
 -1,
 -45992,
 1280713309,
 66337,
 -1,
 1280797191,
 66339,
 -45990,
 1280720860,
 66338,
 -1,
 1280903720,
 66336,
 1281117324,
 1273858237,
 -1,
 1281182846,
 1281064652,
 -1,
 1281248352,
 1281100412,
 66710,
 -45985,
 1281185929,
 66688,
 -1,
 1281231484,
 66715,
 1281444963,
 1281182487,
 -1,
 -45982,
 1281406404,
 66697,
 -1,
 1281428092,
 66696,
 1281641573,
 1281373538,
 66713,
 -1,
 1281570146,
 66717,
 1281772648,
 1281581168,
 -1,
 -45977,
 1281697692,
 66693,
 -1,
 1281793993,
 66703,
 1281969258,
 1281699537,
 66711,
 -1,
 1281896145,
 66716,
 1282100333,
 1281893696,
 -1,
 -45972,
 1282025372,
 66698,
 -1,
 1282100569,
 66694,
 -45970,
 1282052766,
 66709,
 -45969,
 1282240444,
 66692,
 -45968,
 1282297108,
 66707,
 -45967,
 1282390200,
 66714,
 -45966,
 1282443694,
 66690,
 -45965,
 1282517308,
 66695,
 -45964,
 1282575507,
 66702,
 -45963,
 1282614537,
 66706,
 -45962,
 1282712876,
 66705,
 -45961,
 1282736830,
 66704,
 -45960,
 1282831660,
 66691,
 -45959,
 1282887563,
 66712,
 -45958,
 1282942876,
 66708,
 -45957,
 1282998684,
 66700,
 -45956,
 1283101150,
 66701,
 -45955,
 1283162742,
 66699,
 -1,
 1283239383,
 66689,
 1283457023,
 1281139811,
 -1,
 1283476610,
 1283370946,
 -1,
 -45951,
 1283409516,
 66722,
 -1,
 1283474351,
 66723,
 1283673221,
 1283410711,
 -1,
 -45948,
 1283608415,
 66726,
 -1,
 1283655749,
 66727,
 1283869832,
 1283602303,
 -1,
 -45945,
 1283810228,
 66724,
 -1,
 1283884220,
 66725,
 -45943,
 1283792822,
 66720,
 -45942,
 1283983912,
 66721,
 -45941,
 1284089366,
 66729,
 -1,
 1284128491,
 66728,
 1284328628,
 1281048389,
 -1,
 1284394163,
 1284247255,
 -1,
 1284459696,
 1284341452,
 -1,
 1284525203,
 1284421816,
 -1,
 -45935,
 1284445963,
 5778,
 -45934,
 1284527289,
 5783,
 -1,
 1284574774,
 5766,
 1284787351,
 1284467925,
 -1,
 -45931,
 1284724017,
 5785,
 -45930,
 1284778302,
 5779,
 -1,
 1284848214,
 5781,
 1285049498,
 1284721431,
 -1,
 -45927,
 1285010226,
 5774,
 -1,
 1285049947,
 5764,
 1285246109,
 1284978018,
 -1,
 -45924,
 1285166859,
 5782,
 -1,
 1285248850,
 5777,
 1285442720,
 1285192706,
 -1,
 -45921,
 1285367030,
 5765,
 -1,
 1285427385,
 5773,
 1285639331,
 1285377931,
 -1,
 -45918,
 1285597785,
 5780,
 -1,
 1285633674,
 5784,
 1285835942,
 1285561397,
 -1,
 -45915,
 1285772989,
 5769,
 -1,
 1285817521,
 5770,
 -45913,
 1285790083,
 5768,
 -45912,
 1285959792,
 5775,
 -45911,
 1286016592,
 5786,
 -45910,
 1286113227,
 5771,
 -45909,
 1286176069,
 5762,
 -45908,
 1286233948,
 5772,
 -45907,
 1286285956,
 5763,
 -45906,
 1286354669,
 5767,
 -45905,
 1286409570,
 5761,
 -1,
 1286497626,
 5776,
 -45903,
 1284381307,
 5760,
 -45902,
 1286645525,
 5788,
 -1,
 1286678936,
 5787,
 -1,
 1284335371,
 731,
 1286950087,
 1284279500,
 -1,
 1287015621,
 1286892722,
 -1,
 1287081152,
 1286954183,
 -1,
 1287146684,
 1287038710,
 -1,
 -45895,
 1287090696,
 10044,
 -45894,
 1287173165,
 10011,
 -45893,
 1287196264,
 10027,
 -1,
 1287270153,
 10034,
 1287474367,
 1287087350,
 -1,
 -45890,
 1287409281,
 10180,
 -1,
 1287499908,
 10179,
 -1,
 1287409848,
 9251,
 1287782399,
 1287001484,
 -1,
 1287802052,
 1287678004,
 -1,
 -45885,
 1287736884,
 9104,
 -1,
 1287785890,
 9103,
 -1,
 1287744364,
 10174,
 -45882,
 1286953237,
 8997,
 -1,
 1288003585,
 9741,
 1288195286,
 1286884562,
 -1,
 1288260812,
 1288115057,
 -1,
 -45878,
 1288188148,
 9286,
 -45877,
 1288260563,
 9285,
 -1,
 1288307057,
 9284,
 1288522959,
 1288185152,
 -1,
 -45874,
 1288482018,
 9290,
 -1,
 1288537141,
 9288,
 1288719570,
 1288444981,
 -1,
 -45871,
 1288675250,
 9289,
 -1,
 1288736580,
 9281,
 -45869,
 1288658468,
 9283,
 -45868,
 1288874839,
 9280,
 -45867,
 1288912268,
 9282,
 -1,
 1288993094,
 9287,
 1289178332,
 1288157368,
 -1,
 1289243867,
 1289118257,
 -1,
 -45863,
 1289160296,
 10015,
 -45862,
 1289247382,
 10009,
 -1,
 1289293416,
 10029,
 -1,
 1289196742,
 8485,
 1289571553,
 1289098097,
 -1,
 1289637088,
 1289517073,
 -1,
 -45857,
 1289589967,
 10662,
 -1,
 1289662672,
 10663,
 -1,
 1289573877,
 65532,
 -45854,
 1289509259,
 8254,
 -45853,
 1289839588,
 8228,
 -1,
 1289887330,
 8486,
 1290096145,
 1266126028,
 -1,
 1290161548,
 1290013308,
 -1,
 1290227081,
 1290082059,
 -1,
 1290292602,
 1290165023,
 -1,
 1290358043,
 1290226902,
 -1,
 1290423542,
 1290291991,
 -1,
 1290489069,
 1290385592,
 -1,
 -45844,
 1290451130,
 12860,
 -1,
 1290501122,
 12848,
 1290685680,
 1290448834,
 -1,
 -45841,
 1290627106,
 12859,
 -1,
 1290705588,
 12849,
 1290882291,
 1290612433,
 -1,
 -45838,
 1290822731,
 12838,
 -1,
 1290863804,
 12866,
 -45836,
 1290840432,
 12853,
 -45835,
 1291023542,
 12851,
 -1,
 1291079519,
 12837,
 1291275517,
 1290352511,
 -1,
 1291341051,
 1291210635,
 -1,
 -45831,
 1291264605,
 12836,
 -45830,
 1291336674,
 12843,
 -1,
 1291398610,
 12854,
 -45828,
 1291281332,
 12835,
 -1,
 1291562020,
 12864,
 1291734275,
 1291205602,
 -1,
 1291799809,
 1291668247,
 -1,
 -45824,
 1291759554,
 12865,
 -1,
 1291816975,
 12862,
 -45822,
 1291731420,
 12857,
 -1,
 1291945492,
 12867,
 1292127495,
 1291694018,
 -1,
 -45819,
 1292060268,
 12833,
 -45818,
 1292125103,
 12834,
 -1,
 1292201138,
 12841,
 1292389643,
 1292054225,
 -1,
 -45815,
 1292324780,
 12861,
 -45814,
 1292408333,
 12839,
 -1,
 1292437357,
 12847,
 1292651790,
 1292308792,
 -1,
 -45811,
 1292613910,
 12845,
 -1,
 1292634134,
 12844,
 1292848401,
 1292598274,
 -1,
 -45808,
 1292776988,
 12840,
 -1,
 1292862306,
 12852,
 1293045012,
 1292792580,
 -1,
 -45805,
 1293007203,
 12842,
 -1,
 1293054174,
 12846,
 1293241623,
 1292966965,
 -1,
 -45802,
 1293178673,
 12855,
 -1,
 1293259704,
 12858,
 -45800,
 1293158952,
 12832,
 -45799,
 1293385938,
 12856,
 -45798,
 1293451239,
 12850,
 -1,
 1293506222,
 12863,
 1293700414,
 1290294800,
 -1,
 1293765923,
 1293622325,
 -1,
 1293831457,
 1293695591,
 12808,
 1293942783,
 1293769927,
 -1,
 -45792,
 1293859000,
 12828,
 -1,
 1293879932,
 12822,
 1294139391,
 1293759389,
 12809,
 -1,
 1294044102,
 12823,
 1294224680,
 1293725634,
 -1,
 1294290214,
 1294143008,
 12802,
 -1,
 1294240710,
 12816,
 1294467071,
 1294207038,
 12811,
 -1,
 1294371782,
 12825,
 1294552365,
 1294175436,
 -1,
 1294617899,
 1294482103,
 12805,
 -1,
 1294568390,
 12819,
 1294794751,
 1294548095,
 12812,
 -1,
 1294699462,
 12826,
 1294880050,
 1294491760,
 -1,
 1294945584,
 1294796530,
 12800,
 -1,
 1294896070,
 12814,
 1295122431,
 1294899107,
 12810,
 -1,
 1295027142,
 12824,
 1295207732,
 1294827829,
 12806,
 -1,
 1295158214,
 12820,
 1295338806,
 1295126262,
 12803,
 -1,
 1295289286,
 12817,
 1295469880,
 1295298344,
 12801,
 -1,
 1295420358,
 12815,
 1295600954,
 1295392783,
 12804,
 -1,
 1295551430,
 12818,
 1295732028,
 1295529522,
 12807,
 -1,
 1295682502,
 12821,
 1295908863,
 1295648068,
 12813,
 -1,
 1295813574,
 12827,
 1295994201,
 1293649872,
 -1,
 -45760,
 1295920247,
 9397,
 -45759,
 1295983316,
 9396,
 -45758,
 1296046523,
 9395,
 -45757,
 1296109880,
 9394,
 -45756,
 1296173083,
 9393,
 -45755,
 1296283832,
 9392,
 -45754,
 1296347074,
 9391,
 -45753,
 1296386839,
 9390,
 -45752,
 1296439051,
 9389,
 -45751,
 1296537121,
 9388,
 -45750,
 1296600268,
 9387,
 -45749,
 1296643426,
 9386,
 -45748,
 1296727042,
 9385,
 -45747,
 1296790276,
 9384,
 -45746,
 1296853597,
 9383,
 -45745,
 1296916592,
 9382,
 -45744,
 1296979964,
 9381,
 -45743,
 1297043339,
 9380,
 -45742,
 1297103225,
 9379,
 -45741,
 1297170245,
 9378,
 -45740,
 1297233791,
 9377,
 -45739,
 1297297105,
 9376,
 -45738,
 1297360192,
 9375,
 -45737,
 1297423413,
 9374,
 -45736,
 1297486705,
 9373,
 -1,
 1297549948,
 9372,
 1297763690,
 1295931377,
 -1,
 1297829216,
 1297723330,
 -1,
 1297894750,
 1297761830,
 -1,
 -45731,
 1297845345,
 9351,
 -1,
 1297907355,
 9343,
 -45729,
 1297834808,
 9344,
 -1,
 1298033842,
 9341,
 1298222435,
 1297763095,
 -1,
 -45726,
 1298182979,
 9347,
 -1,
 1298231557,
 9348,
 1298419046,
 1298151295,
 -1,
 -45723,
 1298354040,
 9345,
 -1,
 1298426488,
 9346,
 1298615657,
 1298345681,
 -1,
 -45720,
 1298548671,
 9342,
 -1,
 1298638574,
 9349,
 -1,
 1298570716,
 9350,
 1298877815,
 1297720419,
 -1,
 1298943342,
 1298837442,
 -1,
 -45715,
 1298876012,
 9333,
 -1,
 1298940847,
 9334,
 1299139953,
 1298877207,
 -1,
 -45712,
 1299074911,
 9337,
 -1,
 1299122245,
 9338,
 1299336564,
 1299068799,
 -1,
 -45709,
 1299276724,
 9335,
 -1,
 1299350716,
 9336,
 -45707,
 1299253800,
 9332,
 -45706,
 1299490326,
 9340,
 -1,
 1299529451,
 9339,
 1299775487,
 1298815650,
 -1,
 -45703,
 1299682767,
 12829,
 -1,
 1299713374,
 12830,
 1299926403,
 1290209916,
 -1,
 1299991936,
 1299871345,
 -1,
 1300057471,
 1299913276,
 -1,
 -45698,
 1300004072,
 10995,
 -1,
 1300056602,
 10994,
 -1,
 1300007274,
 8741,
 1300365311,
 1299950480,
 -1,
 -45694,
 1300267533,
 11791,
 -1,
 1300316224,
 8233,
 1300561919,
 1299886018,
 -1,
 1300581767,
 1300471446,
 -1,
 -45690,
 1300523371,
 9853,
 -1,
 1300584740,
 8706,
 -45688,
 1300539416,
 12880,
 -1,
 1300714281,
 12349,
 1300955135,
 1290179877,
 -1,
 -45685,
 1300847063,
 9106,
 -1,
 1300907654,
 9105,
 1301106134,
 1290082059,
 -1,
 1301171661,
 1301032657,
 -1,
 1301237180,
 1301105431,
 -1,
 1301302715,
 1301166517,
 -1,
 1301368223,
 1301244509,
 -1,
 1301433758,
 1301295343,
 -1,
 1301499285,
 1301383276,
 -1,
 -45676,
 1301415585,
 65047,
 -1,
 1301480107,
 65091,
 1301695896,
 1301421109,
 -1,
 -45673,
 1301631480,
 65079,
 -1,
 1301694362,
 65089,
 -45671,
 1301626469,
 65081,
 -45670,
 1301833355,
 65095,
 -45669,
 1301901353,
 65077,
 -45668,
 1301967701,
 65085,
 -45667,
 1302021627,
 65083,
 -1,
 1302072781,
 65087,
 -1,
 1301390379,
 65075,
 1302351276,
 1301320177,
 -1,
 1302416803,
 1302300780,
 -1,
 -45662,
 1302361537,
 65048,
 -1,
 1302397611,
 65092,
 1302613414,
 1302338613,
 -1,
 -45659,
 1302548984,
 65080,
 -1,
 1302611866,
 65090,
 -45657,
 1302543973,
 65082,
 -45656,
 1302750859,
 65096,
 -45655,
 1302818857,
 65078,
 -45654,
 1302885205,
 65086,
 -45653,
 1302939131,
 65084,
 -1,
 1302990285,
 65088,
 1303203248,
 1302277841,
 -1,
 -45650,
 1303125647,
 65045,
 -45649,
 1303190507,
 65074,
 -1,
 1303274874,
 65073,
 1303465395,
 1303137477,
 -1,
 -45646,
 1303396855,
 65042,
 -1,
 1303486696,
 65041,
 1303662006,
 1303388014,
 -1,
 -45643,
 1303591005,
 65040,
 -1,
 1303656450,
 65043,
 -45641,
 1303600240,
 65076,
 -45640,
 1303773190,
 65072,
 -45639,
 1303859815,
 65044,
 -45638,
 1303911801,
 65046,
 -1,
 1303994184,
 65049,
 -1,
 1301236972,
 8478,
 1304251852,
 1301191292,
 8826,
 1304363007,
 1304190151,
 -1,
 1304382919,
 1304276210,
 -1,
 1304448450,
 1304339695,
 -1,
 -45631,
 1304382790,
 10929,
 -1,
 1304436965,
 10927,
 1304645061,
 1304398068,
 -1,
 -45628,
 1304583450,
 10933,
 -1,
 1304651055,
 10937,
 -45626,
 1304568037,
 10931,
 -1,
 1304782127,
 10935,
 1304972746,
 1304315315,
 -1,
 -45623,
 1304911271,
 8830,
 -1,
 1304956611,
 8828,
 -45621,
 1304914611,
 8880,
 -1,
 1305092524,
 8936,
 -1,
 1304213901,
 9111,
 1305365971,
 1301099874,
 -1,
 1305431506,
 1305316556,
 -1,
 1305497041,
 1305358652,
 8759,
 -1,
 1305415363,
 8733,
 -1,
 1305456325,
 8522,
 -1,
 1305368138,
 8965,
 1305804799,
 1305300875,
 -1,
 -45611,
 1305720890,
 9113,
 -1,
 1305752975,
 8242,
 1305955824,
 1301047901,
 -1,
 1306021356,
 1305917624,
 -1,
 1306086891,
 1305955095,
 -1,
 1306152426,
 1306019926,
 43,
 1306263551,
 1306090695,
 -1,
 1306283493,
 1306139196,
 -1,
 1306349023,
 1306230889,
 -1,
 -45602,
 1306272434,
 10790,
 -1,
 1306366856,
 10788,
 1306545634,
 1306282775,
 -1,
 -45599,
 1306494261,
 10791,
 -1,
 1306551552,
 10786,
 -45597,
 1306484897,
 10789,
 -45596,
 1306694167,
 10787,
 -1,
 1306764348,
 10792,
 1306938857,
 1306211420,
 -1,
 -45593,
 1306894285,
 10809,
 -45592,
 1306951901,
 10798,
 -1,
 1307030444,
 10797,
 -1,
 1306867565,
 10866,
 -1,
 1306106897,
 177,
 -1,
 1306036586,
 9799,
 1307443199,
 1305938556,
 -1,
 1307463151,
 1307345585,
 8462,
 -1,
 1307392945,
 8463,
 -1,
 1307420459,
 8984,
 1307659776,
 1305882321,
 -1,
 1307725307,
 1307580171,
 -1,
 1307790838,
 1307663559,
 -1,
 -45580,
 1307705388,
 8241,
 -45579,
 1307777434,
 8524,
 -1,
 1307877155,
 8240,
 1308052984,
 1307719162,
 10178,
 -1,
 1307981100,
 10977,
 -45575,
 1308006202,
 8966,
 -45574,
 1308138757,
 9854,
 -1,
 1308164930,
 37,
 1308380670,
 1307659031,
 -1,
 -45571,
 1308327286,
 8369,
 -1,
 1308404890,
 8359,
 -45569,
 1308339880,
 9999,
 -1,
 1308493201,
 9774,
 1308708359,
 1307587938,
 -1,
 1308773893,
 1308642071,
 -1,
 1308839428,
 1308696763,
 12306,
 -1,
 1308796937,
 12320,
 -1,
 1308768985,
 8982,
 -45562,
 1308708896,
 163,
 -1,
 1308986793,
 8236,
 1309167117,
 1308643211,
 -1,
 1309232650,
 1309095118,
 8916,
 -1,
 1309192265,
 10970,
 -45557,
 1309150568,
 9811,
 -45556,
 1309315757,
 10031,
 -1,
 1309364828,
 182,
 1309560336,
 1309094356,
 -1,
 -45553,
 1309521049,
 5941,
 -1,
 1309550593,
 5942,
 -1,
 1309488062,
 8200,
 1309822743,
 1290042370,
 -1,
 1309888162,
 1309748945,
 -1,
 1309953660,
 1309820986,
 -1,
 1310019195,
 1309908092,
 -1,
 1310084692,
 1309966028,
 -1,
 1310150193,
 1310002852,
 -1,
 1310215707,
 1310109634,
 -1,
 -45543,
 1310156099,
 6539,
 -45542,
 1310205852,
 6546,
 -1,
 1310263932,
 6545,
 1310477854,
 1310136763,
 -1,
 -45539,
 1310401114,
 6569,
 -1,
 1310460540,
 6534,
 1310674465,
 1310428364,
 -1,
 -45536,
 1310599068,
 6552,
 -1,
 1310657148,
 6551,
 1310871076,
 1310620674,
 -1,
 -45533,
 1310785948,
 6535,
 -1,
 1310853756,
 6547,
 1311067687,
 1310810224,
 -1,
 -45530,
 1310990938,
 6568,
 -1,
 1311050364,
 6533,
 -45528,
 1311019678,
 6541,
 -45527,
 1311187546,
 6558,
 -45526,
 1311270211,
 6540,
 -45525,
 1311315713,
 6529,
 -45524,
 1311389094,
 6553,
 -45523,
 1311443418,
 6559,
 -45522,
 1311516572,
 6563,
 -45521,
 1311609310,
 6557,
 -45520,
 1311654828,
 6564,
 -1,
 1311747543,
 6565,
 1311919692,
 1310070331,
 -1,
 1311985206,
 1311879106,
 -1,
 -45516,
 1311925571,
 6536,
 -45515,
 1311975324,
 6543,
 -1,
 1312033404,
 6542,
 1312247353,
 1311906235,
 -1,
 -45512,
 1312170586,
 6567,
 -1,
 1312230012,
 6531,
 1312443964,
 1312197836,
 -1,
 -45509,
 1312368540,
 6549,
 -1,
 1312426620,
 6548,
 1312640575,
 1312390146,
 -1,
 -45506,
 1312555420,
 6532,
 -1,
 1312623228,
 6544,
 1312837186,
 1312579696,
 -1,
 -45503,
 1312760410,
 6566,
 -1,
 1312819836,
 6530,
 -45501,
 1312789150,
 6538,
 -45500,
 1312957018,
 6555,
 -45499,
 1313039683,
 6537,
 -45498,
 1313085185,
 6528,
 -45497,
 1313158566,
 6550,
 -45496,
 1313212890,
 6556,
 -45495,
 1313286044,
 6560,
 -45494,
 1313378782,
 6554,
 -45493,
 1313424300,
 6561,
 -1,
 1313517015,
 6562,
 1313734655,
 1311866660,
 -1,
 1313754703,
 1313635330,
 6595,
 -1,
 1313685317,
 6594,
 -45488,
 1313671195,
 6593,
 -45487,
 1313829636,
 6596,
 -45486,
 1313890416,
 6597,
 -45485,
 1313940800,
 6598,
 -1,
 1314001777,
 6599,
 1314213480,
 1310019827,
 -1,
 1314279002,
 1314175160,
 6579,
 1314344536,
 1314205393,
 6585,
 -1,
 1314267860,
 6591,
 -45479,
 1314267860,
 6588,
 -1,
 1314437304,
 6580,
 1314606686,
 1314207074,
 6583,
 1314672221,
 1314523772,
 6584,
 -1,
 1314595540,
 6590,
 -1,
 1314595540,
 6589,
 1314868835,
 1314523772,
 -1,
 1314934369,
 1314785916,
 6577,
 -1,
 1314857684,
 6587,
 -45470,
 1314857684,
 6586,
 -1,
 1314991825,
 6582,
 1315196518,
 1314803595,
 -1,
 -45467,
 1315119828,
 6592,
 -1,
 1315196811,
 6578,
 -45465,
 1315135563,
 6576,
 -1,
 1315319505,
 6581,
 1315524214,
 1314169955,
 -1,
 1315589740,
 1315483586,
 -1,
 -45461,
 1315522156,
 6610,
 -1,
 1315586991,
 6611,
 1315786351,
 1315523351,
 -1,
 -45458,
 1315721055,
 6614,
 -1,
 1315768389,
 6615,
 1315982962,
 1315714943,
 -1,
 -45455,
 1315922868,
 6612,
 -1,
 1315996860,
 6613,
 -45453,
 1315905462,
 6608,
 -45452,
 1316096552,
 6609,
 -45451,
 1316202006,
 6617,
 -1,
 1316241131,
 6616,
 1316441721,
 1315471253,
 -1,
 -45448,
 1316372916,
 6601,
 -1,
 1316436302,
 6600,
 1316683775,
 1316392562,
 6622,
 -1,
 1316554779,
 6623,
 -1,
 1309969141,
 8362,
 1316834960,
 1309894765,
 -1,
 1316900495,
 1316755339,
 -1,
 1316966030,
 1316837361,
 -1,
 1317031556,
 1316925378,
 -1,
 1317097091,
 1316963878,
 -1,
 -45438,
 1317047393,
 9460,
 -1,
 1317109403,
 9452,
 -1,
 1317036856,
 9453,
 1317359239,
 1316965143,
 -1,
 -45434,
 1317319491,
 9456,
 -1,
 1317368069,
 9457,
 1317555850,
 1317287807,
 -1,
 -45431,
 1317490552,
 9454,
 -1,
 1317563000,
 9455,
 1317752461,
 1317482193,
 -1,
 -45428,
 1317685183,
 9451,
 -1,
 1317775086,
 9458,
 -1,
 1317707228,
 9459,
 -1,
 1316921321,
 9471,
 -1,
 1316821206,
 8879,
 1318145696,
 1316791127,
 -1,
 1318211222,
 1318100370,
 -1,
 1318276757,
 1318143958,
 -1,
 -45420,
 1318215079,
 8820,
 -1,
 1318260419,
 8816,
 -1,
 1318228428,
 8824,
 1318538907,
 1318138154,
 -1,
 1318604442,
 1318471638,
 -1,
 -45415,
 1318542759,
 8821,
 -1,
 1318588099,
 8817,
 -1,
 1318537264,
 8825,
 1318911999,
 1318455932,
 -1,
 1318932127,
 1318811430,
 -1,
 -45410,
 1318877242,
 8841,
 -1,
 1318915998,
 8840,
 -1,
 1318858678,
 8775,
 -45407,
 1318076497,
 9112,
 -1,
 1319113940,
 9798,
 1319325413,
 1309816162,
 -1,
 1319390914,
 1319245579,
 8893,
 1319456448,
 1319319641,
 -1,
 1319521971,
 1319390200,
 -1,
 1319587504,
 1319438972,
 -1,
 1319653039,
 1319544073,
 8598,
 1319763967,
 1319591111,
 -1,
 1319784108,
 1319671646,
 -1,
 -45397,
 1319740467,
 8632,
 -1,
 1319799712,
 8689,
 -45395,
 1319741672,
 10531,
 -45394,
 1319917508,
 10546,
 -1,
 1320004248,
 10535,
 -1,
 1319587399,
 10529,
 -45391,
 1319535196,
 11009,
 -45390,
 1320194425,
 8662,
 -1,
 1320242056,
 11017,
 1320484863,
 1319466192,
 -1,
 1320505021,
 1320356476,
 -1,
 1320570556,
 1320461577,
 8599,
 1320681471,
 1320508615,
 -1,
 1320701626,
 1320559306,
 -1,
 -45383,
 1320660881,
 10542,
 -1,
 1320691395,
 10545,
 -45381,
 1320659176,
 10532,
 -1,
 1320837211,
 10536,
 -1,
 1320517749,
 10530,
 -45378,
 1320452700,
 11008,
 -45377,
 1321046393,
 8663,
 -1,
 1321094024,
 11016,
 1321336831,
 1319414480,
 8882,
 -1,
 1321231452,
 8884,
 1321422560,
 1319350210,
 -1,
 1321488093,
 1321360583,
 -1,
 1321553611,
 1321405052,
 -1,
 1321619144,
 1321498406,
 -1,
 -45369,
 1321547338,
 8837,
 -1,
 1321642592,
 8836,
 -45367,
 1321579092,
 8772,
 -45366,
 1321773940,
 8713,
 -1,
 1321815117,
 8777,
 1322012368,
 1321487127,
 -1,
 1322077903,
 1321946663,
 -1,
 -45362,
 1322008967,
 8931,
 -1,
 1322101149,
 8930,
 -1,
 1322029310,
 172,
 1322340051,
 1321971650,
 -1,
 -45358,
 1322277033,
 8877,
 -1,
 1322333741,
 8769,
 1322536661,
 1322275159,
 8938,
 -1,
 1322476636,
 8940,
 1322667736,
 1322469334,
 -1,
 -45353,
 1322605991,
 8813,
 -1,
 1322651331,
 8800,
 -45351,
 1322587112,
 8742,
 -45350,
 1322797104,
 8814,
 -45349,
 1322867417,
 8802,
 -45348,
 1322947020,
 8815,
 -1,
 1323011208,
 9083,
 1323237375,
 1321403916,
 -1,
 -45345,
 1323153221,
 10161,
 -1,
 1323172948,
 10159,
 1323388643,
 1321368578,
 -1,
 -45342,
 1323328150,
 10973,
 -1,
 1323389797,
 8209,
 -45340,
 1323341750,
 8303,
 -1,
 1323511670,
 160,
 1323716348,
 1319268932,
 -1,
 1323781868,
 1323637813,
 -1,
 1323847403,
 1323696291,
 -1,
 -45335,
 1323781937,
 10754,
 -45334,
 1323853644,
 10753,
 -1,
 1323934737,
 10752,
 -1,
 1323806388,
 8720,
 1324175088,
 1323727022,
 8899,
 1324285951,
 1324092363,
 -1,
 -45329,
 1324181964,
 10756,
 -1,
 1324254086,
 10755,
 1324437237,
 1324108567,
 -1,
 1324502772,
 1324371495,
 -1,
 -45325,
 1324419378,
 10758,
 -1,
 1324518242,
 10757,
 -1,
 1324432624,
 8721,
 1324764920,
 1324368514,
 -1,
 -45321,
 1324712464,
 8897,
 -1,
 1324775907,
 8896,
 -45319,
 1324694662,
 11007,
 -45318,
 1324896049,
 10761,
 -45317,
 1324967860,
 8719,
 -1,
 1325039655,
 8898,
 1325223697,
 1323676515,
 -1,
 1325289232,
 1325173845,
 -1,
 1325354756,
 1325248450,
 -1,
 1325420290,
 1325286950,
 -1,
 -45311,
 1325334781,
 9371,
 -1,
 1325407595,
 9363,
 -45309,
 1325368032,
 9364,
 -1,
 1325571183,
 9361,
 1325747977,
 1325288215,
 -1,
 1325813512,
 1325682571,
 -1,
 -45305,
 1325770825,
 9367,
 -1,
 1325793703,
 35,
 -1,
 1325764843,
 9368,
 1326075660,
 1325676415,
 -1,
 -45301,
 1325993007,
 9365,
 -1,
 1326095360,
 9366,
 1326272271,
 1326001873,
 -1,
 -45298,
 1326216518,
 9362,
 -1,
 1326275086,
 9369,
 -1,
 1326193719,
 9370,
 -1,
 1325232189,
 8470,
 1326645247,
 1325140604,
 -1,
 -45293,
 1326552176,
 8302,
 -45292,
 1326588679,
 8239,
 -45291,
 1326681074,
 8892,
 -45290,
 1326716878,
 8358,
 -1,
 1326784164,
 8711,
 1326993403,
 1309757323,
 -1,
 1327058873,
 1326924703,
 -1,
 1327124405,
 1327001459,
 -1,
 1327189887,
 1327054626,
 -1,
 1327255422,
 1327142857,
 -1,
 1327320907,
 1327179072,
 -1,
 1327386442,
 1327267288,
 -1,
 1327451960,
 1327345602,
 -1,
 1327517489,
 1327370552,
 -1,
 1327583024,
 1327443665,
 -1,
 1327648559,
 1327533153,
 13299,
 1327759359,
 1327568268,
 -1,
 1327779622,
 1327673282,
 -1,
 -45275,
 1327711852,
 13301,
 -1,
 1327776687,
 13302,
 1327976233,
 1327713047,
 -1,
 -45272,
 1327910751,
 13305,
 -1,
 1327958085,
 13306,
 1328172844,
 1327904639,
 -1,
 -45269,
 1328112564,
 13303,
 -1,
 1328186556,
 13304,
 -45267,
 1328089640,
 13300,
 -45266,
 1328326166,
 13308,
 -1,
 1328365291,
 13307,
 -1,
 1327595163,
 13291,
 -1,
 1327510882,
 13281,
 1328697143,
 1327446393,
 -1,
 1328762678,
 1328631702,
 -1,
 1328828213,
 1328685780,
 13309,
 -1,
 1328755981,
 13310,
 -1,
 1328787691,
 13292,
 -1,
 1328702251,
 13282,
 -1,
 1328639154,
 13289,
 1329155901,
 1327385367,
 -1,
 1329221435,
 1329090399,
 13285,
 -1,
 1329158412,
 13295,
 1329397759,
 1329137733,
 13286,
 -1,
 1329289484,
 13296,
 1329483587,
 1329084287,
 -1,
 1329549120,
 1329423284,
 13283,
 -1,
 1329486092,
 13293,
 1329725439,
 1329483659,
 -1,
 -45246,
 1329603165,
 13284,
 -1,
 1329674487,
 13294,
 1329876807,
 1329409745,
 -1,
 1329942342,
 1329829389,
 13287,
 -1,
 1329901803,
 13297,
 -1,
 1329874879,
 13290,
 1330138953,
 1329833494,
 13288,
 -1,
 1330075916,
 13298,
 -1,
 1330055720,
 13280,
 -1,
 1327328809,
 13003,
 1330401135,
 1327255399,
 -1,
 1330466652,
 1330360258,
 -1,
 1330532184,
 1330385208,
 -1,
 1330597719,
 1330458321,
 -1,
 1330663254,
 1330547809,
 13164,
 1330774015,
 1330582924,
 -1,
 1330794324,
 1330687938,
 -1,
 -45229,
 1330726508,
 13166,
 -1,
 1330791343,
 13167,
 -45227,
 1330711080,
 13165,
 -1,
 1330951676,
 13168,
 -1,
 1330609819,
 13156,
 -1,
 1330525538,
 13146,
 1331253083,
 1330461049,
 -1,
 -45222,
 1331192619,
 13147,
 -1,
 1331271522,
 13157,
 -1,
 1331195058,
 13154,
 1331515233,
 1330400023,
 -1,
 1331580767,
 1331449695,
 13150,
 -1,
 1331517708,
 13160,
 1331757055,
 1331497029,
 13151,
 -1,
 1331648780,
 13161,
 1331842919,
 1331443583,
 -1,
 1331908452,
 1331782580,
 13148,
 -1,
 1331845388,
 13158,
 1332084735,
 1331842955,
 -1,
 -45210,
 1331962461,
 13149,
 -1,
 1332033783,
 13159,
 1332236139,
 1331769041,
 -1,
 1332301674,
 1332188685,
 13152,
 -1,
 1332261099,
 13162,
 -1,
 1332234175,
 13155,
 1332498285,
 1332192790,
 13153,
 -1,
 1332435212,
 13163,
 -45202,
 1332420534,
 13144,
 -1,
 1332546088,
 13145,
 1332760436,
 1330337788,
 -1,
 1332825971,
 1332721848,
 -1,
 -45198,
 1332762481,
 12997,
 -1,
 1332808313,
 12998,
 -1,
 1332775171,
 12992,
 1333088119,
 1332688294,
 -1,
 -45194,
 1333011156,
 12996,
 -1,
 1333085615,
 12994,
 1333284730,
 1333004924,
 -1,
 -45191,
 1333213228,
 12999,
 -1,
 1333288008,
 12995,
 -45189,
 1333230149,
 13000,
 -45188,
 1333399427,
 13001,
 -45187,
 1333485409,
 13002,
 -1,
 1333531981,
 12993,
 -1,
 1327188479,
 12343,
 1333809045,
 1327131334,
 -1,
 1333874566,
 1333768130,
 -1,
 1333940100,
 1333803385,
 -1,
 -45181,
 1333887656,
 12692,
 -1,
 1333940973,
 12699,
 -45179,
 1333885901,
 12691,
 -1,
 1334063559,
 12694,
 1334267787,
 1333802879,
 -1,
 1334333322,
 1334207412,
 -1,
 -45175,
 1334257446,
 12700,
 -1,
 1334321083,
 12693,
 -1,
 1334257373,
 12697,
 1334595470,
 1334211332,
 -1,
 -45171,
 1334547666,
 12695,
 -1,
 1334606612,
 12703,
 -45169,
 1334551962,
 12698,
 -45168,
 1334708950,
 12689,
 -45167,
 1334772748,
 12690,
 -45166,
 1334866096,
 12688,
 -45165,
 1334916590,
 12701,
 -45164,
 1334988511,
 12702,
 -1,
 1335063365,
 12696,
 1335250857,
 1333740447,
 -1,
 1335316392,
 1335167077,
 -1,
 1335381920,
 1335241718,
 -1,
 1335447451,
 1335339004,
 -1,
 -45158,
 1335403062,
 12281,
 -1,
 1335452619,
 12280,
 1335644062,
 1335388765,
 -1,
 -45155,
 1335596090,
 12282,
 -1,
 1335666363,
 12279,
 -45153,
 1335567026,
 12278,
 -1,
 1335792520,
 12277,
 1335971747,
 1335324952,
 -1,
 -45150,
 1335927350,
 12272,
 -1,
 1335972970,
 12274,
 1336168358,
 1335921585,
 -1,
 -45147,
 1336093476,
 12275,
 -1,
 1336156850,
 12273,
 -45145,
 1336092223,
 12283,
 -1,
 1336320700,
 12276,
 -1,
 1335257761,
 12332,
 1336561580,
 1335172149,
 -1,
 -45141,
 1336487618,
 12289,
 -1,
 1336583056,
 12294,
 -45139,
 1336504021,
 12350,
 -45138,
 1336686551,
 12288,
 -45137,
 1336750302,
 12331,
 -45136,
 1336848828,
 12295,
 -45135,
 1336876160,
 12330,
 -45134,
 1336945598,
 12293,
 -45133,
 1337039599,
 12351,
 -45132,
 1337082359,
 12290,
 -1,
 1337168205,
 12333,
 1337393151,
 1327070364,
 -1,
 1337413560,
 1337297258,
 8801,
 -1,
 1337366921,
 10725,
 -1,
 1337342288,
 10855,
 1337610233,
 1327004674,
 -1,
 1337675742,
 1337548343,
 -1,
 1337741263,
 1337595659,
 -1,
 1337806790,
 1337659956,
 8745,
 1337917439,
 1337744583,
 -1,
 1337937858,
 1337793084,
 -1,
 -45120,
 1337865124,
 10819,
 -45119,
 1337922393,
 10820,
 -1,
 1338016646,
 10816,
 1338200005,
 1337896178,
 -1,
 -45116,
 1338144942,
 10823,
 -1,
 1338202140,
 10825,
 -1,
 1338150165,
 10827,
 1338462156,
 1337748061,
 -1,
 1338527691,
 1338410796,
 -1,
 -45111,
 1338486574,
 65531,
 -45110,
 1338521253,
 65530,
 -1,
 1338574719,
 65529,
 -1,
 1338480104,
 9892,
 -45107,
 1338400338,
 8253,
 -45106,
 1338804110,
 10812,
 -1,
 1338861014,
 8890,
 1339097087,
 1337701618,
 8747,
 1339162623,
 1338989767,
 -1,
 1339183066,
 1339038268,
 -1,
 1339248597,
 1339143020,
 -1,
 -45100,
 1339172086,
 10778,
 -1,
 1339234723,
 10780,
 -45098,
 1339168538,
 10776,
 -45097,
 1339372452,
 10779,
 -45096,
 1339458300,
 10775,
 -45095,
 1339523111,
 10777,
 -1,
 1339574444,
 10766,
 1339772893,
 1339099772,
 -1,
 -45092,
 1339724196,
 10767,
 -1,
 1339788923,
 10773,
 -1,
 1339727839,
 9134,
 1340035052,
 1337591835,
 -1,
 1340100585,
 1339977034,
 -1,
 1340166118,
 1340061205,
 -1,
 -45086,
 1340109869,
 8276,
 -45085,
 1340153209,
 191,
 -45084,
 1340222032,
 8487,
 -45083,
 1340300350,
 8766,
 -1,
 1340357512,
 161,
 1340604415,
 1340097197,
 -1,
 -45080,
 1340518589,
 9689,
 -1,
 1340569286,
 9688,
 1340801023,
 1340051313,
 -1,
 -45077,
 1340680522,
 8290,
 -1,
 1340749477,
 8291,
 1340952560,
 1339963263,
 -1,
 1341018095,
 1340877306,
 8734,
 -1,
 1340950810,
 10718,
 -1,
 1340974202,
 8505,
 1341214709,
 1340873781,
 -1,
 1341280244,
 1341144034,
 -1,
 -45069,
 1341218393,
 8710,
 -1,
 1341262774,
 10721,
 -1,
 1341220667,
 10716,
 1341542392,
 1341169140,
 -1,
 -45065,
 1341503847,
 8298,
 -1,
 1341566572,
 8300,
 -1,
 1341477575,
 9088,
 1341849599,
 1337526245,
 8887,
 -1,
 1341722227,
 8787,
 1341935797,
 1326921599,
 -1,
 1342001285,
 1341896888,
 -1,
 1342066817,
 1341918212,
 -1,
 1342132349,
 1341994802,
 -1,
 1342197823,
 1342073437,
 -1,
 1342263351,
 1342117173,
 -1,
 1342328860,
 1342188450,
 -1,
 -45053,
 1342254199,
 65370,
 -45052,
 1342317268,
 65369,
 -45051,
 1342380475,
 65368,
 -45050,
 1342443832,
 65367,
 -45049,
 1342507035,
 65366,
 -45048,
 1342617784,
 65365,
 -45047,
 1342681026,
 65364,
 -45046,
 1342720791,
 65363,
 -45045,
 1342773003,
 65362,
 -45044,
 1342871073,
 65361,
 -45043,
 1342934220,
 65360,
 -45042,
 1342977378,
 65359,
 -45041,
 1343060994,
 65358,
 -45040,
 1343124228,
 65357,
 -45039,
 1343187549,
 65356,
 -45038,
 1343250544,
 65355,
 -45037,
 1343313916,
 65354,
 -45036,
 1343377291,
 65353,
 -45035,
 1343437177,
 65352,
 -45034,
 1343504197,
 65351,
 -45033,
 1343567743,
 65350,
 -45032,
 1343631057,
 65349,
 -45031,
 1343694144,
 65348,
 -45030,
 1343757365,
 65347,
 -45029,
 1343820657,
 65346,
 -1,
 1343883900,
 65345,
 1344143359,
 1342255598,
 -1,
 -45026,
 1344023671,
 65338,
 -45025,
 1344086740,
 65337,
 -45024,
 1344149947,
 65336,
 -45023,
 1344213304,
 65335,
 -45022,
 1344276507,
 65334,
 -45021,
 1344387256,
 65333,
 -45020,
 1344450498,
 65332,
 -45019,
 1344490263,
 65331,
 -45018,
 1344542475,
 65330,
 -45017,
 1344640545,
 65329,
 -45016,
 1344703692,
 65328,
 -45015,
 1344746850,
 65327,
 -45014,
 1344830466,
 65326,
 -45013,
 1344893700,
 65325,
 -45012,
 1344957021,
 65324,
 -45011,
 1345020016,
 65323,
 -45010,
 1345083388,
 65322,
 -45009,
 1345146763,
 65321,
 -45008,
 1345206649,
 65320,
 -45007,
 1345273669,
 65319,
 -45006,
 1345337215,
 65318,
 -45005,
 1345400529,
 65317,
 -45004,
 1345463616,
 65316,
 -45003,
 1345526837,
 65315,
 -45002,
 1345590129,
 65314,
 -1,
 1345653372,
 65313,
 1345867838,
 1342189265,
 -1,
 1345933373,
 1345818531,
 -1,
 -44998,
 1345866931,
 65375,
 -44997,
 1345939083,
 65339,
 -44996,
 1346007081,
 65288,
 -1,
 1346078835,
 65371,
 -1,
 1345868099,
 65308,
 -1,
 1345823787,
 65343,
 1346392143,
 1342121280,
 -1,
 1346457678,
 1346343921,
 -1,
 1346523204,
 1346416578,
 -1,
 -44989,
 1346455148,
 65298,
 -1,
 1346519983,
 65299,
 1346719815,
 1346456343,
 -1,
 -44986,
 1346654047,
 65302,
 -1,
 1346701381,
 65303,
 1346916426,
 1346647935,
 -1,
 -44983,
 1346855860,
 65300,
 -1,
 1346929852,
 65301,
 -44981,
 1346838454,
 65296,
 -44980,
 1347029544,
 65297,
 -44979,
 1347134998,
 65305,
 -1,
 1347174123,
 65304,
 -1,
 1346389545,
 65284,
 1347440726,
 1346311947,
 -1,
 1347506261,
 1347398222,
 -1,
 -44974,
 1347439795,
 65376,
 -44973,
 1347511947,
 65341,
 -44972,
 1347579945,
 65289,
 -1,
 1347651699,
 65373,
 -1,
 1347453114,
 65340,
 1347899486,
 1347361845,
 -1,
 1347965020,
 1347827042,
 -1,
 1348030555,
 1347892657,
 -1,
 -44966,
 1347972487,
 65312,
 -1,
 1348012668,
 65292,
 -1,
 1347958786,
 65306,
 -44963,
 1347895831,
 65342,
 -1,
 1348206692,
 65504,
 1348423778,
 1347849420,
 -1,
 -44960,
 1348373841,
 65505,
 -44959,
 1348411418,
 65291,
 -1,
 1348510317,
 65285,
 1348685926,
 1348340348,
 -1,
 -44956,
 1348627525,
 65290,
 -44955,
 1348690343,
 65287,
 -1,
 1348732172,
 65286,
 1348948073,
 1348619031,
 -1,
 -44952,
 1348881027,
 65295,
 -1,
 1348950378,
 65307,
 1349144684,
 1348867742,
 -1,
 -44949,
 1349090822,
 65282,
 -1,
 1349128183,
 65311,
 1349341295,
 1349090306,
 -1,
 -44946,
 1349288571,
 65283,
 -1,
 1349344522,
 65506,
 1349537906,
 1349257654,
 -1,
 -44943,
 1349467247,
 65310,
 -1,
 1349518613,
 65344,
 1349734517,
 1349463761,
 -1,
 -44940,
 1349656207,
 65281,
 -1,
 1349755558,
 65309,
 -44938,
 1349690474,
 65509,
 -44937,
 1349870479,
 65510,
 -44936,
 1349921063,
 65372,
 -44935,
 1350010656,
 65374,
 -44934,
 1350041807,
 65507,
 -44933,
 1350137789,
 65293,
 -44932,
 1350189559,
 65294,
 -1,
 1350279882,
 65508,
 1350500351,
 1342069959,
 -1,
 -44929,
 1350408574,
 46,
 -44928,
 1350467731,
 10199,
 -1,
 1350533878,
 9608,
 1350717572,
 1342012418,
 -1,
 -44925,
 1350649213,
 9905,
 -1,
 1350700010,
 8289,
 -1,
 1350657367,
 9179,
 1350979734,
 1341928802,
 -1,
 1351045264,
 1350939488,
 -1,
 1351110798,
 1350982855,
 -1,
 1351176331,
 1351067153,
 -1,
 -44918,
 1351094499,
 8280,
 -1,
 1351193600,
 8283,
 -44916,
 1351119368,
 10018,
 -44915,
 1351333534,
 10021,
 -1,
 1351380497,
 10019,
 -44913,
 1351071778,
 8732,
 -1,
 1351497896,
 8197,
 1351745535,
 1350965003,
 -1,
 1351766164,
 1351639152,
 -1,
 -44909,
 1351693856,
 10972,
 -1,
 1351766500,
 11792,
 -44907,
 1351708099,
 8873,
 -1,
 1351901069,
 8704,
 1352093854,
 1350913931,
 -1,
 1352159386,
 1352027485,
 -1,
 -44903,
 1352087511,
 8199,
 -1,
 1352155275,
 8210,
 -44901,
 1352103331,
 8281,
 -44900,
 1352310820,
 9673,
 -44899,
 1352345266,
 9789,
 -1,
 1352404999,
 10765,
 1352618150,
 1352013579,
 -1,
 1352683682,
 1352545634,
 -1,
 -44895,
 1352610320,
 8994,
 -1,
 1352681012,
 10156,
 1352880293,
 1352597771,
 -1,
 -44892,
 1352833469,
 8260,
 -1,
 1352903789,
 8543,
 -1,
 1352841095,
 8355,
 1353142444,
 1352559197,
 -1,
 1353207979,
 1353069922,
 -1,
 1353273514,
 1353128351,
 9880,
 -1,
 1353223203,
 8277,
 -1,
 1353194795,
 10086,
 -1,
 1353162308,
 9884,
 1353535666,
 1353058940,
 -1,
 1353601200,
 1353489034,
 -1,
 -44881,
 1353518771,
 10540,
 -1,
 1353604912,
 10543,
 -44879,
 1353552630,
 9771,
 -1,
 1353758348,
 8507,
 1353973759,
 1353477280,
 -1,
 -44876,
 1353881908,
 170,
 -1,
 1353945914,
 9792,
 1354125649,
 1341896888,
 -1,
 1354191124,
 1354075340,
 -1,
 1354256616,
 1354143979,
 -1,
 1354322117,
 1354173052,
 -1,
 1354387652,
 1354278153,
 8593,
 1354498047,
 1354325191,
 -1,
 1354518721,
 1354373692,
 -1,
 1354584255,
 1354479257,
 -1,
 -44866,
 1354542129,
 8625,
 -1,
 1354597568,
 8624,
 -44864,
 1354517018,
 10505,
 -1,
 1354713260,
 8670,
 -44862,
 1354468854,
 10514,
 -44861,
 1354849113,
 8645,
 -1,
 1354934287,
 8613,
 -1,
 1354304096,
 11797,
 1355174099,
 1354245339,
 -1,
 1355239630,
 1355113419,
 -1,
 1355305165,
 1355177159,
 -1,
 1355370699,
 1355236213,
 -1,
 -44854,
 1355308362,
 10595,
 -1,
 1355359368,
 10606,
 -44852,
 1355320822,
 10584,
 -1,
 1355524111,
 10592,
 -1,
 1355230213,
 8639,
 1355808767,
 1355194934,
 -1,
 1355829458,
 1355701447,
 -1,
 -44847,
 1355779574,
 10580,
 -1,
 1355851791,
 10588,
 -1,
 1355754501,
 8638,
 1356091613,
 1355122796,
 -1,
 1356157147,
 1356050372,
 8679,
 1356267519,
 1356094663,
 -1,
 1356288218,
 1356181617,
 8683,
 1356398591,
 1356213700,
 -1,
 -44839,
 1356299645,
 8685,
 -1,
 1356380365,
 8684,
 -1,
 1356245007,
 8682,
 1356660735,
 1356108153,
 8686,
 -1,
 1356551302,
 8687,
 1356746978,
 1356050370,
 -1,
 1356812513,
 1356678764,
 -1,
 -44832,
 1356750194,
 10569,
 -1,
 1356802740,
 8607,
 -1,
 1356733426,
 10506,
 1357074661,
 1356670272,
 -1,
 -44828,
 1357026609,
 8657,
 -1,
 1357078131,
 8673,
 -44826,
 1357024615,
 10224,
 -44825,
 1357210248,
 8648,
 -1,
 1357269896,
 11014,
 1357467902,
 1354194119,
 -1,
 1357533423,
 1357395026,
 -1,
 1357598956,
 1357492164,
 8597,
 -1,
 1357514576,
 8616,
 -44819,
 1357546076,
 8691,
 -44818,
 1357681017,
 8661,
 -1,
 1357728648,
 11021,
 1357926646,
 1357482939,
 -1,
 1357992179,
 1357865704,
 -1,
 -44814,
 1357935693,
 10575,
 -1,
 1358012297,
 10572,
 1358233599,
 1357906514,
 -1,
 -44811,
 1358132301,
 10573,
 -1,
 1358208905,
 10577,
 1358385402,
 1357885380,
 -1,
 1358450937,
 1358301822,
 8963,
 -1,
 1358367809,
 8996,
 -1,
 1358381316,
 10685,
 1358647548,
 1358308024,
 8869,
 -1,
 1358600217,
 10207,
 -44803,
 1358592134,
 8944,
 -1,
 1358732091,
 10622,
 1358909713,
 1357388098,
 -1,
 1358975238,
 1358860785,
 -1,
 -44799,
 1358929869,
 9721,
 -44798,
 1358989633,
 10066,
 -44797,
 1359049306,
 9693,
 -44796,
 1359090867,
 10000,
 -44795,
 1359157955,
 9137,
 -1,
 1359250247,
 10064,
 1359433995,
 1358915666,
 -1,
 -44792,
 1359388621,
 9720,
 -44791,
 1359442522,
 9692,
 -44790,
 1359516989,
 9136,
 -1,
 1359570085,
 10196,
 1359761679,
 1359361732,
 -1,
 -44787,
 1359690940,
 9690,
 -44786,
 1359771457,
 9696,
 -1,
 1359839990,
 9600,
 -44784,
 1359707591,
 9620,
 -1,
 1359977059,
 9985,
 1360199679,
 1358828403,
 -1,
 -44781,
 1360103967,
 9710,
 -1,
 1360149235,
 9709,
 1360351549,
 1354117566,
 -1,
 1360417084,
 1360297676,
 -1,
 1360482588,
 1360349975,
 -1,
 1360548122,
 1360398972,
 -1,
 -44775,
 1360481815,
 66450,
 -1,
 1360544671,
 66453,
 -44773,
 1360487670,
 66461,
 -1,
 1360696794,
 66444,
 1360875808,
 1360441282,
 -1,
 -44770,
 1360803170,
 66458,
 -44769,
 1360884257,
 66456,
 -1,
 1360948545,
 66441,
 1361137955,
 1360800887,
 -1,
 -44766,
 1361098936,
 66449,
 -1,
 1361124902,
 66439,
 1361334566,
 1361076336,
 -1,
 -44763,
 1361258396,
 66435,
 -1,
 1361349056,
 66443,
 1361531176,
 1361258344,
 66437,
 -1,
 1361480110,
 66440,
 1361662251,
 1361461061,
 -1,
 -44758,
 1361613255,
 66457,
 -1,
 1361684808,
 66434,
 1361858862,
 1361585472,
 -1,
 -44755,
 1361790907,
 66447,
 -1,
 1361884234,
 66436,
 1362055473,
 1361775228,
 -1,
 -44752,
 1362008526,
 66432,
 -1,
 1362055118,
 66451,
 -44750,
 1362001550,
 66442,
 -44749,
 1362183788,
 66438,
 -44748,
 1362278584,
 66460,
 -44747,
 1362330302,
 66455,
 -44746,
 1362392072,
 66454,
 -44745,
 1362470321,
 66452,
 -44744,
 1362533939,
 66448,
 -44743,
 1362593848,
 66446,
 -44742,
 1362666105,
 66445,
 -44741,
 1362710411,
 66459,
 -1,
 1362760613,
 66433,
 -1,
 1360339782,
 66463,
 1363038542,
 1360296962,
 -1,
 1363104074,
 1362972555,
 -1,
 1363169609,
 1363050881,
 8746,
 1363279871,
 1363107015,
 -1,
 1363300677,
 1363155516,
 -1,
 -44733,
 1363227556,
 10818,
 -44732,
 1363281101,
 10817,
 -1,
 1363384287,
 10821,
 1363562824,
 1363258610,
 -1,
 -44729,
 1363509287,
 10822,
 -1,
 1363585504,
 10824,
 -1,
 1363479198,
 10826,
 -1,
 1363089304,
 9842,
 1363890509,
 1363027264,
 -1,
 -44724,
 1363841609,
 9100,
 -1,
 1363883870,
 8255,
 -1,
 1363832209,
 9903,
 1364152656,
 1362973641,
 9730,
 -1,
 1364073226,
 9748,
 -1,
 1364105754,
 9797,
 1364349400,
 1354043704,
 -1,
 1364414914,
 1364277625,
 -1,
 1364480447,
 1364335273,
 -1,
 1364545982,
 1364417735,
 -1,
 1364611440,
 1364478743,
 -1,
 1364676967,
 1364547044,
 9633,
 1364787199,
 1364614343,
 -1,
 1364808038,
 1364662844,
 -1,
 1364873566,
 1364748893,
 -1,
 1364939101,
 1364815771,
 -1,
 -44708,
 1364873297,
 9714,
 -1,
 1364926729,
 9713,
 -1,
 1364861327,
 10212,
 1365201249,
 1364830204,
 -1,
 -44704,
 1365135441,
 9715,
 -1,
 1365188873,
 9712,
 1365397860,
 1365120779,
 -1,
 -44701,
 1365354954,
 9634,
 -1,
 1365387115,
 10213,
 -44699,
 1365315633,
 9707,
 -1,
 1365525679,
 9093,
 -1,
 1364724290,
 9635,
 1365791082,
 1364620036,
 -1,
 -44695,
 1365740037,
 9786,
 -1,
 1365813581,
 9643,
 -44693,
 1365707208,
 9788,
 -44692,
 1365925107,
 9734,
 -44691,
 1365978132,
 9828,
 -44690,
 1366069560,
 9750,
 -44689,
 1366132904,
 65094,
 -1,
 1366191747,
 9988,
 1366380938,
 1364532277,
 -1,
 1366446461,
 1366307086,
 9675,
 1366556671,
 1366371780,
 -1,
 1366577526,
 1366468604,
 -1,
 -44683,
 1366511697,
 9719,
 -1,
 1366565129,
 9716,
 1366774137,
 1366515395,
 -1,
 -44680,
 1366708305,
 9718,
 -1,
 1366761737,
 9717,
 1366970748,
 1366705010,
 -1,
 -44677,
 1366909644,
 10732,
 -1,
 1366991578,
 9862,
 -1,
 1366924105,
 9863,
 1367232901,
 1366405041,
 -1,
 1367298433,
 1367171184,
 -1,
 -44672,
 1367227552,
 9816,
 -1,
 1367291424,
 9812,
 -44670,
 1367230824,
 9814,
 -44669,
 1367415229,
 9813,
 -44668,
 1367505877,
 9817,
 -1,
 1367563081,
 9815,
 1367757193,
 1367164771,
 10209,
 1367867391,
 1367682500,
 -1,
 -44664,
 1367777822,
 10211,
 -1,
 1367831545,
 10210,
 -1,
 1367708817,
 9831,
 1368084885,
 1366304064,
 -1,
 1368150416,
 1368011828,
 9671,
 1368260607,
 1368087751,
 -1,
 -44658,
 1368165929,
 10192,
 -44657,
 1368222161,
 9826,
 -1,
 1368306321,
 9672,
 1368522751,
 1368096138,
 -1,
 1368543636,
 1368427291,
 -1,
 -44653,
 1368498125,
 9661,
 -1,
 1368561818,
 9663,
 -1,
 1368472208,
 9759,
 1368805789,
 1368004363,
 -1,
 1368871324,
 1368757773,
 -1,
 1368936859,
 1368820507,
 -1,
 -44647,
 1368891341,
 9655,
 -44646,
 1368955034,
 9657,
 -1,
 1369014111,
 9659,
 -1,
 1368865424,
 9758,
 -1,
 1368831109,
 9645,
 1369330083,
 1368757455,
 -1,
 1369395618,
 1369279259,
 -1,
 1369461153,
 1369350093,
 9651,
 -1,
 1369389872,
 9708,
 -1,
 1369413786,
 9653,
 -1,
 1369324176,
 9757,
 1369723305,
 1369269195,
 -1,
 1369788840,
 1369672475,
 -1,
 -44634,
 1369743309,
 9665,
 -44633,
 1369807002,
 9667,
 -1,
 1369866079,
 9669,
 -1,
 1369717392,
 9756,
 1370116527,
 1369651071,
 -1,
 1370182061,
 1370057309,
 -1,
 -44628,
 1370108414,
 10048,
 -1,
 1370196413,
 9872,
 -44626,
 1370105646,
 9785,
 -1,
 1370304343,
 10023,
 1370509746,
 1370042055,
 -1,
 -44623,
 1370461860,
 9647,
 -1,
 1370503284,
 11006,
 1370706357,
 1370468290,
 -1,
 -44620,
 1370620639,
 10177,
 -1,
 1370726762,
 9743,
 1370902968,
 1370620748,
 -1,
 -44617,
 1370838500,
 9723,
 -1,
 1370886067,
 9725,
 1371099579,
 1370831225,
 -1,
 -44614,
 1371032313,
 10710,
 -1,
 1371081132,
 9825,
 -44612,
 1371021931,
 9649,
 -44611,
 1371251902,
 10001,
 -1,
 1371305670,
 9702,
 -1,
 1364480546,
 10163,
 1371602943,
 1364413785,
 -1,
 -44607,
 1371497551,
 9855,
 -1,
 1371553464,
 9784,
 1371754959,
 1364331132,
 -1,
 1371820493,
 1371670555,
 -1,
 1371886026,
 1371772646,
 -1,
 1371951560,
 1371826781,
 -1,
 -44601,
 1371907115,
 65103,
 -1,
 1371944476,
 8967,
 -44599,
 1371907275,
 65099,
 -1,
 1372078219,
 12336,
 1372323839,
 1371827298,
 -1,
 -44596,
 1372209291,
 12316,
 -1,
 1372266247,
 10547,
 -44594,
 1371764924,
 8986,
 -1,
 1372415098,
 9888,
 1372606930,
 1371674379,
 -1,
 -44591,
 1372563959,
 9997,
 -1,
 1372595001,
 8768,
 1372803541,
 1372534114,
 -1,
 -44588,
 1372757506,
 8288,
 -1,
 1372794095,
 8361,
 1373044735,
 1372729041,
 -1,
 -44585,
 1372917227,
 9840,
 -1,
 1373009135,
 10172,
 1373196790,
 1364268702,
 -1,
 1373262320,
 1373112956,
 -1,
 1373327854,
 1373193161,
 -1,
 1373393387,
 1373256981,
 -1,
 1373458920,
 1373349884,
 -1,
 1373524453,
 1373397963,
 9624,
 1373634559,
 1373453098,
 -1,
 1373655522,
 1373541605,
 -1,
 -44575,
 1373610550,
 9628,
 -1,
 1373660107,
 9627,
 1373896703,
 1373593283,
 -1,
 -44572,
 1373807158,
 9626,
 -1,
 1373866753,
 9625,
 1374093311,
 1373479478,
 9629,
 1374158847,
 1373966139,
 9630,
 -1,
 1374073376,
 9631,
 1374289919,
 1373396675,
 -1,
 -44566,
 1374200374,
 9623,
 -1,
 1374249931,
 9622,
 1374486527,
 1373337638,
 -1,
 -44563,
 1374357799,
 8279,
 -1,
 1374436793,
 10764,
 -44561,
 1373250619,
 10774,
 -1,
 1374559201,
 9833,
 1374769653,
 1373214569,
 -1,
 1374835188,
 1374706887,
 -1,
 -44557,
 1374786560,
 63,
 -1,
 1374829448,
 8264,
 -1,
 1374751057,
 8799,
 -1,
 1374715398,
 34,
 1375162897,
 1373121655,
 -1,
 1375228427,
 1375077205,
 -1,
 1375293951,
 1375161111,
 -1,
 1375359486,
 1375216890,
 -1,
 1375425021,
 1375309004,
 -1,
 -44548,
 1375369994,
 10785,
 -1,
 1375424160,
 10784,
 -1,
 1375357242,
 10783,
 -1,
 1375291099,
 10625,
 1375752709,
 1375213323,
 -1,
 1375818243,
 1375709774,
 -1,
 -44542,
 1375735645,
 10632,
 -1,
 1375797826,
 10634,
 -44540,
 1375737677,
 10814,
 -1,
 1375955507,
 10853,
 1376145928,
 1375692882,
 -1,
 -44537,
 1376063325,
 10631,
 -1,
 1376125506,
 10633,
 -44535,
 1376078617,
 10626,
 -44534,
 1376257325,
 10852,
 -1,
 1376322913,
 8959,
 1376583679,
 1375146770,
 -1,
 1376604687,
 1376474965,
 -1,
 -44530,
 1376530201,
 8204,
 -1,
 1376595830,
 65279,
 -44528,
 1376532439,
 8203,
 -1,
 1376715056,
 8205,
 1376932373,
 1375098876,
 -1,
 -44525,
 1376883366,
 9795,
 -44524,
 1376917980,
 10781,
 -1,
 1376985625,
 12292,
 1377239039,
 1376852411,
 -1,
 -44521,
 1377141264,
 8891,
 -1,
 1377187259,
 8999]
_charnames_32 = [
16486,
17954,
20981,
20231,
18493,
19962,
9350,
9222,
7235,
19002,
9335,
19929,
2644,
15452,
20606,
16417,
18564,
18558,
18544,
18546,
18554,
18556,
18549,
18551,
18562,
18560,
2846,
16460,
7384,
17907,
12578,
20978,
2643,
6237,
6578,
6547,
6428,
6323,
6606,
6492,
6521,
6364,
6610,
6569,
6446,
6596,
6410,
6182,
6591,
6612,
6506,
6477,
6388,
6281,
6586,
6558,
6602,
6462,
6535,
7153,
19255,
18938,
3211,
7417,
12580,
5729,
6075,
6044,
5858,
5678,
6128,
6061,
6027,
5945,
6147,
6088,
5889,
6119,
5970,
5623,
6110,
6152,
5916,
5825,
5567,
5777,
6135,
6099,
6141,
6011,
5993,
7209,
18877,
18980,
13476,
]

_charnames_160 = [
20196,
20453,
3356,
19973,
3347,
10656,
10919,
16463,
18599,
2829,
20659,
7342,
20175,
16421,
19274,
4566,
18300,
19946,
16133,
16134,
9344,
5559,
19980,
5557,
3358,
16147,
4564,
19118,
18910,
18911,
18916,
20450,
6274,
6275,
6240,
6268,
6255,
6265,
6276,
6550,
6354,
6356,
6326,
6344,
6384,
6386,
6377,
6372,
6361,
6423,
6229,
6231,
6205,
6213,
6202,
5360,
6224,
6319,
6321,
6311,
6284,
6475,
6409,
5857,
5769,
5770,
5732,
5764,
5747,
5759,
5771,
6047,
5710,
5712,
5681,
5699,
5964,
5966,
5956,
5951,
5727,
5985,
5668,
5670,
5646,
5654,
5643,
18591,
5663,
5818,
5820,
5808,
5781,
6025,
5618,
6017,
6271,
5766,
6257,
5749,
6270,
5765,
6557,
6055,
6552,
6050,
6556,
6054,
6553,
6051,
6437,
5864,
6433,
5873,
6345,
5700,
6355,
5711,
6342,
5697,
6351,
5707,
6337,
5692,
6495,
6064,
6502,
6072,
6501,
6071,
6496,
6065,
6529,
6035,
6532,
6038,
6374,
5953,
6381,
5961,
6385,
5965,
6380,
5960,
6370,
5886,
6615,
6165,
6611,
6150,
6572,
6091,
6098,
6460,
5908,
6450,
5894,
6451,
5895,
6457,
5898,
6453,
5904,
6426,
5990,
6418,
5976,
6419,
5977,
5991,
6363,
5728,
6219,
5659,
6230,
5669,
6201,
5642,
6614,
6163,
6519,
5936,
6515,
5930,
6516,
5931,
6489,
5837,
6483,
5831,
6484,
5832,
6480,
5828,
6393,
5598,
6394,
5599,
6400,
5605,
6306,
5803,
6314,
5814,
6320,
5819,
6316,
5812,
6295,
5792,
6317,
5816,
6566,
6108,
6474,
6024,
6468,
6546,
6010,
6539,
6004,
6542,
5998,
5909,
6081,
6585,
6583,
6080,
6406,
5614,
6233,
6555,
6053,
6280,
6443,
6441,
5866,
5592,
6520,
6491,
6234,
6608,
6132,
6500,
6505,
6042,
6387,
6379,
6575,
6095,
5903,
5915,
6408,
6415,
5979,
6223,
6185,
5626,
6236,
5677,
6593,
6115,
6674,
6405,
5613,
6362,
6660,
5607,
6403,
5610,
6401,
6298,
5795,
6322,
6589,
6469,
6018,
6543,
6001,
6357,
6360,
5721,
5719,
6677,
6407,
5615,
6668,
6675,
6680,
6679,
6672,
6661,
6445,
6432,
5881,
6461,
6454,
5913,
6427,
6424,
5992,
6247,
5739,
6378,
5957,
6212,
5653,
6313,
5810,
6287,
5784,
6290,
5787,
6289,
5786,
6288,
5785,
5591,
6256,
5748,
6252,
5744,
6278,
5773,
6498,
6067,
6497,
6066,
6573,
6092,
6226,
5665,
6227,
5666,
6359,
5718,
6151,
6444,
6431,
5877,
6503,
6073,
6534,
6568,
6425,
5989,
6266,
5760,
6279,
5774,
6225,
5664,
6254,
5746,
6272,
5767,
6343,
5698,
6352,
5708,
6371,
5949,
6382,
5962,
6200,
5641,
6228,
5667,
6513,
5923,
6518,
5935,
6294,
5791,
6318,
5817,
6482,
5830,
6391,
5596,
6476,
6026,
6531,
6037,
6413,
5861,
6235,
5676,
6545,
6009,
6251,
5743,
6335,
5690,
6203,
5644,
6215,
5656,
6196,
5637,
6197,
5638,
6472,
6022,
5892,
5974,
5595,
5883,
5888,
6153,
6269,
6554,
6052,
6459,
6399,
5839,
6000,
6504,
]

_charnames_592 = [
5576,
5775,
5577,
6085,
5672,
6049,
5867,
5868,
5943,
5851,
5854,
5674,
5938,
5941,
6060,
5884,
6070,
5855,
6637,
6074,
5944,
5573,
6040,
6043,
5958,
5967,
6635,
5897,
5902,
5905,
5914,
5582,
5583,
6126,
5981,
5986,
6649,
6087,
6623,
6059,
6118,
5569,
5571,
5572,
5925,
5932,
5927,
5942,
6624,
6636,
5842,
5722,
5885,
5856,
5726,
5587,
5606,
5821,
5822,
6139,
5586,
5585,
5584,
6644,
6005,
5996,
5713,
5717,
6669,
6678,
6667,
6656,
6665,
6639,
6058,
6638,
6653,
6149,
5588,
6633,
6154,
6670,
6659,
5879,
5887,
5880,
5620,
5621,
5622,
6134,
5912,
5911,
6664,
6666,
5574,
5575,
4657,
4658,
4652,
4625,
4577,
4578,
4591,
4661,
4659,
4809,
4788,
4806,
4815,
4772,
4768,
4731,
4797,
4771,
4732,
4769,
4793,
4786,
4707,
1996,
4804,
4765,
4816,
4796,
4725,
4727,
4728,
4729,
4807,
4782,
4703,
4704,
4792,
4785,
4810,
4764,
10920,
18491,
19129,
19635,
16382,
18376,
4773,
4706,
4613,
4633,
4598,
4660,
4628,
4745,
4780,
4757,
4720,
4739,
4800,
4801,
4803,
4794,
4789,
4718,
4726,
4712,
4724,
4723,
4763,
4761,
4762,
4721,
4774,
4813,
4749,
4812,
4748,
4664,
4817,
4711,
2549,
2571,
2508,
2587,
2612,
2629,
2604,
2479,
2486,
2617,
2530,
2476,
2502,
2609,
2459,
2475,
2504,
2596,
2591,
2498,
2533,
2499,
2550,
2572,
2440,
2526,
2431,
2616,
2434,
2624,
2485,
2626,
2614,
2627,
2535,
2481,
2487,
2529,
2500,
2510,
2630,
2608,
2602,
2599,
2503,
2509,
2605,
2597,
2590,
2613,
2449,
2473,
2589,
2579,
2445,
2580,
2446,
2523,
2598,
2583,
2585,
2621,
2610,
2472,
2551,
2573,
2544,
2545,
2546,
2543,
2603,
2563,
2458,
2430,
2639,
2618,
2575,
2438,
2623,
2552,
2518,
2435,
2636,
2620,
2427,
2519,
2517,
2524,
2480,
2574,
2466,
2637,
2471,
2470,
2468,
2469,
2461,
2474,
2467,
2422,
2419,
2417,
2415,
2412,
2421,
2420,
2418,
2416,
2414,
2413,
2411,
2410,
-1,
-1,
-1,
-1,
12535,
12465,
-1,
-1,
-1,
-1,
12524,
-1,
-1,
-1,
12534,
-1,
-1,
-1,
-1,
-1,
12490,
12473,
12223,
12374,
12194,
12181,
12243,
-1,
12153,
-1,
12258,
12140,
12051,
12196,
12283,
12280,
12281,
12183,
12274,
12156,
12270,
12226,
12279,
12278,
12277,
12276,
12275,
12142,
12267,
12272,
-1,
12262,
12271,
12246,
12268,
12282,
12266,
12115,
12234,
12254,
12015,
11982,
11970,
12069,
12024,
11985,
12104,
12101,
12095,
11971,
12096,
11942,
12088,
12045,
12092,
12100,
12099,
12098,
12097,
11928,
12085,
12079,
12102,
12077,
12089,
12018,
12086,
12103,
12084,
11899,
12048,
12021,
11939,
12042,
11927,
-1,
12537,
12485,
12515,
12517,
12516,
12500,
12499,
12511,
12461,
12017,
12456,
12076,
12460,
12094,
12459,
12091,
12457,
12075,
2776,
2687,
2808,
2719,
2783,
2694,
2801,
2712,
2804,
2715,
2775,
2686,
2771,
2682,
12510,
12521,
12463,
12458,
12288,
12464,
12522,
12263,
12078,
12284,
12264,
12074,
12520,
12286,
12289,
12287,
2216,
2209,
2305,
2281,
2273,
2304,
2287,
2265,
2326,
2321,
2325,
2297,
2190,
2220,
2229,
2303,
2250,
2289,
2323,
2275,
2306,
2214,
2240,
2246,
2208,
2227,
2183,
2204,
2202,
2193,
2290,
2314,
2200,
2198,
2299,
2266,
2206,
2317,
2298,
2307,
2232,
2231,
2318,
2260,
2237,
2192,
2264,
2262,
2086,
2125,
2159,
2111,
2142,
2050,
2076,
2082,
2044,
2063,
2019,
2040,
2038,
2029,
2126,
2150,
2036,
2034,
2135,
2102,
2042,
2153,
2134,
2143,
2068,
2067,
2154,
2096,
2073,
2028,
2100,
2098,
2052,
2045,
2141,
2117,
2109,
2140,
2123,
2101,
2162,
2157,
2161,
2133,
2026,
2056,
2065,
2139,
2291,
2127,
2263,
2099,
2212,
2048,
2322,
2158,
2211,
2047,
2288,
2124,
2213,
2049,
2189,
2025,
2316,
2152,
2327,
2163,
2222,
2058,
2223,
2059,
2272,
2108,
2324,
2160,
2292,
2128,
2293,
2129,
2182,
2018,
2335,
2493,
2492,
2496,
2491,
-1,
2495,
2494,
2228,
2064,
2238,
2074,
2201,
2037,
2277,
2113,
2278,
2114,
2279,
2115,
2244,
2080,
2249,
2085,
2188,
2024,
2185,
2021,
2186,
2022,
2286,
2122,
2197,
2033,
2330,
2166,
2315,
2151,
2254,
2090,
2199,
2035,
2300,
2136,
2233,
2069,
2234,
2070,
2319,
2155,
2329,
2165,
2311,
2147,
2312,
2148,
2230,
2066,
2252,
2088,
2253,
2089,
2334,
2245,
2081,
2187,
2023,
2205,
2041,
2196,
2032,
2195,
2031,
2191,
2027,
2203,
2039,
-1,
2258,
2094,
2257,
2093,
2331,
2167,
2217,
2053,
2235,
2071,
2236,
2072,
2243,
2079,
2248,
2084,
2255,
2091,
2219,
2055,
2221,
2057,
2294,
2130,
2284,
2120,
2285,
2121,
2207,
2043,
2271,
2107,
2270,
2106,
2269,
2105,
2310,
2146,
2280,
2116,
2261,
2097,
-1,
-1,
-1,
-1,
-1,
-1,
2176,
2012,
2175,
2011,
2177,
2013,
2174,
2010,
2181,
2017,
2180,
2016,
2179,
2015,
2178,
2014,
]

_charnames_1329 = [
9093,
9092,
9081,
9091,
9053,
9056,
9052,
9051,
9063,
9055,
9088,
9087,
9083,
9049,
9075,
9089,
9079,
9082,
9046,
9086,
9057,
9085,
9066,
9060,
9047,
9073,
9078,
9070,
9067,
9061,
9064,
9069,
9048,
9058,
9072,
9076,
9084,
9090,
-1,
-1,
9102,
9099,
9097,
9096,
9094,
9101,
9100,
-1,
9033,
9032,
9021,
9031,
8993,
8996,
8992,
8991,
9003,
8995,
9028,
9027,
9023,
8989,
9015,
9029,
9019,
9022,
8986,
9026,
8997,
9025,
9006,
9000,
8987,
9013,
9018,
9010,
9007,
9001,
9004,
9009,
8988,
8998,
9012,
9016,
9024,
9030,
9041,
-1,
9104,
9103,
-1,
-1,
-1,
-1,
-1,
-1,
15118,
15105,
15104,
15080,
15081,
15090,
15115,
15082,
15111,
15101,
15089,
15097,
15098,
15099,
15107,
15088,
15110,
15119,
15094,
15095,
15092,
15093,
15114,
15108,
15087,
15102,
15116,
15117,
15113,
15083,
15155,
15132,
15124,
15126,
15125,
15128,
15139,
15134,
15141,
15136,
15127,
-1,
15138,
15144,
15142,
15152,
15140,
15150,
15131,
15133,
15149,
15154,
15156,
15151,
15137,
]

_charnames_1488 = [
15013,
15048,
15064,
15066,
15045,
15033,
15052,
15046,
15025,
15029,
15006,
15041,
15062,
15010,
15060,
15009,
15058,
15001,
15021,
15004,
15037,
15008,
15023,
15056,
15054,
14992,
15027,
-1,
-1,
-1,
-1,
-1,
15072,
15074,
15071,
15148,
15147,
]

_charnames_1547 = [
9359,
8966,
8925,
8945,
8892,
8883,
8893,
8889,
8890,
8891,
8866,
-1,
-1,
-1,
-1,
-1,
8905,
-1,
-1,
8932,
8963,
-1,
8420,
8441,
8437,
8767,
8433,
8594,
8428,
8653,
8252,
8249,
8302,
8800,
8404,
8548,
8323,
8309,
8623,
8784,
8556,
8580,
8570,
8338,
8313,
8777,
8458,
8697,
-1,
-1,
-1,
-1,
-1,
8929,
8713,
8820,
8528,
8750,
8830,
8474,
8375,
8764,
8452,
8591,
8912,
8920,
8935,
8907,
8919,
8934,
8900,
8895,
8958,
8961,
8960,
8899,
8965,
8957,
8962,
8941,
8942,
8943,
8955,
8909,
-1,
8977,
8978,
8969,
8970,
8975,
8976,
8972,
8973,
8980,
8979,
8947,
8926,
8933,
8916,
8373,
8371,
8589,
8448,
8447,
8446,
8422,
8426,
8425,
8813,
8424,
8287,
8288,
8677,
8260,
8259,
8736,
8265,
8670,
8414,
8409,
8508,
8359,
8413,
8272,
8273,
8351,
8334,
8332,
8333,
8346,
8355,
8366,
8328,
8335,
8648,
8627,
8635,
8633,
8628,
8634,
8632,
8807,
8638,
8564,
8560,
8561,
8573,
8574,
8318,
8466,
8372,
8722,
8723,
8789,
8719,
8737,
8824,
8823,
8516,
8588,
8532,
8533,
8494,
8531,
8685,
8691,
8495,
8689,
8705,
8690,
8756,
8757,
8755,
8754,
8484,
8485,
8641,
8483,
8479,
8385,
8284,
8393,
8377,
8382,
8255,
8772,
8544,
8847,
8811,
8618,
8540,
8771,
8788,
8729,
8603,
8604,
8773,
8840,
8602,
8605,
8607,
8914,
8472,
8861,
8862,
8857,
8863,
8872,
8865,
8869,
8952,
8904,
8870,
8868,
8873,
8856,
8875,
8858,
8878,
8877,
8867,
8871,
8946,
8950,
8951,
8954,
8876,
8330,
8636,
17947,
17948,
17939,
17940,
17945,
17946,
17942,
17943,
17950,
17949,
8585,
8343,
8702,
8887,
8886,
8397,
15854,
15824,
15828,
15822,
15826,
15819,
15858,
15857,
15823,
15827,
15859,
15816,
15817,
15818,
-1,
15870,
15808,
15773,
15807,
15793,
15794,
15797,
15796,
15791,
15799,
15798,
15792,
15783,
15784,
15786,
15787,
15804,
15803,
15802,
15801,
15775,
15805,
15806,
15777,
15790,
15776,
15800,
15789,
15774,
15785,
15781,
15779,
15780,
15849,
15848,
15847,
15845,
15844,
15843,
15839,
15838,
15864,
15865,
15813,
15812,
15814,
15853,
15852,
15840,
15868,
15866,
15841,
15832,
15831,
15835,
15834,
15862,
15861,
15867,
15869,
-1,
-1,
15770,
15771,
15772,
8660,
8664,
8658,
8659,
8661,
8663,
8662,
8410,
8412,
8327,
8331,
8629,
8563,
8463,
8465,
8462,
8720,
8718,
8522,
8521,
8520,
8834,
8833,
8478,
8482,
8481,
8758,
8631,
8637,
8562,
]

_charnames_1920 = [
14195,
14167,
14185,
14202,
14209,
14188,
14192,
14197,
14201,
14205,
14207,
14183,
14159,
14189,
14178,
14176,
14168,
14181,
14172,
14163,
14199,
14204,
14206,
14208,
14161,
14194,
14191,
14160,
14173,
14166,
14169,
14182,
14162,
14174,
14198,
14177,
14203,
14200,
14219,
14220,
14223,
14216,
14221,
14211,
14217,
14215,
14212,
14213,
14222,
14186,
]

_charnames_2305 = [
18170,
18168,
18164,
18038,
18081,
18084,
18110,
18111,
18102,
18103,
18044,
18046,
18079,
18037,
18121,
18083,
18078,
18036,
18117,
18082,
18098,
18097,
18074,
18072,
18054,
18076,
18080,
18109,
18108,
18053,
18066,
18065,
18060,
18058,
18052,
18068,
18067,
18062,
18061,
18055,
18051,
18106,
18105,
18114,
18113,
18118,
18101,
18088,
18086,
18093,
18092,
18091,
18048,
18039,
18040,
18041,
18119,
-1,
-1,
18169,
18167,
18131,
18137,
18138,
18132,
18133,
18124,
18125,
18141,
18136,
18143,
18130,
18140,
18135,
18142,
18129,
18165,
-1,
-1,
18177,
18172,
18173,
18178,
18175,
-1,
-1,
-1,
18116,
18096,
18071,
18115,
18059,
18087,
18120,
18100,
18045,
18047,
18126,
18127,
18160,
18159,
18155,
18156,
18147,
18148,
18153,
18154,
18150,
18151,
18158,
18157,
18176,
]

_charnames_2429 = [
18073,
-1,
-1,
-1,
11687,
11685,
11681,
-1,
11610,
11613,
11633,
11634,
11625,
11626,
11589,
11591,
-1,
-1,
11648,
11612,
-1,
-1,
11644,
11611,
11621,
11619,
11637,
11636,
11602,
11640,
11639,
11632,
11631,
11600,
11596,
11595,
11607,
11606,
11601,
11598,
11597,
11609,
11608,
11603,
-1,
11629,
11628,
11643,
11642,
11645,
11624,
11582,
-1,
11646,
-1,
-1,
-1,
11616,
11615,
11617,
11647,
-1,
-1,
11686,
11684,
11658,
11661,
11662,
11659,
11660,
11651,
11652,
-1,
-1,
11664,
11657,
-1,
-1,
11663,
11656,
11682,
11620,
]

_charnames_2519 = [
11701,
-1,
-1,
-1,
-1,
11586,
11587,
-1,
11623,
11590,
11592,
11653,
11654,
-1,
-1,
11675,
11676,
11667,
11668,
11673,
11674,
11670,
11671,
11678,
11677,
11584,
11585,
11699,
11698,
11693,
11691,
11692,
11695,
11694,
11696,
11700,
-1,
-1,
-1,
-1,
-1,
-1,
12792,
12791,
12788,
-1,
12714,
12717,
12745,
12746,
12728,
12729,
-1,
-1,
-1,
-1,
12760,
12716,
-1,
-1,
12756,
12715,
12722,
12721,
12727,
12726,
12706,
12749,
12748,
12744,
12743,
12704,
12700,
12699,
12711,
12710,
12705,
12702,
12701,
12713,
12712,
12707,
-1,
12738,
12737,
12752,
12751,
12757,
12754,
12735,
-1,
12741,
12740,
-1,
12755,
12731,
-1,
12732,
12758,
-1,
-1,
12790,
-1,
12779,
12782,
12783,
12780,
12781,
-1,
-1,
-1,
-1,
12785,
12778,
-1,
-1,
12784,
12777,
12789,
]

_charnames_2662 = [
12771,
12772,
12763,
12764,
12769,
12770,
12766,
12767,
12774,
12773,
12794,
12797,
12795,
12793,
12796,
]

_charnames_2689 = [
12692,
12690,
12686,
-1,
12608,
12611,
12630,
12631,
12616,
12617,
12586,
12588,
12669,
-1,
12646,
12610,
12668,
-1,
12643,
12609,
12626,
12625,
12634,
12633,
12600,
12637,
12636,
12629,
12628,
12598,
12594,
12593,
12605,
12604,
12599,
12596,
12595,
12607,
12606,
12601,
-1,
12620,
12619,
12640,
12639,
12644,
12641,
12642,
-1,
12623,
12622,
-1,
12590,
12614,
12613,
12615,
12645,
-1,
-1,
12691,
12689,
12657,
12660,
12661,
12658,
12659,
12650,
12651,
12664,
-1,
12666,
12656,
12663,
-1,
12665,
12655,
12687,
-1,
-1,
12694,
]

_charnames_2784 = [
12587,
12589,
12652,
12653,
-1,
-1,
12680,
12681,
12672,
12673,
12678,
12679,
12675,
12676,
12683,
12682,
-1,
12693,
]

_charnames_2817 = [
19427,
19425,
19421,
-1,
19348,
19351,
19377,
19378,
19363,
19364,
19326,
19328,
-1,
-1,
19392,
19350,
-1,
-1,
19389,
19349,
19373,
19372,
19381,
19380,
19340,
19384,
19383,
19376,
19375,
19338,
19334,
19333,
19345,
19344,
19339,
19336,
19335,
19347,
19346,
19341,
-1,
19367,
19366,
19387,
19386,
19390,
19362,
19359,
-1,
19370,
19369,
-1,
19330,
19354,
19353,
19355,
19391,
-1,
-1,
19426,
19424,
19397,
19400,
19401,
19398,
19399,
19402,
-1,
-1,
-1,
19404,
19396,
-1,
-1,
19403,
19395,
19422,
]

_charnames_2902 = [
19430,
19429,
-1,
-1,
-1,
-1,
19357,
19358,
-1,
19361,
19327,
19329,
-1,
-1,
-1,
-1,
19415,
19416,
19407,
19408,
19413,
19414,
19410,
19411,
19418,
19417,
19431,
19388,
]

_charnames_2946 = [
13740,
13738,
-1,
13665,
13668,
13688,
13689,
13678,
13679,
-1,
-1,
-1,
13690,
13691,
13667,
-1,
13686,
13687,
13666,
13696,
-1,
-1,
-1,
13663,
13699,
-1,
13697,
-1,
13662,
13681,
-1,
-1,
-1,
13661,
13682,
-1,
-1,
-1,
13664,
13660,
13694,
-1,
-1,
-1,
13695,
13692,
13685,
13684,
13677,
13676,
13675,
13693,
13671,
13670,
13672,
13698,
-1,
-1,
-1,
-1,
13721,
13726,
13727,
13722,
13723,
-1,
-1,
-1,
13728,
13729,
13720,
-1,
13724,
13725,
13719,
13739,
]

_charnames_3046 = [
13711,
13712,
13703,
13704,
13709,
13710,
13706,
13707,
13714,
13713,
13734,
13733,
13732,
13716,
13746,
13744,
13715,
13747,
13743,
13745,
13735,
-1,
-1,
-1,
-1,
-1,
-1,
13898,
13899,
13896,
-1,
13821,
13824,
13848,
13849,
13829,
13830,
13799,
13801,
-1,
13853,
13854,
13823,
-1,
13837,
13838,
13822,
13844,
13843,
13852,
13851,
13813,
13857,
13856,
13847,
13846,
13811,
13807,
13806,
13818,
13817,
13812,
13809,
13808,
13820,
13819,
13814,
-1,
13836,
13835,
13860,
13859,
13862,
13861,
13833,
13832,
13841,
13840,
-1,
13803,
13827,
13826,
13828,
13863,
-1,
-1,
-1,
-1,
13869,
13876,
13877,
13872,
13873,
13870,
13871,
-1,
13878,
13879,
13868,
-1,
13874,
13875,
13867,
13897,
]

_charnames_3168 = [
13800,
13802,
-1,
-1,
-1,
-1,
13890,
13891,
13882,
13883,
13888,
13889,
13885,
13886,
13893,
13892,
]

_charnames_3202 = [
16913,
16909,
-1,
16833,
16836,
16860,
16861,
16841,
16842,
16811,
16813,
-1,
16865,
16866,
16835,
-1,
16849,
16850,
16834,
16856,
16855,
16864,
16863,
16825,
16869,
16868,
16859,
16858,
16823,
16819,
16818,
16830,
16829,
16824,
16821,
16820,
16832,
16831,
16826,
-1,
16848,
16847,
16872,
16871,
16874,
16873,
16845,
16844,
16853,
16852,
-1,
16815,
16839,
16838,
16840,
16875,
-1,
-1,
16914,
16912,
16882,
16889,
16890,
16885,
16886,
16883,
16884,
-1,
16891,
16892,
16881,
-1,
16887,
16888,
16880,
16910,
]

_charnames_3294 = [
16876,
-1,
16812,
16814,
-1,
-1,
-1,
-1,
16903,
16904,
16895,
16896,
16901,
16902,
16898,
16899,
16906,
16905,
]

_charnames_3330 = [
4553,
4551,
-1,
4476,
4479,
4505,
4506,
4489,
4490,
4454,
4456,
-1,
4510,
4511,
4478,
-1,
4497,
4498,
4477,
4501,
4500,
4509,
4508,
4468,
4514,
4513,
4504,
4503,
4466,
4462,
4461,
4473,
4472,
4467,
4464,
4463,
4475,
4474,
4469,
-1,
4496,
4495,
4517,
4516,
4519,
4518,
4493,
4492,
4488,
4487,
4486,
4458,
4482,
4481,
4483,
4520,
-1,
-1,
-1,
-1,
4525,
4530,
4531,
4526,
4527,
4534,
-1,
-1,
4532,
4533,
4524,
-1,
4528,
4529,
4523,
4552,
]

_charnames_3424 = [
4455,
4457,
-1,
-1,
-1,
-1,
4545,
4546,
4537,
4538,
4543,
4544,
4540,
4541,
4548,
4547,
]

_charnames_3458 = [
16099,
16101,
-1,
16008,
16012,
16006,
16007,
16040,
16041,
16058,
16059,
16035,
16036,
16038,
16039,
16064,
16065,
16011,
16061,
16062,
16009,
-1,
-1,
-1,
16000,
16023,
16002,
16025,
16069,
16047,
16003,
16026,
16001,
16024,
16052,
16051,
16046,
15994,
16017,
15997,
16020,
16031,
16044,
15995,
16018,
15998,
16021,
16055,
-1,
16045,
15999,
16022,
16004,
16027,
16028,
16010,
16066,
16068,
-1,
16056,
-1,
-1,
16067,
16050,
16030,
16054,
16070,
16032,
16071,
-1,
-1,
-1,
16100,
-1,
-1,
-1,
-1,
16096,
16084,
16092,
16083,
16091,
16082,
-1,
16089,
-1,
16095,
16075,
16090,
16080,
16079,
16078,
16077,
16094,
]

_charnames_3585 = [
14091,
14088,
14086,
14085,
14087,
14089,
14107,
14115,
14118,
14116,
14051,
14117,
14121,
14136,
14068,
14059,
14064,
14063,
14105,
14135,
14067,
14061,
14060,
14062,
14104,
14139,
14100,
14096,
14125,
14097,
14126,
14098,
14080,
14122,
14130,
14129,
14110,
14112,
14137,
14052,
14053,
14050,
14133,
14111,
14138,
14132,
14101,
14033,
14075,
14039,
14037,
14044,
14045,
14041,
14042,
14040,
14043,
14099,
-1,
-1,
-1,
-1,
14141,
14047,
14038,
14046,
14035,
14036,
14113,
14078,
14079,
14076,
14074,
14073,
14077,
14065,
14106,
14123,
14127,
14152,
14153,
14144,
14145,
14150,
14151,
14147,
14148,
14155,
14154,
14140,
14090,
]

_charnames_3713 = [
6701,
6700,
-1,
6699,
-1,
-1,
6696,
6719,
-1,
6703,
-1,
-1,
6694,
-1,
-1,
-1,
-1,
-1,
-1,
6718,
6687,
6686,
6685,
-1,
6695,
6720,
6692,
6691,
6712,
6690,
6713,
-1,
6717,
6714,
6707,
-1,
6706,
-1,
6715,
-1,
-1,
6704,
6710,
-1,
6716,
6709,
6767,
6722,
6733,
6726,
6724,
6734,
6735,
6727,
6728,
6729,
6730,
-1,
6732,
6761,
6760,
-1,
-1,
6736,
6737,
6738,
6723,
6725,
-1,
6766,
-1,
6757,
6756,
6755,
6758,
6768,
6765,
-1,
-1,
6749,
6750,
6741,
6742,
6747,
6748,
6744,
6745,
6752,
6751,
-1,
-1,
6763,
6764,
]

_charnames_3840 = [
13240,
13309,
13307,
13308,
13347,
13320,
13319,
13351,
13341,
13332,
13335,
13346,
13355,
13340,
13325,
13337,
13324,
13343,
13344,
13317,
13310,
13301,
13300,
13408,
13410,
13409,
13205,
13204,
13203,
13210,
13209,
13206,
13380,
13381,
13372,
13373,
13378,
13379,
13375,
13376,
13383,
13382,
13368,
13359,
13360,
13365,
13366,
13362,
13363,
13370,
13369,
13367,
13334,
13328,
13318,
13327,
13321,
13338,
13312,
13313,
13349,
13350,
13214,
13218,
13273,
13272,
13282,
13281,
13264,
13285,
13284,
13294,
-1,
13262,
13246,
13245,
13258,
13257,
13263,
13251,
13250,
13260,
13259,
13265,
13279,
13278,
13288,
13287,
13292,
13249,
13248,
13255,
13254,
13290,
13275,
13276,
13298,
13289,
13291,
13293,
13268,
13267,
13269,
13295,
13297,
13271,
13296,
-1,
-1,
-1,
-1,
-1,
-1,
13400,
13396,
13397,
13390,
13391,
13386,
13387,
13388,
13389,
13398,
13399,
13394,
13395,
13212,
13211,
13392,
13393,
13226,
13225,
13354,
13352,
13220,
13215,
13221,
13217,
13224,
13223,
-1,
-1,
-1,
-1,
13169,
13168,
13182,
13181,
13160,
13185,
13184,
13194,
-1,
13158,
13142,
13141,
13154,
13153,
13159,
13147,
13146,
13156,
13155,
13161,
13179,
13178,
13188,
13187,
13192,
13145,
13144,
13151,
13150,
13190,
13175,
13176,
13197,
13189,
13191,
13193,
13164,
13163,
13165,
13195,
13196,
13167,
13172,
13171,
13173,
-1,
13411,
13412,
13404,
13403,
13405,
13402,
13239,
13234,
13238,
13235,
13237,
13229,
13231,
13232,
13233,
-1,
-1,
13208,
13333,
13353,
]

_charnames_4096 = [
5419,
5418,
5427,
5426,
5386,
5430,
5429,
5422,
5421,
5385,
5383,
5396,
5395,
5402,
5401,
5384,
5398,
5397,
5404,
5403,
5387,
5413,
5412,
5433,
5432,
5440,
5436,
5438,
5416,
5437,
5408,
5441,
5415,
5434,
-1,
5423,
5424,
5409,
5410,
5442,
-1,
5439,
5435,
-1,
5455,
5451,
5452,
5449,
5450,
5456,
5454,
-1,
-1,
-1,
5465,
5464,
5460,
5461,
-1,
-1,
-1,
-1,
-1,
-1,
5481,
5482,
5473,
5474,
5479,
5480,
5476,
5477,
5484,
5483,
5463,
5462,
5467,
5469,
5470,
5468,
5407,
5406,
5389,
5390,
5391,
5392,
5445,
5446,
5447,
5448,
]

_charnames_4256 = [
12959,
12958,
12944,
12957,
12956,
12947,
12926,
12929,
12955,
12938,
12954,
12953,
12952,
12951,
12935,
12925,
12949,
12932,
12928,
12948,
12934,
12937,
12943,
12950,
12931,
12920,
12923,
12940,
12922,
12921,
12945,
12941,
12914,
12917,
12916,
12946,
12913,
12915,
]

_charnames_4304 = [
12843,
12859,
12838,
12858,
12840,
12848,
12823,
12819,
12856,
12832,
12855,
12854,
12853,
12852,
12829,
12822,
12850,
12826,
12818,
12849,
12828,
12831,
12837,
12851,
12825,
12812,
12815,
12834,
12814,
12813,
12846,
12835,
12806,
12809,
12808,
12847,
12805,
12807,
12857,
12845,
12841,
12820,
12844,
12960,
4798,
-1,
-1,
-1,
14754,
14678,
14756,
14762,
14673,
14765,
14772,
14683,
14676,
14651,
14674,
14731,
14729,
14681,
14716,
14755,
14764,
14702,
14774,
14760,
14677,
14758,
14759,
14763,
14767,
14675,
14768,
14752,
14773,
14753,
14701,
14700,
14694,
14686,
14690,
14688,
14689,
14692,
14691,
14697,
14698,
14695,
14699,
14749,
14751,
14661,
14668,
14658,
14667,
14669,
14654,
14655,
14666,
14670,
14664,
14665,
14662,
14659,
14656,
14671,
14712,
14710,
14725,
14723,
14704,
14745,
14738,
14744,
14734,
14743,
14736,
14679,
14741,
14742,
14739,
14735,
14770,
14730,
14714,
14711,
14727,
14724,
14718,
14719,
14715,
14728,
14703,
14750,
14680,
14771,
-1,
-1,
-1,
-1,
-1,
14775,
14531,
14491,
14500,
14474,
14478,
14482,
14481,
14470,
14469,
14501,
14527,
14528,
14508,
14461,
14517,
14526,
14525,
14529,
14452,
14487,
14479,
14509,
14499,
14498,
14477,
14476,
14485,
14484,
14486,
14473,
14472,
14504,
14503,
14505,
14507,
14506,
14464,
14465,
14466,
14467,
14468,
14519,
14520,
14523,
14521,
14522,
14460,
14457,
14456,
14455,
14454,
14458,
14459,
14489,
14490,
14480,
14511,
14513,
14515,
14514,
14516,
14512,
14492,
14496,
14494,
14495,
14530,
-1,
-1,
-1,
-1,
-1,
14412,
14377,
14414,
14401,
14410,
14409,
14436,
14339,
14349,
14357,
14342,
14363,
14356,
14346,
14366,
14379,
14392,
14394,
14368,
14375,
14441,
14448,
14449,
14422,
14440,
14398,
14423,
14416,
14415,
14408,
14404,
14406,
14407,
14405,
14439,
14438,
14350,
14365,
14354,
14355,
14376,
14360,
14359,
14344,
14345,
14352,
14362,
14347,
14351,
14364,
14388,
14387,
14385,
14383,
14382,
14386,
14390,
14389,
14421,
14395,
14396,
14397,
14419,
14373,
14370,
14371,
14372,
14400,
14444,
14446,
14378,
14445,
14430,
14432,
14433,
14399,
14420,
14427,
14425,
14428,
14426,
14434,
-1,
-1,
-1,
-1,
-1,
-1,
17744,
17746,
17747,
17745,
17743,
17742,
17740,
17741,
17807,
17810,
17811,
17808,
17806,
17805,
17803,
17809,
17734,
17737,
17739,
17735,
17733,
17732,
17738,
17736,
17758,
17761,
17762,
17759,
17757,
17756,
17754,
17753,
17432,
17435,
17437,
17433,
17431,
17430,
17436,
17434,
17796,
17800,
17801,
17797,
17795,
17794,
17792,
17799,
17455,
17458,
17459,
17456,
17452,
17446,
17453,
17457,
17424,
17427,
17428,
17425,
17423,
17422,
17420,
17426,
17531,
17533,
17534,
17532,
17530,
17529,
17527,
17528,
17524,
-1,
17526,
17525,
17523,
17522,
-1,
-1,
17508,
17510,
17512,
17509,
17507,
17506,
17511,
-1,
17503,
-1,
17505,
17504,
17502,
17501,
-1,
-1,
17787,
17789,
17790,
17788,
17786,
17785,
17783,
17782,
17843,
17846,
17848,
17844,
17842,
17841,
17847,
17845,
17493,
17496,
17497,
17494,
17492,
17491,
17489,
17495,
17603,
17606,
17607,
17604,
17602,
17601,
17599,
17605,
17686,
17688,
17689,
17687,
17685,
17684,
17682,
17683,
17679,
-1,
17681,
17680,
17678,
17677,
-1,
-1,
17705,
17708,
17709,
17706,
17704,
17703,
17701,
17707,
17696,
17699,
17700,
17697,
17695,
17694,
17692,
17698,
17391,
17394,
17395,
17392,
17390,
17389,
17387,
17393,
17568,
17570,
17571,
17569,
17567,
17566,
17564,
17565,
17561,
-1,
17563,
17562,
17560,
17559,
-1,
-1,
17545,
17547,
17549,
17546,
17544,
17543,
17548,
-1,
17540,
-1,
17542,
17541,
17539,
17538,
-1,
-1,
17836,
17838,
17839,
17837,
17835,
17834,
17832,
17833,
17614,
17616,
17618,
17615,
17613,
17612,
17617,
-1,
17662,
17665,
17666,
17663,
17661,
17660,
17658,
17664,
17644,
17647,
17649,
17645,
17643,
17642,
17648,
17646,
17827,
17829,
17830,
17828,
17826,
17825,
17823,
17824,
17725,
17728,
17729,
17726,
17724,
17723,
17721,
17727,
17716,
17719,
17720,
17717,
17715,
17714,
17712,
17718,
17817,
17820,
17821,
17818,
17816,
17815,
17813,
17819,
17414,
17416,
17417,
17415,
17413,
17412,
17410,
17411,
17407,
-1,
17409,
17408,
17406,
17405,
-1,
-1,
17381,
17383,
17385,
17382,
17380,
17379,
17384,
17377,
17466,
17469,
17470,
17467,
17465,
17464,
17462,
17468,
17594,
17597,
17598,
17595,
17593,
17592,
17590,
17596,
17610,
17625,
17626,
17619,
17623,
17622,
17620,
17624,
17483,
17486,
17488,
17484,
17482,
17481,
17487,
17485,
17476,
17478,
17479,
17477,
17475,
17474,
17472,
17473,
17771,
17774,
17776,
17772,
17770,
17769,
17775,
17768,
17636,
17638,
17639,
17637,
17635,
17634,
17632,
17631,
17798,
17760,
17773,
-1,
-1,
-1,
-1,
17896,
17851,
17901,
17903,
17895,
17850,
17897,
17899,
17902,
17900,
17890,
17882,
17883,
17888,
17889,
17885,
17886,
17892,
17891,
17854,
17856,
17857,
17862,
17863,
17859,
17860,
17866,
17864,
17865,
17855,
-1,
-1,
-1,
17449,
17752,
17751,
17750,
17451,
17781,
17780,
17779,
17450,
17767,
17766,
17765,
17448,
17630,
17629,
17628,
17875,
17869,
17877,
17876,
17871,
17874,
17879,
17878,
17870,
17873,
-1,
-1,
-1,
-1,
-1,
-1,
3312,
3311,
3310,
3308,
3307,
3306,
3299,
3309,
3298,
3297,
3296,
3295,
3294,
3256,
3255,
3254,
3252,
3251,
3250,
3292,
3291,
3290,
3289,
3288,
3287,
3305,
3304,
3303,
3302,
3301,
3242,
3253,
3243,
3248,
3247,
3246,
3245,
3244,
3285,
3284,
3283,
3282,
3281,
3280,
3240,
3234,
3239,
3238,
3237,
3236,
3235,
3264,
3233,
3263,
3232,
3262,
3231,
3260,
3259,
3258,
3261,
3230,
3229,
3228,
3227,
3226,
3225,
3223,
3222,
3221,
3220,
3219,
3218,
3278,
3277,
3276,
3275,
3274,
3273,
3271,
3270,
3269,
3268,
3267,
3266,
]

_charnames_5121 = [
1984,
1976,
1981,
1983,
1978,
1979,
1797,
1485,
1483,
1969,
1975,
1503,
1578,
1613,
1574,
1614,
1575,
1606,
1572,
1607,
1573,
1629,
1615,
1576,
1616,
1577,
1630,
1973,
1794,
1987,
1860,
1858,
1859,
1854,
1853,
1852,
1849,
1848,
1857,
1855,
1856,
1850,
1985,
1982,
1980,
1977,
1948,
1943,
1946,
1947,
1944,
1945,
1792,
1425,
1424,
1941,
1942,
1940,
1561,
1936,
1557,
1937,
1558,
1934,
1555,
1935,
1556,
1938,
1559,
1939,
1560,
1791,
1932,
1553,
1416,
1732,
1727,
1730,
1731,
1728,
1729,
1795,
1344,
1343,
1725,
1726,
1714,
1551,
1710,
1547,
1711,
1548,
1708,
1545,
1709,
1546,
1712,
1549,
1713,
1550,
1632,
1679,
1705,
1704,
1703,
1706,
1931,
1926,
1929,
1930,
1927,
1928,
1801,
1924,
1925,
1923,
1586,
1919,
1582,
1920,
1583,
1917,
1580,
1918,
1581,
1921,
1584,
1922,
1585,
1635,
1915,
1916,
1782,
1781,
1780,
1783,
1501,
1487,
1498,
1499,
1496,
1497,
1802,
1283,
1486,
1495,
1594,
1491,
1590,
1492,
1591,
1489,
1588,
1490,
1589,
1493,
1592,
1494,
1593,
1636,
1282,
1750,
1882,
1888,
1889,
1890,
1879,
1880,
1799,
1886,
1887,
1878,
1570,
1874,
1566,
1875,
1567,
1872,
1564,
1873,
1565,
1876,
1568,
1877,
1569,
1634,
1870,
1562,
1891,
1972,
1751,
1678,
1638,
1675,
1676,
1673,
1674,
1798,
1618,
1637,
1668,
1604,
1666,
1602,
1667,
1603,
1633,
1617,
1446,
1677,
1842,
1837,
1840,
1841,
1838,
1839,
1800,
1835,
1836,
1827,
1530,
1823,
1526,
1824,
1527,
1821,
1524,
1822,
1525,
1825,
1528,
1826,
1529,
1819,
1522,
1885,
1787,
1753,
1785,
1786,
1778,
1784,
1796,
1734,
1752,
1777,
1513,
1773,
1509,
1774,
1510,
1771,
1507,
1772,
1508,
1775,
1511,
1776,
1512,
1623,
1733,
1971,
1770,
1909,
1881,
1621,
1627,
1625,
1624,
1622,
1626,
1769,
1765,
1766,
1763,
1764,
1767,
1768,
1762,
1521,
1758,
1517,
1759,
1518,
1756,
1515,
1757,
1516,
1760,
1519,
1761,
1520,
1754,
1818,
1813,
1816,
1817,
1814,
1815,
1793,
1811,
1812,
1810,
1542,
1806,
1538,
1807,
1539,
1804,
1536,
1805,
1537,
1808,
1540,
1809,
1541,
1631,
1788,
1914,
1534,
1749,
1958,
1959,
1532,
1952,
1955,
1956,
1953,
1954,
1531,
1950,
1951,
1533,
1957,
1596,
1949,
1595,
1884,
1869,
1864,
1844,
1861,
1865,
1866,
1862,
1863,
1867,
1605,
1843,
1696,
1672,
1691,
1670,
1692,
1671,
1689,
1690,
1693,
1694,
1695,
1552,
1680,
1701,
1700,
1699,
1702,
1698,
1718,
1717,
1716,
1719,
1647,
1643,
1644,
1641,
1642,
1645,
1646,
1640,
1648,
1986,
1963,
1967,
1968,
1965,
1966,
1961,
1962,
1960,
1723,
1722,
1721,
1724,
1599,
1598,
1597,
1600,
1652,
1656,
1657,
1654,
1655,
1650,
1651,
1649,
1658,
1739,
1738,
1737,
1740,
1611,
1610,
1609,
1612,
1608,
1831,
1832,
1829,
1830,
1833,
1834,
1828,
1688,
1684,
1685,
1682,
1683,
1686,
1687,
1681,
1974,
1912,
1911,
1910,
1913,
1897,
1896,
1895,
1898,
1902,
1901,
1900,
1903,
1907,
1906,
1905,
1908,
1744,
1743,
1742,
1745,
1406,
1407,
1404,
1405,
1408,
1409,
1465,
1466,
1463,
1464,
1467,
1468,
1458,
1459,
1456,
1457,
1460,
1461,
1420,
1421,
1418,
1419,
1422,
1423,
1324,
1325,
1322,
1323,
1326,
1327,
1296,
1297,
1294,
1295,
1298,
1299,
1436,
1437,
1434,
1435,
1438,
1439,
1433,
1412,
1413,
1410,
1411,
1414,
1415,
1370,
1371,
1368,
1369,
1372,
1373,
1363,
1364,
1361,
1362,
1365,
1366,
1360,
1443,
1444,
1441,
1442,
1445,
1447,
1472,
1473,
1470,
1471,
1474,
1475,
1451,
1452,
1449,
1450,
1453,
1454,
1398,
1747,
1399,
1396,
1397,
1400,
1748,
1401,
1392,
1393,
1390,
1391,
1394,
1395,
1384,
1385,
1382,
1383,
1386,
1387,
1339,
1340,
1337,
1338,
1341,
1342,
1378,
1379,
1376,
1377,
1380,
1381,
1304,
1305,
1302,
1303,
1306,
1307,
1310,
1311,
1308,
1309,
1312,
1313,
1429,
1430,
1427,
1428,
1431,
1432,
1426,
1484,
1332,
1333,
1330,
1331,
1334,
1335,
1355,
1356,
1353,
1354,
1357,
1358,
1349,
1350,
1347,
1348,
1351,
1352,
1346,
1317,
1318,
1315,
1316,
1319,
1320,
1479,
1480,
1477,
1478,
1481,
1482,
1290,
1291,
1288,
1289,
1292,
1293,
1500,
1868,
1964,
1653,
1661,
1662,
1659,
1660,
1663,
1664,
]

_charnames_5760 = [
19632,
19630,
19626,
19628,
19609,
19614,
19602,
19629,
19622,
19620,
19621,
19625,
19627,
19615,
19608,
19623,
19631,
19612,
19600,
19605,
19617,
19606,
19611,
19601,
19618,
19604,
19624,
19634,
19633,
-1,
-1,
-1,
19222,
19214,
19215,
19200,
19199,
19201,
19205,
19173,
19195,
19153,
19198,
19197,
19160,
19142,
19151,
19156,
19155,
19216,
19207,
19185,
19208,
19189,
19174,
19192,
19193,
19202,
19210,
19211,
19162,
19145,
19219,
19143,
19180,
19169,
19172,
19221,
19191,
19163,
19147,
19168,
19218,
19196,
19149,
19150,
19141,
19183,
19212,
19204,
19140,
19177,
19223,
19146,
19179,
19154,
19175,
19220,
19161,
19144,
19164,
19181,
19167,
19166,
19182,
19152,
19176,
19170,
19187,
19188,
19186,
19148,
19159,
19139,
19171,
19217,
19213,
19225,
19226,
19227,
19229,
19224,
19228,
]

_charnames_5888 = [
13629,
13624,
13617,
13623,
13626,
13613,
13618,
13627,
13614,
13620,
13628,
13621,
13615,
-1,
13622,
13616,
13619,
13625,
13632,
13631,
13633,
]

_charnames_5920 = [
14817,
14812,
14804,
14811,
14814,
14800,
14805,
14815,
14801,
14808,
14816,
14809,
14802,
14807,
14810,
14803,
14806,
14813,
14820,
14819,
14821,
19982,
19983,
]

_charnames_5952 = [
11869,
11864,
11856,
11863,
11866,
11852,
11857,
11867,
11853,
11860,
11868,
11861,
11854,
11859,
11862,
11855,
11858,
11865,
11872,
11871,
]

_charnames_5984 = [
13652,
13648,
13641,
13647,
13649,
13637,
13642,
13650,
13638,
13644,
13651,
13645,
13639,
-1,
13646,
13640,
13643,
-1,
13655,
13654,
]

_charnames_6016 = [
17181,
17179,
17180,
17178,
17175,
17187,
17185,
17186,
17184,
17172,
17202,
17165,
17201,
17164,
17174,
17170,
17168,
17169,
17167,
17173,
17209,
17195,
17196,
17194,
17207,
17203,
17205,
17198,
17204,
17190,
17189,
17191,
17208,
17199,
17206,
17241,
17243,
17247,
17248,
17235,
17238,
17236,
17237,
17250,
17251,
17252,
17253,
17249,
17242,
17246,
17245,
17240,
17231,
17232,
17216,
17223,
17224,
17217,
17218,
17220,
17221,
17222,
17228,
17219,
17225,
17229,
17215,
17214,
17227,
17213,
17158,
17150,
17154,
17159,
17146,
17135,
17149,
17147,
17140,
17144,
17156,
17155,
17152,
17133,
17139,
17134,
17153,
17160,
17136,
17157,
17138,
17268,
17142,
17143,
-1,
-1,
17264,
17265,
17256,
17257,
17262,
17263,
17259,
17260,
17267,
17266,
-1,
-1,
-1,
-1,
-1,
-1,
17117,
17118,
17113,
17116,
17115,
17106,
17112,
17111,
17110,
17109,
-1,
-1,
-1,
-1,
-1,
-1,
5015,
5014,
5008,
5002,
5009,
5003,
5011,
5012,
5006,
5005,
5013,
5001,
4999,
5000,
5010,
-1,
4992,
4993,
4984,
4985,
4990,
4991,
4987,
4988,
4995,
4994,
-1,
-1,
-1,
-1,
-1,
-1,
4860,
4964,
4976,
4956,
4954,
4957,
4955,
4965,
4974,
4896,
4981,
4973,
4972,
4978,
4925,
4960,
4924,
4923,
4859,
4980,
4968,
4975,
4969,
4971,
4970,
4979,
4963,
4962,
4858,
4953,
4977,
4951,
4959,
4952,
4967,
4851,
4855,
4853,
4835,
4830,
4836,
4831,
4829,
4857,
4848,
4847,
4840,
4850,
4834,
4844,
4856,
4839,
4833,
4845,
4846,
4852,
4841,
4854,
4838,
4849,
4843,
4919,
4907,
4908,
4903,
4902,
4922,
4916,
4911,
4909,
4915,
4913,
4906,
4920,
4917,
4918,
4912,
4910,
4905,
4901,
4914,
4921,
4900,
4948,
4947,
4946,
4949,
4945,
]

_charnames_6272 = [
4874,
4890,
4870,
4891,
4886,
4895,
4866,
4873,
4885,
4893,
4884,
4894,
4865,
4864,
4872,
4883,
4867,
4869,
4881,
4880,
4892,
4877,
4878,
4875,
4828,
4827,
4943,
4941,
4939,
4942,
4932,
4936,
4933,
4935,
4940,
4938,
4929,
4930,
4889,
4888,
4944,
4871,
]

_charnames_6400 = [
7122,
7069,
7068,
7075,
7074,
7065,
7081,
7080,
7072,
7071,
7057,
7060,
7059,
7078,
7077,
7066,
7063,
7062,
7084,
7083,
7087,
7056,
7086,
7088,
7085,
7054,
7053,
7055,
7089,
-1,
-1,
-1,
7113,
7121,
7120,
7119,
7115,
7117,
7114,
7118,
7116,
7108,
7110,
7109,
-1,
-1,
-1,
-1,
7100,
7093,
7101,
7095,
7094,
7097,
7098,
7096,
7099,
7104,
7106,
7103,
-1,
-1,
-1,
-1,
7105,
-1,
-1,
-1,
7138,
7137,
7133,
7134,
7125,
7126,
7131,
7132,
7128,
7129,
7136,
7135,
13779,
13781,
13775,
13758,
13783,
13780,
13760,
13759,
13786,
13771,
13770,
13785,
13789,
13782,
13788,
13784,
13778,
13757,
13776,
13764,
13787,
13763,
13762,
13767,
13773,
13772,
13768,
13761,
13765,
13766,
-1,
-1,
13755,
13754,
13753,
13752,
13751,
]

_charnames_6528 = [
20037,
20010,
20033,
20024,
20029,
20006,
19997,
20002,
20019,
20036,
20034,
19992,
20009,
20007,
20021,
20020,
20030,
19994,
19993,
20003,
20027,
20026,
20038,
20000,
19999,
20011,
20041,
20035,
20039,
20014,
20008,
20012,
20040,
20042,
20043,
20013,
20015,
20016,
20032,
20023,
20005,
19996,
-1,
-1,
-1,
-1,
-1,
-1,
20070,
20063,
20069,
20053,
20057,
20071,
20066,
20058,
20059,
20054,
20065,
20064,
20056,
20061,
20060,
20055,
20068,
20047,
20046,
20045,
20048,
20049,
20050,
20051,
20088,
20087,
-1,
-1,
-1,
-1,
-1,
-1,
20082,
20083,
20074,
20075,
20080,
20081,
20077,
20078,
20085,
20084,
-1,
-1,
-1,
-1,
20089,
20090,
17081,
17128,
17080,
17125,
17122,
17077,
17074,
17071,
17068,
17065,
17103,
17100,
17090,
17097,
17094,
17087,
17129,
17127,
17079,
17124,
17121,
17076,
17073,
17070,
17067,
17064,
17102,
17099,
17089,
17096,
17093,
17086,
11833,
11836,
11820,
11819,
11831,
11839,
11825,
11824,
11828,
11837,
11822,
11821,
11838,
11834,
11817,
11816,
11826,
11830,
11832,
11827,
11829,
11840,
11835,
11844,
11842,
11845,
11843,
11846,
-1,
-1,
11847,
11848,
]

_charnames_7424 = [
6641,
6642,
5578,
6640,
6655,
6654,
6630,
6628,
5580,
5589,
6652,
6651,
6634,
6650,
6627,
6620,
6622,
5844,
5845,
5846,
5581,
6621,
5616,
6086,
6648,
6626,
6632,
6631,
6647,
5847,
5849,
5848,
6646,
6645,
6643,
6629,
6676,
6673,
12455,
12454,
12452,
12453,
12451,
2333,
4675,
4676,
4673,
4674,
4690,
4689,
4670,
4688,
4687,
4686,
4685,
4684,
4683,
4682,
4681,
4669,
4671,
4672,
4680,
4667,
4679,
4678,
4677,
4640,
4574,
4641,
4576,
4614,
4637,
4604,
4601,
4632,
4582,
4609,
4583,
4662,
4650,
4608,
4629,
4631,
4585,
4615,
4645,
4572,
4622,
4602,
4579,
4643,
4642,
4616,
4612,
4639,
4611,
4596,
6176,
6174,
6172,
6171,
12110,
12108,
12106,
12107,
12109,
5824,
6083,
5875,
6131,
6125,
5988,
6114,
5934,
5928,
5841,
5608,
6007,
5590,
4705,
5969,
5619,
6168,
5968,
6112,
6167,
5823,
6082,
5874,
6130,
6068,
6093,
5906,
6124,
5987,
6113,
5933,
5840,
5725,
6138,
6146,
6006,
5763,
5776,
5869,
5706,
5675,
5940,
5853,
5959,
5673,
5724,
5813,
5720,
4575,
4588,
4597,
4606,
4627,
4663,
4638,
4600,
4584,
4656,
4655,
4590,
4592,
4653,
4635,
4636,
4595,
4651,
4580,
4649,
4648,
4594,
4617,
4646,
4603,
4607,
4587,
4624,
4623,
4593,
4644,
4581,
4618,
4620,
4621,
4605,
4586,
2483,
2484,
2584,
2582,
]

_charnames_7680 = [
6267,
5761,
6582,
6079,
6581,
6078,
6584,
6084,
6551,
6048,
6440,
5872,
6439,
5871,
6442,
5876,
6436,
5863,
6435,
5862,
6347,
5702,
6348,
5703,
6334,
5689,
6350,
5705,
6336,
5691,
6609,
6133,
6499,
6069,
6526,
6032,
6525,
6031,
6527,
6033,
6530,
6036,
6533,
6041,
6375,
5954,
6373,
5952,
6577,
6097,
6576,
6096,
6574,
6094,
6455,
5899,
6456,
5900,
6458,
5907,
6449,
5893,
6601,
6127,
6600,
6123,
6599,
6122,
6422,
5984,
6421,
5983,
6414,
5980,
6417,
5975,
6217,
5658,
6216,
5657,
6221,
5661,
6222,
5662,
6595,
6117,
6594,
6116,
6512,
5922,
6510,
5920,
6511,
5921,
6517,
5926,
6488,
5836,
6486,
5834,
6490,
5838,
6481,
5829,
6487,
5835,
6398,
5603,
6397,
5602,
6402,
5609,
6392,
5597,
6291,
5788,
6308,
5805,
6312,
5809,
6309,
5806,
6315,
5815,
6588,
6137,
6590,
6140,
6565,
6107,
6567,
6109,
6564,
6105,
6563,
6104,
6562,
6103,
6604,
6144,
6605,
6145,
6467,
6016,
6541,
5997,
6538,
6003,
6544,
6008,
6039,
5604,
6106,
6021,
5762,
5910,
-1,
-1,
-1,
-1,
6253,
5745,
6273,
5768,
6246,
5738,
6244,
5736,
6243,
5735,
6242,
5734,
6245,
5737,
6263,
5755,
6261,
5753,
6260,
5752,
6259,
5751,
6262,
5754,
6341,
5696,
6353,
5709,
6349,
5704,
6333,
5688,
6331,
5686,
6330,
5685,
6329,
5684,
6332,
5687,
6383,
5963,
6369,
5950,
6198,
5639,
6192,
5633,
6211,
5652,
6209,
5650,
6208,
5649,
6207,
5648,
6210,
5651,
6191,
5632,
6189,
5630,
6188,
5629,
6187,
5628,
6190,
5631,
6296,
5793,
6305,
5802,
6304,
5801,
6302,
5799,
6301,
5798,
6300,
5797,
6303,
5800,
6473,
6023,
6466,
6015,
6470,
6019,
6471,
6020,
-1,
-1,
-1,
-1,
-1,
-1,
11988,
11999,
11990,
12001,
11994,
12005,
11992,
12003,
12199,
12210,
12205,
12216,
12207,
12218,
12202,
12213,
11973,
11977,
11975,
11979,
11976,
11980,
-1,
-1,
12185,
12189,
12187,
12191,
12188,
12192,
-1,
-1,
11945,
11956,
11947,
11958,
11951,
11962,
11949,
11960,
12159,
12170,
12165,
12176,
12167,
12178,
12162,
12173,
12060,
12054,
12062,
12056,
12064,
12058,
12063,
12057,
12235,
12229,
12237,
12231,
12239,
12233,
12238,
12232,
11930,
11934,
11932,
11936,
11933,
11937,
-1,
-1,
12144,
12148,
12146,
12150,
12147,
12151,
-1,
-1,
12033,
12027,
12035,
12029,
12037,
12031,
12036,
12030,
-1,
12249,
-1,
12251,
-1,
12253,
-1,
12252,
11902,
11913,
11904,
11915,
11908,
11919,
11906,
11917,
12118,
12129,
12124,
12135,
12126,
12137,
12121,
12132,
12009,
12012,
11981,
11983,
11965,
11967,
12068,
12070,
11938,
11940,
12041,
12043,
11922,
11924,
-1,
-1,
11996,
12007,
11991,
12002,
11995,
12006,
11993,
12004,
12204,
12215,
12206,
12217,
12208,
12219,
12203,
12214,
11953,
11964,
11948,
11959,
11952,
11963,
11950,
11961,
12164,
12175,
12166,
12177,
12168,
12179,
12163,
12174,
11910,
11921,
11905,
11916,
11909,
11920,
11907,
11918,
12123,
12134,
12125,
12136,
12127,
12138,
12122,
12133,
12011,
12016,
12010,
12014,
12013,
-1,
11997,
11998,
12221,
12225,
12222,
12224,
12209,
12513,
12498,
12493,
12501,
12471,
11966,
11969,
11968,
-1,
11954,
11955,
12193,
12195,
12180,
12182,
12169,
12495,
12497,
12496,
12067,
12071,
12050,
12053,
-1,
-1,
12065,
12052,
12241,
12245,
12242,
12244,
-1,
12476,
12478,
12477,
12040,
12044,
12023,
12026,
12081,
12082,
12038,
12025,
12256,
12260,
12257,
12259,
12273,
12470,
12472,
12445,
-1,
-1,
11923,
11926,
11925,
-1,
11911,
11912,
12152,
12154,
12139,
12141,
12128,
12505,
12474,
-1,
18010,
17981,
18009,
17980,
14235,
20623,
16123,
20632,
19984,
14244,
14977,
21007,
21005,
21008,
7339,
19115,
15450,
20194,
20633,
18011,
17982,
15440,
18350,
18339,
7168,
18950,
16105,
16108,
7243,
19000,
18338,
18374,
18612,
18369,
11874,
14283,
19682,
14299,
15439,
15451,
7048,
19842,
7340,
19116,
19974,
7338,
19114,
20243,
19957,
19955,
19925,
18353,
14254,
19247,
19240,
19238,
1993,
16106,
16107,
19275,
18375,
20428,
19681,
20812,
3315,
1994,
9337,
15453,
20643,
7160,
18945,
18372,
20979,
17953,
13486,
19248,
11758,
11745,
7419,
19244,
3328,
14302,
2642,
16494,
20449,
20649,
14227,
20972,
20617,
20634,
14298,
20618,
18481,
14284,
18899,
5505,
20947,
20611,
20458,
20459,
-1,
-1,
-1,
-1,
-1,
-1,
20470,
9346,
20471,
9347,
20242,
20195,
16144,
16130,
-1,
-1,
16139,
16140,
16136,
16137,
16143,
16148,
16146,
16149,
16142,
16131,
16145,
16129,
16187,
16190,
16176,
16177,
16182,
16183,
16179,
16180,
16186,
16191,
16189,
16192,
16185,
16193,
16188,
-1,
6178,
6177,
6175,
6170,
6173,
]

_charnames_8352 = [
18017,
2848,
3366,
20645,
7147,
5558,
20245,
19965,
19230,
20948,
20091,
18492,
18018,
17366,
14331,
18615,
12967,
19964,
12798,
9355,
15456,
3359,
]

_charnames_8400 = [
2436,
2525,
2447,
2581,
2568,
2507,
2428,
2520,
2528,
2506,
2567,
2593,
2635,
2558,
2556,
2562,
2559,
2439,
2557,
2561,
2560,
2534,
2460,
2569,
2592,
2638,
2441,
2448,
]

_charnames_8448 = [
9348,
9354,
18388,
18302,
3355,
1995,
1999,
18019,
16440,
18301,
16438,
16431,
11804,
18386,
19949,
19950,
16430,
11803,
16429,
16437,
7465,
18385,
20240,
16416,
16427,
18380,
18384,
16426,
11802,
18383,
19899,
19272,
16466,
13902,
14287,
18904,
18382,
19675,
19683,
20451,
11801,
14329,
17364,
9317,
16434,
11805,
18026,
16439,
16433,
16432,
14330,
16428,
16436,
9331,
11705,
13133,
18611,
20463,
19309,
20657,
18397,
18398,
18387,
18381,
18399,
14324,
14323,
19245,
14322,
18395,
18394,
18393,
18392,
18391,
19921,
14327,
19956,
-1,
-1,
-1,
-1,
-1,
-1,
18908,
18920,
18912,
18921,
18917,
18926,
18909,
18924,
18913,
18918,
18925,
18927,
20644,
19293,
19280,
19284,
19292,
19287,
19299,
19300,
19303,
19305,
19282,
19302,
19281,
19291,
19297,
19290,
19295,
16335,
16325,
16327,
16334,
16331,
16340,
16341,
16344,
16345,
16328,
16343,
16326,
16333,
16338,
16332,
16337,
19296,
19289,
19283,
19304,
]

_charnames_8592 = [
7264,
20665,
19024,
18417,
7172,
20714,
20135,
20149,
16399,
16409,
7273,
19039,
7331,
19108,
7328,
20704,
19090,
18445,
7271,
19028,
7286,
20675,
19053,
18428,
20715,
7276,
19042,
7275,
19041,
7185,
7176,
18450,
20670,
20669,
18422,
18421,
19043,
18425,
9308,
3333,
20138,
7281,
9309,
3334,
7304,
7311,
20690,
20685,
19068,
19075,
18443,
18438,
19055,
20674,
7291,
7333,
20710,
19110,
18453,
7312,
19076,
7319,
7182,
19100,
7315,
20707,
19096,
18448,
7179,
20717,
20145,
20158,
16406,
16414,
7327,
19093,
7332,
19109,
20672,
18424,
7323,
20708,
19104,
18449,
7280,
19047,
7330,
20692,
19106,
18451,
20698,
20694,
20697,
20696,
20699,
20700,
19107,
20139,
16402,
20716,
18966,
18427,
14229,
7272,
19038,
7175,
7277,
19036,
7177,
7334,
19111,
7186,
20629,
2647,
19846,
14239,
14240,
17972,
20466,
20246,
17957,
20169,
16352,
2840,
18472,
16364,
18014,
20218,
20203,
20212,
5544,
5553,
18488,
18590,
16464,
9336,
19126,
11875,
15642,
3348,
20622,
19920,
20461,
18954,
9313,
5508,
16480,
18593,
18475,
19839,
20184,
7453,
7442,
20412,
20799,
20431,
18366,
14264,
2841,
16234,
18932,
3335,
3331,
9306,
14241,
11710,
19318,
19919,
18490,
17955,
12965,
15447,
13477,
19236,
20452,
16109,
20945,
20178,
5552,
9338,
20168,
9217,
9220,
20127,
9323,
20170,
9325,
14262,
9327,
17934,
12963,
18604,
9221,
12964,
9218,
20474,
2849,
17921,
19127,
19128,
2853,
18025,
17935,
16449,
18303,
17929,
5525,
20980,
20183,
20406,
20186,
16455,
7358,
12548,
7361,
12553,
7383,
12574,
5377,
5378,
11704,
20182,
20185,
20187,
20116,
20121,
7357,
12547,
20115,
20120,
7359,
12549,
20117,
20122,
19900,
16214,
19913,
16227,
19912,
16226,
18466,
18473,
16195,
16151,
20167,
20166,
16202,
16158,
20126,
20125,
16204,
16160,
5371,
5374,
5373,
15702,
15725,
15705,
15728,
15651,
15653,
3170,
3184,
3178,
3164,
3166,
3180,
3186,
3191,
3167,
15759,
15760,
15757,
15762,
18993,
7207,
18456,
20730,
9339,
4819,
14288,
20628,
14250,
18347,
18468,
20177,
18477,
20111,
19914,
16228,
20160,
2838,
20161,
2839,
19432,
20473,
5375,
15319,
20430,
21014,
20244,
20131,
18958,
18989,
20215,
20214,
20219,
20204,
18597,
18489,
16447,
18592,
11573,
7260,
19021,
7166,
18951,
19237,
3343,
3344,
18329,
18327,
18365,
18363,
19976,
17930,
7377,
12569,
18902,
18903,
7385,
12579,
17927,
17928,
17926,
17925,
18467,
18474,
20174,
20173,
15704,
15727,
7382,
12573,
19915,
16229,
20179,
18470,
20180,
18471,
18900,
5556,
20732,
18458,
17964,
17960,
16354,
17965,
17963,
16355,
17961,
17962,
2836,
2834,
16362,
2835,
16363,
21002,
18598,
17969,
15442,
20727,
18460,
19922,
19960,
20935,
7215,
18986,
7255,
19014,
11566,
11569,
14311,
14314,
19252,
15734,
9113,
16467,
16462,
13903,
19972,
18930,
19951,
14328,
20941,
15443,
14315,
14312,
11570,
11567,
14317,
11571,
20640,
16394,
20728,
19653,
17994,
21015,
17363,
7344,
19120,
17995,
11702,
2404,
9328,
15986,
14318,
18603,
2844,
16478,
2852,
2851,
9195,
9189,
9143,
9124,
9125,
9141,
9136,
9169,
9172,
9190,
9213,
9137,
9144,
9132,
9142,
9202,
9197,
9133,
9138,
9174,
9152,
9164,
9122,
9127,
9153,
9184,
9129,
9179,
9160,
9130,
9126,
9180,
9156,
9121,
9146,
9163,
9165,
9205,
9171,
9182,
9147,
9170,
9135,
9181,
9161,
9188,
9206,
9173,
9154,
9203,
9210,
9211,
9175,
9159,
9209,
9187,
9191,
9140,
9139,
9155,
9183,
9193,
9198,
9199,
9208,
9212,
9194,
9200,
9207,
20188,
18957,
16315,
11709,
18883,
20472,
2842,
18601,
17978,
2646,
20837,
18013,
9332,
15320,
3145,
3177,
10918,
20811,
5022,
15455,
19651,
19650,
19851,
19850,
18602,
16420,
9117,
18304,
19916,
20128,
19924,
3338,
7237,
7239,
7238,
19004,
19006,
19005,
7161,
7163,
7162,
18946,
18948,
18947,
7211,
7212,
7213,
3345,
18982,
18983,
18984,
20445,
15438,
20745,
20740,
16232,
16233,
14316,
11563,
11564,
19317,
7259,
19019,
15436,
15435,
15434,
15433,
18280,
18283,
18288,
18298,
18293,
18287,
18297,
18292,
18285,
18296,
18291,
18294,
18289,
18281,
18284,
15749,
19271,
18027,
18884,
5538,
5535,
5536,
5534,
5529,
5530,
5531,
5532,
5537,
18022,
20612,
]

_charnames_9216 = [
15969,
15938,
15937,
15961,
15959,
15963,
15985,
15977,
15978,
15983,
15982,
15979,
15971,
15974,
15940,
15941,
15954,
15950,
15948,
15949,
15951,
15968,
15942,
15960,
15975,
15962,
15934,
15964,
15972,
15984,
15981,
15980,
15943,
15952,
11810,
19647,
15967,
15953,
15935,
]

_charnames_9280 = [
19667,
19665,
19668,
19666,
19659,
19658,
19657,
19669,
19662,
19664,
19661,
]

_charnames_9312 = [
3160,
3151,
3152,
3157,
3158,
3154,
3155,
3162,
3161,
3081,
3106,
3064,
3080,
3098,
3101,
3103,
3104,
3107,
3108,
3050,
19828,
19820,
19821,
19826,
19827,
19823,
19824,
19830,
19829,
19807,
19815,
19805,
19806,
19812,
19813,
19809,
19810,
19816,
19817,
19804,
18559,
18545,
18547,
18555,
18557,
18550,
18552,
18563,
18561,
20227,
20237,
20225,
20226,
20234,
20235,
20230,
20232,
20238,
20239,
20224,
19800,
19799,
19798,
19797,
19796,
19795,
19794,
19793,
19792,
19791,
19790,
19789,
19788,
19787,
19786,
19785,
19784,
19783,
19782,
19781,
19780,
19779,
19778,
19777,
19776,
19775,
2913,
2912,
2911,
2910,
2909,
2908,
2907,
2906,
2905,
2904,
2903,
2902,
2901,
2900,
2899,
2898,
2897,
2896,
2895,
2894,
2893,
2892,
2891,
2890,
2889,
2888,
2886,
2885,
2884,
2883,
2882,
2881,
2880,
2879,
2878,
2877,
2876,
2875,
2874,
2873,
2872,
2871,
2870,
2869,
2868,
2867,
2866,
2865,
2864,
2863,
2862,
2861,
3159,
20107,
20098,
20099,
20104,
20105,
20101,
20102,
20108,
20109,
20097,
18320,
18312,
18313,
18318,
18319,
18315,
18316,
18322,
18321,
18323,
20110,
11352,
11438,
11331,
11424,
11345,
11431,
11344,
11430,
11348,
11434,
11347,
11433,
11313,
11369,
11378,
11411,
11314,
11372,
11381,
11412,
11329,
11442,
11451,
11422,
11330,
11445,
11454,
11421,
11333,
11472,
11452,
11377,
11476,
11368,
11443,
11426,
11334,
11473,
11455,
11380,
11477,
11371,
11446,
11427,
11315,
11361,
11491,
11374,
11383,
11487,
11357,
11413,
11327,
11360,
11490,
11447,
11456,
11486,
11356,
11423,
11335,
11359,
11489,
11474,
11457,
11382,
11478,
11362,
11492,
11363,
11493,
11373,
11448,
11485,
11355,
11428,
11318,
11416,
11317,
11415,
11406,
11393,
11385,
11389,
11403,
11386,
11390,
11404,
11459,
11463,
11399,
11460,
11464,
11400,
11468,
11480,
11395,
11469,
11481,
11396,
11387,
11391,
11405,
11461,
11465,
11401,
11470,
11482,
11397,
11341,
11342,
11339,
11338,
11321,
11322,
11323,
11349,
11324,
11351,
11311,
11435,
11417,
11437,
11409,
11350,
11328,
11436,
11420,
20750,
7412,
7411,
7409,
7406,
7414,
7408,
7413,
20608,
7165,
7204,
7253,
7257,
7205,
7248,
7249,
19011,
7143,
5499,
18610,
20751,
19009,
20970,
20969,
20957,
20964,
20963,
20961,
20960,
20965,
20966,
20967,
11736,
20822,
20834,
20838,
15588,
15584,
15587,
15578,
15580,
15589,
11733,
20841,
11751,
20892,
11794,
20912,
11796,
20923,
11780,
20895,
11781,
20897,
11747,
20888,
11748,
20889,
11749,
20890,
11772,
20882,
11773,
20883,
11755,
20901,
11756,
20902,
11757,
20903,
11766,
20875,
20879,
20635,
7463,
20849,
18482,
3204,
11876,
11723,
3203,
3206,
3202,
3197,
3196,
3208,
7258,
19012,
20456,
20455,
20748,
7404,
20744,
20738,
7395,
7402,
20749,
7405,
11762,
11763,
11778,
11777,
20925,
15583,
15586,
15579,
15582,
20836,
20896,
20755,
20754,
6775,
20832,
20828,
20827,
20831,
20853,
20856,
20855,
20852,
20743,
20736,
7400,
20918,
11789,
20919,
11790,
7394,
11734,
3337,
20814,
16492,
2648,
11735,
20843,
7146,
14243,
16235,
9340,
18275,
2843,
19654,
11795,
20916,
11880,
11883,
11882,
16489,
20815,
15446,
20845,
11738,
16304,
19251,
11759,
11750,
20904,
20898,
20891,
20884,
16495,
2000,
19316,
11891,
1998,
9318,
19436,
3314,
3363,
3364,
16450,
20656,
9353,
14975,
19967,
10655,
14273,
14272,
14274,
14270,
14268,
14269,
14271,
14275,
20929,
20909,
20840,
11732,
20842,
20636,
6778,
5539,
20660,
18021,
4559,
21010,
16488,
20816,
20129,
19947,
9112,
13790,
12968,
1989,
7386,
18929,
7148,
16441,
16490,
2001,
9357,
19978,
20864,
20866,
20865,
20868,
20863,
20867,
11718,
11720,
11719,
11722,
11717,
11721,
11737,
20922,
20878,
11728,
20844,
11793,
11769,
20873,
15445,
20975,
18006,
11708,
11707,
5357,
5356,
5355,
20950,
18023,
20809,
19268,
19267,
19266,
19265,
19264,
19263,
19262,
19269,
11782,
19270,
19845,
19961,
20928,
18585,
18584,
18583,
18582,
18581,
18580,
20859,
20860,
11725,
11726,
5020,
5019,
18578,
18571,
18572,
18577,
20908,
11786,
14976,
9320,
3365,
16453,
16442,
9330,
20648,
12969,
16452,
9356,
20651,
-1,
-1,
-1,
20942,
15429,
18413,
18412,
20427,
4560,
4557,
4558,
18897,
15437,
5503,
5506,
5498,
4565,
18594,
20813,
2854,
20610,
]

_charnames_9985 = [
20752,
11739,
7415,
20847,
-1,
13904,
13791,
9358,
18012,
-1,
-1,
18931,
20944,
7396,
19966,
20739,
20924,
11797,
3313,
15303,
5370,
15314,
11884,
15264,
19673,
15316,
19641,
15310,
6616,
16302,
19672,
4561,
16448,
20619,
20621,
15317,
20620,
11787,
20910,
-1,
16456,
3174,
19642,
11729,
19674,
15309,
19979,
16301,
15318,
19643,
18005,
18002,
18001,
16120,
18000,
15293,
14303,
16122,
14024,
19640,
15269,
16121,
11785,
20907,
18003,
3189,
15268,
16493,
13488,
15302,
16485,
15276,
11885,
18004,
15292,
-1,
16303,
-1,
7397,
20741,
7392,
20737,
-1,
-1,
-1,
11770,
-1,
7142,
5504,
15311,
15274,
15275,
15297,
15298,
-1,
-1,
3346,
15294,
15315,
15263,
19307,
20650,
19308,
5494,
5489,
5502,
5501,
5496,
5491,
15287,
15281,
15288,
15282,
7145,
7144,
5495,
5490,
18522,
18514,
18515,
18520,
18521,
18517,
18518,
18524,
18523,
18525,
18537,
18529,
18530,
18535,
18536,
18532,
18533,
18539,
18538,
18540,
18508,
18500,
18501,
18506,
18507,
18503,
18504,
18510,
18509,
18511,
15306,
-1,
-1,
-1,
15277,
15283,
15313,
18614,
15284,
14282,
15271,
18607,
15299,
11743,
14233,
14234,
11744,
15262,
15261,
15764,
15304,
19123,
7347,
11886,
20641,
15289,
15312,
20191,
-1,
20190,
3146,
20926,
11807,
11808,
11809,
15256,
15257,
15258,
14025,
15270,
20951,
15307,
19652,
-1,
14228,
20915,
19958,
19646,
19645,
7169,
18952,
]

_charnames_10192 = [
20877,
9319,
17967,
7398,
20746,
7250,
19008,
20607,
6771,
6774,
7233,
7232,
7261,
7439,
7431,
20731,
7464,
20869,
20872,
20871,
20829,
20835,
4446,
4442,
4448,
4444,
4447,
4443,
-1,
-1,
-1,
-1,
20709,
18452,
9311,
3336,
18967,
7425,
7436,
7430,
7423,
7434,
7429,
7426,
7437,
7424,
7435,
7438,
10916,
10661,
10789,
10662,
10853,
10726,
10790,
10663,
10885,
10758,
10822,
10695,
10854,
10727,
10791,
10664,
10901,
10774,
10838,
10711,
10870,
10743,
10807,
10680,
10886,
10759,
10823,
10696,
10855,
10728,
10792,
10665,
10909,
10782,
10846,
10719,
10878,
10751,
10815,
10688,
10894,
10767,
10831,
10704,
10863,
10736,
10800,
10673,
10902,
10775,
10839,
10712,
10871,
10744,
10808,
10681,
10887,
10760,
10824,
10697,
10856,
10729,
10793,
10666,
10913,
10786,
10850,
10723,
10882,
10755,
10819,
10692,
10898,
10771,
10835,
10708,
10867,
10740,
10804,
10677,
10906,
10779,
10843,
10716,
10875,
10748,
10812,
10685,
10891,
10764,
10828,
10701,
10860,
10733,
10797,
10670,
10910,
10783,
10847,
10720,
10879,
10752,
10816,
10689,
10895,
10768,
10832,
10705,
10864,
10737,
10801,
10674,
10903,
10776,
10840,
10713,
10872,
10745,
10809,
10682,
10888,
10761,
10825,
10698,
10857,
10730,
10794,
10667,
10915,
10788,
10852,
10725,
10884,
10757,
10821,
10694,
10900,
10773,
10837,
10710,
10869,
10742,
10806,
10679,
10908,
10781,
10845,
10718,
10877,
10750,
10814,
10687,
10893,
10766,
10830,
10703,
10862,
10735,
10799,
10672,
10912,
10785,
10849,
10722,
10881,
10754,
10818,
10691,
10897,
10770,
10834,
10707,
10866,
10739,
10803,
10676,
10905,
10778,
10842,
10715,
10874,
10747,
10811,
10684,
10890,
10763,
10827,
10700,
10859,
10732,
10796,
10669,
10914,
10787,
10851,
10724,
10883,
10756,
10820,
10693,
10899,
10772,
10836,
10709,
10868,
10741,
10805,
10678,
10907,
10780,
10844,
10717,
10876,
10749,
10813,
10686,
10892,
10765,
10829,
10702,
10861,
10734,
10798,
10671,
10911,
10784,
10848,
10721,
10880,
10753,
10817,
10690,
10896,
10769,
10833,
10706,
10865,
10738,
10802,
10675,
10904,
10777,
10841,
10714,
10873,
10746,
10810,
10683,
10889,
10762,
10826,
10699,
10858,
10731,
10795,
10668,
19086,
19087,
7318,
19099,
7181,
19088,
7320,
19101,
18423,
20671,
20705,
18446,
7322,
19103,
7326,
19092,
19089,
19037,
20673,
18426,
19030,
19031,
19082,
19084,
19085,
7292,
19056,
7321,
19102,
7282,
19046,
7287,
19054,
20143,
20156,
20140,
20154,
16401,
16411,
20142,
20155,
16404,
16412,
19132,
20654,
16403,
20152,
20655,
19131,
20153,
20141,
20940,
9107,
9108,
9111,
9110,
19122,
7346,
14307,
11572,
14309,
14308,
7393,
7401,
9307,
3332,
19051,
7290,
16313,
19040,
7274,
19048,
7178,
20703,
7220,
7222,
20722,
20724,
7219,
20721,
7223,
20725,
7302,
19066,
20688,
18441,
7307,
19071,
20683,
18436,
7303,
19067,
20689,
18442,
7308,
19072,
20684,
18437,
7300,
20681,
19065,
18435,
7301,
7310,
19064,
19074,
7299,
7309,
19063,
19073,
20682,
18434,
18997,
17912,
13482,
7289,
19050,
19052,
7369,
7285,
12561,
16213,
7284,
16169,
7254,
19015,
20733,
18459,
14251,
20990,
21000,
7192,
18972,
7196,
18976,
20998,
20993,
20999,
20994,
7159,
18944,
7157,
18943,
7158,
18942,
7230,
18960,
7234,
18968,
18343,
18371,
7225,
19017,
18486,
18896,
5523,
18961,
5524,
9316,
9343,
16483,
16482,
14326,
19249,
9315,
19250,
19678,
19679,
5512,
5513,
5521,
5522,
5515,
5518,
5516,
5519,
19254,
17976,
17974,
17975,
17977,
3207,
3188,
3172,
3181,
3171,
3209,
3199,
3187,
20729,
3175,
3192,
2914,
3190,
3200,
3205,
15758,
15761,
15763,
15756,
15755,
14300,
14281,
14279,
16496,
14280,
18990,
7201,
18895,
11576,
11575,
11798,
13485,
13484,
20921,
11792,
7198,
18978,
7242,
18999,
20468,
13489,
20462,
18410,
15590,
20467,
16316,
17914,
17915,
20407,
13098,
14242,
18463,
18462,
11768,
11764,
20858,
11727,
17986,
17990,
17987,
17991,
17988,
17992,
19231,
19258,
16418,
19257,
11889,
11890,
18356,
14255,
7343,
19119,
13487,
5554,
20202,
20201,
20200,
20207,
20206,
20211,
20210,
14293,
14292,
20217,
4818,
16231,
20973,
20637,
20441,
20443,
3212,
9310,
7046,
7045,
7047,
20444,
20974,
20439,
20437,
20440,
20435,
20438,
20436,
21011,
6773,
20989,
20988,
20987,
19937,
19939,
19934,
19938,
19933,
19936,
19940,
5550,
5549,
5548,
5547,
19944,
19943,
18905,
5369,
5368,
16459,
16393,
5365,
5364,
3183,
5366,
3165,
19942,
5551,
5363,
20429,
19124,
20995,
9351,
20417,
20803,
20802,
20415,
20416,
20804,
20806,
20419,
20807,
20420,
20808,
20421,
3325,
3327,
18332,
18331,
3326,
7459,
7449,
18342,
18341,
14296,
14295,
16476,
16477,
7452,
7461,
7450,
7462,
7451,
7458,
7460,
7457,
16381,
7448,
7447,
21001,
20996,
17918,
20408,
14261,
14260,
13481,
13480,
16117,
2845,
17920,
9324,
9219,
17913,
19945,
17911,
18324,
14301,
14230,
17917,
17933,
7378,
12570,
7376,
12568,
7351,
12541,
7355,
12545,
7353,
12543,
7354,
12544,
7360,
12550,
7373,
12565,
7374,
12566,
7371,
12563,
7366,
12558,
7367,
12559,
7370,
12562,
7368,
12560,
16470,
16472,
16471,
16473,
18408,
18409,
18403,
18404,
16112,
16113,
16115,
16116,
18358,
18360,
18359,
12552,
12575,
7379,
12576,
7380,
12577,
16391,
6776,
16392,
6777,
17919,
19905,
16219,
19904,
16218,
19909,
16223,
19907,
16221,
19910,
16224,
19908,
16222,
18355,
18328,
16208,
16164,
16206,
16162,
16207,
16163,
16203,
16159,
16200,
16156,
16198,
16154,
16201,
16157,
16199,
16155,
15739,
15632,
3323,
3321,
3324,
3322,
16211,
16168,
16212,
16167,
16171,
16172,
17968,
19977,
14286,
20626,
20193,
16314,
16311,
16307,
19959,
18893,
18349,
18894,
18348,
7440,
16312,
16309,
16310,
18368,
18362,
18333,
19242,
18476,
18882,
18881,
18457,
19838,
19837,
14252,
14249,
14265,
14257,
14258,
18405,
18406,
14263,
6772,
18334,
20913,
20216,
20157,
20144,
16405,
16413,
7184,
7335,
20711,
18454,
20159,
20146,
16407,
16415,
7187,
20718,
19034,
19033,
7270,
7269,
15585,
15591,
]

_charnames_11264 = [
13097,
13086,
13088,
13095,
13068,
13050,
13071,
13067,
13072,
13057,
13061,
13054,
13069,
13093,
13080,
13092,
13091,
13078,
13074,
13090,
13044,
13063,
13089,
13083,
13094,
13077,
13075,
13038,
13064,
13096,
13040,
13048,
13049,
13053,
13043,
13051,
13041,
13042,
13052,
13059,
13087,
13060,
13084,
13056,
13039,
13065,
13081,
-1,
13034,
13023,
13025,
13032,
13005,
12987,
13008,
13004,
13009,
12994,
12998,
12991,
13006,
13030,
13017,
13029,
13028,
13015,
13011,
13027,
12981,
13000,
13026,
13020,
13031,
13014,
13012,
12975,
13001,
13033,
12977,
12985,
12986,
12990,
12980,
12988,
12978,
12979,
12989,
12996,
13024,
12997,
13021,
12993,
12976,
13002,
13018,
]

_charnames_11392 = [
2810,
2721,
2813,
2724,
2805,
2716,
2772,
2683,
2819,
2730,
2777,
2688,
2812,
2723,
2802,
2713,
2792,
2703,
2818,
2729,
2785,
2696,
2798,
2709,
2817,
2728,
2816,
2727,
2784,
2695,
2742,
2653,
2796,
2707,
2815,
2726,
2778,
2689,
2793,
2704,
2814,
2725,
2807,
2718,
2782,
2693,
2795,
2706,
2764,
2675,
2770,
2681,
2757,
2668,
2789,
2700,
2768,
2679,
2767,
2678,
2788,
2699,
2753,
2664,
2779,
2690,
2790,
2701,
2752,
2663,
2755,
2666,
2811,
2722,
2769,
2680,
2748,
2659,
2746,
2657,
2799,
2710,
2749,
2660,
2747,
2658,
2754,
2665,
2756,
2667,
2751,
2662,
2763,
2674,
2761,
2672,
2760,
2671,
2762,
2673,
2737,
2740,
2739,
2733,
2738,
2736,
2734,
]

_charnames_11513 = [
2823,
2824,
2822,
2821,
2827,
2826,
2828,
12909,
12908,
12894,
12907,
12906,
12897,
12876,
12879,
12905,
12888,
12904,
12903,
12902,
12901,
12885,
12875,
12899,
12882,
12878,
12898,
12884,
12887,
12893,
12900,
12881,
12870,
12873,
12890,
12872,
12871,
12895,
12891,
12864,
12867,
12866,
12896,
12863,
12865,
]

_charnames_11568 = [
13416,
13440,
13441,
13433,
13435,
13470,
13450,
13417,
13420,
13418,
13419,
13456,
13451,
13430,
13459,
13432,
13438,
13471,
13467,
13439,
13453,
13431,
13460,
13445,
13465,
13455,
13423,
13474,
13464,
13449,
13448,
13447,
13462,
13466,
13446,
13454,
13436,
13437,
13434,
13463,
13473,
13427,
13428,
13429,
13424,
13426,
13452,
13425,
13444,
13443,
13442,
13421,
13468,
13422,
]

_charnames_11648 = [
17804,
17755,
17793,
17454,
17421,
17784,
17490,
17600,
17702,
17693,
17388,
17659,
17722,
17713,
17814,
17463,
17591,
17621,
17633,
17376,
17378,
17375,
17374,
]

_charnames_11680 = [
17441,
17443,
17445,
17442,
17440,
17439,
17444,
-1,
17584,
17586,
17588,
17585,
17583,
17582,
17587,
-1,
17653,
17655,
17657,
17654,
17652,
17651,
17656,
-1,
17577,
17579,
17581,
17578,
17576,
17575,
17580,
-1,
17516,
17518,
17520,
17517,
17515,
17514,
17519,
-1,
17553,
17555,
17557,
17554,
17552,
17551,
17556,
-1,
17671,
17673,
17675,
17672,
17670,
17669,
17674,
-1,
17399,
17401,
17403,
17400,
17398,
17397,
17402,
]

_charnames_11776 = [
18962,
18963,
7167,
18949,
7245,
19001,
19313,
19314,
18483,
7202,
18991,
19312,
7188,
19020,
18028,
19841,
20627,
19253,
15454,
18485,
18429,
20676,
18484,
18373,
-1,
-1,
-1,
-1,
7262,
19022,
]

_charnames_11904 = [
1229,
1116,
1138,
1136,
1137,
1247,
1166,
1223,
1254,
1253,
1250,
1139,
1150,
1149,
1190,
1188,
1189,
1191,
1144,
1222,
1143,
1142,
1207,
1206,
1210,
1226,
-1,
1121,
1151,
1160,
1251,
1158,
1118,
1178,
1177,
1257,
1246,
1245,
1130,
1120,
1249,
1202,
1168,
1217,
1147,
1146,
1173,
1132,
1088,
1234,
1232,
1233,
1235,
1162,
1152,
1227,
1218,
1258,
1171,
1170,
1163,
1159,
1241,
1239,
1240,
1221,
1115,
1184,
1183,
1090,
1129,
1209,
1087,
1089,
1256,
1112,
1127,
1181,
1180,
1119,
1104,
1194,
1193,
1101,
1105,
1157,
1156,
1228,
1172,
1095,
1102,
1109,
1098,
1216,
1214,
1215,
1108,
1208,
1110,
1167,
1242,
1099,
1113,
1091,
1126,
1131,
1097,
1200,
1107,
1199,
1094,
1201,
1111,
1220,
1198,
1093,
]

_charnames_12032 = [
16777,
16706,
16556,
16535,
16530,
16725,
16610,
16708,
16697,
16703,
16740,
16744,
16560,
16644,
16796,
16609,
16776,
16805,
16770,
16667,
16516,
16748,
16731,
16621,
16569,
16531,
16653,
16769,
16786,
16686,
16741,
16735,
16546,
16758,
16760,
16738,
16596,
16670,
16659,
16755,
16795,
16552,
16712,
16645,
16515,
16684,
16747,
16669,
16778,
16614,
16572,
16521,
16559,
16710,
16611,
16523,
16580,
16551,
16587,
16508,
16728,
16718,
16562,
16719,
16588,
16752,
16545,
16570,
16784,
16549,
16789,
16548,
16538,
16690,
16604,
16713,
16504,
16577,
16679,
16564,
16646,
16638,
16651,
16509,
16664,
16625,
16650,
16629,
16561,
16717,
16536,
16630,
16643,
16563,
16768,
16802,
16695,
16619,
16547,
16707,
16804,
16627,
16582,
16543,
16558,
16675,
16553,
16568,
16742,
16514,
16782,
16506,
16517,
16605,
16763,
16655,
16510,
16598,
16749,
16542,
16801,
16791,
16526,
16640,
16779,
16785,
16771,
16734,
16586,
16696,
16692,
16528,
16783,
16688,
16617,
16775,
16584,
16505,
16647,
16762,
16620,
16794,
16591,
16663,
16652,
16678,
16529,
16724,
16513,
16799,
16600,
16772,
16599,
16525,
16756,
16754,
16639,
16583,
16657,
16594,
16689,
16662,
16658,
16672,
16567,
16798,
16759,
16709,
16765,
16685,
16534,
16522,
16753,
16590,
16666,
16631,
16701,
16607,
16704,
16550,
16702,
16673,
16636,
16736,
16729,
16634,
16723,
16581,
16608,
16720,
16626,
16540,
16656,
16764,
16624,
16595,
16539,
16576,
16676,
16730,
16803,
16693,
16592,
16743,
16633,
16603,
16573,
16751,
16790,
16737,
16616,
16574,
16613,
16637,
]

_charnames_12272 = [
20385,
20389,
20386,
20388,
20391,
20383,
20382,
20381,
20378,
20377,
20380,
20390,
-1,
-1,
-1,
-1,
20397,
20394,
20403,
18600,
21012,
20401,
20395,
20399,
7229,
18959,
7244,
18998,
7214,
18985,
7193,
18973,
7226,
19018,
19970,
12966,
7206,
18992,
7197,
18977,
7194,
18974,
7195,
18975,
20939,
19241,
18354,
7418,
19971,
14794,
14782,
14785,
14792,
14793,
14789,
14790,
14796,
14795,
20400,
20398,
20392,
20404,
14776,
14778,
20937,
18886,
18890,
18888,
18891,
18889,
3169,
20350,
14787,
14783,
14786,
18898,
4563,
19848,
20396,
20402,
-1,
15339,
15425,
15337,
15423,
15334,
15421,
15338,
15424,
15336,
15422,
15386,
15398,
15384,
15396,
15382,
15394,
15385,
15397,
15383,
15395,
15344,
15356,
15342,
15354,
15340,
15352,
15343,
15355,
15341,
15353,
15362,
15404,
15360,
15402,
15335,
15358,
15400,
15361,
15403,
15359,
15401,
15350,
15348,
15346,
15349,
15347,
15392,
15410,
15374,
15390,
15408,
15372,
15388,
15406,
15370,
15391,
15409,
15373,
15389,
15407,
15371,
15380,
15378,
15376,
15379,
15377,
15329,
15419,
15327,
15417,
15328,
15418,
15368,
15366,
15364,
15367,
15365,
15333,
15415,
15413,
15414,
15412,
15345,
15420,
15332,
15331,
-1,
-1,
2632,
2633,
17051,
17052,
15427,
15426,
15428,
17054,
16954,
17045,
16952,
17043,
16948,
17041,
16953,
17044,
16949,
17042,
17007,
17019,
17005,
17017,
17003,
17015,
17006,
17018,
17004,
17016,
16959,
16971,
16957,
16969,
16955,
16967,
16958,
16970,
16956,
16968,
16983,
17025,
16981,
17023,
16942,
16979,
17021,
16982,
17024,
16980,
17022,
16965,
16963,
16961,
16964,
16962,
17013,
17031,
16995,
17011,
17029,
16993,
17009,
17027,
16991,
17012,
17030,
16994,
17010,
17028,
16992,
17001,
16999,
16997,
17000,
16998,
16936,
17040,
16934,
17038,
16935,
17039,
16989,
16987,
16985,
16988,
16986,
16947,
17036,
17034,
17035,
17033,
16960,
16973,
16940,
16939,
16977,
16975,
16976,
16974,
17047,
17053,
17048,
17046,
17049,
-1,
-1,
-1,
-1,
-1,
11543,
11550,
11551,
11555,
11556,
11547,
11529,
11552,
11532,
11553,
11554,
11539,
11549,
11545,
11528,
11542,
11538,
11548,
11526,
11541,
11537,
11496,
11513,
11505,
11511,
11502,
11510,
11500,
11517,
11497,
11506,
11499,
11508,
11509,
11520,
11535,
11523,
11546,
11530,
11534,
-1,
-1,
-1,
-1,
14608,
14560,
14609,
14611,
14617,
14616,
14638,
14556,
14571,
14581,
14585,
14574,
14584,
14580,
14576,
14586,
14624,
14588,
14558,
14590,
14564,
14557,
14643,
14645,
14563,
14646,
14610,
14639,
14599,
14648,
14630,
14633,
14551,
14552,
14636,
14634,
14539,
14534,
14640,
14621,
14622,
14641,
14546,
14647,
14620,
14619,
14623,
14541,
14635,
14553,
14642,
14777,
14559,
14613,
14614,
14615,
14582,
14579,
14575,
14577,
14583,
14627,
14629,
14628,
14607,
14597,
14595,
14593,
14592,
14598,
14596,
14604,
14606,
14569,
14568,
14566,
14567,
14570,
14600,
14561,
14535,
14537,
14538,
14605,
14562,
14540,
14548,
14549,
14550,
14544,
14543,
14545,
14631,
14632,
-1,
20369,
20367,
20368,
20356,
20354,
20361,
20357,
20364,
20372,
20362,
20366,
20355,
20360,
20370,
20371,
20365,
11544,
11527,
11540,
11533,
11512,
11507,
11518,
11515,
11524,
11498,
11521,
11536,
11525,
11531,
11503,
11501,
11504,
11519,
11516,
11522,
11559,
11558,
11560,
11561,
]

_charnames_12736 = [
1276,
1275,
1274,
1278,
1273,
1262,
1268,
1269,
1266,
1272,
1267,
1264,
1270,
1265,
1263,
1277,
]

_charnames_12784 = [
16938,
16946,
16945,
16943,
16950,
16932,
16930,
16928,
16931,
16929,
16951,
16926,
16924,
16922,
16925,
16923,
19758,
19766,
19748,
19764,
19768,
19753,
19762,
19770,
19741,
19745,
19760,
19750,
19755,
19772,
19759,
19767,
19749,
19765,
19769,
19754,
19763,
19771,
19744,
19746,
19761,
19751,
19756,
19773,
19743,
19832,
19833,
-1,
19735,
19716,
19717,
19707,
19704,
19701,
19697,
19721,
19727,
19718,
19730,
19705,
19725,
19724,
19731,
19722,
19692,
19695,
19737,
19700,
19728,
19699,
19706,
19733,
19736,
19713,
19734,
19694,
19691,
19720,
19712,
19738,
19708,
19711,
19698,
19714,
]

_charnames_12880 = [
19847,
3061,
3053,
3054,
3059,
3060,
3056,
3057,
3063,
3062,
3066,
3077,
3069,
3070,
3075,
3076,
3122,
3139,
3112,
3137,
3141,
3117,
3135,
3131,
3127,
3129,
3124,
3114,
3119,
3143,
3123,
3140,
3113,
3138,
3142,
3118,
3136,
3134,
3128,
3130,
3125,
3115,
3120,
3144,
2975,
2974,
3133,
17365,
3045,
3023,
3024,
2996,
2993,
2990,
2986,
3014,
3028,
3025,
3009,
2994,
3037,
3036,
3007,
3015,
2980,
2984,
3040,
2989,
3030,
2988,
2995,
3020,
3034,
2987,
3010,
2997,
2981,
3012,
3044,
3042,
3046,
3001,
3019,
3018,
3039,
3021,
3032,
3033,
3004,
3008,
3003,
2983,
2979,
3013,
3002,
3043,
3029,
3072,
3073,
3079,
3078,
3084,
3095,
3087,
3088,
3093,
3094,
3090,
3091,
3097,
3096,
3100,
20339,
20349,
20342,
20345,
20341,
20337,
20338,
20344,
20346,
20347,
20348,
20298,
15612,
15684,
15685,
7139,
2972,
2970,
2968,
2971,
2969,
2952,
2950,
2948,
2951,
2949,
2928,
2926,
2924,
2927,
2925,
2922,
2920,
2918,
2921,
2919,
2940,
2938,
2936,
2939,
2937,
2958,
2956,
2954,
2957,
2955,
2946,
2944,
2942,
2945,
2943,
2967,
2965,
2966,
2934,
2932,
2930,
2933,
2931,
2963,
2961,
2962,
2960,
-1,
15719,
15718,
15720,
15722,
15701,
15700,
15752,
15686,
15687,
15731,
15730,
15525,
15524,
15523,
15619,
15620,
15617,
15616,
15532,
15615,
15517,
15520,
15519,
15518,
15622,
15623,
15527,
15528,
15541,
15530,
15531,
15694,
15693,
15697,
15691,
15690,
15663,
15666,
15664,
15746,
15670,
15674,
15610,
15555,
15554,
15710,
15561,
15559,
15560,
15714,
15598,
15597,
15711,
15596,
15608,
15550,
15549,
15607,
15548,
15551,
15715,
15564,
15713,
15603,
15563,
15601,
15602,
15474,
15473,
15477,
15475,
15476,
15489,
15486,
15487,
15495,
15496,
15497,
15743,
15742,
15744,
15630,
15631,
15638,
15637,
15641,
15640,
15593,
20333,
20334,
20311,
20313,
20322,
20325,
20317,
20319,
20328,
20331,
20315,
20330,
20310,
20314,
20323,
20326,
20318,
20320,
20329,
20332,
20303,
20308,
20306,
20307,
20309,
15605,
15662,
15717,
15709,
15729,
15573,
15658,
15660,
15661,
15706,
15683,
15681,
15680,
15682,
15649,
15556,
15669,
15470,
15471,
15521,
15543,
15502,
15627,
15652,
15542,
15572,
15676,
15469,
15468,
15509,
15540,
15611,
15539,
15508,
15626,
15747,
15467,
15507,
15665,
15537,
15750,
15675,
15466,
15490,
15644,
15511,
15492,
15646,
15483,
15516,
15493,
15647,
15484,
15514,
15480,
15481,
15552,
15536,
15505,
15625,
15633,
15634,
15635,
15567,
15673,
15465,
15504,
15566,
15672,
15464,
15500,
15534,
15501,
15565,
15671,
15463,
15498,
15533,
15499,
15544,
15482,
15721,
15712,
15655,
15654,
15656,
15648,
15667,
15624,
15609,
15604,
15699,
15538,
15515,
15535,
15738,
15737,
15735,
15736,
15503,
15488,
15506,
15571,
15570,
15569,
15568,
15696,
15695,
15592,
15751,
15723,
20297,
20272,
20278,
20286,
20289,
20281,
20283,
20292,
20295,
20279,
20294,
20271,
20277,
20287,
20290,
20282,
20284,
20293,
20296,
20257,
20268,
20260,
20261,
20266,
20267,
20263,
20264,
20270,
20269,
20275,
20276,
15621,
]

_charnames_19904 = [
15161,
15172,
15186,
15248,
15241,
15229,
15167,
15250,
15202,
15178,
15220,
15204,
15247,
15195,
15244,
15251,
15246,
15240,
15236,
15228,
15233,
15198,
15205,
15214,
15208,
15197,
15243,
15196,
15168,
15162,
15210,
15187,
15215,
15194,
15219,
15188,
15177,
15224,
15225,
15182,
15183,
15211,
15232,
15230,
15199,
15218,
15223,
15170,
15216,
15163,
15166,
15174,
15181,
15173,
15238,
15171,
15176,
15175,
15185,
15249,
15209,
15203,
15237,
15234,
]

_charnames_40960 = [
10562,
10561,
10556,
10563,
10559,
10558,
10557,
10560,
10570,
10569,
10568,
10571,
10573,
10572,
10574,
10566,
10565,
10564,
10567,
10576,
10575,
10542,
9924,
9923,
9918,
9925,
9921,
9920,
9919,
9922,
9938,
9937,
9936,
9939,
9911,
9910,
9912,
9934,
9933,
9932,
9935,
9941,
9940,
9942,
9916,
9915,
9909,
9917,
9914,
9913,
9930,
9929,
9926,
9931,
9928,
9927,
10366,
10365,
10361,
10367,
10363,
10362,
10364,
10380,
10379,
10378,
10381,
10354,
10353,
10355,
10376,
10375,
10374,
10377,
10359,
10358,
10352,
10360,
10357,
10356,
10372,
10371,
10368,
10373,
10370,
10369,
9892,
9891,
9886,
9893,
9889,
9888,
9887,
9890,
9904,
9903,
9902,
9905,
9879,
9878,
9880,
9900,
9899,
9898,
9901,
9907,
9906,
9908,
9884,
9883,
9877,
9885,
9882,
9881,
9896,
9895,
9894,
9897,
9401,
9400,
9396,
9402,
9398,
9397,
9399,
9421,
9420,
9419,
9422,
9417,
9416,
9415,
9418,
9413,
9412,
9409,
9414,
9411,
9410,
9407,
9406,
9403,
9408,
9405,
9404,
9610,
9609,
9605,
9611,
9607,
9606,
9608,
9623,
9622,
9621,
9624,
9598,
9597,
9599,
9619,
9618,
9617,
9620,
9603,
9602,
9596,
9604,
9601,
9600,
9615,
9612,
9616,
9614,
9613,
10105,
10104,
10100,
10106,
10102,
10101,
10103,
10117,
10116,
10115,
10118,
10093,
10092,
10091,
10094,
10113,
10112,
10111,
10114,
10120,
10119,
10098,
10097,
10090,
10099,
10096,
10095,
10109,
10108,
10107,
10110,
10511,
10510,
10509,
10512,
10515,
10514,
10513,
10516,
10518,
10517,
10519,
10503,
10502,
10499,
10504,
10501,
10500,
10507,
10506,
10505,
10508,
10326,
10325,
10320,
10327,
10323,
10322,
10321,
10324,
10346,
10345,
10344,
10347,
10342,
10341,
10340,
10343,
10349,
10350,
10338,
10337,
10334,
10339,
10336,
10335,
10332,
10331,
10328,
10333,
10330,
10329,
10218,
10217,
10213,
10219,
10215,
10214,
10216,
10226,
10225,
10224,
10227,
10209,
10208,
10222,
10221,
10220,
10223,
10229,
10228,
10230,
10211,
10210,
10205,
10212,
10207,
10206,
10427,
10426,
10422,
10428,
10424,
10423,
10425,
10435,
10434,
10433,
10436,
10415,
10414,
10413,
10416,
10431,
10430,
10429,
10432,
10438,
10437,
10439,
10420,
10419,
10412,
10421,
10418,
10417,
10192,
10191,
10187,
10193,
10189,
10188,
10190,
10200,
10199,
10198,
10201,
10180,
10179,
10181,
10196,
10195,
10194,
10197,
10203,
10202,
10204,
10185,
10184,
10178,
10186,
10183,
10182,
9484,
9483,
9480,
9485,
9482,
9481,
9492,
9491,
9490,
9493,
9488,
9487,
9486,
9489,
9495,
9494,
9496,
9478,
9477,
9474,
9479,
9476,
9475,
9656,
9655,
9650,
9657,
9653,
9652,
9651,
9654,
9660,
9659,
9658,
9661,
9664,
9663,
9668,
9667,
9669,
9671,
9670,
9672,
9665,
9549,
9548,
9544,
9550,
9546,
9545,
9547,
9559,
9558,
9560,
9537,
9536,
9538,
9553,
9552,
9551,
9554,
9556,
9555,
9557,
9542,
9541,
9535,
9543,
9540,
9539,
9577,
9576,
9572,
9578,
9574,
9573,
9575,
9587,
9586,
9585,
9588,
9565,
9564,
9566,
9590,
9589,
9591,
9593,
9592,
9594,
9570,
9569,
9563,
9571,
9568,
9567,
9583,
9582,
9579,
9584,
9581,
9580,
10300,
10299,
10294,
10301,
10297,
10296,
10295,
10298,
10314,
10313,
10312,
10315,
10287,
10286,
10285,
10288,
10310,
10309,
10308,
10311,
10317,
10316,
10318,
10292,
10291,
10284,
10293,
10290,
10289,
10306,
10305,
10302,
10307,
10304,
10303,
10052,
10051,
10046,
10053,
10049,
10048,
10047,
10050,
10064,
10063,
10062,
10065,
10039,
10038,
10037,
10040,
10056,
10055,
10054,
10057,
10060,
10059,
10058,
10061,
10044,
10043,
10036,
10045,
10042,
10041,
10484,
10483,
10479,
10485,
10481,
10480,
10482,
10496,
10495,
10494,
10497,
10472,
10471,
10473,
10488,
10487,
10486,
10489,
10492,
10491,
10490,
10493,
10477,
10476,
10470,
10478,
10475,
10474,
10023,
10022,
10018,
10020,
10019,
10021,
10034,
10033,
10032,
10035,
10011,
10010,
10009,
10012,
10026,
10025,
10024,
10027,
10030,
10029,
10028,
10031,
10016,
10015,
10008,
10017,
10014,
10013,
10089,
10088,
10083,
10082,
10081,
10084,
10070,
10069,
10071,
10079,
10078,
10077,
10080,
10086,
10085,
10087,
10075,
10074,
10068,
10076,
10073,
10072,
9632,
9631,
9626,
9633,
9629,
9628,
9627,
9630,
9644,
9643,
9642,
9645,
9636,
9635,
9634,
9637,
9640,
9639,
9638,
9641,
9647,
9646,
9648,
9530,
9529,
9531,
9524,
9523,
9522,
9525,
9528,
9527,
9526,
9520,
9519,
9518,
9521,
9533,
9532,
9534,
9688,
9687,
9686,
9683,
9682,
9681,
9684,
9675,
9674,
9673,
9676,
9679,
9678,
9677,
9680,
9690,
9689,
9691,
10548,
10547,
10546,
10549,
10544,
10543,
10545,
10551,
10550,
10552,
10554,
10553,
10555,
9765,
9764,
9760,
9766,
9762,
9761,
9763,
9779,
9778,
9777,
9780,
9753,
9752,
9754,
9775,
9774,
9773,
9776,
9782,
9781,
9783,
9758,
9757,
9751,
9759,
9756,
9755,
9771,
9770,
9767,
9772,
9769,
9768,
9987,
9986,
9981,
9988,
9984,
9983,
9982,
9985,
10001,
10000,
9999,
10002,
9974,
9973,
9975,
9997,
9996,
9995,
9998,
10004,
10003,
10005,
9979,
9978,
9972,
9980,
9977,
9976,
9993,
9992,
9989,
9994,
9991,
9990,
9700,
9699,
9694,
9701,
9697,
9696,
9695,
9698,
9715,
9714,
9713,
9716,
9718,
9717,
9719,
9721,
9720,
9722,
9711,
9708,
9712,
9710,
9709,
9706,
9705,
9702,
9707,
9704,
9703,
9378,
9377,
9373,
9379,
9375,
9374,
9376,
9388,
9387,
9386,
9389,
9370,
9369,
9391,
9392,
9394,
9393,
9371,
9366,
9372,
9368,
9367,
9384,
9383,
9380,
9385,
9382,
9381,
9856,
9855,
9851,
9857,
9853,
9852,
9854,
9870,
9869,
9868,
9871,
9844,
9843,
9845,
9866,
9865,
9864,
9867,
9873,
9872,
9874,
9849,
9848,
9842,
9850,
9847,
9846,
9862,
9861,
9858,
9863,
9860,
9859,
9791,
9790,
9786,
9792,
9788,
9787,
9789,
9809,
9808,
9807,
9810,
9805,
9804,
9803,
9806,
9812,
9811,
9813,
9801,
9800,
9799,
9802,
9797,
9796,
9793,
9798,
9795,
9794,
9749,
9748,
9747,
9750,
9726,
9725,
9727,
9741,
9740,
9739,
9742,
9745,
9744,
9743,
9746,
9731,
9730,
9724,
9732,
9729,
9728,
9737,
9736,
9733,
9738,
9735,
9734,
9970,
9969,
9968,
9971,
9948,
9947,
9946,
9949,
9962,
9961,
9960,
9963,
9966,
9965,
9964,
9967,
9952,
9945,
9953,
9951,
9950,
9958,
9957,
9954,
9959,
9956,
9955,
10256,
10255,
10237,
10236,
10249,
10248,
10247,
10250,
10253,
10252,
10251,
10254,
10239,
10238,
10233,
10240,
10235,
10234,
10245,
10244,
10241,
10246,
10243,
10242,
9468,
9467,
9466,
9469,
9471,
9470,
9472,
9464,
9463,
9462,
9465,
9460,
9459,
9456,
9461,
9458,
9457,
9454,
9453,
9450,
9455,
9452,
9451,
9840,
9839,
9838,
9841,
9817,
9816,
9818,
9832,
9831,
9830,
9833,
9836,
9835,
9834,
9837,
9822,
9821,
9815,
9823,
9820,
9819,
9828,
9827,
9824,
9829,
9826,
9825,
10278,
10277,
10276,
10279,
10259,
10258,
10260,
10274,
10273,
10272,
10275,
10281,
10280,
10282,
10264,
10263,
10257,
10265,
10262,
10261,
10270,
10269,
10266,
10271,
10268,
10267,
10164,
10163,
10158,
10165,
10161,
10160,
10159,
10162,
10151,
10150,
10149,
10152,
10174,
10173,
10172,
10175,
10156,
10155,
10148,
10157,
10154,
10153,
10170,
10169,
10166,
10171,
10168,
10167,
10457,
10456,
10451,
10458,
10454,
10453,
10452,
10455,
10444,
10443,
10442,
10445,
10467,
10466,
10465,
10468,
10449,
10448,
10441,
10450,
10447,
10446,
10463,
10462,
10459,
10464,
10461,
10460,
10138,
10137,
10132,
10139,
10135,
10134,
10133,
10136,
10125,
10124,
10126,
10146,
10145,
10144,
10147,
10130,
10129,
10123,
10131,
10128,
10127,
10142,
10141,
10140,
10143,
9430,
9429,
9424,
9431,
9427,
9426,
9425,
9428,
9436,
9435,
9447,
9446,
9445,
9448,
9437,
9432,
9438,
9434,
9433,
9443,
9442,
9439,
9444,
9441,
9440,
9504,
9503,
9498,
9505,
9501,
9500,
9499,
9502,
9508,
9507,
9509,
9515,
9514,
9513,
9516,
9511,
9510,
9506,
9512,
10527,
10526,
10521,
10528,
10524,
10523,
10522,
10525,
10540,
10539,
10537,
10536,
10535,
10538,
10533,
10532,
10529,
10534,
10531,
10530,
10399,
10398,
10393,
10400,
10396,
10395,
10394,
10397,
10386,
10385,
10384,
10387,
10409,
10408,
10407,
10410,
10391,
10390,
10383,
10392,
10389,
10388,
10405,
10404,
10401,
10406,
10403,
10402,
-1,
-1,
-1,
10653,
10625,
10644,
10609,
10581,
10598,
10602,
10604,
10642,
10622,
10627,
10651,
10641,
10629,
10639,
10620,
10636,
10605,
10588,
10580,
10648,
10650,
10601,
10608,
10635,
10654,
10615,
10590,
10638,
10623,
10630,
10632,
10594,
10633,
10591,
10617,
10610,
10614,
10603,
10616,
10652,
10647,
10595,
10626,
10579,
10582,
10583,
10621,
10597,
10587,
10596,
10584,
10589,
10611,
10645,
]

_charnames_42752 = [
4696,
4701,
4693,
4698,
4695,
4700,
4694,
4699,
4743,
4778,
4755,
4716,
4737,
4744,
4779,
4756,
4717,
4738,
4746,
4781,
4758,
4713,
4740,
]

_charnames_43008 = [
15915,
15912,
15929,
15906,
15914,
15908,
15928,
15892,
15893,
15898,
15899,
15930,
15901,
15902,
15895,
15896,
15875,
15876,
15881,
15882,
15877,
15878,
15883,
15884,
15909,
15889,
15890,
15904,
15905,
15910,
15887,
15911,
15886,
15907,
15913,
15921,
15919,
15917,
15920,
15918,
15926,
15925,
15924,
15923,
]

_charnames_63744 = [
856,
855,
854,
853,
852,
851,
850,
849,
848,
847,
846,
845,
844,
843,
842,
841,
839,
838,
837,
836,
835,
834,
833,
832,
831,
830,
829,
828,
827,
826,
825,
824,
822,
821,
820,
819,
818,
817,
816,
815,
814,
813,
812,
811,
810,
809,
808,
807,
805,
804,
803,
802,
801,
800,
799,
798,
797,
796,
795,
794,
793,
792,
791,
790,
788,
787,
786,
785,
784,
783,
782,
781,
780,
779,
778,
777,
776,
775,
774,
773,
771,
770,
769,
768,
767,
766,
765,
764,
763,
762,
761,
760,
759,
758,
757,
756,
754,
753,
752,
751,
750,
749,
748,
747,
746,
745,
744,
743,
742,
741,
740,
739,
737,
736,
735,
734,
733,
732,
731,
730,
729,
728,
727,
726,
725,
724,
723,
722,
720,
719,
718,
717,
716,
715,
714,
713,
712,
711,
710,
709,
708,
707,
706,
705,
703,
702,
701,
700,
699,
698,
697,
696,
695,
694,
693,
692,
691,
690,
689,
688,
686,
685,
684,
683,
682,
681,
680,
679,
678,
677,
676,
675,
674,
673,
672,
671,
669,
668,
667,
666,
665,
664,
663,
662,
661,
660,
659,
658,
657,
656,
655,
654,
652,
651,
650,
649,
648,
647,
646,
645,
644,
643,
642,
641,
640,
639,
638,
637,
635,
634,
633,
632,
631,
630,
629,
628,
627,
626,
625,
624,
623,
622,
621,
620,
618,
617,
616,
615,
614,
613,
612,
611,
610,
609,
608,
607,
606,
605,
604,
603,
601,
600,
599,
598,
597,
596,
595,
594,
593,
592,
591,
590,
589,
588,
587,
586,
1044,
1043,
1042,
1041,
1040,
1039,
1038,
1037,
1036,
1035,
1034,
1033,
1032,
1031,
1030,
1029,
1027,
1026,
1025,
1024,
1023,
1022,
1021,
1020,
1019,
1018,
1017,
1016,
1015,
1014,
1013,
1012,
1059,
1058,
1057,
1056,
1055,
1054,
1053,
1052,
1051,
1050,
1049,
1048,
1047,
1046,
-1,
-1,
1010,
1009,
1008,
1007,
1006,
1005,
1004,
1003,
1002,
1001,
1000,
999,
998,
997,
996,
995,
993,
992,
991,
990,
989,
988,
987,
986,
985,
984,
983,
982,
981,
980,
979,
978,
976,
975,
974,
973,
972,
971,
970,
969,
968,
967,
966,
965,
964,
963,
962,
961,
1071,
1070,
1069,
1068,
1067,
1066,
1065,
1064,
1063,
1062,
1061,
-1,
-1,
-1,
-1,
-1,
959,
958,
957,
956,
955,
954,
953,
952,
951,
950,
949,
948,
947,
946,
945,
944,
942,
941,
940,
939,
938,
937,
936,
935,
934,
933,
932,
931,
930,
929,
928,
927,
925,
924,
923,
922,
921,
920,
919,
918,
917,
916,
915,
914,
913,
912,
911,
910,
908,
907,
906,
905,
904,
903,
902,
901,
900,
899,
898,
897,
896,
895,
894,
893,
891,
890,
889,
888,
887,
886,
885,
884,
883,
882,
881,
880,
879,
878,
877,
876,
874,
873,
872,
871,
870,
869,
868,
867,
866,
865,
864,
863,
862,
861,
860,
859,
1082,
1081,
1080,
1079,
1078,
1077,
1076,
1075,
1074,
1073,
]

_charnames_64256 = [
6157,
6161,
6160,
6159,
6158,
6164,
6162,
]

_charnames_64275 = [
9037,
9039,
9038,
9040,
9036,
-1,
-1,
-1,
-1,
-1,
15031,
15143,
15073,
15020,
14990,
14989,
14987,
14986,
14985,
14988,
14984,
14983,
15019,
15000,
14999,
14997,
14996,
15016,
15015,
15017,
15051,
15065,
15067,
15047,
15036,
15053,
-1,
15026,
15032,
15007,
15044,
15063,
-1,
15061,
-1,
15059,
15002,
-1,
15005,
15040,
-1,
15024,
15057,
15055,
14994,
15028,
15035,
15050,
15043,
15039,
15075,
8450,
8451,
8680,
8683,
8681,
8682,
8746,
8749,
8747,
8748,
8673,
8676,
8674,
8675,
8291,
8294,
8292,
8293,
8268,
8271,
8269,
8270,
8297,
8300,
8298,
8299,
8792,
8795,
8793,
8794,
8740,
8743,
8741,
8742,
8362,
8365,
8363,
8364,
8511,
8514,
8512,
8513,
8282,
8286,
8283,
8285,
8276,
8279,
8277,
8278,
8357,
8358,
8348,
8349,
8368,
8369,
8353,
8354,
8809,
8810,
8650,
8651,
8524,
8527,
8525,
8526,
8693,
8696,
8694,
8695,
8708,
8711,
8709,
8710,
8498,
8501,
8499,
8500,
8487,
8488,
8644,
8647,
8645,
8646,
8395,
8396,
8380,
8384,
8381,
8383,
8388,
8391,
8389,
8390,
8611,
8612,
8609,
8610,
]

_charnames_64467 = [
8504,
8507,
8505,
8506,
8815,
8816,
8849,
8850,
8620,
8621,
8814,
8797,
8798,
8546,
8547,
8542,
8543,
8843,
8846,
8844,
8845,
8819,
8818,
7726,
7727,
7729,
7730,
7757,
7758,
7760,
7761,
7763,
7764,
7733,
7734,
7753,
7755,
7754,
8240,
8242,
8241,
8732,
8735,
8733,
8734,
7766,
7749,
7740,
7724,
7736,
8033,
8012,
8026,
8020,
8036,
8030,
7665,
7646,
7657,
7634,
7671,
7668,
7693,
7680,
7688,
7685,
8159,
8152,
8089,
8085,
7916,
7921,
7913,
7577,
7557,
7569,
7551,
7598,
7605,
8137,
8125,
8118,
8134,
7712,
7705,
8235,
8059,
8052,
8228,
8222,
8185,
8188,
8174,
8178,
8191,
8182,
8209,
8203,
8212,
8206,
7894,
7903,
7906,
7900,
7886,
7880,
7892,
7897,
7847,
7858,
7866,
7833,
7822,
7869,
7978,
7994,
7986,
7998,
8003,
8005,
7934,
7943,
7961,
7953,
7964,
7958,
8107,
8104,
8111,
8109,
7793,
7774,
7800,
7787,
7803,
7797,
7695,
8244,
8073,
7535,
7530,
7538,
7534,
7529,
7539,
7769,
7768,
7743,
7770,
7725,
7737,
8039,
8038,
8023,
8040,
8037,
8031,
7674,
7673,
7637,
7675,
7672,
7669,
7691,
7690,
7683,
7692,
7689,
7686,
8192,
8183,
8213,
8207,
7895,
7889,
7883,
7893,
7898,
7836,
7823,
7870,
8004,
8001,
7967,
7966,
7956,
7968,
7965,
7959,
8074,
7806,
7805,
7790,
7807,
7804,
7798,
7767,
7750,
7771,
7741,
7747,
8034,
8013,
8027,
8021,
8017,
7666,
7647,
7658,
7635,
7650,
7681,
8160,
8153,
8090,
8086,
7917,
7914,
7578,
7558,
7570,
7552,
7599,
7616,
7606,
8138,
8126,
8119,
8135,
7713,
8236,
8060,
8053,
8229,
8223,
8186,
8189,
8175,
8179,
8210,
8204,
7904,
7907,
7901,
7887,
7881,
7848,
7859,
7867,
7834,
7860,
7979,
7995,
7987,
7999,
7935,
7944,
7962,
7954,
7947,
8108,
8105,
8110,
7794,
7775,
7801,
7788,
7779,
7742,
7746,
8022,
8016,
7636,
7649,
7682,
7694,
7553,
7562,
7501,
7488,
7888,
7882,
7835,
7955,
7946,
7789,
7778,
7537,
7533,
7528,
7715,
7709,
8065,
8062,
8231,
8225,
7587,
7581,
7523,
7517,
8096,
8093,
8165,
8162,
7919,
7910,
7614,
7608,
8140,
8128,
7505,
7483,
7512,
7499,
7520,
7584,
7611,
8131,
7716,
7710,
8066,
8063,
8232,
8226,
7588,
7582,
7524,
7518,
8097,
8094,
8166,
8163,
7920,
7911,
7615,
7609,
8141,
8129,
7509,
7486,
7515,
7502,
7521,
7585,
7612,
8132,
7506,
7484,
7513,
7500,
7563,
7489,
7706,
7579,
7560,
7571,
7508,
7485,
7514,
7707,
8237,
8071,
8070,
19435,
19434,
]

_charnames_64848 = [
7662,
7643,
7642,
7644,
7654,
7630,
7631,
7629,
8148,
8147,
8082,
8083,
7559,
7574,
7575,
7548,
7547,
7549,
7545,
7544,
7595,
7594,
7603,
7480,
7479,
7507,
7497,
7496,
7494,
7493,
8123,
8116,
8115,
7701,
7700,
7703,
7702,
8057,
8048,
8047,
8050,
8219,
8218,
8220,
8172,
8171,
8199,
8201,
7854,
7855,
7856,
7843,
7844,
7864,
7863,
7830,
7829,
7992,
7991,
7990,
7976,
7974,
7984,
7983,
-1,
-1,
7975,
8102,
8101,
7940,
7941,
7927,
7926,
7932,
7950,
7951,
7784,
7783,
8028,
7661,
7663,
7653,
7655,
7628,
7632,
8149,
8157,
8150,
7567,
7596,
7481,
8122,
7845,
7831,
7776,
7795,
7785,
8000,
8200,
7939,
8198,
7853,
8049,
7878,
7929,
7982,
7840,
7877,
7841,
7930,
8156,
8091,
7973,
8180,
8014,
7876,
8056,
7602,
7566,
7931,
]

_charnames_65008 = [
7620,
8214,
8075,
8077,
8006,
7623,
8245,
8076,
8246,
7621,
7622,
8167,
19133,
8041,
-1,
-1,
18618,
18729,
18863,
18852,
18841,
18830,
18819,
18808,
18797,
18718,
18707,
18696,
18685,
18674,
18663,
18652,
19892,
19890,
19889,
19893,
19896,
19885,
19897,
19859,
19873,
19898,
-1,
-1,
-1,
-1,
-1,
-1,
2452,
2451,
2464,
2463,
]

_charnames_65072 = [
19895,
19887,
19886,
19870,
19894,
19866,
19880,
19862,
19876,
19864,
19878,
19868,
19882,
19867,
19881,
19869,
19883,
19863,
19877,
19860,
19874,
16465,
20846,
19865,
19879,
18608,
3353,
20936,
18370,
18609,
3354,
20934,
16367,
16386,
16389,
-1,
16383,
16368,
16384,
16356,
16358,
16372,
16348,
16373,
16349,
16371,
16347,
16385,
16380,
16379,
16376,
16387,
16374,
16388,
16357,
-1,
16350,
16390,
16377,
16366,
-1,
-1,
-1,
-1,
8913,
8930,
8921,
8931,
8936,
-1,
8911,
8910,
8924,
8923,
8939,
8938,
8903,
8902,
8898,
8897,
8421,
8443,
8444,
8439,
8440,
8769,
8770,
8435,
8436,
8597,
8600,
8598,
8599,
8456,
8457,
8666,
8669,
8667,
8668,
8254,
8256,
8262,
8264,
8263,
8257,
8305,
8308,
8306,
8307,
8803,
8806,
8804,
8805,
8416,
8419,
8417,
8418,
8551,
8554,
8552,
8553,
8336,
8337,
8311,
8312,
8639,
8640,
8786,
8787,
8566,
8569,
8567,
8568,
8583,
8587,
8584,
8586,
8576,
8579,
8577,
8578,
8341,
8345,
8342,
8344,
8316,
8320,
8317,
8319,
8780,
8783,
8781,
8782,
8468,
8471,
8469,
8470,
8700,
8704,
8701,
8703,
8725,
8728,
8726,
8727,
8826,
8829,
8827,
8828,
8535,
8538,
8536,
8537,
8760,
8763,
8761,
8762,
8836,
8839,
8837,
8838,
8490,
8493,
8491,
8492,
8399,
8402,
8400,
8401,
8774,
8775,
8454,
8455,
8614,
8617,
8615,
8616,
7819,
7820,
7816,
7817,
7813,
7814,
7824,
7825,
-1,
-1,
21006,
-1,
20595,
20586,
20589,
20558,
20577,
20581,
20580,
20539,
20563,
20579,
20576,
20570,
20602,
20603,
20583,
20554,
20555,
20546,
20547,
20552,
20553,
20549,
20550,
20557,
20556,
20571,
20584,
20541,
20596,
20592,
20587,
20569,
20534,
20533,
20532,
20531,
20530,
20529,
20528,
20527,
20526,
20525,
20524,
20523,
20522,
20521,
20520,
20519,
20518,
20517,
20516,
20515,
20514,
20513,
20512,
20511,
20510,
20509,
20538,
20565,
20562,
20572,
20542,
20593,
20507,
20506,
20505,
20504,
20503,
20502,
20501,
20500,
20499,
20498,
20497,
20496,
20495,
20494,
20493,
20492,
20491,
20490,
20489,
20488,
20487,
20486,
20485,
20484,
20483,
20482,
20540,
20599,
20564,
20600,
20537,
20561,
14967,
14965,
14962,
14968,
14893,
14884,
14837,
14835,
14832,
14836,
14834,
14831,
14829,
14830,
14833,
14894,
14890,
14888,
14886,
14889,
14887,
14872,
14870,
14868,
14871,
14869,
14842,
14840,
14838,
14841,
14839,
14854,
14852,
14850,
14853,
14851,
14848,
14846,
14844,
14847,
14845,
14878,
14876,
14874,
14877,
14875,
14866,
14864,
14862,
14865,
14863,
14882,
14880,
14881,
14860,
14858,
14856,
14859,
14857,
14885,
14843,
14891,
14892,
14959,
14938,
14920,
14939,
14933,
14936,
14935,
14945,
14917,
14897,
14905,
14904,
14900,
14903,
14902,
14901,
14906,
14957,
14930,
14919,
14931,
14922,
14918,
14950,
14952,
14921,
14953,
14940,
14946,
14932,
14958,
-1,
-1,
-1,
14954,
14955,
14910,
14911,
14943,
14941,
-1,
-1,
14909,
14908,
14947,
14926,
14927,
14948,
-1,
-1,
14913,
14956,
14925,
14924,
14928,
14912,
-1,
-1,
14942,
14914,
14949,
-1,
-1,
-1,
20573,
20575,
20590,
20601,
20604,
20597,
20598,
-1,
14971,
14964,
14970,
14961,
14972,
14973,
14969,
]

_charnames_65529 = [
20426,
20425,
20424,
19680,
19273,
-1,
-1,
6961,
6989,
6951,
6976,
7004,
6968,
6981,
6962,
7000,
6947,
6942,
6980,
-1,
6991,
6974,
6931,
6982,
6972,
6938,
7008,
7009,
7001,
6935,
6999,
6956,
6963,
6955,
6995,
6946,
6943,
6966,
6936,
6988,
7003,
6948,
6998,
6930,
6957,
6993,
-1,
6977,
6952,
6945,
6967,
6953,
6994,
6960,
6985,
7002,
6941,
6940,
6965,
6990,
6964,
6970,
6944,
6933,
6986,
6984,
-1,
6997,
6934,
-1,
6958,
6954,
6983,
7007,
6937,
7012,
6979,
6950,
6975,
6932,
6992,
6971,
6973,
7006,
7011,
-1,
-1,
7027,
7026,
7031,
7030,
7024,
7023,
7029,
7021,
7020,
7028,
7018,
7017,
7016,
7015,
]

_charnames_65664 = [
6805,
6804,
6803,
6790,
6789,
6788,
6802,
6801,
6799,
6798,
6796,
6795,
6793,
6792,
6855,
6854,
6853,
6852,
6851,
7039,
7038,
6859,
6858,
6857,
7036,
7035,
6849,
6848,
6847,
6846,
6845,
6835,
6834,
6833,
6832,
6831,
7040,
6830,
6829,
6828,
6816,
6815,
6814,
6813,
6812,
6811,
6810,
6809,
6808,
6807,
6826,
6825,
6824,
6823,
6822,
6821,
6820,
6819,
6818,
6843,
6842,
6841,
6840,
6839,
6838,
6837,
6862,
6861,
6892,
6891,
6889,
6888,
6887,
6886,
6885,
6884,
6882,
6881,
6880,
6879,
6878,
6877,
7041,
6876,
6875,
6873,
6872,
6871,
6870,
6869,
6868,
6867,
6866,
6865,
6926,
6916,
6915,
6914,
6913,
6912,
6911,
6910,
6909,
6908,
6907,
6905,
6904,
6903,
6902,
6901,
6900,
6899,
6898,
6897,
6896,
6923,
6922,
6921,
6920,
6919,
6918,
6924,
6925,
-1,
-1,
-1,
-1,
-1,
9295,
9296,
9302,
-1,
-1,
-1,
-1,
9282,
9227,
9234,
9257,
9264,
9243,
9249,
9276,
9270,
9240,
9231,
9238,
9261,
9268,
9244,
9250,
9277,
9271,
9285,
9230,
9237,
9260,
9267,
9248,
9254,
9281,
9275,
9284,
9229,
9236,
9259,
9266,
9247,
9253,
9280,
9274,
9241,
9232,
9239,
9262,
9269,
9245,
9251,
9278,
9272,
-1,
-1,
-1,
9293,
9290,
9292,
9291,
9289,
9301,
9300,
9299,
9298,
12321,
12317,
12322,
12294,
12305,
12300,
12297,
12308,
12299,
12326,
12310,
12315,
12302,
12319,
12298,
12304,
12327,
12311,
12316,
12303,
12320,
12325,
12309,
12328,
12359,
12337,
12357,
12361,
12335,
12365,
12362,
12348,
12352,
12353,
12356,
12369,
12336,
12334,
12350,
12351,
12358,
12345,
12340,
12333,
12363,
12349,
12344,
12366,
12368,
12339,
12343,
12370,
12367,
12503,
12504,
12487,
12483,
12525,
12491,
12479,
12507,
12488,
12484,
12530,
12531,
12528,
12512,
12466,
12506,
12533,
12372,
12373,
12536,
12489,
12532,
]

_charnames_66304 = [
19540,
19539,
19520,
19537,
19507,
19533,
19532,
19536,
19525,
19530,
19521,
19514,
19513,
19512,
19509,
19535,
19529,
19534,
19518,
19510,
19508,
19526,
19522,
19515,
19528,
19519,
19516,
19511,
19538,
19531,
19523,
-1,
19546,
19543,
19545,
19544,
]

_charnames_66352 = [
13116,
13132,
13128,
13131,
13115,
13121,
13109,
13113,
13106,
13130,
13126,
13125,
13124,
13104,
13127,
13118,
13122,
13102,
13120,
13119,
13107,
13117,
13129,
13110,
13112,
13123,
13103,
]

_charnames_66432 = [
20783,
20795,
20778,
20772,
20781,
20774,
20786,
20770,
20775,
20767,
20785,
20773,
20763,
20793,
20792,
20780,
20791,
20769,
20760,
20784,
20790,
20761,
20789,
20788,
20766,
20777,
20765,
20794,
20787,
20762,
-1,
20796,
19446,
19492,
19489,
19480,
19479,
19486,
19485,
19468,
19495,
19483,
19482,
19453,
19451,
19441,
19445,
19444,
19452,
19490,
19463,
19494,
19477,
19476,
19461,
19460,
19459,
19488,
19471,
19470,
19474,
19473,
19491,
19457,
19487,
19456,
19455,
19493,
-1,
-1,
-1,
-1,
19447,
19449,
19448,
19467,
19442,
19443,
19464,
19465,
19504,
19502,
19499,
19501,
19500,
19503,
]

_charnames_66560 = [
18252,
18253,
18250,
18251,
18248,
18249,
18245,
18246,
18243,
18244,
18241,
18242,
18274,
18261,
18264,
18263,
18269,
18266,
18273,
18259,
18271,
18272,
18268,
18267,
18270,
18239,
18265,
18235,
18258,
18230,
18256,
18231,
18255,
18236,
18238,
18237,
18232,
18233,
18262,
18234,
18205,
18206,
18203,
18204,
18201,
18202,
18198,
18199,
18196,
18197,
18194,
18195,
18227,
18214,
18217,
18216,
18222,
18219,
18226,
18212,
18224,
18225,
18221,
18220,
18223,
18192,
18218,
18188,
18211,
18183,
18209,
18184,
18208,
18189,
18191,
18190,
18185,
18186,
18215,
18187,
16290,
16266,
16293,
16296,
16264,
16279,
16278,
16298,
16273,
16284,
16299,
16297,
16295,
16287,
16265,
16286,
16282,
16294,
16276,
16285,
16292,
16281,
16268,
16261,
16244,
16248,
16253,
16275,
16250,
16246,
16289,
16291,
16258,
16247,
16269,
16288,
16255,
16252,
16254,
16243,
16242,
16251,
16245,
16260,
16241,
16259,
16270,
16272,
19550,
19581,
19569,
19575,
19566,
19558,
19564,
19570,
19554,
19553,
19563,
19580,
19578,
19579,
19571,
19559,
19574,
19573,
19572,
19567,
19577,
19565,
19549,
19560,
19576,
19555,
19568,
19551,
19561,
19556,
-1,
-1,
19592,
19593,
19584,
19585,
19590,
19591,
19587,
19588,
19595,
19594,
]

_charnames_67584 = [
2403,
2402,
2401,
2400,
2399,
2398,
-1,
-1,
2397,
-1,
2384,
2383,
2382,
2381,
2380,
2378,
2377,
2376,
2375,
2374,
2372,
2371,
2370,
2369,
2368,
2366,
2365,
2364,
2363,
2362,
2360,
2359,
2358,
2357,
2356,
2354,
2353,
2352,
2351,
2350,
2348,
2347,
2346,
2345,
2344,
2342,
2341,
2340,
2339,
2338,
2389,
2388,
2387,
2386,
-1,
2395,
2394,
-1,
-1,
-1,
2392,
-1,
-1,
2391,
]

_charnames_68096 = [
17316,
17337,
17335,
17334,
-1,
17338,
17336,
-1,
-1,
-1,
-1,
-1,
17339,
17343,
17348,
17345,
17295,
17294,
17301,
17300,
-1,
17304,
17303,
17314,
-1,
17289,
17275,
17274,
17281,
17280,
17290,
17277,
17276,
17283,
17282,
17291,
17298,
17297,
17307,
17306,
17312,
17309,
17311,
17313,
17310,
17286,
17285,
17287,
17308,
17315,
17293,
17273,
-1,
-1,
-1,
-1,
17347,
17346,
17344,
-1,
-1,
-1,
-1,
17340,
17360,
17358,
17359,
17361,
17352,
17351,
17355,
17354,
]

_charnames_68176 = [
17321,
17329,
17328,
17327,
17330,
17324,
17322,
17320,
17325,
]

_charnames_118784 = [
11055,
11139,
11064,
11235,
11236,
11296,
11297,
11012,
11036,
11067,
11208,
11209,
10998,
10939,
11266,
11169,
10973,
10926,
10929,
11034,
11165,
11243,
11222,
11054,
11290,
11299,
11256,
10985,
10979,
11044,
11074,
11039,
11237,
11298,
10935,
10936,
11004,
11301,
11077,
11170,
10970,
11042,
11033,
11032,
11240,
11159,
11279,
11138,
11156,
11168,
10994,
10938,
11099,
11250,
11145,
11011,
11062,
11048,
11000,
11288,
11302,
11073,
11070,
11258,
11304,
11061,
11001,
11146,
11040,
11230,
11255,
11242,
11234,
11060,
11002,
11059,
10997,
11063,
10978,
10984,
11211,
10928,
10932,
11210,
10996,
11268,
11291,
11193,
11295,
11076,
11049,
11244,
10968,
11280,
11069,
11072,
11261,
11013,
10969,
11147,
11269,
11031,
11035,
11287,
11267,
11043,
11303,
11149,
11052,
11152,
11150,
11051,
11151,
11050,
11223,
10951,
11262,
11239,
11162,
11161,
11163,
11164,
11010,
11264,
11204,
11205,
11038,
11007,
11136,
10991,
10992,
10993,
10934,
10940,
11135,
11154,
11167,
11003,
11277,
11278,
11274,
11275,
11276,
11221,
11218,
11217,
11120,
11123,
11124,
11125,
11155,
10952,
11252,
11134,
10956,
10964,
10965,
10958,
10959,
10962,
10961,
10955,
11183,
11188,
11192,
11189,
11175,
11176,
11179,
11178,
11191,
11186,
11257,
10931,
11104,
11105,
11106,
11190,
11182,
11185,
11226,
11225,
11265,
11251,
11249,
11100,
11087,
11085,
11095,
11089,
11091,
11088,
11086,
11083,
11084,
11098,
11097,
11107,
11092,
11094,
11283,
11285,
11284,
11101,
11102,
11198,
11113,
11115,
11118,
11116,
11117,
11114,
11202,
11200,
11201,
11199,
11229,
11228,
11130,
11131,
11133,
11132,
11016,
11021,
11019,
11020,
11022,
11027,
11025,
11026,
11126,
11137,
11041,
10945,
10944,
10948,
10949,
10947,
10943,
10946,
10976,
10982,
10977,
10983,
11006,
11220,
]

_charnames_119040 = [
5145,
5227,
5177,
5297,
5221,
5166,
5333,
5300,
5296,
5222,
5223,
5156,
5071,
5295,
5294,
5293,
5194,
5195,
5241,
5084,
5244,
5243,
5213,
5131,
5128,
5182,
5178,
5144,
5143,
5181,
5271,
5274,
5273,
5085,
5184,
5187,
5186,
5230,
5229,
-1,
-1,
-1,
5225,
5226,
5192,
5193,
5323,
5324,
5164,
5165,
5314,
5315,
5070,
5082,
5216,
5215,
5320,
5319,
5286,
5342,
5336,
5316,
5309,
5140,
5126,
5137,
5211,
5352,
5260,
5083,
5159,
5160,
5094,
5095,
5100,
5101,
5097,
5098,
5103,
5104,
5092,
5093,
5284,
5285,
5106,
5107,
5262,
5346,
5326,
5325,
5074,
5075,
5240,
5343,
5338,
5317,
5310,
5141,
5127,
5138,
5212,
5035,
5036,
5052,
5051,
5050,
5176,
5175,
5174,
5062,
5045,
5044,
5043,
5042,
5041,
5249,
5307,
5246,
5303,
5247,
5304,
5248,
5305,
5060,
5033,
5054,
5034,
5063,
5064,
5061,
5067,
5349,
5350,
5058,
5066,
5046,
5038,
5069,
5057,
5053,
5299,
5169,
5351,
5261,
5287,
5183,
5081,
5233,
5269,
5270,
5087,
5120,
5353,
5123,
5122,
5198,
5208,
5207,
5206,
5205,
5204,
5203,
5202,
5201,
5200,
5199,
5339,
5327,
5306,
5232,
5056,
5065,
5068,
5037,
5258,
5257,
5337,
5276,
5277,
5344,
5219,
5220,
5288,
5329,
5238,
5153,
5155,
5279,
5282,
5149,
5151,
5189,
5190,
5331,
5332,
5239,
5154,
5281,
5150,
5117,
5119,
5118,
5115,
5110,
5114,
5113,
5112,
5080,
5267,
5266,
5161,
5347,
5254,
5077,
5167,
5078,
5129,
5252,
5253,
5168,
5130,
5259,
]

_charnames_119296 = [
12416,
12433,
12444,
12443,
12427,
12442,
12441,
12440,
12439,
12426,
12425,
12424,
12423,
12422,
12421,
12420,
12419,
12418,
12417,
12438,
12437,
12436,
12435,
12434,
12432,
12431,
12430,
12429,
12428,
12384,
12392,
12376,
12399,
12413,
12412,
12391,
12390,
12389,
12388,
12387,
12386,
12385,
12398,
12397,
12396,
12395,
12394,
12393,
12411,
12410,
12409,
12408,
12407,
12406,
12383,
12382,
12381,
12380,
12379,
12378,
12377,
12404,
12403,
12402,
12401,
12400,
2540,
2541,
2542,
12527,
]

_charnames_119552 = [
5021,
18575,
18574,
18569,
18568,
18566,
13923,
13960,
13992,
14003,
14012,
13910,
13987,
14008,
14001,
13933,
13929,
14019,
14015,
13985,
13955,
13912,
14017,
14006,
13963,
13989,
13954,
13951,
13946,
14022,
13911,
13941,
13935,
13922,
13934,
14002,
13983,
13999,
13919,
14011,
13975,
13971,
13984,
13959,
13952,
13997,
13953,
13979,
13942,
13969,
13978,
13940,
13982,
13956,
13964,
14020,
13913,
13993,
13944,
14021,
13928,
13920,
13977,
13976,
13994,
13990,
13945,
13936,
14005,
13972,
14014,
13932,
13937,
13927,
13943,
13973,
13970,
14018,
13916,
13921,
13965,
13988,
13915,
14009,
13930,
13998,
13962,
]

_charnames_119808 = [
4110,
4108,
4106,
4104,
4079,
4118,
4102,
4117,
4100,
4116,
4098,
4096,
4094,
4092,
4075,
4071,
4115,
4090,
4088,
4067,
4086,
4114,
4113,
4084,
4112,
4082,
4003,
4001,
3999,
3997,
3970,
3995,
3993,
4010,
3991,
4009,
3989,
3987,
3985,
3983,
3966,
3959,
4008,
3981,
3979,
3963,
3977,
4007,
4006,
3975,
4005,
3973,
4242,
4240,
4238,
4236,
4211,
4250,
4234,
4249,
4232,
4248,
4230,
4228,
4226,
4224,
4207,
4203,
4247,
4222,
4220,
4199,
4218,
4246,
4245,
4216,
4244,
4214,
4191,
4189,
4187,
4148,
4160,
4185,
4183,
-1,
4181,
4197,
4179,
4177,
4175,
4173,
4156,
4144,
4196,
4171,
4169,
4153,
4167,
4195,
4194,
4165,
4193,
4163,
3884,
3882,
3880,
3878,
3853,
3892,
3876,
3891,
3874,
3890,
3872,
3870,
3868,
3866,
3849,
3845,
3889,
3864,
3862,
3841,
3860,
3888,
3887,
3858,
3886,
3856,
3832,
3830,
3828,
3826,
3799,
3824,
3822,
3839,
3820,
3838,
3818,
3816,
3814,
3812,
3795,
3788,
3837,
3810,
3808,
3792,
3806,
3836,
3835,
3804,
3834,
3802,
3784,
-1,
3783,
3782,
-1,
-1,
3781,
-1,
-1,
3780,
3779,
-1,
-1,
3778,
3777,
3776,
3775,
-1,
3774,
3773,
3772,
3771,
3770,
3769,
3768,
3767,
3765,
3764,
3763,
3762,
-1,
3761,
-1,
3760,
3759,
3758,
3757,
3756,
3755,
3754,
-1,
3753,
3752,
3751,
3750,
3749,
3748,
3747,
3746,
3745,
3744,
3743,
3957,
3956,
3955,
3954,
3953,
3952,
3951,
3950,
3949,
3948,
3947,
3946,
3945,
3944,
3943,
3942,
3941,
3940,
3939,
3938,
3937,
3936,
3935,
3934,
3933,
3932,
3930,
3929,
3928,
3927,
3926,
3925,
3924,
3923,
3922,
3921,
3920,
3919,
3918,
3917,
3916,
3915,
3914,
3913,
3912,
3911,
3910,
3909,
3908,
3907,
3906,
3905,
4440,
4439,
-1,
4438,
4437,
4436,
4435,
-1,
-1,
4434,
4433,
4432,
4431,
4430,
4429,
4428,
4427,
-1,
4426,
4425,
4424,
4423,
4422,
4421,
4420,
-1,
4418,
4417,
4416,
4415,
4414,
4413,
4412,
4411,
4410,
4409,
4408,
4407,
4406,
4405,
4404,
4403,
4402,
4401,
4400,
4399,
4398,
4397,
4396,
4395,
4394,
4393,
4376,
4375,
-1,
4374,
4373,
4372,
4371,
-1,
4370,
4369,
4368,
4367,
4366,
-1,
4365,
-1,
-1,
-1,
4364,
4363,
4362,
4361,
4360,
4359,
4358,
-1,
4356,
4355,
4354,
4353,
4352,
4351,
4350,
4349,
4348,
4347,
4346,
4345,
4344,
4343,
4342,
4341,
4340,
4339,
4338,
4337,
4336,
4335,
4334,
4333,
4332,
4331,
4065,
4064,
4063,
4062,
4061,
4060,
4059,
4058,
4057,
4056,
4055,
4054,
4053,
4052,
4051,
4050,
4049,
4048,
4047,
4046,
4045,
4044,
4043,
4042,
4041,
4040,
4038,
4037,
4036,
4035,
4034,
4033,
4032,
4031,
4030,
4029,
4028,
4027,
4026,
4025,
4024,
4023,
4022,
4021,
4020,
4019,
4018,
4017,
4016,
4015,
4014,
4013,
3726,
3725,
3724,
3723,
3722,
3721,
3720,
3719,
3718,
3717,
3716,
3715,
3714,
3713,
3712,
3711,
3710,
3709,
3708,
3707,
3706,
3705,
3704,
3703,
3702,
3701,
3699,
3698,
3697,
3696,
3695,
3694,
3693,
3692,
3691,
3690,
3689,
3688,
3687,
3686,
3685,
3684,
3683,
3682,
3681,
3680,
3679,
3678,
3677,
3676,
3675,
3674,
3586,
3584,
3582,
3580,
3555,
3594,
3578,
3593,
3576,
3592,
3574,
3572,
3570,
3568,
3551,
3547,
3591,
3566,
3564,
3543,
3562,
3590,
3589,
3560,
3588,
3558,
3534,
3532,
3530,
3528,
3501,
3526,
3524,
3541,
3522,
3540,
3520,
3518,
3516,
3514,
3497,
3490,
3539,
3512,
3510,
3494,
3508,
3538,
3537,
3506,
3536,
3504,
3672,
3671,
3670,
3669,
3668,
3667,
3666,
3665,
3664,
3663,
3662,
3661,
3660,
3659,
3658,
3657,
3656,
3655,
3654,
3653,
3652,
3651,
3650,
3649,
3648,
3647,
3645,
3644,
3643,
3642,
3641,
3640,
3639,
3638,
3637,
3636,
3635,
3634,
3633,
3632,
3631,
3630,
3629,
3628,
3627,
3626,
3625,
3624,
3623,
3622,
3621,
3620,
3471,
3469,
3467,
3465,
3440,
3479,
3463,
3478,
3461,
3477,
3459,
3457,
3455,
3453,
3436,
3432,
3476,
3451,
3449,
3428,
3447,
3475,
3474,
3445,
3473,
3443,
3419,
3417,
3415,
3413,
3386,
3411,
3409,
3426,
3407,
3425,
3405,
3403,
3401,
3399,
3382,
3375,
3424,
3397,
3395,
3379,
3393,
3423,
3422,
3391,
3421,
3389,
4314,
4313,
4312,
4311,
4310,
4309,
4308,
4307,
4306,
4305,
4304,
4303,
4302,
4301,
4300,
4299,
4298,
4297,
4296,
4295,
4294,
4293,
4292,
4291,
4290,
4289,
4287,
4286,
4285,
4284,
4283,
4282,
4281,
4280,
4279,
4278,
4277,
4276,
4275,
4274,
4273,
4272,
4271,
4270,
4269,
4268,
4267,
4266,
4265,
4264,
4263,
4262,
4151,
4150,
-1,
-1,
4111,
4109,
4103,
4105,
4081,
4083,
4080,
4068,
4101,
4099,
4097,
4095,
4093,
4085,
4077,
4073,
4091,
4069,
4089,
4070,
4087,
4074,
4107,
4072,
4078,
4139,
4004,
4002,
3994,
3998,
3972,
3974,
3971,
3964,
3992,
3990,
3988,
3986,
3984,
3976,
3968,
3961,
3982,
3996,
3980,
3965,
3978,
3962,
4000,
3960,
3969,
4136,
4141,
4137,
4140,
4135,
4138,
4134,
4243,
4241,
4235,
4237,
4213,
4215,
4212,
4200,
4233,
4231,
4229,
4227,
4225,
4217,
4209,
4205,
4223,
4201,
4221,
4202,
4219,
4206,
4239,
4204,
4210,
4257,
4192,
4190,
4184,
4152,
4162,
4164,
4161,
4154,
4182,
4180,
4178,
4176,
4174,
4166,
4158,
4146,
4172,
4186,
4170,
4155,
4168,
4147,
4188,
4145,
4159,
4254,
4259,
4255,
4258,
4253,
4256,
4252,
3885,
3883,
3877,
3879,
3855,
3857,
3854,
3842,
3875,
3873,
3871,
3869,
3867,
3859,
3851,
3847,
3865,
3843,
3863,
3844,
3861,
3848,
3881,
3846,
3852,
3899,
3833,
3831,
3823,
3827,
3801,
3803,
3800,
3793,
3821,
3819,
3817,
3815,
3813,
3805,
3797,
3790,
3811,
3825,
3809,
3794,
3807,
3791,
3829,
3789,
3798,
3896,
3901,
3897,
3900,
3895,
3898,
3894,
3587,
3585,
3579,
3581,
3557,
3559,
3556,
3544,
3577,
3575,
3573,
3571,
3569,
3561,
3553,
3549,
3567,
3545,
3565,
3546,
3563,
3550,
3583,
3548,
3554,
3615,
3535,
3533,
3525,
3529,
3503,
3505,
3502,
3495,
3523,
3521,
3519,
3517,
3515,
3507,
3499,
3492,
3513,
3527,
3511,
3496,
3509,
3493,
3531,
3491,
3500,
3612,
3617,
3613,
3616,
3611,
3614,
3610,
3472,
3470,
3464,
3466,
3442,
3444,
3441,
3429,
3462,
3460,
3458,
3456,
3454,
3446,
3438,
3434,
3452,
3430,
3450,
3431,
3448,
3435,
3468,
3433,
3439,
3486,
3420,
3418,
3410,
3414,
3388,
3390,
3387,
3380,
3408,
3406,
3404,
3402,
3400,
3392,
3384,
3377,
3398,
3412,
3396,
3381,
3394,
3378,
3416,
3376,
3385,
3483,
3488,
3484,
3487,
3482,
3485,
3481,
-1,
-1,
-1,
-1,
4129,
4130,
4121,
4122,
4127,
4128,
4124,
4125,
4132,
4131,
4387,
4388,
4379,
4380,
4385,
4386,
4382,
4383,
4390,
4389,
3737,
3738,
3729,
3730,
3735,
3736,
3732,
3733,
3740,
3739,
3605,
3606,
3597,
3598,
3603,
3604,
3600,
3601,
3608,
3607,
4325,
4326,
4317,
4318,
4323,
4324,
4320,
4321,
4328,
4327,
]

_charnames_194560 = [
549,
548,
547,
546,
545,
544,
543,
542,
541,
540,
539,
538,
537,
536,
535,
534,
532,
531,
530,
529,
528,
527,
526,
525,
524,
523,
522,
521,
520,
519,
518,
517,
515,
514,
513,
512,
511,
510,
509,
508,
507,
506,
505,
504,
503,
502,
501,
500,
498,
497,
496,
495,
494,
493,
492,
491,
490,
489,
488,
487,
486,
485,
484,
483,
481,
480,
479,
478,
477,
476,
475,
474,
473,
472,
471,
470,
469,
468,
467,
466,
464,
463,
462,
461,
460,
459,
458,
457,
456,
455,
454,
453,
452,
451,
450,
449,
447,
446,
445,
444,
443,
442,
441,
440,
439,
438,
437,
436,
435,
434,
433,
432,
430,
429,
428,
427,
426,
425,
424,
423,
422,
421,
420,
419,
418,
417,
416,
415,
413,
412,
411,
410,
409,
408,
407,
406,
405,
404,
403,
402,
401,
400,
399,
398,
396,
395,
394,
393,
392,
391,
390,
389,
388,
387,
386,
385,
384,
383,
382,
381,
379,
378,
377,
376,
375,
374,
373,
372,
371,
370,
369,
368,
367,
366,
365,
364,
362,
361,
360,
359,
358,
357,
356,
355,
354,
353,
352,
351,
350,
349,
348,
347,
345,
344,
343,
342,
341,
340,
339,
338,
337,
336,
335,
334,
333,
332,
331,
330,
328,
327,
326,
325,
324,
323,
322,
321,
320,
319,
318,
317,
316,
315,
314,
313,
311,
310,
309,
308,
307,
306,
305,
304,
303,
302,
301,
300,
299,
298,
297,
296,
294,
293,
292,
291,
290,
289,
288,
287,
286,
285,
284,
283,
282,
281,
280,
279,
276,
275,
274,
273,
272,
271,
270,
269,
268,
267,
266,
265,
264,
263,
262,
261,
259,
258,
257,
256,
255,
254,
253,
252,
251,
250,
249,
248,
247,
246,
245,
244,
242,
241,
240,
239,
238,
237,
236,
235,
234,
233,
232,
231,
230,
229,
228,
227,
225,
224,
223,
222,
221,
220,
219,
218,
217,
216,
215,
214,
213,
212,
211,
210,
208,
207,
206,
205,
204,
203,
202,
201,
200,
199,
198,
197,
196,
195,
194,
193,
191,
190,
189,
188,
187,
186,
185,
184,
183,
182,
181,
180,
179,
178,
177,
176,
174,
173,
172,
171,
170,
169,
168,
167,
166,
165,
164,
163,
162,
161,
160,
159,
157,
156,
155,
154,
153,
152,
151,
150,
149,
148,
147,
146,
145,
144,
143,
142,
140,
139,
138,
137,
136,
135,
134,
133,
132,
131,
130,
129,
128,
127,
126,
125,
123,
122,
121,
120,
119,
118,
117,
116,
115,
114,
113,
112,
111,
110,
109,
108,
106,
105,
104,
103,
102,
101,
100,
99,
98,
97,
96,
95,
94,
93,
92,
91,
89,
88,
87,
86,
85,
84,
83,
82,
81,
80,
79,
78,
77,
76,
75,
74,
72,
71,
70,
69,
68,
67,
66,
65,
64,
63,
62,
61,
60,
59,
58,
57,
55,
54,
53,
52,
51,
50,
49,
48,
47,
46,
45,
44,
43,
42,
41,
40,
38,
37,
36,
35,
34,
33,
32,
31,
30,
29,
28,
27,
26,
25,
24,
23,
21,
20,
19,
18,
17,
16,
15,
14,
13,
12,
11,
10,
9,
8,
7,
6,
567,
566,
565,
564,
563,
562,
561,
560,
559,
558,
557,
556,
555,
554,
553,
552,
582,
581,
580,
579,
578,
577,
576,
575,
574,
573,
572,
571,
570,
569,
]

_charnames_917536 = [
13586,
13603,
13594,
13607,
13571,
13598,
13592,
13591,
13552,
13575,
13590,
13597,
13582,
13608,
13609,
13587,
13567,
13568,
13559,
13560,
13565,
13566,
13562,
13563,
13570,
13569,
13583,
13588,
13554,
13604,
13600,
13595,
13581,
13548,
13547,
13546,
13545,
13544,
13543,
13542,
13541,
13540,
13539,
13538,
13537,
13536,
13535,
13534,
13533,
13532,
13531,
13530,
13529,
13528,
13527,
13526,
13525,
13524,
13523,
13551,
13577,
13574,
13584,
13555,
13601,
13521,
13520,
13519,
13518,
13517,
13516,
13515,
13514,
13513,
13512,
13511,
13510,
13509,
13508,
13507,
13506,
13505,
13504,
13503,
13502,
13501,
13500,
13499,
13498,
13497,
13496,
13553,
13605,
13576,
13606,
1990,
]

_charnames_917760 = [
18641,
18630,
18619,
18774,
18763,
18752,
18741,
18730,
18785,
18796,
18795,
18794,
18793,
18873,
18872,
18871,
18870,
18869,
18868,
18867,
18866,
18865,
18864,
18862,
18861,
18860,
18859,
18858,
18857,
18856,
18855,
18854,
18853,
18851,
18850,
18849,
18848,
18847,
18846,
18845,
18844,
18843,
18842,
18840,
18839,
18838,
18837,
18836,
18835,
18834,
18833,
18832,
18831,
18829,
18828,
18827,
18826,
18825,
18824,
18823,
18822,
18821,
18820,
18818,
18817,
18816,
18815,
18814,
18813,
18812,
18811,
18810,
18809,
18807,
18806,
18805,
18804,
18803,
18802,
18801,
18800,
18799,
18798,
18728,
18727,
18726,
18725,
18724,
18723,
18722,
18721,
18720,
18719,
18717,
18716,
18715,
18714,
18713,
18712,
18711,
18710,
18709,
18708,
18706,
18705,
18704,
18703,
18702,
18701,
18700,
18699,
18698,
18697,
18695,
18694,
18693,
18692,
18691,
18690,
18689,
18688,
18687,
18686,
18684,
18683,
18682,
18681,
18680,
18679,
18678,
18677,
18676,
18675,
18673,
18672,
18671,
18670,
18669,
18668,
18667,
18666,
18665,
18664,
18662,
18661,
18660,
18659,
18658,
18657,
18656,
18655,
18654,
18653,
18651,
18650,
18649,
18648,
18647,
18646,
18645,
18644,
18643,
18642,
18640,
18639,
18638,
18637,
18636,
18635,
18634,
18633,
18632,
18631,
18629,
18628,
18627,
18626,
18625,
18624,
18623,
18622,
18621,
18620,
18784,
18783,
18782,
18781,
18780,
18779,
18778,
18777,
18776,
18775,
18773,
18772,
18771,
18770,
18769,
18768,
18767,
18766,
18765,
18764,
18762,
18761,
18760,
18759,
18758,
18757,
18756,
18755,
18754,
18753,
18751,
18750,
18749,
18748,
18747,
18746,
18745,
18744,
18743,
18742,
18740,
18739,
18738,
18737,
18736,
18735,
18734,
18733,
18732,
18731,
18792,
18791,
18790,
18789,
18788,
18787,
18786,
]

def lookup_charcode(code):
    res = -1
    if 32 <= code <= 126: res = _charnames_32[code-32]
    if 160 <= code <= 577: res = _charnames_160[code-160]
    if 592 <= code <= 1295: res = _charnames_592[code-592]
    if 1329 <= code <= 1479: res = _charnames_1329[code-1329]
    if 1488 <= code <= 1524: res = _charnames_1488[code-1488]
    if code == 1536: res = 8964
    if code == 1537: res = 8882
    if code == 1538: res = 8915
    if code == 1539: res = 8884
    if 1547 <= code <= 1901: res = _charnames_1547[code-1547]
    if 1920 <= code <= 1969: res = _charnames_1920[code-1920]
    if 2305 <= code <= 2416: res = _charnames_2305[code-2305]
    if 2429 <= code <= 2510: res = _charnames_2429[code-2429]
    if 2519 <= code <= 2637: res = _charnames_2519[code-2519]
    if code == 2649: res = 12720
    if code == 2650: res = 12725
    if code == 2651: res = 12753
    if code == 2652: res = 12734
    if code == 2654: res = 12759
    if 2662 <= code <= 2676: res = _charnames_2662[code-2662]
    if 2689 <= code <= 2768: res = _charnames_2689[code-2689]
    if 2784 <= code <= 2801: res = _charnames_2784[code-2784]
    if 2817 <= code <= 2893: res = _charnames_2817[code-2817]
    if 2902 <= code <= 2929: res = _charnames_2902[code-2902]
    if 2946 <= code <= 3021: res = _charnames_2946[code-2946]
    if code == 3031: res = 13742
    if 3046 <= code <= 3149: res = _charnames_3046[code-3046]
    if code == 3157: res = 13864
    if code == 3158: res = 13900
    if 3168 <= code <= 3183: res = _charnames_3168[code-3168]
    if 3202 <= code <= 3277: res = _charnames_3202[code-3202]
    if code == 3285: res = 16877
    if code == 3286: res = 16915
    if 3294 <= code <= 3311: res = _charnames_3294[code-3294]
    if 3330 <= code <= 3405: res = _charnames_3330[code-3330]
    if code == 3415: res = 4554
    if 3424 <= code <= 3439: res = _charnames_3424[code-3424]
    if 3458 <= code <= 3551: res = _charnames_3458[code-3458]
    if code == 3570: res = 16088
    if code == 3571: res = 16087
    if code == 3572: res = 16102
    if 3585 <= code <= 3675: res = _charnames_3585[code-3585]
    if 3713 <= code <= 3805: res = _charnames_3713[code-3713]
    if 3840 <= code <= 4049: res = _charnames_3840[code-3840]
    if 4096 <= code <= 4185: res = _charnames_4096[code-4096]
    if 4256 <= code <= 4293: res = _charnames_4256[code-4256]
    if 4304 <= code <= 5108: res = _charnames_4304[code-4304]
    if 5121 <= code <= 5750: res = _charnames_5121[code-5121]
    if 5760 <= code <= 5872: res = _charnames_5760[code-5760]
    if 5888 <= code <= 5908: res = _charnames_5888[code-5888]
    if 5920 <= code <= 5942: res = _charnames_5920[code-5920]
    if 5952 <= code <= 5971: res = _charnames_5952[code-5952]
    if 5984 <= code <= 6003: res = _charnames_5984[code-5984]
    if 6016 <= code <= 6263: res = _charnames_6016[code-6016]
    if 6272 <= code <= 6313: res = _charnames_6272[code-6272]
    if 6400 <= code <= 6516: res = _charnames_6400[code-6400]
    if 6528 <= code <= 6687: res = _charnames_6528[code-6528]
    if 7424 <= code <= 7619: res = _charnames_7424[code-7424]
    if 7680 <= code <= 8340: res = _charnames_7680[code-7680]
    if 8352 <= code <= 8373: res = _charnames_8352[code-8352]
    if 8400 <= code <= 8427: res = _charnames_8400[code-8400]
    if 8448 <= code <= 8579: res = _charnames_8448[code-8448]
    if 8592 <= code <= 9179: res = _charnames_8592[code-8592]
    if 9216 <= code <= 9254: res = _charnames_9216[code-9216]
    if 9280 <= code <= 9290: res = _charnames_9280[code-9280]
    if 9312 <= code <= 9905: res = _charnames_9312[code-9312]
    if 9985 <= code <= 10182: res = _charnames_9985[code-9985]
    if 10192 <= code <= 11027: res = _charnames_10192[code-10192]
    if 11264 <= code <= 11358: res = _charnames_11264[code-11264]
    if 11392 <= code <= 11498: res = _charnames_11392[code-11392]
    if 11513 <= code <= 11557: res = _charnames_11513[code-11513]
    if 11568 <= code <= 11621: res = _charnames_11568[code-11568]
    if code == 11631: res = 13475
    if 11648 <= code <= 11670: res = _charnames_11648[code-11648]
    if 11680 <= code <= 11742: res = _charnames_11680[code-11680]
    if 11776 <= code <= 11805: res = _charnames_11776[code-11776]
    if 11904 <= code <= 12019: res = _charnames_11904[code-11904]
    if 12032 <= code <= 12245: res = _charnames_12032[code-12032]
    if 12272 <= code <= 12727: res = _charnames_12272[code-12272]
    if 12736 <= code <= 12751: res = _charnames_12736[code-12736]
    if 12784 <= code <= 12867: res = _charnames_12784[code-12784]
    if 12880 <= code <= 13311: res = _charnames_12880[code-12880]
    if 19904 <= code <= 19967: res = _charnames_19904[code-19904]
    if 40960 <= code <= 42182: res = _charnames_40960[code-40960]
    if 42752 <= code <= 42774: res = _charnames_42752[code-42752]
    if 43008 <= code <= 43051: res = _charnames_43008[code-43008]
    if 63744 <= code <= 64217: res = _charnames_63744[code-63744]
    if 64256 <= code <= 64262: res = _charnames_64256[code-64256]
    if 64275 <= code <= 64433: res = _charnames_64275[code-64275]
    if 64467 <= code <= 64831: res = _charnames_64467[code-64467]
    if 64848 <= code <= 64967: res = _charnames_64848[code-64848]
    if 65008 <= code <= 65059: res = _charnames_65008[code-65008]
    if 65072 <= code <= 65518: res = _charnames_65072[code-65072]
    if 65529 <= code <= 65629: res = _charnames_65529[code-65529]
    if 65664 <= code <= 65930: res = _charnames_65664[code-65664]
    if 66304 <= code <= 66339: res = _charnames_66304[code-66304]
    if 66352 <= code <= 66378: res = _charnames_66352[code-66352]
    if 66432 <= code <= 66517: res = _charnames_66432[code-66432]
    if 66560 <= code <= 66729: res = _charnames_66560[code-66560]
    if 67584 <= code <= 67647: res = _charnames_67584[code-67584]
    if 68096 <= code <= 68167: res = _charnames_68096[code-68096]
    if 68176 <= code <= 68184: res = _charnames_68176[code-68176]
    if 118784 <= code <= 119029: res = _charnames_118784[code-118784]
    if 119040 <= code <= 119261: res = _charnames_119040[code-119040]
    if 119296 <= code <= 119365: res = _charnames_119296[code-119296]
    if 119552 <= code <= 119638: res = _charnames_119552[code-119552]
    if 119808 <= code <= 120831: res = _charnames_119808[code-119808]
    if 194560 <= code <= 195101: res = _charnames_194560[code-194560]
    if code == 917505: res = 6779
    if 917536 <= code <= 917631: res = _charnames_917536[code-917536]
    if 917760 <= code <= 917999: res = _charnames_917760[code-917760]
    if res == -1: raise KeyError, code
    return name_of_node(res)

# the following dictionary is used by modules that take this as a base
_orig_names = {
'ACCOUNT OF': 8448,
'ACTIVATE ARABIC FORM SHAPING': 8301,
'ACTIVATE SYMMETRIC SWAPPING': 8299,
'ACUTE ACCENT': 180,
'ACUTE ANGLE': 10655,
'ADDRESSED TO THE SUBJECT': 8449,
'ADI SHAKTI': 9772,
'AEGEAN CHECK MARK': 65794,
'AEGEAN DRY MEASURE FIRST SUBUNIT': 65852,
'AEGEAN LIQUID MEASURE FIRST SUBUNIT': 65853,
'AEGEAN MEASURE SECOND SUBUNIT': 65854,
'AEGEAN MEASURE THIRD SUBUNIT': 65855,
'AEGEAN NUMBER EIGHT': 65806,
'AEGEAN NUMBER EIGHT HUNDRED': 65824,
'AEGEAN NUMBER EIGHT THOUSAND': 65833,
'AEGEAN NUMBER EIGHTY': 65815,
'AEGEAN NUMBER EIGHTY THOUSAND': 65842,
'AEGEAN NUMBER FIFTY': 65812,
'AEGEAN NUMBER FIFTY THOUSAND': 65839,
'AEGEAN NUMBER FIVE': 65803,
'AEGEAN NUMBER FIVE HUNDRED': 65821,
'AEGEAN NUMBER FIVE THOUSAND': 65830,
'AEGEAN NUMBER FORTY': 65811,
'AEGEAN NUMBER FORTY THOUSAND': 65838,
'AEGEAN NUMBER FOUR': 65802,
'AEGEAN NUMBER FOUR HUNDRED': 65820,
'AEGEAN NUMBER FOUR THOUSAND': 65829,
'AEGEAN NUMBER NINE': 65807,
'AEGEAN NUMBER NINE HUNDRED': 65825,
'AEGEAN NUMBER NINE THOUSAND': 65834,
'AEGEAN NUMBER NINETY': 65816,
'AEGEAN NUMBER NINETY THOUSAND': 65843,
'AEGEAN NUMBER ONE': 65799,
'AEGEAN NUMBER ONE HUNDRED': 65817,
'AEGEAN NUMBER ONE THOUSAND': 65826,
'AEGEAN NUMBER SEVEN': 65805,
'AEGEAN NUMBER SEVEN HUNDRED': 65823,
'AEGEAN NUMBER SEVEN THOUSAND': 65832,
'AEGEAN NUMBER SEVENTY': 65814,
'AEGEAN NUMBER SEVENTY THOUSAND': 65841,
'AEGEAN NUMBER SIX': 65804,
'AEGEAN NUMBER SIX HUNDRED': 65822,
'AEGEAN NUMBER SIX THOUSAND': 65831,
'AEGEAN NUMBER SIXTY': 65813,
'AEGEAN NUMBER SIXTY THOUSAND': 65840,
'AEGEAN NUMBER TEN': 65808,
'AEGEAN NUMBER TEN THOUSAND': 65835,
'AEGEAN NUMBER THIRTY': 65810,
'AEGEAN NUMBER THIRTY THOUSAND': 65837,
'AEGEAN NUMBER THREE': 65801,
'AEGEAN NUMBER THREE HUNDRED': 65819,
'AEGEAN NUMBER THREE THOUSAND': 65828,
'AEGEAN NUMBER TWENTY': 65809,
'AEGEAN NUMBER TWENTY THOUSAND': 65836,
'AEGEAN NUMBER TWO': 65800,
'AEGEAN NUMBER TWO HUNDRED': 65818,
'AEGEAN NUMBER TWO THOUSAND': 65827,
'AEGEAN WEIGHT BASE UNIT': 65847,
'AEGEAN WEIGHT FIRST SUBUNIT': 65848,
'AEGEAN WEIGHT FOURTH SUBUNIT': 65851,
'AEGEAN WEIGHT SECOND SUBUNIT': 65849,
'AEGEAN WEIGHT THIRD SUBUNIT': 65850,
'AEGEAN WORD SEPARATOR DOT': 65793,
'AEGEAN WORD SEPARATOR LINE': 65792,
'AFGHANI SIGN': 1547,
'AIRPLANE': 9992,
'ALEF SYMBOL': 8501,
'ALEMBIC': 9879,
'ALL AROUND-PROFILE': 9006,
'ALL EQUAL TO': 8780,
'ALMOST EQUAL OR EQUAL TO': 8778,
'ALMOST EQUAL TO': 8776,
'ALMOST EQUAL TO WITH CIRCUMFLEX ACCENT': 10863,
'ALTERNATIVE KEY SYMBOL': 9095,
'AMALGAMATION OR COPRODUCT': 10815,
'AMPERSAND': 38,
'ANCHOR': 9875,
'AND WITH DOT': 10193,
'ANGLE': 8736,
'ANGLE WITH S INSIDE': 10654,
'ANGLE WITH UNDERBAR': 10660,
'ANGSTROM SIGN': 8491,
'ANKH': 9765,
'ANTICLOCKWISE CLOSED CIRCLE ARROW': 10560,
'ANTICLOCKWISE CONTOUR INTEGRAL': 8755,
'ANTICLOCKWISE GAPPED CIRCLE ARROW': 10226,
'ANTICLOCKWISE INTEGRATION': 10769,
'ANTICLOCKWISE OPEN CIRCLE ARROW': 8634,
'ANTICLOCKWISE TOP SEMICIRCLE ARROW': 8630,
'APL FUNCTIONAL SYMBOL ALPHA': 9082,
'APL FUNCTIONAL SYMBOL ALPHA UNDERBAR': 9078,
'APL FUNCTIONAL SYMBOL BACKSLASH BAR': 9024,
'APL FUNCTIONAL SYMBOL CIRCLE BACKSLASH': 9033,
'APL FUNCTIONAL SYMBOL CIRCLE DIAERESIS': 9061,
'APL FUNCTIONAL SYMBOL CIRCLE JOT': 9022,
'APL FUNCTIONAL SYMBOL CIRCLE STAR': 9055,
'APL FUNCTIONAL SYMBOL CIRCLE STILE': 9021,
'APL FUNCTIONAL SYMBOL CIRCLE UNDERBAR': 9052,
'APL FUNCTIONAL SYMBOL COMMA BAR': 9066,
'APL FUNCTIONAL SYMBOL DEL DIAERESIS': 9058,
'APL FUNCTIONAL SYMBOL DEL STILE': 9042,
'APL FUNCTIONAL SYMBOL DEL TILDE': 9067,
'APL FUNCTIONAL SYMBOL DELTA STILE': 9035,
'APL FUNCTIONAL SYMBOL DELTA UNDERBAR': 9049,
'APL FUNCTIONAL SYMBOL DIAMOND UNDERBAR': 9050,
'APL FUNCTIONAL SYMBOL DOWN CARET TILDE': 9073,
'APL FUNCTIONAL SYMBOL DOWN SHOE STILE': 9062,
'APL FUNCTIONAL SYMBOL DOWN TACK JOT': 9038,
'APL FUNCTIONAL SYMBOL DOWN TACK UNDERBAR': 9034,
'APL FUNCTIONAL SYMBOL DOWNWARDS VANE': 9046,
'APL FUNCTIONAL SYMBOL EPSILON UNDERBAR': 9079,
'APL FUNCTIONAL SYMBOL GREATER-THAN DIAERESIS': 9065,
'APL FUNCTIONAL SYMBOL I-BEAM': 9014,
'APL FUNCTIONAL SYMBOL IOTA': 9075,
'APL FUNCTIONAL SYMBOL IOTA UNDERBAR': 9080,
'APL FUNCTIONAL SYMBOL JOT DIAERESIS': 9060,
'APL FUNCTIONAL SYMBOL JOT UNDERBAR': 9051,
'APL FUNCTIONAL SYMBOL LEFT SHOE STILE': 9063,
'APL FUNCTIONAL SYMBOL LEFTWARDS VANE': 9029,
'APL FUNCTIONAL SYMBOL OMEGA': 9077,
'APL FUNCTIONAL SYMBOL OMEGA UNDERBAR': 9081,
'APL FUNCTIONAL SYMBOL QUAD': 9109,
'APL FUNCTIONAL SYMBOL QUAD BACKSLASH': 9026,
'APL FUNCTIONAL SYMBOL QUAD CIRCLE': 9020,
'APL FUNCTIONAL SYMBOL QUAD COLON': 9056,
'APL FUNCTIONAL SYMBOL QUAD DEL': 9044,
'APL FUNCTIONAL SYMBOL QUAD DELTA': 9037,
'APL FUNCTIONAL SYMBOL QUAD DIAMOND': 9018,
'APL FUNCTIONAL SYMBOL QUAD DIVIDE': 9017,
'APL FUNCTIONAL SYMBOL QUAD DOWN CARET': 9036,
'APL FUNCTIONAL SYMBOL QUAD DOWNWARDS ARROW': 9047,
'APL FUNCTIONAL SYMBOL QUAD EQUAL': 9016,
'APL FUNCTIONAL SYMBOL QUAD GREATER-THAN': 9028,
'APL FUNCTIONAL SYMBOL QUAD JOT': 9019,
'APL FUNCTIONAL SYMBOL QUAD LEFTWARDS ARROW': 9031,
'APL FUNCTIONAL SYMBOL QUAD LESS-THAN': 9027,
'APL FUNCTIONAL SYMBOL QUAD NOT EQUAL': 9071,
'APL FUNCTIONAL SYMBOL QUAD QUESTION': 9072,
'APL FUNCTIONAL SYMBOL QUAD RIGHTWARDS ARROW': 9032,
'APL FUNCTIONAL SYMBOL QUAD SLASH': 9025,
'APL FUNCTIONAL SYMBOL QUAD UP CARET': 9043,
'APL FUNCTIONAL SYMBOL QUAD UPWARDS ARROW': 9040,
'APL FUNCTIONAL SYMBOL QUOTE QUAD': 9054,
'APL FUNCTIONAL SYMBOL QUOTE UNDERBAR': 9048,
'APL FUNCTIONAL SYMBOL RHO': 9076,
'APL FUNCTIONAL SYMBOL RIGHTWARDS VANE': 9030,
'APL FUNCTIONAL SYMBOL SEMICOLON UNDERBAR': 9070,
'APL FUNCTIONAL SYMBOL SLASH BAR': 9023,
'APL FUNCTIONAL SYMBOL SQUISH QUAD': 9015,
'APL FUNCTIONAL SYMBOL STAR DIAERESIS': 9059,
'APL FUNCTIONAL SYMBOL STILE TILDE': 9069,
'APL FUNCTIONAL SYMBOL TILDE DIAERESIS': 9064,
'APL FUNCTIONAL SYMBOL UP CARET TILDE': 9074,
'APL FUNCTIONAL SYMBOL UP SHOE JOT': 9053,
'APL FUNCTIONAL SYMBOL UP TACK DIAERESIS': 9057,
'APL FUNCTIONAL SYMBOL UP TACK JOT': 9045,
'APL FUNCTIONAL SYMBOL UP TACK OVERBAR': 9041,
'APL FUNCTIONAL SYMBOL UPWARDS VANE': 9039,
'APL FUNCTIONAL SYMBOL ZILDE': 9068,
'APOSTROPHE': 39,
'APPROACHES THE LIMIT': 8784,
'APPROXIMATELY BUT NOT ACTUALLY EQUAL TO': 8774,
'APPROXIMATELY EQUAL OR EQUAL TO': 10864,
'APPROXIMATELY EQUAL TO': 8773,
'APPROXIMATELY EQUAL TO OR THE IMAGE OF': 8786,
'AQUARIUS': 9810,
'ARABIC COMMA': 1548,
'ARABIC DAMMA': 1615,
'ARABIC DAMMA ISOLATED FORM': 65144,
'ARABIC DAMMA MEDIAL FORM': 65145,
'ARABIC DAMMATAN': 1612,
'ARABIC DAMMATAN ISOLATED FORM': 65138,
'ARABIC DATE SEPARATOR': 1549,
'ARABIC DECIMAL SEPARATOR': 1643,
'ARABIC EMPTY CENTRE HIGH STOP': 1771,
'ARABIC EMPTY CENTRE LOW STOP': 1770,
'ARABIC END OF AYAH': 1757,
'ARABIC FATHA': 1614,
'ARABIC FATHA ISOLATED FORM': 65142,
'ARABIC FATHA MEDIAL FORM': 65143,
'ARABIC FATHA WITH TWO DOTS': 1630,
'ARABIC FATHATAN': 1611,
'ARABIC FATHATAN ISOLATED FORM': 65136,
'ARABIC FIVE POINTED STAR': 1645,
'ARABIC FOOTNOTE MARKER': 1538,
'ARABIC FULL STOP': 1748,
'ARABIC HAMZA ABOVE': 1620,
'ARABIC HAMZA BELOW': 1621,
'ARABIC INVERTED DAMMA': 1623,
'ARABIC KASRA': 1616,
'ARABIC KASRA ISOLATED FORM': 65146,
'ARABIC KASRA MEDIAL FORM': 65147,
'ARABIC KASRATAN': 1613,
'ARABIC KASRATAN ISOLATED FORM': 65140,
'ARABIC LETTER AE': 1749,
'ARABIC LETTER AIN': 1593,
'ARABIC LETTER AIN FINAL FORM': 65226,
'ARABIC LETTER AIN INITIAL FORM': 65227,
'ARABIC LETTER AIN ISOLATED FORM': 65225,
'ARABIC LETTER AIN MEDIAL FORM': 65228,
'ARABIC LETTER AIN WITH THREE DOTS ABOVE': 1696,
'ARABIC LETTER AIN WITH THREE DOTS POINTING DOWNWARDS ABOVE': 1886,
'ARABIC LETTER AIN WITH TWO DOTS ABOVE': 1885,
'ARABIC LETTER AIN WITH TWO DOTS VERTICALLY ABOVE': 1887,
'ARABIC LETTER ALEF': 1575,
'ARABIC LETTER ALEF FINAL FORM': 65166,
'ARABIC LETTER ALEF ISOLATED FORM': 65165,
'ARABIC LETTER ALEF MAKSURA': 1609,
'ARABIC LETTER ALEF MAKSURA FINAL FORM': 65264,
'ARABIC LETTER ALEF MAKSURA ISOLATED FORM': 65263,
'ARABIC LETTER ALEF WASLA': 1649,
'ARABIC LETTER ALEF WASLA FINAL FORM': 64337,
'ARABIC LETTER ALEF WASLA ISOLATED FORM': 64336,
'ARABIC LETTER ALEF WITH HAMZA ABOVE': 1571,
'ARABIC LETTER ALEF WITH HAMZA ABOVE FINAL FORM': 65156,
'ARABIC LETTER ALEF WITH HAMZA ABOVE ISOLATED FORM': 65155,
'ARABIC LETTER ALEF WITH HAMZA BELOW': 1573,
'ARABIC LETTER ALEF WITH HAMZA BELOW FINAL FORM': 65160,
'ARABIC LETTER ALEF WITH HAMZA BELOW ISOLATED FORM': 65159,
'ARABIC LETTER ALEF WITH MADDA ABOVE': 1570,
'ARABIC LETTER ALEF WITH MADDA ABOVE FINAL FORM': 65154,
'ARABIC LETTER ALEF WITH MADDA ABOVE ISOLATED FORM': 65153,
'ARABIC LETTER ALEF WITH WAVY HAMZA ABOVE': 1650,
'ARABIC LETTER ALEF WITH WAVY HAMZA BELOW': 1651,
'ARABIC LETTER BEEH': 1659,
'ARABIC LETTER BEEH FINAL FORM': 64339,
'ARABIC LETTER BEEH INITIAL FORM': 64340,
'ARABIC LETTER BEEH ISOLATED FORM': 64338,
'ARABIC LETTER BEEH MEDIAL FORM': 64341,
'ARABIC LETTER BEH': 1576,
'ARABIC LETTER BEH FINAL FORM': 65168,
'ARABIC LETTER BEH INITIAL FORM': 65169,
'ARABIC LETTER BEH ISOLATED FORM': 65167,
'ARABIC LETTER BEH MEDIAL FORM': 65170,
'ARABIC LETTER BEH WITH DOT BELOW AND THREE DOTS ABOVE': 1873,
'ARABIC LETTER BEH WITH INVERTED SMALL V BELOW': 1877,
'ARABIC LETTER BEH WITH SMALL V': 1878,
'ARABIC LETTER BEH WITH THREE DOTS HORIZONTALLY BELOW': 1872,
'ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW': 1874,
'ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW AND TWO DOTS ABOVE': 1875,
'ARABIC LETTER BEH WITH TWO DOTS BELOW AND DOT ABOVE': 1876,
'ARABIC LETTER BEHEH': 1664,
'ARABIC LETTER BEHEH FINAL FORM': 64347,
'ARABIC LETTER BEHEH INITIAL FORM': 64348,
'ARABIC LETTER BEHEH ISOLATED FORM': 64346,
'ARABIC LETTER BEHEH MEDIAL FORM': 64349,
'ARABIC LETTER DAD': 1590,
'ARABIC LETTER DAD FINAL FORM': 65214,
'ARABIC LETTER DAD INITIAL FORM': 65215,
'ARABIC LETTER DAD ISOLATED FORM': 65213,
'ARABIC LETTER DAD MEDIAL FORM': 65216,
'ARABIC LETTER DAD WITH DOT BELOW': 1787,
'ARABIC LETTER DAHAL': 1676,
'ARABIC LETTER DAHAL FINAL FORM': 64389,
'ARABIC LETTER DAHAL ISOLATED FORM': 64388,
'ARABIC LETTER DAL': 1583,
'ARABIC LETTER DAL FINAL FORM': 65194,
'ARABIC LETTER DAL ISOLATED FORM': 65193,
'ARABIC LETTER DAL WITH DOT BELOW': 1674,
'ARABIC LETTER DAL WITH DOT BELOW AND SMALL TAH': 1675,
'ARABIC LETTER DAL WITH FOUR DOTS ABOVE': 1680,
'ARABIC LETTER DAL WITH INVERTED SMALL V BELOW': 1882,
'ARABIC LETTER DAL WITH INVERTED V': 1774,
'ARABIC LETTER DAL WITH RING': 1673,
'ARABIC LETTER DAL WITH THREE DOTS ABOVE DOWNWARDS': 1679,
'ARABIC LETTER DAL WITH TWO DOTS VERTICALLY BELOW AND SMALL TAH': 1881,
'ARABIC LETTER DDAHAL': 1677,
'ARABIC LETTER DDAHAL FINAL FORM': 64387,
'ARABIC LETTER DDAHAL ISOLATED FORM': 64386,
'ARABIC LETTER DDAL': 1672,
'ARABIC LETTER DDAL FINAL FORM': 64393,
'ARABIC LETTER DDAL ISOLATED FORM': 64392,
'ARABIC LETTER DOTLESS BEH': 1646,
'ARABIC LETTER DOTLESS FEH': 1697,
'ARABIC LETTER DOTLESS QAF': 1647,
'ARABIC LETTER DUL': 1678,
'ARABIC LETTER DUL FINAL FORM': 64391,
'ARABIC LETTER DUL ISOLATED FORM': 64390,
'ARABIC LETTER DYEH': 1668,
'ARABIC LETTER DYEH FINAL FORM': 64371,
'ARABIC LETTER DYEH INITIAL FORM': 64372,
'ARABIC LETTER DYEH ISOLATED FORM': 64370,
'ARABIC LETTER DYEH MEDIAL FORM': 64373,
'ARABIC LETTER E': 1744,
'ARABIC LETTER E FINAL FORM': 64485,
'ARABIC LETTER E INITIAL FORM': 64486,
'ARABIC LETTER E ISOLATED FORM': 64484,
'ARABIC LETTER E MEDIAL FORM': 64487,
'ARABIC LETTER FARSI YEH': 1740,
'ARABIC LETTER FARSI YEH FINAL FORM': 64509,
'ARABIC LETTER FARSI YEH INITIAL FORM': 64510,
'ARABIC LETTER FARSI YEH ISOLATED FORM': 64508,
'ARABIC LETTER FARSI YEH MEDIAL FORM': 64511,
'ARABIC LETTER FEH': 1601,
'ARABIC LETTER FEH FINAL FORM': 65234,
'ARABIC LETTER FEH INITIAL FORM': 65235,
'ARABIC LETTER FEH ISOLATED FORM': 65233,
'ARABIC LETTER FEH MEDIAL FORM': 65236,
'ARABIC LETTER FEH WITH DOT BELOW': 1699,
'ARABIC LETTER FEH WITH DOT MOVED BELOW': 1698,
'ARABIC LETTER FEH WITH THREE DOTS BELOW': 1701,
'ARABIC LETTER FEH WITH THREE DOTS POINTING UPWARDS BELOW': 1889,
'ARABIC LETTER FEH WITH TWO DOTS BELOW': 1888,
'ARABIC LETTER GAF': 1711,
'ARABIC LETTER GAF FINAL FORM': 64403,
'ARABIC LETTER GAF INITIAL FORM': 64404,
'ARABIC LETTER GAF ISOLATED FORM': 64402,
'ARABIC LETTER GAF MEDIAL FORM': 64405,
'ARABIC LETTER GAF WITH RING': 1712,
'ARABIC LETTER GAF WITH THREE DOTS ABOVE': 1716,
'ARABIC LETTER GAF WITH TWO DOTS BELOW': 1714,
'ARABIC LETTER GHAIN': 1594,
'ARABIC LETTER GHAIN FINAL FORM': 65230,
'ARABIC LETTER GHAIN INITIAL FORM': 65231,
'ARABIC LETTER GHAIN ISOLATED FORM': 65229,
'ARABIC LETTER GHAIN MEDIAL FORM': 65232,
'ARABIC LETTER GHAIN WITH DOT BELOW': 1788,
'ARABIC LETTER GUEH': 1715,
'ARABIC LETTER GUEH FINAL FORM': 64407,
'ARABIC LETTER GUEH INITIAL FORM': 64408,
'ARABIC LETTER GUEH ISOLATED FORM': 64406,
'ARABIC LETTER GUEH MEDIAL FORM': 64409,
'ARABIC LETTER HAH': 1581,
'ARABIC LETTER HAH FINAL FORM': 65186,
'ARABIC LETTER HAH INITIAL FORM': 65187,
'ARABIC LETTER HAH ISOLATED FORM': 65185,
'ARABIC LETTER HAH MEDIAL FORM': 65188,
'ARABIC LETTER HAH WITH HAMZA ABOVE': 1665,
'ARABIC LETTER HAH WITH THREE DOTS ABOVE': 1669,
'ARABIC LETTER HAH WITH THREE DOTS POINTING UPWARDS BELOW': 1880,
'ARABIC LETTER HAH WITH TWO DOTS ABOVE': 1879,
'ARABIC LETTER HAH WITH TWO DOTS VERTICAL ABOVE': 1666,
'ARABIC LETTER HAMZA': 1569,
'ARABIC LETTER HAMZA ISOLATED FORM': 65152,
'ARABIC LETTER HEH': 1607,
'ARABIC LETTER HEH DOACHASHMEE': 1726,
'ARABIC LETTER HEH DOACHASHMEE FINAL FORM': 64427,
'ARABIC LETTER HEH DOACHASHMEE INITIAL FORM': 64428,
'ARABIC LETTER HEH DOACHASHMEE ISOLATED FORM': 64426,
'ARABIC LETTER HEH DOACHASHMEE MEDIAL FORM': 64429,
'ARABIC LETTER HEH FINAL FORM': 65258,
'ARABIC LETTER HEH GOAL': 1729,
'ARABIC LETTER HEH GOAL FINAL FORM': 64423,
'ARABIC LETTER HEH GOAL INITIAL FORM': 64424,
'ARABIC LETTER HEH GOAL ISOLATED FORM': 64422,
'ARABIC LETTER HEH GOAL MEDIAL FORM': 64425,
'ARABIC LETTER HEH GOAL WITH HAMZA ABOVE': 1730,
'ARABIC LETTER HEH INITIAL FORM': 65259,
'ARABIC LETTER HEH ISOLATED FORM': 65257,
'ARABIC LETTER HEH MEDIAL FORM': 65260,
'ARABIC LETTER HEH WITH INVERTED V': 1791,
'ARABIC LETTER HEH WITH YEH ABOVE': 1728,
'ARABIC LETTER HEH WITH YEH ABOVE FINAL FORM': 64421,
'ARABIC LETTER HEH WITH YEH ABOVE ISOLATED FORM': 64420,
'ARABIC LETTER HIGH HAMZA': 1652,
'ARABIC LETTER HIGH HAMZA ALEF': 1653,
'ARABIC LETTER HIGH HAMZA WAW': 1654,
'ARABIC LETTER HIGH HAMZA YEH': 1656,
'ARABIC LETTER JEEM': 1580,
'ARABIC LETTER JEEM FINAL FORM': 65182,
'ARABIC LETTER JEEM INITIAL FORM': 65183,
'ARABIC LETTER JEEM ISOLATED FORM': 65181,
'ARABIC LETTER JEEM MEDIAL FORM': 65184,
'ARABIC LETTER JEH': 1688,
'ARABIC LETTER JEH FINAL FORM': 64395,
'ARABIC LETTER JEH ISOLATED FORM': 64394,
'ARABIC LETTER KAF': 1603,
'ARABIC LETTER KAF FINAL FORM': 65242,
'ARABIC LETTER KAF INITIAL FORM': 65243,
'ARABIC LETTER KAF ISOLATED FORM': 65241,
'ARABIC LETTER KAF MEDIAL FORM': 65244,
'ARABIC LETTER KAF WITH DOT ABOVE': 1708,
'ARABIC LETTER KAF WITH RING': 1707,
'ARABIC LETTER KAF WITH THREE DOTS BELOW': 1710,
'ARABIC LETTER KEHEH': 1705,
'ARABIC LETTER KEHEH FINAL FORM': 64399,
'ARABIC LETTER KEHEH INITIAL FORM': 64400,
'ARABIC LETTER KEHEH ISOLATED FORM': 64398,
'ARABIC LETTER KEHEH MEDIAL FORM': 64401,
'ARABIC LETTER KEHEH WITH DOT ABOVE': 1890,
'ARABIC LETTER KEHEH WITH THREE DOTS ABOVE': 1891,
'ARABIC LETTER KEHEH WITH THREE DOTS POINTING UPWARDS BELOW': 1892,
'ARABIC LETTER KHAH': 1582,
'ARABIC LETTER KHAH FINAL FORM': 65190,
'ARABIC LETTER KHAH INITIAL FORM': 65191,
'ARABIC LETTER KHAH ISOLATED FORM': 65189,
'ARABIC LETTER KHAH MEDIAL FORM': 65192,
'ARABIC LETTER KIRGHIZ OE': 1733,
'ARABIC LETTER KIRGHIZ OE FINAL FORM': 64481,
'ARABIC LETTER KIRGHIZ OE ISOLATED FORM': 64480,
'ARABIC LETTER KIRGHIZ YU': 1737,
'ARABIC LETTER KIRGHIZ YU FINAL FORM': 64483,
'ARABIC LETTER KIRGHIZ YU ISOLATED FORM': 64482,
'ARABIC LETTER LAM': 1604,
'ARABIC LETTER LAM FINAL FORM': 65246,
'ARABIC LETTER LAM INITIAL FORM': 65247,
'ARABIC LETTER LAM ISOLATED FORM': 65245,
'ARABIC LETTER LAM MEDIAL FORM': 65248,
'ARABIC LETTER LAM WITH BAR': 1898,
'ARABIC LETTER LAM WITH DOT ABOVE': 1718,
'ARABIC LETTER LAM WITH SMALL V': 1717,
'ARABIC LETTER LAM WITH THREE DOTS ABOVE': 1719,
'ARABIC LETTER LAM WITH THREE DOTS BELOW': 1720,
'ARABIC LETTER MEEM': 1605,
'ARABIC LETTER MEEM FINAL FORM': 65250,
'ARABIC LETTER MEEM INITIAL FORM': 65251,
'ARABIC LETTER MEEM ISOLATED FORM': 65249,
'ARABIC LETTER MEEM MEDIAL FORM': 65252,
'ARABIC LETTER MEEM WITH DOT ABOVE': 1893,
'ARABIC LETTER MEEM WITH DOT BELOW': 1894,
'ARABIC LETTER NG': 1709,
'ARABIC LETTER NG FINAL FORM': 64468,
'ARABIC LETTER NG INITIAL FORM': 64469,
'ARABIC LETTER NG ISOLATED FORM': 64467,
'ARABIC LETTER NG MEDIAL FORM': 64470,
'ARABIC LETTER NGOEH': 1713,
'ARABIC LETTER NGOEH FINAL FORM': 64411,
'ARABIC LETTER NGOEH INITIAL FORM': 64412,
'ARABIC LETTER NGOEH ISOLATED FORM': 64410,
'ARABIC LETTER NGOEH MEDIAL FORM': 64413,
'ARABIC LETTER NOON': 1606,
'ARABIC LETTER NOON FINAL FORM': 65254,
'ARABIC LETTER NOON GHUNNA': 1722,
'ARABIC LETTER NOON GHUNNA FINAL FORM': 64415,
'ARABIC LETTER NOON GHUNNA ISOLATED FORM': 64414,
'ARABIC LETTER NOON INITIAL FORM': 65255,
'ARABIC LETTER NOON ISOLATED FORM': 65253,
'ARABIC LETTER NOON MEDIAL FORM': 65256,
'ARABIC LETTER NOON WITH DOT BELOW': 1721,
'ARABIC LETTER NOON WITH RING': 1724,
'ARABIC LETTER NOON WITH SMALL TAH': 1896,
'ARABIC LETTER NOON WITH SMALL V': 1897,
'ARABIC LETTER NOON WITH THREE DOTS ABOVE': 1725,
'ARABIC LETTER NOON WITH TWO DOTS BELOW': 1895,
'ARABIC LETTER NYEH': 1667,
'ARABIC LETTER NYEH FINAL FORM': 64375,
'ARABIC LETTER NYEH INITIAL FORM': 64376,
'ARABIC LETTER NYEH ISOLATED FORM': 64374,
'ARABIC LETTER NYEH MEDIAL FORM': 64377,
'ARABIC LETTER OE': 1734,
'ARABIC LETTER OE FINAL FORM': 64474,
'ARABIC LETTER OE ISOLATED FORM': 64473,
'ARABIC LETTER PEH': 1662,
'ARABIC LETTER PEH FINAL FORM': 64343,
'ARABIC LETTER PEH INITIAL FORM': 64344,
'ARABIC LETTER PEH ISOLATED FORM': 64342,
'ARABIC LETTER PEH MEDIAL FORM': 64345,
'ARABIC LETTER PEHEH': 1702,
'ARABIC LETTER PEHEH FINAL FORM': 64367,
'ARABIC LETTER PEHEH INITIAL FORM': 64368,
'ARABIC LETTER PEHEH ISOLATED FORM': 64366,
'ARABIC LETTER PEHEH MEDIAL FORM': 64369,
'ARABIC LETTER QAF': 1602,
'ARABIC LETTER QAF FINAL FORM': 65238,
'ARABIC LETTER QAF INITIAL FORM': 65239,
'ARABIC LETTER QAF ISOLATED FORM': 65237,
'ARABIC LETTER QAF MEDIAL FORM': 65240,
'ARABIC LETTER QAF WITH DOT ABOVE': 1703,
'ARABIC LETTER QAF WITH THREE DOTS ABOVE': 1704,
'ARABIC LETTER REH': 1585,
'ARABIC LETTER REH FINAL FORM': 65198,
'ARABIC LETTER REH ISOLATED FORM': 65197,
'ARABIC LETTER REH WITH DOT BELOW': 1684,
'ARABIC LETTER REH WITH DOT BELOW AND DOT ABOVE': 1686,
'ARABIC LETTER REH WITH FOUR DOTS ABOVE': 1689,
'ARABIC LETTER REH WITH HAMZA ABOVE': 1900,
'ARABIC LETTER REH WITH INVERTED V': 1775,
'ARABIC LETTER REH WITH RING': 1683,
'ARABIC LETTER REH WITH SMALL V': 1682,
'ARABIC LETTER REH WITH SMALL V BELOW': 1685,
'ARABIC LETTER REH WITH STROKE': 1883,
'ARABIC LETTER REH WITH TWO DOTS ABOVE': 1687,
'ARABIC LETTER REH WITH TWO DOTS VERTICALLY ABOVE': 1899,
'ARABIC LETTER RNOON': 1723,
'ARABIC LETTER RNOON FINAL FORM': 64417,
'ARABIC LETTER RNOON INITIAL FORM': 64418,
'ARABIC LETTER RNOON ISOLATED FORM': 64416,
'ARABIC LETTER RNOON MEDIAL FORM': 64419,
'ARABIC LETTER RREH': 1681,
'ARABIC LETTER RREH FINAL FORM': 64397,
'ARABIC LETTER RREH ISOLATED FORM': 64396,
'ARABIC LETTER SAD': 1589,
'ARABIC LETTER SAD FINAL FORM': 65210,
'ARABIC LETTER SAD INITIAL FORM': 65211,
'ARABIC LETTER SAD ISOLATED FORM': 65209,
'ARABIC LETTER SAD MEDIAL FORM': 65212,
'ARABIC LETTER SAD WITH THREE DOTS ABOVE': 1694,
'ARABIC LETTER SAD WITH TWO DOTS BELOW': 1693,
'ARABIC LETTER SEEN': 1587,
'ARABIC LETTER SEEN FINAL FORM': 65202,
'ARABIC LETTER SEEN INITIAL FORM': 65203,
'ARABIC LETTER SEEN ISOLATED FORM': 65201,
'ARABIC LETTER SEEN MEDIAL FORM': 65204,
'ARABIC LETTER SEEN WITH DOT BELOW AND DOT ABOVE': 1690,
'ARABIC LETTER SEEN WITH FOUR DOTS ABOVE': 1884,
'ARABIC LETTER SEEN WITH THREE DOTS BELOW': 1691,
'ARABIC LETTER SEEN WITH THREE DOTS BELOW AND THREE DOTS ABOVE': 1692,
'ARABIC LETTER SEEN WITH TWO DOTS VERTICALLY ABOVE': 1901,
'ARABIC LETTER SHEEN': 1588,
'ARABIC LETTER SHEEN FINAL FORM': 65206,
'ARABIC LETTER SHEEN INITIAL FORM': 65207,
'ARABIC LETTER SHEEN ISOLATED FORM': 65205,
'ARABIC LETTER SHEEN MEDIAL FORM': 65208,
'ARABIC LETTER SHEEN WITH DOT BELOW': 1786,
'ARABIC LETTER SUPERSCRIPT ALEF': 1648,
'ARABIC LETTER SWASH KAF': 1706,
'ARABIC LETTER TAH': 1591,
'ARABIC LETTER TAH FINAL FORM': 65218,
'ARABIC LETTER TAH INITIAL FORM': 65219,
'ARABIC LETTER TAH ISOLATED FORM': 65217,
'ARABIC LETTER TAH MEDIAL FORM': 65220,
'ARABIC LETTER TAH WITH THREE DOTS ABOVE': 1695,
'ARABIC LETTER TCHEH': 1670,
'ARABIC LETTER TCHEH FINAL FORM': 64379,
'ARABIC LETTER TCHEH INITIAL FORM': 64380,
'ARABIC LETTER TCHEH ISOLATED FORM': 64378,
'ARABIC LETTER TCHEH MEDIAL FORM': 64381,
'ARABIC LETTER TCHEH WITH DOT ABOVE': 1727,
'ARABIC LETTER TCHEHEH': 1671,
'ARABIC LETTER TCHEHEH FINAL FORM': 64383,
'ARABIC LETTER TCHEHEH INITIAL FORM': 64384,
'ARABIC LETTER TCHEHEH ISOLATED FORM': 64382,
'ARABIC LETTER TCHEHEH MEDIAL FORM': 64385,
'ARABIC LETTER TEH': 1578,
'ARABIC LETTER TEH FINAL FORM': 65174,
'ARABIC LETTER TEH INITIAL FORM': 65175,
'ARABIC LETTER TEH ISOLATED FORM': 65173,
'ARABIC LETTER TEH MARBUTA': 1577,
'ARABIC LETTER TEH MARBUTA FINAL FORM': 65172,
'ARABIC LETTER TEH MARBUTA GOAL': 1731,
'ARABIC LETTER TEH MARBUTA ISOLATED FORM': 65171,
'ARABIC LETTER TEH MEDIAL FORM': 65176,
'ARABIC LETTER TEH WITH RING': 1660,
'ARABIC LETTER TEH WITH THREE DOTS ABOVE DOWNWARDS': 1661,
'ARABIC LETTER TEHEH': 1663,
'ARABIC LETTER TEHEH FINAL FORM': 64355,
'ARABIC LETTER TEHEH INITIAL FORM': 64356,
'ARABIC LETTER TEHEH ISOLATED FORM': 64354,
'ARABIC LETTER TEHEH MEDIAL FORM': 64357,
'ARABIC LETTER THAL': 1584,
'ARABIC LETTER THAL FINAL FORM': 65196,
'ARABIC LETTER THAL ISOLATED FORM': 65195,
'ARABIC LETTER THEH': 1579,
'ARABIC LETTER THEH FINAL FORM': 65178,
'ARABIC LETTER THEH INITIAL FORM': 65179,
'ARABIC LETTER THEH ISOLATED FORM': 65177,
'ARABIC LETTER THEH MEDIAL FORM': 65180,
'ARABIC LETTER TTEH': 1657,
'ARABIC LETTER TTEH FINAL FORM': 64359,
'ARABIC LETTER TTEH INITIAL FORM': 64360,
'ARABIC LETTER TTEH ISOLATED FORM': 64358,
'ARABIC LETTER TTEH MEDIAL FORM': 64361,
'ARABIC LETTER TTEHEH': 1658,
'ARABIC LETTER TTEHEH FINAL FORM': 64351,
'ARABIC LETTER TTEHEH INITIAL FORM': 64352,
'ARABIC LETTER TTEHEH ISOLATED FORM': 64350,
'ARABIC LETTER TTEHEH MEDIAL FORM': 64353,
'ARABIC LETTER U': 1735,
'ARABIC LETTER U FINAL FORM': 64472,
'ARABIC LETTER U ISOLATED FORM': 64471,
'ARABIC LETTER U WITH HAMZA ABOVE': 1655,
'ARABIC LETTER U WITH HAMZA ABOVE ISOLATED FORM': 64477,
'ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA INITIAL FORM': 64488,
'ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA MEDIAL FORM': 64489,
'ARABIC LETTER VE': 1739,
'ARABIC LETTER VE FINAL FORM': 64479,
'ARABIC LETTER VE ISOLATED FORM': 64478,
'ARABIC LETTER VEH': 1700,
'ARABIC LETTER VEH FINAL FORM': 64363,
'ARABIC LETTER VEH INITIAL FORM': 64364,
'ARABIC LETTER VEH ISOLATED FORM': 64362,
'ARABIC LETTER VEH MEDIAL FORM': 64365,
'ARABIC LETTER WAW': 1608,
'ARABIC LETTER WAW FINAL FORM': 65262,
'ARABIC LETTER WAW ISOLATED FORM': 65261,
'ARABIC LETTER WAW WITH DOT ABOVE': 1743,
'ARABIC LETTER WAW WITH HAMZA ABOVE': 1572,
'ARABIC LETTER WAW WITH HAMZA ABOVE FINAL FORM': 65158,
'ARABIC LETTER WAW WITH HAMZA ABOVE ISOLATED FORM': 65157,
'ARABIC LETTER WAW WITH RING': 1732,
'ARABIC LETTER WAW WITH TWO DOTS ABOVE': 1738,
'ARABIC LETTER YEH': 1610,
'ARABIC LETTER YEH BARREE': 1746,
'ARABIC LETTER YEH BARREE FINAL FORM': 64431,
'ARABIC LETTER YEH BARREE ISOLATED FORM': 64430,
'ARABIC LETTER YEH BARREE WITH HAMZA ABOVE': 1747,
'ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM': 64433,
'ARABIC LETTER YEH BARREE WITH HAMZA ABOVE ISOLATED FORM': 64432,
'ARABIC LETTER YEH FINAL FORM': 65266,
'ARABIC LETTER YEH INITIAL FORM': 65267,
'ARABIC LETTER YEH ISOLATED FORM': 65265,
'ARABIC LETTER YEH MEDIAL FORM': 65268,
'ARABIC LETTER YEH WITH HAMZA ABOVE': 1574,
'ARABIC LETTER YEH WITH HAMZA ABOVE FINAL FORM': 65162,
'ARABIC LETTER YEH WITH HAMZA ABOVE INITIAL FORM': 65163,
'ARABIC LETTER YEH WITH HAMZA ABOVE ISOLATED FORM': 65161,
'ARABIC LETTER YEH WITH HAMZA ABOVE MEDIAL FORM': 65164,
'ARABIC LETTER YEH WITH SMALL V': 1742,
'ARABIC LETTER YEH WITH TAIL': 1741,
'ARABIC LETTER YEH WITH THREE DOTS BELOW': 1745,
'ARABIC LETTER YU': 1736,
'ARABIC LETTER YU FINAL FORM': 64476,
'ARABIC LETTER YU ISOLATED FORM': 64475,
'ARABIC LETTER ZAH': 1592,
'ARABIC LETTER ZAH FINAL FORM': 65222,
'ARABIC LETTER ZAH INITIAL FORM': 65223,
'ARABIC LETTER ZAH ISOLATED FORM': 65221,
'ARABIC LETTER ZAH MEDIAL FORM': 65224,
'ARABIC LETTER ZAIN': 1586,
'ARABIC LETTER ZAIN FINAL FORM': 65200,
'ARABIC LETTER ZAIN ISOLATED FORM': 65199,
'ARABIC LIGATURE AIN WITH ALEF MAKSURA FINAL FORM': 64787,
'ARABIC LIGATURE AIN WITH ALEF MAKSURA ISOLATED FORM': 64759,
'ARABIC LIGATURE AIN WITH JEEM INITIAL FORM': 64698,
'ARABIC LIGATURE AIN WITH JEEM ISOLATED FORM': 64553,
'ARABIC LIGATURE AIN WITH JEEM WITH MEEM FINAL FORM': 64885,
'ARABIC LIGATURE AIN WITH JEEM WITH MEEM INITIAL FORM': 64964,
'ARABIC LIGATURE AIN WITH MEEM INITIAL FORM': 64699,
'ARABIC LIGATURE AIN WITH MEEM ISOLATED FORM': 64554,
'ARABIC LIGATURE AIN WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64888,
'ARABIC LIGATURE AIN WITH MEEM WITH MEEM FINAL FORM': 64886,
'ARABIC LIGATURE AIN WITH MEEM WITH MEEM INITIAL FORM': 64887,
'ARABIC LIGATURE AIN WITH MEEM WITH YEH FINAL FORM': 64950,
'ARABIC LIGATURE AIN WITH YEH FINAL FORM': 64788,
'ARABIC LIGATURE AIN WITH YEH ISOLATED FORM': 64760,
'ARABIC LIGATURE AKBAR ISOLATED FORM': 65011,
'ARABIC LIGATURE ALAYHE ISOLATED FORM': 65015,
'ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF FINAL FORM': 64656,
'ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF ISOLATED FORM': 64605,
'ARABIC LIGATURE ALEF WITH FATHATAN FINAL FORM': 64828,
'ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM': 64829,
'ARABIC LIGATURE ALLAH ISOLATED FORM': 65010,
'ARABIC LIGATURE BEH WITH ALEF MAKSURA FINAL FORM': 64622,
'ARABIC LIGATURE BEH WITH ALEF MAKSURA ISOLATED FORM': 64521,
'ARABIC LIGATURE BEH WITH HAH INITIAL FORM': 64669,
'ARABIC LIGATURE BEH WITH HAH ISOLATED FORM': 64518,
'ARABIC LIGATURE BEH WITH HAH WITH YEH FINAL FORM': 64962,
'ARABIC LIGATURE BEH WITH HEH INITIAL FORM': 64672,
'ARABIC LIGATURE BEH WITH HEH MEDIAL FORM': 64738,
'ARABIC LIGATURE BEH WITH JEEM INITIAL FORM': 64668,
'ARABIC LIGATURE BEH WITH JEEM ISOLATED FORM': 64517,
'ARABIC LIGATURE BEH WITH KHAH INITIAL FORM': 64670,
'ARABIC LIGATURE BEH WITH KHAH ISOLATED FORM': 64519,
'ARABIC LIGATURE BEH WITH KHAH WITH YEH FINAL FORM': 64926,
'ARABIC LIGATURE BEH WITH MEEM FINAL FORM': 64620,
'ARABIC LIGATURE BEH WITH MEEM INITIAL FORM': 64671,
'ARABIC LIGATURE BEH WITH MEEM ISOLATED FORM': 64520,
'ARABIC LIGATURE BEH WITH MEEM MEDIAL FORM': 64737,
'ARABIC LIGATURE BEH WITH NOON FINAL FORM': 64621,
'ARABIC LIGATURE BEH WITH REH FINAL FORM': 64618,
'ARABIC LIGATURE BEH WITH YEH FINAL FORM': 64623,
'ARABIC LIGATURE BEH WITH YEH ISOLATED FORM': 64522,
'ARABIC LIGATURE BEH WITH ZAIN FINAL FORM': 64619,
'ARABIC LIGATURE BISMILLAH AR-RAHMAN AR-RAHEEM': 65021,
'ARABIC LIGATURE DAD WITH ALEF MAKSURA FINAL FORM': 64803,
'ARABIC LIGATURE DAD WITH ALEF MAKSURA ISOLATED FORM': 64775,
'ARABIC LIGATURE DAD WITH HAH INITIAL FORM': 64693,
'ARABIC LIGATURE DAD WITH HAH ISOLATED FORM': 64547,
'ARABIC LIGATURE DAD WITH HAH WITH ALEF MAKSURA FINAL FORM': 64878,
'ARABIC LIGATURE DAD WITH HAH WITH YEH FINAL FORM': 64939,
'ARABIC LIGATURE DAD WITH JEEM INITIAL FORM': 64692,
'ARABIC LIGATURE DAD WITH JEEM ISOLATED FORM': 64546,
'ARABIC LIGATURE DAD WITH KHAH INITIAL FORM': 64694,
'ARABIC LIGATURE DAD WITH KHAH ISOLATED FORM': 64548,
'ARABIC LIGATURE DAD WITH KHAH WITH MEEM FINAL FORM': 64879,
'ARABIC LIGATURE DAD WITH KHAH WITH MEEM INITIAL FORM': 64880,
'ARABIC LIGATURE DAD WITH MEEM INITIAL FORM': 64695,
'ARABIC LIGATURE DAD WITH MEEM ISOLATED FORM': 64549,
'ARABIC LIGATURE DAD WITH REH FINAL FORM': 64812,
'ARABIC LIGATURE DAD WITH REH ISOLATED FORM': 64784,
'ARABIC LIGATURE DAD WITH YEH FINAL FORM': 64804,
'ARABIC LIGATURE DAD WITH YEH ISOLATED FORM': 64776,
'ARABIC LIGATURE FEH WITH ALEF MAKSURA FINAL FORM': 64636,
'ARABIC LIGATURE FEH WITH ALEF MAKSURA ISOLATED FORM': 64561,
'ARABIC LIGATURE FEH WITH HAH INITIAL FORM': 64703,
'ARABIC LIGATURE FEH WITH HAH ISOLATED FORM': 64558,
'ARABIC LIGATURE FEH WITH JEEM INITIAL FORM': 64702,
'ARABIC LIGATURE FEH WITH JEEM ISOLATED FORM': 64557,
'ARABIC LIGATURE FEH WITH KHAH INITIAL FORM': 64704,
'ARABIC LIGATURE FEH WITH KHAH ISOLATED FORM': 64559,
'ARABIC LIGATURE FEH WITH KHAH WITH MEEM FINAL FORM': 64892,
'ARABIC LIGATURE FEH WITH KHAH WITH MEEM INITIAL FORM': 64893,
'ARABIC LIGATURE FEH WITH MEEM INITIAL FORM': 64705,
'ARABIC LIGATURE FEH WITH MEEM ISOLATED FORM': 64560,
'ARABIC LIGATURE FEH WITH MEEM WITH YEH FINAL FORM': 64961,
'ARABIC LIGATURE FEH WITH YEH FINAL FORM': 64637,
'ARABIC LIGATURE FEH WITH YEH ISOLATED FORM': 64562,
'ARABIC LIGATURE GHAIN WITH ALEF MAKSURA FINAL FORM': 64789,
'ARABIC LIGATURE GHAIN WITH ALEF MAKSURA ISOLATED FORM': 64761,
'ARABIC LIGATURE GHAIN WITH JEEM INITIAL FORM': 64700,
'ARABIC LIGATURE GHAIN WITH JEEM ISOLATED FORM': 64555,
'ARABIC LIGATURE GHAIN WITH MEEM INITIAL FORM': 64701,
'ARABIC LIGATURE GHAIN WITH MEEM ISOLATED FORM': 64556,
'ARABIC LIGATURE GHAIN WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64891,
'ARABIC LIGATURE GHAIN WITH MEEM WITH MEEM FINAL FORM': 64889,
'ARABIC LIGATURE GHAIN WITH MEEM WITH YEH FINAL FORM': 64890,
'ARABIC LIGATURE GHAIN WITH YEH FINAL FORM': 64790,
'ARABIC LIGATURE GHAIN WITH YEH ISOLATED FORM': 64762,
'ARABIC LIGATURE HAH WITH ALEF MAKSURA FINAL FORM': 64795,
'ARABIC LIGATURE HAH WITH ALEF MAKSURA ISOLATED FORM': 64767,
'ARABIC LIGATURE HAH WITH JEEM INITIAL FORM': 64681,
'ARABIC LIGATURE HAH WITH JEEM ISOLATED FORM': 64535,
'ARABIC LIGATURE HAH WITH JEEM WITH YEH FINAL FORM': 64959,
'ARABIC LIGATURE HAH WITH MEEM INITIAL FORM': 64682,
'ARABIC LIGATURE HAH WITH MEEM ISOLATED FORM': 64536,
'ARABIC LIGATURE HAH WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64859,
'ARABIC LIGATURE HAH WITH MEEM WITH YEH FINAL FORM': 64858,
'ARABIC LIGATURE HAH WITH YEH FINAL FORM': 64796,
'ARABIC LIGATURE HAH WITH YEH ISOLATED FORM': 64768,
'ARABIC LIGATURE HEH WITH ALEF MAKSURA ISOLATED FORM': 64595,
'ARABIC LIGATURE HEH WITH JEEM INITIAL FORM': 64727,
'ARABIC LIGATURE HEH WITH JEEM ISOLATED FORM': 64593,
'ARABIC LIGATURE HEH WITH MEEM INITIAL FORM': 64728,
'ARABIC LIGATURE HEH WITH MEEM ISOLATED FORM': 64594,
'ARABIC LIGATURE HEH WITH MEEM WITH JEEM INITIAL FORM': 64915,
'ARABIC LIGATURE HEH WITH MEEM WITH MEEM INITIAL FORM': 64916,
'ARABIC LIGATURE HEH WITH SUPERSCRIPT ALEF INITIAL FORM': 64729,
'ARABIC LIGATURE HEH WITH YEH ISOLATED FORM': 64596,
'ARABIC LIGATURE JALLAJALALOUHOU': 65019,
'ARABIC LIGATURE JEEM WITH ALEF MAKSURA FINAL FORM': 64797,
'ARABIC LIGATURE JEEM WITH ALEF MAKSURA ISOLATED FORM': 64769,
'ARABIC LIGATURE JEEM WITH HAH INITIAL FORM': 64679,
'ARABIC LIGATURE JEEM WITH HAH ISOLATED FORM': 64533,
'ARABIC LIGATURE JEEM WITH HAH WITH ALEF MAKSURA FINAL FORM': 64934,
'ARABIC LIGATURE JEEM WITH HAH WITH YEH FINAL FORM': 64958,
'ARABIC LIGATURE JEEM WITH MEEM INITIAL FORM': 64680,
'ARABIC LIGATURE JEEM WITH MEEM ISOLATED FORM': 64534,
'ARABIC LIGATURE JEEM WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64935,
'ARABIC LIGATURE JEEM WITH MEEM WITH HAH FINAL FORM': 64856,
'ARABIC LIGATURE JEEM WITH MEEM WITH HAH INITIAL FORM': 64857,
'ARABIC LIGATURE JEEM WITH MEEM WITH YEH FINAL FORM': 64933,
'ARABIC LIGATURE JEEM WITH YEH FINAL FORM': 64798,
'ARABIC LIGATURE JEEM WITH YEH ISOLATED FORM': 64770,
'ARABIC LIGATURE KAF WITH ALEF FINAL FORM': 64640,
'ARABIC LIGATURE KAF WITH ALEF ISOLATED FORM': 64567,
'ARABIC LIGATURE KAF WITH ALEF MAKSURA FINAL FORM': 64643,
'ARABIC LIGATURE KAF WITH ALEF MAKSURA ISOLATED FORM': 64573,
'ARABIC LIGATURE KAF WITH HAH INITIAL FORM': 64709,
'ARABIC LIGATURE KAF WITH HAH ISOLATED FORM': 64569,
'ARABIC LIGATURE KAF WITH JEEM INITIAL FORM': 64708,
'ARABIC LIGATURE KAF WITH JEEM ISOLATED FORM': 64568,
'ARABIC LIGATURE KAF WITH KHAH INITIAL FORM': 64710,
'ARABIC LIGATURE KAF WITH KHAH ISOLATED FORM': 64570,
'ARABIC LIGATURE KAF WITH LAM FINAL FORM': 64641,
'ARABIC LIGATURE KAF WITH LAM INITIAL FORM': 64711,
'ARABIC LIGATURE KAF WITH LAM ISOLATED FORM': 64571,
'ARABIC LIGATURE KAF WITH LAM MEDIAL FORM': 64747,
'ARABIC LIGATURE KAF WITH MEEM FINAL FORM': 64642,
'ARABIC LIGATURE KAF WITH MEEM INITIAL FORM': 64712,
'ARABIC LIGATURE KAF WITH MEEM ISOLATED FORM': 64572,
'ARABIC LIGATURE KAF WITH MEEM MEDIAL FORM': 64748,
'ARABIC LIGATURE KAF WITH MEEM WITH MEEM FINAL FORM': 64955,
'ARABIC LIGATURE KAF WITH MEEM WITH MEEM INITIAL FORM': 64963,
'ARABIC LIGATURE KAF WITH MEEM WITH YEH FINAL FORM': 64951,
'ARABIC LIGATURE KAF WITH YEH FINAL FORM': 64644,
'ARABIC LIGATURE KAF WITH YEH ISOLATED FORM': 64574,
'ARABIC LIGATURE KHAH WITH ALEF MAKSURA FINAL FORM': 64799,
'ARABIC LIGATURE KHAH WITH ALEF MAKSURA ISOLATED FORM': 64771,
'ARABIC LIGATURE KHAH WITH HAH ISOLATED FORM': 64538,
'ARABIC LIGATURE KHAH WITH JEEM INITIAL FORM': 64683,
'ARABIC LIGATURE KHAH WITH JEEM ISOLATED FORM': 64537,
'ARABIC LIGATURE KHAH WITH MEEM INITIAL FORM': 64684,
'ARABIC LIGATURE KHAH WITH MEEM ISOLATED FORM': 64539,
'ARABIC LIGATURE KHAH WITH YEH FINAL FORM': 64800,
'ARABIC LIGATURE KHAH WITH YEH ISOLATED FORM': 64772,
'ARABIC LIGATURE LAM WITH ALEF FINAL FORM': 65276,
'ARABIC LIGATURE LAM WITH ALEF ISOLATED FORM': 65275,
'ARABIC LIGATURE LAM WITH ALEF MAKSURA FINAL FORM': 64646,
'ARABIC LIGATURE LAM WITH ALEF MAKSURA ISOLATED FORM': 64579,
'ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE FINAL FORM': 65272,
'ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE ISOLATED FORM': 65271,
'ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW FINAL FORM': 65274,
'ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW ISOLATED FORM': 65273,
'ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE FINAL FORM': 65270,
'ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE ISOLATED FORM': 65269,
'ARABIC LIGATURE LAM WITH HAH INITIAL FORM': 64714,
'ARABIC LIGATURE LAM WITH HAH ISOLATED FORM': 64576,
'ARABIC LIGATURE LAM WITH HAH WITH ALEF MAKSURA FINAL FORM': 64898,
'ARABIC LIGATURE LAM WITH HAH WITH MEEM FINAL FORM': 64896,
'ARABIC LIGATURE LAM WITH HAH WITH MEEM INITIAL FORM': 64949,
'ARABIC LIGATURE LAM WITH HAH WITH YEH FINAL FORM': 64897,
'ARABIC LIGATURE LAM WITH HEH INITIAL FORM': 64717,
'ARABIC LIGATURE LAM WITH JEEM INITIAL FORM': 64713,
'ARABIC LIGATURE LAM WITH JEEM ISOLATED FORM': 64575,
'ARABIC LIGATURE LAM WITH JEEM WITH JEEM FINAL FORM': 64900,
'ARABIC LIGATURE LAM WITH JEEM WITH JEEM INITIAL FORM': 64899,
'ARABIC LIGATURE LAM WITH JEEM WITH MEEM FINAL FORM': 64956,
'ARABIC LIGATURE LAM WITH JEEM WITH MEEM INITIAL FORM': 64954,
'ARABIC LIGATURE LAM WITH JEEM WITH YEH FINAL FORM': 64940,
'ARABIC LIGATURE LAM WITH KHAH INITIAL FORM': 64715,
'ARABIC LIGATURE LAM WITH KHAH ISOLATED FORM': 64577,
'ARABIC LIGATURE LAM WITH KHAH WITH MEEM FINAL FORM': 64901,
'ARABIC LIGATURE LAM WITH KHAH WITH MEEM INITIAL FORM': 64902,
'ARABIC LIGATURE LAM WITH MEEM FINAL FORM': 64645,
'ARABIC LIGATURE LAM WITH MEEM INITIAL FORM': 64716,
'ARABIC LIGATURE LAM WITH MEEM ISOLATED FORM': 64578,
'ARABIC LIGATURE LAM WITH MEEM MEDIAL FORM': 64749,
'ARABIC LIGATURE LAM WITH MEEM WITH HAH FINAL FORM': 64903,
'ARABIC LIGATURE LAM WITH MEEM WITH HAH INITIAL FORM': 64904,
'ARABIC LIGATURE LAM WITH MEEM WITH YEH FINAL FORM': 64941,
'ARABIC LIGATURE LAM WITH YEH FINAL FORM': 64647,
'ARABIC LIGATURE LAM WITH YEH ISOLATED FORM': 64580,
'ARABIC LIGATURE MEEM WITH ALEF FINAL FORM': 64648,
'ARABIC LIGATURE MEEM WITH ALEF MAKSURA ISOLATED FORM': 64585,
'ARABIC LIGATURE MEEM WITH HAH INITIAL FORM': 64719,
'ARABIC LIGATURE MEEM WITH HAH ISOLATED FORM': 64582,
'ARABIC LIGATURE MEEM WITH HAH WITH JEEM INITIAL FORM': 64905,
'ARABIC LIGATURE MEEM WITH HAH WITH MEEM INITIAL FORM': 64906,
'ARABIC LIGATURE MEEM WITH HAH WITH YEH FINAL FORM': 64907,
'ARABIC LIGATURE MEEM WITH JEEM INITIAL FORM': 64718,
'ARABIC LIGATURE MEEM WITH JEEM ISOLATED FORM': 64581,
'ARABIC LIGATURE MEEM WITH JEEM WITH HAH INITIAL FORM': 64908,
'ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM': 64914,
'ARABIC LIGATURE MEEM WITH JEEM WITH MEEM INITIAL FORM': 64909,
'ARABIC LIGATURE MEEM WITH JEEM WITH YEH FINAL FORM': 64960,
'ARABIC LIGATURE MEEM WITH KHAH INITIAL FORM': 64720,
'ARABIC LIGATURE MEEM WITH KHAH ISOLATED FORM': 64583,
'ARABIC LIGATURE MEEM WITH KHAH WITH JEEM INITIAL FORM': 64910,
'ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM': 64911,
'ARABIC LIGATURE MEEM WITH KHAH WITH YEH FINAL FORM': 64953,
'ARABIC LIGATURE MEEM WITH MEEM FINAL FORM': 64649,
'ARABIC LIGATURE MEEM WITH MEEM INITIAL FORM': 64721,
'ARABIC LIGATURE MEEM WITH MEEM ISOLATED FORM': 64584,
'ARABIC LIGATURE MEEM WITH MEEM WITH YEH FINAL FORM': 64945,
'ARABIC LIGATURE MEEM WITH YEH ISOLATED FORM': 64586,
'ARABIC LIGATURE MOHAMMAD ISOLATED FORM': 65012,
'ARABIC LIGATURE NOON WITH ALEF MAKSURA FINAL FORM': 64654,
'ARABIC LIGATURE NOON WITH ALEF MAKSURA ISOLATED FORM': 64591,
'ARABIC LIGATURE NOON WITH HAH INITIAL FORM': 64723,
'ARABIC LIGATURE NOON WITH HAH ISOLATED FORM': 64588,
'ARABIC LIGATURE NOON WITH HAH WITH ALEF MAKSURA FINAL FORM': 64918,
'ARABIC LIGATURE NOON WITH HAH WITH MEEM INITIAL FORM': 64917,
'ARABIC LIGATURE NOON WITH HAH WITH YEH FINAL FORM': 64947,
'ARABIC LIGATURE NOON WITH HEH INITIAL FORM': 64726,
'ARABIC LIGATURE NOON WITH HEH MEDIAL FORM': 64751,
'ARABIC LIGATURE NOON WITH JEEM INITIAL FORM': 64722,
'ARABIC LIGATURE NOON WITH JEEM ISOLATED FORM': 64587,
'ARABIC LIGATURE NOON WITH JEEM WITH ALEF MAKSURA FINAL FORM': 64921,
'ARABIC LIGATURE NOON WITH JEEM WITH HAH FINAL FORM': 64957,
'ARABIC LIGATURE NOON WITH JEEM WITH HAH INITIAL FORM': 64952,
'ARABIC LIGATURE NOON WITH JEEM WITH MEEM FINAL FORM': 64919,
'ARABIC LIGATURE NOON WITH JEEM WITH MEEM INITIAL FORM': 64920,
'ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM': 64967,
'ARABIC LIGATURE NOON WITH KHAH INITIAL FORM': 64724,
'ARABIC LIGATURE NOON WITH KHAH ISOLATED FORM': 64589,
'ARABIC LIGATURE NOON WITH MEEM FINAL FORM': 64652,
'ARABIC LIGATURE NOON WITH MEEM INITIAL FORM': 64725,
'ARABIC LIGATURE NOON WITH MEEM ISOLATED FORM': 64590,
'ARABIC LIGATURE NOON WITH MEEM MEDIAL FORM': 64750,
'ARABIC LIGATURE NOON WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64923,
'ARABIC LIGATURE NOON WITH MEEM WITH YEH FINAL FORM': 64922,
'ARABIC LIGATURE NOON WITH NOON FINAL FORM': 64653,
'ARABIC LIGATURE NOON WITH REH FINAL FORM': 64650,
'ARABIC LIGATURE NOON WITH YEH FINAL FORM': 64655,
'ARABIC LIGATURE NOON WITH YEH ISOLATED FORM': 64592,
'ARABIC LIGATURE NOON WITH ZAIN FINAL FORM': 64651,
'ARABIC LIGATURE QAF WITH ALEF MAKSURA FINAL FORM': 64638,
'ARABIC LIGATURE QAF WITH ALEF MAKSURA ISOLATED FORM': 64565,
'ARABIC LIGATURE QAF WITH HAH INITIAL FORM': 64706,
'ARABIC LIGATURE QAF WITH HAH ISOLATED FORM': 64563,
'ARABIC LIGATURE QAF WITH MEEM INITIAL FORM': 64707,
'ARABIC LIGATURE QAF WITH MEEM ISOLATED FORM': 64564,
'ARABIC LIGATURE QAF WITH MEEM WITH HAH FINAL FORM': 64894,
'ARABIC LIGATURE QAF WITH MEEM WITH HAH INITIAL FORM': 64948,
'ARABIC LIGATURE QAF WITH MEEM WITH MEEM FINAL FORM': 64895,
'ARABIC LIGATURE QAF WITH MEEM WITH YEH FINAL FORM': 64946,
'ARABIC LIGATURE QAF WITH YEH FINAL FORM': 64639,
'ARABIC LIGATURE QAF WITH YEH ISOLATED FORM': 64566,
'ARABIC LIGATURE QALA USED AS KORANIC STOP SIGN ISOLATED FORM': 65009,
'ARABIC LIGATURE RASOUL ISOLATED FORM': 65014,
'ARABIC LIGATURE REH WITH SUPERSCRIPT ALEF ISOLATED FORM': 64604,
'ARABIC LIGATURE SAD WITH ALEF MAKSURA FINAL FORM': 64801,
'ARABIC LIGATURE SAD WITH ALEF MAKSURA ISOLATED FORM': 64773,
'ARABIC LIGATURE SAD WITH HAH INITIAL FORM': 64689,
'ARABIC LIGATURE SAD WITH HAH ISOLATED FORM': 64544,
'ARABIC LIGATURE SAD WITH HAH WITH HAH FINAL FORM': 64868,
'ARABIC LIGATURE SAD WITH HAH WITH HAH INITIAL FORM': 64869,
'ARABIC LIGATURE SAD WITH HAH WITH YEH FINAL FORM': 64937,
'ARABIC LIGATURE SAD WITH KHAH INITIAL FORM': 64690,
'ARABIC LIGATURE SAD WITH MEEM INITIAL FORM': 64691,
'ARABIC LIGATURE SAD WITH MEEM ISOLATED FORM': 64545,
'ARABIC LIGATURE SAD WITH MEEM WITH MEEM FINAL FORM': 64870,
'ARABIC LIGATURE SAD WITH MEEM WITH MEEM INITIAL FORM': 64965,
'ARABIC LIGATURE SAD WITH REH FINAL FORM': 64811,
'ARABIC LIGATURE SAD WITH REH ISOLATED FORM': 64783,
'ARABIC LIGATURE SAD WITH YEH FINAL FORM': 64802,
'ARABIC LIGATURE SAD WITH YEH ISOLATED FORM': 64774,
'ARABIC LIGATURE SALAM ISOLATED FORM': 65013,
'ARABIC LIGATURE SALLA ISOLATED FORM': 65017,
'ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM': 65008,
'ARABIC LIGATURE SALLALLAHOU ALAYHE WASALLAM': 65018,
'ARABIC LIGATURE SEEN WITH ALEF MAKSURA FINAL FORM': 64791,
'ARABIC LIGATURE SEEN WITH ALEF MAKSURA ISOLATED FORM': 64763,
'ARABIC LIGATURE SEEN WITH HAH INITIAL FORM': 64686,
'ARABIC LIGATURE SEEN WITH HAH ISOLATED FORM': 64541,
'ARABIC LIGATURE SEEN WITH HAH MEDIAL FORM': 64821,
'ARABIC LIGATURE SEEN WITH HAH WITH JEEM INITIAL FORM': 64860,
'ARABIC LIGATURE SEEN WITH HEH INITIAL FORM': 64817,
'ARABIC LIGATURE SEEN WITH HEH MEDIAL FORM': 64744,
'ARABIC LIGATURE SEEN WITH JEEM INITIAL FORM': 64685,
'ARABIC LIGATURE SEEN WITH JEEM ISOLATED FORM': 64540,
'ARABIC LIGATURE SEEN WITH JEEM MEDIAL FORM': 64820,
'ARABIC LIGATURE SEEN WITH JEEM WITH ALEF MAKSURA FINAL FORM': 64862,
'ARABIC LIGATURE SEEN WITH JEEM WITH HAH INITIAL FORM': 64861,
'ARABIC LIGATURE SEEN WITH KHAH INITIAL FORM': 64687,
'ARABIC LIGATURE SEEN WITH KHAH ISOLATED FORM': 64542,
'ARABIC LIGATURE SEEN WITH KHAH MEDIAL FORM': 64822,
'ARABIC LIGATURE SEEN WITH KHAH WITH ALEF MAKSURA FINAL FORM': 64936,
'ARABIC LIGATURE SEEN WITH KHAH WITH YEH FINAL FORM': 64966,
'ARABIC LIGATURE SEEN WITH MEEM INITIAL FORM': 64688,
'ARABIC LIGATURE SEEN WITH MEEM ISOLATED FORM': 64543,
'ARABIC LIGATURE SEEN WITH MEEM MEDIAL FORM': 64743,
'ARABIC LIGATURE SEEN WITH MEEM WITH HAH FINAL FORM': 64863,
'ARABIC LIGATURE SEEN WITH MEEM WITH HAH INITIAL FORM': 64864,
'ARABIC LIGATURE SEEN WITH MEEM WITH JEEM INITIAL FORM': 64865,
'ARABIC LIGATURE SEEN WITH MEEM WITH MEEM FINAL FORM': 64866,
'ARABIC LIGATURE SEEN WITH MEEM WITH MEEM INITIAL FORM': 64867,
'ARABIC LIGATURE SEEN WITH REH FINAL FORM': 64810,
'ARABIC LIGATURE SEEN WITH REH ISOLATED FORM': 64782,
'ARABIC LIGATURE SEEN WITH YEH FINAL FORM': 64792,
'ARABIC LIGATURE SEEN WITH YEH ISOLATED FORM': 64764,
'ARABIC LIGATURE SHADDA WITH DAMMA ISOLATED FORM': 64609,
'ARABIC LIGATURE SHADDA WITH DAMMA MEDIAL FORM': 64755,
'ARABIC LIGATURE SHADDA WITH DAMMATAN ISOLATED FORM': 64606,
'ARABIC LIGATURE SHADDA WITH FATHA ISOLATED FORM': 64608,
'ARABIC LIGATURE SHADDA WITH FATHA MEDIAL FORM': 64754,
'ARABIC LIGATURE SHADDA WITH KASRA ISOLATED FORM': 64610,
'ARABIC LIGATURE SHADDA WITH KASRA MEDIAL FORM': 64756,
'ARABIC LIGATURE SHADDA WITH KASRATAN ISOLATED FORM': 64607,
'ARABIC LIGATURE SHADDA WITH SUPERSCRIPT ALEF ISOLATED FORM': 64611,
'ARABIC LIGATURE SHEEN WITH ALEF MAKSURA FINAL FORM': 64793,
'ARABIC LIGATURE SHEEN WITH ALEF MAKSURA ISOLATED FORM': 64765,
'ARABIC LIGATURE SHEEN WITH HAH FINAL FORM': 64806,
'ARABIC LIGATURE SHEEN WITH HAH INITIAL FORM': 64814,
'ARABIC LIGATURE SHEEN WITH HAH ISOLATED FORM': 64778,
'ARABIC LIGATURE SHEEN WITH HAH MEDIAL FORM': 64824,
'ARABIC LIGATURE SHEEN WITH HAH WITH MEEM FINAL FORM': 64871,
'ARABIC LIGATURE SHEEN WITH HAH WITH MEEM INITIAL FORM': 64872,
'ARABIC LIGATURE SHEEN WITH HAH WITH YEH FINAL FORM': 64938,
'ARABIC LIGATURE SHEEN WITH HEH INITIAL FORM': 64818,
'ARABIC LIGATURE SHEEN WITH HEH MEDIAL FORM': 64746,
'ARABIC LIGATURE SHEEN WITH JEEM FINAL FORM': 64805,
'ARABIC LIGATURE SHEEN WITH JEEM INITIAL FORM': 64813,
'ARABIC LIGATURE SHEEN WITH JEEM ISOLATED FORM': 64777,
'ARABIC LIGATURE SHEEN WITH JEEM MEDIAL FORM': 64823,
'ARABIC LIGATURE SHEEN WITH JEEM WITH YEH FINAL FORM': 64873,
'ARABIC LIGATURE SHEEN WITH KHAH FINAL FORM': 64807,
'ARABIC LIGATURE SHEEN WITH KHAH INITIAL FORM': 64815,
'ARABIC LIGATURE SHEEN WITH KHAH ISOLATED FORM': 64779,
'ARABIC LIGATURE SHEEN WITH KHAH MEDIAL FORM': 64825,
'ARABIC LIGATURE SHEEN WITH MEEM FINAL FORM': 64808,
'ARABIC LIGATURE SHEEN WITH MEEM INITIAL FORM': 64816,
'ARABIC LIGATURE SHEEN WITH MEEM ISOLATED FORM': 64780,
'ARABIC LIGATURE SHEEN WITH MEEM MEDIAL FORM': 64745,
'ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH FINAL FORM': 64874,
'ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH INITIAL FORM': 64875,
'ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM FINAL FORM': 64876,
'ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM INITIAL FORM': 64877,
'ARABIC LIGATURE SHEEN WITH REH FINAL FORM': 64809,
'ARABIC LIGATURE SHEEN WITH REH ISOLATED FORM': 64781,
'ARABIC LIGATURE SHEEN WITH YEH FINAL FORM': 64794,
'ARABIC LIGATURE SHEEN WITH YEH ISOLATED FORM': 64766,
'ARABIC LIGATURE TAH WITH ALEF MAKSURA FINAL FORM': 64785,
'ARABIC LIGATURE TAH WITH ALEF MAKSURA ISOLATED FORM': 64757,
'ARABIC LIGATURE TAH WITH HAH INITIAL FORM': 64696,
'ARABIC LIGATURE TAH WITH HAH ISOLATED FORM': 64550,
'ARABIC LIGATURE TAH WITH MEEM INITIAL FORM': 64819,
'ARABIC LIGATURE TAH WITH MEEM ISOLATED FORM': 64551,
'ARABIC LIGATURE TAH WITH MEEM MEDIAL FORM': 64826,
'ARABIC LIGATURE TAH WITH MEEM WITH HAH FINAL FORM': 64881,
'ARABIC LIGATURE TAH WITH MEEM WITH HAH INITIAL FORM': 64882,
'ARABIC LIGATURE TAH WITH MEEM WITH MEEM INITIAL FORM': 64883,
'ARABIC LIGATURE TAH WITH MEEM WITH YEH FINAL FORM': 64884,
'ARABIC LIGATURE TAH WITH YEH FINAL FORM': 64786,
'ARABIC LIGATURE TAH WITH YEH ISOLATED FORM': 64758,
'ARABIC LIGATURE TEH WITH ALEF MAKSURA FINAL FORM': 64628,
'ARABIC LIGATURE TEH WITH ALEF MAKSURA ISOLATED FORM': 64527,
'ARABIC LIGATURE TEH WITH HAH INITIAL FORM': 64674,
'ARABIC LIGATURE TEH WITH HAH ISOLATED FORM': 64524,
'ARABIC LIGATURE TEH WITH HAH WITH JEEM FINAL FORM': 64849,
'ARABIC LIGATURE TEH WITH HAH WITH JEEM INITIAL FORM': 64850,
'ARABIC LIGATURE TEH WITH HAH WITH MEEM INITIAL FORM': 64851,
'ARABIC LIGATURE TEH WITH HEH INITIAL FORM': 64677,
'ARABIC LIGATURE TEH WITH HEH MEDIAL FORM': 64740,
'ARABIC LIGATURE TEH WITH JEEM INITIAL FORM': 64673,
'ARABIC LIGATURE TEH WITH JEEM ISOLATED FORM': 64523,
'ARABIC LIGATURE TEH WITH JEEM WITH ALEF MAKSURA FINAL FORM': 64928,
'ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM': 64848,
'ARABIC LIGATURE TEH WITH JEEM WITH YEH FINAL FORM': 64927,
'ARABIC LIGATURE TEH WITH KHAH INITIAL FORM': 64675,
'ARABIC LIGATURE TEH WITH KHAH ISOLATED FORM': 64525,
'ARABIC LIGATURE TEH WITH KHAH WITH ALEF MAKSURA FINAL FORM': 64930,
'ARABIC LIGATURE TEH WITH KHAH WITH MEEM INITIAL FORM': 64852,
'ARABIC LIGATURE TEH WITH KHAH WITH YEH FINAL FORM': 64929,
'ARABIC LIGATURE TEH WITH MEEM FINAL FORM': 64626,
'ARABIC LIGATURE TEH WITH MEEM INITIAL FORM': 64676,
'ARABIC LIGATURE TEH WITH MEEM ISOLATED FORM': 64526,
'ARABIC LIGATURE TEH WITH MEEM MEDIAL FORM': 64739,
'ARABIC LIGATURE TEH WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64932,
'ARABIC LIGATURE TEH WITH MEEM WITH HAH INITIAL FORM': 64854,
'ARABIC LIGATURE TEH WITH MEEM WITH JEEM INITIAL FORM': 64853,
'ARABIC LIGATURE TEH WITH MEEM WITH KHAH INITIAL FORM': 64855,
'ARABIC LIGATURE TEH WITH MEEM WITH YEH FINAL FORM': 64931,
'ARABIC LIGATURE TEH WITH NOON FINAL FORM': 64627,
'ARABIC LIGATURE TEH WITH REH FINAL FORM': 64624,
'ARABIC LIGATURE TEH WITH YEH FINAL FORM': 64629,
'ARABIC LIGATURE TEH WITH YEH ISOLATED FORM': 64528,
'ARABIC LIGATURE TEH WITH ZAIN FINAL FORM': 64625,
'ARABIC LIGATURE THAL WITH SUPERSCRIPT ALEF ISOLATED FORM': 64603,
'ARABIC LIGATURE THEH WITH ALEF MAKSURA FINAL FORM': 64634,
'ARABIC LIGATURE THEH WITH ALEF MAKSURA ISOLATED FORM': 64531,
'ARABIC LIGATURE THEH WITH HEH MEDIAL FORM': 64742,
'ARABIC LIGATURE THEH WITH JEEM ISOLATED FORM': 64529,
'ARABIC LIGATURE THEH WITH MEEM FINAL FORM': 64632,
'ARABIC LIGATURE THEH WITH MEEM INITIAL FORM': 64678,
'ARABIC LIGATURE THEH WITH MEEM ISOLATED FORM': 64530,
'ARABIC LIGATURE THEH WITH MEEM MEDIAL FORM': 64741,
'ARABIC LIGATURE THEH WITH NOON FINAL FORM': 64633,
'ARABIC LIGATURE THEH WITH REH FINAL FORM': 64630,
'ARABIC LIGATURE THEH WITH YEH FINAL FORM': 64635,
'ARABIC LIGATURE THEH WITH YEH ISOLATED FORM': 64532,
'ARABIC LIGATURE THEH WITH ZAIN FINAL FORM': 64631,
'ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM': 64506,
'ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA INITIAL FORM': 64507,
'ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM': 64505,
'ARABIC LIGATURE WASALLAM ISOLATED FORM': 65016,
'ARABIC LIGATURE YEH WITH ALEF MAKSURA FINAL FORM': 64661,
'ARABIC LIGATURE YEH WITH ALEF MAKSURA ISOLATED FORM': 64601,
'ARABIC LIGATURE YEH WITH HAH INITIAL FORM': 64731,
'ARABIC LIGATURE YEH WITH HAH ISOLATED FORM': 64598,
'ARABIC LIGATURE YEH WITH HAH WITH YEH FINAL FORM': 64942,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE FINAL FORM': 64493,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE ISOLATED FORM': 64492,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF FINAL FORM': 64491,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF ISOLATED FORM': 64490,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM': 64616,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM': 64515,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E FINAL FORM': 64503,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E INITIAL FORM': 64504,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E ISOLATED FORM': 64502,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH INITIAL FORM': 64664,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH ISOLATED FORM': 64513,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH INITIAL FORM': 64667,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH MEDIAL FORM': 64736,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM INITIAL FORM': 64663,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM ISOLATED FORM': 64512,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH KHAH INITIAL FORM': 64665,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM FINAL FORM': 64614,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM INITIAL FORM': 64666,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM ISOLATED FORM': 64514,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM MEDIAL FORM': 64735,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH NOON FINAL FORM': 64615,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE FINAL FORM': 64499,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE ISOLATED FORM': 64498,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH REH FINAL FORM': 64612,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U FINAL FORM': 64497,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U ISOLATED FORM': 64496,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW FINAL FORM': 64495,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW ISOLATED FORM': 64494,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH FINAL FORM': 64617,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH ISOLATED FORM': 64516,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU FINAL FORM': 64501,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU ISOLATED FORM': 64500,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ZAIN FINAL FORM': 64613,
'ARABIC LIGATURE YEH WITH HEH INITIAL FORM': 64734,
'ARABIC LIGATURE YEH WITH HEH MEDIAL FORM': 64753,
'ARABIC LIGATURE YEH WITH JEEM INITIAL FORM': 64730,
'ARABIC LIGATURE YEH WITH JEEM ISOLATED FORM': 64597,
'ARABIC LIGATURE YEH WITH JEEM WITH YEH FINAL FORM': 64943,
'ARABIC LIGATURE YEH WITH KHAH INITIAL FORM': 64732,
'ARABIC LIGATURE YEH WITH KHAH ISOLATED FORM': 64599,
'ARABIC LIGATURE YEH WITH MEEM FINAL FORM': 64659,
'ARABIC LIGATURE YEH WITH MEEM INITIAL FORM': 64733,
'ARABIC LIGATURE YEH WITH MEEM ISOLATED FORM': 64600,
'ARABIC LIGATURE YEH WITH MEEM MEDIAL FORM': 64752,
'ARABIC LIGATURE YEH WITH MEEM WITH MEEM FINAL FORM': 64924,
'ARABIC LIGATURE YEH WITH MEEM WITH MEEM INITIAL FORM': 64925,
'ARABIC LIGATURE YEH WITH MEEM WITH YEH FINAL FORM': 64944,
'ARABIC LIGATURE YEH WITH NOON FINAL FORM': 64660,
'ARABIC LIGATURE YEH WITH REH FINAL FORM': 64657,
'ARABIC LIGATURE YEH WITH YEH FINAL FORM': 64662,
'ARABIC LIGATURE YEH WITH YEH ISOLATED FORM': 64602,
'ARABIC LIGATURE YEH WITH ZAIN FINAL FORM': 64658,
'ARABIC LIGATURE ZAH WITH MEEM INITIAL FORM': 64697,
'ARABIC LIGATURE ZAH WITH MEEM ISOLATED FORM': 64552,
'ARABIC LIGATURE ZAH WITH MEEM MEDIAL FORM': 64827,
'ARABIC MADDAH ABOVE': 1619,
'ARABIC MARK NOON GHUNNA': 1624,
'ARABIC NUMBER SIGN': 1536,
'ARABIC PERCENT SIGN': 1642,
'ARABIC PLACE OF SAJDAH': 1769,
'ARABIC POETIC VERSE SIGN': 1550,
'ARABIC QUESTION MARK': 1567,
'ARABIC REVERSED DAMMA': 1629,
'ARABIC ROUNDED HIGH STOP WITH FILLED CENTRE': 1772,
'ARABIC SEMICOLON': 1563,
'ARABIC SHADDA': 1617,
'ARABIC SHADDA ISOLATED FORM': 65148,
'ARABIC SHADDA MEDIAL FORM': 65149,
'ARABIC SIGN ALAYHE ASSALLAM': 1553,
'ARABIC SIGN MISRA': 1551,
'ARABIC SIGN RADI ALLAHOU ANHU': 1555,
'ARABIC SIGN RAHMATULLAH ALAYHE': 1554,
'ARABIC SIGN SAFHA': 1539,
'ARABIC SIGN SALLALLAHOU ALAYHE WASSALLAM': 1552,
'ARABIC SIGN SANAH': 1537,
'ARABIC SIGN SINDHI AMPERSAND': 1789,
'ARABIC SIGN SINDHI POSTPOSITION MEN': 1790,
'ARABIC SIGN TAKHALLUS': 1556,
'ARABIC SMALL HIGH DOTLESS HEAD OF KHAH': 1761,
'ARABIC SMALL HIGH JEEM': 1754,
'ARABIC SMALL HIGH LAM ALEF': 1753,
'ARABIC SMALL HIGH LIGATURE QAF WITH LAM WITH ALEF MAKSURA': 1751,
'ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA': 1750,
'ARABIC SMALL HIGH MADDA': 1764,
'ARABIC SMALL HIGH MEEM INITIAL FORM': 1752,
'ARABIC SMALL HIGH MEEM ISOLATED FORM': 1762,
'ARABIC SMALL HIGH NOON': 1768,
'ARABIC SMALL HIGH ROUNDED ZERO': 1759,
'ARABIC SMALL HIGH SEEN': 1756,
'ARABIC SMALL HIGH TAH': 1557,
'ARABIC SMALL HIGH THREE DOTS': 1755,
'ARABIC SMALL HIGH UPRIGHT RECTANGULAR ZERO': 1760,
'ARABIC SMALL HIGH YEH': 1767,
'ARABIC SMALL LOW MEEM': 1773,
'ARABIC SMALL LOW SEEN': 1763,
'ARABIC SMALL WAW': 1765,
'ARABIC SMALL YEH': 1766,
'ARABIC START OF RUB EL HIZB': 1758,
'ARABIC SUBSCRIPT ALEF': 1622,
'ARABIC SUKUN': 1618,
'ARABIC SUKUN ISOLATED FORM': 65150,
'ARABIC SUKUN MEDIAL FORM': 65151,
'ARABIC TAIL FRAGMENT': 65139,
'ARABIC TATWEEL': 1600,
'ARABIC TATWEEL WITH FATHATAN ABOVE': 65137,
'ARABIC THOUSANDS SEPARATOR': 1644,
'ARABIC TRIPLE DOT PUNCTUATION MARK': 1566,
'ARABIC VOWEL SIGN DOT BELOW': 1628,
'ARABIC VOWEL SIGN INVERTED SMALL V ABOVE': 1627,
'ARABIC VOWEL SIGN SMALL V ABOVE': 1626,
'ARABIC ZWARAKAY': 1625,
'ARABIC-INDIC DIGIT EIGHT': 1640,
'ARABIC-INDIC DIGIT FIVE': 1637,
'ARABIC-INDIC DIGIT FOUR': 1636,
'ARABIC-INDIC DIGIT NINE': 1641,
'ARABIC-INDIC DIGIT ONE': 1633,
'ARABIC-INDIC DIGIT SEVEN': 1639,
'ARABIC-INDIC DIGIT SIX': 1638,
'ARABIC-INDIC DIGIT THREE': 1635,
'ARABIC-INDIC DIGIT TWO': 1634,
'ARABIC-INDIC DIGIT ZERO': 1632,
'ARC': 8978,
'ARIES': 9800,
'ARMENIAN ABBREVIATION MARK': 1375,
'ARMENIAN APOSTROPHE': 1370,
'ARMENIAN CAPITAL LETTER AYB': 1329,
'ARMENIAN CAPITAL LETTER BEN': 1330,
'ARMENIAN CAPITAL LETTER CA': 1342,
'ARMENIAN CAPITAL LETTER CHA': 1353,
'ARMENIAN CAPITAL LETTER CHEH': 1347,
'ARMENIAN CAPITAL LETTER CO': 1361,
'ARMENIAN CAPITAL LETTER DA': 1332,
'ARMENIAN CAPITAL LETTER ECH': 1333,
'ARMENIAN CAPITAL LETTER EH': 1335,
'ARMENIAN CAPITAL LETTER ET': 1336,
'ARMENIAN CAPITAL LETTER FEH': 1366,
'ARMENIAN CAPITAL LETTER GHAD': 1346,
'ARMENIAN CAPITAL LETTER GIM': 1331,
'ARMENIAN CAPITAL LETTER HO': 1344,
'ARMENIAN CAPITAL LETTER INI': 1339,
'ARMENIAN CAPITAL LETTER JA': 1345,
'ARMENIAN CAPITAL LETTER JHEH': 1355,
'ARMENIAN CAPITAL LETTER KEH': 1364,
'ARMENIAN CAPITAL LETTER KEN': 1343,
'ARMENIAN CAPITAL LETTER LIWN': 1340,
'ARMENIAN CAPITAL LETTER MEN': 1348,
'ARMENIAN CAPITAL LETTER NOW': 1350,
'ARMENIAN CAPITAL LETTER OH': 1365,
'ARMENIAN CAPITAL LETTER PEH': 1354,
'ARMENIAN CAPITAL LETTER PIWR': 1363,
'ARMENIAN CAPITAL LETTER RA': 1356,
'ARMENIAN CAPITAL LETTER REH': 1360,
'ARMENIAN CAPITAL LETTER SEH': 1357,
'ARMENIAN CAPITAL LETTER SHA': 1351,
'ARMENIAN CAPITAL LETTER TIWN': 1359,
'ARMENIAN CAPITAL LETTER TO': 1337,
'ARMENIAN CAPITAL LETTER VEW': 1358,
'ARMENIAN CAPITAL LETTER VO': 1352,
'ARMENIAN CAPITAL LETTER XEH': 1341,
'ARMENIAN CAPITAL LETTER YI': 1349,
'ARMENIAN CAPITAL LETTER YIWN': 1362,
'ARMENIAN CAPITAL LETTER ZA': 1334,
'ARMENIAN CAPITAL LETTER ZHE': 1338,
'ARMENIAN COMMA': 1373,
'ARMENIAN EMPHASIS MARK': 1371,
'ARMENIAN EXCLAMATION MARK': 1372,
'ARMENIAN FULL STOP': 1417,
'ARMENIAN HYPHEN': 1418,
'ARMENIAN MODIFIER LETTER LEFT HALF RING': 1369,
'ARMENIAN QUESTION MARK': 1374,
'ARMENIAN SMALL LETTER AYB': 1377,
'ARMENIAN SMALL LETTER BEN': 1378,
'ARMENIAN SMALL LETTER CA': 1390,
'ARMENIAN SMALL LETTER CHA': 1401,
'ARMENIAN SMALL LETTER CHEH': 1395,
'ARMENIAN SMALL LETTER CO': 1409,
'ARMENIAN SMALL LETTER DA': 1380,
'ARMENIAN SMALL LETTER ECH': 1381,
'ARMENIAN SMALL LETTER EH': 1383,
'ARMENIAN SMALL LETTER ET': 1384,
'ARMENIAN SMALL LETTER FEH': 1414,
'ARMENIAN SMALL LETTER GHAD': 1394,
'ARMENIAN SMALL LETTER GIM': 1379,
'ARMENIAN SMALL LETTER HO': 1392,
'ARMENIAN SMALL LETTER INI': 1387,
'ARMENIAN SMALL LETTER JA': 1393,
'ARMENIAN SMALL LETTER JHEH': 1403,
'ARMENIAN SMALL LETTER KEH': 1412,
'ARMENIAN SMALL LETTER KEN': 1391,
'ARMENIAN SMALL LETTER LIWN': 1388,
'ARMENIAN SMALL LETTER MEN': 1396,
'ARMENIAN SMALL LETTER NOW': 1398,
'ARMENIAN SMALL LETTER OH': 1413,
'ARMENIAN SMALL LETTER PEH': 1402,
'ARMENIAN SMALL LETTER PIWR': 1411,
'ARMENIAN SMALL LETTER RA': 1404,
'ARMENIAN SMALL LETTER REH': 1408,
'ARMENIAN SMALL LETTER SEH': 1405,
'ARMENIAN SMALL LETTER SHA': 1399,
'ARMENIAN SMALL LETTER TIWN': 1407,
'ARMENIAN SMALL LETTER TO': 1385,
'ARMENIAN SMALL LETTER VEW': 1406,
'ARMENIAN SMALL LETTER VO': 1400,
'ARMENIAN SMALL LETTER XEH': 1389,
'ARMENIAN SMALL LETTER YI': 1397,
'ARMENIAN SMALL LETTER YIWN': 1410,
'ARMENIAN SMALL LETTER ZA': 1382,
'ARMENIAN SMALL LETTER ZHE': 1386,
'ARMENIAN SMALL LIGATURE ECH YIWN': 1415,
'ARMENIAN SMALL LIGATURE MEN ECH': 64276,
'ARMENIAN SMALL LIGATURE MEN INI': 64277,
'ARMENIAN SMALL LIGATURE MEN NOW': 64275,
'ARMENIAN SMALL LIGATURE MEN XEH': 64279,
'ARMENIAN SMALL LIGATURE VEW NOW': 64278,
'ARROW POINTING DOWNWARDS THEN CURVING LEFTWARDS': 10550,
'ARROW POINTING DOWNWARDS THEN CURVING RIGHTWARDS': 10551,
'ARROW POINTING RIGHTWARDS THEN CURVING DOWNWARDS': 10549,
'ARROW POINTING RIGHTWARDS THEN CURVING UPWARDS': 10548,
'ASCENDING NODE': 9738,
'ASSERTION': 8870,
'ASTERISK': 42,
'ASTERISK OPERATOR': 8727,
'ASTERISM': 8258,
'ASYMPTOTICALLY EQUAL TO': 8771,
'ATOM SYMBOL': 9883,
'AUSTRAL SIGN': 8371,
'BACK-TILTED SHADOWED WHITE RIGHTWARDS ARROW': 10155,
'BALLOON-SPOKED ASTERISK': 10057,
'BALLOT BOX': 9744,
'BALLOT BOX WITH CHECK': 9745,
'BALLOT BOX WITH X': 9746,
'BALLOT X': 10007,
'BEAMED EIGHTH NOTES': 9835,
'BEAMED SIXTEENTH NOTES': 9836,
'BECAUSE': 8757,
'BELL SYMBOL': 9086,
'BENGALI AU LENGTH MARK': 2519,
'BENGALI CURRENCY DENOMINATOR SIXTEEN': 2553,
'BENGALI CURRENCY NUMERATOR FOUR': 2551,
'BENGALI CURRENCY NUMERATOR ONE': 2548,
'BENGALI CURRENCY NUMERATOR ONE LESS THAN THE DENOMINATOR': 2552,
'BENGALI CURRENCY NUMERATOR THREE': 2550,
'BENGALI CURRENCY NUMERATOR TWO': 2549,
'BENGALI DIGIT EIGHT': 2542,
'BENGALI DIGIT FIVE': 2539,
'BENGALI DIGIT FOUR': 2538,
'BENGALI DIGIT NINE': 2543,
'BENGALI DIGIT ONE': 2535,
'BENGALI DIGIT SEVEN': 2541,
'BENGALI DIGIT SIX': 2540,
'BENGALI DIGIT THREE': 2537,
'BENGALI DIGIT TWO': 2536,
'BENGALI DIGIT ZERO': 2534,
'BENGALI ISSHAR': 2554,
'BENGALI LETTER A': 2437,
'BENGALI LETTER AA': 2438,
'BENGALI LETTER AI': 2448,
'BENGALI LETTER AU': 2452,
'BENGALI LETTER BA': 2476,
'BENGALI LETTER BHA': 2477,
'BENGALI LETTER CA': 2458,
'BENGALI LETTER CHA': 2459,
'BENGALI LETTER DA': 2470,
'BENGALI LETTER DDA': 2465,
'BENGALI LETTER DDHA': 2466,
'BENGALI LETTER DHA': 2471,
'BENGALI LETTER E': 2447,
'BENGALI LETTER GA': 2455,
'BENGALI LETTER GHA': 2456,
'BENGALI LETTER HA': 2489,
'BENGALI LETTER I': 2439,
'BENGALI LETTER II': 2440,
'BENGALI LETTER JA': 2460,
'BENGALI LETTER JHA': 2461,
'BENGALI LETTER KA': 2453,
'BENGALI LETTER KHA': 2454,
'BENGALI LETTER KHANDA TA': 2510,
'BENGALI LETTER LA': 2482,
'BENGALI LETTER MA': 2478,
'BENGALI LETTER NA': 2472,
'BENGALI LETTER NGA': 2457,
'BENGALI LETTER NNA': 2467,
'BENGALI LETTER NYA': 2462,
'BENGALI LETTER O': 2451,
'BENGALI LETTER PA': 2474,
'BENGALI LETTER PHA': 2475,
'BENGALI LETTER RA': 2480,
'BENGALI LETTER RA WITH LOWER DIAGONAL': 2545,
'BENGALI LETTER RA WITH MIDDLE DIAGONAL': 2544,
'BENGALI LETTER RHA': 2525,
'BENGALI LETTER RRA': 2524,
'BENGALI LETTER SA': 2488,
'BENGALI LETTER SHA': 2486,
'BENGALI LETTER SSA': 2487,
'BENGALI LETTER TA': 2468,
'BENGALI LETTER THA': 2469,
'BENGALI LETTER TTA': 2463,
'BENGALI LETTER TTHA': 2464,
'BENGALI LETTER U': 2441,
'BENGALI LETTER UU': 2442,
'BENGALI LETTER VOCALIC L': 2444,
'BENGALI LETTER VOCALIC LL': 2529,
'BENGALI LETTER VOCALIC R': 2443,
'BENGALI LETTER VOCALIC RR': 2528,
'BENGALI LETTER YA': 2479,
'BENGALI LETTER YYA': 2527,
'BENGALI RUPEE MARK': 2546,
'BENGALI RUPEE SIGN': 2547,
'BENGALI SIGN ANUSVARA': 2434,
'BENGALI SIGN AVAGRAHA': 2493,
'BENGALI SIGN CANDRABINDU': 2433,
'BENGALI SIGN NUKTA': 2492,
'BENGALI SIGN VIRAMA': 2509,
'BENGALI SIGN VISARGA': 2435,
'BENGALI VOWEL SIGN AA': 2494,
'BENGALI VOWEL SIGN AI': 2504,
'BENGALI VOWEL SIGN AU': 2508,
'BENGALI VOWEL SIGN E': 2503,
'BENGALI VOWEL SIGN I': 2495,
'BENGALI VOWEL SIGN II': 2496,
'BENGALI VOWEL SIGN O': 2507,
'BENGALI VOWEL SIGN U': 2497,
'BENGALI VOWEL SIGN UU': 2498,
'BENGALI VOWEL SIGN VOCALIC L': 2530,
'BENGALI VOWEL SIGN VOCALIC LL': 2531,
'BENGALI VOWEL SIGN VOCALIC R': 2499,
'BENGALI VOWEL SIGN VOCALIC RR': 2500,
'BENZENE RING': 9004,
'BET SYMBOL': 8502,
'BETWEEN': 8812,
'BIG REVERSE SOLIDUS': 10745,
'BIG SOLIDUS': 10744,
'BIOHAZARD SIGN': 9763,
'BLACK BOWTIE': 10707,
'BLACK CENTRE WHITE STAR': 10028,
'BLACK CHESS BISHOP': 9821,
'BLACK CHESS KING': 9818,
'BLACK CHESS KNIGHT': 9822,
'BLACK CHESS PAWN': 9823,
'BLACK CHESS QUEEN': 9819,
'BLACK CHESS ROOK': 9820,
'BLACK CIRCLE': 9679,
'BLACK CIRCLE WITH DOWN ARROW': 10733,
'BLACK CIRCLE WITH TWO WHITE DOTS': 9865,
'BLACK CIRCLE WITH WHITE DOT RIGHT': 9864,
'BLACK CLUB SUIT': 9827,
'BLACK DIAMOND': 9670,
'BLACK DIAMOND MINUS WHITE X': 10070,
'BLACK DIAMOND SUIT': 9830,
'BLACK DIAMOND WITH DOWN ARROW': 10730,
'BLACK DOWN-POINTING SMALL TRIANGLE': 9662,
'BLACK DOWN-POINTING TRIANGLE': 9660,
'BLACK FLAG': 9873,
'BLACK FLORETTE': 10047,
'BLACK FOUR POINTED STAR': 10022,
'BLACK HEART SUIT': 9829,
'BLACK HOURGLASS': 10711,
'BLACK LEFT POINTING INDEX': 9754,
'BLACK LEFT-POINTING POINTER': 9668,
'BLACK LEFT-POINTING SMALL TRIANGLE': 9666,
'BLACK LEFT-POINTING TRIANGLE': 9664,
'BLACK LEFTWARDS BULLET': 8268,
'BLACK LOWER LEFT TRIANGLE': 9699,
'BLACK LOWER RIGHT TRIANGLE': 9698,
'BLACK LOZENGE': 10731,
'BLACK MEDIUM SMALL SQUARE': 9726,
'BLACK MEDIUM SQUARE': 9724,
'BLACK NIB': 10002,
'BLACK PARALLELOGRAM': 9648,
'BLACK RECTANGLE': 9644,
'BLACK RIGHT POINTING INDEX': 9755,
'BLACK RIGHT-POINTING POINTER': 9658,
'BLACK RIGHT-POINTING SMALL TRIANGLE': 9656,
'BLACK RIGHT-POINTING TRIANGLE': 9654,
'BLACK RIGHTWARDS ARROW': 10145,
'BLACK RIGHTWARDS ARROWHEAD': 10148,
'BLACK RIGHTWARDS BULLET': 8269,
'BLACK SCISSORS': 9986,
'BLACK SHOGI PIECE': 9751,
'BLACK SMALL SQUARE': 9642,
'BLACK SMILING FACE': 9787,
'BLACK SPADE SUIT': 9824,
'BLACK SQUARE': 9632,
'BLACK STAR': 9733,
'BLACK SUN WITH RAYS': 9728,
'BLACK TELEPHONE': 9742,
'BLACK UNIVERSAL RECYCLING SYMBOL': 9851,
'BLACK UP-POINTING SMALL TRIANGLE': 9652,
'BLACK UP-POINTING TRIANGLE': 9650,
'BLACK UPPER LEFT TRIANGLE': 9700,
'BLACK UPPER RIGHT TRIANGLE': 9701,
'BLACK VERTICAL RECTANGLE': 9646,
'BLACK-FEATHERED NORTH EAST ARROW': 10166,
'BLACK-FEATHERED RIGHTWARDS ARROW': 10165,
'BLACK-FEATHERED SOUTH EAST ARROW': 10164,
'BLACK-LETTER CAPITAL C': 8493,
'BLACK-LETTER CAPITAL H': 8460,
'BLACK-LETTER CAPITAL I': 8465,
'BLACK-LETTER CAPITAL R': 8476,
'BLACK-LETTER CAPITAL Z': 8488,
'BLANK SYMBOL': 9250,
'BOPOMOFO FINAL LETTER H': 12727,
'BOPOMOFO FINAL LETTER K': 12726,
'BOPOMOFO FINAL LETTER P': 12724,
'BOPOMOFO FINAL LETTER T': 12725,
'BOPOMOFO LETTER A': 12570,
'BOPOMOFO LETTER AI': 12574,
'BOPOMOFO LETTER AINN': 12718,
'BOPOMOFO LETTER AM': 12720,
'BOPOMOFO LETTER AN': 12578,
'BOPOMOFO LETTER ANG': 12580,
'BOPOMOFO LETTER ANN': 12713,
'BOPOMOFO LETTER AU': 12576,
'BOPOMOFO LETTER AUNN': 12719,
'BOPOMOFO LETTER B': 12549,
'BOPOMOFO LETTER BU': 12704,
'BOPOMOFO LETTER C': 12568,
'BOPOMOFO LETTER CH': 12564,
'BOPOMOFO LETTER D': 12553,
'BOPOMOFO LETTER E': 12572,
'BOPOMOFO LETTER EE': 12708,
'BOPOMOFO LETTER EH': 12573,
'BOPOMOFO LETTER EI': 12575,
'BOPOMOFO LETTER EN': 12579,
'BOPOMOFO LETTER ENG': 12581,
'BOPOMOFO LETTER ENN': 12709,
'BOPOMOFO LETTER ER': 12582,
'BOPOMOFO LETTER F': 12552,
'BOPOMOFO LETTER G': 12557,
'BOPOMOFO LETTER GN': 12588,
'BOPOMOFO LETTER GU': 12707,
'BOPOMOFO LETTER H': 12559,
'BOPOMOFO LETTER I': 12583,
'BOPOMOFO LETTER IM': 12716,
'BOPOMOFO LETTER INN': 12714,
'BOPOMOFO LETTER INNN': 12723,
'BOPOMOFO LETTER IR': 12712,
'BOPOMOFO LETTER IU': 12585,
'BOPOMOFO LETTER J': 12560,
'BOPOMOFO LETTER JI': 12706,
'BOPOMOFO LETTER K': 12558,
'BOPOMOFO LETTER L': 12556,
'BOPOMOFO LETTER M': 12551,
'BOPOMOFO LETTER N': 12555,
'BOPOMOFO LETTER NG': 12587,
'BOPOMOFO LETTER NGG': 12717,
'BOPOMOFO LETTER O': 12571,
'BOPOMOFO LETTER OM': 12721,
'BOPOMOFO LETTER ONG': 12722,
'BOPOMOFO LETTER ONN': 12711,
'BOPOMOFO LETTER OO': 12710,
'BOPOMOFO LETTER OU': 12577,
'BOPOMOFO LETTER P': 12550,
'BOPOMOFO LETTER Q': 12561,
'BOPOMOFO LETTER R': 12566,
'BOPOMOFO LETTER S': 12569,
'BOPOMOFO LETTER SH': 12565,
'BOPOMOFO LETTER T': 12554,
'BOPOMOFO LETTER U': 12584,
'BOPOMOFO LETTER UNN': 12715,
'BOPOMOFO LETTER V': 12586,
'BOPOMOFO LETTER X': 12562,
'BOPOMOFO LETTER Z': 12567,
'BOPOMOFO LETTER ZH': 12563,
'BOPOMOFO LETTER ZI': 12705,
'BOTTOM ARC ANTICLOCKWISE ARROW': 10555,
'BOTTOM HALF INTEGRAL': 8993,
'BOTTOM LEFT CORNER': 8990,
'BOTTOM LEFT CROP': 8973,
'BOTTOM RIGHT CORNER': 8991,
'BOTTOM RIGHT CROP': 8972,
'BOTTOM SQUARE BRACKET': 9141,
'BOTTOM SQUARE BRACKET OVER TOP SQUARE BRACKET': 9142,
'BOWTIE': 8904,
'BOWTIE WITH LEFT HALF BLACK': 10705,
'BOWTIE WITH RIGHT HALF BLACK': 10706,
'BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL': 9574,
'BOX DRAWINGS DOUBLE DOWN AND LEFT': 9559,
'BOX DRAWINGS DOUBLE DOWN AND RIGHT': 9556,
'BOX DRAWINGS DOUBLE HORIZONTAL': 9552,
'BOX DRAWINGS DOUBLE UP AND HORIZONTAL': 9577,
'BOX DRAWINGS DOUBLE UP AND LEFT': 9565,
'BOX DRAWINGS DOUBLE UP AND RIGHT': 9562,
'BOX DRAWINGS DOUBLE VERTICAL': 9553,
'BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL': 9580,
'BOX DRAWINGS DOUBLE VERTICAL AND LEFT': 9571,
'BOX DRAWINGS DOUBLE VERTICAL AND RIGHT': 9568,
'BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE': 9573,
'BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE': 9558,
'BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE': 9555,
'BOX DRAWINGS DOWN HEAVY AND HORIZONTAL LIGHT': 9520,
'BOX DRAWINGS DOWN HEAVY AND LEFT LIGHT': 9490,
'BOX DRAWINGS DOWN HEAVY AND LEFT UP LIGHT': 9511,
'BOX DRAWINGS DOWN HEAVY AND RIGHT LIGHT': 9486,
'BOX DRAWINGS DOWN HEAVY AND RIGHT UP LIGHT': 9503,
'BOX DRAWINGS DOWN HEAVY AND UP HORIZONTAL LIGHT': 9537,
'BOX DRAWINGS DOWN LIGHT AND HORIZONTAL HEAVY': 9519,
'BOX DRAWINGS DOWN LIGHT AND LEFT HEAVY': 9489,
'BOX DRAWINGS DOWN LIGHT AND LEFT UP HEAVY': 9513,
'BOX DRAWINGS DOWN LIGHT AND RIGHT HEAVY': 9485,
'BOX DRAWINGS DOWN LIGHT AND RIGHT UP HEAVY': 9505,
'BOX DRAWINGS DOWN LIGHT AND UP HORIZONTAL HEAVY': 9543,
'BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE': 9572,
'BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE': 9557,
'BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE': 9554,
'BOX DRAWINGS HEAVY DOUBLE DASH HORIZONTAL': 9549,
'BOX DRAWINGS HEAVY DOUBLE DASH VERTICAL': 9551,
'BOX DRAWINGS HEAVY DOWN': 9595,
'BOX DRAWINGS HEAVY DOWN AND HORIZONTAL': 9523,
'BOX DRAWINGS HEAVY DOWN AND LEFT': 9491,
'BOX DRAWINGS HEAVY DOWN AND RIGHT': 9487,
'BOX DRAWINGS HEAVY HORIZONTAL': 9473,
'BOX DRAWINGS HEAVY LEFT': 9592,
'BOX DRAWINGS HEAVY LEFT AND LIGHT RIGHT': 9598,
'BOX DRAWINGS HEAVY QUADRUPLE DASH HORIZONTAL': 9481,
'BOX DRAWINGS HEAVY QUADRUPLE DASH VERTICAL': 9483,
'BOX DRAWINGS HEAVY RIGHT': 9594,
'BOX DRAWINGS HEAVY TRIPLE DASH HORIZONTAL': 9477,
'BOX DRAWINGS HEAVY TRIPLE DASH VERTICAL': 9479,
'BOX DRAWINGS HEAVY UP': 9593,
'BOX DRAWINGS HEAVY UP AND HORIZONTAL': 9531,
'BOX DRAWINGS HEAVY UP AND LEFT': 9499,
'BOX DRAWINGS HEAVY UP AND LIGHT DOWN': 9599,
'BOX DRAWINGS HEAVY UP AND RIGHT': 9495,
'BOX DRAWINGS HEAVY VERTICAL': 9475,
'BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL': 9547,
'BOX DRAWINGS HEAVY VERTICAL AND LEFT': 9515,
'BOX DRAWINGS HEAVY VERTICAL AND RIGHT': 9507,
'BOX DRAWINGS LEFT DOWN HEAVY AND RIGHT UP LIGHT': 9541,
'BOX DRAWINGS LEFT HEAVY AND RIGHT DOWN LIGHT': 9517,
'BOX DRAWINGS LEFT HEAVY AND RIGHT UP LIGHT': 9525,
'BOX DRAWINGS LEFT HEAVY AND RIGHT VERTICAL LIGHT': 9533,
'BOX DRAWINGS LEFT LIGHT AND RIGHT DOWN HEAVY': 9522,
'BOX DRAWINGS LEFT LIGHT AND RIGHT UP HEAVY': 9530,
'BOX DRAWINGS LEFT LIGHT AND RIGHT VERTICAL HEAVY': 9546,
'BOX DRAWINGS LEFT UP HEAVY AND RIGHT DOWN LIGHT': 9539,
'BOX DRAWINGS LIGHT ARC DOWN AND LEFT': 9582,
'BOX DRAWINGS LIGHT ARC DOWN AND RIGHT': 9581,
'BOX DRAWINGS LIGHT ARC UP AND LEFT': 9583,
'BOX DRAWINGS LIGHT ARC UP AND RIGHT': 9584,
'BOX DRAWINGS LIGHT DIAGONAL CROSS': 9587,
'BOX DRAWINGS LIGHT DIAGONAL UPPER LEFT TO LOWER RIGHT': 9586,
'BOX DRAWINGS LIGHT DIAGONAL UPPER RIGHT TO LOWER LEFT': 9585,
'BOX DRAWINGS LIGHT DOUBLE DASH HORIZONTAL': 9548,
'BOX DRAWINGS LIGHT DOUBLE DASH VERTICAL': 9550,
'BOX DRAWINGS LIGHT DOWN': 9591,
'BOX DRAWINGS LIGHT DOWN AND HORIZONTAL': 9516,
'BOX DRAWINGS LIGHT DOWN AND LEFT': 9488,
'BOX DRAWINGS LIGHT DOWN AND RIGHT': 9484,
'BOX DRAWINGS LIGHT HORIZONTAL': 9472,
'BOX DRAWINGS LIGHT LEFT': 9588,
'BOX DRAWINGS LIGHT LEFT AND HEAVY RIGHT': 9596,
'BOX DRAWINGS LIGHT QUADRUPLE DASH HORIZONTAL': 9480,
'BOX DRAWINGS LIGHT QUADRUPLE DASH VERTICAL': 9482,
'BOX DRAWINGS LIGHT RIGHT': 9590,
'BOX DRAWINGS LIGHT TRIPLE DASH HORIZONTAL': 9476,
'BOX DRAWINGS LIGHT TRIPLE DASH VERTICAL': 9478,
'BOX DRAWINGS LIGHT UP': 9589,
'BOX DRAWINGS LIGHT UP AND HEAVY DOWN': 9597,
'BOX DRAWINGS LIGHT UP AND HORIZONTAL': 9524,
'BOX DRAWINGS LIGHT UP AND LEFT': 9496,
'BOX DRAWINGS LIGHT UP AND RIGHT': 9492,
'BOX DRAWINGS LIGHT VERTICAL': 9474,
'BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL': 9532,
'BOX DRAWINGS LIGHT VERTICAL AND LEFT': 9508,
'BOX DRAWINGS LIGHT VERTICAL AND RIGHT': 9500,
'BOX DRAWINGS RIGHT DOWN HEAVY AND LEFT UP LIGHT': 9542,
'BOX DRAWINGS RIGHT HEAVY AND LEFT DOWN LIGHT': 9518,
'BOX DRAWINGS RIGHT HEAVY AND LEFT UP LIGHT': 9526,
'BOX DRAWINGS RIGHT HEAVY AND LEFT VERTICAL LIGHT': 9534,
'BOX DRAWINGS RIGHT LIGHT AND LEFT DOWN HEAVY': 9521,
'BOX DRAWINGS RIGHT LIGHT AND LEFT UP HEAVY': 9529,
'BOX DRAWINGS RIGHT LIGHT AND LEFT VERTICAL HEAVY': 9545,
'BOX DRAWINGS RIGHT UP HEAVY AND LEFT DOWN LIGHT': 9540,
'BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE': 9576,
'BOX DRAWINGS UP DOUBLE AND LEFT SINGLE': 9564,
'BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE': 9561,
'BOX DRAWINGS UP HEAVY AND DOWN HORIZONTAL LIGHT': 9536,
'BOX DRAWINGS UP HEAVY AND HORIZONTAL LIGHT': 9528,
'BOX DRAWINGS UP HEAVY AND LEFT DOWN LIGHT': 9510,
'BOX DRAWINGS UP HEAVY AND LEFT LIGHT': 9498,
'BOX DRAWINGS UP HEAVY AND RIGHT DOWN LIGHT': 9502,
'BOX DRAWINGS UP HEAVY AND RIGHT LIGHT': 9494,
'BOX DRAWINGS UP LIGHT AND DOWN HORIZONTAL HEAVY': 9544,
'BOX DRAWINGS UP LIGHT AND HORIZONTAL HEAVY': 9527,
'BOX DRAWINGS UP LIGHT AND LEFT DOWN HEAVY': 9514,
'BOX DRAWINGS UP LIGHT AND LEFT HEAVY': 9497,
'BOX DRAWINGS UP LIGHT AND RIGHT DOWN HEAVY': 9506,
'BOX DRAWINGS UP LIGHT AND RIGHT HEAVY': 9493,
'BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE': 9575,
'BOX DRAWINGS UP SINGLE AND LEFT DOUBLE': 9563,
'BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE': 9560,
'BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE': 9579,
'BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE': 9570,
'BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE': 9567,
'BOX DRAWINGS VERTICAL HEAVY AND HORIZONTAL LIGHT': 9538,
'BOX DRAWINGS VERTICAL HEAVY AND LEFT LIGHT': 9512,
'BOX DRAWINGS VERTICAL HEAVY AND RIGHT LIGHT': 9504,
'BOX DRAWINGS VERTICAL LIGHT AND HORIZONTAL HEAVY': 9535,
'BOX DRAWINGS VERTICAL LIGHT AND LEFT HEAVY': 9509,
'BOX DRAWINGS VERTICAL LIGHT AND RIGHT HEAVY': 9501,
'BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE': 9578,
'BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE': 9569,
'BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE': 9566,
'BRAILLE PATTERN BLANK': 10240,
'BRAILLE PATTERN DOTS-1': 10241,
'BRAILLE PATTERN DOTS-12': 10243,
'BRAILLE PATTERN DOTS-123': 10247,
'BRAILLE PATTERN DOTS-1234': 10255,
'BRAILLE PATTERN DOTS-12345': 10271,
'BRAILLE PATTERN DOTS-123456': 10303,
'BRAILLE PATTERN DOTS-1234567': 10367,
'BRAILLE PATTERN DOTS-12345678': 10495,
'BRAILLE PATTERN DOTS-1234568': 10431,
'BRAILLE PATTERN DOTS-123457': 10335,
'BRAILLE PATTERN DOTS-1234578': 10463,
'BRAILLE PATTERN DOTS-123458': 10399,
'BRAILLE PATTERN DOTS-12346': 10287,
'BRAILLE PATTERN DOTS-123467': 10351,
'BRAILLE PATTERN DOTS-1234678': 10479,
'BRAILLE PATTERN DOTS-123468': 10415,
'BRAILLE PATTERN DOTS-12347': 10319,
'BRAILLE PATTERN DOTS-123478': 10447,
'BRAILLE PATTERN DOTS-12348': 10383,
'BRAILLE PATTERN DOTS-1235': 10263,
'BRAILLE PATTERN DOTS-12356': 10295,
'BRAILLE PATTERN DOTS-123567': 10359,
'BRAILLE PATTERN DOTS-1235678': 10487,
'BRAILLE PATTERN DOTS-123568': 10423,
'BRAILLE PATTERN DOTS-12357': 10327,
'BRAILLE PATTERN DOTS-123578': 10455,
'BRAILLE PATTERN DOTS-12358': 10391,
'BRAILLE PATTERN DOTS-1236': 10279,
'BRAILLE PATTERN DOTS-12367': 10343,
'BRAILLE PATTERN DOTS-123678': 10471,
'BRAILLE PATTERN DOTS-12368': 10407,
'BRAILLE PATTERN DOTS-1237': 10311,
'BRAILLE PATTERN DOTS-12378': 10439,
'BRAILLE PATTERN DOTS-1238': 10375,
'BRAILLE PATTERN DOTS-124': 10251,
'BRAILLE PATTERN DOTS-1245': 10267,
'BRAILLE PATTERN DOTS-12456': 10299,
'BRAILLE PATTERN DOTS-124567': 10363,
'BRAILLE PATTERN DOTS-1245678': 10491,
'BRAILLE PATTERN DOTS-124568': 10427,
'BRAILLE PATTERN DOTS-12457': 10331,
'BRAILLE PATTERN DOTS-124578': 10459,
'BRAILLE PATTERN DOTS-12458': 10395,
'BRAILLE PATTERN DOTS-1246': 10283,
'BRAILLE PATTERN DOTS-12467': 10347,
'BRAILLE PATTERN DOTS-124678': 10475,
'BRAILLE PATTERN DOTS-12468': 10411,
'BRAILLE PATTERN DOTS-1247': 10315,
'BRAILLE PATTERN DOTS-12478': 10443,
'BRAILLE PATTERN DOTS-1248': 10379,
'BRAILLE PATTERN DOTS-125': 10259,
'BRAILLE PATTERN DOTS-1256': 10291,
'BRAILLE PATTERN DOTS-12567': 10355,
'BRAILLE PATTERN DOTS-125678': 10483,
'BRAILLE PATTERN DOTS-12568': 10419,
'BRAILLE PATTERN DOTS-1257': 10323,
'BRAILLE PATTERN DOTS-12578': 10451,
'BRAILLE PATTERN DOTS-1258': 10387,
'BRAILLE PATTERN DOTS-126': 10275,
'BRAILLE PATTERN DOTS-1267': 10339,
'BRAILLE PATTERN DOTS-12678': 10467,
'BRAILLE PATTERN DOTS-1268': 10403,
'BRAILLE PATTERN DOTS-127': 10307,
'BRAILLE PATTERN DOTS-1278': 10435,
'BRAILLE PATTERN DOTS-128': 10371,
'BRAILLE PATTERN DOTS-13': 10245,
'BRAILLE PATTERN DOTS-134': 10253,
'BRAILLE PATTERN DOTS-1345': 10269,
'BRAILLE PATTERN DOTS-13456': 10301,
'BRAILLE PATTERN DOTS-134567': 10365,
'BRAILLE PATTERN DOTS-1345678': 10493,
'BRAILLE PATTERN DOTS-134568': 10429,
'BRAILLE PATTERN DOTS-13457': 10333,
'BRAILLE PATTERN DOTS-134578': 10461,
'BRAILLE PATTERN DOTS-13458': 10397,
'BRAILLE PATTERN DOTS-1346': 10285,
'BRAILLE PATTERN DOTS-13467': 10349,
'BRAILLE PATTERN DOTS-134678': 10477,
'BRAILLE PATTERN DOTS-13468': 10413,
'BRAILLE PATTERN DOTS-1347': 10317,
'BRAILLE PATTERN DOTS-13478': 10445,
'BRAILLE PATTERN DOTS-1348': 10381,
'BRAILLE PATTERN DOTS-135': 10261,
'BRAILLE PATTERN DOTS-1356': 10293,
'BRAILLE PATTERN DOTS-13567': 10357,
'BRAILLE PATTERN DOTS-135678': 10485,
'BRAILLE PATTERN DOTS-13568': 10421,
'BRAILLE PATTERN DOTS-1357': 10325,
'BRAILLE PATTERN DOTS-13578': 10453,
'BRAILLE PATTERN DOTS-1358': 10389,
'BRAILLE PATTERN DOTS-136': 10277,
'BRAILLE PATTERN DOTS-1367': 10341,
'BRAILLE PATTERN DOTS-13678': 10469,
'BRAILLE PATTERN DOTS-1368': 10405,
'BRAILLE PATTERN DOTS-137': 10309,
'BRAILLE PATTERN DOTS-1378': 10437,
'BRAILLE PATTERN DOTS-138': 10373,
'BRAILLE PATTERN DOTS-14': 10249,
'BRAILLE PATTERN DOTS-145': 10265,
'BRAILLE PATTERN DOTS-1456': 10297,
'BRAILLE PATTERN DOTS-14567': 10361,
'BRAILLE PATTERN DOTS-145678': 10489,
'BRAILLE PATTERN DOTS-14568': 10425,
'BRAILLE PATTERN DOTS-1457': 10329,
'BRAILLE PATTERN DOTS-14578': 10457,
'BRAILLE PATTERN DOTS-1458': 10393,
'BRAILLE PATTERN DOTS-146': 10281,
'BRAILLE PATTERN DOTS-1467': 10345,
'BRAILLE PATTERN DOTS-14678': 10473,
'BRAILLE PATTERN DOTS-1468': 10409,
'BRAILLE PATTERN DOTS-147': 10313,
'BRAILLE PATTERN DOTS-1478': 10441,
'BRAILLE PATTERN DOTS-148': 10377,
'BRAILLE PATTERN DOTS-15': 10257,
'BRAILLE PATTERN DOTS-156': 10289,
'BRAILLE PATTERN DOTS-1567': 10353,
'BRAILLE PATTERN DOTS-15678': 10481,
'BRAILLE PATTERN DOTS-1568': 10417,
'BRAILLE PATTERN DOTS-157': 10321,
'BRAILLE PATTERN DOTS-1578': 10449,
'BRAILLE PATTERN DOTS-158': 10385,
'BRAILLE PATTERN DOTS-16': 10273,
'BRAILLE PATTERN DOTS-167': 10337,
'BRAILLE PATTERN DOTS-1678': 10465,
'BRAILLE PATTERN DOTS-168': 10401,
'BRAILLE PATTERN DOTS-17': 10305,
'BRAILLE PATTERN DOTS-178': 10433,
'BRAILLE PATTERN DOTS-18': 10369,
'BRAILLE PATTERN DOTS-2': 10242,
'BRAILLE PATTERN DOTS-23': 10246,
'BRAILLE PATTERN DOTS-234': 10254,
'BRAILLE PATTERN DOTS-2345': 10270,
'BRAILLE PATTERN DOTS-23456': 10302,
'BRAILLE PATTERN DOTS-234567': 10366,
'BRAILLE PATTERN DOTS-2345678': 10494,
'BRAILLE PATTERN DOTS-234568': 10430,
'BRAILLE PATTERN DOTS-23457': 10334,
'BRAILLE PATTERN DOTS-234578': 10462,
'BRAILLE PATTERN DOTS-23458': 10398,
'BRAILLE PATTERN DOTS-2346': 10286,
'BRAILLE PATTERN DOTS-23467': 10350,
'BRAILLE PATTERN DOTS-234678': 10478,
'BRAILLE PATTERN DOTS-23468': 10414,
'BRAILLE PATTERN DOTS-2347': 10318,
'BRAILLE PATTERN DOTS-23478': 10446,
'BRAILLE PATTERN DOTS-2348': 10382,
'BRAILLE PATTERN DOTS-235': 10262,
'BRAILLE PATTERN DOTS-2356': 10294,
'BRAILLE PATTERN DOTS-23567': 10358,
'BRAILLE PATTERN DOTS-235678': 10486,
'BRAILLE PATTERN DOTS-23568': 10422,
'BRAILLE PATTERN DOTS-2357': 10326,
'BRAILLE PATTERN DOTS-23578': 10454,
'BRAILLE PATTERN DOTS-2358': 10390,
'BRAILLE PATTERN DOTS-236': 10278,
'BRAILLE PATTERN DOTS-2367': 10342,
'BRAILLE PATTERN DOTS-23678': 10470,
'BRAILLE PATTERN DOTS-2368': 10406,
'BRAILLE PATTERN DOTS-237': 10310,
'BRAILLE PATTERN DOTS-2378': 10438,
'BRAILLE PATTERN DOTS-238': 10374,
'BRAILLE PATTERN DOTS-24': 10250,
'BRAILLE PATTERN DOTS-245': 10266,
'BRAILLE PATTERN DOTS-2456': 10298,
'BRAILLE PATTERN DOTS-24567': 10362,
'BRAILLE PATTERN DOTS-245678': 10490,
'BRAILLE PATTERN DOTS-24568': 10426,
'BRAILLE PATTERN DOTS-2457': 10330,
'BRAILLE PATTERN DOTS-24578': 10458,
'BRAILLE PATTERN DOTS-2458': 10394,
'BRAILLE PATTERN DOTS-246': 10282,
'BRAILLE PATTERN DOTS-2467': 10346,
'BRAILLE PATTERN DOTS-24678': 10474,
'BRAILLE PATTERN DOTS-2468': 10410,
'BRAILLE PATTERN DOTS-247': 10314,
'BRAILLE PATTERN DOTS-2478': 10442,
'BRAILLE PATTERN DOTS-248': 10378,
'BRAILLE PATTERN DOTS-25': 10258,
'BRAILLE PATTERN DOTS-256': 10290,
'BRAILLE PATTERN DOTS-2567': 10354,
'BRAILLE PATTERN DOTS-25678': 10482,
'BRAILLE PATTERN DOTS-2568': 10418,
'BRAILLE PATTERN DOTS-257': 10322,
'BRAILLE PATTERN DOTS-2578': 10450,
'BRAILLE PATTERN DOTS-258': 10386,
'BRAILLE PATTERN DOTS-26': 10274,
'BRAILLE PATTERN DOTS-267': 10338,
'BRAILLE PATTERN DOTS-2678': 10466,
'BRAILLE PATTERN DOTS-268': 10402,
'BRAILLE PATTERN DOTS-27': 10306,
'BRAILLE PATTERN DOTS-278': 10434,
'BRAILLE PATTERN DOTS-28': 10370,
'BRAILLE PATTERN DOTS-3': 10244,
'BRAILLE PATTERN DOTS-34': 10252,
'BRAILLE PATTERN DOTS-345': 10268,
'BRAILLE PATTERN DOTS-3456': 10300,
'BRAILLE PATTERN DOTS-34567': 10364,
'BRAILLE PATTERN DOTS-345678': 10492,
'BRAILLE PATTERN DOTS-34568': 10428,
'BRAILLE PATTERN DOTS-3457': 10332,
'BRAILLE PATTERN DOTS-34578': 10460,
'BRAILLE PATTERN DOTS-3458': 10396,
'BRAILLE PATTERN DOTS-346': 10284,
'BRAILLE PATTERN DOTS-3467': 10348,
'BRAILLE PATTERN DOTS-34678': 10476,
'BRAILLE PATTERN DOTS-3468': 10412,
'BRAILLE PATTERN DOTS-347': 10316,
'BRAILLE PATTERN DOTS-3478': 10444,
'BRAILLE PATTERN DOTS-348': 10380,
'BRAILLE PATTERN DOTS-35': 10260,
'BRAILLE PATTERN DOTS-356': 10292,
'BRAILLE PATTERN DOTS-3567': 10356,
'BRAILLE PATTERN DOTS-35678': 10484,
'BRAILLE PATTERN DOTS-3568': 10420,
'BRAILLE PATTERN DOTS-357': 10324,
'BRAILLE PATTERN DOTS-3578': 10452,
'BRAILLE PATTERN DOTS-358': 10388,
'BRAILLE PATTERN DOTS-36': 10276,
'BRAILLE PATTERN DOTS-367': 10340,
'BRAILLE PATTERN DOTS-3678': 10468,
'BRAILLE PATTERN DOTS-368': 10404,
'BRAILLE PATTERN DOTS-37': 10308,
'BRAILLE PATTERN DOTS-378': 10436,
'BRAILLE PATTERN DOTS-38': 10372,
'BRAILLE PATTERN DOTS-4': 10248,
'BRAILLE PATTERN DOTS-45': 10264,
'BRAILLE PATTERN DOTS-456': 10296,
'BRAILLE PATTERN DOTS-4567': 10360,
'BRAILLE PATTERN DOTS-45678': 10488,
'BRAILLE PATTERN DOTS-4568': 10424,
'BRAILLE PATTERN DOTS-457': 10328,
'BRAILLE PATTERN DOTS-4578': 10456,
'BRAILLE PATTERN DOTS-458': 10392,
'BRAILLE PATTERN DOTS-46': 10280,
'BRAILLE PATTERN DOTS-467': 10344,
'BRAILLE PATTERN DOTS-4678': 10472,
'BRAILLE PATTERN DOTS-468': 10408,
'BRAILLE PATTERN DOTS-47': 10312,
'BRAILLE PATTERN DOTS-478': 10440,
'BRAILLE PATTERN DOTS-48': 10376,
'BRAILLE PATTERN DOTS-5': 10256,
'BRAILLE PATTERN DOTS-56': 10288,
'BRAILLE PATTERN DOTS-567': 10352,
'BRAILLE PATTERN DOTS-5678': 10480,
'BRAILLE PATTERN DOTS-568': 10416,
'BRAILLE PATTERN DOTS-57': 10320,
'BRAILLE PATTERN DOTS-578': 10448,
'BRAILLE PATTERN DOTS-58': 10384,
'BRAILLE PATTERN DOTS-6': 10272,
'BRAILLE PATTERN DOTS-67': 10336,
'BRAILLE PATTERN DOTS-678': 10464,
'BRAILLE PATTERN DOTS-68': 10400,
'BRAILLE PATTERN DOTS-7': 10304,
'BRAILLE PATTERN DOTS-78': 10432,
'BRAILLE PATTERN DOTS-8': 10368,
'BREVE': 728,
'BROKEN BAR': 166,
'BROKEN CIRCLE WITH NORTHWEST ARROW': 9099,
'BUGINESE END OF SECTION': 6687,
'BUGINESE LETTER A': 6677,
'BUGINESE LETTER BA': 6661,
'BUGINESE LETTER CA': 6668,
'BUGINESE LETTER DA': 6665,
'BUGINESE LETTER GA': 6657,
'BUGINESE LETTER HA': 6678,
'BUGINESE LETTER JA': 6669,
'BUGINESE LETTER KA': 6656,
'BUGINESE LETTER LA': 6674,
'BUGINESE LETTER MA': 6662,
'BUGINESE LETTER MPA': 6663,
'BUGINESE LETTER NA': 6666,
'BUGINESE LETTER NGA': 6658,
'BUGINESE LETTER NGKA': 6659,
'BUGINESE LETTER NRA': 6667,
'BUGINESE LETTER NYA': 6670,
'BUGINESE LETTER NYCA': 6671,
'BUGINESE LETTER PA': 6660,
'BUGINESE LETTER RA': 6673,
'BUGINESE LETTER SA': 6676,
'BUGINESE LETTER TA': 6664,
'BUGINESE LETTER VA': 6675,
'BUGINESE LETTER YA': 6672,
'BUGINESE PALLAWA': 6686,
'BUGINESE VOWEL SIGN AE': 6683,
'BUGINESE VOWEL SIGN E': 6681,
'BUGINESE VOWEL SIGN I': 6679,
'BUGINESE VOWEL SIGN O': 6682,
'BUGINESE VOWEL SIGN U': 6680,
'BUHID LETTER A': 5952,
'BUHID LETTER BA': 5962,
'BUHID LETTER DA': 5959,
'BUHID LETTER GA': 5956,
'BUHID LETTER HA': 5969,
'BUHID LETTER I': 5953,
'BUHID LETTER KA': 5955,
'BUHID LETTER LA': 5966,
'BUHID LETTER MA': 5963,
'BUHID LETTER NA': 5960,
'BUHID LETTER NGA': 5957,
'BUHID LETTER PA': 5961,
'BUHID LETTER RA': 5965,
'BUHID LETTER SA': 5968,
'BUHID LETTER TA': 5958,
'BUHID LETTER U': 5954,
'BUHID LETTER WA': 5967,
'BUHID LETTER YA': 5964,
'BUHID VOWEL SIGN I': 5970,
'BUHID VOWEL SIGN U': 5971,
'BULLET': 8226,
'BULLET OPERATOR': 8729,
'BULLSEYE': 9678,
'BYZANTINE MUSICAL SYMBOL AGOGI ARGI': 118940,
'BYZANTINE MUSICAL SYMBOL AGOGI ARGOTERI': 118939,
'BYZANTINE MUSICAL SYMBOL AGOGI GORGI': 118943,
'BYZANTINE MUSICAL SYMBOL AGOGI GORGOTERI': 118944,
'BYZANTINE MUSICAL SYMBOL AGOGI MESI': 118942,
'BYZANTINE MUSICAL SYMBOL AGOGI METRIA': 118941,
'BYZANTINE MUSICAL SYMBOL AGOGI POLI ARGI': 118938,
'BYZANTINE MUSICAL SYMBOL AGOGI POLI GORGI': 118945,
'BYZANTINE MUSICAL SYMBOL ANATRICHISMA': 118824,
'BYZANTINE MUSICAL SYMBOL ANTIKENOKYLISMA': 118882,
'BYZANTINE MUSICAL SYMBOL ANTIKENOMA': 118876,
'BYZANTINE MUSICAL SYMBOL APESO EKFONITIKON': 118797,
'BYZANTINE MUSICAL SYMBOL APESO EXO NEO': 118835,
'BYZANTINE MUSICAL SYMBOL APLI': 118917,
'BYZANTINE MUSICAL SYMBOL APODERMA ARCHAION': 118818,
'BYZANTINE MUSICAL SYMBOL APODERMA NEO': 118916,
'BYZANTINE MUSICAL SYMBOL APOSTROFOI SYNDESMOS NEO': 118866,
'BYZANTINE MUSICAL SYMBOL APOSTROFOI TELOUS ICHIMATOS': 118957,
'BYZANTINE MUSICAL SYMBOL APOSTROFOS': 118801,
'BYZANTINE MUSICAL SYMBOL APOSTROFOS DIPLI': 118802,
'BYZANTINE MUSICAL SYMBOL APOSTROFOS NEO': 118865,
'BYZANTINE MUSICAL SYMBOL APOTHEMA': 118819,
'BYZANTINE MUSICAL SYMBOL ARGON': 118935,
'BYZANTINE MUSICAL SYMBOL ARGOSYNTHETON': 118899,
'BYZANTINE MUSICAL SYMBOL ARKTIKO DI': 119020,
'BYZANTINE MUSICAL SYMBOL ARKTIKO GA': 119019,
'BYZANTINE MUSICAL SYMBOL ARKTIKO KE': 119021,
'BYZANTINE MUSICAL SYMBOL ARKTIKO NI': 119023,
'BYZANTINE MUSICAL SYMBOL ARKTIKO PA': 119017,
'BYZANTINE MUSICAL SYMBOL ARKTIKO VOU': 119018,
'BYZANTINE MUSICAL SYMBOL ARKTIKO ZO': 119022,
'BYZANTINE MUSICAL SYMBOL CHAMILI': 118870,
'BYZANTINE MUSICAL SYMBOL CHAMILON': 118808,
'BYZANTINE MUSICAL SYMBOL CHOREVMA ARCHAION': 118843,
'BYZANTINE MUSICAL SYMBOL CHOREVMA NEO': 118887,
'BYZANTINE MUSICAL SYMBOL CHROA KLITON': 118985,
'BYZANTINE MUSICAL SYMBOL CHROA SPATHI': 118986,
'BYZANTINE MUSICAL SYMBOL CHROA ZYGOS': 118984,
'BYZANTINE MUSICAL SYMBOL DASEIA': 118785,
'BYZANTINE MUSICAL SYMBOL DIARGON': 118937,
'BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MEGALI': 119003,
'BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MIKRI': 119002,
'BYZANTINE MUSICAL SYMBOL DIASTOLI DIPLI': 119004,
'BYZANTINE MUSICAL SYMBOL DIASTOLI THESEOS': 119005,
'BYZANTINE MUSICAL SYMBOL DIESIS APLI DYO DODEKATA': 118992,
'BYZANTINE MUSICAL SYMBOL DIESIS DIGRAMMOS EX DODEKATA': 118994,
'BYZANTINE MUSICAL SYMBOL DIESIS MONOGRAMMOS TESSERA DODEKATA': 118993,
'BYZANTINE MUSICAL SYMBOL DIESIS TETARTIMORION': 118991,
'BYZANTINE MUSICAL SYMBOL DIESIS TRIGRAMMOS OKTO DODEKATA': 118995,
'BYZANTINE MUSICAL SYMBOL DIESIS TRITIMORION': 118990,
'BYZANTINE MUSICAL SYMBOL DIFTOGGOS OU': 119015,
'BYZANTINE MUSICAL SYMBOL DIGORGON': 118930,
'BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA ANO': 118932,
'BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA KATO': 118931,
'BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON DEXIA': 118933,
'BYZANTINE MUSICAL SYMBOL DIGRAMMA GG': 119014,
'BYZANTINE MUSICAL SYMBOL DIPLI': 118918,
'BYZANTINE MUSICAL SYMBOL DIPLI ARCHAION': 118912,
'BYZANTINE MUSICAL SYMBOL DYO': 118831,
'BYZANTINE MUSICAL SYMBOL EKSTREPTON': 118884,
'BYZANTINE MUSICAL SYMBOL ELAFRON': 118869,
'BYZANTINE MUSICAL SYMBOL ENARXIS KAI FTHORA VOU': 118966,
'BYZANTINE MUSICAL SYMBOL ENDOFONON': 118907,
'BYZANTINE MUSICAL SYMBOL EPEGERMA': 118888,
'BYZANTINE MUSICAL SYMBOL ETERON ARGOSYNTHETON': 118900,
'BYZANTINE MUSICAL SYMBOL ETERON PARAKALESMA': 118880,
'BYZANTINE MUSICAL SYMBOL EXO EKFONITIKON': 118798,
'BYZANTINE MUSICAL SYMBOL FANEROSIS DIFONIAS': 118960,
'BYZANTINE MUSICAL SYMBOL FANEROSIS MONOFONIAS': 118959,
'BYZANTINE MUSICAL SYMBOL FANEROSIS TETRAFONIAS': 118958,
'BYZANTINE MUSICAL SYMBOL FHTORA SKLIRON CHROMA VASIS': 118981,
'BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION': 118836,
'BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION DEYTEROU ICHOU': 118969,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI DI': 118973,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI KE': 118975,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NANA': 118971,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI ANO': 118978,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI KATO': 118977,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI PA': 118970,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI ZO': 118976,
'BYZANTINE MUSICAL SYMBOL FTHORA ENARMONIOS ANTIFONIA': 118988,
'BYZANTINE MUSICAL SYMBOL FTHORA I YFESIS TETARTIMORION': 118987,
'BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA DIFONIAS': 118979,
'BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA MONOFONIAS': 118980,
'BYZANTINE MUSICAL SYMBOL FTHORA NAOS ICHOS': 118972,
'BYZANTINE MUSICAL SYMBOL FTHORA NENANO': 118983,
'BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON CHROMA SYNAFI': 118982,
'BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON DIATONON DI': 118974,
'BYZANTINE MUSICAL SYMBOL GENIKI DIESIS': 119000,
'BYZANTINE MUSICAL SYMBOL GENIKI YFESIS': 119001,
'BYZANTINE MUSICAL SYMBOL GORGON ARCHAION': 118806,
'BYZANTINE MUSICAL SYMBOL GORGON NEO ANO': 118927,
'BYZANTINE MUSICAL SYMBOL GORGON NEO KATO': 119029,
'BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON ARISTERA': 118928,
'BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON DEXIA': 118929,
'BYZANTINE MUSICAL SYMBOL GORGOSYNTHETON': 118898,
'BYZANTINE MUSICAL SYMBOL GORTHMIKON N APLOUN': 118964,
'BYZANTINE MUSICAL SYMBOL GORTHMIKON N DIPLOUN': 118965,
'BYZANTINE MUSICAL SYMBOL GRONTHISMATA': 118853,
'BYZANTINE MUSICAL SYMBOL ICHADIN': 118847,
'BYZANTINE MUSICAL SYMBOL IMIDIARGON': 118936,
'BYZANTINE MUSICAL SYMBOL IMIFONON': 118967,
'BYZANTINE MUSICAL SYMBOL IMIFTHORA': 118837,
'BYZANTINE MUSICAL SYMBOL IMIFTHORON': 118968,
'BYZANTINE MUSICAL SYMBOL ISAKIA TELOUS ICHIMATOS': 118956,
'BYZANTINE MUSICAL SYMBOL ISON ARCHAION': 118810,
'BYZANTINE MUSICAL SYMBOL ISON NEO': 118854,
'BYZANTINE MUSICAL SYMBOL KATAVA TROMIKON': 118839,
'BYZANTINE MUSICAL SYMBOL KATAVASMA': 118906,
'BYZANTINE MUSICAL SYMBOL KATHISTI': 118791,
'BYZANTINE MUSICAL SYMBOL KENTIMA ARCHAION': 118811,
'BYZANTINE MUSICAL SYMBOL KENTIMA NEO ANO': 118863,
'BYZANTINE MUSICAL SYMBOL KENTIMA NEO KATO': 119027,
'BYZANTINE MUSICAL SYMBOL KENTIMA NEO MESO': 119025,
'BYZANTINE MUSICAL SYMBOL KENTIMATA': 118800,
'BYZANTINE MUSICAL SYMBOL KENTIMATA ARCHAION': 118812,
'BYZANTINE MUSICAL SYMBOL KENTIMATA NEO ANO': 118862,
'BYZANTINE MUSICAL SYMBOL KENTIMATA NEO KATO': 119026,
'BYZANTINE MUSICAL SYMBOL KENTIMATA NEO MESO': 119024,
'BYZANTINE MUSICAL SYMBOL KLASMA': 118820,
'BYZANTINE MUSICAL SYMBOL KLASMA ANO': 118911,
'BYZANTINE MUSICAL SYMBOL KLASMA KATO': 119028,
'BYZANTINE MUSICAL SYMBOL KONTEVMA': 118842,
'BYZANTINE MUSICAL SYMBOL KONTEVMA ALLO': 118850,
'BYZANTINE MUSICAL SYMBOL KORONIS': 118921,
'BYZANTINE MUSICAL SYMBOL KOUFISMA': 118858,
'BYZANTINE MUSICAL SYMBOL KRATIMA ALLO': 118914,
'BYZANTINE MUSICAL SYMBOL KRATIMA ARCHAION': 118913,
'BYZANTINE MUSICAL SYMBOL KRATIMA NEO': 118915,
'BYZANTINE MUSICAL SYMBOL KRATIMATA': 118834,
'BYZANTINE MUSICAL SYMBOL KRATIMOKOUFISMA': 118860,
'BYZANTINE MUSICAL SYMBOL KRATIMOYPORROON': 118868,
'BYZANTINE MUSICAL SYMBOL KREMASTI': 118796,
'BYZANTINE MUSICAL SYMBOL KYLISMA': 118881,
'BYZANTINE MUSICAL SYMBOL LEIMMA DYO CHRONON': 118923,
'BYZANTINE MUSICAL SYMBOL LEIMMA ENOS CHRONOU': 118922,
'BYZANTINE MUSICAL SYMBOL LEIMMA IMISEOS CHRONOU': 118926,
'BYZANTINE MUSICAL SYMBOL LEIMMA TESSARON CHRONON': 118925,
'BYZANTINE MUSICAL SYMBOL LEIMMA TRION CHRONON': 118924,
'BYZANTINE MUSICAL SYMBOL LEMOI': 118830,
'BYZANTINE MUSICAL SYMBOL LYGISMA': 118877,
'BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI DEYTEROS ICHOS': 118949,
'BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI PROTOS ICHOS': 118947,
'BYZANTINE MUSICAL SYMBOL MARTYRIA DEYTEROS ICHOS': 118948,
'BYZANTINE MUSICAL SYMBOL MARTYRIA LEGETOS ICHOS': 118954,
'BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS ICHOS': 118955,
'BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS TETARTOS ICHOS': 118963,
'BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOS ICHOS': 118946,
'BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOVARYS ICHOS': 118962,
'BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS ICHOS': 118952,
'BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS LEGETOS ICHOS': 118953,
'BYZANTINE MUSICAL SYMBOL MARTYRIA TRIFONIAS': 118951,
'BYZANTINE MUSICAL SYMBOL MARTYRIA TRITOS ICHOS': 118950,
'BYZANTINE MUSICAL SYMBOL MARTYRIA VARYS ICHOS': 118961,
'BYZANTINE MUSICAL SYMBOL MIKRON ISON': 118871,
'BYZANTINE MUSICAL SYMBOL NANA': 118848,
'BYZANTINE MUSICAL SYMBOL OLIGON ARCHAION': 118805,
'BYZANTINE MUSICAL SYMBOL OLIGON NEO': 118855,
'BYZANTINE MUSICAL SYMBOL OMALON': 118875,
'BYZANTINE MUSICAL SYMBOL OXEIA DIPLI': 118788,
'BYZANTINE MUSICAL SYMBOL OXEIA EKFONITIKON': 118787,
'BYZANTINE MUSICAL SYMBOL OXEIA NEO': 118856,
'BYZANTINE MUSICAL SYMBOL OXEIAI ARCHAION': 118816,
'BYZANTINE MUSICAL SYMBOL OYRANISMA ARCHAION': 118828,
'BYZANTINE MUSICAL SYMBOL OYRANISMA NEO': 118901,
'BYZANTINE MUSICAL SYMBOL PARAKALESMA ARCHAION': 118845,
'BYZANTINE MUSICAL SYMBOL PARAKALESMA NEO': 118879,
'BYZANTINE MUSICAL SYMBOL PARAKLITIKI': 118793,
'BYZANTINE MUSICAL SYMBOL PARAKLITIKI ARCHAION': 118846,
'BYZANTINE MUSICAL SYMBOL PARAKLITIKI NEO': 118878,
'BYZANTINE MUSICAL SYMBOL PARICHON': 118814,
'BYZANTINE MUSICAL SYMBOL PELASTON': 118840,
'BYZANTINE MUSICAL SYMBOL PELASTON NEO': 118861,
'BYZANTINE MUSICAL SYMBOL PERISPOMENI': 118786,
'BYZANTINE MUSICAL SYMBOL PETASMA': 118849,
'BYZANTINE MUSICAL SYMBOL PETASTI': 118857,
'BYZANTINE MUSICAL SYMBOL PETASTOKOUFISMA': 118859,
'BYZANTINE MUSICAL SYMBOL PIASMA ARCHAION': 118822,
'BYZANTINE MUSICAL SYMBOL PIASMA NEO': 118873,
'BYZANTINE MUSICAL SYMBOL PSIFISTOLYGISMA': 118892,
'BYZANTINE MUSICAL SYMBOL PSIFISTON': 118841,
'BYZANTINE MUSICAL SYMBOL PSIFISTON NEO': 118874,
'BYZANTINE MUSICAL SYMBOL PSIFISTOPARAKALESMA': 118895,
'BYZANTINE MUSICAL SYMBOL PSIFISTOSYNAGMA': 118897,
'BYZANTINE MUSICAL SYMBOL PSILI': 118784,
'BYZANTINE MUSICAL SYMBOL PSILON': 118807,
'BYZANTINE MUSICAL SYMBOL RAPISMA': 118844,
'BYZANTINE MUSICAL SYMBOL REVMA': 118821,
'BYZANTINE MUSICAL SYMBOL SAXIMATA': 118813,
'BYZANTINE MUSICAL SYMBOL SEISMA': 118825,
'BYZANTINE MUSICAL SYMBOL SEISMA NEO': 118889,
'BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS': 119010,
'BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS DISIMOU': 119011,
'BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TETRASIMOU': 119013,
'BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TRISIMOU': 119012,
'BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS': 119006,
'BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS DISIMOU': 119007,
'BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TETRASIMOU': 119009,
'BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TRISIMOU': 119008,
'BYZANTINE MUSICAL SYMBOL STAVROS': 118910,
'BYZANTINE MUSICAL SYMBOL STAVROS APODEXIA': 118815,
'BYZANTINE MUSICAL SYMBOL STIGMA': 119016,
'BYZANTINE MUSICAL SYMBOL STRAGGISMATA': 118852,
'BYZANTINE MUSICAL SYMBOL SYNAGMA ARCHAION': 118826,
'BYZANTINE MUSICAL SYMBOL SYNAGMA META STAVROU': 118827,
'BYZANTINE MUSICAL SYMBOL SYNAGMA NEO': 118885,
'BYZANTINE MUSICAL SYMBOL SYNEVMA': 118803,
'BYZANTINE MUSICAL SYMBOL SYRMA': 118886,
'BYZANTINE MUSICAL SYMBOL SYRMATIKI': 118792,
'BYZANTINE MUSICAL SYMBOL TELEIA': 118799,
'BYZANTINE MUSICAL SYMBOL TESSERA': 118833,
'BYZANTINE MUSICAL SYMBOL TETRAPLI': 118920,
'BYZANTINE MUSICAL SYMBOL THEMA': 118829,
'BYZANTINE MUSICAL SYMBOL THEMA APLOUN': 118904,
'BYZANTINE MUSICAL SYMBOL THEMATISMOS ESO': 118902,
'BYZANTINE MUSICAL SYMBOL THEMATISMOS EXO': 118903,
'BYZANTINE MUSICAL SYMBOL THES KAI APOTHES': 118905,
'BYZANTINE MUSICAL SYMBOL THITA': 118804,
'BYZANTINE MUSICAL SYMBOL TINAGMA': 118823,
'BYZANTINE MUSICAL SYMBOL TRIA': 118832,
'BYZANTINE MUSICAL SYMBOL TRIGORGON': 118934,
'BYZANTINE MUSICAL SYMBOL TRIPLI': 118919,
'BYZANTINE MUSICAL SYMBOL TROMIKOLYGISMA': 118893,
'BYZANTINE MUSICAL SYMBOL TROMIKON ALLO': 118851,
'BYZANTINE MUSICAL SYMBOL TROMIKON ARCHAION': 118838,
'BYZANTINE MUSICAL SYMBOL TROMIKON NEO': 118883,
'BYZANTINE MUSICAL SYMBOL TROMIKOPARAKALESMA': 118894,
'BYZANTINE MUSICAL SYMBOL TROMIKOPSIFISTON': 118891,
'BYZANTINE MUSICAL SYMBOL TROMIKOSYNAGMA': 118896,
'BYZANTINE MUSICAL SYMBOL VAREIA DIPLI': 118790,
'BYZANTINE MUSICAL SYMBOL VAREIA EKFONITIKON': 118789,
'BYZANTINE MUSICAL SYMBOL VAREIA NEO': 118872,
'BYZANTINE MUSICAL SYMBOL VAREIAI ARCHAION': 118817,
'BYZANTINE MUSICAL SYMBOL VATHY': 118809,
'BYZANTINE MUSICAL SYMBOL XIRON KLASMA': 118890,
'BYZANTINE MUSICAL SYMBOL YFEN ANO': 118909,
'BYZANTINE MUSICAL SYMBOL YFEN KATO': 118908,
'BYZANTINE MUSICAL SYMBOL YFESIS APLI DYO DODEKATA': 118996,
'BYZANTINE MUSICAL SYMBOL YFESIS DIGRAMMOS EX DODEKATA': 118998,
'BYZANTINE MUSICAL SYMBOL YFESIS MONOGRAMMOS TESSERA DODEKATA': 118997,
'BYZANTINE MUSICAL SYMBOL YFESIS TRIGRAMMOS OKTO DODEKATA': 118999,
'BYZANTINE MUSICAL SYMBOL YFESIS TRITIMORION': 118989,
'BYZANTINE MUSICAL SYMBOL YPOKRISIS': 118794,
'BYZANTINE MUSICAL SYMBOL YPOKRISIS DIPLI': 118795,
'BYZANTINE MUSICAL SYMBOL YPORROI': 118867,
'BYZANTINE MUSICAL SYMBOL YPSILI': 118864,
'CADA UNA': 8454,
'CADUCEUS': 9764,
'CANADIAN SYLLABICS A': 5130,
'CANADIAN SYLLABICS AA': 5131,
'CANADIAN SYLLABICS AAI': 5122,
'CANADIAN SYLLABICS AI': 5148,
'CANADIAN SYLLABICS AIVILIK B': 5551,
'CANADIAN SYLLABICS AN': 5166,
'CANADIAN SYLLABICS ATHAPASCAN M': 5310,
'CANADIAN SYLLABICS ATHAPASCAN S': 5382,
'CANADIAN SYLLABICS BIBLE-CREE Y': 5439,
'CANADIAN SYLLABICS BLACKFOOT A': 5555,
'CANADIAN SYLLABICS BLACKFOOT E': 5552,
'CANADIAN SYLLABICS BLACKFOOT I': 5553,
'CANADIAN SYLLABICS BLACKFOOT KA': 5567,
'CANADIAN SYLLABICS BLACKFOOT KE': 5564,
'CANADIAN SYLLABICS BLACKFOOT KI': 5565,
'CANADIAN SYLLABICS BLACKFOOT KO': 5566,
'CANADIAN SYLLABICS BLACKFOOT NA': 5563,
'CANADIAN SYLLABICS BLACKFOOT NE': 5560,
'CANADIAN SYLLABICS BLACKFOOT NI': 5561,
'CANADIAN SYLLABICS BLACKFOOT NO': 5562,
'CANADIAN SYLLABICS BLACKFOOT O': 5554,
'CANADIAN SYLLABICS BLACKFOOT S': 5384,
'CANADIAN SYLLABICS BLACKFOOT WA': 5559,
'CANADIAN SYLLABICS BLACKFOOT WE': 5556,
'CANADIAN SYLLABICS BLACKFOOT WI': 5557,
'CANADIAN SYLLABICS BLACKFOOT WO': 5558,
'CANADIAN SYLLABICS C': 5281,
'CANADIAN SYLLABICS CA': 5264,
'CANADIAN SYLLABICS CAA': 5265,
'CANADIAN SYLLABICS CAAI': 5258,
'CANADIAN SYLLABICS CARRIER CHA': 5734,
'CANADIAN SYLLABICS CARRIER CHE': 5731,
'CANADIAN SYLLABICS CARRIER CHEE': 5732,
'CANADIAN SYLLABICS CARRIER CHI': 5733,
'CANADIAN SYLLABICS CARRIER CHO': 5730,
'CANADIAN SYLLABICS CARRIER CHU': 5729,
'CANADIAN SYLLABICS CARRIER DEE': 5203,
'CANADIAN SYLLABICS CARRIER DI': 5204,
'CANADIAN SYLLABICS CARRIER DLA': 5677,
'CANADIAN SYLLABICS CARRIER DLE': 5674,
'CANADIAN SYLLABICS CARRIER DLEE': 5675,
'CANADIAN SYLLABICS CARRIER DLI': 5676,
'CANADIAN SYLLABICS CARRIER DLO': 5673,
'CANADIAN SYLLABICS CARRIER DLU': 5672,
'CANADIAN SYLLABICS CARRIER DZA': 5709,
'CANADIAN SYLLABICS CARRIER DZE': 5706,
'CANADIAN SYLLABICS CARRIER DZEE': 5707,
'CANADIAN SYLLABICS CARRIER DZI': 5708,
'CANADIAN SYLLABICS CARRIER DZO': 5705,
'CANADIAN SYLLABICS CARRIER DZU': 5704,
'CANADIAN SYLLABICS CARRIER EE': 5128,
'CANADIAN SYLLABICS CARRIER GA': 5620,
'CANADIAN SYLLABICS CARRIER GE': 5617,
'CANADIAN SYLLABICS CARRIER GEE': 5618,
'CANADIAN SYLLABICS CARRIER GHA': 5577,
'CANADIAN SYLLABICS CARRIER GHE': 5574,
'CANADIAN SYLLABICS CARRIER GHEE': 5575,
'CANADIAN SYLLABICS CARRIER GHI': 5576,
'CANADIAN SYLLABICS CARRIER GHO': 5573,
'CANADIAN SYLLABICS CARRIER GHU': 5572,
'CANADIAN SYLLABICS CARRIER GI': 5619,
'CANADIAN SYLLABICS CARRIER GO': 5616,
'CANADIAN SYLLABICS CARRIER GU': 5615,
'CANADIAN SYLLABICS CARRIER H': 5195,
'CANADIAN SYLLABICS CARRIER HEE': 5174,
'CANADIAN SYLLABICS CARRIER HI': 5175,
'CANADIAN SYLLABICS CARRIER HWA': 5595,
'CANADIAN SYLLABICS CARRIER HWE': 5592,
'CANADIAN SYLLABICS CARRIER HWEE': 5593,
'CANADIAN SYLLABICS CARRIER HWI': 5594,
'CANADIAN SYLLABICS CARRIER HWO': 5591,
'CANADIAN SYLLABICS CARRIER HWU': 5590,
'CANADIAN SYLLABICS CARRIER I': 5129,
'CANADIAN SYLLABICS CARRIER INITIAL Z': 5703,
'CANADIAN SYLLABICS CARRIER JA': 5659,
'CANADIAN SYLLABICS CARRIER JE': 5655,
'CANADIAN SYLLABICS CARRIER JEE': 5656,
'CANADIAN SYLLABICS CARRIER JI': 5657,
'CANADIAN SYLLABICS CARRIER JJA': 5665,
'CANADIAN SYLLABICS CARRIER JJE': 5662,
'CANADIAN SYLLABICS CARRIER JJEE': 5663,
'CANADIAN SYLLABICS CARRIER JJI': 5664,
'CANADIAN SYLLABICS CARRIER JJO': 5661,
'CANADIAN SYLLABICS CARRIER JJU': 5660,
'CANADIAN SYLLABICS CARRIER JO': 5654,
'CANADIAN SYLLABICS CARRIER JU': 5652,
'CANADIAN SYLLABICS CARRIER KHA': 5626,
'CANADIAN SYLLABICS CARRIER KHE': 5623,
'CANADIAN SYLLABICS CARRIER KHEE': 5624,
'CANADIAN SYLLABICS CARRIER KHI': 5625,
'CANADIAN SYLLABICS CARRIER KHO': 5622,
'CANADIAN SYLLABICS CARRIER KHU': 5621,
'CANADIAN SYLLABICS CARRIER KK': 5633,
'CANADIAN SYLLABICS CARRIER KKA': 5632,
'CANADIAN SYLLABICS CARRIER KKE': 5629,
'CANADIAN SYLLABICS CARRIER KKEE': 5630,
'CANADIAN SYLLABICS CARRIER KKI': 5631,
'CANADIAN SYLLABICS CARRIER KKO': 5628,
'CANADIAN SYLLABICS CARRIER KKU': 5627,
'CANADIAN SYLLABICS CARRIER LA': 5671,
'CANADIAN SYLLABICS CARRIER LE': 5668,
'CANADIAN SYLLABICS CARRIER LEE': 5669,
'CANADIAN SYLLABICS CARRIER LHA': 5683,
'CANADIAN SYLLABICS CARRIER LHE': 5680,
'CANADIAN SYLLABICS CARRIER LHEE': 5681,
'CANADIAN SYLLABICS CARRIER LHI': 5682,
'CANADIAN SYLLABICS CARRIER LHO': 5679,
'CANADIAN SYLLABICS CARRIER LHU': 5678,
'CANADIAN SYLLABICS CARRIER LI': 5670,
'CANADIAN SYLLABICS CARRIER LO': 5667,
'CANADIAN SYLLABICS CARRIER LU': 5666,
'CANADIAN SYLLABICS CARRIER MA': 5645,
'CANADIAN SYLLABICS CARRIER ME': 5642,
'CANADIAN SYLLABICS CARRIER MEE': 5643,
'CANADIAN SYLLABICS CARRIER MI': 5644,
'CANADIAN SYLLABICS CARRIER MO': 5641,
'CANADIAN SYLLABICS CARRIER MU': 5640,
'CANADIAN SYLLABICS CARRIER NA': 5639,
'CANADIAN SYLLABICS CARRIER NE': 5636,
'CANADIAN SYLLABICS CARRIER NEE': 5637,
'CANADIAN SYLLABICS CARRIER NG': 5329,
'CANADIAN SYLLABICS CARRIER NI': 5638,
'CANADIAN SYLLABICS CARRIER NO': 5635,
'CANADIAN SYLLABICS CARRIER NU': 5634,
'CANADIAN SYLLABICS CARRIER P': 5614,
'CANADIAN SYLLABICS CARRIER PA': 5613,
'CANADIAN SYLLABICS CARRIER PE': 5610,
'CANADIAN SYLLABICS CARRIER PEE': 5611,
'CANADIAN SYLLABICS CARRIER PI': 5612,
'CANADIAN SYLLABICS CARRIER PO': 5609,
'CANADIAN SYLLABICS CARRIER PU': 5608,
'CANADIAN SYLLABICS CARRIER RA': 5583,
'CANADIAN SYLLABICS CARRIER RE': 5580,
'CANADIAN SYLLABICS CARRIER REE': 5581,
'CANADIAN SYLLABICS CARRIER RI': 5582,
'CANADIAN SYLLABICS CARRIER RO': 5579,
'CANADIAN SYLLABICS CARRIER RU': 5578,
'CANADIAN SYLLABICS CARRIER SA': 5715,
'CANADIAN SYLLABICS CARRIER SE': 5712,
'CANADIAN SYLLABICS CARRIER SEE': 5713,
'CANADIAN SYLLABICS CARRIER SH': 5722,
'CANADIAN SYLLABICS CARRIER SHA': 5721,
'CANADIAN SYLLABICS CARRIER SHE': 5718,
'CANADIAN SYLLABICS CARRIER SHEE': 5719,
'CANADIAN SYLLABICS CARRIER SHI': 5720,
'CANADIAN SYLLABICS CARRIER SHO': 5717,
'CANADIAN SYLLABICS CARRIER SHU': 5716,
'CANADIAN SYLLABICS CARRIER SI': 5714,
'CANADIAN SYLLABICS CARRIER SO': 5711,
'CANADIAN SYLLABICS CARRIER SU': 5710,
'CANADIAN SYLLABICS CARRIER THA': 5601,
'CANADIAN SYLLABICS CARRIER THE': 5598,
'CANADIAN SYLLABICS CARRIER THEE': 5599,
'CANADIAN SYLLABICS CARRIER THI': 5600,
'CANADIAN SYLLABICS CARRIER THO': 5597,
'CANADIAN SYLLABICS CARRIER THU': 5596,
'CANADIAN SYLLABICS CARRIER TLA': 5695,
'CANADIAN SYLLABICS CARRIER TLE': 5692,
'CANADIAN SYLLABICS CARRIER TLEE': 5693,
'CANADIAN SYLLABICS CARRIER TLHA': 5689,
'CANADIAN SYLLABICS CARRIER TLHE': 5686,
'CANADIAN SYLLABICS CARRIER TLHEE': 5687,
'CANADIAN SYLLABICS CARRIER TLHI': 5688,
'CANADIAN SYLLABICS CARRIER TLHO': 5685,
'CANADIAN SYLLABICS CARRIER TLHU': 5684,
'CANADIAN SYLLABICS CARRIER TLI': 5694,
'CANADIAN SYLLABICS CARRIER TLO': 5691,
'CANADIAN SYLLABICS CARRIER TLU': 5690,
'CANADIAN SYLLABICS CARRIER TSA': 5728,
'CANADIAN SYLLABICS CARRIER TSE': 5725,
'CANADIAN SYLLABICS CARRIER TSEE': 5726,
'CANADIAN SYLLABICS CARRIER TSI': 5727,
'CANADIAN SYLLABICS CARRIER TSO': 5724,
'CANADIAN SYLLABICS CARRIER TSU': 5723,
'CANADIAN SYLLABICS CARRIER TTA': 5607,
'CANADIAN SYLLABICS CARRIER TTE': 5604,
'CANADIAN SYLLABICS CARRIER TTEE': 5605,
'CANADIAN SYLLABICS CARRIER TTI': 5606,
'CANADIAN SYLLABICS CARRIER TTO': 5603,
'CANADIAN SYLLABICS CARRIER TTSA': 5740,
'CANADIAN SYLLABICS CARRIER TTSE': 5737,
'CANADIAN SYLLABICS CARRIER TTSEE': 5738,
'CANADIAN SYLLABICS CARRIER TTSI': 5739,
'CANADIAN SYLLABICS CARRIER TTSO': 5736,
'CANADIAN SYLLABICS CARRIER TTSU': 5735,
'CANADIAN SYLLABICS CARRIER TTU': 5602,
'CANADIAN SYLLABICS CARRIER WA': 5589,
'CANADIAN SYLLABICS CARRIER WE': 5586,
'CANADIAN SYLLABICS CARRIER WEE': 5587,
'CANADIAN SYLLABICS CARRIER WI': 5588,
'CANADIAN SYLLABICS CARRIER WO': 5585,
'CANADIAN SYLLABICS CARRIER WU': 5584,
'CANADIAN SYLLABICS CARRIER YA': 5651,
'CANADIAN SYLLABICS CARRIER YE': 5648,
'CANADIAN SYLLABICS CARRIER YEE': 5649,
'CANADIAN SYLLABICS CARRIER YI': 5650,
'CANADIAN SYLLABICS CARRIER YO': 5647,
'CANADIAN SYLLABICS CARRIER YU': 5646,
'CANADIAN SYLLABICS CARRIER Z': 5702,
'CANADIAN SYLLABICS CARRIER ZA': 5701,
'CANADIAN SYLLABICS CARRIER ZE': 5698,
'CANADIAN SYLLABICS CARRIER ZEE': 5699,
'CANADIAN SYLLABICS CARRIER ZI': 5700,
'CANADIAN SYLLABICS CARRIER ZO': 5697,
'CANADIAN SYLLABICS CARRIER ZU': 5696,
'CANADIAN SYLLABICS CE': 5257,
'CANADIAN SYLLABICS CHI SIGN': 5741,
'CANADIAN SYLLABICS CI': 5259,
'CANADIAN SYLLABICS CII': 5260,
'CANADIAN SYLLABICS CO': 5261,
'CANADIAN SYLLABICS COO': 5262,
'CANADIAN SYLLABICS CWA': 5276,
'CANADIAN SYLLABICS CWAA': 5278,
'CANADIAN SYLLABICS CWE': 5266,
'CANADIAN SYLLABICS CWI': 5268,
'CANADIAN SYLLABICS CWII': 5270,
'CANADIAN SYLLABICS CWO': 5272,
'CANADIAN SYLLABICS CWOO': 5274,
'CANADIAN SYLLABICS E': 5121,
'CANADIAN SYLLABICS EN': 5163,
'CANADIAN SYLLABICS F': 5469,
'CANADIAN SYLLABICS FA': 5465,
'CANADIAN SYLLABICS FAA': 5466,
'CANADIAN SYLLABICS FAAI': 5460,
'CANADIAN SYLLABICS FE': 5459,
'CANADIAN SYLLABICS FI': 5461,
'CANADIAN SYLLABICS FII': 5462,
'CANADIAN SYLLABICS FINAL ACUTE': 5151,
'CANADIAN SYLLABICS FINAL BOTTOM HALF RING': 5153,
'CANADIAN SYLLABICS FINAL DOUBLE ACUTE': 5157,
'CANADIAN SYLLABICS FINAL DOUBLE SHORT VERTICAL STROKES': 5158,
'CANADIAN SYLLABICS FINAL DOWN TACK': 5162,
'CANADIAN SYLLABICS FINAL GRAVE': 5152,
'CANADIAN SYLLABICS FINAL MIDDLE DOT': 5159,
'CANADIAN SYLLABICS FINAL PLUS': 5161,
'CANADIAN SYLLABICS FINAL RIGHT HALF RING': 5155,
'CANADIAN SYLLABICS FINAL RING': 5156,
'CANADIAN SYLLABICS FINAL SHORT HORIZONTAL STROKE': 5160,
'CANADIAN SYLLABICS FINAL TOP HALF RING': 5154,
'CANADIAN SYLLABICS FO': 5463,
'CANADIAN SYLLABICS FOO': 5464,
'CANADIAN SYLLABICS FULL STOP': 5742,
'CANADIAN SYLLABICS FWAA': 5467,
'CANADIAN SYLLABICS GLOTTAL STOP': 5150,
'CANADIAN SYLLABICS HK': 5501,
'CANADIAN SYLLABICS I': 5123,
'CANADIAN SYLLABICS II': 5124,
'CANADIAN SYLLABICS IN': 5164,
'CANADIAN SYLLABICS K': 5251,
'CANADIAN SYLLABICS KA': 5234,
'CANADIAN SYLLABICS KAA': 5235,
'CANADIAN SYLLABICS KAAI': 5228,
'CANADIAN SYLLABICS KE': 5227,
'CANADIAN SYLLABICS KI': 5229,
'CANADIAN SYLLABICS KII': 5230,
'CANADIAN SYLLABICS KO': 5231,
'CANADIAN SYLLABICS KOO': 5232,
'CANADIAN SYLLABICS KW': 5252,
'CANADIAN SYLLABICS KWA': 5246,
'CANADIAN SYLLABICS KWAA': 5248,
'CANADIAN SYLLABICS KWE': 5236,
'CANADIAN SYLLABICS KWI': 5238,
'CANADIAN SYLLABICS KWII': 5240,
'CANADIAN SYLLABICS KWO': 5242,
'CANADIAN SYLLABICS KWOO': 5244,
'CANADIAN SYLLABICS L': 5354,
'CANADIAN SYLLABICS LA': 5338,
'CANADIAN SYLLABICS LAA': 5339,
'CANADIAN SYLLABICS LAAI': 5332,
'CANADIAN SYLLABICS LE': 5331,
'CANADIAN SYLLABICS LH': 5542,
'CANADIAN SYLLABICS LHA': 5540,
'CANADIAN SYLLABICS LHAA': 5541,
'CANADIAN SYLLABICS LHI': 5536,
'CANADIAN SYLLABICS LHII': 5537,
'CANADIAN SYLLABICS LHO': 5538,
'CANADIAN SYLLABICS LHOO': 5539,
'CANADIAN SYLLABICS LI': 5333,
'CANADIAN SYLLABICS LII': 5334,
'CANADIAN SYLLABICS LO': 5335,
'CANADIAN SYLLABICS LOO': 5336,
'CANADIAN SYLLABICS LWA': 5350,
'CANADIAN SYLLABICS LWAA': 5352,
'CANADIAN SYLLABICS LWE': 5340,
'CANADIAN SYLLABICS LWI': 5342,
'CANADIAN SYLLABICS LWII': 5344,
'CANADIAN SYLLABICS LWO': 5346,
'CANADIAN SYLLABICS LWOO': 5348,
'CANADIAN SYLLABICS M': 5307,
'CANADIAN SYLLABICS MA': 5290,
'CANADIAN SYLLABICS MAA': 5291,
'CANADIAN SYLLABICS MAAI': 5284,
'CANADIAN SYLLABICS ME': 5283,
'CANADIAN SYLLABICS MEDIAL L': 5356,
'CANADIAN SYLLABICS MEDIAL R': 5458,
'CANADIAN SYLLABICS MH': 5309,
'CANADIAN SYLLABICS MI': 5285,
'CANADIAN SYLLABICS MII': 5286,
'CANADIAN SYLLABICS MO': 5287,
'CANADIAN SYLLABICS MOO': 5288,
'CANADIAN SYLLABICS MOOSE-CREE SK': 5385,
'CANADIAN SYLLABICS MWA': 5302,
'CANADIAN SYLLABICS MWAA': 5304,
'CANADIAN SYLLABICS MWE': 5292,
'CANADIAN SYLLABICS MWI': 5294,
'CANADIAN SYLLABICS MWII': 5296,
'CANADIAN SYLLABICS MWO': 5298,
'CANADIAN SYLLABICS MWOO': 5300,
'CANADIAN SYLLABICS N': 5328,
'CANADIAN SYLLABICS N-CREE THE': 5471,
'CANADIAN SYLLABICS N-CREE THI': 5473,
'CANADIAN SYLLABICS N-CREE THII': 5475,
'CANADIAN SYLLABICS NA': 5319,
'CANADIAN SYLLABICS NAA': 5320,
'CANADIAN SYLLABICS NAAI': 5313,
'CANADIAN SYLLABICS NASKAPI CWAA': 5280,
'CANADIAN SYLLABICS NASKAPI KWAA': 5250,
'CANADIAN SYLLABICS NASKAPI MWAA': 5306,
'CANADIAN SYLLABICS NASKAPI NWAA': 5327,
'CANADIAN SYLLABICS NASKAPI S-W': 5387,
'CANADIAN SYLLABICS NASKAPI SCWA': 5391,
'CANADIAN SYLLABICS NASKAPI SKW': 5386,
'CANADIAN SYLLABICS NASKAPI SKWA': 5390,
'CANADIAN SYLLABICS NASKAPI SPWA': 5388,
'CANADIAN SYLLABICS NASKAPI STWA': 5389,
'CANADIAN SYLLABICS NASKAPI SWAA': 5380,
'CANADIAN SYLLABICS NASKAPI TWAA': 5221,
'CANADIAN SYLLABICS NASKAPI WAA': 5147,
'CANADIAN SYLLABICS NASKAPI WOO': 5142,
'CANADIAN SYLLABICS NASKAPI YWAA': 5437,
'CANADIAN SYLLABICS NE': 5312,
'CANADIAN SYLLABICS NG': 5525,
'CANADIAN SYLLABICS NGA': 5523,
'CANADIAN SYLLABICS NGAA': 5524,
'CANADIAN SYLLABICS NGAAI': 5518,
'CANADIAN SYLLABICS NGAI': 5744,
'CANADIAN SYLLABICS NGI': 5519,
'CANADIAN SYLLABICS NGII': 5520,
'CANADIAN SYLLABICS NGO': 5521,
'CANADIAN SYLLABICS NGOO': 5522,
'CANADIAN SYLLABICS NH': 5330,
'CANADIAN SYLLABICS NI': 5314,
'CANADIAN SYLLABICS NII': 5315,
'CANADIAN SYLLABICS NNG': 5526,
'CANADIAN SYLLABICS NNGA': 5749,
'CANADIAN SYLLABICS NNGAA': 5750,
'CANADIAN SYLLABICS NNGI': 5745,
'CANADIAN SYLLABICS NNGII': 5746,
'CANADIAN SYLLABICS NNGO': 5747,
'CANADIAN SYLLABICS NNGOO': 5748,
'CANADIAN SYLLABICS NO': 5316,
'CANADIAN SYLLABICS NOO': 5317,
'CANADIAN SYLLABICS NUNAVIK H': 5499,
'CANADIAN SYLLABICS NUNAVIK HA': 5497,
'CANADIAN SYLLABICS NUNAVIK HAA': 5498,
'CANADIAN SYLLABICS NUNAVIK HE': 5492,
'CANADIAN SYLLABICS NUNAVIK HI': 5493,
'CANADIAN SYLLABICS NUNAVIK HII': 5494,
'CANADIAN SYLLABICS NUNAVIK HO': 5495,
'CANADIAN SYLLABICS NUNAVIK HOO': 5496,
'CANADIAN SYLLABICS NUNAVUT H': 5500,
'CANADIAN SYLLABICS NWA': 5323,
'CANADIAN SYLLABICS NWAA': 5325,
'CANADIAN SYLLABICS NWE': 5321,
'CANADIAN SYLLABICS O': 5125,
'CANADIAN SYLLABICS ON': 5165,
'CANADIAN SYLLABICS OO': 5126,
'CANADIAN SYLLABICS P': 5193,
'CANADIAN SYLLABICS PA': 5176,
'CANADIAN SYLLABICS PAA': 5177,
'CANADIAN SYLLABICS PAAI': 5168,
'CANADIAN SYLLABICS PE': 5167,
'CANADIAN SYLLABICS PI': 5169,
'CANADIAN SYLLABICS PII': 5170,
'CANADIAN SYLLABICS PO': 5171,
'CANADIAN SYLLABICS POO': 5172,
'CANADIAN SYLLABICS PWA': 5188,
'CANADIAN SYLLABICS PWAA': 5190,
'CANADIAN SYLLABICS PWE': 5178,
'CANADIAN SYLLABICS PWI': 5180,
'CANADIAN SYLLABICS PWII': 5182,
'CANADIAN SYLLABICS PWO': 5184,
'CANADIAN SYLLABICS PWOO': 5186,
'CANADIAN SYLLABICS Q': 5509,
'CANADIAN SYLLABICS QA': 5507,
'CANADIAN SYLLABICS QAA': 5508,
'CANADIAN SYLLABICS QAAI': 5502,
'CANADIAN SYLLABICS QAI': 5743,
'CANADIAN SYLLABICS QI': 5503,
'CANADIAN SYLLABICS QII': 5504,
'CANADIAN SYLLABICS QO': 5505,
'CANADIAN SYLLABICS QOO': 5506,
'CANADIAN SYLLABICS R': 5456,
'CANADIAN SYLLABICS R-CREE RE': 5443,
'CANADIAN SYLLABICS RA': 5451,
'CANADIAN SYLLABICS RAA': 5452,
'CANADIAN SYLLABICS RAAI': 5445,
'CANADIAN SYLLABICS RE': 5442,
'CANADIAN SYLLABICS RI': 5446,
'CANADIAN SYLLABICS RII': 5447,
'CANADIAN SYLLABICS RO': 5448,
'CANADIAN SYLLABICS ROO': 5449,
'CANADIAN SYLLABICS RWAA': 5454,
'CANADIAN SYLLABICS S': 5381,
'CANADIAN SYLLABICS SA': 5364,
'CANADIAN SYLLABICS SAA': 5365,
'CANADIAN SYLLABICS SAAI': 5358,
'CANADIAN SYLLABICS SAYISI HA': 5571,
'CANADIAN SYLLABICS SAYISI HE': 5568,
'CANADIAN SYLLABICS SAYISI HI': 5569,
'CANADIAN SYLLABICS SAYISI HO': 5570,
'CANADIAN SYLLABICS SAYISI JI': 5658,
'CANADIAN SYLLABICS SAYISI JU': 5653,
'CANADIAN SYLLABICS SAYISI M': 5311,
'CANADIAN SYLLABICS SAYISI SHA': 5530,
'CANADIAN SYLLABICS SAYISI SHE': 5527,
'CANADIAN SYLLABICS SAYISI SHI': 5528,
'CANADIAN SYLLABICS SAYISI SHO': 5529,
'CANADIAN SYLLABICS SAYISI TH': 5282,
'CANADIAN SYLLABICS SAYISI YI': 5441,
'CANADIAN SYLLABICS SE': 5357,
'CANADIAN SYLLABICS SH': 5413,
'CANADIAN SYLLABICS SHA': 5397,
'CANADIAN SYLLABICS SHAA': 5398,
'CANADIAN SYLLABICS SHE': 5392,
'CANADIAN SYLLABICS SHI': 5393,
'CANADIAN SYLLABICS SHII': 5394,
'CANADIAN SYLLABICS SHO': 5395,
'CANADIAN SYLLABICS SHOO': 5396,
'CANADIAN SYLLABICS SHWA': 5409,
'CANADIAN SYLLABICS SHWAA': 5411,
'CANADIAN SYLLABICS SHWE': 5399,
'CANADIAN SYLLABICS SHWI': 5401,
'CANADIAN SYLLABICS SHWII': 5403,
'CANADIAN SYLLABICS SHWO': 5405,
'CANADIAN SYLLABICS SHWOO': 5407,
'CANADIAN SYLLABICS SI': 5359,
'CANADIAN SYLLABICS SII': 5360,
'CANADIAN SYLLABICS SO': 5361,
'CANADIAN SYLLABICS SOO': 5362,
'CANADIAN SYLLABICS SOUTH-SLAVEY KAH': 5256,
'CANADIAN SYLLABICS SOUTH-SLAVEY KEH': 5253,
'CANADIAN SYLLABICS SOUTH-SLAVEY KIH': 5254,
'CANADIAN SYLLABICS SOUTH-SLAVEY KOH': 5255,
'CANADIAN SYLLABICS SW': 5383,
'CANADIAN SYLLABICS SWA': 5376,
'CANADIAN SYLLABICS SWAA': 5378,
'CANADIAN SYLLABICS SWE': 5366,
'CANADIAN SYLLABICS SWI': 5368,
'CANADIAN SYLLABICS SWII': 5370,
'CANADIAN SYLLABICS SWO': 5372,
'CANADIAN SYLLABICS SWOO': 5374,
'CANADIAN SYLLABICS T': 5222,
'CANADIAN SYLLABICS TA': 5205,
'CANADIAN SYLLABICS TAA': 5206,
'CANADIAN SYLLABICS TAAI': 5197,
'CANADIAN SYLLABICS TE': 5196,
'CANADIAN SYLLABICS TH': 5482,
'CANADIAN SYLLABICS TH-CREE TH': 5550,
'CANADIAN SYLLABICS TH-CREE THA': 5548,
'CANADIAN SYLLABICS TH-CREE THAA': 5549,
'CANADIAN SYLLABICS TH-CREE THE': 5543,
'CANADIAN SYLLABICS TH-CREE THI': 5544,
'CANADIAN SYLLABICS TH-CREE THII': 5545,
'CANADIAN SYLLABICS TH-CREE THO': 5546,
'CANADIAN SYLLABICS TH-CREE THOO': 5547,
'CANADIAN SYLLABICS THA': 5478,
'CANADIAN SYLLABICS THAA': 5479,
'CANADIAN SYLLABICS THE': 5470,
'CANADIAN SYLLABICS THI': 5472,
'CANADIAN SYLLABICS THII': 5474,
'CANADIAN SYLLABICS THO': 5476,
'CANADIAN SYLLABICS THOO': 5477,
'CANADIAN SYLLABICS THWAA': 5480,
'CANADIAN SYLLABICS TI': 5198,
'CANADIAN SYLLABICS TII': 5199,
'CANADIAN SYLLABICS TLHA': 5513,
'CANADIAN SYLLABICS TLHE': 5510,
'CANADIAN SYLLABICS TLHI': 5511,
'CANADIAN SYLLABICS TLHO': 5512,
'CANADIAN SYLLABICS TO': 5200,
'CANADIAN SYLLABICS TOO': 5201,
'CANADIAN SYLLABICS TTA': 5226,
'CANADIAN SYLLABICS TTE': 5223,
'CANADIAN SYLLABICS TTH': 5487,
'CANADIAN SYLLABICS TTHA': 5486,
'CANADIAN SYLLABICS TTHE': 5483,
'CANADIAN SYLLABICS TTHI': 5484,
'CANADIAN SYLLABICS TTHO': 5485,
'CANADIAN SYLLABICS TTI': 5224,
'CANADIAN SYLLABICS TTO': 5225,
'CANADIAN SYLLABICS TWA': 5217,
'CANADIAN SYLLABICS TWAA': 5219,
'CANADIAN SYLLABICS TWE': 5207,
'CANADIAN SYLLABICS TWI': 5209,
'CANADIAN SYLLABICS TWII': 5211,
'CANADIAN SYLLABICS TWO': 5213,
'CANADIAN SYLLABICS TWOO': 5215,
'CANADIAN SYLLABICS TYA': 5491,
'CANADIAN SYLLABICS TYE': 5488,
'CANADIAN SYLLABICS TYI': 5489,
'CANADIAN SYLLABICS TYO': 5490,
'CANADIAN SYLLABICS WA': 5143,
'CANADIAN SYLLABICS WAA': 5145,
'CANADIAN SYLLABICS WE': 5132,
'CANADIAN SYLLABICS WEST-CREE CWA': 5277,
'CANADIAN SYLLABICS WEST-CREE CWAA': 5279,
'CANADIAN SYLLABICS WEST-CREE CWE': 5267,
'CANADIAN SYLLABICS WEST-CREE CWI': 5269,
'CANADIAN SYLLABICS WEST-CREE CWII': 5271,
'CANADIAN SYLLABICS WEST-CREE CWO': 5273,
'CANADIAN SYLLABICS WEST-CREE CWOO': 5275,
'CANADIAN SYLLABICS WEST-CREE FWAA': 5468,
'CANADIAN SYLLABICS WEST-CREE KWA': 5247,
'CANADIAN SYLLABICS WEST-CREE KWAA': 5249,
'CANADIAN SYLLABICS WEST-CREE KWE': 5237,
'CANADIAN SYLLABICS WEST-CREE KWI': 5239,
'CANADIAN SYLLABICS WEST-CREE KWII': 5241,
'CANADIAN SYLLABICS WEST-CREE KWO': 5243,
'CANADIAN SYLLABICS WEST-CREE KWOO': 5245,
'CANADIAN SYLLABICS WEST-CREE L': 5355,
'CANADIAN SYLLABICS WEST-CREE LA': 5453,
'CANADIAN SYLLABICS WEST-CREE LE': 5444,
'CANADIAN SYLLABICS WEST-CREE LO': 5450,
'CANADIAN SYLLABICS WEST-CREE LWA': 5351,
'CANADIAN SYLLABICS WEST-CREE LWAA': 5353,
'CANADIAN SYLLABICS WEST-CREE LWE': 5341,
'CANADIAN SYLLABICS WEST-CREE LWI': 5343,
'CANADIAN SYLLABICS WEST-CREE LWII': 5345,
'CANADIAN SYLLABICS WEST-CREE LWO': 5347,
'CANADIAN SYLLABICS WEST-CREE LWOO': 5349,
'CANADIAN SYLLABICS WEST-CREE M': 5308,
'CANADIAN SYLLABICS WEST-CREE MWA': 5303,
'CANADIAN SYLLABICS WEST-CREE MWAA': 5305,
'CANADIAN SYLLABICS WEST-CREE MWE': 5293,
'CANADIAN SYLLABICS WEST-CREE MWI': 5295,
'CANADIAN SYLLABICS WEST-CREE MWII': 5297,
'CANADIAN SYLLABICS WEST-CREE MWO': 5299,
'CANADIAN SYLLABICS WEST-CREE MWOO': 5301,
'CANADIAN SYLLABICS WEST-CREE NWA': 5324,
'CANADIAN SYLLABICS WEST-CREE NWAA': 5326,
'CANADIAN SYLLABICS WEST-CREE NWE': 5322,
'CANADIAN SYLLABICS WEST-CREE P': 5194,
'CANADIAN SYLLABICS WEST-CREE PWA': 5189,
'CANADIAN SYLLABICS WEST-CREE PWAA': 5191,
'CANADIAN SYLLABICS WEST-CREE PWE': 5179,
'CANADIAN SYLLABICS WEST-CREE PWI': 5181,
'CANADIAN SYLLABICS WEST-CREE PWII': 5183,
'CANADIAN SYLLABICS WEST-CREE PWO': 5185,
'CANADIAN SYLLABICS WEST-CREE PWOO': 5187,
'CANADIAN SYLLABICS WEST-CREE R': 5457,
'CANADIAN SYLLABICS WEST-CREE RA': 5517,
'CANADIAN SYLLABICS WEST-CREE RE': 5514,
'CANADIAN SYLLABICS WEST-CREE RI': 5515,
'CANADIAN SYLLABICS WEST-CREE RO': 5516,
'CANADIAN SYLLABICS WEST-CREE RWAA': 5455,
'CANADIAN SYLLABICS WEST-CREE SHWA': 5410,
'CANADIAN SYLLABICS WEST-CREE SHWAA': 5412,
'CANADIAN SYLLABICS WEST-CREE SHWE': 5400,
'CANADIAN SYLLABICS WEST-CREE SHWI': 5402,
'CANADIAN SYLLABICS WEST-CREE SHWII': 5404,
'CANADIAN SYLLABICS WEST-CREE SHWO': 5406,
'CANADIAN SYLLABICS WEST-CREE SHWOO': 5408,
'CANADIAN SYLLABICS WEST-CREE SWA': 5377,
'CANADIAN SYLLABICS WEST-CREE SWAA': 5379,
'CANADIAN SYLLABICS WEST-CREE SWE': 5367,
'CANADIAN SYLLABICS WEST-CREE SWI': 5369,
'CANADIAN SYLLABICS WEST-CREE SWII': 5371,
'CANADIAN SYLLABICS WEST-CREE SWO': 5373,
'CANADIAN SYLLABICS WEST-CREE SWOO': 5375,
'CANADIAN SYLLABICS WEST-CREE THWAA': 5481,
'CANADIAN SYLLABICS WEST-CREE TWA': 5218,
'CANADIAN SYLLABICS WEST-CREE TWAA': 5220,
'CANADIAN SYLLABICS WEST-CREE TWE': 5208,
'CANADIAN SYLLABICS WEST-CREE TWI': 5210,
'CANADIAN SYLLABICS WEST-CREE TWII': 5212,
'CANADIAN SYLLABICS WEST-CREE TWO': 5214,
'CANADIAN SYLLABICS WEST-CREE TWOO': 5216,
'CANADIAN SYLLABICS WEST-CREE WA': 5144,
'CANADIAN SYLLABICS WEST-CREE WAA': 5146,
'CANADIAN SYLLABICS WEST-CREE WE': 5133,
'CANADIAN SYLLABICS WEST-CREE WI': 5135,
'CANADIAN SYLLABICS WEST-CREE WII': 5137,
'CANADIAN SYLLABICS WEST-CREE WO': 5139,
'CANADIAN SYLLABICS WEST-CREE WOO': 5141,
'CANADIAN SYLLABICS WEST-CREE Y': 5440,
'CANADIAN SYLLABICS WEST-CREE YWA': 5434,
'CANADIAN SYLLABICS WEST-CREE YWAA': 5436,
'CANADIAN SYLLABICS WEST-CREE YWE': 5424,
'CANADIAN SYLLABICS WEST-CREE YWI': 5426,
'CANADIAN SYLLABICS WEST-CREE YWII': 5428,
'CANADIAN SYLLABICS WEST-CREE YWO': 5430,
'CANADIAN SYLLABICS WEST-CREE YWOO': 5432,
'CANADIAN SYLLABICS WI': 5134,
'CANADIAN SYLLABICS WII': 5136,
'CANADIAN SYLLABICS WO': 5138,
'CANADIAN SYLLABICS WOO': 5140,
'CANADIAN SYLLABICS WOODS-CREE TH': 5535,
'CANADIAN SYLLABICS WOODS-CREE THA': 5534,
'CANADIAN SYLLABICS WOODS-CREE THE': 5531,
'CANADIAN SYLLABICS WOODS-CREE THI': 5532,
'CANADIAN SYLLABICS WOODS-CREE THO': 5533,
'CANADIAN SYLLABICS Y': 5438,
'CANADIAN SYLLABICS Y-CREE COO': 5263,
'CANADIAN SYLLABICS Y-CREE KOO': 5233,
'CANADIAN SYLLABICS Y-CREE LOO': 5337,
'CANADIAN SYLLABICS Y-CREE MOO': 5289,
'CANADIAN SYLLABICS Y-CREE NOO': 5318,
'CANADIAN SYLLABICS Y-CREE OO': 5127,
'CANADIAN SYLLABICS Y-CREE POO': 5173,
'CANADIAN SYLLABICS Y-CREE PWAA': 5192,
'CANADIAN SYLLABICS Y-CREE SOO': 5363,
'CANADIAN SYLLABICS Y-CREE TOO': 5202,
'CANADIAN SYLLABICS Y-CREE W': 5149,
'CANADIAN SYLLABICS Y-CREE YOO': 5420,
'CANADIAN SYLLABICS YA': 5421,
'CANADIAN SYLLABICS YAA': 5422,
'CANADIAN SYLLABICS YAAI': 5415,
'CANADIAN SYLLABICS YE': 5414,
'CANADIAN SYLLABICS YI': 5416,
'CANADIAN SYLLABICS YII': 5417,
'CANADIAN SYLLABICS YO': 5418,
'CANADIAN SYLLABICS YOO': 5419,
'CANADIAN SYLLABICS YWA': 5433,
'CANADIAN SYLLABICS YWAA': 5435,
'CANADIAN SYLLABICS YWE': 5423,
'CANADIAN SYLLABICS YWI': 5425,
'CANADIAN SYLLABICS YWII': 5427,
'CANADIAN SYLLABICS YWO': 5429,
'CANADIAN SYLLABICS YWOO': 5431,
'CANCEL TAG': 917631,
'CANCER': 9803,
'CAPRICORN': 9809,
'CARE OF': 8453,
'CARET': 8248,
'CARET INSERTION POINT': 8257,
'CARON': 711,
'CAUTION SIGN': 9761,
'CEDI SIGN': 8373,
'CEDILLA': 184,
'CENT SIGN': 162,
'CENTRE LINE SYMBOL': 8452,
'CENTRELINE LOW LINE': 65102,
'CENTRELINE OVERLINE': 65098,
'CHARACTER TIE': 8256,
'CHECK MARK': 10003,
'CHEROKEE LETTER A': 5024,
'CHEROKEE LETTER DA': 5075,
'CHEROKEE LETTER DE': 5077,
'CHEROKEE LETTER DI': 5079,
'CHEROKEE LETTER DLA': 5084,
'CHEROKEE LETTER DO': 5081,
'CHEROKEE LETTER DU': 5082,
'CHEROKEE LETTER DV': 5083,
'CHEROKEE LETTER E': 5025,
'CHEROKEE LETTER GA': 5030,
'CHEROKEE LETTER GE': 5032,
'CHEROKEE LETTER GI': 5033,
'CHEROKEE LETTER GO': 5034,
'CHEROKEE LETTER GU': 5035,
'CHEROKEE LETTER GV': 5036,
'CHEROKEE LETTER HA': 5037,
'CHEROKEE LETTER HE': 5038,
'CHEROKEE LETTER HI': 5039,
'CHEROKEE LETTER HNA': 5055,
'CHEROKEE LETTER HO': 5040,
'CHEROKEE LETTER HU': 5041,
'CHEROKEE LETTER HV': 5042,
'CHEROKEE LETTER I': 5026,
'CHEROKEE LETTER KA': 5031,
'CHEROKEE LETTER LA': 5043,
'CHEROKEE LETTER LE': 5044,
'CHEROKEE LETTER LI': 5045,
'CHEROKEE LETTER LO': 5046,
'CHEROKEE LETTER LU': 5047,
'CHEROKEE LETTER LV': 5048,
'CHEROKEE LETTER MA': 5049,
'CHEROKEE LETTER ME': 5050,
'CHEROKEE LETTER MI': 5051,
'CHEROKEE LETTER MO': 5052,
'CHEROKEE LETTER MU': 5053,
'CHEROKEE LETTER NA': 5054,
'CHEROKEE LETTER NAH': 5056,
'CHEROKEE LETTER NE': 5057,
'CHEROKEE LETTER NI': 5058,
'CHEROKEE LETTER NO': 5059,
'CHEROKEE LETTER NU': 5060,
'CHEROKEE LETTER NV': 5061,
'CHEROKEE LETTER O': 5027,
'CHEROKEE LETTER QUA': 5062,
'CHEROKEE LETTER QUE': 5063,
'CHEROKEE LETTER QUI': 5064,
'CHEROKEE LETTER QUO': 5065,
'CHEROKEE LETTER QUU': 5066,
'CHEROKEE LETTER QUV': 5067,
'CHEROKEE LETTER S': 5069,
'CHEROKEE LETTER SA': 5068,
'CHEROKEE LETTER SE': 5070,
'CHEROKEE LETTER SI': 5071,
'CHEROKEE LETTER SO': 5072,
'CHEROKEE LETTER SU': 5073,
'CHEROKEE LETTER SV': 5074,
'CHEROKEE LETTER TA': 5076,
'CHEROKEE LETTER TE': 5078,
'CHEROKEE LETTER TI': 5080,
'CHEROKEE LETTER TLA': 5085,
'CHEROKEE LETTER TLE': 5086,
'CHEROKEE LETTER TLI': 5087,
'CHEROKEE LETTER TLO': 5088,
'CHEROKEE LETTER TLU': 5089,
'CHEROKEE LETTER TLV': 5090,
'CHEROKEE LETTER TSA': 5091,
'CHEROKEE LETTER TSE': 5092,
'CHEROKEE LETTER TSI': 5093,
'CHEROKEE LETTER TSO': 5094,
'CHEROKEE LETTER TSU': 5095,
'CHEROKEE LETTER TSV': 5096,
'CHEROKEE LETTER U': 5028,
'CHEROKEE LETTER V': 5029,
'CHEROKEE LETTER WA': 5097,
'CHEROKEE LETTER WE': 5098,
'CHEROKEE LETTER WI': 5099,
'CHEROKEE LETTER WO': 5100,
'CHEROKEE LETTER WU': 5101,
'CHEROKEE LETTER WV': 5102,
'CHEROKEE LETTER YA': 5103,
'CHEROKEE LETTER YE': 5104,
'CHEROKEE LETTER YI': 5105,
'CHEROKEE LETTER YO': 5106,
'CHEROKEE LETTER YU': 5107,
'CHEROKEE LETTER YV': 5108,
'CHI RHO': 9767,
'CIRCLE DIVIDED BY HORIZONTAL BAR AND TOP HALF DIVIDED BY VERTICAL BAR': 10682,
'CIRCLE WITH ALL BUT UPPER LEFT QUADRANT BLACK': 9685,
'CIRCLE WITH HORIZONTAL BAR': 10677,
'CIRCLE WITH LEFT HALF BLACK': 9680,
'CIRCLE WITH LOWER HALF BLACK': 9682,
'CIRCLE WITH RIGHT HALF BLACK': 9681,
'CIRCLE WITH SMALL CIRCLE TO THE RIGHT': 10690,
'CIRCLE WITH SUPERIMPOSED X': 10683,
'CIRCLE WITH TWO HORIZONTAL STROKES TO THE RIGHT': 10691,
'CIRCLE WITH UPPER HALF BLACK': 9683,
'CIRCLE WITH UPPER RIGHT QUADRANT BLACK': 9684,
'CIRCLE WITH VERTICAL FILL': 9677,
'CIRCLED ANTICLOCKWISE-ROTATED DIVISION SIGN': 10684,
'CIRCLED ASTERISK OPERATOR': 8859,
'CIRCLED BULLET': 10687,
'CIRCLED DASH': 8861,
'CIRCLED DIGIT EIGHT': 9319,
'CIRCLED DIGIT FIVE': 9316,
'CIRCLED DIGIT FOUR': 9315,
'CIRCLED DIGIT NINE': 9320,
'CIRCLED DIGIT ONE': 9312,
'CIRCLED DIGIT SEVEN': 9318,
'CIRCLED DIGIT SIX': 9317,
'CIRCLED DIGIT THREE': 9314,
'CIRCLED DIGIT TWO': 9313,
'CIRCLED DIGIT ZERO': 9450,
'CIRCLED DIVISION SIGN': 10808,
'CIRCLED DIVISION SLASH': 8856,
'CIRCLED DOT OPERATOR': 8857,
'CIRCLED EQUALS': 8860,
'CIRCLED GREATER-THAN': 10689,
'CIRCLED HANGUL CHIEUCH': 12905,
'CIRCLED HANGUL CHIEUCH A': 12919,
'CIRCLED HANGUL CIEUC': 12904,
'CIRCLED HANGUL CIEUC A': 12918,
'CIRCLED HANGUL HIEUH': 12909,
'CIRCLED HANGUL HIEUH A': 12923,
'CIRCLED HANGUL IEUNG': 12903,
'CIRCLED HANGUL IEUNG A': 12917,
'CIRCLED HANGUL IEUNG U': 12926,
'CIRCLED HANGUL KHIEUKH': 12906,
'CIRCLED HANGUL KHIEUKH A': 12920,
'CIRCLED HANGUL KIYEOK': 12896,
'CIRCLED HANGUL KIYEOK A': 12910,
'CIRCLED HANGUL MIEUM': 12900,
'CIRCLED HANGUL MIEUM A': 12914,
'CIRCLED HANGUL NIEUN': 12897,
'CIRCLED HANGUL NIEUN A': 12911,
'CIRCLED HANGUL PHIEUPH': 12908,
'CIRCLED HANGUL PHIEUPH A': 12922,
'CIRCLED HANGUL PIEUP': 12901,
'CIRCLED HANGUL PIEUP A': 12915,
'CIRCLED HANGUL RIEUL': 12899,
'CIRCLED HANGUL RIEUL A': 12913,
'CIRCLED HANGUL SIOS': 12902,
'CIRCLED HANGUL SIOS A': 12916,
'CIRCLED HANGUL THIEUTH': 12907,
'CIRCLED HANGUL THIEUTH A': 12921,
'CIRCLED HANGUL TIKEUT': 12898,
'CIRCLED HANGUL TIKEUT A': 12912,
'CIRCLED HEAVY WHITE RIGHTWARDS ARROW': 10162,
'CIRCLED HORIZONTAL BAR WITH NOTCH': 9097,
'CIRCLED IDEOGRAPH ALLIANCE': 12975,
'CIRCLED IDEOGRAPH ATTENTION': 12959,
'CIRCLED IDEOGRAPH CENTRE': 12965,
'CIRCLED IDEOGRAPH CONGRATULATION': 12951,
'CIRCLED IDEOGRAPH COPY': 12962,
'CIRCLED IDEOGRAPH CORRECT': 12963,
'CIRCLED IDEOGRAPH EARTH': 12943,
'CIRCLED IDEOGRAPH EIGHT': 12935,
'CIRCLED IDEOGRAPH ENTERPRISE': 12973,
'CIRCLED IDEOGRAPH EXCELLENT': 12957,
'CIRCLED IDEOGRAPH FEMALE': 12955,
'CIRCLED IDEOGRAPH FINANCIAL': 12950,
'CIRCLED IDEOGRAPH FIRE': 12939,
'CIRCLED IDEOGRAPH FIVE': 12932,
'CIRCLED IDEOGRAPH FOUR': 12931,
'CIRCLED IDEOGRAPH HAVE': 12946,
'CIRCLED IDEOGRAPH HIGH': 12964,
'CIRCLED IDEOGRAPH ITEM': 12960,
'CIRCLED IDEOGRAPH LABOR': 12952,
'CIRCLED IDEOGRAPH LEFT': 12967,
'CIRCLED IDEOGRAPH LOW': 12966,
'CIRCLED IDEOGRAPH MALE': 12954,
'CIRCLED IDEOGRAPH MEDICINE': 12969,
'CIRCLED IDEOGRAPH METAL': 12942,
'CIRCLED IDEOGRAPH MOON': 12938,
'CIRCLED IDEOGRAPH NAME': 12948,
'CIRCLED IDEOGRAPH NIGHT': 12976,
'CIRCLED IDEOGRAPH NINE': 12936,
'CIRCLED IDEOGRAPH ONE': 12928,
'CIRCLED IDEOGRAPH PRINT': 12958,
'CIRCLED IDEOGRAPH RELIGION': 12970,
'CIRCLED IDEOGRAPH RESOURCE': 12974,
'CIRCLED IDEOGRAPH REST': 12961,
'CIRCLED IDEOGRAPH RIGHT': 12968,
'CIRCLED IDEOGRAPH SECRET': 12953,
'CIRCLED IDEOGRAPH SEVEN': 12934,
'CIRCLED IDEOGRAPH SIX': 12933,
'CIRCLED IDEOGRAPH SOCIETY': 12947,
'CIRCLED IDEOGRAPH SPECIAL': 12949,
'CIRCLED IDEOGRAPH STOCK': 12945,
'CIRCLED IDEOGRAPH STUDY': 12971,
'CIRCLED IDEOGRAPH SUITABLE': 12956,
'CIRCLED IDEOGRAPH SUN': 12944,
'CIRCLED IDEOGRAPH SUPERVISE': 12972,
'CIRCLED IDEOGRAPH TEN': 12937,
'CIRCLED IDEOGRAPH THREE': 12930,
'CIRCLED IDEOGRAPH TWO': 12929,
'CIRCLED IDEOGRAPH WATER': 12940,
'CIRCLED IDEOGRAPH WOOD': 12941,
'CIRCLED KATAKANA A': 13008,
'CIRCLED KATAKANA E': 13011,
'CIRCLED KATAKANA HA': 13033,
'CIRCLED KATAKANA HE': 13036,
'CIRCLED KATAKANA HI': 13034,
'CIRCLED KATAKANA HO': 13037,
'CIRCLED KATAKANA HU': 13035,
'CIRCLED KATAKANA I': 13009,
'CIRCLED KATAKANA KA': 13013,
'CIRCLED KATAKANA KE': 13016,
'CIRCLED KATAKANA KI': 13014,
'CIRCLED KATAKANA KO': 13017,
'CIRCLED KATAKANA KU': 13015,
'CIRCLED KATAKANA MA': 13038,
'CIRCLED KATAKANA ME': 13041,
'CIRCLED KATAKANA MI': 13039,
'CIRCLED KATAKANA MO': 13042,
'CIRCLED KATAKANA MU': 13040,
'CIRCLED KATAKANA NA': 13028,
'CIRCLED KATAKANA NE': 13031,
'CIRCLED KATAKANA NI': 13029,
'CIRCLED KATAKANA NO': 13032,
'CIRCLED KATAKANA NU': 13030,
'CIRCLED KATAKANA O': 13012,
'CIRCLED KATAKANA RA': 13046,
'CIRCLED KATAKANA RE': 13049,
'CIRCLED KATAKANA RI': 13047,
'CIRCLED KATAKANA RO': 13050,
'CIRCLED KATAKANA RU': 13048,
'CIRCLED KATAKANA SA': 13018,
'CIRCLED KATAKANA SE': 13021,
'CIRCLED KATAKANA SI': 13019,
'CIRCLED KATAKANA SO': 13022,
'CIRCLED KATAKANA SU': 13020,
'CIRCLED KATAKANA TA': 13023,
'CIRCLED KATAKANA TE': 13026,
'CIRCLED KATAKANA TI': 13024,
'CIRCLED KATAKANA TO': 13027,
'CIRCLED KATAKANA TU': 13025,
'CIRCLED KATAKANA U': 13010,
'CIRCLED KATAKANA WA': 13051,
'CIRCLED KATAKANA WE': 13053,
'CIRCLED KATAKANA WI': 13052,
'CIRCLED KATAKANA WO': 13054,
'CIRCLED KATAKANA YA': 13043,
'CIRCLED KATAKANA YO': 13045,
'CIRCLED KATAKANA YU': 13044,
'CIRCLED KOREAN CHARACTER CHAMKO': 12924,
'CIRCLED KOREAN CHARACTER JUEUI': 12925,
'CIRCLED LATIN CAPITAL LETTER A': 9398,
'CIRCLED LATIN CAPITAL LETTER B': 9399,
'CIRCLED LATIN CAPITAL LETTER C': 9400,
'CIRCLED LATIN CAPITAL LETTER D': 9401,
'CIRCLED LATIN CAPITAL LETTER E': 9402,
'CIRCLED LATIN CAPITAL LETTER F': 9403,
'CIRCLED LATIN CAPITAL LETTER G': 9404,
'CIRCLED LATIN CAPITAL LETTER H': 9405,
'CIRCLED LATIN CAPITAL LETTER I': 9406,
'CIRCLED LATIN CAPITAL LETTER J': 9407,
'CIRCLED LATIN CAPITAL LETTER K': 9408,
'CIRCLED LATIN CAPITAL LETTER L': 9409,
'CIRCLED LATIN CAPITAL LETTER M': 9410,
'CIRCLED LATIN CAPITAL LETTER N': 9411,
'CIRCLED LATIN CAPITAL LETTER O': 9412,
'CIRCLED LATIN CAPITAL LETTER P': 9413,
'CIRCLED LATIN CAPITAL LETTER Q': 9414,
'CIRCLED LATIN CAPITAL LETTER R': 9415,
'CIRCLED LATIN CAPITAL LETTER S': 9416,
'CIRCLED LATIN CAPITAL LETTER T': 9417,
'CIRCLED LATIN CAPITAL LETTER U': 9418,
'CIRCLED LATIN CAPITAL LETTER V': 9419,
'CIRCLED LATIN CAPITAL LETTER W': 9420,
'CIRCLED LATIN CAPITAL LETTER X': 9421,
'CIRCLED LATIN CAPITAL LETTER Y': 9422,
'CIRCLED LATIN CAPITAL LETTER Z': 9423,
'CIRCLED LATIN SMALL LETTER A': 9424,
'CIRCLED LATIN SMALL LETTER B': 9425,
'CIRCLED LATIN SMALL LETTER C': 9426,
'CIRCLED LATIN SMALL LETTER D': 9427,
'CIRCLED LATIN SMALL LETTER E': 9428,
'CIRCLED LATIN SMALL LETTER F': 9429,
'CIRCLED LATIN SMALL LETTER G': 9430,
'CIRCLED LATIN SMALL LETTER H': 9431,
'CIRCLED LATIN SMALL LETTER I': 9432,
'CIRCLED LATIN SMALL LETTER J': 9433,
'CIRCLED LATIN SMALL LETTER K': 9434,
'CIRCLED LATIN SMALL LETTER L': 9435,
'CIRCLED LATIN SMALL LETTER M': 9436,
'CIRCLED LATIN SMALL LETTER N': 9437,
'CIRCLED LATIN SMALL LETTER O': 9438,
'CIRCLED LATIN SMALL LETTER P': 9439,
'CIRCLED LATIN SMALL LETTER Q': 9440,
'CIRCLED LATIN SMALL LETTER R': 9441,
'CIRCLED LATIN SMALL LETTER S': 9442,
'CIRCLED LATIN SMALL LETTER T': 9443,
'CIRCLED LATIN SMALL LETTER U': 9444,
'CIRCLED LATIN SMALL LETTER V': 9445,
'CIRCLED LATIN SMALL LETTER W': 9446,
'CIRCLED LATIN SMALL LETTER X': 9447,
'CIRCLED LATIN SMALL LETTER Y': 9448,
'CIRCLED LATIN SMALL LETTER Z': 9449,
'CIRCLED LESS-THAN': 10688,
'CIRCLED MINUS': 8854,
'CIRCLED MULTIPLICATION SIGN WITH CIRCUMFLEX ACCENT': 10806,
'CIRCLED NUMBER EIGHTEEN': 9329,
'CIRCLED NUMBER ELEVEN': 9322,
'CIRCLED NUMBER FIFTEEN': 9326,
'CIRCLED NUMBER FIFTY': 12991,
'CIRCLED NUMBER FORTY': 12981,
'CIRCLED NUMBER FORTY EIGHT': 12989,
'CIRCLED NUMBER FORTY FIVE': 12986,
'CIRCLED NUMBER FORTY FOUR': 12985,
'CIRCLED NUMBER FORTY NINE': 12990,
'CIRCLED NUMBER FORTY ONE': 12982,
'CIRCLED NUMBER FORTY SEVEN': 12988,
'CIRCLED NUMBER FORTY SIX': 12987,
'CIRCLED NUMBER FORTY THREE': 12984,
'CIRCLED NUMBER FORTY TWO': 12983,
'CIRCLED NUMBER FOURTEEN': 9325,
'CIRCLED NUMBER NINETEEN': 9330,
'CIRCLED NUMBER SEVENTEEN': 9328,
'CIRCLED NUMBER SIXTEEN': 9327,
'CIRCLED NUMBER TEN': 9321,
'CIRCLED NUMBER THIRTEEN': 9324,
'CIRCLED NUMBER THIRTY': 12890,
'CIRCLED NUMBER THIRTY EIGHT': 12979,
'CIRCLED NUMBER THIRTY FIVE': 12895,
'CIRCLED NUMBER THIRTY FOUR': 12894,
'CIRCLED NUMBER THIRTY NINE': 12980,
'CIRCLED NUMBER THIRTY ONE': 12891,
'CIRCLED NUMBER THIRTY SEVEN': 12978,
'CIRCLED NUMBER THIRTY SIX': 12977,
'CIRCLED NUMBER THIRTY THREE': 12893,
'CIRCLED NUMBER THIRTY TWO': 12892,
'CIRCLED NUMBER TWELVE': 9323,
'CIRCLED NUMBER TWENTY': 9331,
'CIRCLED NUMBER TWENTY EIGHT': 12888,
'CIRCLED NUMBER TWENTY FIVE': 12885,
'CIRCLED NUMBER TWENTY FOUR': 12884,
'CIRCLED NUMBER TWENTY NINE': 12889,
'CIRCLED NUMBER TWENTY ONE': 12881,
'CIRCLED NUMBER TWENTY SEVEN': 12887,
'CIRCLED NUMBER TWENTY SIX': 12886,
'CIRCLED NUMBER TWENTY THREE': 12883,
'CIRCLED NUMBER TWENTY TWO': 12882,
'CIRCLED OPEN CENTRE EIGHT POINTED STAR': 10050,
'CIRCLED PARALLEL': 10679,
'CIRCLED PERPENDICULAR': 10681,
'CIRCLED PLUS': 8853,
'CIRCLED POSTAL MARK': 12342,
'CIRCLED REVERSE SOLIDUS': 10680,
'CIRCLED RING OPERATOR': 8858,
'CIRCLED TIMES': 8855,
'CIRCLED TRIANGLE DOWN': 9098,
'CIRCLED VERTICAL BAR': 10678,
'CIRCLED WHITE BULLET': 10686,
'CIRCLED WHITE STAR': 10026,
'CIRCULATION FUNCTION': 10768,
'CIRCUMFLEX ACCENT': 94,
'CJK COMPATIBILITY IDEOGRAPH-2F800': 194560,
'CJK COMPATIBILITY IDEOGRAPH-2F801': 194561,
'CJK COMPATIBILITY IDEOGRAPH-2F802': 194562,
'CJK COMPATIBILITY IDEOGRAPH-2F803': 194563,
'CJK COMPATIBILITY IDEOGRAPH-2F804': 194564,
'CJK COMPATIBILITY IDEOGRAPH-2F805': 194565,
'CJK COMPATIBILITY IDEOGRAPH-2F806': 194566,
'CJK COMPATIBILITY IDEOGRAPH-2F807': 194567,
'CJK COMPATIBILITY IDEOGRAPH-2F808': 194568,
'CJK COMPATIBILITY IDEOGRAPH-2F809': 194569,
'CJK COMPATIBILITY IDEOGRAPH-2F80A': 194570,
'CJK COMPATIBILITY IDEOGRAPH-2F80B': 194571,
'CJK COMPATIBILITY IDEOGRAPH-2F80C': 194572,
'CJK COMPATIBILITY IDEOGRAPH-2F80D': 194573,
'CJK COMPATIBILITY IDEOGRAPH-2F80E': 194574,
'CJK COMPATIBILITY IDEOGRAPH-2F80F': 194575,
'CJK COMPATIBILITY IDEOGRAPH-2F810': 194576,
'CJK COMPATIBILITY IDEOGRAPH-2F811': 194577,
'CJK COMPATIBILITY IDEOGRAPH-2F812': 194578,
'CJK COMPATIBILITY IDEOGRAPH-2F813': 194579,
'CJK COMPATIBILITY IDEOGRAPH-2F814': 194580,
'CJK COMPATIBILITY IDEOGRAPH-2F815': 194581,
'CJK COMPATIBILITY IDEOGRAPH-2F816': 194582,
'CJK COMPATIBILITY IDEOGRAPH-2F817': 194583,
'CJK COMPATIBILITY IDEOGRAPH-2F818': 194584,
'CJK COMPATIBILITY IDEOGRAPH-2F819': 194585,
'CJK COMPATIBILITY IDEOGRAPH-2F81A': 194586,
'CJK COMPATIBILITY IDEOGRAPH-2F81B': 194587,
'CJK COMPATIBILITY IDEOGRAPH-2F81C': 194588,
'CJK COMPATIBILITY IDEOGRAPH-2F81D': 194589,
'CJK COMPATIBILITY IDEOGRAPH-2F81E': 194590,
'CJK COMPATIBILITY IDEOGRAPH-2F81F': 194591,
'CJK COMPATIBILITY IDEOGRAPH-2F820': 194592,
'CJK COMPATIBILITY IDEOGRAPH-2F821': 194593,
'CJK COMPATIBILITY IDEOGRAPH-2F822': 194594,
'CJK COMPATIBILITY IDEOGRAPH-2F823': 194595,
'CJK COMPATIBILITY IDEOGRAPH-2F824': 194596,
'CJK COMPATIBILITY IDEOGRAPH-2F825': 194597,
'CJK COMPATIBILITY IDEOGRAPH-2F826': 194598,
'CJK COMPATIBILITY IDEOGRAPH-2F827': 194599,
'CJK COMPATIBILITY IDEOGRAPH-2F828': 194600,
'CJK COMPATIBILITY IDEOGRAPH-2F829': 194601,
'CJK COMPATIBILITY IDEOGRAPH-2F82A': 194602,
'CJK COMPATIBILITY IDEOGRAPH-2F82B': 194603,
'CJK COMPATIBILITY IDEOGRAPH-2F82C': 194604,
'CJK COMPATIBILITY IDEOGRAPH-2F82D': 194605,
'CJK COMPATIBILITY IDEOGRAPH-2F82E': 194606,
'CJK COMPATIBILITY IDEOGRAPH-2F82F': 194607,
'CJK COMPATIBILITY IDEOGRAPH-2F830': 194608,
'CJK COMPATIBILITY IDEOGRAPH-2F831': 194609,
'CJK COMPATIBILITY IDEOGRAPH-2F832': 194610,
'CJK COMPATIBILITY IDEOGRAPH-2F833': 194611,
'CJK COMPATIBILITY IDEOGRAPH-2F834': 194612,
'CJK COMPATIBILITY IDEOGRAPH-2F835': 194613,
'CJK COMPATIBILITY IDEOGRAPH-2F836': 194614,
'CJK COMPATIBILITY IDEOGRAPH-2F837': 194615,
'CJK COMPATIBILITY IDEOGRAPH-2F838': 194616,
'CJK COMPATIBILITY IDEOGRAPH-2F839': 194617,
'CJK COMPATIBILITY IDEOGRAPH-2F83A': 194618,
'CJK COMPATIBILITY IDEOGRAPH-2F83B': 194619,
'CJK COMPATIBILITY IDEOGRAPH-2F83C': 194620,
'CJK COMPATIBILITY IDEOGRAPH-2F83D': 194621,
'CJK COMPATIBILITY IDEOGRAPH-2F83E': 194622,
'CJK COMPATIBILITY IDEOGRAPH-2F83F': 194623,
'CJK COMPATIBILITY IDEOGRAPH-2F840': 194624,
'CJK COMPATIBILITY IDEOGRAPH-2F841': 194625,
'CJK COMPATIBILITY IDEOGRAPH-2F842': 194626,
'CJK COMPATIBILITY IDEOGRAPH-2F843': 194627,
'CJK COMPATIBILITY IDEOGRAPH-2F844': 194628,
'CJK COMPATIBILITY IDEOGRAPH-2F845': 194629,
'CJK COMPATIBILITY IDEOGRAPH-2F846': 194630,
'CJK COMPATIBILITY IDEOGRAPH-2F847': 194631,
'CJK COMPATIBILITY IDEOGRAPH-2F848': 194632,
'CJK COMPATIBILITY IDEOGRAPH-2F849': 194633,
'CJK COMPATIBILITY IDEOGRAPH-2F84A': 194634,
'CJK COMPATIBILITY IDEOGRAPH-2F84B': 194635,
'CJK COMPATIBILITY IDEOGRAPH-2F84C': 194636,
'CJK COMPATIBILITY IDEOGRAPH-2F84D': 194637,
'CJK COMPATIBILITY IDEOGRAPH-2F84E': 194638,
'CJK COMPATIBILITY IDEOGRAPH-2F84F': 194639,
'CJK COMPATIBILITY IDEOGRAPH-2F850': 194640,
'CJK COMPATIBILITY IDEOGRAPH-2F851': 194641,
'CJK COMPATIBILITY IDEOGRAPH-2F852': 194642,
'CJK COMPATIBILITY IDEOGRAPH-2F853': 194643,
'CJK COMPATIBILITY IDEOGRAPH-2F854': 194644,
'CJK COMPATIBILITY IDEOGRAPH-2F855': 194645,
'CJK COMPATIBILITY IDEOGRAPH-2F856': 194646,
'CJK COMPATIBILITY IDEOGRAPH-2F857': 194647,
'CJK COMPATIBILITY IDEOGRAPH-2F858': 194648,
'CJK COMPATIBILITY IDEOGRAPH-2F859': 194649,
'CJK COMPATIBILITY IDEOGRAPH-2F85A': 194650,
'CJK COMPATIBILITY IDEOGRAPH-2F85B': 194651,
'CJK COMPATIBILITY IDEOGRAPH-2F85C': 194652,
'CJK COMPATIBILITY IDEOGRAPH-2F85D': 194653,
'CJK COMPATIBILITY IDEOGRAPH-2F85E': 194654,
'CJK COMPATIBILITY IDEOGRAPH-2F85F': 194655,
'CJK COMPATIBILITY IDEOGRAPH-2F860': 194656,
'CJK COMPATIBILITY IDEOGRAPH-2F861': 194657,
'CJK COMPATIBILITY IDEOGRAPH-2F862': 194658,
'CJK COMPATIBILITY IDEOGRAPH-2F863': 194659,
'CJK COMPATIBILITY IDEOGRAPH-2F864': 194660,
'CJK COMPATIBILITY IDEOGRAPH-2F865': 194661,
'CJK COMPATIBILITY IDEOGRAPH-2F866': 194662,
'CJK COMPATIBILITY IDEOGRAPH-2F867': 194663,
'CJK COMPATIBILITY IDEOGRAPH-2F868': 194664,
'CJK COMPATIBILITY IDEOGRAPH-2F869': 194665,
'CJK COMPATIBILITY IDEOGRAPH-2F86A': 194666,
'CJK COMPATIBILITY IDEOGRAPH-2F86B': 194667,
'CJK COMPATIBILITY IDEOGRAPH-2F86C': 194668,
'CJK COMPATIBILITY IDEOGRAPH-2F86D': 194669,
'CJK COMPATIBILITY IDEOGRAPH-2F86E': 194670,
'CJK COMPATIBILITY IDEOGRAPH-2F86F': 194671,
'CJK COMPATIBILITY IDEOGRAPH-2F870': 194672,
'CJK COMPATIBILITY IDEOGRAPH-2F871': 194673,
'CJK COMPATIBILITY IDEOGRAPH-2F872': 194674,
'CJK COMPATIBILITY IDEOGRAPH-2F873': 194675,
'CJK COMPATIBILITY IDEOGRAPH-2F874': 194676,
'CJK COMPATIBILITY IDEOGRAPH-2F875': 194677,
'CJK COMPATIBILITY IDEOGRAPH-2F876': 194678,
'CJK COMPATIBILITY IDEOGRAPH-2F877': 194679,
'CJK COMPATIBILITY IDEOGRAPH-2F878': 194680,
'CJK COMPATIBILITY IDEOGRAPH-2F879': 194681,
'CJK COMPATIBILITY IDEOGRAPH-2F87A': 194682,
'CJK COMPATIBILITY IDEOGRAPH-2F87B': 194683,
'CJK COMPATIBILITY IDEOGRAPH-2F87C': 194684,
'CJK COMPATIBILITY IDEOGRAPH-2F87D': 194685,
'CJK COMPATIBILITY IDEOGRAPH-2F87E': 194686,
'CJK COMPATIBILITY IDEOGRAPH-2F87F': 194687,
'CJK COMPATIBILITY IDEOGRAPH-2F880': 194688,
'CJK COMPATIBILITY IDEOGRAPH-2F881': 194689,
'CJK COMPATIBILITY IDEOGRAPH-2F882': 194690,
'CJK COMPATIBILITY IDEOGRAPH-2F883': 194691,
'CJK COMPATIBILITY IDEOGRAPH-2F884': 194692,
'CJK COMPATIBILITY IDEOGRAPH-2F885': 194693,
'CJK COMPATIBILITY IDEOGRAPH-2F886': 194694,
'CJK COMPATIBILITY IDEOGRAPH-2F887': 194695,
'CJK COMPATIBILITY IDEOGRAPH-2F888': 194696,
'CJK COMPATIBILITY IDEOGRAPH-2F889': 194697,
'CJK COMPATIBILITY IDEOGRAPH-2F88A': 194698,
'CJK COMPATIBILITY IDEOGRAPH-2F88B': 194699,
'CJK COMPATIBILITY IDEOGRAPH-2F88C': 194700,
'CJK COMPATIBILITY IDEOGRAPH-2F88D': 194701,
'CJK COMPATIBILITY IDEOGRAPH-2F88E': 194702,
'CJK COMPATIBILITY IDEOGRAPH-2F88F': 194703,
'CJK COMPATIBILITY IDEOGRAPH-2F890': 194704,
'CJK COMPATIBILITY IDEOGRAPH-2F891': 194705,
'CJK COMPATIBILITY IDEOGRAPH-2F892': 194706,
'CJK COMPATIBILITY IDEOGRAPH-2F893': 194707,
'CJK COMPATIBILITY IDEOGRAPH-2F894': 194708,
'CJK COMPATIBILITY IDEOGRAPH-2F895': 194709,
'CJK COMPATIBILITY IDEOGRAPH-2F896': 194710,
'CJK COMPATIBILITY IDEOGRAPH-2F897': 194711,
'CJK COMPATIBILITY IDEOGRAPH-2F898': 194712,
'CJK COMPATIBILITY IDEOGRAPH-2F899': 194713,
'CJK COMPATIBILITY IDEOGRAPH-2F89A': 194714,
'CJK COMPATIBILITY IDEOGRAPH-2F89B': 194715,
'CJK COMPATIBILITY IDEOGRAPH-2F89C': 194716,
'CJK COMPATIBILITY IDEOGRAPH-2F89D': 194717,
'CJK COMPATIBILITY IDEOGRAPH-2F89E': 194718,
'CJK COMPATIBILITY IDEOGRAPH-2F89F': 194719,
'CJK COMPATIBILITY IDEOGRAPH-2F8A0': 194720,
'CJK COMPATIBILITY IDEOGRAPH-2F8A1': 194721,
'CJK COMPATIBILITY IDEOGRAPH-2F8A2': 194722,
'CJK COMPATIBILITY IDEOGRAPH-2F8A3': 194723,
'CJK COMPATIBILITY IDEOGRAPH-2F8A4': 194724,
'CJK COMPATIBILITY IDEOGRAPH-2F8A5': 194725,
'CJK COMPATIBILITY IDEOGRAPH-2F8A6': 194726,
'CJK COMPATIBILITY IDEOGRAPH-2F8A7': 194727,
'CJK COMPATIBILITY IDEOGRAPH-2F8A8': 194728,
'CJK COMPATIBILITY IDEOGRAPH-2F8A9': 194729,
'CJK COMPATIBILITY IDEOGRAPH-2F8AA': 194730,
'CJK COMPATIBILITY IDEOGRAPH-2F8AB': 194731,
'CJK COMPATIBILITY IDEOGRAPH-2F8AC': 194732,
'CJK COMPATIBILITY IDEOGRAPH-2F8AD': 194733,
'CJK COMPATIBILITY IDEOGRAPH-2F8AE': 194734,
'CJK COMPATIBILITY IDEOGRAPH-2F8AF': 194735,
'CJK COMPATIBILITY IDEOGRAPH-2F8B0': 194736,
'CJK COMPATIBILITY IDEOGRAPH-2F8B1': 194737,
'CJK COMPATIBILITY IDEOGRAPH-2F8B2': 194738,
'CJK COMPATIBILITY IDEOGRAPH-2F8B3': 194739,
'CJK COMPATIBILITY IDEOGRAPH-2F8B4': 194740,
'CJK COMPATIBILITY IDEOGRAPH-2F8B5': 194741,
'CJK COMPATIBILITY IDEOGRAPH-2F8B6': 194742,
'CJK COMPATIBILITY IDEOGRAPH-2F8B7': 194743,
'CJK COMPATIBILITY IDEOGRAPH-2F8B8': 194744,
'CJK COMPATIBILITY IDEOGRAPH-2F8B9': 194745,
'CJK COMPATIBILITY IDEOGRAPH-2F8BA': 194746,
'CJK COMPATIBILITY IDEOGRAPH-2F8BB': 194747,
'CJK COMPATIBILITY IDEOGRAPH-2F8BC': 194748,
'CJK COMPATIBILITY IDEOGRAPH-2F8BD': 194749,
'CJK COMPATIBILITY IDEOGRAPH-2F8BE': 194750,
'CJK COMPATIBILITY IDEOGRAPH-2F8BF': 194751,
'CJK COMPATIBILITY IDEOGRAPH-2F8C0': 194752,
'CJK COMPATIBILITY IDEOGRAPH-2F8C1': 194753,
'CJK COMPATIBILITY IDEOGRAPH-2F8C2': 194754,
'CJK COMPATIBILITY IDEOGRAPH-2F8C3': 194755,
'CJK COMPATIBILITY IDEOGRAPH-2F8C4': 194756,
'CJK COMPATIBILITY IDEOGRAPH-2F8C5': 194757,
'CJK COMPATIBILITY IDEOGRAPH-2F8C6': 194758,
'CJK COMPATIBILITY IDEOGRAPH-2F8C7': 194759,
'CJK COMPATIBILITY IDEOGRAPH-2F8C8': 194760,
'CJK COMPATIBILITY IDEOGRAPH-2F8C9': 194761,
'CJK COMPATIBILITY IDEOGRAPH-2F8CA': 194762,
'CJK COMPATIBILITY IDEOGRAPH-2F8CB': 194763,
'CJK COMPATIBILITY IDEOGRAPH-2F8CC': 194764,
'CJK COMPATIBILITY IDEOGRAPH-2F8CD': 194765,
'CJK COMPATIBILITY IDEOGRAPH-2F8CE': 194766,
'CJK COMPATIBILITY IDEOGRAPH-2F8CF': 194767,
'CJK COMPATIBILITY IDEOGRAPH-2F8D0': 194768,
'CJK COMPATIBILITY IDEOGRAPH-2F8D1': 194769,
'CJK COMPATIBILITY IDEOGRAPH-2F8D2': 194770,
'CJK COMPATIBILITY IDEOGRAPH-2F8D3': 194771,
'CJK COMPATIBILITY IDEOGRAPH-2F8D4': 194772,
'CJK COMPATIBILITY IDEOGRAPH-2F8D5': 194773,
'CJK COMPATIBILITY IDEOGRAPH-2F8D6': 194774,
'CJK COMPATIBILITY IDEOGRAPH-2F8D7': 194775,
'CJK COMPATIBILITY IDEOGRAPH-2F8D8': 194776,
'CJK COMPATIBILITY IDEOGRAPH-2F8D9': 194777,
'CJK COMPATIBILITY IDEOGRAPH-2F8DA': 194778,
'CJK COMPATIBILITY IDEOGRAPH-2F8DB': 194779,
'CJK COMPATIBILITY IDEOGRAPH-2F8DC': 194780,
'CJK COMPATIBILITY IDEOGRAPH-2F8DD': 194781,
'CJK COMPATIBILITY IDEOGRAPH-2F8DE': 194782,
'CJK COMPATIBILITY IDEOGRAPH-2F8DF': 194783,
'CJK COMPATIBILITY IDEOGRAPH-2F8E0': 194784,
'CJK COMPATIBILITY IDEOGRAPH-2F8E1': 194785,
'CJK COMPATIBILITY IDEOGRAPH-2F8E2': 194786,
'CJK COMPATIBILITY IDEOGRAPH-2F8E3': 194787,
'CJK COMPATIBILITY IDEOGRAPH-2F8E4': 194788,
'CJK COMPATIBILITY IDEOGRAPH-2F8E5': 194789,
'CJK COMPATIBILITY IDEOGRAPH-2F8E6': 194790,
'CJK COMPATIBILITY IDEOGRAPH-2F8E7': 194791,
'CJK COMPATIBILITY IDEOGRAPH-2F8E8': 194792,
'CJK COMPATIBILITY IDEOGRAPH-2F8E9': 194793,
'CJK COMPATIBILITY IDEOGRAPH-2F8EA': 194794,
'CJK COMPATIBILITY IDEOGRAPH-2F8EB': 194795,
'CJK COMPATIBILITY IDEOGRAPH-2F8EC': 194796,
'CJK COMPATIBILITY IDEOGRAPH-2F8ED': 194797,
'CJK COMPATIBILITY IDEOGRAPH-2F8EE': 194798,
'CJK COMPATIBILITY IDEOGRAPH-2F8EF': 194799,
'CJK COMPATIBILITY IDEOGRAPH-2F8F0': 194800,
'CJK COMPATIBILITY IDEOGRAPH-2F8F1': 194801,
'CJK COMPATIBILITY IDEOGRAPH-2F8F2': 194802,
'CJK COMPATIBILITY IDEOGRAPH-2F8F3': 194803,
'CJK COMPATIBILITY IDEOGRAPH-2F8F4': 194804,
'CJK COMPATIBILITY IDEOGRAPH-2F8F5': 194805,
'CJK COMPATIBILITY IDEOGRAPH-2F8F6': 194806,
'CJK COMPATIBILITY IDEOGRAPH-2F8F7': 194807,
'CJK COMPATIBILITY IDEOGRAPH-2F8F8': 194808,
'CJK COMPATIBILITY IDEOGRAPH-2F8F9': 194809,
'CJK COMPATIBILITY IDEOGRAPH-2F8FA': 194810,
'CJK COMPATIBILITY IDEOGRAPH-2F8FB': 194811,
'CJK COMPATIBILITY IDEOGRAPH-2F8FC': 194812,
'CJK COMPATIBILITY IDEOGRAPH-2F8FD': 194813,
'CJK COMPATIBILITY IDEOGRAPH-2F8FE': 194814,
'CJK COMPATIBILITY IDEOGRAPH-2F8FF': 194815,
'CJK COMPATIBILITY IDEOGRAPH-2F900': 194816,
'CJK COMPATIBILITY IDEOGRAPH-2F901': 194817,
'CJK COMPATIBILITY IDEOGRAPH-2F902': 194818,
'CJK COMPATIBILITY IDEOGRAPH-2F903': 194819,
'CJK COMPATIBILITY IDEOGRAPH-2F904': 194820,
'CJK COMPATIBILITY IDEOGRAPH-2F905': 194821,
'CJK COMPATIBILITY IDEOGRAPH-2F906': 194822,
'CJK COMPATIBILITY IDEOGRAPH-2F907': 194823,
'CJK COMPATIBILITY IDEOGRAPH-2F908': 194824,
'CJK COMPATIBILITY IDEOGRAPH-2F909': 194825,
'CJK COMPATIBILITY IDEOGRAPH-2F90A': 194826,
'CJK COMPATIBILITY IDEOGRAPH-2F90B': 194827,
'CJK COMPATIBILITY IDEOGRAPH-2F90C': 194828,
'CJK COMPATIBILITY IDEOGRAPH-2F90D': 194829,
'CJK COMPATIBILITY IDEOGRAPH-2F90E': 194830,
'CJK COMPATIBILITY IDEOGRAPH-2F90F': 194831,
'CJK COMPATIBILITY IDEOGRAPH-2F910': 194832,
'CJK COMPATIBILITY IDEOGRAPH-2F911': 194833,
'CJK COMPATIBILITY IDEOGRAPH-2F912': 194834,
'CJK COMPATIBILITY IDEOGRAPH-2F913': 194835,
'CJK COMPATIBILITY IDEOGRAPH-2F914': 194836,
'CJK COMPATIBILITY IDEOGRAPH-2F915': 194837,
'CJK COMPATIBILITY IDEOGRAPH-2F916': 194838,
'CJK COMPATIBILITY IDEOGRAPH-2F917': 194839,
'CJK COMPATIBILITY IDEOGRAPH-2F918': 194840,
'CJK COMPATIBILITY IDEOGRAPH-2F919': 194841,
'CJK COMPATIBILITY IDEOGRAPH-2F91A': 194842,
'CJK COMPATIBILITY IDEOGRAPH-2F91B': 194843,
'CJK COMPATIBILITY IDEOGRAPH-2F91C': 194844,
'CJK COMPATIBILITY IDEOGRAPH-2F91D': 194845,
'CJK COMPATIBILITY IDEOGRAPH-2F91E': 194846,
'CJK COMPATIBILITY IDEOGRAPH-2F91F': 194847,
'CJK COMPATIBILITY IDEOGRAPH-2F920': 194848,
'CJK COMPATIBILITY IDEOGRAPH-2F921': 194849,
'CJK COMPATIBILITY IDEOGRAPH-2F922': 194850,
'CJK COMPATIBILITY IDEOGRAPH-2F923': 194851,
'CJK COMPATIBILITY IDEOGRAPH-2F924': 194852,
'CJK COMPATIBILITY IDEOGRAPH-2F925': 194853,
'CJK COMPATIBILITY IDEOGRAPH-2F926': 194854,
'CJK COMPATIBILITY IDEOGRAPH-2F927': 194855,
'CJK COMPATIBILITY IDEOGRAPH-2F928': 194856,
'CJK COMPATIBILITY IDEOGRAPH-2F929': 194857,
'CJK COMPATIBILITY IDEOGRAPH-2F92A': 194858,
'CJK COMPATIBILITY IDEOGRAPH-2F92B': 194859,
'CJK COMPATIBILITY IDEOGRAPH-2F92C': 194860,
'CJK COMPATIBILITY IDEOGRAPH-2F92D': 194861,
'CJK COMPATIBILITY IDEOGRAPH-2F92E': 194862,
'CJK COMPATIBILITY IDEOGRAPH-2F92F': 194863,
'CJK COMPATIBILITY IDEOGRAPH-2F930': 194864,
'CJK COMPATIBILITY IDEOGRAPH-2F931': 194865,
'CJK COMPATIBILITY IDEOGRAPH-2F932': 194866,
'CJK COMPATIBILITY IDEOGRAPH-2F933': 194867,
'CJK COMPATIBILITY IDEOGRAPH-2F934': 194868,
'CJK COMPATIBILITY IDEOGRAPH-2F935': 194869,
'CJK COMPATIBILITY IDEOGRAPH-2F936': 194870,
'CJK COMPATIBILITY IDEOGRAPH-2F937': 194871,
'CJK COMPATIBILITY IDEOGRAPH-2F938': 194872,
'CJK COMPATIBILITY IDEOGRAPH-2F939': 194873,
'CJK COMPATIBILITY IDEOGRAPH-2F93A': 194874,
'CJK COMPATIBILITY IDEOGRAPH-2F93B': 194875,
'CJK COMPATIBILITY IDEOGRAPH-2F93C': 194876,
'CJK COMPATIBILITY IDEOGRAPH-2F93D': 194877,
'CJK COMPATIBILITY IDEOGRAPH-2F93E': 194878,
'CJK COMPATIBILITY IDEOGRAPH-2F93F': 194879,
'CJK COMPATIBILITY IDEOGRAPH-2F940': 194880,
'CJK COMPATIBILITY IDEOGRAPH-2F941': 194881,
'CJK COMPATIBILITY IDEOGRAPH-2F942': 194882,
'CJK COMPATIBILITY IDEOGRAPH-2F943': 194883,
'CJK COMPATIBILITY IDEOGRAPH-2F944': 194884,
'CJK COMPATIBILITY IDEOGRAPH-2F945': 194885,
'CJK COMPATIBILITY IDEOGRAPH-2F946': 194886,
'CJK COMPATIBILITY IDEOGRAPH-2F947': 194887,
'CJK COMPATIBILITY IDEOGRAPH-2F948': 194888,
'CJK COMPATIBILITY IDEOGRAPH-2F949': 194889,
'CJK COMPATIBILITY IDEOGRAPH-2F94A': 194890,
'CJK COMPATIBILITY IDEOGRAPH-2F94B': 194891,
'CJK COMPATIBILITY IDEOGRAPH-2F94C': 194892,
'CJK COMPATIBILITY IDEOGRAPH-2F94D': 194893,
'CJK COMPATIBILITY IDEOGRAPH-2F94E': 194894,
'CJK COMPATIBILITY IDEOGRAPH-2F94F': 194895,
'CJK COMPATIBILITY IDEOGRAPH-2F950': 194896,
'CJK COMPATIBILITY IDEOGRAPH-2F951': 194897,
'CJK COMPATIBILITY IDEOGRAPH-2F952': 194898,
'CJK COMPATIBILITY IDEOGRAPH-2F953': 194899,
'CJK COMPATIBILITY IDEOGRAPH-2F954': 194900,
'CJK COMPATIBILITY IDEOGRAPH-2F955': 194901,
'CJK COMPATIBILITY IDEOGRAPH-2F956': 194902,
'CJK COMPATIBILITY IDEOGRAPH-2F957': 194903,
'CJK COMPATIBILITY IDEOGRAPH-2F958': 194904,
'CJK COMPATIBILITY IDEOGRAPH-2F959': 194905,
'CJK COMPATIBILITY IDEOGRAPH-2F95A': 194906,
'CJK COMPATIBILITY IDEOGRAPH-2F95B': 194907,
'CJK COMPATIBILITY IDEOGRAPH-2F95C': 194908,
'CJK COMPATIBILITY IDEOGRAPH-2F95D': 194909,
'CJK COMPATIBILITY IDEOGRAPH-2F95E': 194910,
'CJK COMPATIBILITY IDEOGRAPH-2F95F': 194911,
'CJK COMPATIBILITY IDEOGRAPH-2F960': 194912,
'CJK COMPATIBILITY IDEOGRAPH-2F961': 194913,
'CJK COMPATIBILITY IDEOGRAPH-2F962': 194914,
'CJK COMPATIBILITY IDEOGRAPH-2F963': 194915,
'CJK COMPATIBILITY IDEOGRAPH-2F964': 194916,
'CJK COMPATIBILITY IDEOGRAPH-2F965': 194917,
'CJK COMPATIBILITY IDEOGRAPH-2F966': 194918,
'CJK COMPATIBILITY IDEOGRAPH-2F967': 194919,
'CJK COMPATIBILITY IDEOGRAPH-2F968': 194920,
'CJK COMPATIBILITY IDEOGRAPH-2F969': 194921,
'CJK COMPATIBILITY IDEOGRAPH-2F96A': 194922,
'CJK COMPATIBILITY IDEOGRAPH-2F96B': 194923,
'CJK COMPATIBILITY IDEOGRAPH-2F96C': 194924,
'CJK COMPATIBILITY IDEOGRAPH-2F96D': 194925,
'CJK COMPATIBILITY IDEOGRAPH-2F96E': 194926,
'CJK COMPATIBILITY IDEOGRAPH-2F96F': 194927,
'CJK COMPATIBILITY IDEOGRAPH-2F970': 194928,
'CJK COMPATIBILITY IDEOGRAPH-2F971': 194929,
'CJK COMPATIBILITY IDEOGRAPH-2F972': 194930,
'CJK COMPATIBILITY IDEOGRAPH-2F973': 194931,
'CJK COMPATIBILITY IDEOGRAPH-2F974': 194932,
'CJK COMPATIBILITY IDEOGRAPH-2F975': 194933,
'CJK COMPATIBILITY IDEOGRAPH-2F976': 194934,
'CJK COMPATIBILITY IDEOGRAPH-2F977': 194935,
'CJK COMPATIBILITY IDEOGRAPH-2F978': 194936,
'CJK COMPATIBILITY IDEOGRAPH-2F979': 194937,
'CJK COMPATIBILITY IDEOGRAPH-2F97A': 194938,
'CJK COMPATIBILITY IDEOGRAPH-2F97B': 194939,
'CJK COMPATIBILITY IDEOGRAPH-2F97C': 194940,
'CJK COMPATIBILITY IDEOGRAPH-2F97D': 194941,
'CJK COMPATIBILITY IDEOGRAPH-2F97E': 194942,
'CJK COMPATIBILITY IDEOGRAPH-2F97F': 194943,
'CJK COMPATIBILITY IDEOGRAPH-2F980': 194944,
'CJK COMPATIBILITY IDEOGRAPH-2F981': 194945,
'CJK COMPATIBILITY IDEOGRAPH-2F982': 194946,
'CJK COMPATIBILITY IDEOGRAPH-2F983': 194947,
'CJK COMPATIBILITY IDEOGRAPH-2F984': 194948,
'CJK COMPATIBILITY IDEOGRAPH-2F985': 194949,
'CJK COMPATIBILITY IDEOGRAPH-2F986': 194950,
'CJK COMPATIBILITY IDEOGRAPH-2F987': 194951,
'CJK COMPATIBILITY IDEOGRAPH-2F988': 194952,
'CJK COMPATIBILITY IDEOGRAPH-2F989': 194953,
'CJK COMPATIBILITY IDEOGRAPH-2F98A': 194954,
'CJK COMPATIBILITY IDEOGRAPH-2F98B': 194955,
'CJK COMPATIBILITY IDEOGRAPH-2F98C': 194956,
'CJK COMPATIBILITY IDEOGRAPH-2F98D': 194957,
'CJK COMPATIBILITY IDEOGRAPH-2F98E': 194958,
'CJK COMPATIBILITY IDEOGRAPH-2F98F': 194959,
'CJK COMPATIBILITY IDEOGRAPH-2F990': 194960,
'CJK COMPATIBILITY IDEOGRAPH-2F991': 194961,
'CJK COMPATIBILITY IDEOGRAPH-2F992': 194962,
'CJK COMPATIBILITY IDEOGRAPH-2F993': 194963,
'CJK COMPATIBILITY IDEOGRAPH-2F994': 194964,
'CJK COMPATIBILITY IDEOGRAPH-2F995': 194965,
'CJK COMPATIBILITY IDEOGRAPH-2F996': 194966,
'CJK COMPATIBILITY IDEOGRAPH-2F997': 194967,
'CJK COMPATIBILITY IDEOGRAPH-2F998': 194968,
'CJK COMPATIBILITY IDEOGRAPH-2F999': 194969,
'CJK COMPATIBILITY IDEOGRAPH-2F99A': 194970,
'CJK COMPATIBILITY IDEOGRAPH-2F99B': 194971,
'CJK COMPATIBILITY IDEOGRAPH-2F99C': 194972,
'CJK COMPATIBILITY IDEOGRAPH-2F99D': 194973,
'CJK COMPATIBILITY IDEOGRAPH-2F99E': 194974,
'CJK COMPATIBILITY IDEOGRAPH-2F99F': 194975,
'CJK COMPATIBILITY IDEOGRAPH-2F9A0': 194976,
'CJK COMPATIBILITY IDEOGRAPH-2F9A1': 194977,
'CJK COMPATIBILITY IDEOGRAPH-2F9A2': 194978,
'CJK COMPATIBILITY IDEOGRAPH-2F9A3': 194979,
'CJK COMPATIBILITY IDEOGRAPH-2F9A4': 194980,
'CJK COMPATIBILITY IDEOGRAPH-2F9A5': 194981,
'CJK COMPATIBILITY IDEOGRAPH-2F9A6': 194982,
'CJK COMPATIBILITY IDEOGRAPH-2F9A7': 194983,
'CJK COMPATIBILITY IDEOGRAPH-2F9A8': 194984,
'CJK COMPATIBILITY IDEOGRAPH-2F9A9': 194985,
'CJK COMPATIBILITY IDEOGRAPH-2F9AA': 194986,
'CJK COMPATIBILITY IDEOGRAPH-2F9AB': 194987,
'CJK COMPATIBILITY IDEOGRAPH-2F9AC': 194988,
'CJK COMPATIBILITY IDEOGRAPH-2F9AD': 194989,
'CJK COMPATIBILITY IDEOGRAPH-2F9AE': 194990,
'CJK COMPATIBILITY IDEOGRAPH-2F9AF': 194991,
'CJK COMPATIBILITY IDEOGRAPH-2F9B0': 194992,
'CJK COMPATIBILITY IDEOGRAPH-2F9B1': 194993,
'CJK COMPATIBILITY IDEOGRAPH-2F9B2': 194994,
'CJK COMPATIBILITY IDEOGRAPH-2F9B3': 194995,
'CJK COMPATIBILITY IDEOGRAPH-2F9B4': 194996,
'CJK COMPATIBILITY IDEOGRAPH-2F9B5': 194997,
'CJK COMPATIBILITY IDEOGRAPH-2F9B6': 194998,
'CJK COMPATIBILITY IDEOGRAPH-2F9B7': 194999,
'CJK COMPATIBILITY IDEOGRAPH-2F9B8': 195000,
'CJK COMPATIBILITY IDEOGRAPH-2F9B9': 195001,
'CJK COMPATIBILITY IDEOGRAPH-2F9BA': 195002,
'CJK COMPATIBILITY IDEOGRAPH-2F9BB': 195003,
'CJK COMPATIBILITY IDEOGRAPH-2F9BC': 195004,
'CJK COMPATIBILITY IDEOGRAPH-2F9BD': 195005,
'CJK COMPATIBILITY IDEOGRAPH-2F9BE': 195006,
'CJK COMPATIBILITY IDEOGRAPH-2F9BF': 195007,
'CJK COMPATIBILITY IDEOGRAPH-2F9C0': 195008,
'CJK COMPATIBILITY IDEOGRAPH-2F9C1': 195009,
'CJK COMPATIBILITY IDEOGRAPH-2F9C2': 195010,
'CJK COMPATIBILITY IDEOGRAPH-2F9C3': 195011,
'CJK COMPATIBILITY IDEOGRAPH-2F9C4': 195012,
'CJK COMPATIBILITY IDEOGRAPH-2F9C5': 195013,
'CJK COMPATIBILITY IDEOGRAPH-2F9C6': 195014,
'CJK COMPATIBILITY IDEOGRAPH-2F9C7': 195015,
'CJK COMPATIBILITY IDEOGRAPH-2F9C8': 195016,
'CJK COMPATIBILITY IDEOGRAPH-2F9C9': 195017,
'CJK COMPATIBILITY IDEOGRAPH-2F9CA': 195018,
'CJK COMPATIBILITY IDEOGRAPH-2F9CB': 195019,
'CJK COMPATIBILITY IDEOGRAPH-2F9CC': 195020,
'CJK COMPATIBILITY IDEOGRAPH-2F9CD': 195021,
'CJK COMPATIBILITY IDEOGRAPH-2F9CE': 195022,
'CJK COMPATIBILITY IDEOGRAPH-2F9CF': 195023,
'CJK COMPATIBILITY IDEOGRAPH-2F9D0': 195024,
'CJK COMPATIBILITY IDEOGRAPH-2F9D1': 195025,
'CJK COMPATIBILITY IDEOGRAPH-2F9D2': 195026,
'CJK COMPATIBILITY IDEOGRAPH-2F9D3': 195027,
'CJK COMPATIBILITY IDEOGRAPH-2F9D4': 195028,
'CJK COMPATIBILITY IDEOGRAPH-2F9D5': 195029,
'CJK COMPATIBILITY IDEOGRAPH-2F9D6': 195030,
'CJK COMPATIBILITY IDEOGRAPH-2F9D7': 195031,
'CJK COMPATIBILITY IDEOGRAPH-2F9D8': 195032,
'CJK COMPATIBILITY IDEOGRAPH-2F9D9': 195033,
'CJK COMPATIBILITY IDEOGRAPH-2F9DA': 195034,
'CJK COMPATIBILITY IDEOGRAPH-2F9DB': 195035,
'CJK COMPATIBILITY IDEOGRAPH-2F9DC': 195036,
'CJK COMPATIBILITY IDEOGRAPH-2F9DD': 195037,
'CJK COMPATIBILITY IDEOGRAPH-2F9DE': 195038,
'CJK COMPATIBILITY IDEOGRAPH-2F9DF': 195039,
'CJK COMPATIBILITY IDEOGRAPH-2F9E0': 195040,
'CJK COMPATIBILITY IDEOGRAPH-2F9E1': 195041,
'CJK COMPATIBILITY IDEOGRAPH-2F9E2': 195042,
'CJK COMPATIBILITY IDEOGRAPH-2F9E3': 195043,
'CJK COMPATIBILITY IDEOGRAPH-2F9E4': 195044,
'CJK COMPATIBILITY IDEOGRAPH-2F9E5': 195045,
'CJK COMPATIBILITY IDEOGRAPH-2F9E6': 195046,
'CJK COMPATIBILITY IDEOGRAPH-2F9E7': 195047,
'CJK COMPATIBILITY IDEOGRAPH-2F9E8': 195048,
'CJK COMPATIBILITY IDEOGRAPH-2F9E9': 195049,
'CJK COMPATIBILITY IDEOGRAPH-2F9EA': 195050,
'CJK COMPATIBILITY IDEOGRAPH-2F9EB': 195051,
'CJK COMPATIBILITY IDEOGRAPH-2F9EC': 195052,
'CJK COMPATIBILITY IDEOGRAPH-2F9ED': 195053,
'CJK COMPATIBILITY IDEOGRAPH-2F9EE': 195054,
'CJK COMPATIBILITY IDEOGRAPH-2F9EF': 195055,
'CJK COMPATIBILITY IDEOGRAPH-2F9F0': 195056,
'CJK COMPATIBILITY IDEOGRAPH-2F9F1': 195057,
'CJK COMPATIBILITY IDEOGRAPH-2F9F2': 195058,
'CJK COMPATIBILITY IDEOGRAPH-2F9F3': 195059,
'CJK COMPATIBILITY IDEOGRAPH-2F9F4': 195060,
'CJK COMPATIBILITY IDEOGRAPH-2F9F5': 195061,
'CJK COMPATIBILITY IDEOGRAPH-2F9F6': 195062,
'CJK COMPATIBILITY IDEOGRAPH-2F9F7': 195063,
'CJK COMPATIBILITY IDEOGRAPH-2F9F8': 195064,
'CJK COMPATIBILITY IDEOGRAPH-2F9F9': 195065,
'CJK COMPATIBILITY IDEOGRAPH-2F9FA': 195066,
'CJK COMPATIBILITY IDEOGRAPH-2F9FB': 195067,
'CJK COMPATIBILITY IDEOGRAPH-2F9FC': 195068,
'CJK COMPATIBILITY IDEOGRAPH-2F9FD': 195069,
'CJK COMPATIBILITY IDEOGRAPH-2F9FE': 195070,
'CJK COMPATIBILITY IDEOGRAPH-2F9FF': 195071,
'CJK COMPATIBILITY IDEOGRAPH-2FA00': 195072,
'CJK COMPATIBILITY IDEOGRAPH-2FA01': 195073,
'CJK COMPATIBILITY IDEOGRAPH-2FA02': 195074,
'CJK COMPATIBILITY IDEOGRAPH-2FA03': 195075,
'CJK COMPATIBILITY IDEOGRAPH-2FA04': 195076,
'CJK COMPATIBILITY IDEOGRAPH-2FA05': 195077,
'CJK COMPATIBILITY IDEOGRAPH-2FA06': 195078,
'CJK COMPATIBILITY IDEOGRAPH-2FA07': 195079,
'CJK COMPATIBILITY IDEOGRAPH-2FA08': 195080,
'CJK COMPATIBILITY IDEOGRAPH-2FA09': 195081,
'CJK COMPATIBILITY IDEOGRAPH-2FA0A': 195082,
'CJK COMPATIBILITY IDEOGRAPH-2FA0B': 195083,
'CJK COMPATIBILITY IDEOGRAPH-2FA0C': 195084,
'CJK COMPATIBILITY IDEOGRAPH-2FA0D': 195085,
'CJK COMPATIBILITY IDEOGRAPH-2FA0E': 195086,
'CJK COMPATIBILITY IDEOGRAPH-2FA0F': 195087,
'CJK COMPATIBILITY IDEOGRAPH-2FA10': 195088,
'CJK COMPATIBILITY IDEOGRAPH-2FA11': 195089,
'CJK COMPATIBILITY IDEOGRAPH-2FA12': 195090,
'CJK COMPATIBILITY IDEOGRAPH-2FA13': 195091,
'CJK COMPATIBILITY IDEOGRAPH-2FA14': 195092,
'CJK COMPATIBILITY IDEOGRAPH-2FA15': 195093,
'CJK COMPATIBILITY IDEOGRAPH-2FA16': 195094,
'CJK COMPATIBILITY IDEOGRAPH-2FA17': 195095,
'CJK COMPATIBILITY IDEOGRAPH-2FA18': 195096,
'CJK COMPATIBILITY IDEOGRAPH-2FA19': 195097,
'CJK COMPATIBILITY IDEOGRAPH-2FA1A': 195098,
'CJK COMPATIBILITY IDEOGRAPH-2FA1B': 195099,
'CJK COMPATIBILITY IDEOGRAPH-2FA1C': 195100,
'CJK COMPATIBILITY IDEOGRAPH-2FA1D': 195101,
'CJK COMPATIBILITY IDEOGRAPH-F900': 63744,
'CJK COMPATIBILITY IDEOGRAPH-F901': 63745,
'CJK COMPATIBILITY IDEOGRAPH-F902': 63746,
'CJK COMPATIBILITY IDEOGRAPH-F903': 63747,
'CJK COMPATIBILITY IDEOGRAPH-F904': 63748,
'CJK COMPATIBILITY IDEOGRAPH-F905': 63749,
'CJK COMPATIBILITY IDEOGRAPH-F906': 63750,
'CJK COMPATIBILITY IDEOGRAPH-F907': 63751,
'CJK COMPATIBILITY IDEOGRAPH-F908': 63752,
'CJK COMPATIBILITY IDEOGRAPH-F909': 63753,
'CJK COMPATIBILITY IDEOGRAPH-F90A': 63754,
'CJK COMPATIBILITY IDEOGRAPH-F90B': 63755,
'CJK COMPATIBILITY IDEOGRAPH-F90C': 63756,
'CJK COMPATIBILITY IDEOGRAPH-F90D': 63757,
'CJK COMPATIBILITY IDEOGRAPH-F90E': 63758,
'CJK COMPATIBILITY IDEOGRAPH-F90F': 63759,
'CJK COMPATIBILITY IDEOGRAPH-F910': 63760,
'CJK COMPATIBILITY IDEOGRAPH-F911': 63761,
'CJK COMPATIBILITY IDEOGRAPH-F912': 63762,
'CJK COMPATIBILITY IDEOGRAPH-F913': 63763,
'CJK COMPATIBILITY IDEOGRAPH-F914': 63764,
'CJK COMPATIBILITY IDEOGRAPH-F915': 63765,
'CJK COMPATIBILITY IDEOGRAPH-F916': 63766,
'CJK COMPATIBILITY IDEOGRAPH-F917': 63767,
'CJK COMPATIBILITY IDEOGRAPH-F918': 63768,
'CJK COMPATIBILITY IDEOGRAPH-F919': 63769,
'CJK COMPATIBILITY IDEOGRAPH-F91A': 63770,
'CJK COMPATIBILITY IDEOGRAPH-F91B': 63771,
'CJK COMPATIBILITY IDEOGRAPH-F91C': 63772,
'CJK COMPATIBILITY IDEOGRAPH-F91D': 63773,
'CJK COMPATIBILITY IDEOGRAPH-F91E': 63774,
'CJK COMPATIBILITY IDEOGRAPH-F91F': 63775,
'CJK COMPATIBILITY IDEOGRAPH-F920': 63776,
'CJK COMPATIBILITY IDEOGRAPH-F921': 63777,
'CJK COMPATIBILITY IDEOGRAPH-F922': 63778,
'CJK COMPATIBILITY IDEOGRAPH-F923': 63779,
'CJK COMPATIBILITY IDEOGRAPH-F924': 63780,
'CJK COMPATIBILITY IDEOGRAPH-F925': 63781,
'CJK COMPATIBILITY IDEOGRAPH-F926': 63782,
'CJK COMPATIBILITY IDEOGRAPH-F927': 63783,
'CJK COMPATIBILITY IDEOGRAPH-F928': 63784,
'CJK COMPATIBILITY IDEOGRAPH-F929': 63785,
'CJK COMPATIBILITY IDEOGRAPH-F92A': 63786,
'CJK COMPATIBILITY IDEOGRAPH-F92B': 63787,
'CJK COMPATIBILITY IDEOGRAPH-F92C': 63788,
'CJK COMPATIBILITY IDEOGRAPH-F92D': 63789,
'CJK COMPATIBILITY IDEOGRAPH-F92E': 63790,
'CJK COMPATIBILITY IDEOGRAPH-F92F': 63791,
'CJK COMPATIBILITY IDEOGRAPH-F930': 63792,
'CJK COMPATIBILITY IDEOGRAPH-F931': 63793,
'CJK COMPATIBILITY IDEOGRAPH-F932': 63794,
'CJK COMPATIBILITY IDEOGRAPH-F933': 63795,
'CJK COMPATIBILITY IDEOGRAPH-F934': 63796,
'CJK COMPATIBILITY IDEOGRAPH-F935': 63797,
'CJK COMPATIBILITY IDEOGRAPH-F936': 63798,
'CJK COMPATIBILITY IDEOGRAPH-F937': 63799,
'CJK COMPATIBILITY IDEOGRAPH-F938': 63800,
'CJK COMPATIBILITY IDEOGRAPH-F939': 63801,
'CJK COMPATIBILITY IDEOGRAPH-F93A': 63802,
'CJK COMPATIBILITY IDEOGRAPH-F93B': 63803,
'CJK COMPATIBILITY IDEOGRAPH-F93C': 63804,
'CJK COMPATIBILITY IDEOGRAPH-F93D': 63805,
'CJK COMPATIBILITY IDEOGRAPH-F93E': 63806,
'CJK COMPATIBILITY IDEOGRAPH-F93F': 63807,
'CJK COMPATIBILITY IDEOGRAPH-F940': 63808,
'CJK COMPATIBILITY IDEOGRAPH-F941': 63809,
'CJK COMPATIBILITY IDEOGRAPH-F942': 63810,
'CJK COMPATIBILITY IDEOGRAPH-F943': 63811,
'CJK COMPATIBILITY IDEOGRAPH-F944': 63812,
'CJK COMPATIBILITY IDEOGRAPH-F945': 63813,
'CJK COMPATIBILITY IDEOGRAPH-F946': 63814,
'CJK COMPATIBILITY IDEOGRAPH-F947': 63815,
'CJK COMPATIBILITY IDEOGRAPH-F948': 63816,
'CJK COMPATIBILITY IDEOGRAPH-F949': 63817,
'CJK COMPATIBILITY IDEOGRAPH-F94A': 63818,
'CJK COMPATIBILITY IDEOGRAPH-F94B': 63819,
'CJK COMPATIBILITY IDEOGRAPH-F94C': 63820,
'CJK COMPATIBILITY IDEOGRAPH-F94D': 63821,
'CJK COMPATIBILITY IDEOGRAPH-F94E': 63822,
'CJK COMPATIBILITY IDEOGRAPH-F94F': 63823,
'CJK COMPATIBILITY IDEOGRAPH-F950': 63824,
'CJK COMPATIBILITY IDEOGRAPH-F951': 63825,
'CJK COMPATIBILITY IDEOGRAPH-F952': 63826,
'CJK COMPATIBILITY IDEOGRAPH-F953': 63827,
'CJK COMPATIBILITY IDEOGRAPH-F954': 63828,
'CJK COMPATIBILITY IDEOGRAPH-F955': 63829,
'CJK COMPATIBILITY IDEOGRAPH-F956': 63830,
'CJK COMPATIBILITY IDEOGRAPH-F957': 63831,
'CJK COMPATIBILITY IDEOGRAPH-F958': 63832,
'CJK COMPATIBILITY IDEOGRAPH-F959': 63833,
'CJK COMPATIBILITY IDEOGRAPH-F95A': 63834,
'CJK COMPATIBILITY IDEOGRAPH-F95B': 63835,
'CJK COMPATIBILITY IDEOGRAPH-F95C': 63836,
'CJK COMPATIBILITY IDEOGRAPH-F95D': 63837,
'CJK COMPATIBILITY IDEOGRAPH-F95E': 63838,
'CJK COMPATIBILITY IDEOGRAPH-F95F': 63839,
'CJK COMPATIBILITY IDEOGRAPH-F960': 63840,
'CJK COMPATIBILITY IDEOGRAPH-F961': 63841,
'CJK COMPATIBILITY IDEOGRAPH-F962': 63842,
'CJK COMPATIBILITY IDEOGRAPH-F963': 63843,
'CJK COMPATIBILITY IDEOGRAPH-F964': 63844,
'CJK COMPATIBILITY IDEOGRAPH-F965': 63845,
'CJK COMPATIBILITY IDEOGRAPH-F966': 63846,
'CJK COMPATIBILITY IDEOGRAPH-F967': 63847,
'CJK COMPATIBILITY IDEOGRAPH-F968': 63848,
'CJK COMPATIBILITY IDEOGRAPH-F969': 63849,
'CJK COMPATIBILITY IDEOGRAPH-F96A': 63850,
'CJK COMPATIBILITY IDEOGRAPH-F96B': 63851,
'CJK COMPATIBILITY IDEOGRAPH-F96C': 63852,
'CJK COMPATIBILITY IDEOGRAPH-F96D': 63853,
'CJK COMPATIBILITY IDEOGRAPH-F96E': 63854,
'CJK COMPATIBILITY IDEOGRAPH-F96F': 63855,
'CJK COMPATIBILITY IDEOGRAPH-F970': 63856,
'CJK COMPATIBILITY IDEOGRAPH-F971': 63857,
'CJK COMPATIBILITY IDEOGRAPH-F972': 63858,
'CJK COMPATIBILITY IDEOGRAPH-F973': 63859,
'CJK COMPATIBILITY IDEOGRAPH-F974': 63860,
'CJK COMPATIBILITY IDEOGRAPH-F975': 63861,
'CJK COMPATIBILITY IDEOGRAPH-F976': 63862,
'CJK COMPATIBILITY IDEOGRAPH-F977': 63863,
'CJK COMPATIBILITY IDEOGRAPH-F978': 63864,
'CJK COMPATIBILITY IDEOGRAPH-F979': 63865,
'CJK COMPATIBILITY IDEOGRAPH-F97A': 63866,
'CJK COMPATIBILITY IDEOGRAPH-F97B': 63867,
'CJK COMPATIBILITY IDEOGRAPH-F97C': 63868,
'CJK COMPATIBILITY IDEOGRAPH-F97D': 63869,
'CJK COMPATIBILITY IDEOGRAPH-F97E': 63870,
'CJK COMPATIBILITY IDEOGRAPH-F97F': 63871,
'CJK COMPATIBILITY IDEOGRAPH-F980': 63872,
'CJK COMPATIBILITY IDEOGRAPH-F981': 63873,
'CJK COMPATIBILITY IDEOGRAPH-F982': 63874,
'CJK COMPATIBILITY IDEOGRAPH-F983': 63875,
'CJK COMPATIBILITY IDEOGRAPH-F984': 63876,
'CJK COMPATIBILITY IDEOGRAPH-F985': 63877,
'CJK COMPATIBILITY IDEOGRAPH-F986': 63878,
'CJK COMPATIBILITY IDEOGRAPH-F987': 63879,
'CJK COMPATIBILITY IDEOGRAPH-F988': 63880,
'CJK COMPATIBILITY IDEOGRAPH-F989': 63881,
'CJK COMPATIBILITY IDEOGRAPH-F98A': 63882,
'CJK COMPATIBILITY IDEOGRAPH-F98B': 63883,
'CJK COMPATIBILITY IDEOGRAPH-F98C': 63884,
'CJK COMPATIBILITY IDEOGRAPH-F98D': 63885,
'CJK COMPATIBILITY IDEOGRAPH-F98E': 63886,
'CJK COMPATIBILITY IDEOGRAPH-F98F': 63887,
'CJK COMPATIBILITY IDEOGRAPH-F990': 63888,
'CJK COMPATIBILITY IDEOGRAPH-F991': 63889,
'CJK COMPATIBILITY IDEOGRAPH-F992': 63890,
'CJK COMPATIBILITY IDEOGRAPH-F993': 63891,
'CJK COMPATIBILITY IDEOGRAPH-F994': 63892,
'CJK COMPATIBILITY IDEOGRAPH-F995': 63893,
'CJK COMPATIBILITY IDEOGRAPH-F996': 63894,
'CJK COMPATIBILITY IDEOGRAPH-F997': 63895,
'CJK COMPATIBILITY IDEOGRAPH-F998': 63896,
'CJK COMPATIBILITY IDEOGRAPH-F999': 63897,
'CJK COMPATIBILITY IDEOGRAPH-F99A': 63898,
'CJK COMPATIBILITY IDEOGRAPH-F99B': 63899,
'CJK COMPATIBILITY IDEOGRAPH-F99C': 63900,
'CJK COMPATIBILITY IDEOGRAPH-F99D': 63901,
'CJK COMPATIBILITY IDEOGRAPH-F99E': 63902,
'CJK COMPATIBILITY IDEOGRAPH-F99F': 63903,
'CJK COMPATIBILITY IDEOGRAPH-F9A0': 63904,
'CJK COMPATIBILITY IDEOGRAPH-F9A1': 63905,
'CJK COMPATIBILITY IDEOGRAPH-F9A2': 63906,
'CJK COMPATIBILITY IDEOGRAPH-F9A3': 63907,
'CJK COMPATIBILITY IDEOGRAPH-F9A4': 63908,
'CJK COMPATIBILITY IDEOGRAPH-F9A5': 63909,
'CJK COMPATIBILITY IDEOGRAPH-F9A6': 63910,
'CJK COMPATIBILITY IDEOGRAPH-F9A7': 63911,
'CJK COMPATIBILITY IDEOGRAPH-F9A8': 63912,
'CJK COMPATIBILITY IDEOGRAPH-F9A9': 63913,
'CJK COMPATIBILITY IDEOGRAPH-F9AA': 63914,
'CJK COMPATIBILITY IDEOGRAPH-F9AB': 63915,
'CJK COMPATIBILITY IDEOGRAPH-F9AC': 63916,
'CJK COMPATIBILITY IDEOGRAPH-F9AD': 63917,
'CJK COMPATIBILITY IDEOGRAPH-F9AE': 63918,
'CJK COMPATIBILITY IDEOGRAPH-F9AF': 63919,
'CJK COMPATIBILITY IDEOGRAPH-F9B0': 63920,
'CJK COMPATIBILITY IDEOGRAPH-F9B1': 63921,
'CJK COMPATIBILITY IDEOGRAPH-F9B2': 63922,
'CJK COMPATIBILITY IDEOGRAPH-F9B3': 63923,
'CJK COMPATIBILITY IDEOGRAPH-F9B4': 63924,
'CJK COMPATIBILITY IDEOGRAPH-F9B5': 63925,
'CJK COMPATIBILITY IDEOGRAPH-F9B6': 63926,
'CJK COMPATIBILITY IDEOGRAPH-F9B7': 63927,
'CJK COMPATIBILITY IDEOGRAPH-F9B8': 63928,
'CJK COMPATIBILITY IDEOGRAPH-F9B9': 63929,
'CJK COMPATIBILITY IDEOGRAPH-F9BA': 63930,
'CJK COMPATIBILITY IDEOGRAPH-F9BB': 63931,
'CJK COMPATIBILITY IDEOGRAPH-F9BC': 63932,
'CJK COMPATIBILITY IDEOGRAPH-F9BD': 63933,
'CJK COMPATIBILITY IDEOGRAPH-F9BE': 63934,
'CJK COMPATIBILITY IDEOGRAPH-F9BF': 63935,
'CJK COMPATIBILITY IDEOGRAPH-F9C0': 63936,
'CJK COMPATIBILITY IDEOGRAPH-F9C1': 63937,
'CJK COMPATIBILITY IDEOGRAPH-F9C2': 63938,
'CJK COMPATIBILITY IDEOGRAPH-F9C3': 63939,
'CJK COMPATIBILITY IDEOGRAPH-F9C4': 63940,
'CJK COMPATIBILITY IDEOGRAPH-F9C5': 63941,
'CJK COMPATIBILITY IDEOGRAPH-F9C6': 63942,
'CJK COMPATIBILITY IDEOGRAPH-F9C7': 63943,
'CJK COMPATIBILITY IDEOGRAPH-F9C8': 63944,
'CJK COMPATIBILITY IDEOGRAPH-F9C9': 63945,
'CJK COMPATIBILITY IDEOGRAPH-F9CA': 63946,
'CJK COMPATIBILITY IDEOGRAPH-F9CB': 63947,
'CJK COMPATIBILITY IDEOGRAPH-F9CC': 63948,
'CJK COMPATIBILITY IDEOGRAPH-F9CD': 63949,
'CJK COMPATIBILITY IDEOGRAPH-F9CE': 63950,
'CJK COMPATIBILITY IDEOGRAPH-F9CF': 63951,
'CJK COMPATIBILITY IDEOGRAPH-F9D0': 63952,
'CJK COMPATIBILITY IDEOGRAPH-F9D1': 63953,
'CJK COMPATIBILITY IDEOGRAPH-F9D2': 63954,
'CJK COMPATIBILITY IDEOGRAPH-F9D3': 63955,
'CJK COMPATIBILITY IDEOGRAPH-F9D4': 63956,
'CJK COMPATIBILITY IDEOGRAPH-F9D5': 63957,
'CJK COMPATIBILITY IDEOGRAPH-F9D6': 63958,
'CJK COMPATIBILITY IDEOGRAPH-F9D7': 63959,
'CJK COMPATIBILITY IDEOGRAPH-F9D8': 63960,
'CJK COMPATIBILITY IDEOGRAPH-F9D9': 63961,
'CJK COMPATIBILITY IDEOGRAPH-F9DA': 63962,
'CJK COMPATIBILITY IDEOGRAPH-F9DB': 63963,
'CJK COMPATIBILITY IDEOGRAPH-F9DC': 63964,
'CJK COMPATIBILITY IDEOGRAPH-F9DD': 63965,
'CJK COMPATIBILITY IDEOGRAPH-F9DE': 63966,
'CJK COMPATIBILITY IDEOGRAPH-F9DF': 63967,
'CJK COMPATIBILITY IDEOGRAPH-F9E0': 63968,
'CJK COMPATIBILITY IDEOGRAPH-F9E1': 63969,
'CJK COMPATIBILITY IDEOGRAPH-F9E2': 63970,
'CJK COMPATIBILITY IDEOGRAPH-F9E3': 63971,
'CJK COMPATIBILITY IDEOGRAPH-F9E4': 63972,
'CJK COMPATIBILITY IDEOGRAPH-F9E5': 63973,
'CJK COMPATIBILITY IDEOGRAPH-F9E6': 63974,
'CJK COMPATIBILITY IDEOGRAPH-F9E7': 63975,
'CJK COMPATIBILITY IDEOGRAPH-F9E8': 63976,
'CJK COMPATIBILITY IDEOGRAPH-F9E9': 63977,
'CJK COMPATIBILITY IDEOGRAPH-F9EA': 63978,
'CJK COMPATIBILITY IDEOGRAPH-F9EB': 63979,
'CJK COMPATIBILITY IDEOGRAPH-F9EC': 63980,
'CJK COMPATIBILITY IDEOGRAPH-F9ED': 63981,
'CJK COMPATIBILITY IDEOGRAPH-F9EE': 63982,
'CJK COMPATIBILITY IDEOGRAPH-F9EF': 63983,
'CJK COMPATIBILITY IDEOGRAPH-F9F0': 63984,
'CJK COMPATIBILITY IDEOGRAPH-F9F1': 63985,
'CJK COMPATIBILITY IDEOGRAPH-F9F2': 63986,
'CJK COMPATIBILITY IDEOGRAPH-F9F3': 63987,
'CJK COMPATIBILITY IDEOGRAPH-F9F4': 63988,
'CJK COMPATIBILITY IDEOGRAPH-F9F5': 63989,
'CJK COMPATIBILITY IDEOGRAPH-F9F6': 63990,
'CJK COMPATIBILITY IDEOGRAPH-F9F7': 63991,
'CJK COMPATIBILITY IDEOGRAPH-F9F8': 63992,
'CJK COMPATIBILITY IDEOGRAPH-F9F9': 63993,
'CJK COMPATIBILITY IDEOGRAPH-F9FA': 63994,
'CJK COMPATIBILITY IDEOGRAPH-F9FB': 63995,
'CJK COMPATIBILITY IDEOGRAPH-F9FC': 63996,
'CJK COMPATIBILITY IDEOGRAPH-F9FD': 63997,
'CJK COMPATIBILITY IDEOGRAPH-F9FE': 63998,
'CJK COMPATIBILITY IDEOGRAPH-F9FF': 63999,
'CJK COMPATIBILITY IDEOGRAPH-FA00': 64000,
'CJK COMPATIBILITY IDEOGRAPH-FA01': 64001,
'CJK COMPATIBILITY IDEOGRAPH-FA02': 64002,
'CJK COMPATIBILITY IDEOGRAPH-FA03': 64003,
'CJK COMPATIBILITY IDEOGRAPH-FA04': 64004,
'CJK COMPATIBILITY IDEOGRAPH-FA05': 64005,
'CJK COMPATIBILITY IDEOGRAPH-FA06': 64006,
'CJK COMPATIBILITY IDEOGRAPH-FA07': 64007,
'CJK COMPATIBILITY IDEOGRAPH-FA08': 64008,
'CJK COMPATIBILITY IDEOGRAPH-FA09': 64009,
'CJK COMPATIBILITY IDEOGRAPH-FA0A': 64010,
'CJK COMPATIBILITY IDEOGRAPH-FA0B': 64011,
'CJK COMPATIBILITY IDEOGRAPH-FA0C': 64012,
'CJK COMPATIBILITY IDEOGRAPH-FA0D': 64013,
'CJK COMPATIBILITY IDEOGRAPH-FA0E': 64014,
'CJK COMPATIBILITY IDEOGRAPH-FA0F': 64015,
'CJK COMPATIBILITY IDEOGRAPH-FA10': 64016,
'CJK COMPATIBILITY IDEOGRAPH-FA11': 64017,
'CJK COMPATIBILITY IDEOGRAPH-FA12': 64018,
'CJK COMPATIBILITY IDEOGRAPH-FA13': 64019,
'CJK COMPATIBILITY IDEOGRAPH-FA14': 64020,
'CJK COMPATIBILITY IDEOGRAPH-FA15': 64021,
'CJK COMPATIBILITY IDEOGRAPH-FA16': 64022,
'CJK COMPATIBILITY IDEOGRAPH-FA17': 64023,
'CJK COMPATIBILITY IDEOGRAPH-FA18': 64024,
'CJK COMPATIBILITY IDEOGRAPH-FA19': 64025,
'CJK COMPATIBILITY IDEOGRAPH-FA1A': 64026,
'CJK COMPATIBILITY IDEOGRAPH-FA1B': 64027,
'CJK COMPATIBILITY IDEOGRAPH-FA1C': 64028,
'CJK COMPATIBILITY IDEOGRAPH-FA1D': 64029,
'CJK COMPATIBILITY IDEOGRAPH-FA1E': 64030,
'CJK COMPATIBILITY IDEOGRAPH-FA1F': 64031,
'CJK COMPATIBILITY IDEOGRAPH-FA20': 64032,
'CJK COMPATIBILITY IDEOGRAPH-FA21': 64033,
'CJK COMPATIBILITY IDEOGRAPH-FA22': 64034,
'CJK COMPATIBILITY IDEOGRAPH-FA23': 64035,
'CJK COMPATIBILITY IDEOGRAPH-FA24': 64036,
'CJK COMPATIBILITY IDEOGRAPH-FA25': 64037,
'CJK COMPATIBILITY IDEOGRAPH-FA26': 64038,
'CJK COMPATIBILITY IDEOGRAPH-FA27': 64039,
'CJK COMPATIBILITY IDEOGRAPH-FA28': 64040,
'CJK COMPATIBILITY IDEOGRAPH-FA29': 64041,
'CJK COMPATIBILITY IDEOGRAPH-FA2A': 64042,
'CJK COMPATIBILITY IDEOGRAPH-FA2B': 64043,
'CJK COMPATIBILITY IDEOGRAPH-FA2C': 64044,
'CJK COMPATIBILITY IDEOGRAPH-FA2D': 64045,
'CJK COMPATIBILITY IDEOGRAPH-FA30': 64048,
'CJK COMPATIBILITY IDEOGRAPH-FA31': 64049,
'CJK COMPATIBILITY IDEOGRAPH-FA32': 64050,
'CJK COMPATIBILITY IDEOGRAPH-FA33': 64051,
'CJK COMPATIBILITY IDEOGRAPH-FA34': 64052,
'CJK COMPATIBILITY IDEOGRAPH-FA35': 64053,
'CJK COMPATIBILITY IDEOGRAPH-FA36': 64054,
'CJK COMPATIBILITY IDEOGRAPH-FA37': 64055,
'CJK COMPATIBILITY IDEOGRAPH-FA38': 64056,
'CJK COMPATIBILITY IDEOGRAPH-FA39': 64057,
'CJK COMPATIBILITY IDEOGRAPH-FA3A': 64058,
'CJK COMPATIBILITY IDEOGRAPH-FA3B': 64059,
'CJK COMPATIBILITY IDEOGRAPH-FA3C': 64060,
'CJK COMPATIBILITY IDEOGRAPH-FA3D': 64061,
'CJK COMPATIBILITY IDEOGRAPH-FA3E': 64062,
'CJK COMPATIBILITY IDEOGRAPH-FA3F': 64063,
'CJK COMPATIBILITY IDEOGRAPH-FA40': 64064,
'CJK COMPATIBILITY IDEOGRAPH-FA41': 64065,
'CJK COMPATIBILITY IDEOGRAPH-FA42': 64066,
'CJK COMPATIBILITY IDEOGRAPH-FA43': 64067,
'CJK COMPATIBILITY IDEOGRAPH-FA44': 64068,
'CJK COMPATIBILITY IDEOGRAPH-FA45': 64069,
'CJK COMPATIBILITY IDEOGRAPH-FA46': 64070,
'CJK COMPATIBILITY IDEOGRAPH-FA47': 64071,
'CJK COMPATIBILITY IDEOGRAPH-FA48': 64072,
'CJK COMPATIBILITY IDEOGRAPH-FA49': 64073,
'CJK COMPATIBILITY IDEOGRAPH-FA4A': 64074,
'CJK COMPATIBILITY IDEOGRAPH-FA4B': 64075,
'CJK COMPATIBILITY IDEOGRAPH-FA4C': 64076,
'CJK COMPATIBILITY IDEOGRAPH-FA4D': 64077,
'CJK COMPATIBILITY IDEOGRAPH-FA4E': 64078,
'CJK COMPATIBILITY IDEOGRAPH-FA4F': 64079,
'CJK COMPATIBILITY IDEOGRAPH-FA50': 64080,
'CJK COMPATIBILITY IDEOGRAPH-FA51': 64081,
'CJK COMPATIBILITY IDEOGRAPH-FA52': 64082,
'CJK COMPATIBILITY IDEOGRAPH-FA53': 64083,
'CJK COMPATIBILITY IDEOGRAPH-FA54': 64084,
'CJK COMPATIBILITY IDEOGRAPH-FA55': 64085,
'CJK COMPATIBILITY IDEOGRAPH-FA56': 64086,
'CJK COMPATIBILITY IDEOGRAPH-FA57': 64087,
'CJK COMPATIBILITY IDEOGRAPH-FA58': 64088,
'CJK COMPATIBILITY IDEOGRAPH-FA59': 64089,
'CJK COMPATIBILITY IDEOGRAPH-FA5A': 64090,
'CJK COMPATIBILITY IDEOGRAPH-FA5B': 64091,
'CJK COMPATIBILITY IDEOGRAPH-FA5C': 64092,
'CJK COMPATIBILITY IDEOGRAPH-FA5D': 64093,
'CJK COMPATIBILITY IDEOGRAPH-FA5E': 64094,
'CJK COMPATIBILITY IDEOGRAPH-FA5F': 64095,
'CJK COMPATIBILITY IDEOGRAPH-FA60': 64096,
'CJK COMPATIBILITY IDEOGRAPH-FA61': 64097,
'CJK COMPATIBILITY IDEOGRAPH-FA62': 64098,
'CJK COMPATIBILITY IDEOGRAPH-FA63': 64099,
'CJK COMPATIBILITY IDEOGRAPH-FA64': 64100,
'CJK COMPATIBILITY IDEOGRAPH-FA65': 64101,
'CJK COMPATIBILITY IDEOGRAPH-FA66': 64102,
'CJK COMPATIBILITY IDEOGRAPH-FA67': 64103,
'CJK COMPATIBILITY IDEOGRAPH-FA68': 64104,
'CJK COMPATIBILITY IDEOGRAPH-FA69': 64105,
'CJK COMPATIBILITY IDEOGRAPH-FA6A': 64106,
'CJK COMPATIBILITY IDEOGRAPH-FA70': 64112,
'CJK COMPATIBILITY IDEOGRAPH-FA71': 64113,
'CJK COMPATIBILITY IDEOGRAPH-FA72': 64114,
'CJK COMPATIBILITY IDEOGRAPH-FA73': 64115,
'CJK COMPATIBILITY IDEOGRAPH-FA74': 64116,
'CJK COMPATIBILITY IDEOGRAPH-FA75': 64117,
'CJK COMPATIBILITY IDEOGRAPH-FA76': 64118,
'CJK COMPATIBILITY IDEOGRAPH-FA77': 64119,
'CJK COMPATIBILITY IDEOGRAPH-FA78': 64120,
'CJK COMPATIBILITY IDEOGRAPH-FA79': 64121,
'CJK COMPATIBILITY IDEOGRAPH-FA7A': 64122,
'CJK COMPATIBILITY IDEOGRAPH-FA7B': 64123,
'CJK COMPATIBILITY IDEOGRAPH-FA7C': 64124,
'CJK COMPATIBILITY IDEOGRAPH-FA7D': 64125,
'CJK COMPATIBILITY IDEOGRAPH-FA7E': 64126,
'CJK COMPATIBILITY IDEOGRAPH-FA7F': 64127,
'CJK COMPATIBILITY IDEOGRAPH-FA80': 64128,
'CJK COMPATIBILITY IDEOGRAPH-FA81': 64129,
'CJK COMPATIBILITY IDEOGRAPH-FA82': 64130,
'CJK COMPATIBILITY IDEOGRAPH-FA83': 64131,
'CJK COMPATIBILITY IDEOGRAPH-FA84': 64132,
'CJK COMPATIBILITY IDEOGRAPH-FA85': 64133,
'CJK COMPATIBILITY IDEOGRAPH-FA86': 64134,
'CJK COMPATIBILITY IDEOGRAPH-FA87': 64135,
'CJK COMPATIBILITY IDEOGRAPH-FA88': 64136,
'CJK COMPATIBILITY IDEOGRAPH-FA89': 64137,
'CJK COMPATIBILITY IDEOGRAPH-FA8A': 64138,
'CJK COMPATIBILITY IDEOGRAPH-FA8B': 64139,
'CJK COMPATIBILITY IDEOGRAPH-FA8C': 64140,
'CJK COMPATIBILITY IDEOGRAPH-FA8D': 64141,
'CJK COMPATIBILITY IDEOGRAPH-FA8E': 64142,
'CJK COMPATIBILITY IDEOGRAPH-FA8F': 64143,
'CJK COMPATIBILITY IDEOGRAPH-FA90': 64144,
'CJK COMPATIBILITY IDEOGRAPH-FA91': 64145,
'CJK COMPATIBILITY IDEOGRAPH-FA92': 64146,
'CJK COMPATIBILITY IDEOGRAPH-FA93': 64147,
'CJK COMPATIBILITY IDEOGRAPH-FA94': 64148,
'CJK COMPATIBILITY IDEOGRAPH-FA95': 64149,
'CJK COMPATIBILITY IDEOGRAPH-FA96': 64150,
'CJK COMPATIBILITY IDEOGRAPH-FA97': 64151,
'CJK COMPATIBILITY IDEOGRAPH-FA98': 64152,
'CJK COMPATIBILITY IDEOGRAPH-FA99': 64153,
'CJK COMPATIBILITY IDEOGRAPH-FA9A': 64154,
'CJK COMPATIBILITY IDEOGRAPH-FA9B': 64155,
'CJK COMPATIBILITY IDEOGRAPH-FA9C': 64156,
'CJK COMPATIBILITY IDEOGRAPH-FA9D': 64157,
'CJK COMPATIBILITY IDEOGRAPH-FA9E': 64158,
'CJK COMPATIBILITY IDEOGRAPH-FA9F': 64159,
'CJK COMPATIBILITY IDEOGRAPH-FAA0': 64160,
'CJK COMPATIBILITY IDEOGRAPH-FAA1': 64161,
'CJK COMPATIBILITY IDEOGRAPH-FAA2': 64162,
'CJK COMPATIBILITY IDEOGRAPH-FAA3': 64163,
'CJK COMPATIBILITY IDEOGRAPH-FAA4': 64164,
'CJK COMPATIBILITY IDEOGRAPH-FAA5': 64165,
'CJK COMPATIBILITY IDEOGRAPH-FAA6': 64166,
'CJK COMPATIBILITY IDEOGRAPH-FAA7': 64167,
'CJK COMPATIBILITY IDEOGRAPH-FAA8': 64168,
'CJK COMPATIBILITY IDEOGRAPH-FAA9': 64169,
'CJK COMPATIBILITY IDEOGRAPH-FAAA': 64170,
'CJK COMPATIBILITY IDEOGRAPH-FAAB': 64171,
'CJK COMPATIBILITY IDEOGRAPH-FAAC': 64172,
'CJK COMPATIBILITY IDEOGRAPH-FAAD': 64173,
'CJK COMPATIBILITY IDEOGRAPH-FAAE': 64174,
'CJK COMPATIBILITY IDEOGRAPH-FAAF': 64175,
'CJK COMPATIBILITY IDEOGRAPH-FAB0': 64176,
'CJK COMPATIBILITY IDEOGRAPH-FAB1': 64177,
'CJK COMPATIBILITY IDEOGRAPH-FAB2': 64178,
'CJK COMPATIBILITY IDEOGRAPH-FAB3': 64179,
'CJK COMPATIBILITY IDEOGRAPH-FAB4': 64180,
'CJK COMPATIBILITY IDEOGRAPH-FAB5': 64181,
'CJK COMPATIBILITY IDEOGRAPH-FAB6': 64182,
'CJK COMPATIBILITY IDEOGRAPH-FAB7': 64183,
'CJK COMPATIBILITY IDEOGRAPH-FAB8': 64184,
'CJK COMPATIBILITY IDEOGRAPH-FAB9': 64185,
'CJK COMPATIBILITY IDEOGRAPH-FABA': 64186,
'CJK COMPATIBILITY IDEOGRAPH-FABB': 64187,
'CJK COMPATIBILITY IDEOGRAPH-FABC': 64188,
'CJK COMPATIBILITY IDEOGRAPH-FABD': 64189,
'CJK COMPATIBILITY IDEOGRAPH-FABE': 64190,
'CJK COMPATIBILITY IDEOGRAPH-FABF': 64191,
'CJK COMPATIBILITY IDEOGRAPH-FAC0': 64192,
'CJK COMPATIBILITY IDEOGRAPH-FAC1': 64193,
'CJK COMPATIBILITY IDEOGRAPH-FAC2': 64194,
'CJK COMPATIBILITY IDEOGRAPH-FAC3': 64195,
'CJK COMPATIBILITY IDEOGRAPH-FAC4': 64196,
'CJK COMPATIBILITY IDEOGRAPH-FAC5': 64197,
'CJK COMPATIBILITY IDEOGRAPH-FAC6': 64198,
'CJK COMPATIBILITY IDEOGRAPH-FAC7': 64199,
'CJK COMPATIBILITY IDEOGRAPH-FAC8': 64200,
'CJK COMPATIBILITY IDEOGRAPH-FAC9': 64201,
'CJK COMPATIBILITY IDEOGRAPH-FACA': 64202,
'CJK COMPATIBILITY IDEOGRAPH-FACB': 64203,
'CJK COMPATIBILITY IDEOGRAPH-FACC': 64204,
'CJK COMPATIBILITY IDEOGRAPH-FACD': 64205,
'CJK COMPATIBILITY IDEOGRAPH-FACE': 64206,
'CJK COMPATIBILITY IDEOGRAPH-FACF': 64207,
'CJK COMPATIBILITY IDEOGRAPH-FAD0': 64208,
'CJK COMPATIBILITY IDEOGRAPH-FAD1': 64209,
'CJK COMPATIBILITY IDEOGRAPH-FAD2': 64210,
'CJK COMPATIBILITY IDEOGRAPH-FAD3': 64211,
'CJK COMPATIBILITY IDEOGRAPH-FAD4': 64212,
'CJK COMPATIBILITY IDEOGRAPH-FAD5': 64213,
'CJK COMPATIBILITY IDEOGRAPH-FAD6': 64214,
'CJK COMPATIBILITY IDEOGRAPH-FAD7': 64215,
'CJK COMPATIBILITY IDEOGRAPH-FAD8': 64216,
'CJK COMPATIBILITY IDEOGRAPH-FAD9': 64217,
'CJK RADICAL BAMBOO': 11950,
'CJK RADICAL BLUE': 11992,
'CJK RADICAL BOLT OF CLOTH': 11946,
'CJK RADICAL BONE': 12003,
'CJK RADICAL BOX': 11910,
'CJK RADICAL BRUSH ONE': 11962,
'CJK RADICAL BRUSH TWO': 11963,
'CJK RADICAL C-SIMPLIFIED BIRD': 12006,
'CJK RADICAL C-SIMPLIFIED CART': 11979,
'CJK RADICAL C-SIMPLIFIED DRAGON': 12016,
'CJK RADICAL C-SIMPLIFIED EAT': 12000,
'CJK RADICAL C-SIMPLIFIED EVEN': 12012,
'CJK RADICAL C-SIMPLIFIED FISH': 12005,
'CJK RADICAL C-SIMPLIFIED FLY': 11996,
'CJK RADICAL C-SIMPLIFIED FROG': 12010,
'CJK RADICAL C-SIMPLIFIED GATE': 11988,
'CJK RADICAL C-SIMPLIFIED GOLD': 11984,
'CJK RADICAL C-SIMPLIFIED HORSE': 12002,
'CJK RADICAL C-SIMPLIFIED LEAF': 11994,
'CJK RADICAL C-SIMPLIFIED LONG': 11987,
'CJK RADICAL C-SIMPLIFIED SALT': 12007,
'CJK RADICAL C-SIMPLIFIED SEE': 11973,
'CJK RADICAL C-SIMPLIFIED SHELL': 11977,
'CJK RADICAL C-SIMPLIFIED SILK': 11952,
'CJK RADICAL C-SIMPLIFIED SPEECH': 11976,
'CJK RADICAL C-SIMPLIFIED TANNED LEATHER': 11993,
'CJK RADICAL C-SIMPLIFIED TOOTH': 12014,
'CJK RADICAL C-SIMPLIFIED TURTLE': 12019,
'CJK RADICAL C-SIMPLIFIED WIND': 11995,
'CJK RADICAL CHOKE': 11931,
'CJK RADICAL CITY': 11983,
'CJK RADICAL CIVILIAN': 11936,
'CJK RADICAL CLIFF': 11905,
'CJK RADICAL CLOTHES': 11970,
'CJK RADICAL COW': 11943,
'CJK RADICAL DEATH': 11934,
'CJK RADICAL DIVINATION': 11914,
'CJK RADICAL DOG': 11944,
'CJK RADICAL EAT ONE': 11997,
'CJK RADICAL EAT THREE': 11999,
'CJK RADICAL EAT TWO': 11998,
'CJK RADICAL EWE': 11960,
'CJK RADICAL EYE': 11947,
'CJK RADICAL FIRE': 11939,
'CJK RADICAL FOOT': 11978,
'CJK RADICAL GHOST': 12004,
'CJK RADICAL GRASS ONE': 11966,
'CJK RADICAL GRASS THREE': 11968,
'CJK RADICAL GRASS TWO': 11967,
'CJK RADICAL HAND': 11928,
'CJK RADICAL HEAD': 12001,
'CJK RADICAL HEART ONE': 11926,
'CJK RADICAL HEART TWO': 11927,
'CJK RADICAL HORN': 11975,
'CJK RADICAL J-SIMPLIFIED DRAGON': 12015,
'CJK RADICAL J-SIMPLIFIED EVEN': 12011,
'CJK RADICAL J-SIMPLIFIED TOOTH': 12013,
'CJK RADICAL J-SIMPLIFIED TURTLE': 12018,
'CJK RADICAL JADE': 11945,
'CJK RADICAL KNIFE ONE': 11912,
'CJK RADICAL KNIFE TWO': 11913,
'CJK RADICAL LAME FOUR': 11921,
'CJK RADICAL LAME ONE': 11918,
'CJK RADICAL LAME THREE': 11920,
'CJK RADICAL LAME TWO': 11919,
'CJK RADICAL LONG ONE': 11985,
'CJK RADICAL LONG TWO': 11986,
'CJK RADICAL MEAT': 11964,
'CJK RADICAL MESH': 11957,
'CJK RADICAL MOON': 11933,
'CJK RADICAL MORTAR': 11965,
'CJK RADICAL MOTHER': 11935,
'CJK RADICAL MOUND ONE': 11989,
'CJK RADICAL MOUND TWO': 11990,
'CJK RADICAL NET FOUR': 11956,
'CJK RADICAL NET ONE': 11953,
'CJK RADICAL NET THREE': 11955,
'CJK RADICAL NET TWO': 11954,
'CJK RADICAL OLD': 11961,
'CJK RADICAL PAW ONE': 11940,
'CJK RADICAL PAW TWO': 11941,
'CJK RADICAL PERSON': 11909,
'CJK RADICAL RAIN': 11991,
'CJK RADICAL RAM': 11959,
'CJK RADICAL RAP': 11929,
'CJK RADICAL REPEAT': 11904,
'CJK RADICAL SEAL': 11915,
'CJK RADICAL SECOND ONE': 11906,
'CJK RADICAL SECOND THREE': 11908,
'CJK RADICAL SECOND TWO': 11907,
'CJK RADICAL SHEEP': 11958,
'CJK RADICAL SILK': 11951,
'CJK RADICAL SIMPLIFIED HALF TREE TRUNK': 11942,
'CJK RADICAL SIMPLIFIED HORN': 11974,
'CJK RADICAL SIMPLIFIED WALK': 11980,
'CJK RADICAL SIMPLIFIED WHEAT': 12008,
'CJK RADICAL SIMPLIFIED YELLOW': 12009,
'CJK RADICAL SMALL ONE': 11916,
'CJK RADICAL SMALL TWO': 11917,
'CJK RADICAL SNAKE': 11922,
'CJK RADICAL SNOUT ONE': 11924,
'CJK RADICAL SNOUT TWO': 11925,
'CJK RADICAL SPIRIT ONE': 11948,
'CJK RADICAL SPIRIT TWO': 11949,
'CJK RADICAL SUN': 11932,
'CJK RADICAL TABLE': 11911,
'CJK RADICAL THREAD': 11923,
'CJK RADICAL TIGER': 11969,
'CJK RADICAL TURTLE': 12017,
'CJK RADICAL WALK ONE': 11981,
'CJK RADICAL WALK TWO': 11982,
'CJK RADICAL WATER ONE': 11937,
'CJK RADICAL WATER TWO': 11938,
'CJK RADICAL WEST ONE': 11971,
'CJK RADICAL WEST TWO': 11972,
'CJK STROKE BXG': 12739,
'CJK STROKE HP': 12743,
'CJK STROKE HPWG': 12748,
'CJK STROKE HZG': 12742,
'CJK STROKE HZT': 12746,
'CJK STROKE HZW': 12749,
'CJK STROKE HZWG': 12744,
'CJK STROKE HZZ': 12741,
'CJK STROKE HZZP': 12747,
'CJK STROKE HZZZ': 12750,
'CJK STROKE N': 12751,
'CJK STROKE SW': 12740,
'CJK STROKE SZWG': 12745,
'CJK STROKE T': 12736,
'CJK STROKE WG': 12737,
'CJK STROKE XG': 12738,
'CLEAR SCREEN SYMBOL': 9114,
'CLOCKWISE CLOSED CIRCLE ARROW': 10561,
'CLOCKWISE CONTOUR INTEGRAL': 8754,
'CLOCKWISE GAPPED CIRCLE ARROW': 10227,
'CLOCKWISE INTEGRAL': 8753,
'CLOCKWISE OPEN CIRCLE ARROW': 8635,
'CLOCKWISE TOP SEMICIRCLE ARROW': 8631,
'CLOSE UP': 8272,
'CLOSED INTERSECTION WITH SERIFS': 10829,
'CLOSED SUBSET': 10959,
'CLOSED SUBSET OR EQUAL TO': 10961,
'CLOSED SUPERSET': 10960,
'CLOSED SUPERSET OR EQUAL TO': 10962,
'CLOSED UNION WITH SERIFS': 10828,
'CLOSED UNION WITH SERIFS AND SMASH PRODUCT': 10832,
'CLOUD': 9729,
'COFFIN': 9904,
'COLON': 58,
'COLON EQUALS': 8788,
'COLON SIGN': 8353,
'COMBINING ACUTE ACCENT': 769,
'COMBINING ACUTE ACCENT BELOW': 791,
'COMBINING ACUTE TONE MARK': 833,
'COMBINING ALMOST EQUAL TO ABOVE': 844,
'COMBINING ANNUITY SYMBOL': 8423,
'COMBINING ANTICLOCKWISE ARROW ABOVE': 8404,
'COMBINING ANTICLOCKWISE RING OVERLAY': 8410,
'COMBINING ASTERISK BELOW': 857,
'COMBINING BREVE': 774,
'COMBINING BREVE BELOW': 814,
'COMBINING BRIDGE ABOVE': 838,
'COMBINING BRIDGE BELOW': 810,
'COMBINING CANDRABINDU': 784,
'COMBINING CARON': 780,
'COMBINING CARON BELOW': 812,
'COMBINING CEDILLA': 807,
'COMBINING CIRCUMFLEX ACCENT': 770,
'COMBINING CIRCUMFLEX ACCENT BELOW': 813,
'COMBINING CLOCKWISE ARROW ABOVE': 8405,
'COMBINING CLOCKWISE RING OVERLAY': 8409,
'COMBINING COMMA ABOVE': 787,
'COMBINING COMMA ABOVE RIGHT': 789,
'COMBINING COMMA BELOW': 806,
'COMBINING CYRILLIC DASIA PNEUMATA': 1157,
'COMBINING CYRILLIC HUNDRED THOUSANDS SIGN': 1160,
'COMBINING CYRILLIC MILLIONS SIGN': 1161,
'COMBINING CYRILLIC PALATALIZATION': 1156,
'COMBINING CYRILLIC PSILI PNEUMATA': 1158,
'COMBINING CYRILLIC TITLO': 1155,
'COMBINING DIAERESIS': 776,
'COMBINING DIAERESIS BELOW': 804,
'COMBINING DOT ABOVE': 775,
'COMBINING DOT ABOVE RIGHT': 856,
'COMBINING DOT BELOW': 803,
'COMBINING DOTTED ACUTE ACCENT': 7617,
'COMBINING DOTTED GRAVE ACCENT': 7616,
'COMBINING DOUBLE ACUTE ACCENT': 779,
'COMBINING DOUBLE BREVE': 861,
'COMBINING DOUBLE BREVE BELOW': 860,
'COMBINING DOUBLE GRAVE ACCENT': 783,
'COMBINING DOUBLE INVERTED BREVE': 865,
'COMBINING DOUBLE LOW LINE': 819,
'COMBINING DOUBLE MACRON': 862,
'COMBINING DOUBLE MACRON BELOW': 863,
'COMBINING DOUBLE OVERLINE': 831,
'COMBINING DOUBLE RIGHTWARDS ARROW BELOW': 866,
'COMBINING DOUBLE RING BELOW': 858,
'COMBINING DOUBLE TILDE': 864,
'COMBINING DOUBLE TILDE LEFT HALF': 65058,
'COMBINING DOUBLE TILDE RIGHT HALF': 65059,
'COMBINING DOUBLE VERTICAL LINE ABOVE': 782,
'COMBINING DOUBLE VERTICAL LINE BELOW': 840,
'COMBINING DOUBLE VERTICAL STROKE OVERLAY': 8422,
'COMBINING DOWN TACK BELOW': 798,
'COMBINING ENCLOSING CIRCLE': 8413,
'COMBINING ENCLOSING CIRCLE BACKSLASH': 8416,
'COMBINING ENCLOSING DIAMOND': 8415,
'COMBINING ENCLOSING KEYCAP': 8419,
'COMBINING ENCLOSING SCREEN': 8418,
'COMBINING ENCLOSING SQUARE': 8414,
'COMBINING ENCLOSING UPWARD POINTING TRIANGLE': 8420,
'COMBINING EQUALS SIGN BELOW': 839,
'COMBINING FERMATA': 850,
'COMBINING FOUR DOTS ABOVE': 8412,
'COMBINING GRAPHEME JOINER': 847,
'COMBINING GRAVE ACCENT': 768,
'COMBINING GRAVE ACCENT BELOW': 790,
'COMBINING GRAVE TONE MARK': 832,
'COMBINING GREEK DIALYTIKA TONOS': 836,
'COMBINING GREEK KORONIS': 835,
'COMBINING GREEK MUSICAL PENTASEME': 119364,
'COMBINING GREEK MUSICAL TETRASEME': 119363,
'COMBINING GREEK MUSICAL TRISEME': 119362,
'COMBINING GREEK PERISPOMENI': 834,
'COMBINING GREEK YPOGEGRAMMENI': 837,
'COMBINING HOMOTHETIC ABOVE': 843,
'COMBINING HOOK ABOVE': 777,
'COMBINING HORN': 795,
'COMBINING INVERTED BREVE': 785,
'COMBINING INVERTED BREVE BELOW': 815,
'COMBINING INVERTED BRIDGE BELOW': 826,
'COMBINING INVERTED DOUBLE ARCH BELOW': 811,
'COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK': 12442,
'COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK': 12441,
'COMBINING LATIN SMALL LETTER A': 867,
'COMBINING LATIN SMALL LETTER C': 872,
'COMBINING LATIN SMALL LETTER D': 873,
'COMBINING LATIN SMALL LETTER E': 868,
'COMBINING LATIN SMALL LETTER H': 874,
'COMBINING LATIN SMALL LETTER I': 869,
'COMBINING LATIN SMALL LETTER M': 875,
'COMBINING LATIN SMALL LETTER O': 870,
'COMBINING LATIN SMALL LETTER R': 876,
'COMBINING LATIN SMALL LETTER T': 877,
'COMBINING LATIN SMALL LETTER U': 871,
'COMBINING LATIN SMALL LETTER V': 878,
'COMBINING LATIN SMALL LETTER X': 879,
'COMBINING LEFT ANGLE ABOVE': 794,
'COMBINING LEFT ANGLE BELOW': 841,
'COMBINING LEFT ARROW ABOVE': 8406,
'COMBINING LEFT ARROWHEAD BELOW': 852,
'COMBINING LEFT HALF RING ABOVE': 849,
'COMBINING LEFT HALF RING BELOW': 796,
'COMBINING LEFT HARPOON ABOVE': 8400,
'COMBINING LEFT RIGHT ARROW ABOVE': 8417,
'COMBINING LEFT RIGHT ARROW BELOW': 845,
'COMBINING LEFT TACK BELOW': 792,
'COMBINING LEFTWARDS ARROW OVERLAY': 8426,
'COMBINING LIGATURE LEFT HALF': 65056,
'COMBINING LIGATURE RIGHT HALF': 65057,
'COMBINING LONG DOUBLE SOLIDUS OVERLAY': 8427,
'COMBINING LONG SOLIDUS OVERLAY': 824,
'COMBINING LONG STROKE OVERLAY': 822,
'COMBINING LONG VERTICAL LINE OVERLAY': 8402,
'COMBINING LOW LINE': 818,
'COMBINING MACRON': 772,
'COMBINING MACRON BELOW': 817,
'COMBINING MINUS SIGN BELOW': 800,
'COMBINING NOT TILDE ABOVE': 842,
'COMBINING OGONEK': 808,
'COMBINING OVERLINE': 773,
'COMBINING PALATALIZED HOOK BELOW': 801,
'COMBINING PLUS SIGN BELOW': 799,
'COMBINING RETROFLEX HOOK BELOW': 802,
'COMBINING REVERSE SOLIDUS OVERLAY': 8421,
'COMBINING REVERSED COMMA ABOVE': 788,
'COMBINING RIGHT ARROW ABOVE': 8407,
'COMBINING RIGHT ARROWHEAD ABOVE': 848,
'COMBINING RIGHT ARROWHEAD AND UP ARROWHEAD BELOW': 854,
'COMBINING RIGHT ARROWHEAD BELOW': 853,
'COMBINING RIGHT HALF RING ABOVE': 855,
'COMBINING RIGHT HALF RING BELOW': 825,
'COMBINING RIGHT HARPOON ABOVE': 8401,
'COMBINING RIGHT TACK BELOW': 793,
'COMBINING RING ABOVE': 778,
'COMBINING RING BELOW': 805,
'COMBINING RING OVERLAY': 8408,
'COMBINING SEAGULL BELOW': 828,
'COMBINING SHORT SOLIDUS OVERLAY': 823,
'COMBINING SHORT STROKE OVERLAY': 821,
'COMBINING SHORT VERTICAL LINE OVERLAY': 8403,
'COMBINING SNAKE BELOW': 7618,
'COMBINING SQUARE BELOW': 827,
'COMBINING SUSPENSION MARK': 7619,
'COMBINING THREE DOTS ABOVE': 8411,
'COMBINING TILDE': 771,
'COMBINING TILDE BELOW': 816,
'COMBINING TILDE OVERLAY': 820,
'COMBINING TRIPLE UNDERDOT': 8424,
'COMBINING TURNED COMMA ABOVE': 786,
'COMBINING UP TACK BELOW': 797,
'COMBINING UPWARDS ARROW BELOW': 846,
'COMBINING VERTICAL LINE ABOVE': 781,
'COMBINING VERTICAL LINE BELOW': 809,
'COMBINING VERTICAL TILDE': 830,
'COMBINING WIDE BRIDGE ABOVE': 8425,
'COMBINING X ABOVE': 829,
'COMBINING X BELOW': 851,
'COMBINING ZIGZAG ABOVE': 859,
'COMET': 9732,
'COMMA': 44,
'COMMERCIAL AT': 64,
'COMMERCIAL MINUS SIGN': 8274,
'COMPLEMENT': 8705,
'COMPOSITION SYMBOL': 9092,
'CONGRUENT WITH DOT ABOVE': 10861,
'CONICAL TAPER': 9010,
'CONJUNCTION': 9740,
'CONTAINS AS MEMBER': 8715,
'CONTAINS AS NORMAL SUBGROUP': 8883,
'CONTAINS AS NORMAL SUBGROUP OR EQUAL TO': 8885,
'CONTAINS WITH LONG HORIZONTAL STROKE': 8954,
'CONTAINS WITH OVERBAR': 8957,
'CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE': 8955,
'CONTINUOUS UNDERLINE SYMBOL': 9089,
'CONTOUR INTEGRAL': 8750,
'COPTIC CAPITAL LETTER AKHMIMIC KHEI': 11464,
'COPTIC CAPITAL LETTER ALFA': 11392,
'COPTIC CAPITAL LETTER CROSSED SHEI': 11458,
'COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE': 11446,
'COPTIC CAPITAL LETTER CRYPTOGRAMMIC NI': 11452,
'COPTIC CAPITAL LETTER DALDA': 11398,
'COPTIC CAPITAL LETTER DEI': 1006,
'COPTIC CAPITAL LETTER DIALECT-P ALEF': 11442,
'COPTIC CAPITAL LETTER DIALECT-P HORI': 11466,
'COPTIC CAPITAL LETTER DIALECT-P KAPA': 11448,
'COPTIC CAPITAL LETTER DIALECT-P NI': 11450,
'COPTIC CAPITAL LETTER EIE': 11400,
'COPTIC CAPITAL LETTER FEI': 996,
'COPTIC CAPITAL LETTER FI': 11434,
'COPTIC CAPITAL LETTER GAMMA': 11396,
'COPTIC CAPITAL LETTER GANGIA': 1002,
'COPTIC CAPITAL LETTER HATE': 11406,
'COPTIC CAPITAL LETTER HORI': 1000,
'COPTIC CAPITAL LETTER IAUDA': 11410,
'COPTIC CAPITAL LETTER KAPA': 11412,
'COPTIC CAPITAL LETTER KHEI': 998,
'COPTIC CAPITAL LETTER KHI': 11436,
'COPTIC CAPITAL LETTER KSI': 11420,
'COPTIC CAPITAL LETTER L-SHAPED HA': 11472,
'COPTIC CAPITAL LETTER LAULA': 11414,
'COPTIC CAPITAL LETTER MI': 11416,
'COPTIC CAPITAL LETTER NI': 11418,
'COPTIC CAPITAL LETTER O': 11422,
'COPTIC CAPITAL LETTER OLD COPTIC AIN': 11444,
'COPTIC CAPITAL LETTER OLD COPTIC DJA': 11480,
'COPTIC CAPITAL LETTER OLD COPTIC ESH': 11462,
'COPTIC CAPITAL LETTER OLD COPTIC GANGIA': 11478,
'COPTIC CAPITAL LETTER OLD COPTIC HA': 11470,
'COPTIC CAPITAL LETTER OLD COPTIC HAT': 11476,
'COPTIC CAPITAL LETTER OLD COPTIC HEI': 11474,
'COPTIC CAPITAL LETTER OLD COPTIC HORI': 11468,
'COPTIC CAPITAL LETTER OLD COPTIC OOU': 11454,
'COPTIC CAPITAL LETTER OLD COPTIC SHEI': 11460,
'COPTIC CAPITAL LETTER OLD COPTIC SHIMA': 11482,
'COPTIC CAPITAL LETTER OLD NUBIAN NGI': 11486,
'COPTIC CAPITAL LETTER OLD NUBIAN NYI': 11488,
'COPTIC CAPITAL LETTER OLD NUBIAN SHIMA': 11484,
'COPTIC CAPITAL LETTER OLD NUBIAN WAU': 11490,
'COPTIC CAPITAL LETTER OOU': 11440,
'COPTIC CAPITAL LETTER PI': 11424,
'COPTIC CAPITAL LETTER PSI': 11438,
'COPTIC CAPITAL LETTER RO': 11426,
'COPTIC CAPITAL LETTER SAMPI': 11456,
'COPTIC CAPITAL LETTER SHEI': 994,
'COPTIC CAPITAL LETTER SHIMA': 1004,
'COPTIC CAPITAL LETTER SIMA': 11428,
'COPTIC CAPITAL LETTER SOU': 11402,
'COPTIC CAPITAL LETTER TAU': 11430,
'COPTIC CAPITAL LETTER THETHE': 11408,
'COPTIC CAPITAL LETTER UA': 11432,
'COPTIC CAPITAL LETTER VIDA': 11394,
'COPTIC CAPITAL LETTER ZATA': 11404,
'COPTIC FRACTION ONE HALF': 11517,
'COPTIC FULL STOP': 11518,
'COPTIC MORPHOLOGICAL DIVIDER': 11519,
'COPTIC OLD NUBIAN DIRECT QUESTION MARK': 11514,
'COPTIC OLD NUBIAN FULL STOP': 11513,
'COPTIC OLD NUBIAN INDIRECT QUESTION MARK': 11515,
'COPTIC OLD NUBIAN VERSE DIVIDER': 11516,
'COPTIC SMALL LETTER AKHMIMIC KHEI': 11465,
'COPTIC SMALL LETTER ALFA': 11393,
'COPTIC SMALL LETTER CROSSED SHEI': 11459,
'COPTIC SMALL LETTER CRYPTOGRAMMIC EIE': 11447,
'COPTIC SMALL LETTER CRYPTOGRAMMIC NI': 11453,
'COPTIC SMALL LETTER DALDA': 11399,
'COPTIC SMALL LETTER DEI': 1007,
'COPTIC SMALL LETTER DIALECT-P ALEF': 11443,
'COPTIC SMALL LETTER DIALECT-P HORI': 11467,
'COPTIC SMALL LETTER DIALECT-P KAPA': 11449,
'COPTIC SMALL LETTER DIALECT-P NI': 11451,
'COPTIC SMALL LETTER EIE': 11401,
'COPTIC SMALL LETTER FEI': 997,
'COPTIC SMALL LETTER FI': 11435,
'COPTIC SMALL LETTER GAMMA': 11397,
'COPTIC SMALL LETTER GANGIA': 1003,
'COPTIC SMALL LETTER HATE': 11407,
'COPTIC SMALL LETTER HORI': 1001,
'COPTIC SMALL LETTER IAUDA': 11411,
'COPTIC SMALL LETTER KAPA': 11413,
'COPTIC SMALL LETTER KHEI': 999,
'COPTIC SMALL LETTER KHI': 11437,
'COPTIC SMALL LETTER KSI': 11421,
'COPTIC SMALL LETTER L-SHAPED HA': 11473,
'COPTIC SMALL LETTER LAULA': 11415,
'COPTIC SMALL LETTER MI': 11417,
'COPTIC SMALL LETTER NI': 11419,
'COPTIC SMALL LETTER O': 11423,
'COPTIC SMALL LETTER OLD COPTIC AIN': 11445,
'COPTIC SMALL LETTER OLD COPTIC DJA': 11481,
'COPTIC SMALL LETTER OLD COPTIC ESH': 11463,
'COPTIC SMALL LETTER OLD COPTIC GANGIA': 11479,
'COPTIC SMALL LETTER OLD COPTIC HA': 11471,
'COPTIC SMALL LETTER OLD COPTIC HAT': 11477,
'COPTIC SMALL LETTER OLD COPTIC HEI': 11475,
'COPTIC SMALL LETTER OLD COPTIC HORI': 11469,
'COPTIC SMALL LETTER OLD COPTIC OOU': 11455,
'COPTIC SMALL LETTER OLD COPTIC SHEI': 11461,
'COPTIC SMALL LETTER OLD COPTIC SHIMA': 11483,
'COPTIC SMALL LETTER OLD NUBIAN NGI': 11487,
'COPTIC SMALL LETTER OLD NUBIAN NYI': 11489,
'COPTIC SMALL LETTER OLD NUBIAN SHIMA': 11485,
'COPTIC SMALL LETTER OLD NUBIAN WAU': 11491,
'COPTIC SMALL LETTER OOU': 11441,
'COPTIC SMALL LETTER PI': 11425,
'COPTIC SMALL LETTER PSI': 11439,
'COPTIC SMALL LETTER RO': 11427,
'COPTIC SMALL LETTER SAMPI': 11457,
'COPTIC SMALL LETTER SHEI': 995,
'COPTIC SMALL LETTER SHIMA': 1005,
'COPTIC SMALL LETTER SIMA': 11429,
'COPTIC SMALL LETTER SOU': 11403,
'COPTIC SMALL LETTER TAU': 11431,
'COPTIC SMALL LETTER THETHE': 11409,
'COPTIC SMALL LETTER UA': 11433,
'COPTIC SMALL LETTER VIDA': 11395,
'COPTIC SMALL LETTER ZATA': 11405,
'COPTIC SYMBOL KAI': 11492,
'COPTIC SYMBOL KHI RO': 11497,
'COPTIC SYMBOL MI RO': 11493,
'COPTIC SYMBOL PI RO': 11494,
'COPTIC SYMBOL SHIMA SIMA': 11498,
'COPTIC SYMBOL STAUROS': 11495,
'COPTIC SYMBOL TAU RO': 11496,
'COPYRIGHT SIGN': 169,
'CORRESPONDS TO': 8792,
'COUNTERBORE': 9012,
'COUNTERSINK': 9013,
'CROSS OF JERUSALEM': 9769,
'CROSS OF LORRAINE': 9768,
'CROSSED SWORDS': 9876,
'CRUZEIRO SIGN': 8354,
'CUBE ROOT': 8731,
'CURLY BRACKET EXTENSION': 9130,
'CURLY LOGICAL AND': 8911,
'CURLY LOGICAL OR': 8910,
'CURRENCY SIGN': 164,
'CURVED STEM PARAGRAPH SIGN ORNAMENT': 10081,
'CYLINDRICITY': 9005,
'CYPRIOT SYLLABLE A': 67584,
'CYPRIOT SYLLABLE E': 67585,
'CYPRIOT SYLLABLE I': 67586,
'CYPRIOT SYLLABLE JA': 67589,
'CYPRIOT SYLLABLE JO': 67592,
'CYPRIOT SYLLABLE KA': 67594,
'CYPRIOT SYLLABLE KE': 67595,
'CYPRIOT SYLLABLE KI': 67596,
'CYPRIOT SYLLABLE KO': 67597,
'CYPRIOT SYLLABLE KU': 67598,
'CYPRIOT SYLLABLE LA': 67599,
'CYPRIOT SYLLABLE LE': 67600,
'CYPRIOT SYLLABLE LI': 67601,
'CYPRIOT SYLLABLE LO': 67602,
'CYPRIOT SYLLABLE LU': 67603,
'CYPRIOT SYLLABLE MA': 67604,
'CYPRIOT SYLLABLE ME': 67605,
'CYPRIOT SYLLABLE MI': 67606,
'CYPRIOT SYLLABLE MO': 67607,
'CYPRIOT SYLLABLE MU': 67608,
'CYPRIOT SYLLABLE NA': 67609,
'CYPRIOT SYLLABLE NE': 67610,
'CYPRIOT SYLLABLE NI': 67611,
'CYPRIOT SYLLABLE NO': 67612,
'CYPRIOT SYLLABLE NU': 67613,
'CYPRIOT SYLLABLE O': 67587,
'CYPRIOT SYLLABLE PA': 67614,
'CYPRIOT SYLLABLE PE': 67615,
'CYPRIOT SYLLABLE PI': 67616,
'CYPRIOT SYLLABLE PO': 67617,
'CYPRIOT SYLLABLE PU': 67618,
'CYPRIOT SYLLABLE RA': 67619,
'CYPRIOT SYLLABLE RE': 67620,
'CYPRIOT SYLLABLE RI': 67621,
'CYPRIOT SYLLABLE RO': 67622,
'CYPRIOT SYLLABLE RU': 67623,
'CYPRIOT SYLLABLE SA': 67624,
'CYPRIOT SYLLABLE SE': 67625,
'CYPRIOT SYLLABLE SI': 67626,
'CYPRIOT SYLLABLE SO': 67627,
'CYPRIOT SYLLABLE SU': 67628,
'CYPRIOT SYLLABLE TA': 67629,
'CYPRIOT SYLLABLE TE': 67630,
'CYPRIOT SYLLABLE TI': 67631,
'CYPRIOT SYLLABLE TO': 67632,
'CYPRIOT SYLLABLE TU': 67633,
'CYPRIOT SYLLABLE U': 67588,
'CYPRIOT SYLLABLE WA': 67634,
'CYPRIOT SYLLABLE WE': 67635,
'CYPRIOT SYLLABLE WI': 67636,
'CYPRIOT SYLLABLE WO': 67637,
'CYPRIOT SYLLABLE XA': 67639,
'CYPRIOT SYLLABLE XE': 67640,
'CYPRIOT SYLLABLE ZA': 67644,
'CYPRIOT SYLLABLE ZO': 67647,
'CYRILLIC CAPITAL LETTER A': 1040,
'CYRILLIC CAPITAL LETTER A WITH BREVE': 1232,
'CYRILLIC CAPITAL LETTER A WITH DIAERESIS': 1234,
'CYRILLIC CAPITAL LETTER ABKHASIAN CHE': 1212,
'CYRILLIC CAPITAL LETTER ABKHASIAN CHE WITH DESCENDER': 1214,
'CYRILLIC CAPITAL LETTER ABKHASIAN DZE': 1248,
'CYRILLIC CAPITAL LETTER ABKHASIAN HA': 1192,
'CYRILLIC CAPITAL LETTER BARRED O': 1256,
'CYRILLIC CAPITAL LETTER BARRED O WITH DIAERESIS': 1258,
'CYRILLIC CAPITAL LETTER BASHKIR KA': 1184,
'CYRILLIC CAPITAL LETTER BE': 1041,
'CYRILLIC CAPITAL LETTER BIG YUS': 1130,
'CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I': 1030,
'CYRILLIC CAPITAL LETTER CHE': 1063,
'CYRILLIC CAPITAL LETTER CHE WITH DESCENDER': 1206,
'CYRILLIC CAPITAL LETTER CHE WITH DIAERESIS': 1268,
'CYRILLIC CAPITAL LETTER CHE WITH VERTICAL STROKE': 1208,
'CYRILLIC CAPITAL LETTER DE': 1044,
'CYRILLIC CAPITAL LETTER DJE': 1026,
'CYRILLIC CAPITAL LETTER DZE': 1029,
'CYRILLIC CAPITAL LETTER DZHE': 1039,
'CYRILLIC CAPITAL LETTER E': 1069,
'CYRILLIC CAPITAL LETTER E WITH DIAERESIS': 1260,
'CYRILLIC CAPITAL LETTER EF': 1060,
'CYRILLIC CAPITAL LETTER EL': 1051,
'CYRILLIC CAPITAL LETTER EL WITH TAIL': 1221,
'CYRILLIC CAPITAL LETTER EM': 1052,
'CYRILLIC CAPITAL LETTER EM WITH TAIL': 1229,
'CYRILLIC CAPITAL LETTER EN': 1053,
'CYRILLIC CAPITAL LETTER EN WITH DESCENDER': 1186,
'CYRILLIC CAPITAL LETTER EN WITH HOOK': 1223,
'CYRILLIC CAPITAL LETTER EN WITH TAIL': 1225,
'CYRILLIC CAPITAL LETTER ER': 1056,
'CYRILLIC CAPITAL LETTER ER WITH TICK': 1166,
'CYRILLIC CAPITAL LETTER ES': 1057,
'CYRILLIC CAPITAL LETTER ES WITH DESCENDER': 1194,
'CYRILLIC CAPITAL LETTER FITA': 1138,
'CYRILLIC CAPITAL LETTER GHE': 1043,
'CYRILLIC CAPITAL LETTER GHE WITH DESCENDER': 1270,
'CYRILLIC CAPITAL LETTER GHE WITH MIDDLE HOOK': 1172,
'CYRILLIC CAPITAL LETTER GHE WITH STROKE': 1170,
'CYRILLIC CAPITAL LETTER GHE WITH UPTURN': 1168,
'CYRILLIC CAPITAL LETTER GJE': 1027,
'CYRILLIC CAPITAL LETTER HA': 1061,
'CYRILLIC CAPITAL LETTER HA WITH DESCENDER': 1202,
'CYRILLIC CAPITAL LETTER HARD SIGN': 1066,
'CYRILLIC CAPITAL LETTER I': 1048,
'CYRILLIC CAPITAL LETTER I WITH DIAERESIS': 1252,
'CYRILLIC CAPITAL LETTER I WITH GRAVE': 1037,
'CYRILLIC CAPITAL LETTER I WITH MACRON': 1250,
'CYRILLIC CAPITAL LETTER IE': 1045,
'CYRILLIC CAPITAL LETTER IE WITH BREVE': 1238,
'CYRILLIC CAPITAL LETTER IE WITH GRAVE': 1024,
'CYRILLIC CAPITAL LETTER IO': 1025,
'CYRILLIC CAPITAL LETTER IOTIFIED BIG YUS': 1132,
'CYRILLIC CAPITAL LETTER IOTIFIED E': 1124,
'CYRILLIC CAPITAL LETTER IOTIFIED LITTLE YUS': 1128,
'CYRILLIC CAPITAL LETTER IZHITSA': 1140,
'CYRILLIC CAPITAL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT': 1142,
'CYRILLIC CAPITAL LETTER JE': 1032,
'CYRILLIC CAPITAL LETTER KA': 1050,
'CYRILLIC CAPITAL LETTER KA WITH DESCENDER': 1178,
'CYRILLIC CAPITAL LETTER KA WITH HOOK': 1219,
'CYRILLIC CAPITAL LETTER KA WITH STROKE': 1182,
'CYRILLIC CAPITAL LETTER KA WITH VERTICAL STROKE': 1180,
'CYRILLIC CAPITAL LETTER KHAKASSIAN CHE': 1227,
'CYRILLIC CAPITAL LETTER KJE': 1036,
'CYRILLIC CAPITAL LETTER KOMI DE': 1280,
'CYRILLIC CAPITAL LETTER KOMI DJE': 1282,
'CYRILLIC CAPITAL LETTER KOMI DZJE': 1286,
'CYRILLIC CAPITAL LETTER KOMI LJE': 1288,
'CYRILLIC CAPITAL LETTER KOMI NJE': 1290,
'CYRILLIC CAPITAL LETTER KOMI SJE': 1292,
'CYRILLIC CAPITAL LETTER KOMI TJE': 1294,
'CYRILLIC CAPITAL LETTER KOMI ZJE': 1284,
'CYRILLIC CAPITAL LETTER KOPPA': 1152,
'CYRILLIC CAPITAL LETTER KSI': 1134,
'CYRILLIC CAPITAL LETTER LITTLE YUS': 1126,
'CYRILLIC CAPITAL LETTER LJE': 1033,
'CYRILLIC CAPITAL LETTER NJE': 1034,
'CYRILLIC CAPITAL LETTER O': 1054,
'CYRILLIC CAPITAL LETTER O WITH DIAERESIS': 1254,
'CYRILLIC CAPITAL LETTER OMEGA': 1120,
'CYRILLIC CAPITAL LETTER OMEGA WITH TITLO': 1148,
'CYRILLIC CAPITAL LETTER OT': 1150,
'CYRILLIC CAPITAL LETTER PE': 1055,
'CYRILLIC CAPITAL LETTER PE WITH MIDDLE HOOK': 1190,
'CYRILLIC CAPITAL LETTER PSI': 1136,
'CYRILLIC CAPITAL LETTER ROUND OMEGA': 1146,
'CYRILLIC CAPITAL LETTER SCHWA': 1240,
'CYRILLIC CAPITAL LETTER SCHWA WITH DIAERESIS': 1242,
'CYRILLIC CAPITAL LETTER SEMISOFT SIGN': 1164,
'CYRILLIC CAPITAL LETTER SHA': 1064,
'CYRILLIC CAPITAL LETTER SHCHA': 1065,
'CYRILLIC CAPITAL LETTER SHHA': 1210,
'CYRILLIC CAPITAL LETTER SHORT I': 1049,
'CYRILLIC CAPITAL LETTER SHORT I WITH TAIL': 1162,
'CYRILLIC CAPITAL LETTER SHORT U': 1038,
'CYRILLIC CAPITAL LETTER SOFT SIGN': 1068,
'CYRILLIC CAPITAL LETTER STRAIGHT U': 1198,
'CYRILLIC CAPITAL LETTER STRAIGHT U WITH STROKE': 1200,
'CYRILLIC CAPITAL LETTER TE': 1058,
'CYRILLIC CAPITAL LETTER TE WITH DESCENDER': 1196,
'CYRILLIC CAPITAL LETTER TSE': 1062,
'CYRILLIC CAPITAL LETTER TSHE': 1035,
'CYRILLIC CAPITAL LETTER U': 1059,
'CYRILLIC CAPITAL LETTER U WITH DIAERESIS': 1264,
'CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE': 1266,
'CYRILLIC CAPITAL LETTER U WITH MACRON': 1262,
'CYRILLIC CAPITAL LETTER UK': 1144,
'CYRILLIC CAPITAL LETTER UKRAINIAN IE': 1028,
'CYRILLIC CAPITAL LETTER VE': 1042,
'CYRILLIC CAPITAL LETTER YA': 1071,
'CYRILLIC CAPITAL LETTER YAT': 1122,
'CYRILLIC CAPITAL LETTER YERU': 1067,
'CYRILLIC CAPITAL LETTER YERU WITH DIAERESIS': 1272,
'CYRILLIC CAPITAL LETTER YI': 1031,
'CYRILLIC CAPITAL LETTER YU': 1070,
'CYRILLIC CAPITAL LETTER ZE': 1047,
'CYRILLIC CAPITAL LETTER ZE WITH DESCENDER': 1176,
'CYRILLIC CAPITAL LETTER ZE WITH DIAERESIS': 1246,
'CYRILLIC CAPITAL LETTER ZHE': 1046,
'CYRILLIC CAPITAL LETTER ZHE WITH BREVE': 1217,
'CYRILLIC CAPITAL LETTER ZHE WITH DESCENDER': 1174,
'CYRILLIC CAPITAL LETTER ZHE WITH DIAERESIS': 1244,
'CYRILLIC CAPITAL LIGATURE A IE': 1236,
'CYRILLIC CAPITAL LIGATURE EN GHE': 1188,
'CYRILLIC CAPITAL LIGATURE TE TSE': 1204,
'CYRILLIC LETTER PALOCHKA': 1216,
'CYRILLIC LETTER SMALL CAPITAL EL': 7467,
'CYRILLIC SMALL LETTER A': 1072,
'CYRILLIC SMALL LETTER A WITH BREVE': 1233,
'CYRILLIC SMALL LETTER A WITH DIAERESIS': 1235,
'CYRILLIC SMALL LETTER ABKHASIAN CHE': 1213,
'CYRILLIC SMALL LETTER ABKHASIAN CHE WITH DESCENDER': 1215,
'CYRILLIC SMALL LETTER ABKHASIAN DZE': 1249,
'CYRILLIC SMALL LETTER ABKHASIAN HA': 1193,
'CYRILLIC SMALL LETTER BARRED O': 1257,
'CYRILLIC SMALL LETTER BARRED O WITH DIAERESIS': 1259,
'CYRILLIC SMALL LETTER BASHKIR KA': 1185,
'CYRILLIC SMALL LETTER BE': 1073,
'CYRILLIC SMALL LETTER BIG YUS': 1131,
'CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I': 1110,
'CYRILLIC SMALL LETTER CHE': 1095,
'CYRILLIC SMALL LETTER CHE WITH DESCENDER': 1207,
'CYRILLIC SMALL LETTER CHE WITH DIAERESIS': 1269,
'CYRILLIC SMALL LETTER CHE WITH VERTICAL STROKE': 1209,
'CYRILLIC SMALL LETTER DE': 1076,
'CYRILLIC SMALL LETTER DJE': 1106,
'CYRILLIC SMALL LETTER DZE': 1109,
'CYRILLIC SMALL LETTER DZHE': 1119,
'CYRILLIC SMALL LETTER E': 1101,
'CYRILLIC SMALL LETTER E WITH DIAERESIS': 1261,
'CYRILLIC SMALL LETTER EF': 1092,
'CYRILLIC SMALL LETTER EL': 1083,
'CYRILLIC SMALL LETTER EL WITH TAIL': 1222,
'CYRILLIC SMALL LETTER EM': 1084,
'CYRILLIC SMALL LETTER EM WITH TAIL': 1230,
'CYRILLIC SMALL LETTER EN': 1085,
'CYRILLIC SMALL LETTER EN WITH DESCENDER': 1187,
'CYRILLIC SMALL LETTER EN WITH HOOK': 1224,
'CYRILLIC SMALL LETTER EN WITH TAIL': 1226,
'CYRILLIC SMALL LETTER ER': 1088,
'CYRILLIC SMALL LETTER ER WITH TICK': 1167,
'CYRILLIC SMALL LETTER ES': 1089,
'CYRILLIC SMALL LETTER ES WITH DESCENDER': 1195,
'CYRILLIC SMALL LETTER FITA': 1139,
'CYRILLIC SMALL LETTER GHE': 1075,
'CYRILLIC SMALL LETTER GHE WITH DESCENDER': 1271,
'CYRILLIC SMALL LETTER GHE WITH MIDDLE HOOK': 1173,
'CYRILLIC SMALL LETTER GHE WITH STROKE': 1171,
'CYRILLIC SMALL LETTER GHE WITH UPTURN': 1169,
'CYRILLIC SMALL LETTER GJE': 1107,
'CYRILLIC SMALL LETTER HA': 1093,
'CYRILLIC SMALL LETTER HA WITH DESCENDER': 1203,
'CYRILLIC SMALL LETTER HARD SIGN': 1098,
'CYRILLIC SMALL LETTER I': 1080,
'CYRILLIC SMALL LETTER I WITH DIAERESIS': 1253,
'CYRILLIC SMALL LETTER I WITH GRAVE': 1117,
'CYRILLIC SMALL LETTER I WITH MACRON': 1251,
'CYRILLIC SMALL LETTER IE': 1077,
'CYRILLIC SMALL LETTER IE WITH BREVE': 1239,
'CYRILLIC SMALL LETTER IE WITH GRAVE': 1104,
'CYRILLIC SMALL LETTER IO': 1105,
'CYRILLIC SMALL LETTER IOTIFIED BIG YUS': 1133,
'CYRILLIC SMALL LETTER IOTIFIED E': 1125,
'CYRILLIC SMALL LETTER IOTIFIED LITTLE YUS': 1129,
'CYRILLIC SMALL LETTER IZHITSA': 1141,
'CYRILLIC SMALL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT': 1143,
'CYRILLIC SMALL LETTER JE': 1112,
'CYRILLIC SMALL LETTER KA': 1082,
'CYRILLIC SMALL LETTER KA WITH DESCENDER': 1179,
'CYRILLIC SMALL LETTER KA WITH HOOK': 1220,
'CYRILLIC SMALL LETTER KA WITH STROKE': 1183,
'CYRILLIC SMALL LETTER KA WITH VERTICAL STROKE': 1181,
'CYRILLIC SMALL LETTER KHAKASSIAN CHE': 1228,
'CYRILLIC SMALL LETTER KJE': 1116,
'CYRILLIC SMALL LETTER KOMI DE': 1281,
'CYRILLIC SMALL LETTER KOMI DJE': 1283,
'CYRILLIC SMALL LETTER KOMI DZJE': 1287,
'CYRILLIC SMALL LETTER KOMI LJE': 1289,
'CYRILLIC SMALL LETTER KOMI NJE': 1291,
'CYRILLIC SMALL LETTER KOMI SJE': 1293,
'CYRILLIC SMALL LETTER KOMI TJE': 1295,
'CYRILLIC SMALL LETTER KOMI ZJE': 1285,
'CYRILLIC SMALL LETTER KOPPA': 1153,
'CYRILLIC SMALL LETTER KSI': 1135,
'CYRILLIC SMALL LETTER LITTLE YUS': 1127,
'CYRILLIC SMALL LETTER LJE': 1113,
'CYRILLIC SMALL LETTER NJE': 1114,
'CYRILLIC SMALL LETTER O': 1086,
'CYRILLIC SMALL LETTER O WITH DIAERESIS': 1255,
'CYRILLIC SMALL LETTER OMEGA': 1121,
'CYRILLIC SMALL LETTER OMEGA WITH TITLO': 1149,
'CYRILLIC SMALL LETTER OT': 1151,
'CYRILLIC SMALL LETTER PE': 1087,
'CYRILLIC SMALL LETTER PE WITH MIDDLE HOOK': 1191,
'CYRILLIC SMALL LETTER PSI': 1137,
'CYRILLIC SMALL LETTER ROUND OMEGA': 1147,
'CYRILLIC SMALL LETTER SCHWA': 1241,
'CYRILLIC SMALL LETTER SCHWA WITH DIAERESIS': 1243,
'CYRILLIC SMALL LETTER SEMISOFT SIGN': 1165,
'CYRILLIC SMALL LETTER SHA': 1096,
'CYRILLIC SMALL LETTER SHCHA': 1097,
'CYRILLIC SMALL LETTER SHHA': 1211,
'CYRILLIC SMALL LETTER SHORT I': 1081,
'CYRILLIC SMALL LETTER SHORT I WITH TAIL': 1163,
'CYRILLIC SMALL LETTER SHORT U': 1118,
'CYRILLIC SMALL LETTER SOFT SIGN': 1100,
'CYRILLIC SMALL LETTER STRAIGHT U': 1199,
'CYRILLIC SMALL LETTER STRAIGHT U WITH STROKE': 1201,
'CYRILLIC SMALL LETTER TE': 1090,
'CYRILLIC SMALL LETTER TE WITH DESCENDER': 1197,
'CYRILLIC SMALL LETTER TSE': 1094,
'CYRILLIC SMALL LETTER TSHE': 1115,
'CYRILLIC SMALL LETTER U': 1091,
'CYRILLIC SMALL LETTER U WITH DIAERESIS': 1265,
'CYRILLIC SMALL LETTER U WITH DOUBLE ACUTE': 1267,
'CYRILLIC SMALL LETTER U WITH MACRON': 1263,
'CYRILLIC SMALL LETTER UK': 1145,
'CYRILLIC SMALL LETTER UKRAINIAN IE': 1108,
'CYRILLIC SMALL LETTER VE': 1074,
'CYRILLIC SMALL LETTER YA': 1103,
'CYRILLIC SMALL LETTER YAT': 1123,
'CYRILLIC SMALL LETTER YERU': 1099,
'CYRILLIC SMALL LETTER YERU WITH DIAERESIS': 1273,
'CYRILLIC SMALL LETTER YI': 1111,
'CYRILLIC SMALL LETTER YU': 1102,
'CYRILLIC SMALL LETTER ZE': 1079,
'CYRILLIC SMALL LETTER ZE WITH DESCENDER': 1177,
'CYRILLIC SMALL LETTER ZE WITH DIAERESIS': 1247,
'CYRILLIC SMALL LETTER ZHE': 1078,
'CYRILLIC SMALL LETTER ZHE WITH BREVE': 1218,
'CYRILLIC SMALL LETTER ZHE WITH DESCENDER': 1175,
'CYRILLIC SMALL LETTER ZHE WITH DIAERESIS': 1245,
'CYRILLIC SMALL LIGATURE A IE': 1237,
'CYRILLIC SMALL LIGATURE EN GHE': 1189,
'CYRILLIC SMALL LIGATURE TE TSE': 1205,
'CYRILLIC THOUSANDS SIGN': 1154,
'DAGGER': 8224,
'DALET SYMBOL': 8504,
'DARK SHADE': 9619,
'DASHED LOW LINE': 65101,
'DASHED OVERLINE': 65097,
'DASHED TRIANGLE-HEADED RIGHTWARDS ARROW': 10143,
'DECIMAL SEPARATOR KEY SYMBOL': 9110,
'DEGREE CELSIUS': 8451,
'DEGREE FAHRENHEIT': 8457,
'DEGREE SIGN': 176,
'DELTA EQUAL TO': 8796,
'DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL': 9161,
'DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH CIRCLE': 9153,
'DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH TRIANGLE': 9156,
'DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH WAVE': 9159,
'DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL': 9162,
'DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH CIRCLE': 9154,
'DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH TRIANGLE': 9157,
'DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH WAVE': 9160,
'DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM LEFT': 9164,
'DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM RIGHT': 9151,
'DENTISTRY SYMBOL LIGHT VERTICAL AND TOP LEFT': 9163,
'DENTISTRY SYMBOL LIGHT VERTICAL AND TOP RIGHT': 9150,
'DENTISTRY SYMBOL LIGHT VERTICAL AND WAVE': 9158,
'DENTISTRY SYMBOL LIGHT VERTICAL WITH CIRCLE': 9152,
'DENTISTRY SYMBOL LIGHT VERTICAL WITH TRIANGLE': 9155,
'DESCENDING NODE': 9739,
'DESERET CAPITAL LETTER AY': 66572,
'DESERET CAPITAL LETTER BEE': 66578,
'DESERET CAPITAL LETTER CHEE': 66581,
'DESERET CAPITAL LETTER DEE': 66580,
'DESERET CAPITAL LETTER EF': 66585,
'DESERET CAPITAL LETTER EL': 66594,
'DESERET CAPITAL LETTER EM': 66595,
'DESERET CAPITAL LETTER EN': 66596,
'DESERET CAPITAL LETTER ENG': 66597,
'DESERET CAPITAL LETTER ER': 66593,
'DESERET CAPITAL LETTER ES': 66589,
'DESERET CAPITAL LETTER ESH': 66591,
'DESERET CAPITAL LETTER ETH': 66587,
'DESERET CAPITAL LETTER EW': 66599,
'DESERET CAPITAL LETTER GAY': 66584,
'DESERET CAPITAL LETTER H': 66576,
'DESERET CAPITAL LETTER JEE': 66582,
'DESERET CAPITAL LETTER KAY': 66583,
'DESERET CAPITAL LETTER LONG A': 66562,
'DESERET CAPITAL LETTER LONG AH': 66563,
'DESERET CAPITAL LETTER LONG E': 66561,
'DESERET CAPITAL LETTER LONG I': 66560,
'DESERET CAPITAL LETTER LONG O': 66564,
'DESERET CAPITAL LETTER LONG OO': 66565,
'DESERET CAPITAL LETTER OI': 66598,
'DESERET CAPITAL LETTER OW': 66573,
'DESERET CAPITAL LETTER PEE': 66577,
'DESERET CAPITAL LETTER SHORT A': 66568,
'DESERET CAPITAL LETTER SHORT AH': 66569,
'DESERET CAPITAL LETTER SHORT E': 66567,
'DESERET CAPITAL LETTER SHORT I': 66566,
'DESERET CAPITAL LETTER SHORT O': 66570,
'DESERET CAPITAL LETTER SHORT OO': 66571,
'DESERET CAPITAL LETTER TEE': 66579,
'DESERET CAPITAL LETTER THEE': 66588,
'DESERET CAPITAL LETTER VEE': 66586,
'DESERET CAPITAL LETTER WU': 66574,
'DESERET CAPITAL LETTER YEE': 66575,
'DESERET CAPITAL LETTER ZEE': 66590,
'DESERET CAPITAL LETTER ZHEE': 66592,
'DESERET SMALL LETTER AY': 66612,
'DESERET SMALL LETTER BEE': 66618,
'DESERET SMALL LETTER CHEE': 66621,
'DESERET SMALL LETTER DEE': 66620,
'DESERET SMALL LETTER EF': 66625,
'DESERET SMALL LETTER EL': 66634,
'DESERET SMALL LETTER EM': 66635,
'DESERET SMALL LETTER EN': 66636,
'DESERET SMALL LETTER ENG': 66637,
'DESERET SMALL LETTER ER': 66633,
'DESERET SMALL LETTER ES': 66629,
'DESERET SMALL LETTER ESH': 66631,
'DESERET SMALL LETTER ETH': 66627,
'DESERET SMALL LETTER EW': 66639,
'DESERET SMALL LETTER GAY': 66624,
'DESERET SMALL LETTER H': 66616,
'DESERET SMALL LETTER JEE': 66622,
'DESERET SMALL LETTER KAY': 66623,
'DESERET SMALL LETTER LONG A': 66602,
'DESERET SMALL LETTER LONG AH': 66603,
'DESERET SMALL LETTER LONG E': 66601,
'DESERET SMALL LETTER LONG I': 66600,
'DESERET SMALL LETTER LONG O': 66604,
'DESERET SMALL LETTER LONG OO': 66605,
'DESERET SMALL LETTER OI': 66638,
'DESERET SMALL LETTER OW': 66613,
'DESERET SMALL LETTER PEE': 66617,
'DESERET SMALL LETTER SHORT A': 66608,
'DESERET SMALL LETTER SHORT AH': 66609,
'DESERET SMALL LETTER SHORT E': 66607,
'DESERET SMALL LETTER SHORT I': 66606,
'DESERET SMALL LETTER SHORT O': 66610,
'DESERET SMALL LETTER SHORT OO': 66611,
'DESERET SMALL LETTER TEE': 66619,
'DESERET SMALL LETTER THEE': 66628,
'DESERET SMALL LETTER VEE': 66626,
'DESERET SMALL LETTER WU': 66614,
'DESERET SMALL LETTER YEE': 66615,
'DESERET SMALL LETTER ZEE': 66630,
'DESERET SMALL LETTER ZHEE': 66632,
'DEVANAGARI ABBREVIATION SIGN': 2416,
'DEVANAGARI ACUTE ACCENT': 2388,
'DEVANAGARI DANDA': 2404,
'DEVANAGARI DIGIT EIGHT': 2414,
'DEVANAGARI DIGIT FIVE': 2411,
'DEVANAGARI DIGIT FOUR': 2410,
'DEVANAGARI DIGIT NINE': 2415,
'DEVANAGARI DIGIT ONE': 2407,
'DEVANAGARI DIGIT SEVEN': 2413,
'DEVANAGARI DIGIT SIX': 2412,
'DEVANAGARI DIGIT THREE': 2409,
'DEVANAGARI DIGIT TWO': 2408,
'DEVANAGARI DIGIT ZERO': 2406,
'DEVANAGARI DOUBLE DANDA': 2405,
'DEVANAGARI GRAVE ACCENT': 2387,
'DEVANAGARI LETTER A': 2309,
'DEVANAGARI LETTER AA': 2310,
'DEVANAGARI LETTER AI': 2320,
'DEVANAGARI LETTER AU': 2324,
'DEVANAGARI LETTER BA': 2348,
'DEVANAGARI LETTER BHA': 2349,
'DEVANAGARI LETTER CA': 2330,
'DEVANAGARI LETTER CANDRA E': 2317,
'DEVANAGARI LETTER CANDRA O': 2321,
'DEVANAGARI LETTER CHA': 2331,
'DEVANAGARI LETTER DA': 2342,
'DEVANAGARI LETTER DDA': 2337,
'DEVANAGARI LETTER DDDHA': 2396,
'DEVANAGARI LETTER DDHA': 2338,
'DEVANAGARI LETTER DHA': 2343,
'DEVANAGARI LETTER E': 2319,
'DEVANAGARI LETTER FA': 2398,
'DEVANAGARI LETTER GA': 2327,
'DEVANAGARI LETTER GHA': 2328,
'DEVANAGARI LETTER GHHA': 2394,
'DEVANAGARI LETTER GLOTTAL STOP': 2429,
'DEVANAGARI LETTER HA': 2361,
'DEVANAGARI LETTER I': 2311,
'DEVANAGARI LETTER II': 2312,
'DEVANAGARI LETTER JA': 2332,
'DEVANAGARI LETTER JHA': 2333,
'DEVANAGARI LETTER KA': 2325,
'DEVANAGARI LETTER KHA': 2326,
'DEVANAGARI LETTER KHHA': 2393,
'DEVANAGARI LETTER LA': 2354,
'DEVANAGARI LETTER LLA': 2355,
'DEVANAGARI LETTER LLLA': 2356,
'DEVANAGARI LETTER MA': 2350,
'DEVANAGARI LETTER NA': 2344,
'DEVANAGARI LETTER NGA': 2329,
'DEVANAGARI LETTER NNA': 2339,
'DEVANAGARI LETTER NNNA': 2345,
'DEVANAGARI LETTER NYA': 2334,
'DEVANAGARI LETTER O': 2323,
'DEVANAGARI LETTER PA': 2346,
'DEVANAGARI LETTER PHA': 2347,
'DEVANAGARI LETTER QA': 2392,
'DEVANAGARI LETTER RA': 2352,
'DEVANAGARI LETTER RHA': 2397,
'DEVANAGARI LETTER RRA': 2353,
'DEVANAGARI LETTER SA': 2360,
'DEVANAGARI LETTER SHA': 2358,
'DEVANAGARI LETTER SHORT A': 2308,
'DEVANAGARI LETTER SHORT E': 2318,
'DEVANAGARI LETTER SHORT O': 2322,
'DEVANAGARI LETTER SSA': 2359,
'DEVANAGARI LETTER TA': 2340,
'DEVANAGARI LETTER THA': 2341,
'DEVANAGARI LETTER TTA': 2335,
'DEVANAGARI LETTER TTHA': 2336,
'DEVANAGARI LETTER U': 2313,
'DEVANAGARI LETTER UU': 2314,
'DEVANAGARI LETTER VA': 2357,
'DEVANAGARI LETTER VOCALIC L': 2316,
'DEVANAGARI LETTER VOCALIC LL': 2401,
'DEVANAGARI LETTER VOCALIC R': 2315,
'DEVANAGARI LETTER VOCALIC RR': 2400,
'DEVANAGARI LETTER YA': 2351,
'DEVANAGARI LETTER YYA': 2399,
'DEVANAGARI LETTER ZA': 2395,
'DEVANAGARI OM': 2384,
'DEVANAGARI SIGN ANUSVARA': 2306,
'DEVANAGARI SIGN AVAGRAHA': 2365,
'DEVANAGARI SIGN CANDRABINDU': 2305,
'DEVANAGARI SIGN NUKTA': 2364,
'DEVANAGARI SIGN VIRAMA': 2381,
'DEVANAGARI SIGN VISARGA': 2307,
'DEVANAGARI STRESS SIGN ANUDATTA': 2386,
'DEVANAGARI STRESS SIGN UDATTA': 2385,
'DEVANAGARI VOWEL SIGN AA': 2366,
'DEVANAGARI VOWEL SIGN AI': 2376,
'DEVANAGARI VOWEL SIGN AU': 2380,
'DEVANAGARI VOWEL SIGN CANDRA E': 2373,
'DEVANAGARI VOWEL SIGN CANDRA O': 2377,
'DEVANAGARI VOWEL SIGN E': 2375,
'DEVANAGARI VOWEL SIGN I': 2367,
'DEVANAGARI VOWEL SIGN II': 2368,
'DEVANAGARI VOWEL SIGN O': 2379,
'DEVANAGARI VOWEL SIGN SHORT E': 2374,
'DEVANAGARI VOWEL SIGN SHORT O': 2378,
'DEVANAGARI VOWEL SIGN U': 2369,
'DEVANAGARI VOWEL SIGN UU': 2370,
'DEVANAGARI VOWEL SIGN VOCALIC L': 2402,
'DEVANAGARI VOWEL SIGN VOCALIC LL': 2403,
'DEVANAGARI VOWEL SIGN VOCALIC R': 2371,
'DEVANAGARI VOWEL SIGN VOCALIC RR': 2372,
'DIAERESIS': 168,
'DIAMETER SIGN': 8960,
'DIAMOND OPERATOR': 8900,
'DIE FACE-1': 9856,
'DIE FACE-2': 9857,
'DIE FACE-3': 9858,
'DIE FACE-4': 9859,
'DIE FACE-5': 9860,
'DIE FACE-6': 9861,
'DIFFERENCE BETWEEN': 8783,
'DIGIT EIGHT': 56,
'DIGIT EIGHT FULL STOP': 9359,
'DIGIT FIVE': 53,
'DIGIT FIVE FULL STOP': 9356,
'DIGIT FOUR': 52,
'DIGIT FOUR FULL STOP': 9355,
'DIGIT NINE': 57,
'DIGIT NINE FULL STOP': 9360,
'DIGIT ONE': 49,
'DIGIT ONE FULL STOP': 9352,
'DIGIT SEVEN': 55,
'DIGIT SEVEN FULL STOP': 9358,
'DIGIT SIX': 54,
'DIGIT SIX FULL STOP': 9357,
'DIGIT THREE': 51,
'DIGIT THREE FULL STOP': 9354,
'DIGIT TWO': 50,
'DIGIT TWO FULL STOP': 9353,
'DIGIT ZERO': 48,
'DIGRAM FOR EARTH': 119557,
'DIGRAM FOR EARTHLY HEAVEN': 119555,
'DIGRAM FOR EARTHLY HUMAN': 119556,
'DIGRAM FOR GREATER YANG': 9868,
'DIGRAM FOR GREATER YIN': 9871,
'DIGRAM FOR HEAVENLY EARTH': 119553,
'DIGRAM FOR HUMAN EARTH': 119554,
'DIGRAM FOR LESSER YANG': 9870,
'DIGRAM FOR LESSER YIN': 9869,
'DIMENSION ORIGIN': 9009,
'DINGBAT CIRCLED SANS-SERIF DIGIT EIGHT': 10119,
'DINGBAT CIRCLED SANS-SERIF DIGIT FIVE': 10116,
'DINGBAT CIRCLED SANS-SERIF DIGIT FOUR': 10115,
'DINGBAT CIRCLED SANS-SERIF DIGIT NINE': 10120,
'DINGBAT CIRCLED SANS-SERIF DIGIT ONE': 10112,
'DINGBAT CIRCLED SANS-SERIF DIGIT SEVEN': 10118,
'DINGBAT CIRCLED SANS-SERIF DIGIT SIX': 10117,
'DINGBAT CIRCLED SANS-SERIF DIGIT THREE': 10114,
'DINGBAT CIRCLED SANS-SERIF DIGIT TWO': 10113,
'DINGBAT CIRCLED SANS-SERIF NUMBER TEN': 10121,
'DINGBAT NEGATIVE CIRCLED DIGIT EIGHT': 10109,
'DINGBAT NEGATIVE CIRCLED DIGIT FIVE': 10106,
'DINGBAT NEGATIVE CIRCLED DIGIT FOUR': 10105,
'DINGBAT NEGATIVE CIRCLED DIGIT NINE': 10110,
'DINGBAT NEGATIVE CIRCLED DIGIT ONE': 10102,
'DINGBAT NEGATIVE CIRCLED DIGIT SEVEN': 10108,
'DINGBAT NEGATIVE CIRCLED DIGIT SIX': 10107,
'DINGBAT NEGATIVE CIRCLED DIGIT THREE': 10104,
'DINGBAT NEGATIVE CIRCLED DIGIT TWO': 10103,
'DINGBAT NEGATIVE CIRCLED NUMBER TEN': 10111,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT EIGHT': 10129,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FIVE': 10126,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FOUR': 10125,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT NINE': 10130,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT ONE': 10122,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SEVEN': 10128,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SIX': 10127,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT THREE': 10124,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT TWO': 10123,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF NUMBER TEN': 10131,
'DIRECT CURRENT SYMBOL FORM TWO': 9107,
'DISCONTINUOUS UNDERLINE SYMBOL': 9090,
'DITTO MARK': 12291,
'DIVIDES': 8739,
'DIVISION SIGN': 247,
'DIVISION SLASH': 8725,
'DIVISION TIMES': 8903,
'DIVORCE SYMBOL': 9902,
'DOES NOT CONTAIN AS MEMBER': 8716,
'DOES NOT CONTAIN AS NORMAL SUBGROUP': 8939,
'DOES NOT CONTAIN AS NORMAL SUBGROUP OR EQUAL': 8941,
'DOES NOT DIVIDE': 8740,
'DOES NOT DIVIDE WITH REVERSED NEGATION SLASH': 10990,
'DOES NOT FORCE': 8878,
'DOES NOT PRECEDE': 8832,
'DOES NOT PRECEDE OR EQUAL': 8928,
'DOES NOT PROVE': 8876,
'DOES NOT SUCCEED': 8833,
'DOES NOT SUCCEED OR EQUAL': 8929,
'DOLLAR SIGN': 36,
'DONG SIGN': 8363,
'DOT ABOVE': 729,
'DOT MINUS': 8760,
'DOT OPERATOR': 8901,
'DOT PLUS': 8724,
'DOTTED CIRCLE': 9676,
'DOTTED CROSS': 8284,
'DOTTED FENCE': 10649,
'DOTTED OBELOS': 11795,
'DOTTED RIGHT-POINTING ANGLE': 11798,
'DOTTED TRANSPOSITION MARKER': 11784,
'DOUBLE ACUTE ACCENT': 733,
'DOUBLE CIRCLED DIGIT EIGHT': 9468,
'DOUBLE CIRCLED DIGIT FIVE': 9465,
'DOUBLE CIRCLED DIGIT FOUR': 9464,
'DOUBLE CIRCLED DIGIT NINE': 9469,
'DOUBLE CIRCLED DIGIT ONE': 9461,
'DOUBLE CIRCLED DIGIT SEVEN': 9467,
'DOUBLE CIRCLED DIGIT SIX': 9466,
'DOUBLE CIRCLED DIGIT THREE': 9463,
'DOUBLE CIRCLED DIGIT TWO': 9462,
'DOUBLE CIRCLED NUMBER TEN': 9470,
'DOUBLE COLON EQUAL': 10868,
'DOUBLE DAGGER': 8225,
'DOUBLE DOWN TACK': 10986,
'DOUBLE EXCLAMATION MARK': 8252,
'DOUBLE HIGH-REVERSED-9 QUOTATION MARK': 8223,
'DOUBLE INTEGRAL': 8748,
'DOUBLE INTERSECTION': 8914,
'DOUBLE LEFT ARC GREATER-THAN BRACKET': 10645,
'DOUBLE LOGICAL AND': 10835,
'DOUBLE LOGICAL OR': 10836,
'DOUBLE LOW LINE': 8215,
'DOUBLE LOW-9 QUOTATION MARK': 8222,
'DOUBLE NESTED GREATER-THAN': 10914,
'DOUBLE NESTED LESS-THAN': 10913,
'DOUBLE NESTED LESS-THAN WITH UNDERBAR': 10915,
'DOUBLE OBLIQUE HYPHEN': 11799,
'DOUBLE PLUS': 10746,
'DOUBLE PRECEDES': 10939,
'DOUBLE PRIME': 8243,
'DOUBLE PRIME QUOTATION MARK': 12318,
'DOUBLE QUESTION MARK': 8263,
'DOUBLE RIGHT ARC LESS-THAN BRACKET': 10646,
'DOUBLE SOLIDUS OPERATOR': 11005,
'DOUBLE SQUARE INTERSECTION': 10830,
'DOUBLE SQUARE UNION': 10831,
'DOUBLE STROKE NOT SIGN': 10988,
'DOUBLE SUBSET': 8912,
'DOUBLE SUCCEEDS': 10940,
'DOUBLE SUPERSET': 8913,
'DOUBLE UNION': 8915,
'DOUBLE UP TACK': 10987,
'DOUBLE VERTICAL BAR DOUBLE LEFT TURNSTILE': 10981,
'DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE': 8875,
'DOUBLE VERTICAL BAR LEFT TURNSTILE': 10979,
'DOUBLE VERTICAL LINE': 8214,
'DOUBLE WAVY OVERLINE': 65100,
'DOUBLE-ENDED MULTIMAP': 10719,
'DOUBLE-LINE EQUAL TO OR GREATER-THAN': 10906,
'DOUBLE-LINE EQUAL TO OR LESS-THAN': 10905,
'DOUBLE-LINE SLANTED EQUAL TO OR GREATER-THAN': 10908,
'DOUBLE-LINE SLANTED EQUAL TO OR LESS-THAN': 10907,
'DOUBLE-LINE SLANTED GREATER-THAN OR EQUAL TO': 11002,
'DOUBLE-LINE SLANTED LESS-THAN OR EQUAL TO': 11001,
'DOUBLE-STRUCK CAPITAL C': 8450,
'DOUBLE-STRUCK CAPITAL GAMMA': 8510,
'DOUBLE-STRUCK CAPITAL H': 8461,
'DOUBLE-STRUCK CAPITAL N': 8469,
'DOUBLE-STRUCK CAPITAL P': 8473,
'DOUBLE-STRUCK CAPITAL PI': 8511,
'DOUBLE-STRUCK CAPITAL Q': 8474,
'DOUBLE-STRUCK CAPITAL R': 8477,
'DOUBLE-STRUCK CAPITAL Z': 8484,
'DOUBLE-STRUCK ITALIC CAPITAL D': 8517,
'DOUBLE-STRUCK ITALIC SMALL D': 8518,
'DOUBLE-STRUCK ITALIC SMALL E': 8519,
'DOUBLE-STRUCK ITALIC SMALL I': 8520,
'DOUBLE-STRUCK ITALIC SMALL J': 8521,
'DOUBLE-STRUCK N-ARY SUMMATION': 8512,
'DOUBLE-STRUCK SMALL GAMMA': 8509,
'DOUBLE-STRUCK SMALL PI': 8508,
'DOUBLED FEMALE SIGN': 9890,
'DOUBLED MALE SIGN': 9891,
'DOWN ARROWHEAD': 8964,
'DOWN FISH TAIL': 10623,
'DOWN RIGHT DIAGONAL ELLIPSIS': 8945,
'DOWN TACK': 8868,
'DOWN TACK WITH CIRCLE BELOW': 10993,
'DOWN-POINTING TRIANGLE WITH LEFT HALF BLACK': 10728,
'DOWN-POINTING TRIANGLE WITH RIGHT HALF BLACK': 10729,
'DOWNWARDS ANCORA': 11796,
'DOWNWARDS ARROW': 8595,
'DOWNWARDS ARROW FROM BAR': 8615,
'DOWNWARDS ARROW LEFTWARDS OF UPWARDS ARROW': 8693,
'DOWNWARDS ARROW TO BAR': 10515,
'DOWNWARDS ARROW WITH CORNER LEFTWARDS': 8629,
'DOWNWARDS ARROW WITH DOUBLE STROKE': 8671,
'DOWNWARDS ARROW WITH HORIZONTAL STROKE': 10504,
'DOWNWARDS ARROW WITH TIP LEFTWARDS': 8626,
'DOWNWARDS ARROW WITH TIP RIGHTWARDS': 8627,
'DOWNWARDS BLACK ARROW': 11015,
'DOWNWARDS DASHED ARROW': 8675,
'DOWNWARDS DOUBLE ARROW': 8659,
'DOWNWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT': 10597,
'DOWNWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT': 10607,
'DOWNWARDS HARPOON WITH BARB LEFT FROM BAR': 10593,
'DOWNWARDS HARPOON WITH BARB LEFT TO BAR': 10585,
'DOWNWARDS HARPOON WITH BARB LEFTWARDS': 8643,
'DOWNWARDS HARPOON WITH BARB RIGHT FROM BAR': 10589,
'DOWNWARDS HARPOON WITH BARB RIGHT TO BAR': 10581,
'DOWNWARDS HARPOON WITH BARB RIGHTWARDS': 8642,
'DOWNWARDS PAIRED ARROWS': 8650,
'DOWNWARDS QUADRUPLE ARROW': 10225,
'DOWNWARDS TRIPLE ARROW': 10507,
'DOWNWARDS TWO HEADED ARROW': 8609,
'DOWNWARDS WHITE ARROW': 8681,
'DOWNWARDS ZIGZAG ARROW': 8623,
'DRACHMA SIGN': 8367,
'DRAFTING POINT RIGHTWARDS ARROW': 10139,
'EARTH': 9793,
'EARTH GROUND': 9178,
'EAST SYRIAC CROSS': 9841,
'EDITORIAL CORONIS': 11790,
'EIGHT PETALLED OUTLINED BLACK FLORETTE': 10049,
'EIGHT POINTED BLACK STAR': 10036,
'EIGHT POINTED PINWHEEL STAR': 10037,
'EIGHT POINTED RECTILINEAR BLACK STAR': 10039,
'EIGHT SPOKED ASTERISK': 10035,
'EIGHT TEARDROP-SPOKED PROPELLER ASTERISK': 10058,
'EIGHTH NOTE': 9834,
'EJECT SYMBOL': 9167,
'ELECTRIC ARROW': 8961,
'ELEMENT OF': 8712,
'ELEMENT OF OPENING DOWNWARDS': 10969,
'ELEMENT OF OPENING UPWARDS': 10194,
'ELEMENT OF WITH DOT ABOVE': 8949,
'ELEMENT OF WITH LONG HORIZONTAL STROKE': 8946,
'ELEMENT OF WITH OVERBAR': 8950,
'ELEMENT OF WITH TWO HORIZONTAL STROKES': 8953,
'ELEMENT OF WITH UNDERBAR': 8952,
'ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE': 8947,
'EM DASH': 8212,
'EM QUAD': 8193,
'EM SPACE': 8195,
'EMPHASIS SYMBOL': 9091,
'EMPTY SET': 8709,
'EMPTY SET WITH LEFT ARROW ABOVE': 10676,
'EMPTY SET WITH OVERBAR': 10673,
'EMPTY SET WITH RIGHT ARROW ABOVE': 10675,
'EMPTY SET WITH SMALL CIRCLE ABOVE': 10674,
'EN DASH': 8211,
'EN QUAD': 8192,
'EN SPACE': 8194,
'END OF PROOF': 8718,
'ENTER SYMBOL': 9094,
'ENVELOPE': 9993,
'EQUAL AND PARALLEL TO': 8917,
'EQUAL TO BY DEFINITION': 8797,
'EQUAL TO OR GREATER-THAN': 8925,
'EQUAL TO OR LESS-THAN': 8924,
'EQUAL TO OR PRECEDES': 8926,
'EQUAL TO OR SUCCEEDS': 8927,
'EQUALS COLON': 8789,
'EQUALS SIGN': 61,
'EQUALS SIGN ABOVE PLUS SIGN': 10865,
'EQUALS SIGN ABOVE RIGHTWARDS ARROW': 10609,
'EQUALS SIGN ABOVE TILDE OPERATOR': 10867,
'EQUALS SIGN AND SLANTED PARALLEL': 10723,
'EQUALS SIGN AND SLANTED PARALLEL WITH TILDE ABOVE': 10724,
'EQUALS SIGN WITH BUMPY ABOVE': 10926,
'EQUALS SIGN WITH DOT BELOW': 10854,
'EQUALS SIGN WITH TWO DOTS ABOVE AND TWO DOTS BELOW': 10871,
'EQUALS WITH ASTERISK': 10862,
'EQUIANGULAR TO': 8794,
'EQUIVALENT TO': 8781,
'EQUIVALENT WITH FOUR DOTS ABOVE': 10872,
'ERASE TO THE LEFT': 9003,
'ERASE TO THE RIGHT': 8998,
'ERROR-BARRED BLACK CIRCLE': 10739,
'ERROR-BARRED BLACK DIAMOND': 10737,
'ERROR-BARRED BLACK SQUARE': 10735,
'ERROR-BARRED WHITE CIRCLE': 10738,
'ERROR-BARRED WHITE DIAMOND': 10736,
'ERROR-BARRED WHITE SQUARE': 10734,
'ESTIMATED SYMBOL': 8494,
'ESTIMATES': 8793,
'ETHIOPIC COLON': 4965,
'ETHIOPIC COMBINING GEMINATION MARK': 4959,
'ETHIOPIC COMMA': 4963,
'ETHIOPIC DIGIT EIGHT': 4976,
'ETHIOPIC DIGIT FIVE': 4973,
'ETHIOPIC DIGIT FOUR': 4972,
'ETHIOPIC DIGIT NINE': 4977,
'ETHIOPIC DIGIT ONE': 4969,
'ETHIOPIC DIGIT SEVEN': 4975,
'ETHIOPIC DIGIT SIX': 4974,
'ETHIOPIC DIGIT THREE': 4971,
'ETHIOPIC DIGIT TWO': 4970,
'ETHIOPIC FULL STOP': 4962,
'ETHIOPIC NUMBER EIGHTY': 4985,
'ETHIOPIC NUMBER FIFTY': 4982,
'ETHIOPIC NUMBER FORTY': 4981,
'ETHIOPIC NUMBER HUNDRED': 4987,
'ETHIOPIC NUMBER NINETY': 4986,
'ETHIOPIC NUMBER SEVENTY': 4984,
'ETHIOPIC NUMBER SIXTY': 4983,
'ETHIOPIC NUMBER TEN': 4978,
'ETHIOPIC NUMBER TEN THOUSAND': 4988,
'ETHIOPIC NUMBER THIRTY': 4980,
'ETHIOPIC NUMBER TWENTY': 4979,
'ETHIOPIC PARAGRAPH SEPARATOR': 4968,
'ETHIOPIC PREFACE COLON': 4966,
'ETHIOPIC QUESTION MARK': 4967,
'ETHIOPIC SECTION MARK': 4960,
'ETHIOPIC SEMICOLON': 4964,
'ETHIOPIC SYLLABLE BA': 4704,
'ETHIOPIC SYLLABLE BAA': 4707,
'ETHIOPIC SYLLABLE BE': 4709,
'ETHIOPIC SYLLABLE BEE': 4708,
'ETHIOPIC SYLLABLE BI': 4706,
'ETHIOPIC SYLLABLE BO': 4710,
'ETHIOPIC SYLLABLE BOA': 11653,
'ETHIOPIC SYLLABLE BU': 4705,
'ETHIOPIC SYLLABLE BWA': 4711,
'ETHIOPIC SYLLABLE BWE': 4999,
'ETHIOPIC SYLLABLE BWEE': 4998,
'ETHIOPIC SYLLABLE BWI': 4997,
'ETHIOPIC SYLLABLE CA': 4728,
'ETHIOPIC SYLLABLE CAA': 4731,
'ETHIOPIC SYLLABLE CCA': 11688,
'ETHIOPIC SYLLABLE CCAA': 11691,
'ETHIOPIC SYLLABLE CCE': 11693,
'ETHIOPIC SYLLABLE CCEE': 11692,
'ETHIOPIC SYLLABLE CCHA': 11704,
'ETHIOPIC SYLLABLE CCHAA': 11707,
'ETHIOPIC SYLLABLE CCHE': 11709,
'ETHIOPIC SYLLABLE CCHEE': 11708,
'ETHIOPIC SYLLABLE CCHI': 11706,
'ETHIOPIC SYLLABLE CCHO': 11710,
'ETHIOPIC SYLLABLE CCHU': 11705,
'ETHIOPIC SYLLABLE CCI': 11690,
'ETHIOPIC SYLLABLE CCO': 11694,
'ETHIOPIC SYLLABLE CCU': 11689,
'ETHIOPIC SYLLABLE CE': 4733,
'ETHIOPIC SYLLABLE CEE': 4732,
'ETHIOPIC SYLLABLE CHA': 4904,
'ETHIOPIC SYLLABLE CHAA': 4907,
'ETHIOPIC SYLLABLE CHE': 4909,
'ETHIOPIC SYLLABLE CHEE': 4908,
'ETHIOPIC SYLLABLE CHI': 4906,
'ETHIOPIC SYLLABLE CHO': 4910,
'ETHIOPIC SYLLABLE CHOA': 11664,
'ETHIOPIC SYLLABLE CHU': 4905,
'ETHIOPIC SYLLABLE CHWA': 4911,
'ETHIOPIC SYLLABLE CI': 4730,
'ETHIOPIC SYLLABLE CO': 4734,
'ETHIOPIC SYLLABLE COA': 11655,
'ETHIOPIC SYLLABLE CU': 4729,
'ETHIOPIC SYLLABLE CWA': 4735,
'ETHIOPIC SYLLABLE DA': 4848,
'ETHIOPIC SYLLABLE DAA': 4851,
'ETHIOPIC SYLLABLE DDA': 4856,
'ETHIOPIC SYLLABLE DDAA': 4859,
'ETHIOPIC SYLLABLE DDE': 4861,
'ETHIOPIC SYLLABLE DDEE': 4860,
'ETHIOPIC SYLLABLE DDI': 4858,
'ETHIOPIC SYLLABLE DDO': 4862,
'ETHIOPIC SYLLABLE DDOA': 11661,
'ETHIOPIC SYLLABLE DDU': 4857,
'ETHIOPIC SYLLABLE DDWA': 4863,
'ETHIOPIC SYLLABLE DE': 4853,
'ETHIOPIC SYLLABLE DEE': 4852,
'ETHIOPIC SYLLABLE DI': 4850,
'ETHIOPIC SYLLABLE DO': 4854,
'ETHIOPIC SYLLABLE DOA': 11660,
'ETHIOPIC SYLLABLE DU': 4849,
'ETHIOPIC SYLLABLE DWA': 4855,
'ETHIOPIC SYLLABLE FA': 4936,
'ETHIOPIC SYLLABLE FAA': 4939,
'ETHIOPIC SYLLABLE FE': 4941,
'ETHIOPIC SYLLABLE FEE': 4940,
'ETHIOPIC SYLLABLE FI': 4938,
'ETHIOPIC SYLLABLE FO': 4942,
'ETHIOPIC SYLLABLE FU': 4937,
'ETHIOPIC SYLLABLE FWA': 4943,
'ETHIOPIC SYLLABLE FWE': 5003,
'ETHIOPIC SYLLABLE FWEE': 5002,
'ETHIOPIC SYLLABLE FWI': 5001,
'ETHIOPIC SYLLABLE FYA': 4954,
'ETHIOPIC SYLLABLE GA': 4872,
'ETHIOPIC SYLLABLE GAA': 4875,
'ETHIOPIC SYLLABLE GE': 4877,
'ETHIOPIC SYLLABLE GEE': 4876,
'ETHIOPIC SYLLABLE GGA': 4888,
'ETHIOPIC SYLLABLE GGAA': 4891,
'ETHIOPIC SYLLABLE GGE': 4893,
'ETHIOPIC SYLLABLE GGEE': 4892,
'ETHIOPIC SYLLABLE GGI': 4890,
'ETHIOPIC SYLLABLE GGO': 4894,
'ETHIOPIC SYLLABLE GGU': 4889,
'ETHIOPIC SYLLABLE GGWA': 11667,
'ETHIOPIC SYLLABLE GGWAA': 4895,
'ETHIOPIC SYLLABLE GGWE': 11670,
'ETHIOPIC SYLLABLE GGWEE': 11669,
'ETHIOPIC SYLLABLE GGWI': 11668,
'ETHIOPIC SYLLABLE GI': 4874,
'ETHIOPIC SYLLABLE GLOTTAL A': 4768,
'ETHIOPIC SYLLABLE GLOTTAL AA': 4771,
'ETHIOPIC SYLLABLE GLOTTAL E': 4773,
'ETHIOPIC SYLLABLE GLOTTAL EE': 4772,
'ETHIOPIC SYLLABLE GLOTTAL I': 4770,
'ETHIOPIC SYLLABLE GLOTTAL O': 4774,
'ETHIOPIC SYLLABLE GLOTTAL OA': 11658,
'ETHIOPIC SYLLABLE GLOTTAL U': 4769,
'ETHIOPIC SYLLABLE GLOTTAL WA': 4775,
'ETHIOPIC SYLLABLE GO': 4878,
'ETHIOPIC SYLLABLE GOA': 4879,
'ETHIOPIC SYLLABLE GU': 4873,
'ETHIOPIC SYLLABLE GWA': 4880,
'ETHIOPIC SYLLABLE GWAA': 4883,
'ETHIOPIC SYLLABLE GWE': 4885,
'ETHIOPIC SYLLABLE GWEE': 4884,
'ETHIOPIC SYLLABLE GWI': 4882,
'ETHIOPIC SYLLABLE GYA': 11736,
'ETHIOPIC SYLLABLE GYAA': 11739,
'ETHIOPIC SYLLABLE GYE': 11741,
'ETHIOPIC SYLLABLE GYEE': 11740,
'ETHIOPIC SYLLABLE GYI': 11738,
'ETHIOPIC SYLLABLE GYO': 11742,
'ETHIOPIC SYLLABLE GYU': 11737,
'ETHIOPIC SYLLABLE HA': 4608,
'ETHIOPIC SYLLABLE HAA': 4611,
'ETHIOPIC SYLLABLE HE': 4613,
'ETHIOPIC SYLLABLE HEE': 4612,
'ETHIOPIC SYLLABLE HHA': 4624,
'ETHIOPIC SYLLABLE HHAA': 4627,
'ETHIOPIC SYLLABLE HHE': 4629,
'ETHIOPIC SYLLABLE HHEE': 4628,
'ETHIOPIC SYLLABLE HHI': 4626,
'ETHIOPIC SYLLABLE HHO': 4630,
'ETHIOPIC SYLLABLE HHU': 4625,
'ETHIOPIC SYLLABLE HHWA': 4631,
'ETHIOPIC SYLLABLE HI': 4610,
'ETHIOPIC SYLLABLE HO': 4614,
'ETHIOPIC SYLLABLE HOA': 4615,
'ETHIOPIC SYLLABLE HU': 4609,
'ETHIOPIC SYLLABLE JA': 4864,
'ETHIOPIC SYLLABLE JAA': 4867,
'ETHIOPIC SYLLABLE JE': 4869,
'ETHIOPIC SYLLABLE JEE': 4868,
'ETHIOPIC SYLLABLE JI': 4866,
'ETHIOPIC SYLLABLE JO': 4870,
'ETHIOPIC SYLLABLE JOA': 11662,
'ETHIOPIC SYLLABLE JU': 4865,
'ETHIOPIC SYLLABLE JWA': 4871,
'ETHIOPIC SYLLABLE KA': 4776,
'ETHIOPIC SYLLABLE KAA': 4779,
'ETHIOPIC SYLLABLE KE': 4781,
'ETHIOPIC SYLLABLE KEE': 4780,
'ETHIOPIC SYLLABLE KI': 4778,
'ETHIOPIC SYLLABLE KO': 4782,
'ETHIOPIC SYLLABLE KOA': 4783,
'ETHIOPIC SYLLABLE KU': 4777,
'ETHIOPIC SYLLABLE KWA': 4784,
'ETHIOPIC SYLLABLE KWAA': 4787,
'ETHIOPIC SYLLABLE KWE': 4789,
'ETHIOPIC SYLLABLE KWEE': 4788,
'ETHIOPIC SYLLABLE KWI': 4786,
'ETHIOPIC SYLLABLE KXA': 4792,
'ETHIOPIC SYLLABLE KXAA': 4795,
'ETHIOPIC SYLLABLE KXE': 4797,
'ETHIOPIC SYLLABLE KXEE': 4796,
'ETHIOPIC SYLLABLE KXI': 4794,
'ETHIOPIC SYLLABLE KXO': 4798,
'ETHIOPIC SYLLABLE KXU': 4793,
'ETHIOPIC SYLLABLE KXWA': 4800,
'ETHIOPIC SYLLABLE KXWAA': 4803,
'ETHIOPIC SYLLABLE KXWE': 4805,
'ETHIOPIC SYLLABLE KXWEE': 4804,
'ETHIOPIC SYLLABLE KXWI': 4802,
'ETHIOPIC SYLLABLE KYA': 11720,
'ETHIOPIC SYLLABLE KYAA': 11723,
'ETHIOPIC SYLLABLE KYE': 11725,
'ETHIOPIC SYLLABLE KYEE': 11724,
'ETHIOPIC SYLLABLE KYI': 11722,
'ETHIOPIC SYLLABLE KYO': 11726,
'ETHIOPIC SYLLABLE KYU': 11721,
'ETHIOPIC SYLLABLE LA': 4616,
'ETHIOPIC SYLLABLE LAA': 4619,
'ETHIOPIC SYLLABLE LE': 4621,
'ETHIOPIC SYLLABLE LEE': 4620,
'ETHIOPIC SYLLABLE LI': 4618,
'ETHIOPIC SYLLABLE LO': 4622,
'ETHIOPIC SYLLABLE LOA': 11648,
'ETHIOPIC SYLLABLE LU': 4617,
'ETHIOPIC SYLLABLE LWA': 4623,
'ETHIOPIC SYLLABLE MA': 4632,
'ETHIOPIC SYLLABLE MAA': 4635,
'ETHIOPIC SYLLABLE ME': 4637,
'ETHIOPIC SYLLABLE MEE': 4636,
'ETHIOPIC SYLLABLE MI': 4634,
'ETHIOPIC SYLLABLE MO': 4638,
'ETHIOPIC SYLLABLE MOA': 11649,
'ETHIOPIC SYLLABLE MU': 4633,
'ETHIOPIC SYLLABLE MWA': 4639,
'ETHIOPIC SYLLABLE MWE': 4995,
'ETHIOPIC SYLLABLE MWEE': 4994,
'ETHIOPIC SYLLABLE MWI': 4993,
'ETHIOPIC SYLLABLE MYA': 4953,
'ETHIOPIC SYLLABLE NA': 4752,
'ETHIOPIC SYLLABLE NAA': 4755,
'ETHIOPIC SYLLABLE NE': 4757,
'ETHIOPIC SYLLABLE NEE': 4756,
'ETHIOPIC SYLLABLE NI': 4754,
'ETHIOPIC SYLLABLE NO': 4758,
'ETHIOPIC SYLLABLE NOA': 11656,
'ETHIOPIC SYLLABLE NU': 4753,
'ETHIOPIC SYLLABLE NWA': 4759,
'ETHIOPIC SYLLABLE NYA': 4760,
'ETHIOPIC SYLLABLE NYAA': 4763,
'ETHIOPIC SYLLABLE NYE': 4765,
'ETHIOPIC SYLLABLE NYEE': 4764,
'ETHIOPIC SYLLABLE NYI': 4762,
'ETHIOPIC SYLLABLE NYO': 4766,
'ETHIOPIC SYLLABLE NYOA': 11657,
'ETHIOPIC SYLLABLE NYU': 4761,
'ETHIOPIC SYLLABLE NYWA': 4767,
'ETHIOPIC SYLLABLE PA': 4944,
'ETHIOPIC SYLLABLE PAA': 4947,
'ETHIOPIC SYLLABLE PE': 4949,
'ETHIOPIC SYLLABLE PEE': 4948,
'ETHIOPIC SYLLABLE PHA': 4912,
'ETHIOPIC SYLLABLE PHAA': 4915,
'ETHIOPIC SYLLABLE PHARYNGEAL A': 4816,
'ETHIOPIC SYLLABLE PHARYNGEAL AA': 4819,
'ETHIOPIC SYLLABLE PHARYNGEAL E': 4821,
'ETHIOPIC SYLLABLE PHARYNGEAL EE': 4820,
'ETHIOPIC SYLLABLE PHARYNGEAL I': 4818,
'ETHIOPIC SYLLABLE PHARYNGEAL O': 4822,
'ETHIOPIC SYLLABLE PHARYNGEAL U': 4817,
'ETHIOPIC SYLLABLE PHE': 4917,
'ETHIOPIC SYLLABLE PHEE': 4916,
'ETHIOPIC SYLLABLE PHI': 4914,
'ETHIOPIC SYLLABLE PHO': 4918,
'ETHIOPIC SYLLABLE PHOA': 11665,
'ETHIOPIC SYLLABLE PHU': 4913,
'ETHIOPIC SYLLABLE PHWA': 4919,
'ETHIOPIC SYLLABLE PI': 4946,
'ETHIOPIC SYLLABLE PO': 4950,
'ETHIOPIC SYLLABLE POA': 11666,
'ETHIOPIC SYLLABLE PU': 4945,
'ETHIOPIC SYLLABLE PWA': 4951,
'ETHIOPIC SYLLABLE PWE': 5007,
'ETHIOPIC SYLLABLE PWEE': 5006,
'ETHIOPIC SYLLABLE PWI': 5005,
'ETHIOPIC SYLLABLE QA': 4672,
'ETHIOPIC SYLLABLE QAA': 4675,
'ETHIOPIC SYLLABLE QE': 4677,
'ETHIOPIC SYLLABLE QEE': 4676,
'ETHIOPIC SYLLABLE QHA': 4688,
'ETHIOPIC SYLLABLE QHAA': 4691,
'ETHIOPIC SYLLABLE QHE': 4693,
'ETHIOPIC SYLLABLE QHEE': 4692,
'ETHIOPIC SYLLABLE QHI': 4690,
'ETHIOPIC SYLLABLE QHO': 4694,
'ETHIOPIC SYLLABLE QHU': 4689,
'ETHIOPIC SYLLABLE QHWA': 4696,
'ETHIOPIC SYLLABLE QHWAA': 4699,
'ETHIOPIC SYLLABLE QHWE': 4701,
'ETHIOPIC SYLLABLE QHWEE': 4700,
'ETHIOPIC SYLLABLE QHWI': 4698,
'ETHIOPIC SYLLABLE QI': 4674,
'ETHIOPIC SYLLABLE QO': 4678,
'ETHIOPIC SYLLABLE QOA': 4679,
'ETHIOPIC SYLLABLE QU': 4673,
'ETHIOPIC SYLLABLE QWA': 4680,
'ETHIOPIC SYLLABLE QWAA': 4683,
'ETHIOPIC SYLLABLE QWE': 4685,
'ETHIOPIC SYLLABLE QWEE': 4684,
'ETHIOPIC SYLLABLE QWI': 4682,
'ETHIOPIC SYLLABLE QYA': 11712,
'ETHIOPIC SYLLABLE QYAA': 11715,
'ETHIOPIC SYLLABLE QYE': 11717,
'ETHIOPIC SYLLABLE QYEE': 11716,
'ETHIOPIC SYLLABLE QYI': 11714,
'ETHIOPIC SYLLABLE QYO': 11718,
'ETHIOPIC SYLLABLE QYU': 11713,
'ETHIOPIC SYLLABLE RA': 4648,
'ETHIOPIC SYLLABLE RAA': 4651,
'ETHIOPIC SYLLABLE RE': 4653,
'ETHIOPIC SYLLABLE REE': 4652,
'ETHIOPIC SYLLABLE RI': 4650,
'ETHIOPIC SYLLABLE RO': 4654,
'ETHIOPIC SYLLABLE ROA': 11650,
'ETHIOPIC SYLLABLE RU': 4649,
'ETHIOPIC SYLLABLE RWA': 4655,
'ETHIOPIC SYLLABLE RYA': 4952,
'ETHIOPIC SYLLABLE SA': 4656,
'ETHIOPIC SYLLABLE SAA': 4659,
'ETHIOPIC SYLLABLE SE': 4661,
'ETHIOPIC SYLLABLE SEBATBEIT BWA': 4996,
'ETHIOPIC SYLLABLE SEBATBEIT FWA': 5000,
'ETHIOPIC SYLLABLE SEBATBEIT MWA': 4992,
'ETHIOPIC SYLLABLE SEBATBEIT PWA': 5004,
'ETHIOPIC SYLLABLE SEE': 4660,
'ETHIOPIC SYLLABLE SHA': 4664,
'ETHIOPIC SYLLABLE SHAA': 4667,
'ETHIOPIC SYLLABLE SHE': 4669,
'ETHIOPIC SYLLABLE SHEE': 4668,
'ETHIOPIC SYLLABLE SHI': 4666,
'ETHIOPIC SYLLABLE SHO': 4670,
'ETHIOPIC SYLLABLE SHOA': 11652,
'ETHIOPIC SYLLABLE SHU': 4665,
'ETHIOPIC SYLLABLE SHWA': 4671,
'ETHIOPIC SYLLABLE SI': 4658,
'ETHIOPIC SYLLABLE SO': 4662,
'ETHIOPIC SYLLABLE SOA': 11651,
'ETHIOPIC SYLLABLE SSA': 11680,
'ETHIOPIC SYLLABLE SSAA': 11683,
'ETHIOPIC SYLLABLE SSE': 11685,
'ETHIOPIC SYLLABLE SSEE': 11684,
'ETHIOPIC SYLLABLE SSI': 11682,
'ETHIOPIC SYLLABLE SSO': 11686,
'ETHIOPIC SYLLABLE SSU': 11681,
'ETHIOPIC SYLLABLE SU': 4657,
'ETHIOPIC SYLLABLE SWA': 4663,
'ETHIOPIC SYLLABLE SZA': 4640,
'ETHIOPIC SYLLABLE SZAA': 4643,
'ETHIOPIC SYLLABLE SZE': 4645,
'ETHIOPIC SYLLABLE SZEE': 4644,
'ETHIOPIC SYLLABLE SZI': 4642,
'ETHIOPIC SYLLABLE SZO': 4646,
'ETHIOPIC SYLLABLE SZU': 4641,
'ETHIOPIC SYLLABLE SZWA': 4647,
'ETHIOPIC SYLLABLE TA': 4720,
'ETHIOPIC SYLLABLE TAA': 4723,
'ETHIOPIC SYLLABLE TE': 4725,
'ETHIOPIC SYLLABLE TEE': 4724,
'ETHIOPIC SYLLABLE THA': 4896,
'ETHIOPIC SYLLABLE THAA': 4899,
'ETHIOPIC SYLLABLE THE': 4901,
'ETHIOPIC SYLLABLE THEE': 4900,
'ETHIOPIC SYLLABLE THI': 4898,
'ETHIOPIC SYLLABLE THO': 4902,
'ETHIOPIC SYLLABLE THOA': 11663,
'ETHIOPIC SYLLABLE THU': 4897,
'ETHIOPIC SYLLABLE THWA': 4903,
'ETHIOPIC SYLLABLE TI': 4722,
'ETHIOPIC SYLLABLE TO': 4726,
'ETHIOPIC SYLLABLE TOA': 11654,
'ETHIOPIC SYLLABLE TSA': 4920,
'ETHIOPIC SYLLABLE TSAA': 4923,
'ETHIOPIC SYLLABLE TSE': 4925,
'ETHIOPIC SYLLABLE TSEE': 4924,
'ETHIOPIC SYLLABLE TSI': 4922,
'ETHIOPIC SYLLABLE TSO': 4926,
'ETHIOPIC SYLLABLE TSU': 4921,
'ETHIOPIC SYLLABLE TSWA': 4927,
'ETHIOPIC SYLLABLE TU': 4721,
'ETHIOPIC SYLLABLE TWA': 4727,
'ETHIOPIC SYLLABLE TZA': 4928,
'ETHIOPIC SYLLABLE TZAA': 4931,
'ETHIOPIC SYLLABLE TZE': 4933,
'ETHIOPIC SYLLABLE TZEE': 4932,
'ETHIOPIC SYLLABLE TZI': 4930,
'ETHIOPIC SYLLABLE TZO': 4934,
'ETHIOPIC SYLLABLE TZOA': 4935,
'ETHIOPIC SYLLABLE TZU': 4929,
'ETHIOPIC SYLLABLE VA': 4712,
'ETHIOPIC SYLLABLE VAA': 4715,
'ETHIOPIC SYLLABLE VE': 4717,
'ETHIOPIC SYLLABLE VEE': 4716,
'ETHIOPIC SYLLABLE VI': 4714,
'ETHIOPIC SYLLABLE VO': 4718,
'ETHIOPIC SYLLABLE VU': 4713,
'ETHIOPIC SYLLABLE VWA': 4719,
'ETHIOPIC SYLLABLE WA': 4808,
'ETHIOPIC SYLLABLE WAA': 4811,
'ETHIOPIC SYLLABLE WE': 4813,
'ETHIOPIC SYLLABLE WEE': 4812,
'ETHIOPIC SYLLABLE WI': 4810,
'ETHIOPIC SYLLABLE WO': 4814,
'ETHIOPIC SYLLABLE WOA': 4815,
'ETHIOPIC SYLLABLE WU': 4809,
'ETHIOPIC SYLLABLE XA': 4736,
'ETHIOPIC SYLLABLE XAA': 4739,
'ETHIOPIC SYLLABLE XE': 4741,
'ETHIOPIC SYLLABLE XEE': 4740,
'ETHIOPIC SYLLABLE XI': 4738,
'ETHIOPIC SYLLABLE XO': 4742,
'ETHIOPIC SYLLABLE XOA': 4743,
'ETHIOPIC SYLLABLE XU': 4737,
'ETHIOPIC SYLLABLE XWA': 4744,
'ETHIOPIC SYLLABLE XWAA': 4747,
'ETHIOPIC SYLLABLE XWE': 4749,
'ETHIOPIC SYLLABLE XWEE': 4748,
'ETHIOPIC SYLLABLE XWI': 4746,
'ETHIOPIC SYLLABLE XYA': 11728,
'ETHIOPIC SYLLABLE XYAA': 11731,
'ETHIOPIC SYLLABLE XYE': 11733,
'ETHIOPIC SYLLABLE XYEE': 11732,
'ETHIOPIC SYLLABLE XYI': 11730,
'ETHIOPIC SYLLABLE XYO': 11734,
'ETHIOPIC SYLLABLE XYU': 11729,
'ETHIOPIC SYLLABLE YA': 4840,
'ETHIOPIC SYLLABLE YAA': 4843,
'ETHIOPIC SYLLABLE YE': 4845,
'ETHIOPIC SYLLABLE YEE': 4844,
'ETHIOPIC SYLLABLE YI': 4842,
'ETHIOPIC SYLLABLE YO': 4846,
'ETHIOPIC SYLLABLE YOA': 4847,
'ETHIOPIC SYLLABLE YU': 4841,
'ETHIOPIC SYLLABLE ZA': 4824,
'ETHIOPIC SYLLABLE ZAA': 4827,
'ETHIOPIC SYLLABLE ZE': 4829,
'ETHIOPIC SYLLABLE ZEE': 4828,
'ETHIOPIC SYLLABLE ZHA': 4832,
'ETHIOPIC SYLLABLE ZHAA': 4835,
'ETHIOPIC SYLLABLE ZHE': 4837,
'ETHIOPIC SYLLABLE ZHEE': 4836,
'ETHIOPIC SYLLABLE ZHI': 4834,
'ETHIOPIC SYLLABLE ZHO': 4838,
'ETHIOPIC SYLLABLE ZHU': 4833,
'ETHIOPIC SYLLABLE ZHWA': 4839,
'ETHIOPIC SYLLABLE ZI': 4826,
'ETHIOPIC SYLLABLE ZO': 4830,
'ETHIOPIC SYLLABLE ZOA': 11659,
'ETHIOPIC SYLLABLE ZU': 4825,
'ETHIOPIC SYLLABLE ZWA': 4831,
'ETHIOPIC SYLLABLE ZZA': 11696,
'ETHIOPIC SYLLABLE ZZAA': 11699,
'ETHIOPIC SYLLABLE ZZE': 11701,
'ETHIOPIC SYLLABLE ZZEE': 11700,
'ETHIOPIC SYLLABLE ZZI': 11698,
'ETHIOPIC SYLLABLE ZZO': 11702,
'ETHIOPIC SYLLABLE ZZU': 11697,
'ETHIOPIC TONAL MARK CHIRET': 5014,
'ETHIOPIC TONAL MARK DERET': 5009,
'ETHIOPIC TONAL MARK DERET-HIDET': 5016,
'ETHIOPIC TONAL MARK DIFAT': 5012,
'ETHIOPIC TONAL MARK HIDET': 5015,
'ETHIOPIC TONAL MARK KENAT': 5013,
'ETHIOPIC TONAL MARK KURT': 5017,
'ETHIOPIC TONAL MARK RIKRIK': 5010,
'ETHIOPIC TONAL MARK SHORT RIKRIK': 5011,
'ETHIOPIC TONAL MARK YIZET': 5008,
'ETHIOPIC WORDSPACE': 4961,
'EULER CONSTANT': 8455,
'EURO SIGN': 8364,
'EURO-CURRENCY SIGN': 8352,
'EXCESS': 8761,
'EXCLAMATION MARK': 33,
'EXCLAMATION QUESTION MARK': 8265,
'EXTENDED ARABIC-INDIC DIGIT EIGHT': 1784,
'EXTENDED ARABIC-INDIC DIGIT FIVE': 1781,
'EXTENDED ARABIC-INDIC DIGIT FOUR': 1780,
'EXTENDED ARABIC-INDIC DIGIT NINE': 1785,
'EXTENDED ARABIC-INDIC DIGIT ONE': 1777,
'EXTENDED ARABIC-INDIC DIGIT SEVEN': 1783,
'EXTENDED ARABIC-INDIC DIGIT SIX': 1782,
'EXTENDED ARABIC-INDIC DIGIT THREE': 1779,
'EXTENDED ARABIC-INDIC DIGIT TWO': 1778,
'EXTENDED ARABIC-INDIC DIGIT ZERO': 1776,
'FACSIMILE SIGN': 8507,
'FALLING DIAGONAL CROSSING NORTH EAST ARROW': 10543,
'FALLING DIAGONAL CROSSING RISING DIAGONAL': 10540,
'FARSI SYMBOL': 9771,
'FEMALE SIGN': 9792,
'FEMININE ORDINAL INDICATOR': 170,
'FIGURE DASH': 8210,
'FIGURE SPACE': 8199,
'FINITE PART INTEGRAL': 10765,
'FIRST QUARTER MOON': 9789,
'FISHEYE': 9673,
'FIVE DOT PUNCTUATION': 8281,
'FLEUR-DE-LIS': 9884,
'FLORAL HEART': 10086,
'FLOWER': 9880,
'FLOWER PUNCTUATION MARK': 8277,
'FOR ALL': 8704,
'FORCES': 8873,
'FORKED PARAGRAPHOS': 11792,
'FORKING': 10972,
'FOUR BALLOON-SPOKED ASTERISK': 10019,
'FOUR CLUB-SPOKED ASTERISK': 10021,
'FOUR DOT MARK': 8283,
'FOUR DOT PUNCTUATION': 8280,
'FOUR TEARDROP-SPOKED ASTERISK': 10018,
'FOUR-PER-EM SPACE': 8197,
'FOURTH ROOT': 8732,
'FRACTION NUMERATOR ONE': 8543,
'FRACTION SLASH': 8260,
'FRENCH FRANC SIGN': 8355,
'FRONT-TILTED SHADOWED WHITE RIGHTWARDS ARROW': 10156,
'FROWN': 8994,
'FULL BLOCK': 9608,
'FULL OUTER JOIN': 10199,
'FULL STOP': 46,
'FULLWIDTH AMPERSAND': 65286,
'FULLWIDTH APOSTROPHE': 65287,
'FULLWIDTH ASTERISK': 65290,
'FULLWIDTH BROKEN BAR': 65508,
'FULLWIDTH CENT SIGN': 65504,
'FULLWIDTH CIRCUMFLEX ACCENT': 65342,
'FULLWIDTH COLON': 65306,
'FULLWIDTH COMMA': 65292,
'FULLWIDTH COMMERCIAL AT': 65312,
'FULLWIDTH DIGIT EIGHT': 65304,
'FULLWIDTH DIGIT FIVE': 65301,
'FULLWIDTH DIGIT FOUR': 65300,
'FULLWIDTH DIGIT NINE': 65305,
'FULLWIDTH DIGIT ONE': 65297,
'FULLWIDTH DIGIT SEVEN': 65303,
'FULLWIDTH DIGIT SIX': 65302,
'FULLWIDTH DIGIT THREE': 65299,
'FULLWIDTH DIGIT TWO': 65298,
'FULLWIDTH DIGIT ZERO': 65296,
'FULLWIDTH DOLLAR SIGN': 65284,
'FULLWIDTH EQUALS SIGN': 65309,
'FULLWIDTH EXCLAMATION MARK': 65281,
'FULLWIDTH FULL STOP': 65294,
'FULLWIDTH GRAVE ACCENT': 65344,
'FULLWIDTH GREATER-THAN SIGN': 65310,
'FULLWIDTH HYPHEN-MINUS': 65293,
'FULLWIDTH LATIN CAPITAL LETTER A': 65313,
'FULLWIDTH LATIN CAPITAL LETTER B': 65314,
'FULLWIDTH LATIN CAPITAL LETTER C': 65315,
'FULLWIDTH LATIN CAPITAL LETTER D': 65316,
'FULLWIDTH LATIN CAPITAL LETTER E': 65317,
'FULLWIDTH LATIN CAPITAL LETTER F': 65318,
'FULLWIDTH LATIN CAPITAL LETTER G': 65319,
'FULLWIDTH LATIN CAPITAL LETTER H': 65320,
'FULLWIDTH LATIN CAPITAL LETTER I': 65321,
'FULLWIDTH LATIN CAPITAL LETTER J': 65322,
'FULLWIDTH LATIN CAPITAL LETTER K': 65323,
'FULLWIDTH LATIN CAPITAL LETTER L': 65324,
'FULLWIDTH LATIN CAPITAL LETTER M': 65325,
'FULLWIDTH LATIN CAPITAL LETTER N': 65326,
'FULLWIDTH LATIN CAPITAL LETTER O': 65327,
'FULLWIDTH LATIN CAPITAL LETTER P': 65328,
'FULLWIDTH LATIN CAPITAL LETTER Q': 65329,
'FULLWIDTH LATIN CAPITAL LETTER R': 65330,
'FULLWIDTH LATIN CAPITAL LETTER S': 65331,
'FULLWIDTH LATIN CAPITAL LETTER T': 65332,
'FULLWIDTH LATIN CAPITAL LETTER U': 65333,
'FULLWIDTH LATIN CAPITAL LETTER V': 65334,
'FULLWIDTH LATIN CAPITAL LETTER W': 65335,
'FULLWIDTH LATIN CAPITAL LETTER X': 65336,
'FULLWIDTH LATIN CAPITAL LETTER Y': 65337,
'FULLWIDTH LATIN CAPITAL LETTER Z': 65338,
'FULLWIDTH LATIN SMALL LETTER A': 65345,
'FULLWIDTH LATIN SMALL LETTER B': 65346,
'FULLWIDTH LATIN SMALL LETTER C': 65347,
'FULLWIDTH LATIN SMALL LETTER D': 65348,
'FULLWIDTH LATIN SMALL LETTER E': 65349,
'FULLWIDTH LATIN SMALL LETTER F': 65350,
'FULLWIDTH LATIN SMALL LETTER G': 65351,
'FULLWIDTH LATIN SMALL LETTER H': 65352,
'FULLWIDTH LATIN SMALL LETTER I': 65353,
'FULLWIDTH LATIN SMALL LETTER J': 65354,
'FULLWIDTH LATIN SMALL LETTER K': 65355,
'FULLWIDTH LATIN SMALL LETTER L': 65356,
'FULLWIDTH LATIN SMALL LETTER M': 65357,
'FULLWIDTH LATIN SMALL LETTER N': 65358,
'FULLWIDTH LATIN SMALL LETTER O': 65359,
'FULLWIDTH LATIN SMALL LETTER P': 65360,
'FULLWIDTH LATIN SMALL LETTER Q': 65361,
'FULLWIDTH LATIN SMALL LETTER R': 65362,
'FULLWIDTH LATIN SMALL LETTER S': 65363,
'FULLWIDTH LATIN SMALL LETTER T': 65364,
'FULLWIDTH LATIN SMALL LETTER U': 65365,
'FULLWIDTH LATIN SMALL LETTER V': 65366,
'FULLWIDTH LATIN SMALL LETTER W': 65367,
'FULLWIDTH LATIN SMALL LETTER X': 65368,
'FULLWIDTH LATIN SMALL LETTER Y': 65369,
'FULLWIDTH LATIN SMALL LETTER Z': 65370,
'FULLWIDTH LEFT CURLY BRACKET': 65371,
'FULLWIDTH LEFT PARENTHESIS': 65288,
'FULLWIDTH LEFT SQUARE BRACKET': 65339,
'FULLWIDTH LEFT WHITE PARENTHESIS': 65375,
'FULLWIDTH LESS-THAN SIGN': 65308,
'FULLWIDTH LOW LINE': 65343,
'FULLWIDTH MACRON': 65507,
'FULLWIDTH NOT SIGN': 65506,
'FULLWIDTH NUMBER SIGN': 65283,
'FULLWIDTH PERCENT SIGN': 65285,
'FULLWIDTH PLUS SIGN': 65291,
'FULLWIDTH POUND SIGN': 65505,
'FULLWIDTH QUESTION MARK': 65311,
'FULLWIDTH QUOTATION MARK': 65282,
'FULLWIDTH REVERSE SOLIDUS': 65340,
'FULLWIDTH RIGHT CURLY BRACKET': 65373,
'FULLWIDTH RIGHT PARENTHESIS': 65289,
'FULLWIDTH RIGHT SQUARE BRACKET': 65341,
'FULLWIDTH RIGHT WHITE PARENTHESIS': 65376,
'FULLWIDTH SEMICOLON': 65307,
'FULLWIDTH SOLIDUS': 65295,
'FULLWIDTH TILDE': 65374,
'FULLWIDTH VERTICAL LINE': 65372,
'FULLWIDTH WON SIGN': 65510,
'FULLWIDTH YEN SIGN': 65509,
'FUNCTION APPLICATION': 8289,
'FUNERAL URN': 9905,
'FUSE': 9179,
'GEAR': 9881,
'GEMINI': 9802,
'GEOMETRIC PROPORTION': 8762,
'GEOMETRICALLY EQUAL TO': 8785,
'GEOMETRICALLY EQUIVALENT TO': 8782,
'GEORGIAN CAPITAL LETTER AN': 4256,
'GEORGIAN CAPITAL LETTER BAN': 4257,
'GEORGIAN CAPITAL LETTER CAN': 4282,
'GEORGIAN CAPITAL LETTER CHAR': 4285,
'GEORGIAN CAPITAL LETTER CHIN': 4281,
'GEORGIAN CAPITAL LETTER CIL': 4284,
'GEORGIAN CAPITAL LETTER DON': 4259,
'GEORGIAN CAPITAL LETTER EN': 4260,
'GEORGIAN CAPITAL LETTER GAN': 4258,
'GEORGIAN CAPITAL LETTER GHAN': 4278,
'GEORGIAN CAPITAL LETTER HAE': 4288,
'GEORGIAN CAPITAL LETTER HAR': 4292,
'GEORGIAN CAPITAL LETTER HE': 4289,
'GEORGIAN CAPITAL LETTER HIE': 4290,
'GEORGIAN CAPITAL LETTER HOE': 4293,
'GEORGIAN CAPITAL LETTER IN': 4264,
'GEORGIAN CAPITAL LETTER JHAN': 4287,
'GEORGIAN CAPITAL LETTER JIL': 4283,
'GEORGIAN CAPITAL LETTER KAN': 4265,
'GEORGIAN CAPITAL LETTER KHAR': 4277,
'GEORGIAN CAPITAL LETTER LAS': 4266,
'GEORGIAN CAPITAL LETTER MAN': 4267,
'GEORGIAN CAPITAL LETTER NAR': 4268,
'GEORGIAN CAPITAL LETTER ON': 4269,
'GEORGIAN CAPITAL LETTER PAR': 4270,
'GEORGIAN CAPITAL LETTER PHAR': 4276,
'GEORGIAN CAPITAL LETTER QAR': 4279,
'GEORGIAN CAPITAL LETTER RAE': 4272,
'GEORGIAN CAPITAL LETTER SAN': 4273,
'GEORGIAN CAPITAL LETTER SHIN': 4280,
'GEORGIAN CAPITAL LETTER TAN': 4263,
'GEORGIAN CAPITAL LETTER TAR': 4274,
'GEORGIAN CAPITAL LETTER UN': 4275,
'GEORGIAN CAPITAL LETTER VIN': 4261,
'GEORGIAN CAPITAL LETTER WE': 4291,
'GEORGIAN CAPITAL LETTER XAN': 4286,
'GEORGIAN CAPITAL LETTER ZEN': 4262,
'GEORGIAN CAPITAL LETTER ZHAR': 4271,
'GEORGIAN LETTER AIN': 4346,
'GEORGIAN LETTER AN': 4304,
'GEORGIAN LETTER BAN': 4305,
'GEORGIAN LETTER CAN': 4330,
'GEORGIAN LETTER CHAR': 4333,
'GEORGIAN LETTER CHIN': 4329,
'GEORGIAN LETTER CIL': 4332,
'GEORGIAN LETTER DON': 4307,
'GEORGIAN LETTER ELIFI': 4344,
'GEORGIAN LETTER EN': 4308,
'GEORGIAN LETTER FI': 4342,
'GEORGIAN LETTER GAN': 4306,
'GEORGIAN LETTER GHAN': 4326,
'GEORGIAN LETTER HAE': 4336,
'GEORGIAN LETTER HAR': 4340,
'GEORGIAN LETTER HE': 4337,
'GEORGIAN LETTER HIE': 4338,
'GEORGIAN LETTER HOE': 4341,
'GEORGIAN LETTER IN': 4312,
'GEORGIAN LETTER JHAN': 4335,
'GEORGIAN LETTER JIL': 4331,
'GEORGIAN LETTER KAN': 4313,
'GEORGIAN LETTER KHAR': 4325,
'GEORGIAN LETTER LAS': 4314,
'GEORGIAN LETTER MAN': 4315,
'GEORGIAN LETTER NAR': 4316,
'GEORGIAN LETTER ON': 4317,
'GEORGIAN LETTER PAR': 4318,
'GEORGIAN LETTER PHAR': 4324,
'GEORGIAN LETTER QAR': 4327,
'GEORGIAN LETTER RAE': 4320,
'GEORGIAN LETTER SAN': 4321,
'GEORGIAN LETTER SHIN': 4328,
'GEORGIAN LETTER TAN': 4311,
'GEORGIAN LETTER TAR': 4322,
'GEORGIAN LETTER TURNED GAN': 4345,
'GEORGIAN LETTER UN': 4323,
'GEORGIAN LETTER VIN': 4309,
'GEORGIAN LETTER WE': 4339,
'GEORGIAN LETTER XAN': 4334,
'GEORGIAN LETTER YN': 4343,
'GEORGIAN LETTER ZEN': 4310,
'GEORGIAN LETTER ZHAR': 4319,
'GEORGIAN PARAGRAPH SEPARATOR': 4347,
'GEORGIAN SMALL LETTER AN': 11520,
'GEORGIAN SMALL LETTER BAN': 11521,
'GEORGIAN SMALL LETTER CAN': 11546,
'GEORGIAN SMALL LETTER CHAR': 11549,
'GEORGIAN SMALL LETTER CHIN': 11545,
'GEORGIAN SMALL LETTER CIL': 11548,
'GEORGIAN SMALL LETTER DON': 11523,
'GEORGIAN SMALL LETTER EN': 11524,
'GEORGIAN SMALL LETTER GAN': 11522,
'GEORGIAN SMALL LETTER GHAN': 11542,
'GEORGIAN SMALL LETTER HAE': 11552,
'GEORGIAN SMALL LETTER HAR': 11556,
'GEORGIAN SMALL LETTER HE': 11553,
'GEORGIAN SMALL LETTER HIE': 11554,
'GEORGIAN SMALL LETTER HOE': 11557,
'GEORGIAN SMALL LETTER IN': 11528,
'GEORGIAN SMALL LETTER JHAN': 11551,
'GEORGIAN SMALL LETTER JIL': 11547,
'GEORGIAN SMALL LETTER KAN': 11529,
'GEORGIAN SMALL LETTER KHAR': 11541,
'GEORGIAN SMALL LETTER LAS': 11530,
'GEORGIAN SMALL LETTER MAN': 11531,
'GEORGIAN SMALL LETTER NAR': 11532,
'GEORGIAN SMALL LETTER ON': 11533,
'GEORGIAN SMALL LETTER PAR': 11534,
'GEORGIAN SMALL LETTER PHAR': 11540,
'GEORGIAN SMALL LETTER QAR': 11543,
'GEORGIAN SMALL LETTER RAE': 11536,
'GEORGIAN SMALL LETTER SAN': 11537,
'GEORGIAN SMALL LETTER SHIN': 11544,
'GEORGIAN SMALL LETTER TAN': 11527,
'GEORGIAN SMALL LETTER TAR': 11538,
'GEORGIAN SMALL LETTER UN': 11539,
'GEORGIAN SMALL LETTER VIN': 11525,
'GEORGIAN SMALL LETTER WE': 11555,
'GEORGIAN SMALL LETTER XAN': 11550,
'GEORGIAN SMALL LETTER ZEN': 11526,
'GEORGIAN SMALL LETTER ZHAR': 11535,
'GERMAN PENNY SIGN': 8368,
'GETA MARK': 12307,
'GIMEL SYMBOL': 8503,
'GLAGOLITIC CAPITAL LETTER AZU': 11264,
'GLAGOLITIC CAPITAL LETTER BIG YUS': 11304,
'GLAGOLITIC CAPITAL LETTER BUKY': 11265,
'GLAGOLITIC CAPITAL LETTER CHRIVI': 11293,
'GLAGOLITIC CAPITAL LETTER DJERVI': 11276,
'GLAGOLITIC CAPITAL LETTER DOBRO': 11268,
'GLAGOLITIC CAPITAL LETTER DZELO': 11271,
'GLAGOLITIC CAPITAL LETTER FITA': 11306,
'GLAGOLITIC CAPITAL LETTER FRITU': 11287,
'GLAGOLITIC CAPITAL LETTER GLAGOLI': 11267,
'GLAGOLITIC CAPITAL LETTER HERU': 11288,
'GLAGOLITIC CAPITAL LETTER I': 11275,
'GLAGOLITIC CAPITAL LETTER INITIAL IZHE': 11274,
'GLAGOLITIC CAPITAL LETTER IOTATED BIG YUS': 11305,
'GLAGOLITIC CAPITAL LETTER IOTATED SMALL YUS': 11303,
'GLAGOLITIC CAPITAL LETTER IZHE': 11273,
'GLAGOLITIC CAPITAL LETTER IZHITSA': 11307,
'GLAGOLITIC CAPITAL LETTER KAKO': 11277,
'GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE': 11310,
'GLAGOLITIC CAPITAL LETTER LJUDIJE': 11278,
'GLAGOLITIC CAPITAL LETTER MYSLITE': 11279,
'GLAGOLITIC CAPITAL LETTER NASHI': 11280,
'GLAGOLITIC CAPITAL LETTER ONU': 11281,
'GLAGOLITIC CAPITAL LETTER OTU': 11289,
'GLAGOLITIC CAPITAL LETTER PE': 11290,
'GLAGOLITIC CAPITAL LETTER POKOJI': 11282,
'GLAGOLITIC CAPITAL LETTER RITSI': 11283,
'GLAGOLITIC CAPITAL LETTER SHA': 11294,
'GLAGOLITIC CAPITAL LETTER SHTA': 11291,
'GLAGOLITIC CAPITAL LETTER SHTAPIC': 11308,
'GLAGOLITIC CAPITAL LETTER SLOVO': 11284,
'GLAGOLITIC CAPITAL LETTER SMALL YUS': 11300,
'GLAGOLITIC CAPITAL LETTER SMALL YUS WITH TAIL': 11301,
'GLAGOLITIC CAPITAL LETTER SPIDERY HA': 11298,
'GLAGOLITIC CAPITAL LETTER TROKUTASTI A': 11309,
'GLAGOLITIC CAPITAL LETTER TSI': 11292,
'GLAGOLITIC CAPITAL LETTER TVRIDO': 11285,
'GLAGOLITIC CAPITAL LETTER UKU': 11286,
'GLAGOLITIC CAPITAL LETTER VEDE': 11266,
'GLAGOLITIC CAPITAL LETTER YATI': 11297,
'GLAGOLITIC CAPITAL LETTER YERI': 11296,
'GLAGOLITIC CAPITAL LETTER YERU': 11295,
'GLAGOLITIC CAPITAL LETTER YESTU': 11269,
'GLAGOLITIC CAPITAL LETTER YO': 11302,
'GLAGOLITIC CAPITAL LETTER YU': 11299,
'GLAGOLITIC CAPITAL LETTER ZEMLJA': 11272,
'GLAGOLITIC CAPITAL LETTER ZHIVETE': 11270,
'GLAGOLITIC SMALL LETTER AZU': 11312,
'GLAGOLITIC SMALL LETTER BIG YUS': 11352,
'GLAGOLITIC SMALL LETTER BUKY': 11313,
'GLAGOLITIC SMALL LETTER CHRIVI': 11341,
'GLAGOLITIC SMALL LETTER DJERVI': 11324,
'GLAGOLITIC SMALL LETTER DOBRO': 11316,
'GLAGOLITIC SMALL LETTER DZELO': 11319,
'GLAGOLITIC SMALL LETTER FITA': 11354,
'GLAGOLITIC SMALL LETTER FRITU': 11335,
'GLAGOLITIC SMALL LETTER GLAGOLI': 11315,
'GLAGOLITIC SMALL LETTER HERU': 11336,
'GLAGOLITIC SMALL LETTER I': 11323,
'GLAGOLITIC SMALL LETTER INITIAL IZHE': 11322,
'GLAGOLITIC SMALL LETTER IOTATED BIG YUS': 11353,
'GLAGOLITIC SMALL LETTER IOTATED SMALL YUS': 11351,
'GLAGOLITIC SMALL LETTER IZHE': 11321,
'GLAGOLITIC SMALL LETTER IZHITSA': 11355,
'GLAGOLITIC SMALL LETTER KAKO': 11325,
'GLAGOLITIC SMALL LETTER LATINATE MYSLITE': 11358,
'GLAGOLITIC SMALL LETTER LJUDIJE': 11326,
'GLAGOLITIC SMALL LETTER MYSLITE': 11327,
'GLAGOLITIC SMALL LETTER NASHI': 11328,
'GLAGOLITIC SMALL LETTER ONU': 11329,
'GLAGOLITIC SMALL LETTER OTU': 11337,
'GLAGOLITIC SMALL LETTER PE': 11338,
'GLAGOLITIC SMALL LETTER POKOJI': 11330,
'GLAGOLITIC SMALL LETTER RITSI': 11331,
'GLAGOLITIC SMALL LETTER SHA': 11342,
'GLAGOLITIC SMALL LETTER SHTA': 11339,
'GLAGOLITIC SMALL LETTER SHTAPIC': 11356,
'GLAGOLITIC SMALL LETTER SLOVO': 11332,
'GLAGOLITIC SMALL LETTER SMALL YUS': 11348,
'GLAGOLITIC SMALL LETTER SMALL YUS WITH TAIL': 11349,
'GLAGOLITIC SMALL LETTER SPIDERY HA': 11346,
'GLAGOLITIC SMALL LETTER TROKUTASTI A': 11357,
'GLAGOLITIC SMALL LETTER TSI': 11340,
'GLAGOLITIC SMALL LETTER TVRIDO': 11333,
'GLAGOLITIC SMALL LETTER UKU': 11334,
'GLAGOLITIC SMALL LETTER VEDE': 11314,
'GLAGOLITIC SMALL LETTER YATI': 11345,
'GLAGOLITIC SMALL LETTER YERI': 11344,
'GLAGOLITIC SMALL LETTER YERU': 11343,
'GLAGOLITIC SMALL LETTER YESTU': 11317,
'GLAGOLITIC SMALL LETTER YO': 11350,
'GLAGOLITIC SMALL LETTER YU': 11347,
'GLAGOLITIC SMALL LETTER ZEMLJA': 11320,
'GLAGOLITIC SMALL LETTER ZHIVETE': 11318,
'GLEICH STARK': 10726,
'GOTHIC LETTER AHSA': 66352,
'GOTHIC LETTER AIHVUS': 66356,
'GOTHIC LETTER BAIRKAN': 66353,
'GOTHIC LETTER DAGS': 66355,
'GOTHIC LETTER EIS': 66361,
'GOTHIC LETTER FAIHU': 66374,
'GOTHIC LETTER GIBA': 66354,
'GOTHIC LETTER HAGL': 66359,
'GOTHIC LETTER HWAIR': 66376,
'GOTHIC LETTER IGGWS': 66375,
'GOTHIC LETTER IUJA': 66358,
'GOTHIC LETTER JER': 66366,
'GOTHIC LETTER KUSMA': 66362,
'GOTHIC LETTER LAGUS': 66363,
'GOTHIC LETTER MANNA': 66364,
'GOTHIC LETTER NAUTHS': 66365,
'GOTHIC LETTER NINE HUNDRED': 66378,
'GOTHIC LETTER NINETY': 66369,
'GOTHIC LETTER OTHAL': 66377,
'GOTHIC LETTER PAIRTHRA': 66368,
'GOTHIC LETTER QAIRTHRA': 66357,
'GOTHIC LETTER RAIDA': 66370,
'GOTHIC LETTER SAUIL': 66371,
'GOTHIC LETTER TEIWS': 66372,
'GOTHIC LETTER THIUTH': 66360,
'GOTHIC LETTER URUS': 66367,
'GOTHIC LETTER WINJA': 66373,
'GRAVE ACCENT': 96,
'GREATER-THAN ABOVE DOUBLE-LINE EQUAL ABOVE LESS-THAN': 10892,
'GREATER-THAN ABOVE LESS-THAN ABOVE DOUBLE-LINE EQUAL': 10898,
'GREATER-THAN ABOVE RIGHTWARDS ARROW': 10616,
'GREATER-THAN ABOVE SIMILAR ABOVE LESS-THAN': 10896,
'GREATER-THAN ABOVE SIMILAR OR EQUAL': 10894,
'GREATER-THAN ABOVE SLANTED EQUAL ABOVE LESS-THAN ABOVE SLANTED EQUAL': 10900,
'GREATER-THAN AND NOT APPROXIMATE': 10890,
'GREATER-THAN AND SINGLE-LINE NOT EQUAL TO': 10888,
'GREATER-THAN BESIDE LESS-THAN': 10917,
'GREATER-THAN BUT NOT EQUAL TO': 8809,
'GREATER-THAN BUT NOT EQUIVALENT TO': 8935,
'GREATER-THAN CLOSED BY CURVE': 10919,
'GREATER-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL': 10921,
'GREATER-THAN EQUAL TO OR LESS-THAN': 8923,
'GREATER-THAN OR APPROXIMATE': 10886,
'GREATER-THAN OR EQUAL TO': 8805,
'GREATER-THAN OR EQUIVALENT TO': 8819,
'GREATER-THAN OR LESS-THAN': 8823,
'GREATER-THAN OR SLANTED EQUAL TO': 10878,
'GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE': 10882,
'GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE LEFT': 10884,
'GREATER-THAN OR SLANTED EQUAL TO WITH DOT INSIDE': 10880,
'GREATER-THAN OVER EQUAL TO': 8807,
'GREATER-THAN OVERLAPPING LESS-THAN': 10916,
'GREATER-THAN SIGN': 62,
'GREATER-THAN WITH CIRCLE INSIDE': 10874,
'GREATER-THAN WITH DOT': 8919,
'GREATER-THAN WITH QUESTION MARK ABOVE': 10876,
'GREEK ACROPHONIC ATTIC FIFTY': 65860,
'GREEK ACROPHONIC ATTIC FIFTY STATERS': 65873,
'GREEK ACROPHONIC ATTIC FIFTY TALENTS': 65866,
'GREEK ACROPHONIC ATTIC FIFTY THOUSAND': 65863,
'GREEK ACROPHONIC ATTIC FIFTY THOUSAND STATERS': 65878,
'GREEK ACROPHONIC ATTIC FIVE': 65859,
'GREEK ACROPHONIC ATTIC FIVE HUNDRED': 65861,
'GREEK ACROPHONIC ATTIC FIVE HUNDRED STATERS': 65875,
'GREEK ACROPHONIC ATTIC FIVE HUNDRED TALENTS': 65868,
'GREEK ACROPHONIC ATTIC FIVE STATERS': 65871,
'GREEK ACROPHONIC ATTIC FIVE TALENTS': 65864,
'GREEK ACROPHONIC ATTIC FIVE THOUSAND': 65862,
'GREEK ACROPHONIC ATTIC FIVE THOUSAND TALENTS': 65870,
'GREEK ACROPHONIC ATTIC ONE DRACHMA': 65858,
'GREEK ACROPHONIC ATTIC ONE HALF': 65857,
'GREEK ACROPHONIC ATTIC ONE HUNDRED STATERS': 65874,
'GREEK ACROPHONIC ATTIC ONE HUNDRED TALENTS': 65867,
'GREEK ACROPHONIC ATTIC ONE QUARTER': 65856,
'GREEK ACROPHONIC ATTIC ONE THOUSAND STATERS': 65876,
'GREEK ACROPHONIC ATTIC ONE THOUSAND TALENTS': 65869,
'GREEK ACROPHONIC ATTIC TEN MNAS': 65879,
'GREEK ACROPHONIC ATTIC TEN STATERS': 65872,
'GREEK ACROPHONIC ATTIC TEN TALENTS': 65865,
'GREEK ACROPHONIC ATTIC TEN THOUSAND STATERS': 65877,
'GREEK ACROPHONIC CARYSTIAN FIVE HUNDRED': 65903,
'GREEK ACROPHONIC CYRENAIC TWO DRACHMAS': 65885,
'GREEK ACROPHONIC DELPHIC FIVE MNAS': 65907,
'GREEK ACROPHONIC EPIDAUREAN FIVE HUNDRED': 65900,
'GREEK ACROPHONIC EPIDAUREAN TWO': 65883,
'GREEK ACROPHONIC EPIDAUREAN TWO DRACHMAS': 65886,
'GREEK ACROPHONIC HERAEUM ONE PLETHRON': 65880,
'GREEK ACROPHONIC HERMIONIAN FIFTY': 65896,
'GREEK ACROPHONIC HERMIONIAN ONE': 65882,
'GREEK ACROPHONIC HERMIONIAN TEN': 65890,
'GREEK ACROPHONIC MESSENIAN TEN': 65891,
'GREEK ACROPHONIC NAXIAN FIVE HUNDRED': 65904,
'GREEK ACROPHONIC STRATIAN FIFTY MNAS': 65908,
'GREEK ACROPHONIC THESPIAN FIFTY': 65897,
'GREEK ACROPHONIC THESPIAN FIVE HUNDRED': 65902,
'GREEK ACROPHONIC THESPIAN FIVE THOUSAND': 65906,
'GREEK ACROPHONIC THESPIAN ONE': 65881,
'GREEK ACROPHONIC THESPIAN ONE HUNDRED': 65898,
'GREEK ACROPHONIC THESPIAN ONE THOUSAND': 65905,
'GREEK ACROPHONIC THESPIAN TEN': 65892,
'GREEK ACROPHONIC THESPIAN THIRTY': 65893,
'GREEK ACROPHONIC THESPIAN THREE HUNDRED': 65899,
'GREEK ACROPHONIC THESPIAN TWO': 65884,
'GREEK ACROPHONIC TROEZENIAN FIFTY': 65894,
'GREEK ACROPHONIC TROEZENIAN FIFTY ALTERNATE FORM': 65895,
'GREEK ACROPHONIC TROEZENIAN FIVE': 65887,
'GREEK ACROPHONIC TROEZENIAN FIVE HUNDRED': 65901,
'GREEK ACROPHONIC TROEZENIAN TEN': 65888,
'GREEK ACROPHONIC TROEZENIAN TEN ALTERNATE FORM': 65889,
'GREEK ANO TELEIA': 903,
'GREEK AROURA SIGN': 65927,
'GREEK ARTABE SIGN': 65926,
'GREEK BETA SYMBOL': 976,
'GREEK CAPITAL DOTTED LUNATE SIGMA SYMBOL': 1022,
'GREEK CAPITAL LETTER ALPHA': 913,
'GREEK CAPITAL LETTER ALPHA WITH DASIA': 7945,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA': 7949,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA AND PROSGEGRAMMENI': 8077,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI': 7951,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI': 8079,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND PROSGEGRAMMENI': 8073,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA': 7947,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA AND PROSGEGRAMMENI': 8075,
'GREEK CAPITAL LETTER ALPHA WITH MACRON': 8121,
'GREEK CAPITAL LETTER ALPHA WITH OXIA': 8123,
'GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI': 8124,
'GREEK CAPITAL LETTER ALPHA WITH PSILI': 7944,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA': 7948,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA AND PROSGEGRAMMENI': 8076,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI': 7950,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI': 8078,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND PROSGEGRAMMENI': 8072,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA': 7946,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA AND PROSGEGRAMMENI': 8074,
'GREEK CAPITAL LETTER ALPHA WITH TONOS': 902,
'GREEK CAPITAL LETTER ALPHA WITH VARIA': 8122,
'GREEK CAPITAL LETTER ALPHA WITH VRACHY': 8120,
'GREEK CAPITAL LETTER BETA': 914,
'GREEK CAPITAL LETTER CHI': 935,
'GREEK CAPITAL LETTER DELTA': 916,
'GREEK CAPITAL LETTER EPSILON': 917,
'GREEK CAPITAL LETTER EPSILON WITH DASIA': 7961,
'GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA': 7965,
'GREEK CAPITAL LETTER EPSILON WITH DASIA AND VARIA': 7963,
'GREEK CAPITAL LETTER EPSILON WITH OXIA': 8137,
'GREEK CAPITAL LETTER EPSILON WITH PSILI': 7960,
'GREEK CAPITAL LETTER EPSILON WITH PSILI AND OXIA': 7964,
'GREEK CAPITAL LETTER EPSILON WITH PSILI AND VARIA': 7962,
'GREEK CAPITAL LETTER EPSILON WITH TONOS': 904,
'GREEK CAPITAL LETTER EPSILON WITH VARIA': 8136,
'GREEK CAPITAL LETTER ETA': 919,
'GREEK CAPITAL LETTER ETA WITH DASIA': 7977,
'GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA': 7981,
'GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA AND PROSGEGRAMMENI': 8093,
'GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI': 7983,
'GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI': 8095,
'GREEK CAPITAL LETTER ETA WITH DASIA AND PROSGEGRAMMENI': 8089,
'GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA': 7979,
'GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA AND PROSGEGRAMMENI': 8091,
'GREEK CAPITAL LETTER ETA WITH OXIA': 8139,
'GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI': 8140,
'GREEK CAPITAL LETTER ETA WITH PSILI': 7976,
'GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA': 7980,
'GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA AND PROSGEGRAMMENI': 8092,
'GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI': 7982,
'GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI': 8094,
'GREEK CAPITAL LETTER ETA WITH PSILI AND PROSGEGRAMMENI': 8088,
'GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA': 7978,
'GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA AND PROSGEGRAMMENI': 8090,
'GREEK CAPITAL LETTER ETA WITH TONOS': 905,
'GREEK CAPITAL LETTER ETA WITH VARIA': 8138,
'GREEK CAPITAL LETTER GAMMA': 915,
'GREEK CAPITAL LETTER IOTA': 921,
'GREEK CAPITAL LETTER IOTA WITH DASIA': 7993,
'GREEK CAPITAL LETTER IOTA WITH DASIA AND OXIA': 7997,
'GREEK CAPITAL LETTER IOTA WITH DASIA AND PERISPOMENI': 7999,
'GREEK CAPITAL LETTER IOTA WITH DASIA AND VARIA': 7995,
'GREEK CAPITAL LETTER IOTA WITH DIALYTIKA': 938,
'GREEK CAPITAL LETTER IOTA WITH MACRON': 8153,
'GREEK CAPITAL LETTER IOTA WITH OXIA': 8155,
'GREEK CAPITAL LETTER IOTA WITH PSILI': 7992,
'GREEK CAPITAL LETTER IOTA WITH PSILI AND OXIA': 7996,
'GREEK CAPITAL LETTER IOTA WITH PSILI AND PERISPOMENI': 7998,
'GREEK CAPITAL LETTER IOTA WITH PSILI AND VARIA': 7994,
'GREEK CAPITAL LETTER IOTA WITH TONOS': 906,
'GREEK CAPITAL LETTER IOTA WITH VARIA': 8154,
'GREEK CAPITAL LETTER IOTA WITH VRACHY': 8152,
'GREEK CAPITAL LETTER KAPPA': 922,
'GREEK CAPITAL LETTER LAMDA': 923,
'GREEK CAPITAL LETTER MU': 924,
'GREEK CAPITAL LETTER NU': 925,
'GREEK CAPITAL LETTER OMEGA': 937,
'GREEK CAPITAL LETTER OMEGA WITH DASIA': 8041,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA': 8045,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA AND PROSGEGRAMMENI': 8109,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI': 8047,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI': 8111,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND PROSGEGRAMMENI': 8105,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA': 8043,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA AND PROSGEGRAMMENI': 8107,
'GREEK CAPITAL LETTER OMEGA WITH OXIA': 8187,
'GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI': 8188,
'GREEK CAPITAL LETTER OMEGA WITH PSILI': 8040,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA': 8044,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA AND PROSGEGRAMMENI': 8108,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI': 8046,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI': 8110,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND PROSGEGRAMMENI': 8104,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA': 8042,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA AND PROSGEGRAMMENI': 8106,
'GREEK CAPITAL LETTER OMEGA WITH TONOS': 911,
'GREEK CAPITAL LETTER OMEGA WITH VARIA': 8186,
'GREEK CAPITAL LETTER OMICRON': 927,
'GREEK CAPITAL LETTER OMICRON WITH DASIA': 8009,
'GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA': 8013,
'GREEK CAPITAL LETTER OMICRON WITH DASIA AND VARIA': 8011,
'GREEK CAPITAL LETTER OMICRON WITH OXIA': 8185,
'GREEK CAPITAL LETTER OMICRON WITH PSILI': 8008,
'GREEK CAPITAL LETTER OMICRON WITH PSILI AND OXIA': 8012,
'GREEK CAPITAL LETTER OMICRON WITH PSILI AND VARIA': 8010,
'GREEK CAPITAL LETTER OMICRON WITH TONOS': 908,
'GREEK CAPITAL LETTER OMICRON WITH VARIA': 8184,
'GREEK CAPITAL LETTER PHI': 934,
'GREEK CAPITAL LETTER PI': 928,
'GREEK CAPITAL LETTER PSI': 936,
'GREEK CAPITAL LETTER RHO': 929,
'GREEK CAPITAL LETTER RHO WITH DASIA': 8172,
'GREEK CAPITAL LETTER SAN': 1018,
'GREEK CAPITAL LETTER SHO': 1015,
'GREEK CAPITAL LETTER SIGMA': 931,
'GREEK CAPITAL LETTER TAU': 932,
'GREEK CAPITAL LETTER THETA': 920,
'GREEK CAPITAL LETTER UPSILON': 933,
'GREEK CAPITAL LETTER UPSILON WITH DASIA': 8025,
'GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA': 8029,
'GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI': 8031,
'GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA': 8027,
'GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA': 939,
'GREEK CAPITAL LETTER UPSILON WITH MACRON': 8169,
'GREEK CAPITAL LETTER UPSILON WITH OXIA': 8171,
'GREEK CAPITAL LETTER UPSILON WITH TONOS': 910,
'GREEK CAPITAL LETTER UPSILON WITH VARIA': 8170,
'GREEK CAPITAL LETTER UPSILON WITH VRACHY': 8168,
'GREEK CAPITAL LETTER XI': 926,
'GREEK CAPITAL LETTER ZETA': 918,
'GREEK CAPITAL LUNATE SIGMA SYMBOL': 1017,
'GREEK CAPITAL REVERSED DOTTED LUNATE SIGMA SYMBOL': 1023,
'GREEK CAPITAL REVERSED LUNATE SIGMA SYMBOL': 1021,
'GREEK CAPITAL THETA SYMBOL': 1012,
'GREEK DASIA': 8190,
'GREEK DASIA AND OXIA': 8158,
'GREEK DASIA AND PERISPOMENI': 8159,
'GREEK DASIA AND VARIA': 8157,
'GREEK DIALYTIKA AND OXIA': 8174,
'GREEK DIALYTIKA AND PERISPOMENI': 8129,
'GREEK DIALYTIKA AND VARIA': 8173,
'GREEK DIALYTIKA TONOS': 901,
'GREEK DRACHMA SIGN': 65915,
'GREEK FIVE OBOLS SIGN': 65920,
'GREEK FOUR OBOLS SIGN': 65919,
'GREEK GRAMMA SIGN': 65928,
'GREEK INSTRUMENTAL NOTATION SYMBOL-1': 119325,
'GREEK INSTRUMENTAL NOTATION SYMBOL-11': 119331,
'GREEK INSTRUMENTAL NOTATION SYMBOL-12': 119332,
'GREEK INSTRUMENTAL NOTATION SYMBOL-13': 119333,
'GREEK INSTRUMENTAL NOTATION SYMBOL-14': 119334,
'GREEK INSTRUMENTAL NOTATION SYMBOL-17': 119335,
'GREEK INSTRUMENTAL NOTATION SYMBOL-18': 119336,
'GREEK INSTRUMENTAL NOTATION SYMBOL-19': 119337,
'GREEK INSTRUMENTAL NOTATION SYMBOL-2': 119326,
'GREEK INSTRUMENTAL NOTATION SYMBOL-23': 119338,
'GREEK INSTRUMENTAL NOTATION SYMBOL-24': 119339,
'GREEK INSTRUMENTAL NOTATION SYMBOL-25': 119340,
'GREEK INSTRUMENTAL NOTATION SYMBOL-26': 119341,
'GREEK INSTRUMENTAL NOTATION SYMBOL-27': 119342,
'GREEK INSTRUMENTAL NOTATION SYMBOL-29': 119343,
'GREEK INSTRUMENTAL NOTATION SYMBOL-30': 119344,
'GREEK INSTRUMENTAL NOTATION SYMBOL-32': 119345,
'GREEK INSTRUMENTAL NOTATION SYMBOL-36': 119346,
'GREEK INSTRUMENTAL NOTATION SYMBOL-37': 119347,
'GREEK INSTRUMENTAL NOTATION SYMBOL-38': 119348,
'GREEK INSTRUMENTAL NOTATION SYMBOL-39': 119349,
'GREEK INSTRUMENTAL NOTATION SYMBOL-4': 119327,
'GREEK INSTRUMENTAL NOTATION SYMBOL-40': 119350,
'GREEK INSTRUMENTAL NOTATION SYMBOL-42': 119351,
'GREEK INSTRUMENTAL NOTATION SYMBOL-43': 119352,
'GREEK INSTRUMENTAL NOTATION SYMBOL-45': 119353,
'GREEK INSTRUMENTAL NOTATION SYMBOL-47': 119354,
'GREEK INSTRUMENTAL NOTATION SYMBOL-48': 119355,
'GREEK INSTRUMENTAL NOTATION SYMBOL-49': 119356,
'GREEK INSTRUMENTAL NOTATION SYMBOL-5': 119328,
'GREEK INSTRUMENTAL NOTATION SYMBOL-50': 119357,
'GREEK INSTRUMENTAL NOTATION SYMBOL-51': 119358,
'GREEK INSTRUMENTAL NOTATION SYMBOL-52': 119359,
'GREEK INSTRUMENTAL NOTATION SYMBOL-53': 119360,
'GREEK INSTRUMENTAL NOTATION SYMBOL-54': 119361,
'GREEK INSTRUMENTAL NOTATION SYMBOL-7': 119329,
'GREEK INSTRUMENTAL NOTATION SYMBOL-8': 119330,
'GREEK KAI SYMBOL': 983,
'GREEK KAPPA SYMBOL': 1008,
'GREEK KORONIS': 8125,
'GREEK KYATHOS BASE SIGN': 65922,
'GREEK LETTER ARCHAIC KOPPA': 984,
'GREEK LETTER DIGAMMA': 988,
'GREEK LETTER KOPPA': 990,
'GREEK LETTER SAMPI': 992,
'GREEK LETTER SMALL CAPITAL GAMMA': 7462,
'GREEK LETTER SMALL CAPITAL LAMDA': 7463,
'GREEK LETTER SMALL CAPITAL PI': 7464,
'GREEK LETTER SMALL CAPITAL PSI': 7466,
'GREEK LETTER SMALL CAPITAL RHO': 7465,
'GREEK LETTER STIGMA': 986,
'GREEK LETTER YOT': 1011,
'GREEK LITRA SIGN': 65923,
'GREEK LOWER NUMERAL SIGN': 885,
'GREEK LUNATE EPSILON SYMBOL': 1013,
'GREEK LUNATE SIGMA SYMBOL': 1010,
'GREEK METRETES SIGN': 65921,
'GREEK MUSICAL LEIMMA': 119365,
'GREEK NUMERAL SIGN': 884,
'GREEK OBOL SIGN': 65916,
'GREEK ONE HALF SIGN': 65909,
'GREEK ONE HALF SIGN ALTERNATE FORM': 65910,
'GREEK OUNKIA SIGN': 65924,
'GREEK OXIA': 8189,
'GREEK PERISPOMENI': 8128,
'GREEK PHI SYMBOL': 981,
'GREEK PI SYMBOL': 982,
'GREEK PROSGEGRAMMENI': 8126,
'GREEK PSILI': 8127,
'GREEK PSILI AND OXIA': 8142,
'GREEK PSILI AND PERISPOMENI': 8143,
'GREEK PSILI AND VARIA': 8141,
'GREEK QUESTION MARK': 894,
'GREEK REVERSED LUNATE EPSILON SYMBOL': 1014,
'GREEK RHO SYMBOL': 1009,
'GREEK RHO WITH STROKE SYMBOL': 1020,
'GREEK SMALL LETTER ALPHA': 945,
'GREEK SMALL LETTER ALPHA WITH DASIA': 7937,
'GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA': 7941,
'GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA AND YPOGEGRAMMENI': 8069,
'GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI': 7943,
'GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI': 8071,
'GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA': 7939,
'GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA AND YPOGEGRAMMENI': 8067,
'GREEK SMALL LETTER ALPHA WITH DASIA AND YPOGEGRAMMENI': 8065,
'GREEK SMALL LETTER ALPHA WITH MACRON': 8113,
'GREEK SMALL LETTER ALPHA WITH OXIA': 8049,
'GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI': 8116,
'GREEK SMALL LETTER ALPHA WITH PERISPOMENI': 8118,
'GREEK SMALL LETTER ALPHA WITH PERISPOMENI AND YPOGEGRAMMENI': 8119,
'GREEK SMALL LETTER ALPHA WITH PSILI': 7936,
'GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA': 7940,
'GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA AND YPOGEGRAMMENI': 8068,
'GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI': 7942,
'GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI': 8070,
'GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA': 7938,
'GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA AND YPOGEGRAMMENI': 8066,
'GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI': 8064,
'GREEK SMALL LETTER ALPHA WITH TONOS': 940,
'GREEK SMALL LETTER ALPHA WITH VARIA': 8048,
'GREEK SMALL LETTER ALPHA WITH VARIA AND YPOGEGRAMMENI': 8114,
'GREEK SMALL LETTER ALPHA WITH VRACHY': 8112,
'GREEK SMALL LETTER ALPHA WITH YPOGEGRAMMENI': 8115,
'GREEK SMALL LETTER ARCHAIC KOPPA': 985,
'GREEK SMALL LETTER BETA': 946,
'GREEK SMALL LETTER CHI': 967,
'GREEK SMALL LETTER DELTA': 948,
'GREEK SMALL LETTER DIGAMMA': 989,
'GREEK SMALL LETTER EPSILON': 949,
'GREEK SMALL LETTER EPSILON WITH DASIA': 7953,
'GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA': 7957,
'GREEK SMALL LETTER EPSILON WITH DASIA AND VARIA': 7955,
'GREEK SMALL LETTER EPSILON WITH OXIA': 8051,
'GREEK SMALL LETTER EPSILON WITH PSILI': 7952,
'GREEK SMALL LETTER EPSILON WITH PSILI AND OXIA': 7956,
'GREEK SMALL LETTER EPSILON WITH PSILI AND VARIA': 7954,
'GREEK SMALL LETTER EPSILON WITH TONOS': 941,
'GREEK SMALL LETTER EPSILON WITH VARIA': 8050,
'GREEK SMALL LETTER ETA': 951,
'GREEK SMALL LETTER ETA WITH DASIA': 7969,
'GREEK SMALL LETTER ETA WITH DASIA AND OXIA': 7973,
'GREEK SMALL LETTER ETA WITH DASIA AND OXIA AND YPOGEGRAMMENI': 8085,
'GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI': 7975,
'GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI': 8087,
'GREEK SMALL LETTER ETA WITH DASIA AND VARIA': 7971,
'GREEK SMALL LETTER ETA WITH DASIA AND VARIA AND YPOGEGRAMMENI': 8083,
'GREEK SMALL LETTER ETA WITH DASIA AND YPOGEGRAMMENI': 8081,
'GREEK SMALL LETTER ETA WITH OXIA': 8053,
'GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI': 8132,
'GREEK SMALL LETTER ETA WITH PERISPOMENI': 8134,
'GREEK SMALL LETTER ETA WITH PERISPOMENI AND YPOGEGRAMMENI': 8135,
'GREEK SMALL LETTER ETA WITH PSILI': 7968,
'GREEK SMALL LETTER ETA WITH PSILI AND OXIA': 7972,
'GREEK SMALL LETTER ETA WITH PSILI AND OXIA AND YPOGEGRAMMENI': 8084,
'GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI': 7974,
'GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI': 8086,
'GREEK SMALL LETTER ETA WITH PSILI AND VARIA': 7970,
'GREEK SMALL LETTER ETA WITH PSILI AND VARIA AND YPOGEGRAMMENI': 8082,
'GREEK SMALL LETTER ETA WITH PSILI AND YPOGEGRAMMENI': 8080,
'GREEK SMALL LETTER ETA WITH TONOS': 942,
'GREEK SMALL LETTER ETA WITH VARIA': 8052,
'GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI': 8130,
'GREEK SMALL LETTER ETA WITH YPOGEGRAMMENI': 8131,
'GREEK SMALL LETTER FINAL SIGMA': 962,
'GREEK SMALL LETTER GAMMA': 947,
'GREEK SMALL LETTER IOTA': 953,
'GREEK SMALL LETTER IOTA WITH DASIA': 7985,
'GREEK SMALL LETTER IOTA WITH DASIA AND OXIA': 7989,
'GREEK SMALL LETTER IOTA WITH DASIA AND PERISPOMENI': 7991,
'GREEK SMALL LETTER IOTA WITH DASIA AND VARIA': 7987,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA': 970,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA': 8147,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA AND PERISPOMENI': 8151,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS': 912,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA AND VARIA': 8146,
'GREEK SMALL LETTER IOTA WITH MACRON': 8145,
'GREEK SMALL LETTER IOTA WITH OXIA': 8055,
'GREEK SMALL LETTER IOTA WITH PERISPOMENI': 8150,
'GREEK SMALL LETTER IOTA WITH PSILI': 7984,
'GREEK SMALL LETTER IOTA WITH PSILI AND OXIA': 7988,
'GREEK SMALL LETTER IOTA WITH PSILI AND PERISPOMENI': 7990,
'GREEK SMALL LETTER IOTA WITH PSILI AND VARIA': 7986,
'GREEK SMALL LETTER IOTA WITH TONOS': 943,
'GREEK SMALL LETTER IOTA WITH VARIA': 8054,
'GREEK SMALL LETTER IOTA WITH VRACHY': 8144,
'GREEK SMALL LETTER KAPPA': 954,
'GREEK SMALL LETTER KOPPA': 991,
'GREEK SMALL LETTER LAMDA': 955,
'GREEK SMALL LETTER MU': 956,
'GREEK SMALL LETTER NU': 957,
'GREEK SMALL LETTER OMEGA': 969,
'GREEK SMALL LETTER OMEGA WITH DASIA': 8033,
'GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA': 8037,
'GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA AND YPOGEGRAMMENI': 8101,
'GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI': 8039,
'GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI': 8103,
'GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA': 8035,
'GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA AND YPOGEGRAMMENI': 8099,
'GREEK SMALL LETTER OMEGA WITH DASIA AND YPOGEGRAMMENI': 8097,
'GREEK SMALL LETTER OMEGA WITH OXIA': 8061,
'GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI': 8180,
'GREEK SMALL LETTER OMEGA WITH PERISPOMENI': 8182,
'GREEK SMALL LETTER OMEGA WITH PERISPOMENI AND YPOGEGRAMMENI': 8183,
'GREEK SMALL LETTER OMEGA WITH PSILI': 8032,
'GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA': 8036,
'GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA AND YPOGEGRAMMENI': 8100,
'GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI': 8038,
'GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI': 8102,
'GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA': 8034,
'GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA AND YPOGEGRAMMENI': 8098,
'GREEK SMALL LETTER OMEGA WITH PSILI AND YPOGEGRAMMENI': 8096,
'GREEK SMALL LETTER OMEGA WITH TONOS': 974,
'GREEK SMALL LETTER OMEGA WITH VARIA': 8060,
'GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI': 8178,
'GREEK SMALL LETTER OMEGA WITH YPOGEGRAMMENI': 8179,
'GREEK SMALL LETTER OMICRON': 959,
'GREEK SMALL LETTER OMICRON WITH DASIA': 8001,
'GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA': 8005,
'GREEK SMALL LETTER OMICRON WITH DASIA AND VARIA': 8003,
'GREEK SMALL LETTER OMICRON WITH OXIA': 8057,
'GREEK SMALL LETTER OMICRON WITH PSILI': 8000,
'GREEK SMALL LETTER OMICRON WITH PSILI AND OXIA': 8004,
'GREEK SMALL LETTER OMICRON WITH PSILI AND VARIA': 8002,
'GREEK SMALL LETTER OMICRON WITH TONOS': 972,
'GREEK SMALL LETTER OMICRON WITH VARIA': 8056,
'GREEK SMALL LETTER PHI': 966,
'GREEK SMALL LETTER PI': 960,
'GREEK SMALL LETTER PSI': 968,
'GREEK SMALL LETTER RHO': 961,
'GREEK SMALL LETTER RHO WITH DASIA': 8165,
'GREEK SMALL LETTER RHO WITH PSILI': 8164,
'GREEK SMALL LETTER SAMPI': 993,
'GREEK SMALL LETTER SAN': 1019,
'GREEK SMALL LETTER SHO': 1016,
'GREEK SMALL LETTER SIGMA': 963,
'GREEK SMALL LETTER STIGMA': 987,
'GREEK SMALL LETTER TAU': 964,
'GREEK SMALL LETTER THETA': 952,
'GREEK SMALL LETTER UPSILON': 965,
'GREEK SMALL LETTER UPSILON WITH DASIA': 8017,
'GREEK SMALL LETTER UPSILON WITH DASIA AND OXIA': 8021,
'GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI': 8023,
'GREEK SMALL LETTER UPSILON WITH DASIA AND VARIA': 8019,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA': 971,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND OXIA': 8163,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND PERISPOMENI': 8167,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS': 944,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND VARIA': 8162,
'GREEK SMALL LETTER UPSILON WITH MACRON': 8161,
'GREEK SMALL LETTER UPSILON WITH OXIA': 8059,
'GREEK SMALL LETTER UPSILON WITH PERISPOMENI': 8166,
'GREEK SMALL LETTER UPSILON WITH PSILI': 8016,
'GREEK SMALL LETTER UPSILON WITH PSILI AND OXIA': 8020,
'GREEK SMALL LETTER UPSILON WITH PSILI AND PERISPOMENI': 8022,
'GREEK SMALL LETTER UPSILON WITH PSILI AND VARIA': 8018,
'GREEK SMALL LETTER UPSILON WITH TONOS': 973,
'GREEK SMALL LETTER UPSILON WITH VARIA': 8058,
'GREEK SMALL LETTER UPSILON WITH VRACHY': 8160,
'GREEK SMALL LETTER XI': 958,
'GREEK SMALL LETTER ZETA': 950,
'GREEK SUBSCRIPT SMALL LETTER BETA': 7526,
'GREEK SUBSCRIPT SMALL LETTER CHI': 7530,
'GREEK SUBSCRIPT SMALL LETTER GAMMA': 7527,
'GREEK SUBSCRIPT SMALL LETTER PHI': 7529,
'GREEK SUBSCRIPT SMALL LETTER RHO': 7528,
'GREEK TALENT SIGN': 65914,
'GREEK THETA SYMBOL': 977,
'GREEK THREE OBOLS SIGN': 65918,
'GREEK THREE QUARTERS SIGN': 65912,
'GREEK TONOS': 900,
'GREEK TRYBLION BASE SIGN': 65929,
'GREEK TWO OBOLS SIGN': 65917,
'GREEK TWO THIRDS SIGN': 65911,
'GREEK UPSILON WITH ACUTE AND HOOK SYMBOL': 979,
'GREEK UPSILON WITH DIAERESIS AND HOOK SYMBOL': 980,
'GREEK UPSILON WITH HOOK SYMBOL': 978,
'GREEK VARIA': 8175,
'GREEK VOCAL NOTATION SYMBOL-1': 119296,
'GREEK VOCAL NOTATION SYMBOL-10': 119305,
'GREEK VOCAL NOTATION SYMBOL-11': 119306,
'GREEK VOCAL NOTATION SYMBOL-12': 119307,
'GREEK VOCAL NOTATION SYMBOL-13': 119308,
'GREEK VOCAL NOTATION SYMBOL-14': 119309,
'GREEK VOCAL NOTATION SYMBOL-15': 119310,
'GREEK VOCAL NOTATION SYMBOL-16': 119311,
'GREEK VOCAL NOTATION SYMBOL-17': 119312,
'GREEK VOCAL NOTATION SYMBOL-18': 119313,
'GREEK VOCAL NOTATION SYMBOL-19': 119314,
'GREEK VOCAL NOTATION SYMBOL-2': 119297,
'GREEK VOCAL NOTATION SYMBOL-20': 119315,
'GREEK VOCAL NOTATION SYMBOL-21': 119316,
'GREEK VOCAL NOTATION SYMBOL-22': 119317,
'GREEK VOCAL NOTATION SYMBOL-23': 119318,
'GREEK VOCAL NOTATION SYMBOL-24': 119319,
'GREEK VOCAL NOTATION SYMBOL-3': 119298,
'GREEK VOCAL NOTATION SYMBOL-4': 119299,
'GREEK VOCAL NOTATION SYMBOL-5': 119300,
'GREEK VOCAL NOTATION SYMBOL-50': 119320,
'GREEK VOCAL NOTATION SYMBOL-51': 119321,
'GREEK VOCAL NOTATION SYMBOL-52': 119322,
'GREEK VOCAL NOTATION SYMBOL-53': 119323,
'GREEK VOCAL NOTATION SYMBOL-54': 119324,
'GREEK VOCAL NOTATION SYMBOL-6': 119301,
'GREEK VOCAL NOTATION SYMBOL-7': 119302,
'GREEK VOCAL NOTATION SYMBOL-8': 119303,
'GREEK VOCAL NOTATION SYMBOL-9': 119304,
'GREEK XESTES SIGN': 65925,
'GREEK YEAR SIGN': 65913,
'GREEK YPOGEGRAMMENI': 890,
'GREEK ZERO SIGN': 65930,
'GUARANI SIGN': 8370,
'GUJARATI DIGIT EIGHT': 2798,
'GUJARATI DIGIT FIVE': 2795,
'GUJARATI DIGIT FOUR': 2794,
'GUJARATI DIGIT NINE': 2799,
'GUJARATI DIGIT ONE': 2791,
'GUJARATI DIGIT SEVEN': 2797,
'GUJARATI DIGIT SIX': 2796,
'GUJARATI DIGIT THREE': 2793,
'GUJARATI DIGIT TWO': 2792,
'GUJARATI DIGIT ZERO': 2790,
'GUJARATI LETTER A': 2693,
'GUJARATI LETTER AA': 2694,
'GUJARATI LETTER AI': 2704,
'GUJARATI LETTER AU': 2708,
'GUJARATI LETTER BA': 2732,
'GUJARATI LETTER BHA': 2733,
'GUJARATI LETTER CA': 2714,
'GUJARATI LETTER CHA': 2715,
'GUJARATI LETTER DA': 2726,
'GUJARATI LETTER DDA': 2721,
'GUJARATI LETTER DDHA': 2722,
'GUJARATI LETTER DHA': 2727,
'GUJARATI LETTER E': 2703,
'GUJARATI LETTER GA': 2711,
'GUJARATI LETTER GHA': 2712,
'GUJARATI LETTER HA': 2745,
'GUJARATI LETTER I': 2695,
'GUJARATI LETTER II': 2696,
'GUJARATI LETTER JA': 2716,
'GUJARATI LETTER JHA': 2717,
'GUJARATI LETTER KA': 2709,
'GUJARATI LETTER KHA': 2710,
'GUJARATI LETTER LA': 2738,
'GUJARATI LETTER LLA': 2739,
'GUJARATI LETTER MA': 2734,
'GUJARATI LETTER NA': 2728,
'GUJARATI LETTER NGA': 2713,
'GUJARATI LETTER NNA': 2723,
'GUJARATI LETTER NYA': 2718,
'GUJARATI LETTER O': 2707,
'GUJARATI LETTER PA': 2730,
'GUJARATI LETTER PHA': 2731,
'GUJARATI LETTER RA': 2736,
'GUJARATI LETTER SA': 2744,
'GUJARATI LETTER SHA': 2742,
'GUJARATI LETTER SSA': 2743,
'GUJARATI LETTER TA': 2724,
'GUJARATI LETTER THA': 2725,
'GUJARATI LETTER TTA': 2719,
'GUJARATI LETTER TTHA': 2720,
'GUJARATI LETTER U': 2697,
'GUJARATI LETTER UU': 2698,
'GUJARATI LETTER VA': 2741,
'GUJARATI LETTER VOCALIC L': 2700,
'GUJARATI LETTER VOCALIC LL': 2785,
'GUJARATI LETTER VOCALIC R': 2699,
'GUJARATI LETTER VOCALIC RR': 2784,
'GUJARATI LETTER YA': 2735,
'GUJARATI OM': 2768,
'GUJARATI RUPEE SIGN': 2801,
'GUJARATI SIGN ANUSVARA': 2690,
'GUJARATI SIGN AVAGRAHA': 2749,
'GUJARATI SIGN CANDRABINDU': 2689,
'GUJARATI SIGN NUKTA': 2748,
'GUJARATI SIGN VIRAMA': 2765,
'GUJARATI SIGN VISARGA': 2691,
'GUJARATI VOWEL CANDRA E': 2701,
'GUJARATI VOWEL CANDRA O': 2705,
'GUJARATI VOWEL SIGN AA': 2750,
'GUJARATI VOWEL SIGN AI': 2760,
'GUJARATI VOWEL SIGN AU': 2764,
'GUJARATI VOWEL SIGN CANDRA E': 2757,
'GUJARATI VOWEL SIGN CANDRA O': 2761,
'GUJARATI VOWEL SIGN E': 2759,
'GUJARATI VOWEL SIGN I': 2751,
'GUJARATI VOWEL SIGN II': 2752,
'GUJARATI VOWEL SIGN O': 2763,
'GUJARATI VOWEL SIGN U': 2753,
'GUJARATI VOWEL SIGN UU': 2754,
'GUJARATI VOWEL SIGN VOCALIC L': 2786,
'GUJARATI VOWEL SIGN VOCALIC LL': 2787,
'GUJARATI VOWEL SIGN VOCALIC R': 2755,
'GUJARATI VOWEL SIGN VOCALIC RR': 2756,
'GURMUKHI ADDAK': 2673,
'GURMUKHI DIGIT EIGHT': 2670,
'GURMUKHI DIGIT FIVE': 2667,
'GURMUKHI DIGIT FOUR': 2666,
'GURMUKHI DIGIT NINE': 2671,
'GURMUKHI DIGIT ONE': 2663,
'GURMUKHI DIGIT SEVEN': 2669,
'GURMUKHI DIGIT SIX': 2668,
'GURMUKHI DIGIT THREE': 2665,
'GURMUKHI DIGIT TWO': 2664,
'GURMUKHI DIGIT ZERO': 2662,
'GURMUKHI EK ONKAR': 2676,
'GURMUKHI IRI': 2674,
'GURMUKHI LETTER A': 2565,
'GURMUKHI LETTER AA': 2566,
'GURMUKHI LETTER AI': 2576,
'GURMUKHI LETTER AU': 2580,
'GURMUKHI LETTER BA': 2604,
'GURMUKHI LETTER BHA': 2605,
'GURMUKHI LETTER CA': 2586,
'GURMUKHI LETTER CHA': 2587,
'GURMUKHI LETTER DA': 2598,
'GURMUKHI LETTER DDA': 2593,
'GURMUKHI LETTER DDHA': 2594,
'GURMUKHI LETTER DHA': 2599,
'GURMUKHI LETTER EE': 2575,
'GURMUKHI LETTER FA': 2654,
'GURMUKHI LETTER GA': 2583,
'GURMUKHI LETTER GHA': 2584,
'GURMUKHI LETTER GHHA': 2650,
'GURMUKHI LETTER HA': 2617,
'GURMUKHI LETTER I': 2567,
'GURMUKHI LETTER II': 2568,
'GURMUKHI LETTER JA': 2588,
'GURMUKHI LETTER JHA': 2589,
'GURMUKHI LETTER KA': 2581,
'GURMUKHI LETTER KHA': 2582,
'GURMUKHI LETTER KHHA': 2649,
'GURMUKHI LETTER LA': 2610,
'GURMUKHI LETTER LLA': 2611,
'GURMUKHI LETTER MA': 2606,
'GURMUKHI LETTER NA': 2600,
'GURMUKHI LETTER NGA': 2585,
'GURMUKHI LETTER NNA': 2595,
'GURMUKHI LETTER NYA': 2590,
'GURMUKHI LETTER OO': 2579,
'GURMUKHI LETTER PA': 2602,
'GURMUKHI LETTER PHA': 2603,
'GURMUKHI LETTER RA': 2608,
'GURMUKHI LETTER RRA': 2652,
'GURMUKHI LETTER SA': 2616,
'GURMUKHI LETTER SHA': 2614,
'GURMUKHI LETTER TA': 2596,
'GURMUKHI LETTER THA': 2597,
'GURMUKHI LETTER TTA': 2591,
'GURMUKHI LETTER TTHA': 2592,
'GURMUKHI LETTER U': 2569,
'GURMUKHI LETTER UU': 2570,
'GURMUKHI LETTER VA': 2613,
'GURMUKHI LETTER YA': 2607,
'GURMUKHI LETTER ZA': 2651,
'GURMUKHI SIGN ADAK BINDI': 2561,
'GURMUKHI SIGN BINDI': 2562,
'GURMUKHI SIGN NUKTA': 2620,
'GURMUKHI SIGN VIRAMA': 2637,
'GURMUKHI SIGN VISARGA': 2563,
'GURMUKHI TIPPI': 2672,
'GURMUKHI URA': 2675,
'GURMUKHI VOWEL SIGN AA': 2622,
'GURMUKHI VOWEL SIGN AI': 2632,
'GURMUKHI VOWEL SIGN AU': 2636,
'GURMUKHI VOWEL SIGN EE': 2631,
'GURMUKHI VOWEL SIGN I': 2623,
'GURMUKHI VOWEL SIGN II': 2624,
'GURMUKHI VOWEL SIGN OO': 2635,
'GURMUKHI VOWEL SIGN U': 2625,
'GURMUKHI VOWEL SIGN UU': 2626,
'HAIR SPACE': 8202,
'HALFWIDTH BLACK SQUARE': 65517,
'HALFWIDTH DOWNWARDS ARROW': 65516,
'HALFWIDTH FORMS LIGHT VERTICAL': 65512,
'HALFWIDTH HANGUL FILLER': 65440,
'HALFWIDTH HANGUL LETTER A': 65474,
'HALFWIDTH HANGUL LETTER AE': 65475,
'HALFWIDTH HANGUL LETTER CHIEUCH': 65466,
'HALFWIDTH HANGUL LETTER CIEUC': 65464,
'HALFWIDTH HANGUL LETTER E': 65479,
'HALFWIDTH HANGUL LETTER EO': 65478,
'HALFWIDTH HANGUL LETTER EU': 65498,
'HALFWIDTH HANGUL LETTER HIEUH': 65470,
'HALFWIDTH HANGUL LETTER I': 65500,
'HALFWIDTH HANGUL LETTER IEUNG': 65463,
'HALFWIDTH HANGUL LETTER KHIEUKH': 65467,
'HALFWIDTH HANGUL LETTER KIYEOK': 65441,
'HALFWIDTH HANGUL LETTER KIYEOK-SIOS': 65443,
'HALFWIDTH HANGUL LETTER MIEUM': 65457,
'HALFWIDTH HANGUL LETTER NIEUN': 65444,
'HALFWIDTH HANGUL LETTER NIEUN-CIEUC': 65445,
'HALFWIDTH HANGUL LETTER NIEUN-HIEUH': 65446,
'HALFWIDTH HANGUL LETTER O': 65484,
'HALFWIDTH HANGUL LETTER OE': 65487,
'HALFWIDTH HANGUL LETTER PHIEUPH': 65469,
'HALFWIDTH HANGUL LETTER PIEUP': 65458,
'HALFWIDTH HANGUL LETTER PIEUP-SIOS': 65460,
'HALFWIDTH HANGUL LETTER RIEUL': 65449,
'HALFWIDTH HANGUL LETTER RIEUL-HIEUH': 65456,
'HALFWIDTH HANGUL LETTER RIEUL-KIYEOK': 65450,
'HALFWIDTH HANGUL LETTER RIEUL-MIEUM': 65451,
'HALFWIDTH HANGUL LETTER RIEUL-PHIEUPH': 65455,
'HALFWIDTH HANGUL LETTER RIEUL-PIEUP': 65452,
'HALFWIDTH HANGUL LETTER RIEUL-SIOS': 65453,
'HALFWIDTH HANGUL LETTER RIEUL-THIEUTH': 65454,
'HALFWIDTH HANGUL LETTER SIOS': 65461,
'HALFWIDTH HANGUL LETTER SSANGCIEUC': 65465,
'HALFWIDTH HANGUL LETTER SSANGKIYEOK': 65442,
'HALFWIDTH HANGUL LETTER SSANGPIEUP': 65459,
'HALFWIDTH HANGUL LETTER SSANGSIOS': 65462,
'HALFWIDTH HANGUL LETTER SSANGTIKEUT': 65448,
'HALFWIDTH HANGUL LETTER THIEUTH': 65468,
'HALFWIDTH HANGUL LETTER TIKEUT': 65447,
'HALFWIDTH HANGUL LETTER U': 65491,
'HALFWIDTH HANGUL LETTER WA': 65485,
'HALFWIDTH HANGUL LETTER WAE': 65486,
'HALFWIDTH HANGUL LETTER WE': 65493,
'HALFWIDTH HANGUL LETTER WEO': 65492,
'HALFWIDTH HANGUL LETTER WI': 65494,
'HALFWIDTH HANGUL LETTER YA': 65476,
'HALFWIDTH HANGUL LETTER YAE': 65477,
'HALFWIDTH HANGUL LETTER YE': 65483,
'HALFWIDTH HANGUL LETTER YEO': 65482,
'HALFWIDTH HANGUL LETTER YI': 65499,
'HALFWIDTH HANGUL LETTER YO': 65490,
'HALFWIDTH HANGUL LETTER YU': 65495,
'HALFWIDTH IDEOGRAPHIC COMMA': 65380,
'HALFWIDTH IDEOGRAPHIC FULL STOP': 65377,
'HALFWIDTH KATAKANA LETTER A': 65393,
'HALFWIDTH KATAKANA LETTER E': 65396,
'HALFWIDTH KATAKANA LETTER HA': 65418,
'HALFWIDTH KATAKANA LETTER HE': 65421,
'HALFWIDTH KATAKANA LETTER HI': 65419,
'HALFWIDTH KATAKANA LETTER HO': 65422,
'HALFWIDTH KATAKANA LETTER HU': 65420,
'HALFWIDTH KATAKANA LETTER I': 65394,
'HALFWIDTH KATAKANA LETTER KA': 65398,
'HALFWIDTH KATAKANA LETTER KE': 65401,
'HALFWIDTH KATAKANA LETTER KI': 65399,
'HALFWIDTH KATAKANA LETTER KO': 65402,
'HALFWIDTH KATAKANA LETTER KU': 65400,
'HALFWIDTH KATAKANA LETTER MA': 65423,
'HALFWIDTH KATAKANA LETTER ME': 65426,
'HALFWIDTH KATAKANA LETTER MI': 65424,
'HALFWIDTH KATAKANA LETTER MO': 65427,
'HALFWIDTH KATAKANA LETTER MU': 65425,
'HALFWIDTH KATAKANA LETTER N': 65437,
'HALFWIDTH KATAKANA LETTER NA': 65413,
'HALFWIDTH KATAKANA LETTER NE': 65416,
'HALFWIDTH KATAKANA LETTER NI': 65414,
'HALFWIDTH KATAKANA LETTER NO': 65417,
'HALFWIDTH KATAKANA LETTER NU': 65415,
'HALFWIDTH KATAKANA LETTER O': 65397,
'HALFWIDTH KATAKANA LETTER RA': 65431,
'HALFWIDTH KATAKANA LETTER RE': 65434,
'HALFWIDTH KATAKANA LETTER RI': 65432,
'HALFWIDTH KATAKANA LETTER RO': 65435,
'HALFWIDTH KATAKANA LETTER RU': 65433,
'HALFWIDTH KATAKANA LETTER SA': 65403,
'HALFWIDTH KATAKANA LETTER SE': 65406,
'HALFWIDTH KATAKANA LETTER SI': 65404,
'HALFWIDTH KATAKANA LETTER SMALL A': 65383,
'HALFWIDTH KATAKANA LETTER SMALL E': 65386,
'HALFWIDTH KATAKANA LETTER SMALL I': 65384,
'HALFWIDTH KATAKANA LETTER SMALL O': 65387,
'HALFWIDTH KATAKANA LETTER SMALL TU': 65391,
'HALFWIDTH KATAKANA LETTER SMALL U': 65385,
'HALFWIDTH KATAKANA LETTER SMALL YA': 65388,
'HALFWIDTH KATAKANA LETTER SMALL YO': 65390,
'HALFWIDTH KATAKANA LETTER SMALL YU': 65389,
'HALFWIDTH KATAKANA LETTER SO': 65407,
'HALFWIDTH KATAKANA LETTER SU': 65405,
'HALFWIDTH KATAKANA LETTER TA': 65408,
'HALFWIDTH KATAKANA LETTER TE': 65411,
'HALFWIDTH KATAKANA LETTER TI': 65409,
'HALFWIDTH KATAKANA LETTER TO': 65412,
'HALFWIDTH KATAKANA LETTER TU': 65410,
'HALFWIDTH KATAKANA LETTER U': 65395,
'HALFWIDTH KATAKANA LETTER WA': 65436,
'HALFWIDTH KATAKANA LETTER WO': 65382,
'HALFWIDTH KATAKANA LETTER YA': 65428,
'HALFWIDTH KATAKANA LETTER YO': 65430,
'HALFWIDTH KATAKANA LETTER YU': 65429,
'HALFWIDTH KATAKANA MIDDLE DOT': 65381,
'HALFWIDTH KATAKANA SEMI-VOICED SOUND MARK': 65439,
'HALFWIDTH KATAKANA VOICED SOUND MARK': 65438,
'HALFWIDTH KATAKANA-HIRAGANA PROLONGED SOUND MARK': 65392,
'HALFWIDTH LEFT CORNER BRACKET': 65378,
'HALFWIDTH LEFTWARDS ARROW': 65513,
'HALFWIDTH RIGHT CORNER BRACKET': 65379,
'HALFWIDTH RIGHTWARDS ARROW': 65515,
'HALFWIDTH UPWARDS ARROW': 65514,
'HALFWIDTH WHITE CIRCLE': 65518,
'HAMMER AND PICK': 9874,
'HAMMER AND SICKLE': 9773,
'HANGUL CHOSEONG CEONGCHIEUMCHIEUCH': 4437,
'HANGUL CHOSEONG CEONGCHIEUMCIEUC': 4432,
'HANGUL CHOSEONG CEONGCHIEUMSIOS': 4414,
'HANGUL CHOSEONG CEONGCHIEUMSSANGCIEUC': 4433,
'HANGUL CHOSEONG CEONGCHIEUMSSANGSIOS': 4415,
'HANGUL CHOSEONG CHIEUCH': 4366,
'HANGUL CHOSEONG CHIEUCH-HIEUH': 4435,
'HANGUL CHOSEONG CHIEUCH-KHIEUKH': 4434,
'HANGUL CHOSEONG CHITUEUMCHIEUCH': 4436,
'HANGUL CHOSEONG CHITUEUMCIEUC': 4430,
'HANGUL CHOSEONG CHITUEUMSIOS': 4412,
'HANGUL CHOSEONG CHITUEUMSSANGCIEUC': 4431,
'HANGUL CHOSEONG CHITUEUMSSANGSIOS': 4413,
'HANGUL CHOSEONG CIEUC': 4364,
'HANGUL CHOSEONG CIEUC-IEUNG': 4429,
'HANGUL CHOSEONG FILLER': 4447,
'HANGUL CHOSEONG HIEUH': 4370,
'HANGUL CHOSEONG IEUNG': 4363,
'HANGUL CHOSEONG IEUNG-CHIEUCH': 4425,
'HANGUL CHOSEONG IEUNG-CIEUC': 4424,
'HANGUL CHOSEONG IEUNG-KIYEOK': 4417,
'HANGUL CHOSEONG IEUNG-MIEUM': 4419,
'HANGUL CHOSEONG IEUNG-PANSIOS': 4422,
'HANGUL CHOSEONG IEUNG-PHIEUPH': 4427,
'HANGUL CHOSEONG IEUNG-PIEUP': 4420,
'HANGUL CHOSEONG IEUNG-SIOS': 4421,
'HANGUL CHOSEONG IEUNG-THIEUTH': 4426,
'HANGUL CHOSEONG IEUNG-TIKEUT': 4418,
'HANGUL CHOSEONG KAPYEOUNMIEUM': 4381,
'HANGUL CHOSEONG KAPYEOUNPHIEUPH': 4439,
'HANGUL CHOSEONG KAPYEOUNPIEUP': 4395,
'HANGUL CHOSEONG KAPYEOUNRIEUL': 4379,
'HANGUL CHOSEONG KAPYEOUNSSANGPIEUP': 4396,
'HANGUL CHOSEONG KHIEUKH': 4367,
'HANGUL CHOSEONG KIYEOK': 4352,
'HANGUL CHOSEONG MIEUM': 4358,
'HANGUL CHOSEONG MIEUM-PIEUP': 4380,
'HANGUL CHOSEONG NIEUN': 4354,
'HANGUL CHOSEONG NIEUN-KIYEOK': 4371,
'HANGUL CHOSEONG NIEUN-PIEUP': 4374,
'HANGUL CHOSEONG NIEUN-TIKEUT': 4373,
'HANGUL CHOSEONG PANSIOS': 4416,
'HANGUL CHOSEONG PHIEUPH': 4369,
'HANGUL CHOSEONG PHIEUPH-PIEUP': 4438,
'HANGUL CHOSEONG PIEUP': 4359,
'HANGUL CHOSEONG PIEUP-CHIEUCH': 4392,
'HANGUL CHOSEONG PIEUP-CIEUC': 4391,
'HANGUL CHOSEONG PIEUP-KIYEOK': 4382,
'HANGUL CHOSEONG PIEUP-NIEUN': 4383,
'HANGUL CHOSEONG PIEUP-PHIEUPH': 4394,
'HANGUL CHOSEONG PIEUP-SIOS': 4385,
'HANGUL CHOSEONG PIEUP-SIOS-CIEUC': 4390,
'HANGUL CHOSEONG PIEUP-SIOS-KIYEOK': 4386,
'HANGUL CHOSEONG PIEUP-SIOS-PIEUP': 4388,
'HANGUL CHOSEONG PIEUP-SIOS-TIKEUT': 4387,
'HANGUL CHOSEONG PIEUP-SSANGSIOS': 4389,
'HANGUL CHOSEONG PIEUP-THIEUTH': 4393,
'HANGUL CHOSEONG PIEUP-TIKEUT': 4384,
'HANGUL CHOSEONG RIEUL': 4357,
'HANGUL CHOSEONG RIEUL-HIEUH': 4378,
'HANGUL CHOSEONG RIEUL-NIEUN': 4376,
'HANGUL CHOSEONG SIOS': 4361,
'HANGUL CHOSEONG SIOS-CHIEUCH': 4407,
'HANGUL CHOSEONG SIOS-CIEUC': 4406,
'HANGUL CHOSEONG SIOS-HIEUH': 4411,
'HANGUL CHOSEONG SIOS-IEUNG': 4405,
'HANGUL CHOSEONG SIOS-KHIEUKH': 4408,
'HANGUL CHOSEONG SIOS-KIYEOK': 4397,
'HANGUL CHOSEONG SIOS-MIEUM': 4401,
'HANGUL CHOSEONG SIOS-NIEUN': 4398,
'HANGUL CHOSEONG SIOS-PHIEUPH': 4410,
'HANGUL CHOSEONG SIOS-PIEUP': 4402,
'HANGUL CHOSEONG SIOS-PIEUP-KIYEOK': 4403,
'HANGUL CHOSEONG SIOS-RIEUL': 4400,
'HANGUL CHOSEONG SIOS-SSANGSIOS': 4404,
'HANGUL CHOSEONG SIOS-THIEUTH': 4409,
'HANGUL CHOSEONG SIOS-TIKEUT': 4399,
'HANGUL CHOSEONG SSANGCIEUC': 4365,
'HANGUL CHOSEONG SSANGHIEUH': 4440,
'HANGUL CHOSEONG SSANGIEUNG': 4423,
'HANGUL CHOSEONG SSANGKIYEOK': 4353,
'HANGUL CHOSEONG SSANGNIEUN': 4372,
'HANGUL CHOSEONG SSANGPIEUP': 4360,
'HANGUL CHOSEONG SSANGRIEUL': 4377,
'HANGUL CHOSEONG SSANGSIOS': 4362,
'HANGUL CHOSEONG SSANGTIKEUT': 4356,
'HANGUL CHOSEONG THIEUTH': 4368,
'HANGUL CHOSEONG TIKEUT': 4355,
'HANGUL CHOSEONG TIKEUT-KIYEOK': 4375,
'HANGUL CHOSEONG YEORINHIEUH': 4441,
'HANGUL CHOSEONG YESIEUNG': 4428,
'HANGUL DOUBLE DOT TONE MARK': 12335,
'HANGUL FILLER': 12644,
'HANGUL JONGSEONG CHIEUCH': 4542,
'HANGUL JONGSEONG CIEUC': 4541,
'HANGUL JONGSEONG HIEUH': 4546,
'HANGUL JONGSEONG HIEUH-MIEUM': 4599,
'HANGUL JONGSEONG HIEUH-NIEUN': 4597,
'HANGUL JONGSEONG HIEUH-PIEUP': 4600,
'HANGUL JONGSEONG HIEUH-RIEUL': 4598,
'HANGUL JONGSEONG IEUNG': 4540,
'HANGUL JONGSEONG IEUNG-KHIEUKH': 4591,
'HANGUL JONGSEONG IEUNG-KIYEOK': 4588,
'HANGUL JONGSEONG IEUNG-SSANGKIYEOK': 4589,
'HANGUL JONGSEONG KAPYEOUNMIEUM': 4578,
'HANGUL JONGSEONG KAPYEOUNPHIEUPH': 4596,
'HANGUL JONGSEONG KAPYEOUNPIEUP': 4582,
'HANGUL JONGSEONG KHIEUKH': 4543,
'HANGUL JONGSEONG KIYEOK': 4520,
'HANGUL JONGSEONG KIYEOK-RIEUL': 4547,
'HANGUL JONGSEONG KIYEOK-SIOS': 4522,
'HANGUL JONGSEONG KIYEOK-SIOS-KIYEOK': 4548,
'HANGUL JONGSEONG MIEUM': 4535,
'HANGUL JONGSEONG MIEUM-CHIEUCH': 4576,
'HANGUL JONGSEONG MIEUM-HIEUH': 4577,
'HANGUL JONGSEONG MIEUM-KIYEOK': 4570,
'HANGUL JONGSEONG MIEUM-PANSIOS': 4575,
'HANGUL JONGSEONG MIEUM-PIEUP': 4572,
'HANGUL JONGSEONG MIEUM-RIEUL': 4571,
'HANGUL JONGSEONG MIEUM-SIOS': 4573,
'HANGUL JONGSEONG MIEUM-SSANGSIOS': 4574,
'HANGUL JONGSEONG NIEUN': 4523,
'HANGUL JONGSEONG NIEUN-CIEUC': 4524,
'HANGUL JONGSEONG NIEUN-HIEUH': 4525,
'HANGUL JONGSEONG NIEUN-KIYEOK': 4549,
'HANGUL JONGSEONG NIEUN-PANSIOS': 4552,
'HANGUL JONGSEONG NIEUN-SIOS': 4551,
'HANGUL JONGSEONG NIEUN-THIEUTH': 4553,
'HANGUL JONGSEONG NIEUN-TIKEUT': 4550,
'HANGUL JONGSEONG PANSIOS': 4587,
'HANGUL JONGSEONG PHIEUPH': 4545,
'HANGUL JONGSEONG PHIEUPH-PIEUP': 4595,
'HANGUL JONGSEONG PIEUP': 4536,
'HANGUL JONGSEONG PIEUP-HIEUH': 4581,
'HANGUL JONGSEONG PIEUP-PHIEUPH': 4580,
'HANGUL JONGSEONG PIEUP-RIEUL': 4579,
'HANGUL JONGSEONG PIEUP-SIOS': 4537,
'HANGUL JONGSEONG RIEUL': 4527,
'HANGUL JONGSEONG RIEUL-HIEUH': 4534,
'HANGUL JONGSEONG RIEUL-KAPYEOUNPIEUP': 4565,
'HANGUL JONGSEONG RIEUL-KHIEUKH': 4568,
'HANGUL JONGSEONG RIEUL-KIYEOK': 4528,
'HANGUL JONGSEONG RIEUL-KIYEOK-SIOS': 4556,
'HANGUL JONGSEONG RIEUL-MIEUM': 4529,
'HANGUL JONGSEONG RIEUL-MIEUM-KIYEOK': 4561,
'HANGUL JONGSEONG RIEUL-MIEUM-SIOS': 4562,
'HANGUL JONGSEONG RIEUL-NIEUN': 4557,
'HANGUL JONGSEONG RIEUL-PANSIOS': 4567,
'HANGUL JONGSEONG RIEUL-PHIEUPH': 4533,
'HANGUL JONGSEONG RIEUL-PIEUP': 4530,
'HANGUL JONGSEONG RIEUL-PIEUP-HIEUH': 4564,
'HANGUL JONGSEONG RIEUL-PIEUP-SIOS': 4563,
'HANGUL JONGSEONG RIEUL-SIOS': 4531,
'HANGUL JONGSEONG RIEUL-SSANGSIOS': 4566,
'HANGUL JONGSEONG RIEUL-THIEUTH': 4532,
'HANGUL JONGSEONG RIEUL-TIKEUT': 4558,
'HANGUL JONGSEONG RIEUL-TIKEUT-HIEUH': 4559,
'HANGUL JONGSEONG RIEUL-YEORINHIEUH': 4569,
'HANGUL JONGSEONG SIOS': 4538,
'HANGUL JONGSEONG SIOS-KIYEOK': 4583,
'HANGUL JONGSEONG SIOS-PIEUP': 4586,
'HANGUL JONGSEONG SIOS-RIEUL': 4585,
'HANGUL JONGSEONG SIOS-TIKEUT': 4584,
'HANGUL JONGSEONG SSANGIEUNG': 4590,
'HANGUL JONGSEONG SSANGKIYEOK': 4521,
'HANGUL JONGSEONG SSANGRIEUL': 4560,
'HANGUL JONGSEONG SSANGSIOS': 4539,
'HANGUL JONGSEONG THIEUTH': 4544,
'HANGUL JONGSEONG TIKEUT': 4526,
'HANGUL JONGSEONG TIKEUT-KIYEOK': 4554,
'HANGUL JONGSEONG TIKEUT-RIEUL': 4555,
'HANGUL JONGSEONG YEORINHIEUH': 4601,
'HANGUL JONGSEONG YESIEUNG': 4592,
'HANGUL JONGSEONG YESIEUNG-PANSIOS': 4594,
'HANGUL JONGSEONG YESIEUNG-SIOS': 4593,
'HANGUL JUNGSEONG A': 4449,
'HANGUL JUNGSEONG A-O': 4470,
'HANGUL JUNGSEONG A-U': 4471,
'HANGUL JUNGSEONG AE': 4450,
'HANGUL JUNGSEONG ARAEA': 4510,
'HANGUL JUNGSEONG ARAEA-EO': 4511,
'HANGUL JUNGSEONG ARAEA-I': 4513,
'HANGUL JUNGSEONG ARAEA-U': 4512,
'HANGUL JUNGSEONG E': 4454,
'HANGUL JUNGSEONG EO': 4453,
'HANGUL JUNGSEONG EO-EU': 4476,
'HANGUL JUNGSEONG EO-O': 4474,
'HANGUL JUNGSEONG EO-U': 4475,
'HANGUL JUNGSEONG EU': 4467,
'HANGUL JUNGSEONG EU-EU': 4502,
'HANGUL JUNGSEONG EU-U': 4501,
'HANGUL JUNGSEONG FILLER': 4448,
'HANGUL JUNGSEONG I': 4469,
'HANGUL JUNGSEONG I-A': 4504,
'HANGUL JUNGSEONG I-ARAEA': 4509,
'HANGUL JUNGSEONG I-EU': 4508,
'HANGUL JUNGSEONG I-O': 4506,
'HANGUL JUNGSEONG I-U': 4507,
'HANGUL JUNGSEONG I-YA': 4505,
'HANGUL JUNGSEONG O': 4457,
'HANGUL JUNGSEONG O-E': 4480,
'HANGUL JUNGSEONG O-EO': 4479,
'HANGUL JUNGSEONG O-O': 4482,
'HANGUL JUNGSEONG O-U': 4483,
'HANGUL JUNGSEONG O-YE': 4481,
'HANGUL JUNGSEONG OE': 4460,
'HANGUL JUNGSEONG SSANGARAEA': 4514,
'HANGUL JUNGSEONG U': 4462,
'HANGUL JUNGSEONG U-A': 4489,
'HANGUL JUNGSEONG U-AE': 4490,
'HANGUL JUNGSEONG U-EO-EU': 4491,
'HANGUL JUNGSEONG U-U': 4493,
'HANGUL JUNGSEONG U-YE': 4492,
'HANGUL JUNGSEONG WA': 4458,
'HANGUL JUNGSEONG WAE': 4459,
'HANGUL JUNGSEONG WE': 4464,
'HANGUL JUNGSEONG WEO': 4463,
'HANGUL JUNGSEONG WI': 4465,
'HANGUL JUNGSEONG YA': 4451,
'HANGUL JUNGSEONG YA-O': 4472,
'HANGUL JUNGSEONG YA-YO': 4473,
'HANGUL JUNGSEONG YAE': 4452,
'HANGUL JUNGSEONG YE': 4456,
'HANGUL JUNGSEONG YEO': 4455,
'HANGUL JUNGSEONG YEO-O': 4477,
'HANGUL JUNGSEONG YEO-U': 4478,
'HANGUL JUNGSEONG YI': 4468,
'HANGUL JUNGSEONG YI-U': 4503,
'HANGUL JUNGSEONG YO': 4461,
'HANGUL JUNGSEONG YO-I': 4488,
'HANGUL JUNGSEONG YO-O': 4487,
'HANGUL JUNGSEONG YO-YA': 4484,
'HANGUL JUNGSEONG YO-YAE': 4485,
'HANGUL JUNGSEONG YO-YEO': 4486,
'HANGUL JUNGSEONG YU': 4466,
'HANGUL JUNGSEONG YU-A': 4494,
'HANGUL JUNGSEONG YU-E': 4496,
'HANGUL JUNGSEONG YU-EO': 4495,
'HANGUL JUNGSEONG YU-I': 4500,
'HANGUL JUNGSEONG YU-U': 4499,
'HANGUL JUNGSEONG YU-YE': 4498,
'HANGUL JUNGSEONG YU-YEO': 4497,
'HANGUL LETTER A': 12623,
'HANGUL LETTER AE': 12624,
'HANGUL LETTER ARAEA': 12685,
'HANGUL LETTER ARAEAE': 12686,
'HANGUL LETTER CHIEUCH': 12618,
'HANGUL LETTER CIEUC': 12616,
'HANGUL LETTER E': 12628,
'HANGUL LETTER EO': 12627,
'HANGUL LETTER EU': 12641,
'HANGUL LETTER HIEUH': 12622,
'HANGUL LETTER I': 12643,
'HANGUL LETTER IEUNG': 12615,
'HANGUL LETTER KAPYEOUNMIEUM': 12657,
'HANGUL LETTER KAPYEOUNPHIEUPH': 12676,
'HANGUL LETTER KAPYEOUNPIEUP': 12664,
'HANGUL LETTER KAPYEOUNSSANGPIEUP': 12665,
'HANGUL LETTER KHIEUKH': 12619,
'HANGUL LETTER KIYEOK': 12593,
'HANGUL LETTER KIYEOK-SIOS': 12595,
'HANGUL LETTER MIEUM': 12609,
'HANGUL LETTER MIEUM-PANSIOS': 12656,
'HANGUL LETTER MIEUM-PIEUP': 12654,
'HANGUL LETTER MIEUM-SIOS': 12655,
'HANGUL LETTER NIEUN': 12596,
'HANGUL LETTER NIEUN-CIEUC': 12597,
'HANGUL LETTER NIEUN-HIEUH': 12598,
'HANGUL LETTER NIEUN-PANSIOS': 12648,
'HANGUL LETTER NIEUN-SIOS': 12647,
'HANGUL LETTER NIEUN-TIKEUT': 12646,
'HANGUL LETTER O': 12631,
'HANGUL LETTER OE': 12634,
'HANGUL LETTER PANSIOS': 12671,
'HANGUL LETTER PHIEUPH': 12621,
'HANGUL LETTER PIEUP': 12610,
'HANGUL LETTER PIEUP-CIEUC': 12662,
'HANGUL LETTER PIEUP-KIYEOK': 12658,
'HANGUL LETTER PIEUP-SIOS': 12612,
'HANGUL LETTER PIEUP-SIOS-KIYEOK': 12660,
'HANGUL LETTER PIEUP-SIOS-TIKEUT': 12661,
'HANGUL LETTER PIEUP-THIEUTH': 12663,
'HANGUL LETTER PIEUP-TIKEUT': 12659,
'HANGUL LETTER RIEUL': 12601,
'HANGUL LETTER RIEUL-HIEUH': 12608,
'HANGUL LETTER RIEUL-KIYEOK': 12602,
'HANGUL LETTER RIEUL-KIYEOK-SIOS': 12649,
'HANGUL LETTER RIEUL-MIEUM': 12603,
'HANGUL LETTER RIEUL-PANSIOS': 12652,
'HANGUL LETTER RIEUL-PHIEUPH': 12607,
'HANGUL LETTER RIEUL-PIEUP': 12604,
'HANGUL LETTER RIEUL-PIEUP-SIOS': 12651,
'HANGUL LETTER RIEUL-SIOS': 12605,
'HANGUL LETTER RIEUL-THIEUTH': 12606,
'HANGUL LETTER RIEUL-TIKEUT': 12650,
'HANGUL LETTER RIEUL-YEORINHIEUH': 12653,
'HANGUL LETTER SIOS': 12613,
'HANGUL LETTER SIOS-CIEUC': 12670,
'HANGUL LETTER SIOS-KIYEOK': 12666,
'HANGUL LETTER SIOS-NIEUN': 12667,
'HANGUL LETTER SIOS-PIEUP': 12669,
'HANGUL LETTER SIOS-TIKEUT': 12668,
'HANGUL LETTER SSANGCIEUC': 12617,
'HANGUL LETTER SSANGHIEUH': 12677,
'HANGUL LETTER SSANGIEUNG': 12672,
'HANGUL LETTER SSANGKIYEOK': 12594,
'HANGUL LETTER SSANGNIEUN': 12645,
'HANGUL LETTER SSANGPIEUP': 12611,
'HANGUL LETTER SSANGSIOS': 12614,
'HANGUL LETTER SSANGTIKEUT': 12600,
'HANGUL LETTER THIEUTH': 12620,
'HANGUL LETTER TIKEUT': 12599,
'HANGUL LETTER U': 12636,
'HANGUL LETTER WA': 12632,
'HANGUL LETTER WAE': 12633,
'HANGUL LETTER WE': 12638,
'HANGUL LETTER WEO': 12637,
'HANGUL LETTER WI': 12639,
'HANGUL LETTER YA': 12625,
'HANGUL LETTER YAE': 12626,
'HANGUL LETTER YE': 12630,
'HANGUL LETTER YEO': 12629,
'HANGUL LETTER YEORINHIEUH': 12678,
'HANGUL LETTER YESIEUNG': 12673,
'HANGUL LETTER YESIEUNG-PANSIOS': 12675,
'HANGUL LETTER YESIEUNG-SIOS': 12674,
'HANGUL LETTER YI': 12642,
'HANGUL LETTER YO': 12635,
'HANGUL LETTER YO-I': 12681,
'HANGUL LETTER YO-YA': 12679,
'HANGUL LETTER YO-YAE': 12680,
'HANGUL LETTER YU': 12640,
'HANGUL LETTER YU-I': 12684,
'HANGUL LETTER YU-YE': 12683,
'HANGUL LETTER YU-YEO': 12682,
'HANGUL SINGLE DOT TONE MARK': 12334,
'HANGZHOU NUMERAL EIGHT': 12328,
'HANGZHOU NUMERAL FIVE': 12325,
'HANGZHOU NUMERAL FOUR': 12324,
'HANGZHOU NUMERAL NINE': 12329,
'HANGZHOU NUMERAL ONE': 12321,
'HANGZHOU NUMERAL SEVEN': 12327,
'HANGZHOU NUMERAL SIX': 12326,
'HANGZHOU NUMERAL TEN': 12344,
'HANGZHOU NUMERAL THIRTY': 12346,
'HANGZHOU NUMERAL THREE': 12323,
'HANGZHOU NUMERAL TWENTY': 12345,
'HANGZHOU NUMERAL TWO': 12322,
'HANUNOO LETTER A': 5920,
'HANUNOO LETTER BA': 5930,
'HANUNOO LETTER DA': 5927,
'HANUNOO LETTER GA': 5924,
'HANUNOO LETTER HA': 5937,
'HANUNOO LETTER I': 5921,
'HANUNOO LETTER KA': 5923,
'HANUNOO LETTER LA': 5934,
'HANUNOO LETTER MA': 5931,
'HANUNOO LETTER NA': 5928,
'HANUNOO LETTER NGA': 5925,
'HANUNOO LETTER PA': 5929,
'HANUNOO LETTER RA': 5933,
'HANUNOO LETTER SA': 5936,
'HANUNOO LETTER TA': 5926,
'HANUNOO LETTER U': 5922,
'HANUNOO LETTER WA': 5935,
'HANUNOO LETTER YA': 5932,
'HANUNOO SIGN PAMUDPOD': 5940,
'HANUNOO VOWEL SIGN I': 5938,
'HANUNOO VOWEL SIGN U': 5939,
'HEAVY ASTERISK': 10033,
'HEAVY BALLOT X': 10008,
'HEAVY BLACK CURVED DOWNWARDS AND RIGHTWARDS ARROW': 10149,
'HEAVY BLACK CURVED UPWARDS AND RIGHTWARDS ARROW': 10150,
'HEAVY BLACK HEART': 10084,
'HEAVY BLACK-FEATHERED NORTH EAST ARROW': 10169,
'HEAVY BLACK-FEATHERED RIGHTWARDS ARROW': 10168,
'HEAVY BLACK-FEATHERED SOUTH EAST ARROW': 10167,
'HEAVY CHECK MARK': 10004,
'HEAVY CHEVRON SNOWFLAKE': 10054,
'HEAVY CONCAVE-POINTED BLACK RIGHTWARDS ARROW': 10152,
'HEAVY DASHED TRIANGLE-HEADED RIGHTWARDS ARROW': 10144,
'HEAVY DOUBLE COMMA QUOTATION MARK ORNAMENT': 10078,
'HEAVY DOUBLE TURNED COMMA QUOTATION MARK ORNAMENT': 10077,
'HEAVY EIGHT POINTED RECTILINEAR BLACK STAR': 10040,
'HEAVY EIGHT TEARDROP-SPOKED PROPELLER ASTERISK': 10059,
'HEAVY EXCLAMATION MARK ORNAMENT': 10082,
'HEAVY FOUR BALLOON-SPOKED ASTERISK': 10020,
'HEAVY GREEK CROSS': 10010,
'HEAVY HEART EXCLAMATION MARK ORNAMENT': 10083,
'HEAVY LEFT-POINTING ANGLE BRACKET ORNAMENT': 10096,
'HEAVY LEFT-POINTING ANGLE QUOTATION MARK ORNAMENT': 10094,
'HEAVY LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW': 10157,
'HEAVY MULTIPLICATION X': 10006,
'HEAVY NORTH EAST ARROW': 10138,
'HEAVY OPEN CENTRE CROSS': 10012,
'HEAVY OUTLINED BLACK STAR': 10030,
'HEAVY RIGHT-POINTING ANGLE BRACKET ORNAMENT': 10097,
'HEAVY RIGHT-POINTING ANGLE QUOTATION MARK ORNAMENT': 10095,
'HEAVY RIGHTWARDS ARROW': 10137,
'HEAVY ROUND-TIPPED RIGHTWARDS ARROW': 10140,
'HEAVY SINGLE COMMA QUOTATION MARK ORNAMENT': 10076,
'HEAVY SINGLE TURNED COMMA QUOTATION MARK ORNAMENT': 10075,
'HEAVY SOUTH EAST ARROW': 10136,
'HEAVY SPARKLE': 10056,
'HEAVY TEARDROP-SHANKED RIGHTWARDS ARROW': 10171,
'HEAVY TEARDROP-SPOKED ASTERISK': 10045,
'HEAVY TEARDROP-SPOKED PINWHEEL ASTERISK': 10051,
'HEAVY TRIANGLE-HEADED RIGHTWARDS ARROW': 10142,
'HEAVY UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW': 10158,
'HEAVY VERTICAL BAR': 10074,
'HEAVY WEDGE-TAILED RIGHTWARDS ARROW': 10173,
'HEAVY WIDE-HEADED RIGHTWARDS ARROW': 10132,
'HEBREW ACCENT ATNAH HAFUKH': 1442,
'HEBREW ACCENT DARGA': 1447,
'HEBREW ACCENT DEHI': 1453,
'HEBREW ACCENT ETNAHTA': 1425,
'HEBREW ACCENT GERESH': 1436,
'HEBREW ACCENT GERESH MUQDAM': 1437,
'HEBREW ACCENT GERSHAYIM': 1438,
'HEBREW ACCENT ILUY': 1452,
'HEBREW ACCENT MAHAPAKH': 1444,
'HEBREW ACCENT MERKHA': 1445,
'HEBREW ACCENT MERKHA KEFULA': 1446,
'HEBREW ACCENT MUNAH': 1443,
'HEBREW ACCENT OLE': 1451,
'HEBREW ACCENT PASHTA': 1433,
'HEBREW ACCENT PAZER': 1441,
'HEBREW ACCENT QADMA': 1448,
'HEBREW ACCENT QARNEY PARA': 1439,
'HEBREW ACCENT REVIA': 1431,
'HEBREW ACCENT SEGOL': 1426,
'HEBREW ACCENT SHALSHELET': 1427,
'HEBREW ACCENT TELISHA GEDOLA': 1440,
'HEBREW ACCENT TELISHA QETANA': 1449,
'HEBREW ACCENT TEVIR': 1435,
'HEBREW ACCENT TIPEHA': 1430,
'HEBREW ACCENT YERAH BEN YOMO': 1450,
'HEBREW ACCENT YETIV': 1434,
'HEBREW ACCENT ZAQEF GADOL': 1429,
'HEBREW ACCENT ZAQEF QATAN': 1428,
'HEBREW ACCENT ZARQA': 1432,
'HEBREW ACCENT ZINOR': 1454,
'HEBREW LETTER ALEF': 1488,
'HEBREW LETTER ALEF WITH MAPIQ': 64304,
'HEBREW LETTER ALEF WITH PATAH': 64302,
'HEBREW LETTER ALEF WITH QAMATS': 64303,
'HEBREW LETTER ALTERNATIVE AYIN': 64288,
'HEBREW LETTER ALTERNATIVE PLUS SIGN': 64297,
'HEBREW LETTER AYIN': 1506,
'HEBREW LETTER BET': 1489,
'HEBREW LETTER BET WITH DAGESH': 64305,
'HEBREW LETTER BET WITH RAFE': 64332,
'HEBREW LETTER DALET': 1491,
'HEBREW LETTER DALET WITH DAGESH': 64307,
'HEBREW LETTER FINAL KAF': 1498,
'HEBREW LETTER FINAL KAF WITH DAGESH': 64314,
'HEBREW LETTER FINAL MEM': 1501,
'HEBREW LETTER FINAL NUN': 1503,
'HEBREW LETTER FINAL PE': 1507,
'HEBREW LETTER FINAL PE WITH DAGESH': 64323,
'HEBREW LETTER FINAL TSADI': 1509,
'HEBREW LETTER GIMEL': 1490,
'HEBREW LETTER GIMEL WITH DAGESH': 64306,
'HEBREW LETTER HE': 1492,
'HEBREW LETTER HE WITH MAPIQ': 64308,
'HEBREW LETTER HET': 1495,
'HEBREW LETTER KAF': 1499,
'HEBREW LETTER KAF WITH DAGESH': 64315,
'HEBREW LETTER KAF WITH RAFE': 64333,
'HEBREW LETTER LAMED': 1500,
'HEBREW LETTER LAMED WITH DAGESH': 64316,
'HEBREW LETTER MEM': 1502,
'HEBREW LETTER MEM WITH DAGESH': 64318,
'HEBREW LETTER NUN': 1504,
'HEBREW LETTER NUN WITH DAGESH': 64320,
'HEBREW LETTER PE': 1508,
'HEBREW LETTER PE WITH DAGESH': 64324,
'HEBREW LETTER PE WITH RAFE': 64334,
'HEBREW LETTER QOF': 1511,
'HEBREW LETTER QOF WITH DAGESH': 64327,
'HEBREW LETTER RESH': 1512,
'HEBREW LETTER RESH WITH DAGESH': 64328,
'HEBREW LETTER SAMEKH': 1505,
'HEBREW LETTER SAMEKH WITH DAGESH': 64321,
'HEBREW LETTER SHIN': 1513,
'HEBREW LETTER SHIN WITH DAGESH': 64329,
'HEBREW LETTER SHIN WITH DAGESH AND SHIN DOT': 64300,
'HEBREW LETTER SHIN WITH DAGESH AND SIN DOT': 64301,
'HEBREW LETTER SHIN WITH SHIN DOT': 64298,
'HEBREW LETTER SHIN WITH SIN DOT': 64299,
'HEBREW LETTER TAV': 1514,
'HEBREW LETTER TAV WITH DAGESH': 64330,
'HEBREW LETTER TET': 1496,
'HEBREW LETTER TET WITH DAGESH': 64312,
'HEBREW LETTER TSADI': 1510,
'HEBREW LETTER TSADI WITH DAGESH': 64326,
'HEBREW LETTER VAV': 1493,
'HEBREW LETTER VAV WITH DAGESH': 64309,
'HEBREW LETTER VAV WITH HOLAM': 64331,
'HEBREW LETTER WIDE ALEF': 64289,
'HEBREW LETTER WIDE DALET': 64290,
'HEBREW LETTER WIDE FINAL MEM': 64294,
'HEBREW LETTER WIDE HE': 64291,
'HEBREW LETTER WIDE KAF': 64292,
'HEBREW LETTER WIDE LAMED': 64293,
'HEBREW LETTER WIDE RESH': 64295,
'HEBREW LETTER WIDE TAV': 64296,
'HEBREW LETTER YOD': 1497,
'HEBREW LETTER YOD WITH DAGESH': 64313,
'HEBREW LETTER YOD WITH HIRIQ': 64285,
'HEBREW LETTER ZAYIN': 1494,
'HEBREW LETTER ZAYIN WITH DAGESH': 64310,
'HEBREW LIGATURE ALEF LAMED': 64335,
'HEBREW LIGATURE YIDDISH DOUBLE VAV': 1520,
'HEBREW LIGATURE YIDDISH DOUBLE YOD': 1522,
'HEBREW LIGATURE YIDDISH VAV YOD': 1521,
'HEBREW LIGATURE YIDDISH YOD YOD PATAH': 64287,
'HEBREW MARK LOWER DOT': 1477,
'HEBREW MARK MASORA CIRCLE': 1455,
'HEBREW MARK UPPER DOT': 1476,
'HEBREW POINT DAGESH OR MAPIQ': 1468,
'HEBREW POINT HATAF PATAH': 1458,
'HEBREW POINT HATAF QAMATS': 1459,
'HEBREW POINT HATAF SEGOL': 1457,
'HEBREW POINT HIRIQ': 1460,
'HEBREW POINT HOLAM': 1465,
'HEBREW POINT JUDEO-SPANISH VARIKA': 64286,
'HEBREW POINT METEG': 1469,
'HEBREW POINT PATAH': 1463,
'HEBREW POINT QAMATS': 1464,
'HEBREW POINT QAMATS QATAN': 1479,
'HEBREW POINT QUBUTS': 1467,
'HEBREW POINT RAFE': 1471,
'HEBREW POINT SEGOL': 1462,
'HEBREW POINT SHEVA': 1456,
'HEBREW POINT SHIN DOT': 1473,
'HEBREW POINT SIN DOT': 1474,
'HEBREW POINT TSERE': 1461,
'HEBREW PUNCTUATION GERESH': 1523,
'HEBREW PUNCTUATION GERSHAYIM': 1524,
'HEBREW PUNCTUATION MAQAF': 1470,
'HEBREW PUNCTUATION NUN HAFUKHA': 1478,
'HEBREW PUNCTUATION PASEQ': 1472,
'HEBREW PUNCTUATION SOF PASUQ': 1475,
'HELM SYMBOL': 9096,
'HERMITIAN CONJUGATE MATRIX': 8889,
'HEXAGRAM FOR ABUNDANCE': 19958,
'HEXAGRAM FOR AFTER COMPLETION': 19966,
'HEXAGRAM FOR APPROACH': 19922,
'HEXAGRAM FOR BEFORE COMPLETION': 19967,
'HEXAGRAM FOR BITING THROUGH': 19924,
'HEXAGRAM FOR BREAKTHROUGH': 19946,
'HEXAGRAM FOR COMING TO MEET': 19947,
'HEXAGRAM FOR CONFLICT': 19909,
'HEXAGRAM FOR CONTEMPLATION': 19923,
'HEXAGRAM FOR DARKENING OF THE LIGHT': 19939,
'HEXAGRAM FOR DECREASE': 19944,
'HEXAGRAM FOR DELIVERANCE': 19943,
'HEXAGRAM FOR DEVELOPMENT': 19956,
'HEXAGRAM FOR DIFFICULTY AT THE BEGINNING': 19906,
'HEXAGRAM FOR DISPERSION': 19962,
'HEXAGRAM FOR DURATION': 19935,
'HEXAGRAM FOR ENTHUSIASM': 19919,
'HEXAGRAM FOR FELLOWSHIP': 19916,
'HEXAGRAM FOR FOLLOWING': 19920,
'HEXAGRAM FOR GATHERING TOGETHER': 19948,
'HEXAGRAM FOR GRACE': 19925,
'HEXAGRAM FOR GREAT POSSESSION': 19917,
'HEXAGRAM FOR GREAT POWER': 19937,
'HEXAGRAM FOR GREAT PREPONDERANCE': 19931,
'HEXAGRAM FOR GREAT TAMING': 19929,
'HEXAGRAM FOR HOLDING TOGETHER': 19911,
'HEXAGRAM FOR INCREASE': 19945,
'HEXAGRAM FOR INFLUENCE': 19934,
'HEXAGRAM FOR INNER TRUTH': 19964,
'HEXAGRAM FOR INNOCENCE': 19928,
'HEXAGRAM FOR LIMITATION': 19963,
'HEXAGRAM FOR MODESTY': 19918,
'HEXAGRAM FOR MOUTH CORNERS': 19930,
'HEXAGRAM FOR OBSTRUCTION': 19942,
'HEXAGRAM FOR OPPOSITION': 19941,
'HEXAGRAM FOR OPPRESSION': 19950,
'HEXAGRAM FOR PEACE': 19914,
'HEXAGRAM FOR PROGRESS': 19938,
'HEXAGRAM FOR PUSHING UPWARD': 19949,
'HEXAGRAM FOR RETREAT': 19936,
'HEXAGRAM FOR RETURN': 19927,
'HEXAGRAM FOR REVOLUTION': 19952,
'HEXAGRAM FOR SMALL PREPONDERANCE': 19965,
'HEXAGRAM FOR SMALL TAMING': 19912,
'HEXAGRAM FOR SPLITTING APART': 19926,
'HEXAGRAM FOR STANDSTILL': 19915,
'HEXAGRAM FOR THE ABYSMAL WATER': 19932,
'HEXAGRAM FOR THE ARMY': 19910,
'HEXAGRAM FOR THE AROUSING THUNDER': 19954,
'HEXAGRAM FOR THE CAULDRON': 19953,
'HEXAGRAM FOR THE CLINGING FIRE': 19933,
'HEXAGRAM FOR THE CREATIVE HEAVEN': 19904,
'HEXAGRAM FOR THE FAMILY': 19940,
'HEXAGRAM FOR THE GENTLE WIND': 19960,
'HEXAGRAM FOR THE JOYOUS LAKE': 19961,
'HEXAGRAM FOR THE KEEPING STILL MOUNTAIN': 19955,
'HEXAGRAM FOR THE MARRYING MAIDEN': 19957,
'HEXAGRAM FOR THE RECEPTIVE EARTH': 19905,
'HEXAGRAM FOR THE WANDERER': 19959,
'HEXAGRAM FOR THE WELL': 19951,
'HEXAGRAM FOR TREADING': 19913,
'HEXAGRAM FOR WAITING': 19908,
'HEXAGRAM FOR WORK ON THE DECAYED': 19921,
'HEXAGRAM FOR YOUTHFUL FOLLY': 19907,
'HIGH VOLTAGE SIGN': 9889,
'HIRAGANA DIGRAPH YORI': 12447,
'HIRAGANA ITERATION MARK': 12445,
'HIRAGANA LETTER A': 12354,
'HIRAGANA LETTER BA': 12400,
'HIRAGANA LETTER BE': 12409,
'HIRAGANA LETTER BI': 12403,
'HIRAGANA LETTER BO': 12412,
'HIRAGANA LETTER BU': 12406,
'HIRAGANA LETTER DA': 12384,
'HIRAGANA LETTER DE': 12391,
'HIRAGANA LETTER DI': 12386,
'HIRAGANA LETTER DO': 12393,
'HIRAGANA LETTER DU': 12389,
'HIRAGANA LETTER E': 12360,
'HIRAGANA LETTER GA': 12364,
'HIRAGANA LETTER GE': 12370,
'HIRAGANA LETTER GI': 12366,
'HIRAGANA LETTER GO': 12372,
'HIRAGANA LETTER GU': 12368,
'HIRAGANA LETTER HA': 12399,
'HIRAGANA LETTER HE': 12408,
'HIRAGANA LETTER HI': 12402,
'HIRAGANA LETTER HO': 12411,
'HIRAGANA LETTER HU': 12405,
'HIRAGANA LETTER I': 12356,
'HIRAGANA LETTER KA': 12363,
'HIRAGANA LETTER KE': 12369,
'HIRAGANA LETTER KI': 12365,
'HIRAGANA LETTER KO': 12371,
'HIRAGANA LETTER KU': 12367,
'HIRAGANA LETTER MA': 12414,
'HIRAGANA LETTER ME': 12417,
'HIRAGANA LETTER MI': 12415,
'HIRAGANA LETTER MO': 12418,
'HIRAGANA LETTER MU': 12416,
'HIRAGANA LETTER N': 12435,
'HIRAGANA LETTER NA': 12394,
'HIRAGANA LETTER NE': 12397,
'HIRAGANA LETTER NI': 12395,
'HIRAGANA LETTER NO': 12398,
'HIRAGANA LETTER NU': 12396,
'HIRAGANA LETTER O': 12362,
'HIRAGANA LETTER PA': 12401,
'HIRAGANA LETTER PE': 12410,
'HIRAGANA LETTER PI': 12404,
'HIRAGANA LETTER PO': 12413,
'HIRAGANA LETTER PU': 12407,
'HIRAGANA LETTER RA': 12425,
'HIRAGANA LETTER RE': 12428,
'HIRAGANA LETTER RI': 12426,
'HIRAGANA LETTER RO': 12429,
'HIRAGANA LETTER RU': 12427,
'HIRAGANA LETTER SA': 12373,
'HIRAGANA LETTER SE': 12379,
'HIRAGANA LETTER SI': 12375,
'HIRAGANA LETTER SMALL A': 12353,
'HIRAGANA LETTER SMALL E': 12359,
'HIRAGANA LETTER SMALL I': 12355,
'HIRAGANA LETTER SMALL KA': 12437,
'HIRAGANA LETTER SMALL KE': 12438,
'HIRAGANA LETTER SMALL O': 12361,
'HIRAGANA LETTER SMALL TU': 12387,
'HIRAGANA LETTER SMALL U': 12357,
'HIRAGANA LETTER SMALL WA': 12430,
'HIRAGANA LETTER SMALL YA': 12419,
'HIRAGANA LETTER SMALL YO': 12423,
'HIRAGANA LETTER SMALL YU': 12421,
'HIRAGANA LETTER SO': 12381,
'HIRAGANA LETTER SU': 12377,
'HIRAGANA LETTER TA': 12383,
'HIRAGANA LETTER TE': 12390,
'HIRAGANA LETTER TI': 12385,
'HIRAGANA LETTER TO': 12392,
'HIRAGANA LETTER TU': 12388,
'HIRAGANA LETTER U': 12358,
'HIRAGANA LETTER VU': 12436,
'HIRAGANA LETTER WA': 12431,
'HIRAGANA LETTER WE': 12433,
'HIRAGANA LETTER WI': 12432,
'HIRAGANA LETTER WO': 12434,
'HIRAGANA LETTER YA': 12420,
'HIRAGANA LETTER YO': 12424,
'HIRAGANA LETTER YU': 12422,
'HIRAGANA LETTER ZA': 12374,
'HIRAGANA LETTER ZE': 12380,
'HIRAGANA LETTER ZI': 12376,
'HIRAGANA LETTER ZO': 12382,
'HIRAGANA LETTER ZU': 12378,
'HIRAGANA VOICED ITERATION MARK': 12446,
'HOMOTHETIC': 8763,
'HORIZONTAL BAR': 8213,
'HORIZONTAL ELLIPSIS': 8230,
'HORIZONTAL LINE EXTENSION': 9135,
'HORIZONTAL MALE WITH STROKE SIGN': 9897,
'HORIZONTAL SCAN LINE-1': 9146,
'HORIZONTAL SCAN LINE-3': 9147,
'HORIZONTAL SCAN LINE-7': 9148,
'HORIZONTAL SCAN LINE-9': 9149,
'HOT BEVERAGE': 9749,
'HOT SPRINGS': 9832,
'HOURGLASS': 8987,
'HOUSE': 8962,
'HRYVNIA SIGN': 8372,
'HYPHEN': 8208,
'HYPHEN BULLET': 8259,
'HYPHEN-MINUS': 45,
'HYPHENATION POINT': 8231,
'HYPODIASTOLE': 11794,
'HYSTERESIS SYMBOL': 9102,
'IDENTICAL TO': 8801,
'IDENTICAL TO AND SLANTED PARALLEL': 10725,
'IDENTICAL WITH DOT ABOVE': 10855,
'IDEOGRAPHIC ANNOTATION BOTTOM MARK': 12696,
'IDEOGRAPHIC ANNOTATION EARTH MARK': 12702,
'IDEOGRAPHIC ANNOTATION FIRST MARK': 12697,
'IDEOGRAPHIC ANNOTATION FOUR MARK': 12693,
'IDEOGRAPHIC ANNOTATION FOURTH MARK': 12700,
'IDEOGRAPHIC ANNOTATION HEAVEN MARK': 12701,
'IDEOGRAPHIC ANNOTATION LINKING MARK': 12688,
'IDEOGRAPHIC ANNOTATION MAN MARK': 12703,
'IDEOGRAPHIC ANNOTATION MIDDLE MARK': 12695,
'IDEOGRAPHIC ANNOTATION ONE MARK': 12690,
'IDEOGRAPHIC ANNOTATION REVERSE MARK': 12689,
'IDEOGRAPHIC ANNOTATION SECOND MARK': 12698,
'IDEOGRAPHIC ANNOTATION THIRD MARK': 12699,
'IDEOGRAPHIC ANNOTATION THREE MARK': 12692,
'IDEOGRAPHIC ANNOTATION TOP MARK': 12694,
'IDEOGRAPHIC ANNOTATION TWO MARK': 12691,
'IDEOGRAPHIC CLOSING MARK': 12294,
'IDEOGRAPHIC COMMA': 12289,
'IDEOGRAPHIC DEPARTING TONE MARK': 12332,
'IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO BELOW': 12273,
'IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO MIDDLE AND BELOW': 12275,
'IDEOGRAPHIC DESCRIPTION CHARACTER FULL SURROUND': 12276,
'IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO MIDDLE AND RIGHT': 12274,
'IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO RIGHT': 12272,
'IDEOGRAPHIC DESCRIPTION CHARACTER OVERLAID': 12283,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM ABOVE': 12277,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM BELOW': 12278,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LEFT': 12279,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LOWER LEFT': 12282,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER LEFT': 12280,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER RIGHT': 12281,
'IDEOGRAPHIC ENTERING TONE MARK': 12333,
'IDEOGRAPHIC FULL STOP': 12290,
'IDEOGRAPHIC HALF FILL SPACE': 12351,
'IDEOGRAPHIC ITERATION MARK': 12293,
'IDEOGRAPHIC LEVEL TONE MARK': 12330,
'IDEOGRAPHIC NUMBER ZERO': 12295,
'IDEOGRAPHIC RISING TONE MARK': 12331,
'IDEOGRAPHIC SPACE': 12288,
'IDEOGRAPHIC TELEGRAPH LINE FEED SEPARATOR SYMBOL': 12343,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR APRIL': 12995,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR AUGUST': 12999,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHT': 13287,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHTEEN': 13297,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ELEVEN': 13290,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIFTEEN': 13294,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIVE': 13284,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOUR': 13283,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOURTEEN': 13293,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINE': 13288,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINETEEN': 13298,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ONE': 13280,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVEN': 13286,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVENTEEN': 13296,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIX': 13285,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIXTEEN': 13295,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TEN': 13289,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTEEN': 13292,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY': 13309,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY-ONE': 13310,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THREE': 13282,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWELVE': 13291,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY': 13299,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-EIGHT': 13307,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FIVE': 13304,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FOUR': 13303,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-NINE': 13308,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-ONE': 13300,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SEVEN': 13306,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SIX': 13305,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-THREE': 13302,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-TWO': 13301,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWO': 13281,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DECEMBER': 13003,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR FEBRUARY': 12993,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHT': 13152,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHTEEN': 13162,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ELEVEN': 13155,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIFTEEN': 13159,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIVE': 13149,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOUR': 13148,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOURTEEN': 13158,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINE': 13153,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINETEEN': 13163,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ONE': 13145,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVEN': 13151,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVENTEEN': 13161,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIX': 13150,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIXTEEN': 13160,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TEN': 13154,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THIRTEEN': 13157,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THREE': 13147,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWELVE': 13156,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY': 13164,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-FOUR': 13168,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-ONE': 13165,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-THREE': 13167,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-TWO': 13166,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWO': 13146,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ZERO': 13144,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR JANUARY': 12992,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR JULY': 12998,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR JUNE': 12997,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR MARCH': 12994,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR MAY': 12996,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR NOVEMBER': 13002,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR OCTOBER': 13001,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR SEPTEMBER': 13000,
'IDEOGRAPHIC VARIATION INDICATOR': 12350,
'IMAGE OF': 8887,
'IMAGE OF OR APPROXIMATELY EQUAL TO': 8787,
'INCOMPLETE INFINITY': 10716,
'INCREASES AS': 10721,
'INCREMENT': 8710,
'INFINITY': 8734,
'INFINITY NEGATED WITH VERTICAL BAR': 10718,
'INFORMATION SOURCE': 8505,
'INHIBIT ARABIC FORM SHAPING': 8300,
'INHIBIT SYMMETRIC SWAPPING': 8298,
'INSERTION SYMBOL': 9088,
'INTEGRAL': 8747,
'INTEGRAL AROUND A POINT OPERATOR': 10773,
'INTEGRAL AVERAGE WITH SLASH': 10767,
'INTEGRAL EXTENSION': 9134,
'INTEGRAL WITH DOUBLE STROKE': 10766,
'INTEGRAL WITH INTERSECTION': 10777,
'INTEGRAL WITH LEFTWARDS ARROW WITH HOOK': 10775,
'INTEGRAL WITH OVERBAR': 10779,
'INTEGRAL WITH TIMES SIGN': 10776,
'INTEGRAL WITH UNDERBAR': 10780,
'INTEGRAL WITH UNION': 10778,
'INTERCALATE': 8890,
'INTERIOR PRODUCT': 10812,
'INTERLINEAR ANNOTATION ANCHOR': 65529,
'INTERLINEAR ANNOTATION SEPARATOR': 65530,
'INTERLINEAR ANNOTATION TERMINATOR': 65531,
'INTERLOCKED FEMALE AND MALE SIGN': 9892,
'INTERROBANG': 8253,
'INTERSECTION': 8745,
'INTERSECTION ABOVE BAR ABOVE UNION': 10825,
'INTERSECTION ABOVE UNION': 10823,
'INTERSECTION BESIDE AND JOINED WITH INTERSECTION': 10827,
'INTERSECTION WITH DOT': 10816,
'INTERSECTION WITH LOGICAL AND': 10820,
'INTERSECTION WITH OVERBAR': 10819,
'INVERSE BULLET': 9688,
'INVERSE WHITE CIRCLE': 9689,
'INVERTED EXCLAMATION MARK': 161,
'INVERTED LAZY S': 8766,
'INVERTED OHM SIGN': 8487,
'INVERTED QUESTION MARK': 191,
'INVERTED UNDERTIE': 8276,
'INVISIBLE SEPARATOR': 8291,
'INVISIBLE TIMES': 8290,
'JAPANESE INDUSTRIAL STANDARD SYMBOL': 12292,
'JOIN': 10781,
'JUPITER': 9795,
'KANGXI RADICAL AGAIN': 12060,
'KANGXI RADICAL AND': 12157,
'KANGXI RADICAL ARRIVE': 12164,
'KANGXI RADICAL ARROW': 12142,
'KANGXI RADICAL AXE': 12100,
'KANGXI RADICAL BADGER': 12184,
'KANGXI RADICAL BAMBOO': 12149,
'KANGXI RADICAL BEAN': 12182,
'KANGXI RADICAL BIG': 12068,
'KANGXI RADICAL BIRD': 12227,
'KANGXI RADICAL BITTER': 12191,
'KANGXI RADICAL BLACK': 12234,
'KANGXI RADICAL BLOOD': 12174,
'KANGXI RADICAL BLUE': 12205,
'KANGXI RADICAL BOAT': 12168,
'KANGXI RADICAL BODY': 12189,
'KANGXI RADICAL BOLT OF CLOTH': 12134,
'KANGXI RADICAL BONE': 12219,
'KANGXI RADICAL BOW': 12088,
'KANGXI RADICAL BRANCH': 12096,
'KANGXI RADICAL BRISTLE': 12090,
'KANGXI RADICAL BRUSH': 12160,
'KANGXI RADICAL CART': 12190,
'KANGXI RADICAL CAULDRON': 12224,
'KANGXI RADICAL CAVE': 12147,
'KANGXI RADICAL CHILD': 12070,
'KANGXI RADICAL CITY': 12194,
'KANGXI RADICAL CLAN': 12114,
'KANGXI RADICAL CLAW': 12118,
'KANGXI RADICAL CLIFF': 12058,
'KANGXI RADICAL CLOTHES': 12176,
'KANGXI RADICAL COLOR': 12170,
'KANGXI RADICAL COMPARE': 12112,
'KANGXI RADICAL CORPSE': 12075,
'KANGXI RADICAL COVER': 12045,
'KANGXI RADICAL COW': 12124,
'KANGXI RADICAL DEATH': 12109,
'KANGXI RADICAL DEER': 12229,
'KANGXI RADICAL DIPPER': 12099,
'KANGXI RADICAL DISH': 12139,
'KANGXI RADICAL DISTINGUISH': 12196,
'KANGXI RADICAL DIVINATION': 12056,
'KANGXI RADICAL DO NOT': 12111,
'KANGXI RADICAL DOG': 12125,
'KANGXI RADICAL DOOR': 12094,
'KANGXI RADICAL DOT': 12034,
'KANGXI RADICAL DOTTED CLIFF': 12084,
'KANGXI RADICAL DOTTED TENT': 12136,
'KANGXI RADICAL DOUBLE X': 12120,
'KANGXI RADICAL DOWN BOX': 12044,
'KANGXI RADICAL DRAGON': 12243,
'KANGXI RADICAL DRUM': 12238,
'KANGXI RADICAL DRY': 12082,
'KANGXI RADICAL EAR': 12159,
'KANGXI RADICAL EARTH': 12063,
'KANGXI RADICAL EAT': 12215,
'KANGXI RADICAL EIGHT': 12043,
'KANGXI RADICAL EMBROIDERY': 12235,
'KANGXI RADICAL ENCLOSURE': 12062,
'KANGXI RADICAL ENTER': 12042,
'KANGXI RADICAL EVEN': 12241,
'KANGXI RADICAL EVENING': 12067,
'KANGXI RADICAL EYE': 12140,
'KANGXI RADICAL FACE': 12207,
'KANGXI RADICAL FANG': 12123,
'KANGXI RADICAL FATHER': 12119,
'KANGXI RADICAL FEATHER': 12155,
'KANGXI RADICAL FIELD': 12133,
'KANGXI RADICAL FIGHT': 12222,
'KANGXI RADICAL FIRE': 12117,
'KANGXI RADICAL FISH': 12226,
'KANGXI RADICAL FLUTE': 12245,
'KANGXI RADICAL FLY': 12214,
'KANGXI RADICAL FOOT': 12188,
'KANGXI RADICAL FRAGRANT': 12217,
'KANGXI RADICAL FROG': 12236,
'KANGXI RADICAL FUR': 12113,
'KANGXI RADICAL GATE': 12200,
'KANGXI RADICAL GHOST': 12225,
'KANGXI RADICAL GO': 12065,
'KANGXI RADICAL GO SLOWLY': 12066,
'KANGXI RADICAL GOLD': 12198,
'KANGXI RADICAL GRAIN': 12146,
'KANGXI RADICAL GRASS': 12171,
'KANGXI RADICAL HAIR': 12221,
'KANGXI RADICAL HALBERD': 12093,
'KANGXI RADICAL HALF TREE TRUNK': 12121,
'KANGXI RADICAL HAND': 12095,
'KANGXI RADICAL HEAD': 12216,
'KANGXI RADICAL HEART': 12092,
'KANGXI RADICAL HEMP': 12231,
'KANGXI RADICAL HIDING ENCLOSURE': 12054,
'KANGXI RADICAL HOOK': 12037,
'KANGXI RADICAL HORN': 12179,
'KANGXI RADICAL HORSE': 12218,
'KANGXI RADICAL ICE': 12046,
'KANGXI RADICAL INCH': 12072,
'KANGXI RADICAL INSECT': 12173,
'KANGXI RADICAL JADE': 12127,
'KANGXI RADICAL JAR': 12152,
'KANGXI RADICAL KNIFE': 12049,
'KANGXI RADICAL LACK': 12107,
'KANGXI RADICAL LAME': 12074,
'KANGXI RADICAL LEAF': 12212,
'KANGXI RADICAL LEATHER': 12208,
'KANGXI RADICAL LEEK': 12210,
'KANGXI RADICAL LEGS': 12041,
'KANGXI RADICAL LID': 12039,
'KANGXI RADICAL LIFE': 12131,
'KANGXI RADICAL LINE': 12033,
'KANGXI RADICAL LONG': 12199,
'KANGXI RADICAL LONG STRIDE': 12085,
'KANGXI RADICAL MAN': 12040,
'KANGXI RADICAL MEAT': 12161,
'KANGXI RADICAL MELON': 12128,
'KANGXI RADICAL MILLET': 12233,
'KANGXI RADICAL MINISTER': 12162,
'KANGXI RADICAL MOON': 12105,
'KANGXI RADICAL MORNING': 12192,
'KANGXI RADICAL MORTAR': 12165,
'KANGXI RADICAL MOUND': 12201,
'KANGXI RADICAL MOUNTAIN': 12077,
'KANGXI RADICAL MOUTH': 12061,
'KANGXI RADICAL NET': 12153,
'KANGXI RADICAL NOSE': 12240,
'KANGXI RADICAL NOT': 12102,
'KANGXI RADICAL OLD': 12156,
'KANGXI RADICAL ONE': 12032,
'KANGXI RADICAL ONESELF': 12080,
'KANGXI RADICAL OPEN BOX': 12048,
'KANGXI RADICAL OPPOSE': 12167,
'KANGXI RADICAL PIG': 12183,
'KANGXI RADICAL PLOW': 12158,
'KANGXI RADICAL POWER': 12050,
'KANGXI RADICAL PRIVATE': 12059,
'KANGXI RADICAL PROFOUND': 12126,
'KANGXI RADICAL RAIN': 12204,
'KANGXI RADICAL RAP': 12097,
'KANGXI RADICAL RAT': 12239,
'KANGXI RADICAL RED': 12186,
'KANGXI RADICAL RICE': 12150,
'KANGXI RADICAL RIGHT OPEN BOX': 12053,
'KANGXI RADICAL RIVER': 12078,
'KANGXI RADICAL ROOF': 12071,
'KANGXI RADICAL RUN': 12187,
'KANGXI RADICAL SACRIFICIAL WINE': 12223,
'KANGXI RADICAL SALT': 12228,
'KANGXI RADICAL SAY': 12104,
'KANGXI RADICAL SCHOLAR': 12064,
'KANGXI RADICAL SCRIPT': 12098,
'KANGXI RADICAL SEAL': 12057,
'KANGXI RADICAL SECOND': 12036,
'KANGXI RADICAL SEE': 12178,
'KANGXI RADICAL SELF': 12163,
'KANGXI RADICAL SHEEP': 12154,
'KANGXI RADICAL SHELL': 12185,
'KANGXI RADICAL SHOOT': 12087,
'KANGXI RADICAL SHORT TAILED BIRD': 12203,
'KANGXI RADICAL SHORT THREAD': 12083,
'KANGXI RADICAL SICKNESS': 12135,
'KANGXI RADICAL SILK': 12151,
'KANGXI RADICAL SKIN': 12138,
'KANGXI RADICAL SLASH': 12035,
'KANGXI RADICAL SLAVE': 12202,
'KANGXI RADICAL SLICE': 12122,
'KANGXI RADICAL SMALL': 12073,
'KANGXI RADICAL SNOUT': 12089,
'KANGXI RADICAL SOUND': 12211,
'KANGXI RADICAL SPEAR': 12141,
'KANGXI RADICAL SPEECH': 12180,
'KANGXI RADICAL SPIRIT': 12144,
'KANGXI RADICAL SPOON': 12052,
'KANGXI RADICAL SPROUT': 12076,
'KANGXI RADICAL SQUARE': 12101,
'KANGXI RADICAL STAND': 12148,
'KANGXI RADICAL STEAM': 12115,
'KANGXI RADICAL STEP': 12091,
'KANGXI RADICAL STONE': 12143,
'KANGXI RADICAL STOP': 12108,
'KANGXI RADICAL STOPPING': 12169,
'KANGXI RADICAL SUN': 12103,
'KANGXI RADICAL SWEET': 12130,
'KANGXI RADICAL TABLE': 12047,
'KANGXI RADICAL TALL': 12220,
'KANGXI RADICAL TANNED LEATHER': 12209,
'KANGXI RADICAL TEN': 12055,
'KANGXI RADICAL TIGER': 12172,
'KANGXI RADICAL TILE': 12129,
'KANGXI RADICAL TONGUE': 12166,
'KANGXI RADICAL TOOTH': 12242,
'KANGXI RADICAL TRACK': 12145,
'KANGXI RADICAL TREE': 12106,
'KANGXI RADICAL TRIPOD': 12237,
'KANGXI RADICAL TURBAN': 12081,
'KANGXI RADICAL TURTLE': 12244,
'KANGXI RADICAL TWO': 12038,
'KANGXI RADICAL TWO HANDS': 12086,
'KANGXI RADICAL USE': 12132,
'KANGXI RADICAL VALLEY': 12181,
'KANGXI RADICAL VILLAGE': 12197,
'KANGXI RADICAL WALK': 12193,
'KANGXI RADICAL WALK ENCLOSURE': 12175,
'KANGXI RADICAL WATER': 12116,
'KANGXI RADICAL WEAPON': 12110,
'KANGXI RADICAL WEST': 12177,
'KANGXI RADICAL WHEAT': 12230,
'KANGXI RADICAL WHITE': 12137,
'KANGXI RADICAL WIND': 12213,
'KANGXI RADICAL WINE': 12195,
'KANGXI RADICAL WOMAN': 12069,
'KANGXI RADICAL WORK': 12079,
'KANGXI RADICAL WRAP': 12051,
'KANGXI RADICAL WRONG': 12206,
'KANGXI RADICAL YELLOW': 12232,
'KANNADA AI LENGTH MARK': 3286,
'KANNADA DIGIT EIGHT': 3310,
'KANNADA DIGIT FIVE': 3307,
'KANNADA DIGIT FOUR': 3306,
'KANNADA DIGIT NINE': 3311,
'KANNADA DIGIT ONE': 3303,
'KANNADA DIGIT SEVEN': 3309,
'KANNADA DIGIT SIX': 3308,
'KANNADA DIGIT THREE': 3305,
'KANNADA DIGIT TWO': 3304,
'KANNADA DIGIT ZERO': 3302,
'KANNADA LENGTH MARK': 3285,
'KANNADA LETTER A': 3205,
'KANNADA LETTER AA': 3206,
'KANNADA LETTER AI': 3216,
'KANNADA LETTER AU': 3220,
'KANNADA LETTER BA': 3244,
'KANNADA LETTER BHA': 3245,
'KANNADA LETTER CA': 3226,
'KANNADA LETTER CHA': 3227,
'KANNADA LETTER DA': 3238,
'KANNADA LETTER DDA': 3233,
'KANNADA LETTER DDHA': 3234,
'KANNADA LETTER DHA': 3239,
'KANNADA LETTER E': 3214,
'KANNADA LETTER EE': 3215,
'KANNADA LETTER FA': 3294,
'KANNADA LETTER GA': 3223,
'KANNADA LETTER GHA': 3224,
'KANNADA LETTER HA': 3257,
'KANNADA LETTER I': 3207,
'KANNADA LETTER II': 3208,
'KANNADA LETTER JA': 3228,
'KANNADA LETTER JHA': 3229,
'KANNADA LETTER KA': 3221,
'KANNADA LETTER KHA': 3222,
'KANNADA LETTER LA': 3250,
'KANNADA LETTER LLA': 3251,
'KANNADA LETTER MA': 3246,
'KANNADA LETTER NA': 3240,
'KANNADA LETTER NGA': 3225,
'KANNADA LETTER NNA': 3235,
'KANNADA LETTER NYA': 3230,
'KANNADA LETTER O': 3218,
'KANNADA LETTER OO': 3219,
'KANNADA LETTER PA': 3242,
'KANNADA LETTER PHA': 3243,
'KANNADA LETTER RA': 3248,
'KANNADA LETTER RRA': 3249,
'KANNADA LETTER SA': 3256,
'KANNADA LETTER SHA': 3254,
'KANNADA LETTER SSA': 3255,
'KANNADA LETTER TA': 3236,
'KANNADA LETTER THA': 3237,
'KANNADA LETTER TTA': 3231,
'KANNADA LETTER TTHA': 3232,
'KANNADA LETTER U': 3209,
'KANNADA LETTER UU': 3210,
'KANNADA LETTER VA': 3253,
'KANNADA LETTER VOCALIC L': 3212,
'KANNADA LETTER VOCALIC LL': 3297,
'KANNADA LETTER VOCALIC R': 3211,
'KANNADA LETTER VOCALIC RR': 3296,
'KANNADA LETTER YA': 3247,
'KANNADA SIGN ANUSVARA': 3202,
'KANNADA SIGN AVAGRAHA': 3261,
'KANNADA SIGN NUKTA': 3260,
'KANNADA SIGN VIRAMA': 3277,
'KANNADA SIGN VISARGA': 3203,
'KANNADA VOWEL SIGN AA': 3262,
'KANNADA VOWEL SIGN AI': 3272,
'KANNADA VOWEL SIGN AU': 3276,
'KANNADA VOWEL SIGN E': 3270,
'KANNADA VOWEL SIGN EE': 3271,
'KANNADA VOWEL SIGN I': 3263,
'KANNADA VOWEL SIGN II': 3264,
'KANNADA VOWEL SIGN O': 3274,
'KANNADA VOWEL SIGN OO': 3275,
'KANNADA VOWEL SIGN U': 3265,
'KANNADA VOWEL SIGN UU': 3266,
'KANNADA VOWEL SIGN VOCALIC R': 3267,
'KANNADA VOWEL SIGN VOCALIC RR': 3268,
'KATAKANA DIGRAPH KOTO': 12543,
'KATAKANA ITERATION MARK': 12541,
'KATAKANA LETTER A': 12450,
'KATAKANA LETTER BA': 12496,
'KATAKANA LETTER BE': 12505,
'KATAKANA LETTER BI': 12499,
'KATAKANA LETTER BO': 12508,
'KATAKANA LETTER BU': 12502,
'KATAKANA LETTER DA': 12480,
'KATAKANA LETTER DE': 12487,
'KATAKANA LETTER DI': 12482,
'KATAKANA LETTER DO': 12489,
'KATAKANA LETTER DU': 12485,
'KATAKANA LETTER E': 12456,
'KATAKANA LETTER GA': 12460,
'KATAKANA LETTER GE': 12466,
'KATAKANA LETTER GI': 12462,
'KATAKANA LETTER GO': 12468,
'KATAKANA LETTER GU': 12464,
'KATAKANA LETTER HA': 12495,
'KATAKANA LETTER HE': 12504,
'KATAKANA LETTER HI': 12498,
'KATAKANA LETTER HO': 12507,
'KATAKANA LETTER HU': 12501,
'KATAKANA LETTER I': 12452,
'KATAKANA LETTER KA': 12459,
'KATAKANA LETTER KE': 12465,
'KATAKANA LETTER KI': 12461,
'KATAKANA LETTER KO': 12467,
'KATAKANA LETTER KU': 12463,
'KATAKANA LETTER MA': 12510,
'KATAKANA LETTER ME': 12513,
'KATAKANA LETTER MI': 12511,
'KATAKANA LETTER MO': 12514,
'KATAKANA LETTER MU': 12512,
'KATAKANA LETTER N': 12531,
'KATAKANA LETTER NA': 12490,
'KATAKANA LETTER NE': 12493,
'KATAKANA LETTER NI': 12491,
'KATAKANA LETTER NO': 12494,
'KATAKANA LETTER NU': 12492,
'KATAKANA LETTER O': 12458,
'KATAKANA LETTER PA': 12497,
'KATAKANA LETTER PE': 12506,
'KATAKANA LETTER PI': 12500,
'KATAKANA LETTER PO': 12509,
'KATAKANA LETTER PU': 12503,
'KATAKANA LETTER RA': 12521,
'KATAKANA LETTER RE': 12524,
'KATAKANA LETTER RI': 12522,
'KATAKANA LETTER RO': 12525,
'KATAKANA LETTER RU': 12523,
'KATAKANA LETTER SA': 12469,
'KATAKANA LETTER SE': 12475,
'KATAKANA LETTER SI': 12471,
'KATAKANA LETTER SMALL A': 12449,
'KATAKANA LETTER SMALL E': 12455,
'KATAKANA LETTER SMALL HA': 12789,
'KATAKANA LETTER SMALL HE': 12792,
'KATAKANA LETTER SMALL HI': 12790,
'KATAKANA LETTER SMALL HO': 12793,
'KATAKANA LETTER SMALL HU': 12791,
'KATAKANA LETTER SMALL I': 12451,
'KATAKANA LETTER SMALL KA': 12533,
'KATAKANA LETTER SMALL KE': 12534,
'KATAKANA LETTER SMALL KU': 12784,
'KATAKANA LETTER SMALL MU': 12794,
'KATAKANA LETTER SMALL NU': 12788,
'KATAKANA LETTER SMALL O': 12457,
'KATAKANA LETTER SMALL RA': 12795,
'KATAKANA LETTER SMALL RE': 12798,
'KATAKANA LETTER SMALL RI': 12796,
'KATAKANA LETTER SMALL RO': 12799,
'KATAKANA LETTER SMALL RU': 12797,
'KATAKANA LETTER SMALL SI': 12785,
'KATAKANA LETTER SMALL SU': 12786,
'KATAKANA LETTER SMALL TO': 12787,
'KATAKANA LETTER SMALL TU': 12483,
'KATAKANA LETTER SMALL U': 12453,
'KATAKANA LETTER SMALL WA': 12526,
'KATAKANA LETTER SMALL YA': 12515,
'KATAKANA LETTER SMALL YO': 12519,
'KATAKANA LETTER SMALL YU': 12517,
'KATAKANA LETTER SO': 12477,
'KATAKANA LETTER SU': 12473,
'KATAKANA LETTER TA': 12479,
'KATAKANA LETTER TE': 12486,
'KATAKANA LETTER TI': 12481,
'KATAKANA LETTER TO': 12488,
'KATAKANA LETTER TU': 12484,
'KATAKANA LETTER U': 12454,
'KATAKANA LETTER VA': 12535,
'KATAKANA LETTER VE': 12537,
'KATAKANA LETTER VI': 12536,
'KATAKANA LETTER VO': 12538,
'KATAKANA LETTER VU': 12532,
'KATAKANA LETTER WA': 12527,
'KATAKANA LETTER WE': 12529,
'KATAKANA LETTER WI': 12528,
'KATAKANA LETTER WO': 12530,
'KATAKANA LETTER YA': 12516,
'KATAKANA LETTER YO': 12520,
'KATAKANA LETTER YU': 12518,
'KATAKANA LETTER ZA': 12470,
'KATAKANA LETTER ZE': 12476,
'KATAKANA LETTER ZI': 12472,
'KATAKANA LETTER ZO': 12478,
'KATAKANA LETTER ZU': 12474,
'KATAKANA MIDDLE DOT': 12539,
'KATAKANA VOICED ITERATION MARK': 12542,
'KATAKANA-HIRAGANA DOUBLE HYPHEN': 12448,
'KATAKANA-HIRAGANA PROLONGED SOUND MARK': 12540,
'KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK': 12444,
'KATAKANA-HIRAGANA VOICED SOUND MARK': 12443,
'KELVIN SIGN': 8490,
'KEYBOARD': 9000,
'KHAROSHTHI DIGIT FOUR': 68163,
'KHAROSHTHI DIGIT ONE': 68160,
'KHAROSHTHI DIGIT THREE': 68162,
'KHAROSHTHI DIGIT TWO': 68161,
'KHAROSHTHI LETTER A': 68096,
'KHAROSHTHI LETTER BA': 68134,
'KHAROSHTHI LETTER BHA': 68135,
'KHAROSHTHI LETTER CA': 68117,
'KHAROSHTHI LETTER CHA': 68118,
'KHAROSHTHI LETTER DA': 68129,
'KHAROSHTHI LETTER DDA': 68124,
'KHAROSHTHI LETTER DDHA': 68125,
'KHAROSHTHI LETTER DHA': 68130,
'KHAROSHTHI LETTER GA': 68114,
'KHAROSHTHI LETTER GHA': 68115,
'KHAROSHTHI LETTER HA': 68145,
'KHAROSHTHI LETTER JA': 68119,
'KHAROSHTHI LETTER KA': 68112,
'KHAROSHTHI LETTER KHA': 68113,
'KHAROSHTHI LETTER KKA': 68146,
'KHAROSHTHI LETTER LA': 68139,
'KHAROSHTHI LETTER MA': 68136,
'KHAROSHTHI LETTER NA': 68131,
'KHAROSHTHI LETTER NNA': 68126,
'KHAROSHTHI LETTER NYA': 68121,
'KHAROSHTHI LETTER PA': 68132,
'KHAROSHTHI LETTER PHA': 68133,
'KHAROSHTHI LETTER RA': 68138,
'KHAROSHTHI LETTER SA': 68143,
'KHAROSHTHI LETTER SHA': 68141,
'KHAROSHTHI LETTER SSA': 68142,
'KHAROSHTHI LETTER TA': 68127,
'KHAROSHTHI LETTER THA': 68128,
'KHAROSHTHI LETTER TTA': 68122,
'KHAROSHTHI LETTER TTHA': 68123,
'KHAROSHTHI LETTER TTTHA': 68147,
'KHAROSHTHI LETTER VA': 68140,
'KHAROSHTHI LETTER YA': 68137,
'KHAROSHTHI LETTER ZA': 68144,
'KHAROSHTHI NUMBER ONE HUNDRED': 68166,
'KHAROSHTHI NUMBER ONE THOUSAND': 68167,
'KHAROSHTHI NUMBER TEN': 68164,
'KHAROSHTHI NUMBER TWENTY': 68165,
'KHAROSHTHI PUNCTUATION CIRCLE': 68178,
'KHAROSHTHI PUNCTUATION CRESCENT BAR': 68179,
'KHAROSHTHI PUNCTUATION DANDA': 68182,
'KHAROSHTHI PUNCTUATION DOT': 68176,
'KHAROSHTHI PUNCTUATION DOUBLE DANDA': 68183,
'KHAROSHTHI PUNCTUATION LINES': 68184,
'KHAROSHTHI PUNCTUATION LOTUS': 68181,
'KHAROSHTHI PUNCTUATION MANGALAM': 68180,
'KHAROSHTHI PUNCTUATION SMALL CIRCLE': 68177,
'KHAROSHTHI SIGN ANUSVARA': 68110,
'KHAROSHTHI SIGN BAR ABOVE': 68152,
'KHAROSHTHI SIGN CAUDA': 68153,
'KHAROSHTHI SIGN DOT BELOW': 68154,
'KHAROSHTHI SIGN DOUBLE RING BELOW': 68109,
'KHAROSHTHI SIGN VISARGA': 68111,
'KHAROSHTHI VIRAMA': 68159,
'KHAROSHTHI VOWEL LENGTH MARK': 68108,
'KHAROSHTHI VOWEL SIGN E': 68101,
'KHAROSHTHI VOWEL SIGN I': 68097,
'KHAROSHTHI VOWEL SIGN O': 68102,
'KHAROSHTHI VOWEL SIGN U': 68098,
'KHAROSHTHI VOWEL SIGN VOCALIC R': 68099,
'KHMER CURRENCY SYMBOL RIEL': 6107,
'KHMER DIGIT EIGHT': 6120,
'KHMER DIGIT FIVE': 6117,
'KHMER DIGIT FOUR': 6116,
'KHMER DIGIT NINE': 6121,
'KHMER DIGIT ONE': 6113,
'KHMER DIGIT SEVEN': 6119,
'KHMER DIGIT SIX': 6118,
'KHMER DIGIT THREE': 6115,
'KHMER DIGIT TWO': 6114,
'KHMER DIGIT ZERO': 6112,
'KHMER INDEPENDENT VOWEL LY': 6061,
'KHMER INDEPENDENT VOWEL LYY': 6062,
'KHMER INDEPENDENT VOWEL QAA': 6052,
'KHMER INDEPENDENT VOWEL QAI': 6064,
'KHMER INDEPENDENT VOWEL QAQ': 6051,
'KHMER INDEPENDENT VOWEL QAU': 6067,
'KHMER INDEPENDENT VOWEL QE': 6063,
'KHMER INDEPENDENT VOWEL QI': 6053,
'KHMER INDEPENDENT VOWEL QII': 6054,
'KHMER INDEPENDENT VOWEL QOO TYPE ONE': 6065,
'KHMER INDEPENDENT VOWEL QOO TYPE TWO': 6066,
'KHMER INDEPENDENT VOWEL QU': 6055,
'KHMER INDEPENDENT VOWEL QUK': 6056,
'KHMER INDEPENDENT VOWEL QUU': 6057,
'KHMER INDEPENDENT VOWEL QUUV': 6058,
'KHMER INDEPENDENT VOWEL RY': 6059,
'KHMER INDEPENDENT VOWEL RYY': 6060,
'KHMER LETTER BA': 6036,
'KHMER LETTER CA': 6021,
'KHMER LETTER CHA': 6022,
'KHMER LETTER CHO': 6024,
'KHMER LETTER CO': 6023,
'KHMER LETTER DA': 6026,
'KHMER LETTER DO': 6028,
'KHMER LETTER HA': 6048,
'KHMER LETTER KA': 6016,
'KHMER LETTER KHA': 6017,
'KHMER LETTER KHO': 6019,
'KHMER LETTER KO': 6018,
'KHMER LETTER LA': 6049,
'KHMER LETTER LO': 6043,
'KHMER LETTER MO': 6040,
'KHMER LETTER NGO': 6020,
'KHMER LETTER NNO': 6030,
'KHMER LETTER NO': 6035,
'KHMER LETTER NYO': 6025,
'KHMER LETTER PHA': 6037,
'KHMER LETTER PHO': 6039,
'KHMER LETTER PO': 6038,
'KHMER LETTER QA': 6050,
'KHMER LETTER RO': 6042,
'KHMER LETTER SA': 6047,
'KHMER LETTER SHA': 6045,
'KHMER LETTER SSO': 6046,
'KHMER LETTER TA': 6031,
'KHMER LETTER THA': 6032,
'KHMER LETTER THO': 6034,
'KHMER LETTER TO': 6033,
'KHMER LETTER TTHA': 6027,
'KHMER LETTER TTHO': 6029,
'KHMER LETTER VO': 6044,
'KHMER LETTER YO': 6041,
'KHMER SIGN AHSDA': 6095,
'KHMER SIGN ATTHACAN': 6109,
'KHMER SIGN AVAKRAHASANYA': 6108,
'KHMER SIGN BANTOC': 6091,
'KHMER SIGN BARIYOOSAN': 6101,
'KHMER SIGN BATHAMASAT': 6099,
'KHMER SIGN BEYYAL': 6104,
'KHMER SIGN CAMNUC PII KUUH': 6102,
'KHMER SIGN COENG': 6098,
'KHMER SIGN KAKABAT': 6094,
'KHMER SIGN KHAN': 6100,
'KHMER SIGN KOOMUUT': 6106,
'KHMER SIGN LEK TOO': 6103,
'KHMER SIGN MUUSIKATOAN': 6089,
'KHMER SIGN NIKAHIT': 6086,
'KHMER SIGN PHNAEK MUAN': 6105,
'KHMER SIGN REAHMUK': 6087,
'KHMER SIGN ROBAT': 6092,
'KHMER SIGN SAMYOK SANNYA': 6096,
'KHMER SIGN TOANDAKHIAT': 6093,
'KHMER SIGN TRIISAP': 6090,
'KHMER SIGN VIRIAM': 6097,
'KHMER SIGN YUUKALEAPINTU': 6088,
'KHMER SYMBOL BEI KOET': 6627,
'KHMER SYMBOL BEI ROC': 6643,
'KHMER SYMBOL BUON KOET': 6628,
'KHMER SYMBOL BUON ROC': 6644,
'KHMER SYMBOL DAP KOET': 6634,
'KHMER SYMBOL DAP ROC': 6650,
'KHMER SYMBOL DAP-BEI KOET': 6637,
'KHMER SYMBOL DAP-BEI ROC': 6653,
'KHMER SYMBOL DAP-BUON KOET': 6638,
'KHMER SYMBOL DAP-BUON ROC': 6654,
'KHMER SYMBOL DAP-MUOY KOET': 6635,
'KHMER SYMBOL DAP-MUOY ROC': 6651,
'KHMER SYMBOL DAP-PII KOET': 6636,
'KHMER SYMBOL DAP-PII ROC': 6652,
'KHMER SYMBOL DAP-PRAM KOET': 6639,
'KHMER SYMBOL DAP-PRAM ROC': 6655,
'KHMER SYMBOL LEK ATTAK BEI': 6131,
'KHMER SYMBOL LEK ATTAK BUON': 6132,
'KHMER SYMBOL LEK ATTAK MUOY': 6129,
'KHMER SYMBOL LEK ATTAK PII': 6130,
'KHMER SYMBOL LEK ATTAK PRAM': 6133,
'KHMER SYMBOL LEK ATTAK PRAM-BEI': 6136,
'KHMER SYMBOL LEK ATTAK PRAM-BUON': 6137,
'KHMER SYMBOL LEK ATTAK PRAM-MUOY': 6134,
'KHMER SYMBOL LEK ATTAK PRAM-PII': 6135,
'KHMER SYMBOL LEK ATTAK SON': 6128,
'KHMER SYMBOL MUOY KOET': 6625,
'KHMER SYMBOL MUOY ROC': 6641,
'KHMER SYMBOL PATHAMASAT': 6624,
'KHMER SYMBOL PII KOET': 6626,
'KHMER SYMBOL PII ROC': 6642,
'KHMER SYMBOL PRAM KOET': 6629,
'KHMER SYMBOL PRAM ROC': 6645,
'KHMER SYMBOL PRAM-BEI KOET': 6632,
'KHMER SYMBOL PRAM-BEI ROC': 6648,
'KHMER SYMBOL PRAM-BUON KOET': 6633,
'KHMER SYMBOL PRAM-BUON ROC': 6649,
'KHMER SYMBOL PRAM-MUOY KOET': 6630,
'KHMER SYMBOL PRAM-MUOY ROC': 6646,
'KHMER SYMBOL PRAM-PII KOET': 6631,
'KHMER SYMBOL PRAM-PII ROC': 6647,
'KHMER SYMBOL TUTEYASAT': 6640,
'KHMER VOWEL INHERENT AA': 6069,
'KHMER VOWEL INHERENT AQ': 6068,
'KHMER VOWEL SIGN AA': 6070,
'KHMER VOWEL SIGN AE': 6082,
'KHMER VOWEL SIGN AI': 6083,
'KHMER VOWEL SIGN AU': 6085,
'KHMER VOWEL SIGN E': 6081,
'KHMER VOWEL SIGN I': 6071,
'KHMER VOWEL SIGN IE': 6080,
'KHMER VOWEL SIGN II': 6072,
'KHMER VOWEL SIGN OE': 6078,
'KHMER VOWEL SIGN OO': 6084,
'KHMER VOWEL SIGN U': 6075,
'KHMER VOWEL SIGN UA': 6077,
'KHMER VOWEL SIGN UU': 6076,
'KHMER VOWEL SIGN Y': 6073,
'KHMER VOWEL SIGN YA': 6079,
'KHMER VOWEL SIGN YY': 6074,
'KIP SIGN': 8365,
'KOREAN STANDARD SYMBOL': 12927,
'L B BAR SYMBOL': 8468,
'LANGUAGE TAG': 917505,
'LAO CANCELLATION MARK': 3788,
'LAO DIGIT EIGHT': 3800,
'LAO DIGIT FIVE': 3797,
'LAO DIGIT FOUR': 3796,
'LAO DIGIT NINE': 3801,
'LAO DIGIT ONE': 3793,
'LAO DIGIT SEVEN': 3799,
'LAO DIGIT SIX': 3798,
'LAO DIGIT THREE': 3795,
'LAO DIGIT TWO': 3794,
'LAO DIGIT ZERO': 3792,
'LAO ELLIPSIS': 3759,
'LAO HO MO': 3805,
'LAO HO NO': 3804,
'LAO KO LA': 3782,
'LAO LETTER BO': 3738,
'LAO LETTER CO': 3720,
'LAO LETTER DO': 3732,
'LAO LETTER FO SUNG': 3743,
'LAO LETTER FO TAM': 3741,
'LAO LETTER HO SUNG': 3755,
'LAO LETTER HO TAM': 3758,
'LAO LETTER KHO SUNG': 3714,
'LAO LETTER KHO TAM': 3716,
'LAO LETTER KO': 3713,
'LAO LETTER LO LING': 3747,
'LAO LETTER LO LOOT': 3749,
'LAO LETTER MO': 3745,
'LAO LETTER NGO': 3719,
'LAO LETTER NO': 3737,
'LAO LETTER NYO': 3725,
'LAO LETTER O': 3757,
'LAO LETTER PHO SUNG': 3740,
'LAO LETTER PHO TAM': 3742,
'LAO LETTER PO': 3739,
'LAO LETTER SO SUNG': 3754,
'LAO LETTER SO TAM': 3722,
'LAO LETTER THO SUNG': 3734,
'LAO LETTER THO TAM': 3735,
'LAO LETTER TO': 3733,
'LAO LETTER WO': 3751,
'LAO LETTER YO': 3746,
'LAO NIGGAHITA': 3789,
'LAO SEMIVOWEL SIGN LO': 3772,
'LAO SEMIVOWEL SIGN NYO': 3773,
'LAO TONE MAI CATAWA': 3787,
'LAO TONE MAI EK': 3784,
'LAO TONE MAI THO': 3785,
'LAO TONE MAI TI': 3786,
'LAO VOWEL SIGN A': 3760,
'LAO VOWEL SIGN AA': 3762,
'LAO VOWEL SIGN AI': 3780,
'LAO VOWEL SIGN AM': 3763,
'LAO VOWEL SIGN AY': 3779,
'LAO VOWEL SIGN E': 3776,
'LAO VOWEL SIGN EI': 3777,
'LAO VOWEL SIGN I': 3764,
'LAO VOWEL SIGN II': 3765,
'LAO VOWEL SIGN MAI KAN': 3761,
'LAO VOWEL SIGN MAI KON': 3771,
'LAO VOWEL SIGN O': 3778,
'LAO VOWEL SIGN U': 3768,
'LAO VOWEL SIGN UU': 3769,
'LAO VOWEL SIGN Y': 3766,
'LAO VOWEL SIGN YY': 3767,
'LARGE CIRCLE': 9711,
'LARGE DOWN TACK': 10201,
'LARGE LEFT TRIANGLE OPERATOR': 10782,
'LARGE TRIPLE VERTICAL BAR OPERATOR': 11004,
'LARGE UP TACK': 10200,
'LARGER THAN': 10923,
'LARGER THAN OR EQUAL TO': 10925,
'LAST QUARTER MOON': 9790,
'LATIN CAPITAL LETTER A': 65,
'LATIN CAPITAL LETTER A WITH ACUTE': 193,
'LATIN CAPITAL LETTER A WITH BREVE': 258,
'LATIN CAPITAL LETTER A WITH BREVE AND ACUTE': 7854,
'LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW': 7862,
'LATIN CAPITAL LETTER A WITH BREVE AND GRAVE': 7856,
'LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE': 7858,
'LATIN CAPITAL LETTER A WITH BREVE AND TILDE': 7860,
'LATIN CAPITAL LETTER A WITH CARON': 461,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX': 194,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE': 7844,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW': 7852,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE': 7846,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE': 7848,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE': 7850,
'LATIN CAPITAL LETTER A WITH DIAERESIS': 196,
'LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON': 478,
'LATIN CAPITAL LETTER A WITH DOT ABOVE': 550,
'LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON': 480,
'LATIN CAPITAL LETTER A WITH DOT BELOW': 7840,
'LATIN CAPITAL LETTER A WITH DOUBLE GRAVE': 512,
'LATIN CAPITAL LETTER A WITH GRAVE': 192,
'LATIN CAPITAL LETTER A WITH HOOK ABOVE': 7842,
'LATIN CAPITAL LETTER A WITH INVERTED BREVE': 514,
'LATIN CAPITAL LETTER A WITH MACRON': 256,
'LATIN CAPITAL LETTER A WITH OGONEK': 260,
'LATIN CAPITAL LETTER A WITH RING ABOVE': 197,
'LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE': 506,
'LATIN CAPITAL LETTER A WITH RING BELOW': 7680,
'LATIN CAPITAL LETTER A WITH STROKE': 570,
'LATIN CAPITAL LETTER A WITH TILDE': 195,
'LATIN CAPITAL LETTER AE': 198,
'LATIN CAPITAL LETTER AE WITH ACUTE': 508,
'LATIN CAPITAL LETTER AE WITH MACRON': 482,
'LATIN CAPITAL LETTER AFRICAN D': 393,
'LATIN CAPITAL LETTER B': 66,
'LATIN CAPITAL LETTER B WITH DOT ABOVE': 7682,
'LATIN CAPITAL LETTER B WITH DOT BELOW': 7684,
'LATIN CAPITAL LETTER B WITH HOOK': 385,
'LATIN CAPITAL LETTER B WITH LINE BELOW': 7686,
'LATIN CAPITAL LETTER B WITH TOPBAR': 386,
'LATIN CAPITAL LETTER C': 67,
'LATIN CAPITAL LETTER C WITH ACUTE': 262,
'LATIN CAPITAL LETTER C WITH CARON': 268,
'LATIN CAPITAL LETTER C WITH CEDILLA': 199,
'LATIN CAPITAL LETTER C WITH CEDILLA AND ACUTE': 7688,
'LATIN CAPITAL LETTER C WITH CIRCUMFLEX': 264,
'LATIN CAPITAL LETTER C WITH DOT ABOVE': 266,
'LATIN CAPITAL LETTER C WITH HOOK': 391,
'LATIN CAPITAL LETTER C WITH STROKE': 571,
'LATIN CAPITAL LETTER D': 68,
'LATIN CAPITAL LETTER D WITH CARON': 270,
'LATIN CAPITAL LETTER D WITH CEDILLA': 7696,
'LATIN CAPITAL LETTER D WITH CIRCUMFLEX BELOW': 7698,
'LATIN CAPITAL LETTER D WITH DOT ABOVE': 7690,
'LATIN CAPITAL LETTER D WITH DOT BELOW': 7692,
'LATIN CAPITAL LETTER D WITH HOOK': 394,
'LATIN CAPITAL LETTER D WITH LINE BELOW': 7694,
'LATIN CAPITAL LETTER D WITH SMALL LETTER Z': 498,
'LATIN CAPITAL LETTER D WITH SMALL LETTER Z WITH CARON': 453,
'LATIN CAPITAL LETTER D WITH STROKE': 272,
'LATIN CAPITAL LETTER D WITH TOPBAR': 395,
'LATIN CAPITAL LETTER DZ': 497,
'LATIN CAPITAL LETTER DZ WITH CARON': 452,
'LATIN CAPITAL LETTER E': 69,
'LATIN CAPITAL LETTER E WITH ACUTE': 201,
'LATIN CAPITAL LETTER E WITH BREVE': 276,
'LATIN CAPITAL LETTER E WITH CARON': 282,
'LATIN CAPITAL LETTER E WITH CEDILLA': 552,
'LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE': 7708,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX': 202,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE': 7870,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW': 7878,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE': 7872,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE': 7874,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE': 7876,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX BELOW': 7704,
'LATIN CAPITAL LETTER E WITH DIAERESIS': 203,
'LATIN CAPITAL LETTER E WITH DOT ABOVE': 278,
'LATIN CAPITAL LETTER E WITH DOT BELOW': 7864,
'LATIN CAPITAL LETTER E WITH DOUBLE GRAVE': 516,
'LATIN CAPITAL LETTER E WITH GRAVE': 200,
'LATIN CAPITAL LETTER E WITH HOOK ABOVE': 7866,
'LATIN CAPITAL LETTER E WITH INVERTED BREVE': 518,
'LATIN CAPITAL LETTER E WITH MACRON': 274,
'LATIN CAPITAL LETTER E WITH MACRON AND ACUTE': 7702,
'LATIN CAPITAL LETTER E WITH MACRON AND GRAVE': 7700,
'LATIN CAPITAL LETTER E WITH OGONEK': 280,
'LATIN CAPITAL LETTER E WITH TILDE': 7868,
'LATIN CAPITAL LETTER E WITH TILDE BELOW': 7706,
'LATIN CAPITAL LETTER ENG': 330,
'LATIN CAPITAL LETTER ESH': 425,
'LATIN CAPITAL LETTER ETH': 208,
'LATIN CAPITAL LETTER EZH': 439,
'LATIN CAPITAL LETTER EZH REVERSED': 440,
'LATIN CAPITAL LETTER EZH WITH CARON': 494,
'LATIN CAPITAL LETTER F': 70,
'LATIN CAPITAL LETTER F WITH DOT ABOVE': 7710,
'LATIN CAPITAL LETTER F WITH HOOK': 401,
'LATIN CAPITAL LETTER G': 71,
'LATIN CAPITAL LETTER G WITH ACUTE': 500,
'LATIN CAPITAL LETTER G WITH BREVE': 286,
'LATIN CAPITAL LETTER G WITH CARON': 486,
'LATIN CAPITAL LETTER G WITH CEDILLA': 290,
'LATIN CAPITAL LETTER G WITH CIRCUMFLEX': 284,
'LATIN CAPITAL LETTER G WITH DOT ABOVE': 288,
'LATIN CAPITAL LETTER G WITH HOOK': 403,
'LATIN CAPITAL LETTER G WITH MACRON': 7712,
'LATIN CAPITAL LETTER G WITH STROKE': 484,
'LATIN CAPITAL LETTER GAMMA': 404,
'LATIN CAPITAL LETTER GLOTTAL STOP': 577,
'LATIN CAPITAL LETTER H': 72,
'LATIN CAPITAL LETTER H WITH BREVE BELOW': 7722,
'LATIN CAPITAL LETTER H WITH CARON': 542,
'LATIN CAPITAL LETTER H WITH CEDILLA': 7720,
'LATIN CAPITAL LETTER H WITH CIRCUMFLEX': 292,
'LATIN CAPITAL LETTER H WITH DIAERESIS': 7718,
'LATIN CAPITAL LETTER H WITH DOT ABOVE': 7714,
'LATIN CAPITAL LETTER H WITH DOT BELOW': 7716,
'LATIN CAPITAL LETTER H WITH STROKE': 294,
'LATIN CAPITAL LETTER HWAIR': 502,
'LATIN CAPITAL LETTER I': 73,
'LATIN CAPITAL LETTER I WITH ACUTE': 205,
'LATIN CAPITAL LETTER I WITH BREVE': 300,
'LATIN CAPITAL LETTER I WITH CARON': 463,
'LATIN CAPITAL LETTER I WITH CIRCUMFLEX': 206,
'LATIN CAPITAL LETTER I WITH DIAERESIS': 207,
'LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE': 7726,
'LATIN CAPITAL LETTER I WITH DOT ABOVE': 304,
'LATIN CAPITAL LETTER I WITH DOT BELOW': 7882,
'LATIN CAPITAL LETTER I WITH DOUBLE GRAVE': 520,
'LATIN CAPITAL LETTER I WITH GRAVE': 204,
'LATIN CAPITAL LETTER I WITH HOOK ABOVE': 7880,
'LATIN CAPITAL LETTER I WITH INVERTED BREVE': 522,
'LATIN CAPITAL LETTER I WITH MACRON': 298,
'LATIN CAPITAL LETTER I WITH OGONEK': 302,
'LATIN CAPITAL LETTER I WITH STROKE': 407,
'LATIN CAPITAL LETTER I WITH TILDE': 296,
'LATIN CAPITAL LETTER I WITH TILDE BELOW': 7724,
'LATIN CAPITAL LETTER IOTA': 406,
'LATIN CAPITAL LETTER J': 74,
'LATIN CAPITAL LETTER J WITH CIRCUMFLEX': 308,
'LATIN CAPITAL LETTER K': 75,
'LATIN CAPITAL LETTER K WITH ACUTE': 7728,
'LATIN CAPITAL LETTER K WITH CARON': 488,
'LATIN CAPITAL LETTER K WITH CEDILLA': 310,
'LATIN CAPITAL LETTER K WITH DOT BELOW': 7730,
'LATIN CAPITAL LETTER K WITH HOOK': 408,
'LATIN CAPITAL LETTER K WITH LINE BELOW': 7732,
'LATIN CAPITAL LETTER L': 76,
'LATIN CAPITAL LETTER L WITH ACUTE': 313,
'LATIN CAPITAL LETTER L WITH BAR': 573,
'LATIN CAPITAL LETTER L WITH CARON': 317,
'LATIN CAPITAL LETTER L WITH CEDILLA': 315,
'LATIN CAPITAL LETTER L WITH CIRCUMFLEX BELOW': 7740,
'LATIN CAPITAL LETTER L WITH DOT BELOW': 7734,
'LATIN CAPITAL LETTER L WITH DOT BELOW AND MACRON': 7736,
'LATIN CAPITAL LETTER L WITH LINE BELOW': 7738,
'LATIN CAPITAL LETTER L WITH MIDDLE DOT': 319,
'LATIN CAPITAL LETTER L WITH SMALL LETTER J': 456,
'LATIN CAPITAL LETTER L WITH STROKE': 321,
'LATIN CAPITAL LETTER LJ': 455,
'LATIN CAPITAL LETTER M': 77,
'LATIN CAPITAL LETTER M WITH ACUTE': 7742,
'LATIN CAPITAL LETTER M WITH DOT ABOVE': 7744,
'LATIN CAPITAL LETTER M WITH DOT BELOW': 7746,
'LATIN CAPITAL LETTER N': 78,
'LATIN CAPITAL LETTER N WITH ACUTE': 323,
'LATIN CAPITAL LETTER N WITH CARON': 327,
'LATIN CAPITAL LETTER N WITH CEDILLA': 325,
'LATIN CAPITAL LETTER N WITH CIRCUMFLEX BELOW': 7754,
'LATIN CAPITAL LETTER N WITH DOT ABOVE': 7748,
'LATIN CAPITAL LETTER N WITH DOT BELOW': 7750,
'LATIN CAPITAL LETTER N WITH GRAVE': 504,
'LATIN CAPITAL LETTER N WITH LEFT HOOK': 413,
'LATIN CAPITAL LETTER N WITH LINE BELOW': 7752,
'LATIN CAPITAL LETTER N WITH LONG RIGHT LEG': 544,
'LATIN CAPITAL LETTER N WITH SMALL LETTER J': 459,
'LATIN CAPITAL LETTER N WITH TILDE': 209,
'LATIN CAPITAL LETTER NJ': 458,
'LATIN CAPITAL LETTER O': 79,
'LATIN CAPITAL LETTER O WITH ACUTE': 211,
'LATIN CAPITAL LETTER O WITH BREVE': 334,
'LATIN CAPITAL LETTER O WITH CARON': 465,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX': 212,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE': 7888,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW': 7896,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE': 7890,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE': 7892,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE': 7894,
'LATIN CAPITAL LETTER O WITH DIAERESIS': 214,
'LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON': 554,
'LATIN CAPITAL LETTER O WITH DOT ABOVE': 558,
'LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON': 560,
'LATIN CAPITAL LETTER O WITH DOT BELOW': 7884,
'LATIN CAPITAL LETTER O WITH DOUBLE ACUTE': 336,
'LATIN CAPITAL LETTER O WITH DOUBLE GRAVE': 524,
'LATIN CAPITAL LETTER O WITH GRAVE': 210,
'LATIN CAPITAL LETTER O WITH HOOK ABOVE': 7886,
'LATIN CAPITAL LETTER O WITH HORN': 416,
'LATIN CAPITAL LETTER O WITH HORN AND ACUTE': 7898,
'LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW': 7906,
'LATIN CAPITAL LETTER O WITH HORN AND GRAVE': 7900,
'LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE': 7902,
'LATIN CAPITAL LETTER O WITH HORN AND TILDE': 7904,
'LATIN CAPITAL LETTER O WITH INVERTED BREVE': 526,
'LATIN CAPITAL LETTER O WITH MACRON': 332,
'LATIN CAPITAL LETTER O WITH MACRON AND ACUTE': 7762,
'LATIN CAPITAL LETTER O WITH MACRON AND GRAVE': 7760,
'LATIN CAPITAL LETTER O WITH MIDDLE TILDE': 415,
'LATIN CAPITAL LETTER O WITH OGONEK': 490,
'LATIN CAPITAL LETTER O WITH OGONEK AND MACRON': 492,
'LATIN CAPITAL LETTER O WITH STROKE': 216,
'LATIN CAPITAL LETTER O WITH STROKE AND ACUTE': 510,
'LATIN CAPITAL LETTER O WITH TILDE': 213,
'LATIN CAPITAL LETTER O WITH TILDE AND ACUTE': 7756,
'LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS': 7758,
'LATIN CAPITAL LETTER O WITH TILDE AND MACRON': 556,
'LATIN CAPITAL LETTER OI': 418,
'LATIN CAPITAL LETTER OPEN E': 400,
'LATIN CAPITAL LETTER OPEN O': 390,
'LATIN CAPITAL LETTER OU': 546,
'LATIN CAPITAL LETTER P': 80,
'LATIN CAPITAL LETTER P WITH ACUTE': 7764,
'LATIN CAPITAL LETTER P WITH DOT ABOVE': 7766,
'LATIN CAPITAL LETTER P WITH HOOK': 420,
'LATIN CAPITAL LETTER Q': 81,
'LATIN CAPITAL LETTER R': 82,
'LATIN CAPITAL LETTER R WITH ACUTE': 340,
'LATIN CAPITAL LETTER R WITH CARON': 344,
'LATIN CAPITAL LETTER R WITH CEDILLA': 342,
'LATIN CAPITAL LETTER R WITH DOT ABOVE': 7768,
'LATIN CAPITAL LETTER R WITH DOT BELOW': 7770,
'LATIN CAPITAL LETTER R WITH DOT BELOW AND MACRON': 7772,
'LATIN CAPITAL LETTER R WITH DOUBLE GRAVE': 528,
'LATIN CAPITAL LETTER R WITH INVERTED BREVE': 530,
'LATIN CAPITAL LETTER R WITH LINE BELOW': 7774,
'LATIN CAPITAL LETTER REVERSED E': 398,
'LATIN CAPITAL LETTER S': 83,
'LATIN CAPITAL LETTER S WITH ACUTE': 346,
'LATIN CAPITAL LETTER S WITH ACUTE AND DOT ABOVE': 7780,
'LATIN CAPITAL LETTER S WITH CARON': 352,
'LATIN CAPITAL LETTER S WITH CARON AND DOT ABOVE': 7782,
'LATIN CAPITAL LETTER S WITH CEDILLA': 350,
'LATIN CAPITAL LETTER S WITH CIRCUMFLEX': 348,
'LATIN CAPITAL LETTER S WITH COMMA BELOW': 536,
'LATIN CAPITAL LETTER S WITH DOT ABOVE': 7776,
'LATIN CAPITAL LETTER S WITH DOT BELOW': 7778,
'LATIN CAPITAL LETTER S WITH DOT BELOW AND DOT ABOVE': 7784,
'LATIN CAPITAL LETTER SCHWA': 399,
'LATIN CAPITAL LETTER T': 84,
'LATIN CAPITAL LETTER T WITH CARON': 356,
'LATIN CAPITAL LETTER T WITH CEDILLA': 354,
'LATIN CAPITAL LETTER T WITH CIRCUMFLEX BELOW': 7792,
'LATIN CAPITAL LETTER T WITH COMMA BELOW': 538,
'LATIN CAPITAL LETTER T WITH DIAGONAL STROKE': 574,
'LATIN CAPITAL LETTER T WITH DOT ABOVE': 7786,
'LATIN CAPITAL LETTER T WITH DOT BELOW': 7788,
'LATIN CAPITAL LETTER T WITH HOOK': 428,
'LATIN CAPITAL LETTER T WITH LINE BELOW': 7790,
'LATIN CAPITAL LETTER T WITH RETROFLEX HOOK': 430,
'LATIN CAPITAL LETTER T WITH STROKE': 358,
'LATIN CAPITAL LETTER THORN': 222,
'LATIN CAPITAL LETTER TONE FIVE': 444,
'LATIN CAPITAL LETTER TONE SIX': 388,
'LATIN CAPITAL LETTER TONE TWO': 423,
'LATIN CAPITAL LETTER TURNED M': 412,
'LATIN CAPITAL LETTER U': 85,
'LATIN CAPITAL LETTER U WITH ACUTE': 218,
'LATIN CAPITAL LETTER U WITH BREVE': 364,
'LATIN CAPITAL LETTER U WITH CARON': 467,
'LATIN CAPITAL LETTER U WITH CIRCUMFLEX': 219,
'LATIN CAPITAL LETTER U WITH CIRCUMFLEX BELOW': 7798,
'LATIN CAPITAL LETTER U WITH DIAERESIS': 220,
'LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE': 471,
'LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON': 473,
'LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE': 475,
'LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON': 469,
'LATIN CAPITAL LETTER U WITH DIAERESIS BELOW': 7794,
'LATIN CAPITAL LETTER U WITH DOT BELOW': 7908,
'LATIN CAPITAL LETTER U WITH DOUBLE ACUTE': 368,
'LATIN CAPITAL LETTER U WITH DOUBLE GRAVE': 532,
'LATIN CAPITAL LETTER U WITH GRAVE': 217,
'LATIN CAPITAL LETTER U WITH HOOK ABOVE': 7910,
'LATIN CAPITAL LETTER U WITH HORN': 431,
'LATIN CAPITAL LETTER U WITH HORN AND ACUTE': 7912,
'LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW': 7920,
'LATIN CAPITAL LETTER U WITH HORN AND GRAVE': 7914,
'LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE': 7916,
'LATIN CAPITAL LETTER U WITH HORN AND TILDE': 7918,
'LATIN CAPITAL LETTER U WITH INVERTED BREVE': 534,
'LATIN CAPITAL LETTER U WITH MACRON': 362,
'LATIN CAPITAL LETTER U WITH MACRON AND DIAERESIS': 7802,
'LATIN CAPITAL LETTER U WITH OGONEK': 370,
'LATIN CAPITAL LETTER U WITH RING ABOVE': 366,
'LATIN CAPITAL LETTER U WITH TILDE': 360,
'LATIN CAPITAL LETTER U WITH TILDE AND ACUTE': 7800,
'LATIN CAPITAL LETTER U WITH TILDE BELOW': 7796,
'LATIN CAPITAL LETTER UPSILON': 433,
'LATIN CAPITAL LETTER V': 86,
'LATIN CAPITAL LETTER V WITH DOT BELOW': 7806,
'LATIN CAPITAL LETTER V WITH HOOK': 434,
'LATIN CAPITAL LETTER V WITH TILDE': 7804,
'LATIN CAPITAL LETTER W': 87,
'LATIN CAPITAL LETTER W WITH ACUTE': 7810,
'LATIN CAPITAL LETTER W WITH CIRCUMFLEX': 372,
'LATIN CAPITAL LETTER W WITH DIAERESIS': 7812,
'LATIN CAPITAL LETTER W WITH DOT ABOVE': 7814,
'LATIN CAPITAL LETTER W WITH DOT BELOW': 7816,
'LATIN CAPITAL LETTER W WITH GRAVE': 7808,
'LATIN CAPITAL LETTER WYNN': 503,
'LATIN CAPITAL LETTER X': 88,
'LATIN CAPITAL LETTER X WITH DIAERESIS': 7820,
'LATIN CAPITAL LETTER X WITH DOT ABOVE': 7818,
'LATIN CAPITAL LETTER Y': 89,
'LATIN CAPITAL LETTER Y WITH ACUTE': 221,
'LATIN CAPITAL LETTER Y WITH CIRCUMFLEX': 374,
'LATIN CAPITAL LETTER Y WITH DIAERESIS': 376,
'LATIN CAPITAL LETTER Y WITH DOT ABOVE': 7822,
'LATIN CAPITAL LETTER Y WITH DOT BELOW': 7924,
'LATIN CAPITAL LETTER Y WITH GRAVE': 7922,
'LATIN CAPITAL LETTER Y WITH HOOK': 435,
'LATIN CAPITAL LETTER Y WITH HOOK ABOVE': 7926,
'LATIN CAPITAL LETTER Y WITH MACRON': 562,
'LATIN CAPITAL LETTER Y WITH TILDE': 7928,
'LATIN CAPITAL LETTER YOGH': 540,
'LATIN CAPITAL LETTER Z': 90,
'LATIN CAPITAL LETTER Z WITH ACUTE': 377,
'LATIN CAPITAL LETTER Z WITH CARON': 381,
'LATIN CAPITAL LETTER Z WITH CIRCUMFLEX': 7824,
'LATIN CAPITAL LETTER Z WITH DOT ABOVE': 379,
'LATIN CAPITAL LETTER Z WITH DOT BELOW': 7826,
'LATIN CAPITAL LETTER Z WITH HOOK': 548,
'LATIN CAPITAL LETTER Z WITH LINE BELOW': 7828,
'LATIN CAPITAL LETTER Z WITH STROKE': 437,
'LATIN CAPITAL LIGATURE IJ': 306,
'LATIN CAPITAL LIGATURE OE': 338,
'LATIN CROSS': 10013,
'LATIN LETTER AIN': 7461,
'LATIN LETTER ALVEOLAR CLICK': 450,
'LATIN LETTER BIDENTAL PERCUSSIVE': 685,
'LATIN LETTER BILABIAL CLICK': 664,
'LATIN LETTER BILABIAL PERCUSSIVE': 684,
'LATIN LETTER DENTAL CLICK': 448,
'LATIN LETTER GLOTTAL STOP': 660,
'LATIN LETTER GLOTTAL STOP WITH STROKE': 673,
'LATIN LETTER INVERTED GLOTTAL STOP': 662,
'LATIN LETTER INVERTED GLOTTAL STOP WITH STROKE': 446,
'LATIN LETTER LATERAL CLICK': 449,
'LATIN LETTER PHARYNGEAL VOICED FRICATIVE': 661,
'LATIN LETTER RETROFLEX CLICK': 451,
'LATIN LETTER REVERSED ESH LOOP': 426,
'LATIN LETTER REVERSED GLOTTAL STOP WITH STROKE': 674,
'LATIN LETTER SMALL CAPITAL A': 7424,
'LATIN LETTER SMALL CAPITAL AE': 7425,
'LATIN LETTER SMALL CAPITAL B': 665,
'LATIN LETTER SMALL CAPITAL BARRED B': 7427,
'LATIN LETTER SMALL CAPITAL C': 7428,
'LATIN LETTER SMALL CAPITAL D': 7429,
'LATIN LETTER SMALL CAPITAL E': 7431,
'LATIN LETTER SMALL CAPITAL ETH': 7430,
'LATIN LETTER SMALL CAPITAL EZH': 7459,
'LATIN LETTER SMALL CAPITAL G': 610,
'LATIN LETTER SMALL CAPITAL G WITH HOOK': 667,
'LATIN LETTER SMALL CAPITAL H': 668,
'LATIN LETTER SMALL CAPITAL I': 618,
'LATIN LETTER SMALL CAPITAL INVERTED R': 641,
'LATIN LETTER SMALL CAPITAL J': 7434,
'LATIN LETTER SMALL CAPITAL K': 7435,
'LATIN LETTER SMALL CAPITAL L': 671,
'LATIN LETTER SMALL CAPITAL L WITH STROKE': 7436,
'LATIN LETTER SMALL CAPITAL M': 7437,
'LATIN LETTER SMALL CAPITAL N': 628,
'LATIN LETTER SMALL CAPITAL O': 7439,
'LATIN LETTER SMALL CAPITAL OE': 630,
'LATIN LETTER SMALL CAPITAL OPEN O': 7440,
'LATIN LETTER SMALL CAPITAL OU': 7445,
'LATIN LETTER SMALL CAPITAL P': 7448,
'LATIN LETTER SMALL CAPITAL R': 640,
'LATIN LETTER SMALL CAPITAL REVERSED N': 7438,
'LATIN LETTER SMALL CAPITAL REVERSED R': 7449,
'LATIN LETTER SMALL CAPITAL T': 7451,
'LATIN LETTER SMALL CAPITAL TURNED R': 7450,
'LATIN LETTER SMALL CAPITAL U': 7452,
'LATIN LETTER SMALL CAPITAL V': 7456,
'LATIN LETTER SMALL CAPITAL W': 7457,
'LATIN LETTER SMALL CAPITAL Y': 655,
'LATIN LETTER SMALL CAPITAL Z': 7458,
'LATIN LETTER STRETCHED C': 663,
'LATIN LETTER TWO WITH STROKE': 443,
'LATIN LETTER VOICED LARYNGEAL SPIRANT': 7460,
'LATIN LETTER WYNN': 447,
'LATIN LETTER YR': 422,
'LATIN SMALL CAPITAL LETTER I WITH STROKE': 7547,
'LATIN SMALL CAPITAL LETTER U WITH STROKE': 7550,
'LATIN SMALL LETTER A': 97,
'LATIN SMALL LETTER A WITH ACUTE': 225,
'LATIN SMALL LETTER A WITH BREVE': 259,
'LATIN SMALL LETTER A WITH BREVE AND ACUTE': 7855,
'LATIN SMALL LETTER A WITH BREVE AND DOT BELOW': 7863,
'LATIN SMALL LETTER A WITH BREVE AND GRAVE': 7857,
'LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE': 7859,
'LATIN SMALL LETTER A WITH BREVE AND TILDE': 7861,
'LATIN SMALL LETTER A WITH CARON': 462,
'LATIN SMALL LETTER A WITH CIRCUMFLEX': 226,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE': 7845,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW': 7853,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE': 7847,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE': 7849,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE': 7851,
'LATIN SMALL LETTER A WITH DIAERESIS': 228,
'LATIN SMALL LETTER A WITH DIAERESIS AND MACRON': 479,
'LATIN SMALL LETTER A WITH DOT ABOVE': 551,
'LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON': 481,
'LATIN SMALL LETTER A WITH DOT BELOW': 7841,
'LATIN SMALL LETTER A WITH DOUBLE GRAVE': 513,
'LATIN SMALL LETTER A WITH GRAVE': 224,
'LATIN SMALL LETTER A WITH HOOK ABOVE': 7843,
'LATIN SMALL LETTER A WITH INVERTED BREVE': 515,
'LATIN SMALL LETTER A WITH MACRON': 257,
'LATIN SMALL LETTER A WITH OGONEK': 261,
'LATIN SMALL LETTER A WITH RETROFLEX HOOK': 7567,
'LATIN SMALL LETTER A WITH RIGHT HALF RING': 7834,
'LATIN SMALL LETTER A WITH RING ABOVE': 229,
'LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE': 507,
'LATIN SMALL LETTER A WITH RING BELOW': 7681,
'LATIN SMALL LETTER A WITH TILDE': 227,
'LATIN SMALL LETTER AE': 230,
'LATIN SMALL LETTER AE WITH ACUTE': 509,
'LATIN SMALL LETTER AE WITH MACRON': 483,
'LATIN SMALL LETTER ALPHA': 593,
'LATIN SMALL LETTER ALPHA WITH RETROFLEX HOOK': 7568,
'LATIN SMALL LETTER B': 98,
'LATIN SMALL LETTER B WITH DOT ABOVE': 7683,
'LATIN SMALL LETTER B WITH DOT BELOW': 7685,
'LATIN SMALL LETTER B WITH HOOK': 595,
'LATIN SMALL LETTER B WITH LINE BELOW': 7687,
'LATIN SMALL LETTER B WITH MIDDLE TILDE': 7532,
'LATIN SMALL LETTER B WITH PALATAL HOOK': 7552,
'LATIN SMALL LETTER B WITH STROKE': 384,
'LATIN SMALL LETTER B WITH TOPBAR': 387,
'LATIN SMALL LETTER BARRED O': 629,
'LATIN SMALL LETTER BOTTOM HALF O': 7447,
'LATIN SMALL LETTER C': 99,
'LATIN SMALL LETTER C WITH ACUTE': 263,
'LATIN SMALL LETTER C WITH CARON': 269,
'LATIN SMALL LETTER C WITH CEDILLA': 231,
'LATIN SMALL LETTER C WITH CEDILLA AND ACUTE': 7689,
'LATIN SMALL LETTER C WITH CIRCUMFLEX': 265,
'LATIN SMALL LETTER C WITH CURL': 597,
'LATIN SMALL LETTER C WITH DOT ABOVE': 267,
'LATIN SMALL LETTER C WITH HOOK': 392,
'LATIN SMALL LETTER C WITH STROKE': 572,
'LATIN SMALL LETTER CLOSED OMEGA': 631,
'LATIN SMALL LETTER CLOSED OPEN E': 666,
'LATIN SMALL LETTER CLOSED REVERSED OPEN E': 606,
'LATIN SMALL LETTER D': 100,
'LATIN SMALL LETTER D WITH CARON': 271,
'LATIN SMALL LETTER D WITH CEDILLA': 7697,
'LATIN SMALL LETTER D WITH CIRCUMFLEX BELOW': 7699,
'LATIN SMALL LETTER D WITH CURL': 545,
'LATIN SMALL LETTER D WITH DOT ABOVE': 7691,
'LATIN SMALL LETTER D WITH DOT BELOW': 7693,
'LATIN SMALL LETTER D WITH HOOK': 599,
'LATIN SMALL LETTER D WITH HOOK AND TAIL': 7569,
'LATIN SMALL LETTER D WITH LINE BELOW': 7695,
'LATIN SMALL LETTER D WITH MIDDLE TILDE': 7533,
'LATIN SMALL LETTER D WITH PALATAL HOOK': 7553,
'LATIN SMALL LETTER D WITH STROKE': 273,
'LATIN SMALL LETTER D WITH TAIL': 598,
'LATIN SMALL LETTER D WITH TOPBAR': 396,
'LATIN SMALL LETTER DB DIGRAPH': 568,
'LATIN SMALL LETTER DEZH DIGRAPH': 676,
'LATIN SMALL LETTER DOTLESS I': 305,
'LATIN SMALL LETTER DOTLESS J': 567,
'LATIN SMALL LETTER DOTLESS J WITH STROKE': 607,
'LATIN SMALL LETTER DOTLESS J WITH STROKE AND HOOK': 644,
'LATIN SMALL LETTER DZ': 499,
'LATIN SMALL LETTER DZ DIGRAPH': 675,
'LATIN SMALL LETTER DZ DIGRAPH WITH CURL': 677,
'LATIN SMALL LETTER DZ WITH CARON': 454,
'LATIN SMALL LETTER E': 101,
'LATIN SMALL LETTER E WITH ACUTE': 233,
'LATIN SMALL LETTER E WITH BREVE': 277,
'LATIN SMALL LETTER E WITH CARON': 283,
'LATIN SMALL LETTER E WITH CEDILLA': 553,
'LATIN SMALL LETTER E WITH CEDILLA AND BREVE': 7709,
'LATIN SMALL LETTER E WITH CIRCUMFLEX': 234,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE': 7871,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW': 7879,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE': 7873,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE': 7875,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE': 7877,
'LATIN SMALL LETTER E WITH CIRCUMFLEX BELOW': 7705,
'LATIN SMALL LETTER E WITH DIAERESIS': 235,
'LATIN SMALL LETTER E WITH DOT ABOVE': 279,
'LATIN SMALL LETTER E WITH DOT BELOW': 7865,
'LATIN SMALL LETTER E WITH DOUBLE GRAVE': 517,
'LATIN SMALL LETTER E WITH GRAVE': 232,
'LATIN SMALL LETTER E WITH HOOK ABOVE': 7867,
'LATIN SMALL LETTER E WITH INVERTED BREVE': 519,
'LATIN SMALL LETTER E WITH MACRON': 275,
'LATIN SMALL LETTER E WITH MACRON AND ACUTE': 7703,
'LATIN SMALL LETTER E WITH MACRON AND GRAVE': 7701,
'LATIN SMALL LETTER E WITH OGONEK': 281,
'LATIN SMALL LETTER E WITH RETROFLEX HOOK': 7570,
'LATIN SMALL LETTER E WITH TILDE': 7869,
'LATIN SMALL LETTER E WITH TILDE BELOW': 7707,
'LATIN SMALL LETTER ENG': 331,
'LATIN SMALL LETTER ESH': 643,
'LATIN SMALL LETTER ESH WITH CURL': 646,
'LATIN SMALL LETTER ESH WITH PALATAL HOOK': 7563,
'LATIN SMALL LETTER ESH WITH RETROFLEX HOOK': 7576,
'LATIN SMALL LETTER ETH': 240,
'LATIN SMALL LETTER EZH': 658,
'LATIN SMALL LETTER EZH REVERSED': 441,
'LATIN SMALL LETTER EZH WITH CARON': 495,
'LATIN SMALL LETTER EZH WITH CURL': 659,
'LATIN SMALL LETTER EZH WITH RETROFLEX HOOK': 7578,
'LATIN SMALL LETTER EZH WITH TAIL': 442,
'LATIN SMALL LETTER F': 102,
'LATIN SMALL LETTER F WITH DOT ABOVE': 7711,
'LATIN SMALL LETTER F WITH HOOK': 402,
'LATIN SMALL LETTER F WITH MIDDLE TILDE': 7534,
'LATIN SMALL LETTER F WITH PALATAL HOOK': 7554,
'LATIN SMALL LETTER FENG DIGRAPH': 681,
'LATIN SMALL LETTER G': 103,
'LATIN SMALL LETTER G WITH ACUTE': 501,
'LATIN SMALL LETTER G WITH BREVE': 287,
'LATIN SMALL LETTER G WITH CARON': 487,
'LATIN SMALL LETTER G WITH CEDILLA': 291,
'LATIN SMALL LETTER G WITH CIRCUMFLEX': 285,
'LATIN SMALL LETTER G WITH DOT ABOVE': 289,
'LATIN SMALL LETTER G WITH HOOK': 608,
'LATIN SMALL LETTER G WITH MACRON': 7713,
'LATIN SMALL LETTER G WITH PALATAL HOOK': 7555,
'LATIN SMALL LETTER G WITH STROKE': 485,
'LATIN SMALL LETTER GAMMA': 611,
'LATIN SMALL LETTER H': 104,
'LATIN SMALL LETTER H WITH BREVE BELOW': 7723,
'LATIN SMALL LETTER H WITH CARON': 543,
'LATIN SMALL LETTER H WITH CEDILLA': 7721,
'LATIN SMALL LETTER H WITH CIRCUMFLEX': 293,
'LATIN SMALL LETTER H WITH DIAERESIS': 7719,
'LATIN SMALL LETTER H WITH DOT ABOVE': 7715,
'LATIN SMALL LETTER H WITH DOT BELOW': 7717,
'LATIN SMALL LETTER H WITH HOOK': 614,
'LATIN SMALL LETTER H WITH LINE BELOW': 7830,
'LATIN SMALL LETTER H WITH STROKE': 295,
'LATIN SMALL LETTER HENG WITH HOOK': 615,
'LATIN SMALL LETTER HV': 405,
'LATIN SMALL LETTER I': 105,
'LATIN SMALL LETTER I WITH ACUTE': 237,
'LATIN SMALL LETTER I WITH BREVE': 301,
'LATIN SMALL LETTER I WITH CARON': 464,
'LATIN SMALL LETTER I WITH CIRCUMFLEX': 238,
'LATIN SMALL LETTER I WITH DIAERESIS': 239,
'LATIN SMALL LETTER I WITH DIAERESIS AND ACUTE': 7727,
'LATIN SMALL LETTER I WITH DOT BELOW': 7883,
'LATIN SMALL LETTER I WITH DOUBLE GRAVE': 521,
'LATIN SMALL LETTER I WITH GRAVE': 236,
'LATIN SMALL LETTER I WITH HOOK ABOVE': 7881,
'LATIN SMALL LETTER I WITH INVERTED BREVE': 523,
'LATIN SMALL LETTER I WITH MACRON': 299,
'LATIN SMALL LETTER I WITH OGONEK': 303,
'LATIN SMALL LETTER I WITH RETROFLEX HOOK': 7574,
'LATIN SMALL LETTER I WITH STROKE': 616,
'LATIN SMALL LETTER I WITH TILDE': 297,
'LATIN SMALL LETTER I WITH TILDE BELOW': 7725,
'LATIN SMALL LETTER INSULAR G': 7545,
'LATIN SMALL LETTER IOTA': 617,
'LATIN SMALL LETTER IOTA WITH STROKE': 7548,
'LATIN SMALL LETTER J': 106,
'LATIN SMALL LETTER J WITH CARON': 496,
'LATIN SMALL LETTER J WITH CIRCUMFLEX': 309,
'LATIN SMALL LETTER J WITH CROSSED-TAIL': 669,
'LATIN SMALL LETTER K': 107,
'LATIN SMALL LETTER K WITH ACUTE': 7729,
'LATIN SMALL LETTER K WITH CARON': 489,
'LATIN SMALL LETTER K WITH CEDILLA': 311,
'LATIN SMALL LETTER K WITH DOT BELOW': 7731,
'LATIN SMALL LETTER K WITH HOOK': 409,
'LATIN SMALL LETTER K WITH LINE BELOW': 7733,
'LATIN SMALL LETTER K WITH PALATAL HOOK': 7556,
'LATIN SMALL LETTER KRA': 312,
'LATIN SMALL LETTER L': 108,
'LATIN SMALL LETTER L WITH ACUTE': 314,
'LATIN SMALL LETTER L WITH BAR': 410,
'LATIN SMALL LETTER L WITH BELT': 620,
'LATIN SMALL LETTER L WITH CARON': 318,
'LATIN SMALL LETTER L WITH CEDILLA': 316,
'LATIN SMALL LETTER L WITH CIRCUMFLEX BELOW': 7741,
'LATIN SMALL LETTER L WITH CURL': 564,
'LATIN SMALL LETTER L WITH DOT BELOW': 7735,
'LATIN SMALL LETTER L WITH DOT BELOW AND MACRON': 7737,
'LATIN SMALL LETTER L WITH LINE BELOW': 7739,
'LATIN SMALL LETTER L WITH MIDDLE DOT': 320,
'LATIN SMALL LETTER L WITH MIDDLE TILDE': 619,
'LATIN SMALL LETTER L WITH PALATAL HOOK': 7557,
'LATIN SMALL LETTER L WITH RETROFLEX HOOK': 621,
'LATIN SMALL LETTER L WITH STROKE': 322,
'LATIN SMALL LETTER LAMBDA WITH STROKE': 411,
'LATIN SMALL LETTER LEZH': 622,
'LATIN SMALL LETTER LJ': 457,
'LATIN SMALL LETTER LONG S': 383,
'LATIN SMALL LETTER LONG S WITH DOT ABOVE': 7835,
'LATIN SMALL LETTER LS DIGRAPH': 682,
'LATIN SMALL LETTER LZ DIGRAPH': 683,
'LATIN SMALL LETTER M': 109,
'LATIN SMALL LETTER M WITH ACUTE': 7743,
'LATIN SMALL LETTER M WITH DOT ABOVE': 7745,
'LATIN SMALL LETTER M WITH DOT BELOW': 7747,
'LATIN SMALL LETTER M WITH HOOK': 625,
'LATIN SMALL LETTER M WITH MIDDLE TILDE': 7535,
'LATIN SMALL LETTER M WITH PALATAL HOOK': 7558,
'LATIN SMALL LETTER N': 110,
'LATIN SMALL LETTER N PRECEDED BY APOSTROPHE': 329,
'LATIN SMALL LETTER N WITH ACUTE': 324,
'LATIN SMALL LETTER N WITH CARON': 328,
'LATIN SMALL LETTER N WITH CEDILLA': 326,
'LATIN SMALL LETTER N WITH CIRCUMFLEX BELOW': 7755,
'LATIN SMALL LETTER N WITH CURL': 565,
'LATIN SMALL LETTER N WITH DOT ABOVE': 7749,
'LATIN SMALL LETTER N WITH DOT BELOW': 7751,
'LATIN SMALL LETTER N WITH GRAVE': 505,
'LATIN SMALL LETTER N WITH LEFT HOOK': 626,
'LATIN SMALL LETTER N WITH LINE BELOW': 7753,
'LATIN SMALL LETTER N WITH LONG RIGHT LEG': 414,
'LATIN SMALL LETTER N WITH MIDDLE TILDE': 7536,
'LATIN SMALL LETTER N WITH PALATAL HOOK': 7559,
'LATIN SMALL LETTER N WITH RETROFLEX HOOK': 627,
'LATIN SMALL LETTER N WITH TILDE': 241,
'LATIN SMALL LETTER NJ': 460,
'LATIN SMALL LETTER O': 111,
'LATIN SMALL LETTER O WITH ACUTE': 243,
'LATIN SMALL LETTER O WITH BREVE': 335,
'LATIN SMALL LETTER O WITH CARON': 466,
'LATIN SMALL LETTER O WITH CIRCUMFLEX': 244,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE': 7889,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW': 7897,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE': 7891,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE': 7893,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE': 7895,
'LATIN SMALL LETTER O WITH DIAERESIS': 246,
'LATIN SMALL LETTER O WITH DIAERESIS AND MACRON': 555,
'LATIN SMALL LETTER O WITH DOT ABOVE': 559,
'LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON': 561,
'LATIN SMALL LETTER O WITH DOT BELOW': 7885,
'LATIN SMALL LETTER O WITH DOUBLE ACUTE': 337,
'LATIN SMALL LETTER O WITH DOUBLE GRAVE': 525,
'LATIN SMALL LETTER O WITH GRAVE': 242,
'LATIN SMALL LETTER O WITH HOOK ABOVE': 7887,
'LATIN SMALL LETTER O WITH HORN': 417,
'LATIN SMALL LETTER O WITH HORN AND ACUTE': 7899,
'LATIN SMALL LETTER O WITH HORN AND DOT BELOW': 7907,
'LATIN SMALL LETTER O WITH HORN AND GRAVE': 7901,
'LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE': 7903,
'LATIN SMALL LETTER O WITH HORN AND TILDE': 7905,
'LATIN SMALL LETTER O WITH INVERTED BREVE': 527,
'LATIN SMALL LETTER O WITH MACRON': 333,
'LATIN SMALL LETTER O WITH MACRON AND ACUTE': 7763,
'LATIN SMALL LETTER O WITH MACRON AND GRAVE': 7761,
'LATIN SMALL LETTER O WITH OGONEK': 491,
'LATIN SMALL LETTER O WITH OGONEK AND MACRON': 493,
'LATIN SMALL LETTER O WITH STROKE': 248,
'LATIN SMALL LETTER O WITH STROKE AND ACUTE': 511,
'LATIN SMALL LETTER O WITH TILDE': 245,
'LATIN SMALL LETTER O WITH TILDE AND ACUTE': 7757,
'LATIN SMALL LETTER O WITH TILDE AND DIAERESIS': 7759,
'LATIN SMALL LETTER O WITH TILDE AND MACRON': 557,
'LATIN SMALL LETTER OI': 419,
'LATIN SMALL LETTER OPEN E': 603,
'LATIN SMALL LETTER OPEN E WITH RETROFLEX HOOK': 7571,
'LATIN SMALL LETTER OPEN O': 596,
'LATIN SMALL LETTER OPEN O WITH RETROFLEX HOOK': 7575,
'LATIN SMALL LETTER OU': 547,
'LATIN SMALL LETTER P': 112,
'LATIN SMALL LETTER P WITH ACUTE': 7765,
'LATIN SMALL LETTER P WITH DOT ABOVE': 7767,
'LATIN SMALL LETTER P WITH HOOK': 421,
'LATIN SMALL LETTER P WITH MIDDLE TILDE': 7537,
'LATIN SMALL LETTER P WITH PALATAL HOOK': 7560,
'LATIN SMALL LETTER P WITH STROKE': 7549,
'LATIN SMALL LETTER PHI': 632,
'LATIN SMALL LETTER Q': 113,
'LATIN SMALL LETTER Q WITH HOOK': 672,
'LATIN SMALL LETTER QP DIGRAPH': 569,
'LATIN SMALL LETTER R': 114,
'LATIN SMALL LETTER R WITH ACUTE': 341,
'LATIN SMALL LETTER R WITH CARON': 345,
'LATIN SMALL LETTER R WITH CEDILLA': 343,
'LATIN SMALL LETTER R WITH DOT ABOVE': 7769,
'LATIN SMALL LETTER R WITH DOT BELOW': 7771,
'LATIN SMALL LETTER R WITH DOT BELOW AND MACRON': 7773,
'LATIN SMALL LETTER R WITH DOUBLE GRAVE': 529,
'LATIN SMALL LETTER R WITH FISHHOOK': 638,
'LATIN SMALL LETTER R WITH FISHHOOK AND MIDDLE TILDE': 7539,
'LATIN SMALL LETTER R WITH INVERTED BREVE': 531,
'LATIN SMALL LETTER R WITH LINE BELOW': 7775,
'LATIN SMALL LETTER R WITH LONG LEG': 636,
'LATIN SMALL LETTER R WITH MIDDLE TILDE': 7538,
'LATIN SMALL LETTER R WITH PALATAL HOOK': 7561,
'LATIN SMALL LETTER R WITH TAIL': 637,
'LATIN SMALL LETTER RAMS HORN': 612,
'LATIN SMALL LETTER REVERSED E': 600,
'LATIN SMALL LETTER REVERSED OPEN E': 604,
'LATIN SMALL LETTER REVERSED OPEN E WITH HOOK': 605,
'LATIN SMALL LETTER REVERSED OPEN E WITH RETROFLEX HOOK': 7572,
'LATIN SMALL LETTER REVERSED R WITH FISHHOOK': 639,
'LATIN SMALL LETTER S': 115,
'LATIN SMALL LETTER S WITH ACUTE': 347,
'LATIN SMALL LETTER S WITH ACUTE AND DOT ABOVE': 7781,
'LATIN SMALL LETTER S WITH CARON': 353,
'LATIN SMALL LETTER S WITH CARON AND DOT ABOVE': 7783,
'LATIN SMALL LETTER S WITH CEDILLA': 351,
'LATIN SMALL LETTER S WITH CIRCUMFLEX': 349,
'LATIN SMALL LETTER S WITH COMMA BELOW': 537,
'LATIN SMALL LETTER S WITH DOT ABOVE': 7777,
'LATIN SMALL LETTER S WITH DOT BELOW': 7779,
'LATIN SMALL LETTER S WITH DOT BELOW AND DOT ABOVE': 7785,
'LATIN SMALL LETTER S WITH HOOK': 642,
'LATIN SMALL LETTER S WITH MIDDLE TILDE': 7540,
'LATIN SMALL LETTER S WITH PALATAL HOOK': 7562,
'LATIN SMALL LETTER S WITH SWASH TAIL': 575,
'LATIN SMALL LETTER SCHWA': 601,
'LATIN SMALL LETTER SCHWA WITH HOOK': 602,
'LATIN SMALL LETTER SCHWA WITH RETROFLEX HOOK': 7573,
'LATIN SMALL LETTER SCRIPT G': 609,
'LATIN SMALL LETTER SHARP S': 223,
'LATIN SMALL LETTER SIDEWAYS DIAERESIZED U': 7454,
'LATIN SMALL LETTER SIDEWAYS O': 7441,
'LATIN SMALL LETTER SIDEWAYS O WITH STROKE': 7443,
'LATIN SMALL LETTER SIDEWAYS OPEN O': 7442,
'LATIN SMALL LETTER SIDEWAYS TURNED M': 7455,
'LATIN SMALL LETTER SIDEWAYS U': 7453,
'LATIN SMALL LETTER SQUAT REVERSED ESH': 645,
'LATIN SMALL LETTER T': 116,
'LATIN SMALL LETTER T WITH CARON': 357,
'LATIN SMALL LETTER T WITH CEDILLA': 355,
'LATIN SMALL LETTER T WITH CIRCUMFLEX BELOW': 7793,
'LATIN SMALL LETTER T WITH COMMA BELOW': 539,
'LATIN SMALL LETTER T WITH CURL': 566,
'LATIN SMALL LETTER T WITH DIAERESIS': 7831,
'LATIN SMALL LETTER T WITH DOT ABOVE': 7787,
'LATIN SMALL LETTER T WITH DOT BELOW': 7789,
'LATIN SMALL LETTER T WITH HOOK': 429,
'LATIN SMALL LETTER T WITH LINE BELOW': 7791,
'LATIN SMALL LETTER T WITH MIDDLE TILDE': 7541,
'LATIN SMALL LETTER T WITH PALATAL HOOK': 427,
'LATIN SMALL LETTER T WITH RETROFLEX HOOK': 648,
'LATIN SMALL LETTER T WITH STROKE': 359,
'LATIN SMALL LETTER TC DIGRAPH WITH CURL': 680,
'LATIN SMALL LETTER TESH DIGRAPH': 679,
'LATIN SMALL LETTER TH WITH STRIKETHROUGH': 7546,
'LATIN SMALL LETTER THORN': 254,
'LATIN SMALL LETTER TONE FIVE': 445,
'LATIN SMALL LETTER TONE SIX': 389,
'LATIN SMALL LETTER TONE TWO': 424,
'LATIN SMALL LETTER TOP HALF O': 7446,
'LATIN SMALL LETTER TS DIGRAPH': 678,
'LATIN SMALL LETTER TURNED A': 592,
'LATIN SMALL LETTER TURNED AE': 7426,
'LATIN SMALL LETTER TURNED ALPHA': 594,
'LATIN SMALL LETTER TURNED DELTA': 397,
'LATIN SMALL LETTER TURNED E': 477,
'LATIN SMALL LETTER TURNED G': 7543,
'LATIN SMALL LETTER TURNED H': 613,
'LATIN SMALL LETTER TURNED H WITH FISHHOOK': 686,
'LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL': 687,
'LATIN SMALL LETTER TURNED I': 7433,
'LATIN SMALL LETTER TURNED K': 670,
'LATIN SMALL LETTER TURNED M': 623,
'LATIN SMALL LETTER TURNED M WITH LONG LEG': 624,
'LATIN SMALL LETTER TURNED OE': 7444,
'LATIN SMALL LETTER TURNED OPEN E': 7432,
'LATIN SMALL LETTER TURNED R': 633,
'LATIN SMALL LETTER TURNED R WITH HOOK': 635,
'LATIN SMALL LETTER TURNED R WITH LONG LEG': 634,
'LATIN SMALL LETTER TURNED T': 647,
'LATIN SMALL LETTER TURNED V': 652,
'LATIN SMALL LETTER TURNED W': 653,
'LATIN SMALL LETTER TURNED Y': 654,
'LATIN SMALL LETTER U': 117,
'LATIN SMALL LETTER U BAR': 649,
'LATIN SMALL LETTER U WITH ACUTE': 250,
'LATIN SMALL LETTER U WITH BREVE': 365,
'LATIN SMALL LETTER U WITH CARON': 468,
'LATIN SMALL LETTER U WITH CIRCUMFLEX': 251,
'LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW': 7799,
'LATIN SMALL LETTER U WITH DIAERESIS': 252,
'LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE': 472,
'LATIN SMALL LETTER U WITH DIAERESIS AND CARON': 474,
'LATIN SMALL LETTER U WITH DIAERESIS AND GRAVE': 476,
'LATIN SMALL LETTER U WITH DIAERESIS AND MACRON': 470,
'LATIN SMALL LETTER U WITH DIAERESIS BELOW': 7795,
'LATIN SMALL LETTER U WITH DOT BELOW': 7909,
'LATIN SMALL LETTER U WITH DOUBLE ACUTE': 369,
'LATIN SMALL LETTER U WITH DOUBLE GRAVE': 533,
'LATIN SMALL LETTER U WITH GRAVE': 249,
'LATIN SMALL LETTER U WITH HOOK ABOVE': 7911,
'LATIN SMALL LETTER U WITH HORN': 432,
'LATIN SMALL LETTER U WITH HORN AND ACUTE': 7913,
'LATIN SMALL LETTER U WITH HORN AND DOT BELOW': 7921,
'LATIN SMALL LETTER U WITH HORN AND GRAVE': 7915,
'LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE': 7917,
'LATIN SMALL LETTER U WITH HORN AND TILDE': 7919,
'LATIN SMALL LETTER U WITH INVERTED BREVE': 535,
'LATIN SMALL LETTER U WITH MACRON': 363,
'LATIN SMALL LETTER U WITH MACRON AND DIAERESIS': 7803,
'LATIN SMALL LETTER U WITH OGONEK': 371,
'LATIN SMALL LETTER U WITH RETROFLEX HOOK': 7577,
'LATIN SMALL LETTER U WITH RING ABOVE': 367,
'LATIN SMALL LETTER U WITH TILDE': 361,
'LATIN SMALL LETTER U WITH TILDE AND ACUTE': 7801,
'LATIN SMALL LETTER U WITH TILDE BELOW': 7797,
'LATIN SMALL LETTER UE': 7531,
'LATIN SMALL LETTER UPSILON': 650,
'LATIN SMALL LETTER UPSILON WITH STROKE': 7551,
'LATIN SMALL LETTER V': 118,
'LATIN SMALL LETTER V WITH DOT BELOW': 7807,
'LATIN SMALL LETTER V WITH HOOK': 651,
'LATIN SMALL LETTER V WITH PALATAL HOOK': 7564,
'LATIN SMALL LETTER V WITH TILDE': 7805,
'LATIN SMALL LETTER W': 119,
'LATIN SMALL LETTER W WITH ACUTE': 7811,
'LATIN SMALL LETTER W WITH CIRCUMFLEX': 373,
'LATIN SMALL LETTER W WITH DIAERESIS': 7813,
'LATIN SMALL LETTER W WITH DOT ABOVE': 7815,
'LATIN SMALL LETTER W WITH DOT BELOW': 7817,
'LATIN SMALL LETTER W WITH GRAVE': 7809,
'LATIN SMALL LETTER W WITH RING ABOVE': 7832,
'LATIN SMALL LETTER X': 120,
'LATIN SMALL LETTER X WITH DIAERESIS': 7821,
'LATIN SMALL LETTER X WITH DOT ABOVE': 7819,
'LATIN SMALL LETTER X WITH PALATAL HOOK': 7565,
'LATIN SMALL LETTER Y': 121,
'LATIN SMALL LETTER Y WITH ACUTE': 253,
'LATIN SMALL LETTER Y WITH CIRCUMFLEX': 375,
'LATIN SMALL LETTER Y WITH DIAERESIS': 255,
'LATIN SMALL LETTER Y WITH DOT ABOVE': 7823,
'LATIN SMALL LETTER Y WITH DOT BELOW': 7925,
'LATIN SMALL LETTER Y WITH GRAVE': 7923,
'LATIN SMALL LETTER Y WITH HOOK': 436,
'LATIN SMALL LETTER Y WITH HOOK ABOVE': 7927,
'LATIN SMALL LETTER Y WITH MACRON': 563,
'LATIN SMALL LETTER Y WITH RING ABOVE': 7833,
'LATIN SMALL LETTER Y WITH TILDE': 7929,
'LATIN SMALL LETTER YOGH': 541,
'LATIN SMALL LETTER Z': 122,
'LATIN SMALL LETTER Z WITH ACUTE': 378,
'LATIN SMALL LETTER Z WITH CARON': 382,
'LATIN SMALL LETTER Z WITH CIRCUMFLEX': 7825,
'LATIN SMALL LETTER Z WITH CURL': 657,
'LATIN SMALL LETTER Z WITH DOT ABOVE': 380,
'LATIN SMALL LETTER Z WITH DOT BELOW': 7827,
'LATIN SMALL LETTER Z WITH HOOK': 549,
'LATIN SMALL LETTER Z WITH LINE BELOW': 7829,
'LATIN SMALL LETTER Z WITH MIDDLE TILDE': 7542,
'LATIN SMALL LETTER Z WITH PALATAL HOOK': 7566,
'LATIN SMALL LETTER Z WITH RETROFLEX HOOK': 656,
'LATIN SMALL LETTER Z WITH STROKE': 438,
'LATIN SMALL LETTER Z WITH SWASH TAIL': 576,
'LATIN SMALL LIGATURE FF': 64256,
'LATIN SMALL LIGATURE FFI': 64259,
'LATIN SMALL LIGATURE FFL': 64260,
'LATIN SMALL LIGATURE FI': 64257,
'LATIN SMALL LIGATURE FL': 64258,
'LATIN SMALL LIGATURE IJ': 307,
'LATIN SMALL LIGATURE LONG S T': 64261,
'LATIN SMALL LIGATURE OE': 339,
'LATIN SMALL LIGATURE ST': 64262,
'LATIN SUBSCRIPT SMALL LETTER A': 8336,
'LATIN SUBSCRIPT SMALL LETTER E': 8337,
'LATIN SUBSCRIPT SMALL LETTER I': 7522,
'LATIN SUBSCRIPT SMALL LETTER O': 8338,
'LATIN SUBSCRIPT SMALL LETTER R': 7523,
'LATIN SUBSCRIPT SMALL LETTER SCHWA': 8340,
'LATIN SUBSCRIPT SMALL LETTER U': 7524,
'LATIN SUBSCRIPT SMALL LETTER V': 7525,
'LATIN SUBSCRIPT SMALL LETTER X': 8339,
'LEFT AND RIGHT DOUBLE TURNSTILE': 10202,
'LEFT AND RIGHT TACK': 10203,
'LEFT ANGLE BRACKET': 12296,
'LEFT ANGLE BRACKET WITH DOT': 10641,
'LEFT ARC LESS-THAN BRACKET': 10643,
'LEFT BARB DOWN RIGHT BARB DOWN HARPOON': 10576,
'LEFT BARB DOWN RIGHT BARB UP HARPOON': 10571,
'LEFT BARB UP RIGHT BARB DOWN HARPOON': 10570,
'LEFT BARB UP RIGHT BARB UP HARPOON': 10574,
'LEFT BLACK LENTICULAR BRACKET': 12304,
'LEFT BLACK TORTOISE SHELL BRACKET': 10647,
'LEFT CEILING': 8968,
'LEFT CORNER BRACKET': 12300,
'LEFT CURLY BRACKET': 123,
'LEFT CURLY BRACKET LOWER HOOK': 9129,
'LEFT CURLY BRACKET MIDDLE PIECE': 9128,
'LEFT CURLY BRACKET UPPER HOOK': 9127,
'LEFT DOTTED SUBSTITUTION BRACKET': 11780,
'LEFT DOUBLE ANGLE BRACKET': 12298,
'LEFT DOUBLE QUOTATION MARK': 8220,
'LEFT DOUBLE WIGGLY FENCE': 10714,
'LEFT FISH TAIL': 10620,
'LEFT FIVE EIGHTHS BLOCK': 9611,
'LEFT FLOOR': 8970,
'LEFT HALF BLACK CIRCLE': 9686,
'LEFT HALF BLOCK': 9612,
'LEFT LOW PARAPHRASE BRACKET': 11804,
'LEFT MULTIMAP': 10204,
'LEFT NORMAL FACTOR SEMIDIRECT PRODUCT': 8905,
'LEFT ONE EIGHTH BLOCK': 9615,
'LEFT ONE QUARTER BLOCK': 9614,
'LEFT OUTER JOIN': 10197,
'LEFT PARENTHESIS': 40,
'LEFT PARENTHESIS EXTENSION': 9116,
'LEFT PARENTHESIS LOWER HOOK': 9117,
'LEFT PARENTHESIS UPPER HOOK': 9115,
'LEFT RAISED OMISSION BRACKET': 11788,
'LEFT RIGHT ARROW': 8596,
'LEFT RIGHT ARROW THROUGH SMALL CIRCLE': 10568,
'LEFT RIGHT ARROW WITH DOUBLE VERTICAL STROKE': 8700,
'LEFT RIGHT ARROW WITH STROKE': 8622,
'LEFT RIGHT ARROW WITH VERTICAL STROKE': 8697,
'LEFT RIGHT BLACK ARROW': 11020,
'LEFT RIGHT DOUBLE ARROW': 8660,
'LEFT RIGHT DOUBLE ARROW WITH STROKE': 8654,
'LEFT RIGHT DOUBLE ARROW WITH VERTICAL STROKE': 10500,
'LEFT RIGHT OPEN-HEADED ARROW': 8703,
'LEFT RIGHT WAVE ARROW': 8621,
'LEFT RIGHT WHITE ARROW': 11012,
'LEFT S-SHAPED BAG DELIMITER': 10181,
'LEFT SEMIDIRECT PRODUCT': 8907,
'LEFT SEVEN EIGHTHS BLOCK': 9609,
'LEFT SINGLE QUOTATION MARK': 8216,
'LEFT SQUARE BRACKET': 91,
'LEFT SQUARE BRACKET EXTENSION': 9122,
'LEFT SQUARE BRACKET LOWER CORNER': 9123,
'LEFT SQUARE BRACKET UPPER CORNER': 9121,
'LEFT SQUARE BRACKET WITH QUILL': 8261,
'LEFT SQUARE BRACKET WITH TICK IN BOTTOM CORNER': 10639,
'LEFT SQUARE BRACKET WITH TICK IN TOP CORNER': 10637,
'LEFT SQUARE BRACKET WITH UNDERBAR': 10635,
'LEFT SUBSTITUTION BRACKET': 11778,
'LEFT TACK': 8867,
'LEFT THREE EIGHTHS BLOCK': 9613,
'LEFT THREE QUARTERS BLOCK': 9610,
'LEFT TORTOISE SHELL BRACKET': 12308,
'LEFT TRANSPOSITION BRACKET': 11785,
'LEFT TRIANGLE BESIDE VERTICAL BAR': 10703,
'LEFT VERTICAL BOX LINE': 9144,
'LEFT WHITE CORNER BRACKET': 12302,
'LEFT WHITE CURLY BRACKET': 10627,
'LEFT WHITE LENTICULAR BRACKET': 12310,
'LEFT WHITE PARENTHESIS': 10629,
'LEFT WHITE SQUARE BRACKET': 12314,
'LEFT WHITE TORTOISE SHELL BRACKET': 12312,
'LEFT WIGGLY FENCE': 10712,
'LEFT-POINTING ANGLE BRACKET': 9001,
'LEFT-POINTING CURVED ANGLE BRACKET': 10748,
'LEFT-POINTING DOUBLE ANGLE QUOTATION MARK': 171,
'LEFT-SHADED WHITE RIGHTWARDS ARROW': 10154,
'LEFT-SIDE ARC ANTICLOCKWISE ARROW': 10553,
'LEFT-TO-RIGHT EMBEDDING': 8234,
'LEFT-TO-RIGHT MARK': 8206,
'LEFT-TO-RIGHT OVERRIDE': 8237,
'LEFTWARDS ARROW': 8592,
'LEFTWARDS ARROW ABOVE SHORT RIGHTWARDS ARROW': 10563,
'LEFTWARDS ARROW ABOVE TILDE OPERATOR': 10611,
'LEFTWARDS ARROW FROM BAR': 8612,
'LEFTWARDS ARROW FROM BAR TO BLACK DIAMOND': 10527,
'LEFTWARDS ARROW OVER RIGHTWARDS ARROW': 8646,
'LEFTWARDS ARROW THROUGH LESS-THAN': 10615,
'LEFTWARDS ARROW THROUGH SUBSET': 10618,
'LEFTWARDS ARROW TO BAR': 8676,
'LEFTWARDS ARROW TO BAR OVER RIGHTWARDS ARROW TO BAR': 8633,
'LEFTWARDS ARROW TO BLACK DIAMOND': 10525,
'LEFTWARDS ARROW WITH DOUBLE VERTICAL STROKE': 8698,
'LEFTWARDS ARROW WITH HOOK': 8617,
'LEFTWARDS ARROW WITH LOOP': 8619,
'LEFTWARDS ARROW WITH PLUS BELOW': 10566,
'LEFTWARDS ARROW WITH STROKE': 8602,
'LEFTWARDS ARROW WITH TAIL': 8610,
'LEFTWARDS ARROW WITH TIP DOWNWARDS': 11024,
'LEFTWARDS ARROW WITH TIP UPWARDS': 11025,
'LEFTWARDS ARROW WITH VERTICAL STROKE': 8695,
'LEFTWARDS ARROW-TAIL': 10521,
'LEFTWARDS BLACK ARROW': 11013,
'LEFTWARDS DASHED ARROW': 8672,
'LEFTWARDS DOUBLE ARROW': 8656,
'LEFTWARDS DOUBLE ARROW FROM BAR': 10502,
'LEFTWARDS DOUBLE ARROW WITH STROKE': 8653,
'LEFTWARDS DOUBLE ARROW WITH VERTICAL STROKE': 10498,
'LEFTWARDS DOUBLE ARROW-TAIL': 10523,
'LEFTWARDS DOUBLE DASH ARROW': 10508,
'LEFTWARDS HARPOON OVER RIGHTWARDS HARPOON': 8651,
'LEFTWARDS HARPOON WITH BARB DOWN ABOVE RIGHTWARDS HARPOON WITH BARB DOWN': 10599,
'LEFTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH': 10603,
'LEFTWARDS HARPOON WITH BARB DOWN FROM BAR': 10590,
'LEFTWARDS HARPOON WITH BARB DOWN TO BAR': 10582,
'LEFTWARDS HARPOON WITH BARB DOWNWARDS': 8637,
'LEFTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB DOWN': 10594,
'LEFTWARDS HARPOON WITH BARB UP ABOVE LONG DASH': 10602,
'LEFTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB UP': 10598,
'LEFTWARDS HARPOON WITH BARB UP FROM BAR': 10586,
'LEFTWARDS HARPOON WITH BARB UP TO BAR': 10578,
'LEFTWARDS HARPOON WITH BARB UPWARDS': 8636,
'LEFTWARDS OPEN-HEADED ARROW': 8701,
'LEFTWARDS PAIRED ARROWS': 8647,
'LEFTWARDS SQUIGGLE ARROW': 8668,
'LEFTWARDS TRIPLE ARROW': 8666,
'LEFTWARDS TRIPLE DASH ARROW': 10510,
'LEFTWARDS TWO HEADED ARROW': 8606,
'LEFTWARDS WAVE ARROW': 8604,
'LEFTWARDS WHITE ARROW': 8678,
'LEO': 9804,
'LESS-THAN ABOVE DOUBLE-LINE EQUAL ABOVE GREATER-THAN': 10891,
'LESS-THAN ABOVE GREATER-THAN ABOVE DOUBLE-LINE EQUAL': 10897,
'LESS-THAN ABOVE LEFTWARDS ARROW': 10614,
'LESS-THAN ABOVE SIMILAR ABOVE GREATER-THAN': 10895,
'LESS-THAN ABOVE SIMILAR OR EQUAL': 10893,
'LESS-THAN ABOVE SLANTED EQUAL ABOVE GREATER-THAN ABOVE SLANTED EQUAL': 10899,
'LESS-THAN AND NOT APPROXIMATE': 10889,
'LESS-THAN AND SINGLE-LINE NOT EQUAL TO': 10887,
'LESS-THAN BUT NOT EQUAL TO': 8808,
'LESS-THAN BUT NOT EQUIVALENT TO': 8934,
'LESS-THAN CLOSED BY CURVE': 10918,
'LESS-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL': 10920,
'LESS-THAN EQUAL TO OR GREATER-THAN': 8922,
'LESS-THAN OR APPROXIMATE': 10885,
'LESS-THAN OR EQUAL TO': 8804,
'LESS-THAN OR EQUIVALENT TO': 8818,
'LESS-THAN OR GREATER-THAN': 8822,
'LESS-THAN OR SLANTED EQUAL TO': 10877,
'LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE': 10881,
'LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE RIGHT': 10883,
'LESS-THAN OR SLANTED EQUAL TO WITH DOT INSIDE': 10879,
'LESS-THAN OVER EQUAL TO': 8806,
'LESS-THAN SIGN': 60,
'LESS-THAN WITH CIRCLE INSIDE': 10873,
'LESS-THAN WITH DOT': 8918,
'LESS-THAN WITH QUESTION MARK ABOVE': 10875,
'LIBRA': 9806,
'LIGHT LEFT TORTOISE SHELL BRACKET ORNAMENT': 10098,
'LIGHT RIGHT TORTOISE SHELL BRACKET ORNAMENT': 10099,
'LIGHT SHADE': 9617,
'LIGHT VERTICAL BAR': 10072,
'LIGHTNING': 9735,
'LIMBU DIGIT EIGHT': 6478,
'LIMBU DIGIT FIVE': 6475,
'LIMBU DIGIT FOUR': 6474,
'LIMBU DIGIT NINE': 6479,
'LIMBU DIGIT ONE': 6471,
'LIMBU DIGIT SEVEN': 6477,
'LIMBU DIGIT SIX': 6476,
'LIMBU DIGIT THREE': 6473,
'LIMBU DIGIT TWO': 6472,
'LIMBU DIGIT ZERO': 6470,
'LIMBU EXCLAMATION MARK': 6468,
'LIMBU LETTER BA': 6418,
'LIMBU LETTER BHA': 6419,
'LIMBU LETTER CA': 6406,
'LIMBU LETTER CHA': 6407,
'LIMBU LETTER DA': 6413,
'LIMBU LETTER DHA': 6414,
'LIMBU LETTER GA': 6403,
'LIMBU LETTER GHA': 6404,
'LIMBU LETTER HA': 6428,
'LIMBU LETTER JA': 6408,
'LIMBU LETTER JHA': 6409,
'LIMBU LETTER KA': 6401,
'LIMBU LETTER KHA': 6402,
'LIMBU LETTER LA': 6423,
'LIMBU LETTER MA': 6420,
'LIMBU LETTER NA': 6415,
'LIMBU LETTER NGA': 6405,
'LIMBU LETTER PA': 6416,
'LIMBU LETTER PHA': 6417,
'LIMBU LETTER RA': 6422,
'LIMBU LETTER SA': 6427,
'LIMBU LETTER SHA': 6425,
'LIMBU LETTER SSA': 6426,
'LIMBU LETTER TA': 6411,
'LIMBU LETTER THA': 6412,
'LIMBU LETTER WA': 6424,
'LIMBU LETTER YA': 6421,
'LIMBU LETTER YAN': 6410,
'LIMBU QUESTION MARK': 6469,
'LIMBU SIGN KEMPHRENG': 6458,
'LIMBU SIGN LOO': 6464,
'LIMBU SIGN MUKPHRENG': 6457,
'LIMBU SIGN SA-I': 6459,
'LIMBU SMALL LETTER ANUSVARA': 6450,
'LIMBU SMALL LETTER KA': 6448,
'LIMBU SMALL LETTER LA': 6456,
'LIMBU SMALL LETTER MA': 6454,
'LIMBU SMALL LETTER NA': 6452,
'LIMBU SMALL LETTER NGA': 6449,
'LIMBU SMALL LETTER PA': 6453,
'LIMBU SMALL LETTER RA': 6455,
'LIMBU SMALL LETTER TA': 6451,
'LIMBU SUBJOINED LETTER RA': 6442,
'LIMBU SUBJOINED LETTER WA': 6443,
'LIMBU SUBJOINED LETTER YA': 6441,
'LIMBU VOWEL SIGN A': 6432,
'LIMBU VOWEL SIGN AI': 6436,
'LIMBU VOWEL SIGN AU': 6438,
'LIMBU VOWEL SIGN E': 6439,
'LIMBU VOWEL SIGN EE': 6435,
'LIMBU VOWEL SIGN I': 6433,
'LIMBU VOWEL SIGN O': 6440,
'LIMBU VOWEL SIGN OO': 6437,
'LIMBU VOWEL SIGN U': 6434,
'LIMBU VOWEL-CARRIER LETTER': 6400,
'LIMITED LIABILITY SIGN': 13007,
'LINE INTEGRATION NOT INCLUDING THE POLE': 10772,
'LINE INTEGRATION WITH RECTANGULAR PATH AROUND POLE': 10770,
'LINE INTEGRATION WITH SEMICIRCULAR PATH AROUND POLE': 10771,
'LINE SEPARATOR': 8232,
'LINEAR B IDEOGRAM B100 MAN': 65664,
'LINEAR B IDEOGRAM B102 WOMAN': 65665,
'LINEAR B IDEOGRAM B104 DEER': 65666,
'LINEAR B IDEOGRAM B105 EQUID': 65667,
'LINEAR B IDEOGRAM B105F MARE': 65668,
'LINEAR B IDEOGRAM B105M STALLION': 65669,
'LINEAR B IDEOGRAM B106F EWE': 65670,
'LINEAR B IDEOGRAM B106M RAM': 65671,
'LINEAR B IDEOGRAM B107F SHE-GOAT': 65672,
'LINEAR B IDEOGRAM B107M HE-GOAT': 65673,
'LINEAR B IDEOGRAM B108F SOW': 65674,
'LINEAR B IDEOGRAM B108M BOAR': 65675,
'LINEAR B IDEOGRAM B109F COW': 65676,
'LINEAR B IDEOGRAM B109M BULL': 65677,
'LINEAR B IDEOGRAM B120 WHEAT': 65678,
'LINEAR B IDEOGRAM B121 BARLEY': 65679,
'LINEAR B IDEOGRAM B122 OLIVE': 65680,
'LINEAR B IDEOGRAM B123 SPICE': 65681,
'LINEAR B IDEOGRAM B125 CYPERUS': 65682,
'LINEAR B IDEOGRAM B130 OIL': 65685,
'LINEAR B IDEOGRAM B131 WINE': 65686,
'LINEAR B IDEOGRAM B132': 65687,
'LINEAR B IDEOGRAM B140 BRONZE': 65690,
'LINEAR B IDEOGRAM B141 GOLD': 65691,
'LINEAR B IDEOGRAM B142': 65692,
'LINEAR B IDEOGRAM B145 WOOL': 65693,
'LINEAR B IDEOGRAM B146': 65694,
'LINEAR B IDEOGRAM B150': 65695,
'LINEAR B IDEOGRAM B151 HORN': 65696,
'LINEAR B IDEOGRAM B152': 65697,
'LINEAR B IDEOGRAM B153': 65698,
'LINEAR B IDEOGRAM B154': 65699,
'LINEAR B IDEOGRAM B157': 65701,
'LINEAR B IDEOGRAM B158': 65702,
'LINEAR B IDEOGRAM B159 CLOTH': 65703,
'LINEAR B IDEOGRAM B160': 65704,
'LINEAR B IDEOGRAM B161': 65705,
'LINEAR B IDEOGRAM B162 GARMENT': 65706,
'LINEAR B IDEOGRAM B163 ARMOUR': 65707,
'LINEAR B IDEOGRAM B164': 65708,
'LINEAR B IDEOGRAM B165': 65709,
'LINEAR B IDEOGRAM B166': 65710,
'LINEAR B IDEOGRAM B167': 65711,
'LINEAR B IDEOGRAM B168': 65712,
'LINEAR B IDEOGRAM B169': 65713,
'LINEAR B IDEOGRAM B170': 65714,
'LINEAR B IDEOGRAM B171': 65715,
'LINEAR B IDEOGRAM B172': 65716,
'LINEAR B IDEOGRAM B173 MONTH': 65717,
'LINEAR B IDEOGRAM B174': 65718,
'LINEAR B IDEOGRAM B176 TREE': 65719,
'LINEAR B IDEOGRAM B177': 65720,
'LINEAR B IDEOGRAM B178': 65721,
'LINEAR B IDEOGRAM B179': 65722,
'LINEAR B IDEOGRAM B180': 65723,
'LINEAR B IDEOGRAM B181': 65724,
'LINEAR B IDEOGRAM B182': 65725,
'LINEAR B IDEOGRAM B183': 65726,
'LINEAR B IDEOGRAM B184': 65727,
'LINEAR B IDEOGRAM B185': 65728,
'LINEAR B IDEOGRAM B189': 65729,
'LINEAR B IDEOGRAM B190': 65730,
'LINEAR B IDEOGRAM B191 HELMET': 65731,
'LINEAR B IDEOGRAM B220 FOOTSTOOL': 65732,
'LINEAR B IDEOGRAM B225 BATHTUB': 65733,
'LINEAR B IDEOGRAM B230 SPEAR': 65734,
'LINEAR B IDEOGRAM B231 ARROW': 65735,
'LINEAR B IDEOGRAM B232': 65736,
'LINEAR B IDEOGRAM B233 SWORD': 65737,
'LINEAR B IDEOGRAM B234': 65738,
'LINEAR B IDEOGRAM B236': 65739,
'LINEAR B IDEOGRAM B240 WHEELED CHARIOT': 65740,
'LINEAR B IDEOGRAM B241 CHARIOT': 65741,
'LINEAR B IDEOGRAM B242 CHARIOT FRAME': 65742,
'LINEAR B IDEOGRAM B243 WHEEL': 65743,
'LINEAR B IDEOGRAM B245': 65744,
'LINEAR B IDEOGRAM B246': 65745,
'LINEAR B IDEOGRAM B248': 65747,
'LINEAR B IDEOGRAM B249': 65748,
'LINEAR B IDEOGRAM B251': 65749,
'LINEAR B IDEOGRAM B252': 65750,
'LINEAR B IDEOGRAM B253': 65751,
'LINEAR B IDEOGRAM B254 DART': 65752,
'LINEAR B IDEOGRAM B255': 65753,
'LINEAR B IDEOGRAM B256': 65754,
'LINEAR B IDEOGRAM B257': 65755,
'LINEAR B IDEOGRAM B258': 65756,
'LINEAR B IDEOGRAM B259': 65757,
'LINEAR B IDEOGRAM VESSEL B155': 65758,
'LINEAR B IDEOGRAM VESSEL B200': 65759,
'LINEAR B IDEOGRAM VESSEL B201': 65760,
'LINEAR B IDEOGRAM VESSEL B202': 65761,
'LINEAR B IDEOGRAM VESSEL B203': 65762,
'LINEAR B IDEOGRAM VESSEL B204': 65763,
'LINEAR B IDEOGRAM VESSEL B205': 65764,
'LINEAR B IDEOGRAM VESSEL B206': 65765,
'LINEAR B IDEOGRAM VESSEL B207': 65766,
'LINEAR B IDEOGRAM VESSEL B208': 65767,
'LINEAR B IDEOGRAM VESSEL B209': 65768,
'LINEAR B IDEOGRAM VESSEL B210': 65769,
'LINEAR B IDEOGRAM VESSEL B211': 65770,
'LINEAR B IDEOGRAM VESSEL B212': 65771,
'LINEAR B IDEOGRAM VESSEL B213': 65772,
'LINEAR B IDEOGRAM VESSEL B214': 65773,
'LINEAR B IDEOGRAM VESSEL B215': 65774,
'LINEAR B IDEOGRAM VESSEL B216': 65775,
'LINEAR B IDEOGRAM VESSEL B217': 65776,
'LINEAR B IDEOGRAM VESSEL B218': 65777,
'LINEAR B IDEOGRAM VESSEL B219': 65778,
'LINEAR B IDEOGRAM VESSEL B221': 65779,
'LINEAR B IDEOGRAM VESSEL B222': 65780,
'LINEAR B IDEOGRAM VESSEL B226': 65781,
'LINEAR B IDEOGRAM VESSEL B227': 65782,
'LINEAR B IDEOGRAM VESSEL B228': 65783,
'LINEAR B IDEOGRAM VESSEL B229': 65784,
'LINEAR B IDEOGRAM VESSEL B250': 65785,
'LINEAR B IDEOGRAM VESSEL B305': 65786,
'LINEAR B MONOGRAM B127 KAPO': 65683,
'LINEAR B MONOGRAM B128 KANAKO': 65684,
'LINEAR B MONOGRAM B133 AREPA': 65688,
'LINEAR B MONOGRAM B135 MERI': 65689,
'LINEAR B MONOGRAM B156 TURO2': 65700,
'LINEAR B MONOGRAM B247 DIPTE': 65746,
'LINEAR B SYLLABLE B001 DA': 65541,
'LINEAR B SYLLABLE B002 RO': 65579,
'LINEAR B SYLLABLE B003 PA': 65566,
'LINEAR B SYLLABLE B004 TE': 65587,
'LINEAR B SYLLABLE B005 TO': 65589,
'LINEAR B SYLLABLE B006 NA': 65561,
'LINEAR B SYLLABLE B007 DI': 65543,
'LINEAR B SYLLABLE B008 A': 65536,
'LINEAR B SYLLABLE B009 SE': 65582,
'LINEAR B SYLLABLE B010 U': 65540,
'LINEAR B SYLLABLE B011 PO': 65569,
'LINEAR B SYLLABLE B012 SO': 65584,
'LINEAR B SYLLABLE B013 ME': 65557,
'LINEAR B SYLLABLE B014 DO': 65544,
'LINEAR B SYLLABLE B015 MO': 65559,
'LINEAR B SYLLABLE B016 QA': 65571,
'LINEAR B SYLLABLE B017 ZA': 65596,
'LINEAR B SYLLABLE B020 ZO': 65599,
'LINEAR B SYLLABLE B021 QI': 65573,
'LINEAR B SYLLABLE B023 MU': 65560,
'LINEAR B SYLLABLE B024 NE': 65562,
'LINEAR B SYLLABLE B025 A2': 65600,
'LINEAR B SYLLABLE B026 RU': 65580,
'LINEAR B SYLLABLE B027 RE': 65577,
'LINEAR B SYLLABLE B028 I': 65538,
'LINEAR B SYLLABLE B029 PU2': 65606,
'LINEAR B SYLLABLE B030 NI': 65563,
'LINEAR B SYLLABLE B031 SA': 65581,
'LINEAR B SYLLABLE B032 QO': 65574,
'LINEAR B SYLLABLE B033 RA3': 65609,
'LINEAR B SYLLABLE B036 JO': 65549,
'LINEAR B SYLLABLE B037 TI': 65588,
'LINEAR B SYLLABLE B038 E': 65537,
'LINEAR B SYLLABLE B039 PI': 65568,
'LINEAR B SYLLABLE B040 WI': 65593,
'LINEAR B SYLLABLE B041 SI': 65583,
'LINEAR B SYLLABLE B042 WO': 65594,
'LINEAR B SYLLABLE B043 A3': 65601,
'LINEAR B SYLLABLE B044 KE': 65552,
'LINEAR B SYLLABLE B045 DE': 65542,
'LINEAR B SYLLABLE B046 JE': 65547,
'LINEAR B SYLLABLE B048 NWA': 65605,
'LINEAR B SYLLABLE B050 PU': 65570,
'LINEAR B SYLLABLE B051 DU': 65545,
'LINEAR B SYLLABLE B052 NO': 65564,
'LINEAR B SYLLABLE B053 RI': 65578,
'LINEAR B SYLLABLE B054 WA': 65591,
'LINEAR B SYLLABLE B055 NU': 65565,
'LINEAR B SYLLABLE B057 JA': 65546,
'LINEAR B SYLLABLE B058 SU': 65585,
'LINEAR B SYLLABLE B059 TA': 65586,
'LINEAR B SYLLABLE B060 RA': 65576,
'LINEAR B SYLLABLE B061 O': 65539,
'LINEAR B SYLLABLE B062 PTE': 65607,
'LINEAR B SYLLABLE B065 JU': 65550,
'LINEAR B SYLLABLE B066 TA2': 65611,
'LINEAR B SYLLABLE B067 KI': 65553,
'LINEAR B SYLLABLE B068 RO2': 65610,
'LINEAR B SYLLABLE B069 TU': 65590,
'LINEAR B SYLLABLE B070 KO': 65554,
'LINEAR B SYLLABLE B071 DWE': 65603,
'LINEAR B SYLLABLE B072 PE': 65567,
'LINEAR B SYLLABLE B073 MI': 65558,
'LINEAR B SYLLABLE B074 ZE': 65597,
'LINEAR B SYLLABLE B075 WE': 65592,
'LINEAR B SYLLABLE B076 RA2': 65608,
'LINEAR B SYLLABLE B077 KA': 65551,
'LINEAR B SYLLABLE B078 QE': 65572,
'LINEAR B SYLLABLE B080 MA': 65556,
'LINEAR B SYLLABLE B081 KU': 65555,
'LINEAR B SYLLABLE B085 AU': 65602,
'LINEAR B SYLLABLE B087 TWE': 65612,
'LINEAR B SYLLABLE B090 DWO': 65604,
'LINEAR B SYLLABLE B091 TWO': 65613,
'LINEAR B SYMBOL B018': 65616,
'LINEAR B SYMBOL B019': 65617,
'LINEAR B SYMBOL B022': 65618,
'LINEAR B SYMBOL B034': 65619,
'LINEAR B SYMBOL B047': 65620,
'LINEAR B SYMBOL B049': 65621,
'LINEAR B SYMBOL B056': 65622,
'LINEAR B SYMBOL B063': 65623,
'LINEAR B SYMBOL B064': 65624,
'LINEAR B SYMBOL B079': 65625,
'LINEAR B SYMBOL B082': 65626,
'LINEAR B SYMBOL B083': 65627,
'LINEAR B SYMBOL B086': 65628,
'LINEAR B SYMBOL B089': 65629,
'LIRA SIGN': 8356,
'LOGICAL AND': 8743,
'LOGICAL AND WITH DOT ABOVE': 10833,
'LOGICAL AND WITH DOUBLE OVERBAR': 10846,
'LOGICAL AND WITH DOUBLE UNDERBAR': 10848,
'LOGICAL AND WITH HORIZONTAL DASH': 10844,
'LOGICAL AND WITH MIDDLE STEM': 10842,
'LOGICAL AND WITH UNDERBAR': 10847,
'LOGICAL OR': 8744,
'LOGICAL OR OVERLAPPING LOGICAL AND': 10841,
'LOGICAL OR WITH DOT ABOVE': 10834,
'LOGICAL OR WITH DOUBLE OVERBAR': 10850,
'LOGICAL OR WITH DOUBLE UNDERBAR': 10851,
'LOGICAL OR WITH HORIZONTAL DASH': 10845,
'LOGICAL OR WITH MIDDLE STEM': 10843,
'LONG DASH FROM LEFT MEMBER OF DOUBLE VERTICAL': 10982,
'LONG LEFT RIGHT ARROW': 10231,
'LONG LEFT RIGHT DOUBLE ARROW': 10234,
'LONG LEFT TACK': 10206,
'LONG LEFTWARDS ARROW': 10229,
'LONG LEFTWARDS ARROW FROM BAR': 10235,
'LONG LEFTWARDS DOUBLE ARROW': 10232,
'LONG LEFTWARDS DOUBLE ARROW FROM BAR': 10237,
'LONG RIGHT TACK': 10205,
'LONG RIGHTWARDS ARROW': 10230,
'LONG RIGHTWARDS ARROW FROM BAR': 10236,
'LONG RIGHTWARDS DOUBLE ARROW': 10233,
'LONG RIGHTWARDS DOUBLE ARROW FROM BAR': 10238,
'LONG RIGHTWARDS SQUIGGLE ARROW': 10239,
'LOW ASTERISK': 8270,
'LOW DOUBLE PRIME QUOTATION MARK': 12319,
'LOW LINE': 95,
'LOWER BLADE SCISSORS': 9987,
'LOWER FIVE EIGHTHS BLOCK': 9605,
'LOWER HALF BLOCK': 9604,
'LOWER HALF CIRCLE': 9697,
'LOWER HALF INVERSE WHITE CIRCLE': 9691,
'LOWER LEFT QUADRANT CIRCULAR ARC': 9695,
'LOWER LEFT SEMICIRCULAR ANTICLOCKWISE ARROW': 10559,
'LOWER LEFT TRIANGLE': 9722,
'LOWER ONE EIGHTH BLOCK': 9601,
'LOWER ONE QUARTER BLOCK': 9602,
'LOWER RIGHT CORNER WITH DOT': 10195,
'LOWER RIGHT DROP-SHADOWED WHITE SQUARE': 10063,
'LOWER RIGHT PENCIL': 9998,
'LOWER RIGHT QUADRANT CIRCULAR ARC': 9694,
'LOWER RIGHT SEMICIRCULAR CLOCKWISE ARROW': 10558,
'LOWER RIGHT SHADOWED WHITE SQUARE': 10065,
'LOWER RIGHT TRIANGLE': 9727,
'LOWER SEVEN EIGHTHS BLOCK': 9607,
'LOWER THREE EIGHTHS BLOCK': 9603,
'LOWER THREE QUARTERS BLOCK': 9606,
'LOZENGE': 9674,
'LOZENGE DIVIDED BY HORIZONTAL RULE': 10208,
'MACRON': 175,
'MALAYALAM AU LENGTH MARK': 3415,
'MALAYALAM DIGIT EIGHT': 3438,
'MALAYALAM DIGIT FIVE': 3435,
'MALAYALAM DIGIT FOUR': 3434,
'MALAYALAM DIGIT NINE': 3439,
'MALAYALAM DIGIT ONE': 3431,
'MALAYALAM DIGIT SEVEN': 3437,
'MALAYALAM DIGIT SIX': 3436,
'MALAYALAM DIGIT THREE': 3433,
'MALAYALAM DIGIT TWO': 3432,
'MALAYALAM DIGIT ZERO': 3430,
'MALAYALAM LETTER A': 3333,
'MALAYALAM LETTER AA': 3334,
'MALAYALAM LETTER AI': 3344,
'MALAYALAM LETTER AU': 3348,
'MALAYALAM LETTER BA': 3372,
'MALAYALAM LETTER BHA': 3373,
'MALAYALAM LETTER CA': 3354,
'MALAYALAM LETTER CHA': 3355,
'MALAYALAM LETTER DA': 3366,
'MALAYALAM LETTER DDA': 3361,
'MALAYALAM LETTER DDHA': 3362,
'MALAYALAM LETTER DHA': 3367,
'MALAYALAM LETTER E': 3342,
'MALAYALAM LETTER EE': 3343,
'MALAYALAM LETTER GA': 3351,
'MALAYALAM LETTER GHA': 3352,
'MALAYALAM LETTER HA': 3385,
'MALAYALAM LETTER I': 3335,
'MALAYALAM LETTER II': 3336,
'MALAYALAM LETTER JA': 3356,
'MALAYALAM LETTER JHA': 3357,
'MALAYALAM LETTER KA': 3349,
'MALAYALAM LETTER KHA': 3350,
'MALAYALAM LETTER LA': 3378,
'MALAYALAM LETTER LLA': 3379,
'MALAYALAM LETTER LLLA': 3380,
'MALAYALAM LETTER MA': 3374,
'MALAYALAM LETTER NA': 3368,
'MALAYALAM LETTER NGA': 3353,
'MALAYALAM LETTER NNA': 3363,
'MALAYALAM LETTER NYA': 3358,
'MALAYALAM LETTER O': 3346,
'MALAYALAM LETTER OO': 3347,
'MALAYALAM LETTER PA': 3370,
'MALAYALAM LETTER PHA': 3371,
'MALAYALAM LETTER RA': 3376,
'MALAYALAM LETTER RRA': 3377,
'MALAYALAM LETTER SA': 3384,
'MALAYALAM LETTER SHA': 3382,
'MALAYALAM LETTER SSA': 3383,
'MALAYALAM LETTER TA': 3364,
'MALAYALAM LETTER THA': 3365,
'MALAYALAM LETTER TTA': 3359,
'MALAYALAM LETTER TTHA': 3360,
'MALAYALAM LETTER U': 3337,
'MALAYALAM LETTER UU': 3338,
'MALAYALAM LETTER VA': 3381,
'MALAYALAM LETTER VOCALIC L': 3340,
'MALAYALAM LETTER VOCALIC LL': 3425,
'MALAYALAM LETTER VOCALIC R': 3339,
'MALAYALAM LETTER VOCALIC RR': 3424,
'MALAYALAM LETTER YA': 3375,
'MALAYALAM SIGN ANUSVARA': 3330,
'MALAYALAM SIGN VIRAMA': 3405,
'MALAYALAM SIGN VISARGA': 3331,
'MALAYALAM VOWEL SIGN AA': 3390,
'MALAYALAM VOWEL SIGN AI': 3400,
'MALAYALAM VOWEL SIGN AU': 3404,
'MALAYALAM VOWEL SIGN E': 3398,
'MALAYALAM VOWEL SIGN EE': 3399,
'MALAYALAM VOWEL SIGN I': 3391,
'MALAYALAM VOWEL SIGN II': 3392,
'MALAYALAM VOWEL SIGN O': 3402,
'MALAYALAM VOWEL SIGN OO': 3403,
'MALAYALAM VOWEL SIGN U': 3393,
'MALAYALAM VOWEL SIGN UU': 3394,
'MALAYALAM VOWEL SIGN VOCALIC R': 3395,
'MALE AND FEMALE SIGN': 9893,
'MALE SIGN': 9794,
'MALE WITH STROKE AND MALE AND FEMALE SIGN': 9895,
'MALE WITH STROKE SIGN': 9894,
'MALTESE CROSS': 10016,
'MARRIAGE SYMBOL': 9901,
'MASCULINE ORDINAL INDICATOR': 186,
'MASU MARK': 12348,
'MATHEMATICAL BOLD CAPITAL A': 119808,
'MATHEMATICAL BOLD CAPITAL ALPHA': 120488,
'MATHEMATICAL BOLD CAPITAL B': 119809,
'MATHEMATICAL BOLD CAPITAL BETA': 120489,
'MATHEMATICAL BOLD CAPITAL C': 119810,
'MATHEMATICAL BOLD CAPITAL CHI': 120510,
'MATHEMATICAL BOLD CAPITAL D': 119811,
'MATHEMATICAL BOLD CAPITAL DELTA': 120491,
'MATHEMATICAL BOLD CAPITAL E': 119812,
'MATHEMATICAL BOLD CAPITAL EPSILON': 120492,
'MATHEMATICAL BOLD CAPITAL ETA': 120494,
'MATHEMATICAL BOLD CAPITAL F': 119813,
'MATHEMATICAL BOLD CAPITAL G': 119814,
'MATHEMATICAL BOLD CAPITAL GAMMA': 120490,
'MATHEMATICAL BOLD CAPITAL H': 119815,
'MATHEMATICAL BOLD CAPITAL I': 119816,
'MATHEMATICAL BOLD CAPITAL IOTA': 120496,
'MATHEMATICAL BOLD CAPITAL J': 119817,
'MATHEMATICAL BOLD CAPITAL K': 119818,
'MATHEMATICAL BOLD CAPITAL KAPPA': 120497,
'MATHEMATICAL BOLD CAPITAL L': 119819,
'MATHEMATICAL BOLD CAPITAL LAMDA': 120498,
'MATHEMATICAL BOLD CAPITAL M': 119820,
'MATHEMATICAL BOLD CAPITAL MU': 120499,
'MATHEMATICAL BOLD CAPITAL N': 119821,
'MATHEMATICAL BOLD CAPITAL NU': 120500,
'MATHEMATICAL BOLD CAPITAL O': 119822,
'MATHEMATICAL BOLD CAPITAL OMEGA': 120512,
'MATHEMATICAL BOLD CAPITAL OMICRON': 120502,
'MATHEMATICAL BOLD CAPITAL P': 119823,
'MATHEMATICAL BOLD CAPITAL PHI': 120509,
'MATHEMATICAL BOLD CAPITAL PI': 120503,
'MATHEMATICAL BOLD CAPITAL PSI': 120511,
'MATHEMATICAL BOLD CAPITAL Q': 119824,
'MATHEMATICAL BOLD CAPITAL R': 119825,
'MATHEMATICAL BOLD CAPITAL RHO': 120504,
'MATHEMATICAL BOLD CAPITAL S': 119826,
'MATHEMATICAL BOLD CAPITAL SIGMA': 120506,
'MATHEMATICAL BOLD CAPITAL T': 119827,
'MATHEMATICAL BOLD CAPITAL TAU': 120507,
'MATHEMATICAL BOLD CAPITAL THETA': 120495,
'MATHEMATICAL BOLD CAPITAL THETA SYMBOL': 120505,
'MATHEMATICAL BOLD CAPITAL U': 119828,
'MATHEMATICAL BOLD CAPITAL UPSILON': 120508,
'MATHEMATICAL BOLD CAPITAL V': 119829,
'MATHEMATICAL BOLD CAPITAL W': 119830,
'MATHEMATICAL BOLD CAPITAL X': 119831,
'MATHEMATICAL BOLD CAPITAL XI': 120501,
'MATHEMATICAL BOLD CAPITAL Y': 119832,
'MATHEMATICAL BOLD CAPITAL Z': 119833,
'MATHEMATICAL BOLD CAPITAL ZETA': 120493,
'MATHEMATICAL BOLD DIGIT EIGHT': 120790,
'MATHEMATICAL BOLD DIGIT FIVE': 120787,
'MATHEMATICAL BOLD DIGIT FOUR': 120786,
'MATHEMATICAL BOLD DIGIT NINE': 120791,
'MATHEMATICAL BOLD DIGIT ONE': 120783,
'MATHEMATICAL BOLD DIGIT SEVEN': 120789,
'MATHEMATICAL BOLD DIGIT SIX': 120788,
'MATHEMATICAL BOLD DIGIT THREE': 120785,
'MATHEMATICAL BOLD DIGIT TWO': 120784,
'MATHEMATICAL BOLD DIGIT ZERO': 120782,
'MATHEMATICAL BOLD EPSILON SYMBOL': 120540,
'MATHEMATICAL BOLD FRAKTUR CAPITAL A': 120172,
'MATHEMATICAL BOLD FRAKTUR CAPITAL B': 120173,
'MATHEMATICAL BOLD FRAKTUR CAPITAL C': 120174,
'MATHEMATICAL BOLD FRAKTUR CAPITAL D': 120175,
'MATHEMATICAL BOLD FRAKTUR CAPITAL E': 120176,
'MATHEMATICAL BOLD FRAKTUR CAPITAL F': 120177,
'MATHEMATICAL BOLD FRAKTUR CAPITAL G': 120178,
'MATHEMATICAL BOLD FRAKTUR CAPITAL H': 120179,
'MATHEMATICAL BOLD FRAKTUR CAPITAL I': 120180,
'MATHEMATICAL BOLD FRAKTUR CAPITAL J': 120181,
'MATHEMATICAL BOLD FRAKTUR CAPITAL K': 120182,
'MATHEMATICAL BOLD FRAKTUR CAPITAL L': 120183,
'MATHEMATICAL BOLD FRAKTUR CAPITAL M': 120184,
'MATHEMATICAL BOLD FRAKTUR CAPITAL N': 120185,
'MATHEMATICAL BOLD FRAKTUR CAPITAL O': 120186,
'MATHEMATICAL BOLD FRAKTUR CAPITAL P': 120187,
'MATHEMATICAL BOLD FRAKTUR CAPITAL Q': 120188,
'MATHEMATICAL BOLD FRAKTUR CAPITAL R': 120189,
'MATHEMATICAL BOLD FRAKTUR CAPITAL S': 120190,
'MATHEMATICAL BOLD FRAKTUR CAPITAL T': 120191,
'MATHEMATICAL BOLD FRAKTUR CAPITAL U': 120192,
'MATHEMATICAL BOLD FRAKTUR CAPITAL V': 120193,
'MATHEMATICAL BOLD FRAKTUR CAPITAL W': 120194,
'MATHEMATICAL BOLD FRAKTUR CAPITAL X': 120195,
'MATHEMATICAL BOLD FRAKTUR CAPITAL Y': 120196,
'MATHEMATICAL BOLD FRAKTUR CAPITAL Z': 120197,
'MATHEMATICAL BOLD FRAKTUR SMALL A': 120198,
'MATHEMATICAL BOLD FRAKTUR SMALL B': 120199,
'MATHEMATICAL BOLD FRAKTUR SMALL C': 120200,
'MATHEMATICAL BOLD FRAKTUR SMALL D': 120201,
'MATHEMATICAL BOLD FRAKTUR SMALL E': 120202,
'MATHEMATICAL BOLD FRAKTUR SMALL F': 120203,
'MATHEMATICAL BOLD FRAKTUR SMALL G': 120204,
'MATHEMATICAL BOLD FRAKTUR SMALL H': 120205,
'MATHEMATICAL BOLD FRAKTUR SMALL I': 120206,
'MATHEMATICAL BOLD FRAKTUR SMALL J': 120207,
'MATHEMATICAL BOLD FRAKTUR SMALL K': 120208,
'MATHEMATICAL BOLD FRAKTUR SMALL L': 120209,
'MATHEMATICAL BOLD FRAKTUR SMALL M': 120210,
'MATHEMATICAL BOLD FRAKTUR SMALL N': 120211,
'MATHEMATICAL BOLD FRAKTUR SMALL O': 120212,
'MATHEMATICAL BOLD FRAKTUR SMALL P': 120213,
'MATHEMATICAL BOLD FRAKTUR SMALL Q': 120214,
'MATHEMATICAL BOLD FRAKTUR SMALL R': 120215,
'MATHEMATICAL BOLD FRAKTUR SMALL S': 120216,
'MATHEMATICAL BOLD FRAKTUR SMALL T': 120217,
'MATHEMATICAL BOLD FRAKTUR SMALL U': 120218,
'MATHEMATICAL BOLD FRAKTUR SMALL V': 120219,
'MATHEMATICAL BOLD FRAKTUR SMALL W': 120220,
'MATHEMATICAL BOLD FRAKTUR SMALL X': 120221,
'MATHEMATICAL BOLD FRAKTUR SMALL Y': 120222,
'MATHEMATICAL BOLD FRAKTUR SMALL Z': 120223,
'MATHEMATICAL BOLD ITALIC CAPITAL A': 119912,
'MATHEMATICAL BOLD ITALIC CAPITAL ALPHA': 120604,
'MATHEMATICAL BOLD ITALIC CAPITAL B': 119913,
'MATHEMATICAL BOLD ITALIC CAPITAL BETA': 120605,
'MATHEMATICAL BOLD ITALIC CAPITAL C': 119914,
'MATHEMATICAL BOLD ITALIC CAPITAL CHI': 120626,
'MATHEMATICAL BOLD ITALIC CAPITAL D': 119915,
'MATHEMATICAL BOLD ITALIC CAPITAL DELTA': 120607,
'MATHEMATICAL BOLD ITALIC CAPITAL E': 119916,
'MATHEMATICAL BOLD ITALIC CAPITAL EPSILON': 120608,
'MATHEMATICAL BOLD ITALIC CAPITAL ETA': 120610,
'MATHEMATICAL BOLD ITALIC CAPITAL F': 119917,
'MATHEMATICAL BOLD ITALIC CAPITAL G': 119918,
'MATHEMATICAL BOLD ITALIC CAPITAL GAMMA': 120606,
'MATHEMATICAL BOLD ITALIC CAPITAL H': 119919,
'MATHEMATICAL BOLD ITALIC CAPITAL I': 119920,
'MATHEMATICAL BOLD ITALIC CAPITAL IOTA': 120612,
'MATHEMATICAL BOLD ITALIC CAPITAL J': 119921,
'MATHEMATICAL BOLD ITALIC CAPITAL K': 119922,
'MATHEMATICAL BOLD ITALIC CAPITAL KAPPA': 120613,
'MATHEMATICAL BOLD ITALIC CAPITAL L': 119923,
'MATHEMATICAL BOLD ITALIC CAPITAL LAMDA': 120614,
'MATHEMATICAL BOLD ITALIC CAPITAL M': 119924,
'MATHEMATICAL BOLD ITALIC CAPITAL MU': 120615,
'MATHEMATICAL BOLD ITALIC CAPITAL N': 119925,
'MATHEMATICAL BOLD ITALIC CAPITAL NU': 120616,
'MATHEMATICAL BOLD ITALIC CAPITAL O': 119926,
'MATHEMATICAL BOLD ITALIC CAPITAL OMEGA': 120628,
'MATHEMATICAL BOLD ITALIC CAPITAL OMICRON': 120618,
'MATHEMATICAL BOLD ITALIC CAPITAL P': 119927,
'MATHEMATICAL BOLD ITALIC CAPITAL PHI': 120625,
'MATHEMATICAL BOLD ITALIC CAPITAL PI': 120619,
'MATHEMATICAL BOLD ITALIC CAPITAL PSI': 120627,
'MATHEMATICAL BOLD ITALIC CAPITAL Q': 119928,
'MATHEMATICAL BOLD ITALIC CAPITAL R': 119929,
'MATHEMATICAL BOLD ITALIC CAPITAL RHO': 120620,
'MATHEMATICAL BOLD ITALIC CAPITAL S': 119930,
'MATHEMATICAL BOLD ITALIC CAPITAL SIGMA': 120622,
'MATHEMATICAL BOLD ITALIC CAPITAL T': 119931,
'MATHEMATICAL BOLD ITALIC CAPITAL TAU': 120623,
'MATHEMATICAL BOLD ITALIC CAPITAL THETA': 120611,
'MATHEMATICAL BOLD ITALIC CAPITAL THETA SYMBOL': 120621,
'MATHEMATICAL BOLD ITALIC CAPITAL U': 119932,
'MATHEMATICAL BOLD ITALIC CAPITAL UPSILON': 120624,
'MATHEMATICAL BOLD ITALIC CAPITAL V': 119933,
'MATHEMATICAL BOLD ITALIC CAPITAL W': 119934,
'MATHEMATICAL BOLD ITALIC CAPITAL X': 119935,
'MATHEMATICAL BOLD ITALIC CAPITAL XI': 120617,
'MATHEMATICAL BOLD ITALIC CAPITAL Y': 119936,
'MATHEMATICAL BOLD ITALIC CAPITAL Z': 119937,
'MATHEMATICAL BOLD ITALIC CAPITAL ZETA': 120609,
'MATHEMATICAL BOLD ITALIC EPSILON SYMBOL': 120656,
'MATHEMATICAL BOLD ITALIC KAPPA SYMBOL': 120658,
'MATHEMATICAL BOLD ITALIC NABLA': 120629,
'MATHEMATICAL BOLD ITALIC PARTIAL DIFFERENTIAL': 120655,
'MATHEMATICAL BOLD ITALIC PHI SYMBOL': 120659,
'MATHEMATICAL BOLD ITALIC PI SYMBOL': 120661,
'MATHEMATICAL BOLD ITALIC RHO SYMBOL': 120660,
'MATHEMATICAL BOLD ITALIC SMALL A': 119938,
'MATHEMATICAL BOLD ITALIC SMALL ALPHA': 120630,
'MATHEMATICAL BOLD ITALIC SMALL B': 119939,
'MATHEMATICAL BOLD ITALIC SMALL BETA': 120631,
'MATHEMATICAL BOLD ITALIC SMALL C': 119940,
'MATHEMATICAL BOLD ITALIC SMALL CHI': 120652,
'MATHEMATICAL BOLD ITALIC SMALL D': 119941,
'MATHEMATICAL BOLD ITALIC SMALL DELTA': 120633,
'MATHEMATICAL BOLD ITALIC SMALL E': 119942,
'MATHEMATICAL BOLD ITALIC SMALL EPSILON': 120634,
'MATHEMATICAL BOLD ITALIC SMALL ETA': 120636,
'MATHEMATICAL BOLD ITALIC SMALL F': 119943,
'MATHEMATICAL BOLD ITALIC SMALL FINAL SIGMA': 120647,
'MATHEMATICAL BOLD ITALIC SMALL G': 119944,
'MATHEMATICAL BOLD ITALIC SMALL GAMMA': 120632,
'MATHEMATICAL BOLD ITALIC SMALL H': 119945,
'MATHEMATICAL BOLD ITALIC SMALL I': 119946,
'MATHEMATICAL BOLD ITALIC SMALL IOTA': 120638,
'MATHEMATICAL BOLD ITALIC SMALL J': 119947,
'MATHEMATICAL BOLD ITALIC SMALL K': 119948,
'MATHEMATICAL BOLD ITALIC SMALL KAPPA': 120639,
'MATHEMATICAL BOLD ITALIC SMALL L': 119949,
'MATHEMATICAL BOLD ITALIC SMALL LAMDA': 120640,
'MATHEMATICAL BOLD ITALIC SMALL M': 119950,
'MATHEMATICAL BOLD ITALIC SMALL MU': 120641,
'MATHEMATICAL BOLD ITALIC SMALL N': 119951,
'MATHEMATICAL BOLD ITALIC SMALL NU': 120642,
'MATHEMATICAL BOLD ITALIC SMALL O': 119952,
'MATHEMATICAL BOLD ITALIC SMALL OMEGA': 120654,
'MATHEMATICAL BOLD ITALIC SMALL OMICRON': 120644,
'MATHEMATICAL BOLD ITALIC SMALL P': 119953,
'MATHEMATICAL BOLD ITALIC SMALL PHI': 120651,
'MATHEMATICAL BOLD ITALIC SMALL PI': 120645,
'MATHEMATICAL BOLD ITALIC SMALL PSI': 120653,
'MATHEMATICAL BOLD ITALIC SMALL Q': 119954,
'MATHEMATICAL BOLD ITALIC SMALL R': 119955,
'MATHEMATICAL BOLD ITALIC SMALL RHO': 120646,
'MATHEMATICAL BOLD ITALIC SMALL S': 119956,
'MATHEMATICAL BOLD ITALIC SMALL SIGMA': 120648,
'MATHEMATICAL BOLD ITALIC SMALL T': 119957,
'MATHEMATICAL BOLD ITALIC SMALL TAU': 120649,
'MATHEMATICAL BOLD ITALIC SMALL THETA': 120637,
'MATHEMATICAL BOLD ITALIC SMALL U': 119958,
'MATHEMATICAL BOLD ITALIC SMALL UPSILON': 120650,
'MATHEMATICAL BOLD ITALIC SMALL V': 119959,
'MATHEMATICAL BOLD ITALIC SMALL W': 119960,
'MATHEMATICAL BOLD ITALIC SMALL X': 119961,
'MATHEMATICAL BOLD ITALIC SMALL XI': 120643,
'MATHEMATICAL BOLD ITALIC SMALL Y': 119962,
'MATHEMATICAL BOLD ITALIC SMALL Z': 119963,
'MATHEMATICAL BOLD ITALIC SMALL ZETA': 120635,
'MATHEMATICAL BOLD ITALIC THETA SYMBOL': 120657,
'MATHEMATICAL BOLD KAPPA SYMBOL': 120542,
'MATHEMATICAL BOLD NABLA': 120513,
'MATHEMATICAL BOLD PARTIAL DIFFERENTIAL': 120539,
'MATHEMATICAL BOLD PHI SYMBOL': 120543,
'MATHEMATICAL BOLD PI SYMBOL': 120545,
'MATHEMATICAL BOLD RHO SYMBOL': 120544,
'MATHEMATICAL BOLD SCRIPT CAPITAL A': 120016,
'MATHEMATICAL BOLD SCRIPT CAPITAL B': 120017,
'MATHEMATICAL BOLD SCRIPT CAPITAL C': 120018,
'MATHEMATICAL BOLD SCRIPT CAPITAL D': 120019,
'MATHEMATICAL BOLD SCRIPT CAPITAL E': 120020,
'MATHEMATICAL BOLD SCRIPT CAPITAL F': 120021,
'MATHEMATICAL BOLD SCRIPT CAPITAL G': 120022,
'MATHEMATICAL BOLD SCRIPT CAPITAL H': 120023,
'MATHEMATICAL BOLD SCRIPT CAPITAL I': 120024,
'MATHEMATICAL BOLD SCRIPT CAPITAL J': 120025,
'MATHEMATICAL BOLD SCRIPT CAPITAL K': 120026,
'MATHEMATICAL BOLD SCRIPT CAPITAL L': 120027,
'MATHEMATICAL BOLD SCRIPT CAPITAL M': 120028,
'MATHEMATICAL BOLD SCRIPT CAPITAL N': 120029,
'MATHEMATICAL BOLD SCRIPT CAPITAL O': 120030,
'MATHEMATICAL BOLD SCRIPT CAPITAL P': 120031,
'MATHEMATICAL BOLD SCRIPT CAPITAL Q': 120032,
'MATHEMATICAL BOLD SCRIPT CAPITAL R': 120033,
'MATHEMATICAL BOLD SCRIPT CAPITAL S': 120034,
'MATHEMATICAL BOLD SCRIPT CAPITAL T': 120035,
'MATHEMATICAL BOLD SCRIPT CAPITAL U': 120036,
'MATHEMATICAL BOLD SCRIPT CAPITAL V': 120037,
'MATHEMATICAL BOLD SCRIPT CAPITAL W': 120038,
'MATHEMATICAL BOLD SCRIPT CAPITAL X': 120039,
'MATHEMATICAL BOLD SCRIPT CAPITAL Y': 120040,
'MATHEMATICAL BOLD SCRIPT CAPITAL Z': 120041,
'MATHEMATICAL BOLD SCRIPT SMALL A': 120042,
'MATHEMATICAL BOLD SCRIPT SMALL B': 120043,
'MATHEMATICAL BOLD SCRIPT SMALL C': 120044,
'MATHEMATICAL BOLD SCRIPT SMALL D': 120045,
'MATHEMATICAL BOLD SCRIPT SMALL E': 120046,
'MATHEMATICAL BOLD SCRIPT SMALL F': 120047,
'MATHEMATICAL BOLD SCRIPT SMALL G': 120048,
'MATHEMATICAL BOLD SCRIPT SMALL H': 120049,
'MATHEMATICAL BOLD SCRIPT SMALL I': 120050,
'MATHEMATICAL BOLD SCRIPT SMALL J': 120051,
'MATHEMATICAL BOLD SCRIPT SMALL K': 120052,
'MATHEMATICAL BOLD SCRIPT SMALL L': 120053,
'MATHEMATICAL BOLD SCRIPT SMALL M': 120054,
'MATHEMATICAL BOLD SCRIPT SMALL N': 120055,
'MATHEMATICAL BOLD SCRIPT SMALL O': 120056,
'MATHEMATICAL BOLD SCRIPT SMALL P': 120057,
'MATHEMATICAL BOLD SCRIPT SMALL Q': 120058,
'MATHEMATICAL BOLD SCRIPT SMALL R': 120059,
'MATHEMATICAL BOLD SCRIPT SMALL S': 120060,
'MATHEMATICAL BOLD SCRIPT SMALL T': 120061,
'MATHEMATICAL BOLD SCRIPT SMALL U': 120062,
'MATHEMATICAL BOLD SCRIPT SMALL V': 120063,
'MATHEMATICAL BOLD SCRIPT SMALL W': 120064,
'MATHEMATICAL BOLD SCRIPT SMALL X': 120065,
'MATHEMATICAL BOLD SCRIPT SMALL Y': 120066,
'MATHEMATICAL BOLD SCRIPT SMALL Z': 120067,
'MATHEMATICAL BOLD SMALL A': 119834,
'MATHEMATICAL BOLD SMALL ALPHA': 120514,
'MATHEMATICAL BOLD SMALL B': 119835,
'MATHEMATICAL BOLD SMALL BETA': 120515,
'MATHEMATICAL BOLD SMALL C': 119836,
'MATHEMATICAL BOLD SMALL CHI': 120536,
'MATHEMATICAL BOLD SMALL D': 119837,
'MATHEMATICAL BOLD SMALL DELTA': 120517,
'MATHEMATICAL BOLD SMALL E': 119838,
'MATHEMATICAL BOLD SMALL EPSILON': 120518,
'MATHEMATICAL BOLD SMALL ETA': 120520,
'MATHEMATICAL BOLD SMALL F': 119839,
'MATHEMATICAL BOLD SMALL FINAL SIGMA': 120531,
'MATHEMATICAL BOLD SMALL G': 119840,
'MATHEMATICAL BOLD SMALL GAMMA': 120516,
'MATHEMATICAL BOLD SMALL H': 119841,
'MATHEMATICAL BOLD SMALL I': 119842,
'MATHEMATICAL BOLD SMALL IOTA': 120522,
'MATHEMATICAL BOLD SMALL J': 119843,
'MATHEMATICAL BOLD SMALL K': 119844,
'MATHEMATICAL BOLD SMALL KAPPA': 120523,
'MATHEMATICAL BOLD SMALL L': 119845,
'MATHEMATICAL BOLD SMALL LAMDA': 120524,
'MATHEMATICAL BOLD SMALL M': 119846,
'MATHEMATICAL BOLD SMALL MU': 120525,
'MATHEMATICAL BOLD SMALL N': 119847,
'MATHEMATICAL BOLD SMALL NU': 120526,
'MATHEMATICAL BOLD SMALL O': 119848,
'MATHEMATICAL BOLD SMALL OMEGA': 120538,
'MATHEMATICAL BOLD SMALL OMICRON': 120528,
'MATHEMATICAL BOLD SMALL P': 119849,
'MATHEMATICAL BOLD SMALL PHI': 120535,
'MATHEMATICAL BOLD SMALL PI': 120529,
'MATHEMATICAL BOLD SMALL PSI': 120537,
'MATHEMATICAL BOLD SMALL Q': 119850,
'MATHEMATICAL BOLD SMALL R': 119851,
'MATHEMATICAL BOLD SMALL RHO': 120530,
'MATHEMATICAL BOLD SMALL S': 119852,
'MATHEMATICAL BOLD SMALL SIGMA': 120532,
'MATHEMATICAL BOLD SMALL T': 119853,
'MATHEMATICAL BOLD SMALL TAU': 120533,
'MATHEMATICAL BOLD SMALL THETA': 120521,
'MATHEMATICAL BOLD SMALL U': 119854,
'MATHEMATICAL BOLD SMALL UPSILON': 120534,
'MATHEMATICAL BOLD SMALL V': 119855,
'MATHEMATICAL BOLD SMALL W': 119856,
'MATHEMATICAL BOLD SMALL X': 119857,
'MATHEMATICAL BOLD SMALL XI': 120527,
'MATHEMATICAL BOLD SMALL Y': 119858,
'MATHEMATICAL BOLD SMALL Z': 119859,
'MATHEMATICAL BOLD SMALL ZETA': 120519,
'MATHEMATICAL BOLD THETA SYMBOL': 120541,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL A': 120120,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL B': 120121,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL D': 120123,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL E': 120124,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL F': 120125,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL G': 120126,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL I': 120128,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL J': 120129,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL K': 120130,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL L': 120131,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL M': 120132,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL O': 120134,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL S': 120138,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL T': 120139,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL U': 120140,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL V': 120141,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL W': 120142,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL X': 120143,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL Y': 120144,
'MATHEMATICAL DOUBLE-STRUCK DIGIT EIGHT': 120800,
'MATHEMATICAL DOUBLE-STRUCK DIGIT FIVE': 120797,
'MATHEMATICAL DOUBLE-STRUCK DIGIT FOUR': 120796,
'MATHEMATICAL DOUBLE-STRUCK DIGIT NINE': 120801,
'MATHEMATICAL DOUBLE-STRUCK DIGIT ONE': 120793,
'MATHEMATICAL DOUBLE-STRUCK DIGIT SEVEN': 120799,
'MATHEMATICAL DOUBLE-STRUCK DIGIT SIX': 120798,
'MATHEMATICAL DOUBLE-STRUCK DIGIT THREE': 120795,
'MATHEMATICAL DOUBLE-STRUCK DIGIT TWO': 120794,
'MATHEMATICAL DOUBLE-STRUCK DIGIT ZERO': 120792,
'MATHEMATICAL DOUBLE-STRUCK SMALL A': 120146,
'MATHEMATICAL DOUBLE-STRUCK SMALL B': 120147,
'MATHEMATICAL DOUBLE-STRUCK SMALL C': 120148,
'MATHEMATICAL DOUBLE-STRUCK SMALL D': 120149,
'MATHEMATICAL DOUBLE-STRUCK SMALL E': 120150,
'MATHEMATICAL DOUBLE-STRUCK SMALL F': 120151,
'MATHEMATICAL DOUBLE-STRUCK SMALL G': 120152,
'MATHEMATICAL DOUBLE-STRUCK SMALL H': 120153,
'MATHEMATICAL DOUBLE-STRUCK SMALL I': 120154,
'MATHEMATICAL DOUBLE-STRUCK SMALL J': 120155,
'MATHEMATICAL DOUBLE-STRUCK SMALL K': 120156,
'MATHEMATICAL DOUBLE-STRUCK SMALL L': 120157,
'MATHEMATICAL DOUBLE-STRUCK SMALL M': 120158,
'MATHEMATICAL DOUBLE-STRUCK SMALL N': 120159,
'MATHEMATICAL DOUBLE-STRUCK SMALL O': 120160,
'MATHEMATICAL DOUBLE-STRUCK SMALL P': 120161,
'MATHEMATICAL DOUBLE-STRUCK SMALL Q': 120162,
'MATHEMATICAL DOUBLE-STRUCK SMALL R': 120163,
'MATHEMATICAL DOUBLE-STRUCK SMALL S': 120164,
'MATHEMATICAL DOUBLE-STRUCK SMALL T': 120165,
'MATHEMATICAL DOUBLE-STRUCK SMALL U': 120166,
'MATHEMATICAL DOUBLE-STRUCK SMALL V': 120167,
'MATHEMATICAL DOUBLE-STRUCK SMALL W': 120168,
'MATHEMATICAL DOUBLE-STRUCK SMALL X': 120169,
'MATHEMATICAL DOUBLE-STRUCK SMALL Y': 120170,
'MATHEMATICAL DOUBLE-STRUCK SMALL Z': 120171,
'MATHEMATICAL FRAKTUR CAPITAL A': 120068,
'MATHEMATICAL FRAKTUR CAPITAL B': 120069,
'MATHEMATICAL FRAKTUR CAPITAL D': 120071,
'MATHEMATICAL FRAKTUR CAPITAL E': 120072,
'MATHEMATICAL FRAKTUR CAPITAL F': 120073,
'MATHEMATICAL FRAKTUR CAPITAL G': 120074,
'MATHEMATICAL FRAKTUR CAPITAL J': 120077,
'MATHEMATICAL FRAKTUR CAPITAL K': 120078,
'MATHEMATICAL FRAKTUR CAPITAL L': 120079,
'MATHEMATICAL FRAKTUR CAPITAL M': 120080,
'MATHEMATICAL FRAKTUR CAPITAL N': 120081,
'MATHEMATICAL FRAKTUR CAPITAL O': 120082,
'MATHEMATICAL FRAKTUR CAPITAL P': 120083,
'MATHEMATICAL FRAKTUR CAPITAL Q': 120084,
'MATHEMATICAL FRAKTUR CAPITAL S': 120086,
'MATHEMATICAL FRAKTUR CAPITAL T': 120087,
'MATHEMATICAL FRAKTUR CAPITAL U': 120088,
'MATHEMATICAL FRAKTUR CAPITAL V': 120089,
'MATHEMATICAL FRAKTUR CAPITAL W': 120090,
'MATHEMATICAL FRAKTUR CAPITAL X': 120091,
'MATHEMATICAL FRAKTUR CAPITAL Y': 120092,
'MATHEMATICAL FRAKTUR SMALL A': 120094,
'MATHEMATICAL FRAKTUR SMALL B': 120095,
'MATHEMATICAL FRAKTUR SMALL C': 120096,
'MATHEMATICAL FRAKTUR SMALL D': 120097,
'MATHEMATICAL FRAKTUR SMALL E': 120098,
'MATHEMATICAL FRAKTUR SMALL F': 120099,
'MATHEMATICAL FRAKTUR SMALL G': 120100,
'MATHEMATICAL FRAKTUR SMALL H': 120101,
'MATHEMATICAL FRAKTUR SMALL I': 120102,
'MATHEMATICAL FRAKTUR SMALL J': 120103,
'MATHEMATICAL FRAKTUR SMALL K': 120104,
'MATHEMATICAL FRAKTUR SMALL L': 120105,
'MATHEMATICAL FRAKTUR SMALL M': 120106,
'MATHEMATICAL FRAKTUR SMALL N': 120107,
'MATHEMATICAL FRAKTUR SMALL O': 120108,
'MATHEMATICAL FRAKTUR SMALL P': 120109,
'MATHEMATICAL FRAKTUR SMALL Q': 120110,
'MATHEMATICAL FRAKTUR SMALL R': 120111,
'MATHEMATICAL FRAKTUR SMALL S': 120112,
'MATHEMATICAL FRAKTUR SMALL T': 120113,
'MATHEMATICAL FRAKTUR SMALL U': 120114,
'MATHEMATICAL FRAKTUR SMALL V': 120115,
'MATHEMATICAL FRAKTUR SMALL W': 120116,
'MATHEMATICAL FRAKTUR SMALL X': 120117,
'MATHEMATICAL FRAKTUR SMALL Y': 120118,
'MATHEMATICAL FRAKTUR SMALL Z': 120119,
'MATHEMATICAL ITALIC CAPITAL A': 119860,
'MATHEMATICAL ITALIC CAPITAL ALPHA': 120546,
'MATHEMATICAL ITALIC CAPITAL B': 119861,
'MATHEMATICAL ITALIC CAPITAL BETA': 120547,
'MATHEMATICAL ITALIC CAPITAL C': 119862,
'MATHEMATICAL ITALIC CAPITAL CHI': 120568,
'MATHEMATICAL ITALIC CAPITAL D': 119863,
'MATHEMATICAL ITALIC CAPITAL DELTA': 120549,
'MATHEMATICAL ITALIC CAPITAL E': 119864,
'MATHEMATICAL ITALIC CAPITAL EPSILON': 120550,
'MATHEMATICAL ITALIC CAPITAL ETA': 120552,
'MATHEMATICAL ITALIC CAPITAL F': 119865,
'MATHEMATICAL ITALIC CAPITAL G': 119866,
'MATHEMATICAL ITALIC CAPITAL GAMMA': 120548,
'MATHEMATICAL ITALIC CAPITAL H': 119867,
'MATHEMATICAL ITALIC CAPITAL I': 119868,
'MATHEMATICAL ITALIC CAPITAL IOTA': 120554,
'MATHEMATICAL ITALIC CAPITAL J': 119869,
'MATHEMATICAL ITALIC CAPITAL K': 119870,
'MATHEMATICAL ITALIC CAPITAL KAPPA': 120555,
'MATHEMATICAL ITALIC CAPITAL L': 119871,
'MATHEMATICAL ITALIC CAPITAL LAMDA': 120556,
'MATHEMATICAL ITALIC CAPITAL M': 119872,
'MATHEMATICAL ITALIC CAPITAL MU': 120557,
'MATHEMATICAL ITALIC CAPITAL N': 119873,
'MATHEMATICAL ITALIC CAPITAL NU': 120558,
'MATHEMATICAL ITALIC CAPITAL O': 119874,
'MATHEMATICAL ITALIC CAPITAL OMEGA': 120570,
'MATHEMATICAL ITALIC CAPITAL OMICRON': 120560,
'MATHEMATICAL ITALIC CAPITAL P': 119875,
'MATHEMATICAL ITALIC CAPITAL PHI': 120567,
'MATHEMATICAL ITALIC CAPITAL PI': 120561,
'MATHEMATICAL ITALIC CAPITAL PSI': 120569,
'MATHEMATICAL ITALIC CAPITAL Q': 119876,
'MATHEMATICAL ITALIC CAPITAL R': 119877,
'MATHEMATICAL ITALIC CAPITAL RHO': 120562,
'MATHEMATICAL ITALIC CAPITAL S': 119878,
'MATHEMATICAL ITALIC CAPITAL SIGMA': 120564,
'MATHEMATICAL ITALIC CAPITAL T': 119879,
'MATHEMATICAL ITALIC CAPITAL TAU': 120565,
'MATHEMATICAL ITALIC CAPITAL THETA': 120553,
'MATHEMATICAL ITALIC CAPITAL THETA SYMBOL': 120563,
'MATHEMATICAL ITALIC CAPITAL U': 119880,
'MATHEMATICAL ITALIC CAPITAL UPSILON': 120566,
'MATHEMATICAL ITALIC CAPITAL V': 119881,
'MATHEMATICAL ITALIC CAPITAL W': 119882,
'MATHEMATICAL ITALIC CAPITAL X': 119883,
'MATHEMATICAL ITALIC CAPITAL XI': 120559,
'MATHEMATICAL ITALIC CAPITAL Y': 119884,
'MATHEMATICAL ITALIC CAPITAL Z': 119885,
'MATHEMATICAL ITALIC CAPITAL ZETA': 120551,
'MATHEMATICAL ITALIC EPSILON SYMBOL': 120598,
'MATHEMATICAL ITALIC KAPPA SYMBOL': 120600,
'MATHEMATICAL ITALIC NABLA': 120571,
'MATHEMATICAL ITALIC PARTIAL DIFFERENTIAL': 120597,
'MATHEMATICAL ITALIC PHI SYMBOL': 120601,
'MATHEMATICAL ITALIC PI SYMBOL': 120603,
'MATHEMATICAL ITALIC RHO SYMBOL': 120602,
'MATHEMATICAL ITALIC SMALL A': 119886,
'MATHEMATICAL ITALIC SMALL ALPHA': 120572,
'MATHEMATICAL ITALIC SMALL B': 119887,
'MATHEMATICAL ITALIC SMALL BETA': 120573,
'MATHEMATICAL ITALIC SMALL C': 119888,
'MATHEMATICAL ITALIC SMALL CHI': 120594,
'MATHEMATICAL ITALIC SMALL D': 119889,
'MATHEMATICAL ITALIC SMALL DELTA': 120575,
'MATHEMATICAL ITALIC SMALL DOTLESS I': 120484,
'MATHEMATICAL ITALIC SMALL DOTLESS J': 120485,
'MATHEMATICAL ITALIC SMALL E': 119890,
'MATHEMATICAL ITALIC SMALL EPSILON': 120576,
'MATHEMATICAL ITALIC SMALL ETA': 120578,
'MATHEMATICAL ITALIC SMALL F': 119891,
'MATHEMATICAL ITALIC SMALL FINAL SIGMA': 120589,
'MATHEMATICAL ITALIC SMALL G': 119892,
'MATHEMATICAL ITALIC SMALL GAMMA': 120574,
'MATHEMATICAL ITALIC SMALL I': 119894,
'MATHEMATICAL ITALIC SMALL IOTA': 120580,
'MATHEMATICAL ITALIC SMALL J': 119895,
'MATHEMATICAL ITALIC SMALL K': 119896,
'MATHEMATICAL ITALIC SMALL KAPPA': 120581,
'MATHEMATICAL ITALIC SMALL L': 119897,
'MATHEMATICAL ITALIC SMALL LAMDA': 120582,
'MATHEMATICAL ITALIC SMALL M': 119898,
'MATHEMATICAL ITALIC SMALL MU': 120583,
'MATHEMATICAL ITALIC SMALL N': 119899,
'MATHEMATICAL ITALIC SMALL NU': 120584,
'MATHEMATICAL ITALIC SMALL O': 119900,
'MATHEMATICAL ITALIC SMALL OMEGA': 120596,
'MATHEMATICAL ITALIC SMALL OMICRON': 120586,
'MATHEMATICAL ITALIC SMALL P': 119901,
'MATHEMATICAL ITALIC SMALL PHI': 120593,
'MATHEMATICAL ITALIC SMALL PI': 120587,
'MATHEMATICAL ITALIC SMALL PSI': 120595,
'MATHEMATICAL ITALIC SMALL Q': 119902,
'MATHEMATICAL ITALIC SMALL R': 119903,
'MATHEMATICAL ITALIC SMALL RHO': 120588,
'MATHEMATICAL ITALIC SMALL S': 119904,
'MATHEMATICAL ITALIC SMALL SIGMA': 120590,
'MATHEMATICAL ITALIC SMALL T': 119905,
'MATHEMATICAL ITALIC SMALL TAU': 120591,
'MATHEMATICAL ITALIC SMALL THETA': 120579,
'MATHEMATICAL ITALIC SMALL U': 119906,
'MATHEMATICAL ITALIC SMALL UPSILON': 120592,
'MATHEMATICAL ITALIC SMALL V': 119907,
'MATHEMATICAL ITALIC SMALL W': 119908,
'MATHEMATICAL ITALIC SMALL X': 119909,
'MATHEMATICAL ITALIC SMALL XI': 120585,
'MATHEMATICAL ITALIC SMALL Y': 119910,
'MATHEMATICAL ITALIC SMALL Z': 119911,
'MATHEMATICAL ITALIC SMALL ZETA': 120577,
'MATHEMATICAL ITALIC THETA SYMBOL': 120599,
'MATHEMATICAL LEFT ANGLE BRACKET': 10216,
'MATHEMATICAL LEFT DOUBLE ANGLE BRACKET': 10218,
'MATHEMATICAL LEFT WHITE SQUARE BRACKET': 10214,
'MATHEMATICAL MONOSPACE CAPITAL A': 120432,
'MATHEMATICAL MONOSPACE CAPITAL B': 120433,
'MATHEMATICAL MONOSPACE CAPITAL C': 120434,
'MATHEMATICAL MONOSPACE CAPITAL D': 120435,
'MATHEMATICAL MONOSPACE CAPITAL E': 120436,
'MATHEMATICAL MONOSPACE CAPITAL F': 120437,
'MATHEMATICAL MONOSPACE CAPITAL G': 120438,
'MATHEMATICAL MONOSPACE CAPITAL H': 120439,
'MATHEMATICAL MONOSPACE CAPITAL I': 120440,
'MATHEMATICAL MONOSPACE CAPITAL J': 120441,
'MATHEMATICAL MONOSPACE CAPITAL K': 120442,
'MATHEMATICAL MONOSPACE CAPITAL L': 120443,
'MATHEMATICAL MONOSPACE CAPITAL M': 120444,
'MATHEMATICAL MONOSPACE CAPITAL N': 120445,
'MATHEMATICAL MONOSPACE CAPITAL O': 120446,
'MATHEMATICAL MONOSPACE CAPITAL P': 120447,
'MATHEMATICAL MONOSPACE CAPITAL Q': 120448,
'MATHEMATICAL MONOSPACE CAPITAL R': 120449,
'MATHEMATICAL MONOSPACE CAPITAL S': 120450,
'MATHEMATICAL MONOSPACE CAPITAL T': 120451,
'MATHEMATICAL MONOSPACE CAPITAL U': 120452,
'MATHEMATICAL MONOSPACE CAPITAL V': 120453,
'MATHEMATICAL MONOSPACE CAPITAL W': 120454,
'MATHEMATICAL MONOSPACE CAPITAL X': 120455,
'MATHEMATICAL MONOSPACE CAPITAL Y': 120456,
'MATHEMATICAL MONOSPACE CAPITAL Z': 120457,
'MATHEMATICAL MONOSPACE DIGIT EIGHT': 120830,
'MATHEMATICAL MONOSPACE DIGIT FIVE': 120827,
'MATHEMATICAL MONOSPACE DIGIT FOUR': 120826,
'MATHEMATICAL MONOSPACE DIGIT NINE': 120831,
'MATHEMATICAL MONOSPACE DIGIT ONE': 120823,
'MATHEMATICAL MONOSPACE DIGIT SEVEN': 120829,
'MATHEMATICAL MONOSPACE DIGIT SIX': 120828,
'MATHEMATICAL MONOSPACE DIGIT THREE': 120825,
'MATHEMATICAL MONOSPACE DIGIT TWO': 120824,
'MATHEMATICAL MONOSPACE DIGIT ZERO': 120822,
'MATHEMATICAL MONOSPACE SMALL A': 120458,
'MATHEMATICAL MONOSPACE SMALL B': 120459,
'MATHEMATICAL MONOSPACE SMALL C': 120460,
'MATHEMATICAL MONOSPACE SMALL D': 120461,
'MATHEMATICAL MONOSPACE SMALL E': 120462,
'MATHEMATICAL MONOSPACE SMALL F': 120463,
'MATHEMATICAL MONOSPACE SMALL G': 120464,
'MATHEMATICAL MONOSPACE SMALL H': 120465,
'MATHEMATICAL MONOSPACE SMALL I': 120466,
'MATHEMATICAL MONOSPACE SMALL J': 120467,
'MATHEMATICAL MONOSPACE SMALL K': 120468,
'MATHEMATICAL MONOSPACE SMALL L': 120469,
'MATHEMATICAL MONOSPACE SMALL M': 120470,
'MATHEMATICAL MONOSPACE SMALL N': 120471,
'MATHEMATICAL MONOSPACE SMALL O': 120472,
'MATHEMATICAL MONOSPACE SMALL P': 120473,
'MATHEMATICAL MONOSPACE SMALL Q': 120474,
'MATHEMATICAL MONOSPACE SMALL R': 120475,
'MATHEMATICAL MONOSPACE SMALL S': 120476,
'MATHEMATICAL MONOSPACE SMALL T': 120477,
'MATHEMATICAL MONOSPACE SMALL U': 120478,
'MATHEMATICAL MONOSPACE SMALL V': 120479,
'MATHEMATICAL MONOSPACE SMALL W': 120480,
'MATHEMATICAL MONOSPACE SMALL X': 120481,
'MATHEMATICAL MONOSPACE SMALL Y': 120482,
'MATHEMATICAL MONOSPACE SMALL Z': 120483,
'MATHEMATICAL RIGHT ANGLE BRACKET': 10217,
'MATHEMATICAL RIGHT DOUBLE ANGLE BRACKET': 10219,
'MATHEMATICAL RIGHT WHITE SQUARE BRACKET': 10215,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL A': 120276,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL ALPHA': 120662,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL B': 120277,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL BETA': 120663,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL C': 120278,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL CHI': 120684,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL D': 120279,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL DELTA': 120665,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL E': 120280,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL EPSILON': 120666,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL ETA': 120668,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL F': 120281,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL G': 120282,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL GAMMA': 120664,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL H': 120283,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL I': 120284,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL IOTA': 120670,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL J': 120285,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL K': 120286,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL KAPPA': 120671,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL L': 120287,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL LAMDA': 120672,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL M': 120288,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL MU': 120673,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL N': 120289,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL NU': 120674,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL O': 120290,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA': 120686,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL OMICRON': 120676,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL P': 120291,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL PHI': 120683,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL PI': 120677,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL PSI': 120685,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL Q': 120292,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL R': 120293,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL RHO': 120678,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL S': 120294,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL SIGMA': 120680,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL T': 120295,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL TAU': 120681,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA': 120669,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA SYMBOL': 120679,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL U': 120296,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL UPSILON': 120682,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL V': 120297,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL W': 120298,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL X': 120299,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL XI': 120675,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL Y': 120300,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL Z': 120301,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL ZETA': 120667,
'MATHEMATICAL SANS-SERIF BOLD DIGIT EIGHT': 120820,
'MATHEMATICAL SANS-SERIF BOLD DIGIT FIVE': 120817,
'MATHEMATICAL SANS-SERIF BOLD DIGIT FOUR': 120816,
'MATHEMATICAL SANS-SERIF BOLD DIGIT NINE': 120821,
'MATHEMATICAL SANS-SERIF BOLD DIGIT ONE': 120813,
'MATHEMATICAL SANS-SERIF BOLD DIGIT SEVEN': 120819,
'MATHEMATICAL SANS-SERIF BOLD DIGIT SIX': 120818,
'MATHEMATICAL SANS-SERIF BOLD DIGIT THREE': 120815,
'MATHEMATICAL SANS-SERIF BOLD DIGIT TWO': 120814,
'MATHEMATICAL SANS-SERIF BOLD DIGIT ZERO': 120812,
'MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL': 120714,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL A': 120380,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ALPHA': 120720,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL B': 120381,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL BETA': 120721,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL C': 120382,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL CHI': 120742,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL D': 120383,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL DELTA': 120723,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL E': 120384,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL EPSILON': 120724,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ETA': 120726,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL F': 120385,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL G': 120386,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL GAMMA': 120722,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL H': 120387,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL I': 120388,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL IOTA': 120728,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL J': 120389,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL K': 120390,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL KAPPA': 120729,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL L': 120391,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL LAMDA': 120730,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL M': 120392,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL MU': 120731,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL N': 120393,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL NU': 120732,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL O': 120394,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA': 120744,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMICRON': 120734,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL P': 120395,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PHI': 120741,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PI': 120735,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PSI': 120743,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Q': 120396,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL R': 120397,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL RHO': 120736,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL S': 120398,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL SIGMA': 120738,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL T': 120399,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL TAU': 120739,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA': 120727,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA SYMBOL': 120737,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL U': 120400,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL UPSILON': 120740,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL V': 120401,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL W': 120402,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL X': 120403,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL XI': 120733,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Y': 120404,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Z': 120405,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ZETA': 120725,
'MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL': 120772,
'MATHEMATICAL SANS-SERIF BOLD ITALIC KAPPA SYMBOL': 120774,
'MATHEMATICAL SANS-SERIF BOLD ITALIC NABLA': 120745,
'MATHEMATICAL SANS-SERIF BOLD ITALIC PARTIAL DIFFERENTIAL': 120771,
'MATHEMATICAL SANS-SERIF BOLD ITALIC PHI SYMBOL': 120775,
'MATHEMATICAL SANS-SERIF BOLD ITALIC PI SYMBOL': 120777,
'MATHEMATICAL SANS-SERIF BOLD ITALIC RHO SYMBOL': 120776,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL A': 120406,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA': 120746,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL B': 120407,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL BETA': 120747,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL C': 120408,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL CHI': 120768,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL D': 120409,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL DELTA': 120749,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL E': 120410,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL EPSILON': 120750,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ETA': 120752,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL F': 120411,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL FINAL SIGMA': 120763,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL G': 120412,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL GAMMA': 120748,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL H': 120413,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL I': 120414,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL IOTA': 120754,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL J': 120415,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL K': 120416,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL KAPPA': 120755,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL L': 120417,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL LAMDA': 120756,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL M': 120418,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL MU': 120757,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL N': 120419,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL NU': 120758,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL O': 120420,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA': 120770,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMICRON': 120760,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL P': 120421,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PHI': 120767,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PI': 120761,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PSI': 120769,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Q': 120422,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL R': 120423,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL RHO': 120762,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL S': 120424,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL SIGMA': 120764,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL T': 120425,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL TAU': 120765,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL THETA': 120753,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL U': 120426,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL UPSILON': 120766,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL V': 120427,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL W': 120428,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL X': 120429,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL XI': 120759,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Y': 120430,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Z': 120431,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ZETA': 120751,
'MATHEMATICAL SANS-SERIF BOLD ITALIC THETA SYMBOL': 120773,
'MATHEMATICAL SANS-SERIF BOLD KAPPA SYMBOL': 120716,
'MATHEMATICAL SANS-SERIF BOLD NABLA': 120687,
'MATHEMATICAL SANS-SERIF BOLD PARTIAL DIFFERENTIAL': 120713,
'MATHEMATICAL SANS-SERIF BOLD PHI SYMBOL': 120717,
'MATHEMATICAL SANS-SERIF BOLD PI SYMBOL': 120719,
'MATHEMATICAL SANS-SERIF BOLD RHO SYMBOL': 120718,
'MATHEMATICAL SANS-SERIF BOLD SMALL A': 120302,
'MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA': 120688,
'MATHEMATICAL SANS-SERIF BOLD SMALL B': 120303,
'MATHEMATICAL SANS-SERIF BOLD SMALL BETA': 120689,
'MATHEMATICAL SANS-SERIF BOLD SMALL C': 120304,
'MATHEMATICAL SANS-SERIF BOLD SMALL CHI': 120710,
'MATHEMATICAL SANS-SERIF BOLD SMALL D': 120305,
'MATHEMATICAL SANS-SERIF BOLD SMALL DELTA': 120691,
'MATHEMATICAL SANS-SERIF BOLD SMALL E': 120306,
'MATHEMATICAL SANS-SERIF BOLD SMALL EPSILON': 120692,
'MATHEMATICAL SANS-SERIF BOLD SMALL ETA': 120694,
'MATHEMATICAL SANS-SERIF BOLD SMALL F': 120307,
'MATHEMATICAL SANS-SERIF BOLD SMALL FINAL SIGMA': 120705,
'MATHEMATICAL SANS-SERIF BOLD SMALL G': 120308,
'MATHEMATICAL SANS-SERIF BOLD SMALL GAMMA': 120690,
'MATHEMATICAL SANS-SERIF BOLD SMALL H': 120309,
'MATHEMATICAL SANS-SERIF BOLD SMALL I': 120310,
'MATHEMATICAL SANS-SERIF BOLD SMALL IOTA': 120696,
'MATHEMATICAL SANS-SERIF BOLD SMALL J': 120311,
'MATHEMATICAL SANS-SERIF BOLD SMALL K': 120312,
'MATHEMATICAL SANS-SERIF BOLD SMALL KAPPA': 120697,
'MATHEMATICAL SANS-SERIF BOLD SMALL L': 120313,
'MATHEMATICAL SANS-SERIF BOLD SMALL LAMDA': 120698,
'MATHEMATICAL SANS-SERIF BOLD SMALL M': 120314,
'MATHEMATICAL SANS-SERIF BOLD SMALL MU': 120699,
'MATHEMATICAL SANS-SERIF BOLD SMALL N': 120315,
'MATHEMATICAL SANS-SERIF BOLD SMALL NU': 120700,
'MATHEMATICAL SANS-SERIF BOLD SMALL O': 120316,
'MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA': 120712,
'MATHEMATICAL SANS-SERIF BOLD SMALL OMICRON': 120702,
'MATHEMATICAL SANS-SERIF BOLD SMALL P': 120317,
'MATHEMATICAL SANS-SERIF BOLD SMALL PHI': 120709,
'MATHEMATICAL SANS-SERIF BOLD SMALL PI': 120703,
'MATHEMATICAL SANS-SERIF BOLD SMALL PSI': 120711,
'MATHEMATICAL SANS-SERIF BOLD SMALL Q': 120318,
'MATHEMATICAL SANS-SERIF BOLD SMALL R': 120319,
'MATHEMATICAL SANS-SERIF BOLD SMALL RHO': 120704,
'MATHEMATICAL SANS-SERIF BOLD SMALL S': 120320,
'MATHEMATICAL SANS-SERIF BOLD SMALL SIGMA': 120706,
'MATHEMATICAL SANS-SERIF BOLD SMALL T': 120321,
'MATHEMATICAL SANS-SERIF BOLD SMALL TAU': 120707,
'MATHEMATICAL SANS-SERIF BOLD SMALL THETA': 120695,
'MATHEMATICAL SANS-SERIF BOLD SMALL U': 120322,
'MATHEMATICAL SANS-SERIF BOLD SMALL UPSILON': 120708,
'MATHEMATICAL SANS-SERIF BOLD SMALL V': 120323,
'MATHEMATICAL SANS-SERIF BOLD SMALL W': 120324,
'MATHEMATICAL SANS-SERIF BOLD SMALL X': 120325,
'MATHEMATICAL SANS-SERIF BOLD SMALL XI': 120701,
'MATHEMATICAL SANS-SERIF BOLD SMALL Y': 120326,
'MATHEMATICAL SANS-SERIF BOLD SMALL Z': 120327,
'MATHEMATICAL SANS-SERIF BOLD SMALL ZETA': 120693,
'MATHEMATICAL SANS-SERIF BOLD THETA SYMBOL': 120715,
'MATHEMATICAL SANS-SERIF CAPITAL A': 120224,
'MATHEMATICAL SANS-SERIF CAPITAL B': 120225,
'MATHEMATICAL SANS-SERIF CAPITAL C': 120226,
'MATHEMATICAL SANS-SERIF CAPITAL D': 120227,
'MATHEMATICAL SANS-SERIF CAPITAL E': 120228,
'MATHEMATICAL SANS-SERIF CAPITAL F': 120229,
'MATHEMATICAL SANS-SERIF CAPITAL G': 120230,
'MATHEMATICAL SANS-SERIF CAPITAL H': 120231,
'MATHEMATICAL SANS-SERIF CAPITAL I': 120232,
'MATHEMATICAL SANS-SERIF CAPITAL J': 120233,
'MATHEMATICAL SANS-SERIF CAPITAL K': 120234,
'MATHEMATICAL SANS-SERIF CAPITAL L': 120235,
'MATHEMATICAL SANS-SERIF CAPITAL M': 120236,
'MATHEMATICAL SANS-SERIF CAPITAL N': 120237,
'MATHEMATICAL SANS-SERIF CAPITAL O': 120238,
'MATHEMATICAL SANS-SERIF CAPITAL P': 120239,
'MATHEMATICAL SANS-SERIF CAPITAL Q': 120240,
'MATHEMATICAL SANS-SERIF CAPITAL R': 120241,
'MATHEMATICAL SANS-SERIF CAPITAL S': 120242,
'MATHEMATICAL SANS-SERIF CAPITAL T': 120243,
'MATHEMATICAL SANS-SERIF CAPITAL U': 120244,
'MATHEMATICAL SANS-SERIF CAPITAL V': 120245,
'MATHEMATICAL SANS-SERIF CAPITAL W': 120246,
'MATHEMATICAL SANS-SERIF CAPITAL X': 120247,
'MATHEMATICAL SANS-SERIF CAPITAL Y': 120248,
'MATHEMATICAL SANS-SERIF CAPITAL Z': 120249,
'MATHEMATICAL SANS-SERIF DIGIT EIGHT': 120810,
'MATHEMATICAL SANS-SERIF DIGIT FIVE': 120807,
'MATHEMATICAL SANS-SERIF DIGIT FOUR': 120806,
'MATHEMATICAL SANS-SERIF DIGIT NINE': 120811,
'MATHEMATICAL SANS-SERIF DIGIT ONE': 120803,
'MATHEMATICAL SANS-SERIF DIGIT SEVEN': 120809,
'MATHEMATICAL SANS-SERIF DIGIT SIX': 120808,
'MATHEMATICAL SANS-SERIF DIGIT THREE': 120805,
'MATHEMATICAL SANS-SERIF DIGIT TWO': 120804,
'MATHEMATICAL SANS-SERIF DIGIT ZERO': 120802,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL A': 120328,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL B': 120329,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL C': 120330,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL D': 120331,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL E': 120332,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL F': 120333,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL G': 120334,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL H': 120335,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL I': 120336,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL J': 120337,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL K': 120338,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL L': 120339,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL M': 120340,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL N': 120341,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL O': 120342,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL P': 120343,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL Q': 120344,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL R': 120345,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL S': 120346,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL T': 120347,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL U': 120348,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL V': 120349,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL W': 120350,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL X': 120351,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL Y': 120352,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL Z': 120353,
'MATHEMATICAL SANS-SERIF ITALIC SMALL A': 120354,
'MATHEMATICAL SANS-SERIF ITALIC SMALL B': 120355,
'MATHEMATICAL SANS-SERIF ITALIC SMALL C': 120356,
'MATHEMATICAL SANS-SERIF ITALIC SMALL D': 120357,
'MATHEMATICAL SANS-SERIF ITALIC SMALL E': 120358,
'MATHEMATICAL SANS-SERIF ITALIC SMALL F': 120359,
'MATHEMATICAL SANS-SERIF ITALIC SMALL G': 120360,
'MATHEMATICAL SANS-SERIF ITALIC SMALL H': 120361,
'MATHEMATICAL SANS-SERIF ITALIC SMALL I': 120362,
'MATHEMATICAL SANS-SERIF ITALIC SMALL J': 120363,
'MATHEMATICAL SANS-SERIF ITALIC SMALL K': 120364,
'MATHEMATICAL SANS-SERIF ITALIC SMALL L': 120365,
'MATHEMATICAL SANS-SERIF ITALIC SMALL M': 120366,
'MATHEMATICAL SANS-SERIF ITALIC SMALL N': 120367,
'MATHEMATICAL SANS-SERIF ITALIC SMALL O': 120368,
'MATHEMATICAL SANS-SERIF ITALIC SMALL P': 120369,
'MATHEMATICAL SANS-SERIF ITALIC SMALL Q': 120370,
'MATHEMATICAL SANS-SERIF ITALIC SMALL R': 120371,
'MATHEMATICAL SANS-SERIF ITALIC SMALL S': 120372,
'MATHEMATICAL SANS-SERIF ITALIC SMALL T': 120373,
'MATHEMATICAL SANS-SERIF ITALIC SMALL U': 120374,
'MATHEMATICAL SANS-SERIF ITALIC SMALL V': 120375,
'MATHEMATICAL SANS-SERIF ITALIC SMALL W': 120376,
'MATHEMATICAL SANS-SERIF ITALIC SMALL X': 120377,
'MATHEMATICAL SANS-SERIF ITALIC SMALL Y': 120378,
'MATHEMATICAL SANS-SERIF ITALIC SMALL Z': 120379,
'MATHEMATICAL SANS-SERIF SMALL A': 120250,
'MATHEMATICAL SANS-SERIF SMALL B': 120251,
'MATHEMATICAL SANS-SERIF SMALL C': 120252,
'MATHEMATICAL SANS-SERIF SMALL D': 120253,
'MATHEMATICAL SANS-SERIF SMALL E': 120254,
'MATHEMATICAL SANS-SERIF SMALL F': 120255,
'MATHEMATICAL SANS-SERIF SMALL G': 120256,
'MATHEMATICAL SANS-SERIF SMALL H': 120257,
'MATHEMATICAL SANS-SERIF SMALL I': 120258,
'MATHEMATICAL SANS-SERIF SMALL J': 120259,
'MATHEMATICAL SANS-SERIF SMALL K': 120260,
'MATHEMATICAL SANS-SERIF SMALL L': 120261,
'MATHEMATICAL SANS-SERIF SMALL M': 120262,
'MATHEMATICAL SANS-SERIF SMALL N': 120263,
'MATHEMATICAL SANS-SERIF SMALL O': 120264,
'MATHEMATICAL SANS-SERIF SMALL P': 120265,
'MATHEMATICAL SANS-SERIF SMALL Q': 120266,
'MATHEMATICAL SANS-SERIF SMALL R': 120267,
'MATHEMATICAL SANS-SERIF SMALL S': 120268,
'MATHEMATICAL SANS-SERIF SMALL T': 120269,
'MATHEMATICAL SANS-SERIF SMALL U': 120270,
'MATHEMATICAL SANS-SERIF SMALL V': 120271,
'MATHEMATICAL SANS-SERIF SMALL W': 120272,
'MATHEMATICAL SANS-SERIF SMALL X': 120273,
'MATHEMATICAL SANS-SERIF SMALL Y': 120274,
'MATHEMATICAL SANS-SERIF SMALL Z': 120275,
'MATHEMATICAL SCRIPT CAPITAL A': 119964,
'MATHEMATICAL SCRIPT CAPITAL C': 119966,
'MATHEMATICAL SCRIPT CAPITAL D': 119967,
'MATHEMATICAL SCRIPT CAPITAL G': 119970,
'MATHEMATICAL SCRIPT CAPITAL J': 119973,
'MATHEMATICAL SCRIPT CAPITAL K': 119974,
'MATHEMATICAL SCRIPT CAPITAL N': 119977,
'MATHEMATICAL SCRIPT CAPITAL O': 119978,
'MATHEMATICAL SCRIPT CAPITAL P': 119979,
'MATHEMATICAL SCRIPT CAPITAL Q': 119980,
'MATHEMATICAL SCRIPT CAPITAL S': 119982,
'MATHEMATICAL SCRIPT CAPITAL T': 119983,
'MATHEMATICAL SCRIPT CAPITAL U': 119984,
'MATHEMATICAL SCRIPT CAPITAL V': 119985,
'MATHEMATICAL SCRIPT CAPITAL W': 119986,
'MATHEMATICAL SCRIPT CAPITAL X': 119987,
'MATHEMATICAL SCRIPT CAPITAL Y': 119988,
'MATHEMATICAL SCRIPT CAPITAL Z': 119989,
'MATHEMATICAL SCRIPT SMALL A': 119990,
'MATHEMATICAL SCRIPT SMALL B': 119991,
'MATHEMATICAL SCRIPT SMALL C': 119992,
'MATHEMATICAL SCRIPT SMALL D': 119993,
'MATHEMATICAL SCRIPT SMALL F': 119995,
'MATHEMATICAL SCRIPT SMALL H': 119997,
'MATHEMATICAL SCRIPT SMALL I': 119998,
'MATHEMATICAL SCRIPT SMALL J': 119999,
'MATHEMATICAL SCRIPT SMALL K': 120000,
'MATHEMATICAL SCRIPT SMALL L': 120001,
'MATHEMATICAL SCRIPT SMALL M': 120002,
'MATHEMATICAL SCRIPT SMALL N': 120003,
'MATHEMATICAL SCRIPT SMALL P': 120005,
'MATHEMATICAL SCRIPT SMALL Q': 120006,
'MATHEMATICAL SCRIPT SMALL R': 120007,
'MATHEMATICAL SCRIPT SMALL S': 120008,
'MATHEMATICAL SCRIPT SMALL T': 120009,
'MATHEMATICAL SCRIPT SMALL U': 120010,
'MATHEMATICAL SCRIPT SMALL V': 120011,
'MATHEMATICAL SCRIPT SMALL W': 120012,
'MATHEMATICAL SCRIPT SMALL X': 120013,
'MATHEMATICAL SCRIPT SMALL Y': 120014,
'MATHEMATICAL SCRIPT SMALL Z': 120015,
'MEASURED ANGLE': 8737,
'MEASURED ANGLE OPENING LEFT': 10651,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND LEFT': 10667,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND RIGHT': 10666,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND DOWN': 10671,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND UP': 10669,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND DOWN': 10670,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND UP': 10668,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND LEFT': 10665,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND RIGHT': 10664,
'MEASURED BY': 8798,
'MEASURED RIGHT ANGLE WITH DOT': 10653,
'MEDIUM BLACK CIRCLE': 9899,
'MEDIUM FLATTENED LEFT PARENTHESIS ORNAMENT': 10090,
'MEDIUM FLATTENED RIGHT PARENTHESIS ORNAMENT': 10091,
'MEDIUM LEFT CURLY BRACKET ORNAMENT': 10100,
'MEDIUM LEFT PARENTHESIS ORNAMENT': 10088,
'MEDIUM LEFT-POINTING ANGLE BRACKET ORNAMENT': 10092,
'MEDIUM MATHEMATICAL SPACE': 8287,
'MEDIUM RIGHT CURLY BRACKET ORNAMENT': 10101,
'MEDIUM RIGHT PARENTHESIS ORNAMENT': 10089,
'MEDIUM RIGHT-POINTING ANGLE BRACKET ORNAMENT': 10093,
'MEDIUM SHADE': 9618,
'MEDIUM SMALL WHITE CIRCLE': 9900,
'MEDIUM VERTICAL BAR': 10073,
'MEDIUM WHITE CIRCLE': 9898,
'MERCURY': 9791,
'METRICAL BREVE': 9169,
'METRICAL LONG OVER SHORT': 9170,
'METRICAL LONG OVER TWO SHORTS': 9172,
'METRICAL PENTASEME': 9177,
'METRICAL SHORT OVER LONG': 9171,
'METRICAL TETRASEME': 9176,
'METRICAL TRISEME': 9175,
'METRICAL TWO SHORTS JOINED': 9174,
'METRICAL TWO SHORTS OVER LONG': 9173,
'MICRO SIGN': 181,
'MIDDLE DOT': 183,
'MIDLINE HORIZONTAL ELLIPSIS': 8943,
'MILL SIGN': 8357,
'MINUS SIGN': 8722,
'MINUS SIGN IN TRIANGLE': 10810,
'MINUS SIGN WITH COMMA ABOVE': 10793,
'MINUS SIGN WITH DOT BELOW': 10794,
'MINUS SIGN WITH FALLING DOTS': 10795,
'MINUS SIGN WITH RISING DOTS': 10796,
'MINUS TILDE': 8770,
'MINUS-OR-PLUS SIGN': 8723,
'MINY': 10751,
'MODELS': 8871,
'MODIFIER LETTER ACUTE ACCENT': 714,
'MODIFIER LETTER APOSTROPHE': 700,
'MODIFIER LETTER BEGIN HIGH TONE': 761,
'MODIFIER LETTER BEGIN LOW TONE': 763,
'MODIFIER LETTER CAPITAL A': 7468,
'MODIFIER LETTER CAPITAL AE': 7469,
'MODIFIER LETTER CAPITAL B': 7470,
'MODIFIER LETTER CAPITAL BARRED B': 7471,
'MODIFIER LETTER CAPITAL D': 7472,
'MODIFIER LETTER CAPITAL E': 7473,
'MODIFIER LETTER CAPITAL G': 7475,
'MODIFIER LETTER CAPITAL H': 7476,
'MODIFIER LETTER CAPITAL I': 7477,
'MODIFIER LETTER CAPITAL J': 7478,
'MODIFIER LETTER CAPITAL K': 7479,
'MODIFIER LETTER CAPITAL L': 7480,
'MODIFIER LETTER CAPITAL M': 7481,
'MODIFIER LETTER CAPITAL N': 7482,
'MODIFIER LETTER CAPITAL O': 7484,
'MODIFIER LETTER CAPITAL OU': 7485,
'MODIFIER LETTER CAPITAL P': 7486,
'MODIFIER LETTER CAPITAL R': 7487,
'MODIFIER LETTER CAPITAL REVERSED E': 7474,
'MODIFIER LETTER CAPITAL REVERSED N': 7483,
'MODIFIER LETTER CAPITAL T': 7488,
'MODIFIER LETTER CAPITAL U': 7489,
'MODIFIER LETTER CAPITAL W': 7490,
'MODIFIER LETTER CENTRED LEFT HALF RING': 723,
'MODIFIER LETTER CENTRED RIGHT HALF RING': 722,
'MODIFIER LETTER CHINESE TONE YANG PING': 42753,
'MODIFIER LETTER CHINESE TONE YANG QU': 42757,
'MODIFIER LETTER CHINESE TONE YANG RU': 42759,
'MODIFIER LETTER CHINESE TONE YANG SHANG': 42755,
'MODIFIER LETTER CHINESE TONE YIN PING': 42752,
'MODIFIER LETTER CHINESE TONE YIN QU': 42756,
'MODIFIER LETTER CHINESE TONE YIN RU': 42758,
'MODIFIER LETTER CHINESE TONE YIN SHANG': 42754,
'MODIFIER LETTER CIRCUMFLEX ACCENT': 710,
'MODIFIER LETTER CROSS ACCENT': 735,
'MODIFIER LETTER CYRILLIC EN': 7544,
'MODIFIER LETTER DOUBLE APOSTROPHE': 750,
'MODIFIER LETTER DOUBLE PRIME': 698,
'MODIFIER LETTER DOWN ARROWHEAD': 709,
'MODIFIER LETTER DOWN TACK': 725,
'MODIFIER LETTER END HIGH TONE': 762,
'MODIFIER LETTER END LOW TONE': 764,
'MODIFIER LETTER EXTRA-HIGH DOTTED LEFT-STEM TONE BAR': 42765,
'MODIFIER LETTER EXTRA-HIGH DOTTED TONE BAR': 42760,
'MODIFIER LETTER EXTRA-HIGH LEFT-STEM TONE BAR': 42770,
'MODIFIER LETTER EXTRA-HIGH TONE BAR': 741,
'MODIFIER LETTER EXTRA-LOW DOTTED LEFT-STEM TONE BAR': 42769,
'MODIFIER LETTER EXTRA-LOW DOTTED TONE BAR': 42764,
'MODIFIER LETTER EXTRA-LOW LEFT-STEM TONE BAR': 42774,
'MODIFIER LETTER EXTRA-LOW TONE BAR': 745,
'MODIFIER LETTER GEORGIAN NAR': 4348,
'MODIFIER LETTER GLOTTAL STOP': 704,
'MODIFIER LETTER GRAVE ACCENT': 715,
'MODIFIER LETTER HALF TRIANGULAR COLON': 721,
'MODIFIER LETTER HIGH DOTTED LEFT-STEM TONE BAR': 42766,
'MODIFIER LETTER HIGH DOTTED TONE BAR': 42761,
'MODIFIER LETTER HIGH LEFT-STEM TONE BAR': 42771,
'MODIFIER LETTER HIGH TONE BAR': 742,
'MODIFIER LETTER LEFT ARROWHEAD': 706,
'MODIFIER LETTER LEFT HALF RING': 703,
'MODIFIER LETTER LOW ACUTE ACCENT': 719,
'MODIFIER LETTER LOW DOTTED LEFT-STEM TONE BAR': 42768,
'MODIFIER LETTER LOW DOTTED TONE BAR': 42763,
'MODIFIER LETTER LOW DOWN ARROWHEAD': 751,
'MODIFIER LETTER LOW GRAVE ACCENT': 718,
'MODIFIER LETTER LOW LEFT ARROW': 767,
'MODIFIER LETTER LOW LEFT ARROWHEAD': 753,
'MODIFIER LETTER LOW LEFT-STEM TONE BAR': 42773,
'MODIFIER LETTER LOW MACRON': 717,
'MODIFIER LETTER LOW RIGHT ARROWHEAD': 754,
'MODIFIER LETTER LOW RING': 755,
'MODIFIER LETTER LOW TILDE': 759,
'MODIFIER LETTER LOW TONE BAR': 744,
'MODIFIER LETTER LOW UP ARROWHEAD': 752,
'MODIFIER LETTER LOW VERTICAL LINE': 716,
'MODIFIER LETTER MACRON': 713,
'MODIFIER LETTER MID DOTTED LEFT-STEM TONE BAR': 42767,
'MODIFIER LETTER MID DOTTED TONE BAR': 42762,
'MODIFIER LETTER MID LEFT-STEM TONE BAR': 42772,
'MODIFIER LETTER MID TONE BAR': 743,
'MODIFIER LETTER MIDDLE DOUBLE ACUTE ACCENT': 758,
'MODIFIER LETTER MIDDLE DOUBLE GRAVE ACCENT': 757,
'MODIFIER LETTER MIDDLE GRAVE ACCENT': 756,
'MODIFIER LETTER MINUS SIGN': 727,
'MODIFIER LETTER OPEN SHELF': 766,
'MODIFIER LETTER PLUS SIGN': 726,
'MODIFIER LETTER PRIME': 697,
'MODIFIER LETTER RAISED COLON': 760,
'MODIFIER LETTER REVERSED COMMA': 701,
'MODIFIER LETTER REVERSED GLOTTAL STOP': 705,
'MODIFIER LETTER RHOTIC HOOK': 734,
'MODIFIER LETTER RIGHT ARROWHEAD': 707,
'MODIFIER LETTER RIGHT HALF RING': 702,
'MODIFIER LETTER SHELF': 765,
'MODIFIER LETTER SMALL A': 7491,
'MODIFIER LETTER SMALL AIN': 7516,
'MODIFIER LETTER SMALL ALPHA': 7493,
'MODIFIER LETTER SMALL B': 7495,
'MODIFIER LETTER SMALL BARRED O': 7601,
'MODIFIER LETTER SMALL BETA': 7517,
'MODIFIER LETTER SMALL BOTTOM HALF O': 7509,
'MODIFIER LETTER SMALL C': 7580,
'MODIFIER LETTER SMALL C WITH CURL': 7581,
'MODIFIER LETTER SMALL CAPITAL I': 7590,
'MODIFIER LETTER SMALL CAPITAL I WITH STROKE': 7591,
'MODIFIER LETTER SMALL CAPITAL INVERTED R': 694,
'MODIFIER LETTER SMALL CAPITAL L': 7595,
'MODIFIER LETTER SMALL CAPITAL N': 7600,
'MODIFIER LETTER SMALL CAPITAL U': 7608,
'MODIFIER LETTER SMALL CHI': 7521,
'MODIFIER LETTER SMALL D': 7496,
'MODIFIER LETTER SMALL DELTA': 7519,
'MODIFIER LETTER SMALL DOTLESS J WITH STROKE': 7585,
'MODIFIER LETTER SMALL E': 7497,
'MODIFIER LETTER SMALL ENG': 7505,
'MODIFIER LETTER SMALL ESH': 7604,
'MODIFIER LETTER SMALL ETH': 7582,
'MODIFIER LETTER SMALL EZH': 7614,
'MODIFIER LETTER SMALL F': 7584,
'MODIFIER LETTER SMALL G': 7501,
'MODIFIER LETTER SMALL GAMMA': 736,
'MODIFIER LETTER SMALL GREEK GAMMA': 7518,
'MODIFIER LETTER SMALL GREEK PHI': 7520,
'MODIFIER LETTER SMALL H': 688,
'MODIFIER LETTER SMALL H WITH HOOK': 689,
'MODIFIER LETTER SMALL I WITH STROKE': 7588,
'MODIFIER LETTER SMALL IOTA': 7589,
'MODIFIER LETTER SMALL J': 690,
'MODIFIER LETTER SMALL J WITH CROSSED-TAIL': 7592,
'MODIFIER LETTER SMALL K': 7503,
'MODIFIER LETTER SMALL L': 737,
'MODIFIER LETTER SMALL L WITH PALATAL HOOK': 7594,
'MODIFIER LETTER SMALL L WITH RETROFLEX HOOK': 7593,
'MODIFIER LETTER SMALL M': 7504,
'MODIFIER LETTER SMALL M WITH HOOK': 7596,
'MODIFIER LETTER SMALL N WITH LEFT HOOK': 7598,
'MODIFIER LETTER SMALL N WITH RETROFLEX HOOK': 7599,
'MODIFIER LETTER SMALL O': 7506,
'MODIFIER LETTER SMALL OPEN E': 7499,
'MODIFIER LETTER SMALL OPEN O': 7507,
'MODIFIER LETTER SMALL P': 7510,
'MODIFIER LETTER SMALL PHI': 7602,
'MODIFIER LETTER SMALL R': 691,
'MODIFIER LETTER SMALL REVERSED GLOTTAL STOP': 740,
'MODIFIER LETTER SMALL REVERSED OPEN E': 7583,
'MODIFIER LETTER SMALL S': 738,
'MODIFIER LETTER SMALL S WITH HOOK': 7603,
'MODIFIER LETTER SMALL SCHWA': 7498,
'MODIFIER LETTER SMALL SCRIPT G': 7586,
'MODIFIER LETTER SMALL SIDEWAYS U': 7513,
'MODIFIER LETTER SMALL T': 7511,
'MODIFIER LETTER SMALL T WITH PALATAL HOOK': 7605,
'MODIFIER LETTER SMALL THETA': 7615,
'MODIFIER LETTER SMALL TOP HALF O': 7508,
'MODIFIER LETTER SMALL TURNED A': 7492,
'MODIFIER LETTER SMALL TURNED AE': 7494,
'MODIFIER LETTER SMALL TURNED ALPHA': 7579,
'MODIFIER LETTER SMALL TURNED H': 7587,
'MODIFIER LETTER SMALL TURNED I': 7502,
'MODIFIER LETTER SMALL TURNED M': 7514,
'MODIFIER LETTER SMALL TURNED M WITH LONG LEG': 7597,
'MODIFIER LETTER SMALL TURNED OPEN E': 7500,
'MODIFIER LETTER SMALL TURNED R': 692,
'MODIFIER LETTER SMALL TURNED R WITH HOOK': 693,
'MODIFIER LETTER SMALL TURNED V': 7610,
'MODIFIER LETTER SMALL U': 7512,
'MODIFIER LETTER SMALL U BAR': 7606,
'MODIFIER LETTER SMALL UPSILON': 7607,
'MODIFIER LETTER SMALL V': 7515,
'MODIFIER LETTER SMALL V WITH HOOK': 7609,
'MODIFIER LETTER SMALL W': 695,
'MODIFIER LETTER SMALL X': 739,
'MODIFIER LETTER SMALL Y': 696,
'MODIFIER LETTER SMALL Z': 7611,
'MODIFIER LETTER SMALL Z WITH CURL': 7613,
'MODIFIER LETTER SMALL Z WITH RETROFLEX HOOK': 7612,
'MODIFIER LETTER TRIANGULAR COLON': 720,
'MODIFIER LETTER TURNED COMMA': 699,
'MODIFIER LETTER UNASPIRATED': 749,
'MODIFIER LETTER UP ARROWHEAD': 708,
'MODIFIER LETTER UP TACK': 724,
'MODIFIER LETTER VERTICAL LINE': 712,
'MODIFIER LETTER VOICING': 748,
'MODIFIER LETTER YANG DEPARTING TONE MARK': 747,
'MODIFIER LETTER YIN DEPARTING TONE MARK': 746,
'MODULO TWO SUM': 10762,
'MONGOLIAN BIRGA': 6144,
'MONGOLIAN COLON': 6148,
'MONGOLIAN COMMA': 6146,
'MONGOLIAN DIGIT EIGHT': 6168,
'MONGOLIAN DIGIT FIVE': 6165,
'MONGOLIAN DIGIT FOUR': 6164,
'MONGOLIAN DIGIT NINE': 6169,
'MONGOLIAN DIGIT ONE': 6161,
'MONGOLIAN DIGIT SEVEN': 6167,
'MONGOLIAN DIGIT SIX': 6166,
'MONGOLIAN DIGIT THREE': 6163,
'MONGOLIAN DIGIT TWO': 6162,
'MONGOLIAN DIGIT ZERO': 6160,
'MONGOLIAN ELLIPSIS': 6145,
'MONGOLIAN FOUR DOTS': 6149,
'MONGOLIAN FREE VARIATION SELECTOR ONE': 6155,
'MONGOLIAN FREE VARIATION SELECTOR THREE': 6157,
'MONGOLIAN FREE VARIATION SELECTOR TWO': 6156,
'MONGOLIAN FULL STOP': 6147,
'MONGOLIAN LETTER A': 6176,
'MONGOLIAN LETTER ALI GALI A': 6279,
'MONGOLIAN LETTER ALI GALI AH': 6295,
'MONGOLIAN LETTER ALI GALI ANUSVARA ONE': 6272,
'MONGOLIAN LETTER ALI GALI BALUDA': 6277,
'MONGOLIAN LETTER ALI GALI CA': 6283,
'MONGOLIAN LETTER ALI GALI DA': 6289,
'MONGOLIAN LETTER ALI GALI DAGALGA': 6313,
'MONGOLIAN LETTER ALI GALI DAMARU': 6274,
'MONGOLIAN LETTER ALI GALI DDA': 6286,
'MONGOLIAN LETTER ALI GALI HALF U': 6310,
'MONGOLIAN LETTER ALI GALI HALF YA': 6311,
'MONGOLIAN LETTER ALI GALI I': 6280,
'MONGOLIAN LETTER ALI GALI INVERTED UBADAMA': 6276,
'MONGOLIAN LETTER ALI GALI KA': 6281,
'MONGOLIAN LETTER ALI GALI NGA': 6282,
'MONGOLIAN LETTER ALI GALI NNA': 6287,
'MONGOLIAN LETTER ALI GALI PA': 6290,
'MONGOLIAN LETTER ALI GALI PHA': 6291,
'MONGOLIAN LETTER ALI GALI SSA': 6292,
'MONGOLIAN LETTER ALI GALI TA': 6288,
'MONGOLIAN LETTER ALI GALI THREE BALUDA': 6278,
'MONGOLIAN LETTER ALI GALI TTA': 6284,
'MONGOLIAN LETTER ALI GALI TTHA': 6285,
'MONGOLIAN LETTER ALI GALI UBADAMA': 6275,
'MONGOLIAN LETTER ALI GALI VISARGA ONE': 6273,
'MONGOLIAN LETTER ALI GALI ZA': 6294,
'MONGOLIAN LETTER ALI GALI ZHA': 6293,
'MONGOLIAN LETTER ANG': 6185,
'MONGOLIAN LETTER BA': 6186,
'MONGOLIAN LETTER CHA': 6196,
'MONGOLIAN LETTER CHI': 6210,
'MONGOLIAN LETTER DA': 6195,
'MONGOLIAN LETTER E': 6177,
'MONGOLIAN LETTER EE': 6183,
'MONGOLIAN LETTER FA': 6201,
'MONGOLIAN LETTER GA': 6189,
'MONGOLIAN LETTER HAA': 6206,
'MONGOLIAN LETTER I': 6178,
'MONGOLIAN LETTER JA': 6197,
'MONGOLIAN LETTER KA': 6202,
'MONGOLIAN LETTER KHA': 6203,
'MONGOLIAN LETTER LA': 6191,
'MONGOLIAN LETTER LHA': 6208,
'MONGOLIAN LETTER MA': 6190,
'MONGOLIAN LETTER MANCHU ALI GALI BHA': 6312,
'MONGOLIAN LETTER MANCHU ALI GALI CA': 6300,
'MONGOLIAN LETTER MANCHU ALI GALI CYA': 6307,
'MONGOLIAN LETTER MANCHU ALI GALI DDHA': 6303,
'MONGOLIAN LETTER MANCHU ALI GALI DHA': 6305,
'MONGOLIAN LETTER MANCHU ALI GALI GHA': 6298,
'MONGOLIAN LETTER MANCHU ALI GALI JHA': 6301,
'MONGOLIAN LETTER MANCHU ALI GALI NGA': 6299,
'MONGOLIAN LETTER MANCHU ALI GALI SSA': 6306,
'MONGOLIAN LETTER MANCHU ALI GALI TA': 6304,
'MONGOLIAN LETTER MANCHU ALI GALI TTA': 6302,
'MONGOLIAN LETTER MANCHU ALI GALI ZA': 6309,
'MONGOLIAN LETTER MANCHU ALI GALI ZHA': 6308,
'MONGOLIAN LETTER MANCHU FA': 6262,
'MONGOLIAN LETTER MANCHU I': 6259,
'MONGOLIAN LETTER MANCHU KA': 6260,
'MONGOLIAN LETTER MANCHU RA': 6261,
'MONGOLIAN LETTER MANCHU ZHA': 6263,
'MONGOLIAN LETTER NA': 6184,
'MONGOLIAN LETTER O': 6179,
'MONGOLIAN LETTER OE': 6181,
'MONGOLIAN LETTER PA': 6187,
'MONGOLIAN LETTER QA': 6188,
'MONGOLIAN LETTER RA': 6199,
'MONGOLIAN LETTER SA': 6192,
'MONGOLIAN LETTER SHA': 6193,
'MONGOLIAN LETTER SIBE ANG': 6242,
'MONGOLIAN LETTER SIBE CHA': 6257,
'MONGOLIAN LETTER SIBE DA': 6249,
'MONGOLIAN LETTER SIBE E': 6237,
'MONGOLIAN LETTER SIBE FA': 6251,
'MONGOLIAN LETTER SIBE GA': 6244,
'MONGOLIAN LETTER SIBE GAA': 6252,
'MONGOLIAN LETTER SIBE HA': 6245,
'MONGOLIAN LETTER SIBE HAA': 6253,
'MONGOLIAN LETTER SIBE I': 6238,
'MONGOLIAN LETTER SIBE IY': 6239,
'MONGOLIAN LETTER SIBE JA': 6250,
'MONGOLIAN LETTER SIBE KA': 6243,
'MONGOLIAN LETTER SIBE PA': 6246,
'MONGOLIAN LETTER SIBE RAA': 6256,
'MONGOLIAN LETTER SIBE SHA': 6247,
'MONGOLIAN LETTER SIBE TA': 6248,
'MONGOLIAN LETTER SIBE TSA': 6254,
'MONGOLIAN LETTER SIBE U': 6241,
'MONGOLIAN LETTER SIBE UE': 6240,
'MONGOLIAN LETTER SIBE ZA': 6255,
'MONGOLIAN LETTER SIBE ZHA': 6258,
'MONGOLIAN LETTER TA': 6194,
'MONGOLIAN LETTER TODO ALI GALI TA': 6296,
'MONGOLIAN LETTER TODO ALI GALI ZHA': 6297,
'MONGOLIAN LETTER TODO ANG': 6218,
'MONGOLIAN LETTER TODO BA': 6219,
'MONGOLIAN LETTER TODO CHA': 6226,
'MONGOLIAN LETTER TODO DA': 6225,
'MONGOLIAN LETTER TODO DZA': 6236,
'MONGOLIAN LETTER TODO E': 6212,
'MONGOLIAN LETTER TODO GA': 6222,
'MONGOLIAN LETTER TODO GAA': 6232,
'MONGOLIAN LETTER TODO HAA': 6233,
'MONGOLIAN LETTER TODO I': 6213,
'MONGOLIAN LETTER TODO JA': 6227,
'MONGOLIAN LETTER TODO JIA': 6234,
'MONGOLIAN LETTER TODO KA': 6231,
'MONGOLIAN LETTER TODO LONG VOWEL SIGN': 6211,
'MONGOLIAN LETTER TODO MA': 6223,
'MONGOLIAN LETTER TODO NIA': 6235,
'MONGOLIAN LETTER TODO O': 6214,
'MONGOLIAN LETTER TODO OE': 6216,
'MONGOLIAN LETTER TODO PA': 6220,
'MONGOLIAN LETTER TODO QA': 6221,
'MONGOLIAN LETTER TODO TA': 6224,
'MONGOLIAN LETTER TODO TSA': 6228,
'MONGOLIAN LETTER TODO U': 6215,
'MONGOLIAN LETTER TODO UE': 6217,
'MONGOLIAN LETTER TODO WA': 6230,
'MONGOLIAN LETTER TODO YA': 6229,
'MONGOLIAN LETTER TSA': 6204,
'MONGOLIAN LETTER U': 6180,
'MONGOLIAN LETTER UE': 6182,
'MONGOLIAN LETTER WA': 6200,
'MONGOLIAN LETTER YA': 6198,
'MONGOLIAN LETTER ZA': 6205,
'MONGOLIAN LETTER ZHI': 6209,
'MONGOLIAN LETTER ZRA': 6207,
'MONGOLIAN MANCHU COMMA': 6152,
'MONGOLIAN MANCHU FULL STOP': 6153,
'MONGOLIAN NIRUGU': 6154,
'MONGOLIAN SIBE SYLLABLE BOUNDARY MARKER': 6151,
'MONGOLIAN TODO SOFT HYPHEN': 6150,
'MONGOLIAN VOWEL SEPARATOR': 6158,
'MONOGRAM FOR EARTH': 119552,
'MONOGRAM FOR YANG': 9866,
'MONOGRAM FOR YIN': 9867,
'MONOSTABLE SYMBOL': 9101,
'MUCH GREATER-THAN': 8811,
'MUCH LESS-THAN': 8810,
'MULTIMAP': 8888,
'MULTIPLICATION SIGN': 215,
'MULTIPLICATION SIGN IN DOUBLE CIRCLE': 10807,
'MULTIPLICATION SIGN IN LEFT HALF CIRCLE': 10804,
'MULTIPLICATION SIGN IN RIGHT HALF CIRCLE': 10805,
'MULTIPLICATION SIGN IN TRIANGLE': 10811,
'MULTIPLICATION SIGN WITH DOT ABOVE': 10800,
'MULTIPLICATION SIGN WITH UNDERBAR': 10801,
'MULTIPLICATION X': 10005,
'MULTISET': 8844,
'MULTISET MULTIPLICATION': 8845,
'MULTISET UNION': 8846,
'MUSIC FLAT SIGN': 9837,
'MUSIC NATURAL SIGN': 9838,
'MUSIC SHARP SIGN': 9839,
'MUSICAL SYMBOL ARPEGGIATO DOWN': 119172,
'MUSICAL SYMBOL ARPEGGIATO UP': 119171,
'MUSICAL SYMBOL BEGIN BEAM': 119155,
'MUSICAL SYMBOL BEGIN PHRASE': 119161,
'MUSICAL SYMBOL BEGIN SLUR': 119159,
'MUSICAL SYMBOL BEGIN TIE': 119157,
'MUSICAL SYMBOL BRACE': 119060,
'MUSICAL SYMBOL BRACKET': 119061,
'MUSICAL SYMBOL BREATH MARK': 119058,
'MUSICAL SYMBOL BREVE': 119132,
'MUSICAL SYMBOL BREVIS': 119224,
'MUSICAL SYMBOL BREVIS REST': 119235,
'MUSICAL SYMBOL C CLEF': 119073,
'MUSICAL SYMBOL CAESURA': 119059,
'MUSICAL SYMBOL CIRCLE X NOTEHEAD': 119109,
'MUSICAL SYMBOL CLIMACUS': 119255,
'MUSICAL SYMBOL CLIVIS': 119253,
'MUSICAL SYMBOL CLUSTER NOTEHEAD BLACK': 119131,
'MUSICAL SYMBOL CLUSTER NOTEHEAD WHITE': 119130,
'MUSICAL SYMBOL CODA': 119052,
'MUSICAL SYMBOL COMBINING ACCENT': 119163,
'MUSICAL SYMBOL COMBINING ACCENT-STACCATO': 119169,
'MUSICAL SYMBOL COMBINING AUGMENTATION DOT': 119149,
'MUSICAL SYMBOL COMBINING BEND': 119177,
'MUSICAL SYMBOL COMBINING DOIT': 119173,
'MUSICAL SYMBOL COMBINING DOUBLE TONGUE': 119178,
'MUSICAL SYMBOL COMBINING DOWN BOW': 119210,
'MUSICAL SYMBOL COMBINING FLAG-1': 119150,
'MUSICAL SYMBOL COMBINING FLAG-2': 119151,
'MUSICAL SYMBOL COMBINING FLAG-3': 119152,
'MUSICAL SYMBOL COMBINING FLAG-4': 119153,
'MUSICAL SYMBOL COMBINING FLAG-5': 119154,
'MUSICAL SYMBOL COMBINING FLIP': 119175,
'MUSICAL SYMBOL COMBINING HARMONIC': 119212,
'MUSICAL SYMBOL COMBINING LOURE': 119170,
'MUSICAL SYMBOL COMBINING MARCATO': 119167,
'MUSICAL SYMBOL COMBINING MARCATO-STACCATO': 119168,
'MUSICAL SYMBOL COMBINING RIP': 119174,
'MUSICAL SYMBOL COMBINING SMEAR': 119176,
'MUSICAL SYMBOL COMBINING SNAP PIZZICATO': 119213,
'MUSICAL SYMBOL COMBINING SPRECHGESANG STEM': 119142,
'MUSICAL SYMBOL COMBINING STACCATISSIMO': 119166,
'MUSICAL SYMBOL COMBINING STACCATO': 119164,
'MUSICAL SYMBOL COMBINING STEM': 119141,
'MUSICAL SYMBOL COMBINING TENUTO': 119165,
'MUSICAL SYMBOL COMBINING TREMOLO-1': 119143,
'MUSICAL SYMBOL COMBINING TREMOLO-2': 119144,
'MUSICAL SYMBOL COMBINING TREMOLO-3': 119145,
'MUSICAL SYMBOL COMBINING TRIPLE TONGUE': 119179,
'MUSICAL SYMBOL COMBINING UP BOW': 119211,
'MUSICAL SYMBOL COMMON TIME': 119092,
'MUSICAL SYMBOL CRESCENDO': 119186,
'MUSICAL SYMBOL CROIX': 119247,
'MUSICAL SYMBOL CUT TIME': 119093,
'MUSICAL SYMBOL DA CAPO': 119050,
'MUSICAL SYMBOL DAL SEGNO': 119049,
'MUSICAL SYMBOL DAMP': 119220,
'MUSICAL SYMBOL DAMP ALL': 119221,
'MUSICAL SYMBOL DASHED BARLINE': 119044,
'MUSICAL SYMBOL DECRESCENDO': 119187,
'MUSICAL SYMBOL DEGREE SLASH': 119209,
'MUSICAL SYMBOL DOUBLE BARLINE': 119041,
'MUSICAL SYMBOL DOUBLE FLAT': 119083,
'MUSICAL SYMBOL DOUBLE SHARP': 119082,
'MUSICAL SYMBOL DRUM CLEF-1': 119077,
'MUSICAL SYMBOL DRUM CLEF-2': 119078,
'MUSICAL SYMBOL EIGHTH NOTE': 119136,
'MUSICAL SYMBOL EIGHTH REST': 119102,
'MUSICAL SYMBOL END BEAM': 119156,
'MUSICAL SYMBOL END OF STIMME': 119208,
'MUSICAL SYMBOL END PHRASE': 119162,
'MUSICAL SYMBOL END SLUR': 119160,
'MUSICAL SYMBOL END TIE': 119158,
'MUSICAL SYMBOL F CLEF': 119074,
'MUSICAL SYMBOL F CLEF OTTAVA ALTA': 119075,
'MUSICAL SYMBOL F CLEF OTTAVA BASSA': 119076,
'MUSICAL SYMBOL FERMATA': 119056,
'MUSICAL SYMBOL FERMATA BELOW': 119057,
'MUSICAL SYMBOL FINAL BARLINE': 119042,
'MUSICAL SYMBOL FINGERED TREMOLO-1': 119146,
'MUSICAL SYMBOL FINGERED TREMOLO-2': 119147,
'MUSICAL SYMBOL FINGERED TREMOLO-3': 119148,
'MUSICAL SYMBOL FIVE-LINE STAFF': 119066,
'MUSICAL SYMBOL FLAT DOWN': 119085,
'MUSICAL SYMBOL FLAT UP': 119084,
'MUSICAL SYMBOL FORTE': 119185,
'MUSICAL SYMBOL FOUR-LINE STAFF': 119065,
'MUSICAL SYMBOL FOUR-STRING FRETBOARD': 119069,
'MUSICAL SYMBOL FUSA BLACK': 119232,
'MUSICAL SYMBOL FUSA WHITE': 119231,
'MUSICAL SYMBOL G CLEF': 119070,
'MUSICAL SYMBOL G CLEF OTTAVA ALTA': 119071,
'MUSICAL SYMBOL G CLEF OTTAVA BASSA': 119072,
'MUSICAL SYMBOL GLISSANDO DOWN': 119218,
'MUSICAL SYMBOL GLISSANDO UP': 119217,
'MUSICAL SYMBOL GRACE NOTE NO SLASH': 119189,
'MUSICAL SYMBOL GRACE NOTE SLASH': 119188,
'MUSICAL SYMBOL GREGORIAN C CLEF': 119248,
'MUSICAL SYMBOL GREGORIAN F CLEF': 119249,
'MUSICAL SYMBOL HALF NOTE': 119134,
'MUSICAL SYMBOL HALF PEDAL MARK': 119216,
'MUSICAL SYMBOL HALF REST': 119100,
'MUSICAL SYMBOL HAUPTSTIMME': 119206,
'MUSICAL SYMBOL INVERTED TURN': 119192,
'MUSICAL SYMBOL LEFT REPEAT SIGN': 119046,
'MUSICAL SYMBOL LONGA': 119223,
'MUSICAL SYMBOL LONGA IMPERFECTA REST': 119234,
'MUSICAL SYMBOL LONGA PERFECTA REST': 119233,
'MUSICAL SYMBOL MAXIMA': 119222,
'MUSICAL SYMBOL MEZZO': 119184,
'MUSICAL SYMBOL MINIMA': 119227,
'MUSICAL SYMBOL MINIMA BLACK': 119228,
'MUSICAL SYMBOL MINIMA REST': 119237,
'MUSICAL SYMBOL MOON NOTEHEAD BLACK': 119123,
'MUSICAL SYMBOL MOON NOTEHEAD WHITE': 119122,
'MUSICAL SYMBOL MULTI REST': 119098,
'MUSICAL SYMBOL NATURAL DOWN': 119087,
'MUSICAL SYMBOL NATURAL UP': 119086,
'MUSICAL SYMBOL NEBENSTIMME': 119207,
'MUSICAL SYMBOL NOTEHEAD BLACK': 119128,
'MUSICAL SYMBOL NULL NOTEHEAD': 119129,
'MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH NOTE': 119140,
'MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH REST': 119106,
'MUSICAL SYMBOL ONE-LINE STAFF': 119062,
'MUSICAL SYMBOL ORNAMENT STROKE-1': 119195,
'MUSICAL SYMBOL ORNAMENT STROKE-10': 119204,
'MUSICAL SYMBOL ORNAMENT STROKE-11': 119205,
'MUSICAL SYMBOL ORNAMENT STROKE-2': 119196,
'MUSICAL SYMBOL ORNAMENT STROKE-3': 119197,
'MUSICAL SYMBOL ORNAMENT STROKE-4': 119198,
'MUSICAL SYMBOL ORNAMENT STROKE-5': 119199,
'MUSICAL SYMBOL ORNAMENT STROKE-6': 119200,
'MUSICAL SYMBOL ORNAMENT STROKE-7': 119201,
'MUSICAL SYMBOL ORNAMENT STROKE-8': 119202,
'MUSICAL SYMBOL ORNAMENT STROKE-9': 119203,
'MUSICAL SYMBOL OTTAVA ALTA': 119094,
'MUSICAL SYMBOL OTTAVA BASSA': 119095,
'MUSICAL SYMBOL PARENTHESIS NOTEHEAD': 119126,
'MUSICAL SYMBOL PEDAL MARK': 119214,
'MUSICAL SYMBOL PEDAL UP MARK': 119215,
'MUSICAL SYMBOL PES SUBPUNCTIS': 119261,
'MUSICAL SYMBOL PIANO': 119183,
'MUSICAL SYMBOL PLUS NOTEHEAD': 119108,
'MUSICAL SYMBOL PODATUS': 119252,
'MUSICAL SYMBOL PORRECTUS': 119257,
'MUSICAL SYMBOL PORRECTUS FLEXUS': 119258,
'MUSICAL SYMBOL QUARTER NOTE': 119135,
'MUSICAL SYMBOL QUARTER REST': 119101,
'MUSICAL SYMBOL QUARTER TONE FLAT': 119091,
'MUSICAL SYMBOL QUARTER TONE SHARP': 119090,
'MUSICAL SYMBOL QUINDICESIMA ALTA': 119096,
'MUSICAL SYMBOL QUINDICESIMA BASSA': 119097,
'MUSICAL SYMBOL REPEAT DOTS': 119048,
'MUSICAL SYMBOL REPEATED FIGURE-1': 119053,
'MUSICAL SYMBOL REPEATED FIGURE-2': 119054,
'MUSICAL SYMBOL REPEATED FIGURE-3': 119055,
'MUSICAL SYMBOL REVERSE FINAL BARLINE': 119043,
'MUSICAL SYMBOL RIGHT REPEAT SIGN': 119047,
'MUSICAL SYMBOL RINFORZANDO': 119180,
'MUSICAL SYMBOL SCANDICUS': 119254,
'MUSICAL SYMBOL SCANDICUS FLEXUS': 119259,
'MUSICAL SYMBOL SEGNO': 119051,
'MUSICAL SYMBOL SEMIBREVIS BLACK': 119226,
'MUSICAL SYMBOL SEMIBREVIS REST': 119236,
'MUSICAL SYMBOL SEMIBREVIS WHITE': 119225,
'MUSICAL SYMBOL SEMIMINIMA BLACK': 119230,
'MUSICAL SYMBOL SEMIMINIMA REST': 119238,
'MUSICAL SYMBOL SEMIMINIMA WHITE': 119229,
'MUSICAL SYMBOL SHARP DOWN': 119089,
'MUSICAL SYMBOL SHARP UP': 119088,
'MUSICAL SYMBOL SHORT BARLINE': 119045,
'MUSICAL SYMBOL SINGLE BARLINE': 119040,
'MUSICAL SYMBOL SIX-LINE STAFF': 119067,
'MUSICAL SYMBOL SIX-STRING FRETBOARD': 119068,
'MUSICAL SYMBOL SIXTEENTH NOTE': 119137,
'MUSICAL SYMBOL SIXTEENTH REST': 119103,
'MUSICAL SYMBOL SIXTY-FOURTH NOTE': 119139,
'MUSICAL SYMBOL SIXTY-FOURTH REST': 119105,
'MUSICAL SYMBOL SQUARE B': 119250,
'MUSICAL SYMBOL SQUARE NOTEHEAD BLACK': 119111,
'MUSICAL SYMBOL SQUARE NOTEHEAD WHITE': 119110,
'MUSICAL SYMBOL SUBITO': 119181,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA': 119243,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-1': 119244,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-2': 119245,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-3': 119246,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE PERFECTA': 119242,
'MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE IMPERFECTA': 119240,
'MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA': 119239,
'MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA DIMINUTION-1': 119241,
'MUSICAL SYMBOL THIRTY-SECOND NOTE': 119138,
'MUSICAL SYMBOL THIRTY-SECOND REST': 119104,
'MUSICAL SYMBOL THREE-LINE STAFF': 119064,
'MUSICAL SYMBOL TORCULUS': 119256,
'MUSICAL SYMBOL TORCULUS RESUPINUS': 119260,
'MUSICAL SYMBOL TR': 119190,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN BLACK': 119119,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN WHITE': 119118,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT BLACK': 119115,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT WHITE': 119114,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT BLACK': 119117,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT WHITE': 119116,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD UP BLACK': 119113,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT BLACK': 119121,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT WHITE': 119120,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD UP WHITE': 119112,
'MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN BLACK': 119125,
'MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN WHITE': 119124,
'MUSICAL SYMBOL TURN': 119191,
'MUSICAL SYMBOL TURN SLASH': 119193,
'MUSICAL SYMBOL TURN UP': 119194,
'MUSICAL SYMBOL TWO-LINE STAFF': 119063,
'MUSICAL SYMBOL VIRGA': 119251,
'MUSICAL SYMBOL VOID NOTEHEAD': 119127,
'MUSICAL SYMBOL WHOLE NOTE': 119133,
'MUSICAL SYMBOL WHOLE REST': 119099,
'MUSICAL SYMBOL WITH FINGERNAILS': 119219,
'MUSICAL SYMBOL X NOTEHEAD': 119107,
'MUSICAL SYMBOL Z': 119182,
'MYANMAR DIGIT EIGHT': 4168,
'MYANMAR DIGIT FIVE': 4165,
'MYANMAR DIGIT FOUR': 4164,
'MYANMAR DIGIT NINE': 4169,
'MYANMAR DIGIT ONE': 4161,
'MYANMAR DIGIT SEVEN': 4167,
'MYANMAR DIGIT SIX': 4166,
'MYANMAR DIGIT THREE': 4163,
'MYANMAR DIGIT TWO': 4162,
'MYANMAR DIGIT ZERO': 4160,
'MYANMAR LETTER A': 4129,
'MYANMAR LETTER AU': 4138,
'MYANMAR LETTER BA': 4119,
'MYANMAR LETTER BHA': 4120,
'MYANMAR LETTER CA': 4101,
'MYANMAR LETTER CHA': 4102,
'MYANMAR LETTER DA': 4114,
'MYANMAR LETTER DDA': 4109,
'MYANMAR LETTER DDHA': 4110,
'MYANMAR LETTER DHA': 4115,
'MYANMAR LETTER E': 4135,
'MYANMAR LETTER GA': 4098,
'MYANMAR LETTER GHA': 4099,
'MYANMAR LETTER HA': 4127,
'MYANMAR LETTER I': 4131,
'MYANMAR LETTER II': 4132,
'MYANMAR LETTER JA': 4103,
'MYANMAR LETTER JHA': 4104,
'MYANMAR LETTER KA': 4096,
'MYANMAR LETTER KHA': 4097,
'MYANMAR LETTER LA': 4124,
'MYANMAR LETTER LLA': 4128,
'MYANMAR LETTER MA': 4121,
'MYANMAR LETTER NA': 4116,
'MYANMAR LETTER NGA': 4100,
'MYANMAR LETTER NNA': 4111,
'MYANMAR LETTER NNYA': 4106,
'MYANMAR LETTER NYA': 4105,
'MYANMAR LETTER O': 4137,
'MYANMAR LETTER PA': 4117,
'MYANMAR LETTER PHA': 4118,
'MYANMAR LETTER RA': 4123,
'MYANMAR LETTER SA': 4126,
'MYANMAR LETTER SHA': 4176,
'MYANMAR LETTER SSA': 4177,
'MYANMAR LETTER TA': 4112,
'MYANMAR LETTER THA': 4113,
'MYANMAR LETTER TTA': 4107,
'MYANMAR LETTER TTHA': 4108,
'MYANMAR LETTER U': 4133,
'MYANMAR LETTER UU': 4134,
'MYANMAR LETTER VOCALIC L': 4180,
'MYANMAR LETTER VOCALIC LL': 4181,
'MYANMAR LETTER VOCALIC R': 4178,
'MYANMAR LETTER VOCALIC RR': 4179,
'MYANMAR LETTER WA': 4125,
'MYANMAR LETTER YA': 4122,
'MYANMAR SIGN ANUSVARA': 4150,
'MYANMAR SIGN DOT BELOW': 4151,
'MYANMAR SIGN LITTLE SECTION': 4170,
'MYANMAR SIGN SECTION': 4171,
'MYANMAR SIGN VIRAMA': 4153,
'MYANMAR SIGN VISARGA': 4152,
'MYANMAR SYMBOL AFOREMENTIONED': 4174,
'MYANMAR SYMBOL COMPLETED': 4173,
'MYANMAR SYMBOL GENITIVE': 4175,
'MYANMAR SYMBOL LOCATIVE': 4172,
'MYANMAR VOWEL SIGN AA': 4140,
'MYANMAR VOWEL SIGN AI': 4146,
'MYANMAR VOWEL SIGN E': 4145,
'MYANMAR VOWEL SIGN I': 4141,
'MYANMAR VOWEL SIGN II': 4142,
'MYANMAR VOWEL SIGN U': 4143,
'MYANMAR VOWEL SIGN UU': 4144,
'MYANMAR VOWEL SIGN VOCALIC L': 4184,
'MYANMAR VOWEL SIGN VOCALIC LL': 4185,
'MYANMAR VOWEL SIGN VOCALIC R': 4182,
'MYANMAR VOWEL SIGN VOCALIC RR': 4183,
'N-ARY CIRCLED DOT OPERATOR': 10752,
'N-ARY CIRCLED PLUS OPERATOR': 10753,
'N-ARY CIRCLED TIMES OPERATOR': 10754,
'N-ARY COPRODUCT': 8720,
'N-ARY INTERSECTION': 8898,
'N-ARY LOGICAL AND': 8896,
'N-ARY LOGICAL OR': 8897,
'N-ARY PRODUCT': 8719,
'N-ARY SQUARE INTERSECTION OPERATOR': 10757,
'N-ARY SQUARE UNION OPERATOR': 10758,
'N-ARY SUMMATION': 8721,
'N-ARY TIMES OPERATOR': 10761,
'N-ARY UNION': 8899,
'N-ARY UNION OPERATOR WITH DOT': 10755,
'N-ARY UNION OPERATOR WITH PLUS': 10756,
'N-ARY WHITE VERTICAL BAR': 11007,
'NABLA': 8711,
'NAIRA SIGN': 8358,
'NAND': 8892,
'NARROW NO-BREAK SPACE': 8239,
'NATIONAL DIGIT SHAPES': 8302,
'NEGATED DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE': 8879,
'NEGATIVE CIRCLED DIGIT ZERO': 9471,
'NEGATIVE CIRCLED NUMBER EIGHTEEN': 9458,
'NEGATIVE CIRCLED NUMBER ELEVEN': 9451,
'NEGATIVE CIRCLED NUMBER FIFTEEN': 9455,
'NEGATIVE CIRCLED NUMBER FOURTEEN': 9454,
'NEGATIVE CIRCLED NUMBER NINETEEN': 9459,
'NEGATIVE CIRCLED NUMBER SEVENTEEN': 9457,
'NEGATIVE CIRCLED NUMBER SIXTEEN': 9456,
'NEGATIVE CIRCLED NUMBER THIRTEEN': 9453,
'NEGATIVE CIRCLED NUMBER TWELVE': 9452,
'NEGATIVE CIRCLED NUMBER TWENTY': 9460,
'NEITHER A SUBSET OF NOR EQUAL TO': 8840,
'NEITHER A SUPERSET OF NOR EQUAL TO': 8841,
'NEITHER APPROXIMATELY NOR ACTUALLY EQUAL TO': 8775,
'NEITHER GREATER-THAN NOR EQUAL TO': 8817,
'NEITHER GREATER-THAN NOR EQUIVALENT TO': 8821,
'NEITHER GREATER-THAN NOR LESS-THAN': 8825,
'NEITHER LESS-THAN NOR EQUAL TO': 8816,
'NEITHER LESS-THAN NOR EQUIVALENT TO': 8820,
'NEITHER LESS-THAN NOR GREATER-THAN': 8824,
'NEPTUNE': 9798,
'NEW SHEQEL SIGN': 8362,
'NEW TAI LUE DIGIT EIGHT': 6616,
'NEW TAI LUE DIGIT FIVE': 6613,
'NEW TAI LUE DIGIT FOUR': 6612,
'NEW TAI LUE DIGIT NINE': 6617,
'NEW TAI LUE DIGIT ONE': 6609,
'NEW TAI LUE DIGIT SEVEN': 6615,
'NEW TAI LUE DIGIT SIX': 6614,
'NEW TAI LUE DIGIT THREE': 6611,
'NEW TAI LUE DIGIT TWO': 6610,
'NEW TAI LUE DIGIT ZERO': 6608,
'NEW TAI LUE LETTER FINAL B': 6599,
'NEW TAI LUE LETTER FINAL D': 6598,
'NEW TAI LUE LETTER FINAL K': 6597,
'NEW TAI LUE LETTER FINAL M': 6596,
'NEW TAI LUE LETTER FINAL N': 6595,
'NEW TAI LUE LETTER FINAL NG': 6594,
'NEW TAI LUE LETTER FINAL V': 6593,
'NEW TAI LUE LETTER HIGH BA': 6562,
'NEW TAI LUE LETTER HIGH DA': 6561,
'NEW TAI LUE LETTER HIGH FA': 6554,
'NEW TAI LUE LETTER HIGH HA': 6560,
'NEW TAI LUE LETTER HIGH KA': 6530,
'NEW TAI LUE LETTER HIGH KVA': 6566,
'NEW TAI LUE LETTER HIGH LA': 6556,
'NEW TAI LUE LETTER HIGH MA': 6550,
'NEW TAI LUE LETTER HIGH NA': 6544,
'NEW TAI LUE LETTER HIGH NGA': 6532,
'NEW TAI LUE LETTER HIGH PA': 6548,
'NEW TAI LUE LETTER HIGH PHA': 6549,
'NEW TAI LUE LETTER HIGH QA': 6528,
'NEW TAI LUE LETTER HIGH SA': 6537,
'NEW TAI LUE LETTER HIGH TA': 6542,
'NEW TAI LUE LETTER HIGH THA': 6543,
'NEW TAI LUE LETTER HIGH TSA': 6536,
'NEW TAI LUE LETTER HIGH VA': 6555,
'NEW TAI LUE LETTER HIGH XA': 6531,
'NEW TAI LUE LETTER HIGH XVA': 6567,
'NEW TAI LUE LETTER HIGH YA': 6538,
'NEW TAI LUE LETTER LOW BA': 6565,
'NEW TAI LUE LETTER LOW DA': 6564,
'NEW TAI LUE LETTER LOW FA': 6557,
'NEW TAI LUE LETTER LOW HA': 6563,
'NEW TAI LUE LETTER LOW KA': 6533,
'NEW TAI LUE LETTER LOW KVA': 6568,
'NEW TAI LUE LETTER LOW LA': 6559,
'NEW TAI LUE LETTER LOW MA': 6553,
'NEW TAI LUE LETTER LOW NA': 6547,
'NEW TAI LUE LETTER LOW NGA': 6535,
'NEW TAI LUE LETTER LOW PA': 6551,
'NEW TAI LUE LETTER LOW PHA': 6552,
'NEW TAI LUE LETTER LOW QA': 6529,
'NEW TAI LUE LETTER LOW SA': 6540,
'NEW TAI LUE LETTER LOW TA': 6545,
'NEW TAI LUE LETTER LOW THA': 6546,
'NEW TAI LUE LETTER LOW TSA': 6539,
'NEW TAI LUE LETTER LOW VA': 6558,
'NEW TAI LUE LETTER LOW XA': 6534,
'NEW TAI LUE LETTER LOW XVA': 6569,
'NEW TAI LUE LETTER LOW YA': 6541,
'NEW TAI LUE SIGN LAE': 6622,
'NEW TAI LUE SIGN LAEV': 6623,
'NEW TAI LUE TONE MARK-1': 6600,
'NEW TAI LUE TONE MARK-2': 6601,
'NEW TAI LUE VOWEL SIGN AA': 6577,
'NEW TAI LUE VOWEL SIGN AAY': 6587,
'NEW TAI LUE VOWEL SIGN AE': 6582,
'NEW TAI LUE VOWEL SIGN AY': 6586,
'NEW TAI LUE VOWEL SIGN E': 6581,
'NEW TAI LUE VOWEL SIGN II': 6578,
'NEW TAI LUE VOWEL SIGN IY': 6592,
'NEW TAI LUE VOWEL SIGN O': 6583,
'NEW TAI LUE VOWEL SIGN OA': 6584,
'NEW TAI LUE VOWEL SIGN OAY': 6590,
'NEW TAI LUE VOWEL SIGN OY': 6589,
'NEW TAI LUE VOWEL SIGN U': 6579,
'NEW TAI LUE VOWEL SIGN UE': 6585,
'NEW TAI LUE VOWEL SIGN UEY': 6591,
'NEW TAI LUE VOWEL SIGN UU': 6580,
'NEW TAI LUE VOWEL SIGN UY': 6588,
'NEW TAI LUE VOWEL SIGN VOWEL SHORTENER': 6576,
'NEXT PAGE': 9112,
'NO-BREAK SPACE': 160,
'NOMINAL DIGIT SHAPES': 8303,
'NON-BREAKING HYPHEN': 8209,
'NONFORKING': 10973,
'NOR': 8893,
'NORMAL SUBGROUP OF': 8882,
'NORMAL SUBGROUP OF OR EQUAL TO': 8884,
'NORTH EAST AND SOUTH WEST ARROW': 10530,
'NORTH EAST ARROW': 8599,
'NORTH EAST ARROW AND SOUTH EAST ARROW': 10536,
'NORTH EAST ARROW CROSSING NORTH WEST ARROW': 10545,
'NORTH EAST ARROW CROSSING SOUTH EAST ARROW': 10542,
'NORTH EAST ARROW WITH HOOK': 10532,
'NORTH EAST BLACK ARROW': 11016,
'NORTH EAST DOUBLE ARROW': 8663,
'NORTH EAST WHITE ARROW': 11008,
'NORTH WEST AND SOUTH EAST ARROW': 10529,
'NORTH WEST ARROW': 8598,
'NORTH WEST ARROW AND NORTH EAST ARROW': 10535,
'NORTH WEST ARROW CROSSING NORTH EAST ARROW': 10546,
'NORTH WEST ARROW TO CORNER': 8689,
'NORTH WEST ARROW TO LONG BAR': 8632,
'NORTH WEST ARROW WITH HOOK': 10531,
'NORTH WEST BLACK ARROW': 11017,
'NORTH WEST DOUBLE ARROW': 8662,
'NORTH WEST WHITE ARROW': 11009,
'NOT A SUBSET OF': 8836,
'NOT A SUPERSET OF': 8837,
'NOT ALMOST EQUAL TO': 8777,
'NOT AN ELEMENT OF': 8713,
'NOT ASYMPTOTICALLY EQUAL TO': 8772,
'NOT CHECK MARK': 9083,
'NOT EQUAL TO': 8800,
'NOT EQUIVALENT TO': 8813,
'NOT GREATER-THAN': 8815,
'NOT IDENTICAL TO': 8802,
'NOT LESS-THAN': 8814,
'NOT NORMAL SUBGROUP OF': 8938,
'NOT NORMAL SUBGROUP OF OR EQUAL TO': 8940,
'NOT PARALLEL TO': 8742,
'NOT SIGN': 172,
'NOT SQUARE IMAGE OF OR EQUAL TO': 8930,
'NOT SQUARE ORIGINAL OF OR EQUAL TO': 8931,
'NOT TILDE': 8769,
'NOT TRUE': 8877,
'NOTCHED LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW': 10159,
'NOTCHED UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW': 10161,
'NUMBER EIGHTEEN FULL STOP': 9369,
'NUMBER ELEVEN FULL STOP': 9362,
'NUMBER FIFTEEN FULL STOP': 9366,
'NUMBER FOURTEEN FULL STOP': 9365,
'NUMBER NINETEEN FULL STOP': 9370,
'NUMBER SEVENTEEN FULL STOP': 9368,
'NUMBER SIGN': 35,
'NUMBER SIXTEEN FULL STOP': 9367,
'NUMBER TEN FULL STOP': 9361,
'NUMBER THIRTEEN FULL STOP': 9364,
'NUMBER TWELVE FULL STOP': 9363,
'NUMBER TWENTY FULL STOP': 9371,
'NUMERO SIGN': 8470,
'OBJECT REPLACEMENT CHARACTER': 65532,
'OBLIQUE ANGLE OPENING DOWN': 10663,
'OBLIQUE ANGLE OPENING UP': 10662,
'OCR AMOUNT OF CHECK': 9287,
'OCR BELT BUCKLE': 9284,
'OCR BOW TIE': 9285,
'OCR BRANCH BANK IDENTIFICATION': 9286,
'OCR CHAIR': 9281,
'OCR CUSTOMER ACCOUNT NUMBER': 9289,
'OCR DASH': 9288,
'OCR DOUBLE BACKSLASH': 9290,
'OCR FORK': 9282,
'OCR HOOK': 9280,
'OCR INVERTED FORK': 9283,
'OGHAM FEATHER MARK': 5787,
'OGHAM LETTER AILM': 5776,
'OGHAM LETTER BEITH': 5761,
'OGHAM LETTER CEIRT': 5770,
'OGHAM LETTER COLL': 5769,
'OGHAM LETTER DAIR': 5767,
'OGHAM LETTER EABHADH': 5781,
'OGHAM LETTER EADHADH': 5779,
'OGHAM LETTER EAMHANCHOLL': 5785,
'OGHAM LETTER FEARN': 5763,
'OGHAM LETTER GORT': 5772,
'OGHAM LETTER IFIN': 5784,
'OGHAM LETTER IODHADH': 5780,
'OGHAM LETTER LUIS': 5762,
'OGHAM LETTER MUIN': 5771,
'OGHAM LETTER NGEADAL': 5773,
'OGHAM LETTER NION': 5765,
'OGHAM LETTER ONN': 5777,
'OGHAM LETTER OR': 5782,
'OGHAM LETTER PEITH': 5786,
'OGHAM LETTER RUIS': 5775,
'OGHAM LETTER SAIL': 5764,
'OGHAM LETTER STRAIF': 5774,
'OGHAM LETTER TINNE': 5768,
'OGHAM LETTER UATH': 5766,
'OGHAM LETTER UILLEANN': 5783,
'OGHAM LETTER UR': 5778,
'OGHAM REVERSED FEATHER MARK': 5788,
'OGHAM SPACE MARK': 5760,
'OGONEK': 731,
'OHM SIGN': 8486,
'OLD ITALIC LETTER A': 66304,
'OLD ITALIC LETTER BE': 66305,
'OLD ITALIC LETTER CHE': 66332,
'OLD ITALIC LETTER DE': 66307,
'OLD ITALIC LETTER E': 66308,
'OLD ITALIC LETTER EF': 66330,
'OLD ITALIC LETTER EKS': 66327,
'OLD ITALIC LETTER EL': 66315,
'OLD ITALIC LETTER EM': 66316,
'OLD ITALIC LETTER EN': 66317,
'OLD ITALIC LETTER ER': 66323,
'OLD ITALIC LETTER ERS': 66331,
'OLD ITALIC LETTER ES': 66324,
'OLD ITALIC LETTER ESH': 66318,
'OLD ITALIC LETTER HE': 66311,
'OLD ITALIC LETTER I': 66313,
'OLD ITALIC LETTER II': 66333,
'OLD ITALIC LETTER KA': 66314,
'OLD ITALIC LETTER KE': 66306,
'OLD ITALIC LETTER KHE': 66329,
'OLD ITALIC LETTER KU': 66322,
'OLD ITALIC LETTER O': 66319,
'OLD ITALIC LETTER PE': 66320,
'OLD ITALIC LETTER PHE': 66328,
'OLD ITALIC LETTER SHE': 66321,
'OLD ITALIC LETTER TE': 66325,
'OLD ITALIC LETTER THE': 66312,
'OLD ITALIC LETTER U': 66326,
'OLD ITALIC LETTER UU': 66334,
'OLD ITALIC LETTER VE': 66309,
'OLD ITALIC LETTER ZE': 66310,
'OLD ITALIC NUMERAL FIFTY': 66339,
'OLD ITALIC NUMERAL FIVE': 66337,
'OLD ITALIC NUMERAL ONE': 66336,
'OLD ITALIC NUMERAL TEN': 66338,
'OLD PERSIAN NUMBER HUNDRED': 66517,
'OLD PERSIAN NUMBER ONE': 66513,
'OLD PERSIAN NUMBER TEN': 66515,
'OLD PERSIAN NUMBER TWENTY': 66516,
'OLD PERSIAN NUMBER TWO': 66514,
'OLD PERSIAN SIGN A': 66464,
'OLD PERSIAN SIGN AURAMAZDAA': 66504,
'OLD PERSIAN SIGN AURAMAZDAA-2': 66505,
'OLD PERSIAN SIGN AURAMAZDAAHA': 66506,
'OLD PERSIAN SIGN BA': 66482,
'OLD PERSIAN SIGN BAGA': 66510,
'OLD PERSIAN SIGN BUUMISH': 66511,
'OLD PERSIAN SIGN CA': 66472,
'OLD PERSIAN SIGN DA': 66477,
'OLD PERSIAN SIGN DAHYAAUSH': 66508,
'OLD PERSIAN SIGN DAHYAAUSH-2': 66509,
'OLD PERSIAN SIGN DI': 66478,
'OLD PERSIAN SIGN DU': 66479,
'OLD PERSIAN SIGN FA': 66483,
'OLD PERSIAN SIGN GA': 66469,
'OLD PERSIAN SIGN GU': 66470,
'OLD PERSIAN SIGN HA': 66499,
'OLD PERSIAN SIGN I': 66465,
'OLD PERSIAN SIGN JA': 66473,
'OLD PERSIAN SIGN JI': 66474,
'OLD PERSIAN SIGN KA': 66467,
'OLD PERSIAN SIGN KU': 66468,
'OLD PERSIAN SIGN LA': 66494,
'OLD PERSIAN SIGN MA': 66486,
'OLD PERSIAN SIGN MI': 66487,
'OLD PERSIAN SIGN MU': 66488,
'OLD PERSIAN SIGN NA': 66484,
'OLD PERSIAN SIGN NU': 66485,
'OLD PERSIAN SIGN PA': 66481,
'OLD PERSIAN SIGN RA': 66492,
'OLD PERSIAN SIGN RU': 66493,
'OLD PERSIAN SIGN SA': 66495,
'OLD PERSIAN SIGN SHA': 66497,
'OLD PERSIAN SIGN SSA': 66498,
'OLD PERSIAN SIGN TA': 66475,
'OLD PERSIAN SIGN THA': 66480,
'OLD PERSIAN SIGN TU': 66476,
'OLD PERSIAN SIGN U': 66466,
'OLD PERSIAN SIGN VA': 66490,
'OLD PERSIAN SIGN VI': 66491,
'OLD PERSIAN SIGN XA': 66471,
'OLD PERSIAN SIGN XSHAAYATHIYA': 66507,
'OLD PERSIAN SIGN YA': 66489,
'OLD PERSIAN SIGN ZA': 66496,
'OLD PERSIAN WORD DIVIDER': 66512,
'ONE DOT LEADER': 8228,
'OPEN BOX': 9251,
'OPEN CENTRE ASTERISK': 10034,
'OPEN CENTRE BLACK STAR': 10027,
'OPEN CENTRE CROSS': 10011,
'OPEN CENTRE TEARDROP-SPOKED ASTERISK': 10044,
'OPEN SUBSET': 10179,
'OPEN SUPERSET': 10180,
'OPEN-CIRCUIT-OUTPUT H-TYPE SYMBOL': 9103,
'OPEN-CIRCUIT-OUTPUT L-TYPE SYMBOL': 9104,
'OPEN-OUTLINED RIGHTWARDS ARROW': 10174,
'OPPOSITION': 9741,
'OPTION KEY': 8997,
'ORIGINAL OF': 8886,
'ORIYA AI LENGTH MARK': 2902,
'ORIYA AU LENGTH MARK': 2903,
'ORIYA DIGIT EIGHT': 2926,
'ORIYA DIGIT FIVE': 2923,
'ORIYA DIGIT FOUR': 2922,
'ORIYA DIGIT NINE': 2927,
'ORIYA DIGIT ONE': 2919,
'ORIYA DIGIT SEVEN': 2925,
'ORIYA DIGIT SIX': 2924,
'ORIYA DIGIT THREE': 2921,
'ORIYA DIGIT TWO': 2920,
'ORIYA DIGIT ZERO': 2918,
'ORIYA ISSHAR': 2928,
'ORIYA LETTER A': 2821,
'ORIYA LETTER AA': 2822,
'ORIYA LETTER AI': 2832,
'ORIYA LETTER AU': 2836,
'ORIYA LETTER BA': 2860,
'ORIYA LETTER BHA': 2861,
'ORIYA LETTER CA': 2842,
'ORIYA LETTER CHA': 2843,
'ORIYA LETTER DA': 2854,
'ORIYA LETTER DDA': 2849,
'ORIYA LETTER DDHA': 2850,
'ORIYA LETTER DHA': 2855,
'ORIYA LETTER E': 2831,
'ORIYA LETTER GA': 2839,
'ORIYA LETTER GHA': 2840,
'ORIYA LETTER HA': 2873,
'ORIYA LETTER I': 2823,
'ORIYA LETTER II': 2824,
'ORIYA LETTER JA': 2844,
'ORIYA LETTER JHA': 2845,
'ORIYA LETTER KA': 2837,
'ORIYA LETTER KHA': 2838,
'ORIYA LETTER LA': 2866,
'ORIYA LETTER LLA': 2867,
'ORIYA LETTER MA': 2862,
'ORIYA LETTER NA': 2856,
'ORIYA LETTER NGA': 2841,
'ORIYA LETTER NNA': 2851,
'ORIYA LETTER NYA': 2846,
'ORIYA LETTER O': 2835,
'ORIYA LETTER PA': 2858,
'ORIYA LETTER PHA': 2859,
'ORIYA LETTER RA': 2864,
'ORIYA LETTER RHA': 2909,
'ORIYA LETTER RRA': 2908,
'ORIYA LETTER SA': 2872,
'ORIYA LETTER SHA': 2870,
'ORIYA LETTER SSA': 2871,
'ORIYA LETTER TA': 2852,
'ORIYA LETTER THA': 2853,
'ORIYA LETTER TTA': 2847,
'ORIYA LETTER TTHA': 2848,
'ORIYA LETTER U': 2825,
'ORIYA LETTER UU': 2826,
'ORIYA LETTER VA': 2869,
'ORIYA LETTER VOCALIC L': 2828,
'ORIYA LETTER VOCALIC LL': 2913,
'ORIYA LETTER VOCALIC R': 2827,
'ORIYA LETTER VOCALIC RR': 2912,
'ORIYA LETTER WA': 2929,
'ORIYA LETTER YA': 2863,
'ORIYA LETTER YYA': 2911,
'ORIYA SIGN ANUSVARA': 2818,
'ORIYA SIGN AVAGRAHA': 2877,
'ORIYA SIGN CANDRABINDU': 2817,
'ORIYA SIGN NUKTA': 2876,
'ORIYA SIGN VIRAMA': 2893,
'ORIYA SIGN VISARGA': 2819,
'ORIYA VOWEL SIGN AA': 2878,
'ORIYA VOWEL SIGN AI': 2888,
'ORIYA VOWEL SIGN AU': 2892,
'ORIYA VOWEL SIGN E': 2887,
'ORIYA VOWEL SIGN I': 2879,
'ORIYA VOWEL SIGN II': 2880,
'ORIYA VOWEL SIGN O': 2891,
'ORIYA VOWEL SIGN U': 2881,
'ORIYA VOWEL SIGN UU': 2882,
'ORIYA VOWEL SIGN VOCALIC R': 2883,
'ORNATE LEFT PARENTHESIS': 64830,
'ORNATE RIGHT PARENTHESIS': 64831,
'ORTHODOX CROSS': 9766,
'OSMANYA DIGIT EIGHT': 66728,
'OSMANYA DIGIT FIVE': 66725,
'OSMANYA DIGIT FOUR': 66724,
'OSMANYA DIGIT NINE': 66729,
'OSMANYA DIGIT ONE': 66721,
'OSMANYA DIGIT SEVEN': 66727,
'OSMANYA DIGIT SIX': 66726,
'OSMANYA DIGIT THREE': 66723,
'OSMANYA DIGIT TWO': 66722,
'OSMANYA DIGIT ZERO': 66720,
'OSMANYA LETTER A': 66710,
'OSMANYA LETTER AA': 66715,
'OSMANYA LETTER ALEF': 66688,
'OSMANYA LETTER BA': 66689,
'OSMANYA LETTER CAYN': 66699,
'OSMANYA LETTER DEEL': 66694,
'OSMANYA LETTER DHA': 66698,
'OSMANYA LETTER E': 66711,
'OSMANYA LETTER EE': 66716,
'OSMANYA LETTER FA': 66701,
'OSMANYA LETTER GA': 66700,
'OSMANYA LETTER HA': 66708,
'OSMANYA LETTER I': 66712,
'OSMANYA LETTER JA': 66691,
'OSMANYA LETTER KAAF': 66703,
'OSMANYA LETTER KHA': 66693,
'OSMANYA LETTER LAAN': 66704,
'OSMANYA LETTER MIIN': 66705,
'OSMANYA LETTER NUUN': 66706,
'OSMANYA LETTER O': 66713,
'OSMANYA LETTER OO': 66717,
'OSMANYA LETTER QAAF': 66702,
'OSMANYA LETTER RA': 66695,
'OSMANYA LETTER SA': 66696,
'OSMANYA LETTER SHIIN': 66697,
'OSMANYA LETTER TA': 66690,
'OSMANYA LETTER U': 66714,
'OSMANYA LETTER WAW': 66707,
'OSMANYA LETTER XA': 66692,
'OSMANYA LETTER YA': 66709,
'OUNCE SIGN': 8485,
'OUTLINED BLACK STAR': 10029,
'OUTLINED GREEK CROSS': 10009,
'OUTLINED LATIN CROSS': 10015,
'OVERLINE': 8254,
'PARAGRAPH SEPARATOR': 8233,
'PARAGRAPHOS': 11791,
'PARALLEL TO': 8741,
'PARALLEL WITH HORIZONTAL STROKE': 10994,
'PARALLEL WITH TILDE OPERATOR': 10995,
'PARENTHESIZED DIGIT EIGHT': 9339,
'PARENTHESIZED DIGIT FIVE': 9336,
'PARENTHESIZED DIGIT FOUR': 9335,
'PARENTHESIZED DIGIT NINE': 9340,
'PARENTHESIZED DIGIT ONE': 9332,
'PARENTHESIZED DIGIT SEVEN': 9338,
'PARENTHESIZED DIGIT SIX': 9337,
'PARENTHESIZED DIGIT THREE': 9334,
'PARENTHESIZED DIGIT TWO': 9333,
'PARENTHESIZED HANGUL CHIEUCH': 12809,
'PARENTHESIZED HANGUL CHIEUCH A': 12823,
'PARENTHESIZED HANGUL CIEUC': 12808,
'PARENTHESIZED HANGUL CIEUC A': 12822,
'PARENTHESIZED HANGUL CIEUC U': 12828,
'PARENTHESIZED HANGUL HIEUH': 12813,
'PARENTHESIZED HANGUL HIEUH A': 12827,
'PARENTHESIZED HANGUL IEUNG': 12807,
'PARENTHESIZED HANGUL IEUNG A': 12821,
'PARENTHESIZED HANGUL KHIEUKH': 12810,
'PARENTHESIZED HANGUL KHIEUKH A': 12824,
'PARENTHESIZED HANGUL KIYEOK': 12800,
'PARENTHESIZED HANGUL KIYEOK A': 12814,
'PARENTHESIZED HANGUL MIEUM': 12804,
'PARENTHESIZED HANGUL MIEUM A': 12818,
'PARENTHESIZED HANGUL NIEUN': 12801,
'PARENTHESIZED HANGUL NIEUN A': 12815,
'PARENTHESIZED HANGUL PHIEUPH': 12812,
'PARENTHESIZED HANGUL PHIEUPH A': 12826,
'PARENTHESIZED HANGUL PIEUP': 12805,
'PARENTHESIZED HANGUL PIEUP A': 12819,
'PARENTHESIZED HANGUL RIEUL': 12803,
'PARENTHESIZED HANGUL RIEUL A': 12817,
'PARENTHESIZED HANGUL SIOS': 12806,
'PARENTHESIZED HANGUL SIOS A': 12820,
'PARENTHESIZED HANGUL THIEUTH': 12811,
'PARENTHESIZED HANGUL THIEUTH A': 12825,
'PARENTHESIZED HANGUL TIKEUT': 12802,
'PARENTHESIZED HANGUL TIKEUT A': 12816,
'PARENTHESIZED IDEOGRAPH ALLIANCE': 12863,
'PARENTHESIZED IDEOGRAPH CALL': 12858,
'PARENTHESIZED IDEOGRAPH CONGRATULATION': 12855,
'PARENTHESIZED IDEOGRAPH EARTH': 12847,
'PARENTHESIZED IDEOGRAPH EIGHT': 12839,
'PARENTHESIZED IDEOGRAPH ENTERPRISE': 12861,
'PARENTHESIZED IDEOGRAPH FESTIVAL': 12864,
'PARENTHESIZED IDEOGRAPH FINANCIAL': 12854,
'PARENTHESIZED IDEOGRAPH FIRE': 12843,
'PARENTHESIZED IDEOGRAPH FIVE': 12836,
'PARENTHESIZED IDEOGRAPH FOUR': 12835,
'PARENTHESIZED IDEOGRAPH HAVE': 12850,
'PARENTHESIZED IDEOGRAPH LABOR': 12856,
'PARENTHESIZED IDEOGRAPH METAL': 12846,
'PARENTHESIZED IDEOGRAPH MOON': 12842,
'PARENTHESIZED IDEOGRAPH NAME': 12852,
'PARENTHESIZED IDEOGRAPH NINE': 12840,
'PARENTHESIZED IDEOGRAPH ONE': 12832,
'PARENTHESIZED IDEOGRAPH REACH': 12867,
'PARENTHESIZED IDEOGRAPH REPRESENT': 12857,
'PARENTHESIZED IDEOGRAPH RESOURCE': 12862,
'PARENTHESIZED IDEOGRAPH REST': 12865,
'PARENTHESIZED IDEOGRAPH SELF': 12866,
'PARENTHESIZED IDEOGRAPH SEVEN': 12838,
'PARENTHESIZED IDEOGRAPH SIX': 12837,
'PARENTHESIZED IDEOGRAPH SOCIETY': 12851,
'PARENTHESIZED IDEOGRAPH SPECIAL': 12853,
'PARENTHESIZED IDEOGRAPH STOCK': 12849,
'PARENTHESIZED IDEOGRAPH STUDY': 12859,
'PARENTHESIZED IDEOGRAPH SUN': 12848,
'PARENTHESIZED IDEOGRAPH SUPERVISE': 12860,
'PARENTHESIZED IDEOGRAPH TEN': 12841,
'PARENTHESIZED IDEOGRAPH THREE': 12834,
'PARENTHESIZED IDEOGRAPH TWO': 12833,
'PARENTHESIZED IDEOGRAPH WATER': 12844,
'PARENTHESIZED IDEOGRAPH WOOD': 12845,
'PARENTHESIZED KOREAN CHARACTER O HU': 12830,
'PARENTHESIZED KOREAN CHARACTER OJEON': 12829,
'PARENTHESIZED LATIN SMALL LETTER A': 9372,
'PARENTHESIZED LATIN SMALL LETTER B': 9373,
'PARENTHESIZED LATIN SMALL LETTER C': 9374,
'PARENTHESIZED LATIN SMALL LETTER D': 9375,
'PARENTHESIZED LATIN SMALL LETTER E': 9376,
'PARENTHESIZED LATIN SMALL LETTER F': 9377,
'PARENTHESIZED LATIN SMALL LETTER G': 9378,
'PARENTHESIZED LATIN SMALL LETTER H': 9379,
'PARENTHESIZED LATIN SMALL LETTER I': 9380,
'PARENTHESIZED LATIN SMALL LETTER J': 9381,
'PARENTHESIZED LATIN SMALL LETTER K': 9382,
'PARENTHESIZED LATIN SMALL LETTER L': 9383,
'PARENTHESIZED LATIN SMALL LETTER M': 9384,
'PARENTHESIZED LATIN SMALL LETTER N': 9385,
'PARENTHESIZED LATIN SMALL LETTER O': 9386,
'PARENTHESIZED LATIN SMALL LETTER P': 9387,
'PARENTHESIZED LATIN SMALL LETTER Q': 9388,
'PARENTHESIZED LATIN SMALL LETTER R': 9389,
'PARENTHESIZED LATIN SMALL LETTER S': 9390,
'PARENTHESIZED LATIN SMALL LETTER T': 9391,
'PARENTHESIZED LATIN SMALL LETTER U': 9392,
'PARENTHESIZED LATIN SMALL LETTER V': 9393,
'PARENTHESIZED LATIN SMALL LETTER W': 9394,
'PARENTHESIZED LATIN SMALL LETTER X': 9395,
'PARENTHESIZED LATIN SMALL LETTER Y': 9396,
'PARENTHESIZED LATIN SMALL LETTER Z': 9397,
'PARENTHESIZED NUMBER EIGHTEEN': 9349,
'PARENTHESIZED NUMBER ELEVEN': 9342,
'PARENTHESIZED NUMBER FIFTEEN': 9346,
'PARENTHESIZED NUMBER FOURTEEN': 9345,
'PARENTHESIZED NUMBER NINETEEN': 9350,
'PARENTHESIZED NUMBER SEVENTEEN': 9348,
'PARENTHESIZED NUMBER SIXTEEN': 9347,
'PARENTHESIZED NUMBER TEN': 9341,
'PARENTHESIZED NUMBER THIRTEEN': 9344,
'PARENTHESIZED NUMBER TWELVE': 9343,
'PARENTHESIZED NUMBER TWENTY': 9351,
'PART ALTERNATION MARK': 12349,
'PARTIAL DIFFERENTIAL': 8706,
'PARTIALLY-RECYCLED PAPER SYMBOL': 9853,
'PARTNERSHIP SIGN': 12880,
'PASSIVE-PULL-DOWN-OUTPUT SYMBOL': 9105,
'PASSIVE-PULL-UP-OUTPUT SYMBOL': 9106,
'PEACE SYMBOL': 9774,
'PENCIL': 9999,
'PER MILLE SIGN': 8240,
'PER SIGN': 8524,
'PER TEN THOUSAND SIGN': 8241,
'PERCENT SIGN': 37,
'PERMANENT PAPER SIGN': 9854,
'PERPENDICULAR': 10178,
'PERPENDICULAR WITH S': 10977,
'PERSPECTIVE': 8966,
'PESETA SIGN': 8359,
'PESO SIGN': 8369,
'PHILIPPINE DOUBLE PUNCTUATION': 5942,
'PHILIPPINE SINGLE PUNCTUATION': 5941,
'PILCROW SIGN': 182,
'PINWHEEL STAR': 10031,
'PISCES': 9811,
'PITCHFORK': 8916,
'PITCHFORK WITH TEE TOP': 10970,
'PLACE OF INTEREST SIGN': 8984,
'PLANCK CONSTANT': 8462,
'PLANCK CONSTANT OVER TWO PI': 8463,
'PLUS SIGN': 43,
'PLUS SIGN ABOVE EQUALS SIGN': 10866,
'PLUS SIGN IN LEFT HALF CIRCLE': 10797,
'PLUS SIGN IN RIGHT HALF CIRCLE': 10798,
'PLUS SIGN IN TRIANGLE': 10809,
'PLUS SIGN WITH BLACK TRIANGLE': 10792,
'PLUS SIGN WITH CIRCUMFLEX ACCENT ABOVE': 10787,
'PLUS SIGN WITH DOT BELOW': 10789,
'PLUS SIGN WITH SMALL CIRCLE ABOVE': 10786,
'PLUS SIGN WITH SUBSCRIPT TWO': 10791,
'PLUS SIGN WITH TILDE ABOVE': 10788,
'PLUS SIGN WITH TILDE BELOW': 10790,
'PLUS-MINUS SIGN': 177,
'PLUTO': 9799,
'POP DIRECTIONAL FORMATTING': 8236,
'POSITION INDICATOR': 8982,
'POSTAL MARK': 12306,
'POSTAL MARK FACE': 12320,
'POUND SIGN': 163,
'PRECEDES': 8826,
'PRECEDES ABOVE ALMOST EQUAL TO': 10935,
'PRECEDES ABOVE EQUALS SIGN': 10931,
'PRECEDES ABOVE NOT ALMOST EQUAL TO': 10937,
'PRECEDES ABOVE NOT EQUAL TO': 10933,
'PRECEDES ABOVE SINGLE-LINE EQUALS SIGN': 10927,
'PRECEDES ABOVE SINGLE-LINE NOT EQUAL TO': 10929,
'PRECEDES BUT NOT EQUIVALENT TO': 8936,
'PRECEDES OR EQUAL TO': 8828,
'PRECEDES OR EQUIVALENT TO': 8830,
'PRECEDES UNDER RELATION': 8880,
'PRESCRIPTION TAKE': 8478,
'PRESENTATION FORM FOR VERTICAL COLON': 65043,
'PRESENTATION FORM FOR VERTICAL COMMA': 65040,
'PRESENTATION FORM FOR VERTICAL EM DASH': 65073,
'PRESENTATION FORM FOR VERTICAL EN DASH': 65074,
'PRESENTATION FORM FOR VERTICAL EXCLAMATION MARK': 65045,
'PRESENTATION FORM FOR VERTICAL HORIZONTAL ELLIPSIS': 65049,
'PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC COMMA': 65041,
'PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC FULL STOP': 65042,
'PRESENTATION FORM FOR VERTICAL LEFT ANGLE BRACKET': 65087,
'PRESENTATION FORM FOR VERTICAL LEFT BLACK LENTICULAR BRACKET': 65083,
'PRESENTATION FORM FOR VERTICAL LEFT CORNER BRACKET': 65089,
'PRESENTATION FORM FOR VERTICAL LEFT CURLY BRACKET': 65079,
'PRESENTATION FORM FOR VERTICAL LEFT DOUBLE ANGLE BRACKET': 65085,
'PRESENTATION FORM FOR VERTICAL LEFT PARENTHESIS': 65077,
'PRESENTATION FORM FOR VERTICAL LEFT SQUARE BRACKET': 65095,
'PRESENTATION FORM FOR VERTICAL LEFT TORTOISE SHELL BRACKET': 65081,
'PRESENTATION FORM FOR VERTICAL LEFT WHITE CORNER BRACKET': 65091,
'PRESENTATION FORM FOR VERTICAL LEFT WHITE LENTICULAR BRACKET': 65047,
'PRESENTATION FORM FOR VERTICAL LOW LINE': 65075,
'PRESENTATION FORM FOR VERTICAL QUESTION MARK': 65046,
'PRESENTATION FORM FOR VERTICAL RIGHT ANGLE BRACKET': 65088,
'PRESENTATION FORM FOR VERTICAL RIGHT BLACK LENTICULAR BRACKET': 65084,
'PRESENTATION FORM FOR VERTICAL RIGHT CORNER BRACKET': 65090,
'PRESENTATION FORM FOR VERTICAL RIGHT CURLY BRACKET': 65080,
'PRESENTATION FORM FOR VERTICAL RIGHT DOUBLE ANGLE BRACKET': 65086,
'PRESENTATION FORM FOR VERTICAL RIGHT PARENTHESIS': 65078,
'PRESENTATION FORM FOR VERTICAL RIGHT SQUARE BRACKET': 65096,
'PRESENTATION FORM FOR VERTICAL RIGHT TORTOISE SHELL BRACKET': 65082,
'PRESENTATION FORM FOR VERTICAL RIGHT WHITE CORNER BRACKET': 65092,
'PRESENTATION FORM FOR VERTICAL RIGHT WHITE LENTICULAR BRAKCET': 65048,
'PRESENTATION FORM FOR VERTICAL SEMICOLON': 65044,
'PRESENTATION FORM FOR VERTICAL TWO DOT LEADER': 65072,
'PRESENTATION FORM FOR VERTICAL WAVY LOW LINE': 65076,
'PREVIOUS PAGE': 9111,
'PRIME': 8242,
'PRINT SCREEN SYMBOL': 9113,
'PROJECTIVE': 8965,
'PROPERTY LINE': 8522,
'PROPORTION': 8759,
'PROPORTIONAL TO': 8733,
'PUNCTUATION SPACE': 8200,
'QUADRANT LOWER LEFT': 9622,
'QUADRANT LOWER RIGHT': 9623,
'QUADRANT UPPER LEFT': 9624,
'QUADRANT UPPER LEFT AND LOWER LEFT AND LOWER RIGHT': 9625,
'QUADRANT UPPER LEFT AND LOWER RIGHT': 9626,
'QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER LEFT': 9627,
'QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER RIGHT': 9628,
'QUADRANT UPPER RIGHT': 9629,
'QUADRANT UPPER RIGHT AND LOWER LEFT': 9630,
'QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT': 9631,
'QUADRUPLE INTEGRAL OPERATOR': 10764,
'QUADRUPLE PRIME': 8279,
'QUARTER NOTE': 9833,
'QUATERNION INTEGRAL OPERATOR': 10774,
'QUESTION EXCLAMATION MARK': 8264,
'QUESTION MARK': 63,
'QUESTIONED EQUAL TO': 8799,
'QUOTATION MARK': 34,
'RADICAL SYMBOL BOTTOM': 9143,
'RADIOACTIVE SIGN': 9762,
'RAISED DOTTED INTERPOLATION MARKER': 11783,
'RAISED INTERPOLATION MARKER': 11782,
'RAISED SQUARE': 11787,
'RATIO': 8758,
'RECYCLED PAPER SYMBOL': 9852,
'RECYCLING SYMBOL FOR GENERIC MATERIALS': 9850,
'RECYCLING SYMBOL FOR TYPE-1 PLASTICS': 9843,
'RECYCLING SYMBOL FOR TYPE-2 PLASTICS': 9844,
'RECYCLING SYMBOL FOR TYPE-3 PLASTICS': 9845,
'RECYCLING SYMBOL FOR TYPE-4 PLASTICS': 9846,
'RECYCLING SYMBOL FOR TYPE-5 PLASTICS': 9847,
'RECYCLING SYMBOL FOR TYPE-6 PLASTICS': 9848,
'RECYCLING SYMBOL FOR TYPE-7 PLASTICS': 9849,
'REFERENCE MARK': 8251,
'REGISTERED SIGN': 174,
'REPLACEMENT CHARACTER': 65533,
'RESPONSE': 8479,
'RETURN SYMBOL': 9166,
'REVERSE SOLIDUS': 92,
'REVERSE SOLIDUS OPERATOR': 10741,
'REVERSE SOLIDUS WITH HORIZONTAL STROKE': 10743,
'REVERSED ANGLE': 10659,
'REVERSED ANGLE WITH UNDERBAR': 10661,
'REVERSED DOUBLE PRIME': 8246,
'REVERSED DOUBLE PRIME QUOTATION MARK': 12317,
'REVERSED DOUBLE STROKE NOT SIGN': 10989,
'REVERSED EMPTY SET': 10672,
'REVERSED FORKED PARAGRAPHOS': 11793,
'REVERSED NOT SIGN': 8976,
'REVERSED PILCROW SIGN': 8267,
'REVERSED PRIME': 8245,
'REVERSED ROTATED FLORAL HEART BULLET': 9753,
'REVERSED SANS-SERIF CAPITAL L': 8515,
'REVERSED SEMICOLON': 8271,
'REVERSED TILDE': 8765,
'REVERSED TILDE EQUALS': 8909,
'REVERSED TRIPLE PRIME': 8247,
'RIAL SIGN': 65020,
'RIGHT ANGLE': 8735,
'RIGHT ANGLE BRACKET': 12297,
'RIGHT ANGLE BRACKET WITH DOT': 10642,
'RIGHT ANGLE DOTTED SUBSTITUTION MARKER': 11777,
'RIGHT ANGLE SUBSTITUTION MARKER': 11776,
'RIGHT ANGLE VARIANT WITH SQUARE': 10652,
'RIGHT ANGLE WITH ARC': 8894,
'RIGHT ANGLE WITH DOWNWARDS ZIGZAG ARROW': 9084,
'RIGHT ARC GREATER-THAN BRACKET': 10644,
'RIGHT ARROW WITH CIRCLED PLUS': 10228,
'RIGHT ARROW WITH SMALL CIRCLE': 8692,
'RIGHT BLACK LENTICULAR BRACKET': 12305,
'RIGHT BLACK TORTOISE SHELL BRACKET': 10648,
'RIGHT CEILING': 8969,
'RIGHT CORNER BRACKET': 12301,
'RIGHT CURLY BRACKET': 125,
'RIGHT CURLY BRACKET LOWER HOOK': 9133,
'RIGHT CURLY BRACKET MIDDLE PIECE': 9132,
'RIGHT CURLY BRACKET UPPER HOOK': 9131,
'RIGHT DOTTED SUBSTITUTION BRACKET': 11781,
'RIGHT DOUBLE ANGLE BRACKET': 12299,
'RIGHT DOUBLE ARROW WITH ROUNDED HEAD': 10608,
'RIGHT DOUBLE QUOTATION MARK': 8221,
'RIGHT DOUBLE WIGGLY FENCE': 10715,
'RIGHT FISH TAIL': 10621,
'RIGHT FLOOR': 8971,
'RIGHT HALF BLACK CIRCLE': 9687,
'RIGHT HALF BLOCK': 9616,
'RIGHT LOW PARAPHRASE BRACKET': 11805,
'RIGHT NORMAL FACTOR SEMIDIRECT PRODUCT': 8906,
'RIGHT ONE EIGHTH BLOCK': 9621,
'RIGHT OUTER JOIN': 10198,
'RIGHT PARENTHESIS': 41,
'RIGHT PARENTHESIS EXTENSION': 9119,
'RIGHT PARENTHESIS LOWER HOOK': 9120,
'RIGHT PARENTHESIS UPPER HOOK': 9118,
'RIGHT RAISED OMISSION BRACKET': 11789,
'RIGHT S-SHAPED BAG DELIMITER': 10182,
'RIGHT SEMIDIRECT PRODUCT': 8908,
'RIGHT SINGLE QUOTATION MARK': 8217,
'RIGHT SQUARE BRACKET': 93,
'RIGHT SQUARE BRACKET EXTENSION': 9125,
'RIGHT SQUARE BRACKET LOWER CORNER': 9126,
'RIGHT SQUARE BRACKET UPPER CORNER': 9124,
'RIGHT SQUARE BRACKET WITH QUILL': 8262,
'RIGHT SQUARE BRACKET WITH TICK IN BOTTOM CORNER': 10638,
'RIGHT SQUARE BRACKET WITH TICK IN TOP CORNER': 10640,
'RIGHT SQUARE BRACKET WITH UNDERBAR': 10636,
'RIGHT SUBSTITUTION BRACKET': 11779,
'RIGHT TACK': 8866,
'RIGHT TORTOISE SHELL BRACKET': 12309,
'RIGHT TRANSPOSITION BRACKET': 11786,
'RIGHT TRIANGLE': 8895,
'RIGHT TRIANGLE ABOVE LEFT TRIANGLE': 10702,
'RIGHT VERTICAL BOX LINE': 9145,
'RIGHT WHITE CORNER BRACKET': 12303,
'RIGHT WHITE CURLY BRACKET': 10628,
'RIGHT WHITE LENTICULAR BRACKET': 12311,
'RIGHT WHITE PARENTHESIS': 10630,
'RIGHT WHITE SQUARE BRACKET': 12315,
'RIGHT WHITE TORTOISE SHELL BRACKET': 12313,
'RIGHT WIGGLY FENCE': 10713,
'RIGHT-POINTING ANGLE BRACKET': 9002,
'RIGHT-POINTING CURVED ANGLE BRACKET': 10749,
'RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK': 187,
'RIGHT-SHADED WHITE RIGHTWARDS ARROW': 10153,
'RIGHT-SIDE ARC CLOCKWISE ARROW': 10552,
'RIGHT-TO-LEFT EMBEDDING': 8235,
'RIGHT-TO-LEFT MARK': 8207,
'RIGHT-TO-LEFT OVERRIDE': 8238,
'RIGHTHAND INTERIOR PRODUCT': 10813,
'RIGHTWARDS ARROW': 8594,
'RIGHTWARDS ARROW ABOVE ALMOST EQUAL TO': 10613,
'RIGHTWARDS ARROW ABOVE SHORT LEFTWARDS ARROW': 10562,
'RIGHTWARDS ARROW ABOVE TILDE OPERATOR': 10612,
'RIGHTWARDS ARROW FROM BAR': 8614,
'RIGHTWARDS ARROW FROM BAR TO BLACK DIAMOND': 10528,
'RIGHTWARDS ARROW OVER LEFTWARDS ARROW': 8644,
'RIGHTWARDS ARROW THROUGH X': 10567,
'RIGHTWARDS ARROW TO BAR': 8677,
'RIGHTWARDS ARROW TO BLACK DIAMOND': 10526,
'RIGHTWARDS ARROW WITH CORNER DOWNWARDS': 8628,
'RIGHTWARDS ARROW WITH DOTTED STEM': 10513,
'RIGHTWARDS ARROW WITH DOUBLE VERTICAL STROKE': 8699,
'RIGHTWARDS ARROW WITH HOOK': 8618,
'RIGHTWARDS ARROW WITH LOOP': 8620,
'RIGHTWARDS ARROW WITH PLUS BELOW': 10565,
'RIGHTWARDS ARROW WITH STROKE': 8603,
'RIGHTWARDS ARROW WITH TAIL': 8611,
'RIGHTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE': 10517,
'RIGHTWARDS ARROW WITH TAIL WITH VERTICAL STROKE': 10516,
'RIGHTWARDS ARROW WITH TIP DOWNWARDS': 11022,
'RIGHTWARDS ARROW WITH TIP UPWARDS': 11023,
'RIGHTWARDS ARROW WITH VERTICAL STROKE': 8696,
'RIGHTWARDS ARROW-TAIL': 10522,
'RIGHTWARDS DASHED ARROW': 8674,
'RIGHTWARDS DOUBLE ARROW': 8658,
'RIGHTWARDS DOUBLE ARROW FROM BAR': 10503,
'RIGHTWARDS DOUBLE ARROW WITH STROKE': 8655,
'RIGHTWARDS DOUBLE ARROW WITH VERTICAL STROKE': 10499,
'RIGHTWARDS DOUBLE ARROW-TAIL': 10524,
'RIGHTWARDS DOUBLE DASH ARROW': 10509,
'RIGHTWARDS HARPOON OVER LEFTWARDS HARPOON': 8652,
'RIGHTWARDS HARPOON WITH BARB DOWN ABOVE LEFTWARDS HARPOON WITH BARB DOWN': 10601,
'RIGHTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH': 10605,
'RIGHTWARDS HARPOON WITH BARB DOWN FROM BAR': 10591,
'RIGHTWARDS HARPOON WITH BARB DOWN TO BAR': 10583,
'RIGHTWARDS HARPOON WITH BARB DOWNWARDS': 8641,
'RIGHTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB UP': 10600,
'RIGHTWARDS HARPOON WITH BARB UP ABOVE LONG DASH': 10604,
'RIGHTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB DOWN': 10596,
'RIGHTWARDS HARPOON WITH BARB UP FROM BAR': 10587,
'RIGHTWARDS HARPOON WITH BARB UP TO BAR': 10579,
'RIGHTWARDS HARPOON WITH BARB UPWARDS': 8640,
'RIGHTWARDS OPEN-HEADED ARROW': 8702,
'RIGHTWARDS PAIRED ARROWS': 8649,
'RIGHTWARDS SQUIGGLE ARROW': 8669,
'RIGHTWARDS TRIPLE ARROW': 8667,
'RIGHTWARDS TRIPLE DASH ARROW': 10511,
'RIGHTWARDS TWO HEADED ARROW': 8608,
'RIGHTWARDS TWO-HEADED ARROW FROM BAR': 10501,
'RIGHTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE': 10497,
'RIGHTWARDS TWO-HEADED ARROW WITH TAIL': 10518,
'RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE': 10520,
'RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE': 10519,
'RIGHTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE': 10496,
'RIGHTWARDS TWO-HEADED TRIPLE DASH ARROW': 10512,
'RIGHTWARDS WAVE ARROW': 8605,
'RIGHTWARDS WHITE ARROW': 8680,
'RIGHTWARDS WHITE ARROW FROM WALL': 8688,
'RING ABOVE': 730,
'RING EQUAL TO': 8791,
'RING IN EQUAL TO': 8790,
'RING OPERATOR': 8728,
'RISING DIAGONAL CROSSING FALLING DIAGONAL': 10539,
'RISING DIAGONAL CROSSING SOUTH EAST ARROW': 10544,
'ROMAN NUMERAL EIGHT': 8551,
'ROMAN NUMERAL ELEVEN': 8554,
'ROMAN NUMERAL FIFTY': 8556,
'ROMAN NUMERAL FIVE': 8548,
'ROMAN NUMERAL FIVE HUNDRED': 8558,
'ROMAN NUMERAL FIVE THOUSAND': 8577,
'ROMAN NUMERAL FOUR': 8547,
'ROMAN NUMERAL NINE': 8552,
'ROMAN NUMERAL ONE': 8544,
'ROMAN NUMERAL ONE HUNDRED': 8557,
'ROMAN NUMERAL ONE THOUSAND': 8559,
'ROMAN NUMERAL ONE THOUSAND C D': 8576,
'ROMAN NUMERAL REVERSED ONE HUNDRED': 8579,
'ROMAN NUMERAL SEVEN': 8550,
'ROMAN NUMERAL SIX': 8549,
'ROMAN NUMERAL TEN': 8553,
'ROMAN NUMERAL TEN THOUSAND': 8578,
'ROMAN NUMERAL THREE': 8546,
'ROMAN NUMERAL TWELVE': 8555,
'ROMAN NUMERAL TWO': 8545,
'ROTATED CAPITAL Q': 8506,
'ROTATED FLORAL HEART BULLET': 10087,
'ROTATED HEAVY BLACK HEART BULLET': 10085,
'RULE-DELAYED': 10740,
'RUNIC ARLAUG SYMBOL': 5870,
'RUNIC BELGTHOR SYMBOL': 5872,
'RUNIC CROSS PUNCTUATION': 5869,
'RUNIC LETTER AC A': 5802,
'RUNIC LETTER AESC': 5803,
'RUNIC LETTER ALGIZ EOLHX': 5833,
'RUNIC LETTER ANSUZ A': 5800,
'RUNIC LETTER BERKANAN BEORC BJARKAN B': 5842,
'RUNIC LETTER C': 5837,
'RUNIC LETTER CALC': 5859,
'RUNIC LETTER CEALC': 5860,
'RUNIC LETTER CEN': 5811,
'RUNIC LETTER CWEORTH': 5858,
'RUNIC LETTER D': 5841,
'RUNIC LETTER DAGAZ DAEG D': 5854,
'RUNIC LETTER DOTTED-L': 5851,
'RUNIC LETTER DOTTED-N': 5824,
'RUNIC LETTER DOTTED-P': 5844,
'RUNIC LETTER E': 5826,
'RUNIC LETTER EAR': 5856,
'RUNIC LETTER EHWAZ EH E': 5846,
'RUNIC LETTER ENG': 5814,
'RUNIC LETTER ETH': 5799,
'RUNIC LETTER FEHU FEOH FE F': 5792,
'RUNIC LETTER G': 5813,
'RUNIC LETTER GAR': 5816,
'RUNIC LETTER GEBO GYFU G': 5815,
'RUNIC LETTER GER': 5828,
'RUNIC LETTER HAEGL H': 5819,
'RUNIC LETTER HAGLAZ H': 5818,
'RUNIC LETTER ICELANDIC-YR': 5864,
'RUNIC LETTER ING': 5853,
'RUNIC LETTER INGWAZ': 5852,
'RUNIC LETTER IOR': 5857,
'RUNIC LETTER ISAZ IS ISS I': 5825,
'RUNIC LETTER IWAZ EOH': 5831,
'RUNIC LETTER JERAN J': 5827,
'RUNIC LETTER KAUN K': 5812,
'RUNIC LETTER KAUNA': 5810,
'RUNIC LETTER LAUKAZ LAGU LOGR L': 5850,
'RUNIC LETTER LONG-BRANCH-AR AE': 5829,
'RUNIC LETTER LONG-BRANCH-HAGALL H': 5820,
'RUNIC LETTER LONG-BRANCH-MADR M': 5848,
'RUNIC LETTER LONG-BRANCH-OSS O': 5804,
'RUNIC LETTER LONG-BRANCH-YR': 5862,
'RUNIC LETTER MANNAZ MAN M': 5847,
'RUNIC LETTER NAUDIZ NYD NAUD N': 5822,
'RUNIC LETTER O': 5806,
'RUNIC LETTER OE': 5807,
'RUNIC LETTER ON': 5808,
'RUNIC LETTER OPEN-P': 5845,
'RUNIC LETTER OS O': 5801,
'RUNIC LETTER OTHALAN ETHEL O': 5855,
'RUNIC LETTER PERTHO PEORTH P': 5832,
'RUNIC LETTER Q': 5865,
'RUNIC LETTER RAIDO RAD REID R': 5809,
'RUNIC LETTER SHORT-TWIG-AR A': 5830,
'RUNIC LETTER SHORT-TWIG-BJARKAN B': 5843,
'RUNIC LETTER SHORT-TWIG-HAGALL H': 5821,
'RUNIC LETTER SHORT-TWIG-MADR M': 5849,
'RUNIC LETTER SHORT-TWIG-NAUD N': 5823,
'RUNIC LETTER SHORT-TWIG-OSS O': 5805,
'RUNIC LETTER SHORT-TWIG-SOL S': 5836,
'RUNIC LETTER SHORT-TWIG-TYR T': 5840,
'RUNIC LETTER SHORT-TWIG-YR': 5863,
'RUNIC LETTER SIGEL LONG-BRANCH-SOL S': 5835,
'RUNIC LETTER SOWILO S': 5834,
'RUNIC LETTER STAN': 5861,
'RUNIC LETTER THURISAZ THURS THORN': 5798,
'RUNIC LETTER TIWAZ TIR TYR T': 5839,
'RUNIC LETTER URUZ UR U': 5794,
'RUNIC LETTER V': 5793,
'RUNIC LETTER W': 5797,
'RUNIC LETTER WUNJO WYNN W': 5817,
'RUNIC LETTER X': 5866,
'RUNIC LETTER Y': 5796,
'RUNIC LETTER YR': 5795,
'RUNIC LETTER Z': 5838,
'RUNIC MULTIPLE PUNCTUATION': 5868,
'RUNIC SINGLE PUNCTUATION': 5867,
'RUNIC TVIMADUR SYMBOL': 5871,
'RUPEE SIGN': 8360,
'S IN TRIANGLE': 10700,
'SAGITTARIUS': 9808,
'SALTIRE': 9747,
'SATURN': 9796,
'SCALES': 9878,
'SCORPIUS': 9807,
'SCRIPT CAPITAL B': 8492,
'SCRIPT CAPITAL E': 8496,
'SCRIPT CAPITAL F': 8497,
'SCRIPT CAPITAL H': 8459,
'SCRIPT CAPITAL I': 8464,
'SCRIPT CAPITAL L': 8466,
'SCRIPT CAPITAL M': 8499,
'SCRIPT CAPITAL P': 8472,
'SCRIPT CAPITAL R': 8475,
'SCRIPT SMALL E': 8495,
'SCRIPT SMALL G': 8458,
'SCRIPT SMALL L': 8467,
'SCRIPT SMALL O': 8500,
'SCRUPLE': 8456,
'SECTION SIGN': 167,
'SECTOR': 8980,
'SEGMENT': 8979,
'SEMICOLON': 59,
'SEMIDIRECT PRODUCT WITH BOTTOM CLOSED': 10802,
'SERVICE MARK': 8480,
'SESAME DOT': 65093,
'SET MINUS': 8726,
'SHADOWED WHITE CIRCLE': 10061,
'SHADOWED WHITE LATIN CROSS': 10014,
'SHADOWED WHITE STAR': 10032,
'SHAMROCK': 9752,
'SHAVIAN LETTER ADO': 66665,
'SHAVIAN LETTER AGE': 66673,
'SHAVIAN LETTER AH': 66669,
'SHAVIAN LETTER AIR': 66682,
'SHAVIAN LETTER ARE': 66680,
'SHAVIAN LETTER ARRAY': 66684,
'SHAVIAN LETTER ASH': 66664,
'SHAVIAN LETTER AWE': 66679,
'SHAVIAN LETTER BIB': 66650,
'SHAVIAN LETTER CHURCH': 66647,
'SHAVIAN LETTER DEAD': 66651,
'SHAVIAN LETTER EAR': 66685,
'SHAVIAN LETTER EAT': 66672,
'SHAVIAN LETTER EGG': 66663,
'SHAVIAN LETTER ERR': 66683,
'SHAVIAN LETTER FEE': 66643,
'SHAVIAN LETTER GAG': 66652,
'SHAVIAN LETTER HA-HA': 66659,
'SHAVIAN LETTER HUNG': 66649,
'SHAVIAN LETTER IAN': 66686,
'SHAVIAN LETTER ICE': 66674,
'SHAVIAN LETTER IF': 66662,
'SHAVIAN LETTER JUDGE': 66657,
'SHAVIAN LETTER KICK': 66642,
'SHAVIAN LETTER LOLL': 66660,
'SHAVIAN LETTER MEASURE': 66656,
'SHAVIAN LETTER MIME': 66661,
'SHAVIAN LETTER NUN': 66671,
'SHAVIAN LETTER OAK': 66676,
'SHAVIAN LETTER OIL': 66678,
'SHAVIAN LETTER ON': 66666,
'SHAVIAN LETTER OOZE': 66677,
'SHAVIAN LETTER OR': 66681,
'SHAVIAN LETTER OUT': 66668,
'SHAVIAN LETTER PEEP': 66640,
'SHAVIAN LETTER ROAR': 66670,
'SHAVIAN LETTER SO': 66645,
'SHAVIAN LETTER SURE': 66646,
'SHAVIAN LETTER THEY': 66654,
'SHAVIAN LETTER THIGH': 66644,
'SHAVIAN LETTER TOT': 66641,
'SHAVIAN LETTER UP': 66675,
'SHAVIAN LETTER VOW': 66653,
'SHAVIAN LETTER WOE': 66658,
'SHAVIAN LETTER WOOL': 66667,
'SHAVIAN LETTER YEA': 66648,
'SHAVIAN LETTER YEW': 66687,
'SHAVIAN LETTER ZOO': 66655,
'SHORT DOWN TACK': 10975,
'SHORT DOWN TACK WITH OVERBAR': 10983,
'SHORT LEFT TACK': 10974,
'SHORT RIGHTWARDS ARROW ABOVE LEFTWARDS ARROW': 10564,
'SHORT UP TACK': 10976,
'SHORT UP TACK ABOVE SHORT DOWN TACK': 10985,
'SHORT UP TACK WITH UNDERBAR': 10984,
'SHOULDERED OPEN BOX': 9085,
'SHUFFLE PRODUCT': 10722,
'SIMILAR ABOVE GREATER-THAN ABOVE EQUALS SIGN': 10912,
'SIMILAR ABOVE LESS-THAN ABOVE EQUALS SIGN': 10911,
'SIMILAR MINUS SIMILAR': 10860,
'SIMILAR OR GREATER-THAN': 10910,
'SIMILAR OR LESS-THAN': 10909,
'SINE WAVE': 8767,
'SINGLE HIGH-REVERSED-9 QUOTATION MARK': 8219,
'SINGLE LEFT-POINTING ANGLE QUOTATION MARK': 8249,
'SINGLE LOW-9 QUOTATION MARK': 8218,
'SINGLE RIGHT-POINTING ANGLE QUOTATION MARK': 8250,
'SINHALA LETTER AAYANNA': 3462,
'SINHALA LETTER AEEYANNA': 3464,
'SINHALA LETTER AEYANNA': 3463,
'SINHALA LETTER AIYANNA': 3475,
'SINHALA LETTER ALPAPRAANA BAYANNA': 3510,
'SINHALA LETTER ALPAPRAANA CAYANNA': 3488,
'SINHALA LETTER ALPAPRAANA DAYANNA': 3503,
'SINHALA LETTER ALPAPRAANA DDAYANNA': 3497,
'SINHALA LETTER ALPAPRAANA GAYANNA': 3484,
'SINHALA LETTER ALPAPRAANA JAYANNA': 3490,
'SINHALA LETTER ALPAPRAANA KAYANNA': 3482,
'SINHALA LETTER ALPAPRAANA PAYANNA': 3508,
'SINHALA LETTER ALPAPRAANA TAYANNA': 3501,
'SINHALA LETTER ALPAPRAANA TTAYANNA': 3495,
'SINHALA LETTER AMBA BAYANNA': 3513,
'SINHALA LETTER AUYANNA': 3478,
'SINHALA LETTER AYANNA': 3461,
'SINHALA LETTER DANTAJA LAYANNA': 3517,
'SINHALA LETTER DANTAJA NAYANNA': 3505,
'SINHALA LETTER DANTAJA SAYANNA': 3523,
'SINHALA LETTER EEYANNA': 3474,
'SINHALA LETTER EYANNA': 3473,
'SINHALA LETTER FAYANNA': 3526,
'SINHALA LETTER HAYANNA': 3524,
'SINHALA LETTER IIYANNA': 3466,
'SINHALA LETTER ILUUYANNA': 3472,
'SINHALA LETTER ILUYANNA': 3471,
'SINHALA LETTER IRUUYANNA': 3470,
'SINHALA LETTER IRUYANNA': 3469,
'SINHALA LETTER IYANNA': 3465,
'SINHALA LETTER KANTAJA NAASIKYAYA': 3486,
'SINHALA LETTER MAHAAPRAANA BAYANNA': 3511,
'SINHALA LETTER MAHAAPRAANA CAYANNA': 3489,
'SINHALA LETTER MAHAAPRAANA DAYANNA': 3504,
'SINHALA LETTER MAHAAPRAANA DDAYANNA': 3498,
'SINHALA LETTER MAHAAPRAANA GAYANNA': 3485,
'SINHALA LETTER MAHAAPRAANA JAYANNA': 3491,
'SINHALA LETTER MAHAAPRAANA KAYANNA': 3483,
'SINHALA LETTER MAHAAPRAANA PAYANNA': 3509,
'SINHALA LETTER MAHAAPRAANA TAYANNA': 3502,
'SINHALA LETTER MAHAAPRAANA TTAYANNA': 3496,
'SINHALA LETTER MAYANNA': 3512,
'SINHALA LETTER MUURDHAJA LAYANNA': 3525,
'SINHALA LETTER MUURDHAJA NAYANNA': 3499,
'SINHALA LETTER MUURDHAJA SAYANNA': 3522,
'SINHALA LETTER OOYANNA': 3477,
'SINHALA LETTER OYANNA': 3476,
'SINHALA LETTER RAYANNA': 3515,
'SINHALA LETTER SANYAKA DAYANNA': 3507,
'SINHALA LETTER SANYAKA DDAYANNA': 3500,
'SINHALA LETTER SANYAKA GAYANNA': 3487,
'SINHALA LETTER SANYAKA JAYANNA': 3494,
'SINHALA LETTER TAALUJA NAASIKYAYA': 3492,
'SINHALA LETTER TAALUJA SANYOOGA NAAKSIKYAYA': 3493,
'SINHALA LETTER TAALUJA SAYANNA': 3521,
'SINHALA LETTER UUYANNA': 3468,
'SINHALA LETTER UYANNA': 3467,
'SINHALA LETTER VAYANNA': 3520,
'SINHALA LETTER YAYANNA': 3514,
'SINHALA PUNCTUATION KUNDDALIYA': 3572,
'SINHALA SIGN AL-LAKUNA': 3530,
'SINHALA SIGN ANUSVARAYA': 3458,
'SINHALA SIGN VISARGAYA': 3459,
'SINHALA VOWEL SIGN AELA-PILLA': 3535,
'SINHALA VOWEL SIGN DIGA AEDA-PILLA': 3537,
'SINHALA VOWEL SIGN DIGA GAETTA-PILLA': 3570,
'SINHALA VOWEL SIGN DIGA GAYANUKITTA': 3571,
'SINHALA VOWEL SIGN DIGA IS-PILLA': 3539,
'SINHALA VOWEL SIGN DIGA KOMBUVA': 3546,
'SINHALA VOWEL SIGN DIGA PAA-PILLA': 3542,
'SINHALA VOWEL SIGN GAETTA-PILLA': 3544,
'SINHALA VOWEL SIGN GAYANUKITTA': 3551,
'SINHALA VOWEL SIGN KETTI AEDA-PILLA': 3536,
'SINHALA VOWEL SIGN KETTI IS-PILLA': 3538,
'SINHALA VOWEL SIGN KETTI PAA-PILLA': 3540,
'SINHALA VOWEL SIGN KOMBU DEKA': 3547,
'SINHALA VOWEL SIGN KOMBUVA': 3545,
'SINHALA VOWEL SIGN KOMBUVA HAA AELA-PILLA': 3548,
'SINHALA VOWEL SIGN KOMBUVA HAA DIGA AELA-PILLA': 3549,
'SINHALA VOWEL SIGN KOMBUVA HAA GAYANUKITTA': 3550,
'SIX PETALLED BLACK AND WHITE FLORETTE': 10046,
'SIX POINTED BLACK STAR': 10038,
'SIX-PER-EM SPACE': 8198,
'SIXTEEN POINTED ASTERISK': 10042,
'SKULL AND CROSSBONES': 9760,
'SLANTED EQUAL TO OR GREATER-THAN': 10902,
'SLANTED EQUAL TO OR GREATER-THAN WITH DOT INSIDE': 10904,
'SLANTED EQUAL TO OR LESS-THAN': 10901,
'SLANTED EQUAL TO OR LESS-THAN WITH DOT INSIDE': 10903,
'SLOPE': 9011,
'SLOPING LARGE AND': 10840,
'SLOPING LARGE OR': 10839,
'SMALL AMPERSAND': 65120,
'SMALL ASTERISK': 65121,
'SMALL COLON': 65109,
'SMALL COMMA': 65104,
'SMALL COMMERCIAL AT': 65131,
'SMALL CONTAINS AS MEMBER': 8717,
'SMALL CONTAINS WITH OVERBAR': 8958,
'SMALL CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE': 8956,
'SMALL DOLLAR SIGN': 65129,
'SMALL ELEMENT OF': 8714,
'SMALL ELEMENT OF WITH OVERBAR': 8951,
'SMALL ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE': 8948,
'SMALL EM DASH': 65112,
'SMALL EQUALS SIGN': 65126,
'SMALL EXCLAMATION MARK': 65111,
'SMALL FULL STOP': 65106,
'SMALL GREATER-THAN SIGN': 65125,
'SMALL HYPHEN-MINUS': 65123,
'SMALL IDEOGRAPHIC COMMA': 65105,
'SMALL LEFT CURLY BRACKET': 65115,
'SMALL LEFT PARENTHESIS': 65113,
'SMALL LEFT TORTOISE SHELL BRACKET': 65117,
'SMALL LESS-THAN SIGN': 65124,
'SMALL NUMBER SIGN': 65119,
'SMALL PERCENT SIGN': 65130,
'SMALL PLUS SIGN': 65122,
'SMALL QUESTION MARK': 65110,
'SMALL REVERSE SOLIDUS': 65128,
'SMALL RIGHT CURLY BRACKET': 65116,
'SMALL RIGHT PARENTHESIS': 65114,
'SMALL RIGHT TORTOISE SHELL BRACKET': 65118,
'SMALL ROMAN NUMERAL EIGHT': 8567,
'SMALL ROMAN NUMERAL ELEVEN': 8570,
'SMALL ROMAN NUMERAL FIFTY': 8572,
'SMALL ROMAN NUMERAL FIVE': 8564,
'SMALL ROMAN NUMERAL FIVE HUNDRED': 8574,
'SMALL ROMAN NUMERAL FOUR': 8563,
'SMALL ROMAN NUMERAL NINE': 8568,
'SMALL ROMAN NUMERAL ONE': 8560,
'SMALL ROMAN NUMERAL ONE HUNDRED': 8573,
'SMALL ROMAN NUMERAL ONE THOUSAND': 8575,
'SMALL ROMAN NUMERAL SEVEN': 8566,
'SMALL ROMAN NUMERAL SIX': 8565,
'SMALL ROMAN NUMERAL TEN': 8569,
'SMALL ROMAN NUMERAL THREE': 8562,
'SMALL ROMAN NUMERAL TWELVE': 8571,
'SMALL ROMAN NUMERAL TWO': 8561,
'SMALL SEMICOLON': 65108,
'SMALL TILDE': 732,
'SMALL VEE WITH UNDERBAR': 10849,
'SMALLER THAN': 10922,
'SMALLER THAN OR EQUAL TO': 10924,
'SMASH PRODUCT': 10803,
'SMILE': 8995,
'SNOWFLAKE': 10052,
'SNOWMAN': 9731,
'SOFT HYPHEN': 173,
'SOFTWARE-FUNCTION SYMBOL': 9108,
'SOLIDUS': 47,
'SOLIDUS WITH OVERBAR': 10742,
'SOUND RECORDING COPYRIGHT': 8471,
'SOUTH EAST ARROW': 8600,
'SOUTH EAST ARROW AND SOUTH WEST ARROW': 10537,
'SOUTH EAST ARROW CROSSING NORTH EAST ARROW': 10541,
'SOUTH EAST ARROW TO CORNER': 8690,
'SOUTH EAST ARROW WITH HOOK': 10533,
'SOUTH EAST BLACK ARROW': 11018,
'SOUTH EAST DOUBLE ARROW': 8664,
'SOUTH EAST WHITE ARROW': 11010,
'SOUTH WEST ARROW': 8601,
'SOUTH WEST ARROW AND NORTH WEST ARROW': 10538,
'SOUTH WEST ARROW WITH HOOK': 10534,
'SOUTH WEST BLACK ARROW': 11019,
'SOUTH WEST DOUBLE ARROW': 8665,
'SOUTH WEST WHITE ARROW': 11011,
'SPACE': 32,
'SPARKLE': 10055,
'SPHERICAL ANGLE': 8738,
'SPHERICAL ANGLE OPENING LEFT': 10656,
'SPHERICAL ANGLE OPENING UP': 10657,
'SQUARE A OVER M': 13279,
'SQUARE AARU': 13059,
'SQUARE AM': 13250,
'SQUARE ANPEA': 13058,
'SQUARE APAATO': 13056,
'SQUARE ARUHUA': 13057,
'SQUARE AU': 13171,
'SQUARE BAARERU': 13101,
'SQUARE BAR': 13172,
'SQUARE BEETA': 13116,
'SQUARE BIRU': 13105,
'SQUARE BORUTO': 13118,
'SQUARE BQ': 13251,
'SQUARE BUSSYERU': 13108,
'SQUARE C OVER KG': 13254,
'SQUARE CAL': 13192,
'SQUARE CAP': 8851,
'SQUARE CC': 13252,
'SQUARE CD': 13253,
'SQUARE CM': 13213,
'SQUARE CM CUBED': 13220,
'SQUARE CM SQUARED': 13216,
'SQUARE CO': 13255,
'SQUARE CORPORATION': 13183,
'SQUARE CUP': 8852,
'SQUARE DA': 13170,
'SQUARE DAASU': 13092,
'SQUARE DB': 13256,
'SQUARE DESI': 13093,
'SQUARE DL': 13207,
'SQUARE DM': 13175,
'SQUARE DM CUBED': 13177,
'SQUARE DM SQUARED': 13176,
'SQUARE DORU': 13094,
'SQUARE EEKAA': 13064,
'SQUARE ERA NAME HEISEI': 13179,
'SQUARE ERA NAME MEIZI': 13182,
'SQUARE ERA NAME SYOUWA': 13180,
'SQUARE ERA NAME TAISYOU': 13181,
'SQUARE ERG': 13005,
'SQUARE ESUKUUDO': 13063,
'SQUARE EV': 13006,
'SQUARE FM': 13209,
'SQUARE FOOT': 9165,
'SQUARE GAL': 13311,
'SQUARE GANMA': 13071,
'SQUARE GARON': 13070,
'SQUARE GB': 13191,
'SQUARE GHZ': 13203,
'SQUARE GIGA': 13072,
'SQUARE GINII': 13073,
'SQUARE GIRUDAA': 13075,
'SQUARE GPA': 13228,
'SQUARE GURAMU': 13080,
'SQUARE GURAMUTON': 13081,
'SQUARE GY': 13257,
'SQUARE HA': 13258,
'SQUARE HAITU': 13098,
'SQUARE HEKUTAARU': 13110,
'SQUARE HERUTU': 13113,
'SQUARE HG': 13004,
'SQUARE HON': 13119,
'SQUARE HOON': 13122,
'SQUARE HOORU': 13121,
'SQUARE HP': 13259,
'SQUARE HPA': 13169,
'SQUARE HUARADDO': 13106,
'SQUARE HUIITO': 13107,
'SQUARE HURAN': 13109,
'SQUARE HZ': 13200,
'SQUARE IMAGE OF': 8847,
'SQUARE IMAGE OF OR EQUAL TO': 8849,
'SQUARE IMAGE OF OR NOT EQUAL TO': 8932,
'SQUARE IN': 13260,
'SQUARE ININGU': 13060,
'SQUARE INTI': 13061,
'SQUARE IU': 13178,
'SQUARE K OHM': 13248,
'SQUARE KA': 13188,
'SQUARE KAIRI': 13067,
'SQUARE KARATTO': 13068,
'SQUARE KARORII': 13069,
'SQUARE KB': 13189,
'SQUARE KCAL': 13193,
'SQUARE KEESU': 13084,
'SQUARE KG': 13199,
'SQUARE KHZ': 13201,
'SQUARE KIRO': 13076,
'SQUARE KIROGURAMU': 13077,
'SQUARE KIROMEETORU': 13078,
'SQUARE KIROWATTO': 13079,
'SQUARE KK': 13261,
'SQUARE KL': 13208,
'SQUARE KM': 13214,
'SQUARE KM CAPITAL': 13262,
'SQUARE KM CUBED': 13222,
'SQUARE KM SQUARED': 13218,
'SQUARE KOOPO': 13086,
'SQUARE KORUNA': 13085,
'SQUARE KPA': 13226,
'SQUARE KT': 13263,
'SQUARE KUROONE': 13083,
'SQUARE KURUZEIRO': 13082,
'SQUARE KV': 13240,
'SQUARE KW': 13246,
'SQUARE KYURII': 13074,
'SQUARE LEFT OPEN BOX OPERATOR': 10957,
'SQUARE LM': 13264,
'SQUARE LN': 13265,
'SQUARE LOG': 13266,
'SQUARE LOZENGE': 8977,
'SQUARE LX': 13267,
'SQUARE M CUBED': 13221,
'SQUARE M OHM': 13249,
'SQUARE M OVER S': 13223,
'SQUARE M OVER S SQUARED': 13224,
'SQUARE M SQUARED': 13217,
'SQUARE MA': 13187,
'SQUARE MAHHA': 13125,
'SQUARE MAIKURO': 13123,
'SQUARE MAIRU': 13124,
'SQUARE MANSYON': 13127,
'SQUARE MARUKU': 13126,
'SQUARE MB': 13190,
'SQUARE MB SMALL': 13268,
'SQUARE MEETORU': 13133,
'SQUARE MEGA': 13131,
'SQUARE MEGATON': 13132,
'SQUARE MG': 13198,
'SQUARE MHZ': 13202,
'SQUARE MIKURON': 13128,
'SQUARE MIL': 13269,
'SQUARE MIRI': 13129,
'SQUARE MIRIBAARU': 13130,
'SQUARE ML': 13206,
'SQUARE MM': 13212,
'SQUARE MM CUBED': 13219,
'SQUARE MM SQUARED': 13215,
'SQUARE MOL': 13270,
'SQUARE MPA': 13227,
'SQUARE MS': 13235,
'SQUARE MU A': 13186,
'SQUARE MU F': 13196,
'SQUARE MU G': 13197,
'SQUARE MU L': 13205,
'SQUARE MU M': 13211,
'SQUARE MU S': 13234,
'SQUARE MU V': 13238,
'SQUARE MU W': 13244,
'SQUARE MV': 13239,
'SQUARE MV MEGA': 13241,
'SQUARE MW': 13245,
'SQUARE MW MEGA': 13247,
'SQUARE NA': 13185,
'SQUARE NANO': 13096,
'SQUARE NF': 13195,
'SQUARE NM': 13210,
'SQUARE NOTTO': 13097,
'SQUARE NS': 13233,
'SQUARE NV': 13237,
'SQUARE NW': 13243,
'SQUARE ONSU': 13065,
'SQUARE OOMU': 13066,
'SQUARE ORIGINAL OF': 8848,
'SQUARE ORIGINAL OF OR EQUAL TO': 8850,
'SQUARE ORIGINAL OF OR NOT EQUAL TO': 8933,
'SQUARE OV': 13173,
'SQUARE PA': 13225,
'SQUARE PA AMPS': 13184,
'SQUARE PAASENTO': 13099,
'SQUARE PAATU': 13100,
'SQUARE PC': 13174,
'SQUARE PEEZI': 13115,
'SQUARE PENIHI': 13112,
'SQUARE PENSU': 13114,
'SQUARE PESO': 13111,
'SQUARE PF': 13194,
'SQUARE PH': 13271,
'SQUARE PIASUTORU': 13102,
'SQUARE PIKO': 13104,
'SQUARE PIKURU': 13103,
'SQUARE PM': 13272,
'SQUARE POINTO': 13117,
'SQUARE PONDO': 13120,
'SQUARE PPM': 13273,
'SQUARE PR': 13274,
'SQUARE PS': 13232,
'SQUARE PV': 13236,
'SQUARE PW': 13242,
'SQUARE RAD': 13229,
'SQUARE RAD OVER S': 13230,
'SQUARE RAD OVER S SQUARED': 13231,
'SQUARE REMU': 13141,
'SQUARE RENTOGEN': 13142,
'SQUARE RIGHT OPEN BOX OPERATOR': 10958,
'SQUARE RIRA': 13138,
'SQUARE RITTORU': 13137,
'SQUARE ROOT': 8730,
'SQUARE RUPII': 13139,
'SQUARE RUUBURU': 13140,
'SQUARE SAIKURU': 13087,
'SQUARE SANTIIMU': 13088,
'SQUARE SENTI': 13090,
'SQUARE SENTO': 13091,
'SQUARE SIRINGU': 13089,
'SQUARE SR': 13275,
'SQUARE SV': 13276,
'SQUARE THZ': 13204,
'SQUARE TON': 13095,
'SQUARE UON': 13062,
'SQUARE V OVER M': 13278,
'SQUARE WATTO': 13143,
'SQUARE WB': 13277,
'SQUARE WITH BOTTOM HALF BLACK': 11027,
'SQUARE WITH CONTOURED OUTLINE': 10720,
'SQUARE WITH DIAGONAL CROSSHATCH FILL': 9641,
'SQUARE WITH HORIZONTAL FILL': 9636,
'SQUARE WITH LEFT HALF BLACK': 9703,
'SQUARE WITH LOWER RIGHT DIAGONAL HALF BLACK': 9706,
'SQUARE WITH ORTHOGONAL CROSSHATCH FILL': 9638,
'SQUARE WITH RIGHT HALF BLACK': 9704,
'SQUARE WITH TOP HALF BLACK': 11026,
'SQUARE WITH UPPER LEFT DIAGONAL HALF BLACK': 9705,
'SQUARE WITH UPPER LEFT TO LOWER RIGHT FILL': 9639,
'SQUARE WITH UPPER RIGHT TO LOWER LEFT FILL': 9640,
'SQUARE WITH VERTICAL FILL': 9637,
'SQUARE YAADO': 13134,
'SQUARE YAARU': 13135,
'SQUARE YUAN': 13136,
'SQUARED ASTERISK': 10694,
'SQUARED DOT OPERATOR': 8865,
'SQUARED FALLING DIAGONAL SLASH': 10693,
'SQUARED MINUS': 8863,
'SQUARED PLUS': 8862,
'SQUARED RISING DIAGONAL SLASH': 10692,
'SQUARED SMALL CIRCLE': 10695,
'SQUARED SQUARE': 10696,
'SQUARED TIMES': 8864,
'SQUAT BLACK RIGHTWARDS ARROW': 10151,
'STAFF OF AESCULAPIUS': 9877,
'STAFF OF HERMES': 9882,
'STAR AND CRESCENT': 9770,
'STAR EQUALS': 8795,
'STAR OF DAVID': 10017,
'STAR OPERATOR': 8902,
'STRESS OUTLINED WHITE STAR': 10025,
'STRICTLY EQUIVALENT TO': 8803,
'SUBSCRIPT EIGHT': 8328,
'SUBSCRIPT EQUALS SIGN': 8332,
'SUBSCRIPT FIVE': 8325,
'SUBSCRIPT FOUR': 8324,
'SUBSCRIPT LEFT PARENTHESIS': 8333,
'SUBSCRIPT MINUS': 8331,
'SUBSCRIPT NINE': 8329,
'SUBSCRIPT ONE': 8321,
'SUBSCRIPT PLUS SIGN': 8330,
'SUBSCRIPT RIGHT PARENTHESIS': 8334,
'SUBSCRIPT SEVEN': 8327,
'SUBSCRIPT SIX': 8326,
'SUBSCRIPT THREE': 8323,
'SUBSCRIPT TWO': 8322,
'SUBSCRIPT ZERO': 8320,
'SUBSET ABOVE RIGHTWARDS ARROW': 10617,
'SUBSET ABOVE SUBSET': 10965,
'SUBSET ABOVE SUPERSET': 10963,
'SUBSET OF': 8834,
'SUBSET OF ABOVE ALMOST EQUAL TO': 10953,
'SUBSET OF ABOVE EQUALS SIGN': 10949,
'SUBSET OF ABOVE NOT EQUAL TO': 10955,
'SUBSET OF ABOVE TILDE OPERATOR': 10951,
'SUBSET OF OR EQUAL TO': 8838,
'SUBSET OF OR EQUAL TO WITH DOT ABOVE': 10947,
'SUBSET OF WITH NOT EQUAL TO': 8842,
'SUBSET WITH DOT': 10941,
'SUBSET WITH MULTIPLICATION SIGN BELOW': 10945,
'SUBSET WITH PLUS SIGN BELOW': 10943,
'SUCCEEDS': 8827,
'SUCCEEDS ABOVE ALMOST EQUAL TO': 10936,
'SUCCEEDS ABOVE EQUALS SIGN': 10932,
'SUCCEEDS ABOVE NOT ALMOST EQUAL TO': 10938,
'SUCCEEDS ABOVE NOT EQUAL TO': 10934,
'SUCCEEDS ABOVE SINGLE-LINE EQUALS SIGN': 10928,
'SUCCEEDS ABOVE SINGLE-LINE NOT EQUAL TO': 10930,
'SUCCEEDS BUT NOT EQUIVALENT TO': 8937,
'SUCCEEDS OR EQUAL TO': 8829,
'SUCCEEDS OR EQUIVALENT TO': 8831,
'SUCCEEDS UNDER RELATION': 8881,
'SUMMATION BOTTOM': 9139,
'SUMMATION TOP': 9138,
'SUMMATION WITH INTEGRAL': 10763,
'SUN': 9737,
'SUPERSCRIPT EIGHT': 8312,
'SUPERSCRIPT EQUALS SIGN': 8316,
'SUPERSCRIPT FIVE': 8309,
'SUPERSCRIPT FOUR': 8308,
'SUPERSCRIPT LATIN SMALL LETTER I': 8305,
'SUPERSCRIPT LATIN SMALL LETTER N': 8319,
'SUPERSCRIPT LEFT PARENTHESIS': 8317,
'SUPERSCRIPT MINUS': 8315,
'SUPERSCRIPT NINE': 8313,
'SUPERSCRIPT ONE': 185,
'SUPERSCRIPT PLUS SIGN': 8314,
'SUPERSCRIPT RIGHT PARENTHESIS': 8318,
'SUPERSCRIPT SEVEN': 8311,
'SUPERSCRIPT SIX': 8310,
'SUPERSCRIPT THREE': 179,
'SUPERSCRIPT TWO': 178,
'SUPERSCRIPT ZERO': 8304,
'SUPERSET ABOVE LEFTWARDS ARROW': 10619,
'SUPERSET ABOVE SUBSET': 10964,
'SUPERSET ABOVE SUPERSET': 10966,
'SUPERSET BESIDE AND JOINED BY DASH WITH SUBSET': 10968,
'SUPERSET BESIDE SUBSET': 10967,
'SUPERSET OF': 8835,
'SUPERSET OF ABOVE ALMOST EQUAL TO': 10954,
'SUPERSET OF ABOVE EQUALS SIGN': 10950,
'SUPERSET OF ABOVE NOT EQUAL TO': 10956,
'SUPERSET OF ABOVE TILDE OPERATOR': 10952,
'SUPERSET OF OR EQUAL TO': 8839,
'SUPERSET OF OR EQUAL TO WITH DOT ABOVE': 10948,
'SUPERSET OF WITH NOT EQUAL TO': 8843,
'SUPERSET WITH DOT': 10942,
'SUPERSET WITH MULTIPLICATION SIGN BELOW': 10946,
'SUPERSET WITH PLUS SIGN BELOW': 10944,
'SURFACE INTEGRAL': 8751,
'SWUNG DASH': 8275,
'SYLOTI NAGRI LETTER A': 43008,
'SYLOTI NAGRI LETTER BHO': 43036,
'SYLOTI NAGRI LETTER BO': 43035,
'SYLOTI NAGRI LETTER CHO': 43021,
'SYLOTI NAGRI LETTER CO': 43020,
'SYLOTI NAGRI LETTER DDHO': 43027,
'SYLOTI NAGRI LETTER DDO': 43026,
'SYLOTI NAGRI LETTER DHO': 43031,
'SYLOTI NAGRI LETTER DO': 43030,
'SYLOTI NAGRI LETTER E': 43012,
'SYLOTI NAGRI LETTER GHO': 43018,
'SYLOTI NAGRI LETTER GO': 43017,
'SYLOTI NAGRI LETTER HO': 43042,
'SYLOTI NAGRI LETTER I': 43009,
'SYLOTI NAGRI LETTER JHO': 43023,
'SYLOTI NAGRI LETTER JO': 43022,
'SYLOTI NAGRI LETTER KHO': 43016,
'SYLOTI NAGRI LETTER KO': 43015,
'SYLOTI NAGRI LETTER LO': 43039,
'SYLOTI NAGRI LETTER MO': 43037,
'SYLOTI NAGRI LETTER NO': 43032,
'SYLOTI NAGRI LETTER O': 43013,
'SYLOTI NAGRI LETTER PHO': 43034,
'SYLOTI NAGRI LETTER PO': 43033,
'SYLOTI NAGRI LETTER RO': 43038,
'SYLOTI NAGRI LETTER RRO': 43040,
'SYLOTI NAGRI LETTER SO': 43041,
'SYLOTI NAGRI LETTER THO': 43029,
'SYLOTI NAGRI LETTER TO': 43028,
'SYLOTI NAGRI LETTER TTHO': 43025,
'SYLOTI NAGRI LETTER TTO': 43024,
'SYLOTI NAGRI LETTER U': 43011,
'SYLOTI NAGRI POETRY MARK-1': 43048,
'SYLOTI NAGRI POETRY MARK-2': 43049,
'SYLOTI NAGRI POETRY MARK-3': 43050,
'SYLOTI NAGRI POETRY MARK-4': 43051,
'SYLOTI NAGRI SIGN ANUSVARA': 43019,
'SYLOTI NAGRI SIGN DVISVARA': 43010,
'SYLOTI NAGRI SIGN HASANTA': 43014,
'SYLOTI NAGRI VOWEL SIGN A': 43043,
'SYLOTI NAGRI VOWEL SIGN E': 43046,
'SYLOTI NAGRI VOWEL SIGN I': 43044,
'SYLOTI NAGRI VOWEL SIGN OO': 43047,
'SYLOTI NAGRI VOWEL SIGN U': 43045,
'SYMBOL FOR ACKNOWLEDGE': 9222,
'SYMBOL FOR BACKSPACE': 9224,
'SYMBOL FOR BELL': 9223,
'SYMBOL FOR CANCEL': 9240,
'SYMBOL FOR CARRIAGE RETURN': 9229,
'SYMBOL FOR DATA LINK ESCAPE': 9232,
'SYMBOL FOR DELETE': 9249,
'SYMBOL FOR DELETE FORM TWO': 9253,
'SYMBOL FOR DEVICE CONTROL FOUR': 9236,
'SYMBOL FOR DEVICE CONTROL ONE': 9233,
'SYMBOL FOR DEVICE CONTROL THREE': 9235,
'SYMBOL FOR DEVICE CONTROL TWO': 9234,
'SYMBOL FOR END OF MEDIUM': 9241,
'SYMBOL FOR END OF TEXT': 9219,
'SYMBOL FOR END OF TRANSMISSION': 9220,
'SYMBOL FOR END OF TRANSMISSION BLOCK': 9239,
'SYMBOL FOR ENQUIRY': 9221,
'SYMBOL FOR ESCAPE': 9243,
'SYMBOL FOR FILE SEPARATOR': 9244,
'SYMBOL FOR FORM FEED': 9228,
'SYMBOL FOR GROUP SEPARATOR': 9245,
'SYMBOL FOR HORIZONTAL TABULATION': 9225,
'SYMBOL FOR LINE FEED': 9226,
'SYMBOL FOR NEGATIVE ACKNOWLEDGE': 9237,
'SYMBOL FOR NEWLINE': 9252,
'SYMBOL FOR NULL': 9216,
'SYMBOL FOR RECORD SEPARATOR': 9246,
'SYMBOL FOR SHIFT IN': 9231,
'SYMBOL FOR SHIFT OUT': 9230,
'SYMBOL FOR SPACE': 9248,
'SYMBOL FOR START OF HEADING': 9217,
'SYMBOL FOR START OF TEXT': 9218,
'SYMBOL FOR SUBSTITUTE': 9242,
'SYMBOL FOR SUBSTITUTE FORM TWO': 9254,
'SYMBOL FOR SYNCHRONOUS IDLE': 9238,
'SYMBOL FOR UNIT SEPARATOR': 9247,
'SYMBOL FOR VERTICAL TABULATION': 9227,
'SYMMETRY': 9007,
'SYRIAC ABBREVIATION MARK': 1807,
'SYRIAC BARREKH': 1866,
'SYRIAC COLON SKEWED LEFT': 1798,
'SYRIAC COLON SKEWED RIGHT': 1799,
'SYRIAC CONTRACTION': 1802,
'SYRIAC DOTTED ZLAMA ANGULAR': 1849,
'SYRIAC DOTTED ZLAMA HORIZONTAL': 1848,
'SYRIAC END OF PARAGRAPH': 1792,
'SYRIAC ESASA ABOVE': 1853,
'SYRIAC ESASA BELOW': 1854,
'SYRIAC FEMININE DOT': 1856,
'SYRIAC HARKLEAN ASTERISCUS': 1805,
'SYRIAC HARKLEAN METOBELUS': 1804,
'SYRIAC HARKLEAN OBELUS': 1803,
'SYRIAC HBASA ABOVE': 1850,
'SYRIAC HBASA BELOW': 1851,
'SYRIAC HBASA-ESASA DOTTED': 1852,
'SYRIAC HORIZONTAL COLON': 1797,
'SYRIAC LETTER ALAPH': 1808,
'SYRIAC LETTER BETH': 1810,
'SYRIAC LETTER DALATH': 1813,
'SYRIAC LETTER DOTLESS DALATH RISH': 1814,
'SYRIAC LETTER E': 1829,
'SYRIAC LETTER FINAL SEMKATH': 1828,
'SYRIAC LETTER GAMAL': 1811,
'SYRIAC LETTER GAMAL GARSHUNI': 1812,
'SYRIAC LETTER HE': 1815,
'SYRIAC LETTER HETH': 1818,
'SYRIAC LETTER KAPH': 1823,
'SYRIAC LETTER LAMADH': 1824,
'SYRIAC LETTER MIM': 1825,
'SYRIAC LETTER NUN': 1826,
'SYRIAC LETTER PE': 1830,
'SYRIAC LETTER PERSIAN BHETH': 1837,
'SYRIAC LETTER PERSIAN DHALATH': 1839,
'SYRIAC LETTER PERSIAN GHAMAL': 1838,
'SYRIAC LETTER QAPH': 1833,
'SYRIAC LETTER REVERSED PE': 1831,
'SYRIAC LETTER RISH': 1834,
'SYRIAC LETTER SADHE': 1832,
'SYRIAC LETTER SEMKATH': 1827,
'SYRIAC LETTER SHIN': 1835,
'SYRIAC LETTER SOGDIAN FE': 1871,
'SYRIAC LETTER SOGDIAN KHAPH': 1870,
'SYRIAC LETTER SOGDIAN ZHAIN': 1869,
'SYRIAC LETTER SUPERSCRIPT ALAPH': 1809,
'SYRIAC LETTER TAW': 1836,
'SYRIAC LETTER TETH': 1819,
'SYRIAC LETTER TETH GARSHUNI': 1820,
'SYRIAC LETTER WAW': 1816,
'SYRIAC LETTER YUDH': 1821,
'SYRIAC LETTER YUDH HE': 1822,
'SYRIAC LETTER ZAIN': 1817,
'SYRIAC MUSIC': 1865,
'SYRIAC OBLIQUE LINE ABOVE': 1863,
'SYRIAC OBLIQUE LINE BELOW': 1864,
'SYRIAC PTHAHA ABOVE': 1840,
'SYRIAC PTHAHA BELOW': 1841,
'SYRIAC PTHAHA DOTTED': 1842,
'SYRIAC QUSHSHAYA': 1857,
'SYRIAC RBASA ABOVE': 1846,
'SYRIAC RBASA BELOW': 1847,
'SYRIAC RUKKAKHA': 1858,
'SYRIAC RWAHA': 1855,
'SYRIAC SUBLINEAR COLON': 1796,
'SYRIAC SUBLINEAR COLON SKEWED RIGHT': 1801,
'SYRIAC SUBLINEAR FULL STOP': 1794,
'SYRIAC SUPRALINEAR COLON': 1795,
'SYRIAC SUPRALINEAR COLON SKEWED LEFT': 1800,
'SYRIAC SUPRALINEAR FULL STOP': 1793,
'SYRIAC THREE DOTS ABOVE': 1861,
'SYRIAC THREE DOTS BELOW': 1862,
'SYRIAC TWO VERTICAL DOTS ABOVE': 1859,
'SYRIAC TWO VERTICAL DOTS BELOW': 1860,
'SYRIAC ZQAPHA ABOVE': 1843,
'SYRIAC ZQAPHA BELOW': 1844,
'SYRIAC ZQAPHA DOTTED': 1845,
'TAG AMPERSAND': 917542,
'TAG APOSTROPHE': 917543,
'TAG ASTERISK': 917546,
'TAG CIRCUMFLEX ACCENT': 917598,
'TAG COLON': 917562,
'TAG COMMA': 917548,
'TAG COMMERCIAL AT': 917568,
'TAG DIGIT EIGHT': 917560,
'TAG DIGIT FIVE': 917557,
'TAG DIGIT FOUR': 917556,
'TAG DIGIT NINE': 917561,
'TAG DIGIT ONE': 917553,
'TAG DIGIT SEVEN': 917559,
'TAG DIGIT SIX': 917558,
'TAG DIGIT THREE': 917555,
'TAG DIGIT TWO': 917554,
'TAG DIGIT ZERO': 917552,
'TAG DOLLAR SIGN': 917540,
'TAG EQUALS SIGN': 917565,
'TAG EXCLAMATION MARK': 917537,
'TAG FULL STOP': 917550,
'TAG GRAVE ACCENT': 917600,
'TAG GREATER-THAN SIGN': 917566,
'TAG HYPHEN-MINUS': 917549,
'TAG LATIN CAPITAL LETTER A': 917569,
'TAG LATIN CAPITAL LETTER B': 917570,
'TAG LATIN CAPITAL LETTER C': 917571,
'TAG LATIN CAPITAL LETTER D': 917572,
'TAG LATIN CAPITAL LETTER E': 917573,
'TAG LATIN CAPITAL LETTER F': 917574,
'TAG LATIN CAPITAL LETTER G': 917575,
'TAG LATIN CAPITAL LETTER H': 917576,
'TAG LATIN CAPITAL LETTER I': 917577,
'TAG LATIN CAPITAL LETTER J': 917578,
'TAG LATIN CAPITAL LETTER K': 917579,
'TAG LATIN CAPITAL LETTER L': 917580,
'TAG LATIN CAPITAL LETTER M': 917581,
'TAG LATIN CAPITAL LETTER N': 917582,
'TAG LATIN CAPITAL LETTER O': 917583,
'TAG LATIN CAPITAL LETTER P': 917584,
'TAG LATIN CAPITAL LETTER Q': 917585,
'TAG LATIN CAPITAL LETTER R': 917586,
'TAG LATIN CAPITAL LETTER S': 917587,
'TAG LATIN CAPITAL LETTER T': 917588,
'TAG LATIN CAPITAL LETTER U': 917589,
'TAG LATIN CAPITAL LETTER V': 917590,
'TAG LATIN CAPITAL LETTER W': 917591,
'TAG LATIN CAPITAL LETTER X': 917592,
'TAG LATIN CAPITAL LETTER Y': 917593,
'TAG LATIN CAPITAL LETTER Z': 917594,
'TAG LATIN SMALL LETTER A': 917601,
'TAG LATIN SMALL LETTER B': 917602,
'TAG LATIN SMALL LETTER C': 917603,
'TAG LATIN SMALL LETTER D': 917604,
'TAG LATIN SMALL LETTER E': 917605,
'TAG LATIN SMALL LETTER F': 917606,
'TAG LATIN SMALL LETTER G': 917607,
'TAG LATIN SMALL LETTER H': 917608,
'TAG LATIN SMALL LETTER I': 917609,
'TAG LATIN SMALL LETTER J': 917610,
'TAG LATIN SMALL LETTER K': 917611,
'TAG LATIN SMALL LETTER L': 917612,
'TAG LATIN SMALL LETTER M': 917613,
'TAG LATIN SMALL LETTER N': 917614,
'TAG LATIN SMALL LETTER O': 917615,
'TAG LATIN SMALL LETTER P': 917616,
'TAG LATIN SMALL LETTER Q': 917617,
'TAG LATIN SMALL LETTER R': 917618,
'TAG LATIN SMALL LETTER S': 917619,
'TAG LATIN SMALL LETTER T': 917620,
'TAG LATIN SMALL LETTER U': 917621,
'TAG LATIN SMALL LETTER V': 917622,
'TAG LATIN SMALL LETTER W': 917623,
'TAG LATIN SMALL LETTER X': 917624,
'TAG LATIN SMALL LETTER Y': 917625,
'TAG LATIN SMALL LETTER Z': 917626,
'TAG LEFT CURLY BRACKET': 917627,
'TAG LEFT PARENTHESIS': 917544,
'TAG LEFT SQUARE BRACKET': 917595,
'TAG LESS-THAN SIGN': 917564,
'TAG LOW LINE': 917599,
'TAG NUMBER SIGN': 917539,
'TAG PERCENT SIGN': 917541,
'TAG PLUS SIGN': 917547,
'TAG QUESTION MARK': 917567,
'TAG QUOTATION MARK': 917538,
'TAG REVERSE SOLIDUS': 917596,
'TAG RIGHT CURLY BRACKET': 917629,
'TAG RIGHT PARENTHESIS': 917545,
'TAG RIGHT SQUARE BRACKET': 917597,
'TAG SEMICOLON': 917563,
'TAG SOLIDUS': 917551,
'TAG SPACE': 917536,
'TAG TILDE': 917630,
'TAG VERTICAL LINE': 917628,
'TAGALOG LETTER A': 5888,
'TAGALOG LETTER BA': 5898,
'TAGALOG LETTER DA': 5895,
'TAGALOG LETTER GA': 5892,
'TAGALOG LETTER HA': 5905,
'TAGALOG LETTER I': 5889,
'TAGALOG LETTER KA': 5891,
'TAGALOG LETTER LA': 5902,
'TAGALOG LETTER MA': 5899,
'TAGALOG LETTER NA': 5896,
'TAGALOG LETTER NGA': 5893,
'TAGALOG LETTER PA': 5897,
'TAGALOG LETTER SA': 5904,
'TAGALOG LETTER TA': 5894,
'TAGALOG LETTER U': 5890,
'TAGALOG LETTER WA': 5903,
'TAGALOG LETTER YA': 5900,
'TAGALOG SIGN VIRAMA': 5908,
'TAGALOG VOWEL SIGN I': 5906,
'TAGALOG VOWEL SIGN U': 5907,
'TAGBANWA LETTER A': 5984,
'TAGBANWA LETTER BA': 5994,
'TAGBANWA LETTER DA': 5991,
'TAGBANWA LETTER GA': 5988,
'TAGBANWA LETTER I': 5985,
'TAGBANWA LETTER KA': 5987,
'TAGBANWA LETTER LA': 5998,
'TAGBANWA LETTER MA': 5995,
'TAGBANWA LETTER NA': 5992,
'TAGBANWA LETTER NGA': 5989,
'TAGBANWA LETTER PA': 5993,
'TAGBANWA LETTER SA': 6000,
'TAGBANWA LETTER TA': 5990,
'TAGBANWA LETTER U': 5986,
'TAGBANWA LETTER WA': 5999,
'TAGBANWA LETTER YA': 5996,
'TAGBANWA VOWEL SIGN I': 6002,
'TAGBANWA VOWEL SIGN U': 6003,
'TAI LE LETTER A': 6499,
'TAI LE LETTER AI': 6509,
'TAI LE LETTER AUE': 6508,
'TAI LE LETTER E': 6507,
'TAI LE LETTER EE': 6501,
'TAI LE LETTER EH': 6502,
'TAI LE LETTER FA': 6492,
'TAI LE LETTER HA': 6494,
'TAI LE LETTER I': 6500,
'TAI LE LETTER KA': 6480,
'TAI LE LETTER KHA': 6496,
'TAI LE LETTER LA': 6488,
'TAI LE LETTER MA': 6491,
'TAI LE LETTER NA': 6498,
'TAI LE LETTER NGA': 6482,
'TAI LE LETTER O': 6505,
'TAI LE LETTER OO': 6504,
'TAI LE LETTER PA': 6489,
'TAI LE LETTER PHA': 6490,
'TAI LE LETTER QA': 6495,
'TAI LE LETTER SA': 6484,
'TAI LE LETTER TA': 6486,
'TAI LE LETTER THA': 6487,
'TAI LE LETTER TONE-2': 6512,
'TAI LE LETTER TONE-3': 6513,
'TAI LE LETTER TONE-4': 6514,
'TAI LE LETTER TONE-5': 6515,
'TAI LE LETTER TONE-6': 6516,
'TAI LE LETTER TSA': 6483,
'TAI LE LETTER TSHA': 6497,
'TAI LE LETTER U': 6503,
'TAI LE LETTER UE': 6506,
'TAI LE LETTER VA': 6493,
'TAI LE LETTER XA': 6481,
'TAI LE LETTER YA': 6485,
'TAMIL AS ABOVE SIGN': 3064,
'TAMIL AU LENGTH MARK': 3031,
'TAMIL CREDIT SIGN': 3063,
'TAMIL DAY SIGN': 3059,
'TAMIL DEBIT SIGN': 3062,
'TAMIL DIGIT EIGHT': 3054,
'TAMIL DIGIT FIVE': 3051,
'TAMIL DIGIT FOUR': 3050,
'TAMIL DIGIT NINE': 3055,
'TAMIL DIGIT ONE': 3047,
'TAMIL DIGIT SEVEN': 3053,
'TAMIL DIGIT SIX': 3052,
'TAMIL DIGIT THREE': 3049,
'TAMIL DIGIT TWO': 3048,
'TAMIL DIGIT ZERO': 3046,
'TAMIL LETTER A': 2949,
'TAMIL LETTER AA': 2950,
'TAMIL LETTER AI': 2960,
'TAMIL LETTER AU': 2964,
'TAMIL LETTER CA': 2970,
'TAMIL LETTER E': 2958,
'TAMIL LETTER EE': 2959,
'TAMIL LETTER HA': 3001,
'TAMIL LETTER I': 2951,
'TAMIL LETTER II': 2952,
'TAMIL LETTER JA': 2972,
'TAMIL LETTER KA': 2965,
'TAMIL LETTER LA': 2994,
'TAMIL LETTER LLA': 2995,
'TAMIL LETTER LLLA': 2996,
'TAMIL LETTER MA': 2990,
'TAMIL LETTER NA': 2984,
'TAMIL LETTER NGA': 2969,
'TAMIL LETTER NNA': 2979,
'TAMIL LETTER NNNA': 2985,
'TAMIL LETTER NYA': 2974,
'TAMIL LETTER O': 2962,
'TAMIL LETTER OO': 2963,
'TAMIL LETTER PA': 2986,
'TAMIL LETTER RA': 2992,
'TAMIL LETTER RRA': 2993,
'TAMIL LETTER SA': 3000,
'TAMIL LETTER SHA': 2998,
'TAMIL LETTER SSA': 2999,
'TAMIL LETTER TA': 2980,
'TAMIL LETTER TTA': 2975,
'TAMIL LETTER U': 2953,
'TAMIL LETTER UU': 2954,
'TAMIL LETTER VA': 2997,
'TAMIL LETTER YA': 2991,
'TAMIL MONTH SIGN': 3060,
'TAMIL NUMBER ONE HUNDRED': 3057,
'TAMIL NUMBER ONE THOUSAND': 3058,
'TAMIL NUMBER SIGN': 3066,
'TAMIL NUMBER TEN': 3056,
'TAMIL RUPEE SIGN': 3065,
'TAMIL SIGN ANUSVARA': 2946,
'TAMIL SIGN VIRAMA': 3021,
'TAMIL SIGN VISARGA': 2947,
'TAMIL VOWEL SIGN AA': 3006,
'TAMIL VOWEL SIGN AI': 3016,
'TAMIL VOWEL SIGN AU': 3020,
'TAMIL VOWEL SIGN E': 3014,
'TAMIL VOWEL SIGN EE': 3015,
'TAMIL VOWEL SIGN I': 3007,
'TAMIL VOWEL SIGN II': 3008,
'TAMIL VOWEL SIGN O': 3018,
'TAMIL VOWEL SIGN OO': 3019,
'TAMIL VOWEL SIGN U': 3009,
'TAMIL VOWEL SIGN UU': 3010,
'TAMIL YEAR SIGN': 3061,
'TAPE DRIVE': 9991,
'TAURUS': 9801,
'TEARDROP-BARBED RIGHTWARDS ARROW': 10170,
'TEARDROP-SPOKED ASTERISK': 10043,
'TELEPHONE LOCATION SIGN': 9990,
'TELEPHONE RECORDER': 8981,
'TELEPHONE SIGN': 8481,
'TELUGU AI LENGTH MARK': 3158,
'TELUGU DIGIT EIGHT': 3182,
'TELUGU DIGIT FIVE': 3179,
'TELUGU DIGIT FOUR': 3178,
'TELUGU DIGIT NINE': 3183,
'TELUGU DIGIT ONE': 3175,
'TELUGU DIGIT SEVEN': 3181,
'TELUGU DIGIT SIX': 3180,
'TELUGU DIGIT THREE': 3177,
'TELUGU DIGIT TWO': 3176,
'TELUGU DIGIT ZERO': 3174,
'TELUGU LENGTH MARK': 3157,
'TELUGU LETTER A': 3077,
'TELUGU LETTER AA': 3078,
'TELUGU LETTER AI': 3088,
'TELUGU LETTER AU': 3092,
'TELUGU LETTER BA': 3116,
'TELUGU LETTER BHA': 3117,
'TELUGU LETTER CA': 3098,
'TELUGU LETTER CHA': 3099,
'TELUGU LETTER DA': 3110,
'TELUGU LETTER DDA': 3105,
'TELUGU LETTER DDHA': 3106,
'TELUGU LETTER DHA': 3111,
'TELUGU LETTER E': 3086,
'TELUGU LETTER EE': 3087,
'TELUGU LETTER GA': 3095,
'TELUGU LETTER GHA': 3096,
'TELUGU LETTER HA': 3129,
'TELUGU LETTER I': 3079,
'TELUGU LETTER II': 3080,
'TELUGU LETTER JA': 3100,
'TELUGU LETTER JHA': 3101,
'TELUGU LETTER KA': 3093,
'TELUGU LETTER KHA': 3094,
'TELUGU LETTER LA': 3122,
'TELUGU LETTER LLA': 3123,
'TELUGU LETTER MA': 3118,
'TELUGU LETTER NA': 3112,
'TELUGU LETTER NGA': 3097,
'TELUGU LETTER NNA': 3107,
'TELUGU LETTER NYA': 3102,
'TELUGU LETTER O': 3090,
'TELUGU LETTER OO': 3091,
'TELUGU LETTER PA': 3114,
'TELUGU LETTER PHA': 3115,
'TELUGU LETTER RA': 3120,
'TELUGU LETTER RRA': 3121,
'TELUGU LETTER SA': 3128,
'TELUGU LETTER SHA': 3126,
'TELUGU LETTER SSA': 3127,
'TELUGU LETTER TA': 3108,
'TELUGU LETTER THA': 3109,
'TELUGU LETTER TTA': 3103,
'TELUGU LETTER TTHA': 3104,
'TELUGU LETTER U': 3081,
'TELUGU LETTER UU': 3082,
'TELUGU LETTER VA': 3125,
'TELUGU LETTER VOCALIC L': 3084,
'TELUGU LETTER VOCALIC LL': 3169,
'TELUGU LETTER VOCALIC R': 3083,
'TELUGU LETTER VOCALIC RR': 3168,
'TELUGU LETTER YA': 3119,
'TELUGU SIGN ANUSVARA': 3074,
'TELUGU SIGN CANDRABINDU': 3073,
'TELUGU SIGN VIRAMA': 3149,
'TELUGU SIGN VISARGA': 3075,
'TELUGU VOWEL SIGN AA': 3134,
'TELUGU VOWEL SIGN AI': 3144,
'TELUGU VOWEL SIGN AU': 3148,
'TELUGU VOWEL SIGN E': 3142,
'TELUGU VOWEL SIGN EE': 3143,
'TELUGU VOWEL SIGN I': 3135,
'TELUGU VOWEL SIGN II': 3136,
'TELUGU VOWEL SIGN O': 3146,
'TELUGU VOWEL SIGN OO': 3147,
'TELUGU VOWEL SIGN U': 3137,
'TELUGU VOWEL SIGN UU': 3138,
'TELUGU VOWEL SIGN VOCALIC R': 3139,
'TELUGU VOWEL SIGN VOCALIC RR': 3140,
'TETRAGRAM FOR ACCUMULATION': 119617,
'TETRAGRAM FOR ADVANCE': 119577,
'TETRAGRAM FOR AGGRAVATION': 119633,
'TETRAGRAM FOR ASCENT': 119564,
'TETRAGRAM FOR BARRIER': 119561,
'TETRAGRAM FOR BOLD RESOLUTION': 119587,
'TETRAGRAM FOR BRANCHING OUT': 119566,
'TETRAGRAM FOR CENTRE': 119558,
'TETRAGRAM FOR CHANGE': 119585,
'TETRAGRAM FOR CLOSED MOUTH': 119613,
'TETRAGRAM FOR CLOSENESS': 119590,
'TETRAGRAM FOR CLOSURE': 119631,
'TETRAGRAM FOR COMPLETION': 119630,
'TETRAGRAM FOR COMPLIANCE': 119634,
'TETRAGRAM FOR CONSTANCY': 119608,
'TETRAGRAM FOR CONTACT': 119573,
'TETRAGRAM FOR CONTENTION': 119582,
'TETRAGRAM FOR CONTRARIETY': 119563,
'TETRAGRAM FOR DARKENING': 119624,
'TETRAGRAM FOR DECISIVENESS': 119586,
'TETRAGRAM FOR DEFECTIVENESS OR DISTORTION': 119567,
'TETRAGRAM FOR DEPARTURE': 119623,
'TETRAGRAM FOR DIFFICULTIES': 119636,
'TETRAGRAM FOR DIMINISHMENT': 119612,
'TETRAGRAM FOR DIMMING': 119625,
'TETRAGRAM FOR DIVERGENCE': 119568,
'TETRAGRAM FOR DOUBT': 119619,
'TETRAGRAM FOR DUTIES': 119584,
'TETRAGRAM FOR EASE': 119580,
'TETRAGRAM FOR EMBELLISHMENT': 119618,
'TETRAGRAM FOR ENCOUNTERS': 119600,
'TETRAGRAM FOR ENDEAVOUR': 119583,
'TETRAGRAM FOR ENLARGEMENT': 119603,
'TETRAGRAM FOR ETERNITY': 119610,
'TETRAGRAM FOR EXHAUSTION': 119626,
'TETRAGRAM FOR FAILURE': 119632,
'TETRAGRAM FOR FLIGHT': 119606,
'TETRAGRAM FOR FOLLOWING': 119576,
'TETRAGRAM FOR FOSTERING': 119638,
'TETRAGRAM FOR FULL CIRCLE': 119559,
'TETRAGRAM FOR FULLNESS': 119595,
'TETRAGRAM FOR GATHERING': 119592,
'TETRAGRAM FOR GATHERING IN': 119615,
'TETRAGRAM FOR GOING TO MEET': 119599,
'TETRAGRAM FOR GREATNESS': 119602,
'TETRAGRAM FOR GUARDEDNESS': 119614,
'TETRAGRAM FOR HARDNESS': 119629,
'TETRAGRAM FOR HOLDING BACK': 119574,
'TETRAGRAM FOR INCREASE': 119570,
'TETRAGRAM FOR INNER': 119622,
'TETRAGRAM FOR JOY': 119581,
'TETRAGRAM FOR KEEPING SMALL': 119562,
'TETRAGRAM FOR KINSHIP': 119591,
'TETRAGRAM FOR LABOURING': 119637,
'TETRAGRAM FOR LAW OR MODEL': 119597,
'TETRAGRAM FOR LEGION': 119589,
'TETRAGRAM FOR MASSING': 119616,
'TETRAGRAM FOR MEASURE': 119609,
'TETRAGRAM FOR MIRED': 119560,
'TETRAGRAM FOR ON THE VERGE': 119635,
'TETRAGRAM FOR OPPOSITION': 119565,
'TETRAGRAM FOR PACKING': 119588,
'TETRAGRAM FOR PATTERN': 119604,
'TETRAGRAM FOR PENETRATION': 119571,
'TETRAGRAM FOR PURITY': 119594,
'TETRAGRAM FOR REACH': 119572,
'TETRAGRAM FOR RELEASE': 119578,
'TETRAGRAM FOR RESIDENCE': 119596,
'TETRAGRAM FOR RESISTANCE': 119579,
'TETRAGRAM FOR RESPONSE': 119598,
'TETRAGRAM FOR RITUAL': 119605,
'TETRAGRAM FOR SEVERANCE': 119627,
'TETRAGRAM FOR SINKING': 119621,
'TETRAGRAM FOR STOPPAGE': 119628,
'TETRAGRAM FOR STOVE': 119601,
'TETRAGRAM FOR STRENGTH': 119593,
'TETRAGRAM FOR UNITY': 119611,
'TETRAGRAM FOR VASTNESS OR WASTING': 119607,
'TETRAGRAM FOR WAITING': 119575,
'TETRAGRAM FOR WATCH': 119620,
'TETRAGRAM FOR YOUTHFULNESS': 119569,
'THAANA AABAAFILI': 1959,
'THAANA ABAFILI': 1958,
'THAANA EBEFILI': 1964,
'THAANA EEBEEFILI': 1961,
'THAANA EYBEYFILI': 1965,
'THAANA IBIFILI': 1960,
'THAANA LETTER AINU': 1954,
'THAANA LETTER ALIFU': 1927,
'THAANA LETTER BAA': 1924,
'THAANA LETTER CHAVIYANI': 1943,
'THAANA LETTER DAADHU': 1951,
'THAANA LETTER DAVIYANI': 1937,
'THAANA LETTER DHAALU': 1931,
'THAANA LETTER FAAFU': 1930,
'THAANA LETTER GAAFU': 1934,
'THAANA LETTER GHAINU': 1955,
'THAANA LETTER GNAVIYANI': 1935,
'THAANA LETTER HAA': 1920,
'THAANA LETTER HHAA': 1945,
'THAANA LETTER JAVIYANI': 1942,
'THAANA LETTER KAAFU': 1926,
'THAANA LETTER KHAA': 1946,
'THAANA LETTER LAAMU': 1933,
'THAANA LETTER LHAVIYANI': 1925,
'THAANA LETTER MEEMU': 1929,
'THAANA LETTER NAA': 1969,
'THAANA LETTER NOONU': 1922,
'THAANA LETTER PAVIYANI': 1941,
'THAANA LETTER QAAFU': 1956,
'THAANA LETTER RAA': 1923,
'THAANA LETTER SAADHU': 1950,
'THAANA LETTER SEENU': 1936,
'THAANA LETTER SHAVIYANI': 1921,
'THAANA LETTER SHEENU': 1949,
'THAANA LETTER TAVIYANI': 1939,
'THAANA LETTER THAA': 1932,
'THAANA LETTER THAALU': 1947,
'THAANA LETTER TO': 1952,
'THAANA LETTER TTAA': 1944,
'THAANA LETTER VAAVU': 1928,
'THAANA LETTER WAAVU': 1957,
'THAANA LETTER YAA': 1940,
'THAANA LETTER ZAA': 1948,
'THAANA LETTER ZAVIYANI': 1938,
'THAANA LETTER ZO': 1953,
'THAANA OABOAFILI': 1967,
'THAANA OBOFILI': 1966,
'THAANA OOBOOFILI': 1963,
'THAANA SUKUN': 1968,
'THAANA UBUFILI': 1962,
'THAI CHARACTER ANGKHANKHU': 3674,
'THAI CHARACTER BO BAIMAI': 3610,
'THAI CHARACTER CHO CHAN': 3592,
'THAI CHARACTER CHO CHANG': 3594,
'THAI CHARACTER CHO CHING': 3593,
'THAI CHARACTER CHO CHOE': 3596,
'THAI CHARACTER DO CHADA': 3598,
'THAI CHARACTER DO DEK': 3604,
'THAI CHARACTER FO FA': 3613,
'THAI CHARACTER FO FAN': 3615,
'THAI CHARACTER FONGMAN': 3663,
'THAI CHARACTER HO HIP': 3627,
'THAI CHARACTER HO NOKHUK': 3630,
'THAI CHARACTER KHO KHAI': 3586,
'THAI CHARACTER KHO KHON': 3589,
'THAI CHARACTER KHO KHUAT': 3587,
'THAI CHARACTER KHO KHWAI': 3588,
'THAI CHARACTER KHO RAKHANG': 3590,
'THAI CHARACTER KHOMUT': 3675,
'THAI CHARACTER KO KAI': 3585,
'THAI CHARACTER LAKKHANGYAO': 3653,
'THAI CHARACTER LO CHULA': 3628,
'THAI CHARACTER LO LING': 3621,
'THAI CHARACTER LU': 3622,
'THAI CHARACTER MAI CHATTAWA': 3659,
'THAI CHARACTER MAI EK': 3656,
'THAI CHARACTER MAI HAN-AKAT': 3633,
'THAI CHARACTER MAI THO': 3657,
'THAI CHARACTER MAI TRI': 3658,
'THAI CHARACTER MAITAIKHU': 3655,
'THAI CHARACTER MAIYAMOK': 3654,
'THAI CHARACTER MO MA': 3617,
'THAI CHARACTER NGO NGU': 3591,
'THAI CHARACTER NIKHAHIT': 3661,
'THAI CHARACTER NO NEN': 3603,
'THAI CHARACTER NO NU': 3609,
'THAI CHARACTER O ANG': 3629,
'THAI CHARACTER PAIYANNOI': 3631,
'THAI CHARACTER PHINTHU': 3642,
'THAI CHARACTER PHO PHAN': 3614,
'THAI CHARACTER PHO PHUNG': 3612,
'THAI CHARACTER PHO SAMPHAO': 3616,
'THAI CHARACTER PO PLA': 3611,
'THAI CHARACTER RO RUA': 3619,
'THAI CHARACTER RU': 3620,
'THAI CHARACTER SARA A': 3632,
'THAI CHARACTER SARA AA': 3634,
'THAI CHARACTER SARA AE': 3649,
'THAI CHARACTER SARA AI MAIMALAI': 3652,
'THAI CHARACTER SARA AI MAIMUAN': 3651,
'THAI CHARACTER SARA AM': 3635,
'THAI CHARACTER SARA E': 3648,
'THAI CHARACTER SARA I': 3636,
'THAI CHARACTER SARA II': 3637,
'THAI CHARACTER SARA O': 3650,
'THAI CHARACTER SARA U': 3640,
'THAI CHARACTER SARA UE': 3638,
'THAI CHARACTER SARA UEE': 3639,
'THAI CHARACTER SARA UU': 3641,
'THAI CHARACTER SO RUSI': 3625,
'THAI CHARACTER SO SALA': 3624,
'THAI CHARACTER SO SO': 3595,
'THAI CHARACTER SO SUA': 3626,
'THAI CHARACTER THANTHAKHAT': 3660,
'THAI CHARACTER THO NANGMONTHO': 3601,
'THAI CHARACTER THO PHUTHAO': 3602,
'THAI CHARACTER THO THAHAN': 3607,
'THAI CHARACTER THO THAN': 3600,
'THAI CHARACTER THO THONG': 3608,
'THAI CHARACTER THO THUNG': 3606,
'THAI CHARACTER TO PATAK': 3599,
'THAI CHARACTER TO TAO': 3605,
'THAI CHARACTER WO WAEN': 3623,
'THAI CHARACTER YAMAKKAN': 3662,
'THAI CHARACTER YO YAK': 3618,
'THAI CHARACTER YO YING': 3597,
'THAI CURRENCY SYMBOL BAHT': 3647,
'THAI DIGIT EIGHT': 3672,
'THAI DIGIT FIVE': 3669,
'THAI DIGIT FOUR': 3668,
'THAI DIGIT NINE': 3673,
'THAI DIGIT ONE': 3665,
'THAI DIGIT SEVEN': 3671,
'THAI DIGIT SIX': 3670,
'THAI DIGIT THREE': 3667,
'THAI DIGIT TWO': 3666,
'THAI DIGIT ZERO': 3664,
'THERE DOES NOT EXIST': 8708,
'THERE EXISTS': 8707,
'THEREFORE': 8756,
'THERMODYNAMIC': 10727,
'THIN SPACE': 8201,
'THREE CONSECUTIVE EQUALS SIGNS': 10870,
'THREE DIMENSIONAL ANGLE': 10176,
'THREE DOT PUNCTUATION': 8278,
'THREE RIGHTWARDS ARROWS': 8694,
'THREE-D BOTTOM-LIGHTED RIGHTWARDS ARROWHEAD': 10147,
'THREE-D TOP-LIGHTED RIGHTWARDS ARROWHEAD': 10146,
'THREE-PER-EM SPACE': 8196,
'THUNDERSTORM': 9736,
'TIBETAN ASTROLOGICAL SIGN -KHYUD PA': 3864,
'TIBETAN ASTROLOGICAL SIGN SDONG TSHUGS': 3865,
'TIBETAN ASTROLOGICAL SIGN SGRA GCAN -CHAR RTAGS': 3863,
'TIBETAN CANTILLATION SIGN CANG TE-U': 4034,
'TIBETAN CANTILLATION SIGN HEAVY BEAT': 4032,
'TIBETAN CANTILLATION SIGN LIGHT BEAT': 4033,
'TIBETAN CANTILLATION SIGN SBUB -CHAL': 4035,
'TIBETAN DIGIT EIGHT': 3880,
'TIBETAN DIGIT FIVE': 3877,
'TIBETAN DIGIT FOUR': 3876,
'TIBETAN DIGIT HALF EIGHT': 3889,
'TIBETAN DIGIT HALF FIVE': 3886,
'TIBETAN DIGIT HALF FOUR': 3885,
'TIBETAN DIGIT HALF NINE': 3890,
'TIBETAN DIGIT HALF ONE': 3882,
'TIBETAN DIGIT HALF SEVEN': 3888,
'TIBETAN DIGIT HALF SIX': 3887,
'TIBETAN DIGIT HALF THREE': 3884,
'TIBETAN DIGIT HALF TWO': 3883,
'TIBETAN DIGIT HALF ZERO': 3891,
'TIBETAN DIGIT NINE': 3881,
'TIBETAN DIGIT ONE': 3873,
'TIBETAN DIGIT SEVEN': 3879,
'TIBETAN DIGIT SIX': 3878,
'TIBETAN DIGIT THREE': 3875,
'TIBETAN DIGIT TWO': 3874,
'TIBETAN DIGIT ZERO': 3872,
'TIBETAN KU RU KHA': 4030,
'TIBETAN KU RU KHA BZHI MIG CAN': 4031,
'TIBETAN LETTER -A': 3936,
'TIBETAN LETTER A': 3944,
'TIBETAN LETTER BA': 3926,
'TIBETAN LETTER BHA': 3927,
'TIBETAN LETTER CA': 3909,
'TIBETAN LETTER CHA': 3910,
'TIBETAN LETTER DA': 3921,
'TIBETAN LETTER DDA': 3916,
'TIBETAN LETTER DDHA': 3917,
'TIBETAN LETTER DHA': 3922,
'TIBETAN LETTER DZA': 3931,
'TIBETAN LETTER DZHA': 3932,
'TIBETAN LETTER FIXED-FORM RA': 3946,
'TIBETAN LETTER GA': 3906,
'TIBETAN LETTER GHA': 3907,
'TIBETAN LETTER HA': 3943,
'TIBETAN LETTER JA': 3911,
'TIBETAN LETTER KA': 3904,
'TIBETAN LETTER KHA': 3905,
'TIBETAN LETTER KSSA': 3945,
'TIBETAN LETTER LA': 3939,
'TIBETAN LETTER MA': 3928,
'TIBETAN LETTER NA': 3923,
'TIBETAN LETTER NGA': 3908,
'TIBETAN LETTER NNA': 3918,
'TIBETAN LETTER NYA': 3913,
'TIBETAN LETTER PA': 3924,
'TIBETAN LETTER PHA': 3925,
'TIBETAN LETTER RA': 3938,
'TIBETAN LETTER SA': 3942,
'TIBETAN LETTER SHA': 3940,
'TIBETAN LETTER SSA': 3941,
'TIBETAN LETTER TA': 3919,
'TIBETAN LETTER THA': 3920,
'TIBETAN LETTER TSA': 3929,
'TIBETAN LETTER TSHA': 3930,
'TIBETAN LETTER TTA': 3914,
'TIBETAN LETTER TTHA': 3915,
'TIBETAN LETTER WA': 3933,
'TIBETAN LETTER YA': 3937,
'TIBETAN LETTER ZA': 3935,
'TIBETAN LETTER ZHA': 3934,
'TIBETAN LOGOTYPE SIGN CHAD RTAGS': 3861,
'TIBETAN LOGOTYPE SIGN LHAG RTAGS': 3862,
'TIBETAN MARK ANG KHANG GYAS': 3901,
'TIBETAN MARK ANG KHANG GYON': 3900,
'TIBETAN MARK BKA- SHOG YIG MGO': 3850,
'TIBETAN MARK BSDUS RTAGS': 3892,
'TIBETAN MARK BSKA- SHOG GI MGO RGYAN': 4048,
'TIBETAN MARK BSKUR YIG MGO': 3849,
'TIBETAN MARK CARET -DZUD RTAGS BZHI MIG CAN': 3894,
'TIBETAN MARK CARET -DZUD RTAGS ME LONG CAN': 3859,
'TIBETAN MARK CARET YIG MGO PHUR SHAD MA': 3846,
'TIBETAN MARK CHE MGO': 3896,
'TIBETAN MARK CLOSING YIG MGO SGAB MA': 3845,
'TIBETAN MARK DELIMITER TSHEG BSTAR': 3852,
'TIBETAN MARK GTER TSHEG': 3860,
'TIBETAN MARK GTER YIG MGO -UM GTER TSHEG MA': 3843,
'TIBETAN MARK GTER YIG MGO -UM RNAM BCAD MA': 3842,
'TIBETAN MARK GTER YIG MGO TRUNCATED A': 3841,
'TIBETAN MARK GUG RTAGS GYAS': 3899,
'TIBETAN MARK GUG RTAGS GYON': 3898,
'TIBETAN MARK HALANTA': 3972,
'TIBETAN MARK INITIAL YIG MGO MDUN MA': 3844,
'TIBETAN MARK INTERSYLLABIC TSHEG': 3851,
'TIBETAN MARK MNYAM YIG GI MGO RGYAN': 4049,
'TIBETAN MARK NGAS BZUNG NYI ZLA': 3893,
'TIBETAN MARK NGAS BZUNG SGOR RTAGS': 3895,
'TIBETAN MARK NYIS SHAD': 3854,
'TIBETAN MARK NYIS TSHEG SHAD': 3856,
'TIBETAN MARK PALUTA': 3973,
'TIBETAN MARK RGYA GRAM SHAD': 3858,
'TIBETAN MARK RIN CHEN SPUNGS SHAD': 3857,
'TIBETAN MARK SBRUL SHAD': 3848,
'TIBETAN MARK SHAD': 3853,
'TIBETAN MARK TSA -PHRU': 3897,
'TIBETAN MARK TSHEG SHAD': 3855,
'TIBETAN MARK YIG MGO TSHEG SHAD MA': 3847,
'TIBETAN SIGN GRU CAN RGYINGS': 3978,
'TIBETAN SIGN GRU MED RGYINGS': 3979,
'TIBETAN SIGN LCE TSA CAN': 3976,
'TIBETAN SIGN LCI RTAGS': 3974,
'TIBETAN SIGN MAR TSHES': 3903,
'TIBETAN SIGN MCHU CAN': 3977,
'TIBETAN SIGN NYI ZLA NAA DA': 3970,
'TIBETAN SIGN RDEL DKAR GCIG': 3866,
'TIBETAN SIGN RDEL DKAR GNYIS': 3867,
'TIBETAN SIGN RDEL DKAR GSUM': 3868,
'TIBETAN SIGN RDEL DKAR RDEL NAG': 3871,
'TIBETAN SIGN RDEL NAG GCIG': 3869,
'TIBETAN SIGN RDEL NAG GNYIS': 3870,
'TIBETAN SIGN RDEL NAG GSUM': 4047,
'TIBETAN SIGN RJES SU NGA RO': 3966,
'TIBETAN SIGN RNAM BCAD': 3967,
'TIBETAN SIGN SNA LDAN': 3971,
'TIBETAN SIGN YANG RTAGS': 3975,
'TIBETAN SIGN YAR TSHES': 3902,
'TIBETAN SUBJOINED LETTER -A': 4016,
'TIBETAN SUBJOINED LETTER A': 4024,
'TIBETAN SUBJOINED LETTER BA': 4006,
'TIBETAN SUBJOINED LETTER BHA': 4007,
'TIBETAN SUBJOINED LETTER CA': 3989,
'TIBETAN SUBJOINED LETTER CHA': 3990,
'TIBETAN SUBJOINED LETTER DA': 4001,
'TIBETAN SUBJOINED LETTER DDA': 3996,
'TIBETAN SUBJOINED LETTER DDHA': 3997,
'TIBETAN SUBJOINED LETTER DHA': 4002,
'TIBETAN SUBJOINED LETTER DZA': 4011,
'TIBETAN SUBJOINED LETTER DZHA': 4012,
'TIBETAN SUBJOINED LETTER FIXED-FORM RA': 4028,
'TIBETAN SUBJOINED LETTER FIXED-FORM WA': 4026,
'TIBETAN SUBJOINED LETTER FIXED-FORM YA': 4027,
'TIBETAN SUBJOINED LETTER GA': 3986,
'TIBETAN SUBJOINED LETTER GHA': 3987,
'TIBETAN SUBJOINED LETTER HA': 4023,
'TIBETAN SUBJOINED LETTER JA': 3991,
'TIBETAN SUBJOINED LETTER KA': 3984,
'TIBETAN SUBJOINED LETTER KHA': 3985,
'TIBETAN SUBJOINED LETTER KSSA': 4025,
'TIBETAN SUBJOINED LETTER LA': 4019,
'TIBETAN SUBJOINED LETTER MA': 4008,
'TIBETAN SUBJOINED LETTER NA': 4003,
'TIBETAN SUBJOINED LETTER NGA': 3988,
'TIBETAN SUBJOINED LETTER NNA': 3998,
'TIBETAN SUBJOINED LETTER NYA': 3993,
'TIBETAN SUBJOINED LETTER PA': 4004,
'TIBETAN SUBJOINED LETTER PHA': 4005,
'TIBETAN SUBJOINED LETTER RA': 4018,
'TIBETAN SUBJOINED LETTER SA': 4022,
'TIBETAN SUBJOINED LETTER SHA': 4020,
'TIBETAN SUBJOINED LETTER SSA': 4021,
'TIBETAN SUBJOINED LETTER TA': 3999,
'TIBETAN SUBJOINED LETTER THA': 4000,
'TIBETAN SUBJOINED LETTER TSA': 4009,
'TIBETAN SUBJOINED LETTER TSHA': 4010,
'TIBETAN SUBJOINED LETTER TTA': 3994,
'TIBETAN SUBJOINED LETTER TTHA': 3995,
'TIBETAN SUBJOINED LETTER WA': 4013,
'TIBETAN SUBJOINED LETTER YA': 4017,
'TIBETAN SUBJOINED LETTER ZA': 4015,
'TIBETAN SUBJOINED LETTER ZHA': 4014,
'TIBETAN SYLLABLE OM': 3840,
'TIBETAN SYMBOL DRIL BU': 4036,
'TIBETAN SYMBOL NOR BU': 4041,
'TIBETAN SYMBOL NOR BU BZHI -KHYIL': 4044,
'TIBETAN SYMBOL NOR BU GSUM -KHYIL': 4043,
'TIBETAN SYMBOL NOR BU NYIS -KHYIL': 4042,
'TIBETAN SYMBOL PADMA GDAN': 4038,
'TIBETAN SYMBOL PHUR PA': 4040,
'TIBETAN SYMBOL RDO RJE': 4037,
'TIBETAN SYMBOL RDO RJE RGYA GRAM': 4039,
'TIBETAN VOWEL SIGN AA': 3953,
'TIBETAN VOWEL SIGN E': 3962,
'TIBETAN VOWEL SIGN EE': 3963,
'TIBETAN VOWEL SIGN I': 3954,
'TIBETAN VOWEL SIGN II': 3955,
'TIBETAN VOWEL SIGN O': 3964,
'TIBETAN VOWEL SIGN OO': 3965,
'TIBETAN VOWEL SIGN REVERSED I': 3968,
'TIBETAN VOWEL SIGN REVERSED II': 3969,
'TIBETAN VOWEL SIGN U': 3956,
'TIBETAN VOWEL SIGN UU': 3957,
'TIBETAN VOWEL SIGN VOCALIC L': 3960,
'TIBETAN VOWEL SIGN VOCALIC LL': 3961,
'TIBETAN VOWEL SIGN VOCALIC R': 3958,
'TIBETAN VOWEL SIGN VOCALIC RR': 3959,
'TIE OVER INFINITY': 10717,
'TIFINAGH LETTER AHAGGAR YAZH': 11595,
'TIFINAGH LETTER AYER YAGH': 11608,
'TIFINAGH LETTER BERBER ACADEMY YAH': 11585,
'TIFINAGH LETTER BERBER ACADEMY YAJ': 11573,
'TIFINAGH LETTER TAWELLEMET YAZ': 11620,
'TIFINAGH LETTER TUAREG YAGH': 11607,
'TIFINAGH LETTER TUAREG YAGN': 11600,
'TIFINAGH LETTER TUAREG YAH': 11586,
'TIFINAGH LETTER TUAREG YAK': 11582,
'TIFINAGH LETTER TUAREG YAKH': 11590,
'TIFINAGH LETTER TUAREG YANG': 11601,
'TIFINAGH LETTER TUAREG YAQ': 11592,
'TIFINAGH LETTER TUAREG YAZH': 11596,
'TIFINAGH LETTER YA': 11568,
'TIFINAGH LETTER YAA': 11588,
'TIFINAGH LETTER YAB': 11569,
'TIFINAGH LETTER YABH': 11570,
'TIFINAGH LETTER YACH': 11614,
'TIFINAGH LETTER YAD': 11575,
'TIFINAGH LETTER YADD': 11577,
'TIFINAGH LETTER YADDH': 11578,
'TIFINAGH LETTER YADH': 11576,
'TIFINAGH LETTER YAF': 11580,
'TIFINAGH LETTER YAG': 11571,
'TIFINAGH LETTER YAGH': 11606,
'TIFINAGH LETTER YAGHH': 11572,
'TIFINAGH LETTER YAH': 11584,
'TIFINAGH LETTER YAHH': 11587,
'TIFINAGH LETTER YAJ': 11574,
'TIFINAGH LETTER YAK': 11581,
'TIFINAGH LETTER YAKH': 11589,
'TIFINAGH LETTER YAKHH': 11583,
'TIFINAGH LETTER YAL': 11597,
'TIFINAGH LETTER YAM': 11598,
'TIFINAGH LETTER YAN': 11599,
'TIFINAGH LETTER YAP': 11602,
'TIFINAGH LETTER YAQ': 11591,
'TIFINAGH LETTER YAR': 11604,
'TIFINAGH LETTER YARR': 11605,
'TIFINAGH LETTER YAS': 11609,
'TIFINAGH LETTER YASH': 11611,
'TIFINAGH LETTER YASS': 11610,
'TIFINAGH LETTER YAT': 11612,
'TIFINAGH LETTER YATH': 11613,
'TIFINAGH LETTER YATT': 11615,
'TIFINAGH LETTER YAV': 11616,
'TIFINAGH LETTER YAW': 11617,
'TIFINAGH LETTER YAY': 11618,
'TIFINAGH LETTER YAZ': 11619,
'TIFINAGH LETTER YAZH': 11594,
'TIFINAGH LETTER YAZZ': 11621,
'TIFINAGH LETTER YEY': 11579,
'TIFINAGH LETTER YI': 11593,
'TIFINAGH LETTER YU': 11603,
'TIFINAGH MODIFIER LETTER LABIALIZATION MARK': 11631,
'TIGHT TRIFOLIATE SNOWFLAKE': 10053,
'TILDE': 126,
'TILDE OPERATOR': 8764,
'TILDE OPERATOR ABOVE RIGHTWARDS ARROW': 10610,
'TILDE OPERATOR WITH DOT ABOVE': 10858,
'TILDE OPERATOR WITH RISING DOTS': 10859,
'TIMES WITH LEFT HALF BLACK': 10708,
'TIMES WITH RIGHT HALF BLACK': 10709,
'TINY': 10750,
'TIRONIAN SIGN ET': 8266,
'TOP ARC ANTICLOCKWISE ARROW': 10554,
'TOP ARC ANTICLOCKWISE ARROW WITH PLUS': 10557,
'TOP ARC CLOCKWISE ARROW WITH MINUS': 10556,
'TOP HALF INTEGRAL': 8992,
'TOP LEFT CORNER': 8988,
'TOP LEFT CROP': 8975,
'TOP RIGHT CORNER': 8989,
'TOP RIGHT CROP': 8974,
'TOP SQUARE BRACKET': 9140,
'TOTAL RUNOUT': 9008,
'TRADE MARK SIGN': 8482,
'TRANSVERSAL INTERSECTION': 10971,
'TRIANGLE WITH DOT ABOVE': 10698,
'TRIANGLE WITH SERIFS AT BOTTOM': 10701,
'TRIANGLE WITH UNDERBAR': 10699,
'TRIANGLE-HEADED RIGHTWARDS ARROW': 10141,
'TRIANGULAR BULLET': 8227,
'TRICOLON': 8285,
'TRIGRAM FOR EARTH': 9783,
'TRIGRAM FOR FIRE': 9778,
'TRIGRAM FOR HEAVEN': 9776,
'TRIGRAM FOR LAKE': 9777,
'TRIGRAM FOR MOUNTAIN': 9782,
'TRIGRAM FOR THUNDER': 9779,
'TRIGRAM FOR WATER': 9781,
'TRIGRAM FOR WIND': 9780,
'TRIPLE COLON OPERATOR': 10998,
'TRIPLE HORIZONTAL BAR WITH DOUBLE VERTICAL STROKE': 10856,
'TRIPLE HORIZONTAL BAR WITH TRIPLE VERTICAL STROKE': 10857,
'TRIPLE INTEGRAL': 8749,
'TRIPLE NESTED GREATER-THAN': 11000,
'TRIPLE NESTED LESS-THAN': 10999,
'TRIPLE PLUS': 10747,
'TRIPLE PRIME': 8244,
'TRIPLE SOLIDUS BINARY RELATION': 11003,
'TRIPLE TILDE': 8779,
'TRIPLE VERTICAL BAR BINARY RELATION': 10996,
'TRIPLE VERTICAL BAR DELIMITER': 10624,
'TRIPLE VERTICAL BAR RIGHT TURNSTILE': 8874,
'TRIPLE VERTICAL BAR WITH HORIZONTAL STROKE': 10997,
'TRUE': 8872,
'TUGRIK SIGN': 8366,
'TURNED AMPERSAND': 8523,
'TURNED ANGLE': 10658,
'TURNED CAPITAL F': 8498,
'TURNED GREEK SMALL LETTER IOTA': 8489,
'TURNED NOT SIGN': 8985,
'TURNED SANS-SERIF CAPITAL G': 8513,
'TURNED SANS-SERIF CAPITAL L': 8514,
'TURNED SANS-SERIF CAPITAL Y': 8516,
'TWELVE POINTED BLACK STAR': 10041,
'TWO ASTERISKS ALIGNED VERTICALLY': 8273,
'TWO CONSECUTIVE EQUALS SIGNS': 10869,
'TWO DOT LEADER': 8229,
'TWO DOT PUNCTUATION': 8282,
'TWO INTERSECTING LOGICAL AND': 10837,
'TWO INTERSECTING LOGICAL OR': 10838,
'TWO JOINED SQUARES': 10697,
'TWO LOGICAL AND OPERATOR': 10759,
'TWO LOGICAL OR OPERATOR': 10760,
'UGARITIC LETTER AIN': 66451,
'UGARITIC LETTER ALPA': 66432,
'UGARITIC LETTER BETA': 66433,
'UGARITIC LETTER DELTA': 66436,
'UGARITIC LETTER DHAL': 66447,
'UGARITIC LETTER GAMLA': 66434,
'UGARITIC LETTER GHAIN': 66457,
'UGARITIC LETTER HO': 66437,
'UGARITIC LETTER HOTA': 66440,
'UGARITIC LETTER I': 66459,
'UGARITIC LETTER KAF': 66443,
'UGARITIC LETTER KHA': 66435,
'UGARITIC LETTER LAMDA': 66445,
'UGARITIC LETTER MEM': 66446,
'UGARITIC LETTER NUN': 66448,
'UGARITIC LETTER PU': 66452,
'UGARITIC LETTER QOPA': 66454,
'UGARITIC LETTER RASHA': 66455,
'UGARITIC LETTER SADE': 66453,
'UGARITIC LETTER SAMKA': 66450,
'UGARITIC LETTER SHIN': 66444,
'UGARITIC LETTER SSU': 66461,
'UGARITIC LETTER TET': 66441,
'UGARITIC LETTER THANNA': 66456,
'UGARITIC LETTER TO': 66458,
'UGARITIC LETTER U': 66460,
'UGARITIC LETTER WO': 66438,
'UGARITIC LETTER YOD': 66442,
'UGARITIC LETTER ZETA': 66439,
'UGARITIC LETTER ZU': 66449,
'UGARITIC WORD DIVIDER': 66463,
'UMBRELLA': 9730,
'UMBRELLA WITH RAIN DROPS': 9748,
'UNDERTIE': 8255,
'UNDO SYMBOL': 9100,
'UNION': 8746,
'UNION ABOVE BAR ABOVE INTERSECTION': 10824,
'UNION ABOVE INTERSECTION': 10822,
'UNION BESIDE AND JOINED WITH UNION': 10826,
'UNION WITH LOGICAL OR': 10821,
'UNION WITH MINUS SIGN': 10817,
'UNION WITH OVERBAR': 10818,
'UNIVERSAL RECYCLING SYMBOL': 9842,
'UNMARRIED PARTNERSHIP SYMBOL': 9903,
'UP ARROW THROUGH CIRCLE': 10685,
'UP ARROWHEAD': 8963,
'UP ARROWHEAD BETWEEN TWO HORIZONTAL BARS': 8996,
'UP BARB LEFT DOWN BARB LEFT HARPOON': 10577,
'UP BARB LEFT DOWN BARB RIGHT HARPOON': 10573,
'UP BARB RIGHT DOWN BARB LEFT HARPOON': 10572,
'UP BARB RIGHT DOWN BARB RIGHT HARPOON': 10575,
'UP DOWN ARROW': 8597,
'UP DOWN ARROW WITH BASE': 8616,
'UP DOWN BLACK ARROW': 11021,
'UP DOWN DOUBLE ARROW': 8661,
'UP DOWN WHITE ARROW': 8691,
'UP FISH TAIL': 10622,
'UP RIGHT DIAGONAL ELLIPSIS': 8944,
'UP TACK': 8869,
'UP TACK WITH CIRCLE ABOVE': 10207,
'UP-POINTING TRIANGLE WITH LEFT HALF BLACK': 9709,
'UP-POINTING TRIANGLE WITH RIGHT HALF BLACK': 9710,
'UPPER BLADE SCISSORS': 9985,
'UPPER HALF BLOCK': 9600,
'UPPER HALF CIRCLE': 9696,
'UPPER HALF INVERSE WHITE CIRCLE': 9690,
'UPPER LEFT CORNER WITH DOT': 10196,
'UPPER LEFT OR LOWER RIGHT CURLY BRACKET SECTION': 9136,
'UPPER LEFT QUADRANT CIRCULAR ARC': 9692,
'UPPER LEFT TRIANGLE': 9720,
'UPPER ONE EIGHTH BLOCK': 9620,
'UPPER RIGHT DROP-SHADOWED WHITE SQUARE': 10064,
'UPPER RIGHT OR LOWER LEFT CURLY BRACKET SECTION': 9137,
'UPPER RIGHT PENCIL': 10000,
'UPPER RIGHT QUADRANT CIRCULAR ARC': 9693,
'UPPER RIGHT SHADOWED WHITE SQUARE': 10066,
'UPPER RIGHT TRIANGLE': 9721,
'UPWARDS ANCORA': 11797,
'UPWARDS ARROW': 8593,
'UPWARDS ARROW FROM BAR': 8613,
'UPWARDS ARROW LEFTWARDS OF DOWNWARDS ARROW': 8645,
'UPWARDS ARROW TO BAR': 10514,
'UPWARDS ARROW WITH DOUBLE STROKE': 8670,
'UPWARDS ARROW WITH HORIZONTAL STROKE': 10505,
'UPWARDS ARROW WITH TIP LEFTWARDS': 8624,
'UPWARDS ARROW WITH TIP RIGHTWARDS': 8625,
'UPWARDS BLACK ARROW': 11014,
'UPWARDS DASHED ARROW': 8673,
'UPWARDS DOUBLE ARROW': 8657,
'UPWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT': 10606,
'UPWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT': 10595,
'UPWARDS HARPOON WITH BARB LEFT FROM BAR': 10592,
'UPWARDS HARPOON WITH BARB LEFT TO BAR': 10584,
'UPWARDS HARPOON WITH BARB LEFTWARDS': 8639,
'UPWARDS HARPOON WITH BARB RIGHT FROM BAR': 10588,
'UPWARDS HARPOON WITH BARB RIGHT TO BAR': 10580,
'UPWARDS HARPOON WITH BARB RIGHTWARDS': 8638,
'UPWARDS PAIRED ARROWS': 8648,
'UPWARDS QUADRUPLE ARROW': 10224,
'UPWARDS TRIPLE ARROW': 10506,
'UPWARDS TWO HEADED ARROW': 8607,
'UPWARDS TWO-HEADED ARROW FROM SMALL CIRCLE': 10569,
'UPWARDS WHITE ARROW': 8679,
'UPWARDS WHITE ARROW FROM BAR': 8682,
'UPWARDS WHITE ARROW ON PEDESTAL': 8683,
'UPWARDS WHITE ARROW ON PEDESTAL WITH HORIZONTAL BAR': 8684,
'UPWARDS WHITE ARROW ON PEDESTAL WITH VERTICAL BAR': 8685,
'UPWARDS WHITE DOUBLE ARROW': 8686,
'UPWARDS WHITE DOUBLE ARROW ON PEDESTAL': 8687,
'URANUS': 9797,
'VARIATION SELECTOR-1': 65024,
'VARIATION SELECTOR-10': 65033,
'VARIATION SELECTOR-100': 917843,
'VARIATION SELECTOR-101': 917844,
'VARIATION SELECTOR-102': 917845,
'VARIATION SELECTOR-103': 917846,
'VARIATION SELECTOR-104': 917847,
'VARIATION SELECTOR-105': 917848,
'VARIATION SELECTOR-106': 917849,
'VARIATION SELECTOR-107': 917850,
'VARIATION SELECTOR-108': 917851,
'VARIATION SELECTOR-109': 917852,
'VARIATION SELECTOR-11': 65034,
'VARIATION SELECTOR-110': 917853,
'VARIATION SELECTOR-111': 917854,
'VARIATION SELECTOR-112': 917855,
'VARIATION SELECTOR-113': 917856,
'VARIATION SELECTOR-114': 917857,
'VARIATION SELECTOR-115': 917858,
'VARIATION SELECTOR-116': 917859,
'VARIATION SELECTOR-117': 917860,
'VARIATION SELECTOR-118': 917861,
'VARIATION SELECTOR-119': 917862,
'VARIATION SELECTOR-12': 65035,
'VARIATION SELECTOR-120': 917863,
'VARIATION SELECTOR-121': 917864,
'VARIATION SELECTOR-122': 917865,
'VARIATION SELECTOR-123': 917866,
'VARIATION SELECTOR-124': 917867,
'VARIATION SELECTOR-125': 917868,
'VARIATION SELECTOR-126': 917869,
'VARIATION SELECTOR-127': 917870,
'VARIATION SELECTOR-128': 917871,
'VARIATION SELECTOR-129': 917872,
'VARIATION SELECTOR-13': 65036,
'VARIATION SELECTOR-130': 917873,
'VARIATION SELECTOR-131': 917874,
'VARIATION SELECTOR-132': 917875,
'VARIATION SELECTOR-133': 917876,
'VARIATION SELECTOR-134': 917877,
'VARIATION SELECTOR-135': 917878,
'VARIATION SELECTOR-136': 917879,
'VARIATION SELECTOR-137': 917880,
'VARIATION SELECTOR-138': 917881,
'VARIATION SELECTOR-139': 917882,
'VARIATION SELECTOR-14': 65037,
'VARIATION SELECTOR-140': 917883,
'VARIATION SELECTOR-141': 917884,
'VARIATION SELECTOR-142': 917885,
'VARIATION SELECTOR-143': 917886,
'VARIATION SELECTOR-144': 917887,
'VARIATION SELECTOR-145': 917888,
'VARIATION SELECTOR-146': 917889,
'VARIATION SELECTOR-147': 917890,
'VARIATION SELECTOR-148': 917891,
'VARIATION SELECTOR-149': 917892,
'VARIATION SELECTOR-15': 65038,
'VARIATION SELECTOR-150': 917893,
'VARIATION SELECTOR-151': 917894,
'VARIATION SELECTOR-152': 917895,
'VARIATION SELECTOR-153': 917896,
'VARIATION SELECTOR-154': 917897,
'VARIATION SELECTOR-155': 917898,
'VARIATION SELECTOR-156': 917899,
'VARIATION SELECTOR-157': 917900,
'VARIATION SELECTOR-158': 917901,
'VARIATION SELECTOR-159': 917902,
'VARIATION SELECTOR-16': 65039,
'VARIATION SELECTOR-160': 917903,
'VARIATION SELECTOR-161': 917904,
'VARIATION SELECTOR-162': 917905,
'VARIATION SELECTOR-163': 917906,
'VARIATION SELECTOR-164': 917907,
'VARIATION SELECTOR-165': 917908,
'VARIATION SELECTOR-166': 917909,
'VARIATION SELECTOR-167': 917910,
'VARIATION SELECTOR-168': 917911,
'VARIATION SELECTOR-169': 917912,
'VARIATION SELECTOR-17': 917760,
'VARIATION SELECTOR-170': 917913,
'VARIATION SELECTOR-171': 917914,
'VARIATION SELECTOR-172': 917915,
'VARIATION SELECTOR-173': 917916,
'VARIATION SELECTOR-174': 917917,
'VARIATION SELECTOR-175': 917918,
'VARIATION SELECTOR-176': 917919,
'VARIATION SELECTOR-177': 917920,
'VARIATION SELECTOR-178': 917921,
'VARIATION SELECTOR-179': 917922,
'VARIATION SELECTOR-18': 917761,
'VARIATION SELECTOR-180': 917923,
'VARIATION SELECTOR-181': 917924,
'VARIATION SELECTOR-182': 917925,
'VARIATION SELECTOR-183': 917926,
'VARIATION SELECTOR-184': 917927,
'VARIATION SELECTOR-185': 917928,
'VARIATION SELECTOR-186': 917929,
'VARIATION SELECTOR-187': 917930,
'VARIATION SELECTOR-188': 917931,
'VARIATION SELECTOR-189': 917932,
'VARIATION SELECTOR-19': 917762,
'VARIATION SELECTOR-190': 917933,
'VARIATION SELECTOR-191': 917934,
'VARIATION SELECTOR-192': 917935,
'VARIATION SELECTOR-193': 917936,
'VARIATION SELECTOR-194': 917937,
'VARIATION SELECTOR-195': 917938,
'VARIATION SELECTOR-196': 917939,
'VARIATION SELECTOR-197': 917940,
'VARIATION SELECTOR-198': 917941,
'VARIATION SELECTOR-199': 917942,
'VARIATION SELECTOR-2': 65025,
'VARIATION SELECTOR-20': 917763,
'VARIATION SELECTOR-200': 917943,
'VARIATION SELECTOR-201': 917944,
'VARIATION SELECTOR-202': 917945,
'VARIATION SELECTOR-203': 917946,
'VARIATION SELECTOR-204': 917947,
'VARIATION SELECTOR-205': 917948,
'VARIATION SELECTOR-206': 917949,
'VARIATION SELECTOR-207': 917950,
'VARIATION SELECTOR-208': 917951,
'VARIATION SELECTOR-209': 917952,
'VARIATION SELECTOR-21': 917764,
'VARIATION SELECTOR-210': 917953,
'VARIATION SELECTOR-211': 917954,
'VARIATION SELECTOR-212': 917955,
'VARIATION SELECTOR-213': 917956,
'VARIATION SELECTOR-214': 917957,
'VARIATION SELECTOR-215': 917958,
'VARIATION SELECTOR-216': 917959,
'VARIATION SELECTOR-217': 917960,
'VARIATION SELECTOR-218': 917961,
'VARIATION SELECTOR-219': 917962,
'VARIATION SELECTOR-22': 917765,
'VARIATION SELECTOR-220': 917963,
'VARIATION SELECTOR-221': 917964,
'VARIATION SELECTOR-222': 917965,
'VARIATION SELECTOR-223': 917966,
'VARIATION SELECTOR-224': 917967,
'VARIATION SELECTOR-225': 917968,
'VARIATION SELECTOR-226': 917969,
'VARIATION SELECTOR-227': 917970,
'VARIATION SELECTOR-228': 917971,
'VARIATION SELECTOR-229': 917972,
'VARIATION SELECTOR-23': 917766,
'VARIATION SELECTOR-230': 917973,
'VARIATION SELECTOR-231': 917974,
'VARIATION SELECTOR-232': 917975,
'VARIATION SELECTOR-233': 917976,
'VARIATION SELECTOR-234': 917977,
'VARIATION SELECTOR-235': 917978,
'VARIATION SELECTOR-236': 917979,
'VARIATION SELECTOR-237': 917980,
'VARIATION SELECTOR-238': 917981,
'VARIATION SELECTOR-239': 917982,
'VARIATION SELECTOR-24': 917767,
'VARIATION SELECTOR-240': 917983,
'VARIATION SELECTOR-241': 917984,
'VARIATION SELECTOR-242': 917985,
'VARIATION SELECTOR-243': 917986,
'VARIATION SELECTOR-244': 917987,
'VARIATION SELECTOR-245': 917988,
'VARIATION SELECTOR-246': 917989,
'VARIATION SELECTOR-247': 917990,
'VARIATION SELECTOR-248': 917991,
'VARIATION SELECTOR-249': 917992,
'VARIATION SELECTOR-25': 917768,
'VARIATION SELECTOR-250': 917993,
'VARIATION SELECTOR-251': 917994,
'VARIATION SELECTOR-252': 917995,
'VARIATION SELECTOR-253': 917996,
'VARIATION SELECTOR-254': 917997,
'VARIATION SELECTOR-255': 917998,
'VARIATION SELECTOR-256': 917999,
'VARIATION SELECTOR-26': 917769,
'VARIATION SELECTOR-27': 917770,
'VARIATION SELECTOR-28': 917771,
'VARIATION SELECTOR-29': 917772,
'VARIATION SELECTOR-3': 65026,
'VARIATION SELECTOR-30': 917773,
'VARIATION SELECTOR-31': 917774,
'VARIATION SELECTOR-32': 917775,
'VARIATION SELECTOR-33': 917776,
'VARIATION SELECTOR-34': 917777,
'VARIATION SELECTOR-35': 917778,
'VARIATION SELECTOR-36': 917779,
'VARIATION SELECTOR-37': 917780,
'VARIATION SELECTOR-38': 917781,
'VARIATION SELECTOR-39': 917782,
'VARIATION SELECTOR-4': 65027,
'VARIATION SELECTOR-40': 917783,
'VARIATION SELECTOR-41': 917784,
'VARIATION SELECTOR-42': 917785,
'VARIATION SELECTOR-43': 917786,
'VARIATION SELECTOR-44': 917787,
'VARIATION SELECTOR-45': 917788,
'VARIATION SELECTOR-46': 917789,
'VARIATION SELECTOR-47': 917790,
'VARIATION SELECTOR-48': 917791,
'VARIATION SELECTOR-49': 917792,
'VARIATION SELECTOR-5': 65028,
'VARIATION SELECTOR-50': 917793,
'VARIATION SELECTOR-51': 917794,
'VARIATION SELECTOR-52': 917795,
'VARIATION SELECTOR-53': 917796,
'VARIATION SELECTOR-54': 917797,
'VARIATION SELECTOR-55': 917798,
'VARIATION SELECTOR-56': 917799,
'VARIATION SELECTOR-57': 917800,
'VARIATION SELECTOR-58': 917801,
'VARIATION SELECTOR-59': 917802,
'VARIATION SELECTOR-6': 65029,
'VARIATION SELECTOR-60': 917803,
'VARIATION SELECTOR-61': 917804,
'VARIATION SELECTOR-62': 917805,
'VARIATION SELECTOR-63': 917806,
'VARIATION SELECTOR-64': 917807,
'VARIATION SELECTOR-65': 917808,
'VARIATION SELECTOR-66': 917809,
'VARIATION SELECTOR-67': 917810,
'VARIATION SELECTOR-68': 917811,
'VARIATION SELECTOR-69': 917812,
'VARIATION SELECTOR-7': 65030,
'VARIATION SELECTOR-70': 917813,
'VARIATION SELECTOR-71': 917814,
'VARIATION SELECTOR-72': 917815,
'VARIATION SELECTOR-73': 917816,
'VARIATION SELECTOR-74': 917817,
'VARIATION SELECTOR-75': 917818,
'VARIATION SELECTOR-76': 917819,
'VARIATION SELECTOR-77': 917820,
'VARIATION SELECTOR-78': 917821,
'VARIATION SELECTOR-79': 917822,
'VARIATION SELECTOR-8': 65031,
'VARIATION SELECTOR-80': 917823,
'VARIATION SELECTOR-81': 917824,
'VARIATION SELECTOR-82': 917825,
'VARIATION SELECTOR-83': 917826,
'VARIATION SELECTOR-84': 917827,
'VARIATION SELECTOR-85': 917828,
'VARIATION SELECTOR-86': 917829,
'VARIATION SELECTOR-87': 917830,
'VARIATION SELECTOR-88': 917831,
'VARIATION SELECTOR-89': 917832,
'VARIATION SELECTOR-9': 65032,
'VARIATION SELECTOR-90': 917833,
'VARIATION SELECTOR-91': 917834,
'VARIATION SELECTOR-92': 917835,
'VARIATION SELECTOR-93': 917836,
'VARIATION SELECTOR-94': 917837,
'VARIATION SELECTOR-95': 917838,
'VARIATION SELECTOR-96': 917839,
'VARIATION SELECTOR-97': 917840,
'VARIATION SELECTOR-98': 917841,
'VARIATION SELECTOR-99': 917842,
'VECTOR OR CROSS PRODUCT': 10799,
'VERSICLE': 8483,
'VERTICAL BAR BESIDE RIGHT TRIANGLE': 10704,
'VERTICAL BAR DOUBLE LEFT TURNSTILE': 10980,
'VERTICAL BAR TRIPLE RIGHT TURNSTILE': 10978,
'VERTICAL ELLIPSIS': 8942,
'VERTICAL FOUR DOTS': 8286,
'VERTICAL IDEOGRAPHIC ITERATION MARK': 12347,
'VERTICAL KANA REPEAT MARK': 12337,
'VERTICAL KANA REPEAT MARK LOWER HALF': 12341,
'VERTICAL KANA REPEAT MARK UPPER HALF': 12339,
'VERTICAL KANA REPEAT WITH VOICED SOUND MARK': 12338,
'VERTICAL KANA REPEAT WITH VOICED SOUND MARK UPPER HALF': 12340,
'VERTICAL LINE': 124,
'VERTICAL LINE EXTENSION': 9168,
'VERTICAL LINE WITH CIRCLE ABOVE': 10991,
'VERTICAL LINE WITH CIRCLE BELOW': 10992,
'VERTICAL LINE WITH MIDDLE DOT': 9087,
'VERTICAL MALE WITH STROKE SIGN': 9896,
'VERTICAL ZIGZAG LINE': 10650,
'VERY MUCH GREATER-THAN': 8921,
'VERY MUCH LESS-THAN': 8920,
'VICTORY HAND': 9996,
'VIEWDATA SQUARE': 8983,
'VIRGO': 9805,
'VOLUME INTEGRAL': 8752,
'VULGAR FRACTION FIVE EIGHTHS': 8541,
'VULGAR FRACTION FIVE SIXTHS': 8538,
'VULGAR FRACTION FOUR FIFTHS': 8536,
'VULGAR FRACTION ONE EIGHTH': 8539,
'VULGAR FRACTION ONE FIFTH': 8533,
'VULGAR FRACTION ONE HALF': 189,
'VULGAR FRACTION ONE QUARTER': 188,
'VULGAR FRACTION ONE SIXTH': 8537,
'VULGAR FRACTION ONE THIRD': 8531,
'VULGAR FRACTION SEVEN EIGHTHS': 8542,
'VULGAR FRACTION THREE EIGHTHS': 8540,
'VULGAR FRACTION THREE FIFTHS': 8535,
'VULGAR FRACTION THREE QUARTERS': 190,
'VULGAR FRACTION TWO FIFTHS': 8534,
'VULGAR FRACTION TWO THIRDS': 8532,
'WARNING SIGN': 9888,
'WATCH': 8986,
'WAVE ARROW POINTING DIRECTLY RIGHT': 10547,
'WAVE DASH': 12316,
'WAVY DASH': 12336,
'WAVY LINE': 8967,
'WAVY LOW LINE': 65103,
'WAVY OVERLINE': 65099,
'WEDGE-TAILED RIGHTWARDS ARROW': 10172,
'WEST SYRIAC CROSS': 9840,
'WHEEL OF DHARMA': 9784,
'WHEELCHAIR SYMBOL': 9855,
'WHITE BULLET': 9702,
'WHITE CHESS BISHOP': 9815,
'WHITE CHESS KING': 9812,
'WHITE CHESS KNIGHT': 9816,
'WHITE CHESS PAWN': 9817,
'WHITE CHESS QUEEN': 9813,
'WHITE CHESS ROOK': 9814,
'WHITE CIRCLE': 9675,
'WHITE CIRCLE WITH DOT RIGHT': 9862,
'WHITE CIRCLE WITH DOWN ARROW': 10732,
'WHITE CIRCLE WITH LOWER LEFT QUADRANT': 9717,
'WHITE CIRCLE WITH LOWER RIGHT QUADRANT': 9718,
'WHITE CIRCLE WITH TWO DOTS': 9863,
'WHITE CIRCLE WITH UPPER LEFT QUADRANT': 9716,
'WHITE CIRCLE WITH UPPER RIGHT QUADRANT': 9719,
'WHITE CLUB SUIT': 9831,
'WHITE CONCAVE-SIDED DIAMOND': 10209,
'WHITE CONCAVE-SIDED DIAMOND WITH LEFTWARDS TICK': 10210,
'WHITE CONCAVE-SIDED DIAMOND WITH RIGHTWARDS TICK': 10211,
'WHITE DIAMOND': 9671,
'WHITE DIAMOND CONTAINING BLACK SMALL DIAMOND': 9672,
'WHITE DIAMOND SUIT': 9826,
'WHITE DIAMOND WITH CENTRED DOT': 10192,
'WHITE DOWN POINTING INDEX': 9759,
'WHITE DOWN-POINTING SMALL TRIANGLE': 9663,
'WHITE DOWN-POINTING TRIANGLE': 9661,
'WHITE FLAG': 9872,
'WHITE FLORETTE': 10048,
'WHITE FOUR POINTED STAR': 10023,
'WHITE FROWNING FACE': 9785,
'WHITE HEART SUIT': 9825,
'WHITE HOURGLASS': 10710,
'WHITE LEFT POINTING INDEX': 9756,
'WHITE LEFT-POINTING POINTER': 9669,
'WHITE LEFT-POINTING SMALL TRIANGLE': 9667,
'WHITE LEFT-POINTING TRIANGLE': 9665,
'WHITE MEDIUM SMALL SQUARE': 9725,
'WHITE MEDIUM SQUARE': 9723,
'WHITE NIB': 10001,
'WHITE PARALLELOGRAM': 9649,
'WHITE RECTANGLE': 9645,
'WHITE RIGHT POINTING INDEX': 9758,
'WHITE RIGHT-POINTING POINTER': 9659,
'WHITE RIGHT-POINTING SMALL TRIANGLE': 9657,
'WHITE RIGHT-POINTING TRIANGLE': 9655,
'WHITE SCISSORS': 9988,
'WHITE SESAME DOT': 65094,
'WHITE SHOGI PIECE': 9750,
'WHITE SMALL SQUARE': 9643,
'WHITE SMILING FACE': 9786,
'WHITE SPADE SUIT': 9828,
'WHITE SQUARE': 9633,
'WHITE SQUARE CONTAINING BLACK SMALL SQUARE': 9635,
'WHITE SQUARE WITH CENTRE VERTICAL LINE': 9093,
'WHITE SQUARE WITH LEFTWARDS TICK': 10212,
'WHITE SQUARE WITH LOWER LEFT QUADRANT': 9713,
'WHITE SQUARE WITH LOWER RIGHT QUADRANT': 9714,
'WHITE SQUARE WITH RIGHTWARDS TICK': 10213,
'WHITE SQUARE WITH ROUNDED CORNERS': 9634,
'WHITE SQUARE WITH UPPER LEFT QUADRANT': 9712,
'WHITE SQUARE WITH UPPER RIGHT QUADRANT': 9715,
'WHITE SQUARE WITH VERTICAL BISECTING LINE': 9707,
'WHITE STAR': 9734,
'WHITE SUN WITH RAYS': 9788,
'WHITE TELEPHONE': 9743,
'WHITE TRIANGLE CONTAINING SMALL WHITE TRIANGLE': 10177,
'WHITE UP POINTING INDEX': 9757,
'WHITE UP-POINTING SMALL TRIANGLE': 9653,
'WHITE UP-POINTING TRIANGLE': 9651,
'WHITE UP-POINTING TRIANGLE WITH DOT': 9708,
'WHITE VERTICAL BAR': 11006,
'WHITE VERTICAL RECTANGLE': 9647,
'WHITE-FEATHERED RIGHTWARDS ARROW': 10163,
'WON SIGN': 8361,
'WORD JOINER': 8288,
'WREATH PRODUCT': 8768,
'WRITING HAND': 9997,
'X IN A RECTANGLE BOX': 8999,
'XOR': 8891,
'YEN SIGN': 165,
'YI RADICAL BBUT': 42139,
'YI RADICAL BUR': 42149,
'YI RADICAL CHE': 42179,
'YI RADICAL CIP': 42174,
'YI RADICAL CUOP': 42173,
'YI RADICAL CY': 42172,
'YI RADICAL CYP': 42132,
'YI RADICAL CYT': 42147,
'YI RADICAL DDUR': 42148,
'YI RADICAL DU': 42169,
'YI RADICAL GA': 42145,
'YI RADICAL GEP': 42135,
'YI RADICAL GGOP': 42134,
'YI RADICAL GGUO': 42150,
'YI RADICAL GOT': 42166,
'YI RADICAL HMO': 42157,
'YI RADICAL HXIT': 42137,
'YI RADICAL HXOP': 42175,
'YI RADICAL HXUO': 42143,
'YI RADICAL JJIE': 42167,
'YI RADICAL JJUT': 42154,
'YI RADICAL JJY': 42165,
'YI RADICAL JO': 42163,
'YI RADICAL KE': 42182,
'YI RADICAL KIT': 42130,
'YI RADICAL LI': 42129,
'YI RADICAL LIE': 42171,
'YI RADICAL LYR': 42138,
'YI RADICAL MI': 42136,
'YI RADICAL MOP': 42140,
'YI RADICAL NBIE': 42181,
'YI RADICAL NYIP': 42131,
'YI RADICAL NYOP': 42151,
'YI RADICAL NZUP': 42164,
'YI RADICAL OP': 42153,
'YI RADICAL PUT': 42142,
'YI RADICAL PYT': 42156,
'YI RADICAL QOT': 42128,
'YI RADICAL SHAT': 42176,
'YI RADICAL SHOP': 42178,
'YI RADICAL SHUR': 42170,
'YI RADICAL SHY': 42160,
'YI RADICAL SSI': 42133,
'YI RADICAL TAT': 42144,
'YI RADICAL TU': 42152,
'YI RADICAL VEP': 42161,
'YI RADICAL VUR': 42159,
'YI RADICAL WO': 42168,
'YI RADICAL YIT': 42158,
'YI RADICAL YO': 42141,
'YI RADICAL ZA': 42162,
'YI RADICAL ZOT': 42155,
'YI RADICAL ZUP': 42146,
'YI RADICAL ZUR': 42177,
'YI RADICAL ZZIET': 42180,
'YI SYLLABLE A': 40970,
'YI SYLLABLE AP': 40971,
'YI SYLLABLE AT': 40968,
'YI SYLLABLE AX': 40969,
'YI SYLLABLE BA': 40992,
'YI SYLLABLE BAP': 40993,
'YI SYLLABLE BAT': 40990,
'YI SYLLABLE BAX': 40991,
'YI SYLLABLE BBA': 41056,
'YI SYLLABLE BBAP': 41057,
'YI SYLLABLE BBAT': 41054,
'YI SYLLABLE BBAX': 41055,
'YI SYLLABLE BBE': 41066,
'YI SYLLABLE BBEP': 41067,
'YI SYLLABLE BBEX': 41065,
'YI SYLLABLE BBI': 41048,
'YI SYLLABLE BBIE': 41052,
'YI SYLLABLE BBIEP': 41053,
'YI SYLLABLE BBIET': 41050,
'YI SYLLABLE BBIEX': 41051,
'YI SYLLABLE BBIP': 41049,
'YI SYLLABLE BBIT': 41046,
'YI SYLLABLE BBIX': 41047,
'YI SYLLABLE BBO': 41063,
'YI SYLLABLE BBOP': 41064,
'YI SYLLABLE BBOT': 41061,
'YI SYLLABLE BBOX': 41062,
'YI SYLLABLE BBU': 41070,
'YI SYLLABLE BBUO': 41059,
'YI SYLLABLE BBUOP': 41060,
'YI SYLLABLE BBUOX': 41058,
'YI SYLLABLE BBUP': 41071,
'YI SYLLABLE BBUR': 41073,
'YI SYLLABLE BBURX': 41072,
'YI SYLLABLE BBUT': 41068,
'YI SYLLABLE BBUX': 41069,
'YI SYLLABLE BBY': 41076,
'YI SYLLABLE BBYP': 41077,
'YI SYLLABLE BBYT': 41074,
'YI SYLLABLE BBYX': 41075,
'YI SYLLABLE BE': 41002,
'YI SYLLABLE BEP': 41003,
'YI SYLLABLE BEX': 41001,
'YI SYLLABLE BI': 40984,
'YI SYLLABLE BIE': 40988,
'YI SYLLABLE BIEP': 40989,
'YI SYLLABLE BIET': 40986,
'YI SYLLABLE BIEX': 40987,
'YI SYLLABLE BIP': 40985,
'YI SYLLABLE BIT': 40982,
'YI SYLLABLE BIX': 40983,
'YI SYLLABLE BO': 40999,
'YI SYLLABLE BOP': 41000,
'YI SYLLABLE BOT': 40997,
'YI SYLLABLE BOX': 40998,
'YI SYLLABLE BU': 41006,
'YI SYLLABLE BUO': 40995,
'YI SYLLABLE BUOP': 40996,
'YI SYLLABLE BUOX': 40994,
'YI SYLLABLE BUP': 41007,
'YI SYLLABLE BUR': 41009,
'YI SYLLABLE BURX': 41008,
'YI SYLLABLE BUT': 41004,
'YI SYLLABLE BUX': 41005,
'YI SYLLABLE BY': 41012,
'YI SYLLABLE BYP': 41013,
'YI SYLLABLE BYR': 41015,
'YI SYLLABLE BYRX': 41014,
'YI SYLLABLE BYT': 41010,
'YI SYLLABLE BYX': 41011,
'YI SYLLABLE CA': 41656,
'YI SYLLABLE CAP': 41657,
'YI SYLLABLE CAT': 41654,
'YI SYLLABLE CAX': 41655,
'YI SYLLABLE CE': 41666,
'YI SYLLABLE CEP': 41667,
'YI SYLLABLE CEX': 41665,
'YI SYLLABLE CHA': 41827,
'YI SYLLABLE CHAP': 41828,
'YI SYLLABLE CHAT': 41825,
'YI SYLLABLE CHAX': 41826,
'YI SYLLABLE CHE': 41839,
'YI SYLLABLE CHEP': 41840,
'YI SYLLABLE CHET': 41837,
'YI SYLLABLE CHEX': 41838,
'YI SYLLABLE CHO': 41835,
'YI SYLLABLE CHOP': 41836,
'YI SYLLABLE CHOT': 41833,
'YI SYLLABLE CHOX': 41834,
'YI SYLLABLE CHU': 41842,
'YI SYLLABLE CHUO': 41831,
'YI SYLLABLE CHUOP': 41832,
'YI SYLLABLE CHUOT': 41829,
'YI SYLLABLE CHUOX': 41830,
'YI SYLLABLE CHUP': 41843,
'YI SYLLABLE CHUR': 41845,
'YI SYLLABLE CHURX': 41844,
'YI SYLLABLE CHUX': 41841,
'YI SYLLABLE CHY': 41848,
'YI SYLLABLE CHYP': 41849,
'YI SYLLABLE CHYR': 41851,
'YI SYLLABLE CHYRX': 41850,
'YI SYLLABLE CHYT': 41846,
'YI SYLLABLE CHYX': 41847,
'YI SYLLABLE CI': 41648,
'YI SYLLABLE CIE': 41652,
'YI SYLLABLE CIEP': 41653,
'YI SYLLABLE CIET': 41650,
'YI SYLLABLE CIEX': 41651,
'YI SYLLABLE CIP': 41649,
'YI SYLLABLE CIT': 41646,
'YI SYLLABLE CIX': 41647,
'YI SYLLABLE CO': 41663,
'YI SYLLABLE COP': 41664,
'YI SYLLABLE COT': 41661,
'YI SYLLABLE COX': 41662,
'YI SYLLABLE CU': 41670,
'YI SYLLABLE CUO': 41659,
'YI SYLLABLE CUOP': 41660,
'YI SYLLABLE CUOX': 41658,
'YI SYLLABLE CUP': 41671,
'YI SYLLABLE CUR': 41673,
'YI SYLLABLE CURX': 41672,
'YI SYLLABLE CUT': 41668,
'YI SYLLABLE CUX': 41669,
'YI SYLLABLE CY': 41676,
'YI SYLLABLE CYP': 41677,
'YI SYLLABLE CYR': 41679,
'YI SYLLABLE CYRX': 41678,
'YI SYLLABLE CYT': 41674,
'YI SYLLABLE CYX': 41675,
'YI SYLLABLE DA': 41225,
'YI SYLLABLE DAP': 41226,
'YI SYLLABLE DAT': 41223,
'YI SYLLABLE DAX': 41224,
'YI SYLLABLE DDA': 41279,
'YI SYLLABLE DDAP': 41280,
'YI SYLLABLE DDAT': 41277,
'YI SYLLABLE DDAX': 41278,
'YI SYLLABLE DDE': 41289,
'YI SYLLABLE DDEP': 41290,
'YI SYLLABLE DDEX': 41288,
'YI SYLLABLE DDI': 41272,
'YI SYLLABLE DDIE': 41275,
'YI SYLLABLE DDIEP': 41276,
'YI SYLLABLE DDIEX': 41274,
'YI SYLLABLE DDIP': 41273,
'YI SYLLABLE DDIT': 41270,
'YI SYLLABLE DDIX': 41271,
'YI SYLLABLE DDO': 41286,
'YI SYLLABLE DDOP': 41287,
'YI SYLLABLE DDOT': 41284,
'YI SYLLABLE DDOX': 41285,
'YI SYLLABLE DDU': 41293,
'YI SYLLABLE DDUO': 41282,
'YI SYLLABLE DDUOP': 41283,
'YI SYLLABLE DDUOX': 41281,
'YI SYLLABLE DDUP': 41294,
'YI SYLLABLE DDUR': 41296,
'YI SYLLABLE DDURX': 41295,
'YI SYLLABLE DDUT': 41291,
'YI SYLLABLE DDUX': 41292,
'YI SYLLABLE DE': 41234,
'YI SYLLABLE DEP': 41235,
'YI SYLLABLE DEX': 41233,
'YI SYLLABLE DI': 41218,
'YI SYLLABLE DIE': 41221,
'YI SYLLABLE DIEP': 41222,
'YI SYLLABLE DIEX': 41220,
'YI SYLLABLE DIP': 41219,
'YI SYLLABLE DIT': 41216,
'YI SYLLABLE DIX': 41217,
'YI SYLLABLE DO': 41231,
'YI SYLLABLE DOP': 41232,
'YI SYLLABLE DOT': 41229,
'YI SYLLABLE DOX': 41230,
'YI SYLLABLE DU': 41238,
'YI SYLLABLE DUO': 41228,
'YI SYLLABLE DUOX': 41227,
'YI SYLLABLE DUP': 41239,
'YI SYLLABLE DUR': 41241,
'YI SYLLABLE DURX': 41240,
'YI SYLLABLE DUT': 41236,
'YI SYLLABLE DUX': 41237,
'YI SYLLABLE E': 40980,
'YI SYLLABLE EX': 40979,
'YI SYLLABLE FA': 41171,
'YI SYLLABLE FAP': 41172,
'YI SYLLABLE FAT': 41169,
'YI SYLLABLE FAX': 41170,
'YI SYLLABLE FI': 41167,
'YI SYLLABLE FIP': 41168,
'YI SYLLABLE FIT': 41165,
'YI SYLLABLE FIX': 41166,
'YI SYLLABLE FO': 41174,
'YI SYLLABLE FOP': 41175,
'YI SYLLABLE FOX': 41173,
'YI SYLLABLE FU': 41178,
'YI SYLLABLE FUP': 41179,
'YI SYLLABLE FUR': 41181,
'YI SYLLABLE FURX': 41180,
'YI SYLLABLE FUT': 41176,
'YI SYLLABLE FUX': 41177,
'YI SYLLABLE FY': 41184,
'YI SYLLABLE FYP': 41185,
'YI SYLLABLE FYT': 41182,
'YI SYLLABLE FYX': 41183,
'YI SYLLABLE GA': 41444,
'YI SYLLABLE GAP': 41445,
'YI SYLLABLE GAT': 41442,
'YI SYLLABLE GAX': 41443,
'YI SYLLABLE GE': 41456,
'YI SYLLABLE GEP': 41457,
'YI SYLLABLE GET': 41454,
'YI SYLLABLE GEX': 41455,
'YI SYLLABLE GGA': 41500,
'YI SYLLABLE GGAP': 41501,
'YI SYLLABLE GGAT': 41498,
'YI SYLLABLE GGAX': 41499,
'YI SYLLABLE GGE': 41512,
'YI SYLLABLE GGEP': 41513,
'YI SYLLABLE GGET': 41510,
'YI SYLLABLE GGEX': 41511,
'YI SYLLABLE GGI': 41494,
'YI SYLLABLE GGIE': 41496,
'YI SYLLABLE GGIEP': 41497,
'YI SYLLABLE GGIEX': 41495,
'YI SYLLABLE GGIT': 41492,
'YI SYLLABLE GGIX': 41493,
'YI SYLLABLE GGO': 41508,
'YI SYLLABLE GGOP': 41509,
'YI SYLLABLE GGOT': 41506,
'YI SYLLABLE GGOX': 41507,
'YI SYLLABLE GGU': 41516,
'YI SYLLABLE GGUO': 41504,
'YI SYLLABLE GGUOP': 41505,
'YI SYLLABLE GGUOT': 41502,
'YI SYLLABLE GGUOX': 41503,
'YI SYLLABLE GGUP': 41517,
'YI SYLLABLE GGUR': 41519,
'YI SYLLABLE GGURX': 41518,
'YI SYLLABLE GGUT': 41514,
'YI SYLLABLE GGUX': 41515,
'YI SYLLABLE GI': 41436,
'YI SYLLABLE GIE': 41440,
'YI SYLLABLE GIEP': 41441,
'YI SYLLABLE GIET': 41438,
'YI SYLLABLE GIEX': 41439,
'YI SYLLABLE GIP': 41437,
'YI SYLLABLE GIT': 41434,
'YI SYLLABLE GIX': 41435,
'YI SYLLABLE GO': 41452,
'YI SYLLABLE GOP': 41453,
'YI SYLLABLE GOT': 41450,
'YI SYLLABLE GOX': 41451,
'YI SYLLABLE GU': 41460,
'YI SYLLABLE GUO': 41448,
'YI SYLLABLE GUOP': 41449,
'YI SYLLABLE GUOT': 41446,
'YI SYLLABLE GUOX': 41447,
'YI SYLLABLE GUP': 41461,
'YI SYLLABLE GUR': 41463,
'YI SYLLABLE GURX': 41462,
'YI SYLLABLE GUT': 41458,
'YI SYLLABLE GUX': 41459,
'YI SYLLABLE HA': 41587,
'YI SYLLABLE HAP': 41588,
'YI SYLLABLE HAT': 41585,
'YI SYLLABLE HAX': 41586,
'YI SYLLABLE HE': 41598,
'YI SYLLABLE HEP': 41599,
'YI SYLLABLE HEX': 41597,
'YI SYLLABLE HIE': 41584,
'YI SYLLABLE HIEX': 41583,
'YI SYLLABLE HIT': 41582,
'YI SYLLABLE HLA': 41376,
'YI SYLLABLE HLAP': 41377,
'YI SYLLABLE HLAT': 41374,
'YI SYLLABLE HLAX': 41375,
'YI SYLLABLE HLE': 41385,
'YI SYLLABLE HLEP': 41386,
'YI SYLLABLE HLEX': 41384,
'YI SYLLABLE HLI': 41369,
'YI SYLLABLE HLIE': 41372,
'YI SYLLABLE HLIEP': 41373,
'YI SYLLABLE HLIEX': 41371,
'YI SYLLABLE HLIP': 41370,
'YI SYLLABLE HLIT': 41367,
'YI SYLLABLE HLIX': 41368,
'YI SYLLABLE HLO': 41382,
'YI SYLLABLE HLOP': 41383,
'YI SYLLABLE HLOX': 41381,
'YI SYLLABLE HLU': 41389,
'YI SYLLABLE HLUO': 41379,
'YI SYLLABLE HLUOP': 41380,
'YI SYLLABLE HLUOX': 41378,
'YI SYLLABLE HLUP': 41390,
'YI SYLLABLE HLUR': 41392,
'YI SYLLABLE HLURX': 41391,
'YI SYLLABLE HLUT': 41387,
'YI SYLLABLE HLUX': 41388,
'YI SYLLABLE HLY': 41395,
'YI SYLLABLE HLYP': 41396,
'YI SYLLABLE HLYR': 41398,
'YI SYLLABLE HLYRX': 41397,
'YI SYLLABLE HLYT': 41393,
'YI SYLLABLE HLYX': 41394,
'YI SYLLABLE HMA': 41114,
'YI SYLLABLE HMAP': 41115,
'YI SYLLABLE HMAT': 41112,
'YI SYLLABLE HMAX': 41113,
'YI SYLLABLE HMI': 41107,
'YI SYLLABLE HMIE': 41110,
'YI SYLLABLE HMIEP': 41111,
'YI SYLLABLE HMIEX': 41109,
'YI SYLLABLE HMIP': 41108,
'YI SYLLABLE HMIT': 41105,
'YI SYLLABLE HMIX': 41106,
'YI SYLLABLE HMO': 41121,
'YI SYLLABLE HMOP': 41122,
'YI SYLLABLE HMOT': 41119,
'YI SYLLABLE HMOX': 41120,
'YI SYLLABLE HMU': 41125,
'YI SYLLABLE HMUO': 41117,
'YI SYLLABLE HMUOP': 41118,
'YI SYLLABLE HMUOX': 41116,
'YI SYLLABLE HMUP': 41126,
'YI SYLLABLE HMUR': 41128,
'YI SYLLABLE HMURX': 41127,
'YI SYLLABLE HMUT': 41123,
'YI SYLLABLE HMUX': 41124,
'YI SYLLABLE HMY': 41130,
'YI SYLLABLE HMYP': 41131,
'YI SYLLABLE HMYR': 41133,
'YI SYLLABLE HMYRX': 41132,
'YI SYLLABLE HMYX': 41129,
'YI SYLLABLE HNA': 41330,
'YI SYLLABLE HNAP': 41331,
'YI SYLLABLE HNAT': 41328,
'YI SYLLABLE HNAX': 41329,
'YI SYLLABLE HNE': 41338,
'YI SYLLABLE HNEP': 41339,
'YI SYLLABLE HNEX': 41337,
'YI SYLLABLE HNI': 41322,
'YI SYLLABLE HNIE': 41326,
'YI SYLLABLE HNIEP': 41327,
'YI SYLLABLE HNIET': 41324,
'YI SYLLABLE HNIEX': 41325,
'YI SYLLABLE HNIP': 41323,
'YI SYLLABLE HNIT': 41320,
'YI SYLLABLE HNIX': 41321,
'YI SYLLABLE HNOP': 41336,
'YI SYLLABLE HNOT': 41334,
'YI SYLLABLE HNOX': 41335,
'YI SYLLABLE HNUO': 41333,
'YI SYLLABLE HNUOX': 41332,
'YI SYLLABLE HNUT': 41340,
'YI SYLLABLE HO': 41595,
'YI SYLLABLE HOP': 41596,
'YI SYLLABLE HOT': 41593,
'YI SYLLABLE HOX': 41594,
'YI SYLLABLE HUO': 41591,
'YI SYLLABLE HUOP': 41592,
'YI SYLLABLE HUOT': 41589,
'YI SYLLABLE HUOX': 41590,
'YI SYLLABLE HXA': 41552,
'YI SYLLABLE HXAP': 41553,
'YI SYLLABLE HXAT': 41550,
'YI SYLLABLE HXAX': 41551,
'YI SYLLABLE HXE': 41563,
'YI SYLLABLE HXEP': 41564,
'YI SYLLABLE HXEX': 41562,
'YI SYLLABLE HXI': 41544,
'YI SYLLABLE HXIE': 41548,
'YI SYLLABLE HXIEP': 41549,
'YI SYLLABLE HXIET': 41546,
'YI SYLLABLE HXIEX': 41547,
'YI SYLLABLE HXIP': 41545,
'YI SYLLABLE HXIT': 41542,
'YI SYLLABLE HXIX': 41543,
'YI SYLLABLE HXO': 41560,
'YI SYLLABLE HXOP': 41561,
'YI SYLLABLE HXOT': 41558,
'YI SYLLABLE HXOX': 41559,
'YI SYLLABLE HXUO': 41556,
'YI SYLLABLE HXUOP': 41557,
'YI SYLLABLE HXUOT': 41554,
'YI SYLLABLE HXUOX': 41555,
'YI SYLLABLE I': 40962,
'YI SYLLABLE IE': 40966,
'YI SYLLABLE IEP': 40967,
'YI SYLLABLE IET': 40964,
'YI SYLLABLE IEX': 40965,
'YI SYLLABLE IP': 40963,
'YI SYLLABLE IT': 40960,
'YI SYLLABLE IX': 40961,
'YI SYLLABLE JI': 41954,
'YI SYLLABLE JIE': 41958,
'YI SYLLABLE JIEP': 41959,
'YI SYLLABLE JIET': 41956,
'YI SYLLABLE JIEX': 41957,
'YI SYLLABLE JIP': 41955,
'YI SYLLABLE JIT': 41952,
'YI SYLLABLE JIX': 41953,
'YI SYLLABLE JJI': 42010,
'YI SYLLABLE JJIE': 42014,
'YI SYLLABLE JJIEP': 42015,
'YI SYLLABLE JJIET': 42012,
'YI SYLLABLE JJIEX': 42013,
'YI SYLLABLE JJIP': 42011,
'YI SYLLABLE JJIT': 42008,
'YI SYLLABLE JJIX': 42009,
'YI SYLLABLE JJO': 42021,
'YI SYLLABLE JJOP': 42022,
'YI SYLLABLE JJOT': 42019,
'YI SYLLABLE JJOX': 42020,
'YI SYLLABLE JJU': 42025,
'YI SYLLABLE JJUO': 42017,
'YI SYLLABLE JJUOP': 42018,
'YI SYLLABLE JJUOX': 42016,
'YI SYLLABLE JJUP': 42026,
'YI SYLLABLE JJUR': 42028,
'YI SYLLABLE JJURX': 42027,
'YI SYLLABLE JJUT': 42023,
'YI SYLLABLE JJUX': 42024,
'YI SYLLABLE JJY': 42031,
'YI SYLLABLE JJYP': 42032,
'YI SYLLABLE JJYT': 42029,
'YI SYLLABLE JJYX': 42030,
'YI SYLLABLE JO': 41966,
'YI SYLLABLE JOP': 41967,
'YI SYLLABLE JOT': 41964,
'YI SYLLABLE JOX': 41965,
'YI SYLLABLE JU': 41970,
'YI SYLLABLE JUO': 41962,
'YI SYLLABLE JUOP': 41963,
'YI SYLLABLE JUOT': 41960,
'YI SYLLABLE JUOX': 41961,
'YI SYLLABLE JUP': 41971,
'YI SYLLABLE JUR': 41973,
'YI SYLLABLE JURX': 41972,
'YI SYLLABLE JUT': 41968,
'YI SYLLABLE JUX': 41969,
'YI SYLLABLE JY': 41976,
'YI SYLLABLE JYP': 41977,
'YI SYLLABLE JYR': 41979,
'YI SYLLABLE JYRX': 41978,
'YI SYLLABLE JYT': 41974,
'YI SYLLABLE JYX': 41975,
'YI SYLLABLE KA': 41473,
'YI SYLLABLE KAP': 41474,
'YI SYLLABLE KAT': 41471,
'YI SYLLABLE KAX': 41472,
'YI SYLLABLE KE': 41484,
'YI SYLLABLE KEP': 41485,
'YI SYLLABLE KET': 41482,
'YI SYLLABLE KEX': 41483,
'YI SYLLABLE KI': 41466,
'YI SYLLABLE KIE': 41469,
'YI SYLLABLE KIEP': 41470,
'YI SYLLABLE KIEX': 41468,
'YI SYLLABLE KIP': 41467,
'YI SYLLABLE KIT': 41464,
'YI SYLLABLE KIX': 41465,
'YI SYLLABLE KO': 41480,
'YI SYLLABLE KOP': 41481,
'YI SYLLABLE KOT': 41478,
'YI SYLLABLE KOX': 41479,
'YI SYLLABLE KU': 41488,
'YI SYLLABLE KUO': 41476,
'YI SYLLABLE KUOP': 41477,
'YI SYLLABLE KUOX': 41475,
'YI SYLLABLE KUP': 41489,
'YI SYLLABLE KUR': 41491,
'YI SYLLABLE KURX': 41490,
'YI SYLLABLE KUT': 41486,
'YI SYLLABLE KUX': 41487,
'YI SYLLABLE LA': 41409,
'YI SYLLABLE LAP': 41410,
'YI SYLLABLE LAT': 41407,
'YI SYLLABLE LAX': 41408,
'YI SYLLABLE LE': 41420,
'YI SYLLABLE LEP': 41421,
'YI SYLLABLE LEX': 41419,
'YI SYLLABLE LI': 41401,
'YI SYLLABLE LIE': 41405,
'YI SYLLABLE LIEP': 41406,
'YI SYLLABLE LIET': 41403,
'YI SYLLABLE LIEX': 41404,
'YI SYLLABLE LIP': 41402,
'YI SYLLABLE LIT': 41399,
'YI SYLLABLE LIX': 41400,
'YI SYLLABLE LO': 41417,
'YI SYLLABLE LOP': 41418,
'YI SYLLABLE LOT': 41415,
'YI SYLLABLE LOX': 41416,
'YI SYLLABLE LU': 41424,
'YI SYLLABLE LUO': 41413,
'YI SYLLABLE LUOP': 41414,
'YI SYLLABLE LUOT': 41411,
'YI SYLLABLE LUOX': 41412,
'YI SYLLABLE LUP': 41425,
'YI SYLLABLE LUR': 41427,
'YI SYLLABLE LURX': 41426,
'YI SYLLABLE LUT': 41422,
'YI SYLLABLE LUX': 41423,
'YI SYLLABLE LY': 41430,
'YI SYLLABLE LYP': 41431,
'YI SYLLABLE LYR': 41433,
'YI SYLLABLE LYRX': 41432,
'YI SYLLABLE LYT': 41428,
'YI SYLLABLE LYX': 41429,
'YI SYLLABLE MA': 41143,
'YI SYLLABLE MAP': 41144,
'YI SYLLABLE MAT': 41141,
'YI SYLLABLE MAX': 41142,
'YI SYLLABLE ME': 41154,
'YI SYLLABLE MEX': 41153,
'YI SYLLABLE MGA': 41524,
'YI SYLLABLE MGAP': 41525,
'YI SYLLABLE MGAT': 41522,
'YI SYLLABLE MGAX': 41523,
'YI SYLLABLE MGE': 41534,
'YI SYLLABLE MGEP': 41535,
'YI SYLLABLE MGEX': 41533,
'YI SYLLABLE MGIE': 41521,
'YI SYLLABLE MGIEX': 41520,
'YI SYLLABLE MGO': 41531,
'YI SYLLABLE MGOP': 41532,
'YI SYLLABLE MGOT': 41529,
'YI SYLLABLE MGOX': 41530,
'YI SYLLABLE MGU': 41538,
'YI SYLLABLE MGUO': 41527,
'YI SYLLABLE MGUOP': 41528,
'YI SYLLABLE MGUOX': 41526,
'YI SYLLABLE MGUP': 41539,
'YI SYLLABLE MGUR': 41541,
'YI SYLLABLE MGURX': 41540,
'YI SYLLABLE MGUT': 41536,
'YI SYLLABLE MGUX': 41537,
'YI SYLLABLE MI': 41136,
'YI SYLLABLE MIE': 41139,
'YI SYLLABLE MIEP': 41140,
'YI SYLLABLE MIEX': 41138,
'YI SYLLABLE MIP': 41137,
'YI SYLLABLE MIT': 41134,
'YI SYLLABLE MIX': 41135,
'YI SYLLABLE MO': 41151,
'YI SYLLABLE MOP': 41152,
'YI SYLLABLE MOT': 41149,
'YI SYLLABLE MOX': 41150,
'YI SYLLABLE MU': 41157,
'YI SYLLABLE MUO': 41147,
'YI SYLLABLE MUOP': 41148,
'YI SYLLABLE MUOT': 41145,
'YI SYLLABLE MUOX': 41146,
'YI SYLLABLE MUP': 41158,
'YI SYLLABLE MUR': 41160,
'YI SYLLABLE MURX': 41159,
'YI SYLLABLE MUT': 41155,
'YI SYLLABLE MUX': 41156,
'YI SYLLABLE MY': 41163,
'YI SYLLABLE MYP': 41164,
'YI SYLLABLE MYT': 41161,
'YI SYLLABLE MYX': 41162,
'YI SYLLABLE NA': 41349,
'YI SYLLABLE NAP': 41350,
'YI SYLLABLE NAX': 41348,
'YI SYLLABLE NBA': 41087,
'YI SYLLABLE NBAP': 41088,
'YI SYLLABLE NBAT': 41085,
'YI SYLLABLE NBAX': 41086,
'YI SYLLABLE NBI': 41080,
'YI SYLLABLE NBIE': 41083,
'YI SYLLABLE NBIEP': 41084,
'YI SYLLABLE NBIEX': 41082,
'YI SYLLABLE NBIP': 41081,
'YI SYLLABLE NBIT': 41078,
'YI SYLLABLE NBIX': 41079,
'YI SYLLABLE NBO': 41091,
'YI SYLLABLE NBOP': 41092,
'YI SYLLABLE NBOT': 41089,
'YI SYLLABLE NBOX': 41090,
'YI SYLLABLE NBU': 41095,
'YI SYLLABLE NBUP': 41096,
'YI SYLLABLE NBUR': 41098,
'YI SYLLABLE NBURX': 41097,
'YI SYLLABLE NBUT': 41093,
'YI SYLLABLE NBUX': 41094,
'YI SYLLABLE NBY': 41101,
'YI SYLLABLE NBYP': 41102,
'YI SYLLABLE NBYR': 41104,
'YI SYLLABLE NBYRX': 41103,
'YI SYLLABLE NBYT': 41099,
'YI SYLLABLE NBYX': 41100,
'YI SYLLABLE NDA': 41305,
'YI SYLLABLE NDAP': 41306,
'YI SYLLABLE NDAT': 41303,
'YI SYLLABLE NDAX': 41304,
'YI SYLLABLE NDE': 41312,
'YI SYLLABLE NDEP': 41313,
'YI SYLLABLE NDEX': 41311,
'YI SYLLABLE NDI': 41299,
'YI SYLLABLE NDIE': 41302,
'YI SYLLABLE NDIEX': 41301,
'YI SYLLABLE NDIP': 41300,
'YI SYLLABLE NDIT': 41297,
'YI SYLLABLE NDIX': 41298,
'YI SYLLABLE NDO': 41309,
'YI SYLLABLE NDOP': 41310,
'YI SYLLABLE NDOT': 41307,
'YI SYLLABLE NDOX': 41308,
'YI SYLLABLE NDU': 41316,
'YI SYLLABLE NDUP': 41317,
'YI SYLLABLE NDUR': 41319,
'YI SYLLABLE NDURX': 41318,
'YI SYLLABLE NDUT': 41314,
'YI SYLLABLE NDUX': 41315,
'YI SYLLABLE NE': 41359,
'YI SYLLABLE NEP': 41360,
'YI SYLLABLE NEX': 41358,
'YI SYLLABLE NGA': 41570,
'YI SYLLABLE NGAP': 41571,
'YI SYLLABLE NGAT': 41568,
'YI SYLLABLE NGAX': 41569,
'YI SYLLABLE NGE': 41580,
'YI SYLLABLE NGEP': 41581,
'YI SYLLABLE NGEX': 41579,
'YI SYLLABLE NGIE': 41566,
'YI SYLLABLE NGIEP': 41567,
'YI SYLLABLE NGIEX': 41565,
'YI SYLLABLE NGO': 41577,
'YI SYLLABLE NGOP': 41578,
'YI SYLLABLE NGOT': 41575,
'YI SYLLABLE NGOX': 41576,
'YI SYLLABLE NGUO': 41574,
'YI SYLLABLE NGUOT': 41572,
'YI SYLLABLE NGUOX': 41573,
'YI SYLLABLE NI': 41343,
'YI SYLLABLE NIE': 41346,
'YI SYLLABLE NIEP': 41347,
'YI SYLLABLE NIEX': 41345,
'YI SYLLABLE NIP': 41344,
'YI SYLLABLE NIT': 41341,
'YI SYLLABLE NIX': 41342,
'YI SYLLABLE NJI': 42035,
'YI SYLLABLE NJIE': 42039,
'YI SYLLABLE NJIEP': 42040,
'YI SYLLABLE NJIET': 42037,
'YI SYLLABLE NJIEX': 42038,
'YI SYLLABLE NJIP': 42036,
'YI SYLLABLE NJIT': 42033,
'YI SYLLABLE NJIX': 42034,
'YI SYLLABLE NJO': 42045,
'YI SYLLABLE NJOP': 42046,
'YI SYLLABLE NJOT': 42043,
'YI SYLLABLE NJOX': 42044,
'YI SYLLABLE NJU': 42048,
'YI SYLLABLE NJUO': 42042,
'YI SYLLABLE NJUOX': 42041,
'YI SYLLABLE NJUP': 42049,
'YI SYLLABLE NJUR': 42051,
'YI SYLLABLE NJURX': 42050,
'YI SYLLABLE NJUX': 42047,
'YI SYLLABLE NJY': 42054,
'YI SYLLABLE NJYP': 42055,
'YI SYLLABLE NJYR': 42057,
'YI SYLLABLE NJYRX': 42056,
'YI SYLLABLE NJYT': 42052,
'YI SYLLABLE NJYX': 42053,
'YI SYLLABLE NO': 41356,
'YI SYLLABLE NOP': 41357,
'YI SYLLABLE NOT': 41354,
'YI SYLLABLE NOX': 41355,
'YI SYLLABLE NRA': 41878,
'YI SYLLABLE NRAP': 41879,
'YI SYLLABLE NRAT': 41876,
'YI SYLLABLE NRAX': 41877,
'YI SYLLABLE NRE': 41885,
'YI SYLLABLE NREP': 41886,
'YI SYLLABLE NRET': 41883,
'YI SYLLABLE NREX': 41884,
'YI SYLLABLE NRO': 41881,
'YI SYLLABLE NROP': 41882,
'YI SYLLABLE NROX': 41880,
'YI SYLLABLE NRU': 41889,
'YI SYLLABLE NRUP': 41890,
'YI SYLLABLE NRUR': 41892,
'YI SYLLABLE NRURX': 41891,
'YI SYLLABLE NRUT': 41887,
'YI SYLLABLE NRUX': 41888,
'YI SYLLABLE NRY': 41895,
'YI SYLLABLE NRYP': 41896,
'YI SYLLABLE NRYR': 41898,
'YI SYLLABLE NRYRX': 41897,
'YI SYLLABLE NRYT': 41893,
'YI SYLLABLE NRYX': 41894,
'YI SYLLABLE NU': 41363,
'YI SYLLABLE NUO': 41352,
'YI SYLLABLE NUOP': 41353,
'YI SYLLABLE NUOX': 41351,
'YI SYLLABLE NUP': 41364,
'YI SYLLABLE NUR': 41366,
'YI SYLLABLE NURX': 41365,
'YI SYLLABLE NUT': 41361,
'YI SYLLABLE NUX': 41362,
'YI SYLLABLE NYI': 42060,
'YI SYLLABLE NYIE': 42064,
'YI SYLLABLE NYIEP': 42065,
'YI SYLLABLE NYIET': 42062,
'YI SYLLABLE NYIEX': 42063,
'YI SYLLABLE NYIP': 42061,
'YI SYLLABLE NYIT': 42058,
'YI SYLLABLE NYIX': 42059,
'YI SYLLABLE NYO': 42071,
'YI SYLLABLE NYOP': 42072,
'YI SYLLABLE NYOT': 42069,
'YI SYLLABLE NYOX': 42070,
'YI SYLLABLE NYU': 42075,
'YI SYLLABLE NYUO': 42067,
'YI SYLLABLE NYUOP': 42068,
'YI SYLLABLE NYUOX': 42066,
'YI SYLLABLE NYUP': 42076,
'YI SYLLABLE NYUT': 42073,
'YI SYLLABLE NYUX': 42074,
'YI SYLLABLE NZA': 41718,
'YI SYLLABLE NZAP': 41719,
'YI SYLLABLE NZAT': 41716,
'YI SYLLABLE NZAX': 41717,
'YI SYLLABLE NZE': 41725,
'YI SYLLABLE NZEX': 41724,
'YI SYLLABLE NZI': 41711,
'YI SYLLABLE NZIE': 41714,
'YI SYLLABLE NZIEP': 41715,
'YI SYLLABLE NZIEX': 41713,
'YI SYLLABLE NZIP': 41712,
'YI SYLLABLE NZIT': 41709,
'YI SYLLABLE NZIX': 41710,
'YI SYLLABLE NZOP': 41723,
'YI SYLLABLE NZOX': 41722,
'YI SYLLABLE NZU': 41727,
'YI SYLLABLE NZUO': 41721,
'YI SYLLABLE NZUOX': 41720,
'YI SYLLABLE NZUP': 41728,
'YI SYLLABLE NZUR': 41730,
'YI SYLLABLE NZURX': 41729,
'YI SYLLABLE NZUX': 41726,
'YI SYLLABLE NZY': 41733,
'YI SYLLABLE NZYP': 41734,
'YI SYLLABLE NZYR': 41736,
'YI SYLLABLE NZYRX': 41735,
'YI SYLLABLE NZYT': 41731,
'YI SYLLABLE NZYX': 41732,
'YI SYLLABLE O': 40977,
'YI SYLLABLE OP': 40978,
'YI SYLLABLE OT': 40975,
'YI SYLLABLE OX': 40976,
'YI SYLLABLE PA': 41025,
'YI SYLLABLE PAP': 41026,
'YI SYLLABLE PAT': 41023,
'YI SYLLABLE PAX': 41024,
'YI SYLLABLE PI': 41018,
'YI SYLLABLE PIE': 41021,
'YI SYLLABLE PIEP': 41022,
'YI SYLLABLE PIEX': 41020,
'YI SYLLABLE PIP': 41019,
'YI SYLLABLE PIT': 41016,
'YI SYLLABLE PIX': 41017,
'YI SYLLABLE PO': 41032,
'YI SYLLABLE POP': 41033,
'YI SYLLABLE POT': 41030,
'YI SYLLABLE POX': 41031,
'YI SYLLABLE PU': 41036,
'YI SYLLABLE PUO': 41028,
'YI SYLLABLE PUOP': 41029,
'YI SYLLABLE PUOX': 41027,
'YI SYLLABLE PUP': 41037,
'YI SYLLABLE PUR': 41039,
'YI SYLLABLE PURX': 41038,
'YI SYLLABLE PUT': 41034,
'YI SYLLABLE PUX': 41035,
'YI SYLLABLE PY': 41042,
'YI SYLLABLE PYP': 41043,
'YI SYLLABLE PYR': 41045,
'YI SYLLABLE PYRX': 41044,
'YI SYLLABLE PYT': 41040,
'YI SYLLABLE PYX': 41041,
'YI SYLLABLE QI': 41982,
'YI SYLLABLE QIE': 41986,
'YI SYLLABLE QIEP': 41987,
'YI SYLLABLE QIET': 41984,
'YI SYLLABLE QIEX': 41985,
'YI SYLLABLE QIP': 41983,
'YI SYLLABLE QIT': 41980,
'YI SYLLABLE QIX': 41981,
'YI SYLLABLE QO': 41994,
'YI SYLLABLE QOP': 41995,
'YI SYLLABLE QOT': 41992,
'YI SYLLABLE QOX': 41993,
'YI SYLLABLE QU': 41998,
'YI SYLLABLE QUO': 41990,
'YI SYLLABLE QUOP': 41991,
'YI SYLLABLE QUOT': 41988,
'YI SYLLABLE QUOX': 41989,
'YI SYLLABLE QUP': 41999,
'YI SYLLABLE QUR': 42001,
'YI SYLLABLE QURX': 42000,
'YI SYLLABLE QUT': 41996,
'YI SYLLABLE QUX': 41997,
'YI SYLLABLE QY': 42004,
'YI SYLLABLE QYP': 42005,
'YI SYLLABLE QYR': 42007,
'YI SYLLABLE QYRX': 42006,
'YI SYLLABLE QYT': 42002,
'YI SYLLABLE QYX': 42003,
'YI SYLLABLE RA': 41928,
'YI SYLLABLE RAP': 41929,
'YI SYLLABLE RAT': 41926,
'YI SYLLABLE RAX': 41927,
'YI SYLLABLE RE': 41938,
'YI SYLLABLE REP': 41939,
'YI SYLLABLE REX': 41937,
'YI SYLLABLE RO': 41935,
'YI SYLLABLE ROP': 41936,
'YI SYLLABLE ROT': 41933,
'YI SYLLABLE ROX': 41934,
'YI SYLLABLE RRA': 41853,
'YI SYLLABLE RRAX': 41852,
'YI SYLLABLE RRE': 41862,
'YI SYLLABLE RREP': 41863,
'YI SYLLABLE RRET': 41860,
'YI SYLLABLE RREX': 41861,
'YI SYLLABLE RRO': 41858,
'YI SYLLABLE RROP': 41859,
'YI SYLLABLE RROT': 41856,
'YI SYLLABLE RROX': 41857,
'YI SYLLABLE RRU': 41866,
'YI SYLLABLE RRUO': 41855,
'YI SYLLABLE RRUOX': 41854,
'YI SYLLABLE RRUP': 41867,
'YI SYLLABLE RRUR': 41869,
'YI SYLLABLE RRURX': 41868,
'YI SYLLABLE RRUT': 41864,
'YI SYLLABLE RRUX': 41865,
'YI SYLLABLE RRY': 41872,
'YI SYLLABLE RRYP': 41873,
'YI SYLLABLE RRYR': 41875,
'YI SYLLABLE RRYRX': 41874,
'YI SYLLABLE RRYT': 41870,
'YI SYLLABLE RRYX': 41871,
'YI SYLLABLE RU': 41942,
'YI SYLLABLE RUO': 41931,
'YI SYLLABLE RUOP': 41932,
'YI SYLLABLE RUOX': 41930,
'YI SYLLABLE RUP': 41943,
'YI SYLLABLE RUR': 41945,
'YI SYLLABLE RURX': 41944,
'YI SYLLABLE RUT': 41940,
'YI SYLLABLE RUX': 41941,
'YI SYLLABLE RY': 41948,
'YI SYLLABLE RYP': 41949,
'YI SYLLABLE RYR': 41951,
'YI SYLLABLE RYRX': 41950,
'YI SYLLABLE RYT': 41946,
'YI SYLLABLE RYX': 41947,
'YI SYLLABLE SA': 41746,
'YI SYLLABLE SAP': 41747,
'YI SYLLABLE SAT': 41744,
'YI SYLLABLE SAX': 41745,
'YI SYLLABLE SE': 41756,
'YI SYLLABLE SEP': 41757,
'YI SYLLABLE SEX': 41755,
'YI SYLLABLE SHA': 41901,
'YI SYLLABLE SHAP': 41902,
'YI SYLLABLE SHAT': 41899,
'YI SYLLABLE SHAX': 41900,
'YI SYLLABLE SHE': 41912,
'YI SYLLABLE SHEP': 41913,
'YI SYLLABLE SHET': 41910,
'YI SYLLABLE SHEX': 41911,
'YI SYLLABLE SHO': 41908,
'YI SYLLABLE SHOP': 41909,
'YI SYLLABLE SHOT': 41906,
'YI SYLLABLE SHOX': 41907,
'YI SYLLABLE SHU': 41916,
'YI SYLLABLE SHUO': 41904,
'YI SYLLABLE SHUOP': 41905,
'YI SYLLABLE SHUOX': 41903,
'YI SYLLABLE SHUP': 41917,
'YI SYLLABLE SHUR': 41919,
'YI SYLLABLE SHURX': 41918,
'YI SYLLABLE SHUT': 41914,
'YI SYLLABLE SHUX': 41915,
'YI SYLLABLE SHY': 41922,
'YI SYLLABLE SHYP': 41923,
'YI SYLLABLE SHYR': 41925,
'YI SYLLABLE SHYRX': 41924,
'YI SYLLABLE SHYT': 41920,
'YI SYLLABLE SHYX': 41921,
'YI SYLLABLE SI': 41739,
'YI SYLLABLE SIE': 41742,
'YI SYLLABLE SIEP': 41743,
'YI SYLLABLE SIEX': 41741,
'YI SYLLABLE SIP': 41740,
'YI SYLLABLE SIT': 41737,
'YI SYLLABLE SIX': 41738,
'YI SYLLABLE SO': 41753,
'YI SYLLABLE SOP': 41754,
'YI SYLLABLE SOT': 41751,
'YI SYLLABLE SOX': 41752,
'YI SYLLABLE SSA': 41779,
'YI SYLLABLE SSAP': 41780,
'YI SYLLABLE SSAT': 41777,
'YI SYLLABLE SSAX': 41778,
'YI SYLLABLE SSE': 41786,
'YI SYLLABLE SSEP': 41787,
'YI SYLLABLE SSEX': 41785,
'YI SYLLABLE SSI': 41772,
'YI SYLLABLE SSIE': 41775,
'YI SYLLABLE SSIEP': 41776,
'YI SYLLABLE SSIEX': 41774,
'YI SYLLABLE SSIP': 41773,
'YI SYLLABLE SSIT': 41770,
'YI SYLLABLE SSIX': 41771,
'YI SYLLABLE SSO': 41783,
'YI SYLLABLE SSOP': 41784,
'YI SYLLABLE SSOT': 41781,
'YI SYLLABLE SSOX': 41782,
'YI SYLLABLE SSU': 41790,
'YI SYLLABLE SSUP': 41791,
'YI SYLLABLE SSUT': 41788,
'YI SYLLABLE SSUX': 41789,
'YI SYLLABLE SSY': 41794,
'YI SYLLABLE SSYP': 41795,
'YI SYLLABLE SSYR': 41797,
'YI SYLLABLE SSYRX': 41796,
'YI SYLLABLE SSYT': 41792,
'YI SYLLABLE SSYX': 41793,
'YI SYLLABLE SU': 41760,
'YI SYLLABLE SUO': 41749,
'YI SYLLABLE SUOP': 41750,
'YI SYLLABLE SUOX': 41748,
'YI SYLLABLE SUP': 41761,
'YI SYLLABLE SUR': 41763,
'YI SYLLABLE SURX': 41762,
'YI SYLLABLE SUT': 41758,
'YI SYLLABLE SUX': 41759,
'YI SYLLABLE SY': 41766,
'YI SYLLABLE SYP': 41767,
'YI SYLLABLE SYR': 41769,
'YI SYLLABLE SYRX': 41768,
'YI SYLLABLE SYT': 41764,
'YI SYLLABLE SYX': 41765,
'YI SYLLABLE TA': 41251,
'YI SYLLABLE TAP': 41252,
'YI SYLLABLE TAT': 41249,
'YI SYLLABLE TAX': 41250,
'YI SYLLABLE TE': 41262,
'YI SYLLABLE TEP': 41263,
'YI SYLLABLE TEX': 41261,
'YI SYLLABLE TI': 41244,
'YI SYLLABLE TIE': 41247,
'YI SYLLABLE TIEP': 41248,
'YI SYLLABLE TIEX': 41246,
'YI SYLLABLE TIP': 41245,
'YI SYLLABLE TIT': 41242,
'YI SYLLABLE TIX': 41243,
'YI SYLLABLE TO': 41259,
'YI SYLLABLE TOP': 41260,
'YI SYLLABLE TOT': 41257,
'YI SYLLABLE TOX': 41258,
'YI SYLLABLE TU': 41266,
'YI SYLLABLE TUO': 41255,
'YI SYLLABLE TUOP': 41256,
'YI SYLLABLE TUOT': 41253,
'YI SYLLABLE TUOX': 41254,
'YI SYLLABLE TUP': 41267,
'YI SYLLABLE TUR': 41269,
'YI SYLLABLE TURX': 41268,
'YI SYLLABLE TUT': 41264,
'YI SYLLABLE TUX': 41265,
'YI SYLLABLE UO': 40973,
'YI SYLLABLE UOP': 40974,
'YI SYLLABLE UOX': 40972,
'YI SYLLABLE VA': 41196,
'YI SYLLABLE VAP': 41197,
'YI SYLLABLE VAT': 41194,
'YI SYLLABLE VAX': 41195,
'YI SYLLABLE VEP': 41203,
'YI SYLLABLE VEX': 41202,
'YI SYLLABLE VI': 41188,
'YI SYLLABLE VIE': 41192,
'YI SYLLABLE VIEP': 41193,
'YI SYLLABLE VIET': 41190,
'YI SYLLABLE VIEX': 41191,
'YI SYLLABLE VIP': 41189,
'YI SYLLABLE VIT': 41186,
'YI SYLLABLE VIX': 41187,
'YI SYLLABLE VO': 41200,
'YI SYLLABLE VOP': 41201,
'YI SYLLABLE VOT': 41198,
'YI SYLLABLE VOX': 41199,
'YI SYLLABLE VU': 41206,
'YI SYLLABLE VUP': 41207,
'YI SYLLABLE VUR': 41209,
'YI SYLLABLE VURX': 41208,
'YI SYLLABLE VUT': 41204,
'YI SYLLABLE VUX': 41205,
'YI SYLLABLE VY': 41212,
'YI SYLLABLE VYP': 41213,
'YI SYLLABLE VYR': 41215,
'YI SYLLABLE VYRX': 41214,
'YI SYLLABLE VYT': 41210,
'YI SYLLABLE VYX': 41211,
'YI SYLLABLE WA': 41602,
'YI SYLLABLE WAP': 41603,
'YI SYLLABLE WAT': 41600,
'YI SYLLABLE WAX': 41601,
'YI SYLLABLE WE': 41611,
'YI SYLLABLE WEP': 41612,
'YI SYLLABLE WEX': 41610,
'YI SYLLABLE WO': 41608,
'YI SYLLABLE WOP': 41609,
'YI SYLLABLE WOX': 41607,
'YI SYLLABLE WU': 40981,
'YI SYLLABLE WUO': 41605,
'YI SYLLABLE WUOP': 41606,
'YI SYLLABLE WUOX': 41604,
'YI SYLLABLE XI': 42079,
'YI SYLLABLE XIE': 42083,
'YI SYLLABLE XIEP': 42084,
'YI SYLLABLE XIET': 42081,
'YI SYLLABLE XIEX': 42082,
'YI SYLLABLE XIP': 42080,
'YI SYLLABLE XIT': 42077,
'YI SYLLABLE XIX': 42078,
'YI SYLLABLE XO': 42089,
'YI SYLLABLE XOP': 42090,
'YI SYLLABLE XOT': 42087,
'YI SYLLABLE XOX': 42088,
'YI SYLLABLE XUO': 42086,
'YI SYLLABLE XUOX': 42085,
'YI SYLLABLE XY': 42093,
'YI SYLLABLE XYP': 42094,
'YI SYLLABLE XYR': 42096,
'YI SYLLABLE XYRX': 42095,
'YI SYLLABLE XYT': 42091,
'YI SYLLABLE XYX': 42092,
'YI SYLLABLE YI': 42099,
'YI SYLLABLE YIE': 42103,
'YI SYLLABLE YIEP': 42104,
'YI SYLLABLE YIET': 42101,
'YI SYLLABLE YIEX': 42102,
'YI SYLLABLE YIP': 42100,
'YI SYLLABLE YIT': 42097,
'YI SYLLABLE YIX': 42098,
'YI SYLLABLE YO': 42111,
'YI SYLLABLE YOP': 42112,
'YI SYLLABLE YOT': 42109,
'YI SYLLABLE YOX': 42110,
'YI SYLLABLE YU': 42115,
'YI SYLLABLE YUO': 42107,
'YI SYLLABLE YUOP': 42108,
'YI SYLLABLE YUOT': 42105,
'YI SYLLABLE YUOX': 42106,
'YI SYLLABLE YUP': 42116,
'YI SYLLABLE YUR': 42118,
'YI SYLLABLE YURX': 42117,
'YI SYLLABLE YUT': 42113,
'YI SYLLABLE YUX': 42114,
'YI SYLLABLE YY': 42121,
'YI SYLLABLE YYP': 42122,
'YI SYLLABLE YYR': 42124,
'YI SYLLABLE YYRX': 42123,
'YI SYLLABLE YYT': 42119,
'YI SYLLABLE YYX': 42120,
'YI SYLLABLE ZA': 41622,
'YI SYLLABLE ZAP': 41623,
'YI SYLLABLE ZAT': 41620,
'YI SYLLABLE ZAX': 41621,
'YI SYLLABLE ZE': 41632,
'YI SYLLABLE ZEP': 41633,
'YI SYLLABLE ZEX': 41631,
'YI SYLLABLE ZHA': 41800,
'YI SYLLABLE ZHAP': 41801,
'YI SYLLABLE ZHAT': 41798,
'YI SYLLABLE ZHAX': 41799,
'YI SYLLABLE ZHE': 41811,
'YI SYLLABLE ZHEP': 41812,
'YI SYLLABLE ZHET': 41809,
'YI SYLLABLE ZHEX': 41810,
'YI SYLLABLE ZHO': 41807,
'YI SYLLABLE ZHOP': 41808,
'YI SYLLABLE ZHOT': 41805,
'YI SYLLABLE ZHOX': 41806,
'YI SYLLABLE ZHU': 41815,
'YI SYLLABLE ZHUO': 41803,
'YI SYLLABLE ZHUOP': 41804,
'YI SYLLABLE ZHUOX': 41802,
'YI SYLLABLE ZHUP': 41816,
'YI SYLLABLE ZHUR': 41818,
'YI SYLLABLE ZHURX': 41817,
'YI SYLLABLE ZHUT': 41813,
'YI SYLLABLE ZHUX': 41814,
'YI SYLLABLE ZHY': 41821,
'YI SYLLABLE ZHYP': 41822,
'YI SYLLABLE ZHYR': 41824,
'YI SYLLABLE ZHYRX': 41823,
'YI SYLLABLE ZHYT': 41819,
'YI SYLLABLE ZHYX': 41820,
'YI SYLLABLE ZI': 41615,
'YI SYLLABLE ZIE': 41618,
'YI SYLLABLE ZIEP': 41619,
'YI SYLLABLE ZIEX': 41617,
'YI SYLLABLE ZIP': 41616,
'YI SYLLABLE ZIT': 41613,
'YI SYLLABLE ZIX': 41614,
'YI SYLLABLE ZO': 41629,
'YI SYLLABLE ZOP': 41630,
'YI SYLLABLE ZOT': 41627,
'YI SYLLABLE ZOX': 41628,
'YI SYLLABLE ZU': 41636,
'YI SYLLABLE ZUO': 41625,
'YI SYLLABLE ZUOP': 41626,
'YI SYLLABLE ZUOX': 41624,
'YI SYLLABLE ZUP': 41637,
'YI SYLLABLE ZUR': 41639,
'YI SYLLABLE ZURX': 41638,
'YI SYLLABLE ZUT': 41634,
'YI SYLLABLE ZUX': 41635,
'YI SYLLABLE ZY': 41642,
'YI SYLLABLE ZYP': 41643,
'YI SYLLABLE ZYR': 41645,
'YI SYLLABLE ZYRX': 41644,
'YI SYLLABLE ZYT': 41640,
'YI SYLLABLE ZYX': 41641,
'YI SYLLABLE ZZA': 41690,
'YI SYLLABLE ZZAP': 41691,
'YI SYLLABLE ZZAT': 41688,
'YI SYLLABLE ZZAX': 41689,
'YI SYLLABLE ZZE': 41696,
'YI SYLLABLE ZZEP': 41697,
'YI SYLLABLE ZZEX': 41695,
'YI SYLLABLE ZZI': 41682,
'YI SYLLABLE ZZIE': 41686,
'YI SYLLABLE ZZIEP': 41687,
'YI SYLLABLE ZZIET': 41684,
'YI SYLLABLE ZZIEX': 41685,
'YI SYLLABLE ZZIP': 41683,
'YI SYLLABLE ZZIT': 41680,
'YI SYLLABLE ZZIX': 41681,
'YI SYLLABLE ZZO': 41693,
'YI SYLLABLE ZZOP': 41694,
'YI SYLLABLE ZZOX': 41692,
'YI SYLLABLE ZZU': 41699,
'YI SYLLABLE ZZUP': 41700,
'YI SYLLABLE ZZUR': 41702,
'YI SYLLABLE ZZURX': 41701,
'YI SYLLABLE ZZUX': 41698,
'YI SYLLABLE ZZY': 41705,
'YI SYLLABLE ZZYP': 41706,
'YI SYLLABLE ZZYR': 41708,
'YI SYLLABLE ZZYRX': 41707,
'YI SYLLABLE ZZYT': 41703,
'YI SYLLABLE ZZYX': 41704,
'YIN YANG': 9775,
'Z NOTATION BAG MEMBERSHIP': 8959,
'Z NOTATION DOMAIN ANTIRESTRICTION': 10852,
'Z NOTATION LEFT BINDING BRACKET': 10633,
'Z NOTATION LEFT IMAGE BRACKET': 10631,
'Z NOTATION RANGE ANTIRESTRICTION': 10853,
'Z NOTATION RELATIONAL COMPOSITION': 10814,
'Z NOTATION RIGHT BINDING BRACKET': 10634,
'Z NOTATION RIGHT IMAGE BRACKET': 10632,
'Z NOTATION SCHEMA COMPOSITION': 10783,
'Z NOTATION SCHEMA PIPING': 10784,
'Z NOTATION SCHEMA PROJECTION': 10785,
'Z NOTATION SPOT': 10625,
'Z NOTATION TYPE COLON': 10626,
'ZERO WIDTH JOINER': 8205,
'ZERO WIDTH NO-BREAK SPACE': 65279,
'ZERO WIDTH NON-JOINER': 8204,
'ZERO WIDTH SPACE': 8203,
}

_cjk_prefix = "CJK UNIFIED IDEOGRAPH-"
_hangul_prefix = 'HANGUL SYLLABLE '

_hangul_L = ['G', 'GG', 'N', 'D', 'DD', 'R', 'M', 'B', 'BB',
            'S', 'SS', '', 'J', 'JJ', 'C', 'K', 'T', 'P', 'H']
_hangul_V = ['A', 'AE', 'YA', 'YAE', 'EO', 'E', 'YEO', 'YE', 'O', 'WA', 'WAE',
            'OE', 'YO', 'U', 'WEO', 'WE', 'WI', 'YU', 'EU', 'YI', 'I']
_hangul_T = ['', 'G', 'GG', 'GS', 'N', 'NJ', 'NH', 'D', 'L', 'LG', 'LM',
            'LB', 'LS', 'LT', 'LP', 'LH', 'M', 'B', 'BS', 'S', 'SS',
            'NG', 'J', 'C', 'K', 'T', 'P', 'H']

def _lookup_hangul(syllables):
    l_code = v_code = t_code = -1
    for i in range(len(_hangul_L)):
        jamo = _hangul_L[i]
        if (syllables[:len(jamo)] == jamo and
            (l_code < 0 or len(jamo) > len(_hangul_L[l_code]))):
            l_code = i
    if l_code < 0:
        raise KeyError
    start = len(_hangul_L[l_code])

    for i in range(len(_hangul_V)):
        jamo = _hangul_V[i]
        if (syllables[start:start + len(jamo)] == jamo and
            (v_code < 0 or len(jamo) > len(_hangul_V[v_code]))):
            v_code = i
    if v_code < 0:
        raise KeyError
    start += len(_hangul_V[v_code])

    for i in range(len(_hangul_T)):
        jamo = _hangul_T[i]
        if (syllables[start:start + len(jamo)] == jamo and
            (t_code < 0 or len(jamo) > len(_hangul_T[t_code]))):
            t_code = i
    if t_code < 0:
        raise KeyError
    start += len(_hangul_T[t_code])

    if len(syllables[start:]):
        raise KeyError
    return 0xAC00 + (l_code * 21 + v_code) * 28 + t_code

def _lookup_cjk(cjk_code):
    if len(cjk_code) != 4 and len(cjk_code) != 5:
        raise KeyError
    for c in cjk_code:
        if not ('0' <= c <= '9' or 'A' <= c <= 'F'):
            raise KeyError
    code = int(cjk_code, 16)
    if (0x3400 <= code <= 0x4DB5 or
        0x4E00 <= code <= 0x9FBB or
        0x20000 <= code <= 0x2A6D6):
        return code
    raise KeyError

def lookup(name):
    if name[:len(_cjk_prefix)] == _cjk_prefix:
        return _lookup_cjk(name[len(_cjk_prefix):])
    if name[:len(_hangul_prefix)] == _hangul_prefix:
        return _lookup_hangul(name[len(_hangul_prefix):])

    if not base_mod:
        return trie_lookup(name)
    else:
        try:
            return _code_by_name[name]
        except KeyError:
            if name not in _code_by_name_corrected:
                return base_mod.trie_lookup(name)
            else:
                raise

def name(code):
    if (0x3400 <= code <= 0x4DB5 or
        0x4E00 <= code <= 0x9FBB or
        0x20000 <= code <= 0x2A6D6):
        return "CJK UNIFIED IDEOGRAPH-" + hex(code)[2:].upper()
    if 0xAC00 <= code <= 0xD7A3:
        # vl_code, t_code = divmod(code - 0xAC00, len(_hangul_T))
        vl_code = (code - 0xAC00) // len(_hangul_T)
        t_code = (code - 0xAC00) % len(_hangul_T)
        # l_code, v_code = divmod(vl_code,  len(_hangul_V))
        l_code = vl_code // len(_hangul_V)
        v_code = vl_code % len(_hangul_V)
        return ("HANGUL SYLLABLE " + _hangul_L[l_code] +
                _hangul_V[v_code] + _hangul_T[t_code])
    
    if not base_mod:
        return lookup_charcode(code)
    else:
        try:
            return _names[code]
        except KeyError:
            if code not in _names_corrected:
                return base_mod.lookup_charcode(code)
            else:
                raise

_db_records = [
('Cc', 'B', 'N', 5, 0),
('Cc', 'BN', 'N', 0, 0),
('Cc', 'S', 'N', 1, 0),
('Cc', 'WS', 'N', 1, 0),
('Cf', 'AL', 'N', 0, 0),
('Cf', 'BN', 'A', 0, 0),
('Cf', 'BN', 'N', 0, 0),
('Cf', 'L', 'N', 0, 0),
('Cf', 'LRE', 'N', 0, 0),
('Cf', 'LRO', 'N', 0, 0),
('Cf', 'ON', 'N', 0, 0),
('Cf', 'PDF', 'N', 0, 0),
('Cf', 'R', 'N', 0, 0),
('Cf', 'RLE', 'N', 0, 0),
('Cf', 'RLO', 'N', 0, 0),
('Cn', '', 'N', 0, 0),
('Cn', '', 'W', 0, 0),
('Co', 'L', 'A', 0, 0),
('Cs', 'L', 'N', 0, 0),
('Ll', 'L', 'A', 34, 0),
('Ll', 'L', 'F', 34, 0),
('Ll', 'L', 'N', 34, 0),
('Ll', 'L', 'Na', 34, 0),
('Lm', 'AL', 'N', 2, 0),
('Lm', 'L', 'A', 2, 0),
('Lm', 'L', 'H', 2, 0),
('Lm', 'L', 'N', 2, 0),
('Lm', 'L', 'W', 2, 0),
('Lm', 'ON', 'A', 2, 0),
('Lm', 'ON', 'N', 2, 0),
('Lo', 'AL', 'N', 2, 0),
('Lo', 'L', 'H', 2, 0),
('Lo', 'L', 'N', 2, 0),
('Lo', 'L', 'W', 2, 0),
('Lo', 'L', 'W', 66, 0),
('Lo', 'R', 'N', 2, 0),
('Lt', 'L', 'N', 18, 0),
('Lu', 'L', 'A', 10, 0),
('Lu', 'L', 'F', 10, 0),
('Lu', 'L', 'N', 10, 0),
('Lu', 'L', 'Na', 10, 0),
('Mc', 'L', 'N', 0, 0),
('Mc', 'L', 'N', 0, 216),
('Mc', 'L', 'N', 0, 226),
('Mc', 'NSM', 'N', 0, 0),
('Me', 'NSM', 'N', 0, 0),
('Mn', 'L', 'N', 0, 0),
('Mn', 'NSM', 'A', 0, 0),
('Mn', 'NSM', 'A', 0, 1),
('Mn', 'NSM', 'A', 0, 202),
('Mn', 'NSM', 'A', 0, 216),
('Mn', 'NSM', 'A', 0, 220),
('Mn', 'NSM', 'A', 0, 230),
('Mn', 'NSM', 'A', 0, 232),
('Mn', 'NSM', 'A', 0, 233),
('Mn', 'NSM', 'A', 0, 234),
('Mn', 'NSM', 'A', 0, 240),
('Mn', 'NSM', 'N', 0, 0),
('Mn', 'NSM', 'N', 0, 1),
('Mn', 'NSM', 'N', 0, 7),
('Mn', 'NSM', 'N', 0, 9),
('Mn', 'NSM', 'N', 0, 10),
('Mn', 'NSM', 'N', 0, 11),
('Mn', 'NSM', 'N', 0, 12),
('Mn', 'NSM', 'N', 0, 13),
('Mn', 'NSM', 'N', 0, 14),
('Mn', 'NSM', 'N', 0, 15),
('Mn', 'NSM', 'N', 0, 16),
('Mn', 'NSM', 'N', 0, 17),
('Mn', 'NSM', 'N', 0, 18),
('Mn', 'NSM', 'N', 0, 19),
('Mn', 'NSM', 'N', 0, 20),
('Mn', 'NSM', 'N', 0, 21),
('Mn', 'NSM', 'N', 0, 22),
('Mn', 'NSM', 'N', 0, 23),
('Mn', 'NSM', 'N', 0, 24),
('Mn', 'NSM', 'N', 0, 25),
('Mn', 'NSM', 'N', 0, 26),
('Mn', 'NSM', 'N', 0, 27),
('Mn', 'NSM', 'N', 0, 28),
('Mn', 'NSM', 'N', 0, 29),
('Mn', 'NSM', 'N', 0, 30),
('Mn', 'NSM', 'N', 0, 31),
('Mn', 'NSM', 'N', 0, 32),
('Mn', 'NSM', 'N', 0, 33),
('Mn', 'NSM', 'N', 0, 34),
('Mn', 'NSM', 'N', 0, 35),
('Mn', 'NSM', 'N', 0, 36),
('Mn', 'NSM', 'N', 0, 84),
('Mn', 'NSM', 'N', 0, 91),
('Mn', 'NSM', 'N', 0, 103),
('Mn', 'NSM', 'N', 0, 107),
('Mn', 'NSM', 'N', 0, 118),
('Mn', 'NSM', 'N', 0, 122),
('Mn', 'NSM', 'N', 0, 129),
('Mn', 'NSM', 'N', 0, 130),
('Mn', 'NSM', 'N', 0, 132),
('Mn', 'NSM', 'N', 0, 216),
('Mn', 'NSM', 'N', 0, 220),
('Mn', 'NSM', 'N', 0, 222),
('Mn', 'NSM', 'N', 0, 228),
('Mn', 'NSM', 'N', 0, 230),
('Mn', 'NSM', 'W', 0, 8),
('Mn', 'NSM', 'W', 0, 218),
('Mn', 'NSM', 'W', 0, 222),
('Mn', 'NSM', 'W', 0, 224),
('Mn', 'NSM', 'W', 0, 228),
('Mn', 'NSM', 'W', 0, 232),
('Nd', 'AN', 'N', 448, 0),
('Nd', 'EN', 'F', 448, 0),
('Nd', 'EN', 'N', 448, 0),
('Nd', 'EN', 'Na', 448, 0),
('Nd', 'L', 'N', 448, 0),
('Nl', 'L', 'A', 64, 0),
('Nl', 'L', 'N', 0, 0),
('Nl', 'L', 'N', 64, 0),
('Nl', 'L', 'W', 64, 0),
('Nl', 'ON', 'N', 64, 0),
('No', 'EN', 'A', 64, 0),
('No', 'EN', 'A', 192, 0),
('No', 'EN', 'N', 192, 0),
('No', 'L', 'N', 0, 0),
('No', 'L', 'N', 64, 0),
('No', 'L', 'N', 192, 0),
('No', 'L', 'W', 64, 0),
('No', 'ON', 'A', 64, 0),
('No', 'ON', 'A', 192, 0),
('No', 'ON', 'N', 64, 0),
('No', 'ON', 'N', 192, 0),
('No', 'ON', 'W', 64, 0),
('No', 'R', 'N', 64, 0),
('No', 'R', 'N', 192, 0),
('Pc', 'ON', 'F', 0, 0),
('Pc', 'ON', 'N', 0, 0),
('Pc', 'ON', 'Na', 0, 0),
('Pc', 'ON', 'W', 0, 0),
('Pd', 'ES', 'F', 0, 0),
('Pd', 'ES', 'Na', 0, 0),
('Pd', 'ES', 'W', 0, 0),
('Pd', 'ON', 'A', 0, 0),
('Pd', 'ON', 'N', 0, 0),
('Pd', 'ON', 'W', 0, 0),
('Pe', 'ON', 'F', 512, 0),
('Pe', 'ON', 'H', 512, 0),
('Pe', 'ON', 'N', 0, 0),
('Pe', 'ON', 'N', 512, 0),
('Pe', 'ON', 'Na', 512, 0),
('Pe', 'ON', 'W', 0, 0),
('Pe', 'ON', 'W', 512, 0),
('Pf', 'ON', 'A', 0, 0),
('Pf', 'ON', 'N', 512, 0),
('Pi', 'ON', 'A', 0, 0),
('Pi', 'ON', 'N', 0, 0),
('Pi', 'ON', 'N', 512, 0),
('Po', 'AL', 'N', 0, 0),
('Po', 'AN', 'N', 0, 0),
('Po', 'CS', 'F', 0, 0),
('Po', 'CS', 'N', 0, 0),
('Po', 'CS', 'Na', 0, 0),
('Po', 'CS', 'W', 0, 0),
('Po', 'ET', 'A', 0, 0),
('Po', 'ET', 'F', 0, 0),
('Po', 'ET', 'N', 0, 0),
('Po', 'ET', 'Na', 0, 0),
('Po', 'ET', 'W', 0, 0),
('Po', 'L', 'N', 0, 0),
('Po', 'ON', 'A', 0, 0),
('Po', 'ON', 'F', 0, 0),
('Po', 'ON', 'H', 0, 0),
('Po', 'ON', 'N', 0, 0),
('Po', 'ON', 'Na', 0, 0),
('Po', 'ON', 'W', 0, 0),
('Po', 'R', 'N', 0, 0),
('Ps', 'ON', 'F', 512, 0),
('Ps', 'ON', 'H', 512, 0),
('Ps', 'ON', 'N', 0, 0),
('Ps', 'ON', 'N', 512, 0),
('Ps', 'ON', 'Na', 512, 0),
('Ps', 'ON', 'W', 0, 0),
('Ps', 'ON', 'W', 512, 0),
('Sc', 'AL', 'N', 0, 0),
('Sc', 'ET', 'A', 0, 0),
('Sc', 'ET', 'F', 0, 0),
('Sc', 'ET', 'H', 0, 0),
('Sc', 'ET', 'N', 0, 0),
('Sc', 'ET', 'Na', 0, 0),
('Sc', 'ET', 'W', 0, 0),
('Sk', 'ON', 'A', 0, 0),
('Sk', 'ON', 'F', 0, 0),
('Sk', 'ON', 'N', 0, 0),
('Sk', 'ON', 'Na', 0, 0),
('Sk', 'ON', 'W', 0, 0),
('Sm', 'CS', 'N', 0, 0),
('Sm', 'ES', 'F', 0, 0),
('Sm', 'ES', 'N', 0, 0),
('Sm', 'ES', 'Na', 0, 0),
('Sm', 'ES', 'W', 0, 0),
('Sm', 'ET', 'A', 0, 0),
('Sm', 'ET', 'N', 0, 0),
('Sm', 'L', 'N', 0, 0),
('Sm', 'ON', 'A', 0, 0),
('Sm', 'ON', 'A', 512, 0),
('Sm', 'ON', 'F', 0, 0),
('Sm', 'ON', 'F', 512, 0),
('Sm', 'ON', 'H', 0, 0),
('Sm', 'ON', 'N', 0, 0),
('Sm', 'ON', 'N', 512, 0),
('Sm', 'ON', 'Na', 0, 0),
('Sm', 'ON', 'Na', 512, 0),
('Sm', 'ON', 'W', 0, 0),
('So', 'AL', 'N', 0, 0),
('So', 'ET', 'A', 0, 0),
('So', 'ET', 'N', 0, 0),
('So', 'L', 'A', 0, 0),
('So', 'L', 'N', 0, 0),
('So', 'L', 'W', 0, 0),
('So', 'ON', 'A', 0, 0),
('So', 'ON', 'F', 0, 0),
('So', 'ON', 'H', 0, 0),
('So', 'ON', 'N', 0, 0),
('So', 'ON', 'Na', 0, 0),
('So', 'ON', 'W', 0, 0),
('Zl', 'WS', 'N', 5, 0),
('Zp', 'B', 'N', 5, 0),
('Zs', 'CS', 'N', 1, 0),
('Zs', 'WS', 'F', 1, 0),
('Zs', 'WS', 'N', 1, 0),
('Zs', 'WS', 'Na', 1, 0),
]
_db_pgtbl = (
'\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x08\x08\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./01233343353333'
'3333333333333678393:33;3<33333=>33?@333A33333333333B33C333333333'
'D333E3333333FG33333333H33333333IJ333K\x08\x08LM\x08\x08\x0833333333333333333333'
'33333333333333333333333NOOOOOOOOPPPPPPPPPPPPPPPPPPPPPPPPP3QRSTUV'
'WX\x08YZ\x08\x08\x08[\x08\\\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08]^_`abcd\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'ef3333333ghi33333333333333333333333j33333k33333333333333333l3333'
'3333333333333333333333333333333333m33333333333333333333333333333'
'33333333333333333333333333333333333333nooooooooooooooooooooooooo'
'oooooooooooooooooooooooooooooooooooooooooooooooooooooooo33pooooq'
'oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo'
'oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo'
'oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo'
'oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooq'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'rs\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08'
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP'
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP'
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP'
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPt'
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP'
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP'
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP'
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPt'
)
_db_pages = ( 
'\x01\x01\x01\x01\x01\x01\x01\x01\x01\x02\x00\x02\x03\x00\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x00\x00\x00\x02\xe3\xaa\xaa\xa3\xb9\xa3\xaa\xaa\xb1\x92\xaa\xc3\x9e\x89\x9e\x9eoooooooooo\x9e\xaa\xd0\xcf\xd0\xaa'
'\xaa((((((((((((((((((((((((((\xb1\xaa\x92\xbe\x86\xbe\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\xb1\xcf\x92\xcf\x01'
'\x01\x01\x01\x01\x01\x00\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\xe0\xa6\xb9\xb9\xb5\xb9\xdc\xd8\xbb\xdb\x13\x99\xcf\x05\xd8\xbe\xd3\xc5ww\xbb\x15\xd8\xa6\xbbw\x13\x96}}}\xa6'
"''''''%'''''''''%''''''\xc8%'''''%\x13\x13\x13\x15\x15\x15\x15\x13\x15\x13\x13\x13\x15\x13\x13\x15\x15\x13\x15\x13\x13\x15\x15\x15\xc8\x13\x13\x13\x15\x13\x15\x13\x15"
"'\x13'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x13'\x13'\x15'\x15'\x15'\x13'\x15'\x15'\x15'\x15'\x15%\x13'\x15'\x13'\x15'\x15'\x13%\x13'\x15'\x15\x13'\x15'\x15'\x15%"
"\x13%\x13'\x13'\x15'\x13\x13%\x13'\x13'\x15'\x15%\x13'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15%\x13'\x15'\x13'\x15'\x15'\x15'\x15'\x15'\x15''\x15'\x15'\x15\x15"
"\x15''\x15'\x15''\x15'''\x15\x15''''\x15''\x15'''\x15\x15\x15''\x15''\x15'\x15'\x15''\x15'\x15\x15'\x15''\x15'''\x15'\x15''\x15\x15 '\x15\x15\x15"
"    '$\x15'$\x15'$\x15'\x13'\x13'\x13'\x13'\x13'\x13'\x13'\x13\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15\x15'$\x15'\x15'''\x15'\x15'\x15'\x15"
"'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15\x15\x15\x15\x15\x15\x15''\x15''\x15"
"\x15'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x15\x13\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x13\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
'\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1d\x1d\x1a\x1a\x1a\x1a\x1a'
'\x1a\x1a\xbd\xbd\xbb\xbd\x1d\x1c\x1d\x1c\x1c\x1c\x1d\x1c\x1d\x1d\x18\x1a\xbd\xbd\xbd\xbd\xbd\xbd\xbb\xbb\xbb\xbb\xbd\xbb\xbd\xbb\x1a\x1a\x1a\x1a\x1a\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\x1a\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd'
'4444444444444444444445333352333331133331133333333333000003333444'
'444448433344433/44433334533467767764444444444444\x0f\x0f\x0f\x0f\xbd\xbd\x0f\x0f\x0f\x0f\x1a\x0f\x0f\x0f\xa9\x0f'
"\x0f\x0f\x0f\x0f\xbd\xbd'\xa9'''\x0f'\x0f''\x15%%%%%%%%%%%%%%%%%\x0f%%%%%%%''\x15\x15\x15\x15\x15\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13"
"\x13\x13\x15\x13\x13\x13\x13\x13\x13\x13\x15\x15\x15\x15\x15\x0f\x15\x15'''\x15\x15\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15\x15\x15\x15\x15'\x15\xcd'\x15''\x15\x15'''"
"'%''''''''''''''%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13"
"\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x15\x13\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15"
"'\x15\xd6eeee\x0f--'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15"
"''\x15'\x15'\x15'\x15'\x15'\x15'\x15\x0f'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15\x0f\x0f\x0f\x0f\x0f\x0f"
"'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'''''''''''''''"
"'''''''''''''''''''''''\x0f\x0f\x1a\xa5\xa5\xa5\xa5\xa5\xa5\x0f\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
'\x15\x15\x15\x15\x15\x15\x15\x15\x0f\xa5\x8c\x0f\x0f\x0f\x0f\x0f\x0fbeeeebeeecbeeeeeebbbbbbeebeecde=>?@ABCDEF\x0fGHI\xacJ'
'\xacKL\xaceb\xacE\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f###########################\x0f\x0f\x0f\x0f\x0f###\xac\xac\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x04\x04\x04\x04\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xb4\x9d\x9a\xdb\xdbeeeeee\x0f\x0f\x0f\x0f\x0f\x9a\x0f\x0f\x9a\x9a\x0f\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x0f\x0f\x0f\x0f\x0f'
'\x17\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1eNOPQRSTUeebbeeeeebee\x0fllllllllll\xa2\x9b\x9b\x9a\x1e\x1eV\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x9a\x1eeeeeeee\x04-eeeebe\x17\x17ee\xdbbeeb\x1e\x1ennnnnnnnnn\x1e\x1e\x1e\xd2\xd2\x1e'
'\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x0f\x06\x1eW\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1eebeebeebbbebbebe'
'eebebebebee\x0f\x0f\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e99999999999\x1e\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f99)                                                      \x0f\x0f; ))'
')99999999))))<\x0f\x0f ebee\x0f\x0f\x0f          99\xa5\xa5pppppppppp\xa5\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f \x0f\x0f'
'\x0f9))\x0f        \x0f\x0f  \x0f\x0f                      \x0f       \x0f \x0f\x0f\x0f    \x0f\x0f; ))'
')9999\x0f\x0f))\x0f\x0f))< \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f)\x0f\x0f\x0f\x0f  \x0f   99\x0f\x0fpppppppppp  \xb8\xb8zzzzyz\xd6\x0f\x0f\x0f\x0f\x0f'
'\x0f99)\x0f      \x0f\x0f\x0f\x0f  \x0f\x0f                      \x0f       \x0f  \x0f  \x0f  \x0f\x0f;\x0f))'
')99\x0f\x0f\x0f\x0f99\x0f\x0f99<\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f    \x0f \x0f\x0f\x0f\x0f\x0f\x0f\x0fpppppppppp99   \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f99)\x0f         \x0f   \x0f                      \x0f       \x0f  \x0f     \x0f\x0f; ))'
')99999\x0f99)\x0f))<\x0f\x0f \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f  99\x0f\x0fpppppppppp\x0f\xb8\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f9))\x0f        \x0f\x0f  \x0f\x0f                      \x0f       \x0f  \x0f     \x0f\x0f; )9'
')999\x0f\x0f\x0f))\x0f\x0f))<\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f9)\x0f\x0f\x0f\x0f  \x0f   \x0f\x0f\x0f\x0fpppppppppp\xd6 \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f9 \x0f      \x0f\x0f\x0f   \x0f    \x0f\x0f\x0f  \x0f \x0f  \x0f\x0f\x0f  \x0f\x0f\x0f   \x0f\x0f\x0f            \x0f\x0f\x0f\x0f))'
'9))\x0f\x0f\x0f)))\x0f)))<\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f)\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0fppppppppppzzz\xdb\xdb\xdb\xdb\xdb\xdb\xb8\xdb\x0f\x0f\x0f\x0f\x0f'
'\x0f)))\x0f        \x0f   \x0f                       \x0f          \x0f     \x0f\x0f\x0f\x0f99'
'9))))\x0f999\x0f999<\x0f\x0f\x0f\x0f\x0f\x0f\x0fXY\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f  \x0f\x0f\x0f\x0fpppppppppp\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f))\x0f        \x0f   \x0f                       \x0f          \x0f     \x0f\x0f; ).'
')))))\x0f.))\x0f))9<\x0f\x0f\x0f\x0f\x0f\x0f\x0f))\x0f\x0f\x0f\x0f\x0f\x0f\x0f \x0f  \x0f\x0f\x0f\x0fpppppppppp\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f))\x0f        \x0f   \x0f                       \x0f                \x0f\x0f\x0f\x0f))'
')999\x0f\x0f)))\x0f)))<\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f)\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f  \x0f\x0f\x0f\x0fpppppppppp\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f))\x0f                  \x0f\x0f\x0f                        \x0f         \x0f \x0f\x0f'
'       \x0f\x0f\x0f<\x0f\x0f\x0f\x0f)))999\x0f9\x0f))))))))\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f))\xa5\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f                                                9  9999ZZ<\x0f\x0f\x0f\x0f\xb8'
'      \x1a9[[[[999\xa5pppppppppp\xa5\xa5\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f  \x0f \x0f\x0f  \x0f \x0f\x0f \x0f\x0f\x0f\x0f\x0f\x0f    \x0f       \x0f   \x0f \x0f \x0f\x0f  \x0f    9  9999\\\\\x0f99 \x0f\x0f'
'     \x0f\x1a\x0f]]]]99\x0f\x0fpppppppppp\x0f\x0f  \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
' \xd6\xd6\xd6\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xd6\xd6\xd6\xd6\xd6bb\xd6\xd6\xd6\xd6\xd6\xd6ppppppppppzzzzzzzzzz\xd6b\xd6b\xd6a\xaf\x90\xaf\x90))'
'        \x0f                                  \x0f\x0f\x0f\x0f\x0f\x0f^_9`99999____9)'
'_9ee<\xa5ee    \x0f\x0f\x0f\x0f99999999\x0f999999999999999999999999999999999999\x0f\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6b\xd6\xd6\xd6\xd6\xd6\xd6\x0f\x0f\xd6\xa5\xa5\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                                  \x0f     \x0f  \x0f)9999)9\x0f\x0f\x0f9;)<\x0f\x0f\x0f\x0f\x0f\x0f'
'pppppppppp\xa5\xa5\xa5\xa5\xa5\xa5      ))99\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
"\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f''''''''''''''''''''''''''''''''"
"''''''\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f                                           \xa5\x1a\x0f\x0f\x0f"
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f\x0f\x0f\x0f!                                '
'                                   \x0f\x0f\x0f\x0f\x0f                        '
'                                                          \x0f\x0f\x0f\x0f\x0f\x0f'
'                                                                '
'         \x0f    \x0f\x0f       \x0f \x0f    \x0f\x0f                                '
'         \x0f    \x0f\x0f                                 \x0f    \x0f\x0f       \x0f'
' \x0f    \x0f\x0f               \x0f                                        '
'                 \x0f    \x0f\x0f                                        '
'                           \x0f\x0f\x0f\x0fe\xd6\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5{{{{{{{{{zzzzzzzzzzz\x0f\x0f\x0f'
'                \xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f                                '
'                                                     \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f                                                               '
'                                                                '
'                                                                '
'                                                                '
'                                                                '
'                                                                '
'                                                                '
'                                                                '
'                                                                '
'                                             \xa5\xa5        \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xe2                          \xaf\x90\x0f\x0f\x0f                                '
'                                           \xa5\xa5\xa5sss\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'             \x0f    99<\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f                  99<\xa5\xa5\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                  99\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f             \x0f   \x0f99\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                                                    \x07\x07)9999999))'
'))))))9))999999999<9\xa5\xa5\xa5\x1a\xa5\xa5\xa5\xb8 e\x0f\x0fpppppppppp\x0f\x0f\x0f\x0f\x0f\x0f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xa9\xa9\xa9\xa9\xa9\xa9\x8c\xa9\xa9\xa9\xa9999\xe2\x0fpppppppppp\x0f\x0f\x0f\x0f\x0f\x0f                                '
'   \x1a                                                    \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                                         d\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                             \x0f\x0f\x0f999))))99,,,\x0f\x0f\x0f\x0f))9))))))ceb\x0f\x0f\x0f\x0f'
'\xdb\x0f\x0f\x0f\xa9\xa9pppppppppp                              \x0f\x0f     \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                                          \x0f\x0f\x0f\x0f\x0f\x0f))))))))))))))))'
')       ))\x0f\x0f\x0f\x0f\x0f\x0fpppppppppp\x0f\x0f\x0f\x0f\xa9\xa9\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'                       eb)))\x0f\x0f\xa5\xa5\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a'
'\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x1a\x15\x15\x15\x15\x15\x15\x15'
'\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a\x1a'
'eebe\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
"'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15"
"'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15"
"'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15\x15\x15\x15\x15\x15\x15\x0f\x0f\x0f\x0f'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15"
"'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15\x0f\x0f\x0f\x0f\x0f\x0f"
"\x15\x15\x15\x15\x15\x15\x15\x15''''''''\x15\x15\x15\x15\x15\x15\x0f\x0f''''''\x0f\x0f\x15\x15\x15\x15\x15\x15\x15\x15''''''''\x15\x15\x15\x15\x15\x15\x15\x15''''''''"
"\x15\x15\x15\x15\x15\x15\x0f\x0f''''''\x0f\x0f\x15\x15\x15\x15\x15\x15\x15\x15\x0f'\x0f'\x0f'\x0f'\x15\x15\x15\x15\x15\x15\x15\x15''''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x0f\x0f"
"\x15\x15\x15\x15\x15\x15\x15\x15$$$$$$$$\x15\x15\x15\x15\x15\x15\x15\x15$$$$$$$$\x15\x15\x15\x15\x15\x15\x15\x15$$$$$$$$\x15\x15\x15\x15\x15\x0f\x15\x15''''$\xbd\x15\xbd"
"\xbd\xbd\x15\x15\x15\x0f\x15\x15''''$\xbd\xbd\xbd\x15\x15\x15\x15\x0f\x0f\x15\x15''''\x0f\xbd\xbd\xbd\x15\x15\x15\x15\x15\x15\x15\x15'''''\xbd\xbd\xbd\x0f\x0f\x15\x15\x15\x0f\x15\x15''''$\xbd\xbd\x0f"
'\xe2\xe2\xe2\xe2\xe2\xe2\xe2\xe2\xe2\xe2\xe2\x06\x06\x06\x07\x0c\x8b\x8c\x8c\x8b\x8b\x8b\xa6\xa9\x97\x95\xaf\x98\x97\x95\xaf\x98\xa6\xa6\xa6\xa9\xa6\xa6\xa6\xa6\xde\xdf\x08\r\x0b\t\x0e\xe0\xa0\xa2\xa0\xa0\xa2\xa6\xa9\xa9\xa9\x99\x96\xa6\xa9\xa9\xa6\x85'
'\x85\xa9\xa9\xa9\xc0\xb0\x91\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xcd\xa9\x85\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xe2\x06\x06\x06\x06\x0f\x0f\x0f\x0f\x0f\x0f\x06\x06\x06\x06\x06\x06x\x15\x0f\x0fwxxxxx\xc2\xc2\xcd\xb0\x91\x13'
'xwwwwxxxxx\xc2\xc2\xcd\xb0\x91\x0f\x1a\x1a\x1a\x1a\x1a\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xb8\xb8\xb8\xb8\xb8\xb8\xb8\xb8\xb8\xb7\xb8\xb8\xb5\xb8\xb8\xb8\xb8\xb8\xb8\xb8\xb8\xb8\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0fee::eeee:::ee----e---::ebe::\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
"\xdb\xdb'\xd8\xdb\xd8\xdb'\xdb\xd8\x15'''\x15\x15'''\x13\xdb'\xd8\xdb\xdb'''''\xdb\xdb\xdb\xd8\xd8\xdb'\xdb%\xdb'\xdb'%''\xd4\x15''\xdb'\x15    \x15\xdb\xdb\x15\x15''"
"\xce\xcd\xcd\xcd\xcd'\x15\x15\x15\x15\xdb\xcd\xdb\x0f\x0f\x0f\x0f\x0f\x0f}}\x7f\x7f\x7f\x7f\x7f\x7f}}}}\x7fqqqqqqqqqqqqssssqqqqqqqqqqssssss"
'sssr\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xc8\xc8\xc8\xc8\xc8\xd8\xd8\xd8\xd8\xd8\xcd\xcd\xdb\xdb\xdb\xdb\xcd\xdb\xdb\xcd\xdb\xdb\xcd\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xcd\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xd8\xdb\xdb\xdb\xdb\xdb\xdb'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xcd\xcd\xdb\xdb\xc8\xdb\xc8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd'
'\xc8\xce\xc9\xc9\xce\xcd\xcd\xc8\xc9\xce\xce\xc9\xce\xce\xcd\xc8\xcd\xc9\xc2\xc6\xcd\xc9\xce\xcd\xcd\xcd\xc9\xce\xce\xc9\xc8\xc9\xc9\xce\xce\xc8\xce\xc8\xce\xc8\xc8\xc8\xc8\xc9\xc9\xce\xc9\xce\xce\xce\xce\xce\xc8\xc8\xc8\xc8\xcd\xce\xcd\xce\xc9\xc9\xce\xce'
'\xce\xce\xce\xce\xce\xce\xce\xce\xc9\xce\xce\xce\xc9\xcd\xcd\xcd\xcd\xcd\xc9\xce\xce\xce\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xce\xc9\xc8\xce\xcd\xc9\xc9\xc9\xc9\xce\xce\xc9\xc9\xcd\xcd\xc9\xc9\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce'
'\xce\xce\xc9\xc9\xce\xce\xc9\xc9\xce\xce\xce\xce\xce\xcd\xcd\xce\xce\xce\xce\xcd\xcd\xc8\xcd\xcd\xce\xc8\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xce\xce\xcd\xc8\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcd\xcd\xcd\xcd\xcd\xce\xc9'
'\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xce\xce\xce\xce\xce\xcd\xcd\xce\xce\xcd\xcd\xcd\xcd\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcd\xcd\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xce\xce\xce\xce\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xce\xce\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xb3\x94\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xdb\xcd\xdb\xdb\xdb'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd6\xdb\xdb\xdb\xdb\xdb\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xaf\x90\xa9\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f~~~~~~~~~}}}}}}}}}}}~~~~~~~~~}}}'
'}}}}}}}}wwwwwwwwwvvvvvvvvvvv\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5'
'\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\x80}}}}}}}}}}~~~~~~~~~}~'
'\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8'
'\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xdb\xdb\xdb\xdb\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xdb\xdb\xd8\xd8\xd8\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xd8\xdb\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xd8\xdb\xdb\xd8\xc8\xdb\xdb\xdb\xdb\xd8\xd8\xdb\xdb'
'\xd8\xc8\xdb\xdb\xdb\xdb\xd8\xd8\xd8\xdb\xdb\xd8\xdb\xdb\xd8\xd8\xd8\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xd8\xd8\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd'
'\xdb\xdb\xdb\xdb\xdb\xd8\xd8\xdb\xdb\xd8\xdb\xdb\xdb\xdb\xd8\xd8\xdb\xdb\xdb\xdb\xd8\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xdb\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'\xd8\xdb\xd8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xd8\xdb\xd8\xd8\xd8\xdb\xd8\xd8\xd8\xd8\xdb\xd8\xd8\xdb\xc8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd6\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\xdb\xdb\xdb\xdb\x0f\xdb\xdb\xdb\xdb\x0f\x0f\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xd8\xdb\xdb'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\xdb\x0f\xdb\xdb\xdb\xdb\x0f\x0f\x0f\xdb\x0f\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xb0\x91~~~~~~~~~}'
'\x80\x80\x80\x80\x80\x80\x80\x80\x80\x7f\x80\x80\x80\x80\x80\x80\x80\x80\x80\x7f\xdb\x0f\x0f\x0f\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f'
'\xce\xcd\xcd\xce\xce\xb0\x91\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xcd\xcd\xcd\xce\xce\xce\xce\xcd\xcd\xcd\xcd\xcd\xce\xce\xce\xcd\xcd\xcd\xce\xce\xce\xce\xb1\x92\xb1\x92\xb1\x92\x0f\x0f\x0f\x0f\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd'
'\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd'
'\xcd\xcd\xcd\xb0\x91\xb1\x92\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xb0\x91\xcd\xcd\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xce\xcd\xcd\xcd\xcd\xcd\xcd\xcd'
'\xce\xce\xce\xce\xce\xce\xcd\xcd\xcd\xce\xcd\xcd\xcd\xcd\xce\xce\xce\xce\xce\xcd\xce\xce\xcd\xcd\xb0\x91\xb0\x91\xce\xcd\xcd\xcd\xcd\xce\xcd\xce\xce\xce\xcd\xcd\xce\xce\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xce\xce\xce\xce\xce\xce\xcd\xcd\xb0\x91\xcd\xcd'
'\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcd\xce\xce\xce\xce\xcd\xcd\xce\xcd\xce\xcd\xcd\xce\xcd\xce\xce\xce\xce\xcd\xcd\xcd\xcd\xcd\xce\xce\xcd\xcd\xcd\xcd\xcd\xcd\xce\xce\xce\xcd'
'\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xce\xce\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xce\xce\xcd\xcd\xcd\xcd\xce\xce\xce\xce\xcd\xce\xce\xcd\xcd\xce\xce\xcd\xcd\xcd\xcd\xce\xce\xce\xce\xce\xce\xce'
'\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcd\xcd\xce\xce\xce\xce\xce\xce\xce\xce\xcd\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce'
'\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcd\xcd\xcd\xcd\xcd\xce\xcd\xce\xcd\xcd\xcd\xce\xce\xce\xce\xce\xcd\xcd\xcd\xcd\xcd\xce\xce\xce\xcd\xcd\xcd\xcd\xce\xcd\xcd\xcd\xce\xce\xce\xce\xce\xcd\xce\xcd\xcd'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
"'''''''''''''''''''''''''''''''''''''''''''''''\x0f\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
'\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
"'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15"
"'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15'\x15\x15\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xa9\xa9\xa9\xa9\x7f\xa9\xa9"
'\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f                '
'                                      \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x1a\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                       \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f       \x0f       \x0f       \x0f       \x0f'
'       \x0f       \x0f       \x0f       \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xa9\xa9\x99\x96\x99\x96\xa9\xa9\xa9\x99\x96\xa9\x99\x96\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\x8c\x0f\x0f\x0f\x0f\x99\x96\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\x0f\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd'
'\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd'
'\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd'
'\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd'
'\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\x0f\x0f\x0f\x0f'
'\xe1\xab\xab\xab\xdd\x1b!t\xb3\x94\xb3\x94\xb3\x94\xb3\x94\xb3\x94\xdd\xdd\xb3\x94\xb3\x94\xb3\x94\xb3\x94\x8d\xb2\x93\x93\xddtttttttttgjkhii\x8d\x1b\x1b\x1b\x1b\x1b\xdd\xddttt\x1b!\xab\xdd\xdb'
'\x0f!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0fff\xbf\xbf\x1b\x1b!\x8d!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\xab\x1b\x1b\x1b!'
'\x0f\x0f\x0f\x0f\x0f!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f\x0f\x0f!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!\x0f\xd7\xd7||||\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f!!!!!!!!!!!!!!!!'
'\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xdd\xdd\x0f||||||||||\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7'
'\xd7\xd7\xd7\xd7\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xdd\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xdd\xdd\xdd\xd7'
'||||||||||\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81'
'\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xdd\xdd\xdd\xdd\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\x0f'
'\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7'
'\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xdd\xdd\xdd\xdd\xd7\xd7\xd7\xd7\xd7'
'\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7'
'\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xdd\xdd\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xdd'
'!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'"!!"!!!"!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!"!!!!!!!"!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"'
'"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!"!"!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!"!"""!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!""""!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!"!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!""'
'!!!!!!!!!!!!"""!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!"!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!"!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'!!!!!!!!!!!!!!!!!!!!!\x1b!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!\x0f\x0f\x0f\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd'
'\xdd\xdd\xdd\xdd\xdd\xdd\xdd\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'  ,   <    9                       ))99)\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f\x0f\x0f\x0f!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x15\x15\x15\x15\x15\x15\x15\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x15\x15\x15\x15\x15\x0f\x0f\x0f\x0f\x0f#M##########\xc2#############\x0f#####\x0f#\x0f'
'##\x0f##\x0f##########\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\xaf\x90'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x0f\x0f\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\xb4\xdb\x0f\x0f'
'////////////////\xab\xab\xab\xab\xab\xab\xab\xb2\x93\xab\x0f\x0f\x0f\x0f\x0f\x0feeee\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xab\x8d\x8d\x87\x87\xb2\x93\xb2\x93\xb2\x93\xb2\x93\xb2\x93\xb2'
'\x93\xb2\x93\xb2\x93\xab\xab\xb2\x93\xab\xab\xab\xab\x87\x87\x87\x9f\xab\x9f\x0f\xab\x9f\xab\xab\x8d\xb2\x93\xb2\x93\xb2\x93\xa4\xab\xab\xc4\x8a\xd1\xd1\xd1\x0f\xab\xba\xa4\xab\x0f\x0f\x0f\x0f\x1e\x1e\x1e\x1e\x1e\x0f\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e'
'\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x1e\x0f\x0f\x06'
'\x0f\xa7\xa7\xa1\xb6\xa1\xa7\xa7\xad\x8e\xa7\xc1\x9c\x88\x9c\x9cmmmmmmmmmm\x9c\xa7\xcb\xca\xcb\xa7\xa7&&&&&&&&&&&&&&&&&&&&&&&&&&\xad\xa7\x8e\xbc\x84'
'\xbc\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\xad\xca\x8e\xca\xad\x8e\xa8\xae\x8f\xa8\xa8\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x19\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f'
'\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x19\x19\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x1f\x0f'
'\x0f\x0f\x1f\x1f\x1f\x1f\x1f\x1f\x0f\x0f\x1f\x1f\x1f\x1f\x1f\x1f\x0f\x0f\x1f\x1f\x1f\x1f\x1f\x1f\x0f\x0f\x1f\x1f\x1f\x0f\x0f\x0f\xb6\xb6\xca\xbc\xd9\xb6\xb6\x0f\xda\xcc\xcc\xcc\xcc\xda\xda\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\n\n\n\xdb\xd8\x0f\x0f'
'            \x0f                          \x0f                   \x0f  \x0f '
'              \x0f\x0f              \x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                                                                '
'                                                           \x0f\x0f\x0f\x0f\x0f'
'\xa5\xa9\xd6\x0f\x0f\x0f\x0fzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz\x0f\x0f\x0f\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'uuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu\x7f\x7f\x7f\x7f\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x7f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                               \x0fzzzz\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f                '
'          s\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'                              \x0f\xa5                                '
'    \x0f\x0f\x0f\x0f        \xd6uuuuu\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
"''''''''''''''''''''''''''''''''''''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
'\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15                                                '
'                              \x0f\x0fpppppppppp\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'######\x0f\x0f#\x0f############################################\x0f##\x0f\x0f\x0f#\x0f\x0f#'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'#999\x0f99\x0f\x0f\x0f\x0f\x0f9b9e####\x0f###\x0f###########################\x0f\x0f\x0f\x0fe:b\x0f\x0f\x0f\x0f<'
'\x83\x83\x83\x83\x82\x82\x82\x82\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\xac\xac\xac\xac\xac\xac\xac\xac\xac\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\x0f\x0f\x0f\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6**:::\xd6\xd6\xd6+*****\x06\x06\x06\x06\x06\x06\x06\x06bbbbb'
'bbb\xd6\xd6eeeeebb\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6eeee\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6'
'\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'\xdb\xdbeee\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb'
'\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
"''''''''''''''''''''''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''''''''''''"
"''''''''''''''\x15\x15\x15\x15\x15\x15\x15\x0f\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''''''''''''''''''''''''"
"''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15'\x0f''\x0f\x0f'\x0f\x0f''\x0f\x0f''''\x0f''''''''\x15\x15\x15\x15\x0f\x15\x0f\x15\x15\x15"
"\x15\x15\x15\x15\x0f\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''''''''''''''''''''''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
"\x15\x15\x15\x15''\x0f''''\x0f\x0f''''''''\x0f'''''''\x0f\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''\x0f''''\x0f"
"'''''\x0f'\x0f\x0f\x0f'''''''\x0f\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''''''''''''''''''''"
"''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''''''''''''''''''''''''''\x15\x15\x15\x15\x15\x15"
"\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''''''''''''''''''''''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
"\x15\x15\x15\x15\x15\x15\x15\x15''''''''''''''''''''''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''''"
"''''''''''''''''''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15''''''''''''''''"
"''''''''''\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x0f\x0f''''''''''''''''''''''''"
"'\xc7\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\xc7\x15\x15\x15\x15\x15\x15'''''''''''''''''''''''''\xc7\x15\x15\x15\x15"
"\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\xc7\x15\x15\x15\x15\x15\x15'''''''''''''''''''''''''\xc7\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
"\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\xc7\x15\x15\x15\x15\x15\x15'''''''''''''''''''''''''\xc7\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
"\x15\x15\x15\x15\x15\x15\x15\x15\x15\xc7\x15\x15\x15\x15\x15\x15'''''''''''''''''''''''''\xc7\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15"
'\x15\x15\x15\xc7\x15\x15\x15\x15\x15\x15\x0f\x0f\x0f\x0fnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn'
'!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!"!!!!!!!!"!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!"!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
'!!!!!!!!!!!!!!!!!!!!!!!\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x0f\x0f'
'\x0f\x06\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06'
'\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'////////////////////////////////////////////////////////////////'
'////////////////////////////////////////////////////////////////'
'////////////////////////////////////////////////////////////////'
'////////////////////////////////////////////////\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x0f\x0f'
)

def _get_record(code):
    return _db_records[ord(_db_pages[(ord(_db_pgtbl[code >> 8]) << 8) + (code & 255)])]

def category(code): return _get_record(code)[0]
def bidirectional(code): return _get_record(code)[1]
def east_asian_width(code): return _get_record(code)[2]
def isspace(code): return _get_record(code)[3] & 1 != 0
def isalpha(code): return _get_record(code)[3] & 2 != 0
def islinebreak(code): return _get_record(code)[3] & 4 != 0
def isnumeric(code): return _get_record(code)[3] & 64 != 0
def isdigit(code): return _get_record(code)[3] & 128 != 0
def isdecimal(code): return _get_record(code)[3] & 256 != 0
def isalnum(code): return _get_record(code)[3] & 66 != 0
def isupper(code): return _get_record(code)[3] & 8 != 0
def istitle(code): return _get_record(code)[3] & 16 != 0
def islower(code): return _get_record(code)[3] & 32 != 0
def iscased(code): return _get_record(code)[3] & 56 != 0
def mirrored(code): return _get_record(code)[3] & 512 != 0
def combining(code): return _get_record(code)[4]
_decimal = {
48: 0,
49: 1,
50: 2,
51: 3,
52: 4,
53: 5,
54: 6,
55: 7,
56: 8,
57: 9,
1632: 0,
1633: 1,
1634: 2,
1635: 3,
1636: 4,
1637: 5,
1638: 6,
1639: 7,
1640: 8,
1641: 9,
1776: 0,
1777: 1,
1778: 2,
1779: 3,
1780: 4,
1781: 5,
1782: 6,
1783: 7,
1784: 8,
1785: 9,
2406: 0,
2407: 1,
2408: 2,
2409: 3,
2410: 4,
2411: 5,
2412: 6,
2413: 7,
2414: 8,
2415: 9,
2534: 0,
2535: 1,
2536: 2,
2537: 3,
2538: 4,
2539: 5,
2540: 6,
2541: 7,
2542: 8,
2543: 9,
2662: 0,
2663: 1,
2664: 2,
2665: 3,
2666: 4,
2667: 5,
2668: 6,
2669: 7,
2670: 8,
2671: 9,
2790: 0,
2791: 1,
2792: 2,
2793: 3,
2794: 4,
2795: 5,
2796: 6,
2797: 7,
2798: 8,
2799: 9,
2918: 0,
2919: 1,
2920: 2,
2921: 3,
2922: 4,
2923: 5,
2924: 6,
2925: 7,
2926: 8,
2927: 9,
3046: 0,
3047: 1,
3048: 2,
3049: 3,
3050: 4,
3051: 5,
3052: 6,
3053: 7,
3054: 8,
3055: 9,
3174: 0,
3175: 1,
3176: 2,
3177: 3,
3178: 4,
3179: 5,
3180: 6,
3181: 7,
3182: 8,
3183: 9,
3302: 0,
3303: 1,
3304: 2,
3305: 3,
3306: 4,
3307: 5,
3308: 6,
3309: 7,
3310: 8,
3311: 9,
3430: 0,
3431: 1,
3432: 2,
3433: 3,
3434: 4,
3435: 5,
3436: 6,
3437: 7,
3438: 8,
3439: 9,
3664: 0,
3665: 1,
3666: 2,
3667: 3,
3668: 4,
3669: 5,
3670: 6,
3671: 7,
3672: 8,
3673: 9,
3792: 0,
3793: 1,
3794: 2,
3795: 3,
3796: 4,
3797: 5,
3798: 6,
3799: 7,
3800: 8,
3801: 9,
3872: 0,
3873: 1,
3874: 2,
3875: 3,
3876: 4,
3877: 5,
3878: 6,
3879: 7,
3880: 8,
3881: 9,
4160: 0,
4161: 1,
4162: 2,
4163: 3,
4164: 4,
4165: 5,
4166: 6,
4167: 7,
4168: 8,
4169: 9,
6112: 0,
6113: 1,
6114: 2,
6115: 3,
6116: 4,
6117: 5,
6118: 6,
6119: 7,
6120: 8,
6121: 9,
6160: 0,
6161: 1,
6162: 2,
6163: 3,
6164: 4,
6165: 5,
6166: 6,
6167: 7,
6168: 8,
6169: 9,
6470: 0,
6471: 1,
6472: 2,
6473: 3,
6474: 4,
6475: 5,
6476: 6,
6477: 7,
6478: 8,
6479: 9,
6608: 0,
6609: 1,
6610: 2,
6611: 3,
6612: 4,
6613: 5,
6614: 6,
6615: 7,
6616: 8,
6617: 9,
65296: 0,
65297: 1,
65298: 2,
65299: 3,
65300: 4,
65301: 5,
65302: 6,
65303: 7,
65304: 8,
65305: 9,
66720: 0,
66721: 1,
66722: 2,
66723: 3,
66724: 4,
66725: 5,
66726: 6,
66727: 7,
66728: 8,
66729: 9,
120782: 0,
120783: 1,
120784: 2,
120785: 3,
120786: 4,
120787: 5,
120788: 6,
120789: 7,
120790: 8,
120791: 9,
120792: 0,
120793: 1,
120794: 2,
120795: 3,
120796: 4,
120797: 5,
120798: 6,
120799: 7,
120800: 8,
120801: 9,
120802: 0,
120803: 1,
120804: 2,
120805: 3,
120806: 4,
120807: 5,
120808: 6,
120809: 7,
120810: 8,
120811: 9,
120812: 0,
120813: 1,
120814: 2,
120815: 3,
120816: 4,
120817: 5,
120818: 6,
120819: 7,
120820: 8,
120821: 9,
120822: 0,
120823: 1,
120824: 2,
120825: 3,
120826: 4,
120827: 5,
120828: 6,
120829: 7,
120830: 8,
120831: 9,
}

_decimal_corrected = {
}
_digit = {
48: 0,
49: 1,
50: 2,
51: 3,
52: 4,
53: 5,
54: 6,
55: 7,
56: 8,
57: 9,
178: 2,
179: 3,
185: 1,
1632: 0,
1633: 1,
1634: 2,
1635: 3,
1636: 4,
1637: 5,
1638: 6,
1639: 7,
1640: 8,
1641: 9,
1776: 0,
1777: 1,
1778: 2,
1779: 3,
1780: 4,
1781: 5,
1782: 6,
1783: 7,
1784: 8,
1785: 9,
2406: 0,
2407: 1,
2408: 2,
2409: 3,
2410: 4,
2411: 5,
2412: 6,
2413: 7,
2414: 8,
2415: 9,
2534: 0,
2535: 1,
2536: 2,
2537: 3,
2538: 4,
2539: 5,
2540: 6,
2541: 7,
2542: 8,
2543: 9,
2662: 0,
2663: 1,
2664: 2,
2665: 3,
2666: 4,
2667: 5,
2668: 6,
2669: 7,
2670: 8,
2671: 9,
2790: 0,
2791: 1,
2792: 2,
2793: 3,
2794: 4,
2795: 5,
2796: 6,
2797: 7,
2798: 8,
2799: 9,
2918: 0,
2919: 1,
2920: 2,
2921: 3,
2922: 4,
2923: 5,
2924: 6,
2925: 7,
2926: 8,
2927: 9,
3046: 0,
3047: 1,
3048: 2,
3049: 3,
3050: 4,
3051: 5,
3052: 6,
3053: 7,
3054: 8,
3055: 9,
3174: 0,
3175: 1,
3176: 2,
3177: 3,
3178: 4,
3179: 5,
3180: 6,
3181: 7,
3182: 8,
3183: 9,
3302: 0,
3303: 1,
3304: 2,
3305: 3,
3306: 4,
3307: 5,
3308: 6,
3309: 7,
3310: 8,
3311: 9,
3430: 0,
3431: 1,
3432: 2,
3433: 3,
3434: 4,
3435: 5,
3436: 6,
3437: 7,
3438: 8,
3439: 9,
3664: 0,
3665: 1,
3666: 2,
3667: 3,
3668: 4,
3669: 5,
3670: 6,
3671: 7,
3672: 8,
3673: 9,
3792: 0,
3793: 1,
3794: 2,
3795: 3,
3796: 4,
3797: 5,
3798: 6,
3799: 7,
3800: 8,
3801: 9,
3872: 0,
3873: 1,
3874: 2,
3875: 3,
3876: 4,
3877: 5,
3878: 6,
3879: 7,
3880: 8,
3881: 9,
4160: 0,
4161: 1,
4162: 2,
4163: 3,
4164: 4,
4165: 5,
4166: 6,
4167: 7,
4168: 8,
4169: 9,
4969: 1,
4970: 2,
4971: 3,
4972: 4,
4973: 5,
4974: 6,
4975: 7,
4976: 8,
4977: 9,
6112: 0,
6113: 1,
6114: 2,
6115: 3,
6116: 4,
6117: 5,
6118: 6,
6119: 7,
6120: 8,
6121: 9,
6160: 0,
6161: 1,
6162: 2,
6163: 3,
6164: 4,
6165: 5,
6166: 6,
6167: 7,
6168: 8,
6169: 9,
6470: 0,
6471: 1,
6472: 2,
6473: 3,
6474: 4,
6475: 5,
6476: 6,
6477: 7,
6478: 8,
6479: 9,
6608: 0,
6609: 1,
6610: 2,
6611: 3,
6612: 4,
6613: 5,
6614: 6,
6615: 7,
6616: 8,
6617: 9,
8304: 0,
8308: 4,
8309: 5,
8310: 6,
8311: 7,
8312: 8,
8313: 9,
8320: 0,
8321: 1,
8322: 2,
8323: 3,
8324: 4,
8325: 5,
8326: 6,
8327: 7,
8328: 8,
8329: 9,
9312: 1,
9313: 2,
9314: 3,
9315: 4,
9316: 5,
9317: 6,
9318: 7,
9319: 8,
9320: 9,
9332: 1,
9333: 2,
9334: 3,
9335: 4,
9336: 5,
9337: 6,
9338: 7,
9339: 8,
9340: 9,
9352: 1,
9353: 2,
9354: 3,
9355: 4,
9356: 5,
9357: 6,
9358: 7,
9359: 8,
9360: 9,
9450: 0,
9461: 1,
9462: 2,
9463: 3,
9464: 4,
9465: 5,
9466: 6,
9467: 7,
9468: 8,
9469: 9,
9471: 0,
10102: 1,
10103: 2,
10104: 3,
10105: 4,
10106: 5,
10107: 6,
10108: 7,
10109: 8,
10110: 9,
10112: 1,
10113: 2,
10114: 3,
10115: 4,
10116: 5,
10117: 6,
10118: 7,
10119: 8,
10120: 9,
10122: 1,
10123: 2,
10124: 3,
10125: 4,
10126: 5,
10127: 6,
10128: 7,
10129: 8,
10130: 9,
65296: 0,
65297: 1,
65298: 2,
65299: 3,
65300: 4,
65301: 5,
65302: 6,
65303: 7,
65304: 8,
65305: 9,
66720: 0,
66721: 1,
66722: 2,
66723: 3,
66724: 4,
66725: 5,
66726: 6,
66727: 7,
66728: 8,
66729: 9,
68160: 1,
68161: 2,
68162: 3,
68163: 4,
120782: 0,
120783: 1,
120784: 2,
120785: 3,
120786: 4,
120787: 5,
120788: 6,
120789: 7,
120790: 8,
120791: 9,
120792: 0,
120793: 1,
120794: 2,
120795: 3,
120796: 4,
120797: 5,
120798: 6,
120799: 7,
120800: 8,
120801: 9,
120802: 0,
120803: 1,
120804: 2,
120805: 3,
120806: 4,
120807: 5,
120808: 6,
120809: 7,
120810: 8,
120811: 9,
120812: 0,
120813: 1,
120814: 2,
120815: 3,
120816: 4,
120817: 5,
120818: 6,
120819: 7,
120820: 8,
120821: 9,
120822: 0,
120823: 1,
120824: 2,
120825: 3,
120826: 4,
120827: 5,
120828: 6,
120829: 7,
120830: 8,
120831: 9,
}

_digit_corrected = {
}
_numeric = {
48: 0.0,
49: 1.0,
50: 2.0,
51: 3.0,
52: 4.0,
53: 5.0,
54: 6.0,
55: 7.0,
56: 8.0,
57: 9.0,
178: 2.0,
179: 3.0,
185: 1.0,
188: 1.0 / 4.0,
189: 1.0 / 2.0,
190: 3.0 / 4.0,
1632: 0.0,
1633: 1.0,
1634: 2.0,
1635: 3.0,
1636: 4.0,
1637: 5.0,
1638: 6.0,
1639: 7.0,
1640: 8.0,
1641: 9.0,
1776: 0.0,
1777: 1.0,
1778: 2.0,
1779: 3.0,
1780: 4.0,
1781: 5.0,
1782: 6.0,
1783: 7.0,
1784: 8.0,
1785: 9.0,
2406: 0.0,
2407: 1.0,
2408: 2.0,
2409: 3.0,
2410: 4.0,
2411: 5.0,
2412: 6.0,
2413: 7.0,
2414: 8.0,
2415: 9.0,
2534: 0.0,
2535: 1.0,
2536: 2.0,
2537: 3.0,
2538: 4.0,
2539: 5.0,
2540: 6.0,
2541: 7.0,
2542: 8.0,
2543: 9.0,
2548: 1.0,
2549: 2.0,
2550: 3.0,
2551: 4.0,
2553: 16.0,
2662: 0.0,
2663: 1.0,
2664: 2.0,
2665: 3.0,
2666: 4.0,
2667: 5.0,
2668: 6.0,
2669: 7.0,
2670: 8.0,
2671: 9.0,
2790: 0.0,
2791: 1.0,
2792: 2.0,
2793: 3.0,
2794: 4.0,
2795: 5.0,
2796: 6.0,
2797: 7.0,
2798: 8.0,
2799: 9.0,
2918: 0.0,
2919: 1.0,
2920: 2.0,
2921: 3.0,
2922: 4.0,
2923: 5.0,
2924: 6.0,
2925: 7.0,
2926: 8.0,
2927: 9.0,
3046: 0.0,
3047: 1.0,
3048: 2.0,
3049: 3.0,
3050: 4.0,
3051: 5.0,
3052: 6.0,
3053: 7.0,
3054: 8.0,
3055: 9.0,
3056: 10.0,
3057: 100.0,
3058: 1000.0,
3174: 0.0,
3175: 1.0,
3176: 2.0,
3177: 3.0,
3178: 4.0,
3179: 5.0,
3180: 6.0,
3181: 7.0,
3182: 8.0,
3183: 9.0,
3302: 0.0,
3303: 1.0,
3304: 2.0,
3305: 3.0,
3306: 4.0,
3307: 5.0,
3308: 6.0,
3309: 7.0,
3310: 8.0,
3311: 9.0,
3430: 0.0,
3431: 1.0,
3432: 2.0,
3433: 3.0,
3434: 4.0,
3435: 5.0,
3436: 6.0,
3437: 7.0,
3438: 8.0,
3439: 9.0,
3664: 0.0,
3665: 1.0,
3666: 2.0,
3667: 3.0,
3668: 4.0,
3669: 5.0,
3670: 6.0,
3671: 7.0,
3672: 8.0,
3673: 9.0,
3792: 0.0,
3793: 1.0,
3794: 2.0,
3795: 3.0,
3796: 4.0,
3797: 5.0,
3798: 6.0,
3799: 7.0,
3800: 8.0,
3801: 9.0,
3872: 0.0,
3873: 1.0,
3874: 2.0,
3875: 3.0,
3876: 4.0,
3877: 5.0,
3878: 6.0,
3879: 7.0,
3880: 8.0,
3881: 9.0,
3882: 1.0 / 2.0,
3883: 3.0 / 2.0,
3884: 5.0 / 2.0,
3885: 7.0 / 2.0,
3886: 9.0 / 2.0,
3887: 11.0 / 2.0,
3888: 13.0 / 2.0,
3889: 15.0 / 2.0,
3890: 17.0 / 2.0,
3891: -1.0 / 2.0,
4160: 0.0,
4161: 1.0,
4162: 2.0,
4163: 3.0,
4164: 4.0,
4165: 5.0,
4166: 6.0,
4167: 7.0,
4168: 8.0,
4169: 9.0,
4969: 1.0,
4970: 2.0,
4971: 3.0,
4972: 4.0,
4973: 5.0,
4974: 6.0,
4975: 7.0,
4976: 8.0,
4977: 9.0,
4978: 10.0,
4979: 20.0,
4980: 30.0,
4981: 40.0,
4982: 50.0,
4983: 60.0,
4984: 70.0,
4985: 80.0,
4986: 90.0,
4987: 100.0,
4988: 10000.0,
5870: 17.0,
5871: 18.0,
5872: 19.0,
6112: 0.0,
6113: 1.0,
6114: 2.0,
6115: 3.0,
6116: 4.0,
6117: 5.0,
6118: 6.0,
6119: 7.0,
6120: 8.0,
6121: 9.0,
6128: 0.0,
6129: 1.0,
6130: 2.0,
6131: 3.0,
6132: 4.0,
6133: 5.0,
6134: 6.0,
6135: 7.0,
6136: 8.0,
6137: 9.0,
6160: 0.0,
6161: 1.0,
6162: 2.0,
6163: 3.0,
6164: 4.0,
6165: 5.0,
6166: 6.0,
6167: 7.0,
6168: 8.0,
6169: 9.0,
6470: 0.0,
6471: 1.0,
6472: 2.0,
6473: 3.0,
6474: 4.0,
6475: 5.0,
6476: 6.0,
6477: 7.0,
6478: 8.0,
6479: 9.0,
6608: 0.0,
6609: 1.0,
6610: 2.0,
6611: 3.0,
6612: 4.0,
6613: 5.0,
6614: 6.0,
6615: 7.0,
6616: 8.0,
6617: 9.0,
8304: 0.0,
8308: 4.0,
8309: 5.0,
8310: 6.0,
8311: 7.0,
8312: 8.0,
8313: 9.0,
8320: 0.0,
8321: 1.0,
8322: 2.0,
8323: 3.0,
8324: 4.0,
8325: 5.0,
8326: 6.0,
8327: 7.0,
8328: 8.0,
8329: 9.0,
8531: 1.0 / 3.0,
8532: 2.0 / 3.0,
8533: 1.0 / 5.0,
8534: 2.0 / 5.0,
8535: 3.0 / 5.0,
8536: 4.0 / 5.0,
8537: 1.0 / 6.0,
8538: 5.0 / 6.0,
8539: 1.0 / 8.0,
8540: 3.0 / 8.0,
8541: 5.0 / 8.0,
8542: 7.0 / 8.0,
8543: 1.0,
8544: 1.0,
8545: 2.0,
8546: 3.0,
8547: 4.0,
8548: 5.0,
8549: 6.0,
8550: 7.0,
8551: 8.0,
8552: 9.0,
8553: 10.0,
8554: 11.0,
8555: 12.0,
8556: 50.0,
8557: 100.0,
8558: 500.0,
8559: 1000.0,
8560: 1.0,
8561: 2.0,
8562: 3.0,
8563: 4.0,
8564: 5.0,
8565: 6.0,
8566: 7.0,
8567: 8.0,
8568: 9.0,
8569: 10.0,
8570: 11.0,
8571: 12.0,
8572: 50.0,
8573: 100.0,
8574: 500.0,
8575: 1000.0,
8576: 1000.0,
8577: 5000.0,
8578: 10000.0,
9312: 1.0,
9313: 2.0,
9314: 3.0,
9315: 4.0,
9316: 5.0,
9317: 6.0,
9318: 7.0,
9319: 8.0,
9320: 9.0,
9321: 10.0,
9322: 11.0,
9323: 12.0,
9324: 13.0,
9325: 14.0,
9326: 15.0,
9327: 16.0,
9328: 17.0,
9329: 18.0,
9330: 19.0,
9331: 20.0,
9332: 1.0,
9333: 2.0,
9334: 3.0,
9335: 4.0,
9336: 5.0,
9337: 6.0,
9338: 7.0,
9339: 8.0,
9340: 9.0,
9341: 10.0,
9342: 11.0,
9343: 12.0,
9344: 13.0,
9345: 14.0,
9346: 15.0,
9347: 16.0,
9348: 17.0,
9349: 18.0,
9350: 19.0,
9351: 20.0,
9352: 1.0,
9353: 2.0,
9354: 3.0,
9355: 4.0,
9356: 5.0,
9357: 6.0,
9358: 7.0,
9359: 8.0,
9360: 9.0,
9361: 10.0,
9362: 11.0,
9363: 12.0,
9364: 13.0,
9365: 14.0,
9366: 15.0,
9367: 16.0,
9368: 17.0,
9369: 18.0,
9370: 19.0,
9371: 20.0,
9450: 0.0,
9451: 11.0,
9452: 12.0,
9453: 13.0,
9454: 14.0,
9455: 15.0,
9456: 16.0,
9457: 17.0,
9458: 18.0,
9459: 19.0,
9460: 20.0,
9461: 1.0,
9462: 2.0,
9463: 3.0,
9464: 4.0,
9465: 5.0,
9466: 6.0,
9467: 7.0,
9468: 8.0,
9469: 9.0,
9470: 10.0,
9471: 0.0,
10102: 1.0,
10103: 2.0,
10104: 3.0,
10105: 4.0,
10106: 5.0,
10107: 6.0,
10108: 7.0,
10109: 8.0,
10110: 9.0,
10111: 10.0,
10112: 1.0,
10113: 2.0,
10114: 3.0,
10115: 4.0,
10116: 5.0,
10117: 6.0,
10118: 7.0,
10119: 8.0,
10120: 9.0,
10121: 10.0,
10122: 1.0,
10123: 2.0,
10124: 3.0,
10125: 4.0,
10126: 5.0,
10127: 6.0,
10128: 7.0,
10129: 8.0,
10130: 9.0,
10131: 10.0,
11517: 1.0 / 2.0,
12295: 0.0,
12321: 1.0,
12322: 2.0,
12323: 3.0,
12324: 4.0,
12325: 5.0,
12326: 6.0,
12327: 7.0,
12328: 8.0,
12329: 9.0,
12344: 10.0,
12345: 20.0,
12346: 30.0,
12690: 1.0,
12691: 2.0,
12692: 3.0,
12693: 4.0,
12832: 1.0,
12833: 2.0,
12834: 3.0,
12835: 4.0,
12836: 5.0,
12837: 6.0,
12838: 7.0,
12839: 8.0,
12840: 9.0,
12841: 10.0,
12881: 21.0,
12882: 22.0,
12883: 23.0,
12884: 24.0,
12885: 25.0,
12886: 26.0,
12887: 27.0,
12888: 28.0,
12889: 29.0,
12890: 30.0,
12891: 31.0,
12892: 32.0,
12893: 33.0,
12894: 34.0,
12895: 35.0,
12928: 1.0,
12929: 2.0,
12930: 3.0,
12931: 4.0,
12932: 5.0,
12933: 6.0,
12934: 7.0,
12935: 8.0,
12936: 9.0,
12937: 10.0,
12977: 36.0,
12978: 37.0,
12979: 38.0,
12980: 39.0,
12981: 40.0,
12982: 41.0,
12983: 42.0,
12984: 43.0,
12985: 44.0,
12986: 45.0,
12987: 46.0,
12988: 47.0,
12989: 48.0,
12990: 49.0,
12991: 50.0,
13317: 5.0,
13443: 2.0,
14378: 5.0,
15181: 7.0,
19968: 1.0,
19971: 7.0,
19975: 10000.0,
19977: 3.0,
20061: 9.0,
20108: 2.0,
20116: 5.0,
20118: 4.0,
20159: 100000000.0,
20160: 10.0,
20191: 1000.0,
20200: 3.0,
20237: 5.0,
20336: 100.0,
20740: 100000000.0,
20806: 1000000000000.0,
20841: 2.0,
20843: 8.0,
20845: 6.0,
21313: 10.0,
21315: 1000.0,
21316: 20.0,
21317: 30.0,
21324: 40.0,
21441: 3.0,
21442: 3.0,
21443: 3.0,
21444: 3.0,
22235: 4.0,
22769: 1.0,
22777: 1.0,
24186: 1.0,
24318: 9.0,
24319: 20.0,
24332: 1.0,
24333: 2.0,
24334: 3.0,
24336: 2.0,
25342: 10.0,
25420: 8.0,
26578: 7.0,
29590: 9.0,
30334: 100.0,
32902: 4.0,
33836: 10000.0,
36014: 2.0,
36019: 2.0,
36144: 2.0,
38470: 6.0,
38476: 100.0,
38520: 6.0,
38646: 0.0,
65296: 0.0,
65297: 1.0,
65298: 2.0,
65299: 3.0,
65300: 4.0,
65301: 5.0,
65302: 6.0,
65303: 7.0,
65304: 8.0,
65305: 9.0,
65799: 1.0,
65800: 2.0,
65801: 3.0,
65802: 4.0,
65803: 5.0,
65804: 6.0,
65805: 7.0,
65806: 8.0,
65807: 9.0,
65808: 10.0,
65809: 20.0,
65810: 30.0,
65811: 40.0,
65812: 50.0,
65813: 60.0,
65814: 70.0,
65815: 80.0,
65816: 90.0,
65817: 100.0,
65818: 200.0,
65819: 300.0,
65820: 400.0,
65821: 500.0,
65822: 600.0,
65823: 700.0,
65824: 800.0,
65825: 900.0,
65826: 1000.0,
65827: 2000.0,
65828: 3000.0,
65829: 4000.0,
65830: 5000.0,
65831: 6000.0,
65832: 7000.0,
65833: 8000.0,
65834: 9000.0,
65835: 10000.0,
65836: 20000.0,
65837: 30000.0,
65838: 40000.0,
65839: 50000.0,
65840: 60000.0,
65841: 70000.0,
65842: 80000.0,
65843: 90000.0,
65856: 1.0 / 4.0,
65857: 1.0 / 2.0,
65858: 1.0,
65859: 5.0,
65860: 50.0,
65861: 500.0,
65862: 5000.0,
65863: 50000.0,
65864: 5.0,
65865: 10.0,
65866: 50.0,
65867: 100.0,
65868: 500.0,
65869: 1000.0,
65870: 5000.0,
65871: 5.0,
65872: 10.0,
65873: 50.0,
65874: 100.0,
65875: 500.0,
65876: 1000.0,
65877: 10000.0,
65878: 50000.0,
65879: 10.0,
65880: 1.0,
65881: 1.0,
65882: 1.0,
65883: 2.0,
65884: 2.0,
65885: 2.0,
65886: 2.0,
65887: 5.0,
65888: 10.0,
65889: 10.0,
65890: 10.0,
65891: 10.0,
65892: 10.0,
65893: 30.0,
65894: 50.0,
65895: 50.0,
65896: 50.0,
65897: 50.0,
65898: 100.0,
65899: 300.0,
65900: 500.0,
65901: 500.0,
65902: 500.0,
65903: 500.0,
65904: 500.0,
65905: 1000.0,
65906: 5000.0,
65907: 5.0,
65908: 50.0,
65909: 1.0 / 2.0,
65910: 1.0 / 2.0,
65911: 2.0 / 3.0,
65912: 3.0 / 4.0,
65930: 0.0,
66336: 1.0,
66337: 5.0,
66338: 10.0,
66339: 50.0,
66378: 900.0,
66513: 1.0,
66514: 2.0,
66515: 10.0,
66516: 20.0,
66517: 100.0,
66720: 0.0,
66721: 1.0,
66722: 2.0,
66723: 3.0,
66724: 4.0,
66725: 5.0,
66726: 6.0,
66727: 7.0,
66728: 8.0,
66729: 9.0,
68160: 1.0,
68161: 2.0,
68162: 3.0,
68163: 4.0,
68164: 10.0,
68165: 20.0,
68166: 100.0,
68167: 1000.0,
120782: 0.0,
120783: 1.0,
120784: 2.0,
120785: 3.0,
120786: 4.0,
120787: 5.0,
120788: 6.0,
120789: 7.0,
120790: 8.0,
120791: 9.0,
120792: 0.0,
120793: 1.0,
120794: 2.0,
120795: 3.0,
120796: 4.0,
120797: 5.0,
120798: 6.0,
120799: 7.0,
120800: 8.0,
120801: 9.0,
120802: 0.0,
120803: 1.0,
120804: 2.0,
120805: 3.0,
120806: 4.0,
120807: 5.0,
120808: 6.0,
120809: 7.0,
120810: 8.0,
120811: 9.0,
120812: 0.0,
120813: 1.0,
120814: 2.0,
120815: 3.0,
120816: 4.0,
120817: 5.0,
120818: 6.0,
120819: 7.0,
120820: 8.0,
120821: 9.0,
120822: 0.0,
120823: 1.0,
120824: 2.0,
120825: 3.0,
120826: 4.0,
120827: 5.0,
120828: 6.0,
120829: 7.0,
120830: 8.0,
120831: 9.0,
131073: 7.0,
131172: 4.0,
131298: 4.0,
131361: 5.0,
133418: 1.0,
133507: 30.0,
133516: 40.0,
133532: 40.0,
133866: 6.0,
133885: 3.0,
133913: 3.0,
140176: 2.0,
141720: 3.0,
146203: 3.0,
156269: 4.0,
}

_numeric_corrected = {
}

def decimal(code):
    try:
        return _decimal[code]
    except KeyError:
        if base_mod is not None and code not in _decimal_corrected:
            return base_mod._decimal[code]
        else:
            raise

def digit(code):
    try:
        return _digit[code]
    except KeyError:
        if base_mod is not None and code not in _digit_corrected:
            return base_mod._digit[code]
        else:
            raise

def numeric(code):
    try:
        return _numeric[code]
    except KeyError:
        if base_mod is not None and code not in _numeric_corrected:
            return base_mod._numeric[code]
        else:
            raise

_toupper = {
97: 65,
98: 66,
99: 67,
100: 68,
101: 69,
102: 70,
103: 71,
104: 72,
105: 73,
106: 74,
107: 75,
108: 76,
109: 77,
110: 78,
111: 79,
112: 80,
113: 81,
114: 82,
115: 83,
116: 84,
117: 85,
118: 86,
119: 87,
120: 88,
121: 89,
122: 90,
181: 924,
224: 192,
225: 193,
226: 194,
227: 195,
228: 196,
229: 197,
230: 198,
231: 199,
232: 200,
233: 201,
234: 202,
235: 203,
236: 204,
237: 205,
238: 206,
239: 207,
240: 208,
241: 209,
242: 210,
243: 211,
244: 212,
245: 213,
246: 214,
248: 216,
249: 217,
250: 218,
251: 219,
252: 220,
253: 221,
254: 222,
255: 376,
257: 256,
259: 258,
261: 260,
263: 262,
265: 264,
267: 266,
269: 268,
271: 270,
273: 272,
275: 274,
277: 276,
279: 278,
281: 280,
283: 282,
285: 284,
287: 286,
289: 288,
291: 290,
293: 292,
295: 294,
297: 296,
299: 298,
301: 300,
303: 302,
305: 73,
307: 306,
309: 308,
311: 310,
314: 313,
316: 315,
318: 317,
320: 319,
322: 321,
324: 323,
326: 325,
328: 327,
331: 330,
333: 332,
335: 334,
337: 336,
339: 338,
341: 340,
343: 342,
345: 344,
347: 346,
349: 348,
351: 350,
353: 352,
355: 354,
357: 356,
359: 358,
361: 360,
363: 362,
365: 364,
367: 366,
369: 368,
371: 370,
373: 372,
375: 374,
378: 377,
380: 379,
382: 381,
383: 83,
387: 386,
389: 388,
392: 391,
396: 395,
402: 401,
405: 502,
409: 408,
410: 573,
414: 544,
417: 416,
419: 418,
421: 420,
424: 423,
429: 428,
432: 431,
436: 435,
438: 437,
441: 440,
445: 444,
447: 503,
453: 452,
454: 452,
456: 455,
457: 455,
459: 458,
460: 458,
462: 461,
464: 463,
466: 465,
468: 467,
470: 469,
472: 471,
474: 473,
476: 475,
477: 398,
479: 478,
481: 480,
483: 482,
485: 484,
487: 486,
489: 488,
491: 490,
493: 492,
495: 494,
498: 497,
499: 497,
501: 500,
505: 504,
507: 506,
509: 508,
511: 510,
513: 512,
515: 514,
517: 516,
519: 518,
521: 520,
523: 522,
525: 524,
527: 526,
529: 528,
531: 530,
533: 532,
535: 534,
537: 536,
539: 538,
541: 540,
543: 542,
547: 546,
549: 548,
551: 550,
553: 552,
555: 554,
557: 556,
559: 558,
561: 560,
563: 562,
572: 571,
595: 385,
596: 390,
598: 393,
599: 394,
601: 399,
603: 400,
608: 403,
611: 404,
616: 407,
617: 406,
623: 412,
626: 413,
629: 415,
640: 422,
643: 425,
648: 430,
650: 433,
651: 434,
658: 439,
660: 577,
837: 921,
940: 902,
941: 904,
942: 905,
943: 906,
945: 913,
946: 914,
947: 915,
948: 916,
949: 917,
950: 918,
951: 919,
952: 920,
953: 921,
954: 922,
955: 923,
956: 924,
957: 925,
958: 926,
959: 927,
960: 928,
961: 929,
962: 931,
963: 931,
964: 932,
965: 933,
966: 934,
967: 935,
968: 936,
969: 937,
970: 938,
971: 939,
972: 908,
973: 910,
974: 911,
976: 914,
977: 920,
981: 934,
982: 928,
985: 984,
987: 986,
989: 988,
991: 990,
993: 992,
995: 994,
997: 996,
999: 998,
1001: 1000,
1003: 1002,
1005: 1004,
1007: 1006,
1008: 922,
1009: 929,
1010: 1017,
1013: 917,
1016: 1015,
1019: 1018,
1072: 1040,
1073: 1041,
1074: 1042,
1075: 1043,
1076: 1044,
1077: 1045,
1078: 1046,
1079: 1047,
1080: 1048,
1081: 1049,
1082: 1050,
1083: 1051,
1084: 1052,
1085: 1053,
1086: 1054,
1087: 1055,
1088: 1056,
1089: 1057,
1090: 1058,
1091: 1059,
1092: 1060,
1093: 1061,
1094: 1062,
1095: 1063,
1096: 1064,
1097: 1065,
1098: 1066,
1099: 1067,
1100: 1068,
1101: 1069,
1102: 1070,
1103: 1071,
1104: 1024,
1105: 1025,
1106: 1026,
1107: 1027,
1108: 1028,
1109: 1029,
1110: 1030,
1111: 1031,
1112: 1032,
1113: 1033,
1114: 1034,
1115: 1035,
1116: 1036,
1117: 1037,
1118: 1038,
1119: 1039,
1121: 1120,
1123: 1122,
1125: 1124,
1127: 1126,
1129: 1128,
1131: 1130,
1133: 1132,
1135: 1134,
1137: 1136,
1139: 1138,
1141: 1140,
1143: 1142,
1145: 1144,
1147: 1146,
1149: 1148,
1151: 1150,
1153: 1152,
1163: 1162,
1165: 1164,
1167: 1166,
1169: 1168,
1171: 1170,
1173: 1172,
1175: 1174,
1177: 1176,
1179: 1178,
1181: 1180,
1183: 1182,
1185: 1184,
1187: 1186,
1189: 1188,
1191: 1190,
1193: 1192,
1195: 1194,
1197: 1196,
1199: 1198,
1201: 1200,
1203: 1202,
1205: 1204,
1207: 1206,
1209: 1208,
1211: 1210,
1213: 1212,
1215: 1214,
1218: 1217,
1220: 1219,
1222: 1221,
1224: 1223,
1226: 1225,
1228: 1227,
1230: 1229,
1233: 1232,
1235: 1234,
1237: 1236,
1239: 1238,
1241: 1240,
1243: 1242,
1245: 1244,
1247: 1246,
1249: 1248,
1251: 1250,
1253: 1252,
1255: 1254,
1257: 1256,
1259: 1258,
1261: 1260,
1263: 1262,
1265: 1264,
1267: 1266,
1269: 1268,
1271: 1270,
1273: 1272,
1281: 1280,
1283: 1282,
1285: 1284,
1287: 1286,
1289: 1288,
1291: 1290,
1293: 1292,
1295: 1294,
1377: 1329,
1378: 1330,
1379: 1331,
1380: 1332,
1381: 1333,
1382: 1334,
1383: 1335,
1384: 1336,
1385: 1337,
1386: 1338,
1387: 1339,
1388: 1340,
1389: 1341,
1390: 1342,
1391: 1343,
1392: 1344,
1393: 1345,
1394: 1346,
1395: 1347,
1396: 1348,
1397: 1349,
1398: 1350,
1399: 1351,
1400: 1352,
1401: 1353,
1402: 1354,
1403: 1355,
1404: 1356,
1405: 1357,
1406: 1358,
1407: 1359,
1408: 1360,
1409: 1361,
1410: 1362,
1411: 1363,
1412: 1364,
1413: 1365,
1414: 1366,
7681: 7680,
7683: 7682,
7685: 7684,
7687: 7686,
7689: 7688,
7691: 7690,
7693: 7692,
7695: 7694,
7697: 7696,
7699: 7698,
7701: 7700,
7703: 7702,
7705: 7704,
7707: 7706,
7709: 7708,
7711: 7710,
7713: 7712,
7715: 7714,
7717: 7716,
7719: 7718,
7721: 7720,
7723: 7722,
7725: 7724,
7727: 7726,
7729: 7728,
7731: 7730,
7733: 7732,
7735: 7734,
7737: 7736,
7739: 7738,
7741: 7740,
7743: 7742,
7745: 7744,
7747: 7746,
7749: 7748,
7751: 7750,
7753: 7752,
7755: 7754,
7757: 7756,
7759: 7758,
7761: 7760,
7763: 7762,
7765: 7764,
7767: 7766,
7769: 7768,
7771: 7770,
7773: 7772,
7775: 7774,
7777: 7776,
7779: 7778,
7781: 7780,
7783: 7782,
7785: 7784,
7787: 7786,
7789: 7788,
7791: 7790,
7793: 7792,
7795: 7794,
7797: 7796,
7799: 7798,
7801: 7800,
7803: 7802,
7805: 7804,
7807: 7806,
7809: 7808,
7811: 7810,
7813: 7812,
7815: 7814,
7817: 7816,
7819: 7818,
7821: 7820,
7823: 7822,
7825: 7824,
7827: 7826,
7829: 7828,
7835: 7776,
7841: 7840,
7843: 7842,
7845: 7844,
7847: 7846,
7849: 7848,
7851: 7850,
7853: 7852,
7855: 7854,
7857: 7856,
7859: 7858,
7861: 7860,
7863: 7862,
7865: 7864,
7867: 7866,
7869: 7868,
7871: 7870,
7873: 7872,
7875: 7874,
7877: 7876,
7879: 7878,
7881: 7880,
7883: 7882,
7885: 7884,
7887: 7886,
7889: 7888,
7891: 7890,
7893: 7892,
7895: 7894,
7897: 7896,
7899: 7898,
7901: 7900,
7903: 7902,
7905: 7904,
7907: 7906,
7909: 7908,
7911: 7910,
7913: 7912,
7915: 7914,
7917: 7916,
7919: 7918,
7921: 7920,
7923: 7922,
7925: 7924,
7927: 7926,
7929: 7928,
7936: 7944,
7937: 7945,
7938: 7946,
7939: 7947,
7940: 7948,
7941: 7949,
7942: 7950,
7943: 7951,
7952: 7960,
7953: 7961,
7954: 7962,
7955: 7963,
7956: 7964,
7957: 7965,
7968: 7976,
7969: 7977,
7970: 7978,
7971: 7979,
7972: 7980,
7973: 7981,
7974: 7982,
7975: 7983,
7984: 7992,
7985: 7993,
7986: 7994,
7987: 7995,
7988: 7996,
7989: 7997,
7990: 7998,
7991: 7999,
8000: 8008,
8001: 8009,
8002: 8010,
8003: 8011,
8004: 8012,
8005: 8013,
8017: 8025,
8019: 8027,
8021: 8029,
8023: 8031,
8032: 8040,
8033: 8041,
8034: 8042,
8035: 8043,
8036: 8044,
8037: 8045,
8038: 8046,
8039: 8047,
8048: 8122,
8049: 8123,
8050: 8136,
8051: 8137,
8052: 8138,
8053: 8139,
8054: 8154,
8055: 8155,
8056: 8184,
8057: 8185,
8058: 8170,
8059: 8171,
8060: 8186,
8061: 8187,
8064: 8072,
8065: 8073,
8066: 8074,
8067: 8075,
8068: 8076,
8069: 8077,
8070: 8078,
8071: 8079,
8080: 8088,
8081: 8089,
8082: 8090,
8083: 8091,
8084: 8092,
8085: 8093,
8086: 8094,
8087: 8095,
8096: 8104,
8097: 8105,
8098: 8106,
8099: 8107,
8100: 8108,
8101: 8109,
8102: 8110,
8103: 8111,
8112: 8120,
8113: 8121,
8115: 8124,
8126: 921,
8131: 8140,
8144: 8152,
8145: 8153,
8160: 8168,
8161: 8169,
8165: 8172,
8179: 8188,
8560: 8544,
8561: 8545,
8562: 8546,
8563: 8547,
8564: 8548,
8565: 8549,
8566: 8550,
8567: 8551,
8568: 8552,
8569: 8553,
8570: 8554,
8571: 8555,
8572: 8556,
8573: 8557,
8574: 8558,
8575: 8559,
9424: 9398,
9425: 9399,
9426: 9400,
9427: 9401,
9428: 9402,
9429: 9403,
9430: 9404,
9431: 9405,
9432: 9406,
9433: 9407,
9434: 9408,
9435: 9409,
9436: 9410,
9437: 9411,
9438: 9412,
9439: 9413,
9440: 9414,
9441: 9415,
9442: 9416,
9443: 9417,
9444: 9418,
9445: 9419,
9446: 9420,
9447: 9421,
9448: 9422,
9449: 9423,
11312: 11264,
11313: 11265,
11314: 11266,
11315: 11267,
11316: 11268,
11317: 11269,
11318: 11270,
11319: 11271,
11320: 11272,
11321: 11273,
11322: 11274,
11323: 11275,
11324: 11276,
11325: 11277,
11326: 11278,
11327: 11279,
11328: 11280,
11329: 11281,
11330: 11282,
11331: 11283,
11332: 11284,
11333: 11285,
11334: 11286,
11335: 11287,
11336: 11288,
11337: 11289,
11338: 11290,
11339: 11291,
11340: 11292,
11341: 11293,
11342: 11294,
11343: 11295,
11344: 11296,
11345: 11297,
11346: 11298,
11347: 11299,
11348: 11300,
11349: 11301,
11350: 11302,
11351: 11303,
11352: 11304,
11353: 11305,
11354: 11306,
11355: 11307,
11356: 11308,
11357: 11309,
11358: 11310,
11393: 11392,
11395: 11394,
11397: 11396,
11399: 11398,
11401: 11400,
11403: 11402,
11405: 11404,
11407: 11406,
11409: 11408,
11411: 11410,
11413: 11412,
11415: 11414,
11417: 11416,
11419: 11418,
11421: 11420,
11423: 11422,
11425: 11424,
11427: 11426,
11429: 11428,
11431: 11430,
11433: 11432,
11435: 11434,
11437: 11436,
11439: 11438,
11441: 11440,
11443: 11442,
11445: 11444,
11447: 11446,
11449: 11448,
11451: 11450,
11453: 11452,
11455: 11454,
11457: 11456,
11459: 11458,
11461: 11460,
11463: 11462,
11465: 11464,
11467: 11466,
11469: 11468,
11471: 11470,
11473: 11472,
11475: 11474,
11477: 11476,
11479: 11478,
11481: 11480,
11483: 11482,
11485: 11484,
11487: 11486,
11489: 11488,
11491: 11490,
11520: 4256,
11521: 4257,
11522: 4258,
11523: 4259,
11524: 4260,
11525: 4261,
11526: 4262,
11527: 4263,
11528: 4264,
11529: 4265,
11530: 4266,
11531: 4267,
11532: 4268,
11533: 4269,
11534: 4270,
11535: 4271,
11536: 4272,
11537: 4273,
11538: 4274,
11539: 4275,
11540: 4276,
11541: 4277,
11542: 4278,
11543: 4279,
11544: 4280,
11545: 4281,
11546: 4282,
11547: 4283,
11548: 4284,
11549: 4285,
11550: 4286,
11551: 4287,
11552: 4288,
11553: 4289,
11554: 4290,
11555: 4291,
11556: 4292,
11557: 4293,
65345: 65313,
65346: 65314,
65347: 65315,
65348: 65316,
65349: 65317,
65350: 65318,
65351: 65319,
65352: 65320,
65353: 65321,
65354: 65322,
65355: 65323,
65356: 65324,
65357: 65325,
65358: 65326,
65359: 65327,
65360: 65328,
65361: 65329,
65362: 65330,
65363: 65331,
65364: 65332,
65365: 65333,
65366: 65334,
65367: 65335,
65368: 65336,
65369: 65337,
65370: 65338,
66600: 66560,
66601: 66561,
66602: 66562,
66603: 66563,
66604: 66564,
66605: 66565,
66606: 66566,
66607: 66567,
66608: 66568,
66609: 66569,
66610: 66570,
66611: 66571,
66612: 66572,
66613: 66573,
66614: 66574,
66615: 66575,
66616: 66576,
66617: 66577,
66618: 66578,
66619: 66579,
66620: 66580,
66621: 66581,
66622: 66582,
66623: 66583,
66624: 66584,
66625: 66585,
66626: 66586,
66627: 66587,
66628: 66588,
66629: 66589,
66630: 66590,
66631: 66591,
66632: 66592,
66633: 66593,
66634: 66594,
66635: 66595,
66636: 66596,
66637: 66597,
66638: 66598,
66639: 66599,
}

_toupper_corrected = {
}
_tolower = {
65: 97,
66: 98,
67: 99,
68: 100,
69: 101,
70: 102,
71: 103,
72: 104,
73: 105,
74: 106,
75: 107,
76: 108,
77: 109,
78: 110,
79: 111,
80: 112,
81: 113,
82: 114,
83: 115,
84: 116,
85: 117,
86: 118,
87: 119,
88: 120,
89: 121,
90: 122,
192: 224,
193: 225,
194: 226,
195: 227,
196: 228,
197: 229,
198: 230,
199: 231,
200: 232,
201: 233,
202: 234,
203: 235,
204: 236,
205: 237,
206: 238,
207: 239,
208: 240,
209: 241,
210: 242,
211: 243,
212: 244,
213: 245,
214: 246,
216: 248,
217: 249,
218: 250,
219: 251,
220: 252,
221: 253,
222: 254,
256: 257,
258: 259,
260: 261,
262: 263,
264: 265,
266: 267,
268: 269,
270: 271,
272: 273,
274: 275,
276: 277,
278: 279,
280: 281,
282: 283,
284: 285,
286: 287,
288: 289,
290: 291,
292: 293,
294: 295,
296: 297,
298: 299,
300: 301,
302: 303,
304: 105,
306: 307,
308: 309,
310: 311,
313: 314,
315: 316,
317: 318,
319: 320,
321: 322,
323: 324,
325: 326,
327: 328,
330: 331,
332: 333,
334: 335,
336: 337,
338: 339,
340: 341,
342: 343,
344: 345,
346: 347,
348: 349,
350: 351,
352: 353,
354: 355,
356: 357,
358: 359,
360: 361,
362: 363,
364: 365,
366: 367,
368: 369,
370: 371,
372: 373,
374: 375,
376: 255,
377: 378,
379: 380,
381: 382,
385: 595,
386: 387,
388: 389,
390: 596,
391: 392,
393: 598,
394: 599,
395: 396,
398: 477,
399: 601,
400: 603,
401: 402,
403: 608,
404: 611,
406: 617,
407: 616,
408: 409,
412: 623,
413: 626,
415: 629,
416: 417,
418: 419,
420: 421,
422: 640,
423: 424,
425: 643,
428: 429,
430: 648,
431: 432,
433: 650,
434: 651,
435: 436,
437: 438,
439: 658,
440: 441,
444: 445,
452: 454,
453: 454,
455: 457,
456: 457,
458: 460,
459: 460,
461: 462,
463: 464,
465: 466,
467: 468,
469: 470,
471: 472,
473: 474,
475: 476,
478: 479,
480: 481,
482: 483,
484: 485,
486: 487,
488: 489,
490: 491,
492: 493,
494: 495,
497: 499,
498: 499,
500: 501,
502: 405,
503: 447,
504: 505,
506: 507,
508: 509,
510: 511,
512: 513,
514: 515,
516: 517,
518: 519,
520: 521,
522: 523,
524: 525,
526: 527,
528: 529,
530: 531,
532: 533,
534: 535,
536: 537,
538: 539,
540: 541,
542: 543,
544: 414,
546: 547,
548: 549,
550: 551,
552: 553,
554: 555,
556: 557,
558: 559,
560: 561,
562: 563,
571: 572,
573: 410,
577: 660,
902: 940,
904: 941,
905: 942,
906: 943,
908: 972,
910: 973,
911: 974,
913: 945,
914: 946,
915: 947,
916: 948,
917: 949,
918: 950,
919: 951,
920: 952,
921: 953,
922: 954,
923: 955,
924: 956,
925: 957,
926: 958,
927: 959,
928: 960,
929: 961,
931: 963,
932: 964,
933: 965,
934: 966,
935: 967,
936: 968,
937: 969,
938: 970,
939: 971,
984: 985,
986: 987,
988: 989,
990: 991,
992: 993,
994: 995,
996: 997,
998: 999,
1000: 1001,
1002: 1003,
1004: 1005,
1006: 1007,
1012: 952,
1015: 1016,
1017: 1010,
1018: 1019,
1024: 1104,
1025: 1105,
1026: 1106,
1027: 1107,
1028: 1108,
1029: 1109,
1030: 1110,
1031: 1111,
1032: 1112,
1033: 1113,
1034: 1114,
1035: 1115,
1036: 1116,
1037: 1117,
1038: 1118,
1039: 1119,
1040: 1072,
1041: 1073,
1042: 1074,
1043: 1075,
1044: 1076,
1045: 1077,
1046: 1078,
1047: 1079,
1048: 1080,
1049: 1081,
1050: 1082,
1051: 1083,
1052: 1084,
1053: 1085,
1054: 1086,
1055: 1087,
1056: 1088,
1057: 1089,
1058: 1090,
1059: 1091,
1060: 1092,
1061: 1093,
1062: 1094,
1063: 1095,
1064: 1096,
1065: 1097,
1066: 1098,
1067: 1099,
1068: 1100,
1069: 1101,
1070: 1102,
1071: 1103,
1120: 1121,
1122: 1123,
1124: 1125,
1126: 1127,
1128: 1129,
1130: 1131,
1132: 1133,
1134: 1135,
1136: 1137,
1138: 1139,
1140: 1141,
1142: 1143,
1144: 1145,
1146: 1147,
1148: 1149,
1150: 1151,
1152: 1153,
1162: 1163,
1164: 1165,
1166: 1167,
1168: 1169,
1170: 1171,
1172: 1173,
1174: 1175,
1176: 1177,
1178: 1179,
1180: 1181,
1182: 1183,
1184: 1185,
1186: 1187,
1188: 1189,
1190: 1191,
1192: 1193,
1194: 1195,
1196: 1197,
1198: 1199,
1200: 1201,
1202: 1203,
1204: 1205,
1206: 1207,
1208: 1209,
1210: 1211,
1212: 1213,
1214: 1215,
1217: 1218,
1219: 1220,
1221: 1222,
1223: 1224,
1225: 1226,
1227: 1228,
1229: 1230,
1232: 1233,
1234: 1235,
1236: 1237,
1238: 1239,
1240: 1241,
1242: 1243,
1244: 1245,
1246: 1247,
1248: 1249,
1250: 1251,
1252: 1253,
1254: 1255,
1256: 1257,
1258: 1259,
1260: 1261,
1262: 1263,
1264: 1265,
1266: 1267,
1268: 1269,
1270: 1271,
1272: 1273,
1280: 1281,
1282: 1283,
1284: 1285,
1286: 1287,
1288: 1289,
1290: 1291,
1292: 1293,
1294: 1295,
1329: 1377,
1330: 1378,
1331: 1379,
1332: 1380,
1333: 1381,
1334: 1382,
1335: 1383,
1336: 1384,
1337: 1385,
1338: 1386,
1339: 1387,
1340: 1388,
1341: 1389,
1342: 1390,
1343: 1391,
1344: 1392,
1345: 1393,
1346: 1394,
1347: 1395,
1348: 1396,
1349: 1397,
1350: 1398,
1351: 1399,
1352: 1400,
1353: 1401,
1354: 1402,
1355: 1403,
1356: 1404,
1357: 1405,
1358: 1406,
1359: 1407,
1360: 1408,
1361: 1409,
1362: 1410,
1363: 1411,
1364: 1412,
1365: 1413,
1366: 1414,
4256: 11520,
4257: 11521,
4258: 11522,
4259: 11523,
4260: 11524,
4261: 11525,
4262: 11526,
4263: 11527,
4264: 11528,
4265: 11529,
4266: 11530,
4267: 11531,
4268: 11532,
4269: 11533,
4270: 11534,
4271: 11535,
4272: 11536,
4273: 11537,
4274: 11538,
4275: 11539,
4276: 11540,
4277: 11541,
4278: 11542,
4279: 11543,
4280: 11544,
4281: 11545,
4282: 11546,
4283: 11547,
4284: 11548,
4285: 11549,
4286: 11550,
4287: 11551,
4288: 11552,
4289: 11553,
4290: 11554,
4291: 11555,
4292: 11556,
4293: 11557,
7680: 7681,
7682: 7683,
7684: 7685,
7686: 7687,
7688: 7689,
7690: 7691,
7692: 7693,
7694: 7695,
7696: 7697,
7698: 7699,
7700: 7701,
7702: 7703,
7704: 7705,
7706: 7707,
7708: 7709,
7710: 7711,
7712: 7713,
7714: 7715,
7716: 7717,
7718: 7719,
7720: 7721,
7722: 7723,
7724: 7725,
7726: 7727,
7728: 7729,
7730: 7731,
7732: 7733,
7734: 7735,
7736: 7737,
7738: 7739,
7740: 7741,
7742: 7743,
7744: 7745,
7746: 7747,
7748: 7749,
7750: 7751,
7752: 7753,
7754: 7755,
7756: 7757,
7758: 7759,
7760: 7761,
7762: 7763,
7764: 7765,
7766: 7767,
7768: 7769,
7770: 7771,
7772: 7773,
7774: 7775,
7776: 7777,
7778: 7779,
7780: 7781,
7782: 7783,
7784: 7785,
7786: 7787,
7788: 7789,
7790: 7791,
7792: 7793,
7794: 7795,
7796: 7797,
7798: 7799,
7800: 7801,
7802: 7803,
7804: 7805,
7806: 7807,
7808: 7809,
7810: 7811,
7812: 7813,
7814: 7815,
7816: 7817,
7818: 7819,
7820: 7821,
7822: 7823,
7824: 7825,
7826: 7827,
7828: 7829,
7840: 7841,
7842: 7843,
7844: 7845,
7846: 7847,
7848: 7849,
7850: 7851,
7852: 7853,
7854: 7855,
7856: 7857,
7858: 7859,
7860: 7861,
7862: 7863,
7864: 7865,
7866: 7867,
7868: 7869,
7870: 7871,
7872: 7873,
7874: 7875,
7876: 7877,
7878: 7879,
7880: 7881,
7882: 7883,
7884: 7885,
7886: 7887,
7888: 7889,
7890: 7891,
7892: 7893,
7894: 7895,
7896: 7897,
7898: 7899,
7900: 7901,
7902: 7903,
7904: 7905,
7906: 7907,
7908: 7909,
7910: 7911,
7912: 7913,
7914: 7915,
7916: 7917,
7918: 7919,
7920: 7921,
7922: 7923,
7924: 7925,
7926: 7927,
7928: 7929,
7944: 7936,
7945: 7937,
7946: 7938,
7947: 7939,
7948: 7940,
7949: 7941,
7950: 7942,
7951: 7943,
7960: 7952,
7961: 7953,
7962: 7954,
7963: 7955,
7964: 7956,
7965: 7957,
7976: 7968,
7977: 7969,
7978: 7970,
7979: 7971,
7980: 7972,
7981: 7973,
7982: 7974,
7983: 7975,
7992: 7984,
7993: 7985,
7994: 7986,
7995: 7987,
7996: 7988,
7997: 7989,
7998: 7990,
7999: 7991,
8008: 8000,
8009: 8001,
8010: 8002,
8011: 8003,
8012: 8004,
8013: 8005,
8025: 8017,
8027: 8019,
8029: 8021,
8031: 8023,
8040: 8032,
8041: 8033,
8042: 8034,
8043: 8035,
8044: 8036,
8045: 8037,
8046: 8038,
8047: 8039,
8072: 8064,
8073: 8065,
8074: 8066,
8075: 8067,
8076: 8068,
8077: 8069,
8078: 8070,
8079: 8071,
8088: 8080,
8089: 8081,
8090: 8082,
8091: 8083,
8092: 8084,
8093: 8085,
8094: 8086,
8095: 8087,
8104: 8096,
8105: 8097,
8106: 8098,
8107: 8099,
8108: 8100,
8109: 8101,
8110: 8102,
8111: 8103,
8120: 8112,
8121: 8113,
8122: 8048,
8123: 8049,
8124: 8115,
8136: 8050,
8137: 8051,
8138: 8052,
8139: 8053,
8140: 8131,
8152: 8144,
8153: 8145,
8154: 8054,
8155: 8055,
8168: 8160,
8169: 8161,
8170: 8058,
8171: 8059,
8172: 8165,
8184: 8056,
8185: 8057,
8186: 8060,
8187: 8061,
8188: 8179,
8486: 969,
8490: 107,
8491: 229,
8544: 8560,
8545: 8561,
8546: 8562,
8547: 8563,
8548: 8564,
8549: 8565,
8550: 8566,
8551: 8567,
8552: 8568,
8553: 8569,
8554: 8570,
8555: 8571,
8556: 8572,
8557: 8573,
8558: 8574,
8559: 8575,
9398: 9424,
9399: 9425,
9400: 9426,
9401: 9427,
9402: 9428,
9403: 9429,
9404: 9430,
9405: 9431,
9406: 9432,
9407: 9433,
9408: 9434,
9409: 9435,
9410: 9436,
9411: 9437,
9412: 9438,
9413: 9439,
9414: 9440,
9415: 9441,
9416: 9442,
9417: 9443,
9418: 9444,
9419: 9445,
9420: 9446,
9421: 9447,
9422: 9448,
9423: 9449,
11264: 11312,
11265: 11313,
11266: 11314,
11267: 11315,
11268: 11316,
11269: 11317,
11270: 11318,
11271: 11319,
11272: 11320,
11273: 11321,
11274: 11322,
11275: 11323,
11276: 11324,
11277: 11325,
11278: 11326,
11279: 11327,
11280: 11328,
11281: 11329,
11282: 11330,
11283: 11331,
11284: 11332,
11285: 11333,
11286: 11334,
11287: 11335,
11288: 11336,
11289: 11337,
11290: 11338,
11291: 11339,
11292: 11340,
11293: 11341,
11294: 11342,
11295: 11343,
11296: 11344,
11297: 11345,
11298: 11346,
11299: 11347,
11300: 11348,
11301: 11349,
11302: 11350,
11303: 11351,
11304: 11352,
11305: 11353,
11306: 11354,
11307: 11355,
11308: 11356,
11309: 11357,
11310: 11358,
11392: 11393,
11394: 11395,
11396: 11397,
11398: 11399,
11400: 11401,
11402: 11403,
11404: 11405,
11406: 11407,
11408: 11409,
11410: 11411,
11412: 11413,
11414: 11415,
11416: 11417,
11418: 11419,
11420: 11421,
11422: 11423,
11424: 11425,
11426: 11427,
11428: 11429,
11430: 11431,
11432: 11433,
11434: 11435,
11436: 11437,
11438: 11439,
11440: 11441,
11442: 11443,
11444: 11445,
11446: 11447,
11448: 11449,
11450: 11451,
11452: 11453,
11454: 11455,
11456: 11457,
11458: 11459,
11460: 11461,
11462: 11463,
11464: 11465,
11466: 11467,
11468: 11469,
11470: 11471,
11472: 11473,
11474: 11475,
11476: 11477,
11478: 11479,
11480: 11481,
11482: 11483,
11484: 11485,
11486: 11487,
11488: 11489,
11490: 11491,
65313: 65345,
65314: 65346,
65315: 65347,
65316: 65348,
65317: 65349,
65318: 65350,
65319: 65351,
65320: 65352,
65321: 65353,
65322: 65354,
65323: 65355,
65324: 65356,
65325: 65357,
65326: 65358,
65327: 65359,
65328: 65360,
65329: 65361,
65330: 65362,
65331: 65363,
65332: 65364,
65333: 65365,
65334: 65366,
65335: 65367,
65336: 65368,
65337: 65369,
65338: 65370,
66560: 66600,
66561: 66601,
66562: 66602,
66563: 66603,
66564: 66604,
66565: 66605,
66566: 66606,
66567: 66607,
66568: 66608,
66569: 66609,
66570: 66610,
66571: 66611,
66572: 66612,
66573: 66613,
66574: 66614,
66575: 66615,
66576: 66616,
66577: 66617,
66578: 66618,
66579: 66619,
66580: 66620,
66581: 66621,
66582: 66622,
66583: 66623,
66584: 66624,
66585: 66625,
66586: 66626,
66587: 66627,
66588: 66628,
66589: 66629,
66590: 66630,
66591: 66631,
66592: 66632,
66593: 66633,
66594: 66634,
66595: 66635,
66596: 66636,
66597: 66637,
66598: 66638,
66599: 66639,
}

_tolower_corrected = {
}
_totitle = {
97: 65,
98: 66,
99: 67,
100: 68,
101: 69,
102: 70,
103: 71,
104: 72,
105: 73,
106: 74,
107: 75,
108: 76,
109: 77,
110: 78,
111: 79,
112: 80,
113: 81,
114: 82,
115: 83,
116: 84,
117: 85,
118: 86,
119: 87,
120: 88,
121: 89,
122: 90,
181: 924,
224: 192,
225: 193,
226: 194,
227: 195,
228: 196,
229: 197,
230: 198,
231: 199,
232: 200,
233: 201,
234: 202,
235: 203,
236: 204,
237: 205,
238: 206,
239: 207,
240: 208,
241: 209,
242: 210,
243: 211,
244: 212,
245: 213,
246: 214,
248: 216,
249: 217,
250: 218,
251: 219,
252: 220,
253: 221,
254: 222,
255: 376,
257: 256,
259: 258,
261: 260,
263: 262,
265: 264,
267: 266,
269: 268,
271: 270,
273: 272,
275: 274,
277: 276,
279: 278,
281: 280,
283: 282,
285: 284,
287: 286,
289: 288,
291: 290,
293: 292,
295: 294,
297: 296,
299: 298,
301: 300,
303: 302,
305: 73,
307: 306,
309: 308,
311: 310,
314: 313,
316: 315,
318: 317,
320: 319,
322: 321,
324: 323,
326: 325,
328: 327,
331: 330,
333: 332,
335: 334,
337: 336,
339: 338,
341: 340,
343: 342,
345: 344,
347: 346,
349: 348,
351: 350,
353: 352,
355: 354,
357: 356,
359: 358,
361: 360,
363: 362,
365: 364,
367: 366,
369: 368,
371: 370,
373: 372,
375: 374,
378: 377,
380: 379,
382: 381,
383: 83,
387: 386,
389: 388,
392: 391,
396: 395,
402: 401,
405: 502,
409: 408,
410: 573,
414: 544,
417: 416,
419: 418,
421: 420,
424: 423,
429: 428,
432: 431,
436: 435,
438: 437,
441: 440,
445: 444,
447: 503,
452: 453,
453: 453,
454: 453,
455: 456,
456: 456,
457: 456,
458: 459,
459: 459,
460: 459,
462: 461,
464: 463,
466: 465,
468: 467,
470: 469,
472: 471,
474: 473,
476: 475,
477: 398,
479: 478,
481: 480,
483: 482,
485: 484,
487: 486,
489: 488,
491: 490,
493: 492,
495: 494,
497: 498,
498: 498,
499: 498,
501: 500,
505: 504,
507: 506,
509: 508,
511: 510,
513: 512,
515: 514,
517: 516,
519: 518,
521: 520,
523: 522,
525: 524,
527: 526,
529: 528,
531: 530,
533: 532,
535: 534,
537: 536,
539: 538,
541: 540,
543: 542,
547: 546,
549: 548,
551: 550,
553: 552,
555: 554,
557: 556,
559: 558,
561: 560,
563: 562,
572: 571,
595: 385,
596: 390,
598: 393,
599: 394,
601: 399,
603: 400,
608: 403,
611: 404,
616: 407,
617: 406,
623: 412,
626: 413,
629: 415,
640: 422,
643: 425,
648: 430,
650: 433,
651: 434,
658: 439,
660: 577,
837: 921,
940: 902,
941: 904,
942: 905,
943: 906,
945: 913,
946: 914,
947: 915,
948: 916,
949: 917,
950: 918,
951: 919,
952: 920,
953: 921,
954: 922,
955: 923,
956: 924,
957: 925,
958: 926,
959: 927,
960: 928,
961: 929,
962: 931,
963: 931,
964: 932,
965: 933,
966: 934,
967: 935,
968: 936,
969: 937,
970: 938,
971: 939,
972: 908,
973: 910,
974: 911,
976: 914,
977: 920,
981: 934,
982: 928,
985: 984,
987: 986,
989: 988,
991: 990,
993: 992,
995: 994,
997: 996,
999: 998,
1001: 1000,
1003: 1002,
1005: 1004,
1007: 1006,
1008: 922,
1009: 929,
1010: 1017,
1013: 917,
1016: 1015,
1019: 1018,
1072: 1040,
1073: 1041,
1074: 1042,
1075: 1043,
1076: 1044,
1077: 1045,
1078: 1046,
1079: 1047,
1080: 1048,
1081: 1049,
1082: 1050,
1083: 1051,
1084: 1052,
1085: 1053,
1086: 1054,
1087: 1055,
1088: 1056,
1089: 1057,
1090: 1058,
1091: 1059,
1092: 1060,
1093: 1061,
1094: 1062,
1095: 1063,
1096: 1064,
1097: 1065,
1098: 1066,
1099: 1067,
1100: 1068,
1101: 1069,
1102: 1070,
1103: 1071,
1104: 1024,
1105: 1025,
1106: 1026,
1107: 1027,
1108: 1028,
1109: 1029,
1110: 1030,
1111: 1031,
1112: 1032,
1113: 1033,
1114: 1034,
1115: 1035,
1116: 1036,
1117: 1037,
1118: 1038,
1119: 1039,
1121: 1120,
1123: 1122,
1125: 1124,
1127: 1126,
1129: 1128,
1131: 1130,
1133: 1132,
1135: 1134,
1137: 1136,
1139: 1138,
1141: 1140,
1143: 1142,
1145: 1144,
1147: 1146,
1149: 1148,
1151: 1150,
1153: 1152,
1163: 1162,
1165: 1164,
1167: 1166,
1169: 1168,
1171: 1170,
1173: 1172,
1175: 1174,
1177: 1176,
1179: 1178,
1181: 1180,
1183: 1182,
1185: 1184,
1187: 1186,
1189: 1188,
1191: 1190,
1193: 1192,
1195: 1194,
1197: 1196,
1199: 1198,
1201: 1200,
1203: 1202,
1205: 1204,
1207: 1206,
1209: 1208,
1211: 1210,
1213: 1212,
1215: 1214,
1218: 1217,
1220: 1219,
1222: 1221,
1224: 1223,
1226: 1225,
1228: 1227,
1230: 1229,
1233: 1232,
1235: 1234,
1237: 1236,
1239: 1238,
1241: 1240,
1243: 1242,
1245: 1244,
1247: 1246,
1249: 1248,
1251: 1250,
1253: 1252,
1255: 1254,
1257: 1256,
1259: 1258,
1261: 1260,
1263: 1262,
1265: 1264,
1267: 1266,
1269: 1268,
1271: 1270,
1273: 1272,
1281: 1280,
1283: 1282,
1285: 1284,
1287: 1286,
1289: 1288,
1291: 1290,
1293: 1292,
1295: 1294,
1377: 1329,
1378: 1330,
1379: 1331,
1380: 1332,
1381: 1333,
1382: 1334,
1383: 1335,
1384: 1336,
1385: 1337,
1386: 1338,
1387: 1339,
1388: 1340,
1389: 1341,
1390: 1342,
1391: 1343,
1392: 1344,
1393: 1345,
1394: 1346,
1395: 1347,
1396: 1348,
1397: 1349,
1398: 1350,
1399: 1351,
1400: 1352,
1401: 1353,
1402: 1354,
1403: 1355,
1404: 1356,
1405: 1357,
1406: 1358,
1407: 1359,
1408: 1360,
1409: 1361,
1410: 1362,
1411: 1363,
1412: 1364,
1413: 1365,
1414: 1366,
7681: 7680,
7683: 7682,
7685: 7684,
7687: 7686,
7689: 7688,
7691: 7690,
7693: 7692,
7695: 7694,
7697: 7696,
7699: 7698,
7701: 7700,
7703: 7702,
7705: 7704,
7707: 7706,
7709: 7708,
7711: 7710,
7713: 7712,
7715: 7714,
7717: 7716,
7719: 7718,
7721: 7720,
7723: 7722,
7725: 7724,
7727: 7726,
7729: 7728,
7731: 7730,
7733: 7732,
7735: 7734,
7737: 7736,
7739: 7738,
7741: 7740,
7743: 7742,
7745: 7744,
7747: 7746,
7749: 7748,
7751: 7750,
7753: 7752,
7755: 7754,
7757: 7756,
7759: 7758,
7761: 7760,
7763: 7762,
7765: 7764,
7767: 7766,
7769: 7768,
7771: 7770,
7773: 7772,
7775: 7774,
7777: 7776,
7779: 7778,
7781: 7780,
7783: 7782,
7785: 7784,
7787: 7786,
7789: 7788,
7791: 7790,
7793: 7792,
7795: 7794,
7797: 7796,
7799: 7798,
7801: 7800,
7803: 7802,
7805: 7804,
7807: 7806,
7809: 7808,
7811: 7810,
7813: 7812,
7815: 7814,
7817: 7816,
7819: 7818,
7821: 7820,
7823: 7822,
7825: 7824,
7827: 7826,
7829: 7828,
7835: 7776,
7841: 7840,
7843: 7842,
7845: 7844,
7847: 7846,
7849: 7848,
7851: 7850,
7853: 7852,
7855: 7854,
7857: 7856,
7859: 7858,
7861: 7860,
7863: 7862,
7865: 7864,
7867: 7866,
7869: 7868,
7871: 7870,
7873: 7872,
7875: 7874,
7877: 7876,
7879: 7878,
7881: 7880,
7883: 7882,
7885: 7884,
7887: 7886,
7889: 7888,
7891: 7890,
7893: 7892,
7895: 7894,
7897: 7896,
7899: 7898,
7901: 7900,
7903: 7902,
7905: 7904,
7907: 7906,
7909: 7908,
7911: 7910,
7913: 7912,
7915: 7914,
7917: 7916,
7919: 7918,
7921: 7920,
7923: 7922,
7925: 7924,
7927: 7926,
7929: 7928,
7936: 7944,
7937: 7945,
7938: 7946,
7939: 7947,
7940: 7948,
7941: 7949,
7942: 7950,
7943: 7951,
7952: 7960,
7953: 7961,
7954: 7962,
7955: 7963,
7956: 7964,
7957: 7965,
7968: 7976,
7969: 7977,
7970: 7978,
7971: 7979,
7972: 7980,
7973: 7981,
7974: 7982,
7975: 7983,
7984: 7992,
7985: 7993,
7986: 7994,
7987: 7995,
7988: 7996,
7989: 7997,
7990: 7998,
7991: 7999,
8000: 8008,
8001: 8009,
8002: 8010,
8003: 8011,
8004: 8012,
8005: 8013,
8017: 8025,
8019: 8027,
8021: 8029,
8023: 8031,
8032: 8040,
8033: 8041,
8034: 8042,
8035: 8043,
8036: 8044,
8037: 8045,
8038: 8046,
8039: 8047,
8048: 8122,
8049: 8123,
8050: 8136,
8051: 8137,
8052: 8138,
8053: 8139,
8054: 8154,
8055: 8155,
8056: 8184,
8057: 8185,
8058: 8170,
8059: 8171,
8060: 8186,
8061: 8187,
8064: 8072,
8065: 8073,
8066: 8074,
8067: 8075,
8068: 8076,
8069: 8077,
8070: 8078,
8071: 8079,
8080: 8088,
8081: 8089,
8082: 8090,
8083: 8091,
8084: 8092,
8085: 8093,
8086: 8094,
8087: 8095,
8096: 8104,
8097: 8105,
8098: 8106,
8099: 8107,
8100: 8108,
8101: 8109,
8102: 8110,
8103: 8111,
8112: 8120,
8113: 8121,
8115: 8124,
8126: 921,
8131: 8140,
8144: 8152,
8145: 8153,
8160: 8168,
8161: 8169,
8165: 8172,
8179: 8188,
8560: 8544,
8561: 8545,
8562: 8546,
8563: 8547,
8564: 8548,
8565: 8549,
8566: 8550,
8567: 8551,
8568: 8552,
8569: 8553,
8570: 8554,
8571: 8555,
8572: 8556,
8573: 8557,
8574: 8558,
8575: 8559,
9424: 9398,
9425: 9399,
9426: 9400,
9427: 9401,
9428: 9402,
9429: 9403,
9430: 9404,
9431: 9405,
9432: 9406,
9433: 9407,
9434: 9408,
9435: 9409,
9436: 9410,
9437: 9411,
9438: 9412,
9439: 9413,
9440: 9414,
9441: 9415,
9442: 9416,
9443: 9417,
9444: 9418,
9445: 9419,
9446: 9420,
9447: 9421,
9448: 9422,
9449: 9423,
11312: 11264,
11313: 11265,
11314: 11266,
11315: 11267,
11316: 11268,
11317: 11269,
11318: 11270,
11319: 11271,
11320: 11272,
11321: 11273,
11322: 11274,
11323: 11275,
11324: 11276,
11325: 11277,
11326: 11278,
11327: 11279,
11328: 11280,
11329: 11281,
11330: 11282,
11331: 11283,
11332: 11284,
11333: 11285,
11334: 11286,
11335: 11287,
11336: 11288,
11337: 11289,
11338: 11290,
11339: 11291,
11340: 11292,
11341: 11293,
11342: 11294,
11343: 11295,
11344: 11296,
11345: 11297,
11346: 11298,
11347: 11299,
11348: 11300,
11349: 11301,
11350: 11302,
11351: 11303,
11352: 11304,
11353: 11305,
11354: 11306,
11355: 11307,
11356: 11308,
11357: 11309,
11358: 11310,
11393: 11392,
11395: 11394,
11397: 11396,
11399: 11398,
11401: 11400,
11403: 11402,
11405: 11404,
11407: 11406,
11409: 11408,
11411: 11410,
11413: 11412,
11415: 11414,
11417: 11416,
11419: 11418,
11421: 11420,
11423: 11422,
11425: 11424,
11427: 11426,
11429: 11428,
11431: 11430,
11433: 11432,
11435: 11434,
11437: 11436,
11439: 11438,
11441: 11440,
11443: 11442,
11445: 11444,
11447: 11446,
11449: 11448,
11451: 11450,
11453: 11452,
11455: 11454,
11457: 11456,
11459: 11458,
11461: 11460,
11463: 11462,
11465: 11464,
11467: 11466,
11469: 11468,
11471: 11470,
11473: 11472,
11475: 11474,
11477: 11476,
11479: 11478,
11481: 11480,
11483: 11482,
11485: 11484,
11487: 11486,
11489: 11488,
11491: 11490,
11520: 4256,
11521: 4257,
11522: 4258,
11523: 4259,
11524: 4260,
11525: 4261,
11526: 4262,
11527: 4263,
11528: 4264,
11529: 4265,
11530: 4266,
11531: 4267,
11532: 4268,
11533: 4269,
11534: 4270,
11535: 4271,
11536: 4272,
11537: 4273,
11538: 4274,
11539: 4275,
11540: 4276,
11541: 4277,
11542: 4278,
11543: 4279,
11544: 4280,
11545: 4281,
11546: 4282,
11547: 4283,
11548: 4284,
11549: 4285,
11550: 4286,
11551: 4287,
11552: 4288,
11553: 4289,
11554: 4290,
11555: 4291,
11556: 4292,
11557: 4293,
65345: 65313,
65346: 65314,
65347: 65315,
65348: 65316,
65349: 65317,
65350: 65318,
65351: 65319,
65352: 65320,
65353: 65321,
65354: 65322,
65355: 65323,
65356: 65324,
65357: 65325,
65358: 65326,
65359: 65327,
65360: 65328,
65361: 65329,
65362: 65330,
65363: 65331,
65364: 65332,
65365: 65333,
65366: 65334,
65367: 65335,
65368: 65336,
65369: 65337,
65370: 65338,
66600: 66560,
66601: 66561,
66602: 66562,
66603: 66563,
66604: 66564,
66605: 66565,
66606: 66566,
66607: 66567,
66608: 66568,
66609: 66569,
66610: 66570,
66611: 66571,
66612: 66572,
66613: 66573,
66614: 66574,
66615: 66575,
66616: 66576,
66617: 66577,
66618: 66578,
66619: 66579,
66620: 66580,
66621: 66581,
66622: 66582,
66623: 66583,
66624: 66584,
66625: 66585,
66626: 66586,
66627: 66587,
66628: 66588,
66629: 66589,
66630: 66590,
66631: 66591,
66632: 66592,
66633: 66593,
66634: 66594,
66635: 66595,
66636: 66596,
66637: 66597,
66638: 66598,
66639: 66599,
}

_totitle_corrected = {
}

def toupper(code):
    try:
        return _toupper[code]
    except KeyError:
        if base_mod is not None and code not in _toupper_corrected:
            return base_mod._toupper.get(code, code)
        else:
            return code

def tolower(code):
    try:
        return _tolower[code]
    except KeyError:
        if base_mod is not None and code not in _tolower_corrected:
            return base_mod._tolower.get(code, code)
        else:
            return code

def totitle(code):
    try:
        return _totitle[code]
    except KeyError:
        if base_mod is not None and code not in _totitle_corrected:
            return base_mod._totitle.get(code, code)
        else:
            return code

_raw_decomposition = {
160: '<noBreak> 0020',
168: '<compat> 0020 0308',
170: '<super> 0061',
175: '<compat> 0020 0304',
178: '<super> 0032',
179: '<super> 0033',
180: '<compat> 0020 0301',
181: '<compat> 03BC',
184: '<compat> 0020 0327',
185: '<super> 0031',
186: '<super> 006F',
188: '<fraction> 0031 2044 0034',
189: '<fraction> 0031 2044 0032',
190: '<fraction> 0033 2044 0034',
192: '0041 0300',
193: '0041 0301',
194: '0041 0302',
195: '0041 0303',
196: '0041 0308',
197: '0041 030A',
199: '0043 0327',
200: '0045 0300',
201: '0045 0301',
202: '0045 0302',
203: '0045 0308',
204: '0049 0300',
205: '0049 0301',
206: '0049 0302',
207: '0049 0308',
209: '004E 0303',
210: '004F 0300',
211: '004F 0301',
212: '004F 0302',
213: '004F 0303',
214: '004F 0308',
217: '0055 0300',
218: '0055 0301',
219: '0055 0302',
220: '0055 0308',
221: '0059 0301',
224: '0061 0300',
225: '0061 0301',
226: '0061 0302',
227: '0061 0303',
228: '0061 0308',
229: '0061 030A',
231: '0063 0327',
232: '0065 0300',
233: '0065 0301',
234: '0065 0302',
235: '0065 0308',
236: '0069 0300',
237: '0069 0301',
238: '0069 0302',
239: '0069 0308',
241: '006E 0303',
242: '006F 0300',
243: '006F 0301',
244: '006F 0302',
245: '006F 0303',
246: '006F 0308',
249: '0075 0300',
250: '0075 0301',
251: '0075 0302',
252: '0075 0308',
253: '0079 0301',
255: '0079 0308',
256: '0041 0304',
257: '0061 0304',
258: '0041 0306',
259: '0061 0306',
260: '0041 0328',
261: '0061 0328',
262: '0043 0301',
263: '0063 0301',
264: '0043 0302',
265: '0063 0302',
266: '0043 0307',
267: '0063 0307',
268: '0043 030C',
269: '0063 030C',
270: '0044 030C',
271: '0064 030C',
274: '0045 0304',
275: '0065 0304',
276: '0045 0306',
277: '0065 0306',
278: '0045 0307',
279: '0065 0307',
280: '0045 0328',
281: '0065 0328',
282: '0045 030C',
283: '0065 030C',
284: '0047 0302',
285: '0067 0302',
286: '0047 0306',
287: '0067 0306',
288: '0047 0307',
289: '0067 0307',
290: '0047 0327',
291: '0067 0327',
292: '0048 0302',
293: '0068 0302',
296: '0049 0303',
297: '0069 0303',
298: '0049 0304',
299: '0069 0304',
300: '0049 0306',
301: '0069 0306',
302: '0049 0328',
303: '0069 0328',
304: '0049 0307',
306: '<compat> 0049 004A',
307: '<compat> 0069 006A',
308: '004A 0302',
309: '006A 0302',
310: '004B 0327',
311: '006B 0327',
313: '004C 0301',
314: '006C 0301',
315: '004C 0327',
316: '006C 0327',
317: '004C 030C',
318: '006C 030C',
319: '<compat> 004C 00B7',
320: '<compat> 006C 00B7',
323: '004E 0301',
324: '006E 0301',
325: '004E 0327',
326: '006E 0327',
327: '004E 030C',
328: '006E 030C',
329: '<compat> 02BC 006E',
332: '004F 0304',
333: '006F 0304',
334: '004F 0306',
335: '006F 0306',
336: '004F 030B',
337: '006F 030B',
340: '0052 0301',
341: '0072 0301',
342: '0052 0327',
343: '0072 0327',
344: '0052 030C',
345: '0072 030C',
346: '0053 0301',
347: '0073 0301',
348: '0053 0302',
349: '0073 0302',
350: '0053 0327',
351: '0073 0327',
352: '0053 030C',
353: '0073 030C',
354: '0054 0327',
355: '0074 0327',
356: '0054 030C',
357: '0074 030C',
360: '0055 0303',
361: '0075 0303',
362: '0055 0304',
363: '0075 0304',
364: '0055 0306',
365: '0075 0306',
366: '0055 030A',
367: '0075 030A',
368: '0055 030B',
369: '0075 030B',
370: '0055 0328',
371: '0075 0328',
372: '0057 0302',
373: '0077 0302',
374: '0059 0302',
375: '0079 0302',
376: '0059 0308',
377: '005A 0301',
378: '007A 0301',
379: '005A 0307',
380: '007A 0307',
381: '005A 030C',
382: '007A 030C',
383: '<compat> 0073',
416: '004F 031B',
417: '006F 031B',
431: '0055 031B',
432: '0075 031B',
452: '<compat> 0044 017D',
453: '<compat> 0044 017E',
454: '<compat> 0064 017E',
455: '<compat> 004C 004A',
456: '<compat> 004C 006A',
457: '<compat> 006C 006A',
458: '<compat> 004E 004A',
459: '<compat> 004E 006A',
460: '<compat> 006E 006A',
461: '0041 030C',
462: '0061 030C',
463: '0049 030C',
464: '0069 030C',
465: '004F 030C',
466: '006F 030C',
467: '0055 030C',
468: '0075 030C',
469: '00DC 0304',
470: '00FC 0304',
471: '00DC 0301',
472: '00FC 0301',
473: '00DC 030C',
474: '00FC 030C',
475: '00DC 0300',
476: '00FC 0300',
478: '00C4 0304',
479: '00E4 0304',
480: '0226 0304',
481: '0227 0304',
482: '00C6 0304',
483: '00E6 0304',
486: '0047 030C',
487: '0067 030C',
488: '004B 030C',
489: '006B 030C',
490: '004F 0328',
491: '006F 0328',
492: '01EA 0304',
493: '01EB 0304',
494: '01B7 030C',
495: '0292 030C',
496: '006A 030C',
497: '<compat> 0044 005A',
498: '<compat> 0044 007A',
499: '<compat> 0064 007A',
500: '0047 0301',
501: '0067 0301',
504: '004E 0300',
505: '006E 0300',
506: '00C5 0301',
507: '00E5 0301',
508: '00C6 0301',
509: '00E6 0301',
510: '00D8 0301',
511: '00F8 0301',
512: '0041 030F',
513: '0061 030F',
514: '0041 0311',
515: '0061 0311',
516: '0045 030F',
517: '0065 030F',
518: '0045 0311',
519: '0065 0311',
520: '0049 030F',
521: '0069 030F',
522: '0049 0311',
523: '0069 0311',
524: '004F 030F',
525: '006F 030F',
526: '004F 0311',
527: '006F 0311',
528: '0052 030F',
529: '0072 030F',
530: '0052 0311',
531: '0072 0311',
532: '0055 030F',
533: '0075 030F',
534: '0055 0311',
535: '0075 0311',
536: '0053 0326',
537: '0073 0326',
538: '0054 0326',
539: '0074 0326',
542: '0048 030C',
543: '0068 030C',
550: '0041 0307',
551: '0061 0307',
552: '0045 0327',
553: '0065 0327',
554: '00D6 0304',
555: '00F6 0304',
556: '00D5 0304',
557: '00F5 0304',
558: '004F 0307',
559: '006F 0307',
560: '022E 0304',
561: '022F 0304',
562: '0059 0304',
563: '0079 0304',
688: '<super> 0068',
689: '<super> 0266',
690: '<super> 006A',
691: '<super> 0072',
692: '<super> 0279',
693: '<super> 027B',
694: '<super> 0281',
695: '<super> 0077',
696: '<super> 0079',
728: '<compat> 0020 0306',
729: '<compat> 0020 0307',
730: '<compat> 0020 030A',
731: '<compat> 0020 0328',
732: '<compat> 0020 0303',
733: '<compat> 0020 030B',
736: '<super> 0263',
737: '<super> 006C',
738: '<super> 0073',
739: '<super> 0078',
740: '<super> 0295',
832: '0300',
833: '0301',
835: '0313',
836: '0308 0301',
884: '02B9',
890: '<compat> 0020 0345',
894: '003B',
900: '<compat> 0020 0301',
901: '00A8 0301',
902: '0391 0301',
903: '00B7',
904: '0395 0301',
905: '0397 0301',
906: '0399 0301',
908: '039F 0301',
910: '03A5 0301',
911: '03A9 0301',
912: '03CA 0301',
938: '0399 0308',
939: '03A5 0308',
940: '03B1 0301',
941: '03B5 0301',
942: '03B7 0301',
943: '03B9 0301',
944: '03CB 0301',
970: '03B9 0308',
971: '03C5 0308',
972: '03BF 0301',
973: '03C5 0301',
974: '03C9 0301',
976: '<compat> 03B2',
977: '<compat> 03B8',
978: '<compat> 03A5',
979: '03D2 0301',
980: '03D2 0308',
981: '<compat> 03C6',
982: '<compat> 03C0',
1008: '<compat> 03BA',
1009: '<compat> 03C1',
1010: '<compat> 03C2',
1012: '<compat> 0398',
1013: '<compat> 03B5',
1017: '<compat> 03A3',
1024: '0415 0300',
1025: '0415 0308',
1027: '0413 0301',
1031: '0406 0308',
1036: '041A 0301',
1037: '0418 0300',
1038: '0423 0306',
1049: '0418 0306',
1081: '0438 0306',
1104: '0435 0300',
1105: '0435 0308',
1107: '0433 0301',
1111: '0456 0308',
1116: '043A 0301',
1117: '0438 0300',
1118: '0443 0306',
1142: '0474 030F',
1143: '0475 030F',
1217: '0416 0306',
1218: '0436 0306',
1232: '0410 0306',
1233: '0430 0306',
1234: '0410 0308',
1235: '0430 0308',
1238: '0415 0306',
1239: '0435 0306',
1242: '04D8 0308',
1243: '04D9 0308',
1244: '0416 0308',
1245: '0436 0308',
1246: '0417 0308',
1247: '0437 0308',
1250: '0418 0304',
1251: '0438 0304',
1252: '0418 0308',
1253: '0438 0308',
1254: '041E 0308',
1255: '043E 0308',
1258: '04E8 0308',
1259: '04E9 0308',
1260: '042D 0308',
1261: '044D 0308',
1262: '0423 0304',
1263: '0443 0304',
1264: '0423 0308',
1265: '0443 0308',
1266: '0423 030B',
1267: '0443 030B',
1268: '0427 0308',
1269: '0447 0308',
1272: '042B 0308',
1273: '044B 0308',
1415: '<compat> 0565 0582',
1570: '0627 0653',
1571: '0627 0654',
1572: '0648 0654',
1573: '0627 0655',
1574: '064A 0654',
1653: '<compat> 0627 0674',
1654: '<compat> 0648 0674',
1655: '<compat> 06C7 0674',
1656: '<compat> 064A 0674',
1728: '06D5 0654',
1730: '06C1 0654',
1747: '06D2 0654',
2345: '0928 093C',
2353: '0930 093C',
2356: '0933 093C',
2392: '0915 093C',
2393: '0916 093C',
2394: '0917 093C',
2395: '091C 093C',
2396: '0921 093C',
2397: '0922 093C',
2398: '092B 093C',
2399: '092F 093C',
2507: '09C7 09BE',
2508: '09C7 09D7',
2524: '09A1 09BC',
2525: '09A2 09BC',
2527: '09AF 09BC',
2611: '0A32 0A3C',
2614: '0A38 0A3C',
2649: '0A16 0A3C',
2650: '0A17 0A3C',
2651: '0A1C 0A3C',
2654: '0A2B 0A3C',
2888: '0B47 0B56',
2891: '0B47 0B3E',
2892: '0B47 0B57',
2908: '0B21 0B3C',
2909: '0B22 0B3C',
2964: '0B92 0BD7',
3018: '0BC6 0BBE',
3019: '0BC7 0BBE',
3020: '0BC6 0BD7',
3144: '0C46 0C56',
3264: '0CBF 0CD5',
3271: '0CC6 0CD5',
3272: '0CC6 0CD6',
3274: '0CC6 0CC2',
3275: '0CCA 0CD5',
3402: '0D46 0D3E',
3403: '0D47 0D3E',
3404: '0D46 0D57',
3546: '0DD9 0DCA',
3548: '0DD9 0DCF',
3549: '0DDC 0DCA',
3550: '0DD9 0DDF',
3635: '<compat> 0E4D 0E32',
3763: '<compat> 0ECD 0EB2',
3804: '<compat> 0EAB 0E99',
3805: '<compat> 0EAB 0EA1',
3852: '<noBreak> 0F0B',
3907: '0F42 0FB7',
3917: '0F4C 0FB7',
3922: '0F51 0FB7',
3927: '0F56 0FB7',
3932: '0F5B 0FB7',
3945: '0F40 0FB5',
3955: '0F71 0F72',
3957: '0F71 0F74',
3958: '0FB2 0F80',
3959: '<compat> 0FB2 0F81',
3960: '0FB3 0F80',
3961: '<compat> 0FB3 0F81',
3969: '0F71 0F80',
3987: '0F92 0FB7',
3997: '0F9C 0FB7',
4002: '0FA1 0FB7',
4007: '0FA6 0FB7',
4012: '0FAB 0FB7',
4025: '0F90 0FB5',
4134: '1025 102E',
4348: '<super> 10DC',
7468: '<super> 0041',
7469: '<super> 00C6',
7470: '<super> 0042',
7472: '<super> 0044',
7473: '<super> 0045',
7474: '<super> 018E',
7475: '<super> 0047',
7476: '<super> 0048',
7477: '<super> 0049',
7478: '<super> 004A',
7479: '<super> 004B',
7480: '<super> 004C',
7481: '<super> 004D',
7482: '<super> 004E',
7484: '<super> 004F',
7485: '<super> 0222',
7486: '<super> 0050',
7487: '<super> 0052',
7488: '<super> 0054',
7489: '<super> 0055',
7490: '<super> 0057',
7491: '<super> 0061',
7492: '<super> 0250',
7493: '<super> 0251',
7494: '<super> 1D02',
7495: '<super> 0062',
7496: '<super> 0064',
7497: '<super> 0065',
7498: '<super> 0259',
7499: '<super> 025B',
7500: '<super> 025C',
7501: '<super> 0067',
7503: '<super> 006B',
7504: '<super> 006D',
7505: '<super> 014B',
7506: '<super> 006F',
7507: '<super> 0254',
7508: '<super> 1D16',
7509: '<super> 1D17',
7510: '<super> 0070',
7511: '<super> 0074',
7512: '<super> 0075',
7513: '<super> 1D1D',
7514: '<super> 026F',
7515: '<super> 0076',
7516: '<super> 1D25',
7517: '<super> 03B2',
7518: '<super> 03B3',
7519: '<super> 03B4',
7520: '<super> 03C6',
7521: '<super> 03C7',
7522: '<sub> 0069',
7523: '<sub> 0072',
7524: '<sub> 0075',
7525: '<sub> 0076',
7526: '<sub> 03B2',
7527: '<sub> 03B3',
7528: '<sub> 03C1',
7529: '<sub> 03C6',
7530: '<sub> 03C7',
7544: '<super> 043D',
7579: '<super> 0252',
7580: '<super> 0063',
7581: '<super> 0255',
7582: '<super> 00F0',
7583: '<super> 025C',
7584: '<super> 0066',
7585: '<super> 025F',
7586: '<super> 0261',
7587: '<super> 0265',
7588: '<super> 0268',
7589: '<super> 0269',
7590: '<super> 026A',
7591: '<super> 1D7B',
7592: '<super> 029D',
7593: '<super> 026D',
7594: '<super> 1D85',
7595: '<super> 029F',
7596: '<super> 0271',
7597: '<super> 0270',
7598: '<super> 0272',
7599: '<super> 0273',
7600: '<super> 0274',
7601: '<super> 0275',
7602: '<super> 0278',
7603: '<super> 0282',
7604: '<super> 0283',
7605: '<super> 01AB',
7606: '<super> 0289',
7607: '<super> 028A',
7608: '<super> 1D1C',
7609: '<super> 028B',
7610: '<super> 028C',
7611: '<super> 007A',
7612: '<super> 0290',
7613: '<super> 0291',
7614: '<super> 0292',
7615: '<super> 03B8',
7680: '0041 0325',
7681: '0061 0325',
7682: '0042 0307',
7683: '0062 0307',
7684: '0042 0323',
7685: '0062 0323',
7686: '0042 0331',
7687: '0062 0331',
7688: '00C7 0301',
7689: '00E7 0301',
7690: '0044 0307',
7691: '0064 0307',
7692: '0044 0323',
7693: '0064 0323',
7694: '0044 0331',
7695: '0064 0331',
7696: '0044 0327',
7697: '0064 0327',
7698: '0044 032D',
7699: '0064 032D',
7700: '0112 0300',
7701: '0113 0300',
7702: '0112 0301',
7703: '0113 0301',
7704: '0045 032D',
7705: '0065 032D',
7706: '0045 0330',
7707: '0065 0330',
7708: '0228 0306',
7709: '0229 0306',
7710: '0046 0307',
7711: '0066 0307',
7712: '0047 0304',
7713: '0067 0304',
7714: '0048 0307',
7715: '0068 0307',
7716: '0048 0323',
7717: '0068 0323',
7718: '0048 0308',
7719: '0068 0308',
7720: '0048 0327',
7721: '0068 0327',
7722: '0048 032E',
7723: '0068 032E',
7724: '0049 0330',
7725: '0069 0330',
7726: '00CF 0301',
7727: '00EF 0301',
7728: '004B 0301',
7729: '006B 0301',
7730: '004B 0323',
7731: '006B 0323',
7732: '004B 0331',
7733: '006B 0331',
7734: '004C 0323',
7735: '006C 0323',
7736: '1E36 0304',
7737: '1E37 0304',
7738: '004C 0331',
7739: '006C 0331',
7740: '004C 032D',
7741: '006C 032D',
7742: '004D 0301',
7743: '006D 0301',
7744: '004D 0307',
7745: '006D 0307',
7746: '004D 0323',
7747: '006D 0323',
7748: '004E 0307',
7749: '006E 0307',
7750: '004E 0323',
7751: '006E 0323',
7752: '004E 0331',
7753: '006E 0331',
7754: '004E 032D',
7755: '006E 032D',
7756: '00D5 0301',
7757: '00F5 0301',
7758: '00D5 0308',
7759: '00F5 0308',
7760: '014C 0300',
7761: '014D 0300',
7762: '014C 0301',
7763: '014D 0301',
7764: '0050 0301',
7765: '0070 0301',
7766: '0050 0307',
7767: '0070 0307',
7768: '0052 0307',
7769: '0072 0307',
7770: '0052 0323',
7771: '0072 0323',
7772: '1E5A 0304',
7773: '1E5B 0304',
7774: '0052 0331',
7775: '0072 0331',
7776: '0053 0307',
7777: '0073 0307',
7778: '0053 0323',
7779: '0073 0323',
7780: '015A 0307',
7781: '015B 0307',
7782: '0160 0307',
7783: '0161 0307',
7784: '1E62 0307',
7785: '1E63 0307',
7786: '0054 0307',
7787: '0074 0307',
7788: '0054 0323',
7789: '0074 0323',
7790: '0054 0331',
7791: '0074 0331',
7792: '0054 032D',
7793: '0074 032D',
7794: '0055 0324',
7795: '0075 0324',
7796: '0055 0330',
7797: '0075 0330',
7798: '0055 032D',
7799: '0075 032D',
7800: '0168 0301',
7801: '0169 0301',
7802: '016A 0308',
7803: '016B 0308',
7804: '0056 0303',
7805: '0076 0303',
7806: '0056 0323',
7807: '0076 0323',
7808: '0057 0300',
7809: '0077 0300',
7810: '0057 0301',
7811: '0077 0301',
7812: '0057 0308',
7813: '0077 0308',
7814: '0057 0307',
7815: '0077 0307',
7816: '0057 0323',
7817: '0077 0323',
7818: '0058 0307',
7819: '0078 0307',
7820: '0058 0308',
7821: '0078 0308',
7822: '0059 0307',
7823: '0079 0307',
7824: '005A 0302',
7825: '007A 0302',
7826: '005A 0323',
7827: '007A 0323',
7828: '005A 0331',
7829: '007A 0331',
7830: '0068 0331',
7831: '0074 0308',
7832: '0077 030A',
7833: '0079 030A',
7834: '<compat> 0061 02BE',
7835: '017F 0307',
7840: '0041 0323',
7841: '0061 0323',
7842: '0041 0309',
7843: '0061 0309',
7844: '00C2 0301',
7845: '00E2 0301',
7846: '00C2 0300',
7847: '00E2 0300',
7848: '00C2 0309',
7849: '00E2 0309',
7850: '00C2 0303',
7851: '00E2 0303',
7852: '1EA0 0302',
7853: '1EA1 0302',
7854: '0102 0301',
7855: '0103 0301',
7856: '0102 0300',
7857: '0103 0300',
7858: '0102 0309',
7859: '0103 0309',
7860: '0102 0303',
7861: '0103 0303',
7862: '1EA0 0306',
7863: '1EA1 0306',
7864: '0045 0323',
7865: '0065 0323',
7866: '0045 0309',
7867: '0065 0309',
7868: '0045 0303',
7869: '0065 0303',
7870: '00CA 0301',
7871: '00EA 0301',
7872: '00CA 0300',
7873: '00EA 0300',
7874: '00CA 0309',
7875: '00EA 0309',
7876: '00CA 0303',
7877: '00EA 0303',
7878: '1EB8 0302',
7879: '1EB9 0302',
7880: '0049 0309',
7881: '0069 0309',
7882: '0049 0323',
7883: '0069 0323',
7884: '004F 0323',
7885: '006F 0323',
7886: '004F 0309',
7887: '006F 0309',
7888: '00D4 0301',
7889: '00F4 0301',
7890: '00D4 0300',
7891: '00F4 0300',
7892: '00D4 0309',
7893: '00F4 0309',
7894: '00D4 0303',
7895: '00F4 0303',
7896: '1ECC 0302',
7897: '1ECD 0302',
7898: '01A0 0301',
7899: '01A1 0301',
7900: '01A0 0300',
7901: '01A1 0300',
7902: '01A0 0309',
7903: '01A1 0309',
7904: '01A0 0303',
7905: '01A1 0303',
7906: '01A0 0323',
7907: '01A1 0323',
7908: '0055 0323',
7909: '0075 0323',
7910: '0055 0309',
7911: '0075 0309',
7912: '01AF 0301',
7913: '01B0 0301',
7914: '01AF 0300',
7915: '01B0 0300',
7916: '01AF 0309',
7917: '01B0 0309',
7918: '01AF 0303',
7919: '01B0 0303',
7920: '01AF 0323',
7921: '01B0 0323',
7922: '0059 0300',
7923: '0079 0300',
7924: '0059 0323',
7925: '0079 0323',
7926: '0059 0309',
7927: '0079 0309',
7928: '0059 0303',
7929: '0079 0303',
7936: '03B1 0313',
7937: '03B1 0314',
7938: '1F00 0300',
7939: '1F01 0300',
7940: '1F00 0301',
7941: '1F01 0301',
7942: '1F00 0342',
7943: '1F01 0342',
7944: '0391 0313',
7945: '0391 0314',
7946: '1F08 0300',
7947: '1F09 0300',
7948: '1F08 0301',
7949: '1F09 0301',
7950: '1F08 0342',
7951: '1F09 0342',
7952: '03B5 0313',
7953: '03B5 0314',
7954: '1F10 0300',
7955: '1F11 0300',
7956: '1F10 0301',
7957: '1F11 0301',
7960: '0395 0313',
7961: '0395 0314',
7962: '1F18 0300',
7963: '1F19 0300',
7964: '1F18 0301',
7965: '1F19 0301',
7968: '03B7 0313',
7969: '03B7 0314',
7970: '1F20 0300',
7971: '1F21 0300',
7972: '1F20 0301',
7973: '1F21 0301',
7974: '1F20 0342',
7975: '1F21 0342',
7976: '0397 0313',
7977: '0397 0314',
7978: '1F28 0300',
7979: '1F29 0300',
7980: '1F28 0301',
7981: '1F29 0301',
7982: '1F28 0342',
7983: '1F29 0342',
7984: '03B9 0313',
7985: '03B9 0314',
7986: '1F30 0300',
7987: '1F31 0300',
7988: '1F30 0301',
7989: '1F31 0301',
7990: '1F30 0342',
7991: '1F31 0342',
7992: '0399 0313',
7993: '0399 0314',
7994: '1F38 0300',
7995: '1F39 0300',
7996: '1F38 0301',
7997: '1F39 0301',
7998: '1F38 0342',
7999: '1F39 0342',
8000: '03BF 0313',
8001: '03BF 0314',
8002: '1F40 0300',
8003: '1F41 0300',
8004: '1F40 0301',
8005: '1F41 0301',
8008: '039F 0313',
8009: '039F 0314',
8010: '1F48 0300',
8011: '1F49 0300',
8012: '1F48 0301',
8013: '1F49 0301',
8016: '03C5 0313',
8017: '03C5 0314',
8018: '1F50 0300',
8019: '1F51 0300',
8020: '1F50 0301',
8021: '1F51 0301',
8022: '1F50 0342',
8023: '1F51 0342',
8025: '03A5 0314',
8027: '1F59 0300',
8029: '1F59 0301',
8031: '1F59 0342',
8032: '03C9 0313',
8033: '03C9 0314',
8034: '1F60 0300',
8035: '1F61 0300',
8036: '1F60 0301',
8037: '1F61 0301',
8038: '1F60 0342',
8039: '1F61 0342',
8040: '03A9 0313',
8041: '03A9 0314',
8042: '1F68 0300',
8043: '1F69 0300',
8044: '1F68 0301',
8045: '1F69 0301',
8046: '1F68 0342',
8047: '1F69 0342',
8048: '03B1 0300',
8049: '03AC',
8050: '03B5 0300',
8051: '03AD',
8052: '03B7 0300',
8053: '03AE',
8054: '03B9 0300',
8055: '03AF',
8056: '03BF 0300',
8057: '03CC',
8058: '03C5 0300',
8059: '03CD',
8060: '03C9 0300',
8061: '03CE',
8064: '1F00 0345',
8065: '1F01 0345',
8066: '1F02 0345',
8067: '1F03 0345',
8068: '1F04 0345',
8069: '1F05 0345',
8070: '1F06 0345',
8071: '1F07 0345',
8072: '1F08 0345',
8073: '1F09 0345',
8074: '1F0A 0345',
8075: '1F0B 0345',
8076: '1F0C 0345',
8077: '1F0D 0345',
8078: '1F0E 0345',
8079: '1F0F 0345',
8080: '1F20 0345',
8081: '1F21 0345',
8082: '1F22 0345',
8083: '1F23 0345',
8084: '1F24 0345',
8085: '1F25 0345',
8086: '1F26 0345',
8087: '1F27 0345',
8088: '1F28 0345',
8089: '1F29 0345',
8090: '1F2A 0345',
8091: '1F2B 0345',
8092: '1F2C 0345',
8093: '1F2D 0345',
8094: '1F2E 0345',
8095: '1F2F 0345',
8096: '1F60 0345',
8097: '1F61 0345',
8098: '1F62 0345',
8099: '1F63 0345',
8100: '1F64 0345',
8101: '1F65 0345',
8102: '1F66 0345',
8103: '1F67 0345',
8104: '1F68 0345',
8105: '1F69 0345',
8106: '1F6A 0345',
8107: '1F6B 0345',
8108: '1F6C 0345',
8109: '1F6D 0345',
8110: '1F6E 0345',
8111: '1F6F 0345',
8112: '03B1 0306',
8113: '03B1 0304',
8114: '1F70 0345',
8115: '03B1 0345',
8116: '03AC 0345',
8118: '03B1 0342',
8119: '1FB6 0345',
8120: '0391 0306',
8121: '0391 0304',
8122: '0391 0300',
8123: '0386',
8124: '0391 0345',
8125: '<compat> 0020 0313',
8126: '03B9',
8127: '<compat> 0020 0313',
8128: '<compat> 0020 0342',
8129: '00A8 0342',
8130: '1F74 0345',
8131: '03B7 0345',
8132: '03AE 0345',
8134: '03B7 0342',
8135: '1FC6 0345',
8136: '0395 0300',
8137: '0388',
8138: '0397 0300',
8139: '0389',
8140: '0397 0345',
8141: '1FBF 0300',
8142: '1FBF 0301',
8143: '1FBF 0342',
8144: '03B9 0306',
8145: '03B9 0304',
8146: '03CA 0300',
8147: '0390',
8150: '03B9 0342',
8151: '03CA 0342',
8152: '0399 0306',
8153: '0399 0304',
8154: '0399 0300',
8155: '038A',
8157: '1FFE 0300',
8158: '1FFE 0301',
8159: '1FFE 0342',
8160: '03C5 0306',
8161: '03C5 0304',
8162: '03CB 0300',
8163: '03B0',
8164: '03C1 0313',
8165: '03C1 0314',
8166: '03C5 0342',
8167: '03CB 0342',
8168: '03A5 0306',
8169: '03A5 0304',
8170: '03A5 0300',
8171: '038E',
8172: '03A1 0314',
8173: '00A8 0300',
8174: '0385',
8175: '0060',
8178: '1F7C 0345',
8179: '03C9 0345',
8180: '03CE 0345',
8182: '03C9 0342',
8183: '1FF6 0345',
8184: '039F 0300',
8185: '038C',
8186: '03A9 0300',
8187: '038F',
8188: '03A9 0345',
8189: '00B4',
8190: '<compat> 0020 0314',
8192: '2002',
8193: '2003',
8194: '<compat> 0020',
8195: '<compat> 0020',
8196: '<compat> 0020',
8197: '<compat> 0020',
8198: '<compat> 0020',
8199: '<noBreak> 0020',
8200: '<compat> 0020',
8201: '<compat> 0020',
8202: '<compat> 0020',
8209: '<noBreak> 2010',
8215: '<compat> 0020 0333',
8228: '<compat> 002E',
8229: '<compat> 002E 002E',
8230: '<compat> 002E 002E 002E',
8239: '<noBreak> 0020',
8243: '<compat> 2032 2032',
8244: '<compat> 2032 2032 2032',
8246: '<compat> 2035 2035',
8247: '<compat> 2035 2035 2035',
8252: '<compat> 0021 0021',
8254: '<compat> 0020 0305',
8263: '<compat> 003F 003F',
8264: '<compat> 003F 0021',
8265: '<compat> 0021 003F',
8279: '<compat> 2032 2032 2032 2032',
8287: '<compat> 0020',
8304: '<super> 0030',
8305: '<super> 0069',
8308: '<super> 0034',
8309: '<super> 0035',
8310: '<super> 0036',
8311: '<super> 0037',
8312: '<super> 0038',
8313: '<super> 0039',
8314: '<super> 002B',
8315: '<super> 2212',
8316: '<super> 003D',
8317: '<super> 0028',
8318: '<super> 0029',
8319: '<super> 006E',
8320: '<sub> 0030',
8321: '<sub> 0031',
8322: '<sub> 0032',
8323: '<sub> 0033',
8324: '<sub> 0034',
8325: '<sub> 0035',
8326: '<sub> 0036',
8327: '<sub> 0037',
8328: '<sub> 0038',
8329: '<sub> 0039',
8330: '<sub> 002B',
8331: '<sub> 2212',
8332: '<sub> 003D',
8333: '<sub> 0028',
8334: '<sub> 0029',
8336: '<sub> 0061',
8337: '<sub> 0065',
8338: '<sub> 006F',
8339: '<sub> 0078',
8340: '<sub> 0259',
8360: '<compat> 0052 0073',
8448: '<compat> 0061 002F 0063',
8449: '<compat> 0061 002F 0073',
8450: '<font> 0043',
8451: '<compat> 00B0 0043',
8453: '<compat> 0063 002F 006F',
8454: '<compat> 0063 002F 0075',
8455: '<compat> 0190',
8457: '<compat> 00B0 0046',
8458: '<font> 0067',
8459: '<font> 0048',
8460: '<font> 0048',
8461: '<font> 0048',
8462: '<font> 0068',
8463: '<font> 0127',
8464: '<font> 0049',
8465: '<font> 0049',
8466: '<font> 004C',
8467: '<font> 006C',
8469: '<font> 004E',
8470: '<compat> 004E 006F',
8473: '<font> 0050',
8474: '<font> 0051',
8475: '<font> 0052',
8476: '<font> 0052',
8477: '<font> 0052',
8480: '<super> 0053 004D',
8481: '<compat> 0054 0045 004C',
8482: '<super> 0054 004D',
8484: '<font> 005A',
8486: '03A9',
8488: '<font> 005A',
8490: '004B',
8491: '00C5',
8492: '<font> 0042',
8493: '<font> 0043',
8495: '<font> 0065',
8496: '<font> 0045',
8497: '<font> 0046',
8499: '<font> 004D',
8500: '<font> 006F',
8501: '<compat> 05D0',
8502: '<compat> 05D1',
8503: '<compat> 05D2',
8504: '<compat> 05D3',
8505: '<font> 0069',
8507: '<compat> 0046 0041 0058',
8508: '<font> 03C0',
8509: '<font> 03B3',
8510: '<font> 0393',
8511: '<font> 03A0',
8512: '<font> 2211',
8517: '<font> 0044',
8518: '<font> 0064',
8519: '<font> 0065',
8520: '<font> 0069',
8521: '<font> 006A',
8531: '<fraction> 0031 2044 0033',
8532: '<fraction> 0032 2044 0033',
8533: '<fraction> 0031 2044 0035',
8534: '<fraction> 0032 2044 0035',
8535: '<fraction> 0033 2044 0035',
8536: '<fraction> 0034 2044 0035',
8537: '<fraction> 0031 2044 0036',
8538: '<fraction> 0035 2044 0036',
8539: '<fraction> 0031 2044 0038',
8540: '<fraction> 0033 2044 0038',
8541: '<fraction> 0035 2044 0038',
8542: '<fraction> 0037 2044 0038',
8543: '<fraction> 0031 2044',
8544: '<compat> 0049',
8545: '<compat> 0049 0049',
8546: '<compat> 0049 0049 0049',
8547: '<compat> 0049 0056',
8548: '<compat> 0056',
8549: '<compat> 0056 0049',
8550: '<compat> 0056 0049 0049',
8551: '<compat> 0056 0049 0049 0049',
8552: '<compat> 0049 0058',
8553: '<compat> 0058',
8554: '<compat> 0058 0049',
8555: '<compat> 0058 0049 0049',
8556: '<compat> 004C',
8557: '<compat> 0043',
8558: '<compat> 0044',
8559: '<compat> 004D',
8560: '<compat> 0069',
8561: '<compat> 0069 0069',
8562: '<compat> 0069 0069 0069',
8563: '<compat> 0069 0076',
8564: '<compat> 0076',
8565: '<compat> 0076 0069',
8566: '<compat> 0076 0069 0069',
8567: '<compat> 0076 0069 0069 0069',
8568: '<compat> 0069 0078',
8569: '<compat> 0078',
8570: '<compat> 0078 0069',
8571: '<compat> 0078 0069 0069',
8572: '<compat> 006C',
8573: '<compat> 0063',
8574: '<compat> 0064',
8575: '<compat> 006D',
8602: '2190 0338',
8603: '2192 0338',
8622: '2194 0338',
8653: '21D0 0338',
8654: '21D4 0338',
8655: '21D2 0338',
8708: '2203 0338',
8713: '2208 0338',
8716: '220B 0338',
8740: '2223 0338',
8742: '2225 0338',
8748: '<compat> 222B 222B',
8749: '<compat> 222B 222B 222B',
8751: '<compat> 222E 222E',
8752: '<compat> 222E 222E 222E',
8769: '223C 0338',
8772: '2243 0338',
8775: '2245 0338',
8777: '2248 0338',
8800: '003D 0338',
8802: '2261 0338',
8813: '224D 0338',
8814: '003C 0338',
8815: '003E 0338',
8816: '2264 0338',
8817: '2265 0338',
8820: '2272 0338',
8821: '2273 0338',
8824: '2276 0338',
8825: '2277 0338',
8832: '227A 0338',
8833: '227B 0338',
8836: '2282 0338',
8837: '2283 0338',
8840: '2286 0338',
8841: '2287 0338',
8876: '22A2 0338',
8877: '22A8 0338',
8878: '22A9 0338',
8879: '22AB 0338',
8928: '227C 0338',
8929: '227D 0338',
8930: '2291 0338',
8931: '2292 0338',
8938: '22B2 0338',
8939: '22B3 0338',
8940: '22B4 0338',
8941: '22B5 0338',
9001: '3008',
9002: '3009',
9312: '<circle> 0031',
9313: '<circle> 0032',
9314: '<circle> 0033',
9315: '<circle> 0034',
9316: '<circle> 0035',
9317: '<circle> 0036',
9318: '<circle> 0037',
9319: '<circle> 0038',
9320: '<circle> 0039',
9321: '<circle> 0031 0030',
9322: '<circle> 0031 0031',
9323: '<circle> 0031 0032',
9324: '<circle> 0031 0033',
9325: '<circle> 0031 0034',
9326: '<circle> 0031 0035',
9327: '<circle> 0031 0036',
9328: '<circle> 0031 0037',
9329: '<circle> 0031 0038',
9330: '<circle> 0031 0039',
9331: '<circle> 0032 0030',
9332: '<compat> 0028 0031 0029',
9333: '<compat> 0028 0032 0029',
9334: '<compat> 0028 0033 0029',
9335: '<compat> 0028 0034 0029',
9336: '<compat> 0028 0035 0029',
9337: '<compat> 0028 0036 0029',
9338: '<compat> 0028 0037 0029',
9339: '<compat> 0028 0038 0029',
9340: '<compat> 0028 0039 0029',
9341: '<compat> 0028 0031 0030 0029',
9342: '<compat> 0028 0031 0031 0029',
9343: '<compat> 0028 0031 0032 0029',
9344: '<compat> 0028 0031 0033 0029',
9345: '<compat> 0028 0031 0034 0029',
9346: '<compat> 0028 0031 0035 0029',
9347: '<compat> 0028 0031 0036 0029',
9348: '<compat> 0028 0031 0037 0029',
9349: '<compat> 0028 0031 0038 0029',
9350: '<compat> 0028 0031 0039 0029',
9351: '<compat> 0028 0032 0030 0029',
9352: '<compat> 0031 002E',
9353: '<compat> 0032 002E',
9354: '<compat> 0033 002E',
9355: '<compat> 0034 002E',
9356: '<compat> 0035 002E',
9357: '<compat> 0036 002E',
9358: '<compat> 0037 002E',
9359: '<compat> 0038 002E',
9360: '<compat> 0039 002E',
9361: '<compat> 0031 0030 002E',
9362: '<compat> 0031 0031 002E',
9363: '<compat> 0031 0032 002E',
9364: '<compat> 0031 0033 002E',
9365: '<compat> 0031 0034 002E',
9366: '<compat> 0031 0035 002E',
9367: '<compat> 0031 0036 002E',
9368: '<compat> 0031 0037 002E',
9369: '<compat> 0031 0038 002E',
9370: '<compat> 0031 0039 002E',
9371: '<compat> 0032 0030 002E',
9372: '<compat> 0028 0061 0029',
9373: '<compat> 0028 0062 0029',
9374: '<compat> 0028 0063 0029',
9375: '<compat> 0028 0064 0029',
9376: '<compat> 0028 0065 0029',
9377: '<compat> 0028 0066 0029',
9378: '<compat> 0028 0067 0029',
9379: '<compat> 0028 0068 0029',
9380: '<compat> 0028 0069 0029',
9381: '<compat> 0028 006A 0029',
9382: '<compat> 0028 006B 0029',
9383: '<compat> 0028 006C 0029',
9384: '<compat> 0028 006D 0029',
9385: '<compat> 0028 006E 0029',
9386: '<compat> 0028 006F 0029',
9387: '<compat> 0028 0070 0029',
9388: '<compat> 0028 0071 0029',
9389: '<compat> 0028 0072 0029',
9390: '<compat> 0028 0073 0029',
9391: '<compat> 0028 0074 0029',
9392: '<compat> 0028 0075 0029',
9393: '<compat> 0028 0076 0029',
9394: '<compat> 0028 0077 0029',
9395: '<compat> 0028 0078 0029',
9396: '<compat> 0028 0079 0029',
9397: '<compat> 0028 007A 0029',
9398: '<circle> 0041',
9399: '<circle> 0042',
9400: '<circle> 0043',
9401: '<circle> 0044',
9402: '<circle> 0045',
9403: '<circle> 0046',
9404: '<circle> 0047',
9405: '<circle> 0048',
9406: '<circle> 0049',
9407: '<circle> 004A',
9408: '<circle> 004B',
9409: '<circle> 004C',
9410: '<circle> 004D',
9411: '<circle> 004E',
9412: '<circle> 004F',
9413: '<circle> 0050',
9414: '<circle> 0051',
9415: '<circle> 0052',
9416: '<circle> 0053',
9417: '<circle> 0054',
9418: '<circle> 0055',
9419: '<circle> 0056',
9420: '<circle> 0057',
9421: '<circle> 0058',
9422: '<circle> 0059',
9423: '<circle> 005A',
9424: '<circle> 0061',
9425: '<circle> 0062',
9426: '<circle> 0063',
9427: '<circle> 0064',
9428: '<circle> 0065',
9429: '<circle> 0066',
9430: '<circle> 0067',
9431: '<circle> 0068',
9432: '<circle> 0069',
9433: '<circle> 006A',
9434: '<circle> 006B',
9435: '<circle> 006C',
9436: '<circle> 006D',
9437: '<circle> 006E',
9438: '<circle> 006F',
9439: '<circle> 0070',
9440: '<circle> 0071',
9441: '<circle> 0072',
9442: '<circle> 0073',
9443: '<circle> 0074',
9444: '<circle> 0075',
9445: '<circle> 0076',
9446: '<circle> 0077',
9447: '<circle> 0078',
9448: '<circle> 0079',
9449: '<circle> 007A',
9450: '<circle> 0030',
10764: '<compat> 222B 222B 222B 222B',
10868: '<compat> 003A 003A 003D',
10869: '<compat> 003D 003D',
10870: '<compat> 003D 003D 003D',
10972: '2ADD 0338',
11631: '<super> 2D61',
11935: '<compat> 6BCD',
12019: '<compat> 9F9F',
12032: '<compat> 4E00',
12033: '<compat> 4E28',
12034: '<compat> 4E36',
12035: '<compat> 4E3F',
12036: '<compat> 4E59',
12037: '<compat> 4E85',
12038: '<compat> 4E8C',
12039: '<compat> 4EA0',
12040: '<compat> 4EBA',
12041: '<compat> 513F',
12042: '<compat> 5165',
12043: '<compat> 516B',
12044: '<compat> 5182',
12045: '<compat> 5196',
12046: '<compat> 51AB',
12047: '<compat> 51E0',
12048: '<compat> 51F5',
12049: '<compat> 5200',
12050: '<compat> 529B',
12051: '<compat> 52F9',
12052: '<compat> 5315',
12053: '<compat> 531A',
12054: '<compat> 5338',
12055: '<compat> 5341',
12056: '<compat> 535C',
12057: '<compat> 5369',
12058: '<compat> 5382',
12059: '<compat> 53B6',
12060: '<compat> 53C8',
12061: '<compat> 53E3',
12062: '<compat> 56D7',
12063: '<compat> 571F',
12064: '<compat> 58EB',
12065: '<compat> 5902',
12066: '<compat> 590A',
12067: '<compat> 5915',
12068: '<compat> 5927',
12069: '<compat> 5973',
12070: '<compat> 5B50',
12071: '<compat> 5B80',
12072: '<compat> 5BF8',
12073: '<compat> 5C0F',
12074: '<compat> 5C22',
12075: '<compat> 5C38',
12076: '<compat> 5C6E',
12077: '<compat> 5C71',
12078: '<compat> 5DDB',
12079: '<compat> 5DE5',
12080: '<compat> 5DF1',
12081: '<compat> 5DFE',
12082: '<compat> 5E72',
12083: '<compat> 5E7A',
12084: '<compat> 5E7F',
12085: '<compat> 5EF4',
12086: '<compat> 5EFE',
12087: '<compat> 5F0B',
12088: '<compat> 5F13',
12089: '<compat> 5F50',
12090: '<compat> 5F61',
12091: '<compat> 5F73',
12092: '<compat> 5FC3',
12093: '<compat> 6208',
12094: '<compat> 6236',
12095: '<compat> 624B',
12096: '<compat> 652F',
12097: '<compat> 6534',
12098: '<compat> 6587',
12099: '<compat> 6597',
12100: '<compat> 65A4',
12101: '<compat> 65B9',
12102: '<compat> 65E0',
12103: '<compat> 65E5',
12104: '<compat> 66F0',
12105: '<compat> 6708',
12106: '<compat> 6728',
12107: '<compat> 6B20',
12108: '<compat> 6B62',
12109: '<compat> 6B79',
12110: '<compat> 6BB3',
12111: '<compat> 6BCB',
12112: '<compat> 6BD4',
12113: '<compat> 6BDB',
12114: '<compat> 6C0F',
12115: '<compat> 6C14',
12116: '<compat> 6C34',
12117: '<compat> 706B',
12118: '<compat> 722A',
12119: '<compat> 7236',
12120: '<compat> 723B',
12121: '<compat> 723F',
12122: '<compat> 7247',
12123: '<compat> 7259',
12124: '<compat> 725B',
12125: '<compat> 72AC',
12126: '<compat> 7384',
12127: '<compat> 7389',
12128: '<compat> 74DC',
12129: '<compat> 74E6',
12130: '<compat> 7518',
12131: '<compat> 751F',
12132: '<compat> 7528',
12133: '<compat> 7530',
12134: '<compat> 758B',
12135: '<compat> 7592',
12136: '<compat> 7676',
12137: '<compat> 767D',
12138: '<compat> 76AE',
12139: '<compat> 76BF',
12140: '<compat> 76EE',
12141: '<compat> 77DB',
12142: '<compat> 77E2',
12143: '<compat> 77F3',
12144: '<compat> 793A',
12145: '<compat> 79B8',
12146: '<compat> 79BE',
12147: '<compat> 7A74',
12148: '<compat> 7ACB',
12149: '<compat> 7AF9',
12150: '<compat> 7C73',
12151: '<compat> 7CF8',
12152: '<compat> 7F36',
12153: '<compat> 7F51',
12154: '<compat> 7F8A',
12155: '<compat> 7FBD',
12156: '<compat> 8001',
12157: '<compat> 800C',
12158: '<compat> 8012',
12159: '<compat> 8033',
12160: '<compat> 807F',
12161: '<compat> 8089',
12162: '<compat> 81E3',
12163: '<compat> 81EA',
12164: '<compat> 81F3',
12165: '<compat> 81FC',
12166: '<compat> 820C',
12167: '<compat> 821B',
12168: '<compat> 821F',
12169: '<compat> 826E',
12170: '<compat> 8272',
12171: '<compat> 8278',
12172: '<compat> 864D',
12173: '<compat> 866B',
12174: '<compat> 8840',
12175: '<compat> 884C',
12176: '<compat> 8863',
12177: '<compat> 897E',
12178: '<compat> 898B',
12179: '<compat> 89D2',
12180: '<compat> 8A00',
12181: '<compat> 8C37',
12182: '<compat> 8C46',
12183: '<compat> 8C55',
12184: '<compat> 8C78',
12185: '<compat> 8C9D',
12186: '<compat> 8D64',
12187: '<compat> 8D70',
12188: '<compat> 8DB3',
12189: '<compat> 8EAB',
12190: '<compat> 8ECA',
12191: '<compat> 8F9B',
12192: '<compat> 8FB0',
12193: '<compat> 8FB5',
12194: '<compat> 9091',
12195: '<compat> 9149',
12196: '<compat> 91C6',
12197: '<compat> 91CC',
12198: '<compat> 91D1',
12199: '<compat> 9577',
12200: '<compat> 9580',
12201: '<compat> 961C',
12202: '<compat> 96B6',
12203: '<compat> 96B9',
12204: '<compat> 96E8',
12205: '<compat> 9751',
12206: '<compat> 975E',
12207: '<compat> 9762',
12208: '<compat> 9769',
12209: '<compat> 97CB',
12210: '<compat> 97ED',
12211: '<compat> 97F3',
12212: '<compat> 9801',
12213: '<compat> 98A8',
12214: '<compat> 98DB',
12215: '<compat> 98DF',
12216: '<compat> 9996',
12217: '<compat> 9999',
12218: '<compat> 99AC',
12219: '<compat> 9AA8',
12220: '<compat> 9AD8',
12221: '<compat> 9ADF',
12222: '<compat> 9B25',
12223: '<compat> 9B2F',
12224: '<compat> 9B32',
12225: '<compat> 9B3C',
12226: '<compat> 9B5A',
12227: '<compat> 9CE5',
12228: '<compat> 9E75',
12229: '<compat> 9E7F',
12230: '<compat> 9EA5',
12231: '<compat> 9EBB',
12232: '<compat> 9EC3',
12233: '<compat> 9ECD',
12234: '<compat> 9ED1',
12235: '<compat> 9EF9',
12236: '<compat> 9EFD',
12237: '<compat> 9F0E',
12238: '<compat> 9F13',
12239: '<compat> 9F20',
12240: '<compat> 9F3B',
12241: '<compat> 9F4A',
12242: '<compat> 9F52',
12243: '<compat> 9F8D',
12244: '<compat> 9F9C',
12245: '<compat> 9FA0',
12288: '<wide> 0020',
12342: '<compat> 3012',
12344: '<compat> 5341',
12345: '<compat> 5344',
12346: '<compat> 5345',
12364: '304B 3099',
12366: '304D 3099',
12368: '304F 3099',
12370: '3051 3099',
12372: '3053 3099',
12374: '3055 3099',
12376: '3057 3099',
12378: '3059 3099',
12380: '305B 3099',
12382: '305D 3099',
12384: '305F 3099',
12386: '3061 3099',
12389: '3064 3099',
12391: '3066 3099',
12393: '3068 3099',
12400: '306F 3099',
12401: '306F 309A',
12403: '3072 3099',
12404: '3072 309A',
12406: '3075 3099',
12407: '3075 309A',
12409: '3078 3099',
12410: '3078 309A',
12412: '307B 3099',
12413: '307B 309A',
12436: '3046 3099',
12443: '<compat> 0020 3099',
12444: '<compat> 0020 309A',
12446: '309D 3099',
12447: '<vertical> 3088 308A',
12460: '30AB 3099',
12462: '30AD 3099',
12464: '30AF 3099',
12466: '30B1 3099',
12468: '30B3 3099',
12470: '30B5 3099',
12472: '30B7 3099',
12474: '30B9 3099',
12476: '30BB 3099',
12478: '30BD 3099',
12480: '30BF 3099',
12482: '30C1 3099',
12485: '30C4 3099',
12487: '30C6 3099',
12489: '30C8 3099',
12496: '30CF 3099',
12497: '30CF 309A',
12499: '30D2 3099',
12500: '30D2 309A',
12502: '30D5 3099',
12503: '30D5 309A',
12505: '30D8 3099',
12506: '30D8 309A',
12508: '30DB 3099',
12509: '30DB 309A',
12532: '30A6 3099',
12535: '30EF 3099',
12536: '30F0 3099',
12537: '30F1 3099',
12538: '30F2 3099',
12542: '30FD 3099',
12543: '<vertical> 30B3 30C8',
12593: '<compat> 1100',
12594: '<compat> 1101',
12595: '<compat> 11AA',
12596: '<compat> 1102',
12597: '<compat> 11AC',
12598: '<compat> 11AD',
12599: '<compat> 1103',
12600: '<compat> 1104',
12601: '<compat> 1105',
12602: '<compat> 11B0',
12603: '<compat> 11B1',
12604: '<compat> 11B2',
12605: '<compat> 11B3',
12606: '<compat> 11B4',
12607: '<compat> 11B5',
12608: '<compat> 111A',
12609: '<compat> 1106',
12610: '<compat> 1107',
12611: '<compat> 1108',
12612: '<compat> 1121',
12613: '<compat> 1109',
12614: '<compat> 110A',
12615: '<compat> 110B',
12616: '<compat> 110C',
12617: '<compat> 110D',
12618: '<compat> 110E',
12619: '<compat> 110F',
12620: '<compat> 1110',
12621: '<compat> 1111',
12622: '<compat> 1112',
12623: '<compat> 1161',
12624: '<compat> 1162',
12625: '<compat> 1163',
12626: '<compat> 1164',
12627: '<compat> 1165',
12628: '<compat> 1166',
12629: '<compat> 1167',
12630: '<compat> 1168',
12631: '<compat> 1169',
12632: '<compat> 116A',
12633: '<compat> 116B',
12634: '<compat> 116C',
12635: '<compat> 116D',
12636: '<compat> 116E',
12637: '<compat> 116F',
12638: '<compat> 1170',
12639: '<compat> 1171',
12640: '<compat> 1172',
12641: '<compat> 1173',
12642: '<compat> 1174',
12643: '<compat> 1175',
12644: '<compat> 1160',
12645: '<compat> 1114',
12646: '<compat> 1115',
12647: '<compat> 11C7',
12648: '<compat> 11C8',
12649: '<compat> 11CC',
12650: '<compat> 11CE',
12651: '<compat> 11D3',
12652: '<compat> 11D7',
12653: '<compat> 11D9',
12654: '<compat> 111C',
12655: '<compat> 11DD',
12656: '<compat> 11DF',
12657: '<compat> 111D',
12658: '<compat> 111E',
12659: '<compat> 1120',
12660: '<compat> 1122',
12661: '<compat> 1123',
12662: '<compat> 1127',
12663: '<compat> 1129',
12664: '<compat> 112B',
12665: '<compat> 112C',
12666: '<compat> 112D',
12667: '<compat> 112E',
12668: '<compat> 112F',
12669: '<compat> 1132',
12670: '<compat> 1136',
12671: '<compat> 1140',
12672: '<compat> 1147',
12673: '<compat> 114C',
12674: '<compat> 11F1',
12675: '<compat> 11F2',
12676: '<compat> 1157',
12677: '<compat> 1158',
12678: '<compat> 1159',
12679: '<compat> 1184',
12680: '<compat> 1185',
12681: '<compat> 1188',
12682: '<compat> 1191',
12683: '<compat> 1192',
12684: '<compat> 1194',
12685: '<compat> 119E',
12686: '<compat> 11A1',
12690: '<super> 4E00',
12691: '<super> 4E8C',
12692: '<super> 4E09',
12693: '<super> 56DB',
12694: '<super> 4E0A',
12695: '<super> 4E2D',
12696: '<super> 4E0B',
12697: '<super> 7532',
12698: '<super> 4E59',
12699: '<super> 4E19',
12700: '<super> 4E01',
12701: '<super> 5929',
12702: '<super> 5730',
12703: '<super> 4EBA',
12800: '<compat> 0028 1100 0029',
12801: '<compat> 0028 1102 0029',
12802: '<compat> 0028 1103 0029',
12803: '<compat> 0028 1105 0029',
12804: '<compat> 0028 1106 0029',
12805: '<compat> 0028 1107 0029',
12806: '<compat> 0028 1109 0029',
12807: '<compat> 0028 110B 0029',
12808: '<compat> 0028 110C 0029',
12809: '<compat> 0028 110E 0029',
12810: '<compat> 0028 110F 0029',
12811: '<compat> 0028 1110 0029',
12812: '<compat> 0028 1111 0029',
12813: '<compat> 0028 1112 0029',
12814: '<compat> 0028 1100 1161 0029',
12815: '<compat> 0028 1102 1161 0029',
12816: '<compat> 0028 1103 1161 0029',
12817: '<compat> 0028 1105 1161 0029',
12818: '<compat> 0028 1106 1161 0029',
12819: '<compat> 0028 1107 1161 0029',
12820: '<compat> 0028 1109 1161 0029',
12821: '<compat> 0028 110B 1161 0029',
12822: '<compat> 0028 110C 1161 0029',
12823: '<compat> 0028 110E 1161 0029',
12824: '<compat> 0028 110F 1161 0029',
12825: '<compat> 0028 1110 1161 0029',
12826: '<compat> 0028 1111 1161 0029',
12827: '<compat> 0028 1112 1161 0029',
12828: '<compat> 0028 110C 116E 0029',
12829: '<compat> 0028 110B 1169 110C 1165 11AB 0029',
12830: '<compat> 0028 110B 1169 1112 116E 0029',
12832: '<compat> 0028 4E00 0029',
12833: '<compat> 0028 4E8C 0029',
12834: '<compat> 0028 4E09 0029',
12835: '<compat> 0028 56DB 0029',
12836: '<compat> 0028 4E94 0029',
12837: '<compat> 0028 516D 0029',
12838: '<compat> 0028 4E03 0029',
12839: '<compat> 0028 516B 0029',
12840: '<compat> 0028 4E5D 0029',
12841: '<compat> 0028 5341 0029',
12842: '<compat> 0028 6708 0029',
12843: '<compat> 0028 706B 0029',
12844: '<compat> 0028 6C34 0029',
12845: '<compat> 0028 6728 0029',
12846: '<compat> 0028 91D1 0029',
12847: '<compat> 0028 571F 0029',
12848: '<compat> 0028 65E5 0029',
12849: '<compat> 0028 682A 0029',
12850: '<compat> 0028 6709 0029',
12851: '<compat> 0028 793E 0029',
12852: '<compat> 0028 540D 0029',
12853: '<compat> 0028 7279 0029',
12854: '<compat> 0028 8CA1 0029',
12855: '<compat> 0028 795D 0029',
12856: '<compat> 0028 52B4 0029',
12857: '<compat> 0028 4EE3 0029',
12858: '<compat> 0028 547C 0029',
12859: '<compat> 0028 5B66 0029',
12860: '<compat> 0028 76E3 0029',
12861: '<compat> 0028 4F01 0029',
12862: '<compat> 0028 8CC7 0029',
12863: '<compat> 0028 5354 0029',
12864: '<compat> 0028 796D 0029',
12865: '<compat> 0028 4F11 0029',
12866: '<compat> 0028 81EA 0029',
12867: '<compat> 0028 81F3 0029',
12880: '<square> 0050 0054 0045',
12881: '<circle> 0032 0031',
12882: '<circle> 0032 0032',
12883: '<circle> 0032 0033',
12884: '<circle> 0032 0034',
12885: '<circle> 0032 0035',
12886: '<circle> 0032 0036',
12887: '<circle> 0032 0037',
12888: '<circle> 0032 0038',
12889: '<circle> 0032 0039',
12890: '<circle> 0033 0030',
12891: '<circle> 0033 0031',
12892: '<circle> 0033 0032',
12893: '<circle> 0033 0033',
12894: '<circle> 0033 0034',
12895: '<circle> 0033 0035',
12896: '<circle> 1100',
12897: '<circle> 1102',
12898: '<circle> 1103',
12899: '<circle> 1105',
12900: '<circle> 1106',
12901: '<circle> 1107',
12902: '<circle> 1109',
12903: '<circle> 110B',
12904: '<circle> 110C',
12905: '<circle> 110E',
12906: '<circle> 110F',
12907: '<circle> 1110',
12908: '<circle> 1111',
12909: '<circle> 1112',
12910: '<circle> 1100 1161',
12911: '<circle> 1102 1161',
12912: '<circle> 1103 1161',
12913: '<circle> 1105 1161',
12914: '<circle> 1106 1161',
12915: '<circle> 1107 1161',
12916: '<circle> 1109 1161',
12917: '<circle> 110B 1161',
12918: '<circle> 110C 1161',
12919: '<circle> 110E 1161',
12920: '<circle> 110F 1161',
12921: '<circle> 1110 1161',
12922: '<circle> 1111 1161',
12923: '<circle> 1112 1161',
12924: '<circle> 110E 1161 11B7 1100 1169',
12925: '<circle> 110C 116E 110B 1174',
12926: '<circle> 110B 116E',
12928: '<circle> 4E00',
12929: '<circle> 4E8C',
12930: '<circle> 4E09',
12931: '<circle> 56DB',
12932: '<circle> 4E94',
12933: '<circle> 516D',
12934: '<circle> 4E03',
12935: '<circle> 516B',
12936: '<circle> 4E5D',
12937: '<circle> 5341',
12938: '<circle> 6708',
12939: '<circle> 706B',
12940: '<circle> 6C34',
12941: '<circle> 6728',
12942: '<circle> 91D1',
12943: '<circle> 571F',
12944: '<circle> 65E5',
12945: '<circle> 682A',
12946: '<circle> 6709',
12947: '<circle> 793E',
12948: '<circle> 540D',
12949: '<circle> 7279',
12950: '<circle> 8CA1',
12951: '<circle> 795D',
12952: '<circle> 52B4',
12953: '<circle> 79D8',
12954: '<circle> 7537',
12955: '<circle> 5973',
12956: '<circle> 9069',
12957: '<circle> 512A',
12958: '<circle> 5370',
12959: '<circle> 6CE8',
12960: '<circle> 9805',
12961: '<circle> 4F11',
12962: '<circle> 5199',
12963: '<circle> 6B63',
12964: '<circle> 4E0A',
12965: '<circle> 4E2D',
12966: '<circle> 4E0B',
12967: '<circle> 5DE6',
12968: '<circle> 53F3',
12969: '<circle> 533B',
12970: '<circle> 5B97',
12971: '<circle> 5B66',
12972: '<circle> 76E3',
12973: '<circle> 4F01',
12974: '<circle> 8CC7',
12975: '<circle> 5354',
12976: '<circle> 591C',
12977: '<circle> 0033 0036',
12978: '<circle> 0033 0037',
12979: '<circle> 0033 0038',
12980: '<circle> 0033 0039',
12981: '<circle> 0034 0030',
12982: '<circle> 0034 0031',
12983: '<circle> 0034 0032',
12984: '<circle> 0034 0033',
12985: '<circle> 0034 0034',
12986: '<circle> 0034 0035',
12987: '<circle> 0034 0036',
12988: '<circle> 0034 0037',
12989: '<circle> 0034 0038',
12990: '<circle> 0034 0039',
12991: '<circle> 0035 0030',
12992: '<compat> 0031 6708',
12993: '<compat> 0032 6708',
12994: '<compat> 0033 6708',
12995: '<compat> 0034 6708',
12996: '<compat> 0035 6708',
12997: '<compat> 0036 6708',
12998: '<compat> 0037 6708',
12999: '<compat> 0038 6708',
13000: '<compat> 0039 6708',
13001: '<compat> 0031 0030 6708',
13002: '<compat> 0031 0031 6708',
13003: '<compat> 0031 0032 6708',
13004: '<square> 0048 0067',
13005: '<square> 0065 0072 0067',
13006: '<square> 0065 0056',
13007: '<square> 004C 0054 0044',
13008: '<circle> 30A2',
13009: '<circle> 30A4',
13010: '<circle> 30A6',
13011: '<circle> 30A8',
13012: '<circle> 30AA',
13013: '<circle> 30AB',
13014: '<circle> 30AD',
13015: '<circle> 30AF',
13016: '<circle> 30B1',
13017: '<circle> 30B3',
13018: '<circle> 30B5',
13019: '<circle> 30B7',
13020: '<circle> 30B9',
13021: '<circle> 30BB',
13022: '<circle> 30BD',
13023: '<circle> 30BF',
13024: '<circle> 30C1',
13025: '<circle> 30C4',
13026: '<circle> 30C6',
13027: '<circle> 30C8',
13028: '<circle> 30CA',
13029: '<circle> 30CB',
13030: '<circle> 30CC',
13031: '<circle> 30CD',
13032: '<circle> 30CE',
13033: '<circle> 30CF',
13034: '<circle> 30D2',
13035: '<circle> 30D5',
13036: '<circle> 30D8',
13037: '<circle> 30DB',
13038: '<circle> 30DE',
13039: '<circle> 30DF',
13040: '<circle> 30E0',
13041: '<circle> 30E1',
13042: '<circle> 30E2',
13043: '<circle> 30E4',
13044: '<circle> 30E6',
13045: '<circle> 30E8',
13046: '<circle> 30E9',
13047: '<circle> 30EA',
13048: '<circle> 30EB',
13049: '<circle> 30EC',
13050: '<circle> 30ED',
13051: '<circle> 30EF',
13052: '<circle> 30F0',
13053: '<circle> 30F1',
13054: '<circle> 30F2',
13056: '<square> 30A2 30D1 30FC 30C8',
13057: '<square> 30A2 30EB 30D5 30A1',
13058: '<square> 30A2 30F3 30DA 30A2',
13059: '<square> 30A2 30FC 30EB',
13060: '<square> 30A4 30CB 30F3 30B0',
13061: '<square> 30A4 30F3 30C1',
13062: '<square> 30A6 30A9 30F3',
13063: '<square> 30A8 30B9 30AF 30FC 30C9',
13064: '<square> 30A8 30FC 30AB 30FC',
13065: '<square> 30AA 30F3 30B9',
13066: '<square> 30AA 30FC 30E0',
13067: '<square> 30AB 30A4 30EA',
13068: '<square> 30AB 30E9 30C3 30C8',
13069: '<square> 30AB 30ED 30EA 30FC',
13070: '<square> 30AC 30ED 30F3',
13071: '<square> 30AC 30F3 30DE',
13072: '<square> 30AE 30AC',
13073: '<square> 30AE 30CB 30FC',
13074: '<square> 30AD 30E5 30EA 30FC',
13075: '<square> 30AE 30EB 30C0 30FC',
13076: '<square> 30AD 30ED',
13077: '<square> 30AD 30ED 30B0 30E9 30E0',
13078: '<square> 30AD 30ED 30E1 30FC 30C8 30EB',
13079: '<square> 30AD 30ED 30EF 30C3 30C8',
13080: '<square> 30B0 30E9 30E0',
13081: '<square> 30B0 30E9 30E0 30C8 30F3',
13082: '<square> 30AF 30EB 30BC 30A4 30ED',
13083: '<square> 30AF 30ED 30FC 30CD',
13084: '<square> 30B1 30FC 30B9',
13085: '<square> 30B3 30EB 30CA',
13086: '<square> 30B3 30FC 30DD',
13087: '<square> 30B5 30A4 30AF 30EB',
13088: '<square> 30B5 30F3 30C1 30FC 30E0',
13089: '<square> 30B7 30EA 30F3 30B0',
13090: '<square> 30BB 30F3 30C1',
13091: '<square> 30BB 30F3 30C8',
13092: '<square> 30C0 30FC 30B9',
13093: '<square> 30C7 30B7',
13094: '<square> 30C9 30EB',
13095: '<square> 30C8 30F3',
13096: '<square> 30CA 30CE',
13097: '<square> 30CE 30C3 30C8',
13098: '<square> 30CF 30A4 30C4',
13099: '<square> 30D1 30FC 30BB 30F3 30C8',
13100: '<square> 30D1 30FC 30C4',
13101: '<square> 30D0 30FC 30EC 30EB',
13102: '<square> 30D4 30A2 30B9 30C8 30EB',
13103: '<square> 30D4 30AF 30EB',
13104: '<square> 30D4 30B3',
13105: '<square> 30D3 30EB',
13106: '<square> 30D5 30A1 30E9 30C3 30C9',
13107: '<square> 30D5 30A3 30FC 30C8',
13108: '<square> 30D6 30C3 30B7 30A7 30EB',
13109: '<square> 30D5 30E9 30F3',
13110: '<square> 30D8 30AF 30BF 30FC 30EB',
13111: '<square> 30DA 30BD',
13112: '<square> 30DA 30CB 30D2',
13113: '<square> 30D8 30EB 30C4',
13114: '<square> 30DA 30F3 30B9',
13115: '<square> 30DA 30FC 30B8',
13116: '<square> 30D9 30FC 30BF',
13117: '<square> 30DD 30A4 30F3 30C8',
13118: '<square> 30DC 30EB 30C8',
13119: '<square> 30DB 30F3',
13120: '<square> 30DD 30F3 30C9',
13121: '<square> 30DB 30FC 30EB',
13122: '<square> 30DB 30FC 30F3',
13123: '<square> 30DE 30A4 30AF 30ED',
13124: '<square> 30DE 30A4 30EB',
13125: '<square> 30DE 30C3 30CF',
13126: '<square> 30DE 30EB 30AF',
13127: '<square> 30DE 30F3 30B7 30E7 30F3',
13128: '<square> 30DF 30AF 30ED 30F3',
13129: '<square> 30DF 30EA',
13130: '<square> 30DF 30EA 30D0 30FC 30EB',
13131: '<square> 30E1 30AC',
13132: '<square> 30E1 30AC 30C8 30F3',
13133: '<square> 30E1 30FC 30C8 30EB',
13134: '<square> 30E4 30FC 30C9',
13135: '<square> 30E4 30FC 30EB',
13136: '<square> 30E6 30A2 30F3',
13137: '<square> 30EA 30C3 30C8 30EB',
13138: '<square> 30EA 30E9',
13139: '<square> 30EB 30D4 30FC',
13140: '<square> 30EB 30FC 30D6 30EB',
13141: '<square> 30EC 30E0',
13142: '<square> 30EC 30F3 30C8 30B2 30F3',
13143: '<square> 30EF 30C3 30C8',
13144: '<compat> 0030 70B9',
13145: '<compat> 0031 70B9',
13146: '<compat> 0032 70B9',
13147: '<compat> 0033 70B9',
13148: '<compat> 0034 70B9',
13149: '<compat> 0035 70B9',
13150: '<compat> 0036 70B9',
13151: '<compat> 0037 70B9',
13152: '<compat> 0038 70B9',
13153: '<compat> 0039 70B9',
13154: '<compat> 0031 0030 70B9',
13155: '<compat> 0031 0031 70B9',
13156: '<compat> 0031 0032 70B9',
13157: '<compat> 0031 0033 70B9',
13158: '<compat> 0031 0034 70B9',
13159: '<compat> 0031 0035 70B9',
13160: '<compat> 0031 0036 70B9',
13161: '<compat> 0031 0037 70B9',
13162: '<compat> 0031 0038 70B9',
13163: '<compat> 0031 0039 70B9',
13164: '<compat> 0032 0030 70B9',
13165: '<compat> 0032 0031 70B9',
13166: '<compat> 0032 0032 70B9',
13167: '<compat> 0032 0033 70B9',
13168: '<compat> 0032 0034 70B9',
13169: '<square> 0068 0050 0061',
13170: '<square> 0064 0061',
13171: '<square> 0041 0055',
13172: '<square> 0062 0061 0072',
13173: '<square> 006F 0056',
13174: '<square> 0070 0063',
13175: '<square> 0064 006D',
13176: '<square> 0064 006D 00B2',
13177: '<square> 0064 006D 00B3',
13178: '<square> 0049 0055',
13179: '<square> 5E73 6210',
13180: '<square> 662D 548C',
13181: '<square> 5927 6B63',
13182: '<square> 660E 6CBB',
13183: '<square> 682A 5F0F 4F1A 793E',
13184: '<square> 0070 0041',
13185: '<square> 006E 0041',
13186: '<square> 03BC 0041',
13187: '<square> 006D 0041',
13188: '<square> 006B 0041',
13189: '<square> 004B 0042',
13190: '<square> 004D 0042',
13191: '<square> 0047 0042',
13192: '<square> 0063 0061 006C',
13193: '<square> 006B 0063 0061 006C',
13194: '<square> 0070 0046',
13195: '<square> 006E 0046',
13196: '<square> 03BC 0046',
13197: '<square> 03BC 0067',
13198: '<square> 006D 0067',
13199: '<square> 006B 0067',
13200: '<square> 0048 007A',
13201: '<square> 006B 0048 007A',
13202: '<square> 004D 0048 007A',
13203: '<square> 0047 0048 007A',
13204: '<square> 0054 0048 007A',
13205: '<square> 03BC 2113',
13206: '<square> 006D 2113',
13207: '<square> 0064 2113',
13208: '<square> 006B 2113',
13209: '<square> 0066 006D',
13210: '<square> 006E 006D',
13211: '<square> 03BC 006D',
13212: '<square> 006D 006D',
13213: '<square> 0063 006D',
13214: '<square> 006B 006D',
13215: '<square> 006D 006D 00B2',
13216: '<square> 0063 006D 00B2',
13217: '<square> 006D 00B2',
13218: '<square> 006B 006D 00B2',
13219: '<square> 006D 006D 00B3',
13220: '<square> 0063 006D 00B3',
13221: '<square> 006D 00B3',
13222: '<square> 006B 006D 00B3',
13223: '<square> 006D 2215 0073',
13224: '<square> 006D 2215 0073 00B2',
13225: '<square> 0050 0061',
13226: '<square> 006B 0050 0061',
13227: '<square> 004D 0050 0061',
13228: '<square> 0047 0050 0061',
13229: '<square> 0072 0061 0064',
13230: '<square> 0072 0061 0064 2215 0073',
13231: '<square> 0072 0061 0064 2215 0073 00B2',
13232: '<square> 0070 0073',
13233: '<square> 006E 0073',
13234: '<square> 03BC 0073',
13235: '<square> 006D 0073',
13236: '<square> 0070 0056',
13237: '<square> 006E 0056',
13238: '<square> 03BC 0056',
13239: '<square> 006D 0056',
13240: '<square> 006B 0056',
13241: '<square> 004D 0056',
13242: '<square> 0070 0057',
13243: '<square> 006E 0057',
13244: '<square> 03BC 0057',
13245: '<square> 006D 0057',
13246: '<square> 006B 0057',
13247: '<square> 004D 0057',
13248: '<square> 006B 03A9',
13249: '<square> 004D 03A9',
13250: '<square> 0061 002E 006D 002E',
13251: '<square> 0042 0071',
13252: '<square> 0063 0063',
13253: '<square> 0063 0064',
13254: '<square> 0043 2215 006B 0067',
13255: '<square> 0043 006F 002E',
13256: '<square> 0064 0042',
13257: '<square> 0047 0079',
13258: '<square> 0068 0061',
13259: '<square> 0048 0050',
13260: '<square> 0069 006E',
13261: '<square> 004B 004B',
13262: '<square> 004B 004D',
13263: '<square> 006B 0074',
13264: '<square> 006C 006D',
13265: '<square> 006C 006E',
13266: '<square> 006C 006F 0067',
13267: '<square> 006C 0078',
13268: '<square> 006D 0062',
13269: '<square> 006D 0069 006C',
13270: '<square> 006D 006F 006C',
13271: '<square> 0050 0048',
13272: '<square> 0070 002E 006D 002E',
13273: '<square> 0050 0050 004D',
13274: '<square> 0050 0052',
13275: '<square> 0073 0072',
13276: '<square> 0053 0076',
13277: '<square> 0057 0062',
13278: '<square> 0056 2215 006D',
13279: '<square> 0041 2215 006D',
13280: '<compat> 0031 65E5',
13281: '<compat> 0032 65E5',
13282: '<compat> 0033 65E5',
13283: '<compat> 0034 65E5',
13284: '<compat> 0035 65E5',
13285: '<compat> 0036 65E5',
13286: '<compat> 0037 65E5',
13287: '<compat> 0038 65E5',
13288: '<compat> 0039 65E5',
13289: '<compat> 0031 0030 65E5',
13290: '<compat> 0031 0031 65E5',
13291: '<compat> 0031 0032 65E5',
13292: '<compat> 0031 0033 65E5',
13293: '<compat> 0031 0034 65E5',
13294: '<compat> 0031 0035 65E5',
13295: '<compat> 0031 0036 65E5',
13296: '<compat> 0031 0037 65E5',
13297: '<compat> 0031 0038 65E5',
13298: '<compat> 0031 0039 65E5',
13299: '<compat> 0032 0030 65E5',
13300: '<compat> 0032 0031 65E5',
13301: '<compat> 0032 0032 65E5',
13302: '<compat> 0032 0033 65E5',
13303: '<compat> 0032 0034 65E5',
13304: '<compat> 0032 0035 65E5',
13305: '<compat> 0032 0036 65E5',
13306: '<compat> 0032 0037 65E5',
13307: '<compat> 0032 0038 65E5',
13308: '<compat> 0032 0039 65E5',
13309: '<compat> 0033 0030 65E5',
13310: '<compat> 0033 0031 65E5',
13311: '<square> 0067 0061 006C',
63744: '8C48',
63745: '66F4',
63746: '8ECA',
63747: '8CC8',
63748: '6ED1',
63749: '4E32',
63750: '53E5',
63751: '9F9C',
63752: '9F9C',
63753: '5951',
63754: '91D1',
63755: '5587',
63756: '5948',
63757: '61F6',
63758: '7669',
63759: '7F85',
63760: '863F',
63761: '87BA',
63762: '88F8',
63763: '908F',
63764: '6A02',
63765: '6D1B',
63766: '70D9',
63767: '73DE',
63768: '843D',
63769: '916A',
63770: '99F1',
63771: '4E82',
63772: '5375',
63773: '6B04',
63774: '721B',
63775: '862D',
63776: '9E1E',
63777: '5D50',
63778: '6FEB',
63779: '85CD',
63780: '8964',
63781: '62C9',
63782: '81D8',
63783: '881F',
63784: '5ECA',
63785: '6717',
63786: '6D6A',
63787: '72FC',
63788: '90CE',
63789: '4F86',
63790: '51B7',
63791: '52DE',
63792: '64C4',
63793: '6AD3',
63794: '7210',
63795: '76E7',
63796: '8001',
63797: '8606',
63798: '865C',
63799: '8DEF',
63800: '9732',
63801: '9B6F',
63802: '9DFA',
63803: '788C',
63804: '797F',
63805: '7DA0',
63806: '83C9',
63807: '9304',
63808: '9E7F',
63809: '8AD6',
63810: '58DF',
63811: '5F04',
63812: '7C60',
63813: '807E',
63814: '7262',
63815: '78CA',
63816: '8CC2',
63817: '96F7',
63818: '58D8',
63819: '5C62',
63820: '6A13',
63821: '6DDA',
63822: '6F0F',
63823: '7D2F',
63824: '7E37',
63825: '964B',
63826: '52D2',
63827: '808B',
63828: '51DC',
63829: '51CC',
63830: '7A1C',
63831: '7DBE',
63832: '83F1',
63833: '9675',
63834: '8B80',
63835: '62CF',
63836: '6A02',
63837: '8AFE',
63838: '4E39',
63839: '5BE7',
63840: '6012',
63841: '7387',
63842: '7570',
63843: '5317',
63844: '78FB',
63845: '4FBF',
63846: '5FA9',
63847: '4E0D',
63848: '6CCC',
63849: '6578',
63850: '7D22',
63851: '53C3',
63852: '585E',
63853: '7701',
63854: '8449',
63855: '8AAA',
63856: '6BBA',
63857: '8FB0',
63858: '6C88',
63859: '62FE',
63860: '82E5',
63861: '63A0',
63862: '7565',
63863: '4EAE',
63864: '5169',
63865: '51C9',
63866: '6881',
63867: '7CE7',
63868: '826F',
63869: '8AD2',
63870: '91CF',
63871: '52F5',
63872: '5442',
63873: '5973',
63874: '5EEC',
63875: '65C5',
63876: '6FFE',
63877: '792A',
63878: '95AD',
63879: '9A6A',
63880: '9E97',
63881: '9ECE',
63882: '529B',
63883: '66C6',
63884: '6B77',
63885: '8F62',
63886: '5E74',
63887: '6190',
63888: '6200',
63889: '649A',
63890: '6F23',
63891: '7149',
63892: '7489',
63893: '79CA',
63894: '7DF4',
63895: '806F',
63896: '8F26',
63897: '84EE',
63898: '9023',
63899: '934A',
63900: '5217',
63901: '52A3',
63902: '54BD',
63903: '70C8',
63904: '88C2',
63905: '8AAA',
63906: '5EC9',
63907: '5FF5',
63908: '637B',
63909: '6BAE',
63910: '7C3E',
63911: '7375',
63912: '4EE4',
63913: '56F9',
63914: '5BE7',
63915: '5DBA',
63916: '601C',
63917: '73B2',
63918: '7469',
63919: '7F9A',
63920: '8046',
63921: '9234',
63922: '96F6',
63923: '9748',
63924: '9818',
63925: '4F8B',
63926: '79AE',
63927: '91B4',
63928: '96B8',
63929: '60E1',
63930: '4E86',
63931: '50DA',
63932: '5BEE',
63933: '5C3F',
63934: '6599',
63935: '6A02',
63936: '71CE',
63937: '7642',
63938: '84FC',
63939: '907C',
63940: '9F8D',
63941: '6688',
63942: '962E',
63943: '5289',
63944: '677B',
63945: '67F3',
63946: '6D41',
63947: '6E9C',
63948: '7409',
63949: '7559',
63950: '786B',
63951: '7D10',
63952: '985E',
63953: '516D',
63954: '622E',
63955: '9678',
63956: '502B',
63957: '5D19',
63958: '6DEA',
63959: '8F2A',
63960: '5F8B',
63961: '6144',
63962: '6817',
63963: '7387',
63964: '9686',
63965: '5229',
63966: '540F',
63967: '5C65',
63968: '6613',
63969: '674E',
63970: '68A8',
63971: '6CE5',
63972: '7406',
63973: '75E2',
63974: '7F79',
63975: '88CF',
63976: '88E1',
63977: '91CC',
63978: '96E2',
63979: '533F',
63980: '6EBA',
63981: '541D',
63982: '71D0',
63983: '7498',
63984: '85FA',
63985: '96A3',
63986: '9C57',
63987: '9E9F',
63988: '6797',
63989: '6DCB',
63990: '81E8',
63991: '7ACB',
63992: '7B20',
63993: '7C92',
63994: '72C0',
63995: '7099',
63996: '8B58',
63997: '4EC0',
63998: '8336',
63999: '523A',
64000: '5207',
64001: '5EA6',
64002: '62D3',
64003: '7CD6',
64004: '5B85',
64005: '6D1E',
64006: '66B4',
64007: '8F3B',
64008: '884C',
64009: '964D',
64010: '898B',
64011: '5ED3',
64012: '5140',
64013: '55C0',
64016: '585A',
64018: '6674',
64021: '51DE',
64022: '732A',
64023: '76CA',
64024: '793C',
64025: '795E',
64026: '7965',
64027: '798F',
64028: '9756',
64029: '7CBE',
64030: '7FBD',
64032: '8612',
64034: '8AF8',
64037: '9038',
64038: '90FD',
64042: '98EF',
64043: '98FC',
64044: '9928',
64045: '9DB4',
64048: '4FAE',
64049: '50E7',
64050: '514D',
64051: '52C9',
64052: '52E4',
64053: '5351',
64054: '559D',
64055: '5606',
64056: '5668',
64057: '5840',
64058: '58A8',
64059: '5C64',
64060: '5C6E',
64061: '6094',
64062: '6168',
64063: '618E',
64064: '61F2',
64065: '654F',
64066: '65E2',
64067: '6691',
64068: '6885',
64069: '6D77',
64070: '6E1A',
64071: '6F22',
64072: '716E',
64073: '722B',
64074: '7422',
64075: '7891',
64076: '793E',
64077: '7949',
64078: '7948',
64079: '7950',
64080: '7956',
64081: '795D',
64082: '798D',
64083: '798E',
64084: '7A40',
64085: '7A81',
64086: '7BC0',
64087: '7DF4',
64088: '7E09',
64089: '7E41',
64090: '7F72',
64091: '8005',
64092: '81ED',
64093: '8279',
64094: '8279',
64095: '8457',
64096: '8910',
64097: '8996',
64098: '8B01',
64099: '8B39',
64100: '8CD3',
64101: '8D08',
64102: '8FB6',
64103: '9038',
64104: '96E3',
64105: '97FF',
64106: '983B',
64112: '4E26',
64113: '51B5',
64114: '5168',
64115: '4F80',
64116: '5145',
64117: '5180',
64118: '52C7',
64119: '52FA',
64120: '559D',
64121: '5555',
64122: '5599',
64123: '55E2',
64124: '585A',
64125: '58B3',
64126: '5944',
64127: '5954',
64128: '5A62',
64129: '5B28',
64130: '5ED2',
64131: '5ED9',
64132: '5F69',
64133: '5FAD',
64134: '60D8',
64135: '614E',
64136: '6108',
64137: '618E',
64138: '6160',
64139: '61F2',
64140: '6234',
64141: '63C4',
64142: '641C',
64143: '6452',
64144: '6556',
64145: '6674',
64146: '6717',
64147: '671B',
64148: '6756',
64149: '6B79',
64150: '6BBA',
64151: '6D41',
64152: '6EDB',
64153: '6ECB',
64154: '6F22',
64155: '701E',
64156: '716E',
64157: '77A7',
64158: '7235',
64159: '72AF',
64160: '732A',
64161: '7471',
64162: '7506',
64163: '753B',
64164: '761D',
64165: '761F',
64166: '76CA',
64167: '76DB',
64168: '76F4',
64169: '774A',
64170: '7740',
64171: '78CC',
64172: '7AB1',
64173: '7BC0',
64174: '7C7B',
64175: '7D5B',
64176: '7DF4',
64177: '7F3E',
64178: '8005',
64179: '8352',
64180: '83EF',
64181: '8779',
64182: '8941',
64183: '8986',
64184: '8996',
64185: '8ABF',
64186: '8AF8',
64187: '8ACB',
64188: '8B01',
64189: '8AFE',
64190: '8AED',
64191: '8B39',
64192: '8B8A',
64193: '8D08',
64194: '8F38',
64195: '9072',
64196: '9199',
64197: '9276',
64198: '967C',
64199: '96E3',
64200: '9756',
64201: '97DB',
64202: '97FF',
64203: '980B',
64204: '983B',
64205: '9B12',
64206: '9F9C',
64207: '2284A',
64208: '22844',
64209: '233D5',
64210: '3B9D',
64211: '4018',
64212: '4039',
64213: '25249',
64214: '25CD0',
64215: '27ED3',
64216: '9F43',
64217: '9F8E',
64256: '<compat> 0066 0066',
64257: '<compat> 0066 0069',
64258: '<compat> 0066 006C',
64259: '<compat> 0066 0066 0069',
64260: '<compat> 0066 0066 006C',
64261: '<compat> 017F 0074',
64262: '<compat> 0073 0074',
64275: '<compat> 0574 0576',
64276: '<compat> 0574 0565',
64277: '<compat> 0574 056B',
64278: '<compat> 057E 0576',
64279: '<compat> 0574 056D',
64285: '05D9 05B4',
64287: '05F2 05B7',
64288: '<font> 05E2',
64289: '<font> 05D0',
64290: '<font> 05D3',
64291: '<font> 05D4',
64292: '<font> 05DB',
64293: '<font> 05DC',
64294: '<font> 05DD',
64295: '<font> 05E8',
64296: '<font> 05EA',
64297: '<font> 002B',
64298: '05E9 05C1',
64299: '05E9 05C2',
64300: 'FB49 05C1',
64301: 'FB49 05C2',
64302: '05D0 05B7',
64303: '05D0 05B8',
64304: '05D0 05BC',
64305: '05D1 05BC',
64306: '05D2 05BC',
64307: '05D3 05BC',
64308: '05D4 05BC',
64309: '05D5 05BC',
64310: '05D6 05BC',
64312: '05D8 05BC',
64313: '05D9 05BC',
64314: '05DA 05BC',
64315: '05DB 05BC',
64316: '05DC 05BC',
64318: '05DE 05BC',
64320: '05E0 05BC',
64321: '05E1 05BC',
64323: '05E3 05BC',
64324: '05E4 05BC',
64326: '05E6 05BC',
64327: '05E7 05BC',
64328: '05E8 05BC',
64329: '05E9 05BC',
64330: '05EA 05BC',
64331: '05D5 05B9',
64332: '05D1 05BF',
64333: '05DB 05BF',
64334: '05E4 05BF',
64335: '<compat> 05D0 05DC',
64336: '<isolated> 0671',
64337: '<final> 0671',
64338: '<isolated> 067B',
64339: '<final> 067B',
64340: '<initial> 067B',
64341: '<medial> 067B',
64342: '<isolated> 067E',
64343: '<final> 067E',
64344: '<initial> 067E',
64345: '<medial> 067E',
64346: '<isolated> 0680',
64347: '<final> 0680',
64348: '<initial> 0680',
64349: '<medial> 0680',
64350: '<isolated> 067A',
64351: '<final> 067A',
64352: '<initial> 067A',
64353: '<medial> 067A',
64354: '<isolated> 067F',
64355: '<final> 067F',
64356: '<initial> 067F',
64357: '<medial> 067F',
64358: '<isolated> 0679',
64359: '<final> 0679',
64360: '<initial> 0679',
64361: '<medial> 0679',
64362: '<isolated> 06A4',
64363: '<final> 06A4',
64364: '<initial> 06A4',
64365: '<medial> 06A4',
64366: '<isolated> 06A6',
64367: '<final> 06A6',
64368: '<initial> 06A6',
64369: '<medial> 06A6',
64370: '<isolated> 0684',
64371: '<final> 0684',
64372: '<initial> 0684',
64373: '<medial> 0684',
64374: '<isolated> 0683',
64375: '<final> 0683',
64376: '<initial> 0683',
64377: '<medial> 0683',
64378: '<isolated> 0686',
64379: '<final> 0686',
64380: '<initial> 0686',
64381: '<medial> 0686',
64382: '<isolated> 0687',
64383: '<final> 0687',
64384: '<initial> 0687',
64385: '<medial> 0687',
64386: '<isolated> 068D',
64387: '<final> 068D',
64388: '<isolated> 068C',
64389: '<final> 068C',
64390: '<isolated> 068E',
64391: '<final> 068E',
64392: '<isolated> 0688',
64393: '<final> 0688',
64394: '<isolated> 0698',
64395: '<final> 0698',
64396: '<isolated> 0691',
64397: '<final> 0691',
64398: '<isolated> 06A9',
64399: '<final> 06A9',
64400: '<initial> 06A9',
64401: '<medial> 06A9',
64402: '<isolated> 06AF',
64403: '<final> 06AF',
64404: '<initial> 06AF',
64405: '<medial> 06AF',
64406: '<isolated> 06B3',
64407: '<final> 06B3',
64408: '<initial> 06B3',
64409: '<medial> 06B3',
64410: '<isolated> 06B1',
64411: '<final> 06B1',
64412: '<initial> 06B1',
64413: '<medial> 06B1',
64414: '<isolated> 06BA',
64415: '<final> 06BA',
64416: '<isolated> 06BB',
64417: '<final> 06BB',
64418: '<initial> 06BB',
64419: '<medial> 06BB',
64420: '<isolated> 06C0',
64421: '<final> 06C0',
64422: '<isolated> 06C1',
64423: '<final> 06C1',
64424: '<initial> 06C1',
64425: '<medial> 06C1',
64426: '<isolated> 06BE',
64427: '<final> 06BE',
64428: '<initial> 06BE',
64429: '<medial> 06BE',
64430: '<isolated> 06D2',
64431: '<final> 06D2',
64432: '<isolated> 06D3',
64433: '<final> 06D3',
64467: '<isolated> 06AD',
64468: '<final> 06AD',
64469: '<initial> 06AD',
64470: '<medial> 06AD',
64471: '<isolated> 06C7',
64472: '<final> 06C7',
64473: '<isolated> 06C6',
64474: '<final> 06C6',
64475: '<isolated> 06C8',
64476: '<final> 06C8',
64477: '<isolated> 0677',
64478: '<isolated> 06CB',
64479: '<final> 06CB',
64480: '<isolated> 06C5',
64481: '<final> 06C5',
64482: '<isolated> 06C9',
64483: '<final> 06C9',
64484: '<isolated> 06D0',
64485: '<final> 06D0',
64486: '<initial> 06D0',
64487: '<medial> 06D0',
64488: '<initial> 0649',
64489: '<medial> 0649',
64490: '<isolated> 0626 0627',
64491: '<final> 0626 0627',
64492: '<isolated> 0626 06D5',
64493: '<final> 0626 06D5',
64494: '<isolated> 0626 0648',
64495: '<final> 0626 0648',
64496: '<isolated> 0626 06C7',
64497: '<final> 0626 06C7',
64498: '<isolated> 0626 06C6',
64499: '<final> 0626 06C6',
64500: '<isolated> 0626 06C8',
64501: '<final> 0626 06C8',
64502: '<isolated> 0626 06D0',
64503: '<final> 0626 06D0',
64504: '<initial> 0626 06D0',
64505: '<isolated> 0626 0649',
64506: '<final> 0626 0649',
64507: '<initial> 0626 0649',
64508: '<isolated> 06CC',
64509: '<final> 06CC',
64510: '<initial> 06CC',
64511: '<medial> 06CC',
64512: '<isolated> 0626 062C',
64513: '<isolated> 0626 062D',
64514: '<isolated> 0626 0645',
64515: '<isolated> 0626 0649',
64516: '<isolated> 0626 064A',
64517: '<isolated> 0628 062C',
64518: '<isolated> 0628 062D',
64519: '<isolated> 0628 062E',
64520: '<isolated> 0628 0645',
64521: '<isolated> 0628 0649',
64522: '<isolated> 0628 064A',
64523: '<isolated> 062A 062C',
64524: '<isolated> 062A 062D',
64525: '<isolated> 062A 062E',
64526: '<isolated> 062A 0645',
64527: '<isolated> 062A 0649',
64528: '<isolated> 062A 064A',
64529: '<isolated> 062B 062C',
64530: '<isolated> 062B 0645',
64531: '<isolated> 062B 0649',
64532: '<isolated> 062B 064A',
64533: '<isolated> 062C 062D',
64534: '<isolated> 062C 0645',
64535: '<isolated> 062D 062C',
64536: '<isolated> 062D 0645',
64537: '<isolated> 062E 062C',
64538: '<isolated> 062E 062D',
64539: '<isolated> 062E 0645',
64540: '<isolated> 0633 062C',
64541: '<isolated> 0633 062D',
64542: '<isolated> 0633 062E',
64543: '<isolated> 0633 0645',
64544: '<isolated> 0635 062D',
64545: '<isolated> 0635 0645',
64546: '<isolated> 0636 062C',
64547: '<isolated> 0636 062D',
64548: '<isolated> 0636 062E',
64549: '<isolated> 0636 0645',
64550: '<isolated> 0637 062D',
64551: '<isolated> 0637 0645',
64552: '<isolated> 0638 0645',
64553: '<isolated> 0639 062C',
64554: '<isolated> 0639 0645',
64555: '<isolated> 063A 062C',
64556: '<isolated> 063A 0645',
64557: '<isolated> 0641 062C',
64558: '<isolated> 0641 062D',
64559: '<isolated> 0641 062E',
64560: '<isolated> 0641 0645',
64561: '<isolated> 0641 0649',
64562: '<isolated> 0641 064A',
64563: '<isolated> 0642 062D',
64564: '<isolated> 0642 0645',
64565: '<isolated> 0642 0649',
64566: '<isolated> 0642 064A',
64567: '<isolated> 0643 0627',
64568: '<isolated> 0643 062C',
64569: '<isolated> 0643 062D',
64570: '<isolated> 0643 062E',
64571: '<isolated> 0643 0644',
64572: '<isolated> 0643 0645',
64573: '<isolated> 0643 0649',
64574: '<isolated> 0643 064A',
64575: '<isolated> 0644 062C',
64576: '<isolated> 0644 062D',
64577: '<isolated> 0644 062E',
64578: '<isolated> 0644 0645',
64579: '<isolated> 0644 0649',
64580: '<isolated> 0644 064A',
64581: '<isolated> 0645 062C',
64582: '<isolated> 0645 062D',
64583: '<isolated> 0645 062E',
64584: '<isolated> 0645 0645',
64585: '<isolated> 0645 0649',
64586: '<isolated> 0645 064A',
64587: '<isolated> 0646 062C',
64588: '<isolated> 0646 062D',
64589: '<isolated> 0646 062E',
64590: '<isolated> 0646 0645',
64591: '<isolated> 0646 0649',
64592: '<isolated> 0646 064A',
64593: '<isolated> 0647 062C',
64594: '<isolated> 0647 0645',
64595: '<isolated> 0647 0649',
64596: '<isolated> 0647 064A',
64597: '<isolated> 064A 062C',
64598: '<isolated> 064A 062D',
64599: '<isolated> 064A 062E',
64600: '<isolated> 064A 0645',
64601: '<isolated> 064A 0649',
64602: '<isolated> 064A 064A',
64603: '<isolated> 0630 0670',
64604: '<isolated> 0631 0670',
64605: '<isolated> 0649 0670',
64606: '<isolated> 0020 064C 0651',
64607: '<isolated> 0020 064D 0651',
64608: '<isolated> 0020 064E 0651',
64609: '<isolated> 0020 064F 0651',
64610: '<isolated> 0020 0650 0651',
64611: '<isolated> 0020 0651 0670',
64612: '<final> 0626 0631',
64613: '<final> 0626 0632',
64614: '<final> 0626 0645',
64615: '<final> 0626 0646',
64616: '<final> 0626 0649',
64617: '<final> 0626 064A',
64618: '<final> 0628 0631',
64619: '<final> 0628 0632',
64620: '<final> 0628 0645',
64621: '<final> 0628 0646',
64622: '<final> 0628 0649',
64623: '<final> 0628 064A',
64624: '<final> 062A 0631',
64625: '<final> 062A 0632',
64626: '<final> 062A 0645',
64627: '<final> 062A 0646',
64628: '<final> 062A 0649',
64629: '<final> 062A 064A',
64630: '<final> 062B 0631',
64631: '<final> 062B 0632',
64632: '<final> 062B 0645',
64633: '<final> 062B 0646',
64634: '<final> 062B 0649',
64635: '<final> 062B 064A',
64636: '<final> 0641 0649',
64637: '<final> 0641 064A',
64638: '<final> 0642 0649',
64639: '<final> 0642 064A',
64640: '<final> 0643 0627',
64641: '<final> 0643 0644',
64642: '<final> 0643 0645',
64643: '<final> 0643 0649',
64644: '<final> 0643 064A',
64645: '<final> 0644 0645',
64646: '<final> 0644 0649',
64647: '<final> 0644 064A',
64648: '<final> 0645 0627',
64649: '<final> 0645 0645',
64650: '<final> 0646 0631',
64651: '<final> 0646 0632',
64652: '<final> 0646 0645',
64653: '<final> 0646 0646',
64654: '<final> 0646 0649',
64655: '<final> 0646 064A',
64656: '<final> 0649 0670',
64657: '<final> 064A 0631',
64658: '<final> 064A 0632',
64659: '<final> 064A 0645',
64660: '<final> 064A 0646',
64661: '<final> 064A 0649',
64662: '<final> 064A 064A',
64663: '<initial> 0626 062C',
64664: '<initial> 0626 062D',
64665: '<initial> 0626 062E',
64666: '<initial> 0626 0645',
64667: '<initial> 0626 0647',
64668: '<initial> 0628 062C',
64669: '<initial> 0628 062D',
64670: '<initial> 0628 062E',
64671: '<initial> 0628 0645',
64672: '<initial> 0628 0647',
64673: '<initial> 062A 062C',
64674: '<initial> 062A 062D',
64675: '<initial> 062A 062E',
64676: '<initial> 062A 0645',
64677: '<initial> 062A 0647',
64678: '<initial> 062B 0645',
64679: '<initial> 062C 062D',
64680: '<initial> 062C 0645',
64681: '<initial> 062D 062C',
64682: '<initial> 062D 0645',
64683: '<initial> 062E 062C',
64684: '<initial> 062E 0645',
64685: '<initial> 0633 062C',
64686: '<initial> 0633 062D',
64687: '<initial> 0633 062E',
64688: '<initial> 0633 0645',
64689: '<initial> 0635 062D',
64690: '<initial> 0635 062E',
64691: '<initial> 0635 0645',
64692: '<initial> 0636 062C',
64693: '<initial> 0636 062D',
64694: '<initial> 0636 062E',
64695: '<initial> 0636 0645',
64696: '<initial> 0637 062D',
64697: '<initial> 0638 0645',
64698: '<initial> 0639 062C',
64699: '<initial> 0639 0645',
64700: '<initial> 063A 062C',
64701: '<initial> 063A 0645',
64702: '<initial> 0641 062C',
64703: '<initial> 0641 062D',
64704: '<initial> 0641 062E',
64705: '<initial> 0641 0645',
64706: '<initial> 0642 062D',
64707: '<initial> 0642 0645',
64708: '<initial> 0643 062C',
64709: '<initial> 0643 062D',
64710: '<initial> 0643 062E',
64711: '<initial> 0643 0644',
64712: '<initial> 0643 0645',
64713: '<initial> 0644 062C',
64714: '<initial> 0644 062D',
64715: '<initial> 0644 062E',
64716: '<initial> 0644 0645',
64717: '<initial> 0644 0647',
64718: '<initial> 0645 062C',
64719: '<initial> 0645 062D',
64720: '<initial> 0645 062E',
64721: '<initial> 0645 0645',
64722: '<initial> 0646 062C',
64723: '<initial> 0646 062D',
64724: '<initial> 0646 062E',
64725: '<initial> 0646 0645',
64726: '<initial> 0646 0647',
64727: '<initial> 0647 062C',
64728: '<initial> 0647 0645',
64729: '<initial> 0647 0670',
64730: '<initial> 064A 062C',
64731: '<initial> 064A 062D',
64732: '<initial> 064A 062E',
64733: '<initial> 064A 0645',
64734: '<initial> 064A 0647',
64735: '<medial> 0626 0645',
64736: '<medial> 0626 0647',
64737: '<medial> 0628 0645',
64738: '<medial> 0628 0647',
64739: '<medial> 062A 0645',
64740: '<medial> 062A 0647',
64741: '<medial> 062B 0645',
64742: '<medial> 062B 0647',
64743: '<medial> 0633 0645',
64744: '<medial> 0633 0647',
64745: '<medial> 0634 0645',
64746: '<medial> 0634 0647',
64747: '<medial> 0643 0644',
64748: '<medial> 0643 0645',
64749: '<medial> 0644 0645',
64750: '<medial> 0646 0645',
64751: '<medial> 0646 0647',
64752: '<medial> 064A 0645',
64753: '<medial> 064A 0647',
64754: '<medial> 0640 064E 0651',
64755: '<medial> 0640 064F 0651',
64756: '<medial> 0640 0650 0651',
64757: '<isolated> 0637 0649',
64758: '<isolated> 0637 064A',
64759: '<isolated> 0639 0649',
64760: '<isolated> 0639 064A',
64761: '<isolated> 063A 0649',
64762: '<isolated> 063A 064A',
64763: '<isolated> 0633 0649',
64764: '<isolated> 0633 064A',
64765: '<isolated> 0634 0649',
64766: '<isolated> 0634 064A',
64767: '<isolated> 062D 0649',
64768: '<isolated> 062D 064A',
64769: '<isolated> 062C 0649',
64770: '<isolated> 062C 064A',
64771: '<isolated> 062E 0649',
64772: '<isolated> 062E 064A',
64773: '<isolated> 0635 0649',
64774: '<isolated> 0635 064A',
64775: '<isolated> 0636 0649',
64776: '<isolated> 0636 064A',
64777: '<isolated> 0634 062C',
64778: '<isolated> 0634 062D',
64779: '<isolated> 0634 062E',
64780: '<isolated> 0634 0645',
64781: '<isolated> 0634 0631',
64782: '<isolated> 0633 0631',
64783: '<isolated> 0635 0631',
64784: '<isolated> 0636 0631',
64785: '<final> 0637 0649',
64786: '<final> 0637 064A',
64787: '<final> 0639 0649',
64788: '<final> 0639 064A',
64789: '<final> 063A 0649',
64790: '<final> 063A 064A',
64791: '<final> 0633 0649',
64792: '<final> 0633 064A',
64793: '<final> 0634 0649',
64794: '<final> 0634 064A',
64795: '<final> 062D 0649',
64796: '<final> 062D 064A',
64797: '<final> 062C 0649',
64798: '<final> 062C 064A',
64799: '<final> 062E 0649',
64800: '<final> 062E 064A',
64801: '<final> 0635 0649',
64802: '<final> 0635 064A',
64803: '<final> 0636 0649',
64804: '<final> 0636 064A',
64805: '<final> 0634 062C',
64806: '<final> 0634 062D',
64807: '<final> 0634 062E',
64808: '<final> 0634 0645',
64809: '<final> 0634 0631',
64810: '<final> 0633 0631',
64811: '<final> 0635 0631',
64812: '<final> 0636 0631',
64813: '<initial> 0634 062C',
64814: '<initial> 0634 062D',
64815: '<initial> 0634 062E',
64816: '<initial> 0634 0645',
64817: '<initial> 0633 0647',
64818: '<initial> 0634 0647',
64819: '<initial> 0637 0645',
64820: '<medial> 0633 062C',
64821: '<medial> 0633 062D',
64822: '<medial> 0633 062E',
64823: '<medial> 0634 062C',
64824: '<medial> 0634 062D',
64825: '<medial> 0634 062E',
64826: '<medial> 0637 0645',
64827: '<medial> 0638 0645',
64828: '<final> 0627 064B',
64829: '<isolated> 0627 064B',
64848: '<initial> 062A 062C 0645',
64849: '<final> 062A 062D 062C',
64850: '<initial> 062A 062D 062C',
64851: '<initial> 062A 062D 0645',
64852: '<initial> 062A 062E 0645',
64853: '<initial> 062A 0645 062C',
64854: '<initial> 062A 0645 062D',
64855: '<initial> 062A 0645 062E',
64856: '<final> 062C 0645 062D',
64857: '<initial> 062C 0645 062D',
64858: '<final> 062D 0645 064A',
64859: '<final> 062D 0645 0649',
64860: '<initial> 0633 062D 062C',
64861: '<initial> 0633 062C 062D',
64862: '<final> 0633 062C 0649',
64863: '<final> 0633 0645 062D',
64864: '<initial> 0633 0645 062D',
64865: '<initial> 0633 0645 062C',
64866: '<final> 0633 0645 0645',
64867: '<initial> 0633 0645 0645',
64868: '<final> 0635 062D 062D',
64869: '<initial> 0635 062D 062D',
64870: '<final> 0635 0645 0645',
64871: '<final> 0634 062D 0645',
64872: '<initial> 0634 062D 0645',
64873: '<final> 0634 062C 064A',
64874: '<final> 0634 0645 062E',
64875: '<initial> 0634 0645 062E',
64876: '<final> 0634 0645 0645',
64877: '<initial> 0634 0645 0645',
64878: '<final> 0636 062D 0649',
64879: '<final> 0636 062E 0645',
64880: '<initial> 0636 062E 0645',
64881: '<final> 0637 0645 062D',
64882: '<initial> 0637 0645 062D',
64883: '<initial> 0637 0645 0645',
64884: '<final> 0637 0645 064A',
64885: '<final> 0639 062C 0645',
64886: '<final> 0639 0645 0645',
64887: '<initial> 0639 0645 0645',
64888: '<final> 0639 0645 0649',
64889: '<final> 063A 0645 0645',
64890: '<final> 063A 0645 064A',
64891: '<final> 063A 0645 0649',
64892: '<final> 0641 062E 0645',
64893: '<initial> 0641 062E 0645',
64894: '<final> 0642 0645 062D',
64895: '<final> 0642 0645 0645',
64896: '<final> 0644 062D 0645',
64897: '<final> 0644 062D 064A',
64898: '<final> 0644 062D 0649',
64899: '<initial> 0644 062C 062C',
64900: '<final> 0644 062C 062C',
64901: '<final> 0644 062E 0645',
64902: '<initial> 0644 062E 0645',
64903: '<final> 0644 0645 062D',
64904: '<initial> 0644 0645 062D',
64905: '<initial> 0645 062D 062C',
64906: '<initial> 0645 062D 0645',
64907: '<final> 0645 062D 064A',
64908: '<initial> 0645 062C 062D',
64909: '<initial> 0645 062C 0645',
64910: '<initial> 0645 062E 062C',
64911: '<initial> 0645 062E 0645',
64914: '<initial> 0645 062C 062E',
64915: '<initial> 0647 0645 062C',
64916: '<initial> 0647 0645 0645',
64917: '<initial> 0646 062D 0645',
64918: '<final> 0646 062D 0649',
64919: '<final> 0646 062C 0645',
64920: '<initial> 0646 062C 0645',
64921: '<final> 0646 062C 0649',
64922: '<final> 0646 0645 064A',
64923: '<final> 0646 0645 0649',
64924: '<final> 064A 0645 0645',
64925: '<initial> 064A 0645 0645',
64926: '<final> 0628 062E 064A',
64927: '<final> 062A 062C 064A',
64928: '<final> 062A 062C 0649',
64929: '<final> 062A 062E 064A',
64930: '<final> 062A 062E 0649',
64931: '<final> 062A 0645 064A',
64932: '<final> 062A 0645 0649',
64933: '<final> 062C 0645 064A',
64934: '<final> 062C 062D 0649',
64935: '<final> 062C 0645 0649',
64936: '<final> 0633 062E 0649',
64937: '<final> 0635 062D 064A',
64938: '<final> 0634 062D 064A',
64939: '<final> 0636 062D 064A',
64940: '<final> 0644 062C 064A',
64941: '<final> 0644 0645 064A',
64942: '<final> 064A 062D 064A',
64943: '<final> 064A 062C 064A',
64944: '<final> 064A 0645 064A',
64945: '<final> 0645 0645 064A',
64946: '<final> 0642 0645 064A',
64947: '<final> 0646 062D 064A',
64948: '<initial> 0642 0645 062D',
64949: '<initial> 0644 062D 0645',
64950: '<final> 0639 0645 064A',
64951: '<final> 0643 0645 064A',
64952: '<initial> 0646 062C 062D',
64953: '<final> 0645 062E 064A',
64954: '<initial> 0644 062C 0645',
64955: '<final> 0643 0645 0645',
64956: '<final> 0644 062C 0645',
64957: '<final> 0646 062C 062D',
64958: '<final> 062C 062D 064A',
64959: '<final> 062D 062C 064A',
64960: '<final> 0645 062C 064A',
64961: '<final> 0641 0645 064A',
64962: '<final> 0628 062D 064A',
64963: '<initial> 0643 0645 0645',
64964: '<initial> 0639 062C 0645',
64965: '<initial> 0635 0645 0645',
64966: '<final> 0633 062E 064A',
64967: '<final> 0646 062C 064A',
65008: '<isolated> 0635 0644 06D2',
65009: '<isolated> 0642 0644 06D2',
65010: '<isolated> 0627 0644 0644 0647',
65011: '<isolated> 0627 0643 0628 0631',
65012: '<isolated> 0645 062D 0645 062F',
65013: '<isolated> 0635 0644 0639 0645',
65014: '<isolated> 0631 0633 0648 0644',
65015: '<isolated> 0639 0644 064A 0647',
65016: '<isolated> 0648 0633 0644 0645',
65017: '<isolated> 0635 0644 0649',
65018: '<isolated> 0635 0644 0649 0020 0627 0644 0644 0647 0020 0639 0644 064A 0647 0020 0648 0633 0644 0645',
65019: '<isolated> 062C 0644 0020 062C 0644 0627 0644 0647',
65020: '<isolated> 0631 06CC 0627 0644',
65040: '<vertical> 002C',
65041: '<vertical> 3001',
65042: '<vertical> 3002',
65043: '<vertical> 003A',
65044: '<vertical> 003B',
65045: '<vertical> 0021',
65046: '<vertical> 003F',
65047: '<vertical> 3016',
65048: '<vertical> 3017',
65049: '<vertical> 2026',
65072: '<vertical> 2025',
65073: '<vertical> 2014',
65074: '<vertical> 2013',
65075: '<vertical> 005F',
65076: '<vertical> 005F',
65077: '<vertical> 0028',
65078: '<vertical> 0029',
65079: '<vertical> 007B',
65080: '<vertical> 007D',
65081: '<vertical> 3014',
65082: '<vertical> 3015',
65083: '<vertical> 3010',
65084: '<vertical> 3011',
65085: '<vertical> 300A',
65086: '<vertical> 300B',
65087: '<vertical> 3008',
65088: '<vertical> 3009',
65089: '<vertical> 300C',
65090: '<vertical> 300D',
65091: '<vertical> 300E',
65092: '<vertical> 300F',
65095: '<vertical> 005B',
65096: '<vertical> 005D',
65097: '<compat> 203E',
65098: '<compat> 203E',
65099: '<compat> 203E',
65100: '<compat> 203E',
65101: '<compat> 005F',
65102: '<compat> 005F',
65103: '<compat> 005F',
65104: '<small> 002C',
65105: '<small> 3001',
65106: '<small> 002E',
65108: '<small> 003B',
65109: '<small> 003A',
65110: '<small> 003F',
65111: '<small> 0021',
65112: '<small> 2014',
65113: '<small> 0028',
65114: '<small> 0029',
65115: '<small> 007B',
65116: '<small> 007D',
65117: '<small> 3014',
65118: '<small> 3015',
65119: '<small> 0023',
65120: '<small> 0026',
65121: '<small> 002A',
65122: '<small> 002B',
65123: '<small> 002D',
65124: '<small> 003C',
65125: '<small> 003E',
65126: '<small> 003D',
65128: '<small> 005C',
65129: '<small> 0024',
65130: '<small> 0025',
65131: '<small> 0040',
65136: '<isolated> 0020 064B',
65137: '<medial> 0640 064B',
65138: '<isolated> 0020 064C',
65140: '<isolated> 0020 064D',
65142: '<isolated> 0020 064E',
65143: '<medial> 0640 064E',
65144: '<isolated> 0020 064F',
65145: '<medial> 0640 064F',
65146: '<isolated> 0020 0650',
65147: '<medial> 0640 0650',
65148: '<isolated> 0020 0651',
65149: '<medial> 0640 0651',
65150: '<isolated> 0020 0652',
65151: '<medial> 0640 0652',
65152: '<isolated> 0621',
65153: '<isolated> 0622',
65154: '<final> 0622',
65155: '<isolated> 0623',
65156: '<final> 0623',
65157: '<isolated> 0624',
65158: '<final> 0624',
65159: '<isolated> 0625',
65160: '<final> 0625',
65161: '<isolated> 0626',
65162: '<final> 0626',
65163: '<initial> 0626',
65164: '<medial> 0626',
65165: '<isolated> 0627',
65166: '<final> 0627',
65167: '<isolated> 0628',
65168: '<final> 0628',
65169: '<initial> 0628',
65170: '<medial> 0628',
65171: '<isolated> 0629',
65172: '<final> 0629',
65173: '<isolated> 062A',
65174: '<final> 062A',
65175: '<initial> 062A',
65176: '<medial> 062A',
65177: '<isolated> 062B',
65178: '<final> 062B',
65179: '<initial> 062B',
65180: '<medial> 062B',
65181: '<isolated> 062C',
65182: '<final> 062C',
65183: '<initial> 062C',
65184: '<medial> 062C',
65185: '<isolated> 062D',
65186: '<final> 062D',
65187: '<initial> 062D',
65188: '<medial> 062D',
65189: '<isolated> 062E',
65190: '<final> 062E',
65191: '<initial> 062E',
65192: '<medial> 062E',
65193: '<isolated> 062F',
65194: '<final> 062F',
65195: '<isolated> 0630',
65196: '<final> 0630',
65197: '<isolated> 0631',
65198: '<final> 0631',
65199: '<isolated> 0632',
65200: '<final> 0632',
65201: '<isolated> 0633',
65202: '<final> 0633',
65203: '<initial> 0633',
65204: '<medial> 0633',
65205: '<isolated> 0634',
65206: '<final> 0634',
65207: '<initial> 0634',
65208: '<medial> 0634',
65209: '<isolated> 0635',
65210: '<final> 0635',
65211: '<initial> 0635',
65212: '<medial> 0635',
65213: '<isolated> 0636',
65214: '<final> 0636',
65215: '<initial> 0636',
65216: '<medial> 0636',
65217: '<isolated> 0637',
65218: '<final> 0637',
65219: '<initial> 0637',
65220: '<medial> 0637',
65221: '<isolated> 0638',
65222: '<final> 0638',
65223: '<initial> 0638',
65224: '<medial> 0638',
65225: '<isolated> 0639',
65226: '<final> 0639',
65227: '<initial> 0639',
65228: '<medial> 0639',
65229: '<isolated> 063A',
65230: '<final> 063A',
65231: '<initial> 063A',
65232: '<medial> 063A',
65233: '<isolated> 0641',
65234: '<final> 0641',
65235: '<initial> 0641',
65236: '<medial> 0641',
65237: '<isolated> 0642',
65238: '<final> 0642',
65239: '<initial> 0642',
65240: '<medial> 0642',
65241: '<isolated> 0643',
65242: '<final> 0643',
65243: '<initial> 0643',
65244: '<medial> 0643',
65245: '<isolated> 0644',
65246: '<final> 0644',
65247: '<initial> 0644',
65248: '<medial> 0644',
65249: '<isolated> 0645',
65250: '<final> 0645',
65251: '<initial> 0645',
65252: '<medial> 0645',
65253: '<isolated> 0646',
65254: '<final> 0646',
65255: '<initial> 0646',
65256: '<medial> 0646',
65257: '<isolated> 0647',
65258: '<final> 0647',
65259: '<initial> 0647',
65260: '<medial> 0647',
65261: '<isolated> 0648',
65262: '<final> 0648',
65263: '<isolated> 0649',
65264: '<final> 0649',
65265: '<isolated> 064A',
65266: '<final> 064A',
65267: '<initial> 064A',
65268: '<medial> 064A',
65269: '<isolated> 0644 0622',
65270: '<final> 0644 0622',
65271: '<isolated> 0644 0623',
65272: '<final> 0644 0623',
65273: '<isolated> 0644 0625',
65274: '<final> 0644 0625',
65275: '<isolated> 0644 0627',
65276: '<final> 0644 0627',
65281: '<wide> 0021',
65282: '<wide> 0022',
65283: '<wide> 0023',
65284: '<wide> 0024',
65285: '<wide> 0025',
65286: '<wide> 0026',
65287: '<wide> 0027',
65288: '<wide> 0028',
65289: '<wide> 0029',
65290: '<wide> 002A',
65291: '<wide> 002B',
65292: '<wide> 002C',
65293: '<wide> 002D',
65294: '<wide> 002E',
65295: '<wide> 002F',
65296: '<wide> 0030',
65297: '<wide> 0031',
65298: '<wide> 0032',
65299: '<wide> 0033',
65300: '<wide> 0034',
65301: '<wide> 0035',
65302: '<wide> 0036',
65303: '<wide> 0037',
65304: '<wide> 0038',
65305: '<wide> 0039',
65306: '<wide> 003A',
65307: '<wide> 003B',
65308: '<wide> 003C',
65309: '<wide> 003D',
65310: '<wide> 003E',
65311: '<wide> 003F',
65312: '<wide> 0040',
65313: '<wide> 0041',
65314: '<wide> 0042',
65315: '<wide> 0043',
65316: '<wide> 0044',
65317: '<wide> 0045',
65318: '<wide> 0046',
65319: '<wide> 0047',
65320: '<wide> 0048',
65321: '<wide> 0049',
65322: '<wide> 004A',
65323: '<wide> 004B',
65324: '<wide> 004C',
65325: '<wide> 004D',
65326: '<wide> 004E',
65327: '<wide> 004F',
65328: '<wide> 0050',
65329: '<wide> 0051',
65330: '<wide> 0052',
65331: '<wide> 0053',
65332: '<wide> 0054',
65333: '<wide> 0055',
65334: '<wide> 0056',
65335: '<wide> 0057',
65336: '<wide> 0058',
65337: '<wide> 0059',
65338: '<wide> 005A',
65339: '<wide> 005B',
65340: '<wide> 005C',
65341: '<wide> 005D',
65342: '<wide> 005E',
65343: '<wide> 005F',
65344: '<wide> 0060',
65345: '<wide> 0061',
65346: '<wide> 0062',
65347: '<wide> 0063',
65348: '<wide> 0064',
65349: '<wide> 0065',
65350: '<wide> 0066',
65351: '<wide> 0067',
65352: '<wide> 0068',
65353: '<wide> 0069',
65354: '<wide> 006A',
65355: '<wide> 006B',
65356: '<wide> 006C',
65357: '<wide> 006D',
65358: '<wide> 006E',
65359: '<wide> 006F',
65360: '<wide> 0070',
65361: '<wide> 0071',
65362: '<wide> 0072',
65363: '<wide> 0073',
65364: '<wide> 0074',
65365: '<wide> 0075',
65366: '<wide> 0076',
65367: '<wide> 0077',
65368: '<wide> 0078',
65369: '<wide> 0079',
65370: '<wide> 007A',
65371: '<wide> 007B',
65372: '<wide> 007C',
65373: '<wide> 007D',
65374: '<wide> 007E',
65375: '<wide> 2985',
65376: '<wide> 2986',
65377: '<narrow> 3002',
65378: '<narrow> 300C',
65379: '<narrow> 300D',
65380: '<narrow> 3001',
65381: '<narrow> 30FB',
65382: '<narrow> 30F2',
65383: '<narrow> 30A1',
65384: '<narrow> 30A3',
65385: '<narrow> 30A5',
65386: '<narrow> 30A7',
65387: '<narrow> 30A9',
65388: '<narrow> 30E3',
65389: '<narrow> 30E5',
65390: '<narrow> 30E7',
65391: '<narrow> 30C3',
65392: '<narrow> 30FC',
65393: '<narrow> 30A2',
65394: '<narrow> 30A4',
65395: '<narrow> 30A6',
65396: '<narrow> 30A8',
65397: '<narrow> 30AA',
65398: '<narrow> 30AB',
65399: '<narrow> 30AD',
65400: '<narrow> 30AF',
65401: '<narrow> 30B1',
65402: '<narrow> 30B3',
65403: '<narrow> 30B5',
65404: '<narrow> 30B7',
65405: '<narrow> 30B9',
65406: '<narrow> 30BB',
65407: '<narrow> 30BD',
65408: '<narrow> 30BF',
65409: '<narrow> 30C1',
65410: '<narrow> 30C4',
65411: '<narrow> 30C6',
65412: '<narrow> 30C8',
65413: '<narrow> 30CA',
65414: '<narrow> 30CB',
65415: '<narrow> 30CC',
65416: '<narrow> 30CD',
65417: '<narrow> 30CE',
65418: '<narrow> 30CF',
65419: '<narrow> 30D2',
65420: '<narrow> 30D5',
65421: '<narrow> 30D8',
65422: '<narrow> 30DB',
65423: '<narrow> 30DE',
65424: '<narrow> 30DF',
65425: '<narrow> 30E0',
65426: '<narrow> 30E1',
65427: '<narrow> 30E2',
65428: '<narrow> 30E4',
65429: '<narrow> 30E6',
65430: '<narrow> 30E8',
65431: '<narrow> 30E9',
65432: '<narrow> 30EA',
65433: '<narrow> 30EB',
65434: '<narrow> 30EC',
65435: '<narrow> 30ED',
65436: '<narrow> 30EF',
65437: '<narrow> 30F3',
65438: '<narrow> 3099',
65439: '<narrow> 309A',
65440: '<narrow> 3164',
65441: '<narrow> 3131',
65442: '<narrow> 3132',
65443: '<narrow> 3133',
65444: '<narrow> 3134',
65445: '<narrow> 3135',
65446: '<narrow> 3136',
65447: '<narrow> 3137',
65448: '<narrow> 3138',
65449: '<narrow> 3139',
65450: '<narrow> 313A',
65451: '<narrow> 313B',
65452: '<narrow> 313C',
65453: '<narrow> 313D',
65454: '<narrow> 313E',
65455: '<narrow> 313F',
65456: '<narrow> 3140',
65457: '<narrow> 3141',
65458: '<narrow> 3142',
65459: '<narrow> 3143',
65460: '<narrow> 3144',
65461: '<narrow> 3145',
65462: '<narrow> 3146',
65463: '<narrow> 3147',
65464: '<narrow> 3148',
65465: '<narrow> 3149',
65466: '<narrow> 314A',
65467: '<narrow> 314B',
65468: '<narrow> 314C',
65469: '<narrow> 314D',
65470: '<narrow> 314E',
65474: '<narrow> 314F',
65475: '<narrow> 3150',
65476: '<narrow> 3151',
65477: '<narrow> 3152',
65478: '<narrow> 3153',
65479: '<narrow> 3154',
65482: '<narrow> 3155',
65483: '<narrow> 3156',
65484: '<narrow> 3157',
65485: '<narrow> 3158',
65486: '<narrow> 3159',
65487: '<narrow> 315A',
65490: '<narrow> 315B',
65491: '<narrow> 315C',
65492: '<narrow> 315D',
65493: '<narrow> 315E',
65494: '<narrow> 315F',
65495: '<narrow> 3160',
65498: '<narrow> 3161',
65499: '<narrow> 3162',
65500: '<narrow> 3163',
65504: '<wide> 00A2',
65505: '<wide> 00A3',
65506: '<wide> 00AC',
65507: '<wide> 00AF',
65508: '<wide> 00A6',
65509: '<wide> 00A5',
65510: '<wide> 20A9',
65512: '<narrow> 2502',
65513: '<narrow> 2190',
65514: '<narrow> 2191',
65515: '<narrow> 2192',
65516: '<narrow> 2193',
65517: '<narrow> 25A0',
65518: '<narrow> 25CB',
119134: '1D157 1D165',
119135: '1D158 1D165',
119136: '1D15F 1D16E',
119137: '1D15F 1D16F',
119138: '1D15F 1D170',
119139: '1D15F 1D171',
119140: '1D15F 1D172',
119227: '1D1B9 1D165',
119228: '1D1BA 1D165',
119229: '1D1BB 1D16E',
119230: '1D1BC 1D16E',
119231: '1D1BB 1D16F',
119232: '1D1BC 1D16F',
119808: '<font> 0041',
119809: '<font> 0042',
119810: '<font> 0043',
119811: '<font> 0044',
119812: '<font> 0045',
119813: '<font> 0046',
119814: '<font> 0047',
119815: '<font> 0048',
119816: '<font> 0049',
119817: '<font> 004A',
119818: '<font> 004B',
119819: '<font> 004C',
119820: '<font> 004D',
119821: '<font> 004E',
119822: '<font> 004F',
119823: '<font> 0050',
119824: '<font> 0051',
119825: '<font> 0052',
119826: '<font> 0053',
119827: '<font> 0054',
119828: '<font> 0055',
119829: '<font> 0056',
119830: '<font> 0057',
119831: '<font> 0058',
119832: '<font> 0059',
119833: '<font> 005A',
119834: '<font> 0061',
119835: '<font> 0062',
119836: '<font> 0063',
119837: '<font> 0064',
119838: '<font> 0065',
119839: '<font> 0066',
119840: '<font> 0067',
119841: '<font> 0068',
119842: '<font> 0069',
119843: '<font> 006A',
119844: '<font> 006B',
119845: '<font> 006C',
119846: '<font> 006D',
119847: '<font> 006E',
119848: '<font> 006F',
119849: '<font> 0070',
119850: '<font> 0071',
119851: '<font> 0072',
119852: '<font> 0073',
119853: '<font> 0074',
119854: '<font> 0075',
119855: '<font> 0076',
119856: '<font> 0077',
119857: '<font> 0078',
119858: '<font> 0079',
119859: '<font> 007A',
119860: '<font> 0041',
119861: '<font> 0042',
119862: '<font> 0043',
119863: '<font> 0044',
119864: '<font> 0045',
119865: '<font> 0046',
119866: '<font> 0047',
119867: '<font> 0048',
119868: '<font> 0049',
119869: '<font> 004A',
119870: '<font> 004B',
119871: '<font> 004C',
119872: '<font> 004D',
119873: '<font> 004E',
119874: '<font> 004F',
119875: '<font> 0050',
119876: '<font> 0051',
119877: '<font> 0052',
119878: '<font> 0053',
119879: '<font> 0054',
119880: '<font> 0055',
119881: '<font> 0056',
119882: '<font> 0057',
119883: '<font> 0058',
119884: '<font> 0059',
119885: '<font> 005A',
119886: '<font> 0061',
119887: '<font> 0062',
119888: '<font> 0063',
119889: '<font> 0064',
119890: '<font> 0065',
119891: '<font> 0066',
119892: '<font> 0067',
119894: '<font> 0069',
119895: '<font> 006A',
119896: '<font> 006B',
119897: '<font> 006C',
119898: '<font> 006D',
119899: '<font> 006E',
119900: '<font> 006F',
119901: '<font> 0070',
119902: '<font> 0071',
119903: '<font> 0072',
119904: '<font> 0073',
119905: '<font> 0074',
119906: '<font> 0075',
119907: '<font> 0076',
119908: '<font> 0077',
119909: '<font> 0078',
119910: '<font> 0079',
119911: '<font> 007A',
119912: '<font> 0041',
119913: '<font> 0042',
119914: '<font> 0043',
119915: '<font> 0044',
119916: '<font> 0045',
119917: '<font> 0046',
119918: '<font> 0047',
119919: '<font> 0048',
119920: '<font> 0049',
119921: '<font> 004A',
119922: '<font> 004B',
119923: '<font> 004C',
119924: '<font> 004D',
119925: '<font> 004E',
119926: '<font> 004F',
119927: '<font> 0050',
119928: '<font> 0051',
119929: '<font> 0052',
119930: '<font> 0053',
119931: '<font> 0054',
119932: '<font> 0055',
119933: '<font> 0056',
119934: '<font> 0057',
119935: '<font> 0058',
119936: '<font> 0059',
119937: '<font> 005A',
119938: '<font> 0061',
119939: '<font> 0062',
119940: '<font> 0063',
119941: '<font> 0064',
119942: '<font> 0065',
119943: '<font> 0066',
119944: '<font> 0067',
119945: '<font> 0068',
119946: '<font> 0069',
119947: '<font> 006A',
119948: '<font> 006B',
119949: '<font> 006C',
119950: '<font> 006D',
119951: '<font> 006E',
119952: '<font> 006F',
119953: '<font> 0070',
119954: '<font> 0071',
119955: '<font> 0072',
119956: '<font> 0073',
119957: '<font> 0074',
119958: '<font> 0075',
119959: '<font> 0076',
119960: '<font> 0077',
119961: '<font> 0078',
119962: '<font> 0079',
119963: '<font> 007A',
119964: '<font> 0041',
119966: '<font> 0043',
119967: '<font> 0044',
119970: '<font> 0047',
119973: '<font> 004A',
119974: '<font> 004B',
119977: '<font> 004E',
119978: '<font> 004F',
119979: '<font> 0050',
119980: '<font> 0051',
119982: '<font> 0053',
119983: '<font> 0054',
119984: '<font> 0055',
119985: '<font> 0056',
119986: '<font> 0057',
119987: '<font> 0058',
119988: '<font> 0059',
119989: '<font> 005A',
119990: '<font> 0061',
119991: '<font> 0062',
119992: '<font> 0063',
119993: '<font> 0064',
119995: '<font> 0066',
119997: '<font> 0068',
119998: '<font> 0069',
119999: '<font> 006A',
120000: '<font> 006B',
120001: '<font> 006C',
120002: '<font> 006D',
120003: '<font> 006E',
120005: '<font> 0070',
120006: '<font> 0071',
120007: '<font> 0072',
120008: '<font> 0073',
120009: '<font> 0074',
120010: '<font> 0075',
120011: '<font> 0076',
120012: '<font> 0077',
120013: '<font> 0078',
120014: '<font> 0079',
120015: '<font> 007A',
120016: '<font> 0041',
120017: '<font> 0042',
120018: '<font> 0043',
120019: '<font> 0044',
120020: '<font> 0045',
120021: '<font> 0046',
120022: '<font> 0047',
120023: '<font> 0048',
120024: '<font> 0049',
120025: '<font> 004A',
120026: '<font> 004B',
120027: '<font> 004C',
120028: '<font> 004D',
120029: '<font> 004E',
120030: '<font> 004F',
120031: '<font> 0050',
120032: '<font> 0051',
120033: '<font> 0052',
120034: '<font> 0053',
120035: '<font> 0054',
120036: '<font> 0055',
120037: '<font> 0056',
120038: '<font> 0057',
120039: '<font> 0058',
120040: '<font> 0059',
120041: '<font> 005A',
120042: '<font> 0061',
120043: '<font> 0062',
120044: '<font> 0063',
120045: '<font> 0064',
120046: '<font> 0065',
120047: '<font> 0066',
120048: '<font> 0067',
120049: '<font> 0068',
120050: '<font> 0069',
120051: '<font> 006A',
120052: '<font> 006B',
120053: '<font> 006C',
120054: '<font> 006D',
120055: '<font> 006E',
120056: '<font> 006F',
120057: '<font> 0070',
120058: '<font> 0071',
120059: '<font> 0072',
120060: '<font> 0073',
120061: '<font> 0074',
120062: '<font> 0075',
120063: '<font> 0076',
120064: '<font> 0077',
120065: '<font> 0078',
120066: '<font> 0079',
120067: '<font> 007A',
120068: '<font> 0041',
120069: '<font> 0042',
120071: '<font> 0044',
120072: '<font> 0045',
120073: '<font> 0046',
120074: '<font> 0047',
120077: '<font> 004A',
120078: '<font> 004B',
120079: '<font> 004C',
120080: '<font> 004D',
120081: '<font> 004E',
120082: '<font> 004F',
120083: '<font> 0050',
120084: '<font> 0051',
120086: '<font> 0053',
120087: '<font> 0054',
120088: '<font> 0055',
120089: '<font> 0056',
120090: '<font> 0057',
120091: '<font> 0058',
120092: '<font> 0059',
120094: '<font> 0061',
120095: '<font> 0062',
120096: '<font> 0063',
120097: '<font> 0064',
120098: '<font> 0065',
120099: '<font> 0066',
120100: '<font> 0067',
120101: '<font> 0068',
120102: '<font> 0069',
120103: '<font> 006A',
120104: '<font> 006B',
120105: '<font> 006C',
120106: '<font> 006D',
120107: '<font> 006E',
120108: '<font> 006F',
120109: '<font> 0070',
120110: '<font> 0071',
120111: '<font> 0072',
120112: '<font> 0073',
120113: '<font> 0074',
120114: '<font> 0075',
120115: '<font> 0076',
120116: '<font> 0077',
120117: '<font> 0078',
120118: '<font> 0079',
120119: '<font> 007A',
120120: '<font> 0041',
120121: '<font> 0042',
120123: '<font> 0044',
120124: '<font> 0045',
120125: '<font> 0046',
120126: '<font> 0047',
120128: '<font> 0049',
120129: '<font> 004A',
120130: '<font> 004B',
120131: '<font> 004C',
120132: '<font> 004D',
120134: '<font> 004F',
120138: '<font> 0053',
120139: '<font> 0054',
120140: '<font> 0055',
120141: '<font> 0056',
120142: '<font> 0057',
120143: '<font> 0058',
120144: '<font> 0059',
120146: '<font> 0061',
120147: '<font> 0062',
120148: '<font> 0063',
120149: '<font> 0064',
120150: '<font> 0065',
120151: '<font> 0066',
120152: '<font> 0067',
120153: '<font> 0068',
120154: '<font> 0069',
120155: '<font> 006A',
120156: '<font> 006B',
120157: '<font> 006C',
120158: '<font> 006D',
120159: '<font> 006E',
120160: '<font> 006F',
120161: '<font> 0070',
120162: '<font> 0071',
120163: '<font> 0072',
120164: '<font> 0073',
120165: '<font> 0074',
120166: '<font> 0075',
120167: '<font> 0076',
120168: '<font> 0077',
120169: '<font> 0078',
120170: '<font> 0079',
120171: '<font> 007A',
120172: '<font> 0041',
120173: '<font> 0042',
120174: '<font> 0043',
120175: '<font> 0044',
120176: '<font> 0045',
120177: '<font> 0046',
120178: '<font> 0047',
120179: '<font> 0048',
120180: '<font> 0049',
120181: '<font> 004A',
120182: '<font> 004B',
120183: '<font> 004C',
120184: '<font> 004D',
120185: '<font> 004E',
120186: '<font> 004F',
120187: '<font> 0050',
120188: '<font> 0051',
120189: '<font> 0052',
120190: '<font> 0053',
120191: '<font> 0054',
120192: '<font> 0055',
120193: '<font> 0056',
120194: '<font> 0057',
120195: '<font> 0058',
120196: '<font> 0059',
120197: '<font> 005A',
120198: '<font> 0061',
120199: '<font> 0062',
120200: '<font> 0063',
120201: '<font> 0064',
120202: '<font> 0065',
120203: '<font> 0066',
120204: '<font> 0067',
120205: '<font> 0068',
120206: '<font> 0069',
120207: '<font> 006A',
120208: '<font> 006B',
120209: '<font> 006C',
120210: '<font> 006D',
120211: '<font> 006E',
120212: '<font> 006F',
120213: '<font> 0070',
120214: '<font> 0071',
120215: '<font> 0072',
120216: '<font> 0073',
120217: '<font> 0074',
120218: '<font> 0075',
120219: '<font> 0076',
120220: '<font> 0077',
120221: '<font> 0078',
120222: '<font> 0079',
120223: '<font> 007A',
120224: '<font> 0041',
120225: '<font> 0042',
120226: '<font> 0043',
120227: '<font> 0044',
120228: '<font> 0045',
120229: '<font> 0046',
120230: '<font> 0047',
120231: '<font> 0048',
120232: '<font> 0049',
120233: '<font> 004A',
120234: '<font> 004B',
120235: '<font> 004C',
120236: '<font> 004D',
120237: '<font> 004E',
120238: '<font> 004F',
120239: '<font> 0050',
120240: '<font> 0051',
120241: '<font> 0052',
120242: '<font> 0053',
120243: '<font> 0054',
120244: '<font> 0055',
120245: '<font> 0056',
120246: '<font> 0057',
120247: '<font> 0058',
120248: '<font> 0059',
120249: '<font> 005A',
120250: '<font> 0061',
120251: '<font> 0062',
120252: '<font> 0063',
120253: '<font> 0064',
120254: '<font> 0065',
120255: '<font> 0066',
120256: '<font> 0067',
120257: '<font> 0068',
120258: '<font> 0069',
120259: '<font> 006A',
120260: '<font> 006B',
120261: '<font> 006C',
120262: '<font> 006D',
120263: '<font> 006E',
120264: '<font> 006F',
120265: '<font> 0070',
120266: '<font> 0071',
120267: '<font> 0072',
120268: '<font> 0073',
120269: '<font> 0074',
120270: '<font> 0075',
120271: '<font> 0076',
120272: '<font> 0077',
120273: '<font> 0078',
120274: '<font> 0079',
120275: '<font> 007A',
120276: '<font> 0041',
120277: '<font> 0042',
120278: '<font> 0043',
120279: '<font> 0044',
120280: '<font> 0045',
120281: '<font> 0046',
120282: '<font> 0047',
120283: '<font> 0048',
120284: '<font> 0049',
120285: '<font> 004A',
120286: '<font> 004B',
120287: '<font> 004C',
120288: '<font> 004D',
120289: '<font> 004E',
120290: '<font> 004F',
120291: '<font> 0050',
120292: '<font> 0051',
120293: '<font> 0052',
120294: '<font> 0053',
120295: '<font> 0054',
120296: '<font> 0055',
120297: '<font> 0056',
120298: '<font> 0057',
120299: '<font> 0058',
120300: '<font> 0059',
120301: '<font> 005A',
120302: '<font> 0061',
120303: '<font> 0062',
120304: '<font> 0063',
120305: '<font> 0064',
120306: '<font> 0065',
120307: '<font> 0066',
120308: '<font> 0067',
120309: '<font> 0068',
120310: '<font> 0069',
120311: '<font> 006A',
120312: '<font> 006B',
120313: '<font> 006C',
120314: '<font> 006D',
120315: '<font> 006E',
120316: '<font> 006F',
120317: '<font> 0070',
120318: '<font> 0071',
120319: '<font> 0072',
120320: '<font> 0073',
120321: '<font> 0074',
120322: '<font> 0075',
120323: '<font> 0076',
120324: '<font> 0077',
120325: '<font> 0078',
120326: '<font> 0079',
120327: '<font> 007A',
120328: '<font> 0041',
120329: '<font> 0042',
120330: '<font> 0043',
120331: '<font> 0044',
120332: '<font> 0045',
120333: '<font> 0046',
120334: '<font> 0047',
120335: '<font> 0048',
120336: '<font> 0049',
120337: '<font> 004A',
120338: '<font> 004B',
120339: '<font> 004C',
120340: '<font> 004D',
120341: '<font> 004E',
120342: '<font> 004F',
120343: '<font> 0050',
120344: '<font> 0051',
120345: '<font> 0052',
120346: '<font> 0053',
120347: '<font> 0054',
120348: '<font> 0055',
120349: '<font> 0056',
120350: '<font> 0057',
120351: '<font> 0058',
120352: '<font> 0059',
120353: '<font> 005A',
120354: '<font> 0061',
120355: '<font> 0062',
120356: '<font> 0063',
120357: '<font> 0064',
120358: '<font> 0065',
120359: '<font> 0066',
120360: '<font> 0067',
120361: '<font> 0068',
120362: '<font> 0069',
120363: '<font> 006A',
120364: '<font> 006B',
120365: '<font> 006C',
120366: '<font> 006D',
120367: '<font> 006E',
120368: '<font> 006F',
120369: '<font> 0070',
120370: '<font> 0071',
120371: '<font> 0072',
120372: '<font> 0073',
120373: '<font> 0074',
120374: '<font> 0075',
120375: '<font> 0076',
120376: '<font> 0077',
120377: '<font> 0078',
120378: '<font> 0079',
120379: '<font> 007A',
120380: '<font> 0041',
120381: '<font> 0042',
120382: '<font> 0043',
120383: '<font> 0044',
120384: '<font> 0045',
120385: '<font> 0046',
120386: '<font> 0047',
120387: '<font> 0048',
120388: '<font> 0049',
120389: '<font> 004A',
120390: '<font> 004B',
120391: '<font> 004C',
120392: '<font> 004D',
120393: '<font> 004E',
120394: '<font> 004F',
120395: '<font> 0050',
120396: '<font> 0051',
120397: '<font> 0052',
120398: '<font> 0053',
120399: '<font> 0054',
120400: '<font> 0055',
120401: '<font> 0056',
120402: '<font> 0057',
120403: '<font> 0058',
120404: '<font> 0059',
120405: '<font> 005A',
120406: '<font> 0061',
120407: '<font> 0062',
120408: '<font> 0063',
120409: '<font> 0064',
120410: '<font> 0065',
120411: '<font> 0066',
120412: '<font> 0067',
120413: '<font> 0068',
120414: '<font> 0069',
120415: '<font> 006A',
120416: '<font> 006B',
120417: '<font> 006C',
120418: '<font> 006D',
120419: '<font> 006E',
120420: '<font> 006F',
120421: '<font> 0070',
120422: '<font> 0071',
120423: '<font> 0072',
120424: '<font> 0073',
120425: '<font> 0074',
120426: '<font> 0075',
120427: '<font> 0076',
120428: '<font> 0077',
120429: '<font> 0078',
120430: '<font> 0079',
120431: '<font> 007A',
120432: '<font> 0041',
120433: '<font> 0042',
120434: '<font> 0043',
120435: '<font> 0044',
120436: '<font> 0045',
120437: '<font> 0046',
120438: '<font> 0047',
120439: '<font> 0048',
120440: '<font> 0049',
120441: '<font> 004A',
120442: '<font> 004B',
120443: '<font> 004C',
120444: '<font> 004D',
120445: '<font> 004E',
120446: '<font> 004F',
120447: '<font> 0050',
120448: '<font> 0051',
120449: '<font> 0052',
120450: '<font> 0053',
120451: '<font> 0054',
120452: '<font> 0055',
120453: '<font> 0056',
120454: '<font> 0057',
120455: '<font> 0058',
120456: '<font> 0059',
120457: '<font> 005A',
120458: '<font> 0061',
120459: '<font> 0062',
120460: '<font> 0063',
120461: '<font> 0064',
120462: '<font> 0065',
120463: '<font> 0066',
120464: '<font> 0067',
120465: '<font> 0068',
120466: '<font> 0069',
120467: '<font> 006A',
120468: '<font> 006B',
120469: '<font> 006C',
120470: '<font> 006D',
120471: '<font> 006E',
120472: '<font> 006F',
120473: '<font> 0070',
120474: '<font> 0071',
120475: '<font> 0072',
120476: '<font> 0073',
120477: '<font> 0074',
120478: '<font> 0075',
120479: '<font> 0076',
120480: '<font> 0077',
120481: '<font> 0078',
120482: '<font> 0079',
120483: '<font> 007A',
120484: '<font> 0131',
120485: '<font> 0237',
120488: '<font> 0391',
120489: '<font> 0392',
120490: '<font> 0393',
120491: '<font> 0394',
120492: '<font> 0395',
120493: '<font> 0396',
120494: '<font> 0397',
120495: '<font> 0398',
120496: '<font> 0399',
120497: '<font> 039A',
120498: '<font> 039B',
120499: '<font> 039C',
120500: '<font> 039D',
120501: '<font> 039E',
120502: '<font> 039F',
120503: '<font> 03A0',
120504: '<font> 03A1',
120505: '<font> 03F4',
120506: '<font> 03A3',
120507: '<font> 03A4',
120508: '<font> 03A5',
120509: '<font> 03A6',
120510: '<font> 03A7',
120511: '<font> 03A8',
120512: '<font> 03A9',
120513: '<font> 2207',
120514: '<font> 03B1',
120515: '<font> 03B2',
120516: '<font> 03B3',
120517: '<font> 03B4',
120518: '<font> 03B5',
120519: '<font> 03B6',
120520: '<font> 03B7',
120521: '<font> 03B8',
120522: '<font> 03B9',
120523: '<font> 03BA',
120524: '<font> 03BB',
120525: '<font> 03BC',
120526: '<font> 03BD',
120527: '<font> 03BE',
120528: '<font> 03BF',
120529: '<font> 03C0',
120530: '<font> 03C1',
120531: '<font> 03C2',
120532: '<font> 03C3',
120533: '<font> 03C4',
120534: '<font> 03C5',
120535: '<font> 03C6',
120536: '<font> 03C7',
120537: '<font> 03C8',
120538: '<font> 03C9',
120539: '<font> 2202',
120540: '<font> 03F5',
120541: '<font> 03D1',
120542: '<font> 03F0',
120543: '<font> 03D5',
120544: '<font> 03F1',
120545: '<font> 03D6',
120546: '<font> 0391',
120547: '<font> 0392',
120548: '<font> 0393',
120549: '<font> 0394',
120550: '<font> 0395',
120551: '<font> 0396',
120552: '<font> 0397',
120553: '<font> 0398',
120554: '<font> 0399',
120555: '<font> 039A',
120556: '<font> 039B',
120557: '<font> 039C',
120558: '<font> 039D',
120559: '<font> 039E',
120560: '<font> 039F',
120561: '<font> 03A0',
120562: '<font> 03A1',
120563: '<font> 03F4',
120564: '<font> 03A3',
120565: '<font> 03A4',
120566: '<font> 03A5',
120567: '<font> 03A6',
120568: '<font> 03A7',
120569: '<font> 03A8',
120570: '<font> 03A9',
120571: '<font> 2207',
120572: '<font> 03B1',
120573: '<font> 03B2',
120574: '<font> 03B3',
120575: '<font> 03B4',
120576: '<font> 03B5',
120577: '<font> 03B6',
120578: '<font> 03B7',
120579: '<font> 03B8',
120580: '<font> 03B9',
120581: '<font> 03BA',
120582: '<font> 03BB',
120583: '<font> 03BC',
120584: '<font> 03BD',
120585: '<font> 03BE',
120586: '<font> 03BF',
120587: '<font> 03C0',
120588: '<font> 03C1',
120589: '<font> 03C2',
120590: '<font> 03C3',
120591: '<font> 03C4',
120592: '<font> 03C5',
120593: '<font> 03C6',
120594: '<font> 03C7',
120595: '<font> 03C8',
120596: '<font> 03C9',
120597: '<font> 2202',
120598: '<font> 03F5',
120599: '<font> 03D1',
120600: '<font> 03F0',
120601: '<font> 03D5',
120602: '<font> 03F1',
120603: '<font> 03D6',
120604: '<font> 0391',
120605: '<font> 0392',
120606: '<font> 0393',
120607: '<font> 0394',
120608: '<font> 0395',
120609: '<font> 0396',
120610: '<font> 0397',
120611: '<font> 0398',
120612: '<font> 0399',
120613: '<font> 039A',
120614: '<font> 039B',
120615: '<font> 039C',
120616: '<font> 039D',
120617: '<font> 039E',
120618: '<font> 039F',
120619: '<font> 03A0',
120620: '<font> 03A1',
120621: '<font> 03F4',
120622: '<font> 03A3',
120623: '<font> 03A4',
120624: '<font> 03A5',
120625: '<font> 03A6',
120626: '<font> 03A7',
120627: '<font> 03A8',
120628: '<font> 03A9',
120629: '<font> 2207',
120630: '<font> 03B1',
120631: '<font> 03B2',
120632: '<font> 03B3',
120633: '<font> 03B4',
120634: '<font> 03B5',
120635: '<font> 03B6',
120636: '<font> 03B7',
120637: '<font> 03B8',
120638: '<font> 03B9',
120639: '<font> 03BA',
120640: '<font> 03BB',
120641: '<font> 03BC',
120642: '<font> 03BD',
120643: '<font> 03BE',
120644: '<font> 03BF',
120645: '<font> 03C0',
120646: '<font> 03C1',
120647: '<font> 03C2',
120648: '<font> 03C3',
120649: '<font> 03C4',
120650: '<font> 03C5',
120651: '<font> 03C6',
120652: '<font> 03C7',
120653: '<font> 03C8',
120654: '<font> 03C9',
120655: '<font> 2202',
120656: '<font> 03F5',
120657: '<font> 03D1',
120658: '<font> 03F0',
120659: '<font> 03D5',
120660: '<font> 03F1',
120661: '<font> 03D6',
120662: '<font> 0391',
120663: '<font> 0392',
120664: '<font> 0393',
120665: '<font> 0394',
120666: '<font> 0395',
120667: '<font> 0396',
120668: '<font> 0397',
120669: '<font> 0398',
120670: '<font> 0399',
120671: '<font> 039A',
120672: '<font> 039B',
120673: '<font> 039C',
120674: '<font> 039D',
120675: '<font> 039E',
120676: '<font> 039F',
120677: '<font> 03A0',
120678: '<font> 03A1',
120679: '<font> 03F4',
120680: '<font> 03A3',
120681: '<font> 03A4',
120682: '<font> 03A5',
120683: '<font> 03A6',
120684: '<font> 03A7',
120685: '<font> 03A8',
120686: '<font> 03A9',
120687: '<font> 2207',
120688: '<font> 03B1',
120689: '<font> 03B2',
120690: '<font> 03B3',
120691: '<font> 03B4',
120692: '<font> 03B5',
120693: '<font> 03B6',
120694: '<font> 03B7',
120695: '<font> 03B8',
120696: '<font> 03B9',
120697: '<font> 03BA',
120698: '<font> 03BB',
120699: '<font> 03BC',
120700: '<font> 03BD',
120701: '<font> 03BE',
120702: '<font> 03BF',
120703: '<font> 03C0',
120704: '<font> 03C1',
120705: '<font> 03C2',
120706: '<font> 03C3',
120707: '<font> 03C4',
120708: '<font> 03C5',
120709: '<font> 03C6',
120710: '<font> 03C7',
120711: '<font> 03C8',
120712: '<font> 03C9',
120713: '<font> 2202',
120714: '<font> 03F5',
120715: '<font> 03D1',
120716: '<font> 03F0',
120717: '<font> 03D5',
120718: '<font> 03F1',
120719: '<font> 03D6',
120720: '<font> 0391',
120721: '<font> 0392',
120722: '<font> 0393',
120723: '<font> 0394',
120724: '<font> 0395',
120725: '<font> 0396',
120726: '<font> 0397',
120727: '<font> 0398',
120728: '<font> 0399',
120729: '<font> 039A',
120730: '<font> 039B',
120731: '<font> 039C',
120732: '<font> 039D',
120733: '<font> 039E',
120734: '<font> 039F',
120735: '<font> 03A0',
120736: '<font> 03A1',
120737: '<font> 03F4',
120738: '<font> 03A3',
120739: '<font> 03A4',
120740: '<font> 03A5',
120741: '<font> 03A6',
120742: '<font> 03A7',
120743: '<font> 03A8',
120744: '<font> 03A9',
120745: '<font> 2207',
120746: '<font> 03B1',
120747: '<font> 03B2',
120748: '<font> 03B3',
120749: '<font> 03B4',
120750: '<font> 03B5',
120751: '<font> 03B6',
120752: '<font> 03B7',
120753: '<font> 03B8',
120754: '<font> 03B9',
120755: '<font> 03BA',
120756: '<font> 03BB',
120757: '<font> 03BC',
120758: '<font> 03BD',
120759: '<font> 03BE',
120760: '<font> 03BF',
120761: '<font> 03C0',
120762: '<font> 03C1',
120763: '<font> 03C2',
120764: '<font> 03C3',
120765: '<font> 03C4',
120766: '<font> 03C5',
120767: '<font> 03C6',
120768: '<font> 03C7',
120769: '<font> 03C8',
120770: '<font> 03C9',
120771: '<font> 2202',
120772: '<font> 03F5',
120773: '<font> 03D1',
120774: '<font> 03F0',
120775: '<font> 03D5',
120776: '<font> 03F1',
120777: '<font> 03D6',
120782: '<font> 0030',
120783: '<font> 0031',
120784: '<font> 0032',
120785: '<font> 0033',
120786: '<font> 0034',
120787: '<font> 0035',
120788: '<font> 0036',
120789: '<font> 0037',
120790: '<font> 0038',
120791: '<font> 0039',
120792: '<font> 0030',
120793: '<font> 0031',
120794: '<font> 0032',
120795: '<font> 0033',
120796: '<font> 0034',
120797: '<font> 0035',
120798: '<font> 0036',
120799: '<font> 0037',
120800: '<font> 0038',
120801: '<font> 0039',
120802: '<font> 0030',
120803: '<font> 0031',
120804: '<font> 0032',
120805: '<font> 0033',
120806: '<font> 0034',
120807: '<font> 0035',
120808: '<font> 0036',
120809: '<font> 0037',
120810: '<font> 0038',
120811: '<font> 0039',
120812: '<font> 0030',
120813: '<font> 0031',
120814: '<font> 0032',
120815: '<font> 0033',
120816: '<font> 0034',
120817: '<font> 0035',
120818: '<font> 0036',
120819: '<font> 0037',
120820: '<font> 0038',
120821: '<font> 0039',
120822: '<font> 0030',
120823: '<font> 0031',
120824: '<font> 0032',
120825: '<font> 0033',
120826: '<font> 0034',
120827: '<font> 0035',
120828: '<font> 0036',
120829: '<font> 0037',
120830: '<font> 0038',
120831: '<font> 0039',
194560: '4E3D',
194561: '4E38',
194562: '4E41',
194563: '20122',
194564: '4F60',
194565: '4FAE',
194566: '4FBB',
194567: '5002',
194568: '507A',
194569: '5099',
194570: '50E7',
194571: '50CF',
194572: '349E',
194573: '2063A',
194574: '514D',
194575: '5154',
194576: '5164',
194577: '5177',
194578: '2051C',
194579: '34B9',
194580: '5167',
194581: '518D',
194582: '2054B',
194583: '5197',
194584: '51A4',
194585: '4ECC',
194586: '51AC',
194587: '51B5',
194588: '291DF',
194589: '51F5',
194590: '5203',
194591: '34DF',
194592: '523B',
194593: '5246',
194594: '5272',
194595: '5277',
194596: '3515',
194597: '52C7',
194598: '52C9',
194599: '52E4',
194600: '52FA',
194601: '5305',
194602: '5306',
194603: '5317',
194604: '5349',
194605: '5351',
194606: '535A',
194607: '5373',
194608: '537D',
194609: '537F',
194610: '537F',
194611: '537F',
194612: '20A2C',
194613: '7070',
194614: '53CA',
194615: '53DF',
194616: '20B63',
194617: '53EB',
194618: '53F1',
194619: '5406',
194620: '549E',
194621: '5438',
194622: '5448',
194623: '5468',
194624: '54A2',
194625: '54F6',
194626: '5510',
194627: '5553',
194628: '5563',
194629: '5584',
194630: '5584',
194631: '5599',
194632: '55AB',
194633: '55B3',
194634: '55C2',
194635: '5716',
194636: '5606',
194637: '5717',
194638: '5651',
194639: '5674',
194640: '5207',
194641: '58EE',
194642: '57CE',
194643: '57F4',
194644: '580D',
194645: '578B',
194646: '5832',
194647: '5831',
194648: '58AC',
194649: '214E4',
194650: '58F2',
194651: '58F7',
194652: '5906',
194653: '591A',
194654: '5922',
194655: '5962',
194656: '216A8',
194657: '216EA',
194658: '59EC',
194659: '5A1B',
194660: '5A27',
194661: '59D8',
194662: '5A66',
194663: '36EE',
194664: '36FC',
194665: '5B08',
194666: '5B3E',
194667: '5B3E',
194668: '219C8',
194669: '5BC3',
194670: '5BD8',
194671: '5BE7',
194672: '5BF3',
194673: '21B18',
194674: '5BFF',
194675: '5C06',
194676: '5F53',
194677: '5C22',
194678: '3781',
194679: '5C60',
194680: '5C6E',
194681: '5CC0',
194682: '5C8D',
194683: '21DE4',
194684: '5D43',
194685: '21DE6',
194686: '5D6E',
194687: '5D6B',
194688: '5D7C',
194689: '5DE1',
194690: '5DE2',
194691: '382F',
194692: '5DFD',
194693: '5E28',
194694: '5E3D',
194695: '5E69',
194696: '3862',
194697: '22183',
194698: '387C',
194699: '5EB0',
194700: '5EB3',
194701: '5EB6',
194702: '5ECA',
194703: '2A392',
194704: '5EFE',
194705: '22331',
194706: '22331',
194707: '8201',
194708: '5F22',
194709: '5F22',
194710: '38C7',
194711: '232B8',
194712: '261DA',
194713: '5F62',
194714: '5F6B',
194715: '38E3',
194716: '5F9A',
194717: '5FCD',
194718: '5FD7',
194719: '5FF9',
194720: '6081',
194721: '393A',
194722: '391C',
194723: '6094',
194724: '226D4',
194725: '60C7',
194726: '6148',
194727: '614C',
194728: '614E',
194729: '614C',
194730: '617A',
194731: '618E',
194732: '61B2',
194733: '61A4',
194734: '61AF',
194735: '61DE',
194736: '61F2',
194737: '61F6',
194738: '6210',
194739: '621B',
194740: '625D',
194741: '62B1',
194742: '62D4',
194743: '6350',
194744: '22B0C',
194745: '633D',
194746: '62FC',
194747: '6368',
194748: '6383',
194749: '63E4',
194750: '22BF1',
194751: '6422',
194752: '63C5',
194753: '63A9',
194754: '3A2E',
194755: '6469',
194756: '647E',
194757: '649D',
194758: '6477',
194759: '3A6C',
194760: '654F',
194761: '656C',
194762: '2300A',
194763: '65E3',
194764: '66F8',
194765: '6649',
194766: '3B19',
194767: '6691',
194768: '3B08',
194769: '3AE4',
194770: '5192',
194771: '5195',
194772: '6700',
194773: '669C',
194774: '80AD',
194775: '43D9',
194776: '6717',
194777: '671B',
194778: '6721',
194779: '675E',
194780: '6753',
194781: '233C3',
194782: '3B49',
194783: '67FA',
194784: '6785',
194785: '6852',
194786: '6885',
194787: '2346D',
194788: '688E',
194789: '681F',
194790: '6914',
194791: '3B9D',
194792: '6942',
194793: '69A3',
194794: '69EA',
194795: '6AA8',
194796: '236A3',
194797: '6ADB',
194798: '3C18',
194799: '6B21',
194800: '238A7',
194801: '6B54',
194802: '3C4E',
194803: '6B72',
194804: '6B9F',
194805: '6BBA',
194806: '6BBB',
194807: '23A8D',
194808: '21D0B',
194809: '23AFA',
194810: '6C4E',
194811: '23CBC',
194812: '6CBF',
194813: '6CCD',
194814: '6C67',
194815: '6D16',
194816: '6D3E',
194817: '6D77',
194818: '6D41',
194819: '6D69',
194820: '6D78',
194821: '6D85',
194822: '23D1E',
194823: '6D34',
194824: '6E2F',
194825: '6E6E',
194826: '3D33',
194827: '6ECB',
194828: '6EC7',
194829: '23ED1',
194830: '6DF9',
194831: '6F6E',
194832: '23F5E',
194833: '23F8E',
194834: '6FC6',
194835: '7039',
194836: '701E',
194837: '701B',
194838: '3D96',
194839: '704A',
194840: '707D',
194841: '7077',
194842: '70AD',
194843: '20525',
194844: '7145',
194845: '24263',
194846: '719C',
194847: '243AB',
194848: '7228',
194849: '7235',
194850: '7250',
194851: '24608',
194852: '7280',
194853: '7295',
194854: '24735',
194855: '24814',
194856: '737A',
194857: '738B',
194858: '3EAC',
194859: '73A5',
194860: '3EB8',
194861: '3EB8',
194862: '7447',
194863: '745C',
194864: '7471',
194865: '7485',
194866: '74CA',
194867: '3F1B',
194868: '7524',
194869: '24C36',
194870: '753E',
194871: '24C92',
194872: '7570',
194873: '2219F',
194874: '7610',
194875: '24FA1',
194876: '24FB8',
194877: '25044',
194878: '3FFC',
194879: '4008',
194880: '76F4',
194881: '250F3',
194882: '250F2',
194883: '25119',
194884: '25133',
194885: '771E',
194886: '771F',
194887: '771F',
194888: '774A',
194889: '4039',
194890: '778B',
194891: '4046',
194892: '4096',
194893: '2541D',
194894: '784E',
194895: '788C',
194896: '78CC',
194897: '40E3',
194898: '25626',
194899: '7956',
194900: '2569A',
194901: '256C5',
194902: '798F',
194903: '79EB',
194904: '412F',
194905: '7A40',
194906: '7A4A',
194907: '7A4F',
194908: '2597C',
194909: '25AA7',
194910: '25AA7',
194911: '7AEE',
194912: '4202',
194913: '25BAB',
194914: '7BC6',
194915: '7BC9',
194916: '4227',
194917: '25C80',
194918: '7CD2',
194919: '42A0',
194920: '7CE8',
194921: '7CE3',
194922: '7D00',
194923: '25F86',
194924: '7D63',
194925: '4301',
194926: '7DC7',
194927: '7E02',
194928: '7E45',
194929: '4334',
194930: '26228',
194931: '26247',
194932: '4359',
194933: '262D9',
194934: '7F7A',
194935: '2633E',
194936: '7F95',
194937: '7FFA',
194938: '8005',
194939: '264DA',
194940: '26523',
194941: '8060',
194942: '265A8',
194943: '8070',
194944: '2335F',
194945: '43D5',
194946: '80B2',
194947: '8103',
194948: '440B',
194949: '813E',
194950: '5AB5',
194951: '267A7',
194952: '267B5',
194953: '23393',
194954: '2339C',
194955: '8201',
194956: '8204',
194957: '8F9E',
194958: '446B',
194959: '8291',
194960: '828B',
194961: '829D',
194962: '52B3',
194963: '82B1',
194964: '82B3',
194965: '82BD',
194966: '82E6',
194967: '26B3C',
194968: '82E5',
194969: '831D',
194970: '8363',
194971: '83AD',
194972: '8323',
194973: '83BD',
194974: '83E7',
194975: '8457',
194976: '8353',
194977: '83CA',
194978: '83CC',
194979: '83DC',
194980: '26C36',
194981: '26D6B',
194982: '26CD5',
194983: '452B',
194984: '84F1',
194985: '84F3',
194986: '8516',
194987: '273CA',
194988: '8564',
194989: '26F2C',
194990: '455D',
194991: '4561',
194992: '26FB1',
194993: '270D2',
194994: '456B',
194995: '8650',
194996: '865C',
194997: '8667',
194998: '8669',
194999: '86A9',
195000: '8688',
195001: '870E',
195002: '86E2',
195003: '8779',
195004: '8728',
195005: '876B',
195006: '8786',
195007: '45D7',
195008: '87E1',
195009: '8801',
195010: '45F9',
195011: '8860',
195012: '8863',
195013: '27667',
195014: '88D7',
195015: '88DE',
195016: '4635',
195017: '88FA',
195018: '34BB',
195019: '278AE',
195020: '27966',
195021: '46BE',
195022: '46C7',
195023: '8AA0',
195024: '8AED',
195025: '8B8A',
195026: '8C55',
195027: '27CA8',
195028: '8CAB',
195029: '8CC1',
195030: '8D1B',
195031: '8D77',
195032: '27F2F',
195033: '20804',
195034: '8DCB',
195035: '8DBC',
195036: '8DF0',
195037: '208DE',
195038: '8ED4',
195039: '8F38',
195040: '285D2',
195041: '285ED',
195042: '9094',
195043: '90F1',
195044: '9111',
195045: '2872E',
195046: '911B',
195047: '9238',
195048: '92D7',
195049: '92D8',
195050: '927C',
195051: '93F9',
195052: '9415',
195053: '28BFA',
195054: '958B',
195055: '4995',
195056: '95B7',
195057: '28D77',
195058: '49E6',
195059: '96C3',
195060: '5DB2',
195061: '9723',
195062: '29145',
195063: '2921A',
195064: '4A6E',
195065: '4A76',
195066: '97E0',
195067: '2940A',
195068: '4AB2',
195069: '29496',
195070: '980B',
195071: '980B',
195072: '9829',
195073: '295B6',
195074: '98E2',
195075: '4B33',
195076: '9929',
195077: '99A7',
195078: '99C2',
195079: '99FE',
195080: '4BCE',
195081: '29B30',
195082: '9B12',
195083: '9C40',
195084: '9CFD',
195085: '4CCE',
195086: '4CED',
195087: '9D67',
195088: '2A0CE',
195089: '4CF8',
195090: '2A105',
195091: '2A20E',
195092: '2A291',
195093: '9EBB',
195094: '4D56',
195095: '9EF9',
195096: '9EFE',
195097: '9F05',
195098: '9F0F',
195099: '9F16',
195100: '9F3B',
195101: '2A600',
}

_raw_decomposition_corrected = {
}

def decomposition(code):
    try:
        return _raw_decomposition[code]
    except KeyError:
        if base_mod is not None and code not in _raw_decomposition_corrected:
            return base_mod._raw_decomposition.get(code, '')
        else:
            return ''

_composition_max = 12541
_composition_shift = 14
_composition = {
   65 << 14 |   768:   192,
   65 << 14 |   769:   193,
   65 << 14 |   770:   194,
   65 << 14 |   771:   195,
   65 << 14 |   776:   196,
   65 << 14 |   778:   197,
   67 << 14 |   807:   199,
   69 << 14 |   768:   200,
   69 << 14 |   769:   201,
   69 << 14 |   770:   202,
   69 << 14 |   776:   203,
   73 << 14 |   768:   204,
   73 << 14 |   769:   205,
   73 << 14 |   770:   206,
   73 << 14 |   776:   207,
   78 << 14 |   771:   209,
   79 << 14 |   768:   210,
   79 << 14 |   769:   211,
   79 << 14 |   770:   212,
   79 << 14 |   771:   213,
   79 << 14 |   776:   214,
   85 << 14 |   768:   217,
   85 << 14 |   769:   218,
   85 << 14 |   770:   219,
   85 << 14 |   776:   220,
   89 << 14 |   769:   221,
   97 << 14 |   768:   224,
   97 << 14 |   769:   225,
   97 << 14 |   770:   226,
   97 << 14 |   771:   227,
   97 << 14 |   776:   228,
   97 << 14 |   778:   229,
   99 << 14 |   807:   231,
  101 << 14 |   768:   232,
  101 << 14 |   769:   233,
  101 << 14 |   770:   234,
  101 << 14 |   776:   235,
  105 << 14 |   768:   236,
  105 << 14 |   769:   237,
  105 << 14 |   770:   238,
  105 << 14 |   776:   239,
  110 << 14 |   771:   241,
  111 << 14 |   768:   242,
  111 << 14 |   769:   243,
  111 << 14 |   770:   244,
  111 << 14 |   771:   245,
  111 << 14 |   776:   246,
  117 << 14 |   768:   249,
  117 << 14 |   769:   250,
  117 << 14 |   770:   251,
  117 << 14 |   776:   252,
  121 << 14 |   769:   253,
  121 << 14 |   776:   255,
   65 << 14 |   772:   256,
   97 << 14 |   772:   257,
   65 << 14 |   774:   258,
   97 << 14 |   774:   259,
   65 << 14 |   808:   260,
   97 << 14 |   808:   261,
   67 << 14 |   769:   262,
   99 << 14 |   769:   263,
   67 << 14 |   770:   264,
   99 << 14 |   770:   265,
   67 << 14 |   775:   266,
   99 << 14 |   775:   267,
   67 << 14 |   780:   268,
   99 << 14 |   780:   269,
   68 << 14 |   780:   270,
  100 << 14 |   780:   271,
   69 << 14 |   772:   274,
  101 << 14 |   772:   275,
   69 << 14 |   774:   276,
  101 << 14 |   774:   277,
   69 << 14 |   775:   278,
  101 << 14 |   775:   279,
   69 << 14 |   808:   280,
  101 << 14 |   808:   281,
   69 << 14 |   780:   282,
  101 << 14 |   780:   283,
   71 << 14 |   770:   284,
  103 << 14 |   770:   285,
   71 << 14 |   774:   286,
  103 << 14 |   774:   287,
   71 << 14 |   775:   288,
  103 << 14 |   775:   289,
   71 << 14 |   807:   290,
  103 << 14 |   807:   291,
   72 << 14 |   770:   292,
  104 << 14 |   770:   293,
   73 << 14 |   771:   296,
  105 << 14 |   771:   297,
   73 << 14 |   772:   298,
  105 << 14 |   772:   299,
   73 << 14 |   774:   300,
  105 << 14 |   774:   301,
   73 << 14 |   808:   302,
  105 << 14 |   808:   303,
   73 << 14 |   775:   304,
   74 << 14 |   770:   308,
  106 << 14 |   770:   309,
   75 << 14 |   807:   310,
  107 << 14 |   807:   311,
   76 << 14 |   769:   313,
  108 << 14 |   769:   314,
   76 << 14 |   807:   315,
  108 << 14 |   807:   316,
   76 << 14 |   780:   317,
  108 << 14 |   780:   318,
   78 << 14 |   769:   323,
  110 << 14 |   769:   324,
   78 << 14 |   807:   325,
  110 << 14 |   807:   326,
   78 << 14 |   780:   327,
  110 << 14 |   780:   328,
   79 << 14 |   772:   332,
  111 << 14 |   772:   333,
   79 << 14 |   774:   334,
  111 << 14 |   774:   335,
   79 << 14 |   779:   336,
  111 << 14 |   779:   337,
   82 << 14 |   769:   340,
  114 << 14 |   769:   341,
   82 << 14 |   807:   342,
  114 << 14 |   807:   343,
   82 << 14 |   780:   344,
  114 << 14 |   780:   345,
   83 << 14 |   769:   346,
  115 << 14 |   769:   347,
   83 << 14 |   770:   348,
  115 << 14 |   770:   349,
   83 << 14 |   807:   350,
  115 << 14 |   807:   351,
   83 << 14 |   780:   352,
  115 << 14 |   780:   353,
   84 << 14 |   807:   354,
  116 << 14 |   807:   355,
   84 << 14 |   780:   356,
  116 << 14 |   780:   357,
   85 << 14 |   771:   360,
  117 << 14 |   771:   361,
   85 << 14 |   772:   362,
  117 << 14 |   772:   363,
   85 << 14 |   774:   364,
  117 << 14 |   774:   365,
   85 << 14 |   778:   366,
  117 << 14 |   778:   367,
   85 << 14 |   779:   368,
  117 << 14 |   779:   369,
   85 << 14 |   808:   370,
  117 << 14 |   808:   371,
   87 << 14 |   770:   372,
  119 << 14 |   770:   373,
   89 << 14 |   770:   374,
  121 << 14 |   770:   375,
   89 << 14 |   776:   376,
   90 << 14 |   769:   377,
  122 << 14 |   769:   378,
   90 << 14 |   775:   379,
  122 << 14 |   775:   380,
   90 << 14 |   780:   381,
  122 << 14 |   780:   382,
   79 << 14 |   795:   416,
  111 << 14 |   795:   417,
   85 << 14 |   795:   431,
  117 << 14 |   795:   432,
   65 << 14 |   780:   461,
   97 << 14 |   780:   462,
   73 << 14 |   780:   463,
  105 << 14 |   780:   464,
   79 << 14 |   780:   465,
  111 << 14 |   780:   466,
   85 << 14 |   780:   467,
  117 << 14 |   780:   468,
  220 << 14 |   772:   469,
  252 << 14 |   772:   470,
  220 << 14 |   769:   471,
  252 << 14 |   769:   472,
  220 << 14 |   780:   473,
  252 << 14 |   780:   474,
  220 << 14 |   768:   475,
  252 << 14 |   768:   476,
  196 << 14 |   772:   478,
  228 << 14 |   772:   479,
  550 << 14 |   772:   480,
  551 << 14 |   772:   481,
  198 << 14 |   772:   482,
  230 << 14 |   772:   483,
   71 << 14 |   780:   486,
  103 << 14 |   780:   487,
   75 << 14 |   780:   488,
  107 << 14 |   780:   489,
   79 << 14 |   808:   490,
  111 << 14 |   808:   491,
  490 << 14 |   772:   492,
  491 << 14 |   772:   493,
  439 << 14 |   780:   494,
  658 << 14 |   780:   495,
  106 << 14 |   780:   496,
   71 << 14 |   769:   500,
  103 << 14 |   769:   501,
   78 << 14 |   768:   504,
  110 << 14 |   768:   505,
  197 << 14 |   769:   506,
  229 << 14 |   769:   507,
  198 << 14 |   769:   508,
  230 << 14 |   769:   509,
  216 << 14 |   769:   510,
  248 << 14 |   769:   511,
   65 << 14 |   783:   512,
   97 << 14 |   783:   513,
   65 << 14 |   785:   514,
   97 << 14 |   785:   515,
   69 << 14 |   783:   516,
  101 << 14 |   783:   517,
   69 << 14 |   785:   518,
  101 << 14 |   785:   519,
   73 << 14 |   783:   520,
  105 << 14 |   783:   521,
   73 << 14 |   785:   522,
  105 << 14 |   785:   523,
   79 << 14 |   783:   524,
  111 << 14 |   783:   525,
   79 << 14 |   785:   526,
  111 << 14 |   785:   527,
   82 << 14 |   783:   528,
  114 << 14 |   783:   529,
   82 << 14 |   785:   530,
  114 << 14 |   785:   531,
   85 << 14 |   783:   532,
  117 << 14 |   783:   533,
   85 << 14 |   785:   534,
  117 << 14 |   785:   535,
   83 << 14 |   806:   536,
  115 << 14 |   806:   537,
   84 << 14 |   806:   538,
  116 << 14 |   806:   539,
   72 << 14 |   780:   542,
  104 << 14 |   780:   543,
   65 << 14 |   775:   550,
   97 << 14 |   775:   551,
   69 << 14 |   807:   552,
  101 << 14 |   807:   553,
  214 << 14 |   772:   554,
  246 << 14 |   772:   555,
  213 << 14 |   772:   556,
  245 << 14 |   772:   557,
   79 << 14 |   775:   558,
  111 << 14 |   775:   559,
  558 << 14 |   772:   560,
  559 << 14 |   772:   561,
   89 << 14 |   772:   562,
  121 << 14 |   772:   563,
  168 << 14 |   769:   901,
  913 << 14 |   769:   902,
  917 << 14 |   769:   904,
  919 << 14 |   769:   905,
  921 << 14 |   769:   906,
  927 << 14 |   769:   908,
  933 << 14 |   769:   910,
  937 << 14 |   769:   911,
  970 << 14 |   769:   912,
  921 << 14 |   776:   938,
  933 << 14 |   776:   939,
  945 << 14 |   769:   940,
  949 << 14 |   769:   941,
  951 << 14 |   769:   942,
  953 << 14 |   769:   943,
  971 << 14 |   769:   944,
  953 << 14 |   776:   970,
  965 << 14 |   776:   971,
  959 << 14 |   769:   972,
  965 << 14 |   769:   973,
  969 << 14 |   769:   974,
  978 << 14 |   769:   979,
  978 << 14 |   776:   980,
 1045 << 14 |   768:  1024,
 1045 << 14 |   776:  1025,
 1043 << 14 |   769:  1027,
 1030 << 14 |   776:  1031,
 1050 << 14 |   769:  1036,
 1048 << 14 |   768:  1037,
 1059 << 14 |   774:  1038,
 1048 << 14 |   774:  1049,
 1080 << 14 |   774:  1081,
 1077 << 14 |   768:  1104,
 1077 << 14 |   776:  1105,
 1075 << 14 |   769:  1107,
 1110 << 14 |   776:  1111,
 1082 << 14 |   769:  1116,
 1080 << 14 |   768:  1117,
 1091 << 14 |   774:  1118,
 1140 << 14 |   783:  1142,
 1141 << 14 |   783:  1143,
 1046 << 14 |   774:  1217,
 1078 << 14 |   774:  1218,
 1040 << 14 |   774:  1232,
 1072 << 14 |   774:  1233,
 1040 << 14 |   776:  1234,
 1072 << 14 |   776:  1235,
 1045 << 14 |   774:  1238,
 1077 << 14 |   774:  1239,
 1240 << 14 |   776:  1242,
 1241 << 14 |   776:  1243,
 1046 << 14 |   776:  1244,
 1078 << 14 |   776:  1245,
 1047 << 14 |   776:  1246,
 1079 << 14 |   776:  1247,
 1048 << 14 |   772:  1250,
 1080 << 14 |   772:  1251,
 1048 << 14 |   776:  1252,
 1080 << 14 |   776:  1253,
 1054 << 14 |   776:  1254,
 1086 << 14 |   776:  1255,
 1256 << 14 |   776:  1258,
 1257 << 14 |   776:  1259,
 1069 << 14 |   776:  1260,
 1101 << 14 |   776:  1261,
 1059 << 14 |   772:  1262,
 1091 << 14 |   772:  1263,
 1059 << 14 |   776:  1264,
 1091 << 14 |   776:  1265,
 1059 << 14 |   779:  1266,
 1091 << 14 |   779:  1267,
 1063 << 14 |   776:  1268,
 1095 << 14 |   776:  1269,
 1067 << 14 |   776:  1272,
 1099 << 14 |   776:  1273,
 1575 << 14 |  1619:  1570,
 1575 << 14 |  1620:  1571,
 1608 << 14 |  1620:  1572,
 1575 << 14 |  1621:  1573,
 1610 << 14 |  1620:  1574,
 1749 << 14 |  1620:  1728,
 1729 << 14 |  1620:  1730,
 1746 << 14 |  1620:  1747,
 2344 << 14 |  2364:  2345,
 2352 << 14 |  2364:  2353,
 2355 << 14 |  2364:  2356,
 2503 << 14 |  2494:  2507,
 2503 << 14 |  2519:  2508,
 2887 << 14 |  2902:  2888,
 2887 << 14 |  2878:  2891,
 2887 << 14 |  2903:  2892,
 2962 << 14 |  3031:  2964,
 3014 << 14 |  3006:  3018,
 3015 << 14 |  3006:  3019,
 3014 << 14 |  3031:  3020,
 3142 << 14 |  3158:  3144,
 3263 << 14 |  3285:  3264,
 3270 << 14 |  3285:  3271,
 3270 << 14 |  3286:  3272,
 3270 << 14 |  3266:  3274,
 3274 << 14 |  3285:  3275,
 3398 << 14 |  3390:  3402,
 3399 << 14 |  3390:  3403,
 3398 << 14 |  3415:  3404,
 3545 << 14 |  3530:  3546,
 3545 << 14 |  3535:  3548,
 3548 << 14 |  3530:  3549,
 3545 << 14 |  3551:  3550,
 4133 << 14 |  4142:  4134,
   65 << 14 |   805:  7680,
   97 << 14 |   805:  7681,
   66 << 14 |   775:  7682,
   98 << 14 |   775:  7683,
   66 << 14 |   803:  7684,
   98 << 14 |   803:  7685,
   66 << 14 |   817:  7686,
   98 << 14 |   817:  7687,
  199 << 14 |   769:  7688,
  231 << 14 |   769:  7689,
   68 << 14 |   775:  7690,
  100 << 14 |   775:  7691,
   68 << 14 |   803:  7692,
  100 << 14 |   803:  7693,
   68 << 14 |   817:  7694,
  100 << 14 |   817:  7695,
   68 << 14 |   807:  7696,
  100 << 14 |   807:  7697,
   68 << 14 |   813:  7698,
  100 << 14 |   813:  7699,
  274 << 14 |   768:  7700,
  275 << 14 |   768:  7701,
  274 << 14 |   769:  7702,
  275 << 14 |   769:  7703,
   69 << 14 |   813:  7704,
  101 << 14 |   813:  7705,
   69 << 14 |   816:  7706,
  101 << 14 |   816:  7707,
  552 << 14 |   774:  7708,
  553 << 14 |   774:  7709,
   70 << 14 |   775:  7710,
  102 << 14 |   775:  7711,
   71 << 14 |   772:  7712,
  103 << 14 |   772:  7713,
   72 << 14 |   775:  7714,
  104 << 14 |   775:  7715,
   72 << 14 |   803:  7716,
  104 << 14 |   803:  7717,
   72 << 14 |   776:  7718,
  104 << 14 |   776:  7719,
   72 << 14 |   807:  7720,
  104 << 14 |   807:  7721,
   72 << 14 |   814:  7722,
  104 << 14 |   814:  7723,
   73 << 14 |   816:  7724,
  105 << 14 |   816:  7725,
  207 << 14 |   769:  7726,
  239 << 14 |   769:  7727,
   75 << 14 |   769:  7728,
  107 << 14 |   769:  7729,
   75 << 14 |   803:  7730,
  107 << 14 |   803:  7731,
   75 << 14 |   817:  7732,
  107 << 14 |   817:  7733,
   76 << 14 |   803:  7734,
  108 << 14 |   803:  7735,
 7734 << 14 |   772:  7736,
 7735 << 14 |   772:  7737,
   76 << 14 |   817:  7738,
  108 << 14 |   817:  7739,
   76 << 14 |   813:  7740,
  108 << 14 |   813:  7741,
   77 << 14 |   769:  7742,
  109 << 14 |   769:  7743,
   77 << 14 |   775:  7744,
  109 << 14 |   775:  7745,
   77 << 14 |   803:  7746,
  109 << 14 |   803:  7747,
   78 << 14 |   775:  7748,
  110 << 14 |   775:  7749,
   78 << 14 |   803:  7750,
  110 << 14 |   803:  7751,
   78 << 14 |   817:  7752,
  110 << 14 |   817:  7753,
   78 << 14 |   813:  7754,
  110 << 14 |   813:  7755,
  213 << 14 |   769:  7756,
  245 << 14 |   769:  7757,
  213 << 14 |   776:  7758,
  245 << 14 |   776:  7759,
  332 << 14 |   768:  7760,
  333 << 14 |   768:  7761,
  332 << 14 |   769:  7762,
  333 << 14 |   769:  7763,
   80 << 14 |   769:  7764,
  112 << 14 |   769:  7765,
   80 << 14 |   775:  7766,
  112 << 14 |   775:  7767,
   82 << 14 |   775:  7768,
  114 << 14 |   775:  7769,
   82 << 14 |   803:  7770,
  114 << 14 |   803:  7771,
 7770 << 14 |   772:  7772,
 7771 << 14 |   772:  7773,
   82 << 14 |   817:  7774,
  114 << 14 |   817:  7775,
   83 << 14 |   775:  7776,
  115 << 14 |   775:  7777,
   83 << 14 |   803:  7778,
  115 << 14 |   803:  7779,
  346 << 14 |   775:  7780,
  347 << 14 |   775:  7781,
  352 << 14 |   775:  7782,
  353 << 14 |   775:  7783,
 7778 << 14 |   775:  7784,
 7779 << 14 |   775:  7785,
   84 << 14 |   775:  7786,
  116 << 14 |   775:  7787,
   84 << 14 |   803:  7788,
  116 << 14 |   803:  7789,
   84 << 14 |   817:  7790,
  116 << 14 |   817:  7791,
   84 << 14 |   813:  7792,
  116 << 14 |   813:  7793,
   85 << 14 |   804:  7794,
  117 << 14 |   804:  7795,
   85 << 14 |   816:  7796,
  117 << 14 |   816:  7797,
   85 << 14 |   813:  7798,
  117 << 14 |   813:  7799,
  360 << 14 |   769:  7800,
  361 << 14 |   769:  7801,
  362 << 14 |   776:  7802,
  363 << 14 |   776:  7803,
   86 << 14 |   771:  7804,
  118 << 14 |   771:  7805,
   86 << 14 |   803:  7806,
  118 << 14 |   803:  7807,
   87 << 14 |   768:  7808,
  119 << 14 |   768:  7809,
   87 << 14 |   769:  7810,
  119 << 14 |   769:  7811,
   87 << 14 |   776:  7812,
  119 << 14 |   776:  7813,
   87 << 14 |   775:  7814,
  119 << 14 |   775:  7815,
   87 << 14 |   803:  7816,
  119 << 14 |   803:  7817,
   88 << 14 |   775:  7818,
  120 << 14 |   775:  7819,
   88 << 14 |   776:  7820,
  120 << 14 |   776:  7821,
   89 << 14 |   775:  7822,
  121 << 14 |   775:  7823,
   90 << 14 |   770:  7824,
  122 << 14 |   770:  7825,
   90 << 14 |   803:  7826,
  122 << 14 |   803:  7827,
   90 << 14 |   817:  7828,
  122 << 14 |   817:  7829,
  104 << 14 |   817:  7830,
  116 << 14 |   776:  7831,
  119 << 14 |   778:  7832,
  121 << 14 |   778:  7833,
  383 << 14 |   775:  7835,
   65 << 14 |   803:  7840,
   97 << 14 |   803:  7841,
   65 << 14 |   777:  7842,
   97 << 14 |   777:  7843,
  194 << 14 |   769:  7844,
  226 << 14 |   769:  7845,
  194 << 14 |   768:  7846,
  226 << 14 |   768:  7847,
  194 << 14 |   777:  7848,
  226 << 14 |   777:  7849,
  194 << 14 |   771:  7850,
  226 << 14 |   771:  7851,
 7840 << 14 |   770:  7852,
 7841 << 14 |   770:  7853,
  258 << 14 |   769:  7854,
  259 << 14 |   769:  7855,
  258 << 14 |   768:  7856,
  259 << 14 |   768:  7857,
  258 << 14 |   777:  7858,
  259 << 14 |   777:  7859,
  258 << 14 |   771:  7860,
  259 << 14 |   771:  7861,
 7840 << 14 |   774:  7862,
 7841 << 14 |   774:  7863,
   69 << 14 |   803:  7864,
  101 << 14 |   803:  7865,
   69 << 14 |   777:  7866,
  101 << 14 |   777:  7867,
   69 << 14 |   771:  7868,
  101 << 14 |   771:  7869,
  202 << 14 |   769:  7870,
  234 << 14 |   769:  7871,
  202 << 14 |   768:  7872,
  234 << 14 |   768:  7873,
  202 << 14 |   777:  7874,
  234 << 14 |   777:  7875,
  202 << 14 |   771:  7876,
  234 << 14 |   771:  7877,
 7864 << 14 |   770:  7878,
 7865 << 14 |   770:  7879,
   73 << 14 |   777:  7880,
  105 << 14 |   777:  7881,
   73 << 14 |   803:  7882,
  105 << 14 |   803:  7883,
   79 << 14 |   803:  7884,
  111 << 14 |   803:  7885,
   79 << 14 |   777:  7886,
  111 << 14 |   777:  7887,
  212 << 14 |   769:  7888,
  244 << 14 |   769:  7889,
  212 << 14 |   768:  7890,
  244 << 14 |   768:  7891,
  212 << 14 |   777:  7892,
  244 << 14 |   777:  7893,
  212 << 14 |   771:  7894,
  244 << 14 |   771:  7895,
 7884 << 14 |   770:  7896,
 7885 << 14 |   770:  7897,
  416 << 14 |   769:  7898,
  417 << 14 |   769:  7899,
  416 << 14 |   768:  7900,
  417 << 14 |   768:  7901,
  416 << 14 |   777:  7902,
  417 << 14 |   777:  7903,
  416 << 14 |   771:  7904,
  417 << 14 |   771:  7905,
  416 << 14 |   803:  7906,
  417 << 14 |   803:  7907,
   85 << 14 |   803:  7908,
  117 << 14 |   803:  7909,
   85 << 14 |   777:  7910,
  117 << 14 |   777:  7911,
  431 << 14 |   769:  7912,
  432 << 14 |   769:  7913,
  431 << 14 |   768:  7914,
  432 << 14 |   768:  7915,
  431 << 14 |   777:  7916,
  432 << 14 |   777:  7917,
  431 << 14 |   771:  7918,
  432 << 14 |   771:  7919,
  431 << 14 |   803:  7920,
  432 << 14 |   803:  7921,
   89 << 14 |   768:  7922,
  121 << 14 |   768:  7923,
   89 << 14 |   803:  7924,
  121 << 14 |   803:  7925,
   89 << 14 |   777:  7926,
  121 << 14 |   777:  7927,
   89 << 14 |   771:  7928,
  121 << 14 |   771:  7929,
  945 << 14 |   787:  7936,
  945 << 14 |   788:  7937,
 7936 << 14 |   768:  7938,
 7937 << 14 |   768:  7939,
 7936 << 14 |   769:  7940,
 7937 << 14 |   769:  7941,
 7936 << 14 |   834:  7942,
 7937 << 14 |   834:  7943,
  913 << 14 |   787:  7944,
  913 << 14 |   788:  7945,
 7944 << 14 |   768:  7946,
 7945 << 14 |   768:  7947,
 7944 << 14 |   769:  7948,
 7945 << 14 |   769:  7949,
 7944 << 14 |   834:  7950,
 7945 << 14 |   834:  7951,
  949 << 14 |   787:  7952,
  949 << 14 |   788:  7953,
 7952 << 14 |   768:  7954,
 7953 << 14 |   768:  7955,
 7952 << 14 |   769:  7956,
 7953 << 14 |   769:  7957,
  917 << 14 |   787:  7960,
  917 << 14 |   788:  7961,
 7960 << 14 |   768:  7962,
 7961 << 14 |   768:  7963,
 7960 << 14 |   769:  7964,
 7961 << 14 |   769:  7965,
  951 << 14 |   787:  7968,
  951 << 14 |   788:  7969,
 7968 << 14 |   768:  7970,
 7969 << 14 |   768:  7971,
 7968 << 14 |   769:  7972,
 7969 << 14 |   769:  7973,
 7968 << 14 |   834:  7974,
 7969 << 14 |   834:  7975,
  919 << 14 |   787:  7976,
  919 << 14 |   788:  7977,
 7976 << 14 |   768:  7978,
 7977 << 14 |   768:  7979,
 7976 << 14 |   769:  7980,
 7977 << 14 |   769:  7981,
 7976 << 14 |   834:  7982,
 7977 << 14 |   834:  7983,
  953 << 14 |   787:  7984,
  953 << 14 |   788:  7985,
 7984 << 14 |   768:  7986,
 7985 << 14 |   768:  7987,
 7984 << 14 |   769:  7988,
 7985 << 14 |   769:  7989,
 7984 << 14 |   834:  7990,
 7985 << 14 |   834:  7991,
  921 << 14 |   787:  7992,
  921 << 14 |   788:  7993,
 7992 << 14 |   768:  7994,
 7993 << 14 |   768:  7995,
 7992 << 14 |   769:  7996,
 7993 << 14 |   769:  7997,
 7992 << 14 |   834:  7998,
 7993 << 14 |   834:  7999,
  959 << 14 |   787:  8000,
  959 << 14 |   788:  8001,
 8000 << 14 |   768:  8002,
 8001 << 14 |   768:  8003,
 8000 << 14 |   769:  8004,
 8001 << 14 |   769:  8005,
  927 << 14 |   787:  8008,
  927 << 14 |   788:  8009,
 8008 << 14 |   768:  8010,
 8009 << 14 |   768:  8011,
 8008 << 14 |   769:  8012,
 8009 << 14 |   769:  8013,
  965 << 14 |   787:  8016,
  965 << 14 |   788:  8017,
 8016 << 14 |   768:  8018,
 8017 << 14 |   768:  8019,
 8016 << 14 |   769:  8020,
 8017 << 14 |   769:  8021,
 8016 << 14 |   834:  8022,
 8017 << 14 |   834:  8023,
  933 << 14 |   788:  8025,
 8025 << 14 |   768:  8027,
 8025 << 14 |   769:  8029,
 8025 << 14 |   834:  8031,
  969 << 14 |   787:  8032,
  969 << 14 |   788:  8033,
 8032 << 14 |   768:  8034,
 8033 << 14 |   768:  8035,
 8032 << 14 |   769:  8036,
 8033 << 14 |   769:  8037,
 8032 << 14 |   834:  8038,
 8033 << 14 |   834:  8039,
  937 << 14 |   787:  8040,
  937 << 14 |   788:  8041,
 8040 << 14 |   768:  8042,
 8041 << 14 |   768:  8043,
 8040 << 14 |   769:  8044,
 8041 << 14 |   769:  8045,
 8040 << 14 |   834:  8046,
 8041 << 14 |   834:  8047,
  945 << 14 |   768:  8048,
  949 << 14 |   768:  8050,
  951 << 14 |   768:  8052,
  953 << 14 |   768:  8054,
  959 << 14 |   768:  8056,
  965 << 14 |   768:  8058,
  969 << 14 |   768:  8060,
 7936 << 14 |   837:  8064,
 7937 << 14 |   837:  8065,
 7938 << 14 |   837:  8066,
 7939 << 14 |   837:  8067,
 7940 << 14 |   837:  8068,
 7941 << 14 |   837:  8069,
 7942 << 14 |   837:  8070,
 7943 << 14 |   837:  8071,
 7944 << 14 |   837:  8072,
 7945 << 14 |   837:  8073,
 7946 << 14 |   837:  8074,
 7947 << 14 |   837:  8075,
 7948 << 14 |   837:  8076,
 7949 << 14 |   837:  8077,
 7950 << 14 |   837:  8078,
 7951 << 14 |   837:  8079,
 7968 << 14 |   837:  8080,
 7969 << 14 |   837:  8081,
 7970 << 14 |   837:  8082,
 7971 << 14 |   837:  8083,
 7972 << 14 |   837:  8084,
 7973 << 14 |   837:  8085,
 7974 << 14 |   837:  8086,
 7975 << 14 |   837:  8087,
 7976 << 14 |   837:  8088,
 7977 << 14 |   837:  8089,
 7978 << 14 |   837:  8090,
 7979 << 14 |   837:  8091,
 7980 << 14 |   837:  8092,
 7981 << 14 |   837:  8093,
 7982 << 14 |   837:  8094,
 7983 << 14 |   837:  8095,
 8032 << 14 |   837:  8096,
 8033 << 14 |   837:  8097,
 8034 << 14 |   837:  8098,
 8035 << 14 |   837:  8099,
 8036 << 14 |   837:  8100,
 8037 << 14 |   837:  8101,
 8038 << 14 |   837:  8102,
 8039 << 14 |   837:  8103,
 8040 << 14 |   837:  8104,
 8041 << 14 |   837:  8105,
 8042 << 14 |   837:  8106,
 8043 << 14 |   837:  8107,
 8044 << 14 |   837:  8108,
 8045 << 14 |   837:  8109,
 8046 << 14 |   837:  8110,
 8047 << 14 |   837:  8111,
  945 << 14 |   774:  8112,
  945 << 14 |   772:  8113,
 8048 << 14 |   837:  8114,
  945 << 14 |   837:  8115,
  940 << 14 |   837:  8116,
  945 << 14 |   834:  8118,
 8118 << 14 |   837:  8119,
  913 << 14 |   774:  8120,
  913 << 14 |   772:  8121,
  913 << 14 |   768:  8122,
  913 << 14 |   837:  8124,
  168 << 14 |   834:  8129,
 8052 << 14 |   837:  8130,
  951 << 14 |   837:  8131,
  942 << 14 |   837:  8132,
  951 << 14 |   834:  8134,
 8134 << 14 |   837:  8135,
  917 << 14 |   768:  8136,
  919 << 14 |   768:  8138,
  919 << 14 |   837:  8140,
 8127 << 14 |   768:  8141,
 8127 << 14 |   769:  8142,
 8127 << 14 |   834:  8143,
  953 << 14 |   774:  8144,
  953 << 14 |   772:  8145,
  970 << 14 |   768:  8146,
  953 << 14 |   834:  8150,
  970 << 14 |   834:  8151,
  921 << 14 |   774:  8152,
  921 << 14 |   772:  8153,
  921 << 14 |   768:  8154,
 8190 << 14 |   768:  8157,
 8190 << 14 |   769:  8158,
 8190 << 14 |   834:  8159,
  965 << 14 |   774:  8160,
  965 << 14 |   772:  8161,
  971 << 14 |   768:  8162,
  961 << 14 |   787:  8164,
  961 << 14 |   788:  8165,
  965 << 14 |   834:  8166,
  971 << 14 |   834:  8167,
  933 << 14 |   774:  8168,
  933 << 14 |   772:  8169,
  933 << 14 |   768:  8170,
  929 << 14 |   788:  8172,
  168 << 14 |   768:  8173,
 8060 << 14 |   837:  8178,
  969 << 14 |   837:  8179,
  974 << 14 |   837:  8180,
  969 << 14 |   834:  8182,
 8182 << 14 |   837:  8183,
  927 << 14 |   768:  8184,
  937 << 14 |   768:  8186,
  937 << 14 |   837:  8188,
 8592 << 14 |   824:  8602,
 8594 << 14 |   824:  8603,
 8596 << 14 |   824:  8622,
 8656 << 14 |   824:  8653,
 8660 << 14 |   824:  8654,
 8658 << 14 |   824:  8655,
 8707 << 14 |   824:  8708,
 8712 << 14 |   824:  8713,
 8715 << 14 |   824:  8716,
 8739 << 14 |   824:  8740,
 8741 << 14 |   824:  8742,
 8764 << 14 |   824:  8769,
 8771 << 14 |   824:  8772,
 8773 << 14 |   824:  8775,
 8776 << 14 |   824:  8777,
   61 << 14 |   824:  8800,
 8801 << 14 |   824:  8802,
 8781 << 14 |   824:  8813,
   60 << 14 |   824:  8814,
   62 << 14 |   824:  8815,
 8804 << 14 |   824:  8816,
 8805 << 14 |   824:  8817,
 8818 << 14 |   824:  8820,
 8819 << 14 |   824:  8821,
 8822 << 14 |   824:  8824,
 8823 << 14 |   824:  8825,
 8826 << 14 |   824:  8832,
 8827 << 14 |   824:  8833,
 8834 << 14 |   824:  8836,
 8835 << 14 |   824:  8837,
 8838 << 14 |   824:  8840,
 8839 << 14 |   824:  8841,
 8866 << 14 |   824:  8876,
 8872 << 14 |   824:  8877,
 8873 << 14 |   824:  8878,
 8875 << 14 |   824:  8879,
 8828 << 14 |   824:  8928,
 8829 << 14 |   824:  8929,
 8849 << 14 |   824:  8930,
 8850 << 14 |   824:  8931,
 8882 << 14 |   824:  8938,
 8883 << 14 |   824:  8939,
 8884 << 14 |   824:  8940,
 8885 << 14 |   824:  8941,
12363 << 14 | 12441: 12364,
12365 << 14 | 12441: 12366,
12367 << 14 | 12441: 12368,
12369 << 14 | 12441: 12370,
12371 << 14 | 12441: 12372,
12373 << 14 | 12441: 12374,
12375 << 14 | 12441: 12376,
12377 << 14 | 12441: 12378,
12379 << 14 | 12441: 12380,
12381 << 14 | 12441: 12382,
12383 << 14 | 12441: 12384,
12385 << 14 | 12441: 12386,
12388 << 14 | 12441: 12389,
12390 << 14 | 12441: 12391,
12392 << 14 | 12441: 12393,
12399 << 14 | 12441: 12400,
12399 << 14 | 12442: 12401,
12402 << 14 | 12441: 12403,
12402 << 14 | 12442: 12404,
12405 << 14 | 12441: 12406,
12405 << 14 | 12442: 12407,
12408 << 14 | 12441: 12409,
12408 << 14 | 12442: 12410,
12411 << 14 | 12441: 12412,
12411 << 14 | 12442: 12413,
12358 << 14 | 12441: 12436,
12445 << 14 | 12441: 12446,
12459 << 14 | 12441: 12460,
12461 << 14 | 12441: 12462,
12463 << 14 | 12441: 12464,
12465 << 14 | 12441: 12466,
12467 << 14 | 12441: 12468,
12469 << 14 | 12441: 12470,
12471 << 14 | 12441: 12472,
12473 << 14 | 12441: 12474,
12475 << 14 | 12441: 12476,
12477 << 14 | 12441: 12478,
12479 << 14 | 12441: 12480,
12481 << 14 | 12441: 12482,
12484 << 14 | 12441: 12485,
12486 << 14 | 12441: 12487,
12488 << 14 | 12441: 12489,
12495 << 14 | 12441: 12496,
12495 << 14 | 12442: 12497,
12498 << 14 | 12441: 12499,
12498 << 14 | 12442: 12500,
12501 << 14 | 12441: 12502,
12501 << 14 | 12442: 12503,
12504 << 14 | 12441: 12505,
12504 << 14 | 12442: 12506,
12507 << 14 | 12441: 12508,
12507 << 14 | 12442: 12509,
12454 << 14 | 12441: 12532,
12527 << 14 | 12441: 12535,
12528 << 14 | 12441: 12536,
12529 << 14 | 12441: 12537,
12530 << 14 | 12441: 12538,
12541 << 14 | 12441: 12542,
}

_canon_decomposition = {
192: [65, 768],
193: [65, 769],
194: [65, 770],
195: [65, 771],
196: [65, 776],
197: [65, 778],
199: [67, 807],
200: [69, 768],
201: [69, 769],
202: [69, 770],
203: [69, 776],
204: [73, 768],
205: [73, 769],
206: [73, 770],
207: [73, 776],
209: [78, 771],
210: [79, 768],
211: [79, 769],
212: [79, 770],
213: [79, 771],
214: [79, 776],
217: [85, 768],
218: [85, 769],
219: [85, 770],
220: [85, 776],
221: [89, 769],
224: [97, 768],
225: [97, 769],
226: [97, 770],
227: [97, 771],
228: [97, 776],
229: [97, 778],
231: [99, 807],
232: [101, 768],
233: [101, 769],
234: [101, 770],
235: [101, 776],
236: [105, 768],
237: [105, 769],
238: [105, 770],
239: [105, 776],
241: [110, 771],
242: [111, 768],
243: [111, 769],
244: [111, 770],
245: [111, 771],
246: [111, 776],
249: [117, 768],
250: [117, 769],
251: [117, 770],
252: [117, 776],
253: [121, 769],
255: [121, 776],
256: [65, 772],
257: [97, 772],
258: [65, 774],
259: [97, 774],
260: [65, 808],
261: [97, 808],
262: [67, 769],
263: [99, 769],
264: [67, 770],
265: [99, 770],
266: [67, 775],
267: [99, 775],
268: [67, 780],
269: [99, 780],
270: [68, 780],
271: [100, 780],
274: [69, 772],
275: [101, 772],
276: [69, 774],
277: [101, 774],
278: [69, 775],
279: [101, 775],
280: [69, 808],
281: [101, 808],
282: [69, 780],
283: [101, 780],
284: [71, 770],
285: [103, 770],
286: [71, 774],
287: [103, 774],
288: [71, 775],
289: [103, 775],
290: [71, 807],
291: [103, 807],
292: [72, 770],
293: [104, 770],
296: [73, 771],
297: [105, 771],
298: [73, 772],
299: [105, 772],
300: [73, 774],
301: [105, 774],
302: [73, 808],
303: [105, 808],
304: [73, 775],
308: [74, 770],
309: [106, 770],
310: [75, 807],
311: [107, 807],
313: [76, 769],
314: [108, 769],
315: [76, 807],
316: [108, 807],
317: [76, 780],
318: [108, 780],
323: [78, 769],
324: [110, 769],
325: [78, 807],
326: [110, 807],
327: [78, 780],
328: [110, 780],
332: [79, 772],
333: [111, 772],
334: [79, 774],
335: [111, 774],
336: [79, 779],
337: [111, 779],
340: [82, 769],
341: [114, 769],
342: [82, 807],
343: [114, 807],
344: [82, 780],
345: [114, 780],
346: [83, 769],
347: [115, 769],
348: [83, 770],
349: [115, 770],
350: [83, 807],
351: [115, 807],
352: [83, 780],
353: [115, 780],
354: [84, 807],
355: [116, 807],
356: [84, 780],
357: [116, 780],
360: [85, 771],
361: [117, 771],
362: [85, 772],
363: [117, 772],
364: [85, 774],
365: [117, 774],
366: [85, 778],
367: [117, 778],
368: [85, 779],
369: [117, 779],
370: [85, 808],
371: [117, 808],
372: [87, 770],
373: [119, 770],
374: [89, 770],
375: [121, 770],
376: [89, 776],
377: [90, 769],
378: [122, 769],
379: [90, 775],
380: [122, 775],
381: [90, 780],
382: [122, 780],
416: [79, 795],
417: [111, 795],
431: [85, 795],
432: [117, 795],
461: [65, 780],
462: [97, 780],
463: [73, 780],
464: [105, 780],
465: [79, 780],
466: [111, 780],
467: [85, 780],
468: [117, 780],
469: [85, 776, 772],
470: [117, 776, 772],
471: [85, 776, 769],
472: [117, 776, 769],
473: [85, 776, 780],
474: [117, 776, 780],
475: [85, 776, 768],
476: [117, 776, 768],
478: [65, 776, 772],
479: [97, 776, 772],
480: [65, 775, 772],
481: [97, 775, 772],
482: [198, 772],
483: [230, 772],
486: [71, 780],
487: [103, 780],
488: [75, 780],
489: [107, 780],
490: [79, 808],
491: [111, 808],
492: [79, 808, 772],
493: [111, 808, 772],
494: [439, 780],
495: [658, 780],
496: [106, 780],
500: [71, 769],
501: [103, 769],
504: [78, 768],
505: [110, 768],
506: [65, 778, 769],
507: [97, 778, 769],
508: [198, 769],
509: [230, 769],
510: [216, 769],
511: [248, 769],
512: [65, 783],
513: [97, 783],
514: [65, 785],
515: [97, 785],
516: [69, 783],
517: [101, 783],
518: [69, 785],
519: [101, 785],
520: [73, 783],
521: [105, 783],
522: [73, 785],
523: [105, 785],
524: [79, 783],
525: [111, 783],
526: [79, 785],
527: [111, 785],
528: [82, 783],
529: [114, 783],
530: [82, 785],
531: [114, 785],
532: [85, 783],
533: [117, 783],
534: [85, 785],
535: [117, 785],
536: [83, 806],
537: [115, 806],
538: [84, 806],
539: [116, 806],
542: [72, 780],
543: [104, 780],
550: [65, 775],
551: [97, 775],
552: [69, 807],
553: [101, 807],
554: [79, 776, 772],
555: [111, 776, 772],
556: [79, 771, 772],
557: [111, 771, 772],
558: [79, 775],
559: [111, 775],
560: [79, 775, 772],
561: [111, 775, 772],
562: [89, 772],
563: [121, 772],
832: [768],
833: [769],
835: [787],
836: [776, 769],
884: [697],
894: [59],
901: [168, 769],
902: [913, 769],
903: [183],
904: [917, 769],
905: [919, 769],
906: [921, 769],
908: [927, 769],
910: [933, 769],
911: [937, 769],
912: [953, 776, 769],
938: [921, 776],
939: [933, 776],
940: [945, 769],
941: [949, 769],
942: [951, 769],
943: [953, 769],
944: [965, 776, 769],
970: [953, 776],
971: [965, 776],
972: [959, 769],
973: [965, 769],
974: [969, 769],
979: [978, 769],
980: [978, 776],
1024: [1045, 768],
1025: [1045, 776],
1027: [1043, 769],
1031: [1030, 776],
1036: [1050, 769],
1037: [1048, 768],
1038: [1059, 774],
1049: [1048, 774],
1081: [1080, 774],
1104: [1077, 768],
1105: [1077, 776],
1107: [1075, 769],
1111: [1110, 776],
1116: [1082, 769],
1117: [1080, 768],
1118: [1091, 774],
1142: [1140, 783],
1143: [1141, 783],
1217: [1046, 774],
1218: [1078, 774],
1232: [1040, 774],
1233: [1072, 774],
1234: [1040, 776],
1235: [1072, 776],
1238: [1045, 774],
1239: [1077, 774],
1242: [1240, 776],
1243: [1241, 776],
1244: [1046, 776],
1245: [1078, 776],
1246: [1047, 776],
1247: [1079, 776],
1250: [1048, 772],
1251: [1080, 772],
1252: [1048, 776],
1253: [1080, 776],
1254: [1054, 776],
1255: [1086, 776],
1258: [1256, 776],
1259: [1257, 776],
1260: [1069, 776],
1261: [1101, 776],
1262: [1059, 772],
1263: [1091, 772],
1264: [1059, 776],
1265: [1091, 776],
1266: [1059, 779],
1267: [1091, 779],
1268: [1063, 776],
1269: [1095, 776],
1272: [1067, 776],
1273: [1099, 776],
1570: [1575, 1619],
1571: [1575, 1620],
1572: [1608, 1620],
1573: [1575, 1621],
1574: [1610, 1620],
1728: [1749, 1620],
1730: [1729, 1620],
1747: [1746, 1620],
2345: [2344, 2364],
2353: [2352, 2364],
2356: [2355, 2364],
2392: [2325, 2364],
2393: [2326, 2364],
2394: [2327, 2364],
2395: [2332, 2364],
2396: [2337, 2364],
2397: [2338, 2364],
2398: [2347, 2364],
2399: [2351, 2364],
2507: [2503, 2494],
2508: [2503, 2519],
2524: [2465, 2492],
2525: [2466, 2492],
2527: [2479, 2492],
2611: [2610, 2620],
2614: [2616, 2620],
2649: [2582, 2620],
2650: [2583, 2620],
2651: [2588, 2620],
2654: [2603, 2620],
2888: [2887, 2902],
2891: [2887, 2878],
2892: [2887, 2903],
2908: [2849, 2876],
2909: [2850, 2876],
2964: [2962, 3031],
3018: [3014, 3006],
3019: [3015, 3006],
3020: [3014, 3031],
3144: [3142, 3158],
3264: [3263, 3285],
3271: [3270, 3285],
3272: [3270, 3286],
3274: [3270, 3266],
3275: [3270, 3266, 3285],
3402: [3398, 3390],
3403: [3399, 3390],
3404: [3398, 3415],
3546: [3545, 3530],
3548: [3545, 3535],
3549: [3545, 3535, 3530],
3550: [3545, 3551],
3907: [3906, 4023],
3917: [3916, 4023],
3922: [3921, 4023],
3927: [3926, 4023],
3932: [3931, 4023],
3945: [3904, 4021],
3955: [3953, 3954],
3957: [3953, 3956],
3958: [4018, 3968],
3960: [4019, 3968],
3969: [3953, 3968],
3987: [3986, 4023],
3997: [3996, 4023],
4002: [4001, 4023],
4007: [4006, 4023],
4012: [4011, 4023],
4025: [3984, 4021],
4134: [4133, 4142],
7680: [65, 805],
7681: [97, 805],
7682: [66, 775],
7683: [98, 775],
7684: [66, 803],
7685: [98, 803],
7686: [66, 817],
7687: [98, 817],
7688: [67, 807, 769],
7689: [99, 807, 769],
7690: [68, 775],
7691: [100, 775],
7692: [68, 803],
7693: [100, 803],
7694: [68, 817],
7695: [100, 817],
7696: [68, 807],
7697: [100, 807],
7698: [68, 813],
7699: [100, 813],
7700: [69, 772, 768],
7701: [101, 772, 768],
7702: [69, 772, 769],
7703: [101, 772, 769],
7704: [69, 813],
7705: [101, 813],
7706: [69, 816],
7707: [101, 816],
7708: [69, 807, 774],
7709: [101, 807, 774],
7710: [70, 775],
7711: [102, 775],
7712: [71, 772],
7713: [103, 772],
7714: [72, 775],
7715: [104, 775],
7716: [72, 803],
7717: [104, 803],
7718: [72, 776],
7719: [104, 776],
7720: [72, 807],
7721: [104, 807],
7722: [72, 814],
7723: [104, 814],
7724: [73, 816],
7725: [105, 816],
7726: [73, 776, 769],
7727: [105, 776, 769],
7728: [75, 769],
7729: [107, 769],
7730: [75, 803],
7731: [107, 803],
7732: [75, 817],
7733: [107, 817],
7734: [76, 803],
7735: [108, 803],
7736: [76, 803, 772],
7737: [108, 803, 772],
7738: [76, 817],
7739: [108, 817],
7740: [76, 813],
7741: [108, 813],
7742: [77, 769],
7743: [109, 769],
7744: [77, 775],
7745: [109, 775],
7746: [77, 803],
7747: [109, 803],
7748: [78, 775],
7749: [110, 775],
7750: [78, 803],
7751: [110, 803],
7752: [78, 817],
7753: [110, 817],
7754: [78, 813],
7755: [110, 813],
7756: [79, 771, 769],
7757: [111, 771, 769],
7758: [79, 771, 776],
7759: [111, 771, 776],
7760: [79, 772, 768],
7761: [111, 772, 768],
7762: [79, 772, 769],
7763: [111, 772, 769],
7764: [80, 769],
7765: [112, 769],
7766: [80, 775],
7767: [112, 775],
7768: [82, 775],
7769: [114, 775],
7770: [82, 803],
7771: [114, 803],
7772: [82, 803, 772],
7773: [114, 803, 772],
7774: [82, 817],
7775: [114, 817],
7776: [83, 775],
7777: [115, 775],
7778: [83, 803],
7779: [115, 803],
7780: [83, 769, 775],
7781: [115, 769, 775],
7782: [83, 780, 775],
7783: [115, 780, 775],
7784: [83, 803, 775],
7785: [115, 803, 775],
7786: [84, 775],
7787: [116, 775],
7788: [84, 803],
7789: [116, 803],
7790: [84, 817],
7791: [116, 817],
7792: [84, 813],
7793: [116, 813],
7794: [85, 804],
7795: [117, 804],
7796: [85, 816],
7797: [117, 816],
7798: [85, 813],
7799: [117, 813],
7800: [85, 771, 769],
7801: [117, 771, 769],
7802: [85, 772, 776],
7803: [117, 772, 776],
7804: [86, 771],
7805: [118, 771],
7806: [86, 803],
7807: [118, 803],
7808: [87, 768],
7809: [119, 768],
7810: [87, 769],
7811: [119, 769],
7812: [87, 776],
7813: [119, 776],
7814: [87, 775],
7815: [119, 775],
7816: [87, 803],
7817: [119, 803],
7818: [88, 775],
7819: [120, 775],
7820: [88, 776],
7821: [120, 776],
7822: [89, 775],
7823: [121, 775],
7824: [90, 770],
7825: [122, 770],
7826: [90, 803],
7827: [122, 803],
7828: [90, 817],
7829: [122, 817],
7830: [104, 817],
7831: [116, 776],
7832: [119, 778],
7833: [121, 778],
7835: [383, 775],
7840: [65, 803],
7841: [97, 803],
7842: [65, 777],
7843: [97, 777],
7844: [65, 770, 769],
7845: [97, 770, 769],
7846: [65, 770, 768],
7847: [97, 770, 768],
7848: [65, 770, 777],
7849: [97, 770, 777],
7850: [65, 770, 771],
7851: [97, 770, 771],
7852: [65, 803, 770],
7853: [97, 803, 770],
7854: [65, 774, 769],
7855: [97, 774, 769],
7856: [65, 774, 768],
7857: [97, 774, 768],
7858: [65, 774, 777],
7859: [97, 774, 777],
7860: [65, 774, 771],
7861: [97, 774, 771],
7862: [65, 803, 774],
7863: [97, 803, 774],
7864: [69, 803],
7865: [101, 803],
7866: [69, 777],
7867: [101, 777],
7868: [69, 771],
7869: [101, 771],
7870: [69, 770, 769],
7871: [101, 770, 769],
7872: [69, 770, 768],
7873: [101, 770, 768],
7874: [69, 770, 777],
7875: [101, 770, 777],
7876: [69, 770, 771],
7877: [101, 770, 771],
7878: [69, 803, 770],
7879: [101, 803, 770],
7880: [73, 777],
7881: [105, 777],
7882: [73, 803],
7883: [105, 803],
7884: [79, 803],
7885: [111, 803],
7886: [79, 777],
7887: [111, 777],
7888: [79, 770, 769],
7889: [111, 770, 769],
7890: [79, 770, 768],
7891: [111, 770, 768],
7892: [79, 770, 777],
7893: [111, 770, 777],
7894: [79, 770, 771],
7895: [111, 770, 771],
7896: [79, 803, 770],
7897: [111, 803, 770],
7898: [79, 795, 769],
7899: [111, 795, 769],
7900: [79, 795, 768],
7901: [111, 795, 768],
7902: [79, 795, 777],
7903: [111, 795, 777],
7904: [79, 795, 771],
7905: [111, 795, 771],
7906: [79, 795, 803],
7907: [111, 795, 803],
7908: [85, 803],
7909: [117, 803],
7910: [85, 777],
7911: [117, 777],
7912: [85, 795, 769],
7913: [117, 795, 769],
7914: [85, 795, 768],
7915: [117, 795, 768],
7916: [85, 795, 777],
7917: [117, 795, 777],
7918: [85, 795, 771],
7919: [117, 795, 771],
7920: [85, 795, 803],
7921: [117, 795, 803],
7922: [89, 768],
7923: [121, 768],
7924: [89, 803],
7925: [121, 803],
7926: [89, 777],
7927: [121, 777],
7928: [89, 771],
7929: [121, 771],
7936: [945, 787],
7937: [945, 788],
7938: [945, 787, 768],
7939: [945, 788, 768],
7940: [945, 787, 769],
7941: [945, 788, 769],
7942: [945, 787, 834],
7943: [945, 788, 834],
7944: [913, 787],
7945: [913, 788],
7946: [913, 787, 768],
7947: [913, 788, 768],
7948: [913, 787, 769],
7949: [913, 788, 769],
7950: [913, 787, 834],
7951: [913, 788, 834],
7952: [949, 787],
7953: [949, 788],
7954: [949, 787, 768],
7955: [949, 788, 768],
7956: [949, 787, 769],
7957: [949, 788, 769],
7960: [917, 787],
7961: [917, 788],
7962: [917, 787, 768],
7963: [917, 788, 768],
7964: [917, 787, 769],
7965: [917, 788, 769],
7968: [951, 787],
7969: [951, 788],
7970: [951, 787, 768],
7971: [951, 788, 768],
7972: [951, 787, 769],
7973: [951, 788, 769],
7974: [951, 787, 834],
7975: [951, 788, 834],
7976: [919, 787],
7977: [919, 788],
7978: [919, 787, 768],
7979: [919, 788, 768],
7980: [919, 787, 769],
7981: [919, 788, 769],
7982: [919, 787, 834],
7983: [919, 788, 834],
7984: [953, 787],
7985: [953, 788],
7986: [953, 787, 768],
7987: [953, 788, 768],
7988: [953, 787, 769],
7989: [953, 788, 769],
7990: [953, 787, 834],
7991: [953, 788, 834],
7992: [921, 787],
7993: [921, 788],
7994: [921, 787, 768],
7995: [921, 788, 768],
7996: [921, 787, 769],
7997: [921, 788, 769],
7998: [921, 787, 834],
7999: [921, 788, 834],
8000: [959, 787],
8001: [959, 788],
8002: [959, 787, 768],
8003: [959, 788, 768],
8004: [959, 787, 769],
8005: [959, 788, 769],
8008: [927, 787],
8009: [927, 788],
8010: [927, 787, 768],
8011: [927, 788, 768],
8012: [927, 787, 769],
8013: [927, 788, 769],
8016: [965, 787],
8017: [965, 788],
8018: [965, 787, 768],
8019: [965, 788, 768],
8020: [965, 787, 769],
8021: [965, 788, 769],
8022: [965, 787, 834],
8023: [965, 788, 834],
8025: [933, 788],
8027: [933, 788, 768],
8029: [933, 788, 769],
8031: [933, 788, 834],
8032: [969, 787],
8033: [969, 788],
8034: [969, 787, 768],
8035: [969, 788, 768],
8036: [969, 787, 769],
8037: [969, 788, 769],
8038: [969, 787, 834],
8039: [969, 788, 834],
8040: [937, 787],
8041: [937, 788],
8042: [937, 787, 768],
8043: [937, 788, 768],
8044: [937, 787, 769],
8045: [937, 788, 769],
8046: [937, 787, 834],
8047: [937, 788, 834],
8048: [945, 768],
8049: [945, 769],
8050: [949, 768],
8051: [949, 769],
8052: [951, 768],
8053: [951, 769],
8054: [953, 768],
8055: [953, 769],
8056: [959, 768],
8057: [959, 769],
8058: [965, 768],
8059: [965, 769],
8060: [969, 768],
8061: [969, 769],
8064: [945, 787, 837],
8065: [945, 788, 837],
8066: [945, 787, 768, 837],
8067: [945, 788, 768, 837],
8068: [945, 787, 769, 837],
8069: [945, 788, 769, 837],
8070: [945, 787, 834, 837],
8071: [945, 788, 834, 837],
8072: [913, 787, 837],
8073: [913, 788, 837],
8074: [913, 787, 768, 837],
8075: [913, 788, 768, 837],
8076: [913, 787, 769, 837],
8077: [913, 788, 769, 837],
8078: [913, 787, 834, 837],
8079: [913, 788, 834, 837],
8080: [951, 787, 837],
8081: [951, 788, 837],
8082: [951, 787, 768, 837],
8083: [951, 788, 768, 837],
8084: [951, 787, 769, 837],
8085: [951, 788, 769, 837],
8086: [951, 787, 834, 837],
8087: [951, 788, 834, 837],
8088: [919, 787, 837],
8089: [919, 788, 837],
8090: [919, 787, 768, 837],
8091: [919, 788, 768, 837],
8092: [919, 787, 769, 837],
8093: [919, 788, 769, 837],
8094: [919, 787, 834, 837],
8095: [919, 788, 834, 837],
8096: [969, 787, 837],
8097: [969, 788, 837],
8098: [969, 787, 768, 837],
8099: [969, 788, 768, 837],
8100: [969, 787, 769, 837],
8101: [969, 788, 769, 837],
8102: [969, 787, 834, 837],
8103: [969, 788, 834, 837],
8104: [937, 787, 837],
8105: [937, 788, 837],
8106: [937, 787, 768, 837],
8107: [937, 788, 768, 837],
8108: [937, 787, 769, 837],
8109: [937, 788, 769, 837],
8110: [937, 787, 834, 837],
8111: [937, 788, 834, 837],
8112: [945, 774],
8113: [945, 772],
8114: [945, 768, 837],
8115: [945, 837],
8116: [945, 769, 837],
8118: [945, 834],
8119: [945, 834, 837],
8120: [913, 774],
8121: [913, 772],
8122: [913, 768],
8123: [913, 769],
8124: [913, 837],
8126: [953],
8129: [168, 834],
8130: [951, 768, 837],
8131: [951, 837],
8132: [951, 769, 837],
8134: [951, 834],
8135: [951, 834, 837],
8136: [917, 768],
8137: [917, 769],
8138: [919, 768],
8139: [919, 769],
8140: [919, 837],
8141: [8127, 768],
8142: [8127, 769],
8143: [8127, 834],
8144: [953, 774],
8145: [953, 772],
8146: [953, 776, 768],
8147: [953, 776, 769],
8150: [953, 834],
8151: [953, 776, 834],
8152: [921, 774],
8153: [921, 772],
8154: [921, 768],
8155: [921, 769],
8157: [8190, 768],
8158: [8190, 769],
8159: [8190, 834],
8160: [965, 774],
8161: [965, 772],
8162: [965, 776, 768],
8163: [965, 776, 769],
8164: [961, 787],
8165: [961, 788],
8166: [965, 834],
8167: [965, 776, 834],
8168: [933, 774],
8169: [933, 772],
8170: [933, 768],
8171: [933, 769],
8172: [929, 788],
8173: [168, 768],
8174: [168, 769],
8175: [96],
8178: [969, 768, 837],
8179: [969, 837],
8180: [969, 769, 837],
8182: [969, 834],
8183: [969, 834, 837],
8184: [927, 768],
8185: [927, 769],
8186: [937, 768],
8187: [937, 769],
8188: [937, 837],
8189: [180],
8192: [8194],
8193: [8195],
8486: [937],
8490: [75],
8491: [65, 778],
8602: [8592, 824],
8603: [8594, 824],
8622: [8596, 824],
8653: [8656, 824],
8654: [8660, 824],
8655: [8658, 824],
8708: [8707, 824],
8713: [8712, 824],
8716: [8715, 824],
8740: [8739, 824],
8742: [8741, 824],
8769: [8764, 824],
8772: [8771, 824],
8775: [8773, 824],
8777: [8776, 824],
8800: [61, 824],
8802: [8801, 824],
8813: [8781, 824],
8814: [60, 824],
8815: [62, 824],
8816: [8804, 824],
8817: [8805, 824],
8820: [8818, 824],
8821: [8819, 824],
8824: [8822, 824],
8825: [8823, 824],
8832: [8826, 824],
8833: [8827, 824],
8836: [8834, 824],
8837: [8835, 824],
8840: [8838, 824],
8841: [8839, 824],
8876: [8866, 824],
8877: [8872, 824],
8878: [8873, 824],
8879: [8875, 824],
8928: [8828, 824],
8929: [8829, 824],
8930: [8849, 824],
8931: [8850, 824],
8938: [8882, 824],
8939: [8883, 824],
8940: [8884, 824],
8941: [8885, 824],
9001: [12296],
9002: [12297],
10972: [10973, 824],
12364: [12363, 12441],
12366: [12365, 12441],
12368: [12367, 12441],
12370: [12369, 12441],
12372: [12371, 12441],
12374: [12373, 12441],
12376: [12375, 12441],
12378: [12377, 12441],
12380: [12379, 12441],
12382: [12381, 12441],
12384: [12383, 12441],
12386: [12385, 12441],
12389: [12388, 12441],
12391: [12390, 12441],
12393: [12392, 12441],
12400: [12399, 12441],
12401: [12399, 12442],
12403: [12402, 12441],
12404: [12402, 12442],
12406: [12405, 12441],
12407: [12405, 12442],
12409: [12408, 12441],
12410: [12408, 12442],
12412: [12411, 12441],
12413: [12411, 12442],
12436: [12358, 12441],
12446: [12445, 12441],
12460: [12459, 12441],
12462: [12461, 12441],
12464: [12463, 12441],
12466: [12465, 12441],
12468: [12467, 12441],
12470: [12469, 12441],
12472: [12471, 12441],
12474: [12473, 12441],
12476: [12475, 12441],
12478: [12477, 12441],
12480: [12479, 12441],
12482: [12481, 12441],
12485: [12484, 12441],
12487: [12486, 12441],
12489: [12488, 12441],
12496: [12495, 12441],
12497: [12495, 12442],
12499: [12498, 12441],
12500: [12498, 12442],
12502: [12501, 12441],
12503: [12501, 12442],
12505: [12504, 12441],
12506: [12504, 12442],
12508: [12507, 12441],
12509: [12507, 12442],
12532: [12454, 12441],
12535: [12527, 12441],
12536: [12528, 12441],
12537: [12529, 12441],
12538: [12530, 12441],
12542: [12541, 12441],
63744: [35912],
63745: [26356],
63746: [36554],
63747: [36040],
63748: [28369],
63749: [20018],
63750: [21477],
63751: [40860],
63752: [40860],
63753: [22865],
63754: [37329],
63755: [21895],
63756: [22856],
63757: [25078],
63758: [30313],
63759: [32645],
63760: [34367],
63761: [34746],
63762: [35064],
63763: [37007],
63764: [27138],
63765: [27931],
63766: [28889],
63767: [29662],
63768: [33853],
63769: [37226],
63770: [39409],
63771: [20098],
63772: [21365],
63773: [27396],
63774: [29211],
63775: [34349],
63776: [40478],
63777: [23888],
63778: [28651],
63779: [34253],
63780: [35172],
63781: [25289],
63782: [33240],
63783: [34847],
63784: [24266],
63785: [26391],
63786: [28010],
63787: [29436],
63788: [37070],
63789: [20358],
63790: [20919],
63791: [21214],
63792: [25796],
63793: [27347],
63794: [29200],
63795: [30439],
63796: [32769],
63797: [34310],
63798: [34396],
63799: [36335],
63800: [38706],
63801: [39791],
63802: [40442],
63803: [30860],
63804: [31103],
63805: [32160],
63806: [33737],
63807: [37636],
63808: [40575],
63809: [35542],
63810: [22751],
63811: [24324],
63812: [31840],
63813: [32894],
63814: [29282],
63815: [30922],
63816: [36034],
63817: [38647],
63818: [22744],
63819: [23650],
63820: [27155],
63821: [28122],
63822: [28431],
63823: [32047],
63824: [32311],
63825: [38475],
63826: [21202],
63827: [32907],
63828: [20956],
63829: [20940],
63830: [31260],
63831: [32190],
63832: [33777],
63833: [38517],
63834: [35712],
63835: [25295],
63836: [27138],
63837: [35582],
63838: [20025],
63839: [23527],
63840: [24594],
63841: [29575],
63842: [30064],
63843: [21271],
63844: [30971],
63845: [20415],
63846: [24489],
63847: [19981],
63848: [27852],
63849: [25976],
63850: [32034],
63851: [21443],
63852: [22622],
63853: [30465],
63854: [33865],
63855: [35498],
63856: [27578],
63857: [36784],
63858: [27784],
63859: [25342],
63860: [33509],
63861: [25504],
63862: [30053],
63863: [20142],
63864: [20841],
63865: [20937],
63866: [26753],
63867: [31975],
63868: [33391],
63869: [35538],
63870: [37327],
63871: [21237],
63872: [21570],
63873: [22899],
63874: [24300],
63875: [26053],
63876: [28670],
63877: [31018],
63878: [38317],
63879: [39530],
63880: [40599],
63881: [40654],
63882: [21147],
63883: [26310],
63884: [27511],
63885: [36706],
63886: [24180],
63887: [24976],
63888: [25088],
63889: [25754],
63890: [28451],
63891: [29001],
63892: [29833],
63893: [31178],
63894: [32244],
63895: [32879],
63896: [36646],
63897: [34030],
63898: [36899],
63899: [37706],
63900: [21015],
63901: [21155],
63902: [21693],
63903: [28872],
63904: [35010],
63905: [35498],
63906: [24265],
63907: [24565],
63908: [25467],
63909: [27566],
63910: [31806],
63911: [29557],
63912: [20196],
63913: [22265],
63914: [23527],
63915: [23994],
63916: [24604],
63917: [29618],
63918: [29801],
63919: [32666],
63920: [32838],
63921: [37428],
63922: [38646],
63923: [38728],
63924: [38936],
63925: [20363],
63926: [31150],
63927: [37300],
63928: [38584],
63929: [24801],
63930: [20102],
63931: [20698],
63932: [23534],
63933: [23615],
63934: [26009],
63935: [27138],
63936: [29134],
63937: [30274],
63938: [34044],
63939: [36988],
63940: [40845],
63941: [26248],
63942: [38446],
63943: [21129],
63944: [26491],
63945: [26611],
63946: [27969],
63947: [28316],
63948: [29705],
63949: [30041],
63950: [30827],
63951: [32016],
63952: [39006],
63953: [20845],
63954: [25134],
63955: [38520],
63956: [20523],
63957: [23833],
63958: [28138],
63959: [36650],
63960: [24459],
63961: [24900],
63962: [26647],
63963: [29575],
63964: [38534],
63965: [21033],
63966: [21519],
63967: [23653],
63968: [26131],
63969: [26446],
63970: [26792],
63971: [27877],
63972: [29702],
63973: [30178],
63974: [32633],
63975: [35023],
63976: [35041],
63977: [37324],
63978: [38626],
63979: [21311],
63980: [28346],
63981: [21533],
63982: [29136],
63983: [29848],
63984: [34298],
63985: [38563],
63986: [40023],
63987: [40607],
63988: [26519],
63989: [28107],
63990: [33256],
63991: [31435],
63992: [31520],
63993: [31890],
63994: [29376],
63995: [28825],
63996: [35672],
63997: [20160],
63998: [33590],
63999: [21050],
64000: [20999],
64001: [24230],
64002: [25299],
64003: [31958],
64004: [23429],
64005: [27934],
64006: [26292],
64007: [36667],
64008: [34892],
64009: [38477],
64010: [35211],
64011: [24275],
64012: [20800],
64013: [21952],
64016: [22618],
64018: [26228],
64021: [20958],
64022: [29482],
64023: [30410],
64024: [31036],
64025: [31070],
64026: [31077],
64027: [31119],
64028: [38742],
64029: [31934],
64030: [32701],
64032: [34322],
64034: [35576],
64037: [36920],
64038: [37117],
64042: [39151],
64043: [39164],
64044: [39208],
64045: [40372],
64048: [20398],
64049: [20711],
64050: [20813],
64051: [21193],
64052: [21220],
64053: [21329],
64054: [21917],
64055: [22022],
64056: [22120],
64057: [22592],
64058: [22696],
64059: [23652],
64060: [23662],
64061: [24724],
64062: [24936],
64063: [24974],
64064: [25074],
64065: [25935],
64066: [26082],
64067: [26257],
64068: [26757],
64069: [28023],
64070: [28186],
64071: [28450],
64072: [29038],
64073: [29227],
64074: [29730],
64075: [30865],
64076: [31038],
64077: [31049],
64078: [31048],
64079: [31056],
64080: [31062],
64081: [31069],
64082: [31117],
64083: [31118],
64084: [31296],
64085: [31361],
64086: [31680],
64087: [32244],
64088: [32265],
64089: [32321],
64090: [32626],
64091: [32773],
64092: [33261],
64093: [33401],
64094: [33401],
64095: [33879],
64096: [35088],
64097: [35222],
64098: [35585],
64099: [35641],
64100: [36051],
64101: [36104],
64102: [36790],
64103: [36920],
64104: [38627],
64105: [38911],
64106: [38971],
64112: [20006],
64113: [20917],
64114: [20840],
64115: [20352],
64116: [20805],
64117: [20864],
64118: [21191],
64119: [21242],
64120: [21917],
64121: [21845],
64122: [21913],
64123: [21986],
64124: [22618],
64125: [22707],
64126: [22852],
64127: [22868],
64128: [23138],
64129: [23336],
64130: [24274],
64131: [24281],
64132: [24425],
64133: [24493],
64134: [24792],
64135: [24910],
64136: [24840],
64137: [24974],
64138: [24928],
64139: [25074],
64140: [25140],
64141: [25540],
64142: [25628],
64143: [25682],
64144: [25942],
64145: [26228],
64146: [26391],
64147: [26395],
64148: [26454],
64149: [27513],
64150: [27578],
64151: [27969],
64152: [28379],
64153: [28363],
64154: [28450],
64155: [28702],
64156: [29038],
64157: [30631],
64158: [29237],
64159: [29359],
64160: [29482],
64161: [29809],
64162: [29958],
64163: [30011],
64164: [30237],
64165: [30239],
64166: [30410],
64167: [30427],
64168: [30452],
64169: [30538],
64170: [30528],
64171: [30924],
64172: [31409],
64173: [31680],
64174: [31867],
64175: [32091],
64176: [32244],
64177: [32574],
64178: [32773],
64179: [33618],
64180: [33775],
64181: [34681],
64182: [35137],
64183: [35206],
64184: [35222],
64185: [35519],
64186: [35576],
64187: [35531],
64188: [35585],
64189: [35582],
64190: [35565],
64191: [35641],
64192: [35722],
64193: [36104],
64194: [36664],
64195: [36978],
64196: [37273],
64197: [37494],
64198: [38524],
64199: [38627],
64200: [38742],
64201: [38875],
64202: [38911],
64203: [38923],
64204: [38971],
64205: [39698],
64206: [40860],
64207: [141386],
64208: [141380],
64209: [144341],
64210: [15261],
64211: [16408],
64212: [16441],
64213: [152137],
64214: [154832],
64215: [163539],
64216: [40771],
64217: [40846],
64285: [1497, 1460],
64287: [1522, 1463],
64298: [1513, 1473],
64299: [1513, 1474],
64300: [1513, 1468, 1473],
64301: [1513, 1468, 1474],
64302: [1488, 1463],
64303: [1488, 1464],
64304: [1488, 1468],
64305: [1489, 1468],
64306: [1490, 1468],
64307: [1491, 1468],
64308: [1492, 1468],
64309: [1493, 1468],
64310: [1494, 1468],
64312: [1496, 1468],
64313: [1497, 1468],
64314: [1498, 1468],
64315: [1499, 1468],
64316: [1500, 1468],
64318: [1502, 1468],
64320: [1504, 1468],
64321: [1505, 1468],
64323: [1507, 1468],
64324: [1508, 1468],
64326: [1510, 1468],
64327: [1511, 1468],
64328: [1512, 1468],
64329: [1513, 1468],
64330: [1514, 1468],
64331: [1493, 1465],
64332: [1489, 1471],
64333: [1499, 1471],
64334: [1508, 1471],
119134: [119127, 119141],
119135: [119128, 119141],
119136: [119128, 119141, 119150],
119137: [119128, 119141, 119151],
119138: [119128, 119141, 119152],
119139: [119128, 119141, 119153],
119140: [119128, 119141, 119154],
119227: [119225, 119141],
119228: [119226, 119141],
119229: [119225, 119141, 119150],
119230: [119226, 119141, 119150],
119231: [119225, 119141, 119151],
119232: [119226, 119141, 119151],
194560: [20029],
194561: [20024],
194562: [20033],
194563: [131362],
194564: [20320],
194565: [20398],
194566: [20411],
194567: [20482],
194568: [20602],
194569: [20633],
194570: [20711],
194571: [20687],
194572: [13470],
194573: [132666],
194574: [20813],
194575: [20820],
194576: [20836],
194577: [20855],
194578: [132380],
194579: [13497],
194580: [20839],
194581: [20877],
194582: [132427],
194583: [20887],
194584: [20900],
194585: [20172],
194586: [20908],
194587: [20917],
194588: [168415],
194589: [20981],
194590: [20995],
194591: [13535],
194592: [21051],
194593: [21062],
194594: [21106],
194595: [21111],
194596: [13589],
194597: [21191],
194598: [21193],
194599: [21220],
194600: [21242],
194601: [21253],
194602: [21254],
194603: [21271],
194604: [21321],
194605: [21329],
194606: [21338],
194607: [21363],
194608: [21373],
194609: [21375],
194610: [21375],
194611: [21375],
194612: [133676],
194613: [28784],
194614: [21450],
194615: [21471],
194616: [133987],
194617: [21483],
194618: [21489],
194619: [21510],
194620: [21662],
194621: [21560],
194622: [21576],
194623: [21608],
194624: [21666],
194625: [21750],
194626: [21776],
194627: [21843],
194628: [21859],
194629: [21892],
194630: [21892],
194631: [21913],
194632: [21931],
194633: [21939],
194634: [21954],
194635: [22294],
194636: [22022],
194637: [22295],
194638: [22097],
194639: [22132],
194640: [20999],
194641: [22766],
194642: [22478],
194643: [22516],
194644: [22541],
194645: [22411],
194646: [22578],
194647: [22577],
194648: [22700],
194649: [136420],
194650: [22770],
194651: [22775],
194652: [22790],
194653: [22810],
194654: [22818],
194655: [22882],
194656: [136872],
194657: [136938],
194658: [23020],
194659: [23067],
194660: [23079],
194661: [23000],
194662: [23142],
194663: [14062],
194664: [14076],
194665: [23304],
194666: [23358],
194667: [23358],
194668: [137672],
194669: [23491],
194670: [23512],
194671: [23527],
194672: [23539],
194673: [138008],
194674: [23551],
194675: [23558],
194676: [24403],
194677: [23586],
194678: [14209],
194679: [23648],
194680: [23662],
194681: [23744],
194682: [23693],
194683: [138724],
194684: [23875],
194685: [138726],
194686: [23918],
194687: [23915],
194688: [23932],
194689: [24033],
194690: [24034],
194691: [14383],
194692: [24061],
194693: [24104],
194694: [24125],
194695: [24169],
194696: [14434],
194697: [139651],
194698: [14460],
194699: [24240],
194700: [24243],
194701: [24246],
194702: [24266],
194703: [172946],
194704: [24318],
194705: [140081],
194706: [140081],
194707: [33281],
194708: [24354],
194709: [24354],
194710: [14535],
194711: [144056],
194712: [156122],
194713: [24418],
194714: [24427],
194715: [14563],
194716: [24474],
194717: [24525],
194718: [24535],
194719: [24569],
194720: [24705],
194721: [14650],
194722: [14620],
194723: [24724],
194724: [141012],
194725: [24775],
194726: [24904],
194727: [24908],
194728: [24910],
194729: [24908],
194730: [24954],
194731: [24974],
194732: [25010],
194733: [24996],
194734: [25007],
194735: [25054],
194736: [25074],
194737: [25078],
194738: [25104],
194739: [25115],
194740: [25181],
194741: [25265],
194742: [25300],
194743: [25424],
194744: [142092],
194745: [25405],
194746: [25340],
194747: [25448],
194748: [25475],
194749: [25572],
194750: [142321],
194751: [25634],
194752: [25541],
194753: [25513],
194754: [14894],
194755: [25705],
194756: [25726],
194757: [25757],
194758: [25719],
194759: [14956],
194760: [25935],
194761: [25964],
194762: [143370],
194763: [26083],
194764: [26360],
194765: [26185],
194766: [15129],
194767: [26257],
194768: [15112],
194769: [15076],
194770: [20882],
194771: [20885],
194772: [26368],
194773: [26268],
194774: [32941],
194775: [17369],
194776: [26391],
194777: [26395],
194778: [26401],
194779: [26462],
194780: [26451],
194781: [144323],
194782: [15177],
194783: [26618],
194784: [26501],
194785: [26706],
194786: [26757],
194787: [144493],
194788: [26766],
194789: [26655],
194790: [26900],
194791: [15261],
194792: [26946],
194793: [27043],
194794: [27114],
194795: [27304],
194796: [145059],
194797: [27355],
194798: [15384],
194799: [27425],
194800: [145575],
194801: [27476],
194802: [15438],
194803: [27506],
194804: [27551],
194805: [27578],
194806: [27579],
194807: [146061],
194808: [138507],
194809: [146170],
194810: [27726],
194811: [146620],
194812: [27839],
194813: [27853],
194814: [27751],
194815: [27926],
194816: [27966],
194817: [28023],
194818: [27969],
194819: [28009],
194820: [28024],
194821: [28037],
194822: [146718],
194823: [27956],
194824: [28207],
194825: [28270],
194826: [15667],
194827: [28363],
194828: [28359],
194829: [147153],
194830: [28153],
194831: [28526],
194832: [147294],
194833: [147342],
194834: [28614],
194835: [28729],
194836: [28702],
194837: [28699],
194838: [15766],
194839: [28746],
194840: [28797],
194841: [28791],
194842: [28845],
194843: [132389],
194844: [28997],
194845: [148067],
194846: [29084],
194847: [148395],
194848: [29224],
194849: [29237],
194850: [29264],
194851: [149000],
194852: [29312],
194853: [29333],
194854: [149301],
194855: [149524],
194856: [29562],
194857: [29579],
194858: [16044],
194859: [29605],
194860: [16056],
194861: [16056],
194862: [29767],
194863: [29788],
194864: [29809],
194865: [29829],
194866: [29898],
194867: [16155],
194868: [29988],
194869: [150582],
194870: [30014],
194871: [150674],
194872: [30064],
194873: [139679],
194874: [30224],
194875: [151457],
194876: [151480],
194877: [151620],
194878: [16380],
194879: [16392],
194880: [30452],
194881: [151795],
194882: [151794],
194883: [151833],
194884: [151859],
194885: [30494],
194886: [30495],
194887: [30495],
194888: [30538],
194889: [16441],
194890: [30603],
194891: [16454],
194892: [16534],
194893: [152605],
194894: [30798],
194895: [30860],
194896: [30924],
194897: [16611],
194898: [153126],
194899: [31062],
194900: [153242],
194901: [153285],
194902: [31119],
194903: [31211],
194904: [16687],
194905: [31296],
194906: [31306],
194907: [31311],
194908: [153980],
194909: [154279],
194910: [154279],
194911: [31470],
194912: [16898],
194913: [154539],
194914: [31686],
194915: [31689],
194916: [16935],
194917: [154752],
194918: [31954],
194919: [17056],
194920: [31976],
194921: [31971],
194922: [32000],
194923: [155526],
194924: [32099],
194925: [17153],
194926: [32199],
194927: [32258],
194928: [32325],
194929: [17204],
194930: [156200],
194931: [156231],
194932: [17241],
194933: [156377],
194934: [32634],
194935: [156478],
194936: [32661],
194937: [32762],
194938: [32773],
194939: [156890],
194940: [156963],
194941: [32864],
194942: [157096],
194943: [32880],
194944: [144223],
194945: [17365],
194946: [32946],
194947: [33027],
194948: [17419],
194949: [33086],
194950: [23221],
194951: [157607],
194952: [157621],
194953: [144275],
194954: [144284],
194955: [33281],
194956: [33284],
194957: [36766],
194958: [17515],
194959: [33425],
194960: [33419],
194961: [33437],
194962: [21171],
194963: [33457],
194964: [33459],
194965: [33469],
194966: [33510],
194967: [158524],
194968: [33509],
194969: [33565],
194970: [33635],
194971: [33709],
194972: [33571],
194973: [33725],
194974: [33767],
194975: [33879],
194976: [33619],
194977: [33738],
194978: [33740],
194979: [33756],
194980: [158774],
194981: [159083],
194982: [158933],
194983: [17707],
194984: [34033],
194985: [34035],
194986: [34070],
194987: [160714],
194988: [34148],
194989: [159532],
194990: [17757],
194991: [17761],
194992: [159665],
194993: [159954],
194994: [17771],
194995: [34384],
194996: [34396],
194997: [34407],
194998: [34409],
194999: [34473],
195000: [34440],
195001: [34574],
195002: [34530],
195003: [34681],
195004: [34600],
195005: [34667],
195006: [34694],
195007: [17879],
195008: [34785],
195009: [34817],
195010: [17913],
195011: [34912],
195012: [34915],
195013: [161383],
195014: [35031],
195015: [35038],
195016: [17973],
195017: [35066],
195018: [13499],
195019: [161966],
195020: [162150],
195021: [18110],
195022: [18119],
195023: [35488],
195024: [35565],
195025: [35722],
195026: [35925],
195027: [162984],
195028: [36011],
195029: [36033],
195030: [36123],
195031: [36215],
195032: [163631],
195033: [133124],
195034: [36299],
195035: [36284],
195036: [36336],
195037: [133342],
195038: [36564],
195039: [36664],
195040: [165330],
195041: [165357],
195042: [37012],
195043: [37105],
195044: [37137],
195045: [165678],
195046: [37147],
195047: [37432],
195048: [37591],
195049: [37592],
195050: [37500],
195051: [37881],
195052: [37909],
195053: [166906],
195054: [38283],
195055: [18837],
195056: [38327],
195057: [167287],
195058: [18918],
195059: [38595],
195060: [23986],
195061: [38691],
195062: [168261],
195063: [168474],
195064: [19054],
195065: [19062],
195066: [38880],
195067: [168970],
195068: [19122],
195069: [169110],
195070: [38923],
195071: [38923],
195072: [38953],
195073: [169398],
195074: [39138],
195075: [19251],
195076: [39209],
195077: [39335],
195078: [39362],
195079: [39422],
195080: [19406],
195081: [170800],
195082: [39698],
195083: [40000],
195084: [40189],
195085: [19662],
195086: [19693],
195087: [40295],
195088: [172238],
195089: [19704],
195090: [172293],
195091: [172558],
195092: [172689],
195093: [40635],
195094: [19798],
195095: [40697],
195096: [40702],
195097: [40709],
195098: [40719],
195099: [40726],
195100: [40763],
195101: [173568],
}

_canon_decomposition_corrected = {
}
_compat_decomposition = {
160: [32],
168: [32, 776],
170: [97],
175: [32, 772],
178: [50],
179: [51],
180: [32, 769],
181: [956],
184: [32, 807],
185: [49],
186: [111],
188: [49, 8260, 52],
189: [49, 8260, 50],
190: [51, 8260, 52],
192: [65, 768],
193: [65, 769],
194: [65, 770],
195: [65, 771],
196: [65, 776],
197: [65, 778],
199: [67, 807],
200: [69, 768],
201: [69, 769],
202: [69, 770],
203: [69, 776],
204: [73, 768],
205: [73, 769],
206: [73, 770],
207: [73, 776],
209: [78, 771],
210: [79, 768],
211: [79, 769],
212: [79, 770],
213: [79, 771],
214: [79, 776],
217: [85, 768],
218: [85, 769],
219: [85, 770],
220: [85, 776],
221: [89, 769],
224: [97, 768],
225: [97, 769],
226: [97, 770],
227: [97, 771],
228: [97, 776],
229: [97, 778],
231: [99, 807],
232: [101, 768],
233: [101, 769],
234: [101, 770],
235: [101, 776],
236: [105, 768],
237: [105, 769],
238: [105, 770],
239: [105, 776],
241: [110, 771],
242: [111, 768],
243: [111, 769],
244: [111, 770],
245: [111, 771],
246: [111, 776],
249: [117, 768],
250: [117, 769],
251: [117, 770],
252: [117, 776],
253: [121, 769],
255: [121, 776],
256: [65, 772],
257: [97, 772],
258: [65, 774],
259: [97, 774],
260: [65, 808],
261: [97, 808],
262: [67, 769],
263: [99, 769],
264: [67, 770],
265: [99, 770],
266: [67, 775],
267: [99, 775],
268: [67, 780],
269: [99, 780],
270: [68, 780],
271: [100, 780],
274: [69, 772],
275: [101, 772],
276: [69, 774],
277: [101, 774],
278: [69, 775],
279: [101, 775],
280: [69, 808],
281: [101, 808],
282: [69, 780],
283: [101, 780],
284: [71, 770],
285: [103, 770],
286: [71, 774],
287: [103, 774],
288: [71, 775],
289: [103, 775],
290: [71, 807],
291: [103, 807],
292: [72, 770],
293: [104, 770],
296: [73, 771],
297: [105, 771],
298: [73, 772],
299: [105, 772],
300: [73, 774],
301: [105, 774],
302: [73, 808],
303: [105, 808],
304: [73, 775],
306: [73, 74],
307: [105, 106],
308: [74, 770],
309: [106, 770],
310: [75, 807],
311: [107, 807],
313: [76, 769],
314: [108, 769],
315: [76, 807],
316: [108, 807],
317: [76, 780],
318: [108, 780],
319: [76, 183],
320: [108, 183],
323: [78, 769],
324: [110, 769],
325: [78, 807],
326: [110, 807],
327: [78, 780],
328: [110, 780],
329: [700, 110],
332: [79, 772],
333: [111, 772],
334: [79, 774],
335: [111, 774],
336: [79, 779],
337: [111, 779],
340: [82, 769],
341: [114, 769],
342: [82, 807],
343: [114, 807],
344: [82, 780],
345: [114, 780],
346: [83, 769],
347: [115, 769],
348: [83, 770],
349: [115, 770],
350: [83, 807],
351: [115, 807],
352: [83, 780],
353: [115, 780],
354: [84, 807],
355: [116, 807],
356: [84, 780],
357: [116, 780],
360: [85, 771],
361: [117, 771],
362: [85, 772],
363: [117, 772],
364: [85, 774],
365: [117, 774],
366: [85, 778],
367: [117, 778],
368: [85, 779],
369: [117, 779],
370: [85, 808],
371: [117, 808],
372: [87, 770],
373: [119, 770],
374: [89, 770],
375: [121, 770],
376: [89, 776],
377: [90, 769],
378: [122, 769],
379: [90, 775],
380: [122, 775],
381: [90, 780],
382: [122, 780],
383: [115],
416: [79, 795],
417: [111, 795],
431: [85, 795],
432: [117, 795],
452: [68, 90, 780],
453: [68, 122, 780],
454: [100, 122, 780],
455: [76, 74],
456: [76, 106],
457: [108, 106],
458: [78, 74],
459: [78, 106],
460: [110, 106],
461: [65, 780],
462: [97, 780],
463: [73, 780],
464: [105, 780],
465: [79, 780],
466: [111, 780],
467: [85, 780],
468: [117, 780],
469: [85, 776, 772],
470: [117, 776, 772],
471: [85, 776, 769],
472: [117, 776, 769],
473: [85, 776, 780],
474: [117, 776, 780],
475: [85, 776, 768],
476: [117, 776, 768],
478: [65, 776, 772],
479: [97, 776, 772],
480: [65, 775, 772],
481: [97, 775, 772],
482: [198, 772],
483: [230, 772],
486: [71, 780],
487: [103, 780],
488: [75, 780],
489: [107, 780],
490: [79, 808],
491: [111, 808],
492: [79, 808, 772],
493: [111, 808, 772],
494: [439, 780],
495: [658, 780],
496: [106, 780],
497: [68, 90],
498: [68, 122],
499: [100, 122],
500: [71, 769],
501: [103, 769],
504: [78, 768],
505: [110, 768],
506: [65, 778, 769],
507: [97, 778, 769],
508: [198, 769],
509: [230, 769],
510: [216, 769],
511: [248, 769],
512: [65, 783],
513: [97, 783],
514: [65, 785],
515: [97, 785],
516: [69, 783],
517: [101, 783],
518: [69, 785],
519: [101, 785],
520: [73, 783],
521: [105, 783],
522: [73, 785],
523: [105, 785],
524: [79, 783],
525: [111, 783],
526: [79, 785],
527: [111, 785],
528: [82, 783],
529: [114, 783],
530: [82, 785],
531: [114, 785],
532: [85, 783],
533: [117, 783],
534: [85, 785],
535: [117, 785],
536: [83, 806],
537: [115, 806],
538: [84, 806],
539: [116, 806],
542: [72, 780],
543: [104, 780],
550: [65, 775],
551: [97, 775],
552: [69, 807],
553: [101, 807],
554: [79, 776, 772],
555: [111, 776, 772],
556: [79, 771, 772],
557: [111, 771, 772],
558: [79, 775],
559: [111, 775],
560: [79, 775, 772],
561: [111, 775, 772],
562: [89, 772],
563: [121, 772],
688: [104],
689: [614],
690: [106],
691: [114],
692: [633],
693: [635],
694: [641],
695: [119],
696: [121],
728: [32, 774],
729: [32, 775],
730: [32, 778],
731: [32, 808],
732: [32, 771],
733: [32, 779],
736: [611],
737: [108],
738: [115],
739: [120],
740: [661],
832: [768],
833: [769],
835: [787],
836: [776, 769],
884: [697],
890: [32, 837],
894: [59],
900: [32, 769],
901: [32, 776, 769],
902: [913, 769],
903: [183],
904: [917, 769],
905: [919, 769],
906: [921, 769],
908: [927, 769],
910: [933, 769],
911: [937, 769],
912: [953, 776, 769],
938: [921, 776],
939: [933, 776],
940: [945, 769],
941: [949, 769],
942: [951, 769],
943: [953, 769],
944: [965, 776, 769],
970: [953, 776],
971: [965, 776],
972: [959, 769],
973: [965, 769],
974: [969, 769],
976: [946],
977: [952],
978: [933],
979: [933, 769],
980: [933, 776],
981: [966],
982: [960],
1008: [954],
1009: [961],
1010: [962],
1012: [920],
1013: [949],
1017: [931],
1024: [1045, 768],
1025: [1045, 776],
1027: [1043, 769],
1031: [1030, 776],
1036: [1050, 769],
1037: [1048, 768],
1038: [1059, 774],
1049: [1048, 774],
1081: [1080, 774],
1104: [1077, 768],
1105: [1077, 776],
1107: [1075, 769],
1111: [1110, 776],
1116: [1082, 769],
1117: [1080, 768],
1118: [1091, 774],
1142: [1140, 783],
1143: [1141, 783],
1217: [1046, 774],
1218: [1078, 774],
1232: [1040, 774],
1233: [1072, 774],
1234: [1040, 776],
1235: [1072, 776],
1238: [1045, 774],
1239: [1077, 774],
1242: [1240, 776],
1243: [1241, 776],
1244: [1046, 776],
1245: [1078, 776],
1246: [1047, 776],
1247: [1079, 776],
1250: [1048, 772],
1251: [1080, 772],
1252: [1048, 776],
1253: [1080, 776],
1254: [1054, 776],
1255: [1086, 776],
1258: [1256, 776],
1259: [1257, 776],
1260: [1069, 776],
1261: [1101, 776],
1262: [1059, 772],
1263: [1091, 772],
1264: [1059, 776],
1265: [1091, 776],
1266: [1059, 779],
1267: [1091, 779],
1268: [1063, 776],
1269: [1095, 776],
1272: [1067, 776],
1273: [1099, 776],
1415: [1381, 1410],
1570: [1575, 1619],
1571: [1575, 1620],
1572: [1608, 1620],
1573: [1575, 1621],
1574: [1610, 1620],
1653: [1575, 1652],
1654: [1608, 1652],
1655: [1735, 1652],
1656: [1610, 1652],
1728: [1749, 1620],
1730: [1729, 1620],
1747: [1746, 1620],
2345: [2344, 2364],
2353: [2352, 2364],
2356: [2355, 2364],
2392: [2325, 2364],
2393: [2326, 2364],
2394: [2327, 2364],
2395: [2332, 2364],
2396: [2337, 2364],
2397: [2338, 2364],
2398: [2347, 2364],
2399: [2351, 2364],
2507: [2503, 2494],
2508: [2503, 2519],
2524: [2465, 2492],
2525: [2466, 2492],
2527: [2479, 2492],
2611: [2610, 2620],
2614: [2616, 2620],
2649: [2582, 2620],
2650: [2583, 2620],
2651: [2588, 2620],
2654: [2603, 2620],
2888: [2887, 2902],
2891: [2887, 2878],
2892: [2887, 2903],
2908: [2849, 2876],
2909: [2850, 2876],
2964: [2962, 3031],
3018: [3014, 3006],
3019: [3015, 3006],
3020: [3014, 3031],
3144: [3142, 3158],
3264: [3263, 3285],
3271: [3270, 3285],
3272: [3270, 3286],
3274: [3270, 3266],
3275: [3270, 3266, 3285],
3402: [3398, 3390],
3403: [3399, 3390],
3404: [3398, 3415],
3546: [3545, 3530],
3548: [3545, 3535],
3549: [3545, 3535, 3530],
3550: [3545, 3551],
3635: [3661, 3634],
3763: [3789, 3762],
3804: [3755, 3737],
3805: [3755, 3745],
3852: [3851],
3907: [3906, 4023],
3917: [3916, 4023],
3922: [3921, 4023],
3927: [3926, 4023],
3932: [3931, 4023],
3945: [3904, 4021],
3955: [3953, 3954],
3957: [3953, 3956],
3958: [4018, 3968],
3959: [4018, 3953, 3968],
3960: [4019, 3968],
3961: [4019, 3953, 3968],
3969: [3953, 3968],
3987: [3986, 4023],
3997: [3996, 4023],
4002: [4001, 4023],
4007: [4006, 4023],
4012: [4011, 4023],
4025: [3984, 4021],
4134: [4133, 4142],
4348: [4316],
7468: [65],
7469: [198],
7470: [66],
7472: [68],
7473: [69],
7474: [398],
7475: [71],
7476: [72],
7477: [73],
7478: [74],
7479: [75],
7480: [76],
7481: [77],
7482: [78],
7484: [79],
7485: [546],
7486: [80],
7487: [82],
7488: [84],
7489: [85],
7490: [87],
7491: [97],
7492: [592],
7493: [593],
7494: [7426],
7495: [98],
7496: [100],
7497: [101],
7498: [601],
7499: [603],
7500: [604],
7501: [103],
7503: [107],
7504: [109],
7505: [331],
7506: [111],
7507: [596],
7508: [7446],
7509: [7447],
7510: [112],
7511: [116],
7512: [117],
7513: [7453],
7514: [623],
7515: [118],
7516: [7461],
7517: [946],
7518: [947],
7519: [948],
7520: [966],
7521: [967],
7522: [105],
7523: [114],
7524: [117],
7525: [118],
7526: [946],
7527: [947],
7528: [961],
7529: [966],
7530: [967],
7544: [1085],
7579: [594],
7580: [99],
7581: [597],
7582: [240],
7583: [604],
7584: [102],
7585: [607],
7586: [609],
7587: [613],
7588: [616],
7589: [617],
7590: [618],
7591: [7547],
7592: [669],
7593: [621],
7594: [7557],
7595: [671],
7596: [625],
7597: [624],
7598: [626],
7599: [627],
7600: [628],
7601: [629],
7602: [632],
7603: [642],
7604: [643],
7605: [427],
7606: [649],
7607: [650],
7608: [7452],
7609: [651],
7610: [652],
7611: [122],
7612: [656],
7613: [657],
7614: [658],
7615: [952],
7680: [65, 805],
7681: [97, 805],
7682: [66, 775],
7683: [98, 775],
7684: [66, 803],
7685: [98, 803],
7686: [66, 817],
7687: [98, 817],
7688: [67, 807, 769],
7689: [99, 807, 769],
7690: [68, 775],
7691: [100, 775],
7692: [68, 803],
7693: [100, 803],
7694: [68, 817],
7695: [100, 817],
7696: [68, 807],
7697: [100, 807],
7698: [68, 813],
7699: [100, 813],
7700: [69, 772, 768],
7701: [101, 772, 768],
7702: [69, 772, 769],
7703: [101, 772, 769],
7704: [69, 813],
7705: [101, 813],
7706: [69, 816],
7707: [101, 816],
7708: [69, 807, 774],
7709: [101, 807, 774],
7710: [70, 775],
7711: [102, 775],
7712: [71, 772],
7713: [103, 772],
7714: [72, 775],
7715: [104, 775],
7716: [72, 803],
7717: [104, 803],
7718: [72, 776],
7719: [104, 776],
7720: [72, 807],
7721: [104, 807],
7722: [72, 814],
7723: [104, 814],
7724: [73, 816],
7725: [105, 816],
7726: [73, 776, 769],
7727: [105, 776, 769],
7728: [75, 769],
7729: [107, 769],
7730: [75, 803],
7731: [107, 803],
7732: [75, 817],
7733: [107, 817],
7734: [76, 803],
7735: [108, 803],
7736: [76, 803, 772],
7737: [108, 803, 772],
7738: [76, 817],
7739: [108, 817],
7740: [76, 813],
7741: [108, 813],
7742: [77, 769],
7743: [109, 769],
7744: [77, 775],
7745: [109, 775],
7746: [77, 803],
7747: [109, 803],
7748: [78, 775],
7749: [110, 775],
7750: [78, 803],
7751: [110, 803],
7752: [78, 817],
7753: [110, 817],
7754: [78, 813],
7755: [110, 813],
7756: [79, 771, 769],
7757: [111, 771, 769],
7758: [79, 771, 776],
7759: [111, 771, 776],
7760: [79, 772, 768],
7761: [111, 772, 768],
7762: [79, 772, 769],
7763: [111, 772, 769],
7764: [80, 769],
7765: [112, 769],
7766: [80, 775],
7767: [112, 775],
7768: [82, 775],
7769: [114, 775],
7770: [82, 803],
7771: [114, 803],
7772: [82, 803, 772],
7773: [114, 803, 772],
7774: [82, 817],
7775: [114, 817],
7776: [83, 775],
7777: [115, 775],
7778: [83, 803],
7779: [115, 803],
7780: [83, 769, 775],
7781: [115, 769, 775],
7782: [83, 780, 775],
7783: [115, 780, 775],
7784: [83, 803, 775],
7785: [115, 803, 775],
7786: [84, 775],
7787: [116, 775],
7788: [84, 803],
7789: [116, 803],
7790: [84, 817],
7791: [116, 817],
7792: [84, 813],
7793: [116, 813],
7794: [85, 804],
7795: [117, 804],
7796: [85, 816],
7797: [117, 816],
7798: [85, 813],
7799: [117, 813],
7800: [85, 771, 769],
7801: [117, 771, 769],
7802: [85, 772, 776],
7803: [117, 772, 776],
7804: [86, 771],
7805: [118, 771],
7806: [86, 803],
7807: [118, 803],
7808: [87, 768],
7809: [119, 768],
7810: [87, 769],
7811: [119, 769],
7812: [87, 776],
7813: [119, 776],
7814: [87, 775],
7815: [119, 775],
7816: [87, 803],
7817: [119, 803],
7818: [88, 775],
7819: [120, 775],
7820: [88, 776],
7821: [120, 776],
7822: [89, 775],
7823: [121, 775],
7824: [90, 770],
7825: [122, 770],
7826: [90, 803],
7827: [122, 803],
7828: [90, 817],
7829: [122, 817],
7830: [104, 817],
7831: [116, 776],
7832: [119, 778],
7833: [121, 778],
7834: [97, 702],
7835: [115, 775],
7840: [65, 803],
7841: [97, 803],
7842: [65, 777],
7843: [97, 777],
7844: [65, 770, 769],
7845: [97, 770, 769],
7846: [65, 770, 768],
7847: [97, 770, 768],
7848: [65, 770, 777],
7849: [97, 770, 777],
7850: [65, 770, 771],
7851: [97, 770, 771],
7852: [65, 803, 770],
7853: [97, 803, 770],
7854: [65, 774, 769],
7855: [97, 774, 769],
7856: [65, 774, 768],
7857: [97, 774, 768],
7858: [65, 774, 777],
7859: [97, 774, 777],
7860: [65, 774, 771],
7861: [97, 774, 771],
7862: [65, 803, 774],
7863: [97, 803, 774],
7864: [69, 803],
7865: [101, 803],
7866: [69, 777],
7867: [101, 777],
7868: [69, 771],
7869: [101, 771],
7870: [69, 770, 769],
7871: [101, 770, 769],
7872: [69, 770, 768],
7873: [101, 770, 768],
7874: [69, 770, 777],
7875: [101, 770, 777],
7876: [69, 770, 771],
7877: [101, 770, 771],
7878: [69, 803, 770],
7879: [101, 803, 770],
7880: [73, 777],
7881: [105, 777],
7882: [73, 803],
7883: [105, 803],
7884: [79, 803],
7885: [111, 803],
7886: [79, 777],
7887: [111, 777],
7888: [79, 770, 769],
7889: [111, 770, 769],
7890: [79, 770, 768],
7891: [111, 770, 768],
7892: [79, 770, 777],
7893: [111, 770, 777],
7894: [79, 770, 771],
7895: [111, 770, 771],
7896: [79, 803, 770],
7897: [111, 803, 770],
7898: [79, 795, 769],
7899: [111, 795, 769],
7900: [79, 795, 768],
7901: [111, 795, 768],
7902: [79, 795, 777],
7903: [111, 795, 777],
7904: [79, 795, 771],
7905: [111, 795, 771],
7906: [79, 795, 803],
7907: [111, 795, 803],
7908: [85, 803],
7909: [117, 803],
7910: [85, 777],
7911: [117, 777],
7912: [85, 795, 769],
7913: [117, 795, 769],
7914: [85, 795, 768],
7915: [117, 795, 768],
7916: [85, 795, 777],
7917: [117, 795, 777],
7918: [85, 795, 771],
7919: [117, 795, 771],
7920: [85, 795, 803],
7921: [117, 795, 803],
7922: [89, 768],
7923: [121, 768],
7924: [89, 803],
7925: [121, 803],
7926: [89, 777],
7927: [121, 777],
7928: [89, 771],
7929: [121, 771],
7936: [945, 787],
7937: [945, 788],
7938: [945, 787, 768],
7939: [945, 788, 768],
7940: [945, 787, 769],
7941: [945, 788, 769],
7942: [945, 787, 834],
7943: [945, 788, 834],
7944: [913, 787],
7945: [913, 788],
7946: [913, 787, 768],
7947: [913, 788, 768],
7948: [913, 787, 769],
7949: [913, 788, 769],
7950: [913, 787, 834],
7951: [913, 788, 834],
7952: [949, 787],
7953: [949, 788],
7954: [949, 787, 768],
7955: [949, 788, 768],
7956: [949, 787, 769],
7957: [949, 788, 769],
7960: [917, 787],
7961: [917, 788],
7962: [917, 787, 768],
7963: [917, 788, 768],
7964: [917, 787, 769],
7965: [917, 788, 769],
7968: [951, 787],
7969: [951, 788],
7970: [951, 787, 768],
7971: [951, 788, 768],
7972: [951, 787, 769],
7973: [951, 788, 769],
7974: [951, 787, 834],
7975: [951, 788, 834],
7976: [919, 787],
7977: [919, 788],
7978: [919, 787, 768],
7979: [919, 788, 768],
7980: [919, 787, 769],
7981: [919, 788, 769],
7982: [919, 787, 834],
7983: [919, 788, 834],
7984: [953, 787],
7985: [953, 788],
7986: [953, 787, 768],
7987: [953, 788, 768],
7988: [953, 787, 769],
7989: [953, 788, 769],
7990: [953, 787, 834],
7991: [953, 788, 834],
7992: [921, 787],
7993: [921, 788],
7994: [921, 787, 768],
7995: [921, 788, 768],
7996: [921, 787, 769],
7997: [921, 788, 769],
7998: [921, 787, 834],
7999: [921, 788, 834],
8000: [959, 787],
8001: [959, 788],
8002: [959, 787, 768],
8003: [959, 788, 768],
8004: [959, 787, 769],
8005: [959, 788, 769],
8008: [927, 787],
8009: [927, 788],
8010: [927, 787, 768],
8011: [927, 788, 768],
8012: [927, 787, 769],
8013: [927, 788, 769],
8016: [965, 787],
8017: [965, 788],
8018: [965, 787, 768],
8019: [965, 788, 768],
8020: [965, 787, 769],
8021: [965, 788, 769],
8022: [965, 787, 834],
8023: [965, 788, 834],
8025: [933, 788],
8027: [933, 788, 768],
8029: [933, 788, 769],
8031: [933, 788, 834],
8032: [969, 787],
8033: [969, 788],
8034: [969, 787, 768],
8035: [969, 788, 768],
8036: [969, 787, 769],
8037: [969, 788, 769],
8038: [969, 787, 834],
8039: [969, 788, 834],
8040: [937, 787],
8041: [937, 788],
8042: [937, 787, 768],
8043: [937, 788, 768],
8044: [937, 787, 769],
8045: [937, 788, 769],
8046: [937, 787, 834],
8047: [937, 788, 834],
8048: [945, 768],
8049: [945, 769],
8050: [949, 768],
8051: [949, 769],
8052: [951, 768],
8053: [951, 769],
8054: [953, 768],
8055: [953, 769],
8056: [959, 768],
8057: [959, 769],
8058: [965, 768],
8059: [965, 769],
8060: [969, 768],
8061: [969, 769],
8064: [945, 787, 837],
8065: [945, 788, 837],
8066: [945, 787, 768, 837],
8067: [945, 788, 768, 837],
8068: [945, 787, 769, 837],
8069: [945, 788, 769, 837],
8070: [945, 787, 834, 837],
8071: [945, 788, 834, 837],
8072: [913, 787, 837],
8073: [913, 788, 837],
8074: [913, 787, 768, 837],
8075: [913, 788, 768, 837],
8076: [913, 787, 769, 837],
8077: [913, 788, 769, 837],
8078: [913, 787, 834, 837],
8079: [913, 788, 834, 837],
8080: [951, 787, 837],
8081: [951, 788, 837],
8082: [951, 787, 768, 837],
8083: [951, 788, 768, 837],
8084: [951, 787, 769, 837],
8085: [951, 788, 769, 837],
8086: [951, 787, 834, 837],
8087: [951, 788, 834, 837],
8088: [919, 787, 837],
8089: [919, 788, 837],
8090: [919, 787, 768, 837],
8091: [919, 788, 768, 837],
8092: [919, 787, 769, 837],
8093: [919, 788, 769, 837],
8094: [919, 787, 834, 837],
8095: [919, 788, 834, 837],
8096: [969, 787, 837],
8097: [969, 788, 837],
8098: [969, 787, 768, 837],
8099: [969, 788, 768, 837],
8100: [969, 787, 769, 837],
8101: [969, 788, 769, 837],
8102: [969, 787, 834, 837],
8103: [969, 788, 834, 837],
8104: [937, 787, 837],
8105: [937, 788, 837],
8106: [937, 787, 768, 837],
8107: [937, 788, 768, 837],
8108: [937, 787, 769, 837],
8109: [937, 788, 769, 837],
8110: [937, 787, 834, 837],
8111: [937, 788, 834, 837],
8112: [945, 774],
8113: [945, 772],
8114: [945, 768, 837],
8115: [945, 837],
8116: [945, 769, 837],
8118: [945, 834],
8119: [945, 834, 837],
8120: [913, 774],
8121: [913, 772],
8122: [913, 768],
8123: [913, 769],
8124: [913, 837],
8125: [32, 787],
8126: [953],
8127: [32, 787],
8128: [32, 834],
8129: [32, 776, 834],
8130: [951, 768, 837],
8131: [951, 837],
8132: [951, 769, 837],
8134: [951, 834],
8135: [951, 834, 837],
8136: [917, 768],
8137: [917, 769],
8138: [919, 768],
8139: [919, 769],
8140: [919, 837],
8141: [32, 787, 768],
8142: [32, 787, 769],
8143: [32, 787, 834],
8144: [953, 774],
8145: [953, 772],
8146: [953, 776, 768],
8147: [953, 776, 769],
8150: [953, 834],
8151: [953, 776, 834],
8152: [921, 774],
8153: [921, 772],
8154: [921, 768],
8155: [921, 769],
8157: [32, 788, 768],
8158: [32, 788, 769],
8159: [32, 788, 834],
8160: [965, 774],
8161: [965, 772],
8162: [965, 776, 768],
8163: [965, 776, 769],
8164: [961, 787],
8165: [961, 788],
8166: [965, 834],
8167: [965, 776, 834],
8168: [933, 774],
8169: [933, 772],
8170: [933, 768],
8171: [933, 769],
8172: [929, 788],
8173: [32, 776, 768],
8174: [32, 776, 769],
8175: [96],
8178: [969, 768, 837],
8179: [969, 837],
8180: [969, 769, 837],
8182: [969, 834],
8183: [969, 834, 837],
8184: [927, 768],
8185: [927, 769],
8186: [937, 768],
8187: [937, 769],
8188: [937, 837],
8189: [32, 769],
8190: [32, 788],
8192: [32],
8193: [32],
8194: [32],
8195: [32],
8196: [32],
8197: [32],
8198: [32],
8199: [32],
8200: [32],
8201: [32],
8202: [32],
8209: [8208],
8215: [32, 819],
8228: [46],
8229: [46, 46],
8230: [46, 46, 46],
8239: [32],
8243: [8242, 8242],
8244: [8242, 8242, 8242],
8246: [8245, 8245],
8247: [8245, 8245, 8245],
8252: [33, 33],
8254: [32, 773],
8263: [63, 63],
8264: [63, 33],
8265: [33, 63],
8279: [8242, 8242, 8242, 8242],
8287: [32],
8304: [48],
8305: [105],
8308: [52],
8309: [53],
8310: [54],
8311: [55],
8312: [56],
8313: [57],
8314: [43],
8315: [8722],
8316: [61],
8317: [40],
8318: [41],
8319: [110],
8320: [48],
8321: [49],
8322: [50],
8323: [51],
8324: [52],
8325: [53],
8326: [54],
8327: [55],
8328: [56],
8329: [57],
8330: [43],
8331: [8722],
8332: [61],
8333: [40],
8334: [41],
8336: [97],
8337: [101],
8338: [111],
8339: [120],
8340: [601],
8360: [82, 115],
8448: [97, 47, 99],
8449: [97, 47, 115],
8450: [67],
8451: [176, 67],
8453: [99, 47, 111],
8454: [99, 47, 117],
8455: [400],
8457: [176, 70],
8458: [103],
8459: [72],
8460: [72],
8461: [72],
8462: [104],
8463: [295],
8464: [73],
8465: [73],
8466: [76],
8467: [108],
8469: [78],
8470: [78, 111],
8473: [80],
8474: [81],
8475: [82],
8476: [82],
8477: [82],
8480: [83, 77],
8481: [84, 69, 76],
8482: [84, 77],
8484: [90],
8486: [937],
8488: [90],
8490: [75],
8491: [65, 778],
8492: [66],
8493: [67],
8495: [101],
8496: [69],
8497: [70],
8499: [77],
8500: [111],
8501: [1488],
8502: [1489],
8503: [1490],
8504: [1491],
8505: [105],
8507: [70, 65, 88],
8508: [960],
8509: [947],
8510: [915],
8511: [928],
8512: [8721],
8517: [68],
8518: [100],
8519: [101],
8520: [105],
8521: [106],
8531: [49, 8260, 51],
8532: [50, 8260, 51],
8533: [49, 8260, 53],
8534: [50, 8260, 53],
8535: [51, 8260, 53],
8536: [52, 8260, 53],
8537: [49, 8260, 54],
8538: [53, 8260, 54],
8539: [49, 8260, 56],
8540: [51, 8260, 56],
8541: [53, 8260, 56],
8542: [55, 8260, 56],
8543: [49, 8260],
8544: [73],
8545: [73, 73],
8546: [73, 73, 73],
8547: [73, 86],
8548: [86],
8549: [86, 73],
8550: [86, 73, 73],
8551: [86, 73, 73, 73],
8552: [73, 88],
8553: [88],
8554: [88, 73],
8555: [88, 73, 73],
8556: [76],
8557: [67],
8558: [68],
8559: [77],
8560: [105],
8561: [105, 105],
8562: [105, 105, 105],
8563: [105, 118],
8564: [118],
8565: [118, 105],
8566: [118, 105, 105],
8567: [118, 105, 105, 105],
8568: [105, 120],
8569: [120],
8570: [120, 105],
8571: [120, 105, 105],
8572: [108],
8573: [99],
8574: [100],
8575: [109],
8602: [8592, 824],
8603: [8594, 824],
8622: [8596, 824],
8653: [8656, 824],
8654: [8660, 824],
8655: [8658, 824],
8708: [8707, 824],
8713: [8712, 824],
8716: [8715, 824],
8740: [8739, 824],
8742: [8741, 824],
8748: [8747, 8747],
8749: [8747, 8747, 8747],
8751: [8750, 8750],
8752: [8750, 8750, 8750],
8769: [8764, 824],
8772: [8771, 824],
8775: [8773, 824],
8777: [8776, 824],
8800: [61, 824],
8802: [8801, 824],
8813: [8781, 824],
8814: [60, 824],
8815: [62, 824],
8816: [8804, 824],
8817: [8805, 824],
8820: [8818, 824],
8821: [8819, 824],
8824: [8822, 824],
8825: [8823, 824],
8832: [8826, 824],
8833: [8827, 824],
8836: [8834, 824],
8837: [8835, 824],
8840: [8838, 824],
8841: [8839, 824],
8876: [8866, 824],
8877: [8872, 824],
8878: [8873, 824],
8879: [8875, 824],
8928: [8828, 824],
8929: [8829, 824],
8930: [8849, 824],
8931: [8850, 824],
8938: [8882, 824],
8939: [8883, 824],
8940: [8884, 824],
8941: [8885, 824],
9001: [12296],
9002: [12297],
9312: [49],
9313: [50],
9314: [51],
9315: [52],
9316: [53],
9317: [54],
9318: [55],
9319: [56],
9320: [57],
9321: [49, 48],
9322: [49, 49],
9323: [49, 50],
9324: [49, 51],
9325: [49, 52],
9326: [49, 53],
9327: [49, 54],
9328: [49, 55],
9329: [49, 56],
9330: [49, 57],
9331: [50, 48],
9332: [40, 49, 41],
9333: [40, 50, 41],
9334: [40, 51, 41],
9335: [40, 52, 41],
9336: [40, 53, 41],
9337: [40, 54, 41],
9338: [40, 55, 41],
9339: [40, 56, 41],
9340: [40, 57, 41],
9341: [40, 49, 48, 41],
9342: [40, 49, 49, 41],
9343: [40, 49, 50, 41],
9344: [40, 49, 51, 41],
9345: [40, 49, 52, 41],
9346: [40, 49, 53, 41],
9347: [40, 49, 54, 41],
9348: [40, 49, 55, 41],
9349: [40, 49, 56, 41],
9350: [40, 49, 57, 41],
9351: [40, 50, 48, 41],
9352: [49, 46],
9353: [50, 46],
9354: [51, 46],
9355: [52, 46],
9356: [53, 46],
9357: [54, 46],
9358: [55, 46],
9359: [56, 46],
9360: [57, 46],
9361: [49, 48, 46],
9362: [49, 49, 46],
9363: [49, 50, 46],
9364: [49, 51, 46],
9365: [49, 52, 46],
9366: [49, 53, 46],
9367: [49, 54, 46],
9368: [49, 55, 46],
9369: [49, 56, 46],
9370: [49, 57, 46],
9371: [50, 48, 46],
9372: [40, 97, 41],
9373: [40, 98, 41],
9374: [40, 99, 41],
9375: [40, 100, 41],
9376: [40, 101, 41],
9377: [40, 102, 41],
9378: [40, 103, 41],
9379: [40, 104, 41],
9380: [40, 105, 41],
9381: [40, 106, 41],
9382: [40, 107, 41],
9383: [40, 108, 41],
9384: [40, 109, 41],
9385: [40, 110, 41],
9386: [40, 111, 41],
9387: [40, 112, 41],
9388: [40, 113, 41],
9389: [40, 114, 41],
9390: [40, 115, 41],
9391: [40, 116, 41],
9392: [40, 117, 41],
9393: [40, 118, 41],
9394: [40, 119, 41],
9395: [40, 120, 41],
9396: [40, 121, 41],
9397: [40, 122, 41],
9398: [65],
9399: [66],
9400: [67],
9401: [68],
9402: [69],
9403: [70],
9404: [71],
9405: [72],
9406: [73],
9407: [74],
9408: [75],
9409: [76],
9410: [77],
9411: [78],
9412: [79],
9413: [80],
9414: [81],
9415: [82],
9416: [83],
9417: [84],
9418: [85],
9419: [86],
9420: [87],
9421: [88],
9422: [89],
9423: [90],
9424: [97],
9425: [98],
9426: [99],
9427: [100],
9428: [101],
9429: [102],
9430: [103],
9431: [104],
9432: [105],
9433: [106],
9434: [107],
9435: [108],
9436: [109],
9437: [110],
9438: [111],
9439: [112],
9440: [113],
9441: [114],
9442: [115],
9443: [116],
9444: [117],
9445: [118],
9446: [119],
9447: [120],
9448: [121],
9449: [122],
9450: [48],
10764: [8747, 8747, 8747, 8747],
10868: [58, 58, 61],
10869: [61, 61],
10870: [61, 61, 61],
10972: [10973, 824],
11631: [11617],
11935: [27597],
12019: [40863],
12032: [19968],
12033: [20008],
12034: [20022],
12035: [20031],
12036: [20057],
12037: [20101],
12038: [20108],
12039: [20128],
12040: [20154],
12041: [20799],
12042: [20837],
12043: [20843],
12044: [20866],
12045: [20886],
12046: [20907],
12047: [20960],
12048: [20981],
12049: [20992],
12050: [21147],
12051: [21241],
12052: [21269],
12053: [21274],
12054: [21304],
12055: [21313],
12056: [21340],
12057: [21353],
12058: [21378],
12059: [21430],
12060: [21448],
12061: [21475],
12062: [22231],
12063: [22303],
12064: [22763],
12065: [22786],
12066: [22794],
12067: [22805],
12068: [22823],
12069: [22899],
12070: [23376],
12071: [23424],
12072: [23544],
12073: [23567],
12074: [23586],
12075: [23608],
12076: [23662],
12077: [23665],
12078: [24027],
12079: [24037],
12080: [24049],
12081: [24062],
12082: [24178],
12083: [24186],
12084: [24191],
12085: [24308],
12086: [24318],
12087: [24331],
12088: [24339],
12089: [24400],
12090: [24417],
12091: [24435],
12092: [24515],
12093: [25096],
12094: [25142],
12095: [25163],
12096: [25903],
12097: [25908],
12098: [25991],
12099: [26007],
12100: [26020],
12101: [26041],
12102: [26080],
12103: [26085],
12104: [26352],
12105: [26376],
12106: [26408],
12107: [27424],
12108: [27490],
12109: [27513],
12110: [27571],
12111: [27595],
12112: [27604],
12113: [27611],
12114: [27663],
12115: [27668],
12116: [27700],
12117: [28779],
12118: [29226],
12119: [29238],
12120: [29243],
12121: [29247],
12122: [29255],
12123: [29273],
12124: [29275],
12125: [29356],
12126: [29572],
12127: [29577],
12128: [29916],
12129: [29926],
12130: [29976],
12131: [29983],
12132: [29992],
12133: [30000],
12134: [30091],
12135: [30098],
12136: [30326],
12137: [30333],
12138: [30382],
12139: [30399],
12140: [30446],
12141: [30683],
12142: [30690],
12143: [30707],
12144: [31034],
12145: [31160],
12146: [31166],
12147: [31348],
12148: [31435],
12149: [31481],
12150: [31859],
12151: [31992],
12152: [32566],
12153: [32593],
12154: [32650],
12155: [32701],
12156: [32769],
12157: [32780],
12158: [32786],
12159: [32819],
12160: [32895],
12161: [32905],
12162: [33251],
12163: [33258],
12164: [33267],
12165: [33276],
12166: [33292],
12167: [33307],
12168: [33311],
12169: [33390],
12170: [33394],
12171: [33400],
12172: [34381],
12173: [34411],
12174: [34880],
12175: [34892],
12176: [34915],
12177: [35198],
12178: [35211],
12179: [35282],
12180: [35328],
12181: [35895],
12182: [35910],
12183: [35925],
12184: [35960],
12185: [35997],
12186: [36196],
12187: [36208],
12188: [36275],
12189: [36523],
12190: [36554],
12191: [36763],
12192: [36784],
12193: [36789],
12194: [37009],
12195: [37193],
12196: [37318],
12197: [37324],
12198: [37329],
12199: [38263],
12200: [38272],
12201: [38428],
12202: [38582],
12203: [38585],
12204: [38632],
12205: [38737],
12206: [38750],
12207: [38754],
12208: [38761],
12209: [38859],
12210: [38893],
12211: [38899],
12212: [38913],
12213: [39080],
12214: [39131],
12215: [39135],
12216: [39318],
12217: [39321],
12218: [39340],
12219: [39592],
12220: [39640],
12221: [39647],
12222: [39717],
12223: [39727],
12224: [39730],
12225: [39740],
12226: [39770],
12227: [40165],
12228: [40565],
12229: [40575],
12230: [40613],
12231: [40635],
12232: [40643],
12233: [40653],
12234: [40657],
12235: [40697],
12236: [40701],
12237: [40718],
12238: [40723],
12239: [40736],
12240: [40763],
12241: [40778],
12242: [40786],
12243: [40845],
12244: [40860],
12245: [40864],
12288: [32],
12342: [12306],
12344: [21313],
12345: [21316],
12346: [21317],
12364: [12363, 12441],
12366: [12365, 12441],
12368: [12367, 12441],
12370: [12369, 12441],
12372: [12371, 12441],
12374: [12373, 12441],
12376: [12375, 12441],
12378: [12377, 12441],
12380: [12379, 12441],
12382: [12381, 12441],
12384: [12383, 12441],
12386: [12385, 12441],
12389: [12388, 12441],
12391: [12390, 12441],
12393: [12392, 12441],
12400: [12399, 12441],
12401: [12399, 12442],
12403: [12402, 12441],
12404: [12402, 12442],
12406: [12405, 12441],
12407: [12405, 12442],
12409: [12408, 12441],
12410: [12408, 12442],
12412: [12411, 12441],
12413: [12411, 12442],
12436: [12358, 12441],
12443: [32, 12441],
12444: [32, 12442],
12446: [12445, 12441],
12447: [12424, 12426],
12460: [12459, 12441],
12462: [12461, 12441],
12464: [12463, 12441],
12466: [12465, 12441],
12468: [12467, 12441],
12470: [12469, 12441],
12472: [12471, 12441],
12474: [12473, 12441],
12476: [12475, 12441],
12478: [12477, 12441],
12480: [12479, 12441],
12482: [12481, 12441],
12485: [12484, 12441],
12487: [12486, 12441],
12489: [12488, 12441],
12496: [12495, 12441],
12497: [12495, 12442],
12499: [12498, 12441],
12500: [12498, 12442],
12502: [12501, 12441],
12503: [12501, 12442],
12505: [12504, 12441],
12506: [12504, 12442],
12508: [12507, 12441],
12509: [12507, 12442],
12532: [12454, 12441],
12535: [12527, 12441],
12536: [12528, 12441],
12537: [12529, 12441],
12538: [12530, 12441],
12542: [12541, 12441],
12543: [12467, 12488],
12593: [4352],
12594: [4353],
12595: [4522],
12596: [4354],
12597: [4524],
12598: [4525],
12599: [4355],
12600: [4356],
12601: [4357],
12602: [4528],
12603: [4529],
12604: [4530],
12605: [4531],
12606: [4532],
12607: [4533],
12608: [4378],
12609: [4358],
12610: [4359],
12611: [4360],
12612: [4385],
12613: [4361],
12614: [4362],
12615: [4363],
12616: [4364],
12617: [4365],
12618: [4366],
12619: [4367],
12620: [4368],
12621: [4369],
12622: [4370],
12623: [4449],
12624: [4450],
12625: [4451],
12626: [4452],
12627: [4453],
12628: [4454],
12629: [4455],
12630: [4456],
12631: [4457],
12632: [4458],
12633: [4459],
12634: [4460],
12635: [4461],
12636: [4462],
12637: [4463],
12638: [4464],
12639: [4465],
12640: [4466],
12641: [4467],
12642: [4468],
12643: [4469],
12644: [4448],
12645: [4372],
12646: [4373],
12647: [4551],
12648: [4552],
12649: [4556],
12650: [4558],
12651: [4563],
12652: [4567],
12653: [4569],
12654: [4380],
12655: [4573],
12656: [4575],
12657: [4381],
12658: [4382],
12659: [4384],
12660: [4386],
12661: [4387],
12662: [4391],
12663: [4393],
12664: [4395],
12665: [4396],
12666: [4397],
12667: [4398],
12668: [4399],
12669: [4402],
12670: [4406],
12671: [4416],
12672: [4423],
12673: [4428],
12674: [4593],
12675: [4594],
12676: [4439],
12677: [4440],
12678: [4441],
12679: [4484],
12680: [4485],
12681: [4488],
12682: [4497],
12683: [4498],
12684: [4500],
12685: [4510],
12686: [4513],
12690: [19968],
12691: [20108],
12692: [19977],
12693: [22235],
12694: [19978],
12695: [20013],
12696: [19979],
12697: [30002],
12698: [20057],
12699: [19993],
12700: [19969],
12701: [22825],
12702: [22320],
12703: [20154],
12800: [40, 4352, 41],
12801: [40, 4354, 41],
12802: [40, 4355, 41],
12803: [40, 4357, 41],
12804: [40, 4358, 41],
12805: [40, 4359, 41],
12806: [40, 4361, 41],
12807: [40, 4363, 41],
12808: [40, 4364, 41],
12809: [40, 4366, 41],
12810: [40, 4367, 41],
12811: [40, 4368, 41],
12812: [40, 4369, 41],
12813: [40, 4370, 41],
12814: [40, 4352, 4449, 41],
12815: [40, 4354, 4449, 41],
12816: [40, 4355, 4449, 41],
12817: [40, 4357, 4449, 41],
12818: [40, 4358, 4449, 41],
12819: [40, 4359, 4449, 41],
12820: [40, 4361, 4449, 41],
12821: [40, 4363, 4449, 41],
12822: [40, 4364, 4449, 41],
12823: [40, 4366, 4449, 41],
12824: [40, 4367, 4449, 41],
12825: [40, 4368, 4449, 41],
12826: [40, 4369, 4449, 41],
12827: [40, 4370, 4449, 41],
12828: [40, 4364, 4462, 41],
12829: [40, 4363, 4457, 4364, 4453, 4523, 41],
12830: [40, 4363, 4457, 4370, 4462, 41],
12832: [40, 19968, 41],
12833: [40, 20108, 41],
12834: [40, 19977, 41],
12835: [40, 22235, 41],
12836: [40, 20116, 41],
12837: [40, 20845, 41],
12838: [40, 19971, 41],
12839: [40, 20843, 41],
12840: [40, 20061, 41],
12841: [40, 21313, 41],
12842: [40, 26376, 41],
12843: [40, 28779, 41],
12844: [40, 27700, 41],
12845: [40, 26408, 41],
12846: [40, 37329, 41],
12847: [40, 22303, 41],
12848: [40, 26085, 41],
12849: [40, 26666, 41],
12850: [40, 26377, 41],
12851: [40, 31038, 41],
12852: [40, 21517, 41],
12853: [40, 29305, 41],
12854: [40, 36001, 41],
12855: [40, 31069, 41],
12856: [40, 21172, 41],
12857: [40, 20195, 41],
12858: [40, 21628, 41],
12859: [40, 23398, 41],
12860: [40, 30435, 41],
12861: [40, 20225, 41],
12862: [40, 36039, 41],
12863: [40, 21332, 41],
12864: [40, 31085, 41],
12865: [40, 20241, 41],
12866: [40, 33258, 41],
12867: [40, 33267, 41],
12880: [80, 84, 69],
12881: [50, 49],
12882: [50, 50],
12883: [50, 51],
12884: [50, 52],
12885: [50, 53],
12886: [50, 54],
12887: [50, 55],
12888: [50, 56],
12889: [50, 57],
12890: [51, 48],
12891: [51, 49],
12892: [51, 50],
12893: [51, 51],
12894: [51, 52],
12895: [51, 53],
12896: [4352],
12897: [4354],
12898: [4355],
12899: [4357],
12900: [4358],
12901: [4359],
12902: [4361],
12903: [4363],
12904: [4364],
12905: [4366],
12906: [4367],
12907: [4368],
12908: [4369],
12909: [4370],
12910: [4352, 4449],
12911: [4354, 4449],
12912: [4355, 4449],
12913: [4357, 4449],
12914: [4358, 4449],
12915: [4359, 4449],
12916: [4361, 4449],
12917: [4363, 4449],
12918: [4364, 4449],
12919: [4366, 4449],
12920: [4367, 4449],
12921: [4368, 4449],
12922: [4369, 4449],
12923: [4370, 4449],
12924: [4366, 4449, 4535, 4352, 4457],
12925: [4364, 4462, 4363, 4468],
12926: [4363, 4462],
12928: [19968],
12929: [20108],
12930: [19977],
12931: [22235],
12932: [20116],
12933: [20845],
12934: [19971],
12935: [20843],
12936: [20061],
12937: [21313],
12938: [26376],
12939: [28779],
12940: [27700],
12941: [26408],
12942: [37329],
12943: [22303],
12944: [26085],
12945: [26666],
12946: [26377],
12947: [31038],
12948: [21517],
12949: [29305],
12950: [36001],
12951: [31069],
12952: [21172],
12953: [31192],
12954: [30007],
12955: [22899],
12956: [36969],
12957: [20778],
12958: [21360],
12959: [27880],
12960: [38917],
12961: [20241],
12962: [20889],
12963: [27491],
12964: [19978],
12965: [20013],
12966: [19979],
12967: [24038],
12968: [21491],
12969: [21307],
12970: [23447],
12971: [23398],
12972: [30435],
12973: [20225],
12974: [36039],
12975: [21332],
12976: [22812],
12977: [51, 54],
12978: [51, 55],
12979: [51, 56],
12980: [51, 57],
12981: [52, 48],
12982: [52, 49],
12983: [52, 50],
12984: [52, 51],
12985: [52, 52],
12986: [52, 53],
12987: [52, 54],
12988: [52, 55],
12989: [52, 56],
12990: [52, 57],
12991: [53, 48],
12992: [49, 26376],
12993: [50, 26376],
12994: [51, 26376],
12995: [52, 26376],
12996: [53, 26376],
12997: [54, 26376],
12998: [55, 26376],
12999: [56, 26376],
13000: [57, 26376],
13001: [49, 48, 26376],
13002: [49, 49, 26376],
13003: [49, 50, 26376],
13004: [72, 103],
13005: [101, 114, 103],
13006: [101, 86],
13007: [76, 84, 68],
13008: [12450],
13009: [12452],
13010: [12454],
13011: [12456],
13012: [12458],
13013: [12459],
13014: [12461],
13015: [12463],
13016: [12465],
13017: [12467],
13018: [12469],
13019: [12471],
13020: [12473],
13021: [12475],
13022: [12477],
13023: [12479],
13024: [12481],
13025: [12484],
13026: [12486],
13027: [12488],
13028: [12490],
13029: [12491],
13030: [12492],
13031: [12493],
13032: [12494],
13033: [12495],
13034: [12498],
13035: [12501],
13036: [12504],
13037: [12507],
13038: [12510],
13039: [12511],
13040: [12512],
13041: [12513],
13042: [12514],
13043: [12516],
13044: [12518],
13045: [12520],
13046: [12521],
13047: [12522],
13048: [12523],
13049: [12524],
13050: [12525],
13051: [12527],
13052: [12528],
13053: [12529],
13054: [12530],
13056: [12450, 12495, 12442, 12540, 12488],
13057: [12450, 12523, 12501, 12449],
13058: [12450, 12531, 12504, 12442, 12450],
13059: [12450, 12540, 12523],
13060: [12452, 12491, 12531, 12463, 12441],
13061: [12452, 12531, 12481],
13062: [12454, 12457, 12531],
13063: [12456, 12473, 12463, 12540, 12488, 12441],
13064: [12456, 12540, 12459, 12540],
13065: [12458, 12531, 12473],
13066: [12458, 12540, 12512],
13067: [12459, 12452, 12522],
13068: [12459, 12521, 12483, 12488],
13069: [12459, 12525, 12522, 12540],
13070: [12459, 12441, 12525, 12531],
13071: [12459, 12441, 12531, 12510],
13072: [12461, 12441, 12459, 12441],
13073: [12461, 12441, 12491, 12540],
13074: [12461, 12517, 12522, 12540],
13075: [12461, 12441, 12523, 12479, 12441, 12540],
13076: [12461, 12525],
13077: [12461, 12525, 12463, 12441, 12521, 12512],
13078: [12461, 12525, 12513, 12540, 12488, 12523],
13079: [12461, 12525, 12527, 12483, 12488],
13080: [12463, 12441, 12521, 12512],
13081: [12463, 12441, 12521, 12512, 12488, 12531],
13082: [12463, 12523, 12475, 12441, 12452, 12525],
13083: [12463, 12525, 12540, 12493],
13084: [12465, 12540, 12473],
13085: [12467, 12523, 12490],
13086: [12467, 12540, 12507, 12442],
13087: [12469, 12452, 12463, 12523],
13088: [12469, 12531, 12481, 12540, 12512],
13089: [12471, 12522, 12531, 12463, 12441],
13090: [12475, 12531, 12481],
13091: [12475, 12531, 12488],
13092: [12479, 12441, 12540, 12473],
13093: [12486, 12441, 12471],
13094: [12488, 12441, 12523],
13095: [12488, 12531],
13096: [12490, 12494],
13097: [12494, 12483, 12488],
13098: [12495, 12452, 12484],
13099: [12495, 12442, 12540, 12475, 12531, 12488],
13100: [12495, 12442, 12540, 12484],
13101: [12495, 12441, 12540, 12524, 12523],
13102: [12498, 12442, 12450, 12473, 12488, 12523],
13103: [12498, 12442, 12463, 12523],
13104: [12498, 12442, 12467],
13105: [12498, 12441, 12523],
13106: [12501, 12449, 12521, 12483, 12488, 12441],
13107: [12501, 12451, 12540, 12488],
13108: [12501, 12441, 12483, 12471, 12455, 12523],
13109: [12501, 12521, 12531],
13110: [12504, 12463, 12479, 12540, 12523],
13111: [12504, 12442, 12477],
13112: [12504, 12442, 12491, 12498],
13113: [12504, 12523, 12484],
13114: [12504, 12442, 12531, 12473],
13115: [12504, 12442, 12540, 12471, 12441],
13116: [12504, 12441, 12540, 12479],
13117: [12507, 12442, 12452, 12531, 12488],
13118: [12507, 12441, 12523, 12488],
13119: [12507, 12531],
13120: [12507, 12442, 12531, 12488, 12441],
13121: [12507, 12540, 12523],
13122: [12507, 12540, 12531],
13123: [12510, 12452, 12463, 12525],
13124: [12510, 12452, 12523],
13125: [12510, 12483, 12495],
13126: [12510, 12523, 12463],
13127: [12510, 12531, 12471, 12519, 12531],
13128: [12511, 12463, 12525, 12531],
13129: [12511, 12522],
13130: [12511, 12522, 12495, 12441, 12540, 12523],
13131: [12513, 12459, 12441],
13132: [12513, 12459, 12441, 12488, 12531],
13133: [12513, 12540, 12488, 12523],
13134: [12516, 12540, 12488, 12441],
13135: [12516, 12540, 12523],
13136: [12518, 12450, 12531],
13137: [12522, 12483, 12488, 12523],
13138: [12522, 12521],
13139: [12523, 12498, 12442, 12540],
13140: [12523, 12540, 12501, 12441, 12523],
13141: [12524, 12512],
13142: [12524, 12531, 12488, 12465, 12441, 12531],
13143: [12527, 12483, 12488],
13144: [48, 28857],
13145: [49, 28857],
13146: [50, 28857],
13147: [51, 28857],
13148: [52, 28857],
13149: [53, 28857],
13150: [54, 28857],
13151: [55, 28857],
13152: [56, 28857],
13153: [57, 28857],
13154: [49, 48, 28857],
13155: [49, 49, 28857],
13156: [49, 50, 28857],
13157: [49, 51, 28857],
13158: [49, 52, 28857],
13159: [49, 53, 28857],
13160: [49, 54, 28857],
13161: [49, 55, 28857],
13162: [49, 56, 28857],
13163: [49, 57, 28857],
13164: [50, 48, 28857],
13165: [50, 49, 28857],
13166: [50, 50, 28857],
13167: [50, 51, 28857],
13168: [50, 52, 28857],
13169: [104, 80, 97],
13170: [100, 97],
13171: [65, 85],
13172: [98, 97, 114],
13173: [111, 86],
13174: [112, 99],
13175: [100, 109],
13176: [100, 109, 50],
13177: [100, 109, 51],
13178: [73, 85],
13179: [24179, 25104],
13180: [26157, 21644],
13181: [22823, 27491],
13182: [26126, 27835],
13183: [26666, 24335, 20250, 31038],
13184: [112, 65],
13185: [110, 65],
13186: [956, 65],
13187: [109, 65],
13188: [107, 65],
13189: [75, 66],
13190: [77, 66],
13191: [71, 66],
13192: [99, 97, 108],
13193: [107, 99, 97, 108],
13194: [112, 70],
13195: [110, 70],
13196: [956, 70],
13197: [956, 103],
13198: [109, 103],
13199: [107, 103],
13200: [72, 122],
13201: [107, 72, 122],
13202: [77, 72, 122],
13203: [71, 72, 122],
13204: [84, 72, 122],
13205: [956, 108],
13206: [109, 108],
13207: [100, 108],
13208: [107, 108],
13209: [102, 109],
13210: [110, 109],
13211: [956, 109],
13212: [109, 109],
13213: [99, 109],
13214: [107, 109],
13215: [109, 109, 50],
13216: [99, 109, 50],
13217: [109, 50],
13218: [107, 109, 50],
13219: [109, 109, 51],
13220: [99, 109, 51],
13221: [109, 51],
13222: [107, 109, 51],
13223: [109, 8725, 115],
13224: [109, 8725, 115, 50],
13225: [80, 97],
13226: [107, 80, 97],
13227: [77, 80, 97],
13228: [71, 80, 97],
13229: [114, 97, 100],
13230: [114, 97, 100, 8725, 115],
13231: [114, 97, 100, 8725, 115, 50],
13232: [112, 115],
13233: [110, 115],
13234: [956, 115],
13235: [109, 115],
13236: [112, 86],
13237: [110, 86],
13238: [956, 86],
13239: [109, 86],
13240: [107, 86],
13241: [77, 86],
13242: [112, 87],
13243: [110, 87],
13244: [956, 87],
13245: [109, 87],
13246: [107, 87],
13247: [77, 87],
13248: [107, 937],
13249: [77, 937],
13250: [97, 46, 109, 46],
13251: [66, 113],
13252: [99, 99],
13253: [99, 100],
13254: [67, 8725, 107, 103],
13255: [67, 111, 46],
13256: [100, 66],
13257: [71, 121],
13258: [104, 97],
13259: [72, 80],
13260: [105, 110],
13261: [75, 75],
13262: [75, 77],
13263: [107, 116],
13264: [108, 109],
13265: [108, 110],
13266: [108, 111, 103],
13267: [108, 120],
13268: [109, 98],
13269: [109, 105, 108],
13270: [109, 111, 108],
13271: [80, 72],
13272: [112, 46, 109, 46],
13273: [80, 80, 77],
13274: [80, 82],
13275: [115, 114],
13276: [83, 118],
13277: [87, 98],
13278: [86, 8725, 109],
13279: [65, 8725, 109],
13280: [49, 26085],
13281: [50, 26085],
13282: [51, 26085],
13283: [52, 26085],
13284: [53, 26085],
13285: [54, 26085],
13286: [55, 26085],
13287: [56, 26085],
13288: [57, 26085],
13289: [49, 48, 26085],
13290: [49, 49, 26085],
13291: [49, 50, 26085],
13292: [49, 51, 26085],
13293: [49, 52, 26085],
13294: [49, 53, 26085],
13295: [49, 54, 26085],
13296: [49, 55, 26085],
13297: [49, 56, 26085],
13298: [49, 57, 26085],
13299: [50, 48, 26085],
13300: [50, 49, 26085],
13301: [50, 50, 26085],
13302: [50, 51, 26085],
13303: [50, 52, 26085],
13304: [50, 53, 26085],
13305: [50, 54, 26085],
13306: [50, 55, 26085],
13307: [50, 56, 26085],
13308: [50, 57, 26085],
13309: [51, 48, 26085],
13310: [51, 49, 26085],
13311: [103, 97, 108],
63744: [35912],
63745: [26356],
63746: [36554],
63747: [36040],
63748: [28369],
63749: [20018],
63750: [21477],
63751: [40860],
63752: [40860],
63753: [22865],
63754: [37329],
63755: [21895],
63756: [22856],
63757: [25078],
63758: [30313],
63759: [32645],
63760: [34367],
63761: [34746],
63762: [35064],
63763: [37007],
63764: [27138],
63765: [27931],
63766: [28889],
63767: [29662],
63768: [33853],
63769: [37226],
63770: [39409],
63771: [20098],
63772: [21365],
63773: [27396],
63774: [29211],
63775: [34349],
63776: [40478],
63777: [23888],
63778: [28651],
63779: [34253],
63780: [35172],
63781: [25289],
63782: [33240],
63783: [34847],
63784: [24266],
63785: [26391],
63786: [28010],
63787: [29436],
63788: [37070],
63789: [20358],
63790: [20919],
63791: [21214],
63792: [25796],
63793: [27347],
63794: [29200],
63795: [30439],
63796: [32769],
63797: [34310],
63798: [34396],
63799: [36335],
63800: [38706],
63801: [39791],
63802: [40442],
63803: [30860],
63804: [31103],
63805: [32160],
63806: [33737],
63807: [37636],
63808: [40575],
63809: [35542],
63810: [22751],
63811: [24324],
63812: [31840],
63813: [32894],
63814: [29282],
63815: [30922],
63816: [36034],
63817: [38647],
63818: [22744],
63819: [23650],
63820: [27155],
63821: [28122],
63822: [28431],
63823: [32047],
63824: [32311],
63825: [38475],
63826: [21202],
63827: [32907],
63828: [20956],
63829: [20940],
63830: [31260],
63831: [32190],
63832: [33777],
63833: [38517],
63834: [35712],
63835: [25295],
63836: [27138],
63837: [35582],
63838: [20025],
63839: [23527],
63840: [24594],
63841: [29575],
63842: [30064],
63843: [21271],
63844: [30971],
63845: [20415],
63846: [24489],
63847: [19981],
63848: [27852],
63849: [25976],
63850: [32034],
63851: [21443],
63852: [22622],
63853: [30465],
63854: [33865],
63855: [35498],
63856: [27578],
63857: [36784],
63858: [27784],
63859: [25342],
63860: [33509],
63861: [25504],
63862: [30053],
63863: [20142],
63864: [20841],
63865: [20937],
63866: [26753],
63867: [31975],
63868: [33391],
63869: [35538],
63870: [37327],
63871: [21237],
63872: [21570],
63873: [22899],
63874: [24300],
63875: [26053],
63876: [28670],
63877: [31018],
63878: [38317],
63879: [39530],
63880: [40599],
63881: [40654],
63882: [21147],
63883: [26310],
63884: [27511],
63885: [36706],
63886: [24180],
63887: [24976],
63888: [25088],
63889: [25754],
63890: [28451],
63891: [29001],
63892: [29833],
63893: [31178],
63894: [32244],
63895: [32879],
63896: [36646],
63897: [34030],
63898: [36899],
63899: [37706],
63900: [21015],
63901: [21155],
63902: [21693],
63903: [28872],
63904: [35010],
63905: [35498],
63906: [24265],
63907: [24565],
63908: [25467],
63909: [27566],
63910: [31806],
63911: [29557],
63912: [20196],
63913: [22265],
63914: [23527],
63915: [23994],
63916: [24604],
63917: [29618],
63918: [29801],
63919: [32666],
63920: [32838],
63921: [37428],
63922: [38646],
63923: [38728],
63924: [38936],
63925: [20363],
63926: [31150],
63927: [37300],
63928: [38584],
63929: [24801],
63930: [20102],
63931: [20698],
63932: [23534],
63933: [23615],
63934: [26009],
63935: [27138],
63936: [29134],
63937: [30274],
63938: [34044],
63939: [36988],
63940: [40845],
63941: [26248],
63942: [38446],
63943: [21129],
63944: [26491],
63945: [26611],
63946: [27969],
63947: [28316],
63948: [29705],
63949: [30041],
63950: [30827],
63951: [32016],
63952: [39006],
63953: [20845],
63954: [25134],
63955: [38520],
63956: [20523],
63957: [23833],
63958: [28138],
63959: [36650],
63960: [24459],
63961: [24900],
63962: [26647],
63963: [29575],
63964: [38534],
63965: [21033],
63966: [21519],
63967: [23653],
63968: [26131],
63969: [26446],
63970: [26792],
63971: [27877],
63972: [29702],
63973: [30178],
63974: [32633],
63975: [35023],
63976: [35041],
63977: [37324],
63978: [38626],
63979: [21311],
63980: [28346],
63981: [21533],
63982: [29136],
63983: [29848],
63984: [34298],
63985: [38563],
63986: [40023],
63987: [40607],
63988: [26519],
63989: [28107],
63990: [33256],
63991: [31435],
63992: [31520],
63993: [31890],
63994: [29376],
63995: [28825],
63996: [35672],
63997: [20160],
63998: [33590],
63999: [21050],
64000: [20999],
64001: [24230],
64002: [25299],
64003: [31958],
64004: [23429],
64005: [27934],
64006: [26292],
64007: [36667],
64008: [34892],
64009: [38477],
64010: [35211],
64011: [24275],
64012: [20800],
64013: [21952],
64016: [22618],
64018: [26228],
64021: [20958],
64022: [29482],
64023: [30410],
64024: [31036],
64025: [31070],
64026: [31077],
64027: [31119],
64028: [38742],
64029: [31934],
64030: [32701],
64032: [34322],
64034: [35576],
64037: [36920],
64038: [37117],
64042: [39151],
64043: [39164],
64044: [39208],
64045: [40372],
64048: [20398],
64049: [20711],
64050: [20813],
64051: [21193],
64052: [21220],
64053: [21329],
64054: [21917],
64055: [22022],
64056: [22120],
64057: [22592],
64058: [22696],
64059: [23652],
64060: [23662],
64061: [24724],
64062: [24936],
64063: [24974],
64064: [25074],
64065: [25935],
64066: [26082],
64067: [26257],
64068: [26757],
64069: [28023],
64070: [28186],
64071: [28450],
64072: [29038],
64073: [29227],
64074: [29730],
64075: [30865],
64076: [31038],
64077: [31049],
64078: [31048],
64079: [31056],
64080: [31062],
64081: [31069],
64082: [31117],
64083: [31118],
64084: [31296],
64085: [31361],
64086: [31680],
64087: [32244],
64088: [32265],
64089: [32321],
64090: [32626],
64091: [32773],
64092: [33261],
64093: [33401],
64094: [33401],
64095: [33879],
64096: [35088],
64097: [35222],
64098: [35585],
64099: [35641],
64100: [36051],
64101: [36104],
64102: [36790],
64103: [36920],
64104: [38627],
64105: [38911],
64106: [38971],
64112: [20006],
64113: [20917],
64114: [20840],
64115: [20352],
64116: [20805],
64117: [20864],
64118: [21191],
64119: [21242],
64120: [21917],
64121: [21845],
64122: [21913],
64123: [21986],
64124: [22618],
64125: [22707],
64126: [22852],
64127: [22868],
64128: [23138],
64129: [23336],
64130: [24274],
64131: [24281],
64132: [24425],
64133: [24493],
64134: [24792],
64135: [24910],
64136: [24840],
64137: [24974],
64138: [24928],
64139: [25074],
64140: [25140],
64141: [25540],
64142: [25628],
64143: [25682],
64144: [25942],
64145: [26228],
64146: [26391],
64147: [26395],
64148: [26454],
64149: [27513],
64150: [27578],
64151: [27969],
64152: [28379],
64153: [28363],
64154: [28450],
64155: [28702],
64156: [29038],
64157: [30631],
64158: [29237],
64159: [29359],
64160: [29482],
64161: [29809],
64162: [29958],
64163: [30011],
64164: [30237],
64165: [30239],
64166: [30410],
64167: [30427],
64168: [30452],
64169: [30538],
64170: [30528],
64171: [30924],
64172: [31409],
64173: [31680],
64174: [31867],
64175: [32091],
64176: [32244],
64177: [32574],
64178: [32773],
64179: [33618],
64180: [33775],
64181: [34681],
64182: [35137],
64183: [35206],
64184: [35222],
64185: [35519],
64186: [35576],
64187: [35531],
64188: [35585],
64189: [35582],
64190: [35565],
64191: [35641],
64192: [35722],
64193: [36104],
64194: [36664],
64195: [36978],
64196: [37273],
64197: [37494],
64198: [38524],
64199: [38627],
64200: [38742],
64201: [38875],
64202: [38911],
64203: [38923],
64204: [38971],
64205: [39698],
64206: [40860],
64207: [141386],
64208: [141380],
64209: [144341],
64210: [15261],
64211: [16408],
64212: [16441],
64213: [152137],
64214: [154832],
64215: [163539],
64216: [40771],
64217: [40846],
64256: [102, 102],
64257: [102, 105],
64258: [102, 108],
64259: [102, 102, 105],
64260: [102, 102, 108],
64261: [115, 116],
64262: [115, 116],
64275: [1396, 1398],
64276: [1396, 1381],
64277: [1396, 1387],
64278: [1406, 1398],
64279: [1396, 1389],
64285: [1497, 1460],
64287: [1522, 1463],
64288: [1506],
64289: [1488],
64290: [1491],
64291: [1492],
64292: [1499],
64293: [1500],
64294: [1501],
64295: [1512],
64296: [1514],
64297: [43],
64298: [1513, 1473],
64299: [1513, 1474],
64300: [1513, 1468, 1473],
64301: [1513, 1468, 1474],
64302: [1488, 1463],
64303: [1488, 1464],
64304: [1488, 1468],
64305: [1489, 1468],
64306: [1490, 1468],
64307: [1491, 1468],
64308: [1492, 1468],
64309: [1493, 1468],
64310: [1494, 1468],
64312: [1496, 1468],
64313: [1497, 1468],
64314: [1498, 1468],
64315: [1499, 1468],
64316: [1500, 1468],
64318: [1502, 1468],
64320: [1504, 1468],
64321: [1505, 1468],
64323: [1507, 1468],
64324: [1508, 1468],
64326: [1510, 1468],
64327: [1511, 1468],
64328: [1512, 1468],
64329: [1513, 1468],
64330: [1514, 1468],
64331: [1493, 1465],
64332: [1489, 1471],
64333: [1499, 1471],
64334: [1508, 1471],
64335: [1488, 1500],
64336: [1649],
64337: [1649],
64338: [1659],
64339: [1659],
64340: [1659],
64341: [1659],
64342: [1662],
64343: [1662],
64344: [1662],
64345: [1662],
64346: [1664],
64347: [1664],
64348: [1664],
64349: [1664],
64350: [1658],
64351: [1658],
64352: [1658],
64353: [1658],
64354: [1663],
64355: [1663],
64356: [1663],
64357: [1663],
64358: [1657],
64359: [1657],
64360: [1657],
64361: [1657],
64362: [1700],
64363: [1700],
64364: [1700],
64365: [1700],
64366: [1702],
64367: [1702],
64368: [1702],
64369: [1702],
64370: [1668],
64371: [1668],
64372: [1668],
64373: [1668],
64374: [1667],
64375: [1667],
64376: [1667],
64377: [1667],
64378: [1670],
64379: [1670],
64380: [1670],
64381: [1670],
64382: [1671],
64383: [1671],
64384: [1671],
64385: [1671],
64386: [1677],
64387: [1677],
64388: [1676],
64389: [1676],
64390: [1678],
64391: [1678],
64392: [1672],
64393: [1672],
64394: [1688],
64395: [1688],
64396: [1681],
64397: [1681],
64398: [1705],
64399: [1705],
64400: [1705],
64401: [1705],
64402: [1711],
64403: [1711],
64404: [1711],
64405: [1711],
64406: [1715],
64407: [1715],
64408: [1715],
64409: [1715],
64410: [1713],
64411: [1713],
64412: [1713],
64413: [1713],
64414: [1722],
64415: [1722],
64416: [1723],
64417: [1723],
64418: [1723],
64419: [1723],
64420: [1749, 1620],
64421: [1749, 1620],
64422: [1729],
64423: [1729],
64424: [1729],
64425: [1729],
64426: [1726],
64427: [1726],
64428: [1726],
64429: [1726],
64430: [1746],
64431: [1746],
64432: [1746, 1620],
64433: [1746, 1620],
64467: [1709],
64468: [1709],
64469: [1709],
64470: [1709],
64471: [1735],
64472: [1735],
64473: [1734],
64474: [1734],
64475: [1736],
64476: [1736],
64477: [1735, 1652],
64478: [1739],
64479: [1739],
64480: [1733],
64481: [1733],
64482: [1737],
64483: [1737],
64484: [1744],
64485: [1744],
64486: [1744],
64487: [1744],
64488: [1609],
64489: [1609],
64490: [1610, 1620, 1575],
64491: [1610, 1620, 1575],
64492: [1610, 1620, 1749],
64493: [1610, 1620, 1749],
64494: [1610, 1620, 1608],
64495: [1610, 1620, 1608],
64496: [1610, 1620, 1735],
64497: [1610, 1620, 1735],
64498: [1610, 1620, 1734],
64499: [1610, 1620, 1734],
64500: [1610, 1620, 1736],
64501: [1610, 1620, 1736],
64502: [1610, 1620, 1744],
64503: [1610, 1620, 1744],
64504: [1610, 1620, 1744],
64505: [1610, 1620, 1609],
64506: [1610, 1620, 1609],
64507: [1610, 1620, 1609],
64508: [1740],
64509: [1740],
64510: [1740],
64511: [1740],
64512: [1610, 1620, 1580],
64513: [1610, 1620, 1581],
64514: [1610, 1620, 1605],
64515: [1610, 1620, 1609],
64516: [1610, 1620, 1610],
64517: [1576, 1580],
64518: [1576, 1581],
64519: [1576, 1582],
64520: [1576, 1605],
64521: [1576, 1609],
64522: [1576, 1610],
64523: [1578, 1580],
64524: [1578, 1581],
64525: [1578, 1582],
64526: [1578, 1605],
64527: [1578, 1609],
64528: [1578, 1610],
64529: [1579, 1580],
64530: [1579, 1605],
64531: [1579, 1609],
64532: [1579, 1610],
64533: [1580, 1581],
64534: [1580, 1605],
64535: [1581, 1580],
64536: [1581, 1605],
64537: [1582, 1580],
64538: [1582, 1581],
64539: [1582, 1605],
64540: [1587, 1580],
64541: [1587, 1581],
64542: [1587, 1582],
64543: [1587, 1605],
64544: [1589, 1581],
64545: [1589, 1605],
64546: [1590, 1580],
64547: [1590, 1581],
64548: [1590, 1582],
64549: [1590, 1605],
64550: [1591, 1581],
64551: [1591, 1605],
64552: [1592, 1605],
64553: [1593, 1580],
64554: [1593, 1605],
64555: [1594, 1580],
64556: [1594, 1605],
64557: [1601, 1580],
64558: [1601, 1581],
64559: [1601, 1582],
64560: [1601, 1605],
64561: [1601, 1609],
64562: [1601, 1610],
64563: [1602, 1581],
64564: [1602, 1605],
64565: [1602, 1609],
64566: [1602, 1610],
64567: [1603, 1575],
64568: [1603, 1580],
64569: [1603, 1581],
64570: [1603, 1582],
64571: [1603, 1604],
64572: [1603, 1605],
64573: [1603, 1609],
64574: [1603, 1610],
64575: [1604, 1580],
64576: [1604, 1581],
64577: [1604, 1582],
64578: [1604, 1605],
64579: [1604, 1609],
64580: [1604, 1610],
64581: [1605, 1580],
64582: [1605, 1581],
64583: [1605, 1582],
64584: [1605, 1605],
64585: [1605, 1609],
64586: [1605, 1610],
64587: [1606, 1580],
64588: [1606, 1581],
64589: [1606, 1582],
64590: [1606, 1605],
64591: [1606, 1609],
64592: [1606, 1610],
64593: [1607, 1580],
64594: [1607, 1605],
64595: [1607, 1609],
64596: [1607, 1610],
64597: [1610, 1580],
64598: [1610, 1581],
64599: [1610, 1582],
64600: [1610, 1605],
64601: [1610, 1609],
64602: [1610, 1610],
64603: [1584, 1648],
64604: [1585, 1648],
64605: [1609, 1648],
64606: [32, 1612, 1617],
64607: [32, 1613, 1617],
64608: [32, 1614, 1617],
64609: [32, 1615, 1617],
64610: [32, 1616, 1617],
64611: [32, 1617, 1648],
64612: [1610, 1620, 1585],
64613: [1610, 1620, 1586],
64614: [1610, 1620, 1605],
64615: [1610, 1620, 1606],
64616: [1610, 1620, 1609],
64617: [1610, 1620, 1610],
64618: [1576, 1585],
64619: [1576, 1586],
64620: [1576, 1605],
64621: [1576, 1606],
64622: [1576, 1609],
64623: [1576, 1610],
64624: [1578, 1585],
64625: [1578, 1586],
64626: [1578, 1605],
64627: [1578, 1606],
64628: [1578, 1609],
64629: [1578, 1610],
64630: [1579, 1585],
64631: [1579, 1586],
64632: [1579, 1605],
64633: [1579, 1606],
64634: [1579, 1609],
64635: [1579, 1610],
64636: [1601, 1609],
64637: [1601, 1610],
64638: [1602, 1609],
64639: [1602, 1610],
64640: [1603, 1575],
64641: [1603, 1604],
64642: [1603, 1605],
64643: [1603, 1609],
64644: [1603, 1610],
64645: [1604, 1605],
64646: [1604, 1609],
64647: [1604, 1610],
64648: [1605, 1575],
64649: [1605, 1605],
64650: [1606, 1585],
64651: [1606, 1586],
64652: [1606, 1605],
64653: [1606, 1606],
64654: [1606, 1609],
64655: [1606, 1610],
64656: [1609, 1648],
64657: [1610, 1585],
64658: [1610, 1586],
64659: [1610, 1605],
64660: [1610, 1606],
64661: [1610, 1609],
64662: [1610, 1610],
64663: [1610, 1620, 1580],
64664: [1610, 1620, 1581],
64665: [1610, 1620, 1582],
64666: [1610, 1620, 1605],
64667: [1610, 1620, 1607],
64668: [1576, 1580],
64669: [1576, 1581],
64670: [1576, 1582],
64671: [1576, 1605],
64672: [1576, 1607],
64673: [1578, 1580],
64674: [1578, 1581],
64675: [1578, 1582],
64676: [1578, 1605],
64677: [1578, 1607],
64678: [1579, 1605],
64679: [1580, 1581],
64680: [1580, 1605],
64681: [1581, 1580],
64682: [1581, 1605],
64683: [1582, 1580],
64684: [1582, 1605],
64685: [1587, 1580],
64686: [1587, 1581],
64687: [1587, 1582],
64688: [1587, 1605],
64689: [1589, 1581],
64690: [1589, 1582],
64691: [1589, 1605],
64692: [1590, 1580],
64693: [1590, 1581],
64694: [1590, 1582],
64695: [1590, 1605],
64696: [1591, 1581],
64697: [1592, 1605],
64698: [1593, 1580],
64699: [1593, 1605],
64700: [1594, 1580],
64701: [1594, 1605],
64702: [1601, 1580],
64703: [1601, 1581],
64704: [1601, 1582],
64705: [1601, 1605],
64706: [1602, 1581],
64707: [1602, 1605],
64708: [1603, 1580],
64709: [1603, 1581],
64710: [1603, 1582],
64711: [1603, 1604],
64712: [1603, 1605],
64713: [1604, 1580],
64714: [1604, 1581],
64715: [1604, 1582],
64716: [1604, 1605],
64717: [1604, 1607],
64718: [1605, 1580],
64719: [1605, 1581],
64720: [1605, 1582],
64721: [1605, 1605],
64722: [1606, 1580],
64723: [1606, 1581],
64724: [1606, 1582],
64725: [1606, 1605],
64726: [1606, 1607],
64727: [1607, 1580],
64728: [1607, 1605],
64729: [1607, 1648],
64730: [1610, 1580],
64731: [1610, 1581],
64732: [1610, 1582],
64733: [1610, 1605],
64734: [1610, 1607],
64735: [1610, 1620, 1605],
64736: [1610, 1620, 1607],
64737: [1576, 1605],
64738: [1576, 1607],
64739: [1578, 1605],
64740: [1578, 1607],
64741: [1579, 1605],
64742: [1579, 1607],
64743: [1587, 1605],
64744: [1587, 1607],
64745: [1588, 1605],
64746: [1588, 1607],
64747: [1603, 1604],
64748: [1603, 1605],
64749: [1604, 1605],
64750: [1606, 1605],
64751: [1606, 1607],
64752: [1610, 1605],
64753: [1610, 1607],
64754: [1600, 1614, 1617],
64755: [1600, 1615, 1617],
64756: [1600, 1616, 1617],
64757: [1591, 1609],
64758: [1591, 1610],
64759: [1593, 1609],
64760: [1593, 1610],
64761: [1594, 1609],
64762: [1594, 1610],
64763: [1587, 1609],
64764: [1587, 1610],
64765: [1588, 1609],
64766: [1588, 1610],
64767: [1581, 1609],
64768: [1581, 1610],
64769: [1580, 1609],
64770: [1580, 1610],
64771: [1582, 1609],
64772: [1582, 1610],
64773: [1589, 1609],
64774: [1589, 1610],
64775: [1590, 1609],
64776: [1590, 1610],
64777: [1588, 1580],
64778: [1588, 1581],
64779: [1588, 1582],
64780: [1588, 1605],
64781: [1588, 1585],
64782: [1587, 1585],
64783: [1589, 1585],
64784: [1590, 1585],
64785: [1591, 1609],
64786: [1591, 1610],
64787: [1593, 1609],
64788: [1593, 1610],
64789: [1594, 1609],
64790: [1594, 1610],
64791: [1587, 1609],
64792: [1587, 1610],
64793: [1588, 1609],
64794: [1588, 1610],
64795: [1581, 1609],
64796: [1581, 1610],
64797: [1580, 1609],
64798: [1580, 1610],
64799: [1582, 1609],
64800: [1582, 1610],
64801: [1589, 1609],
64802: [1589, 1610],
64803: [1590, 1609],
64804: [1590, 1610],
64805: [1588, 1580],
64806: [1588, 1581],
64807: [1588, 1582],
64808: [1588, 1605],
64809: [1588, 1585],
64810: [1587, 1585],
64811: [1589, 1585],
64812: [1590, 1585],
64813: [1588, 1580],
64814: [1588, 1581],
64815: [1588, 1582],
64816: [1588, 1605],
64817: [1587, 1607],
64818: [1588, 1607],
64819: [1591, 1605],
64820: [1587, 1580],
64821: [1587, 1581],
64822: [1587, 1582],
64823: [1588, 1580],
64824: [1588, 1581],
64825: [1588, 1582],
64826: [1591, 1605],
64827: [1592, 1605],
64828: [1575, 1611],
64829: [1575, 1611],
64848: [1578, 1580, 1605],
64849: [1578, 1581, 1580],
64850: [1578, 1581, 1580],
64851: [1578, 1581, 1605],
64852: [1578, 1582, 1605],
64853: [1578, 1605, 1580],
64854: [1578, 1605, 1581],
64855: [1578, 1605, 1582],
64856: [1580, 1605, 1581],
64857: [1580, 1605, 1581],
64858: [1581, 1605, 1610],
64859: [1581, 1605, 1609],
64860: [1587, 1581, 1580],
64861: [1587, 1580, 1581],
64862: [1587, 1580, 1609],
64863: [1587, 1605, 1581],
64864: [1587, 1605, 1581],
64865: [1587, 1605, 1580],
64866: [1587, 1605, 1605],
64867: [1587, 1605, 1605],
64868: [1589, 1581, 1581],
64869: [1589, 1581, 1581],
64870: [1589, 1605, 1605],
64871: [1588, 1581, 1605],
64872: [1588, 1581, 1605],
64873: [1588, 1580, 1610],
64874: [1588, 1605, 1582],
64875: [1588, 1605, 1582],
64876: [1588, 1605, 1605],
64877: [1588, 1605, 1605],
64878: [1590, 1581, 1609],
64879: [1590, 1582, 1605],
64880: [1590, 1582, 1605],
64881: [1591, 1605, 1581],
64882: [1591, 1605, 1581],
64883: [1591, 1605, 1605],
64884: [1591, 1605, 1610],
64885: [1593, 1580, 1605],
64886: [1593, 1605, 1605],
64887: [1593, 1605, 1605],
64888: [1593, 1605, 1609],
64889: [1594, 1605, 1605],
64890: [1594, 1605, 1610],
64891: [1594, 1605, 1609],
64892: [1601, 1582, 1605],
64893: [1601, 1582, 1605],
64894: [1602, 1605, 1581],
64895: [1602, 1605, 1605],
64896: [1604, 1581, 1605],
64897: [1604, 1581, 1610],
64898: [1604, 1581, 1609],
64899: [1604, 1580, 1580],
64900: [1604, 1580, 1580],
64901: [1604, 1582, 1605],
64902: [1604, 1582, 1605],
64903: [1604, 1605, 1581],
64904: [1604, 1605, 1581],
64905: [1605, 1581, 1580],
64906: [1605, 1581, 1605],
64907: [1605, 1581, 1610],
64908: [1605, 1580, 1581],
64909: [1605, 1580, 1605],
64910: [1605, 1582, 1580],
64911: [1605, 1582, 1605],
64914: [1605, 1580, 1582],
64915: [1607, 1605, 1580],
64916: [1607, 1605, 1605],
64917: [1606, 1581, 1605],
64918: [1606, 1581, 1609],
64919: [1606, 1580, 1605],
64920: [1606, 1580, 1605],
64921: [1606, 1580, 1609],
64922: [1606, 1605, 1610],
64923: [1606, 1605, 1609],
64924: [1610, 1605, 1605],
64925: [1610, 1605, 1605],
64926: [1576, 1582, 1610],
64927: [1578, 1580, 1610],
64928: [1578, 1580, 1609],
64929: [1578, 1582, 1610],
64930: [1578, 1582, 1609],
64931: [1578, 1605, 1610],
64932: [1578, 1605, 1609],
64933: [1580, 1605, 1610],
64934: [1580, 1581, 1609],
64935: [1580, 1605, 1609],
64936: [1587, 1582, 1609],
64937: [1589, 1581, 1610],
64938: [1588, 1581, 1610],
64939: [1590, 1581, 1610],
64940: [1604, 1580, 1610],
64941: [1604, 1605, 1610],
64942: [1610, 1581, 1610],
64943: [1610, 1580, 1610],
64944: [1610, 1605, 1610],
64945: [1605, 1605, 1610],
64946: [1602, 1605, 1610],
64947: [1606, 1581, 1610],
64948: [1602, 1605, 1581],
64949: [1604, 1581, 1605],
64950: [1593, 1605, 1610],
64951: [1603, 1605, 1610],
64952: [1606, 1580, 1581],
64953: [1605, 1582, 1610],
64954: [1604, 1580, 1605],
64955: [1603, 1605, 1605],
64956: [1604, 1580, 1605],
64957: [1606, 1580, 1581],
64958: [1580, 1581, 1610],
64959: [1581, 1580, 1610],
64960: [1605, 1580, 1610],
64961: [1601, 1605, 1610],
64962: [1576, 1581, 1610],
64963: [1603, 1605, 1605],
64964: [1593, 1580, 1605],
64965: [1589, 1605, 1605],
64966: [1587, 1582, 1610],
64967: [1606, 1580, 1610],
65008: [1589, 1604, 1746],
65009: [1602, 1604, 1746],
65010: [1575, 1604, 1604, 1607],
65011: [1575, 1603, 1576, 1585],
65012: [1605, 1581, 1605, 1583],
65013: [1589, 1604, 1593, 1605],
65014: [1585, 1587, 1608, 1604],
65015: [1593, 1604, 1610, 1607],
65016: [1608, 1587, 1604, 1605],
65017: [1589, 1604, 1609],
65018: [1589, 1604, 1609, 32, 1575, 1604, 1604, 1607, 32, 1593, 1604, 1610, 1607, 32, 1608, 1587, 1604, 1605],
65019: [1580, 1604, 32, 1580, 1604, 1575, 1604, 1607],
65020: [1585, 1740, 1575, 1604],
65040: [44],
65041: [12289],
65042: [12290],
65043: [58],
65044: [59],
65045: [33],
65046: [63],
65047: [12310],
65048: [12311],
65049: [46, 46, 46],
65072: [46, 46],
65073: [8212],
65074: [8211],
65075: [95],
65076: [95],
65077: [40],
65078: [41],
65079: [123],
65080: [125],
65081: [12308],
65082: [12309],
65083: [12304],
65084: [12305],
65085: [12298],
65086: [12299],
65087: [12296],
65088: [12297],
65089: [12300],
65090: [12301],
65091: [12302],
65092: [12303],
65095: [91],
65096: [93],
65097: [32, 773],
65098: [32, 773],
65099: [32, 773],
65100: [32, 773],
65101: [95],
65102: [95],
65103: [95],
65104: [44],
65105: [12289],
65106: [46],
65108: [59],
65109: [58],
65110: [63],
65111: [33],
65112: [8212],
65113: [40],
65114: [41],
65115: [123],
65116: [125],
65117: [12308],
65118: [12309],
65119: [35],
65120: [38],
65121: [42],
65122: [43],
65123: [45],
65124: [60],
65125: [62],
65126: [61],
65128: [92],
65129: [36],
65130: [37],
65131: [64],
65136: [32, 1611],
65137: [1600, 1611],
65138: [32, 1612],
65140: [32, 1613],
65142: [32, 1614],
65143: [1600, 1614],
65144: [32, 1615],
65145: [1600, 1615],
65146: [32, 1616],
65147: [1600, 1616],
65148: [32, 1617],
65149: [1600, 1617],
65150: [32, 1618],
65151: [1600, 1618],
65152: [1569],
65153: [1575, 1619],
65154: [1575, 1619],
65155: [1575, 1620],
65156: [1575, 1620],
65157: [1608, 1620],
65158: [1608, 1620],
65159: [1575, 1621],
65160: [1575, 1621],
65161: [1610, 1620],
65162: [1610, 1620],
65163: [1610, 1620],
65164: [1610, 1620],
65165: [1575],
65166: [1575],
65167: [1576],
65168: [1576],
65169: [1576],
65170: [1576],
65171: [1577],
65172: [1577],
65173: [1578],
65174: [1578],
65175: [1578],
65176: [1578],
65177: [1579],
65178: [1579],
65179: [1579],
65180: [1579],
65181: [1580],
65182: [1580],
65183: [1580],
65184: [1580],
65185: [1581],
65186: [1581],
65187: [1581],
65188: [1581],
65189: [1582],
65190: [1582],
65191: [1582],
65192: [1582],
65193: [1583],
65194: [1583],
65195: [1584],
65196: [1584],
65197: [1585],
65198: [1585],
65199: [1586],
65200: [1586],
65201: [1587],
65202: [1587],
65203: [1587],
65204: [1587],
65205: [1588],
65206: [1588],
65207: [1588],
65208: [1588],
65209: [1589],
65210: [1589],
65211: [1589],
65212: [1589],
65213: [1590],
65214: [1590],
65215: [1590],
65216: [1590],
65217: [1591],
65218: [1591],
65219: [1591],
65220: [1591],
65221: [1592],
65222: [1592],
65223: [1592],
65224: [1592],
65225: [1593],
65226: [1593],
65227: [1593],
65228: [1593],
65229: [1594],
65230: [1594],
65231: [1594],
65232: [1594],
65233: [1601],
65234: [1601],
65235: [1601],
65236: [1601],
65237: [1602],
65238: [1602],
65239: [1602],
65240: [1602],
65241: [1603],
65242: [1603],
65243: [1603],
65244: [1603],
65245: [1604],
65246: [1604],
65247: [1604],
65248: [1604],
65249: [1605],
65250: [1605],
65251: [1605],
65252: [1605],
65253: [1606],
65254: [1606],
65255: [1606],
65256: [1606],
65257: [1607],
65258: [1607],
65259: [1607],
65260: [1607],
65261: [1608],
65262: [1608],
65263: [1609],
65264: [1609],
65265: [1610],
65266: [1610],
65267: [1610],
65268: [1610],
65269: [1604, 1575, 1619],
65270: [1604, 1575, 1619],
65271: [1604, 1575, 1620],
65272: [1604, 1575, 1620],
65273: [1604, 1575, 1621],
65274: [1604, 1575, 1621],
65275: [1604, 1575],
65276: [1604, 1575],
65281: [33],
65282: [34],
65283: [35],
65284: [36],
65285: [37],
65286: [38],
65287: [39],
65288: [40],
65289: [41],
65290: [42],
65291: [43],
65292: [44],
65293: [45],
65294: [46],
65295: [47],
65296: [48],
65297: [49],
65298: [50],
65299: [51],
65300: [52],
65301: [53],
65302: [54],
65303: [55],
65304: [56],
65305: [57],
65306: [58],
65307: [59],
65308: [60],
65309: [61],
65310: [62],
65311: [63],
65312: [64],
65313: [65],
65314: [66],
65315: [67],
65316: [68],
65317: [69],
65318: [70],
65319: [71],
65320: [72],
65321: [73],
65322: [74],
65323: [75],
65324: [76],
65325: [77],
65326: [78],
65327: [79],
65328: [80],
65329: [81],
65330: [82],
65331: [83],
65332: [84],
65333: [85],
65334: [86],
65335: [87],
65336: [88],
65337: [89],
65338: [90],
65339: [91],
65340: [92],
65341: [93],
65342: [94],
65343: [95],
65344: [96],
65345: [97],
65346: [98],
65347: [99],
65348: [100],
65349: [101],
65350: [102],
65351: [103],
65352: [104],
65353: [105],
65354: [106],
65355: [107],
65356: [108],
65357: [109],
65358: [110],
65359: [111],
65360: [112],
65361: [113],
65362: [114],
65363: [115],
65364: [116],
65365: [117],
65366: [118],
65367: [119],
65368: [120],
65369: [121],
65370: [122],
65371: [123],
65372: [124],
65373: [125],
65374: [126],
65375: [10629],
65376: [10630],
65377: [12290],
65378: [12300],
65379: [12301],
65380: [12289],
65381: [12539],
65382: [12530],
65383: [12449],
65384: [12451],
65385: [12453],
65386: [12455],
65387: [12457],
65388: [12515],
65389: [12517],
65390: [12519],
65391: [12483],
65392: [12540],
65393: [12450],
65394: [12452],
65395: [12454],
65396: [12456],
65397: [12458],
65398: [12459],
65399: [12461],
65400: [12463],
65401: [12465],
65402: [12467],
65403: [12469],
65404: [12471],
65405: [12473],
65406: [12475],
65407: [12477],
65408: [12479],
65409: [12481],
65410: [12484],
65411: [12486],
65412: [12488],
65413: [12490],
65414: [12491],
65415: [12492],
65416: [12493],
65417: [12494],
65418: [12495],
65419: [12498],
65420: [12501],
65421: [12504],
65422: [12507],
65423: [12510],
65424: [12511],
65425: [12512],
65426: [12513],
65427: [12514],
65428: [12516],
65429: [12518],
65430: [12520],
65431: [12521],
65432: [12522],
65433: [12523],
65434: [12524],
65435: [12525],
65436: [12527],
65437: [12531],
65438: [12441],
65439: [12442],
65440: [4448],
65441: [4352],
65442: [4353],
65443: [4522],
65444: [4354],
65445: [4524],
65446: [4525],
65447: [4355],
65448: [4356],
65449: [4357],
65450: [4528],
65451: [4529],
65452: [4530],
65453: [4531],
65454: [4532],
65455: [4533],
65456: [4378],
65457: [4358],
65458: [4359],
65459: [4360],
65460: [4385],
65461: [4361],
65462: [4362],
65463: [4363],
65464: [4364],
65465: [4365],
65466: [4366],
65467: [4367],
65468: [4368],
65469: [4369],
65470: [4370],
65474: [4449],
65475: [4450],
65476: [4451],
65477: [4452],
65478: [4453],
65479: [4454],
65482: [4455],
65483: [4456],
65484: [4457],
65485: [4458],
65486: [4459],
65487: [4460],
65490: [4461],
65491: [4462],
65492: [4463],
65493: [4464],
65494: [4465],
65495: [4466],
65498: [4467],
65499: [4468],
65500: [4469],
65504: [162],
65505: [163],
65506: [172],
65507: [32, 772],
65508: [166],
65509: [165],
65510: [8361],
65512: [9474],
65513: [8592],
65514: [8593],
65515: [8594],
65516: [8595],
65517: [9632],
65518: [9675],
119134: [119127, 119141],
119135: [119128, 119141],
119136: [119128, 119141, 119150],
119137: [119128, 119141, 119151],
119138: [119128, 119141, 119152],
119139: [119128, 119141, 119153],
119140: [119128, 119141, 119154],
119227: [119225, 119141],
119228: [119226, 119141],
119229: [119225, 119141, 119150],
119230: [119226, 119141, 119150],
119231: [119225, 119141, 119151],
119232: [119226, 119141, 119151],
119808: [65],
119809: [66],
119810: [67],
119811: [68],
119812: [69],
119813: [70],
119814: [71],
119815: [72],
119816: [73],
119817: [74],
119818: [75],
119819: [76],
119820: [77],
119821: [78],
119822: [79],
119823: [80],
119824: [81],
119825: [82],
119826: [83],
119827: [84],
119828: [85],
119829: [86],
119830: [87],
119831: [88],
119832: [89],
119833: [90],
119834: [97],
119835: [98],
119836: [99],
119837: [100],
119838: [101],
119839: [102],
119840: [103],
119841: [104],
119842: [105],
119843: [106],
119844: [107],
119845: [108],
119846: [109],
119847: [110],
119848: [111],
119849: [112],
119850: [113],
119851: [114],
119852: [115],
119853: [116],
119854: [117],
119855: [118],
119856: [119],
119857: [120],
119858: [121],
119859: [122],
119860: [65],
119861: [66],
119862: [67],
119863: [68],
119864: [69],
119865: [70],
119866: [71],
119867: [72],
119868: [73],
119869: [74],
119870: [75],
119871: [76],
119872: [77],
119873: [78],
119874: [79],
119875: [80],
119876: [81],
119877: [82],
119878: [83],
119879: [84],
119880: [85],
119881: [86],
119882: [87],
119883: [88],
119884: [89],
119885: [90],
119886: [97],
119887: [98],
119888: [99],
119889: [100],
119890: [101],
119891: [102],
119892: [103],
119894: [105],
119895: [106],
119896: [107],
119897: [108],
119898: [109],
119899: [110],
119900: [111],
119901: [112],
119902: [113],
119903: [114],
119904: [115],
119905: [116],
119906: [117],
119907: [118],
119908: [119],
119909: [120],
119910: [121],
119911: [122],
119912: [65],
119913: [66],
119914: [67],
119915: [68],
119916: [69],
119917: [70],
119918: [71],
119919: [72],
119920: [73],
119921: [74],
119922: [75],
119923: [76],
119924: [77],
119925: [78],
119926: [79],
119927: [80],
119928: [81],
119929: [82],
119930: [83],
119931: [84],
119932: [85],
119933: [86],
119934: [87],
119935: [88],
119936: [89],
119937: [90],
119938: [97],
119939: [98],
119940: [99],
119941: [100],
119942: [101],
119943: [102],
119944: [103],
119945: [104],
119946: [105],
119947: [106],
119948: [107],
119949: [108],
119950: [109],
119951: [110],
119952: [111],
119953: [112],
119954: [113],
119955: [114],
119956: [115],
119957: [116],
119958: [117],
119959: [118],
119960: [119],
119961: [120],
119962: [121],
119963: [122],
119964: [65],
119966: [67],
119967: [68],
119970: [71],
119973: [74],
119974: [75],
119977: [78],
119978: [79],
119979: [80],
119980: [81],
119982: [83],
119983: [84],
119984: [85],
119985: [86],
119986: [87],
119987: [88],
119988: [89],
119989: [90],
119990: [97],
119991: [98],
119992: [99],
119993: [100],
119995: [102],
119997: [104],
119998: [105],
119999: [106],
120000: [107],
120001: [108],
120002: [109],
120003: [110],
120005: [112],
120006: [113],
120007: [114],
120008: [115],
120009: [116],
120010: [117],
120011: [118],
120012: [119],
120013: [120],
120014: [121],
120015: [122],
120016: [65],
120017: [66],
120018: [67],
120019: [68],
120020: [69],
120021: [70],
120022: [71],
120023: [72],
120024: [73],
120025: [74],
120026: [75],
120027: [76],
120028: [77],
120029: [78],
120030: [79],
120031: [80],
120032: [81],
120033: [82],
120034: [83],
120035: [84],
120036: [85],
120037: [86],
120038: [87],
120039: [88],
120040: [89],
120041: [90],
120042: [97],
120043: [98],
120044: [99],
120045: [100],
120046: [101],
120047: [102],
120048: [103],
120049: [104],
120050: [105],
120051: [106],
120052: [107],
120053: [108],
120054: [109],
120055: [110],
120056: [111],
120057: [112],
120058: [113],
120059: [114],
120060: [115],
120061: [116],
120062: [117],
120063: [118],
120064: [119],
120065: [120],
120066: [121],
120067: [122],
120068: [65],
120069: [66],
120071: [68],
120072: [69],
120073: [70],
120074: [71],
120077: [74],
120078: [75],
120079: [76],
120080: [77],
120081: [78],
120082: [79],
120083: [80],
120084: [81],
120086: [83],
120087: [84],
120088: [85],
120089: [86],
120090: [87],
120091: [88],
120092: [89],
120094: [97],
120095: [98],
120096: [99],
120097: [100],
120098: [101],
120099: [102],
120100: [103],
120101: [104],
120102: [105],
120103: [106],
120104: [107],
120105: [108],
120106: [109],
120107: [110],
120108: [111],
120109: [112],
120110: [113],
120111: [114],
120112: [115],
120113: [116],
120114: [117],
120115: [118],
120116: [119],
120117: [120],
120118: [121],
120119: [122],
120120: [65],
120121: [66],
120123: [68],
120124: [69],
120125: [70],
120126: [71],
120128: [73],
120129: [74],
120130: [75],
120131: [76],
120132: [77],
120134: [79],
120138: [83],
120139: [84],
120140: [85],
120141: [86],
120142: [87],
120143: [88],
120144: [89],
120146: [97],
120147: [98],
120148: [99],
120149: [100],
120150: [101],
120151: [102],
120152: [103],
120153: [104],
120154: [105],
120155: [106],
120156: [107],
120157: [108],
120158: [109],
120159: [110],
120160: [111],
120161: [112],
120162: [113],
120163: [114],
120164: [115],
120165: [116],
120166: [117],
120167: [118],
120168: [119],
120169: [120],
120170: [121],
120171: [122],
120172: [65],
120173: [66],
120174: [67],
120175: [68],
120176: [69],
120177: [70],
120178: [71],
120179: [72],
120180: [73],
120181: [74],
120182: [75],
120183: [76],
120184: [77],
120185: [78],
120186: [79],
120187: [80],
120188: [81],
120189: [82],
120190: [83],
120191: [84],
120192: [85],
120193: [86],
120194: [87],
120195: [88],
120196: [89],
120197: [90],
120198: [97],
120199: [98],
120200: [99],
120201: [100],
120202: [101],
120203: [102],
120204: [103],
120205: [104],
120206: [105],
120207: [106],
120208: [107],
120209: [108],
120210: [109],
120211: [110],
120212: [111],
120213: [112],
120214: [113],
120215: [114],
120216: [115],
120217: [116],
120218: [117],
120219: [118],
120220: [119],
120221: [120],
120222: [121],
120223: [122],
120224: [65],
120225: [66],
120226: [67],
120227: [68],
120228: [69],
120229: [70],
120230: [71],
120231: [72],
120232: [73],
120233: [74],
120234: [75],
120235: [76],
120236: [77],
120237: [78],
120238: [79],
120239: [80],
120240: [81],
120241: [82],
120242: [83],
120243: [84],
120244: [85],
120245: [86],
120246: [87],
120247: [88],
120248: [89],
120249: [90],
120250: [97],
120251: [98],
120252: [99],
120253: [100],
120254: [101],
120255: [102],
120256: [103],
120257: [104],
120258: [105],
120259: [106],
120260: [107],
120261: [108],
120262: [109],
120263: [110],
120264: [111],
120265: [112],
120266: [113],
120267: [114],
120268: [115],
120269: [116],
120270: [117],
120271: [118],
120272: [119],
120273: [120],
120274: [121],
120275: [122],
120276: [65],
120277: [66],
120278: [67],
120279: [68],
120280: [69],
120281: [70],
120282: [71],
120283: [72],
120284: [73],
120285: [74],
120286: [75],
120287: [76],
120288: [77],
120289: [78],
120290: [79],
120291: [80],
120292: [81],
120293: [82],
120294: [83],
120295: [84],
120296: [85],
120297: [86],
120298: [87],
120299: [88],
120300: [89],
120301: [90],
120302: [97],
120303: [98],
120304: [99],
120305: [100],
120306: [101],
120307: [102],
120308: [103],
120309: [104],
120310: [105],
120311: [106],
120312: [107],
120313: [108],
120314: [109],
120315: [110],
120316: [111],
120317: [112],
120318: [113],
120319: [114],
120320: [115],
120321: [116],
120322: [117],
120323: [118],
120324: [119],
120325: [120],
120326: [121],
120327: [122],
120328: [65],
120329: [66],
120330: [67],
120331: [68],
120332: [69],
120333: [70],
120334: [71],
120335: [72],
120336: [73],
120337: [74],
120338: [75],
120339: [76],
120340: [77],
120341: [78],
120342: [79],
120343: [80],
120344: [81],
120345: [82],
120346: [83],
120347: [84],
120348: [85],
120349: [86],
120350: [87],
120351: [88],
120352: [89],
120353: [90],
120354: [97],
120355: [98],
120356: [99],
120357: [100],
120358: [101],
120359: [102],
120360: [103],
120361: [104],
120362: [105],
120363: [106],
120364: [107],
120365: [108],
120366: [109],
120367: [110],
120368: [111],
120369: [112],
120370: [113],
120371: [114],
120372: [115],
120373: [116],
120374: [117],
120375: [118],
120376: [119],
120377: [120],
120378: [121],
120379: [122],
120380: [65],
120381: [66],
120382: [67],
120383: [68],
120384: [69],
120385: [70],
120386: [71],
120387: [72],
120388: [73],
120389: [74],
120390: [75],
120391: [76],
120392: [77],
120393: [78],
120394: [79],
120395: [80],
120396: [81],
120397: [82],
120398: [83],
120399: [84],
120400: [85],
120401: [86],
120402: [87],
120403: [88],
120404: [89],
120405: [90],
120406: [97],
120407: [98],
120408: [99],
120409: [100],
120410: [101],
120411: [102],
120412: [103],
120413: [104],
120414: [105],
120415: [106],
120416: [107],
120417: [108],
120418: [109],
120419: [110],
120420: [111],
120421: [112],
120422: [113],
120423: [114],
120424: [115],
120425: [116],
120426: [117],
120427: [118],
120428: [119],
120429: [120],
120430: [121],
120431: [122],
120432: [65],
120433: [66],
120434: [67],
120435: [68],
120436: [69],
120437: [70],
120438: [71],
120439: [72],
120440: [73],
120441: [74],
120442: [75],
120443: [76],
120444: [77],
120445: [78],
120446: [79],
120447: [80],
120448: [81],
120449: [82],
120450: [83],
120451: [84],
120452: [85],
120453: [86],
120454: [87],
120455: [88],
120456: [89],
120457: [90],
120458: [97],
120459: [98],
120460: [99],
120461: [100],
120462: [101],
120463: [102],
120464: [103],
120465: [104],
120466: [105],
120467: [106],
120468: [107],
120469: [108],
120470: [109],
120471: [110],
120472: [111],
120473: [112],
120474: [113],
120475: [114],
120476: [115],
120477: [116],
120478: [117],
120479: [118],
120480: [119],
120481: [120],
120482: [121],
120483: [122],
120484: [305],
120485: [567],
120488: [913],
120489: [914],
120490: [915],
120491: [916],
120492: [917],
120493: [918],
120494: [919],
120495: [920],
120496: [921],
120497: [922],
120498: [923],
120499: [924],
120500: [925],
120501: [926],
120502: [927],
120503: [928],
120504: [929],
120505: [920],
120506: [931],
120507: [932],
120508: [933],
120509: [934],
120510: [935],
120511: [936],
120512: [937],
120513: [8711],
120514: [945],
120515: [946],
120516: [947],
120517: [948],
120518: [949],
120519: [950],
120520: [951],
120521: [952],
120522: [953],
120523: [954],
120524: [955],
120525: [956],
120526: [957],
120527: [958],
120528: [959],
120529: [960],
120530: [961],
120531: [962],
120532: [963],
120533: [964],
120534: [965],
120535: [966],
120536: [967],
120537: [968],
120538: [969],
120539: [8706],
120540: [949],
120541: [952],
120542: [954],
120543: [966],
120544: [961],
120545: [960],
120546: [913],
120547: [914],
120548: [915],
120549: [916],
120550: [917],
120551: [918],
120552: [919],
120553: [920],
120554: [921],
120555: [922],
120556: [923],
120557: [924],
120558: [925],
120559: [926],
120560: [927],
120561: [928],
120562: [929],
120563: [920],
120564: [931],
120565: [932],
120566: [933],
120567: [934],
120568: [935],
120569: [936],
120570: [937],
120571: [8711],
120572: [945],
120573: [946],
120574: [947],
120575: [948],
120576: [949],
120577: [950],
120578: [951],
120579: [952],
120580: [953],
120581: [954],
120582: [955],
120583: [956],
120584: [957],
120585: [958],
120586: [959],
120587: [960],
120588: [961],
120589: [962],
120590: [963],
120591: [964],
120592: [965],
120593: [966],
120594: [967],
120595: [968],
120596: [969],
120597: [8706],
120598: [949],
120599: [952],
120600: [954],
120601: [966],
120602: [961],
120603: [960],
120604: [913],
120605: [914],
120606: [915],
120607: [916],
120608: [917],
120609: [918],
120610: [919],
120611: [920],
120612: [921],
120613: [922],
120614: [923],
120615: [924],
120616: [925],
120617: [926],
120618: [927],
120619: [928],
120620: [929],
120621: [920],
120622: [931],
120623: [932],
120624: [933],
120625: [934],
120626: [935],
120627: [936],
120628: [937],
120629: [8711],
120630: [945],
120631: [946],
120632: [947],
120633: [948],
120634: [949],
120635: [950],
120636: [951],
120637: [952],
120638: [953],
120639: [954],
120640: [955],
120641: [956],
120642: [957],
120643: [958],
120644: [959],
120645: [960],
120646: [961],
120647: [962],
120648: [963],
120649: [964],
120650: [965],
120651: [966],
120652: [967],
120653: [968],
120654: [969],
120655: [8706],
120656: [949],
120657: [952],
120658: [954],
120659: [966],
120660: [961],
120661: [960],
120662: [913],
120663: [914],
120664: [915],
120665: [916],
120666: [917],
120667: [918],
120668: [919],
120669: [920],
120670: [921],
120671: [922],
120672: [923],
120673: [924],
120674: [925],
120675: [926],
120676: [927],
120677: [928],
120678: [929],
120679: [920],
120680: [931],
120681: [932],
120682: [933],
120683: [934],
120684: [935],
120685: [936],
120686: [937],
120687: [8711],
120688: [945],
120689: [946],
120690: [947],
120691: [948],
120692: [949],
120693: [950],
120694: [951],
120695: [952],
120696: [953],
120697: [954],
120698: [955],
120699: [956],
120700: [957],
120701: [958],
120702: [959],
120703: [960],
120704: [961],
120705: [962],
120706: [963],
120707: [964],
120708: [965],
120709: [966],
120710: [967],
120711: [968],
120712: [969],
120713: [8706],
120714: [949],
120715: [952],
120716: [954],
120717: [966],
120718: [961],
120719: [960],
120720: [913],
120721: [914],
120722: [915],
120723: [916],
120724: [917],
120725: [918],
120726: [919],
120727: [920],
120728: [921],
120729: [922],
120730: [923],
120731: [924],
120732: [925],
120733: [926],
120734: [927],
120735: [928],
120736: [929],
120737: [920],
120738: [931],
120739: [932],
120740: [933],
120741: [934],
120742: [935],
120743: [936],
120744: [937],
120745: [8711],
120746: [945],
120747: [946],
120748: [947],
120749: [948],
120750: [949],
120751: [950],
120752: [951],
120753: [952],
120754: [953],
120755: [954],
120756: [955],
120757: [956],
120758: [957],
120759: [958],
120760: [959],
120761: [960],
120762: [961],
120763: [962],
120764: [963],
120765: [964],
120766: [965],
120767: [966],
120768: [967],
120769: [968],
120770: [969],
120771: [8706],
120772: [949],
120773: [952],
120774: [954],
120775: [966],
120776: [961],
120777: [960],
120782: [48],
120783: [49],
120784: [50],
120785: [51],
120786: [52],
120787: [53],
120788: [54],
120789: [55],
120790: [56],
120791: [57],
120792: [48],
120793: [49],
120794: [50],
120795: [51],
120796: [52],
120797: [53],
120798: [54],
120799: [55],
120800: [56],
120801: [57],
120802: [48],
120803: [49],
120804: [50],
120805: [51],
120806: [52],
120807: [53],
120808: [54],
120809: [55],
120810: [56],
120811: [57],
120812: [48],
120813: [49],
120814: [50],
120815: [51],
120816: [52],
120817: [53],
120818: [54],
120819: [55],
120820: [56],
120821: [57],
120822: [48],
120823: [49],
120824: [50],
120825: [51],
120826: [52],
120827: [53],
120828: [54],
120829: [55],
120830: [56],
120831: [57],
194560: [20029],
194561: [20024],
194562: [20033],
194563: [131362],
194564: [20320],
194565: [20398],
194566: [20411],
194567: [20482],
194568: [20602],
194569: [20633],
194570: [20711],
194571: [20687],
194572: [13470],
194573: [132666],
194574: [20813],
194575: [20820],
194576: [20836],
194577: [20855],
194578: [132380],
194579: [13497],
194580: [20839],
194581: [20877],
194582: [132427],
194583: [20887],
194584: [20900],
194585: [20172],
194586: [20908],
194587: [20917],
194588: [168415],
194589: [20981],
194590: [20995],
194591: [13535],
194592: [21051],
194593: [21062],
194594: [21106],
194595: [21111],
194596: [13589],
194597: [21191],
194598: [21193],
194599: [21220],
194600: [21242],
194601: [21253],
194602: [21254],
194603: [21271],
194604: [21321],
194605: [21329],
194606: [21338],
194607: [21363],
194608: [21373],
194609: [21375],
194610: [21375],
194611: [21375],
194612: [133676],
194613: [28784],
194614: [21450],
194615: [21471],
194616: [133987],
194617: [21483],
194618: [21489],
194619: [21510],
194620: [21662],
194621: [21560],
194622: [21576],
194623: [21608],
194624: [21666],
194625: [21750],
194626: [21776],
194627: [21843],
194628: [21859],
194629: [21892],
194630: [21892],
194631: [21913],
194632: [21931],
194633: [21939],
194634: [21954],
194635: [22294],
194636: [22022],
194637: [22295],
194638: [22097],
194639: [22132],
194640: [20999],
194641: [22766],
194642: [22478],
194643: [22516],
194644: [22541],
194645: [22411],
194646: [22578],
194647: [22577],
194648: [22700],
194649: [136420],
194650: [22770],
194651: [22775],
194652: [22790],
194653: [22810],
194654: [22818],
194655: [22882],
194656: [136872],
194657: [136938],
194658: [23020],
194659: [23067],
194660: [23079],
194661: [23000],
194662: [23142],
194663: [14062],
194664: [14076],
194665: [23304],
194666: [23358],
194667: [23358],
194668: [137672],
194669: [23491],
194670: [23512],
194671: [23527],
194672: [23539],
194673: [138008],
194674: [23551],
194675: [23558],
194676: [24403],
194677: [23586],
194678: [14209],
194679: [23648],
194680: [23662],
194681: [23744],
194682: [23693],
194683: [138724],
194684: [23875],
194685: [138726],
194686: [23918],
194687: [23915],
194688: [23932],
194689: [24033],
194690: [24034],
194691: [14383],
194692: [24061],
194693: [24104],
194694: [24125],
194695: [24169],
194696: [14434],
194697: [139651],
194698: [14460],
194699: [24240],
194700: [24243],
194701: [24246],
194702: [24266],
194703: [172946],
194704: [24318],
194705: [140081],
194706: [140081],
194707: [33281],
194708: [24354],
194709: [24354],
194710: [14535],
194711: [144056],
194712: [156122],
194713: [24418],
194714: [24427],
194715: [14563],
194716: [24474],
194717: [24525],
194718: [24535],
194719: [24569],
194720: [24705],
194721: [14650],
194722: [14620],
194723: [24724],
194724: [141012],
194725: [24775],
194726: [24904],
194727: [24908],
194728: [24910],
194729: [24908],
194730: [24954],
194731: [24974],
194732: [25010],
194733: [24996],
194734: [25007],
194735: [25054],
194736: [25074],
194737: [25078],
194738: [25104],
194739: [25115],
194740: [25181],
194741: [25265],
194742: [25300],
194743: [25424],
194744: [142092],
194745: [25405],
194746: [25340],
194747: [25448],
194748: [25475],
194749: [25572],
194750: [142321],
194751: [25634],
194752: [25541],
194753: [25513],
194754: [14894],
194755: [25705],
194756: [25726],
194757: [25757],
194758: [25719],
194759: [14956],
194760: [25935],
194761: [25964],
194762: [143370],
194763: [26083],
194764: [26360],
194765: [26185],
194766: [15129],
194767: [26257],
194768: [15112],
194769: [15076],
194770: [20882],
194771: [20885],
194772: [26368],
194773: [26268],
194774: [32941],
194775: [17369],
194776: [26391],
194777: [26395],
194778: [26401],
194779: [26462],
194780: [26451],
194781: [144323],
194782: [15177],
194783: [26618],
194784: [26501],
194785: [26706],
194786: [26757],
194787: [144493],
194788: [26766],
194789: [26655],
194790: [26900],
194791: [15261],
194792: [26946],
194793: [27043],
194794: [27114],
194795: [27304],
194796: [145059],
194797: [27355],
194798: [15384],
194799: [27425],
194800: [145575],
194801: [27476],
194802: [15438],
194803: [27506],
194804: [27551],
194805: [27578],
194806: [27579],
194807: [146061],
194808: [138507],
194809: [146170],
194810: [27726],
194811: [146620],
194812: [27839],
194813: [27853],
194814: [27751],
194815: [27926],
194816: [27966],
194817: [28023],
194818: [27969],
194819: [28009],
194820: [28024],
194821: [28037],
194822: [146718],
194823: [27956],
194824: [28207],
194825: [28270],
194826: [15667],
194827: [28363],
194828: [28359],
194829: [147153],
194830: [28153],
194831: [28526],
194832: [147294],
194833: [147342],
194834: [28614],
194835: [28729],
194836: [28702],
194837: [28699],
194838: [15766],
194839: [28746],
194840: [28797],
194841: [28791],
194842: [28845],
194843: [132389],
194844: [28997],
194845: [148067],
194846: [29084],
194847: [148395],
194848: [29224],
194849: [29237],
194850: [29264],
194851: [149000],
194852: [29312],
194853: [29333],
194854: [149301],
194855: [149524],
194856: [29562],
194857: [29579],
194858: [16044],
194859: [29605],
194860: [16056],
194861: [16056],
194862: [29767],
194863: [29788],
194864: [29809],
194865: [29829],
194866: [29898],
194867: [16155],
194868: [29988],
194869: [150582],
194870: [30014],
194871: [150674],
194872: [30064],
194873: [139679],
194874: [30224],
194875: [151457],
194876: [151480],
194877: [151620],
194878: [16380],
194879: [16392],
194880: [30452],
194881: [151795],
194882: [151794],
194883: [151833],
194884: [151859],
194885: [30494],
194886: [30495],
194887: [30495],
194888: [30538],
194889: [16441],
194890: [30603],
194891: [16454],
194892: [16534],
194893: [152605],
194894: [30798],
194895: [30860],
194896: [30924],
194897: [16611],
194898: [153126],
194899: [31062],
194900: [153242],
194901: [153285],
194902: [31119],
194903: [31211],
194904: [16687],
194905: [31296],
194906: [31306],
194907: [31311],
194908: [153980],
194909: [154279],
194910: [154279],
194911: [31470],
194912: [16898],
194913: [154539],
194914: [31686],
194915: [31689],
194916: [16935],
194917: [154752],
194918: [31954],
194919: [17056],
194920: [31976],
194921: [31971],
194922: [32000],
194923: [155526],
194924: [32099],
194925: [17153],
194926: [32199],
194927: [32258],
194928: [32325],
194929: [17204],
194930: [156200],
194931: [156231],
194932: [17241],
194933: [156377],
194934: [32634],
194935: [156478],
194936: [32661],
194937: [32762],
194938: [32773],
194939: [156890],
194940: [156963],
194941: [32864],
194942: [157096],
194943: [32880],
194944: [144223],
194945: [17365],
194946: [32946],
194947: [33027],
194948: [17419],
194949: [33086],
194950: [23221],
194951: [157607],
194952: [157621],
194953: [144275],
194954: [144284],
194955: [33281],
194956: [33284],
194957: [36766],
194958: [17515],
194959: [33425],
194960: [33419],
194961: [33437],
194962: [21171],
194963: [33457],
194964: [33459],
194965: [33469],
194966: [33510],
194967: [158524],
194968: [33509],
194969: [33565],
194970: [33635],
194971: [33709],
194972: [33571],
194973: [33725],
194974: [33767],
194975: [33879],
194976: [33619],
194977: [33738],
194978: [33740],
194979: [33756],
194980: [158774],
194981: [159083],
194982: [158933],
194983: [17707],
194984: [34033],
194985: [34035],
194986: [34070],
194987: [160714],
194988: [34148],
194989: [159532],
194990: [17757],
194991: [17761],
194992: [159665],
194993: [159954],
194994: [17771],
194995: [34384],
194996: [34396],
194997: [34407],
194998: [34409],
194999: [34473],
195000: [34440],
195001: [34574],
195002: [34530],
195003: [34681],
195004: [34600],
195005: [34667],
195006: [34694],
195007: [17879],
195008: [34785],
195009: [34817],
195010: [17913],
195011: [34912],
195012: [34915],
195013: [161383],
195014: [35031],
195015: [35038],
195016: [17973],
195017: [35066],
195018: [13499],
195019: [161966],
195020: [162150],
195021: [18110],
195022: [18119],
195023: [35488],
195024: [35565],
195025: [35722],
195026: [35925],
195027: [162984],
195028: [36011],
195029: [36033],
195030: [36123],
195031: [36215],
195032: [163631],
195033: [133124],
195034: [36299],
195035: [36284],
195036: [36336],
195037: [133342],
195038: [36564],
195039: [36664],
195040: [165330],
195041: [165357],
195042: [37012],
195043: [37105],
195044: [37137],
195045: [165678],
195046: [37147],
195047: [37432],
195048: [37591],
195049: [37592],
195050: [37500],
195051: [37881],
195052: [37909],
195053: [166906],
195054: [38283],
195055: [18837],
195056: [38327],
195057: [167287],
195058: [18918],
195059: [38595],
195060: [23986],
195061: [38691],
195062: [168261],
195063: [168474],
195064: [19054],
195065: [19062],
195066: [38880],
195067: [168970],
195068: [19122],
195069: [169110],
195070: [38923],
195071: [38923],
195072: [38953],
195073: [169398],
195074: [39138],
195075: [19251],
195076: [39209],
195077: [39335],
195078: [39362],
195079: [39422],
195080: [19406],
195081: [170800],
195082: [39698],
195083: [40000],
195084: [40189],
195085: [19662],
195086: [19693],
195087: [40295],
195088: [172238],
195089: [19704],
195090: [172293],
195091: [172558],
195092: [172689],
195093: [40635],
195094: [19798],
195095: [40697],
195096: [40702],
195097: [40709],
195098: [40719],
195099: [40726],
195100: [40763],
195101: [173568],
}

_compat_decomposition_corrected = {
}

def canon_decomposition(code):
    try:
        return _canon_decomposition[code]
    except KeyError:
        if base_mod is not None and code not in _canon_decomposition_corrected:
            return base_mod._canon_decomposition.get(code, [])
        else:
            return []
def compat_decomposition(code):
    try:
        return _compat_decomposition[code]
    except KeyError:
        if base_mod is not None and code not in _compat_decomposition_corrected:
            return base_mod._compat_decomposition.get(code, [])
        else:
            return []

